/*****************************************************************************/
/*                                                                           */
/* EINE BIBLIOTHEK FUER EINFACHE MATRIXOPERATIONEN          FARZAD EGHTESSADI*/
/* IM ZUSAMMENHANG MIT DER ANALYSE DER PETRI-NETZE          SOMMERSEMESTER 93*/
/*                                                                           */
/* CS, 6.6.2000: Changed some else if's to else with modus ponens ;-)        */
/*****************************************************************************/

#include <stdio.h>
#include "Matrix.h"

/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_HEAD_PTR  Net_To_Matrix (LMPNet Net)

#else

MATRIX_HEAD_PTR  Net_To_Matrix (Net)

LMPNet               Net;    /* Das in eine Matrix zu konvertierende Netz    */
#endif

/*                                                                           */
/* Konvertieren eines Netzes in die obige Datenstruktur                      */
/* Unterscheidet sich nur durch Multiplikation mit -1                        */
/*****************************************************************************/

{
int                  i        = 0,
                     j        = 0;

Place                placePtr = Net->Places;    /* Stellenliste              */
STEdge               succPtr  = NULL;           /* Zeiger auf Nachbereich &  */
TSEdge               prevPtr  = NULL;           /* Zeiger auf Vorbereich ei- */
                                                /* ner Stelle                */
MATRIX_HEAD_PTR      row      = NULL,           /* Zeiger auf Matrixzeile    */
                     matrix   = NULL,           /* Rueckgabewert, zeigt auf  */
                                                /* die 1. Matrixzeile        */
                     matlast  = NULL;           /* Hilfszeiger, zeigt auf    */
                                                /* vorletzte Matrixzeile     */
MATRIX_ELEMENT_PTR   node     = NULL,           /* Matrixelement             */
                     nodelast = NULL;           /* Hilfszeiger auf vorletz-  */
                                                /* Matrixelement             */

matrix = (MATRIX_HEAD_PTR)                      /* Zeiger auf 1. Matrixzeile */
               Malloc (sizeof (MAT_HEAD));      /* erzeugen und ordungsge-   */
matrix->HeadPtr = NULL;                         /* maess verzeigern          */
matrix->next = NULL;
                                                /* Matrixzeiger auf Zeilen-  */
row = matrix;                                   /* zeiger setzen             */

                                                /* und los geht's            */
while (placePtr != NULL)                        /* FUER alle Stellen DO      */
   {
   succPtr = placePtr->postset;                 /* Zeiger auf Nachbereich    */
                                                /* der Stelle setzen         */
   prevPtr = placePtr->preset;                  /* Zeiger auf Vorbereich     */
                                                /* der Stelle setzen         */
   row->HeadPtr = (MATRIX_ELEMENT_PTR)          /* Matrixelement erzeugen    */
                    Malloc (sizeof (MAT_ELEM)); /* und an Matrixzeile        */
   row->next = NULL;                            /* anhaengen                 */
   node = row->HeadPtr;                         /* Zeiger auf Zeilenanfang   */
                                                /* setzen                    */
   while ( (succPtr != NULL) ||                 /* DA Nachbereich oder Vor-  */
           (prevPtr != NULL)    )               /* bereich nicht leer        */
      {                                         /* DO                        */
      if ( (succPtr != NULL) &&                 /* WENN nur Nachbereich <>   */
           (prevPtr == NULL)    )               /* leer, DANN                */
         {                                      /* fuelle Matrixelement      */
         node->element = succPtr->weight * (-1.0);
         node->spalte  = column_index (Net, succPtr->trans->name) - 1;
         node->zeile   = row_index (Net, succPtr->place->name) - 1;
         node->next    = NULL;
         succPtr       = succPtr->nexttrans;
         }
      else if ( (succPtr == NULL) &&            /* Kein Nachbereich, aber    */
                (prevPtr != NULL)   )           /* Vorbereich                */
              {
              node->element = prevPtr->weight;
              node->spalte  = column_index (Net, prevPtr->trans->name) - 1;
              node->zeile   = row_index (Net, prevPtr->place->name) - 1;
              node->next    = NULL;
              prevPtr       = prevPtr->nexttrans;
              }
           else if ( (succPtr != NULL) &&       /* Vor- und Nachbereich      */
                     (prevPtr != NULL)   )      /* sind nicht leer           */
                   {
                   i = column_index (Net, succPtr->trans->name) - 1;
                   j = column_index (Net, prevPtr->trans->name) - 1;

                   if (i == j)
                      {
                      node->element = (succPtr->weight) + ((-1.0) *
                                                    prevPtr->weight);
                      node->spalte  = i;
                      node->zeile   = row_index(Net, succPtr->place->name) - 1;
                      node->next    = NULL;

                      succPtr       = succPtr->nexttrans;
                      prevPtr       = prevPtr->nexttrans;
                      }                         /*           END IF (i == j) */

                   else if (i < j)
                           {
                           node->element = succPtr->weight * (-1.0);
                           node->spalte  = i;
                           node->zeile   = row_index (Net, succPtr->
                                                           place->name) - 1;
                           node->next    = NULL;
                           succPtr       = succPtr->nexttrans;
                           }                    /*            END IF (i < j) */

                        else
                                {
                                node->element = prevPtr->weight;
                                node->spalte  = j;
                                node->zeile   = row_index (Net, prevPtr->
                                                           place->name) - 1;
                                node->next    = NULL;
                                prevPtr       = prevPtr->nexttrans;

                                }               /*          END OF if (i > j)*/
                   }                            /* END IF Vor- & Nach <> leer*/

      node->next = (MATRIX_ELEMENT_PTR)         /* naechstes Matrixelement   */
                     Malloc (sizeof (MAT_ELEM));/* erzeugen, das vorletzte   */
      nodelast = node;                          /* Matrixelement merken      */
      node = node->next;                        /* Matrixelementzeiger wei-  */
                                                /* ter setzen                */
      }                                         /* END WHILE(Vor-&Nach<>leer)*/
                                                /* (Ende Zeile einrichten)   */
   free (node);                                 /* zuletzt erzeugtes Matrix- */
                                                /* element wieder freigeben  */
   nodelast->next = NULL;                       /* und voriges verzeigern    */
   placePtr = placePtr->nextplace;              /* naechste Stelle           */
   row->next = (MATRIX_HEAD_PTR)                /* naechste Zeile einrichten */
                    Malloc (sizeof (MAT_HEAD));
   matlast = row;                               /* vorletzte Zeile merken    */
   row = row->next;                             /* Zeilenzeiger auf naechste */
                                                /* Zeile setzen              */
	}                                       /* END WHILE (PlacePtr)      */
                                                /* Ende Stellendurchlauf     */
free (row);                                     /* zuletzt erzeugte Zeile    */
matlast->next = NULL;                           /* freigeben und vorige Zei- */
                                                /* le ordentlich verzeigern  */
return (matrix);                                /* erzeugte Matrix zurueck   */
}                                               /***  ENDe  Net_to_Matrix  ***/


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

void Show_Row (MATRIX_ELEMENT_PTR   R,         /* Zeiger auf Zeile          */
               int                  n,         /* und Anzahl der Zeilenele- */
                                               /* elemnte der Matrix        */
               FILE               * Datei)     /* Zeiger auff Aussgbedatei  */

#else

void Show_Row (R, n, Datei)

MATRIX_ELEMENT_PTR   R;                         /* Zeiger auf Zeile          */
int                  n;                         /* und Anzahl der Zeilenele- */
                                                /* elemnte der Matrix        */
FILE                 * Datei;                   /* Zeiger auf Ausgabedatei   */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  Ausgabe einer Zeile einer Matrix oder Ausgabe eines Vektors in Zeilenform*/
/*  Leicht andere Formatierung                                               */
/*****************************************************************************/

{
  int                  i;
  MATRIX_ELEMENT_PTR   row_node = R;             /* Zeiger auf Matrixzeile   */

  if (row_node == NULL)                          /* WENN Zeile leer          */
  {
    for(i=1; i <= n; i++)
    { /*      n-mal [0,0] ausgeben */
      fprintf (Datei, "  0.0  ");
    }
  }
  else
  {                                             /* fuelle Zeile bis zur      */
    if (row_node->spalte > 0)                   /* aktuellen Spalte mit Null */
      for (i = 0; i < row_node->spalte; i++)
      {
        fprintf (Datei, "  0.0  ");
      }

    while (row_node->next != NULL)              /* SOLANGE es ein Element <> */
    {                                           /* 0 in der Zeile gibt, gebe */
      fprintf (Datei, " %4.1f  ", row_node->element);
      if (row_node->next->spalte -              /* es aus und fuelle Zeile   */
                   row_node->spalte > 1)        /* mit [0.0] bis zum naech-  */
         {
         for (i = 1;                            /* sten Element mit 0.0 auf  */
              i < row_node->next->spalte -
                              row_node->spalte;
              i++, fprintf (Datei, "  0.0  "));
         }
      row_node = row_node->next;                /* naechstes Zeilenelement   */
      }                                         /* END WHILE (row_node->next)*/
   fprintf (Datei, " %4.1f  ",row_node->element);/* Letztes Zeilenelemnt > 0 */
                                                /* ausgeben                  */
   if (row_node->spalte < n)                    /* Zeile mit [0.0] bis Zei-  */
      {                                         /* lenende auffuellen        */
      for (i = 1;
           i < n - row_node->spalte;
           i++, fprintf (Datei, "  0.0  "));
      }
   }
fprintf (Datei, "\n");
}



/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

float Element (MATRIX_ELEMENT_PTR Row,          /* Zeiger auf Matrixzeile    */
               int                RowI)         /* i-te Zeile der Matrix     */

#else

float Element (Row, RowI)

MATRIX_ELEMENT_PTR Row;                         /* Zeiger auf Matrixzeile    */
int                RowI;                        /* i-te Spalte der Matrix    */

#endif

/*                                                                           */
/*  gibt den Wert des i-ten Elements einer Zeile zurueck                     */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_ELEMENT_PTR row = Row;                  /* Aktueller Zeiger auf Zeile */

RowI--;
if (row == NULL)                                /* WENN leere Zeile          */
  return (0.0);                                 /* DANN 0.0 zurueck          */
                                                /* ANDERNFALLS,              */
else                                            /* WENN nicht leere Zeile    */
  {
    if (row->spalte == RowI)                    /* WENN Zeile.Spalte gleich i*/
      {
	return (row->element);                  /* DANN Wert elemnt zurueck  */
      }                                         /* ANDERNFALLS,              */
    else if (row->spalte  > RowI)               /* WENN Zeile.Spalte > i     */
      {
	return (0.0);                           /* DANN 0.0 zurueck          */
      }                                         /* ANDERNFALLS,              */
    else                                        /* Wenn Zeile.Spalte < i     */
      {
	while ((row->spalte < RowI)             /* DANN Zeile auf Suche nach */
	       && (row->next != NULL))          /* passendem i durchlaufen   */
	  {
	    row = row->next;
	  }                                     /* END WHILE (passende Zeile */
                                                /*            suchen)        */
	if (row->spalte == RowI)                /* WENN passende i gefunden  */
	  {
	    return (row->element);              /* DANN Element zurueck      */
	  }                                     /* END IF (row->spalte=RowI) */
        else                                    /* ANDERNFALLS  0 zurueck    */
	  {
	    return (0.0);
	  }                                     /* END IF (row->spalte>RowI) */
      }                                         /* END IF (row->spalte<RowI) */
  }                                             /* END ELSE IF (row != NULL) */
}                                               /***     END OF Element    ***/


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

float element (MATRIX_HEAD_PTR   Matrix,        /* Zeiger auf Matrix         */
               int               RowI  ,        /* i-te Zeile                */
               int               ColJ  )        /* j-te Spalte               */

#else

float element (Matrix, RowI, ColJ)

MATRIX_HEAD_PTR   Matrix;                       /* Zeiger auf Matrix         */
int               RowI,                         /* i-te Zeile                */
                  ColJ;                         /* j-te Spalte               */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  liefert den Wert des Elements der 'i`-ten Zeile und 'j`-ten Spalte 	     */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_HEAD_PTR   matrix  = Matrix;             /* Arbeitszeiger auf Matrix  */
int               counter = 1;

while ((matrix != NULL) && (counter < RowI))    /* SOLANGE 'mat` und Zeile i */
   {                                            /* nicht erreicht            */
   matrix = matrix->next;                       /* naechste Zeile            */
   counter++;                                   /* bis zeile i erreicht ist  */
   }                                            /* END WHILE ((!mat) & (t<i))*/
return (Element (matrix->HeadPtr, ColJ));       /* gebe Wert von j-ter Spal- */
                                                /* te aus Zeile i zurueck    */
}


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_HEAD_PTR Change_Value
                       (MATRIX_HEAD_PTR Matrix, /* zu bearbeitende Matrix    */
                        int             RowI  , /* Zeile i                   */
                        int             ColJ  , /* Spalte j                  */
                        float           Value ) /* neuer Wert                */

#else

MATRIX_HEAD_PTR Change_Value (Matrix, RowI, ColJ, Value)

MATRIX_HEAD_PTR    Matrix;                      /* zu bearbeitende Matrix    */
int                RowI,                        /* Zeile i                   */
                   ColJ;                        /* Spalte j                  */
float              Value;                       /* neuer Wert                */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  ersetzt den Wert des Elements (i,j) in der Matrix M durch a              */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_HEAD_PTR    matrix = Matrix;             /* Arbeitszeiger auf Matrix  */
MATRIX_ELEMENT_PTR row,                         /* Zeiger auf Matrixzeile    */
                   neu,                         /* Zeiger auf neu zu erzeu-  */
                                                /* gendes Matrixelement      */
                   help;                        /* Hilfszeiger               */
int                k = 0;                       /* Hilfszaehler              */

RowI--;
ColJ--;

while ((k < RowI) && (matrix != NULL))          /* gehe zur i-ten Zeile      */
   {
   matrix = matrix->next;
   k++;
   }                                            /* END WHILE ((k<i) && (mat))*/

row = matrix->HeadPtr;                          /* (i-te) Zeile zuweisen     */
if (Value != 0.0)                               /* Nur ersetzen wenn a <> 0  */
   {
   if (row == NULL)                             /* Da Zeile leer ist         */
      {
      matrix->HeadPtr = (MATRIX_ELEMENT_PTR)
                      Malloc (sizeof (MAT_ELEM));
      matrix->HeadPtr->spalte = ColJ;
      matrix->HeadPtr->zeile = RowI;            /* neue Zeile erzeugen       */
      matrix->HeadPtr->element = Value;
      matrix->HeadPtr->next = NULL;
      return (Matrix);
      }                                         /* END IF (row == NULL)      */

   else if (ColJ < row->spalte)                 /* DA j < Zeile.Spalte       */
           {
           neu = (MATRIX_ELEMENT_PTR)
                     Malloc (sizeof (MAT_ELEM));
           neu->spalte = ColJ;
           neu->zeile = RowI;                   /* neues Element in Zeile    */
           neu->element = Value;                /* einfuegen                 */
           neu->next = row;
           matrix->HeadPtr = neu;
           return (Matrix);
           }                                    /* END IF (j < row->spalte)  */

   while ( (row->spalte < ColJ) &&              /* Zu j-ten Eintrag in der   */
           (row->next != NULL)     )            /* Zeile 'row` gehen         */
      {
      help = row;
      row = row->next;
      }
   if (row->spalte > ColJ)                      /* WENN Zeile.Spalte > j ist */
      {
      neu = (MATRIX_ELEMENT_PTR)
                     Malloc (sizeof (MAT_ELEM));
      neu->spalte = ColJ;
      neu->zeile = RowI;                        /* Element in Zeile einfuegen*/
      neu->element = Value;
      help->next = neu;
      neu->next = row;
      }                                         /* END IF (row->spalte > j)  */
   else if (row->spalte < ColJ)                 /* WENN Zeile.Spalte < j ist */
           {
           row->next = (MATRIX_ELEMENT_PTR)
                      Malloc (sizeof (MAT_ELEM));
           row->next->spalte = ColJ;
           row->next->zeile = RowI;             /* neues Element an Zeile    */
           row->next->element = Value;          /* anhaengen                 */
           row->next->next = NULL;
           }                                    /* END IF (row->spalte < j)  */
   else /* Zeile.Spalte = j */
   {
     row->element = Value; /* Wert aendern */
   }
  } /* END  IF (a != 0.0) */

else if ((Value == 0.0) && (row != NULL))       /* WENN a = 0,               */
        {                                       /* DANN Eintrag loeschen     */
        while ( (row->spalte < ColJ)   &&       /* Zu j-ten Eintrag in der   */
                (row->next != NULL)   )         /* Zeile 'row` gehen         */
           {
           help = row;
           row = row->next;
           }                                    /* END WHILE !(j-ter Eintrag)*/
        if (row->spalte == ColJ)                /* WENN Zeile.spalte = j     */
           {
           if (row == matrix->HeadPtr)          /* WENN erstes Zeilenelement */
              {
              matrix->HeadPtr = row->next;      /* Eintrag loeschen          */
              free (row);
              }                                 /* END IF (row==mat->HeadPtr)*/
           else if (row->next == NULL)          /* WENN Zeilenende           */
                   {
                   help->next = NULL;           /* neuses Zeilenende setzen  */
                   free (row);
                   }                            /* ENDIF (row->next == NULL) */
                else                            /* ANDERNFALLS (in der Zeile)*/
                   {                            /* Eintrag aus der Zeile ent-*/
                   help->next = row->next;      /* fernen                    */
                   free (row);
                   }                            /* END ELSE (row->next)      */
           }                                    /* END IF (row->spalte == j) */
       }                                        /* ENDIF (a==0)&&(row!=NULL) */
return (Matrix);                                /* geaenderte Matrix zurueck */
}                                               /***   END  Change_Value   ***/


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_ELEMENT_PTR Multiplication
                     (MATRIX_ELEMENT_PTR Row,   /* Zeiger auf Zeile R        */
                      float              Value) /* Multiplikator             */

#else

MATRIX_ELEMENT_PTR Multiplication (Row, Value)

MATRIX_ELEMENT_PTR Row;                         /* Zeiger auf Zeile R        */
float              Value;                       /* Multiplikator             */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  Multiplikation einer Zeile `R` mit einer Zahl `a`                        */
/*                                                                           */
/*****************************************************************************/

{
  MATRIX_ELEMENT_PTR row = Row;                /* Zeiger auf Matrixzeile    */

  if (Value == 0.0)
  { /* gebe leere Zeile zurueck  */
    return (NULL);
  }
  while (row != NULL)
  {  /* multipliziere jedes Element mit Value */
    row->element = Value * (row->element);
    row = row->next;
  }
  return (Row); /* Rueckgabe der mit 'Value' multiplizierte Zeile */
}


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_HEAD_PTR Transponation (
                  MATRIX_HEAD_PTR Matrix,       /* zu transponierende Matrix */
                  int             Columns)      /* Anzahl Spalten            */

#else

MATRIX_HEAD_PTR Transponation (Matrix, Columns)

MATRIX_HEAD_PTR   Matrix;                       /* zu transponierende Matrix */
int               Columns;                      /* Anzahl Spalten            */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  Bildet die Transponierte einer Matrix                                    */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_HEAD_PTR matrix       = Matrix,          /* transponierende Matrix    */
                transmatrix  = (MATRIX_HEAD_PTR)/* Zeiger fuer Rueckgabe     */
                    Malloc (sizeof (MAT_HEAD)),
                transmat     = transmatrix,     /* transponierte Matrix      */
                transmatlast = NULL;            /* Hilfszeiger auf vorletzte */
                                                /* Zeile der transponierten  */
                                                /* Matrix                    */
int             row          = 1,
                col          = 1;

transmat->HeadPtr = NULL;
transmat->next = NULL;

while (row <= Columns)                          /* WEIL Zeile<=Matrixspalten */
   {
   col = 1;                                     /* initialisere Spalte       */
   while (matrix != NULL)                       /* WEIL Matrix nicht leer    */
      {                                         /* tausche die Werte         */
      Change_Value (transmatrix, row, col,
                 Element (matrix->HeadPtr, row));
      matrix = matrix->next;                    /* naechste Zeile in alter   */
                                                /* zu transponierender Matrix*/
      col++;                                    /* naechste Spalte in trans- */
                                                /* ponierter  Matrix         */
      }                                         /* END WHILE (matrix != NULL)*/
   transmat->next = (MATRIX_HEAD_PTR)
                      Malloc (sizeof (MAT_HEAD));
   transmatlast = transmat;                     /* naechste Zeile in der     */
   transmat = transmat->next;                   /* neuen, transponierten     */
   transmat->HeadPtr = NULL;                    /* Matrix erzeugen           */
   transmat->next = NULL;
   matrix = Matrix;
   row++;
   }                                            /* END WHILE (i <= n)        */
transmatlast->next = NULL;
free (transmat);
return (transmatrix);
}


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_ELEMENT_PTR Add_Rows
                    (MATRIX_ELEMENT_PTR  Row1,   /* neue, addierte Zeile     */
                     MATRIX_ELEMENT_PTR  Row2)   /* zu addierende Zeile      */

#else

MATRIX_ELEMENT_PTR Add_Rows (Row1, Row2)

MATRIX_ELEMENT_PTR   Row1,                       /* neue, addierte Zeile     */
                     Row2;                       /* zu addierende Zeile      */

#endif                                           /* END STDC & C++ DEFINITION*/

/*                                                                           */
/*  liefert die Addition zweier Zeilen einer Matrix                          */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_ELEMENT_PTR   row1   = Row1,               /* Zeiger auf Zeile, zu    */
                                                  /* der addiert wird        */
                     row2   = Row2,               /* Zeiger auf zu addieren- */
                                                  /* de Zeile                */
                     help   = Row1,               /* Hilfszeiger             */
                     begin  = NULL;

if ( (row2 == NULL)                   ||          /* FALLS Zeile2 oder bei-  */
    ((row2 == NULL) && (row1 == NULL))  )         /* de Zeilen leer DANN     */
   {
   return (Row1);                                 /* Rueckgabe unveraendert  */
   }

else if (row1 == NULL)                            /* WENN Zeile1 = leer      */
        {                                         /* DANN fordere neuen      */
        row1 = (MATRIX_ELEMENT_PTR)
                       Malloc (sizeof (MAT_ELEM));
        Row1 = row1;                              /* Speicherplatz an        */
        while (row2 != NULL)                      /* WEIL Zeile2 nicht leer  */
           {
           row1->element = row2->element;         /* schreibe alle Werte von */
           row1->zeile = row2->zeile;             /* Zeile2 in Zeile1        */
           row1->spalte = row2->spalte;
           row1->next = (MATRIX_ELEMENT_PTR)
                        Malloc (sizeof (MAT_ELEM));
           help = row1;                           /* und gehe in beiden Zei- */
           row1 = row1->next;                     /* zum jeweils naechsten   */
           row2 = row2->next;                     /* Element in der Zeile    */
           }                                      /* ENDWHILE (row2 != NULL) */
        free (row1);
        help->next = NULL;
        return (Row1);                            /* gebe neue Zeiel zurueck */
        }                                         /* END IF  (row1 == NULL)  */
     else if (row1->spalte > row2->spalte)        /* Z1.Spalte > Z2.Spalte   */
       {                                    /* DANN fuege neue Zeilen- */
             begin = (MATRIX_ELEMENT_PTR)
                       Malloc (sizeof (MAT_ELEM));
             Row1 = begin;                        /* elemente in Zeile1 ein  */
             while ((row2 != NULL)             && /* SOLANGE Zeile2 <> leer  */
                    (row1->spalte > row2->spalte))/* & Z1.spalte > Z2.Spalte */
                {
                begin->element = row2->element;   /* Zeilenelement einfuegen */
                begin->spalte = row2->spalte;
                begin->zeile = row1->zeile;
                begin->next = (MATRIX_ELEMENT_PTR)
                       Malloc (sizeof (MAT_ELEM));
                help = begin;
                begin = begin->next;
                row2 = row2->next;
                }
             free (begin);
             help->next = row1;
             help = row1;
       }

while (row2 != NULL)
   {
   if (row1 != NULL)
      {
      if (row1->spalte == row2->spalte)
         {
         row1->element = row1->element +          /* addiere Z1.Element */
                         row2->element;           /* und Z2. Element         */
         help = row1;
         row1 = row1->next;                       /* weiter zu den naechsten */
         row2 = row2->next;                       /* Zeilenelementen         */
         }                                        /* END IF (Z1.Sp = Z2.Sp)  */
      else if (row1->spalte < row2->spalte)       /* WENN Z1.Sp < Z2.Sp      */
              {                                   /* DANN setze Zeiger nur   */
              help = row1;                        /* in Z1 weiter            */
              row1 = row1->next;
              }                                   /* END IF (Z1.Sp < Z2.Sp)  */
           else                                   /* WENN Z1.Sp > Z2.Sp      */
                   {
                   help->next = (MATRIX_ELEMENT_PTR) Malloc (sizeof (MAT_ELEM));
                   help->next->element = row2->element;
                   help->next->spalte = row2->spalte;
                   help->next->zeile = row1->zeile;/* DANN fuege neues Zei-  */
                   help->next->next = row1;       /* lenelement in Z1 ein    */
                   help = help->next;             /* und setze Zeiger in Z2  */
                   row2 = row2->next;             /* und help weiter         */
                   }                              /* END IF ( Z1.Sp > Z2.Sp) */
      }                                           /* END IF (row1 != NULL)   */
   else if (help->next == NULL)                   /* WENN am Zeilenende Z1   */
           {                                      /* Dann fuege nues Element */
           help->next = (MATRIX_ELEMENT_PTR)
                        Malloc (sizeof (MAT_ELEM));
           help = help->next;
           help->element = row2->element;         /* an Z1 an und setzte     */
           help->spalte = row2->spalte;
           help->zeile = help->zeile;
           help->next = NULL;
           row2 = row2->next;                     /* Zeiger in Z2 weiter     */
           }                                      /* ENDIF (help->next==NULL)*/
   }                                              /* ENDWHILE (row2 != NULL) */
return (Row1);                                    /* gebe neue Zeiel zurueck */
}                                                 /***   END OF Add_Rows   ***/


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

void Change_Rows (MATRIX_HEAD_PTR Row1,
                  MATRIX_HEAD_PTR Row2)

#else

void Change_Rows (Row1, Row2)

MATRIX_HEAD_PTR   Row1,
                  Row2;

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  vertauschen zweier Zeilen einer Matrix                                   */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_ELEMENT_PTR row = Row1->HeadPtr;

Row1->HeadPtr = Row2->HeadPtr;
Row2->HeadPtr = row;
}                                                /***  END OF Change_Rows  ***/


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_ELEMENT_PTR Change_ij (
                         MATRIX_ELEMENT_PTR   H,/* zu bearbeitende Zeile     */
                         int                  i,/* Zeile i                   */
                         int                  j,/* Zeile j                   */
                         int                  n)/* Anzahl Zeilenelemente     */

#else

MATRIX_ELEMENT_PTR Change_ij (H, i, j, n)

MATRIX_ELEMENT_PTR   H;                         /* zu bearbeitende Zeile     */
int                  i,                         /* Zeile i                   */
                     j,                         /* Zeile j                   */
                     n;                         /* Anzahl Zeilenelemente     */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  vertauschen der Spalten "i" und "j" in einer "n"-spaltigen Zeile "Row"   */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_ELEMENT_PTR   mat     = H;               /* Zeiger auf Zeile          */
MATRIX_ELEMENT_PTR   coli    = mat,             /* Zeiger auf Zeilenelement i*/
                     colj    = mat,             /* Zeiger auf Zeilenelement j*/
                     helpi   = coli,            /* Hilfszeiger auf ZE i      */
                     helpj   = colj,            /* Hilfszeiger auf ZE j      */
                     neu     = NULL;            /* neues Zeilenelement       */
float                elem;
int                  k;

i--;                                            /* Initialisierungen         */
j--;

if (i > j)                                      /* WENN i > j                */
   {                                            /* DANN Vertausche i und j   */
   k = i;
   i = j;
   j = k;
   }                                            /*          END IF (i > j)   */

if ( (j <= n) && (H != NULL) )                  /* WENN Zeile nicht leer  &  */
   {                                            /* j < Anzahl Spalten von H  */
                                                /* DANN                      */
   while ((coli != NULL) && (coli->spalte < i)) /* setze Zeiger Coli auf     */
      {                                         /* Spalte i                  */
      helpi = coli;
      coli = coli -> next;
      }                                         /* END WHILE ((coli != NULL) */
                                                /* && (coli->spalte < i))    */
   while ((colj != NULL) && (colj->spalte < j)) /* und setze Zeiger colj     */
      {                                         /* auf Spalte j              */
      helpj = colj;
      colj = colj->next;
      }                                         /* END WHILE ((colj != NULL) */
                                                /* && (colj->spalte < j))    */
   if ((colj != NULL) && (coli != NULL))        /* WENN beide Zeiger <> leer */
      {
      if ( (colj->spalte == j)           &&     /* WENN Spalte j = Spalte i  */
           (colj->spalte == coli->spalte)   )
         {
         colj->spalte = i;
         }                                      /* END IF ((colj->sp == j)   */
                                                /* & (colj->sp == coli->sp)) */

      else if ( (coli->spalte == i) &&          /* ANDERNFALLS WENN          */
                (colj->spalte > j)    )         /* Coli.Sp = i & Colj.Sp = j */
              {
              neu = (MATRIX_ELEMENT_PTR)
                         Malloc(sizeof(MAT_ELEM));
              neu->element = coli->element;
              neu->spalte  = j;                 /* DANN erzeuge neues Zei-   */
              neu->zeile   = coli->zeile;       /* lenelement j              */
              neu->next    = colj;
              helpj->next  = neu;

              if (i == 0)
                 {
                 H = coli->next;
                 }
              else
                 {
                 helpi->next = coli->next;
                 }
              free (coli);
              }                                  /*  END IF (Colj.Sp = i) && */
                                                 /*         (Coli.Sp > j)    */

           else if ( (coli->spalte == i) &&      /* ANDERNFALLS WENN         */
                     (colj->spalte == j)   )     /* Colj.Sp = j & Coli.Sp = i*/
                   {
                   elem = coli->element;         /* DANN                     */
                   coli->element = colj->element;/* tausche die Elemente aus */
                   colj->element = elem;
                   }                             /*  END IF (Coli.Sp = i) && */
                                                 /*         (Colj.Sp = j)    */

                else if ( (coli->spalte > i) &&  /* ANDERNFALLS WENN         */
                          (colj->spalte == j)  ) /* Coli.Sp > i & Colj.Sp = j*/
                        {
                        neu = (MATRIX_ELEMENT_PTR)
                        Malloc (sizeof (MAT_ELEM));
                        neu->element = colj->element;
                        neu->spalte  = i;
                        neu->zeile   = colj->zeile;
                        neu->next    = coli;     /* DANN erzeuge neues Zei-  */
                                                 /* lenelement i             */
                        if (coli == H)
                           {
                           H = neu;
                           }
                        else
                           {
                           helpi->next = neu;
                           }

                        helpj->next  = colj->next;
                        free(colj);
                        }                        /*  END IF (Coli.Sp > i) && */
                                                 /*         (Colj.Sp = j)    */
      }                                          /* END IF ((colj != NULL)   */
                                                 /*       && (coli != NULL)) */

   else if ( (colj == NULL)              &&      /* WENN Spalte j nicht da   */
            ((i == 0) || (helpi == coli))  )     /* und i=0 oder helpi = coli*/
           {
           if (coli->spalte == i)                /* dann Spalte j erzeugen   */
              {
              neu = (MATRIX_ELEMENT_PTR)
                     Malloc (sizeof (MAT_ELEM));
              neu->spalte  = j;
              neu->zeile   = coli->zeile;
              neu->element = coli->element;
              neu->next    = NULL;
              helpj->next  = neu;

              H = coli->next;
              free (coli);
              }                                  /* END IF (coli->sp == i)   */
           }                                     /* END IF ((colj == NULL) &&*/
                                                 /* ((i==0) || (helpi==coli))*/

        else if ( (colj == NULL)      &&         /* WENN Spalte Colj leer    */
                  (coli != NULL)      &&         /* UND  Spalte coli nicht   */
                  (coli->spalte == i)   )        /* und coli = i, DANN       */
                {
                neu = (MATRIX_ELEMENT_PTR)
                         Malloc(sizeof(MAT_ELEM));
                neu->spalte  = j;
                neu->zeile   = coli->zeile;      /* Erzeuge neues Element    */
                neu->element = coli->element;
                neu->next    = NULL;
                helpj->next  = neu;
                helpi->next  = coli->next;
                free (coli);
                }                                /* END IF ((colj == NULL)   */
                                                 /*     && (coli!=NULL)      */
                                                 /*  && (coli->spalte == i)) */
   }                                             /* END IF ((j < = n) &&     */
                                                 /*        (H != NULL)  )    */
return (H);
}                                                /***   END OF Change_ij   ***/





/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_HEAD_PTR Change_Columns (
                         MATRIX_HEAD_PTR  M,    /* zu bearbeitende Zeile     */
                         int              i,    /* Zeile i                   */
                         int              j,    /* Zeile j                   */
                         int              n)    /* Anzahl Zeilenelemente     */

#else

MATRIX_HEAD_PTR Change_Columns (M, i, j, n)

MATRIX_HEAD_PTR      M;                         /* zu bearbeitende Zeile     */
int                  i,                         /* Zeile i                   */
                     j,                         /* Zeile j                   */
                     n;                         /* Anzahl Zeilenelemente     */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  vertauschen der Spalten "i" und "j" in "n"-spaltiger Matrix "M"          */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_HEAD_PTR    row;                         /* Zeiger auf Zeile von M    */

if ((i > 0) && (j > 0) && (i <= n) && (j <= n)) /* Erfolgt Tausch innerhalb  */
   {                                            /* der Grenzen (n,m) von M?  */
   row = M;                                     /* Zeilenzeiger setzen       */
   while (row != NULL)                          /* WENN Zeile <> leer, DANN  */
      {                                         /* i-tes & j-tes Zeilenelment*/
      row->HeadPtr = Change_ij (row->HeadPtr, i, j, n); /* tauschen          */
      row = row->next;                          /* naechste Zeile            */
      }                                         /* END WHILE (row != NULL)   */
   }                                            /* END IF(i>0&j>0&i<=n&j<=n) */
return (M);                                     /* Matrix M zurueckgeben     */
}                                               /*** END Change_Columns () ***/


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_HEAD_PTR Insert_Column (
                     MATRIX_HEAD_PTR    Matrix, /* Zu bearbeitende Matrix    */
                     MATRIX_ELEMENT_PTR Column, /* Zeiger auf einzufuegenden */
                                                /* Spaltenvektor             */
                     int                Col     /* Spalte, nach der einzufue-*/
                                                /* gender Vektor eingetragen */
                                                /* werden soll               */
                     #if defined (__MTRACE__)   /* TRACE ausgabe             */
                                              ,
                     FILE             * Datei
                     #endif                     /* END __MTRACE__ DEFINITION  */
                                               )

#else

MATRIX_HEAD_PTR Insert_Column (Matrix, Column, Col

                     #if defined (__MTRACE__)   /* TRACE ausgabe             */
                                              ,
                                          Datei
                     #endif                     /* END __TRACE__ DEFINITION  */
                                               )

MATRIX_HEAD_PTR      Matrix;                    /* Zu bearbeitende Matrix    */
MATRIX_ELEMENT_PTR   Column;                    /* Zeiger auf einzufuegenden */
                                                /* Spaltenvektor             */
int                  Col;                       /* Spalte, nach der einzufue-*/
                                                /* gender Vektor eingetragen */
                                                /* werden soll               */
   #if defined (__MTRACE__)                     /* TRACE ausgabe             */

   FILE            * Datei;

   #endif                                       /* END __TRACE__ DEFINITION  */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  Einfuegen einer Spalte "Column" in die Matrix "Matrix" nach Spalte "Col" */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_HEAD_PTR      matrix = Matrix;           /* Zeiger auf Matrix         */
MATRIX_ELEMENT_PTR   help   = Column,           /* Hilfszeiger auf Spalte    */
                     row    = matrix->HeadPtr;  /* Auf 1. Zeile der Matrix   */
                                                /* zeigen                    */
int                  rowcount = 0;              /* Zeilen zaehler            */

while (matrix != NULL)                          /* WEIL Matrix nicht leer    */
   {                                            /* DO                        */
   row = matrix->HeadPtr;                       /* Auf Zeile zeigen          */
   if (help->element != 0.0)                    /* WENN Spaltenelement einen */
      {                                         /* Eintrag hat, DANN         */
      if (row != NULL)                          /* WENN nicht am Zeilenende  */
         {                                      /* DANN  an das Ende der     */
         while (row->next != NULL)              /* Zeilenliste gehen und     */
            {
            row = row->next;
            }                                   /* END WHILE (!row->next)    */
         row->next = (MATRIX_ELEMENT_PTR)
                      Malloc (sizeof (MAT_ELEM));
         row->next->element = help->element;
         row->next->zeile   = row->zeile;       /* neues Zeilenelement in    */
         row->next->spalte  = Col;              /* Zeilenliste eintragen     */
         row->next->next    = NULL;
         }                                      /* END IF (row != NULL)      */

      else                                      /* ANDERNFALLS, WENN am Zei- */
              {                                 /* lenende                   */
              matrix->HeadPtr = (MATRIX_ELEMENT_PTR)
                      Malloc (sizeof (MAT_ELEM));
              matrix->HeadPtr->zeile   = rowcount;
              matrix->HeadPtr->spalte  = Col;   /* Zeilenliste erzeugen      */
              matrix->HeadPtr->element = help->element;
              matrix->HeadPtr->next    = NULL;
              }                                 /* END IF  (row == NULL)     */
      }                                         /* END IF (help->element!=0) */
      rowcount++;
      help = help->next;                        /* naechstes Spaltenelement  */

      #ifdef __MTRACE__                         /* TRACEn Matrixbibliothek   */
      Show_Row (row, Col, Datei);
      #endif                                    /* END __MTRACE__ DEFINITION */

      matrix  = matrix->next;                   /* naechste Zeile            */
   }                                            /* END WHILE (mat != NULL)   */
return ( Matrix );                              /* Rueckgabe neue Matrix     */
}                                               /*** END OF Insert_Column  ***/



/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_ELEMENT_PTR Del_Row (MATRIX_ELEMENT_PTR Row)   /* zu loeschende Zeile */

#else

MATRIX_ELEMENT_PTR Del_Row (Row)

MATRIX_ELEMENT_PTR     Row;                     /* zu loeschende Matrixzeile */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  Loeschen einer im Speicher abgelegten Zeile "Row"                        */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_ELEMENT_PTR  delptr = Row,               /* Zeiger auf zu loeschendes */
                                                /* Matrixelement setzen      */
                    forptr;                     /* Zeiger auf das naechste   */
                                                /* zu loeschende Element     */

while (delptr != NULL)                          /* SOLANGE Zeile nicht leer  */
   {                                            /* DO                        */
   forptr = delptr->next;                       /* loeschen                  */
   Free (delptr);
   delptr = forptr;
   }
Row = NULL;
return (Row);                                   /* leere Zeile zurueckgeben  */
}                                               /***   END  Del_Matrix ()  ***/




/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_HEAD_PTR Del_Matrix (MATRIX_HEAD_PTR Matrix)/* zu loeschende Matrix   */

#else

MATRIX_HEAD_PTR Del_Matrix (Matrix)

MATRIX_HEAD_PTR     Matrix;                     /* zu loeschende Matrix      */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  Loeschen einer im Speicher abgelegten Matrix "Matrix"                    */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_HEAD_PTR     help = Matrix;              /* Hilfszeiger               */

while (Matrix != NULL)                          /* SOLANGE Matrix nicht leer */
   {                                            /* DO                        */
   help = Matrix;                               /* Hilfszeiger auf aktuelle  */
                                                /* Zeile der Matrix setzen   */
   Matrix = Matrix->next;                       /* naechste Zeile            */
   help->HeadPtr = Del_Row (help->HeadPtr);     /* vorherige Zeile loeschen  */
   Free (help);                                 /* Hilfszeiger freigeben     */
   }                                            /* END WHILE (*Matrix!=NULL) */
return (Matrix);                                /* leere Matrix zurueckgeben */
}                                               /***   END  Del_Matrix ()  ***/


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_ELEMENT_PTR Convert_Marking (
                                 MARKING  Marke)/* Zeiger Markierungsliste   */

#else

MATRIX_ELEMENT_PTR Convert_Marking (Marke)

MARKING            Marke;                       /* Zeiger Markierungsliste   */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/* Konvertiert eine Markierungsliste "Marke" in einen SpaltenVektor, da eine */
/* Markierung ueber die Stellen geht.                                        */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_ELEMENT_PTR markptr  = NULL,             /* Zeiger auf Vektorelement  */
                   mark     = NULL,             /* zurueckzugebender Vektor  */
                   help     = NULL;             /* Hilfszeiger               */
int                colcount = 0;                /* Spaltenzaehler            */

if (Marke != NULL)                              /* WENN Markierung vorhanden */
   {                                            /* DANN Speicherplatz holen  */
   mark = (MATRIX_ELEMENT_PTR)
                   Malloc (sizeof (MAT_ELEM));
   markptr = mark;                              /* und Zeiger initialisieren */
   while (Marke != NULL)                        /* WEIL Markierungsliste     */
      {                                         /* nicht leer ist            */
      markptr->element = Marke->value;          /* Werte der Marke in Vek-   */
      markptr->zeile   = 0;                     /* torelement eintragen      */
      markptr->spalte  = colcount;
      markptr->next    = (MATRIX_ELEMENT_PTR)
                       Malloc (sizeof (MAT_ELEM));
      help             = markptr;
      markptr          = markptr->next;         /* naechstes Vektorelement   */
      Marke            = Marke->next;           /* weiter Markierungsliste   */
      colcount++;                               /* Spaltenzaehler erhoehen   */
      }                                         /* END WHILE (Marke != NULL) */
   help->next = NULL;
   free (markptr);                              /* Speicher freigeben        */
   return (mark);                               /* Vektor zurueckgeben       */
   }                                            /* END IF (Marke != NULL)    */
else	return (NULL);
}                                               /*** END Convert_Marking() ***/


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

void Print_Matrix_Ptr (MATRIX_HEAD_PTR   Matrix ,
                       int               Columns,
                       FILE            * Datei  )

#else

void Print_Matrix_Ptr (Matrix, Columns, Datei)

MATRIX_HEAD_PTR   Matrix;
int               Columns;
FILE              *Datei;

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  Gibt die in Zeigerform gespeicherte Matrix "Matrix" aus                  */
/*  Etwas weniger Ausgabe, aber mit Datei.                                   */
/*****************************************************************************/


{
MATRIX_HEAD_PTR     matrix = Matrix;

MATRIX_ELEMENT_PTR  Node   = Matrix->HeadPtr;

int                 col    = 1,
                    row    = 1;

float               elem   = 0.0;

while (matrix != NULL)
   {
   Node = matrix->HeadPtr;
   fprintf (Datei, " %2d [", row);
   col = 1;
   while (col <= Columns)
      {
      elem = Element (Node, col);
      fprintf (Datei,   elem == 0.0
                      ? "     "
                      : " %4.1f", elem);
      col++;
      }                                         /* END WHILE (i <= n)        */
   fprintf (Datei, " ]\n");
   row++;
   matrix = matrix->next;                       /* naechste Zeile            */
   }                                            /* END WHILE (Matrix != NULL)*/
fprintf (Datei, "\n");
}                                               /*** END Print_Matrix_Ptr  ***/



/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_HEAD_PTR Make_Zerro (MATRIX_HEAD_PTR    Matrix,
                            MATRIX_ELEMENT_PTR Row   ,/* i-te Zeile          */
                            int                ColJ  )/* j-te Spalte         */


#else

MATRIX_HEAD_PTR Make_Zerro (Matrix, Row, ColJ)

MATRIX_HEAD_PTR       Matrix;
MATRIX_ELEMENT_PTR    Row;                      /* i-te Zeile                */
int                   ColJ;                     /* j-te Spalte               */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  Aendert eine Matrix in eine obere Dreiecks-Matrix                        */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_HEAD_PTR       Mhelp = Matrix;
MATRIX_ELEMENT_PTR    Rhelp;

float                 elem1 = 0.0,
                      elem2 = 0.0;


if (Element (Row, ColJ) != 0.0)                 /* WENN Elemnt A(i,j) <> 0   */
   {                                            /* DANN                      */
   while ( (Mhelp->HeadPtr != Row) &&           /* gehe zur i-ten Zeile      */
           (Mhelp->next != NULL)      )
      {
      Mhelp = Mhelp->next;
      }                                         /* END WHILE (i-teZeile)     */
   while (Mhelp->next != NULL)                  /* WEIL weitere Zeilen vor-  */
      {                                         /* handen DO                 */
      Mhelp = Mhelp -> next;                    /* falls in j-ter Spalte ab  */
      Rhelp = Mhelp -> HeadPtr;                 /* Zeile i Matrixelemente    */
      elem1 = Element (Row, ColJ);              /* <> 1 vorkommen, addiere   */
      elem2 = Element (Rhelp, ColJ);            /* diese mit i-ter Zeile     */
      if (elem2 != 0.0)
         {
         Rhelp = Add_Rows (Rhelp, Multiplication (Row, -1.0 * elem2 / elem1));
         Multiplication (Row, -1.0 * elem1 / elem2);
         }                                      /* END IF (elem2 != 0.0)     */
      }                                         /* END WHILE (MHelp->next)   */
   }                                            /* END IF (Element(R,j)!= 0) */
return (Matrix);
}                                               /***   END  Make_Zerro ()  ***/


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

MATRIX_HEAD_PTR Gauss_Elimination
                   (MATRIX_HEAD_PTR   Matrix,   /* bearbeitende Matrix       */
                    int               Columns)  /* #Spalten der Matrix       */

#else

MATRIX_HEAD_PTR Gauss_Elimination (Matrix, Columns)

MATRIX_HEAD_PTR Matrix;                         /* bearbeitende Matrix       */
int             Columns;                        /* #Spalten der Matrix       */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  Wendet Gauss-Seidel Algorithmus auf "n"-spaltige Inzidenz-Matrix "M" an  */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_HEAD_PTR     matrix = Matrix,            /* Zeiger auf Matrixzeilen   */
                    under  = NULL;              /* Zeiger auf Zeile unter-   */
                                                /* halb der aktuellen Zeile  */
MATRIX_ELEMENT_PTR  node   = NULL;              /* Zeiger auf Matrixelement  */
int                 colj   = 1;                 /* j-te Spalte               */

while (matrix->next != NULL)                    /* WEIL Matrix nicht leer    */
   {                                            /* DO                        */
   if (matrix->HeadPtr == NULL)                 /* WENN Matrixzeile leer     */
      {                                         /* DANN                      */
      under = matrix->next;                     /* naechste Zeile            */
      while ( (under->HeadPtr == NULL) &&       /* Suche naechste nichtlee-  */
              (under->next != NULL)      )      /* re Zeile                  */
         {
         under = under->next;
         }
      if (under->HeadPtr != NULL)               /* WENN nichtleere Zeile ge- */
         {                                      /* funden, DANN tausche lee- */
         Change_Rows (matrix, under);           /* re gegen nichtleere Zeile */
         }
      }                                         /* END OF 1st IF             */
                                                /* (matrix->HeadPtr == NULL) */
   matrix = matrix->next;
   }                                            /* END OF 1st WHILE          */
                                                /*   (matrix->next != NULL)  */
matrix = Matrix;                                /* Zeiger zuruecksetzen      */
colj = 1;

while ((matrix->HeadPtr != NULL) &&             /* WEIL noch Matrixelemente  */
       (matrix->next != NULL))                  /* DO                        */
   {
   if (Element (matrix->HeadPtr, colj) == 0.0)  /* WENN eine Null in der Di- */
      {                                         /* agonalen der Matrix ist,  */
      under = matrix->next;                     /* DANN                      */
      while ((Element (under->HeadPtr, colj)==0.0)/* Suche Matrixelement <> 0*/
             && (under->next != NULL))
         {
         under = under->next;
         }
      if (Element (under->HeadPtr, colj) != 0.0)/* WENN gefunden             */
         {
         Change_Rows (matrix, under);           /* DANN Zeilen vertauschen   */
         }
      else                                      /* ANDERNFALLS, versuche     */
              {                                 /* Spalten zu vertauschen    */
              node = matrix->HeadPtr;
              while ((node->next != NULL)    && /* weiter, falls Spalte < j- */
                     (node->spalte + 1 <= colj))/* te Spalte                 */
                 {
                 node = node->next;
                 }
              while ((node->next != NULL)   &&  /* weiter, falls Matrixele-  */
                     (node->element == 0.0)   ) /* ment = 0                  */
                 {
                 node = node->next;
                 }
              if (node->element != 0.0)         /* WENN Matrixelement <> 0   */
                 {                              /* DANN Spalten vertauschen  */
                 Matrix = Change_Columns (Matrix,
                 colj, node->spalte + 1, Columns);
                 }                              /*          END OF 6th IF    */
              }                                 /*     END OF 5th IF (ELSE)  */
      }                                         /* END IF (Element(matrix->  */
                                                /*      HeadPtr, j) == 0.0)  */
   matrix = Make_Zerro (matrix,                 /* pivotiere Spalte colj ab  */
                        matrix->HeadPtr, colj); /* Zeile matrix->HeadPtr     */
   matrix = matrix->next;                       /* naechste MatrixZeile      */
   colj++;
   }                                            /* END WHILE(Matrixelemente) */
return (Matrix);                                /* Rueckgabe Matrix in obe-  */
                                                /* Dreiecksform              */
}                                               /** END Gauss_Elimination() **/






/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

int Rang (MATRIX_HEAD_PTR    Matrix,            /* Matrix, von der der Rang  */
                                                /* berechnet werden soll     */
          int                Columns,           /* Anzahl der Spalten        */
          bool               Gauss)             /* Gauss_elimination noetig? */



#else

int Rang (Matrix, Columns, Gauss)

MATRIX_HEAD_PTR    Matrix;                      /* Matrix, von der der Rang  */
                                                /* berechnet werden soll     */
int                Columns;                     /* Anzahl der Spalten        */
bool               Gauss;                       /* Gauss_elimination noetig? */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  berechnet den Rang einer "columns"-spaltigen Matrix "Matrix"             */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_ELEMENT_PTR row;                         /* Zeiger auf Matrixzeile    */
int                rang = 0;                    /* Zaehler fuer den Rang     */

if (Gauss)                                      /* Wenn Matrix noch nicht in */
   {                                            /* oberer Dreiecksform ist,  */
   Gauss_Elimination (Matrix, Columns);         /* DANN dahin ueberfuehren   */
   }

while ( (Matrix != NULL) &&                     /* WEIL Matrix noch nicht    */
        (Matrix->HeadPtr != NULL))              /* durchlaufen               */
   {
   row = Matrix->HeadPtr;                       /* Zeile durchlaufen         */
   while ( (row->element == 0.0) &&             /* WEIL Matrixelement = 0 && */
           (row->next != NULL)     )            /* noch Zeilenelemente da    */
      {
      row = row->next;                          /* DO: Zeiger weitersetzen   */
      }
   if (row->element != 0.0)                     /* WENN Zeilenelement <> 0   */
      {
      rang++;                                   /* DANN rang inkrementieren  */
      }
   Matrix = Matrix->next;                       /* naechste Zeile            */
   }
return (rang);
}                                               /***       END   Rang      ***/


/*****************************************************************************/
/*                                                                           */
/*           Funktionen zur Bestimmung, ob eine Markierung M von             */
/*          der Startmarkierung M0 aus erreichbarr ist oder nicht            */
/*                                                                           */
/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

int Decide (LMPNet       net,                  /* zu bearbeitendes netz     */
            MARKING      Marke,                 /* erreichbare Markierung    */
            MARKING      Mark0                  /* Anfangsmarkierung         */

   #if defined(__MTRACE__)                      /* TRACE Matrixbibliothek    */
                               ,
            FILE       * Datei
   #endif                                       /* END __MTRACE__ DEFINITION */
                               )
#else

int Decide (net, Mark0, Marke

   #if defined(__MTRACE__)                      /* TRACEn Matrixbibliothek   */
                               ,
                               Datei
   #endif                                       /* END __MTRACE__ DEFINITION */
                               )

LMPNet       net;                              /* zu bearbeitendes netz     */
MARKING      Marke,                             /* erreichbare Markierung    */
             Mark0;                             /* Anfangsmarkierung         */

   #if defined(__MTRACE__)                      /* TRACEn Matrixbibliothek   */

   FILE    * Datei;

   #endif                                       /* END __MTRACE__ DEFINITION */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*  Entscheidet, ob die konvertierte Matrix eine Loesung besitzt oder nicht  */
/*                                                                           */
/*  Zunaechst wird der Rang der aus dem Netz "net" erstellten Inzidenzmat-  */
/*  rix C berechnet. Danach werden aus den beiden Markierungen "Mark0" und   */
/*  "Marke" in die Spaltenvektoren "mark0" und "marke" umgewandelt. Aus die- */
/*  sen beiden Spaltenvektoren, wird der Spaltenvektor "marke" - "mark0" ge- */
/*  bildet und um diesen wird dann die Matrix C erweitert.                   */
/*                                                                           */
/*  Dann wird der Rang dieser erweiterten Matrix berechnet. Sind die beiden  */
/*  Raenge gleich, ist das System loesbar. Um den Rang einer Matrix zu be-   */
/*  rechnen, wird diese mit Hilfe des Gauss-Algorithmus in obere Dreiecksform*/
/*  gebracht. Anschliessend ergibt die Anzahl der Zeilen, die nicht identisch*/
/*  null sind, den Rang der Matrix.                                          */
/*                                                                           */
/*  Ob das System eine eindeutige Loesung hat, oder einen Loesungsraum, ist  */
/*  hieraus nicht ersichtlich, allerdings ist dies fuer die Existenz einer   */
/*  Loesung auch nicht von Bedeutung. Dass die Loesung, sofern eine solche   */
/*  existiert, eine rationale Loesung ist, ist leicht ersichtlich, da die    */
/*  Inzidenzmatrix nur ganze Zahlen als Elemente enthaelt und die Opera-     */
/*  tionen, die der Gauss-Algorithmus verwendet (Addition, Multiplikation und*/
/*  Division) nicht aus der Menge der rationalen Zahlen hinausfuehren.       */
/*                                                                           */
/*****************************************************************************/

{
MATRIX_ELEMENT_PTR mark0 = Convert_Marking      /* Startmarkierung in Spal-  */
                                   (Mark0),     /* ten Vektor umwandeln      */
                   marke = Convert_Marking      /* erreichbare Markierung in */
                                   (Marke);     /* Spaltenvektor umwandeln   */

                                                /* Diese Vektoren beziehen   */
                                                /* sich auf die Stellen des  */
                                                /* Netzes                    */

MATRIX_HEAD_PTR    matrix = Net_To_Matrix (net);/* Netz in Inzidenzmatrix C */
                                                /* konvertieren              */
int                rangC  = 0,                  /* Rang d. Inzidenzmartrix C */
                   rangE  = 0,                  /* Rang der um den Spalten-  */
                                                /* vektor "mark"-"mark0" er- */
                                                /* weiterten Inzidenzmatrix C*/
                   tn = net->NumTransitions;   /* Anzahl der Transitionen   */
                                                /* des Netzes "net"         */

#if defined(__MTRACE__)                         /* TRACEn Matrixbibliothek   */
fprintf (Datei, " Inzidenzmatrix \n");
Print_Matrix_Ptr (matrix, tn, Datei);
#endif                                          /* END __MTRACE__ DEFINITION */

rangC = Rang (matrix, tn, True);                /* Rang der Inzidenzmatrix C */
                                                /* berechnen, dann Matrix    */
#if defined(__MTRACE__)                         /* TRACEn Matrixbibliothek   */
fprintf (Datei, " Rang Inzidenzmatrix \n");
Print_Matrix_Ptr (matrix, tn, Datei);
#endif                                          /* END __MTRACE__ DEFINITION */

Del_Matrix (matrix);                            /* loeschen und erneut Netz  */
matrix = Net_To_Matrix (net);                  /* in Inzidenzmatrix C       */
                                                /* konvertieren              */
#if defined(__MTRACE__)                         /* TRACEn Matrixbibliothek   */
fprintf (Datei, "erreichbare > ");
Show_Row (marke, tn, Datei);
fprintf (Datei, "Startmark.  > ");
Show_Row (mark0, tn, Datei);
#endif                                          /* END __MTRACE__ DEFINITION */

Add_Rows (marke, Multiplication (mark0, -1.0)); /* Vektor "marke"-"mark0"    */
                                                /* bilden durch addieren von */
                                                /* "marke" und "mark0"*(-1)  */
#if defined(__MTRACE__)                         /* TRACEn Matrixbibliothek   */
fprintf (Datei, "Mark-Mark0  > ");
Show_Row (marke, tn, Datei);
fprintf (Datei, "\n normale Matrix =>\n\n");
Print_Matrix_Ptr (matrix, tn, Datei);
matrix = Insert_Column (matrix, marke, tn, Datei);
#else
matrix = Insert_Column (matrix, marke, tn);     /* Inzidenzmatrix C durch an-*/
                                                /* fuegen von eben berechne- */
                                                /* Spaltenvektors erweitern  */
#endif                                          /* END __MTRACE__ DEFINITION */

#if defined(__MTRACE__)                         /* TRACEn Matrixbibliothek   */
fprintf (Datei, "\n erweiterte Matrix =>\n\n");
Print_Matrix_Ptr (matrix, tn + 1, Datei);
#endif                                          /* END __MTRACE__ DEFINITION */

rangE = Rang (matrix, tn + 1, 1);               /* Rang der erweiterten In-  */
                                                /* zidenzmatrix berechnen.   */

#if defined(__MTRACE__)                         /* TRACEn Matrixbibliothek   */
fprintf (Datei, "\nRang erweiterte Matrix \n");
Print_Matrix_Ptr (matrix, tn + 1, Datei);
fprintf (Datei, "\nRang Inzidenzmatrix C >%2d", rangC);
fprintf (Datei, " = %2d< Rang erweiterte Matrix\n", rangE);
#endif                                          /* END __MTRACE__ DEFINITION */

Del_Matrix (matrix);                            /* Den Speicher von der Mat- */
Del_Row (mark0);                                /* rix und den beiden Spal-  */
Del_Row (marke);                                /* tenvektoren befreien      */

if (rangC == rangE)                             /* WENN (Irang == Erang)     */
   {
   return (1);                                  /* gebe 1 (True) zurueck     */
   }
else                                            /* ANDERNFALLS               */
   {
   return (0);                                  /* gebe 0 (False) zurueck    */
   }
}   	                                        /***     END OF DECIDE     ***/


/*****************************************************************************/
/************     ENDE DER  MATRIX BIBLIOTHEK        *************************/
/*****************************************************************************/
