/**************************************************************************/
/*              PRAKTIKUM WERKZEUGE ZUR PETRI-NETZ-ANALYSE                */
/* HIER: Test auf n-Beschraenktheit                                       */
/**************************************************************************/
/* Stefan Roemer,                        Do., 17.02.1994 - Mi.,14.09.1994 */
/**************************************************************************/
#define VERSION "2.0.1"
#define DATE "14.09.1994"
/**************************************************************************/

#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include "neunetze.h"
#include "convertPEP.h"
#include "nbound.h"

/**************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int main( int argc, char ** argv )

#else

int main( argc, argv )

  int argc;
  char ** argv;

#endif 

  {

    LMPNet              net; 
    Place               pl;
    STEdge              st;
    TSEdge              ts;
    FILE                * outfile;
    char                inFilename[NAMELENGTH],
                        resFilename[NAMELENGTH],
                        UDGfilename[NAMELENGTH];
    int                 count;
    register Cardinal32 num,
                        upper_bound = 1,
                        ind;
    register char       fileparamcount = 0,
                        ch,
                        * ptr;
    bool                showVersion = False,
                        showUsage   = False;
    static char         null[2] = "\0";


/*#########################*/

    *inFilename = '\0';
    *resFilename = '\0';
    *UDGfilename = '\0';

    if ( argc > 1 )
      {
        count = 0;
        while ( ++count < argc )
          {
            if ( ( ch = *( ptr = argv[count] ) ) == '-' )
              {
                while (( ch = tolower( *++ptr ) ))
                  {
                    switch ( ch )
                      {
                        case 'b' : if ( *++ptr == '=' )
                                     {
                                       ind = 1;
                                       if ( isdigit( ch = *++ptr ) )
                                         {
                                           num = ch - '0';
                                           while ( isdigit( ch = *++ptr ) )
                                             {
                                               num *= ind++;
                                               num += ch - '0';
                                             } /* while */
                                           upper_bound = num;
                                         } /* if */
                                       else
                                         {
                                           fprintf( stderr,
        "ERROR: BOUNDED.main(): number (upper bound) expected after '-b='.\n" );
                                           exit ( 11 );
                                         } /* else */
                                       if ( ! num )
                                         {
                                           fprintf( stderr,
  "ERROR: BOUNDED.main(): upper bound greater than 0 expected after '-b='.\n" );
                                           exit ( 11 );
                                         } /* else */
                                     } /* if */
                                   else
                                     {
                                       upper_bound = 1;
                                     } /* else */
                                   ptr--;
                                   break;
                        case 'f' : if ( *++ptr != '=' )
                                     {
                                       fprintf( stderr,
                          "ERROR: BOUNDED.main(): '=' expected after '-f'.\n" );
                                       exit ( 11 );
                                     } /* if */
                                   if ( *inFilename )
                                     {
                                       fprintf( stderr,
                     "WARNING: BOUNDED.main(): parameter '-f' appears twice;" );
                                       fprintf( stderr,
                                                " %*s'%s' overwrites '%s'.\n",
                                                24, "", ptr + 1, inFilename );
                                     } /* if */
                                   strcpy( inFilename, ++ptr );
                                   ptr = null;
                                   break;
                        case 'r' : if ( *++ptr != '=' )
                                     {
                                       fprintf( stderr,
                          "ERROR: BOUNDED.main(): '=' expected after '-r'.\n" );
                                       exit ( 11 );
                                     } /* if */
                                   if ( *resFilename )
                                     {
                                       fprintf( stderr,
                     "WARNING: BOUNDED.main(): parameter '-r' appears twice;" );
                                       fprintf( stderr,
                                                " %*s'%s' overwrites '%s'.\n",
                                                24, "", ptr + 1, resFilename );
                                     } /* if */
                                   strcpy( resFilename, ++ptr );
                                   ptr = null;
                                   break;
 /* BG */
case 'p' : BOUND_progress = True;
break;
 /* BG */
                        case 's' : BOUND_statistics = True;
                                   break;
                        case 'u' : if ( *++ptr != '=' )
                                     {
                                       fprintf( stderr,
                          "ERROR: BOUNDED.main(): '=' expected after '-u'.\n" );
                                       exit ( 11 );
                                     } /* if */
                                   if ( *UDGfilename )
                                     {
                                       fprintf( stderr,
                     "WARNING: BOUNDED.main(): parameter '-u' appears twice;" );
                                       fprintf( stderr,
                                                " %*s'%s' overwrites '%s'.\n",
                                                24, "", ptr + 1, UDGfilename );
                                     } /* if */
                                   strcpy( UDGfilename, ++ptr );
                                   ptr = null;
                                   break;
                        case 'v' : showVersion = True;
                                   break;
                        case '$' : showUsage = True;
                                   break;
                        default  : fprintf( stderr,
                              "WARNING: BOUNDED.main(): bad parameter '%s'.\n",
                                                                 argv[count] );
                                   break;
                      } /* switch */
                  } /* while */
              } /* if */
            else
              {
                if ( isdigit( ch ) )
                  {
                    ind = 1;
                    num = ch - '0';
                    while ( isdigit( ch = *++ptr ) )
                      {
                        num *= ind++;
                        num += ch - '0';
                      } /* while */
                    if ( num )
                      {
                        upper_bound = num;
                      } /* if */
                    else
                      {
                        fprintf( stderr,
             "ERROR: BOUNDED.main(): upper bound greater than 0 expected.\n" );
                        exit ( 11 );
                      } /* else */
                  } /* if */
                else if ( ! fileparamcount++ )
                  {
                    strcpy( inFilename, ptr );
                  } /* else if */
                else if ( fileparamcount == 2 )
                  {
                    strcpy( resFilename, ptr );
                  } /* else if */
                else
                  {
                    fprintf( stderr,
                          "WARNING: BOUNDED.main(): unknown parameter '%s'.\n",
                                                                         ptr );
                    exit ( 11 );
                  } /* else */
                ptr = null;
              } /* else */
          } /* while */
      } /* if */
    else
      {
        showUsage = True;
      } /* else */

    if ( showVersion )
      {
       printf( "BOUNDED: version %s (%s), (c) Stefan Roemer\n", VERSION, DATE );
      } /* if */
    if ( showUsage )
      {
        printf( "'%s' -- check if a net is n-bounded.\n", *argv );
        printf( "parameters: ( in any order )\n" );
        printf( "  <PEPnetfile>      or\n" );
        printf( "  -f=<PEPnetfile>   specify input file\n" );
        printf( "  <resultfile>       or\n" );
        printf( "  -r=<resultfile>    result of computation (for PEP)\n" );
        printf( "  <number>           or\n" );
        printf( "  -b=<number>        upper bound\n" );
        printf( "  -u=<UDGfile>       calculate the whole reachability graph\n" );
        printf( "                       and write it into 'UDGfile'.\n" );
        printf( "  -s                 display statistics\n" );
/* BG  */
        printf( "  -p                 display progress\n" );
/* BG */
        printf( "  -v                 display program version number\n" );
      } /* if */
    if ( ! ( showVersion || showUsage || *inFilename ) )
      {
        fprintf( stderr,
              "ERROR: BOUNDED.main(): missing parameter ( PEP net file ).\n" );
        exit ( 10 );
      } /* else */

    if ( ! *inFilename )
      {
        exit( 0 );
      } /* if */

    if ( ( net = read_PEP( inFilename ) ) -> NumPlaces > 0xFFFF )
      {
        fprintf( stderr,
                 "ERROR: BOUNDED: the net contains more than 2^16 places.\n" );
        exit ( 21 );
      } /* if */

    pl = net->Places;
    while ( pl )
      {
        st = pl->postset;
        while ( st )
          {
            if ( st->weight > 1 )
              {
                fprintf( stderr,
                          "ERROR: BOUNDED: arc weight greater than 1.\n" );
                exit ( 22 );
              } /* if */
            st = st->nexttrans;
          } /* while */
        ts = pl->preset;
        while ( ts )
          {
            if ( ts->weight > 1 )
              {
                fprintf( stderr,
                          "ERROR: BOUNDED: arc weight greater than 1.\n" );
                exit ( 22 );
              } /* if */
            ts = ts->nexttrans;
          } /* while */
        pl = pl->nextplace;
      } /* while */

    if ( *resFilename )
      {
        if ( ! ( outfile = fopen( resFilename, "w" ) ) )
          {
            fprintf( stderr,
                "ERROR: BOUND: cannot open output file '%s'.\n", resFilename );
            exit ( 5 );
          } /* if */
      } /* if */
    else
      {
        outfile = stdout;
      } /* else */

    if ( n_bounded( net, upper_bound, UDGfilename ) )
      {
        fprintf( outfile, "SYSTEM IST N-BESCHRAENKT (N=%u)\n", upper_bound );

      } /* if */
    else
      {
        fprintf( outfile, "SYSTEM NICHT N-BESCHRAENKT (N=%u)\n", upper_bound );
      } /* else */
        
    /* BG */
    if ( BOUND_statistics )
    {
       fprintf ( outfile, "%u different reachable markings.\n", 
                               AnzahlMarkierungen );
       fprintf( outfile, "%u arcs in the reachability graph.\n", AnzahlKanten );
    }


    remove_net( &net );

    if ( argc > 2 )
      {
        fclose( outfile );
      } /* if */

    exit ( 0 );

} /* main() */

/*****************************************************************************/
/* END OF FILE BOUNDED.c                                                     */
/*****************************************************************************/

