/*****************************************************************************/
/***         C sources for programm test for free choice                   ***/
/***       Praktikum Werkzeuge zur Analyse von Petri-Netzen, SS 1992       ***/
/***                             Stefan Roemer                             ***/
/*****************************************************************************/
/* Version 2.0:  Conversion to new data types:       Stefan Roemer, 6.5.1993 */
/*****************************************************************************/

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "freechoice.h"
#include "convertPEP.h"

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
bool FC( LMPNet Net )
#else
bool FC( Net )

  LMPNet Net;
#endif 
{
  Place  pl;
  STEdge st;

  if ( Net && ( pl = Net->Places ) )
    {
      /* for all pl do */
      while ( pl )
        {
          /* if |pl*| > 1 */
          if ( ( st = pl->postset ) && st->nexttrans )
            {
              /* then if exist t in pl*: */
              while ( st )
                {
                  /* |*t| > 1   */
        	  if ( st->trans->preset->nextplace )
        	    {
		      /* not free choice */
        	      return ( False );
        	    }
                  st = st->nexttrans;
                } /* while ( st ) */
            } /* if */
          pl = pl->nextplace;
        } /* while ( pl ) */
    } /* if |pl->postset|>1 */
  else
    {
      return ( False );
    }
  return ( True );
} /* FC() */

#if defined(__STDC__) || defined(__cplusplus)
int main( int argc, char ** argv )
#else
int main( argc, argv )

  int argc;
  char ** argv;
#endif 
{
  LMPNet net; 
  FILE   * outfile;

  if ( argc == 1 )
    {
      printf( "Freechoice check\n" );
      printf( "Usage: FREECHOICE net-filename [result-filename]\n" );
      printf( "net-filename is the PEP ll-net to be analysed,\n" );
      printf( "if result-filename is not specified, stdout is used.\n" );
      exit (1);
    }

  net = read_PEP( argv[1] );

  if ( argc > 2 )
    { 
      if ( ! ( outfile = fopen( argv[2], "w" ) ) )
        {
          fprintf( stderr, "ERROR: FREECHOICE: cannot open output file '%s'.\n",
                   argv[2] );
          exit ( 5 );
        }
    } /* if argc > 2 */
  else
    {
      outfile = stdout;
    } /* else */

  if ( FC( net ) )
    {
      fprintf( outfile, "SYSTEM IS FREE CHOICE\n" );
    } /* if */
  else
    {
      fprintf( outfile, "SYSTEM IS NOT FREE CHOICE\n" );
    } /* else */

  remove_net( &net );

  if ( argc > 2 )
    { 
      fclose( outfile );
    } /* if */
  exit(0);
} /* main() */

/* END OF FILE */
