/* PRAKTIKUM WERKZEUGE ZUR PETRI-NETZ-ANALYSE */
/* check for liveness                         */

#include <stdlib.h>
#include <stdio.h>
#include "neunetze.h"
#include "convertPEP.h"
#include "leb.h"

#if defined(__STDC__) || defined(__cplusplus)
int main( int argc, char ** argv )
#else
int main( argc, argv )

  int argc;
  char ** argv;
#endif 
  {

    LMPNet net; 
    FILE   * outfile;

    if ( argc == 1 )
      {
        printf( "Check liveness\n" );
        printf( "Usage: LEBENDIG <Infile> [Outfile]" );
        exit( 1 );
      }

    net = read_PEP( argv[1] );

    if ( argc > 2 )
      { 
        if ( ! ( outfile = fopen( argv[2], "w" ) ) )
          {
          fprintf( stderr, "ERROR: LEBENDIG: cannot open output file '%s'.\n",
                             argv[2] );
            exit ( 5 );
          } /* if */
      } /* if */
    else
      {
        outfile = stdout;
      } /* else */
 
    if ( lebendig( net ) )
      {
        fprintf( outfile, "SYSTEM IS LIVE\n" );
      } /* if */
    else
      {
        fprintf( outfile, "SYSTEM IS NOT LIVE\n" );
      } /* else */

    remove_net( &net );

    if ( argc > 2 )
      { 
        fclose( outfile );
     } /* if */
    exit ( 0 );
} /* main() */

/* END OF FILE */
