/******************************************************************************/
/***       Praktikum Werkzeuge zur Analyse von Petri-Netzen, SS 1992        ***/
/***       Header-Datei fuer Programmteil 'Test auf Reversibilitaet'        ***/
/***           Konstantin Lazaridis, Lutz Lindau, Stefan Roemer             ***/
/***       Version 1.0                                Mo.,01.06.1992        ***/
/***       Version 2.0 ( Konversion an die neue Datenstruktur )             ***/
/***                                    Stefan Roemer Mo.,10.05.1993        ***/
/******************************************************************************/


#ifndef __REVERSIBEL_H__
#define __REVERSIBEL_H__


#include "neunetze.h"


/******************************************************************************/
/***               A L L G E M E I N E   F U N K T I O N E N                ***/
/******************************************************************************/

/******************************************************************************/
/* Berechnung der maximalen Falle einer gegebenen Stellenmenge                */
/******************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

extern LIST_POINTER Berechne_maximale_Falle( LMPNet, LIST_POINTER );

#else

extern LIST_POINTER Berechne_maximale_Falle();

#endif 

/*  LIST_POINTER Berechne_maximale_Falle( System, X );                        */
/*    LMPNet       System;             Zeiger auf zu testendes Petri-Netz     */
/*    LIST_POINTER X;                  zu bearbeitende Menge von Stellen      */
/*  Ergebnismenge: Maximaler Trap zu X                                        */


/******************************************************************************/
/* Test auf Reversibilitaet                                                   */
/******************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

extern bool reversibel( LMPNet );

#else

extern bool reversibel();

#endif

/* bool reversibel( System )                                                  */
/*   LMPNet          System            Zeiger auf zu testendes Petrinetz      */
/* Rueckgabewert: True, falls System reversibel; False, falls nicht           */

/******************************************************************************/

#endif  /* __REVERSIBEL_H__ */

/******************************************************************************/
/* END OF FILE rev.h                                                          */
/******************************************************************************/

