/*     Programm zum Testen der verschiedenen Bibliotheksfunktionen        */
/*              PRAKTIKUM WERKZEUGE ZUR PETRI-NETZ-ANALYSE                */
/* HIER: Test auf Reversibilitaet ( und FC/Beschraenktheit/Lebendigkeit ) */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "convertPEP.h"
#include "rev.h"

int main( int argc, char ** argv )
  {

    LMPNet net; 
    FILE   * outfile;

    if ( argc == 1 )
      {
        printf( "Reversible check\n" );
        printf( "Usage: REVERSIBEL net-filename [result-filename]\n" );
        printf( "net-filename is the PEP ll-net to be analysed,\n" );
        printf( "if result-filename is not specified, stdout is used.\n" );
        exit (1);
      }

    net = read_PEP( argv[1] );

    if ( argc > 2 )
      { 
        if ( ! ( outfile = fopen( argv[2], "w" ) ) )
          {
         fprintf( stderr, "ERROR: REVERSIBEL: cannot open output file '%s'.\n",
                             argv[2] );
            exit ( 5 );
          } /* if */
      } /* if */
    else
      {
        outfile = stdout;
      } /* else */

    if ( reversibel( net ) )
      {
        fprintf( outfile, "SYSTEM IST REVERSIBEL\n" );
      } /* if */
    else
      {
         fprintf( outfile, "SYSTEM NICHT REVERSIBEL\n" );
      } /* else */

    remove_net( &net );

    if ( argc > 2 )
      { 
        fclose( outfile );
     } /* if */
 
    exit ( 0 );
} /* main() */

/* END OF FILE */
