/*****************************************************************************/
/***      Praktikum Werkzeuge zur Analyse von Petri-Netzen, WS 1993/94     ***/
/***        C-Quelldatei fuer Programmteil 'Test auf T-System'             ***/
/***                            Stefan Roemer                              ***/
/*****************************************************************************/
/* Version 2.0: ANPASSUNG AN DIE NEUE DATENSTRUKTUR: Stefan Roemer, 7.3.1994 */
/*****************************************************************************/

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "neunetze.h"
#include "convertPEP.h"

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

static bool T_System( LMPNet Netz )

#else

static bool T_System( Netz )

  LMPNet Netz;

#endif 

  {

    register Place s;

    if ( Netz && ( s = Netz->Places ) )
      {
        while ( s )
          {
            if (    ( s->postset && s->postset->nexttrans )
                 || ( s->preset  && s->preset->nexttrans ) )
              {
                return ( False );
              } /* if */
            s = s->nextplace;
          } /* while ( s ) */
      } /* if */
    else
      {
        return ( False );
      } /* else */

    return ( True );

  } /* T_System() */


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int main( int argc, char ** argv )

#else

int main( argc, argv )

  int argc;
  char ** argv;

#endif 

  {

    LMPNet net; 
    FILE   * outfile;
    char*  filename;

    if ( argc >= 2 )
      {
        filename=strdup( argv[1] );
      }
    else
      {
        printf( "T-System check\n" );
        printf( "Usage: T_SYSTEM net-filename [result-filename]\n" );
        printf( "net-filename is the PEP ll-net to be analysed,\n" );
        printf( "if result-filename is not specified, stdout is used.\n" );
	exit (1);
      } /* else */

    net = read_PEP( filename );

    if ( argc > 2 )
      { 
        if ( ! ( outfile = fopen( argv[2], "w" ) ) )
          {
           fprintf( stderr, "ERROR: T_SYSTEM: cannot open output file '%s'.\n",
                             argv[2] );
            exit ( 5 );
          } /* if */
      } /* if */
    else
      {
        outfile = stdout;
      } /* else */

    if ( T_System( net ) )
      {
        fprintf( outfile, "SYSTEM IST T-SYSTEM\n" );
      } /* if */
    else
      {
        fprintf( outfile, "SYSTEM KEIN T-SYSTEM\n" );
      } /* else */

    remove_net( &net );

    if ( argc > 2 )
      { 
        fclose( outfile );
      } /* if */
    free(filename);

    exit ( 0 );

} /* main() */

/* END OF FILE T_SYSTEM.c */
