/*****************************************************************************/
/* Berechnung von Traps. */
/*****************************************************************************/
#define VERSION "1.4"
#define DATE "14.12.1994"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "neunetze.h"
#include "convertPEP.h"
#include "rev.h"

/*****************************************************************************/

typedef struct TrapList_
  {
    LIST_POINTER     list;
    struct TrapList_ * next;
  } TrapListEntry,
    *TrapList;

LMPNet   net;
TrapList traplist = NULL;
Cardinal32 rekcount = 0, trapcount = 0;

#define COUNT_IT
#undef COUNT_IT
#define UPPER_BOUND 100000000

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

static bool equal( LIST_POINTER list1, LIST_POINTER list2 )

#else

static bool equal( list1, list2 )

  LIST_POINTER list1,
               list2;

#endif

  {

    register LIST_POINTER l1,
                          l2;

    for ( l1 = list1, l2 = list2 ; l1 && l2 && ! strcmp( l1->name, l2->name ) ;
                                                l1 = l1->next, l2 = l2->next )
      skip;
 
    return ( (bool) ! ( l1 || l2 ) );
 
  } /* equal() */
 

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int main( int argc, char ** argv )

#else

int main( argc, argv )

  int argc;
  char ** argv;

#endif 

  {

    register Place pl;
    LIST_POINTER    list, trap, include, exclude;
    register LIST_POINTER l, l1, l2, lincl, lexcl;
    register TrapList t;
    Place * plarray, *plptr;
    Cardinal32 bits, bitt;
    char string[1001];
    register char * strptr;
    bool inclflag;


    char                inFilename[NAMELENGTH];
    Cardinal32          upper_bound = UPPER_BOUND,
                        count,
                        inclcount = 0,
                        plcount = 0;
    register Cardinal32 num,
                        ind;
    register char       ch,
                        * ptr;
    bool                showVersion = False,
                        showUsage   = False;
    static char         null[2] = "\0";


/*#########################*/

    *inFilename = '\0';
    include = exclude = NULL;

    if ( argc > 1 )
      {
        count = 0;
        while ( ++count < argc )
          {
            if ( ( ch = *( ptr = argv[count] ) ) == '-' )
              {
                while (( ch = tolower( *++ptr ) ))
                  {
                    switch ( ch )
                      {
                        case 'b' : if ( *++ptr == '=' )
                                     {
                                       ind = 1;
                                       if ( isdigit( ch = *++ptr ) )
                                         {
                                           num = ch - '0';
                                           while ( isdigit( ch = *++ptr ) )
                                             {
                                               num *= ind++;
                                               num += ch - '0';
                                             } /* while */
                                           upper_bound = num;
                                         } /* if */
                                       else
                                         {
                                           fprintf( stderr,
        "ERROR: BOUNDED.main(): number (upper bound) expected after '-b='.\n" );
                                           exit ( 11 );
                                         } /* else */
                                       if ( ! num )
                                         {
                                           fprintf( stderr,
  "ERROR: BOUNDED.main(): upper bound greater than 0 expected after '-b='.\n" );
                                           exit ( 11 );
                                         } /* else */
                                     } /* if */
                                   else
                                     {
                                       upper_bound = UPPER_BOUND;
                                     } /* else */
                                   ptr--;
                                   break;
                        case 'f' : if ( *++ptr != '=' )
                                     {
                                       fprintf( stderr,
                          "ERROR: BOUNDED.main(): '=' expected after '-f'.\n" );
                                       exit ( 11 );
                                     } /* if */
                                   if ( *inFilename )
                                     {
                                       fprintf( stderr,
                     "WARNING: BOUNDED.main(): parameter '-f' appears twice;" );
                                       fprintf( stderr,
                                                " %*s'%s' overwrites '%s'.\n",
                                                24, "", ptr + 1, inFilename );
                                     } /* if */
                                   strcpy( inFilename, ++ptr );
                                   ptr = null;
                                   break;
                        case 'i' : ptr++;
                                   while ( *ptr )
                                     {
                                       strptr = string;
                                       while ( *ptr
                                          && ( ( *strptr = *(ptr++) ) != ',' ) )
                                         {
                                           strptr++;
                                         } /* while */
                                       *strptr = '\0';
                                       if ( include )
                                         {
                                           lincl = lincl->next = (LIST_POINTER)
                                               Malloc( sizeof( LIST_ELEMENT ) );
                                         } /* if */
                                       else
                                         {
                                           include = lincl = (LIST_POINTER)
                                               Malloc( sizeof( LIST_ELEMENT ) );
                                               } /* else */
                                       strcpy( lincl->name, string );
                                       lincl->next = NULL;
                                     } /* while */
                                   ptr = null;
                                   break;
                        case 'v' : showVersion = True;
                                   break;
                        case 'x' : ptr++;
                                   while ( *ptr )
                                     {
                                       strptr = string;
                                       while ( *ptr
                                          && ( ( *strptr = *(ptr++) ) != ',' ) )
                                         {
                                           strptr++;
                                         } /* while */
                                       *strptr = '\0';
                                       if ( exclude )
                                         {
                                           lexcl = lexcl->next = (LIST_POINTER)
                                               Malloc( sizeof( LIST_ELEMENT ) );
                                         } /* if */
                                       else
                                         {
                                           exclude = lexcl = (LIST_POINTER)
                                               Malloc( sizeof( LIST_ELEMENT ) );
                                               } /* else */
                                       strcpy( lexcl->name, string );
                                       lexcl->next = NULL;
                                     } /* while */
                                   ptr = null;
                                   break;
                        case '$' : showUsage = True;
                                   break;
                        default  : fprintf( stderr,
                              "WARNING: TRAP.main(): bad parameter '%s'.\n",
                                                                 argv[count] );
                                   break;
                      } /* switch */
                  } /* while */
              } /* if */
            else
              {
                if ( isdigit( ch ) )
                  {
                    ind = 1;
                    num = ch - '0';
                    while ( isdigit( ch = *++ptr ) )
                      {
                        num *= ind++;
                        num += ch - '0';
                      } /* while */
                    if ( num )
                      {
                        upper_bound = num;
                      } /* if */
                    else
                      {
                        fprintf( stderr,
             "ERROR: TRAP.main(): upper bound greater than 0 expected.\n" );
                        exit ( 11 );
                      } /* else */
                  } /* if */
                else
                  {
                    strcpy( inFilename, ptr );
                  } /* else */
                ptr = null;
              } /* else */
          } /* while */
      } /* if */
    else
      {
        showUsage = True;
      } /* else */

    if ( showVersion )
      {
       printf( "TRAP: version %s (%s), (c) Stefan Roemer\n", VERSION, DATE );
      } /* if */
    if ( showUsage )
      {
        printf( "'%s' -- calculate traps.\n", *argv );
        printf( "parameters: ( in any order )\n" );
        printf( "  <PEPnetfile>        or\n" );
        printf( "  -f=<PEPnetfile>     specify input file\n" );
        printf( "  <number>            or\n" );
        printf( "  -b=<number>         upper bound\n" );
        printf( "  -i<pl1>[,<pl2>,...] include places\n" );
        printf( "  -x<pl1>[,<pl2>,...] exclude places\n" );
        printf( "  -v                  display program version number\n" );
      } /* if */
    if ( ! ( showVersion || showUsage || *inFilename ) )
      {
        fprintf( stderr,
              "ERROR: TRAP.main(): missing parameter ( PEP net file ).\n" );
        exit ( 10 );
      } /* else */

    if ( ! *inFilename )
      {
        exit( 0 );
      } /* if */

    net = read_PEP( inFilename );
    for ( pl = net->Places ; pl ; pl = pl->nextplace )
      {
        pl->component = 0;
      } /* for */
    for ( l = include ; l ; l = l->next )
      {
        if (( pl = find_P( net, l->name ) ))
          {
            if ( ! pl->component )
              {
                inclcount++;
                pl->component = 1;
              } /* if */
          } /* if */
        else
          {
            fprintf( stderr, "'%s' is not a place of the net.\n", l->name );
          } /* else */
      } /* for */
    for ( l = exclude ; l ; l = l->next )
      {
        if (( pl = find_P( net, l->name ) ))
          {
            pl->component = 2;
          } /* if */
        else
          {
            fprintf( stderr, "'%s' is not a place of the net.\n", l->name );
          } /* else */
      } /* for */

    if (( pl = net->Places ))
      {
        plarray = plptr = (Place*) Malloc( net->NumPlaces * sizeof( Place ) );
        for ( skip ; pl ; pl = pl->nextplace )
          {
            if ( ! pl->component )
              {
                plcount++;
                *(plptr++) = pl;
              } /* if */
          } /* for */
        bits = 1;
        for ( bitt = plcount ; bitt-- ; bits *= 2 ) skip;
        while ( --bits )
          {
rekcount++;
/*
printf("Loop: %8u\n", rekcount);
*/
            bitt = bits;
            count = bitt & 1;
            for ( ind = 1 ; ind < plcount ; ind++ )
              {
                bitt >>= 1;
                count += bitt & 1;
              } /* for */
            if ( count > upper_bound )
              {
                continue;
              } /* if */
            list = NULL;
            for ( ind = 0 ; ind < plcount ; ind++ )
              {
                if ( bits & ( 1 << ind ) )
                  {
                    if ( list )
                      {
                        l = l->next
                          = (LIST_POINTER) Malloc( sizeof( LIST_ELEMENT ) );
                      } /* if */
                    else
                      {
                        list = l
                             = (LIST_POINTER) Malloc( sizeof( LIST_ELEMENT ) );
                      } /* else */
                    strcpy( l->name, plarray[ind]->name );
                  } /* if */
              } /* for */
              l->next = NULL;
            if ( include )
              {
                lincl->next = list;
                list = include;
              } /* if */
/*
show_multiset(list);
*/
            if (( trap = Berechne_maximale_Falle( net, list ) ))
              {
                for ( count = 0, l = trap ; l ; l = l->next )
                  {
                    count++;
                  } /* for */
                inclflag = True;
                l1 = include;
                l2 = trap;
                while ( l1 && l2 )
                  {
                    if ( !l1 || !l2 || strcmp( l1->name, l2->name ) )
                      {
                        inclflag = False;
                      } /* if */
                    l1 = l1->next;
                    l2 = l2->next;
                  } /* while */
/*
printf("TRAP-------->");
show_multiset( trap );
*/
                /* Speichere Trap */
                if ( inclflag && ( t = traplist ) && ( count <= upper_bound ) )
                  {
                    while ( t && ! equal( t->list, trap ) )
                      {
                        t = t->next;
                      } /* while */
                    if ( t )
                      {
                        remove_list( &trap );
                      } /* if */
                    else
                      {
                        t = (TrapList) Malloc( sizeof( TrapListEntry ) );
                        t->list = trap;
                        t->next = traplist;
                        traplist = t;
trapcount++;
#ifdef COUNT_IT
printf("(%5u/%8u) ", trapcount, rekcount);
#endif
printf("TRAP: ");
show_multiset(trap);
                      } /* else */
              } /* if */
                  else if ( inclflag && ( count <= upper_bound ) )
                    {
                      t = traplist = (TrapList) Malloc( sizeof( TrapListEntry ) );
                      t->list = trap;
                      t->next = NULL;
trapcount++;
#ifdef COUNT_IT
printf("(%5u/%8u) ", trapcount, rekcount);
#endif
printf("TRAP: ");
show_multiset(trap);
                    } /* else */
                } /* if */
            if ( include )
              {
                remove_list( &(lincl->next) );
              } /* if */
            else
              {
                remove_list( &list );
              } /* else */
          } /* while */
      } /* if */

    remove_net( &net );

    exit ( 0 );

} /* main() */

/*****************************************************************************/
/* END OF FILE TRAP.c                                                        */
/*****************************************************************************/
