#include "vector.h"

/******************************************************************************/
/*                  Funktion zum Kopieren  einer Markierung                   */
/******************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
Vektor Kopiere( Vektor v1, Vektor v2 )
#else
Vektor Kopiere( v1, v2 )

  Vektor v1, v2;               /* Es wird v1 := v2 ausgefuehrt und ein Zeiger */
        		       /* auf v1 als Funktionswert zurueckgegeben.    */
#endif

  {

    register Vektor v1ptr = v1;

    while (( *(v1ptr++) = *(v2++) ))
      skip;

    return ( v1 );

  } /* Kopiere() */


/******************************************************************************/
/*        Funktion zur Initialisierung eines neuen Markierungsvektors         */
/*           aus einem gegebenen ( geordneten ! ) Markierungsvektor           */
/******************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
Vektor ErzeugeVektor( Vektor vek )
#else
Vektor ErzeugeVektor( vek )

  Vektor vek;               /* Der zu kopierende Markierungsvektor; ein       */
        		    /* Zeiger auf den Zielvektor wird zurueckgegeben. */
#endif

  {

    Vektor          ZielVektor;
    register Vektor vekptr = vek,
                    ZielPtr;
    VCardinal       Groesse = 0;

    while ( *vekptr )                                    /* Laenge ermitteln */
      {
        Groesse++;
        vekptr++;
        vekptr++;
      }

    ZielPtr = ZielVektor = NeuerVektor( Groesse );
    vekptr = vek;

    while (( *(ZielPtr++) = *(vekptr++) ))
      skip;

    return ( ZielVektor );

  } /* ErzeugeVektor() */


/******************************************************************************/
/*    Funktion, die aus dem Vorbereich einer Transition den entsprechenden    */
/* Markierungsvektor generiert; der Zielvektor dieser Funktion ( vek ) muss   */
/*             gross genug sein, um das Ergebnis aufzunehmen.                 */
/******************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
Vektor VektorAusTSListe( Vektor vek, TSEdge tsListe )
#else
Vektor VektorAusTSListe( vek, tsListe )
  
  Vektor vek;                             /* Ziel: Markierungsvektor.         */
  TSEdge tsListe;                         /* Quelle: Postset einer Transition */
#endif

  {

    register Vektor vekPtr = vek;

    while ( tsListe )
      {
        *(vekPtr++) = tsListe->place->numname;
        *(vekPtr++) = tsListe->weight;
        tsListe = tsListe->nextplace;
      } /* while */
    *vekPtr = 0;

    return ( vek );

  } /* VektorAusTSListe() */

  
/******************************************************************************/
/*    Funktion, die aus dem Nachbereich einer Transition den entsprechenden   */
/* Markierungsvektor generiert; der Zielvektor dieser Funktion ( vek ) muss   */
/*             gross genug sein, um das Ergebnis aufzunehmen.                 */
/******************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
Vektor VektorAusSTListe( Vektor vek, STEdge stListe )
#else
Vektor VektorAusSTListe( vek, stListe )
  
  Vektor vek;                              /* Ziel: Markierungsvektor.        */
  STEdge stListe;                          /* Quelle: Preset einer Transition */
#endif

  {

    register Vektor vekPtr = vek;

    while ( stListe )
      {
        *(vekPtr++) = stListe->place->numname;
        *(vekPtr++) = stListe->weight;
        stListe = stListe->nextplace;
      } /* while */
    *vekPtr = 0;

    return ( vek );

  } /* VektorAusSTListe() */


/*****************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

bool VEnthalten (Vektor  v1,                    /* Die zuvergleichenden Vek- */
                Vektor  v2)                     /* toren, Test auf v1 == v2  */

#else

bool VEnthalten (v1, v2)

Vektor v1,                                      /* Die zuvergleichenden Vek- */
       v2;                                      /* toren, Test auf v1 == v2  */

#endif                                          /* END STDC & C++ DEFINITION */

/*                                                                           */
/*        Funktion zur Feststellung , ob eine Markierung Teil einer          */
/*                          anderen Markierung  ist                          */
/*                                                                           */
/*****************************************************************************/

{
while ( *v1 && *v2 )                            /* WEIL weder V1 noch V2     */
   {                                            /* durchlaufen  DO           */
   if (*v1 == *v2)                              /* WENN V1(i) <> V2(i)       */
      {
      if (*++v1 > *++v2)
         return (False);                        /* DANN FALSE zurueck        */
      v1++;
      }                                         /* ENDIF (*(v1++) != *(v2++))*/
   else if (*(v1) < *(v2++))
            {
            return (False);
            }
  v2++;

  }                                             /* END WHILE (*v1 && *v2)    */
return (!*v1);
}                                               /**    END VEnthalten()    ***/

  
/******************************************************************************/
/*        Funktion zur Feststellung , ob eine Markierung gleich               */
/*                          anderen Markierung  ist                           */
/******************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
bool VektorGleich( Vektor vek1, Vektor vek2 )
#else
bool VektorGleich( vek1, vek2 )

  Vektor vek1, vek2;            /* Die zu vergleichenden Markierungsvektoren; */
        		        /* es wird getestet, ob v1 == v2 gilt.        */
#endif

  {
    register Vektor v1 = vek1,
                    v2 = vek2;

    while ( *v1 && *v2 )
      {
        if ( *(v1++) != *(v2++) )
          {
            return ( False ); 
          }
      } /* while */

    return ( ! ( *v1 || *v2 ) );

  } /* VektorGleich() */


/******************************************************************************/
/*        Funktion zur Feststellung, ob eine Markierung 'kleiner' ist         */
/*                         als eine andere Markierung                         */
/******************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
bool VektorKleiner( Vektor vek1, Vektor vek2 )
#else
bool VektorKleiner( vek1, vek2 )

  Vektor vek1, vek2;            /* Die zu vergleichenden Markierungsvektoren; */
        		        /* es wird getestet, ob v1 < v2 gilt.         */
#endif

  {

    register Vektor v1 = vek1,
                    v2 = vek2;
    bool gleich = True;

    while ( *v1 && *v2 )
      {
        if ( *v1 == *v2 )
          {
            if ( *(++v1) > *(++v2) ) 
              {
        	return ( False );
              } /* if */
            else if ( *v1 < *v2 )
              {
        	gleich = False;
              } /* else if */
            v1++;
            v2++;
          } /* if */
        else if ( *v1 < *v2 )
          {
            return ( False );
          } /* else if */
        else /* ( *v1 > *v2 ) */
          {
            gleich = False;
            v2++;
            v2++;
          } /* else */
      } /* while */

    return ( ( ! *v1 ) || ( ( *v1 == *v2 ) && ! gleich ) );

  } /* VektorKleiner() */


/******************************************************************************/
/*              Funktion zur Addition zweier Markierungsvektoren              */
/******************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
Vektor Addiere( Vektor v1, Vektor v2, Vektor HilfsVektor )
#else
Vektor Addiere( v1, v2, HilfsVektor )

  Vektor v1, v2, HilfsVektor;          /* Es wird v1 := v1 + v2 berechnet und */
        			       /* ein Zeiger auf v1 zurueckgegeben.   */
#endif

  {

    register Vektor v1ptr   = v1,
                    v2ptr   = v2,
                    HilfPtr = HilfsVektor;

    while ( *v1ptr || *v2ptr )
      {
        if ( *v1ptr && (*v1ptr == *v2ptr) )
          {
            *(HilfPtr++) = *(v1ptr++);
            v2ptr++;
            *(HilfPtr++) = ( ( *v1ptr == OMEGA ) || ( *v2ptr == OMEGA ) ) ?
        	           OMEGA : *v1ptr + *v2ptr;
            v1ptr++, v2ptr++;
          } /* if */
        else if ( ( ! *v2ptr ) || ( *v1ptr && ( *v1ptr < *v2ptr ) ) )
          {
            *(HilfPtr++) = *(v1ptr++);
            *(HilfPtr++) = *(v1ptr++);
          } /* else if */
        else /* ( ( ! *v1ptr ) || ( *v1ptr > *v2ptr ) ) */
          {
            *(HilfPtr++) = *(v2ptr++);
            *(HilfPtr++) = *(v2ptr++);
          } /* else */
      } /* while */

    *HilfPtr = 0;
    HilfPtr = HilfsVektor;
    v1ptr = v1;
    while (( *(v1ptr++) = *(HilfPtr++) ))
      skip; /* while */

    return ( v1 );

  } /* Addiere() */


/******************************************************************************/
/*            Funktion zur Subtraktion zweier Markierungsvektoren             */
/******************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
Vektor Subtrahiere( Vektor v1, Vektor v2 )
#else
Vektor Subtrahiere( v1, v2 )

  Vektor v1, v2;                       /* Es wird v1 := v1 - v2 berechnet und */
        			       /* ein Zeiger auf v1 zurueckgegeben.   */
#endif

  {

    register Vektor v1Lptr = v1, /* Lesezeiger    */ 
        	    v1Sptr = v1, /* Schreibzeiger */
                    v2ptr  = v2;

    while ( *v1Lptr )
      {
        if ( *v1Lptr == *v2ptr )
          {
            *(v1Sptr++) = *(v1Lptr++);
            v2ptr++;
            *(v1Sptr) = ( *v1Lptr == OMEGA ) ? OMEGA : *v1Lptr - *v2ptr;
            v1Lptr++;
            v2ptr++;
            if ( *v1Sptr ) v1Sptr++; else v1Sptr--;
          } /* if */
        else /* ( ( ! *v2ptr ) || ( *v1ptr < *v2ptr ) ) */
          {
            *(v1Sptr++) = *(v1Lptr++);
            *(v1Sptr++) = *(v1Lptr++);
          } /* else */
      } /* while */

    *v1Sptr = 0;

    return ( v1 );

  } /* Subtrahiere() */


/******************************************************************************/
/*      Funktion zur Multiplikation eines Markierungsvektoren mit Omega       */
/******************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
Vektor MultipliziereMitOmega( Vektor vek )
#else
Vektor MultipliziereMitOmega( vek )

  Vektor vek;                         /* Es wird vek := vek * omega berechnet */
        			      /* und Zeiger auf vek zurueckgegeben.   */ 
#endif

  {

    register Vektor vekptr = vek;

    while ( *(vekptr++) )
      {
        *(vekptr++) = OMEGA;
      }

    return ( vek );

  } /* MultipliziereMitOmega() */

