/******************************************************************************/
/*        Praktikum Werkzeuge zur Analyse von Petri-Netzen, WS 1993/94        */
/*   Header-Datei fuer Programmteil 'Erreichbarkeit & Erreichbarkeitspfade    */
/******************************************************************************/
/*   Version 2.0 ( Erreicbarkeitspfade )   Eberhard Meisel, Maerz -  Mai 94   */
/******************************************************************************/

#include "neunetze.h"
#include "bound.h"

/* BG hier hinzugefuegt: */
extern bool  Beschraenkt;

#if defined(__STDC__) || defined(__cplusplus)
extern bool (*TestVergleich)(Vektor,Vektor);
#else
extern bool (*TestVergleich)();
#endif
                                                 /* 2-fachverkettete Liste zur*/
typedef struct reachelement     * ReachList;     /* Darstellung einer Liste   */
                                                 /* Transition\Markierung mit */
typedef struct reachelement                      /* Liste direkter Vorgaenger */
   {                                             /* von Markierung            */
   ReachList       prev,                         /* Zeiger auf vorhergehendes */
                   next,                         /* bzw. naechstes Listenelem.*/
                   alter;                        /* Zeiger auf Liste von      */
                                                 /* Pfadgabelungen            */
   Vektor          mark;                         /* Von Transition "trans"    */
   Vektor          trans;                        /* aktivierte Markierung     */
   int             alt;                          /* wie oft kommt "mark" vor  */

   #if defined(__TRACE__)                        /* erweiterte Ausgabe        */
   int             num;                          /* Nummer Reachlistenelement */
   #endif                                        /* END __TRACE__ DEFINITION  */

   }                              ReachElement;

                                                 /* Datenstruktur fuer Liste  */
                                                 /* von Erreichbarkeitspfaden */
typedef struct pfadelement      * Pfad;          /* 2-fachverkette Liste zur  */
                                                 /* Darstellung einer Liste   */
typedef struct pfadelement                       /* Marking Transition        */
   {
   Pfad            prev,                         /* Zeiger auf vorhergehendes */
                   succ;                         /* bzw. auf nachfolgendes    */
                                                 /* Listenelement des Pfades  */
   Vektor          tran;                         /* zu schaltende Transition  */

   #if defined(__TRACE__)                        /* erweiterte Ausgabe        */

   Vektor          mark;                         /* Zeiger auf Markierung,    */
                                                 /* die "tran" aktiviert      */

   #endif                                        /* END __TRACE__ DEFINITION  */
   }                              PfadElement;   /* aktiviert                 */


typedef struct pfadlistelement  * PfadList;

typedef struct pfadlistelement
   {
   Pfad            pfad;                         /* Zeiger auf einen Pfad     */
   PfadList        next;                         /* naechste Pfadliste        */
   }                              PfadListElem;


typedef struct pfadkopfelem     * PfadKopf;      /* Zeiger auf den Kopf einer */
                                                 /* Liste von Erreichbarkeits-*/
typedef struct pfadkopfelem                      /* pfaden                    */
   {
   Vektor          init;                         /* enthaelt die Markierung   */
                                                 /* von der aus die Erreich-  */
                                                 /* barkeitsliste aufgebaut   */
                                                 /* wurde                     */
   ReachList       rlist;                        /* Zeiger Reachliste; diese  */
                                                 /* enthaelt die im Speicher  */
                                                 /* abgelegten Markierungs- & */
                                                 /* Transitionsvektoren, auf  */
   PfadList        pfade;                        /* die die in den Pfadlisten */
                                                 /* abgelegten Zeiger zeigen  */
   bool            minpfad;                      /* FLAG: True, wenn kuerze-  */
                                                 /*       ster Pfad berechnet */
                                                 /*       werden soll         */
   bool            reached;                      /* erreichbare Markierung    */
   }                              PfadKopfElem;  /* erreicht                  */



/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern void SchreibeTransition (FILE       * ,   /* Zeiger auf die Zieldatei. */
                                Vektor       ,   /* Auszugebende Markierung   */
                                Transition * ,   /* Transitionenfeldliste     */
                                int          );  /* Transitionsname wird um   */
                                                 /* `fill` Leerzeichen aufge- */
#else                                            /* fuellt.                   */

extern void SchreibeTransition ( );

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/* Parameter:                                                                 */
/*                                                                            */
/* FILE          * Datei;                           Zeiger auf die Zieldatei. */
/* Vektor          vek;                             Auszugebende Markierung   */
/* Transition    * Transfeld;                       Transitionenfeldliste     */
/* int             fill;                            Transitionsname wird um   */
/*                                                  `fill` Leerzeichen aufge- */
/*                                                  fuellt.                   */
/*                                                                            */
/*        Prozedur, die einen Transitionsvektor in eine Datei ausgibt         */
/*                                                                            */
/******************************************************************************/




/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern PfadKopf ComputePath  (PfadKopf    ,      /* enthaelt Zeiger auf Er-   */
                                                 /* reichbarkeitsliste        */
                              Vektor      ,      /* zu erreichende Markierung */
                              bool        ,      /* Flag: gibt an ob kuerze-  */
                                                 /* Pfad oder alle moeglichen */
                                                 /* berechnet werden soll     */
                              bool               /* FLAG: wenn true, werden   */
                                                 /* Pfade zu Teilmarkie-      */
                                                 /* rungen berechnet          */
   #if defined(__TRACE__)                        /* TRACE ausgabe             */
                                          ,
                              LMPNet      ,
                              FILE      *
   #endif                                        /* END TRACE DEFINITION      */
                                          );
#else

extern PfadKopf ComputePath ( );

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/*  Parameter:                                                                */
/*                                                                            */
/*    PfadKopf                PKopf        ;        enthaelt Zeiger auf Er-   */
/*                                                 reichbarkeitsliste        */
/*    Vektor                  ReachVek     ;        zu erreichende Markierung */
/*    bool                    Minpfad      ;        Flag: gibt an ob kuerze-  */
/*                                                  Pfad oder alle moeglichen */
/*                                                  berechnet werden soll     */
/*    bool                    TeilMark     :        FLAG: wenn true, werden   */
/*                                                  Pfade zu Teilmarkie-      */
/*                                                  rungen berechnet          */
/*       #if defined(__TRACE__)                                               */
/*                                                                            */
/*       LMPNet               Netz;                 Zeiger markiertes Netz    */
/*       FILE             *   Datei;                Zeiger auf Ausgabedatei   */
/*                                                                            */
/*       #endif                                                               */
/*                                                                            */
/* Funktion zur Berechnung der Erreichbarkeitspfade von der Startmarkierung   */
/* eines Systems Netz zu einer erreichbaren Markierung  aus der in  der       */
/* uebergebenen Datenstruktur "reachlist" abgelegten Erreichbarkeitsliste     */
/*                                                                            */
/******************************************************************************/





/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern PfadKopf ComputeReach  (LMPNet   ,        /* zu untersuchendes Netz    */
                               PfadKopf ,        /* Enthaelt Zeiger auf die   */
                                                 /* Startmarkierung           */
                               Vektor   ,        /* zu erreichende Markierung */
                               bool     ,        /* Flag: gibt an ob kuerze-  */
                                                 /* Pfad oder alle moeglichen */
                                                 /* berechnet werden soll     */
                               bool              /* FLAG: wenn true, werden   */
                                                 /* Pfade zu Teilmarkie-      */
                                                 /* rungen berechnet          */
   #if defined(__TRACE__)                        /* TRACE ausgabe             */
                                        ,
                               FILE *            /* Zeiger auf Ausgabedatei   */
   #endif                                        /* ENDe TRACE DEEFINITION    */
                                        );
#else

extern PfadKopf ComputeReach ();

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/*  Parameter:                                                                */
/*                                                                            */
/*    LMPNet                   Netz    ;            zu untersuchendes Netz    */
/*    PfadKopf                 PKopf   ;            Enthaelt Zeiger auf die   */
/*                                                  Startmarkierung           */
/*    Vektor                   ReachVek;            zu erreichende Markierung */
/*    bool                     MinPfad ;            Flag: gibt an ob kuerze-  */
/*                                                  Pfad oder alle moeglichen */
/*                                                  berechnet werden soll     */
/*    bool                    TeilMark     :        FLAG: wenn true, werden   */
/*                                                  Pfade zu Teilmarkie-      */
/*                                                  rungen berechnet          */
/*                                                                            */
/*    #if defined(__TRACE__)                        TRACE ausgabe             */
/*                                                                            */
/*    FILE                   * Datei   ;            Zeiger auf Ausgabedatei   */
/*                                                                            */
/*    #endif                                        ENDDe TRACE DEFINITION    */
/*                                                                            */
/*                                                                            */
/*  Funktion zur Berechnung der Erreichbarkeitspfade von der Startmarkierung  */
/*  eines Systems `Netz` zu einer erreichbaren Markierung `EMark`.            */
/*                                                                            */
/******************************************************************************/








/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern PfadKopf ComputeSchaltfolgen (LMPNet   ,  /* zu untersuchendes Netz    */
                                     PfadKopf ,  /* Schaltfolgenliste         */
                                     Vektor   ,  /* Anfangsmarkierung         */
                                     Vektor   ,  /* zu erreichende Markierung */
                                     bool     ,  /* Flag: gibt an ob kuerze-  */
                                                 /* Pfad oder alle moeglichen */
                                                 /* berechnet werden soll     */
                                     bool        /* FLAG: wenn true, werden   */
                                                 /* Pfade zu Teilmarkie-      */
                                                 /* rungen berechnet          */

   #if defined(__TRACE__)                        /* TRACE ausgabe             */
                                              ,
                                     FILE *      /* Zeiger auf Ausgabedatei   */
   #endif                                        /* ENDe TRACE DEEFINITION    */
                                              );
#else

extern PfadKopf ComputeSchaltfolgen ();

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/*  Parameter:                                                                */
/*                                                                            */
/*    LMPNet                   Netz    ;            zu untersuchendes Netz    */
/*    PfadKopf                         ,            Schaltfolgenliste         */
/*    Vektor                   StartVek;            Anfangsmarkierung         */
/*    Vektor                   ReachVek;            zu erreichende Markierung */
/*    bool                     MinPfad ;            Flag: gibt an ob kuerze-  */
/*                                                  Pfad oder alle moeglichen */
/*                                                  berechnet werden soll     */
/*    bool                    TeilMark ;            FLAG: wenn true, werden   */
/*                                                  Pfade zu Teilmarkie-      */
/*                                                  rungen berechnet          */
/*                                                                            */
/*    #if defined(__TRACE__)                        TRACE ausgabe             */
/*                                                                            */
/*    FILE                   * Datei   ;            Zeiger auf Ausgabedatei   */
/*                                                                            */
/*    #endif                                        ENDDe TRACE DEFINITION    */
/*                                                                            */
/*                                                                            */
/*  Funktion zur Berechnung der Erreichbarkeitspfade von der Startmarkierung  */
/*  'StartVek` eines Systems 'Netz` zu einer erreichbaren Markierung          */
/*  'ReachVek des System 'Netz`.                                              */
/*                                                                            */
/******************************************************************************/





#if defined(__TRACE__)                          /* TRACE ausgabe             */

/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

void WriteReachList (LMPNet      ,               /* Zeiger markiertes Netz    */
                     ReachList   ,               /* auszugebende ReachListe   */
                     Vektor      ,               /* zu erreichende Markierung */
                     FILE      * );              /* Zeiger auf Ausgabedatei   */
#else

void WriteReachList ();

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/*  Parameter:                                                               */
/*                                                                            */
/*    LMPNet         Netz    ;                      Zeiger markiertes Netz    */
/*    ReachList      RList   ;                      auszugebende ReachListe   */
/*    Vektor         ReachVek;                      zu erreichende Markierung */
/*    FILE         * Datei   ;                      Zeiger auf Ausgabedattei  */
/*                                                                            */
/*  Die Funktion "WriteReachList" gibt eine Reachliste aus                    */
/*                                                                            */
/******************************************************************************/

#endif                                           /* ENDe TRACE DEFINITION     */





/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern void RemoveReachList (ReachList *         /* zu loeschende ReachListe  */

   #if defined(__TRACE__)                        /* TRACE ausgabe             */
                                         ,
                             FILE      *         /* Zeiger auf Ausgabedatei   */
   #endif                                        /* END TRACE DEFINITION      */
                                          );

#else

extern void RemoveReachList ();                  /* call-by-reference !       */

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/* Parameter:                                                                 */
/*                                                                            */
/*  reachlist  * ReachList;                         zu loeschende ReachListe  */
/*                                                                            */
/*    #if defined(__TRACE__)                        TRACE ausgabe             */
/*                                                                            */
/*    FILE     * Datei;                             Zeiger auf Ausgabedatei   */
/*                                                                            */
/*    #endif                                        END TRACE DEFINITION      */
/*                                                                            */
/*                                                                            */
/*  Die Funktion "RemoveReachList" entfernt eine Reachliste aus dem Speicher  */
/*                                                                            */
/******************************************************************************/






/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern void RemovePathList (PfadList *           /* zu loeschnede PfadListe   */

   #if defined(__TRACE__)                        /* TRACE ausgabe             */
                                       ,
                             LMPNet    ,
                             FILE    *
   #endif                                        /* END TRACE DEFINITION      */
                                       );

#else

extern void RemovePathList ();                   /* call-by-reference !       */

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/* Parameter:                                                                 */
/*                                                                            */
/*  PfadList   * PLKopf;                            zu loeschende PfadListe   */
/*                                                                            */
/*    #if defined(__TRACE__)                        TRACE ausgabe             */
/*                                                                            */
/*    LMPNet     Netz;                              Zeiger auf Netz           */
/*    FILE     * Datei;                             Zeiger auf Ausgabedatei   */
/*                                                                            */
/*    #endif                                        END TRACE DEFINITION      */
/*                                                                            */
/*                                                                            */
/*  Die Funktion "RemovePathList" entfernt eine Pathliste aus dem Speicher    */
/*                                                                            */
/******************************************************************************/





/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern void RemovePathHead (PfadKopf *           /* zu loeschnede PfadListe   */

   #if defined(__TRACE__)                        /* TRACE ausgabe             */
                                       ,
                             LMPNet    ,
                             FILE    *
   #endif                                        /* END TRACE DEFINITION      */
                                       );

#else

extern void RemovePathHead ();                   /* call-by-reference !       */

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/* Parameter:                                                                 */
/*                                                                            */
/*  PfadKopf   * PLKopf;                            zu loeschende PfadListe   */
/*                                                                            */
/*    #if defined(__TRACE__)                        TRACE ausgabe             */
/*                                                                            */
/*    LMPNet     Netz;                              Zeiger auf Netz           */
/*    FILE     * Datei;                             Zeiger auf Ausgabedatei   */
/*                                                                            */
/*    #endif                                        END TRACE DEFINITION      */
/*                                                                            */
/*  Die Funktion "RemovePathList" entfernt eine Pathliste aus dem Speicher    */
/*                                                                            */
/******************************************************************************/




#ifdef __WPL__

/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern void WritePathList (LMPNet   ,            /* zu bearbeitendes Netz     */
                           PfadKopf ,            /* auszugebende PfadListe    */
                           char  *               /* Name der Netzdatei        */

   #if defined(__TRACE__)                        /* TRACE ausgabe             */
                                    ,
                           FILE *                /* Zeiger auf Ausgabedatei   */
   #endif                                        /* END TRACE DEFINITION      */
                                    );

#else

extern void WritePathList ( );

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/* Parameter:                                                                 */
/*                                                                            */
/*  LMPNet       Netz;                              zu bearbeitendes Netz     */
/*  PfadKopf     PathList;                          auszugebende PfadListe    */
/*  char       * netname;                           Name des Netzes           */
/*                                                                            */
/*  #if defined(__TRACE__)                          TRACE ausgabe             */
/*                                                                            */
/*    FILE     * Datei;                             Zeiger auf Ausgabedatei   */
/*                                                                            */
/*  #endif                                          END TRACE DEFINITION      */
/*                                                                            */
/*  Wenn die TRACE-Definition eingeschaltet ist, erfolgt die Ausgabe der      */
/*  Pfade in der Datei, auf die der Dateizeiger von `outfile` zeigt.          */
/*                                                                            */
/*  Wenn die TRACE-Definition ausgeschaltet ist, erfolgt die Ausgabe der      */
/*  Pfade in einer Datei, der an den Netznamen die Endung ".Pfd" wird         */
/*                                                                            */
/******************************************************************************/

#endif                                           /* END __WPL__ DEFINITION    */




/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern void WriteSchaltfolgen (LMPNet    ,       /* zu bearbeitendes Netz     */
                               PfadKopf  ,       /* auszugebende PfadListe    */
                               bool      ,       /* Kurze Ausgabe der Transi- */
                                                 /* tionen                    */
                               char    *

   #if defined(__TRACE__)                        /* TRACE ausgabe             */
                                         ,
                               FILE    *         /* Zeiger auf Ausgabedatei   */
   #endif                                        /* END TRACE DEFINITION      */
                                    );

#else

extern void WriteSchaltfolgen ( );

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/* Parameter:                                                                 */
/*                                                                            */
/*  LMPNet       Netz;                              zu bearbeitendes Netz     */
/*  PfadKopf     PathList;                          auszugebende PfadListe    */
/*  bool         Short;                             Kurze Ausgabe der Transi- */
/*                                                  tionen                    */
/*  char       * netname;                           Name des Netzes           */
/*                                                                            */
/*  #if defined(__TRACE__)                          TRACE ausgabe             */
/*                                                                            */
/*    FILE     * Datei;                             Zeiger auf Ausgabedatei   */
/*                                                                            */
/*  #endif                                          END TRACE DEFINITION      */
/*                                                                            */
/*  Wenn die TRACE-Definition eingeschaltet ist, erfolgt die Ausgabe der      */
/*  Schaltfolgen der Transitionen in der Datei, auf die der Dateizeiger       */
/*  `outfile` zeigt.                                                          */
/*                                                                            */
/*  Wenn die TRACE-Definition ausgeschaltet ist, erfolgt die Ausgabe der      */
/*  Schaltfolgen der Transitionen in einer Datei, der an den Netznamen die    */
/*  Endung ".SF" angehaengt wird.                                             */
/*                                                                            */
/*  Ist der Parameter 'short` auf "False" gesetzt, werden die auszugebenden   */
/*  Transitionen alle auf die gleiche Laenge mit Leerzeichen aufgefuellt      */
/*                                                                            */
/******************************************************************************/




#define __REACHABILITY__
#if defined (__REACHABILITY__)

/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern int Reachability (LMPNet,                 /* zu beaarbeitendes Netz    */
                         MARKING,                /* zu erreichende Markeirung */
                         MARKING                 /* Startmarkierung           */

    #if defined(__MTRACE__)                      /* TRACEn Matrixbibliothek   */
                                ,
                         FILE *
    #endif                                       /* END __MTRACE__ DEFINITION */
                                );
#else

extern int Reachability ( );

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/* Parameter:                                                                 */
/*                                                                            */
/* LMPNet       Netz;                               zu beaarbeitendes Netz    */
/* MARKING      Mark0,                              zu erreichende Markeirung */
/*              Marke;                              Startmarkierung           */
/*                                                                            */
/*     #if defined(__MTRACE__)                      TRACEn Matrixbibliothek   */
/*                                                                            */
/*     FILE   * Datei;                                                        */
/*                                                                            */
/*     #endif                                       END __MTRACE__ DEFINITION */
/*                                                                            */
/*                                                                            */
/*  Erreichbarkeitsanalye                                                     */
/*                                                                            */
/******************************************************************************/

#endif                                            /* Erreichbarkeitsanalyse   */





/******************************************************************************/
/*                                                                            */
/*  Nun einige Funktionen zum einfacheren      Autor: Eberhard Meisel         */
/*  Testen von Netzen auf Erreichbarkeit              Juni 94                 */
/*                                                                            */
/******************************************************************************/






/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern void ShowPlaces  (MARKING    ,            /* Zeiger auf Markierung     */
                         Place      ,            /* Zeiger auf Stellenliste   */
                         FILE     * );           /* Zeiger auf Ausgabedatei   */

#else

extern void ShowPlaces ();

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/* Parameter:                                                                 */
/*                                                                            */
/* MARKING     Marking;                             Zeiger auf Markierung     */
/* Place       Stellen;                             Zeiger auf Stellenliste   */
/* FILE      * Datei  ;                             Zeiger auf Ausgabedatei   */
/*                                                                            */
/* Gibt die Stellen eines Netzes mit ihrer Markierung auf dem Bildschirm aus  */
/*                                                                            */
/******************************************************************************/



/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern MARKING ReadMarkFile (LMPNet     ,        /* Zeiger auf Stellenliste   */
                             char     * );       /* Zeiger auf Datei mit Mar- */
                                                 /* kierungsliste             */
#else

extern MARKING ReadMarkFile ( );

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/* Parameter:                                                                 */
/*                                                                            */
/* LMPNet      Netz;                                Zeiger auf Stellenliste   */
/* char      * Markfilename;                        Zeiger auf Datei mit Mar- */
/*                                                  kierungsliste             */
/*                                                                            */
/* Liest eine Markierung aus einer Datei ein                                  */
/*                                                                            */
/******************************************************************************/




/******************************************************************************/
#if defined(__STDC__) || defined(__cplusplus)

extern MARKING ReadArgMark (LMPNet    ,          /* Zeiger auf Netz           */
                            char    * );         /* Zeiger auf Datei mit Mar- */
                                                 /* kierungsliste             */
#else

extern MARKING ReadArgMark ();

#endif                                           /* END STDC & C++ DEFINITION */

/*                                                                            */
/* Parameter:                                                                 */
/*                                                                            */
/* LMPNet      Netz;                                Zeiger auf Stellenliste   */
/* char     *  ArgMark;                             Zeiger auf Datei mit Mar- */
/*                                                  kierungsliste             */
/*                                                                            */
/* Liest eine Markierungsfolge der Art "001100100001100" ein                  */
/*                                                                            */
/******************************************************************************/
