/****************************************************************************/
/* bufgen.c                                                                 */
/* Mi.,27.04.1994 - Mi.,03.08.1994                            Stefan Roemer */
/****************************************************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/****************************************************************************/

typedef unsigned int Cardinal32;

/****************************************************************************/

#define f( str ) (void) fprintf( file, str )
#define fx( str, x ) (void) fprintf( file, str, x )
#define fxy( str, x, y ) (void) fprintf( file, str, x, y )

#define __EXTENDED__
#define RADIUS 7

/****************************************************************************/

static Cardinal32 r = RADIUS;
static Cardinal32 d = RADIUS * 2;
static Cardinal32 p = 0;
static Cardinal32 t = 0;
static Cardinal32 lp = 0;
static Cardinal32 lt = 0;
static Cardinal32 x = 0;
static Cardinal32 y = 0;
static Cardinal32 xoff = 50;
static Cardinal32 yoff = 50;

/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void PEP_STEdge( FILE * file,
                  int  x1,
                  int  y1,
                  int  x2,
                  int  y2
                  /*, int gewicht */ )

#else

void PEP_STEdge( file, x1, y1, x2, y2 /*, gewicht */ )

  FILE * file;
  int  x1, /* Koordinaten der Stelle */
       y1,
       x2, /* Koordinaten der Transition */
       y2;
/*int  gewicht; */

#endif

  {
    
    int   x_1,
          x_2,
          y_1,
          y_2;

#ifdef __EXTENDED__    
    float m,
          b,
          dx,
          dy;

    dx = (float) ( x2 - x1 );
    dy = (float) ( y2 - y1 );
    m = (float) r / hypot( dx, dy );
    x_1 = (int) ( (float) x1 + m * dx );
    y_1 = (int) ( (float) y1 + m * dy );

    if ( x1 == x2 )
      {
        x_2 = x2;
        if ( y1 < y2 )
          {
            y_2 = y2 - r;
          } /* if */
        else if ( y1 > y2 )
          {
            y_2 = y2 + r;
          } /* else if */
        else /* ( y1 == y2 ) */
          {
            printf( "PEP_TSEdge(): Stelle ueberdeckt Transition!\n" );
            y_1 = y1;
          } /* else */
      } /* if */
    else /* ( x1 != x2 ) */
      {
        b = (float) y1 - ( m = dy / dx ) * (float) x1;
        if ( fabs( m ) > 1 )
          {
            if ( y1 < y2 )
              {
                y_2 = y2 - r;
              } /* if */
            else /* ( y1 >= y2 ) */
              {
                y_2 = y2 + r;
              } /* else */
            x_2 = (int) ( ( (float) y_2 - b ) / m );
          } /* else if */
        else /* ( fabs( m ) < 1 ) */
          {
            if ( x1 < x2 )
              {
                x_2 = x2 - r;
              } /* if */
            else /* ( x2 >= x1 ) */
              {
                x_2 = x2 + r;
              } /* else */
            y_2 = (int) ( m * (float) x_2 + b );
          } /* else */
      } /* else */

#ifdef __WEIGHTED_ARCS__
    if ( gewicht != 1 )
      {
        fprintf( file, "4 1 1 8 0 -1 0 0.000 0 7 7 %d %d %d\001\n",
                 x1+(x2-x1)/2+3, y1+(y2-y1)/2, gewicht );
      } /* if */
#endif

#else /* SIMPLE */
    x_1 = x1;
    y_1 = y1 + r;
    x_2 = x2;
    y_2 = y2 - r - 2;

#endif /* __EXTENDED__ */

    fprintf( file, "lpt: %d@%d lpt: %d@%d ", x_1, y_1, x_2, y_2 );

  } /* PEP_STEdge() */


/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void PEP_TSEdge( FILE * file,
                  int  x1,
                  int  y1,
                  int  x2,
                  int  y2
                  /*, int gewicht */ )

#else

void PEP_TSEdge( file, x1, y1, x2, y2 /*, gewicht */ )

  FILE * file;
  int  x1,
       y1,
       x2,
       y2;
/*int  gewicht; */

#endif
 
  {

    int   x_1,
          x_2,
          y_1,
          y_2;

#ifdef __EXTENDED__    
    float m,
          b,
          dx,
          dy;
 
    dx = (float) ( x2 - x1 );
    dy = (float) ( y2 - y1 );
    m = (float) r / hypot( dx, dy );
    x_2 = (int) ( (float) x2 - m * dx );
    y_2 = (int) ( (float) y2 - m * dy );

    if ( x1 == x2 )
      {
        x_1 = x1;
        if ( y1 < y2 )
          {
            y_1 = y1 + r;
          } /* if */
        else if ( y1 > y2 )
          {
            y_1 = y1 - r;
          } /* else if */
        else /* ( y1 == y2 ) */
          {
            printf( "PEP_TSEdge(): Stelle ueberdeckt Transition!\n" );
            y_1 = y1;
          } /* else */
      } /* if */
    else /* ( x1 != x2 ) */
      {
        b = (float) y1 - ( m = dy / dx ) * (float) x1;
        if ( fabs( m ) > 1 )
          {
            if ( y1 < y2 )
              {
                y_1 = y1 + r;
              } /* if */
            else /* ( y1 >= y2 ) */
              {
                y_1 = y1 - r;
              } /* else */
            x_1 = (int) ( ( (float) y_1 - b ) / m );
          } /* else if */
        else /* ( fabs( m ) < 1 ) */
          {
            if ( x1 < x2 )
              {
                x_1 = x1 + r;
              } /* if */
            else /* ( x2 >= x1 ) */
              {
                x_1 = x1 - r;
              } /* else */
            y_1 = (int) ( m * (float) x_1 + b );
          } /* else */
      } /* else */

#ifdef __WEIGHTED_ARCS__
    if ( gewicht != 1 )
      {
        fprintf( file, "4 1 1 8 0 -1 0 0.000 0 7 7 %d %d %d\001\n",
                 x1+(x2-x1)/2+3, y1+(y2-y1)/2, gewicht );
      } /* if */
#endif

#else /* SIMPLE */
    x_1 = x1;
    y_1 = y1 + r;
    x_2 = x2;
    y_2 = y2 - r - 2;

#endif /* __EXTENDED__ */

    fprintf( file, "lpt: %d@%d lpt: %d@%d ", x_1, y_1, x_2, y_2 );

  } /* PEP_TSEdge() */


/****************************************************************************/

#define PxM( I, X, Y ) { register Cardinal32 ii = lp * i + (I); \
                         pli[ii] = ii; \
                         plx[ii] = xoff + ( i*x + (X) ) * d; \
                         ply[ii] = yoff + (Y) * d; \
                         fxy( "PLA: idt: %u nam: 'S%u' ", pli[ii], ii ); \
                         fxy( "dpt: %u@%u ", plx[ii], ply[ii] ); \
                         fxy( "dnp: %u@%u ", plx[ii] - 5, ply[ii]-3*r-4 ); \
                         f( "dwd: 2 ima: 1 cma: 1 end:\n" ); \
                       }

#define PyM( I, X, Y ) { register Cardinal32 ii = lp * i + (I); \
                         pli[ii] = ii; \
                         plx[ii] = xoff + (X) * d; \
                         ply[ii] = yoff + ( i*y + (Y) ) * d; \
                         fxy( "PLA: idt: %u nam: 'S%u' ", pli[ii], ii ); \
                         fxy( "dpt: %u@%u ", plx[ii], ply[ii] ); \
                         fxy( "dnp: %u@%u ", plx[ii] - 5, ply[ii]-3*r-4 ); \
                         f( "dwd: 2 ima: 1 cma: 1 end:\n" ); \
                       }

#define Px( I, X, Y ) { register Cardinal32 ii = lp * i + (I); \
                        pli[ii] = ii; \
                        plx[ii] = xoff + ( i*x + (X) ) * d; \
                        ply[ii] = yoff + (Y) * d; \
                        fxy( "PLA: idt: %u nam: 'S%u' ", pli[ii], ii ); \
                        fxy( "dpt: %u@%u ", plx[ii], ply[ii] ); \
                        fxy( "dnp: %u@%u ", plx[ii] - 5, ply[ii]-3*r-4 ); \
                        f( "dwd: 2 ima: 0 cma: 0 end:\n" ); \
                      }

#define Py( I, X, Y ) { register Cardinal32 ii = lp * i + (I); \
                        pli[ii] = ii; \
                        plx[ii] = xoff + (X) * d; \
                        ply[ii] = yoff + ( i*y + (Y) ) * d; \
                        fxy( "PLA: idt: %u nam: 'S%u' ", pli[ii], ii ); \
                        fxy( "dpt: %u@%u ", plx[ii], ply[ii] ); \
                        fxy( "dnp: %u@%u ", plx[ii] - 5, ply[ii]-3*r-4 ); \
                        f( "dwd: 2 ima: 0 cma: 0 end:\n" ); \
                      }

#define Tx( I, X, Y ) { register Cardinal32 ii = lt * i + (I); \
                        tri[ii] = ii + p; \
                        trx[ii] = xoff + ( i*x + (X) ) *d; \
                        trY[ii] = yoff + (Y) * d; \
                        fxy( "TRA: idt: %u nam: 'T%u' ", tri[ii], ii ); \
                        fxy( "dpt: %u@%u ", trx[ii], trY[ii] ); \
                        fxy( "dnp: %u@%u ", trx[ii]-5, trY[ii]-3*r-4 ); \
                        f( "dwd: 2 end:\n" ); \
                      }

#define Ty( I, X, Y ) { register Cardinal32 ii = lt * i + (I); \
                        tri[ii] = ii + p; \
                        trx[ii] = xoff + (X) *d; \
                        trY[ii] = yoff + ( i*y + (Y) ) * d; \
                        fxy( "TRA: idt: %u nam: 'T%u' ", tri[ii], ii ); \
                        fxy( "dpt: %u@%u ", trx[ii], trY[ii] ); \
                        fxy( "dnp: %u@%u ", trx[ii]-5, trY[ii]-3*r-4 ); \
                        f( "dwd: 2 end:\n" ); \
                      }

#define ST( S, T ) { register Cardinal32 ss = lp * i + (S), \
                                         tt = lt * i + (T); \
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", pli[ss], tri[tt] );\
                     PEP_STEdge( file, plx[ss], ply[ss], trx[tt], trY[tt] );\
                     f( "wgt: 1 end:\n" ); \
                   }

#define SToff( SI, S, TI, T ) { register Cardinal32 ss = lp * (SI) + (S),\
                                                    tt = lt * (TI) + (T);\
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", pli[ss], tri[tt] );\
                     PEP_STEdge( file, plx[ss], ply[ss], trx[tt], trY[tt] );\
                     f( "wgt: 1 end:\n" ); \
                   }

#define STmod( SI, S, TI, T ) { register Cardinal32 ss = lp * ((SI)%n) + (S),\
                                                    tt = lt * ((TI)%n) + (T);\
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", pli[ss], tri[tt] );\
                     PEP_STEdge( file, plx[ss], ply[ss], trx[tt], trY[tt] );\
                     f( "wgt: 1 end:\n" ); \
                   }

#define TS( T, S ) { register Cardinal32 ss = lp * i + (S), \
                                         tt = lt * i + (T); \
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", tri[tt], pli[ss] );\
                     PEP_STEdge( file, trx[tt], trY[tt], plx[ss], ply[ss] );\
                     f( "wgt: 1 end:\n" ); \
                   }

#define TSoff( TI, T, SI, S ) { register Cardinal32 ss = lp * (SI) + (S),\
                                                    tt = lt * (TI) + (T);\
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", tri[tt], pli[ss] );\
                     PEP_STEdge( file, trx[tt], trY[tt], plx[ss], ply[ss] );\
                     f( "wgt: 1 end:\n" ); \
                   }

#define TSmod( TI, T, SI, S ) { register Cardinal32 ss = lp * ((SI)%n) + (S),\
                                                    tt = lt * ((TI)%n) + (T);\
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", tri[tt], pli[ss] );\
                     PEP_STEdge( file, trx[tt], trY[tt], plx[ss], ply[ss] );\
                     f( "wgt: 1 end:\n" ); \
                   }


/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void gen_net( Cardinal32 n )

#else

void gen_net( n )

  Cardinal32 n;

#endif

  {

    register Cardinal32 plnum,
                        trnum,
                        i,
                        * plx,
                        * ply,
                        * trx,
                        * trY,
                        * pli,
                        * tri;
    FILE                * file;
    char                str[200];

    r = RADIUS;
    sprintf( str, "buf%u.st_net", n );
    file = fopen( str, "w" );
    f( "PEP\n" );
    f( "PTNet\n" );
    f( "FORMAT_A\n" );
    f( "com: 'This file was created by the n-buffer net generator.'\n" );
    fxy( "pap:  wis: 1 xnu:%d ynu:%d end:\n", 10, 10 );
    fxy( "set:  elw: 1 ena: '%%w' vsi: %d@%d vno: 10@0 vna: '' vbw: 2", r, r);
    fxy( " nov: 5 vpm: 0 psi: %d@%d pno: 10@0 pna: '%%c' pbw: 2 nop: 5",r, r);
    f( " ppm: 0 wgt: 1 cap: Omega ima: 0 end:\n" );
    f( "end:\n" );

    d = r << 2;
    p = plnum = n << 1;
    t = trnum = n + 1;
    lp = 2;
    lt = 1;
    x = 2;
    y = 3;
    pli = (Cardinal32 *) malloc( ( plnum + 1 ) * sizeof( Cardinal32 ) );
    plx = (Cardinal32 *) malloc( ( plnum + 1 ) * sizeof( Cardinal32 ) );
    ply = (Cardinal32 *) malloc( ( plnum + 1 ) * sizeof( Cardinal32 ) );
    tri = (Cardinal32 *) malloc( ( trnum + 1 ) * sizeof( Cardinal32 ) );
    trx = (Cardinal32 *) malloc( ( trnum + 1 ) * sizeof( Cardinal32 ) );
    trY = (Cardinal32 *) malloc( ( trnum + 1 ) * sizeof( Cardinal32 ) );

    for ( i = 0 ; i < n ; i++ )
      {
        PxM( 1, 2, 1 );
        Px(  2, 2, 3 );
      } /* for */
    for ( i = 0 ; i < n ; i++ )
      {
        Tx( 1, 1, 2 );
      } /* for */
    Tx( 1, 1, 2 );
    for ( i = 0 ; i < n ; i++ )
      {
        TS( 1, 1 );
        ST( 2, 1 );
        SToff( i, 1, i+1, 1 );
        TSoff( i+1, 1, i, 2 );
      } /* for */
   
    fx( "TXT: str: 'Buffer_%u' dpt: 15@5 end:\n", n );
    f( "END:\n" );
    fclose( file );

    free( (char *) pli );
    free( (char *) plx );
    free( (char *) ply );
    free( (char *) tri );
    free( (char *) trx );
    free( (char *) trY );

    sprintf( str, "buf%u.st_net", n );
    printf( "File '%s' has been written.\n", str );

  } /* gen_net() */


/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int main( int argc, char ** argv )

#else

int main( argc, argv )

  int  argc;
  char ** argv;

#endif

  {

    register Cardinal32 size = 1;

    if ( argc != 2 )
      {
        printf( "Buffer-Groesse angeben!\n" );
        exit( 1 );
      } /* if */
    if (( size = (Cardinal32) atoi( argv[1] ) ))
      {
        gen_net( size );
      } /* if */

    exit ( 0 );

  } /* main() */


/****************************************************************************/
/* END OF FILE bufgen.c                                                     */
/****************************************************************************/
