/****************************************************************************/
/* pargen.c                                                                 */
/****************************************************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/****************************************************************************/

typedef unsigned int Cardinal32;

/****************************************************************************/

#define f( str ) (void) fprintf( file, str )
#define fx( str, x ) (void) fprintf( file, str, x )
#define fxy( str, x, y ) (void) fprintf( file, str, x, y )

#define __EXTENDED__
#define RADIUS 7

#define ITER 4
int GL_flags;

/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int gen_net( Cardinal32 n, Cardinal32 lft )

#else

int gen_net( n, lft )

  Cardinal32 n;
  Cardinal32 lft;

#endif

  {

    register Cardinal32 i;
    FILE                * file;
    char                str[200];

    sprintf( str, (GL_flags&ITER)?"iter%u.ll_net":"par%u.ll_net", n );
    if ((file = fopen( str, "w" )))
      {
	f( "PEP\n" );
	f( "PetriBox\n" );
	f( "FORMAT_N\n" );
	f( "%% This file was created by the n-parallel net generator.\n" );
	
	f( "PL\n" );
	for ( i = 0 ; i < n ; i++ )
	  {
	    fprintf(file, "%d\"P%d\"%d@%deM1m1\n",2*i+1,2*i+1,40+i*40,40 );
	    fprintf(file, "%d\"P%d\"%d@%dx\n",2*i+2,2*i+2,40+i*40,120 );
	  } /* for */
	f( "TR\n" );
	for ( i = 0 ; i < n ; i++ )
	  {
	    if (GL_flags & ITER)
	      {
		fprintf(file, "%d\"T%d\"%d@%dE0L%d\n",2*i+1,2*i+1,20+i*40,80,lft );
		fprintf(file, "%d\"T%d\"%d@%dE0L%d\n",2*i+2,2*i+2,60+i*40,80,lft );
	      }
	    else
	      fprintf(file, "%d\"T%d\"%d@%dE0L%d\n",i+1,i+1,40+i*40,80, lft );
	  } /* for */
	f( "TP\n" );
	for ( i = 0 ; i < n ; i++ )
	  {
	    if (GL_flags & ITER)
	      {
		fprintf(file, "%d<%d\n",2*i+1,2*i+2 );
		fprintf(file, "%d<%d\n",2*i+2,2*i+1 );
	      }
	    else
	      fprintf(file, "%d<%d\n",i+1,2*i+2 );
	  } /* for */
	f( "PT\n" );
	for ( i = 0 ; i < n ; i++ )
	  {
            if (GL_flags & ITER)
              {
                fprintf(file, "%d>%d\n",2*i+1,2*i+1 );
                fprintf(file, "%d>%d\n",2*i+2,2*i+2 );
              } 
            else
	      fprintf(file, "%d>%d\n",2*i+1,i+1 );
	  } /* for */

	fclose( file );
	return 0;
      } /* if file */
    else
      return 1;
  } /* gen_net() */


/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int main( int argc, char ** argv )

#else

int main( argc, argv )

  int  argc;
  char ** argv;

#endif

  {

    register Cardinal32 size,
			lft=1;

    if ( argc < 2 )
      {
        printf( "usage: pargen -n=#n [-i|-l=#lft]\n" );
        printf( "       -n=#n: number of parallel nets\n" );
	printf( "	-i: print cycles instead of parallel transitions\n");
        printf( "       -l=#lft: latest firing time\n\n" );
        exit( 1 );
      } /* if */
    if (( size = (Cardinal32) atoi( &argv[1][3] ) ))
      {
	if (argc>=3)
	  {
	    if (strcmp(argv[2],"-i")==0)
	      {
	        GL_flags |= ITER;
	        if (argc>=4)
		  lft=(Cardinal32) atoi( &argv[3][3] );
	      }
	    else
              lft=(Cardinal32) atoi( &argv[2][3] );
	  }
        if (gen_net( size, lft ))
          exit(2);
      } /* if */
    else
      exit(2);

    exit ( 0 );

  } /* main() */


/****************************************************************************/
/* END OF FILE pargen.c                                                     */
/****************************************************************************/
