/****************************************************************************/
/* slotgen.c                                                                */
/* Do.,17.10.1994 - Do.,17.10.1994                            Stefan Roemer */
/****************************************************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/****************************************************************************/

typedef unsigned int Cardinal32;

/****************************************************************************/

#define f( str ) (void) fprintf( file, str )
#define fx( str, x ) (void) fprintf( file, str, x )
#define fxy( str, x, y ) (void) fprintf( file, str, x, y )
#define fxyz( str, x, y, z ) (void) fprintf( file, str, x, y, z )

#define __EXTENDED__
#define RADIUS 7

/****************************************************************************/

static Cardinal32 r = RADIUS;
static Cardinal32 d = RADIUS * 2;
static Cardinal32 p = 0;
static Cardinal32 t = 0;
static Cardinal32 lp = 0;
static Cardinal32 lt = 0;
static Cardinal32 x = 0;
static Cardinal32 y = 0;
static Cardinal32 xoff = 50;
static Cardinal32 yoff = 50;

/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void PEP_STEdge( FILE * file,
                  int  x1,
                  int  y1,
                  int  x2,
                  int  y2
                  /*, int gewicht */ )

#else

void PEP_STEdge( file, x1, y1, x2, y2 /*, gewicht */ )

  FILE * file;
  int  x1, /* Koordinaten der Stelle */
       y1,
       x2, /* Koordinaten der Transition */
       y2;
/*int  gewicht; */

#endif

  {
    
    int   x_1,
          x_2,
          y_1,
          y_2;

#ifdef __EXTENDED__    
    float m,
          b,
          dx,
          dy;

    dx = (float) ( x2 - x1 );
    dy = (float) ( y2 - y1 );
    m = (float) r / hypot( dx, dy );
    x_1 = (int) ( (float) x1 + m * dx );
    y_1 = (int) ( (float) y1 + m * dy );

    if ( x1 == x2 )
      {
        x_2 = x2;
        if ( y1 < y2 )
          {
            y_2 = y2 - r;
          } /* if */
        else if ( y1 > y2 )
          {
            y_2 = y2 + r;
          } /* else if */
        else /* ( y1 == y2 ) */
          {
            printf( "PEP_STEdge(): Stelle ueberdeckt Transition!\n" );
            y_1 = y1;
          } /* else */
      } /* if */
    else /* ( x1 != x2 ) */
      {
        b = (float) y1 - ( m = dy / dx ) * (float) x1;
        if ( fabs( m ) > 1 )
          {
            if ( y1 < y2 )
              {
                y_2 = y2 - r;
              } /* if */
            else /* ( y1 >= y2 ) */
              {
                y_2 = y2 + r;
              } /* else */
            x_2 = (int) ( ( (float) y_2 - b ) / m );
          } /* else if */
        else /* ( fabs( m ) < 1 ) */
          {
            if ( x1 < x2 )
              {
                x_2 = x2 - r;
              } /* if */
            else /* ( x2 >= x1 ) */
              {
                x_2 = x2 + r;
              } /* else */
            y_2 = (int) ( m * (float) x_2 + b );
          } /* else */
      } /* else */

#ifdef __WEIGHTED_ARCS__
    if ( gewicht != 1 )
      {
        fprintf( file, "4 1 1 8 0 -1 0 0.000 0 7 7 %d %d %d\001\n",
                 x1+(x2-x1)/2+3, y1+(y2-y1)/2, gewicht );
      } /* if */
#endif

#else /* SIMPLE */
    x_1 = x1;
    y_1 = y1 + r;
    x_2 = x2;
    y_2 = y2 - r - 2;

#endif /* __EXTENDED__ */

    fprintf( file, "lpt: %d@%d lpt: %d@%d ", x_1, y_1, x_2, y_2 );

  } /* PEP_STEdge() */


/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void PEP_TSEdge( FILE * file,
                  int  x1,
                  int  y1,
                  int  x2,
                  int  y2
                  /*, int gewicht */ )

#else

void PEP_TSEdge( file, x1, y1, x2, y2 /*, gewicht */ )

  FILE * file;
  int  x1,
       y1,
       x2,
       y2;
/*int  gewicht; */

#endif
 
  {

    int   x_1,
          x_2,
          y_1,
          y_2;

#ifdef __EXTENDED__    
    float m,
          b,
          dx,
          dy;
 
    dx = (float) ( x2 - x1 );
    dy = (float) ( y2 - y1 );
    m = (float) r / hypot( dx, dy );
    x_2 = (int) ( (float) x2 - m * dx );
    y_2 = (int) ( (float) y2 - m * dy );

    if ( x1 == x2 )
      {
        x_1 = x1;
        if ( y1 < y2 )
          {
            y_1 = y1 + r;
          } /* if */
        else if ( y1 > y2 )
          {
            y_1 = y1 - r;
          } /* else if */
        else /* ( y1 == y2 ) */
          {
            printf( "PEP_TSEdge(): Stelle ueberdeckt Transition!\n" );
            y_1 = y1;
          } /* else */
      } /* if */
    else /* ( x1 != x2 ) */
      {
        b = (float) y1 - ( m = dy / dx ) * (float) x1;
        if ( fabs( m ) > 1 )
          {
            if ( y1 < y2 )
              {
                y_1 = y1 + r;
              } /* if */
            else /* ( y1 >= y2 ) */
              {
                y_1 = y1 - r;
              } /* else */
            x_1 = (int) ( ( (float) y_1 - b ) / m );
          } /* else if */
        else /* ( fabs( m ) < 1 ) */
          {
            if ( x1 < x2 )
              {
                x_1 = x1 + r;
              } /* if */
            else /* ( x2 >= x1 ) */
              {
                x_1 = x1 - r;
              } /* else */
            y_1 = (int) ( m * (float) x_1 + b );
          } /* else */
      } /* else */

#ifdef __WEIGHTED_ARCS__
    if ( gewicht != 1 )
      {
        fprintf( file, "4 1 1 8 0 -1 0 0.000 0 7 7 %d %d %d\001\n",
                 x1+(x2-x1)/2+3, y1+(y2-y1)/2, gewicht );
      } /* if */
#endif

#else /* SIMPLE */
    x_1 = x1;
    y_1 = y1 + r;
    x_2 = x2;
    y_2 = y2 - r - 2;

#endif /* __EXTENDED__ */

    fprintf( file, "lpt: %d@%d lpt: %d@%d ", x_1, y_1, x_2, y_2 );

  } /* PEP_TSEdge() */


/****************************************************************************/

#define PxM( I, X, Y ) { register Cardinal32 ii = lp * i + (I); \
                         pli[ii] = ii; \
                         plx[ii] = xoff + ( i*x + (X) ) * d; \
                         ply[ii] = yoff + (Y) * d; \
                         fxy( "PLA: idt: %u nam: 'P%u' ", pli[ii], ii);\
                         fxy( "dpt: %u@%u ", plx[ii], ply[ii] ); \
                         fxy( "dnp: %u@%u ", plx[ii] - 5, ply[ii]-3*r-4 ); \
                         f( "dwd: 2 ima: 1 cma: 1 end:\n" ); \
                       }

#define PyM( I, X, Y ) { register Cardinal32 ii = lp * i + (I); \
                         pli[ii] = ii; \
                         plx[ii] = xoff + (X) * d; \
                         ply[ii] = yoff + ( i*y + (Y) ) * d; \
                         fxy( "PLA: idt: %u nam: 'P%u' ", pli[ii], ii);\
                         fxy( "dpt: %u@%u ", plx[ii], ply[ii] ); \
                         fxy( "dnp: %u@%u ", plx[ii] - 5, ply[ii]-3*r-4 ); \
                         f( "dwd: 2 ima: 1 cma: 1 end:\n" ); \
                       }

#define Px( I, X, Y ) { register Cardinal32 ii = lp * i + (I); \
                        pli[ii] = ii; \
                        plx[ii] = xoff + ( i*x + (X) ) * d; \
                        ply[ii] = yoff + (Y) * d; \
                        fxy( "PLA: idt: %u nam: 'P%u' ", pli[ii], ii );\
                        fxy( "dpt: %u@%u ", plx[ii], ply[ii] ); \
                        fxy( "dnp: %u@%u ", plx[ii] - 5, ply[ii]-3*r-4 ); \
                        f( "dwd: 2 ima: 0 cma: 0 end:\n" ); \
                      }

#define Py( I, X, Y ) { register Cardinal32 ii = lp * i + (I); \
                        pli[ii] = ii; \
                        plx[ii] = xoff + (X) * d; \
                        ply[ii] = yoff + ( i*y + (Y) ) * d; \
                        fxy( "PLA: idt: %u nam: '%s%u' ", pli[ii], ii );\
                        fxy( "dpt: %u@%u ", plx[ii], ply[ii] ); \
                        fxy( "dnp: %u@%u ", plx[ii] - 5, ply[ii]-3*r-4 ); \
                        f( "dwd: 2 ima: 0 cma: 0 end:\n" ); \
                      }

#define Tx( I, X, Y, N ) { register Cardinal32 ii = lt * i + (I); \
                           tri[ii] = ii + p; \
                           trx[ii] = xoff + ( i*x + (X) ) *d; \
                           trY[ii] = yoff + (Y) * d; \
                           fxyz( "TRA: idt: %u nam: '%s%u' ", tri[ii], N,i+1);\
                           fxy( "dpt: %u@%u ", trx[ii], trY[ii] ); \
                           fxy( "dnp: %u@%u ", trx[ii]-5, trY[ii]-3*r-4 ); \
                           f( "dwd: 2 end:\n" ); \
                         }

#define Ty( I, X, Y, N ) { register Cardinal32 ii = lt * i + (I); \
                           tri[ii] = ii + p; \
                           trx[ii] = xoff + (X) *d; \
                           trY[ii] = yoff + ( i*y + (Y) ) * d; \
                           fxyz( "TRA: idt: %u nam: '%s%u' ", tri[ii], N,i+1);\
                           fxy( "dpt: %u@%u ", trx[ii], trY[ii] ); \
                           fxy( "dnp: %u@%u ", trx[ii]-5, trY[ii]-3*r-4 ); \
                           f( "dwd: 2 end:\n" ); \
                         }

#define ST( S, T ) { register Cardinal32 ss = lp * i + (S), \
                                         tt = lt * i + (T); \
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", pli[ss], tri[tt] );\
                     PEP_STEdge( file, plx[ss], ply[ss], trx[tt], trY[tt] );\
                     f( "wgt: 1 end:\n" ); \
                   }

#define SToff( SI, S, TI, T ) { register Cardinal32 ss = lp * (SI) + (S),\
                                                    tt = lt * (TI) + (T);\
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", pli[ss], tri[tt] );\
                     PEP_STEdge( file, plx[ss], ply[ss], trx[tt], trY[tt] );\
                     f( "wgt: 1 end:\n" ); \
                   }

#define STmod( SI, S, TI, T ) { register Cardinal32 ss = lp * ((SI)%n) + (S),\
                                                    tt = lt * ((TI)%n) + (T);\
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", pli[ss], tri[tt] );\
                     PEP_STEdge( file, plx[ss], ply[ss], trx[tt], trY[tt] );\
                     f( "wgt: 1 end:\n" ); \
                   }

#define TS( T, S ) { register Cardinal32 ss = lp * i + (S), \
                                         tt = lt * i + (T); \
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", tri[tt], pli[ss] );\
                     PEP_STEdge( file, trx[tt], trY[tt], plx[ss], ply[ss] );\
                     f( "wgt: 1 end:\n" ); \
                   }

#define TSoff( TI, T, SI, S ) { register Cardinal32 ss = lp * (SI) + (S),\
                                                    tt = lt * (TI) + (T);\
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", tri[tt], pli[ss] );\
                     PEP_STEdge( file, trx[tt], trY[tt], plx[ss], ply[ss] );\
                     f( "wgt: 1 end:\n" ); \
                   }

#define TSmod( TI, T, SI, S ) { register Cardinal32 ss = lp * ((SI)%n) + (S),\
                                                    tt = lt * ((TI)%n) + (T);\
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", tri[tt], pli[ss] );\
                     PEP_STEdge( file, trx[tt], trY[tt], plx[ss], ply[ss] );\
                     f( "wgt: 1 end:\n" ); \
                   }

#define TSyoff( T, S, Y ) \
                   { register Cardinal32 ss = lp * i + (S), \
                                         tt = lt * i + (T); \
                     fxy( "ARC: sou: %u des: %u dsz: 1 ", tri[tt], pli[ss] );\
                     PEP_STEdge( file, trx[tt], trY[tt], \
                                                      trx[tt], trY[tt]+(Y) );\
                     PEP_STEdge( file, plx[ss], trY[tt]+(Y), \
                                                          plx[ss], ply[ss] );\
                     f( "wgt: 1 end:\n" ); \
                   }


/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void gen_net( Cardinal32 n )

#else

void gen_net( n )

  Cardinal32 n;

#endif

  {

    register Cardinal32 i,
                        * plx,
                        * ply,
                        * trx,
                        * trY,
                        * pli,
                        * tri;
    FILE                * file;
    char                str[200];

    r = RADIUS;
    sprintf( str, "slot%u.st_net", n );
    file = fopen( str, "w" );
    f( "PEP\n" );
    f( "PTNet\n" );
    f( "FORMAT_A\n" );
 f("com: 'This file was created by the \"slotted ring\" net generator.'\n");
    fxy( "pap:  wis: 1 xnu:%d ynu:%d end:\n", 10, 10 );
    fxy( "set:  elw: 1 ena: '%%w' vsi: %d@%d vno: 10@0 vna: '' vbw: 2", r, r);
    fxy( " nov: 5 vpm: 0 psi: %d@%d pno: 10@0 pna: '%%c' pbw: 2 nop: 5",r, r);
    f( " ppm: 0 wgt: 1 cap: Omega ima: 0 end:\n" );
    f( "end:\n" );

    d  = r << 2;
    lp = 10;     /* Anzahl Stellen pro Komponente */
    lt = 10;     /* Anzahl Transitionen pro Komponente */
    p  = lp * n; /* Anzahl Stellen insgesamt */
    t  = lt * n; /* Anzahl Transitionen insgesamt */
    x  = 12;     /* Hoehe einer Komponente */
    y  = 16;     /* Breite einer Komponente */
    pli = (Cardinal32 *) malloc( ( p + 1 ) * sizeof( Cardinal32 ) );
    plx = (Cardinal32 *) malloc( ( p + 1 ) * sizeof( Cardinal32 ) );
    ply = (Cardinal32 *) malloc( ( p + 1 ) * sizeof( Cardinal32 ) );
    tri = (Cardinal32 *) malloc( ( t + 1 ) * sizeof( Cardinal32 ) );
    trx = (Cardinal32 *) malloc( ( t + 1 ) * sizeof( Cardinal32 ) );
    trY = (Cardinal32 *) malloc( ( t + 1 ) * sizeof( Cardinal32 ) );

    for ( i = 0 ; i < n ; i++ )
      {
        Px(  1,  7,  1 );
        PxM( 2, 12,  1 );
        Px(  3,  8,  3 );
        Px(  4, 10,  3 );
        Px(  5, 14,  3 );
        PxM( 6, 16,  3 );
        Px(  7,  3,  7 );
        Px(  8,  5, 11 );
        Px(  9,  9,  7 );
        Px( 10, 12,  5 );
      } /* for */
    for ( i = 0 ; i < n ; i++ )
      {
        Tx(  1,  9,  1, "GiveFreeSlot" );
        Tx(  2, 17,  1, "Free" );
        Tx(  3,  9,  5, "PutMessageInSlot" );
        Tx(  4, 15,  5, "Used" );
        if ( i ) Tx(  5,  6,  3, "Ack" );
        Tx(  6, 12,  3, "IntAck" );
        Tx(  7,  6,  7, "Other" );
        Tx(  8,  3,  9, "Owner" );
        Tx(  9,  7, 11, "GoOn" );
        Tx( 10,  9, 13, "Write" );
      } /* for */
    i = 0; Tx(  5,  5,  1, "Ack" );
    for ( i = 0 ; i < n ; i++ )
      {
        ST(  1,  1 );
        TS(  1,  2 );
        ST(  2,  2 );
        TS(  1,  3 );
        TS(  2,  5 );
        ST(  4,  1 );
        ST(  6,  2 );
        TS(  3,  3 );
        ST(  3,  5 );
        ST(  4,  3 );
        TS(  3,  3 );
        ST(  6,  4 );
        TS(  4,  5 );
        ST(  5,  6 );
        TS(  6,  4 );
        ST(  9,  3 );
        TS(  7,  9 );
        ST(  7,  7 );
        ST(  7,  8 );
        TS(  8,  8 );
        ST(  8,  9 );
        ST(  8, 10 );
        TS( 10,  9 );
        TS(  9,  1 );
        TS(  3, 10 );
        ST( 10,  4 );
        if ( n > 1 )
          {
            TSmod( i, 4, i+1, 7 );
            TSmod( i+1, 5, i, 6 );
            TSmod( i, 2, i+1, 8 );
          } /* if */
        else
          {
            TS( 5, 6 );
            TS( 4, 7 );
            TS( 2, 8 );
          } /* else */
      } /* for */
   
    fx( "TXT: str: 'Slotted_ring_protocol_for_%u_nodes' dpt: 15@5 end:\n", n );
    f( "END:\n" );
    fclose( file );

    free( (char *) pli );
    free( (char *) plx );
    free( (char *) ply );
    free( (char *) tri );
    free( (char *) trx );
    free( (char *) trY );

    sprintf( str, "slot%u.st_net", n );
    printf( "File '%s' has been written.\n", str );

  } /* gen_net() */


/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int main( int argc, char ** argv )

#else

int main( argc, argv )

  int  argc;
  char ** argv;

#endif

  {

    register Cardinal32 size = 1;

    if ( argc != 2 )
      {
        printf( "Anzahl Komponenten angeben!\n" );
        exit( 1 );
      } /* if */
    if (( size = (Cardinal32) atoi( argv[1] ) ))
      {
        gen_net( size );
      } /* if */

    exit ( 0 );

  } /* main() */


/****************************************************************************/
/* END OF FILE slotgen.c                                                    */
/****************************************************************************/
