#*******************************************************************
# Help-Viewer in Tcl/Tk-Layout f"ur eine Untermenge von HTML-Dateien
# erstellt von Carola Pohl / Burkhard Bieber
# last-update: 13.12.96
# 30.11.2000, CS: cosmetic updates
#*******************************************************************

  # 1. den Oberpfad holen und ablegen
if [catch {set env(PEPHOME)}] {
  set gvar(pephome.path) "/opt/pep"
} else {
  set gvar(pephome.path) $env(PEPHOME)
}  ;# else, die Pfadangabe war vorhanden
  # 2. Autopath f"ur allgemeine Dinge (Kommunikation, ...)
set gvar(my_auto_path.path) "$gvar(pephome.path)/lib"
set auto_path [linsert $auto_path 0 $gvar(my_auto_path.path)]
  # 4. Pfad zu den HTML-Seiten
set HELPPATH "$gvar(pephome.path)/lib/help"

  # Kommunikation aufbauen
init_client_com

# Argument bestimmen
if {$argc >= 1} {
    set ArgDatei [lindex $argv 0]
} else {
    puts stderr "No help file specified on command line!\n"
    exit
}
 
# merke die zuerst geffnete Datei in FIRST
set FIRST $ArgDatei

# merke ursprngliche Hintergrundfarbe Hfarbe
set Info [. configure -background]
set Hfarbe [lindex $Info 4]

# Definition des Fensters (Text-Widget, Scrollbar und OK-Button) 

frame .mbar -relief raised -bd 2
pack .mbar -fill x

button .mbar.src -text Sources
button .mbar.undo -text Back -command ShowLastDatei -state disabled
button .mbar.first -text First -command "Fensterinhalt $FIRST"
pack .mbar.src -side left
pack .mbar.undo .mbar.first -side right

bind .mbar.src <1> "Browser"

button .quit -text Quit \
           -command "goodbye_server;destroy ."

frame .f
text .f.t -wrap word \
        -relief raised \
        -bd 2 \
        -yscrollcommand ".f.s set" \
        -width 60 \
        -height 25 \
        -font -Adobe-Helvetica-Medium-R-Normal--*-140-*
scrollbar .f.s -relief flat \
             -command ".f.t yview"

label .l

pack .f -expand true -fill both
pack .f.s -side right -fill y
pack .f.t -fill both -expand true
pack .quit -side right 
pack .l -side left 


# Initialisierung der History-Liste
set HistListe [list]                       ;# leere Liste erzeugen   

# im weiteren wird die History-Liste wiefolgt aufgebaut:
# Datei1 Marke1 Datei2 Marke2 Datei3 Marke3 ...
# falls zur Dateiangabe (Dateik) keine Marke existiert, 
# hat Markek den Wert 0

set z 1


# Einfgen des Strings was in das Text-Widget 
# einschlielich einer Behandlung der Sonderzeichen
proc Einfgen {was} {

    global .f.t sondanz

    set sondanz 0                 ;# Laenge der Sonderzeichen
    set newList [split $was " "]
    set sonder [lsearch $newList &*] 
    while {$sonder!=-1} {
        set partList [lrange $newList 0 [expr ($sonder-1)]]
        set list [join $partList " "]
        .f.t insert end "$list"
        set char [lindex $newList $sonder]
        switch $char {
          "&lt" {.f.t insert end "<"
                 set sondanz [expr ($sondanz+2)]
                }\
          "&gt" {.f.t insert end ">"
                 set sondanz [expr ($sondanz+2)]
                }\
          "&amp" {.f.t insert end "&"
                 set sondanz [expr ($sondanz+3)]
                 }\
          "&quot" {.f.t insert end "''"
                 set sondanz [expr ($sondanz+4)]
                  }
        }
        set last [llength $newList]
        set newList [lrange $newList [expr ($sonder +1)] $last]
        set sonder [lsearch $newList &*] 
    }
    set list [join $newList " "]
    .f.t insert end "$list "
}


proc Bearbeite {which} {

    global .f.t sondanz i Hfarbe

    set id [lindex $which 0]
    switch $id {
    "<B>" { set anz [llength $which]
            set dat [lrange $which 1 [expr ($anz-2)]]
            Einfgen $dat
            set laenge [expr (([string length $dat]+1)-$sondanz)]
            .f.t tag add fett "insert - $laenge chars" "insert - 1 chars"
            .f.t tag configure fett -font \
		  -Adobe-Helvetica-Bold-R-Normal-*-140-*
          }\
    "<I>" { set anz [llength $which]
            set dat [lrange $which 1 [expr ($anz-2)]]
            Einfgen $dat
            set laenge [expr (([string length $dat]+1)-$sondanz)]
            .f.t tag add kursiv "insert - $laenge chars" "insert - 1 chars"
            .f.t tag configure kursiv -font \
                  -*-Medium-I-Normal-*-140-*
          }\
    "<TT>" { set anz [llength $which]
            set dat [lrange $which 1 [expr ($anz-2)]]
            Einfgen $dat
            set laenge [expr (([string length $dat]+1)-$sondanz)]
            .f.t tag add courier "insert - $laenge chars" "insert - 1 chars"
            .f.t tag configure courier -font \
		  -*-Courier-Medium-R-Normal-*-140-*
          }\


    "<A" { set anz [llength $which]
          set Ref [lindex $which 1]                   ;# ....=" .html# ">
          set idd [string range $Ref 0 3]              ;# NAME oder HREF
          set bis [string length $Ref]
          set Info [string range $Ref 6 [expr ($bis-3)]]
          if {$idd=="NAME"} {
             set Marke $Info 
          } else {
             set test [string match *#* $Info]        ;# 1 falls ...#...
             if {$test==1} {                          ;# falls RefMarke existiert
               set Infos [split $Info "#"]
               set RefDatei [lindex $Infos 0]
               set RefMarke [lindex $Infos 1]
             } else {
               set RefDatei $Info
             }
          }
          set Teilliste [lrange $which 2 [expr ($anz-2)]]
          set neudat [join $Teilliste " "]
          Einfgen $neudat
          set laenge [expr (([string length $neudat]+1)-$sondanz)]
          if {$idd=="NAME"} {
             .f.t mark set $Marke "insert -1 chars"
          } else {
             incr i
             .f.t tag add ref($i) "insert - $laenge chars" "insert - 1 chars"
             .f.t tag configure ref($i) \
                     -font -Adobe-Helvetica-Medium-R-Normal--*-140-* \
		     -foreground maroon
             .f.t tag bind ref($i) <Enter> \
		  ".f.t tag configure ref($i) -foreground black -background maroon; .f.t config -cursor {hand2 black white}"
 	     .f.t tag bind ref($i) <Leave> \
		  ".f.t tag configure ref($i) -foreground maroon -background $Hfarbe; .f.t config -cursor gumby"

             if {$test==1} {                             ;# falls RefMarke existiert
               .f.t tag bind ref($i) <1> "Fensterinhalt $RefDatei $RefMarke"
             } else {
               .f.t tag bind ref($i) <1> "Fensterinhalt $RefDatei"
            }
          }
         }
    }

    }


# Prozedur Fensterinhalt erstellt den Inhalt des Text-Fensters
# u"bergebene Parameter: D  Name, der zu o"ffnenden Datei
#                       M  Marke, zu der gegebenenfalls gesprungen werden soll
proc Fensterinhalt {D {M 0}} {

     global .f.t HistListe z HELPPATH sondanz Hfarbe i

     # Schreibstatus des Text-Widget
     .f.t configure -state normal 
     .f.t config -cursor {watch maroon white}
     update idletasks

     if {[llength $HistListe]!=0} {
	 .mbar.undo configure -state normal
     }
     
     # Eintrag in History-Liste
     set Dlist [list $D $M]
     set HistListe [concat $HistListe $Dlist]

     .f.t delete 0.0 end               ;# evtl. vorhandenen Text lo"schen

     # Datei o"ffnen, falls vorhanden
     set D $HELPPATH/$D
     set test [file exists $D]       ;# die zu o"ffnende Datei steht in argv
     if {$test == 1} {
        set Datei [open $D r]        ;# Datei zum Lesen o"ffnen
     } else {
        puts stderr "File $D does not exist!\n"
        exit
     }

     # Angabe des geffneten Files
     destroy .l
     label .l -text "File: [string range "[file dirname $D]" 1 20].../[file tail $D]"
     pack .l -side left

     # Dateiinhalt zeilenweise lesen
     set Liste [list]                       ;# leere Liste erzeugen
     gets $Datei zeile                      ;# Zeile aus Datei lesen
     while {$zeile >= 0} {                  ;# solange Dateiende nicht erreicht
        set neuListe [split $zeile " "]     ;# Umwandlung der Zeile in Liste
        set Liste [concat $Liste $neuListe] ;# neue Liste an alte anha"ngen
        gets $Datei zeile                   ;# na"chste Zeile lesen
     }

     # Behandlung der Liste
     set i 1                           ;# Initialisierung einer Laufvariable
     set first [lsearch $Liste <*]      ;# Suche erstes Vorkommen von <
     while {$first >= 0} {

       ;# Einfgen der Zeichen bis zum Auftreten von < ins Text-Widget
       set Teilliste [lrange $Liste 0 [expr ($first-1)]]
       set neudat [join $Teilliste " "]
       Einfgen $neudat 

       ;# je nach Markierung <?> das entsprechende tun     
       set next [lindex $Liste [expr ($first)]]
       switch $next {
       "<P>" {
          .f.t insert end "\n\n"
          set ende $first
         }
       "<BR>" {
          .f.t insert end "\n"
          set ende $first
         }
       "<DL>" {
         .f.t insert end "\n"
         set end1 [lsearch $Liste <DT>]
         set last [llength $Liste]            ;# La"nge der Liste
         set Liste [lrange $Liste [expr ($end1 +1)] $last]
         set end2 [lsearch $Liste <DD>]
         set zei [lindex $Liste $end2]
         
         while {(($zei=="<DD>") || ($zei=="<DT>")) || ($zei=="</DL>")} {

         switch $zei {
        "<DD>" {
          .f.t insert end "\n"
          .f.t insert end "   "
          set Teilliste [lrange $Liste 0 [expr ($end2-1)]]
          set neudat [join $Teilliste " "]
          Einfgen $neudat
          set laenge [expr (([string length $neudat]+1)-$sondanz)]
          .f.t tag add format "insert - $laenge chars" "insert - 0 chars"
          .f.t tag configure format -font \
                       -Adobe-Helvetica-Medium-R-Normal--*-140-* \
                       -foreground blue
          .f.t insert end "\n"

          set last [llength $Liste]            ;# La"nge der Liste
          set Liste [lrange $Liste [expr ($end2 +1)] $last]

          set end1 [lsearch $Liste <*D*>]
          set zei [lindex $Liste $end1]
 
          }
        "<DT>" -
        "</DL>" {
           set Teilliste [lrange $Liste 0 [expr ($end1-1)]]
           set counter 0
           set number [llength $Teilliste]
           set aktual [lindex $Teilliste $counter]
           set last [lindex $Teilliste $number]
           set place [string length $aktual]
           set belegt $place
           set part $Teilliste

           .f.t insert end "        "
           while {($counter<=$number)} {
             if {$aktual=="<B>"} {
                set part [lrange $Teilliste $counter $number]
                set zu [lsearch $part </B>]
                set list [lrange $part 0 $zu]
                Bearbeite $list
                set counter [expr (($zu+$counter)+1)]
             } elseif {$aktual=="<I>"} {
                set part [lrange $Teilliste $counter $number]
                set zu [lsearch $part </I>]
                set list [lrange $part 0 $zu]
                Bearbeite $list
                set counter [expr (($zu+$counter)+1)]
             } elseif {$aktual=="<TT>"} {
                set part [lrange $Teilliste $counter $number]
                set zu [lsearch $part </TT>]
                set list [lrange $part 0 $zu]
                Bearbeite $list
                set counter [expr (($zu+$counter)+1)]
             } elseif {$aktual=="<A"} {
                set part [lrange $Teilliste $counter $number]
                set zu [lsearch $part </A>]
                set list [lrange $part 0 $zu]
                Bearbeite $list
                set counter [expr (($zu+$counter)+1)]
             } elseif {$aktual=="<P>"} {
                .f.t insert end "\n\n"
                .f.t insert end "        "
                incr counter
             } elseif {$aktual=="<BR>"} {
                .f.t insert end "\n"
                .f.t insert end "        "
                incr counter
             } else {
                Einfgen $aktual
                incr counter
             }
             set aktual [lindex $Teilliste $counter]
             if {$aktual=="<B>"} {
                set part [lrange $Teilliste $counter $number]
                set z [lsearch $part </B>]
                set l [lrange $part 1 [expr ($z-1)]]
                set d [join $l " "]
                set place [string length $d]
             } elseif {$aktual=="<I>"} {
                set part [lrange $Teilliste $counter $number]
                set z [lsearch $part </I>]
                set l [lrange $part 1 [expr ($z-1)]]
                set d [join $l " "]
                set place [string length $d]
             } elseif {$aktual=="<TT>"} {
                set part [lrange $Teilliste $counter $number]
                set z [lsearch $part </TT>]
                set l [lrange $part 1 [expr ($z-1)]]
                set d [join $l " "]
                set place [string length $d]
             } elseif {$aktual=="<A"} {
                set part [lrange $Teilliste $counter $number]
                set z [lsearch $part </A>]
                set l [lrange $part 2 [expr ($z-1)]]
                set d [join $l " "]
                set place [string length $d]
             } elseif {$aktual=="<P>"} {
                set belegt 0
                set place 0
             } elseif {$aktual=="<BR>"} {
                set belegt 0
                set place 0
             } else {
                set place [string length $aktual]
             }
             set belegt [expr $belegt+$place]
             if {$belegt>52} {
               .f.t insert end "\n"
               .f.t insert end "        "
               set belegt $place
             }
           }


           if {$zei=="</DL>"} {break}

           set last [llength $Liste]            ;# La"nge der Liste
           set Liste [lrange $Liste [expr ($end1 +1)] $last]

           set end2 [lsearch $Liste <D*>]
           set zei [lindex $Liste $end2]

           }
          }  ;# switch
         }  ;#while

         .f.t insert end "\n\n"
         set ende $end1

        }
       "<H1>" -
       "<H2>" -
       "<H3>" { if {$next=="<H1>"} {
                   set ende [lsearch $Liste </H1>]
             } elseif {$next=="<H2>"} {
                   set ende [lsearch $Liste </H2>]
             } else {
                   set ende [lsearch $Liste </H3>]
	     }
          set Teilliste [lrange $Liste [expr ($first+1)] [expr ($ende-1)]]
          set neudat [join $Teilliste " "]
          .f.t insert end "\n\n"
          Einfgen $neudat
          set laenge [expr (([string length $neudat]+1)-$sondanz)]
          if {$next=="<H1>"} {
              .f.t tag add h1 "insert - $laenge chars" "insert - 1 chars"
          } elseif {$next=="<H2>"} {
              .f.t tag add h2 "insert - $laenge chars" "insert - 1 chars"
          } else {
              .f.t tag add h3 "insert - $laenge chars" "insert - 1 chars"
	  }
	  if {$next=="<H1>"} {
              .f.t tag configure h1 -font \
                       -Adobe-Helvetica-Bold-R-Normal--*-240-* \
                       -foreground blue
          } elseif {$next=="<H2>"} {
              .f.t tag configure h2 -font \
                       -Adobe-Helvetica-Medium-R-Normal--*-180-* \
                       -foreground blue 
          } else {
              .f.t tag configure h3 -font \
                       -Adobe-Helvetica-Bold-R-Normal--*-180-* \
	  }
          .f.t insert end "\n\n"

          }
       "<B>" {set ende [lsearch $Liste </B>]
          set Teilliste [lrange $Liste [expr ($first+1)] [expr ($ende-1)]]
          set neudat [join $Teilliste " "]
          Einfgen $neudat
          set laenge [expr (([string length $neudat]+1)-$sondanz)]
          .f.t tag add fett "insert - $laenge chars" "insert - 1 chars"
          .f.t tag configure fett -font \
		  -Adobe-Helvetica-Bold-R-Normal-*-140-*}
       "<I>" {set ende [lsearch $Liste </I>]
          set Teilliste [lrange $Liste [expr ($first+1)] [expr ($ende-1)]]
          set neudat [join $Teilliste " "]
          Einfgen $neudat
          set laenge [expr (([string length $neudat]+1)-$sondanz)]
          .f.t tag add kursiv "insert - $laenge chars" "insert - 1 chars"
          .f.t tag configure kursiv -font \
		  -*-Medium-I-Normal-*-140-*}
       "<TT>" {set ende [lsearch $Liste </TT>]
          set Teilliste [lrange $Liste [expr ($first+1)] [expr ($ende-1)]]
          set neudat [join $Teilliste " "]
          Einfgen $neudat
          set laenge [expr (([string length $neudat]+1)-$sondanz)]
          .f.t tag add courier "insert - $laenge chars" "insert - 1 chars"
          .f.t tag configure courier -font \
                   -*-Courier-Medium-R-Normal-*-140-*}
       "<A" {
          set Ref [lindex $Liste [expr ($first+1)]]   ;# ....=" .html# ">
          set id [string range $Ref 0 3]              ;# NAME oder HREF
          set bis [string length $Ref]
          set Info [string range $Ref 6 [expr ($bis-3)]]
          if {$id=="NAME"} {
             set Marke $Info 
          } else {
             set test [string match *#* $Info]        ;# 1 falls ...#...
             if {$test==1} {                          ;# falls RefMarke existiert
               set Infos [split $Info "#"]
               set RefDatei [lindex $Infos 0]
               set RefMarke [lindex $Infos 1]
             } else {
               set RefDatei $Info
             }
          }
          set ende [lsearch $Liste </A>]
          set Teilliste [lrange $Liste [expr ($first+2)] [expr ($ende-1)]]
          set neudat [join $Teilliste " "]
          Einfgen $neudat
          set laenge [expr (([string length $neudat]+1)-$sondanz)]
          if {$id=="NAME"} {
             .f.t mark set $Marke "insert -1 chars"
          } else {
             incr i
             .f.t tag add ref($i) "insert - $laenge chars" "insert - 1 chars"
             .f.t tag configure ref($i) \
                     -font -Adobe-Helvetica-Medium-R-Normal--*-140-* \
		     -foreground maroon
             .f.t tag bind ref($i) <Enter> \
		  ".f.t tag configure ref($i) -foreground black -background maroon; .f.t config -cursor {hand2 black white}"
 	     .f.t tag bind ref($i) <Leave> \
		  ".f.t tag configure ref($i) -foreground maroon -background $Hfarbe; .f.t config -cursor gumby"

             if {$test==1} {                             ;# falls RefMarke existiert
               .f.t tag bind ref($i) <1> "Fensterinhalt $RefDatei $RefMarke"
             } else {
               .f.t tag bind ref($i) <1> "Fensterinhalt $RefDatei"
             } ;#if
          } ;#if

	 }
      } ;#switch


       ;# den bereits abgearbeiteten Teil aus der Liste entfernen
       set last [llength $Liste]            ;# La"nge der Liste
       set Liste [lrange $Liste [expr ($ende +1)] $last] 

       set first [lsearch $Liste <*]       ;# na"chstes Vorkommen von < suchen

     } ;#while

     # die eventuell noch vorhandenen Elemente der Liste ausgeben
     set neudat [join $Liste " "]
     Einfgen $neudat


     # falls Marke existiert, richtigen Ausschnitt im Fenster anzeigen
     if {$M != 0} {.f.t yview -pickplace $M}

     # nur Lesestatus des Text-Widget
     .f.t configure -state disabled -cursor gumby
     
 } ;# procend



Fensterinhalt $ArgDatei



# Anzeigen der zuvor geo"ffneten Datei
# Dementsprechende Ku"rzung der History-Liste
proc ShowLastDatei {} {

    global HistListe
    ;# Aufbau der Liste:
    ;# Datei1 Marke1 Datei2 Marke2 Datei3 Marke3 ...
    ;#   0      1      2      3      4       5       Index

    set stelle [expr ([llength $HistListe] -4)]
    set Datei [lindex $HistListe $stelle]
    set Marke [lindex $HistListe [expr ($stelle+1)]]

    # Eintrag aus History entfernen
    set HistListe [lrange $HistListe 0 [expr ($stelle-1)]]

    # Text-Fenster mit alten Datei aufrufen
    Fensterinhalt $Datei $Marke

    # 2 elements are always in (start)
    if {[llength $HistListe]<3} {
	.mbar.undo configure -state disabled
    }

}


proc Browser {} {

 global HELPPATH flag

 if {[winfo exists .w]!=1} {

   toplevel .w
   wm title .w "Browser"

   listbox .w.source -relief raised -borderwidth 2 \
                  -yscrollcommand ".w.yscroll set" \
                  -xscrollcommand ".w.xscroll set"
   scrollbar .w.yscroll -command ".w.source yview"
   scrollbar .w.xscroll -command ".w.source xview" -orient horizontal

   set srcdat [glob $HELPPATH/*.html]
   set anz [llength $srcdat]

   set i 0
   while {$i<$anz} {
     set hlpdat [file tail [lindex $srcdat $i]]
     .w.source insert end $hlpdat
     incr i
   }

   button .w.b -text Close -command {destroy .w}
   pack .w.b -side bottom -fill x

   pack .w.yscroll -side right -fill y
   pack .w.xscroll -side bottom -fill x
   pack .w.source -side left -expand true -fill both

   bind .w.source <Double-Button-1> {
      Fensterinhalt [selection get]
   }

  } else {raise .w}
}

proc end_session {save_first} {
    destroy .
}

  #*** Dateiende help.tcl ***

