// ExprInterface.cc
// Tobias Himstedt 1995
// Burkhard Bieber 1995
// last-update: 13.09.95

  //**********
  // includes
  //**********

#include "Val.h"
#include <stdio.h>

  //******************
  // Global Variables
  //******************

VT* actual_VT;
String aString;
VHSet<Val> last;

  //**********************************************************************
  // Make functions of the expression parser available for C++ via extern
  //**********************************************************************

extern "C" {

extern int expr_parse(void);

int
parse_VT(VT &a)
{
  int r;
  actual_VT = &a;
  extern FILE *expr_in;
  expr_in = tmpfile();
  fputs(a.string_term, expr_in);
  rewind(expr_in);
  r = expr_parse();
  fclose(expr_in);
  return r;
}  // parse_VT

void
new_operator(OperatorType t)
{
  actual_VT->upn_list.append(VTNode(t));
}  // new_operator

void
new_ident(char *s)
{
  actual_VT->upn_list.append(VTNode(s));
}  // new_ident

void
new_number(int a)
{
  actual_VT->upn_list.append(VTNode(a));
}  // new_number

void
new_number_dot(void)
{
  actual_VT->upn_list.append(VTNode(dot));
}  // new_number_dot

void
new_number_bool(bool tf)
{
  actual_VT->upn_list.append(VTNode(tf));
}  // new_number_bool

void
new_quantor(char *s)
{
  aString = s;
    // cout << "Neue freie Variable: " << aString << endl;
}  // new_quantor

void
new_value(int a)
{
  actual_VT->intern_set[aString].add(a);
}  // new_value

void
new_value_bool(bool tf)
{
  actual_VT->intern_set[aString].add(tf);
}  // new_value_bool

void
new_value_dot(void)
{
  actual_VT->intern_set[aString].add(dot);
}  // new_value_dot
    
void
new_values(int id1, int id2)
{
/*
  cout << "Wertebereich fuer freie Var :" << aString << " ist "
    << id1 << " bis " << id2 << endl;
*/
  for (int i = id1; i <= id2; i++)
    actual_VT->intern_set[aString].add(i);
}  // new_values

void
store_last(void)
{
  last = actual_VT->intern_set[aString];    
    // cout << "Merke mir 1. Wertebereich fur Kreuzprod fuer Var. : " 
    // << aString << endl;
    // actual_VT->intern_set[aString+"_1"] = actual_VT->intern_set[aString];
  actual_VT->intern_set.del(aString);
    // aString += "_2";
}  // store_last

void
make_cross(void)
{
    // cout << " Mache Kreuzprod fuer Var :" << aString << endl;
  VHSet<Val> a = actual_VT->intern_set[aString];
  actual_VT->intern_set.del(aString);
  for (Pix i = last.first(); i; last.next(i))
    for (Pix j = a.first(); j; a.next(j))
      actual_VT->intern_set[aString].add(Tupel(last(i), a(j)));
}  // make_cross

}  // extern "C"

  //*** Dateiende ExprInterface.cc ***

