// HLBlock.cc
// Highlevel-Blocks
// Burkhard Bieber 1995/96
// last-update: 09.04.96

  //**********
  // includes
  //**********

#include "HLBlock.h"
#include "HLNet.h"

  //**********
  // Methoden
  //**********

HLBlock::HLBlock(const Net &n, const String &t) : Block(n, t)
  // nicht viel zu tun
{
  // Nix
}  // HLBlock::HLBlock

void
HLBlock::Write(ostream &f) const
  // keine neuen Dinge im HL Bereich zu schreiben
{
  Block::Write(f);
}  // HLBlock::Write

void
HLBlock::ReadOptional(istream &f)
  // Optionale Parameter von stream f einlesen
{
  char c;

  Block::ReadOptional(f);
  f >> c;
  switch (c) {
    default:
      f.putback(c);
  }  // switch c
}  // HLBlock::ReadOptional

  // Informationen fr Tcl-Teil bereitstellen
int
HLBlock::ObjectGet(Tcl_Interp *ip, int argc, CONST char *argv[])
{
  if (argc != 1) {
    Tcl_AppendResult(ip, "wrong #args for Block get",
      NULL);
    return TCL_ERROR;
  }  // if Argumentanzahl ist Kse
  else
    return Block::ObjectGet(ip, argc, argv);
  return TCL_OK;
}  // HLBlock::ObjectGet

  // Informationen aus Tcl-Teil bernehmen
int
HLBlock::ObjectSet(Tcl_Interp *ip, int argc, CONST char *argv[])
{
  if (argc < 2) {
    Tcl_AppendResult(ip, "wrong #args for Block set",
      NULL);
    return TCL_ERROR;
  }  // if Argumentanzahl falsch

  if (argc > 0)
    return Block::ObjectSet(ip, argc, argv);
  return TCL_OK;
}  // HLBLock::ObjectSet

  //*** Dateiende HLBlock.cc ***

