// HLBlock.h
// Highlevel-Blocks fr den Netzeditor
// Burkhard Bieber 1995
// last-update: 13.09.95

#ifndef __HLBLOCK_H__
#define __HLBLOCK_H__

  //**********
  // Includes
  //**********

#include "../Low/Block.h"
#include "../Low/Net.h"

  //*********
  // Klassen
  //*********

class HLBlock : public Block {
  protected:
    virtual void Write(ostream &f) const;
    virtual void ReadOptional(istream &f);
  public:
    virtual HLBlock *asHLBlock() const;
    HLBlock(const Net &n, const String &Type="HLBlock");
    HLBlock(const HLBlock &b);
    virtual int ObjectGet(Tcl_Interp *ip, int argc, CONST char *argv[]);
    virtual int ObjectSet(Tcl_Interp *ip, int argc, CONST char *argv[]); 
};  // class HLBlock

  //*******************
  // Methoden (inline)
  //*******************

inline
HLBlock::HLBlock(const HLBlock &b) : Block(b)
{
  // Nix
}  // HLBlock::HLBlock

inline  HLBlock *
HLBlock::asHLBlock() const
{
  return (HLBlock *) this;
}  // HLBlock::asHLBlock

#endif  // #ifndef __HLBLOCK_H__

  //*** Dateiende HLBlock.h ***

