// HLBox.cc
// Highlevel-Boxs
// Burkhard Bieber 1995/96
// last-update: 09.04.96

  //**********
  // includes
  //**********

#include "HLBox.h"
#include "HLNet.h"

  //**********
  // Methoden
  //**********

HLBox::HLBox(const Net &n, const String &t) : Box(n, t)
  // nicht viel zu tun
{
  // Nix
}  // HLBox::HLBox

void
HLBox::Write(ostream &f) const
  // keine neuen Dinge im HL Bereich zu schreiben
{
  Box::Write(f);
}  // HLBox::Write

void
HLBox::ReadOptional(istream &f)
  // Optionale Parameter von stream f einlesen
{
  char c;

  Box::ReadOptional(f);
  f.get(c);
  switch (c) {
    default:
      f.putback(c);
  }  // switch c
}  // HLBox::ReadOptional

  // Informationen fr Tcl-Teil bereitstellen
int
HLBox::ObjectGet(Tcl_Interp *ip, int argc, CONST char *argv[])
{
  if (argc != 1) {
    Tcl_AppendResult(ip, "wrong #args for Box get",
      NULL);
    return TCL_ERROR;
  }  // if Argumentanzahl ist Kse
  else
    return Box::ObjectGet(ip, argc, argv);
  return TCL_OK;
}  // HLBox::ObjectGet

  // Informationen aus Tcl-Teil bernehmen
int
HLBox::ObjectSet(Tcl_Interp *ip, int argc, CONST char *argv[])
{
  if (argc < 2) {
    Tcl_AppendResult(ip, "wrong #args for Box set",
      NULL);
    return TCL_ERROR;
  }  // if Argumentanzahl falsch

  if (argc > 0)
    return Box::ObjectSet(ip, argc, argv);
  return TCL_OK;
}  // HLBLock::ObjectSet

  //*** Dateiende HLBox.cc ***

