// HLPTransition.h
// Tobias Himstedt 1995
// Burkhard Bieber 1995/96
// last-update: 12.01.96

#ifndef __HLPTRANSITION_H__
#define __HLPTRANSITION_H__

  //**********
  // includes
  //**********

#include "Val.h"
#include "../Low/PTransition.h"

  //*********
  // Klassen
  //*********

class HLPTransition : public PTransition {
  protected:
    String action_terms;
    VT value_term;
    int rx_at, ry_at;
    int rx_vt, ry_vt;
    virtual void ReadOptional(istream &f);
    virtual void Write(ostream &f) const;
  public:
      // Kann diese Transition schalten
      // virtual int CanFire(void) const;
    void ChangeValueTerm(const String &new_vt);
    void ChangeActionTerms(const String &new_at);
    virtual HLPTransition *asHLPTransition() const;
    const String &ActionTerms(void) const;
    const VT &ValueTerm(void) const;
    Val EvaluateVT(Binding &b);
    const HLPTransition &operator =(const HLPTransition &t);
    HLPTransition(const Net &n, const String &Type = "HLPTransition");
    int ObjectGet(Tcl_Interp *ip, int argc, CONST char *argv[]);
    int ObjectSet(Tcl_Interp *ip, int argc, CONST char *argv[]);
};  // class HLPTransition

inline const HLPTransition &
HLPTransition::operator =(const HLPTransition &t)
{
  if (Name() == t.Name())
    return *this;
  PTransition::operator =(t);
  action_terms = t.action_terms;
  value_term = t.value_term;
  rx_at = t.rx_at;
  ry_at = t.ry_at;
  rx_vt = t.rx_vt;
  rx_vt = t.ry_vt;
  return *this;
}

inline const String &
HLPTransition::ActionTerms(void) const
{
  return action_terms;
}  // HLPTransition::ActionTerms

inline void
HLPTransition::ChangeActionTerms(const String &at)
{
  action_terms = at;
}  // HLPTransition::ChangeActionTerms

inline void
HLPTransition::ChangeValueTerm(const String &vt)
{
  value_term.ChangeTerm(vt);
}  // HLPTransition::ChangeValueTerm

inline const VT &
HLPTransition::ValueTerm(void) const
{
  return value_term;
}  // HLPTransition::ValueTerm

inline Val
HLPTransition::EvaluateVT(Binding &b)
{
  return value_term.Evaluate(b);
}  // HLPTransition::EvaluateVT

#endif  // #ifndef __HLPTRANSITION_H__

  //*** Dateiende HLPTransition.h ***

