/******************************************************************************/
/* FILE scanner.l                                                             */
/*                                                                            */
/* FLEX source file: scanner for b(pn)^2                                      */
/*                                                                            */
/* winter 1996/97 by Martin Ackermann                                         */
/******************************************************************************/

%option nounput
%option noyywrap

%{
#include <string.h>
#ifdef _AIX
#include <strings.h>
#endif
#include <unistd.h>
#include <ctype.h>

#include "decls.h"
#include "../../frontend/tree.h"

int exprlineno = 1;
int exprcoluno = 1;

char *Reserved[6]={"not", "and", "or", "true", "false", "_max_"};

int  _Reserved[6]={NOT, AND, OR, TRUE, FALSE, MAX};

/* Makes the distinction between normal identifiers and identifiers for 
   constants */
int exprident( void ) {
  s_lookup(exprtext,&(exprlval.ident));
  if ( exprlval.ident.sym->s_type == MNET_CONST ) {
    exprlval.ident.sym->s_special |= ( _G_RW | _G_PRUPR );
    /* zeigt Verwendung des const-Bezeichners an */
    exprlval.wert = exprlval.ident.sym->s_init_or_cap;
    return CONST_IDENT;
  } else {
    exprlval.ident.ref.start_l = exprlineno;
    exprlval.ident.ref.start_c = exprcoluno;
    exprlval.ident.ref.end_l   = exprlineno;
    exprlval.ident.ref.end_c   = exprcoluno + exprleng;
    return IDENT;
  }
}

%}

delim     [ \t]
ws        ({delim}|\n)*
digit     [0-9]
letter    [A-Za-z_]
ident     {letter}({letter}|{digit})*
number    [1-9]{digit}*|0

%%
"~"		{ return TILDE; }

"@"		{ return AT; }

"|"             { return OR; }

"&"             { return AND; }

"<="            { return LE; }

">="            { return GE; }

"??"            { return EMPTY_; }

"!!"            { return FULL; }

"%"             { return MOD; }

{number}        { int py; 
                  sscanf(exprtext,"%d",&py); 
                  if (py > MAX_POS)
                    Msg( FAT, "Constant out of range !" );
                  exprlval.wert = py;
                  return NUMBER;
                }

_?[A-Z]+_?      |
_?[a-z]+_?      { int i;
                  for (i=0; i<sizeof(Reserved)/sizeof(*Reserved); i++)
                    if (!strcasecmp(exprtext,Reserved[i]))
                      return _Reserved[i];
                  return exprident();
                }

{ident}         { return exprident(); }

[-=#+*/:,.(!?';<>] { return exprtext[0]; }
 
%%
