// NetFileOrder.cc
// Fr die Behandlung der Reihenfolge innerhalb der Netzdatei.
// Burkhard Bieber 1996
// last-update: 11.01.96

  //**********
  // includes
  //**********

#include "../include/String.h"
#include "NetFileOrder.h"

  //**********
  // Methoden
  //**********

NetFileOrder::NetFileOrder(const String &sn, const String &ln,
  int of, int s, int e, int l) :
  shortname(""), longname(""),
  option_flag(of),
  section_num(s), earliest_num(e), latest_num(l),
  used_flag(0)
  // Konstruktur, leider so realisiert, da die Strings kopiert werden mssen.
{
  shortname = sn;
  longname = ln;
}  // NetFileOrder::NetFileOrder

void
NetFileOrder::Write(ostream &s) const
{
  s << shortname << "," << longname
    << " (" << section_num << "," << earliest_num << "," << latest_num << ")"
    << (option_flag ? " (optional)" : "")
    << (used_flag ? " (used)" : " (not used)");
}  // NetFileOrder::Write

  // Freundschaftliche Operatoren
ostream &
operator <<(ostream &s, const NetFileOrder &nfo)
{
  nfo.Write(s);
  return s;
}  // Operator <<

  //*** Dateiende NetFileOrder.cc ***

