// NetFileOrder.h
// Include-Datei fr die Behandlung der Reihenfolge innerhalb der Netzdatei.
// Burkhard Bieber 1996
// last-update: 11.01.96

#ifndef __NETFILEORDER_H__
#define __NETFILEORDER_H__

  //*********
  // Klassen
  //*********

class NetFileOrder {
  private:
      // Datenelemente
    String shortname,  // Krzel
      longname;        // der volle Name des Abschnittes in der Datei
    int option_flag;   // Ist dieser Teil optional?
    int section_num,   // Sequenznummer in der Datei ab 0
      earliest_num,    // Sequenznummer des frhesten Auftauchens oder -1
      latest_num;      // Sequenznummer des sptesten Auftauchens oder -1
    int used_flag;     // wird whrend eines Lesedurchlaufes benutzt
  public:
      // Freunde und Verwandte
    friend ostream &operator <<(ostream &s, const NetFileOrder &nfo);
      // Ausgabe eines Teils
    void Write(ostream &s) const;
      // Lesezugriffe auf das Objekt
    const String &ShortName(void) {return shortname;}
    const String &LongName(void) {return longname;}
    int OptionFlag(void) {return option_flag;}
    int SectionNum(void) {return section_num;}
    int EarliestNum(void) {return earliest_num;}
    int LatestNum(void) {return latest_num;}
    int UsedFlag(void) {return used_flag;}
      // Schreibzugriffe auf das Objekt
    void SetUsedFlag(void) {used_flag = 1;}
    void ResetUsedFlag(void) {used_flag = 0;}
      // Konstruktor
    NetFileOrder(const String &sn, const String &ln, int of,
      int s, int e, int l);
};  // class NetFileOrder

#endif  // #ifndef __NETFILEORDER_H__

  //*** Dateiende NetFileOrder.h ***

