// NetObject.cc
// Tobias Himstedt 1995
// Burkhard Bieber 1995/96
// Christian Stehno: changed ip->result to use strdup
// last-update: 30.05.2000

  //**********
  // includes
  //**********

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <cstring>
#include "NetObject.h"

  //*********************************
  // Stream-Operatoren fr NetObject
  //*********************************

ostream &
operator <<(ostream &f, const NetObject &t)
{
  t.Write(f);
  return f << endl;
}  // operator <<

istream &
operator >>(istream &f, NetObject &t)
{
  t.ReadStandard(f);
  int c = f.peek();
  while (c != EOF) {
    if (c == '%') {
      String rest;
      readline(f, rest, EOF);
      break;
    }  // if c == '%'
    f >> ws;
    t.ReadOptional(f);
    c = f.peek();
  }  // while nicht Eingabeende
  return f;
}  // operator >>

  //************************
  // Methoden fr NetObject
  //************************

void 
NetObject::Write(ostream &f) const
{
  if (visibility != 1)
    f << 'v' << visibility;
}  // NetObject::Write

void
NetObject::ReadOptional(istream &f)
{
  char c;

  f.get(c);
  if (c == 'v') 
    f >> visibility;
  else 
    f.putback(c);
}  // NetObject::ReadOptional

int
NetObject::ObjectCommand(Tcl_Interp *ip, int argc, CONST char *argv[])
  // TCL-Schnittstelle
{
  if (!strcmp(argv[0], "get"))
    return ObjectGet(ip, argc-1, &argv[1]);

  else if (!strcmp(argv[0], "set"))
    return ObjectSet(ip, argc-1, &argv[1]);

  else {
    Tcl_AppendResult(ip, "wrong args for NetObject: must be get/set option",
      NULL);
    return TCL_ERROR;
  }  // else, unbekanntes Kommando
}  // NetObject::ObjectCommand

int
NetObject::ObjectSet(Tcl_Interp *ip, int argc, CONST char *argv[])
  // TCL-Schnittstelle
{
  if (argc == 0)
    return TCL_OK;  // Wichtig fr hhere Abfragen!

  if (argc < 2) {
    Tcl_AppendResult(ip, "wrong #args for NetObject set",
      NULL);
    return TCL_ERROR;
  }  // if falsche Argumentanzahl fr set

  char *bs = NULL;
  int c = visibility;
  Tk_ArgvInfo parse_table[] = {
    {"BlockVis", TK_ARGV_STRING, NULL, (char *) &bs,
     "Block visiblity state"},
    {"Visibility", TK_ARGV_INT, NULL, (char *) &c,
     "Visibility"},
    {NULL, TK_ARGV_END, NULL, NULL, NULL}};
  if (Tk_ParseArgv(ip, NULL, &argc, argv, parse_table,
    TK_ARGV_DONT_SKIP_FIRST_ARG) != TCL_OK)
    return TCL_ERROR;
  visibility = c;

  if (bs) {
    if (!strcmp(bs, "exposed"))
      SetBlockVis(EXPOSED);
    else if (!strcmp(bs, "hidden"))
      SetBlockVis(HIDDEN);
    else if(!strcmp(bs, "exposed_contents"))
      SetBlockVis(EXPOSED_CONTENTS);
    else  // Spter: evtl. noch eine Meldung
      return TCL_ERROR;
  }  // if neue Status
  return TCL_OK;
}  // NetObject::ObjectSet

int
NetObject::ObjectGet(Tcl_Interp *ip, int argc, CONST char *argv[])
  // TCL-Schnittstelle
{
  if (argc != 1) {
    Tcl_AppendResult(ip, "wrong #args for NetObject get",
      NULL);
    return TCL_ERROR;
  }  // if falsche Argumentanzahl fr get

  if (EQ(0, "Visibility"))
    INTRES(visibility);

  else if (EQ(0, "BlockVis"))
    ip->result = strdup((block_vis == EXPOSED) ? "exposed" :
      (block_vis == HIDDEN) ? "hidden" : "exposed_contents");

  else {
    Tcl_AppendResult(ip, "unknown option(s) for NetObject get",
      NULL);
    return TCL_ERROR;
  }  // if unbekannte get-Option
  return TCL_OK;
}  // NetObject::ObjectGet

  //*** Dateiende NetObject.cc ***

