// ExprInterface.cc
// Tobias Himstedt 1995
// Burkhard Bieber 1995
// last-update: 13.09.95

  //**********
  // includes
  //**********

#include "val.h"
#include <stdio.h>

  //******************
  // Global Variables
  //******************

VT* actual_VT;
string aString;
set<val, less<val> > last;

  //**********************************************************************
  // Make functions of the expression parser available for C++ via extern
  //**********************************************************************

extern "C" {

extern int expr_parse(void);

int
parse_VT(VT &a)
{
  int r;
  actual_VT = &a;
  extern FILE *expr_in;
  expr_in = tmpfile();
  fputs(a.string_term.c_str(), expr_in);
  rewind(expr_in);
  r = expr_parse();
  fclose(expr_in);
  return r;
}  // parse_VT

void
new_operator(OperatorType t)
{
  actual_VT->upn_list.push_back(VTNode(t));
}  // new_operator

void
new_ident(char *s)
{
  actual_VT->upn_list.push_back(VTNode(s));
}  // new_ident

void
new_number(int a)
{
  actual_VT->upn_list.push_back(VTNode(a));
}  // new_number

void
new_number_dot(void)
{
  actual_VT->upn_list.push_back(VTNode(dot));
}  // new_number_dot

void
new_number_bool(bool tf)
{
  actual_VT->upn_list.push_back(VTNode(tf));
}  // new_number_bool

void
new_quantor(char *s)
{
  aString = s;
    // cout << "New free variable: " << aString << endl;
}  // new_quantor

void
new_value(int a)
{
  actual_VT->intern_set[aString].insert(val(a));
}  // new_value

void
new_value_bool(bool tf)
{
  actual_VT->intern_set[aString].insert(val(tf));
}  // new_value_bool

void
new_value_dot(void)
{
  actual_VT->intern_set[aString].insert(val(dot));
}  // new_value_dot
    
void
new_values(int id1, int id2)
{
/*
  cout << "Value range for free Var :" << aString << " is "
    << id1 << " to " << id2 << endl;
*/
  for (int i = id1; i <= id2; i++)
    actual_VT->intern_set[aString].insert(val(i));
}  // new_values

void
store_last(void)
{
  last = actual_VT->intern_set[aString];    
    // cout << "Storing 1. value range for crossprod of Var. : " 
    // << aString << endl;
    // actual_VT->intern_set[aString+"_1"] = actual_VT->intern_set[aString];
  actual_VT->intern_set.erase(actual_VT->intern_set.find(aString));
    // aString += "_2";
}  // store_last

void
make_cross(void)
{
    // cout << " Computing crossprod of Var :" << aString << endl;
  set<val, less<val> > a = actual_VT->intern_set[aString];
  actual_VT->intern_set.erase(actual_VT->intern_set.find(aString));
  set<val, less<val> >::iterator i, j;
  for (i = last.begin(); i != last.end(); ++i)
    for (j = a.begin(); j != a.end(); ++j)
      actual_VT->intern_set[aString].insert(val(Tupel((*i), (*j))));
}  // make_cross

}  // extern "C"

  //*** end of file ExprInterface.cc ***

