%option noyywrap
%option nounput
%{
#ifdef __cplusplus
extern "C" {
#endif
#include <string.h>
#ifdef __cplusplus
}
#endif
%}

delim	[ \t\n]
ws	{delim}+
digit	[0-9]
letter	[A-Za-z'_!?@]
ident 	{letter}({letter}|{digit})*
number  {digit}+

%%
dot		{ return BLACK_TOKEN; }
tt              { return BOOL_TRUE; }
ff              { return BOOL_FALSE; }
X               { return CROSS; }
pr0             { return PROJ0; }
pr1             { return PROJ1; }
".."            { return PP; }
","             { return KOM; }
"!"             { return LNOT; }
"|"             { return LOR;}
"&"		{ return LAND; }
"->"            { return LIMP; }
"="             { return EQUAL; }
"#"		{ return NOTEQ; }
"<="		{ return LEQ; }
">="		{ return GEQ; }
"<"		{ return LESS; }
">"		{ return GREATER; }
"+"		{ return PLUS; }
"-"		{ return MINUS; }
"*"		{ return TIMES; }
"/"		{ return DIVIDE; }
"("		{ return BRACE_OPEN; }
")"		{ return BRACE_CLOSE; }
"{"		{ return BRACE_OPEN1; }
"}"		{ return BRACE_CLOSE1; }
"["		{ return BRACE_OPEN2; }
"]"		{ return BRACE_CLOSE2; }
":"             { return DP; }
"%"             { return MODULO; }
{number}	{ int *py = (int *)malloc(sizeof(int)); 
	          sscanf(yytext,"%d",py); 
                  yylval = (void *)py;
		  return NUMBER;} 
{ident}		{ yylval = (void *)strdup(yytext); 
                  return IDENT;}
{ws}		{ /* Nix */ }
 
%%

