
#include "ServerSocket.h"
#include <sys/time.h>
#include <sys/types.h>
#include <iostream.h>
#include <strings.h>


ServerSocket::ServerSocket(int port) {
  if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
    cerr << "server: can't open stream socket" << endl;
  memset(&serv_addr, '\0', sizeof(serv_addr));
  serv_addr.sin_family      = AF_INET;
  serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  serv_addr.sin_port        = htons(port);

  if(bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0)
    cerr << "server: can't bind local address" << endl;
  
  listen(sockfd, 5);
} // ServerSocket::ServerSocket

int
ServerSocket::akzept() {
  clilen = sizeof(cli_addr);
  return (accept(sockfd, (struct sockaddr *)&cli_addr, &clilen));
} // ServerSocket::akzept

ServerSocket::~ServerSocket() {
  if(sockfd)
    close(sockfd);
} // ServerSocket::~ServerSocket

void
ServerSocket::schliesse() {
  close(sockfd);
} // ServerSocket::schliesse

int
ServerSocket::schreibe(int fd, string text) {
  int nbytes = text.length();
  char header[2];
  header[0] = (unsigned char)(nbytes / 256);
  header[1] = (unsigned char)(nbytes - int(nbytes / 256) * 256);
  const char *zeichen = text.c_str();

  write(fd, header, 2);
  return write(fd, zeichen, nbytes);
} // ServerSocket::schreibe

string
ServerSocket::lese(int fd) {
  char header[2];
  read(fd, header, 2);
  int nbytes = (unsigned char)header[0] * 256 + (unsigned char)header[1];

  char ptr[nbytes];
  memset(&ptr, '\0', nbytes);
  int nread1 = 0, nread2 = 0;
  while(nbytes - nread1 > 0) {
    nread2 = read(fd, ptr + nread1, nbytes - nread1);
    if(nread1 < 0) {
      delete [] ptr;
      return "";
    }
    nread1 += nread2;
  }

  string ret = ptr;
  return ret.substr(0, nbytes);
} // ServerSocket::lese


