/************************************************************
 * Stack.h
 *  - sicherere Stack-Klasse
 ************************************************************/
#ifndef STACK
#define STACK

#include <deque>

template <class T>
class Stack {
  protected:
    deque<T> c;        // Container fuer die Elemente

  public:  
    // Anzahl der Elemente
    deque<T>::size_type size() const {
        return c.size();
    }

    // leer ?
    bool empty() const {
        return c.empty();
    }

    // Zugriff auf oberstes Element
    T& top () {
        if (c.empty()) {
            cerr << "Stack empty" << endl;
        }
        return c.back();
    }

    // Element einkellern
    void push (const T& elem) {
        c.push_back(elem);
    }

    // Element auskellern
    T pop () {
        if (c.empty()) {
            cerr << "Stack empty" << endl;
        }
        T elem(c.back());
        c.pop_back();
        return elem;
    }

    void clear() {
      c.erase(c.begin(), c.end());
    }

    ~Stack() {
    }
};

#endif /* STACK */
