#include "edge.h"
#include "net.h"

int edge::edge_counter = 0;

edge::edge() {
}

edge::edge(net *n, istrstream &os) {
  char c;
  int from,to;
  string temp;

  Net = n;
  os >> from >> c >>to;

  if(c == '<') {
    typ = 1;
    From = Net->GetTransitionFromId(from);
    To   = Net->GetPlaceFromId(to);
  } else {
    typ = 0;
    From = Net->GetPlaceFromId(from);
    To   = Net->GetTransitionFromId(to);
  }
  if(From == "" || To == "") {
    if(From == "") {
      cerr << "Vertex with Id " << from << " doesn't exist." << endl;
    } else {
      cerr << "Vertex with Id " << to   << " doesn't exist." << endl;
    }
    return;
  }
  c = os.peek();
  while(c != '\n') {
    os.get(c);
    temp = "";
    switch(c) {
      case 'q':
      case 'J': {
                  os >> from >> c >> to;
                  break;
                }
      case 'p': {
                  os >> c;
                  os >> c;
                  while(c != '"') {
                    temp += c;
                    os.get(c);
                  }
                  ChangeVars(temp);
                  break;
                }
      case 'v': {
                  os >> from;
                  break;
                }
    }
    c = os.peek();
  }
  id = edge_counter++;
  char buffer[30];
  sprintf(buffer, "%ld", (long int)id);
  name = "A" + string(buffer);
}

edge::edge(net *n, string& from, string &to) : From(from), To(to), Net(n)
  // Konstruktor f"ur eine Kante von from nach to
{
  id = edge_counter++;
  char buffer[30];
  sprintf(buffer, "%ld", (long int)id);
  name = "A" + string(buffer);
}


void
edge::ChangeVars(const string &new_vars) {
  vars.erase(vars.begin(), vars.end());
  int co = 0;
  int weight = 0;
  unsigned int i;
  string temp;
  char *s = new char[255];
  strcpy(s, new_vars.c_str());
  
  string together = "";
  s = strtok(s,",");
  while (s) {
    string t(s);
    if(t.at(0) == '(') {
      if(together == "") {
        i = t.find("(");
        t = t.substr(i+1, 1000);
        together += "(";
        together += t;
      }
      else {
        together += ",";
        together += t;
      }
      co++;
    }
    else {
      if(t[t.length()-1] == ')') {
        together += ",";
        together += t;
        co++;
        dimension = co;
        Tupel tupel = StringToTupel(together);
        vars.insert(multiset<val, less<val> >::value_type(val(tupel)));
        weight++;
        together = "";
      }
      else {
        if(together != "") {
          together += ",";
          together += t;
          co++;
        }
        else {
          temp = s;
          while(temp.find(" ") != string::npos)
            temp.serase(temp.find(" "),1);
          // temp.setType(temp.digit());
          if(temp.find(",") != string::npos) {
            Tupel tupel = StringToTupel(temp);
            vars.insert(multiset<val, less<val> >::value_type(tupel));
          } else
            vars.insert(multiset<val, less<val> >::value_type(StringToVal(temp)));
          weight++;
          dimension = 1;
        }
      }
    }
    s = strtok(NULL, ",");
  }  // while noch etwas von s zu bearbeiten
  SetWeight(weight);
}  // edge::ChangeVars


void
edge::ChangeSrc(string &neu)
{
  From = neu;
}  // edge::ChangeSrc

void
edge::ChangeDest(string &neu)
{
  To = neu;
}  // edge::ChangeDest






