#ifndef EDGE
#define EDGE

#include <strstream>
#include <string>
#include <stdio.h>
#include "vertex.h"
#include "val.h"

class net;

class edge {
  protected:
    static int edge_counter;
    long int id;
    string name;
    string From, To;
    net *Net;
    int typ;
    int dimension;
    int weight;
    multiset<val, less<val> > vars;

  public:
    edge();
    ~edge() {};
    edge(net *n, istrstream &os);
    edge(net *n, string &from, string &to);

    string Name(void) {return name;};
    void SetWeight(int& i) {weight = i;};
    void ChangeVars(const string& new_vars);
    void ChangeSrc(string &neu);
    void ChangeDest(string &neu);
    string Src(void) {return From;};
    string Dest(void) {return To;};
    multiset<val, less<val> > Vars(void) {return vars;};
};

#endif
