#ifndef NET
#define NET

using namespace std;

#include <string>
#include <strstream>
#include <map>
#include <iostream.h>
#include "transition.h"
#include "place.h"
#include "edge.h"

#if defined (__GNUC__) && __GNUC__ <= 2 && __GNUC_MINOR__ < 8
#define serase remove
#else
#define serase erase
#endif

typedef map<string,transition,less<string> > StringTransMap;
typedef map<string,place,less<string> >      StringPlaceMap;
typedef map<string,edge,less<string> >       StringEdgeMap;
typedef multimap<string, val, less<string> > binding;

extern string BINDUNG;

class net {
  protected:
    StringTransMap Transitions;
    StringPlaceMap Places;
    StringEdgeMap  Edges;
    Binding BelegteVars;
    Binding bind;
    string  BelegteString;
    set<string, less<string> > bindungen;
    set<binding, less<binding> > bindungen2;

    void possible(multiset<val, less<val> > &t_vars,
                  multiset<val, less<val> > &t_marking,
                  string bindung);
    void ParseAsignment(const string &asignment_string);
    int CheckBinding(transition &t);

  public:
    net(istrstream &os);
    net(void) {};
    void read(istrstream &os);
    int ReadHeader(istrstream &os);
    void EatComment(istrstream &os);
    string GetTransitionFromId(int id);
    string GetPlaceFromId(int id);
    int IsActive(string &tr);
    void RenameTransition(string &old, string &neu);
    void RenamePlace(string &old, string &neu);
    void ChangeValueTerm(string &t, string &vt);
    void ChangeTyp(string &p, string &typ);
    void ChangeMarking(string &p, string &mark);
    void ChangeVars(string &b1, string &b2, string &vars);
    void NewPlace(string &p);
    void NewTransition(string &t);
    void NewEdge(string &from, string &to);
    void DeleteTransition(string &t);
    void DeletePlace(string &p);
    void DeleteEdge(string &from, string &to);
    set<string, less<string> > InputEdges(string &t);
    set<string, less<string> > OutputEdges(string &t);
    void PreAnalyse(transition *actual_trans);
    void InAnalyse(transition *actual_trans);
    set<string, less<string> > SearchBinding(const transition &tra);
    void FireTransition(string &t_name, string &bind_string);
    void FireWithout(string &t_name);
    string Marking(void);
    string ActiveTransitions(void);
};

#endif
