#include "ServerSocket.h"
#include <signal.h>
#include "net.h"
#include <sys/time.h>
#include <unistd.h>

int
SubtractTimevals2(timeval *result, timeval *x, timeval *y)
{
  if(x->tv_usec < y->tv_usec) {
    int nsec = (y->tv_usec - x->tv_usec) / 1000000 + 1;
    y->tv_usec -= 1000000 * nsec;
    y->tv_sec += nsec;
  }
  if(x->tv_usec - y->tv_usec > 1000000) {
    int nsec = (y->tv_usec - x->tv_usec) / 1000000;
    y->tv_usec += 1000000 * nsec;
    y->tv_sec -= nsec;
  }
  result->tv_sec = x->tv_sec - y->tv_sec;
  result->tv_usec = x->tv_usec - y->tv_usec;

  return x->tv_sec < y->tv_sec;
}

int
main(int argc, char *argv[])
{
  int newsockfd, childpid;
  net *Netz = (net *)NULL;

  ServerSocket s(8123);

  //    VT vt("e + 1");
  //    Binding b;
  //    b.insert(multimap<string, val, less<string> >::value_type("d", 1));
  //    cerr << vt.Evaluate(b).asString() << endl;

  for(;;) {
    newsockfd = s.akzept();

    if(newsockfd < 0)
      cerr << "server: accept error" << flush;
    signal(SIGCLD, SIG_IGN);
    if((childpid = fork()) < 0)
      cerr << "server: fork error" << flush;
    else if(childpid == 0) {
      s.schliesse();
      string str, bind, b1, b2;
      while(1) {
        str = s.lese(newsockfd);
        if(str == "Load") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          s.schreibe(newsockfd, "OK");
          istrstream os(str.c_str());
          Netz = new net(os);
        }
        else if(str == "Close") {
          close(newsockfd);
          break;
        }
        else if(str == "IsActive") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          if(Netz != (net *) NULL) {
            if(Netz->IsActive(str)) {
              s.schreibe(newsockfd, "Yes");
              str = s.lese(newsockfd);
              s.schreibe(newsockfd, BINDUNG);
            } else
              s.schreibe(newsockfd, "No");
          }
        }
        else if(str == "Fire") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          s.schreibe(newsockfd, "OK");
          bind = s.lese(newsockfd);
          if(Netz != (net *) NULL) {
            Netz->FireTransition(str, bind);
          }
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "FireWithout") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          if(Netz != (net *) NULL)
            Netz->FireWithout(str);
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "Marking") {
          if(Netz != (net *) NULL)
            str = Netz->Marking();
          s.schreibe(newsockfd, str);
        }
        else if(str == "ActiveTransitions") {
          if(Netz != (net *) NULL)
            str = Netz->ActiveTransitions();
          s.schreibe(newsockfd, str);
        } 
        else if(str == "RenameTransition") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          s.schreibe(newsockfd, "OK");
          bind = s.lese(newsockfd);
          if(Netz != (net *)NULL)
            Netz->RenameTransition(str, bind);
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "RenamePlace") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          s.schreibe(newsockfd, "OK");
          bind = s.lese(newsockfd);
          if(Netz != (net *)NULL)
            Netz->RenamePlace(str, bind);
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "ValueTerm") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          s.schreibe(newsockfd, "OK");
          bind = s.lese(newsockfd);
          if(Netz != (net *)NULL)
            Netz->ChangeValueTerm(str, bind);
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "Typ") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          s.schreibe(newsockfd, "OK");
          bind = s.lese(newsockfd);
          if(Netz != (net *)NULL)
            Netz->ChangeTyp(str, bind);
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "Marking") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          s.schreibe(newsockfd, "OK");
          bind = s.lese(newsockfd);
          if(bind == "leer") {
            string bi("");
            if(Netz != (net *)NULL)
              Netz->ChangeMarking(str,bi);
          } else {
            if(Netz != (net *)NULL)
              Netz->ChangeMarking(str, bind);
          }
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "ChangeVars") {
          s.schreibe(newsockfd, "OK");
          b1 = s.lese(newsockfd);
          s.schreibe(newsockfd, "OK");
          b2 = s.lese(newsockfd);
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          if(Netz != (net *)NULL)
            Netz->ChangeVars(b1,b2,str);
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "NewTransition") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          if(Netz == (net *)NULL)
            Netz = new net();
          Netz->NewTransition(str);
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "NewPlace") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          if(Netz == (net *)NULL)
            Netz = new net();
          Netz->NewPlace(str);
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "NewEdge") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          s.schreibe(newsockfd, "OK");
          bind = s.lese(newsockfd);
          if(Netz != (net *)NULL)
            Netz->NewEdge(str, bind);
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "DeleteTransition") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          if(Netz != (net *)NULL)
            Netz->DeleteTransition(str);
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "DeletePlace") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          if(Netz != (net *)NULL)
            Netz->DeletePlace(str);
          s.schreibe(newsockfd, "OK");
        }
        else if(str == "DeleteEdge") {
          s.schreibe(newsockfd, "OK");
          str = s.lese(newsockfd);
          s.schreibe(newsockfd, "OK");
          bind = s.lese(newsockfd);
          if(Netz != (net *)NULL)
            Netz->DeleteEdge(str, bind);
          s.schreibe(newsockfd, "OK");
        }
      }
      exit(0);
    }
    close(newsockfd);
  }
  exit(0);
}
