#include "place.h"

int place::place_counter = 0;

place::place() {
}  // place::place

place::place(string n)
  // Konstruktor f"ur einen bestimmten Namen
{
  name = n;
} // place::place

place::place(istrstream &os) {
  char c;
  int x,y;
  string temp;

  read(os);
  c = os.peek();
  while(c != '\n') {
    os.get(c);
    temp = "";
    switch(c) {
      case 'n':
      case 'a':
      case 'B':
                os >> x >> c >> y;
                break;
      case 'b':
      case 'z':
      case 'R':
      case 'u': {
                  os >> c;
                  os >> c;
                  while(c != '"') {
                    temp += c;
                    os.get(c);
                  }
                  break;
                }
      case 'y': {
                  os >> c;
                  os >> c;
                  while(c != '"') {
                    temp += c;
                    os.get(c);
                  }
                  StringToMultiSet(temp, marking);
                  break;
                }
      case 'Z': {
                  os >> c;
                  os >> c;
                  while(c != '"') {
                    temp += c;
                    os.get(c);
                  }
                  StringToType(temp);
                  break;
                }
      case 'e':
      case 'x':
                break;
    }
    c = os.peek();
  }
}

inline const string &
place::PreFix() const
{
  return PlacePrefix;
}  // place::PreFix

inline void
place::SetMaxId(int nr)
{
  place_counter = (nr>place_counter) ? nr+1 : place_counter;
}  // place::SetMaxId

void
place::SubtractMarking(multiset<val, less<val> > &smark)
  // Marking verkleinern
{
  for(multiset<val, less<val> >::iterator i = smark.begin(); i != smark.end(); ++i) {
    multiset<val, less<val> >::iterator j = marking.find((*i));
    if(j != marking.end())
      marking.erase(j);
  }
}  // place::SubtractMarking

void
place::AddMarking(multiset<val, less<val> > &smark)
  // Marking vergr"o"sern
{
  for(multiset<val, less<val> >::iterator i = smark.begin(); i != smark.end(); ++i) {
    marking.insert((*i));
  }
}  // place::AddMarking

string
place::Markierung(void) {
  string Marking = "";
  for(multiset<val, less<val> >::iterator i = marking.begin(); i != marking.end(); ++i) {
    if(Marking == "")
      Marking = (*i).asString();
    else
      Marking += "," + (*i).asString();
  }
  return Marking;
}

void
place::StringToType(string s) {
  type.erase(type.begin(), type.end());
  while(s.find(" ") != string::npos)
    s.serase(s.find(" "), 1);
  unsigned int co = s.find("X");
  if (co != string::npos) {
    string sv = s.substr(0,co);
    type_string = s;
    set<val, less<val> > s1, s2, temp;
    StringToSet(sv, s1);
    co = s.find("X");
    string av;
    if(co != string::npos)
      av = s.substr(co+1,1000);
    else
      av = "";
    for(set<val, less<val> >::iterator i = s1.begin(); i != s1.end(); ++i) {
      string te = s;
      int help = 0;
      while(te != "") {
        help++;
        co = te.find("X");
        if(co == string::npos)
          break;
        te = te.substr(co+1,1000);
      }
      Tupel temp(help);
      temp.add((*i));
      add(temp,av);
    }
  }  // if
  else {
    if (s.find("{") != string::npos) 
      type_string = s;
    else
      type_string = "{" + s + "}";
    StringToSet(s, type);
  }  // else
}  // place::StringToType


void
place::add(Tupel &va, string s)
 // rekursive Methode, um alle Elemente der n-dimensionalen Menge zu bilden
{
  Tupel temp = va;
  
  string sv;
  unsigned int co = s.find("X");
  set<val, less<val> > s1;
  if(co != string::npos) {
    sv = s.substr(0,co);
    StringToSet(sv, s1);
    co = s.find("X");
    string av = s.substr(co+1,1000);
    for(set<val, less<val> >::iterator i = s1.begin(); i != s1.end(); ++i) {
      Tupel temp2(temp);
      temp2.add((*i));
      add(temp2,av);
    }
  }
  else {
    StringToSet(s, s1);
    for(set<val, less<val> >::iterator j = s1.begin(); j != s1.end(); ++j) {
      Tupel temp2(temp);
      temp2.add((*j));
      type.insert(val(temp2));
    } // for j "uber alle Elemente der letzten Menge
  }  // else
}  // HLPlace::add


void
place::StringToSet(string s, set<val, less<val> > &set)
  // Konvertiert String nach Set
{
  set.erase(set.begin(), set.end());
  if(s == "")
    return;
  while(s.find("{") != string::npos)
    s = s.serase(s.find("{"),1);
  while(s.find("}") != string::npos)
    s = s.serase(s.find("}"),1);
  while(s.find(" ") != string::npos)
    s = s.serase(s.find(" "),1);
  unsigned int co = s.find(",");
  string sv;
  if(co != string::npos)
    sv = s.substr(0,co);
  while (sv != "") {
    StringRangeAppendSet(sv, set);
    co = s.find(",");
    if(co != string::npos) {
      s = s.substr(co+1,1000);
      sv = s.substr(0,co);
    } else 
      sv = "";
  }  // while
  StringRangeAppendSet(s, set);
}  // place::StringToSet


void
place::StringRangeAppendSet(string range, set<val, less<val> > &set) const
  // Fgt an die Menge set einen Wert an, der aus dem String range
  // geewonnen wird. range kann aber auch eine Bereich start..ende sein
  // In diesem Fall werden alle Werte von start bis end zur Menge
  // zugefgt.
{
  unsigned int co = range.find("..");
  string lower = range.substr(0,co);
  if (co != string::npos) {
    val anfang = StringToVal(lower);
    string upper = range.substr(co+2,1000);
    val ende = StringToVal(upper);
    if (anfang.Type() != INTEGER || ende.Type() != INTEGER) {
      cerr << "Lower and upper bounds must be Integers" << endl << flush;
      return ;
    }  // if
    if (ende < anfang) { 
      val tmp = anfang;
      anfang = ende;
      ende = tmp;
    }  // if
    for (int p = anfang.asInt(); p <= ende.asInt(); p++) {
      set.insert(val(p));
    }
  }  // if
  else {
    set.insert(StringToVal(range));
  }
}  // place::StringRangeAppendSet

void
place::StringToMultiSet(string s, multiset<val, less<val> > &set)
  // Konvertiert string in eine Multimenge ber val
{
  set.erase(set.begin(), set.begin());
  if(s == "")
    return;
  marking_st = s;
  string sv;
  unsigned int co;

  if (s == "")
    return ;
  while(s.find("{") != string::npos)
    s = s.serase(s.find("{"),1);
  while(s.find("}") != string::npos)
    s = s.serase(s.find("}"),1);
  while(s.find(" ") != string::npos)
    s = s.serase(s.find(" "),1);
//  s = s.gsub("{", "");
//  s = s.gsub("}", "");
//  s = s.gsub(" ", "");
  do {
    if (s.at(0) == '(') {
      string t1, ta, te;
      co = s.find("(");
      if(co != string::npos) {
        t1 = s.substr(co+1,1000);
        // string t1 = s.after("(");
        // Tupel gefunden
        co = t1.find(")");
        if(co != string::npos) {
          ta = t1.substr(0,co);
          te = ta;
        }
      }
      // string ta = t1.before(")");
      // string te = ta;
      int help = 0;
      while(te != "") {
        co = te.find(",");
        if(co != string::npos) {
          //s = s.substr(co+1,1000);
          te = te.substr(co+1,1000);
        } else 
          te = "";
        help++;
      }
      Tupel temp(help);
      while(ta != "") {
        co = ta.find(",");
        if(co != string::npos)
          temp.add(StringToVal(ta.substr(0,co)));
        else
          temp.add(StringToVal(ta));
        co = ta.find(",");
        if(co != string::npos)
          ta = ta.substr(co+1,1000);
        else
          ta = "";
        // ta = ta.after(",");
      }
      set.insert(temp);
      co = t1.find("),");
      if(co != string::npos)
        s = t1.substr(co+2, 1000);
      else
        s = "";
      // s = t1.after("),");
    } else {
      co = s.find(",");
      if(co != string::npos)
        sv = s.substr(0,co);
      else
        sv = "";
      // sv = s.before(",");
      if (sv == "")
        StringRangeAppendMultiSet(s, set);
      else
        StringRangeAppendMultiSet(sv, set);
      co = s.find(",");
      if(co != string::npos)
        s = s.substr(co+1, 1000);
      else
        s = "";
      //s = s.after(",");
    }  // else
  } while(s != "");
}  // place::StringToMultiSet

void
place::StringRangeAppendMultiSet(string range, multiset<val, less<val> > &set) const
  // Fgt an die Multimenge set einen Wert an, der aus dem String range
  // gewonnen wird. range kann aber auch eine Bereich start..ende sein
  // In diesem Fall werden alle Werte von start bis end zur Multimenge#
  // zugefgt.
{
  unsigned int co;
  string lower;
  co = range.find("..");
  if(co != string::npos)
    lower = range.substr(0,co);
  //  string lower = range.before("..");
  if (lower != "") {
    val anfang = StringToVal(lower);
    string upper = range.substr(co+1,1000);
    // string upper = range.after("..");
    val ende = StringToVal(upper);
    if (anfang.Type() != INTEGER || ende.Type() != INTEGER) {
      cerr << "Lower and upper bounds must be Integers" << endl;
      return ;
    }  // if
    if (ende < anfang) { 
      val tmp = anfang;
      anfang = ende;
      ende = tmp;
    }  // if
    for (int p = anfang.asInt(); p <= ende.asInt(); p++)
      set.insert(p);
  } else {
    co = range.find("*");
    string v;
    if(co != string::npos)
      v = range.substr(0,co);
    else
      v = "";
    // string v = range.before("*");
    if (v != "") {
      co = range.find("*");
      string h;
      if(co != string::npos)
        h = range.substr(co+1,1000);
      else
        h = "";
      // string h = range.after("*");
      for(int i = 0; i < atoi(v.c_str()); i++) {
        set.insert(StringToVal(h));
      }
      // set.insert(StringToVal(h), atoi(v.data()));
    }  // if
    else {
      set.insert(StringToVal(range));
    }
  }  // else,
}  // place::StringRangeAppendMultiSet

