#include "val.h"
#include <ctype.h>
#include "Stack.h"
#include <stdio.h>
#include <stdlib.h>

val::val(const val& v1, const val& v2) : vtype(TUPEL), 
    tupel(new Tupel(v1,v2))
{
    // Nix
}

val::val(const string& str) : vtype(STRING), String(new string(str.c_str()))
{
    // Nix
}

val::~val() {
  if (vtype == STRING) {
    delete String;
  }
  else if (vtype == TUPEL) {
    delete tupel;
  }
}

const val& 
val::operator =(const val& v) 
{
    vtype = v.vtype;
    if (vtype == TUPEL) {
        delete tupel;
	tupel = new Tupel(*v.tupel);
    }
    else if(vtype == STRING) {
        delete String;
        String = new string(*v.String);
    }
    else
	value = v.value;
    return *this;
}

val::val(const val& v):vtype(v.vtype)
{
    if (vtype == TUPEL) {
	tupel = new Tupel(*v.tupel);
    }
    else if(vtype == STRING) {
           String = new string(*v.String);
         }
    else
	value = v.value;
}

val::val(const Tupel& t) : vtype(TUPEL), tupel(new Tupel(t))
{
    
    // Nix
}


string
Binding::asString(void)
{
    string l;
    multimap<string, val, less<string> >::iterator i, n;

    for (i = begin(); i != end(); ++i) {
        n = i;
	l += (*i).first + "=" + ((*i).second).asString();
	++n;
	if (n != end())
	    l += ",";
    }
    return l;
}


val
val::get(int i) const
{
    if(vtype == TUPEL)
      return tupel->get(i);
    if(vtype == INTEGER)
      return value;
    if(vtype == DOT)
      return *this;
    if(vtype == BOOLEAN)
      return (value ? val("tt") : val("ff"));
    if(vtype == STRING)
      return *String;
    return val(0);
}

void
val::set(val a, int i)
{
    if(a.vtype == TUPEL)
      set(a.get(0), i);
    if(vtype == TUPEL)
      tupel->set(a,i);
    else {
        vtype = a.vtype;
        if(vtype == STRING) {
          delete String;
          String = new string(*a.String);
        }
        else if(vtype == TUPEL) {
          delete tupel;
          tupel = new Tupel(*a.tupel);
        }
        else
          value = a.value;
    }
}

void
val::replaceAll(string s, val a)
{
  if(vtype == STRING)
    *this = a;
  if(vtype != TUPEL)
    return;
  tupel->replaceAll(s, a);
}

int
val::find(string s) const
{
    if(vtype == STRING) {
      return (s == *String);
    }
    if(vtype == TUPEL) {
      return tupel->find(s);
    }
    if(vtype == DOT) {
      return ((s == "dot") || (s == "(dot)"));
    }
    return 0;
}


int
val::hasStrings(void) const
{
    if(vtype == TUPEL)
      return tupel->hasStrings();
    return (vtype == STRING);
}


multiset<string, less<string> >
val::Strings() const
{
    multiset<string, less<string> > var;
    if(vtype == TUPEL)
      return tupel->Strings();
    if(vtype == STRING)
      var.insert(*String);
    return var;
}


string
val::asString(void) const
{
    switch (vtype) {
    case INTEGER: {
        string t = IntToString(value);
	return t;}
    case DOT:{
	return "dot";}
    case BOOLEAN:{
	return value ? "tt" : "ff";}
    case TUPEL:{
	return tupel->asString();}
    case STRING:{
        return *String;}
    }
    return "";
}
	

Tupel
StringToTupel(string val_string)
{
    unsigned int i;

    while(val_string.find("(") != string::npos)
      val_string.serase(val_string.find("("),1);
    while(val_string.find(")") != string::npos)
      val_string.serase(val_string.find(")"),1);  
    string te = val_string;
    string ta = te;
    int help = 0;
    while(te != "") {
      help++;
      i = te.find(",");
      if(i == string::npos)
        break;
      te = te.substr(i+1, 1000);
    }
    Tupel temp(help);
    while(ta != "") {
      i = ta.find(",");
      if(i != string::npos) {
        temp.add(StringToVal(ta.substr(0,i)));
      }
      else {
        temp.add(StringToVal(ta));
      }
      i = ta.find(",");
      if(i == string::npos)
        break;
      ta = ta.substr(i+1,1000);
    }
    return temp;
}



val
StringToVal(const string& val_string)
{
    int v;
    val value;

    if (sscanf(val_string.c_str(), "%d", &v)) {
	value = v;
    } else {
        string num = val_string;
        while(num.find(" ") != string::npos) {
          num.serase(num.find(" "), 1);
        }
	//string num = val_string.gsub(" ","");
	if (num == "dot")
	    value = dot;
	else if (num == "ff")
	    value = false;
	else if (num == "tt")
	    value = true;
	else if (num.find("(") != string::npos)
	    value = StringToTupel(val_string);
	else {
            value = val_string;
	}
    }
    return value;
}

int
IsVal(const string& val_string)
{
    int v;

    if (sscanf(val_string.c_str(), "%d", &v))
      return 1;
    else {
      string num = val_string;
      while(num.find(" ") != string::npos)
        num.serase(num.find(" "), 1);
      if (num == "dot")
	return 1;
      else if (num == "ff")
	return 1;
      else if (num == "tt")
	return 1;
    }
    return 0;
}

string
IntToString(int c)
{
    char buffer[30];
    sprintf(buffer, "%ld", (long int)c);
    return string(buffer);
}

ostream&
operator <<(ostream& s, const val& v)
{
    switch (v.vtype) {
    case INTEGER:{
	return s << v.value;}
    case DOT:{
	return s << "dot";}
    case BOOLEAN:{
	return s << (v.value ? "tt" : "ff");}
    case TUPEL:{
	return s << v.tupel->asString();}
    case STRING:{
        return s << v.String;}
    }
    return s;  // Damit der Compiler Ruhe gibt
}

val
val::pr0() const
{
    if (vtype != TUPEL) {
	cerr << "Versuch auf Tupelzugriff, wo kein Tupel war" << endl;
	return 0;
    }
    return tupel->pr0();
}

val
val::pr1() const
{
    if (vtype != TUPEL) {
	cerr << "Versuch auf Tupelzugriff, wo kein Tupel war" << endl;
	return 0;
    }
    return tupel->pr1();
}

	
val
val::operator +(const val& a) const
{
    if (vtype != INTEGER || a.vtype != INTEGER) {
	cerr << "Addition nur auf INTEGER definiert" << endl;
	return val(0);
    }
    return val(value + a.value);
}

val
val::operator -(const val& a) const
{
    if (vtype != INTEGER || a.vtype != INTEGER) {
	cerr << "Subtraktion nur auf INTEGER definiert" << endl;
	return val(0);
    }
    return val(value - a.value);
}

val
val::operator *(const val& a) const
{
    if (vtype != INTEGER || a.vtype != INTEGER) {
	cerr << "Multiplikation nur auf INTEGER definiert" << endl;
	return val(0);
    }
    return val(value * a.value);
}

val
val::operator /(const val& a) const
{
    if (a.vtype != INTEGER || a.vtype != INTEGER) {
	cerr << "Division nur auf INTEGER definiert" << endl;
	return val(0);
    }
    if (a.value == 0) {
	cerr << "Division durch Null" << endl;
	return 0;
    }
    return val(value / a.value);
}

val
val::operator %(const val& a) const
{
    if (a.vtype != INTEGER || a.vtype != INTEGER) {
	cerr << "Modulo nur auf INTEGER definiert" << endl;
	return val(0);
    }
    if (a.value == 0) {
	cerr << "Modulo Null" << endl;
	return 0;
    }
    return val(value % a.value);
}

val
val::operator &(const val& a) const
{
    if (vtype != BOOLEAN || a.vtype != BOOLEAN) {
	cerr << "& nur auf BOOLEAN definiert" << endl;
	return val(false);
    }
    // return val((value && a.value) ? true : false);
    return ((*this == true) && (a == true)) ? val(true) : val(false);
}

val
val::operator |(const val& a) const
{
    if (vtype != BOOLEAN || a.vtype != BOOLEAN) {
	cerr << "| nur auf BOOLEAN definiert" << endl;
	return val(false);
    }
    return val((value || a.value) ? true : false);
}

val
val::imp(const val& a) const
{
    if (vtype != BOOLEAN || a.vtype != BOOLEAN) {
	cerr << "-> nur auf BOOLEAN definiert" << endl;
	return val(false);
    }
    return val((!value || a.value) ? true : false);
}


int
val::operator ==(const val& a) const
{
    if (vtype == a.vtype) {
        if(vtype == DOT)
           return 1;
	if (vtype == TUPEL)
	    return *tupel == *a.tupel;
	else if(vtype == STRING) {
               return (*String == *a.String);
             }
        else
	    return value == a.value;
    }
    if(a.vtype == TUPEL) {
      return (*this == a.get(0));
    }
    if(vtype == TUPEL) {
      return (get(0) == a);
    }
    return 0;
}


int
val::EQUAL(const val& a) const
{
    if (vtype == a.vtype) {
        if(vtype == DOT)
           return 1;
	else if (vtype == TUPEL)
	    return tupel->EQUAL(*a.tupel);
	else if(vtype == STRING) {
               return (*String == *a.String);
             }
        else
	    return value == a.value;
    }
    if(a.vtype == TUPEL) {
      return (*this == a.get(0));
    }
    if(vtype == TUPEL) {
      return (get(0) == a);
    }
    return (((vtype == STRING) && (a.vtype == INTEGER)) || ((vtype == INTEGER) && (a.vtype == STRING)) || ((vtype == STRING) && (a.vtype == DOT)) || ((vtype == DOT) && (a.vtype == STRING)) || ((vtype == BOOLEAN) && (a.vtype == STRING)) || ((vtype == STRING) && (a.vtype == BOOLEAN)));
}


int
val::operator !=(const val& a) const
{
    return !(*this == a);
}


// dieser Operator ist sehr wichtig, da er von set<val, less<val> >
// ben"otigt wird.
int 
val::operator  <(const val& a) const
{
    if (vtype == DOT && a.vtype == DOT)
        return false;
    if (vtype == DOT && a.vtype == INTEGER)
        return true;
    if (vtype == DOT && a.vtype == STRING)
        return true;
    if (vtype == DOT && a.vtype == TUPEL)
       return true;
    if (vtype == STRING && a.vtype == DOT)
        return false;
    if (vtype == INTEGER && a.vtype == DOT)
        return false;
    if (vtype == TUPEL && a.vtype == DOT)
        return false;
    if (vtype == TUPEL && a.vtype == TUPEL) {
        if(tupel->Dim() < a.tupel->Dim())
          return true;
        for(int z = 0;z < tupel->Dim();z++) {
          if(tupel->get(z) < a.tupel->get(z))
            return true;
        }
        return false;
    }
    if(vtype == STRING && a.vtype == STRING) {
      return (*String) < *(a.String);
    }
    if(vtype == STRING && a.vtype == INTEGER) {
      return true;
    }
    if(vtype == INTEGER && a.vtype == STRING) {
      return false;
    }
    if (vtype != INTEGER || a.vtype != INTEGER) {
cerr << vtype << ":" << a.vtype << endl;
	cerr << "Relation <  nur auf INTEGER (und DOT) definiert" << endl;
	return 0;
    }
    return (value < a.value); //  ? true : false;
}

int
val::operator  >(const val& a) const
{
    if ((vtype == DOT && a.vtype == INTEGER) || (vtype == DOT && a.vtype == INTEGER))
        return false;
    if (vtype != INTEGER || a.vtype != INTEGER) {
	cerr << "Relation > nur auf INTEGER (und DOT) definiert" << endl;
	return 0;
    }
    return (value > a.value); // ? true : false;
}

int
val::operator  <=(const val& a) const
{
    if ((vtype == DOT && a.vtype == INTEGER) || (vtype == DOT && a.vtype == INTEGER))
        return false;
    if (vtype != INTEGER || a.vtype != INTEGER) {
	cerr << "Relation <=  nur auf INTEGER definiert" << endl;
	return 0;
    }
    return (value <= a.value); // ? true : false;
}

int
val::operator  >=(const val& a) const
{
    if ((vtype == DOT && a.vtype == INTEGER) || (vtype == DOT && a.vtype == INTEGER))
        return false;
    if (vtype != INTEGER || a.vtype != INTEGER) {
	cerr << "Relation >=  nur auf INTEGER definiert" << endl;
	return 0;
    }
    return (value >= a.value); // ? true : false;
}

val
val::operator !() const
{
    if (vtype != BOOLEAN) {
	cerr << "Operator ! nur auf BOOLEAN definiert" << endl;
	return false;
    }  
    return (value == 1) ? false : true;
}

int
VTNode::operator ==(const VTNode& a) const
{
    if (node_type == a.node_type) 
	
	switch (node_type) {
	    
	case OPERATOR:{
	    return (a.otype == otype);}

	case VALUE:{
	    return (*a.v == *v);}

	case VARIABLE:{
	    return *ident == *a.ident;
	    break;}
	default:{
	    cerr << "Irgendwas ist falsch in VTNode::operator==" << endl;
	    return 0;}
	}
    else
	return 0;

}
void
VTNode::Delete(void)
{
    if (node_type == VALUE)
	delete v;
    else if (node_type == VARIABLE)
	delete ident;
    
}   
 
VTNode&
VTNode::operator =(const VTNode& right)
{
    if (this == &right)
	return *this;
    
    Delete();

    node_type = right.node_type;

    switch (node_type) {
    case OPERATOR:{
	otype = right.otype;
	break;}
    case VALUE:{
	v = new val(*right.v);
	break;}
    case VARIABLE:{
	ident = new string(*right.ident);
	break;}

    default:{
	cerr << "Irgendwas stimmt nicht in VtNode::operator=" << endl;}

    }

    return *this;
};

VTNode::VTNode(const VTNode& a)
{
    node_type = a.node_type;
    switch (node_type) {

    case VALUE:{
	v = new val(*a.v);
	break;}

    case VARIABLE:{
	ident = new string(*a.ident);
	break;}

    case OPERATOR:{
	otype = a.otype;
	break;}
    /* case PROJECTION:
	ptype = a.ptype;
	break; */
    }
}

val
VT::EvaluateDict(Binding& binding, const map<string, set<val, less<val> >, less<string> >::iterator& i)
{
    if (i == intern_set.end()) 
	return FixedEvaluate(binding);
    
    const string& var = (*i).first;

    set<val, less<val> > values = (*i).second;
    set<val, less<val> >::iterator k;
    for (k=values.begin(); k != values.end(); ++k) {
	bind.insert(multimap<string, val, less<string> >::value_type(var,*k));
	map<string, set<val, less<val> >, less<string> >::iterator l=i;
	l++;
	if (EvaluateDict(binding,l) == true)
	    return true;
    }
    return false;
}

val
VT::Evaluate(Binding& bindings)
{
    bind.erase(bind.begin(), bind.end());
    return EvaluateDict(bindings, intern_set.begin());
}

val
VT::FixedEvaluate(Binding& binding)
{
    if (upn_list.empty()) {
	cerr << "Nix zum Auswerten da" << endl;
	return 0;
    }

    val ret;

    val a, b;
    int cont = 1;

    Stack<val> upn_stack;

    list<VTNode>::iterator i;

    for (i=upn_list.begin(); i != upn_list.end() && cont; ++i) {
	
	switch ((*i).Type()) {      // Was fr ein Typ

	case OPERATOR:   
	    // Falls Operator -> die beiden obersten Werte vom Stack holen
	    // und auf diesen den Operator anwenden

	    b = upn_stack.pop();
		
	    switch ((*i).Operator()) {

	    case AND:
		a = upn_stack.pop();
		upn_stack.push(a & b);
		break;

	    case OR:
		a = upn_stack.pop();
		upn_stack.push(a | b);
		break;

	    case IMP:
		a = upn_stack.pop();
		upn_stack.push(a.imp(b));
		break;

	    case ADD:
		a = upn_stack.pop();
		upn_stack.push(a + b);
		break;

	    case SUB:
		a = upn_stack.pop();
		upn_stack.push(a - b);
		break;
		
	    case DIV:
		a = upn_stack.pop();
		upn_stack.push(a / b);
		break;
		
	    case MULT:
		a = upn_stack.pop();
		upn_stack.push(a * b);
		break;

	    case MOD:
		a = upn_stack.pop();
		upn_stack.push(a % b);
		break;

	    case EQ:
		a = upn_stack.pop();
		upn_stack.push((a == b) ? true : false);
		break;

	    case NOT_EQ:
		a = upn_stack.pop();
		upn_stack.push((a != b) ? true : false); 
		break;

	    case GT:
		a = upn_stack.pop();
		upn_stack.push((a > b) ? true : false);
		break;

	    case LE:
		a = upn_stack.pop();
		upn_stack.push((a < b) ? true : false);
		break;

	    case GT_EQ:
		a = upn_stack.pop();
		upn_stack.push((a >= b) ? true : false);
		break;

	    case LE_EQ:
		a = upn_stack.pop();
		upn_stack.push((a <= b) ? true : false);
		break;

	    case NOT:
		upn_stack.push(!b);
		break;
	    case PR0:
		upn_stack.push(b.pr0());
		break;
	    case PR1:
		upn_stack.push(b.pr1());
		break;
	    }
	    break;
	case VALUE:
	    // Fall Zahl -> auf Stack bringen
	    upn_stack.push((*i).Value());
	    break;
	    
	case VARIABLE:
	    // Falls Variable -> den Wert der Variable auf Stack
	    if (binding.find((*i).Identifier()) != binding.end()) {
		upn_stack.push((*binding.find((*i).Identifier())).second);
	    }
	    else if (bind.find((*i).Identifier()) != bind.end()) {
		upn_stack.push((*bind.find((*i).Identifier())).second);
		//cout << "Var :" << upn_list(i).Identifier()
		//    << "Wert :" << bind[upn_list(i).Identifier()] << endl;
	    }
	    else { // In diesem Fall -> ueberhaupt keine Bindung gefunden
		// Liste als abgearbeitet erklaeren
		// Stack loeschen und false drauf
		cont = 0;
		upn_stack.clear();
		upn_stack.push(false);
	    }
	    /* case PROJECTION:
	       if (upn_list(i).Projection() == PR0) {
	       upn_list.next(i);
	       upn_stack.push(binding[upn_list(i).Identifier()].pr0());
	       }
	       else {
	       upn_list.next(i);
	       upn_stack.push(binding[upn_list(i).Identifier()].pr1());
	       }
	       break; */
	    
	}
	
    }

    // Alles ausgewertet -> dann Wert zurck
    ret = upn_stack.pop();

    if (!upn_stack.empty()) {
         cerr << "Irgendwas stimmt nicht in VT::Evaluate.\n" <<
	      "Der Stack ist nicht leer, wie er es sein sollte" << endl;
    }
    return ret;
}

void 
VT::ChangeTerm(const string& new_vt) 
{
    string_term = new_vt;
    vars_in_VT.erase(vars_in_VT.begin(), vars_in_VT.end());
    upn_list.erase(upn_list.begin(), upn_list.end());
    parse_VT(*this);
}


// Fuer Martin

extern "C" {

    int CheckVT(const char* vt_string) {
	VT vt(vt_string);
	Binding b;
	return (vt.Evaluate(b) == true) ? 1 : 0;
    }
}

    
