# read simulation server names from file
proc GetServer {} {
  global env

  if [catch {set homepath $env(HOME)}] {
    set homepath ""
  }
  if [catch {set peppath $env(PEPHOME)}] {
    set peppath ""
  }
  set path [file join $homepath ".pep_server"]
  if [catch {set file [open $path r]}] {
    set path [file join $peppath ".pep_server"]
    if [catch {set file [open $path r]}] {
      return {}
    }
  }
  set input [string trim [read $file]]
  close $file
  return [split $input "\n"]
}

# write simulation server names to file
# which may be user or global
# list is the names list
proc SetServer {which list} {
  global env

  if [catch {set homepath $env(HOME)}] {
    set homepath ""
  }
  if [catch {set peppath $env(PEPHOME)}] {
    set peppath ""
  }
  if {$which=="user"} {
    set path [file join $homepath ".pep_server"]
  } else {
  if {$which=="global"} {
    set path [file join $peppath ".pep_server"]
  } else {
    return -code error
  }}
  if [catch {set file [open $path w]}] {
    return
  }
  puts $file [join $list "\n"]
  close $file
}

proc save_editor_contents {new_filename} {
  SaveNet $new_filename
}

proc reload_editor_contents {new_filename} {
  LoadNet $new_filename
}

proc S_getActiveTransitions { } {
  global PT

  if {$PT(NetChanged)} {
    $PT(net) clearActive
  }
  return [$PT(net) get ActiveTransitions]
}

proc S_oneStep { } {
   global PT

   AnimateEnd
   if {[llength $PT(node_list)] == $PT(counters)} {
      if {[llength $PT(loop_list)] == 0} {
         FireBindings
      } else {
         while {$PT(wait) == 0} {
            after 200
         }
         set PT(wait) 0
         ActiveTransitions
         set t [lindex $PT(loop_list) $PT(counterl)]
#TODO Maybe not active ?!
         set PT(trans) $t
         FireTrans 12345
         set PT(counterl) [expr $PT(counterl) + 1]
         if {$PT(counterl) == [llength $PT(loop_list)]} {
            set PT(counterl) 0
         }
         set PT(wait) 1
      }
   } else {
      while {$PT(wait) == 0} {
         after 200
      }
      set PT(wait) 0
      ActiveTransitions
      set t [lindex $PT(node_list) $PT(counters)]
      if {$t == ""} {
         switch [tk_dialog .d {Active Transition Error} \
            {One of the Transitions you wanted to execute is not active!} question 0 {Ok}] {

         0 { set PT(AnimationStop) 1
             set PT(wait) 1
             return }
         }
      }
      set PT(trans) $t
      FireTrans 12345
      if {[expr $PT(counters)] < [llength $PT(node_list)]} {
         set PT(counters) [expr $PT(counters) + 1]
      }
      set PT(wait) 1
   }
}

proc S_FireRandomTrans { } {
 global PT

  set ac [$PT(net) get ActiveTransitions]
  set random [expr {int(rand()*[llength $ac])}]
  set t_index [lindex $ac $random]

  if {[$PT(canvas) find withtag $t_index] == ""} {
      set PT(trans) $t_index
      FireTrans 12345
  } else {
      set t [lindex [$PT(canvas) find withtag $t_index] 0]
      FireTrans $t
  }
}

proc S_setValueFromSimulator {name value} {
 global gvar

 #puts "name: $name     value: $value"
 set gvar($name) $value
}
