// This may look like C code, but it is really -*- C++ -*-
// WARNING: This file is obsolete.  Use ../SLList.h, if you can.
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

// Modified for Templates by Tobias Himstedt
// Universitaet Hildesheim
// 1/95

// Modified for gcc 2.7.2 by Burkhard Bieber
// Changed <Pix.h> to "Pix.h" - Christian Stehno

// last-update: 30.05.2000


#ifndef SLList_h
#define SLList_h 1

#include "Pix.h"
#include <limits.h>

/* #ifndef _SLListNode_h
#define _SLListNode_h 1 */

template<class Type>
struct SLListNode
{
    Type                 hd;
    SLListNode*          tl;
    SLListNode() { }
    SLListNode(const Type& h, SLListNode<Type>* t = 0);
    ~SLListNode() { }
};


template<class Type> inline 
SLListNode<Type>::SLListNode(const Type& h, SLListNode<Type>* t) : hd(h), 
    tl(t) {}


template<class Type>
class SLList
{
protected:
    SLListNode<Type>*        last;
    
public:
    SLList();
    SLList(const SLList<Type>& a);
    ~SLList();
    
    const SLList&         operator = (const SLList<Type>& a);
    
    int                   empty() const;
    unsigned int          length() const;
    
    void                  clear();
    
    Pix                   prepend(const Type& item);
    Pix                   append(const Type& item);
    
    void                  join(SLList<Type>& r);
    
    Pix                   prepend(SLListNode<Type>* r);
    Pix                   append(SLListNode<Type>* r);
    
    Type&                 operator () (Pix p) const;
    Pix                   first() const;
    void                  next(Pix& p) const;
    int                   owns(Pix p) const;
    Pix                   ins_after(Pix p, const Type& item);
    void                  del_after(Pix p);
    
    Type&                  front() const;
    Type&                  rear() const;
    Type                   remove_front();
    int                   remove_front(Type& x);
    void                  del_front();
    
    void                  error(const char* msg) const;
    int                   OK() const;
};

template<class Type> inline 
SLList<Type>::~SLList()
{
    clear();
}

template<class Type> inline 
SLList<Type>::SLList()
{
    last = 0;
}

template<class Type> inline int 
SLList<Type>::empty() const
{
    return last == 0;
}


template<class Type> inline Pix 
SLList<Type>::first() const
{
    return (last == 0)? 0 : Pix(last->tl);
}

template<class Type> inline void 
SLList<Type>::next(Pix& p) const
{
    p = (p == 0 || p == last)? 0 : Pix(((SLListNode<Type>*)(p))->tl);
}

template<class Type> inline Type& 
SLList<Type>::operator () (Pix p) const
{
    if (p == 0) error("null Pix");
    return ((SLListNode<Type>*)(p))->hd;
}

template<class Type> inline Type& 
SLList<Type>::front() const
{
    if (last == 0) error("front: empty list");
    return last->tl->hd;
}

template<class Type> inline Type& 
SLList<Type>::rear() const
{
    if (last == 0) error("rear: empty list");
    return last->hd;
}

template<class Type> void 
SLList<Type>::error(const char* msg) const
{
    cerr << "SLList :" << msg;
}

template<class Type> unsigned int 
SLList<Type>::length() const
{
    int l = 0;
    SLListNode<Type>* t = last;
    if (t != 0) do { ++l; t = t->tl; } while (t != last);
    return l;
}

template<class Type> 
SLList<Type>::SLList(const SLList<Type>& a)
{
    if (a.last == 0)
	last = 0;
    else
	{
	    SLListNode<Type>* p = a.last->tl;
	    SLListNode<Type>* h = new SLListNode<Type>(p->hd);
	    last = h;
	    for (;;)
		{
		    if (p == a.last)
			{
			    last->tl = h;
			    return;
			}
		    p = p->tl;
		    SLListNode<Type>* n = new SLListNode<Type>(p->hd);
		    last->tl = n;
		    last = n;
		}
	}
}

template<class Type> const SLList<Type>& 
SLList<Type>::operator = (const SLList<Type>& a)
{
    if (this == &a)
	return *this;

    if (last != a.last)
	{
	    clear();
	    if (a.last != 0)
		{
		    SLListNode<Type>* p = a.last->tl;
		    SLListNode<Type>* h = new SLListNode<Type>(p->hd);
		    last = h;
		    for (;;)
			{
			    if (p == a.last)
				{
				    last->tl = h;
				    break;
				}
			    p = p->tl;
			    SLListNode<Type>* n = new SLListNode<Type>(p->hd);
			    last->tl = n;
			    last = n;
			}
		}
	}
    return *this;
}

template<class Type> void 
SLList<Type>::clear()
{
    if (last == 0)
	return;
    
    SLListNode<Type>* p = last->tl;
    last->tl = 0;
    last = 0;
    
    while (p != 0)
	{
	    SLListNode<Type>* nxt = p->tl;
	    delete(p);
	    p = nxt;
	}
}


template<class Type> Pix 
SLList<Type>::prepend(const Type& item)
{
    SLListNode<Type>* t = new SLListNode<Type>(item);
    if (last == 0)
	t->tl = last = t;
    else
	{
	    t->tl = last->tl;
	    last->tl = t;
	}
    return Pix(t);
}


template<class Type> Pix 
SLList<Type>::prepend(SLListNode<Type>* t)
{
    if (t == 0) return 0;
    if (last == 0)
	t->tl = last = t;
    else
	{
	    t->tl = last->tl;
	    last->tl = t;
	}
    return Pix(t);
}


template<class Type> Pix 
SLList<Type>::append(const Type& item)
{
    SLListNode<Type>* t = new SLListNode<Type>(item);
    if (last == 0)
	t->tl = last = t;
    else
	{
	    t->tl = last->tl;
	    last->tl = t;
	    last = t;
	}
    return Pix(t);
}

template<class Type> Pix 
SLList<Type>::append(SLListNode<Type>* t)
{
    if (t == 0) return 0;
    if (last == 0)
	t->tl = last = t;
    else
	{
	    t->tl = last->tl;
	    last->tl = t;
	    last = t;
	}
    return Pix(t);
}

template<class Type> void 
SLList<Type>::join(SLList<Type>& b)
{
    SLListNode<Type>* t = b.last;
    b.last = 0;
    if (last == 0)
	last = t;
    else if (t != 0)
	{
	    SLListNode<Type>* f = last->tl;
	    last->tl = t->tl;
	    t->tl = f;
	    last = t;
	}
}

template<class Type> Pix 
SLList<Type>::ins_after(Pix p, const Type& item)
{
    SLListNode<Type>* u = (SLListNode<Type>*)p;
    SLListNode<Type>* t = new SLListNode<Type>(item);
    if (last == 0)
	t->tl = last = t;
    else if (u == 0) // ins_after 0 means prepend
	{
	    t->tl = last->tl;
	    last->tl = t;
	}
    else
	{
	    t->tl = u->tl;
	    u->tl = t;
	    if (u == last) 
		last = t;
	}
    return Pix(t);
}


template<class Type> void 
SLList<Type>::del_after(Pix p)
{
    SLListNode<Type>* u = (SLListNode<Type>*)p;
    if (last == 0 || u == last) error("cannot del_after last");
    if (u == 0) u = last; // del_after 0 means delete first
    SLListNode<Type>* t = u->tl;
    if (u == t)
	last = 0;
    else
	{
	    u->tl = t->tl;
	    if (last == t)
		last = u;
	}
    delete t;
}

template<class Type> int 
SLList<Type>::owns(Pix p) const
{
    SLListNode<Type>* t = last;
    if (t != 0 && p != 0)
	{
	    do
		{
		    if (Pix(t) == p) return 1;
		    t = t->tl;
		} while (t != last);
	}
    return 0;
}

template<class Type> Type 
SLList<Type>::remove_front()
{
    if (last == 0) error("remove_front of empty list");
    SLListNode<Type>* t = last->tl;
    Type res = t->hd;
    if (t == last)
	last = 0;
    else
	last->tl = t->tl;
    delete t;
    return res;
}

template<class Type> int 
SLList<Type>::remove_front(Type& x)
{
    if (last == 0)
	return 0;
    else
	{
	    SLListNode<Type>* t = last->tl;
	    x = t->hd;
	    if (t == last)
		last = 0;
	    else
		last->tl = t->tl;
	    delete t;
	    return 1;
	}
}


template<class Type> void 
SLList<Type>::del_front()
{
    if (last == 0) error("del_front of empty list");
    SLListNode<Type>* t = last->tl;
    if (t == last)
	last = 0;
    else
	last->tl = t->tl;
    delete t;
}

template<class Type> int 
SLList<Type>::OK() const
{
    int v = 1;
    if (last != 0)
	{
	    SLListNode<Type>* t = last;
	    long count = LONG_MAX;      // Lots of chances to find last!
	    do
		{
		    count--;
		    t = t->tl;
		} while (count > 0 && t != last);
	    v &= count > 0;
	}
    if (!v) error("invariant failure");
  return v;
}

#endif
