
#include "ServerSocket.h"
#include <iostream.h>

ServerSocket::ServerSocket(int port) {
  if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
    cerr << "server: can't open stream socket" << endl;
  memset(&serv_addr, '\0', sizeof(serv_addr));
  serv_addr.sin_family      = AF_INET;
  serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  serv_addr.sin_port        = htons(port);

  if(bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0)
    cerr << "server: can't bind local address" << endl;
  
  listen(sockfd, 5);
} // ServerSocket::ServerSocket

int
ServerSocket::akzept() {
  clilen = sizeof(cli_addr);
  return (accept(sockfd, (struct sockaddr *)&cli_addr, &clilen));
} // ServerSocket::akzept

ServerSocket::~ServerSocket() {
  if(sockfd)
    close(sockfd);
} // ServerSocket::~ServerSocket

void
ServerSocket::schliesse() {
  close(sockfd);
} // ServerSocket::schliesse

int
ServerSocket::schreibe(int fd, string text) {
  int nbytes = text.length();
  const char *zeichen = text.data();

  return write(fd, zeichen, nbytes);
}

string
ServerSocket::lese(int fd) {
  char ptr[MAXSIZE];
  memset(&ptr, '\0', sizeof(ptr));

  int nread = read(fd, &ptr, MAXSIZE);
  if(nread < 0)
    return "";

  return string(ptr);
}
