
#include "Socket.h"
#include <iostream>
#include <string>
#include <strings.h>

typedef unsigned short int USINT;

Socket::Socket(string host, int port) {
  struct hostent *hp;
  struct hostent tcp_host_info;
  char *ptr = new char[host.length()];

  memset(&serv_addr, '\0', sizeof(serv_addr));
  serv_addr.sin_family = AF_INET;
  strcpy(ptr, host.c_str());
  ptr[host.length()] = (char)NULL;
  hp = gethostbyname(ptr);
  tcp_host_info = *hp;
  memcpy(&serv_addr.sin_addr, hp->h_addr, hp->h_length);
  serv_addr.sin_port = htons(port);

  if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
    cerr << "client: can't open stream socket" << endl << flush;
} // Socket::Socket

int
Socket::Connect() {
  return (connect(sockfd, (struct sockaddr *)&serv_addr, sizeof(serv_addr)));
} // Socket::Connect

unsigned int
Socket::getsock() const {
  return sockfd;
} // Socket::getsock

Socket::~Socket() {
  if(sockfd)
    close(sockfd);
} // Socket::~Socket

int
Socket::Write(string text) {
  int nbytes = text.length();
  char header[2];
  header[0] = (unsigned char)(nbytes / 256);
  header[1] = (unsigned char)(nbytes - char(nbytes / 256) * 256);
  const char *zeichen = text.c_str();

  ::write(sockfd, header, 2);
  return write(sockfd, zeichen, nbytes);
} // Socket::write

string
Socket::Read() {
  char header[2];
  read(sockfd, header, 2);
  int nbytes = (unsigned char)header[0] * 256 + (unsigned char)header[1];

  char ptr[nbytes];
  memset(ptr, '\0', nbytes);
  int nread1 = 0, nread2 = 0;
  while(nbytes - nread1 > 0) {
    nread2 = ::read(sockfd, ptr + nread1, nbytes - nread1);
    if(nread2 < 0) {
      delete [] ptr;
      return "";
    }
    nread1 += nread2;
  }

  string ret = ptr;
  return ret.substr(0, nbytes);
} // Socket::read

int
Socket::operator ==(const Socket &s) const {
  return (getsock() == s.getsock());
} // Socket::operator ==

