// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


// Modified for Templates by Tobias Himstedt
// Universitaet Hildesheim
// 1/95

#ifndef Stack_h
#define Stack_h

template<class Type>
class Stack
{
public:
    Stack() { }
    virtual              ~Stack() {};
    
    virtual void          push(const Type& item) = 0;
    virtual Type           pop() = 0;
    virtual Type&          top() const = 0;               
    virtual void          del_top() = 0;
    
    virtual int           empty() const = 0;
    virtual int           full() const = 0;
    virtual int           length() const = 0;
    
    virtual void          clear() = 0;
    
    void                  error(const char*) const;
    virtual int           OK() const = 0;
};


template<class Type> void 
Stack<Type>::error(const char* msg) const
{
    cerr << "Stack :" << msg;
}

#endif
