// -------------------------------------------------------------------------
// Programm : HIPS Highlevel Petrinetz Simulator/Editor 
// ----------------------------------------------------
// Datei    : String.cc
// Funktion : Implementation ein String- Klasse
//            nach Stroustrup
// Author   : Tobias Himstedt
//            Diplomarbeit 1994 
//            Universitaet Hildesheim
//            Institut fuer Theoretische Informatik
//            Prof. Dr. Best
// -------------------------------------------------------------------------
// Burkhard Bieber 1996
// Cecile Bui Thanh: changed FromTo because of an error in the size of the
//                   String built...
// last-update: Dec. 2001

#ifdef __GNUG__
#pragma implementation
#endif       

#include "String.h"

char NULL_STRING[1] = "";

void
String::Resize(int len)
{
    srep* p1;
    p1 = new srep;
    p1->s = new char[len+1];
    p1->len = len;
    
    if (p->s)
	strncpy(p1->s, p->s, ((unsigned int) len > p->len) ? p->len : len);
        
    p->n--;
    if (!p->n) 
	delete p;
    p = p1;
}


void
String::operator +=(const String& s1)
{
    if (!s1.p->s)
	return ;

    if (!p->s) {
	delete p;
	p = s1.p;
	p->n++;
	return ;
    }

    srep* old_p = p;
    p->n--;
    
    p = new srep;
    p->len = strlen(old_p->s) + strlen(s1.p->s);
    p->s = new char[p->len+1];
    
    strcpy(p->s, old_p->s);
    strcat(p->s, s1.p->s);

    if (!old_p->n)
	delete old_p;
}

String
String::StrTok(const String& delimiter, int& start, 
		 char& found_delimiter) const
{
    int f = 0;
    int j=0,i;
    
    found_delimiter = 0;
    
    if ((unsigned int) start>=length()) 
	return "";
    
    for (i=start; !f && (unsigned int) i<length(); i++) 
	for (j=0; !f && (unsigned int) j<delimiter.length(); j++) 
	    if ((*this)[i] == delimiter[j]) {  // Delimiter gefunden
		f = 1;
		break;
	    }
    
    // Kein Delimiter gefunden?
    if (!f) {  // von start an alles zurueck
	String d(length() - start);
	for (i=start; (unsigned int) i<length(); i++)
	    d[i-start] = (*this)[i];

	d[i-start] = 0;
	start = i;
	return d;
    }
	
    found_delimiter = delimiter[j];

    String d(i-1-start);
    for (j=0; j<i-1-start; j++)
	d[j] = (*this)[j+start];

    d[j] = 0;
    start = i;
    return d;
}

ostream&
operator <<(ostream& f, const String& s)
{
    if (s.p->s)
	f << s.p->s;
    else
	f << "NULL STRING";

    return f;
}

istream& 
operator >>(istream& s, String& x)
{
// TODO: ipfx is lost in g++ 3    if (!s.ipfx(0) ||
    if ((!(s.flags() & ios::skipws) && !ws(s))) {
	s.setstate(ios::failbit);
	return s;
    }
    int ch;
    int i = 0;
    x.Resize(50);
    register streambuf *sb = s.rdbuf();
    while ((ch = sb->sbumpc()) != EOF) {
	if (isspace(ch))
	    break;
	if ((unsigned int) i >= x.p->len) // evtl -1
	    x.Resize(i+1);
	x[i++] = ch;
    }
    x[i] = 0;
    s.clear();
    if (i == 0) s.setstate(ios::failbit);
    if (ch == EOF) s.setstate(ios::eofbit);
    return s;
}


int 
readline(istream& s, String& x, char terminator, int discard)
{
// TODO: ipfx is lost in g++ 3   if (!s.ipfx(0))
//	return 0;
    int ch;
    int i = 0;
    x.Resize(80);
    register streambuf *sb = s.rdbuf();
    while ((ch = sb->sbumpc()) != EOF) {
	if (ch != terminator || !discard) {
	    if ((unsigned int) i >= x.p->len)
		x.Resize(i+1);
	    x[i++] = ch;
	}
	if (ch == terminator)
	    break;
    }
    x[i] = 0;
    if (ch == EOF) s.setstate(ios::eofbit);
    return i;
}


String
String::FromTo(int a, int b) const
{
    int d = b > a ? b : a;
    int c = b < a ? b : a;
    int j = 0;
//    String res(d-c+1);
//    for (int i=c; i < d; i++,j++)
//        res[j] = (*this)[i];
//    res[j] = '\0';
    char * res = new char[d-c+2];
    for (int i=c; i < d; i++,j++)
        res[j] = (*this)[i];
    res[j] = 0;
    return (*(new String(res)));
}

