#ifndef UTILS_H
#define UTILS_H

#include "String.h"
#include "Socket.h"
#include "Set.h"
#include <tcl.h>

extern char *strdup(const char *);


extern String Tcl_ErrorMsg;

typedef int boolean;
#define true 1
#define false 0

extern "C" { 
void Error(const char* s);
}
 
#define INTRES(x) sprintf(ip->result,"%d",x)
#define EQ(nr, s) !strcmp(argv[nr], s)

unsigned int hash_string(const char* x); // From Dragon book, p436
unsigned int hash_int(int x);
// unsigned int foldhash(double x);

inline unsigned int
Hash(const String& s)
{
    return hash_string(s);
}

inline unsigned int
Hash(const int& i)
{
    return hash_int(i);
}

inline unsigned int
Hash(const Socket& s)
{
    return s.getsock();
}

inline int
Compare(const String& s1, const String& s2)
{
    return strcmp(s1,s2);
}

inline void
Result(Tcl_Interp* ip, const String& s)
{
    Tcl_SetResult(ip, strdup(s), TCL_DYNAMIC);
}

#endif
