/* Ulf Fildebrandt 1998
   Ein Beispiel, um die Verwendung des Schaltungsservers zu veranschaulichen.
*/

#include <iostream>
#include <fstream>
#include <string>
#include "../include/Socket.h"

int main(int argc, char *argv[]) {
  if(argc > 2) {

    // Einlesen des Netzes
    ifstream in(argv[1]);
    string text, line;
    char c;
    while(in) {
      in.get(c);
      text += c;
    }
    in.close();
    cout << "Netz " << argv[1] << " gelesen." << endl;

    // Verbindung zum Server herstellen
    string name = argv[2];
    Socket s(name, 8123);
    s.Connect();
    s.Write("Load");
    if(s.Read() != "OK")
      exit(0);
    s.Write(text);
    if(s.Read() != "OK")
      exit(0);

    cout << "Simulation beginnt..." << endl;

    s.Write("ActiveTransitions");
    while((text = s.Read()) != "") {
      cout << "Aktive Transitionen: " << text << endl;
      s.Write("Marking");
      cout << "Markierung:          " << s.Read() << endl;
      if(text.find(",") != string::npos) {
        text = text.substr(0,text.find(","));
      }
      s.Write("FireWithout");
      if(s.Read() != "OK")
        exit(0);
      cout << "Transition " << text << " wird geschaltet." << endl;
      s.Write(text);
      if(s.Read() != "OK")
        exit(0);
      s.Write("ActiveTransitions");
    }

    // Verbindung zum Server schliessen
    s.Write("Close");
  }
}
