/*****************************************************************************/
/* scanner.h                                                                 */
/*****************************************************************************/
/* Scanner fuer den Formel-Transformator.                                    */
/*****************************************************************************/
/*                                 Stefan Roemer,  13.07.1994-18.07.1994     */
/*****************************************************************************/

#ifndef __SCANNER_H__
#define __SCANNER_H__

#include "memlib.h"

/*****************************************************************************/

#define SPACE_STR_LEN 200

/*****************************************************************************/

extern FILE          *yyin, *yyout;
extern Cardinal32    FT_spaceLen;
extern char          * FT_space,
                     * FT_spaceMax;

/*****************************************************************************/
/* Der eigentliche Scanner.                                                  */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int yylex( void );

#else

int yylex( /* void */ );

#endif


/*****************************************************************************/
/* Fehlerbehandlungsroutine, die von dem von "yacc" erzeugten Parser benoe-  */
/* tigt wird; diese wird bei Fehlern, die waehrend des Parsens des Ausdrucks */
/* auftreten, aufgerufen und gibt die Fehlermeldung `msg` auf dem Bildschirm */
/* aus.                                                                      */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

extern int yyerror( char * msg );

#else

extern int yyerror( /* char * msg */ );

#endif

/*****************************************************************************/

#endif /* __SCANNER_H__ */

/*****************************************************************************/
/* END OF FILE scanner.h                                                     */
/*****************************************************************************/

