/*****************************************************************************/
/* SDLFORM.H                                                                 */
/*****************************************************************************/

#ifndef __SDLFORM_H__
#define __SDLFORM_H__

#include "list.h"
#include "readSDL.h"
#include "parser.h"
#include "mtupel.h"

/*****************************************************************************/

typedef struct
{
	Place place;
	int nr;
	int bits;
	MTupel value;
} *T_plref, plref_elem;

typedef struct t_defitem_elem
{
	char type;
	char *name;
	int nr;
	int size;
	T_list list;
	T_list used;
	T_list set;
	struct t_defitem_elem *proc;
} *T_defitem, defitem_elem;

typedef struct
{
	char *name;
	T_list set;
	int value;
} *T_variable, variable_elem;

typedef struct
{
	T_defitem ptr;
	int value;
	T_variable var;
} *T_ident, ident_elem;

typedef struct
{
	char *name;
	int value;
} *T_key, key_elem;

typedef struct
{
	char *name;
	T_list args;
} *T_sigident, sigident_elem;

/*****************************************************************************/

extern T_list sdl_defitems;
extern T_list sdl_variables;
extern T_list sdl_pidset;
extern T_ident sdl_system;
extern T_list sdl_states;
extern T_list sdl_pidlist;
extern T_list sdl_signals;

/*****************************************************************************/

#define alloc_plref() (MYmalloc(sizeof(plref_elem)))
#define alloc_defitem() (MYmalloc(sizeof(defitem_elem)))
#define alloc_variable() (MYmalloc(sizeof(variable_elem)))
#define alloc_ident() (MYmalloc(sizeof(ident_elem)))
#define alloc_key() (MYmalloc(sizeof(key_elem)))
#define alloc_sigident() (MYmalloc(sizeof(sigident_elem)))

int sdl_find_keyword(char*,void*);
int sdl_make_variable(char*,void*);
T_defitem sdl_search_var_def(T_defitem,char*);
T_ident sdl_search_var_ident(T_ident,char*);
BTree sdl_use_node(BTree);

/*****************************************************************************/

#endif /* __SDLFORM_H__ */

/*****************************************************************************/
/* END OF FILE sdlform.h                                                     */
/*****************************************************************************/

