/****************************************************************************/
/*             O P E R A T I O N S   O N   B I T - A R R A Y S              */
/****************************************************************************/

#include "bitarray.h"
#include "global.h"

static Cardinal32 GL_bitArrayLen;

/****************************************************************************/
/* Liefert Speicher fuer neues Bitarray zurueck, Groesse in GL_bitArrayLen  */

#if defined(__STDC__) || defined(__cplusplus)

BIT_ARRAY bit_alloc( void )

#else

BIT_ARRAY bit_alloc( )

#endif

{
  register Cardinal32 num = GL_bitArrayLen;
  register BIT_ARRAY ptr,ptr2;

  ptr=mymalloc_bitarray(GL_bitArrayLen);
  for ( ptr2 = ptr ; num-- ; *( ptr2++ ) = '\0')
    skip;
  return ptr;
}

/****************************************************************************/
/* Liefert den Wert der Arraygroesse zurueck                                */

#if defined(__STDC__) || defined(__cplusplus)

Cardinal32 bit_getsize( void )

#else

Cardinal32 bit_getsize( )

#endif

{
  return GL_bitArrayLen;
}

/****************************************************************************/
/* Setzt die Groesse der Bitarrays, muss vor dem ersten Erzeugen von Arrays */
/* aufgerufen werden, danach sollte keine weitere Aenderung gemacht werden  */

#if defined(__STDC__) || defined(__cplusplus)

void bit_setsize( Cardinal32 size )

#else

void bit_setsize( size )

  Cardinal32 size;

#endif

{
  GL_bitArrayLen=size;
}

/****************************************************************************/
/* Test, ob array1<array2 (-1), array1==array2 (0) oder array1>array2 (1).  */

#if defined(__STDC__) || defined(__cplusplus)

int bit_compare( BIT_ARRAY array1, BIT_ARRAY array2 )

#else

int bit_compare( array1, array2 )

  BIT_ARRAY array1;
  BIT_ARRAY array2;

#endif

  {

    register BIT_ARRAY  a1 = array1,
                        a2 = array2;
    register Cardinal32 len;

    for ( len = GL_bitArrayLen ; len && ( *a1 == *a2 ) ; len-- )
      {
        a1++;
        a2++;
      } /* for */

    return ( len ? ( *a1 < *a2 ? -1 : 1 ) : 0 );

  } /* bit_compare() */


/****************************************************************************/
/* Display a bit array as a place list.                                     */

#if defined(__STDC__) || defined(__cplusplus)

void bit_print_name( BIT_ARRAY arrayptr, LMPNet net )

#else

void bit_print_name( arrayptr, net )

  BIT_ARRAY arrayptr;
  LMPNet net;

#endif

  {

    register Place pl;

    putchar( '{' );
    for ( pl = net->Places ; pl && ! Test_Bit( arrayptr, pl->numname ) ;
          pl = pl->nextplace )
      skip;
    if (pl)
    {
    printf( "%s", pl->name );
    while ( (pl = pl->nextplace) )
      {
        if ( Test_Bit( arrayptr, pl->numname ))
          printf( ",%s", pl->name );
      } /* while */
    }
    puts( "}" );

  } /* bit_print() */


/****************************************************************************/
/* Display a bit array as a place list.                                     */

#if defined(__STDC__) || defined(__cplusplus)

void bit_print_numname( BIT_ARRAY arrayptr, LMPNet net )

#else

void bit_print_numname( arrayptr, net )

  BIT_ARRAY arrayptr;
  LMPNet net;

#endif

  {

    register Condition cond;

    putchar( '{' );
    for ( cond = net->Places ; cond && ! Test_Bit( arrayptr, cond->numname ) ;
          cond = cond->nextplace )
      skip;
    if ( cond )
      {
        printf( "C%u", cond->numname );
        while ( (cond = cond->nextplace) )
          {
            if ( Test_Bit( arrayptr, cond->numname ))
              printf( ",C%u", cond->numname );
          } /* while */
      } /* if */
    puts( "}" );

  } /* bit_print_numname() */

/*****************************************************************************/
/* Kopieren eines Bit-Arrays, Rueckgabewert ist das neuangelegte Bitarray    */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

BIT_ARRAY bit_copy( BIT_ARRAY array )

#else

BIT_ARRAY bit_copy( array )

  BIT_ARRAY array;

#endif

  {

    register Cardinal32 counter = GL_bitArrayLen;
    register BIT_ARRAY  ptr1,
                        ptr2 = array,
                        newarray;

    ptr1 = newarray = bit_alloc();
    while (( counter-- ))
      *(ptr1++) = *(ptr2++);
    return ( newarray );

  } /* bit_copy() */


/*****************************************************************************/
/* Vereinigen zweier Bit-Arrays.                                             */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

BIT_ARRAY bit_union( BIT_ARRAY array1, BIT_ARRAY array2 )

#else

BIT_ARRAY bit_union( array1, array2 )

  BIT_ARRAY array1,
            array2;

#endif

  {

    register Cardinal32 counter = GL_bitArrayLen;
    register BIT_ARRAY  ptr1 = array1,
                        ptr2 = array2;

    while (( counter-- ))
      *(ptr1++) |= *(ptr2++);
    return ( array1 );

  } /* bit_union() */


/*****************************************************************************/
/* Calculate the difference of two bit arrays.                               */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

BIT_ARRAY bit_difference( BIT_ARRAY array1, BIT_ARRAY array2 )

#else

BIT_ARRAY bit_difference( array1, array2 )

  BIT_ARRAY array1,
            array2;

#endif

  {

    register Cardinal32 counter = GL_bitArrayLen;
    register BIT_ARRAY  ptr1 = array1,
                        ptr2 = array2;

    while (( counter-- ))
      *(ptr1++) &= ~*(ptr2++);
    return ( array1 );

  } /* bit_difference() */

