/* Hilfsfunktionen fuer die (N)ERV-Entfaltung */

#include "cutoff_erv.h"
#include "hash.h"
#include "sub_unf.h"
#include "parikh.h"
#include "nets.h"
#include "queue.h"

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void ERV_Delete_Event_Postset( Event event )

#else

void ERV_Delete_Event_Postset( event )

  Event event;

#endif

  {

    register Condition cond,
                       * stackptr;
    register Event     ev;
    register TSEdge    ec;
    register STEdge    ce;
    register LIST      plptr,
                       pldel;

    IncCMark();
    IncEMark();
    InitCStack();

/*
printf("DELETE:\n");
*/
    for ( ec = event->postset ; ec ; ec = ec->nextplace )
      {
        cond = ec->place;
        if ( cond->postset )
          PushCondition( cond );
/*
printf("VORHER : ");
list_print((LIST) ( (Place) cond->inscript )->inscript );
*/
        if ( ( plptr = (LIST) ( (Place) cond->inscript )
                                                  ->inscript )->item == cond )
          {
            ( (Place) cond->inscript )->inscript = (char *) plptr->next;
            Free( plptr );
          } /* if */
        else
          {
            for ( skip ; plptr->next->item != cond ; plptr = plptr->next )
              skip;
            plptr->next = ( pldel = plptr->next )->next;
            Free( pldel );
          } /* else */
/*
printf("NACHHER: ");
list_print((LIST) ( (Place) cond->inscript )->inscript );
*/
        cond->numname = 0;
      } /* for */

    while ( (cond = PopCondition() ))
      {
        for ( ce = cond->postset ; ce ; ce = ce->nexttrans )
          {
            if ( IsNotEMarked( ev = ce->trans ) )
              {
                EMark( ev );
                ev->numname = 0;
                for ( ec = ev->postset ; ec ; ec = ec->nextplace )
                  {
                    cond = ec->place;
/*
printf("*VORHER : ");
list_print((LIST) ( (Place) cond->inscript )->inscript );
*/
                    if ( cond->postset )
                      PushCondition( cond );
                    if ( ( plptr = (LIST) ( (Place) cond->inscript )
                                                  ->inscript )->item == cond )
                      {
                        ( (Place) cond->inscript )->inscript
                                                       = (char *) plptr->next;
                        Free( plptr );
                      } /* if */
                    else
                      {
                        for ( skip ; plptr->next->item != cond ;
                                                         plptr = plptr->next )
                          skip;
                        plptr->next = ( pldel = plptr->next )->next;
                        Free( pldel );
                      } /* else */
/*
printf("*NACHHER: ");
list_print((LIST) ( (Place) cond->inscript )->inscript );
*/
                    cond->numname = 0;
                  } /* for */
              } /* if */
          } /* for */
      } /* while ( cond = ... )  */
/*
printf("END OF DELETE\n");
*/

  } /* ERV_Delete_Event_Postset() */


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int ERV_IsNotCutoffPoint_LIST( LIST finalStateList, Event event )

#else

int ERV_IsNotCutoffPoint_LIST( finalStateList, event )

  LIST  finalStateList;
  Event event;

#endif

  {

    register HASH      hash,
                       newhash;
    register int       test = 2;
    register TSEdge    ec;
    register LIST      plptr;
    Event              cutoffevent;
    bool               previous = False;

    if ( GL_flags & CHECK_CONFIGS )
      {
        if ( (int) event > 10 )
          {
            printf( "E%u: ", event->numname );
            printf( "(depth=%u) ", (Cardinal32) event->label );
            printf( "(size=%u) ", GL_configSize );
          } /* if */
        else
          {
            printf( "--  Start Marking  --: " );
          } /* else */
        list_print( finalStateList );
      } /* if */
#ifdef BLOSSEINTEST
if ( (int) event > 10 )
{
    register Place      cond,
                        * stackptr;
    register Event      ev, ev2;
    register STEdge     ce;
    register TSEdge     ec;

    ev2 = event;
    IncCMark();
    IncEMark();
    InitCStack();
    EMark( event );
printf("[e%u] = {e%u",event->numname,event->numname);
    for ( ce = event->preset ; ce ; ce = ce->nextplace )
      {
        CMark( PushCondition( ce->place ) );
      } /* for */
    while ( (cond = PopCondition()) )
      {
        if ( IsNotEMarked( ev = cond->preset->trans ) )
          {
            EMark( ev );
printf(",e%u",ev->numname);
            for ( ce = ev->preset ; ce ; ce = ce->nextplace )
              {
                CMark( cond = ce->place );
                if ( ( ec = cond->preset ) && IsNotEMarked( ec->trans ))
                  PushCondition( cond );
              } /* for */
          } /* if */
      } /* while */
printf("}\n");
  event = ev2;
}
#endif /* BLOSSEINTEST */

    if (    ( hash = GL_hashTable[ GL_hashIndex ] )
         && ( ( test = list_compare( finalStateList, hash->list ) ) == 1 ) )
      {
/*
printf("-- GROESSER\n");
*/
        while ( ( newhash = hash->next ) && ( ( test = list_compare(
                                    finalStateList, newhash->list ) ) == 1 ) )
          {
/*
printf("-- GROESSER\n");
*/
            hash = newhash;
          } /* while */
        if ( newhash && ! test ) /* Markierung gefunden */
          {
/*
printf("-- GLEICH\n");
*/
if ( GL_configSize < ( hash = newhash )->minConfigSize )
{ printf( "E R R O R ?\n" ); }
else
            if (    ( GL_configSize < ( hash = newhash )->minConfigSize )
                 || (    ( GL_configSize == hash->minConfigSize )
                      && ( P_compare( event, hash->event ) < 0 ) ) )
              { /* [event] < [hash->event] ==> hash->event ist cutoff! */
#ifdef LOG_THE_CUTOFFS
printf("(PREVIOUS) CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
#ifdef LOG_THE_CUTOFFS
#endif /* LOG_THE_CUTOFFS */
                ERV_Delete_Event_Postset( hash->event );
                hash->minConfigSize = GL_configSize;
                cutoffevent = hash->event;
for ( ec = cutoffevent->postset ; ec ; ec = ec->nextplace )
  ec->place->label = 4;
hash->event->postset = NULL;
                hash->event = event;
                previous = True;
/*
                if ( GL_flags & LAST_CORR_EVENT )
                  hash->event = event;
*/
              } /* if */
            else
              { /* [event] > [hash->event] ==> event ist cutoff! */
#ifdef LOG_THE_CUTOFFS
printf("CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
                cutoffevent = event;
              } /* else */
            list_delete( &finalStateList );
          } /* if */
        else /* Markierung ist noch nicht ermittelt worden */
          {
/*
printf("-- NEU\n");
*/
            ( newhash = (HASH) MYmalloc( sizeof( HASH_ELEM ) ) )->event = event;
            newhash->list = finalStateList;
            newhash->minConfigSize = GL_configSize;
            newhash->next = hash->next;
            hash = hash->next = newhash;
          } /* else */
      } /* if */
    else if ( ! test ) /* Markierung gefunden am Anfang */
      {
/*
printf("-- ANFANG\n");
*/
if ( GL_configSize < hash->minConfigSize )
{ printf( "E R R O R ?\n" ); }
else
        if (    ( GL_configSize < hash->minConfigSize ) /* UEBERFLUESSIG !! */
             || (    ( GL_configSize == hash->minConfigSize )
                  && ( P_compare( event, hash->event ) < 0 ) ) )
          { /* [event] < [hash->event] ==> hash->event ist cutoff! */
#ifdef LOG_THE_CUTOFFS
printf("(PREVIOUS) CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
            ERV_Delete_Event_Postset( hash->event );
            hash->minConfigSize = GL_configSize;
            cutoffevent = hash->event;
for ( ec = cutoffevent->postset ; ec ; ec = ec->nextplace )
  ec->place->label = 4;
hash->event->postset = NULL;
            hash->event = event;
            previous = True;
/*
            if ( GL_flags & LAST_CORR_EVENT )
              hash->event = event;
*/
          } /* if */
        else
          { /* [event] > [hash->event] ==> event ist cutoff! */
#ifdef LOG_THE_CUTOFFS
printf("CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
            cutoffevent = event;
          } /* else */
        list_delete( &finalStateList );
      } /* else if */
    else /* Liste noch leer */
      {
/*
printf("-- LEER\n");
*/
        ( hash = (HASH) MYmalloc( sizeof( HASH_ELEM ) ) )->list = finalStateList;
        hash->minConfigSize = GL_configSize;
        hash->next = GL_hashTable[ GL_hashIndex ];
        ( GL_hashTable[ GL_hashIndex ] = hash )->event = event;
      } /* else */

    if ( ! test )
      {
        GL_numCutoffs++;
        ( ( plptr = allocLIST() )->next = GL_cutoffList );
        ( GL_cutoffList = plptr )->item = (Place) cutoffevent;
        ( ( plptr = allocLIST() )->next = GL_cutoffCorrespondingList );
        ( GL_cutoffCorrespondingList = plptr )->item = (Place) hash->event;
      } /* if */
/*
printf("Cutoffs: ");
list_print(GL_cutoffList);
*/

    return ( test || previous );

  } /* ERV_IsNotCutoffPoint_LIST() */


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int ERV_IsNotCutoffPoint_ARRAY( LIST finalStateList, Event event )

#else

int ERV_IsNotCutoffPoint_ARRAY( finalStateList, event )

  LIST  finalStateList;
  Event event;

#endif

  {

    register HASH      hash,
                       newhash;
    register BIT_ARRAY finalStateArray = (BIT_ARRAY) finalStateList;
    register int       test = 2;
    register TSEdge    ec;
    register LIST      plptr,
                       pldel;
    register Condition cond;
    Event              cutoffevent;
    bool               previous = False;

    if ( GL_flags & CHECK_CONFIGS )
      {
        if ( (int) event > 10 )
          {
            printf( "E%u: ", event->numname );
            printf( "(depth=%u) ", (Cardinal32) event->label );
            printf( "(size=%u) ", GL_configSize );
          } /* if */
        else
          {
            printf( "--  Start Marking  --: " );
          } /* else */
        bit_print_name( (BIT_ARRAY) finalStateList, GL_net );
      } /* if */

    if ( ( hash = GL_hashTable[ GL_hashIndex ] )
           && ( ( test = bit_compare( finalStateArray,
                                            (BIT_ARRAY) hash->list ) ) == 1 ) )
      {
        while ( ( newhash = hash->next ) && ( ( test = bit_compare(
                        finalStateArray, (BIT_ARRAY) newhash->list ) ) == 1 ) )
          {
            hash = newhash;
          } /* while */
        if ( newhash && ! test )
          {
            if (    ( GL_configSize <= ( hash = newhash )->minConfigSize )
                 || (    ( GL_configSize == hash->minConfigSize )
                      && ( P_compare( event, hash->event ) < 0 ) ) )
              { /* [event] < [hash->event] ==> hash->event is cutoff! */
#ifdef LOG_THE_CUTOFFS
printf("(PREVIOUS) CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
                for ( ec = hash->event->postset ; ec ; ec = ec->nextplace )
                  {
                    cond = ec->place;
                    if ( ( plptr = (LIST) ( (Place) cond->inscript )
                                                  ->inscript )->item == cond )
                      {
                        ( (Place) cond->inscript )->inscript
                                                        = (char *) plptr->next;
                        Free( plptr );
                      } /* if */
                    else
                      {
                        for ( skip ; plptr->next->item != cond ;
                                                         plptr = plptr->next )
                          skip;
                        plptr->next = ( pldel = plptr->next )->next;
                        Free( pldel );
                      } /* else */
                  } /* for */
                hash->minConfigSize = GL_configSize;
                hash->event = event;
                cutoffevent = hash->event;
                previous = True;
/*
                if ( GL_flags & LAST_CORR_EVENT )
                  hash->event = event;
*/
              } /* if */
            else
              { /* [event] > [hash->event] ==> event ist cutoff! */
#ifdef LOG_THE_CUTOFFS
printf("CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
                cutoffevent = event;
              } /* else */
            Free( finalStateArray );
if ( (int) event > 2 ) event->preset->weight = (Cardinal32) newhash->list;
          } /* if */
        else
          {
            ( newhash = (HASH) MYmalloc( sizeof( HASH_ELEM ) ) )->event = event;
            newhash->list = (LIST) finalStateArray;
            newhash->minConfigSize = GL_configSize;
            newhash->next = hash->next;
            hash = hash->next = newhash;
if ( (int) event > 2 ) event->preset->weight = (Cardinal32) finalStateArray;
          } /* else */
      } /* if */
    else if ( ! test )
      {
        if (    ( GL_configSize < hash->minConfigSize ) /* UEBERFLUESSIG !! */
             || (    ( GL_configSize == hash->minConfigSize )
                  && ( P_compare( event, hash->event ) < 0 ) ) )
          { /* [event] < [hash->event] ==> hash->event ist cutoff! */
#ifdef LOG_THE_CUTOFFS
printf("(PREVIOUS) CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
            for ( ec = hash->event->postset ; ec ; ec = ec->nextplace )
              {
                cond = ec->place;
                if ( ( plptr = (LIST) ( (Place) cond->inscript )->inscript )
                                                              ->item == cond )
                  {
                    ( (Place)cond->inscript )->inscript = (char *)plptr->next;
                    Free( plptr );
                  } /* if */
                else
                  {
                    for ( skip ; plptr->next->item != cond ;
                                                         plptr = plptr->next )
                      skip;
                    plptr->next = ( pldel = plptr->next )->next;
                    Free( pldel );
                  } /* else */
              } /* for */
            hash->minConfigSize = GL_configSize;
            hash->event = event;
            cutoffevent = hash->event;
            previous = True;
/*
            if ( GL_flags & LAST_CORR_EVENT )
              hash->event = event;
*/
          } /* if */
        else
          { /* [event] > [hash->event] ==> event ist cutoff! */
#ifdef LOG_THE_CUTOFFS
printf("CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
            cutoffevent = event;
          } /* else */
        Free( finalStateArray );
if ( (int) event > 2 ) event->preset->weight = (Cardinal32) hash->list;
      } /* else if */
    else
      {
        ( hash = (HASH) MYmalloc( sizeof( HASH_ELEM ) ) )->list
                                                      = (LIST) finalStateArray;
        hash->minConfigSize = GL_configSize;
        hash->next = GL_hashTable[ GL_hashIndex ];
        ( GL_hashTable[ GL_hashIndex ] = hash )->event = event;
if ( (int) event > 2 ) event->preset->weight = (Cardinal32) finalStateArray;
      } /* else */

    if ( ! test )
      {
        GL_numCutoffs++;
        ( ( plptr = allocLIST() )->next = GL_cutoffList );
        ( GL_cutoffList = plptr )->item = (Place) cutoffevent;
        ( ( plptr = allocLIST() )->next = GL_cutoffCorrespondingList );
        ( GL_cutoffCorrespondingList = plptr )->item = (Place) hash->event;
      } /* if */

#ifdef DAS_KANN_WEG
if ( GL_flags & CHECK_CONFIGS )
  {
    if ( (int) event > 10 )
      {
        printf( "E%u: ", event->numname );
        printf( "(depth=%u) ", (Cardinal32) event->label );
        printf( "(size=%u) ", GL_configSize );
        bit_print_name( (BIT_ARRAY) event->preset->weight, GL_net );
      } /* if */
    else
      {
        printf( "--  Start Marking  --: " );
        bit_print_name( GL_BitStartMarking, GL_net );
      } /* else */
  } /* if */
#endif

    return ( test || previous );

  } /* ERV_IsNotCutoffPoint_ARRAY() */


/*****************************************************************************/
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int NERV_IsNotCutoffPoint_LIST( LIST finalStateList, Event event )

#else

int NERV_IsNotCutoffPoint_LIST( finalStateList, event )

  LIST  finalStateList;
  Event event;

#endif

  {

    register HASH      hash,
                       newhash;
    register int       test = 2;
    register LIST      newCutoff;

    if ( GL_flags & CHECK_CONFIGS )
      {
        if ( (int) event > 10 )
          {
            printf( "E%u: ", event->numname );
            printf( "(depth=%u) ", (Cardinal32) event->label );
            printf( "(size=%u) ", GL_configSize );
          } /* if */
        else
          {
            printf( "--  Start Marking  --: " );
          } /* else */
        list_print( finalStateList );
      } /* if */
#ifdef BLOSSEINTEST
if ( (int) event > 10 )
{
    register Place      cond,
                        * stackptr;
    register Event      ev, ev2;
    register STEdge     ce;
    register TSEdge     ec;

    ev2 = event;
    IncCMark();
    IncEMark();
    InitCStack();
    EMark( event );
printf("[e%u] = {e%u",event->numname,event->numname);
    for ( ce = event->preset ; ce ; ce = ce->nextplace )
      {
        CMark( PushCondition( ce->place ) );
      } /* for */
    while ( (cond=PopCondition()) )
      {
        if ( IsNotEMarked( ev = cond->preset->trans ) )
          {
            EMark( ev );
printf(",e%u",ev->numname);
            for ( ce = ev->preset ; ce ; ce = ce->nextplace )
              {
                CMark( cond = ce->place );
                if ( ( ec = cond->preset ) && IsNotEMarked( ec->trans ))
                  PushCondition( cond );
              } /* for */
          } /* if */
      } /* while */
printf("}\n");
  event = ev2;
}
#endif /* BLOSSEINTEST */

    if (    ( hash = GL_hashTable[ GL_hashIndex ] )
         && ( ( test = list_compare( finalStateList, hash->list ) ) == 1 ) )
      {
        while ( ( newhash = hash->next ) && ( ( test = list_compare(
                                    finalStateList, newhash->list ) ) == 1 ) )
          {
            hash = newhash;
          } /* while */
        if ( newhash && ! test ) /* Markierung gefunden */
          {
#ifdef LOG_THE_CUTOFFS
printf("CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
            list_delete( &finalStateList );
          } /* if */
        else /* Markierung ist noch nicht ermittelt worden */
          {
            ( newhash = (HASH) MYmalloc( sizeof( HASH_ELEM ) ) )->event = event;
            newhash->list = finalStateList;
            newhash->minConfigSize = GL_configSize;
            newhash->next = hash->next;
            hash = hash->next = newhash;
          } /* else */
      } /* if */
    else if ( ! test ) /* Markierung gefunden am Anfang */
      {
#ifdef LOG_THE_CUTOFFS
printf("CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
        list_delete( &finalStateList );
      } /* else if */
    else /* Liste noch leer */
      {
        ( hash = (HASH) MYmalloc( sizeof( HASH_ELEM ) ) )->list = finalStateList;
        hash->minConfigSize = GL_configSize;
        hash->next = GL_hashTable[ GL_hashIndex ];
        ( GL_hashTable[ GL_hashIndex ] = hash )->event = event;
      } /* else */

    if ( ! test )
      {
        GL_numCutoffs++;
        ( ( newCutoff = allocLIST() )->next = GL_cutoffList );
        ( GL_cutoffList = newCutoff )->item = (Place) event;
        ( ( newCutoff = allocLIST() )->next = GL_cutoffCorrespondingList );
        ( GL_cutoffCorrespondingList = newCutoff )->item = (Place) hash->event;
      } /* if */
/*
printf("Cutoffs: ");
list_print(GL_cutoffList);
*/

    return ( test );

  } /* NERV_IsNotCutoffPoint_LIST() */


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int NERV_IsNotCutoffPoint_ARRAY( LIST finalStateList, Event event )

#else

int NERV_IsNotCutoffPoint_ARRAY( finalStateList, event )

  LIST  finalStateList;
  Event event;

#endif

  {

    register HASH      hash,
                       newhash;
    register BIT_ARRAY finalStateArray = (BIT_ARRAY) finalStateList;
    register int       test = 2;
    register LIST      newCutoff;

    if ( GL_flags & CHECK_CONFIGS )
      {
        if ( (int) event > 10 )
          {
            printf( "E%u: ", event->numname );
            printf( "(depth=%u) ", (Cardinal32) event->label );
            printf( "(size=%u) ", GL_configSize );
          } /* if */
        else
          {
            printf( "--  Start Marking  --: " );
          } /* else */
        bit_print_name( (BIT_ARRAY) finalStateList, GL_net );
      } /* if */

    if ( ( hash = GL_hashTable[ GL_hashIndex ] )
           && ( ( test = bit_compare( finalStateArray,
                                            (BIT_ARRAY) hash->list ) ) == 1 ) )
      {
        while ( ( newhash = hash->next ) && ( ( test = bit_compare(
                        finalStateArray, (BIT_ARRAY) newhash->list ) ) == 1 ) )
          {
            hash = newhash;
          } /* while */
        if ( newhash && ! test )
          {
#ifdef LOG_THE_CUTOFFS
printf("CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
            Free( finalStateArray );
if ( (int) event > 2 ) event->preset->weight = (Cardinal32) newhash->list;
          } /* if */
        else
          {
            ( newhash = (HASH) MYmalloc( sizeof( HASH_ELEM ) ) )->event = event;
            newhash->list = (LIST) finalStateArray;
            newhash->minConfigSize = GL_configSize;
            newhash->next = hash->next;
            hash = hash->next = newhash;
if ( (int) event > 2 ) event->preset->weight = (Cardinal32) finalStateArray;
          } /* else */
      } /* if */
    else if ( ! test )
      {
#ifdef LOG_THE_CUTOFFS
printf("CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
        Free( finalStateArray );
if ( (int) event > 2 ) event->preset->weight = (Cardinal32) hash->list;
      } /* else if */
    else
      {
        ( hash = (HASH) MYmalloc( sizeof( HASH_ELEM ) ) )->list
                                                      = (LIST) finalStateArray;
        hash->minConfigSize = GL_configSize;
        hash->next = GL_hashTable[ GL_hashIndex ];
        ( GL_hashTable[ GL_hashIndex ] = hash )->event = event;
if ( (int) event > 2 ) event->preset->weight = (Cardinal32) finalStateArray;
      } /* else */

    if ( ! test )
      {
        GL_numCutoffs++;
        ( ( newCutoff = allocLIST() )->next = GL_cutoffList );
        ( GL_cutoffList = newCutoff )->item = (Place) event;
        ( ( newCutoff = allocLIST() )->next = GL_cutoffCorrespondingList );
        ( GL_cutoffCorrespondingList = newCutoff )->item = (Place) hash->event;
      } /* if */

#ifdef DAS_KANN_WEG
if ( GL_flags & CHECK_CONFIGS )
  {
    if ( (int) event > 10 )
      {
        printf( "E%u: ", event->numname );
        printf( "(depth=%u) ", (Cardinal32) event->label );
        printf( "(size=%u) ", GL_configSize );
        bit_print_name( (BIT_ARRAY) event->preset->weight, GL_net );
      } /* if */
    else
      {
        printf( "--  Start Marking  --: " );
        bit_print_name( GL_BitStartMarking, GL_net );
      } /* else */
  } /* if */
#endif

    return ( test );

  } /* NERV_IsNotCutoffPoint_ARRAY() */


