#ifndef __CUTOFF_EV_H__
#define __CUTOFF_EV_H__

#include "global.h"
#include "parikh.h"


/*****************************************************************************/
/* Insert a new event in the unfolding.                                      */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

Event Insert_Event_With_CE_Edges( LMPNet unfold_net, Transition tr_org,
                                  Condition * conds );

#else

Event Insert_Event_With_CE_Edges( unfold_net, tr_org, conds );

#endif

/*****************************************************************************/
/* Check for the cut-off property.                                           */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int IsNotCutoffEvent_LIST( LIST          finalStateList,
                           Event         event);

#else

int IsNotCutoffEvent_LIST( finalStateList, event );

#endif

/*****************************************************************************/
/* The function 'mark()' ( also known as 'final_state()' ).                  */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

LIST Mark_LIST( Event event, LMPNet unfold_net );

#else

LIST Mark_LIST( event, unfold_net );

#endif

/*****************************************************************************/
/* Check for the cut-off property.                                           */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int IsNotCutoffEvent_ARRAY( LIST          finalStateList,
                            Event         event );

#else

int IsNotCutoffEvent_ARRAY( finalStateList, event );

#endif

/*****************************************************************************/
/* The function 'mark()' ( also known as 'final_state()' ).                  */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

LIST Mark_ARRAY( Event event, LMPNet unfold_net );

#else

LIST Mark_ARRAY( event, unfold_net );

#endif

#endif /* __CUTOFF_EV_H__ */
