/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/
/*$$$  THE FOLLOWING ROUTINES STORE ONLY THE SIZE OF THE CONFIGURATIONS   $$$*/
/*$$$                    AND NOT THE PARIKH VECTORS.                      $$$*/
/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

#include "cutoff_ev2.h"
#include "sub_unf.h"
#include "cutoff_erv.h"
#include "hash.h"

#define LOOK_ONLY_AT_SIZES
#ifdef LOOK_ONLY_AT_SIZES

/*****************************************************************************/
/* Insert a new possible extension in the queue.                             */
/* same as insert_PE_queue_condarray except for comparison using size here   */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

PE_QUEUE insert_PE_queue_condarray_size( Transition trans )

#else

PE_QUEUE insert_PE_queue_condarray_size( trans )

  Transition trans;

#endif

  {

    register Condition  * ptr,
                        * copy;
    register Cardinal32 count;
    register PE_QUEUE   qu,
                        qunew;

    qunew = (PE_QUEUE) MYmalloc( sizeof( PE_QUEUE_Entry ) );
    qunew->conds = copy = 
      (Condition *) MYmalloc( ( GL_maxTpreset + 1 ) * sizeof( Condition ) );
    *copy = (Condition) trans;
    ptr = GL_CArray;
    for ( count = (Cardinal32) trans->inscript ; count-- ; *++copy = *(ptr++) )
      skip;
#ifdef _EV_DISPLAY_IT_
copy = qunew->conds;
printf("INSERT_PRESET WAS (%s): ",trans->name);
count = (Cardinal32) trans->inscript;
while ((count--))
{ copy++;
printf("C%u(P%u/%s),", (*copy)->numname,((Place)(*copy)->inscript)->numname,
((Place)(*copy)->inscript)->name); }
printf("!\n");
#endif /* _EV_DISPLAY_IT_ */
    count = (Cardinal32) ( qunew->parikh = GL_Calculate_PSize_T( trans ) );

    if ( GL_flags & SORT_BEGIN )
      {
        if ( (qu = GL_PE_queue) )
          {
            if ( count <= (Cardinal32) qu->parikh )
              {
                qunew->next = GL_PE_queue;
                GL_PE_queue = qunew;
              } /* if */
            else
              {
                for ( skip ; qu->next
                 && ( count > (Cardinal32) qu->next->parikh ) ; qu = qu->next )
                  skip;
                qunew->next = qu->next;
                qu->next = qunew;
              } /* else */
          } /* if */
        else
          {
            ( GL_PE_queue = qunew )->next = NULL;
          } /* else */
      } /* if */
    else /* sort in from behind */
      {
        if ( ( qu = GL_PE_queue_last ) && ( count < (Cardinal32) qu->parikh ) )
          {
            while ( ( qu = qu->prev ) && ( count < (Cardinal32) qu->parikh ) )
              skip;
            if ( qu )
              {
                ( qu->next = ( qunew->next = qu->next )->prev = qunew )
                                                                   ->prev = qu;
              } /* if */
            else
              {
                ( GL_PE_queue = ( ( qunew->next=GL_PE_queue )->prev = qunew ) )
                                                                 ->prev = NULL;
              } /* else */
          } /* if */
        else if ( qu )
          {
            ( GL_PE_queue_last = ( ( GL_PE_queue_last->next = qunew )->prev
                                     = GL_PE_queue_last )->next )->next = NULL;
          } /* else if */
        else
          {
            ( GL_PE_queue = GL_PE_queue_last = qunew )->prev = qunew->next
                                                                        = NULL;
          } /* else */
      } /* else */

#if defined( _EV_DISPLAY_IT_ ) || defined( _TRACE_EV_QUEUE_ )
Display_PE_Queue();
#endif /* _EV_DISPLAY_IT_ */

    return ( qunew );

  } /* insert_PE_queue_condarray_size() */


/*****************************************************************************/
/* Insert a new possible extension in the queue.                             */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

PE_QUEUE insert_PE_queue_condlist_size( Transition trans )

#else

PE_QUEUE insert_PE_queue_condlist_size( trans )

  Transition trans;

#endif

  {

    register Condition  * copy,
                        * ccopy = GL_CArray;
    register LIST       * listArrayPtr;
    register PE_QUEUE   qu,
                        qunew;
    register Cardinal32 count;

    qunew = (PE_QUEUE) MYmalloc( sizeof( PE_QUEUE_Entry ) );
    qunew->conds = copy =
      (Condition *) MYmalloc( ( GL_maxTpreset + 1 ) * sizeof( Condition ) );
    *copy = (Condition) trans;
    *ccopy = *++copy = (Condition) *( listArrayPtr = GL_listArray1 );

#ifdef _EV_DISPLAY_IT_
printf("PRESET SIZE = %u\n", (Cardinal32) trans->inscript);
/*
printf("CONDITION POINTER IS %p.\n", *copy);
*/
printf("CONDITION IS C%u.\n", (*copy)->numname);
#endif /* _EV_DISPLAY_IT_ */

    while ( *++listArrayPtr )
      {
        *++ccopy = *++copy = ( *( listArrayPtr++ ) )->item;

#ifdef _EV_DISPLAY_IT_
/*
printf("CONDITION POINTER IS %p.\n", *copy);
*/
printf("CONDITION IS C%u.\n", (*copy)->numname);
#endif /* _EV_DISPLAY_IT_ */

      } /* while */
#ifdef _EV_DISPLAY_IT_
{
Cardinal32 count = (Cardinal32) trans->inscript;
copy = qunew->conds;
printf("COND-PRESET (%s/T%u): ", trans->name, trans->numname);
while (count--)
  {
    printf("C%u,", (*++copy)->numname);
  } /* while */
printf("\n");
copy = qunew->conds;
printf("INSERT_PRESET WAS (%s): ",trans->name);
for ( count = (Cardinal32) trans->inscript ; count-- ; skip )
{
copy++;
printf("C%u(P%u/%s),", (*copy)->numname,((Place)(*copy)->inscript)->numname,
((Place)(*copy)->inscript)->name);
}
printf("!\n");
}
#endif /* _EV_DISPLAY_IT_ */

    count = (Cardinal32) ( qunew->parikh = GL_Calculate_PSize_T( trans ) );

    if ( GL_flags & SORT_BEGIN )
      {
        if ( (qu = GL_PE_queue) )
          {
            if ( count <= (Cardinal32) qu->parikh )
              {
                qunew->next = GL_PE_queue;
                GL_PE_queue = qunew;
              } /* if */
            else
              {
                for ( skip ; qu->next
                 && ( count > (Cardinal32) qu->next->parikh ) ; qu = qu->next )
                  skip;
                qunew->next = qu->next;
                qu->next = qunew;
              } /* else */
          } /* if */
        else
          {
            ( GL_PE_queue = qunew )->next = NULL;
          } /* else */
      } /* if */
    else /* sort in from behind */
      {
        if ( ( qu = GL_PE_queue_last ) && ( count < (Cardinal32) qu->parikh ) )
          {
            while ( ( qu = qu->prev ) && ( count < (Cardinal32) qu->parikh ) )
              skip;
            if ( qu )
              {
                ( qu->next = ( qunew->next = qu->next )->prev = qunew )
                                                                   ->prev = qu;
              } /* if */
            else
              {
                ( GL_PE_queue = ( ( qunew->next = GL_PE_queue )->prev
                                                     = qunew ) ) ->prev = NULL;
              } /* else */
          } /* if */
        else if ( qu )
          {
            ( GL_PE_queue_last = ( ( GL_PE_queue_last->next = qunew )->prev
                                     = GL_PE_queue_last )->next )->next = NULL;
          } /* else if */
        else
          {
            ( GL_PE_queue = GL_PE_queue_last = qunew )->prev = qunew->next
                                                                        = NULL;
          } /* else */
      } /* else */

#if defined( _EV_DISPLAY_IT_ ) || defined( _TRACE_EV_QUEUE_ )
Display_PE_Queue();
#endif /* _EV_DISPLAY_IT_ */

    return ( qunew );

  } /* insert_PE_queue_condlist_size() */

/*****************************************************************************/
/* Check for the cut-off property.                                           */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

static void Recalculate_conflicts_size( Event event )

#else

static void Recalculate_conflicts_size( event )

  Event event;

#endif

  {

    register Place      cond,
                        * stackptr,
                        * stackptr2;
    register Event      ev;
    register STEdge     ce;
    register TSEdge     ec;
    register Cardinal32 sum,
                        num;
    register BIT_ARRAY  conflArrayPtr;

    num = ( GL_unfold_net->NumPlaces + (Cardinal32)
                        ( (Transition) event->inscript )->prevtrans + 2 ) >> 3;
    for ( conflArrayPtr = GL_conflictArray ; num-- ;
                                                  *( conflArrayPtr++ ) = '\0' )
      skip;

    IncCMark();
    IncEMark();
    InitCStack();
    *( stackptr2 = GL_stackC2 ) = NULL;
    sum = 1;
    EMark( event );
    for ( ce = event->preset ; ce ; ce = ce->nextplace )
      {
        if (( ( cond = ce->place )->postset->nexttrans ))
          *++stackptr2=cond;
        Set_Bit( GL_conflictArray, cond->numname );
        CMark( PushCondition( cond ) );
      } /* for */
    while ( (cond = PopCondition()) )
      {
        if ( IsNotEMarked( ev = cond->preset->trans ) )
          {
            EMark( ev );
            sum++;
            for ( ce = ev->preset ; ce ; ce = ce->nextplace )
              {
                CMark( cond = ce->place );
                ec = cond->preset;
                if ( ec && IsNotEMarked( ec->trans ))
                  PushCondition( cond );
                Set_Bit( GL_conflictArray, cond->numname );
                if (( cond->postset->nexttrans ))
                  *++stackptr2 = cond;
              } /* for */
          } /* if */
      } /* while */
    GL_configSize = sum;

    GL_stackC2ptr = stackptr2;

  } /* Recalculate_conflicts_size() */


/*****************************************************************************/
/* Check for the cut-off property.                                           */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int IsNotCutoffEvent_LIST_size( LIST          finalStateList,
				Event         event )

#else

int IsNotCutoffEvent_LIST_size( finalStateList, event )

  LIST          finalStateList;
  Event         event;

#endif

  {

    register HASH   hash,
                    newhash;
    register LIST   newCutoff;
    register int    test = 2;
    register TSEdge ec;
    Event           cutoffevent;
    bool            previous = False;

    if ( GL_flags & CHECK_CONFIGS )
      {
        if ( (int) event > 10 )
          {
            printf( "E%u: ", event->numname );
            printf( "(depth=%u) ", (Cardinal32) event->label );
            printf( "(size=%u) ", GL_configSize );
          } /* if */
        else
          {
            printf( "--  Start Marking  --: " );
          } /* else */
        list_print( finalStateList );
      } /* if */

    if ( ( hash = GL_hashTable[ GL_hashIndex ] )
           && ( ( test = list_compare( finalStateList, hash->list ) ) == 1 ) )
      {
        while ( ( newhash = hash->next ) && ( ( test = list_compare(
                                    finalStateList, newhash->list ) ) == 1 ) )
          {
            hash = newhash;
          } /* while */
        if ( newhash && ! test )
          {
            /* Cutoff event found */
/*
printf( "VGL-A: %u-%u\n", GL_configSize, newhash->minConfigSize );
*/
	    hash = newhash;
            list_delete( &finalStateList );
if ( GL_configSize < hash->minConfigSize )
{ printf( "Q U E U E I N G   E R R O R ! -- A: %u-%u\n",
  GL_configSize, hash->minConfigSize ); 
}
else
  {
            if (    ( GL_configSize == hash->minConfigSize )
                 && ( P_compare( event, hash->event ) < 0 ) )
              { /* [event] < [hash->event] ==> hash->event ist cutoff! */
#ifdef LOG_THE_CUTOFFS
printf("(PREVIOUS) CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
                ERV_Delete_Event_Postset( hash->event );
                hash->minConfigSize = GL_configSize;
                cutoffevent = hash->event;
for ( ec = cutoffevent->postset ; ec ; ec = ec->nextplace )
  ec->place->label = 4;
cutoffevent->postset = NULL;
                hash->event = event;
/*
                Recalculate_conflicts_size( hash->event = event );
*/
                previous = True;
/*
                if ( GL_flags & LAST_CORR_EVENT )
                  hash->event = event;
*/
              } /* if */
            else
              { /* [event] > [hash->event] ==> event ist cutoff! */
#ifdef LOG_THE_CUTOFFS
printf("CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
                cutoffevent = event;
              } /* else */
  } /* else */
	  } /* if */
        else
          {
            ( newhash = (HASH) MYmalloc( sizeof( HASH_ELEM ) ) )->event = event;
            newhash->list = finalStateList;
            newhash->minConfigSize = GL_configSize;
            newhash->next = hash->next;
            hash = hash->next = newhash;
          } /* else */
      } /* if */
    else if ( ! test )
      {
        /* Cutoff event found */
        list_delete( &finalStateList );
/*
printf( "VGL-B: %u-%u\n", GL_configSize, hash->minConfigSize );
*/
if ( GL_configSize < hash->minConfigSize )
    /* Offensichtlich fehlte hier das ->numname */
{ printf( "Q U E U E I N G   E R R O R ! -- B: %u-%u(E%u)\n",
  GL_configSize, hash->minConfigSize, hash->event->numname ); }
else
        if (    ( GL_configSize == hash->minConfigSize )
             && ( P_compare( event, hash->event ) < 0 ) )
          { /* [event] < [hash->event] ==> hash->event ist cutoff! */
#ifdef LOG_THE_CUTOFFS
printf("(PREVIOUS) CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
            ERV_Delete_Event_Postset( hash->event );
            hash->minConfigSize = GL_configSize;
            cutoffevent = hash->event;
for ( ec = cutoffevent->postset ; ec ; ec = ec->nextplace )
  ec->place->label = 4;
cutoffevent->postset = NULL;
            hash->event = event;
/*
            Recalculate_conflicts_size( hash->event = event );
*/
            previous = True;
/*
            if (( GL_flags & LAST_CORR_EVENT ))
              hash->event = event;
*/
          } /* if */
        else
          { /* [event] > [hash->event] ==> event ist cutoff! */
#ifdef LOG_THE_CUTOFFS
printf("CUTOFF FOUND\n");
#endif /* LOG_THE_CUTOFFS */
            cutoffevent = event;
          } /* else */
      } /* else if */
    else
      {
        ( hash = (HASH) MYmalloc( sizeof( HASH_ELEM ) ) )->list = finalStateList;
        hash->next = GL_hashTable[ GL_hashIndex ];
        hash->minConfigSize = GL_configSize;
        ( GL_hashTable[ GL_hashIndex ] = hash )->event = event;
      } /* else */

    if ( ! test )
      {
        GL_numCutoffs++;
        ( ( newCutoff = allocLIST() )->next = GL_cutoffList );
        ( GL_cutoffList = newCutoff )->item = (Place) cutoffevent;
        ( ( newCutoff = allocLIST() )->next = GL_cutoffCorrespondingList );
        ( GL_cutoffCorrespondingList = newCutoff )->item = (Place) hash->event;
      } /* if */

#ifdef _EV_DISPLAY_IT_
printf( "E%u is %s cutoff event\n", (int) event > 10 ? event->numname : 0,
                                                        test ? "NOT a" : "A" );
#endif /* _EV_DISPLAY_IT_ */
    return ( test || previous );

  } /* IsNotCutoffEvent_LIST_size() */

#endif /* LOOK_ONLY_AT_SIZES */
