#ifndef __CUTOFF_EV2_H__
#define __CUTOFF_EV2_H__

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/
/*$$$  THE FOLLOWING ROUTINES STORE ONLY THE SIZE OF THE CONFIGURATIONS   $$$*/
/*$$$                    AND NOT THE PARIKH VECTORS.                      $$$*/
/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

#include "global.h"
#include "poss_ext.h"
#include "parikh.h"

/*****************************************************************************/
/* Insert a new possible extension in the queue.                             */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

PE_QUEUE insert_PE_queue_condarray_size( Transition trans );

#else

PE_QUEUE insert_PE_queue_condarray_size( trans );

#endif

/*****************************************************************************/
/* Insert a new possible extension in the queue.                             */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

PE_QUEUE insert_PE_queue_condlist_size( Transition trans );

#else

PE_QUEUE insert_PE_queue_condlist_size( trans );

#endif

/*****************************************************************************/
/* Check for the cut-off property.                                           */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

int IsNotCutoffEvent_LIST_size( LIST          finalStateList,
                                       Event         event );

#else

int IsNotCutoffEvent_LIST_size( finalStateList, event );

#endif

/*****************************************************************************/

/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/
/*$$$                      END OF THE SPECIAL ROUTINES                    $$$*/
/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/

#endif /* __CUTOFF_EV2_H__ */
