#include "hash.h"

HASH       * GL_hashTable;
Cardinal32 GL_numBuckets,
           GL_hashIndex;

Cardinal32 hash_size(void)
{
  return GL_numBuckets;
}

#if defined(__STDC__) || defined(__cplusplus)

void hash_alloc( Cardinal32 places )

#else

void hash_alloc( places )

  Cardinal32 places;

#endif
{
    register Cardinal32 counter;

    /* Der Hash speichert Listen von Markierungen der Groesse nach sortiert */
    /* Anzahl Hash-Eimer ist 4*(Anzahl Stellen)+1 */
    if (GL_flags & WITH_TIME)
      places <<=1;
    counter = GL_numBuckets = ( places << 2 ) + 1;
    /* Hash erzeugen und initialisieren mit NULL-Pointer */
    GL_hashTable = (HASH *) MYmalloc( GL_numBuckets * sizeof( HASH ) );
    while ( counter )
      GL_hashTable[--counter] = NULL;
}

/* Den von einem Hash-Eintrag belegten Speicherplatz freigeben.             */
#if defined(__STDC__) || defined(__cplusplus)

void hash_delete( HASH list )

#else

void hash_delete( list )

  HASH list;

#endif
{

  register HASH hash;

  for ( hash = list ; hash ; hash = list )
    {
      list_delete( &( hash->list ) );
      list=hash->next;
      Free( hash );
    } /* for */

} /* hash_delete() */

#if defined(__STDC__) || defined(__cplusplus)

void hash_index_list( LIST list )

#else

void hash_index_list( list )

  LIST list;

#endif
{
    register Cardinal32 sum, num;

    sum = num = 0;
    while ( list )
      {
        sum += list->item->numname * ++num;
        list = list->next;
	num++;
      }
    GL_hashIndex = sum % GL_numBuckets;
}

#if defined(__STDC__) || defined(__cplusplus)

void hash_index_bit( BIT_ARRAY array )

#else

void hash_index_bit( array )

#endif
{
  register Cardinal32 sum, num;

  sum = 0;
  num = bit_getsize();
  while ( num )
    sum += (Cardinal32) *( array++ ) * num--;
  GL_hashIndex = sum % GL_numBuckets;
}

#if defined(__STDC__) || defined(__cplusplus)

void hash_show( LMPNet net )

#else

void hash_show( net )

  LMPNet net;

#endif
{
  Cardinal32 count;
  HASH hash;

  printf( "Hash table:\n" );
  if ( GL_flags & USE_BITARRAYS )
    {
      for ( count = 0 ; count < GL_numBuckets ; count++ )
        {
          printf( "##%3u. ", count );
          if ( (hash = GL_hashTable[ count ]) )
            {
              bit_print_name( (BIT_ARRAY) hash->list, net );
              while ( (hash = hash->next) )
                {
                  printf( "       " );
                  bit_print_name( (BIT_ARRAY) hash->list, net );
                } /* while */
            } /* if */
          else
            {
              printf( "\n" );
            } /* else */
        } /* for count */
    } /* if useBitArrays */
  else
    {
      for ( count = 0 ; count < GL_numBuckets ; count++ )
        {
          printf( "##%3u. ", count );
          if ( (hash = GL_hashTable[ count ]) )
            {
              list_print( hash->list );
              while ( (hash = hash->next) )
                {
                  printf( "       " );
                  list_print( hash->list );
                } /* while */
            } /* if */
          else
            {
              putchar( '\n' );
            } /* else */
        } /* for count */
    } /* else !useBitArrays */
}
