/*******************************************************************************/
/*                  O P E R A T I O N S   O N   L I S T S                      */
/* Aenderung 10.6.99: list.h erstellt und Anpassungen gemacht -Christian Stehno*/
/*******************************************************************************/

#ifndef __LIST_H__
#define __LIST_H__

#include "neunetze.h"

/* Data structure: linear ( singly linked ) list. */
typedef struct listelem_
  {
    Place            item;
    Cardinal32       tokenage;
    struct listelem_ *next;
  } LIST_ELEM,
    *LIST;


/****************************************************************************/
/* Ausgabe der Listengroesse                                                */

#if defined(__STDC__) || defined(__cplusplus)

Cardinal32 list_getsize( void );

#else

Cardinal32 list_getsize( void );

#endif

/****************************************************************************/
/* Anlegen einer Liste vom Typ 'LIST' im Speicher.                          */

#if defined(__STDC__) || defined(__cplusplus)

LIST allocLIST( void );

#else

LIST allocLIST();

#endif

/****************************************************************************/
/* Entfernen der globalen Liste aus dem Speicher.                           */

#if defined(__STDC__) || defined(__cplusplus)

void freeLIST( void );

#else

void freeLIST();

#endif

/****************************************************************************/
/* Entfernen einer Liste vom Typ 'LIST' aus dem Speicher.                   */

#if defined(__STDC__) || defined(__cplusplus)

void list_delete_mem( LIST * list );

#else

void list_delete_mem( list );

#endif

/****************************************************************************/
/* Entfernen einer Liste vom Typ 'LIST'.                                    */

#if defined(__STDC__) || defined(__cplusplus)

void list_delete( LIST * list );

#else

void list_delete( list );

#endif

/****************************************************************************/
/* Test auf Gleichheit zweier Listen.                                       */

#if defined(__STDC__) || defined(__cplusplus)

bool lists_are_equal( LIST list1, LIST list2 );

#else

bool lists_are_equal( list1, list2 );

#endif

/****************************************************************************/
/* Compare two lists: list1<list2 (-1), list1==list2 (0) or list1>list2 (1) */
/* Comparison is based on the numeric values of list->item                  */

#if defined(__STDC__) || defined(__cplusplus)

int list_compare( LIST list1, LIST list2 );

#else

int list_compare( list1, list2 );

#endif

/****************************************************************************/
/* Check whether a list contains an element.                                */

#if defined(__STDC__) || defined(__cplusplus)

bool list_contains( LIST list, Place element );

#else

bool list_contains( list, element );

#endif

/****************************************************************************/
/* Check whether a list is included in another.                             */

#if defined(__STDC__) || defined(__cplusplus)

bool list_included( LIST list1, LIST list2 );

#else

bool list_included( list1, list2 );

#endif

/****************************************************************************/
/* Insert an element in a list.                                             */

#if defined(__STDC__) || defined(__cplusplus)

void list_insert( LIST * list, Place item, Cardinal32 tokenage );

#else

void list_insert( list, item, tokenage );

#endif

/****************************************************************************/
/* Check whether a reversed list is included in another.                    */

#if defined(__STDC__) || defined(__cplusplus)

bool rev_list_included( LIST list1, LIST list2 );

#else

bool rev_list_included( list1, list2 );

#endif

/****************************************************************************/
/* Insert an element in a reverse ordered list.                             */

#if defined(__STDC__) || defined(__cplusplus)

void rev_list_insert( LIST * list, Place item );

#else

void rev_list_insert( list, item );

#endif

/****************************************************************************/
/* Copy a reverse ordered list without taking those elements included in    */
/* the list 'diffList'.                                                     */

#if defined(__STDC__) || defined(__cplusplus)

LIST rev_list_copy_diff( LIST copyList, LIST diffList );

#else

LIST rev_list_copy_diff( copyList, diffList );

#endif

/****************************************************************************/
/* Reverse a list.                                                          */

#if defined(__STDC__) || defined(__cplusplus)

void list_reverse( LIST * list );

#else

void list_reverse( list );

#endif

/****************************************************************************/
/* Display a list as a set of conditions ( respectively events ) on the     */
/* screen.                                                                  */

#if defined(__STDC__) || defined(__cplusplus)

void list_print( LIST list );

#else

void list_print( list );

#endif

#endif /* __LIST_H__ */

/* End of file list.h */
