/* Alle Funktionen rund um PE */
/* Moegliche defines in diesem File: */
/*  _EV_DISPLAY_IT_  diverse Ausgaben */

#include "poss_ext.h"
#include "sub_unf.h"
#include "queue.h"
#include "unfold.h"
#include "cutoff_mm.h"

PE_QUEUE         GL_PE_queue      = NULL,
                 GL_PE_queue_last = NULL;

/*****************************************************************************/
/* Some function pointer definitions.                                        */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

PE_QUEUE  (* EV_insert_PE_queue_condlist)( Transition );
PE_QUEUE  (* EV_insert_PE_queue_condarray)( Transition );

#else

PE_QUEUE  (* EV_insert_PE_queue_condlist)();
PE_QUEUE  (* EV_insert_PE_queue_condarray)();

#endif

/*****************************************************************************/
/* Calculate possible extensions for the actual finite prefix.               */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void Display_PE_Queue( void )

#else

void Display_PE_Queue()

#endif

  {

    register PE_QUEUE   queue;
    register Cardinal32 line = 0,
                        count;
    register Condition  * coptr;

    printf( "GL_PE_queue:\n" );
    for ( queue = GL_PE_queue ; queue ; queue = queue->next )
      {
        printf( "%5u. %s (", ++line,
                            ( (Transition) *( coptr = queue->conds ) )->name );
        printf( "C%u", (*++coptr)->numname );
        count = (Cardinal32) ( (Transition) *( coptr - 1 ) )->inscript;
        while ((--count))
          printf( ",C%u", (*++coptr)->numname );
        putchar( ')' );
        putchar( ' ' );
        if ( GL_ParikhInAdvance )
          {
            GL_Display_Parikh( queue->parikh );
          } /* if */
        else
          {
            printf( "[%u]\n", (Cardinal32) queue->parikh );
          } /* else */
      } /* for */
    printf( "------------------------------------------------\n" );

  } /* Display_PE_Queue() */


/*****************************************************************************/
/* Insert a new possible extension in the queue.                             */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

PE_QUEUE insert_PE_queue_condarray( Transition trans )

#else

PE_QUEUE insert_PE_queue_condarray( trans )

  Transition trans;

#endif

  {

    register Condition  * ptr,
                        * copy;
    register Cardinal32 count;
    register PE_QUEUE   qu,
                        qunew;

    qunew = (PE_QUEUE) MYmalloc( sizeof( PE_QUEUE_Entry ) );
    qunew->conds = copy =
      (Condition *) MYmalloc( ( GL_maxTpreset + 1 ) * sizeof( Condition ) );
    *copy = (Condition) trans;
    ptr = GL_CArray;
    for ( count = (Cardinal32) trans->inscript ; count-- ; *++copy = *(ptr++) )
      skip;
#ifdef _EV_DISPLAY_IT_
copy = qunew->conds;
printf("INSERT_PRESET WAS (%s): ",trans->name);
count = (Cardinal32) trans->inscript;
while ((count--))
  {
    copy++;
    printf("C%u(P%u/%s),", (*copy)->numname,((Place)(*copy)->inscript)->numname,
	   ((Place)(*copy)->inscript)->name);
  }
printf("!\n");
#endif /* _EV_DISPLAY_IT_ */
    if ( GL_ParikhInAdvance )
      {
        qunew->parikh = GL_Calculate_Parikh_T( trans );
      } /* if */
    else
      {
        qunew->parikh = GL_Calculate_PSize_T( trans );
      } /* else */

    if ( GL_flags & SORT_BEGIN )
      {
        if ( (qu = GL_PE_queue) )
          {
            if ( GL_Compare_Parikh_A( qunew->parikh, qu->parikh, qunew->conds,
                                                              qu->conds ) < 1 )
              {
                qunew->next = GL_PE_queue;
                GL_PE_queue = qunew;
              } /* if */
            else
              {
                for ( skip ; qu->next && ( GL_Compare_Parikh_A( qunew->parikh,
                     qu->next->parikh, qunew->conds, qu->next->conds ) == 1 ) ;
                                                                qu = qu->next )
                  skip;
                qunew->next = qu->next;
                qu->next = qunew;
              } /* else */
          } /* if */
        else
          {
            ( GL_PE_queue = qunew )->next = NULL;
          } /* else */
      } /* if */
    else /* sort in from behind */
      {
        if ( ( qu = GL_PE_queue_last ) && ( GL_Compare_Parikh_A( qunew->parikh,
                                  qu->parikh, qunew->conds, qu->conds ) < 0 ) )
          {
            while ( ( qu = qu->prev ) && ( GL_Compare_Parikh_A( qunew->parikh,
                                  qu->parikh, qunew->conds, qu->conds ) < 0 ) )
              skip;
            if ( qu )
              {
                ( qu->next = ( qunew->next = qu->next )->prev = qunew )
                                                                   ->prev = qu;
              } /* if */
            else
              {
                ( GL_PE_queue = ( ( qunew->next = GL_PE_queue )->prev = qunew ) )
                                                                 ->prev = NULL;
              } /* else */
          } /* if */
        else if ( qu )
          {
            ( GL_PE_queue_last = ( ( GL_PE_queue_last->next = qunew )->prev
                                     = GL_PE_queue_last )->next )->next = NULL;
          } /* else if */
        else
          {
            ( GL_PE_queue = GL_PE_queue_last = qunew )->prev = qunew->next
                                                                        = NULL;
          } /* else */
      } /* else */

#if defined( _EV_DISPLAY_IT_ ) || defined( _TRACE_EV_QUEUE_ )
Display_PE_Queue();
#endif /* _EV_DISPLAY_IT_ */

    return ( qunew );

  } /* insert_PE_queue_condarray() */


/*****************************************************************************/
/* Insert a new possible extension in the queue.                             */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

PE_QUEUE insert_PE_queue_condlist( Transition trans )

#else

PE_QUEUE insert_PE_queue_condlist( trans )

  Transition trans;

#endif

  {

    register Condition  * copy,
                        * ccopy = GL_CArray;
    register LIST       * listArrayPtr;
    register PE_QUEUE   qu,
                        qunew;

    qunew = (PE_QUEUE) MYmalloc( sizeof( PE_QUEUE_Entry ) );
    qunew->conds = copy =
      (Condition *) MYmalloc( ( GL_maxTpreset + 1 ) * sizeof( Condition ) );
    *copy = (Condition) trans;
    *ccopy = *++copy = (Condition) *( listArrayPtr = GL_listArray1 );

#ifdef _EV_DISPLAY_IT_
printf("PRESET SIZE = %u\n", (Cardinal32) trans->inscript);
/*
printf("CONDITION POINTER IS %p.\n", *copy);
*/
printf("CONDITION IS C%u.\n", (*copy)->numname);
#endif /* _EV_DISPLAY_IT_ */

    while ( *++listArrayPtr )
      {
        *++ccopy = *++copy = ( *( listArrayPtr++ ) )->item;

#ifdef _EV_DISPLAY_IT_
/*
printf("CONDITION POINTER IS %p.\n", *copy);
*/
printf("CONDITION IS C%u.\n", (*copy)->numname);
#endif /* _EV_DISPLAY_IT_ */

      } /* while */
#ifdef _EV_DISPLAY_IT_
{
Cardinal32 count = (Cardinal32) trans->inscript;
copy = qunew->conds;
printf("COND-PRESET (%s/T%u): ", trans->name, trans->numname);
while (count--)
  {
    printf("C%u,", (*++copy)->numname);
  } /* while */
printf("\n");
copy = qunew->conds;
printf("INSERT_PRESET WAS (%s): ",trans->name);
for ( count = (Cardinal32) trans->inscript ; count-- ; skip )
{
copy++;
printf("C%u(P%u/%s),", (*copy)->numname,((Place)(*copy)->inscript)->numname,
((Place)(*copy)->inscript)->name);
}
printf("!\n");
}
#endif /* _EV_DISPLAY_IT_ */

    if ( GL_ParikhInAdvance )
      {
        qunew->parikh = GL_Calculate_Parikh_T( trans );
      } /* if */
    else
      {
        qunew->parikh = GL_Calculate_PSize_T( trans );
      } /* else */

    if ( GL_flags & SORT_BEGIN )
      {
        if ( (qu = GL_PE_queue) )
          {
            if ( GL_Compare_Parikh_A( qunew->parikh, qu->parikh, qunew->conds,
                                                              qu->conds ) < 1 )
              {
                qunew->next = GL_PE_queue;
                GL_PE_queue = qunew;
              } /* if */
            else
              {
                for ( skip ; qu->next && ( GL_Compare_Parikh_A( qunew->parikh,
                     qu->next->parikh, qunew->conds, qu->next->conds ) == 1 ) ;
                                                                qu = qu->next )
                  skip;
                qunew->next = qu->next;
                qu->next = qunew;
              } /* else */
          } /* if */
        else
          {
            ( GL_PE_queue = qunew )->next = NULL;
          } /* else */
      } /* if */
    else /* sort in from behind */
      {
        if ( ( qu = GL_PE_queue_last ) && ( GL_Compare_Parikh_A( qunew->parikh,
                                  qu->parikh, qunew->conds, qu->conds ) < 0 ) )
          {
            while ( ( qu = qu->prev ) && ( GL_Compare_Parikh_A( qunew->parikh,
                                  qu->parikh, qunew->conds, qu->conds ) < 0 ) )
              skip;
            if ( qu )
              {
                ( qu->next = ( qunew->next = qu->next )->prev = qunew )
                                                                   ->prev = qu;
              } /* if */
            else
              {
                ( GL_PE_queue = ( ( qunew->next = GL_PE_queue )->prev
                                                     = qunew ) ) ->prev = NULL;
              } /* else */
          } /* if */
        else if ( qu )
          {
            ( GL_PE_queue_last = ( ( GL_PE_queue_last->next = qunew )->prev
                                     = GL_PE_queue_last )->next )->next = NULL;
          } /* else if */
        else
          {
            ( GL_PE_queue = GL_PE_queue_last = qunew )->prev = qunew->next
                                                                        = NULL;
          } /* else */
      } /* else */

#if defined( _EV_DISPLAY_IT_ ) || defined( _TRACE_EV_QUEUE_ )
Display_PE_Queue();
#endif /* _EV_DISPLAY_IT_ */

    return ( qunew );

  } /* insert_PE_queue_condlist() */

/*****************************************************************************/
/* The GenEvents procedure.                                                  */
/* Recalculate the queue of possible Events considering the postset of the   */
/* newly introduced Condition cond                                           */
/* GL_listArray enthaelt alle moeglichen Kombinationen von passenden         */
/* Conditions in der Entfaltung. Jedes zweite Feld die zu einer Stelle des   */
/* Vorbereichs gehoerenden Bedingungen. Diese werden dann alle der Reihe nach*/
/* durchprobiert. Das jeweils zweite Feld wird fuer das Ruecksetzen der Liste*/
/* nach einem Durchlauf benutzt                                              */
/* Sideeffects: GL_listArray1, GL_listArray2, GL_listArray4                  */
/*            ? GL_conflictArray, GL_listArray                               */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void GenEvents( Condition condition, LMPNet unfold_net )

#else

void GenEvents( condition, unfold_net )

  Condition condition;
  LMPNet unfold_net;

#endif

  {

    register Transition tr;
    register STEdge     st,
                        st2;
    register LIST       list;
    Place               item;

    /* GL_listArray1 zeigt auf aktuelle Bedingung */
    *GL_listArray1 = (LIST) condition;
    /* Durchlaufe den Nachbereich der zur Condition gehoerenden Stelle */
    for ( st = ( (Place) condition->inscript )->postset ; st ;
	  st = st->nexttrans )
      {
        /* st2 zeigt auf Vorb. der Transitionen, die evtl. eingefuegt werden */
        st2 = ( tr = st->trans )->preset;
	if (!(GL_flags & WITH_TIME) || !tr->time_label ||
	    condition->tokenage>=tr->time_label->low)
	  {
	    if ( st2->nextplace )
	      {                                                  /* |*t| > 1 */
		if ( st2->nextplace->nextplace )
		  {                                              /* |*t| > 2 */
		    /* Bei mehr als zwei Conditions mit Array arbeiten */
		    register LIST * listArrayPtr,
		                  * listArrayLast;

		    for ( list = (LIST) ( listArrayPtr = GL_listArray2 ) ;
			  st2 && list ; st2 = st2->nextplace )
		      {
			/* Teste den Vorbereich der Transition ausser der geg. Bedingung */
			if ( st2 != st )
			  {
			    /* list ist leer */
			    *listArrayPtr = NULL;
			    /* Durchlaufe alle Bedingungen die diesem Vorbereich entsprechen */
			    for ( list = (LIST) st2->place->inscript ; list ;
				  list = list->next )
			      {
			    if (!(GL_flags & WITH_TIME) || !tr->time_label ||
				list->item->tokenage>=tr->time_label->low)
			      {
                            /* Wenn diese Bedingung nicht in Konflikt steht eintragen */
                            if ( ! Test_Bit( GL_conflictArray,list->item->numname ))
                              list_insert( listArrayPtr, list->item, 0 );
      } /* if Transition tr schaltbar bzgl. condition */
                          } /* for list */
                        /* list zeigt nun auf den naechsten Listenzeiger */
                        list = *( listArrayPtr++ );
                        /* Dieses Feld bekommt den Wert vom vorherigen */
                        /* listArrayptr zeigt auf naechstes Feld       */
                        *( listArrayPtr++ ) = list;
                      } /* if st2 != st */
                  } /* for st2 (list) */
                *listArrayPtr = NULL;
                /* Wenn eine Liste angelegt wurde und alle st2 durchlaufen */
                if ( list )
                  {
                    /* Zeiger auf die letzte Liste speichern */
                    listArrayLast = listArrayPtr - 2;
                    /* Ab der zweiten Liste beginnen, warum nicht die erste ?! */
                    listArrayPtr = GL_listArray4;
                    /* Solange noch Listen vorhanden */
                    while ( *listArrayPtr )
                      {
                        /* Wenn einfuegen eines Events mit Vorbereich in */
                        /* listArrayPtr Konflikt erzeugen wuerde         */
                        if ( (*GL_LiConflictsFunction)( listArrayPtr ) )
                          {
                            /* Soll das wohl ein Element loeschen ?? */
                            while ( *listArrayPtr &&
                                    ! ( *listArrayPtr = (*listArrayPtr)->next ) )
                              {
                                *listArrayPtr = *( listArrayPtr + 1 );
                                listArrayPtr--;
                                listArrayPtr--;
                              } /* while */
                          } /* if */
                        /* Sonst naechste Liste pruefen */
                        else
                          {
                            listArrayPtr++;
                            listArrayPtr++;
                          } /* else */
                      } /* while */
                    /* Solange nicht vorne angekommen (kann auch von vorher sein ! */
                    while ( listArrayPtr != GL_listArray )
                      {
                        /* Konflikte und Vorbereich muessen geklaert sein ! */
                        insert_event_with_ce_edges( unfold_net, tr );
                        /* Hinten anfangen */
                        listArrayPtr = listArrayLast;
                        /* wie oben ! */
                        while ( *listArrayPtr &&
                                ! ( *listArrayPtr = (*listArrayPtr)->next ) )
                          {
                            *listArrayPtr = *( listArrayPtr + 1 );
                            listArrayPtr--;
                            listArrayPtr--;
                          } /* while */
                        /* auch wie oben ! */
                        while ( *listArrayPtr )
                          {
                            if ( (*GL_LiConflictsFunction)( listArrayPtr ) )
                              {
                                while ( *listArrayPtr && ! ( *listArrayPtr
                                                    = (*listArrayPtr)->next ) )
                                  {
                                    *listArrayPtr = *( listArrayPtr+1 );
                                    listArrayPtr--;
                                    listArrayPtr--;
                                  } /* while */
                              } /* if */
                            else
                              {
                                listArrayPtr++;
                                listArrayPtr++;
                              } /* else */
                          } /* while */
                      } /* while */
                  } /* if ( list ) */
                /* Alle Listen loeschen */
                listArrayPtr = GL_listArray1;
                while ( *++listArrayPtr )
                  {
                    list_delete( listArrayPtr++ );
                  } /* while */
              } /* if |*t|>2 */
            else /* |*t| = 2 */
              {
                *GL_listArray4 = NULL;
                *GL_listArray2 = (LIST) &item;
                /* Waehle die andere Kante */
                if ( ! (st2 = st->nextplace))
                  st2 = st->prevplace;
                /* Durchlaufe alle zugehoerigen Bedingungen */
                /* Wenn die zweite Stelle schon im Netz vorhanden ist kann */
                /* Transition eingefuegt werden, da dann Vorb. vorhanden */
                for ( list = (LIST) st2->place->inscript ; list ;
                                                            list = list->next )
                  {
		    if (!(GL_flags & WITH_TIME) || !tr->time_label ||
			list->item->tokenage>=tr->time_label->low)
		      {
			/* Wenn Bedingung nicht im Konflikt tr eingefuegen */
			if (!Test_Bit( GL_conflictArray, list->item->numname ))
			  {
			    /* item via GL_ListArray2 uebergeben, entspricht */
			    /* zweiter Bedingung im Vorb. von  Transition tr */
			    item = list->item;
			    insert_event_with_ce_edges( unfold_net, tr );
			  } /* if */
		      } /* if Transition tr schaltbar bzgl. list->item */
                  } /* for list */
              } /* else */
          } /* if |*t|>1 */
        else /* |*t| = 1 */
          {
            /* in diesem Fall gibt es nur die eine Kante von condition zu tr */
            *GL_listArray2 = NULL;
            insert_event_with_ce_edges( unfold_net, tr );
          } /* else */
      } /* if Transition tr schaltbar bzgl. condition */
      } /* for ( st ) */
    
  } /* GenEvents() */

/*****************************************************************************/
/* Calculate possible extensions for the actual finite prefix.               */
/* Wie GenEvents, ausser #ifdef's und insert_event's                         */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void Get_PE( Condition condition )

#else

void Get_PE( condition )

  Condition condition;

#endif

  {

    register Transition tr;
    register STEdge     st,
                        st2;
    register LIST       list,
                        * listArrayPtr,
                        * listArrayLast;
    Place               item;

    *GL_listArray1 = (LIST) condition;
    for ( st = ( (Place) condition->inscript )->postset ; st ;
                                                           st = st->nexttrans )
      {
        st2 = ( tr = st->trans )->preset;
        if ( st2->nextplace )
          {                                                      /* |*t| > 1 */
            if ( st2->nextplace->nextplace )
              {                                                  /* |*t| > 2 */
                for ( list = (LIST) ( listArrayPtr = GL_listArray2 ) ;
                                           st2 && list ; st2 = st2->nextplace )
                  {
                    if ( st2 != st )
                      {
                        *listArrayPtr = NULL;
                        for ( list = (LIST) st2->place->inscript ; list ;
                                                            list = list->next )
                          {
                            if ( !Test_Bit( GL_conflictArray,list->item->numname ))
                              list_insert( listArrayPtr, list->item, 0 );
                          } /* while */
                        list = *( listArrayPtr++ );
                        *( listArrayPtr++ ) = list;
                      } /* if */
                  } /* for */
                *listArrayPtr = NULL;
                if ( list )
                  {
                    listArrayLast = listArrayPtr - 2;
                    listArrayPtr = GL_listArray4;
                    while ( *listArrayPtr )
                      {
                        if ( (*GL_LiConflictsFunction)( listArrayPtr ) )
                          {
                            while ( *listArrayPtr
                               && ! ( *listArrayPtr = (*listArrayPtr)->next ) )
                              {
                                *listArrayPtr = *( listArrayPtr + 1 );
                                listArrayPtr--;
                                listArrayPtr--;
                              } /* while */
                          } /* if */
                        else
                          {
                            listArrayPtr++;
                            listArrayPtr++;
                          } /* else */
                      } /* while */
                    while ( listArrayPtr != GL_listArray )
                      {
#ifdef _EV_DISPLAY_IT_
/*
{
  LIST * lptr = GL_listArray1;
  Condition c=(Condition)*lptr;

printf("GET_PE>2 (%u): C%u(%s)",(Cardinal32)tr->inscript,c->numname,
                                                   ((Place)c->inscript)->name);
while (*++lptr)
  {
    c=*(lptr++);
    printf(", C%u(%s)",c->numname,((Place)c->inscript)->name);
  }
printf("\n");
}
*/
#endif /* _EV_DISPLAY_IT_ */
                        EV_insert_PE_queue_condlist( tr );
                        listArrayPtr = listArrayLast;
                        while ( *listArrayPtr
                               && ! ( *listArrayPtr = (*listArrayPtr)->next ) )
                          {
                            *( listArrayPtr ) = *( listArrayPtr + 1 );
                            listArrayPtr--;
                            listArrayPtr--;
                          } /* while */
                        while ( *listArrayPtr )
                          {
                            if ( (*GL_LiConflictsFunction)( listArrayPtr ) )
                              {
                                while ( *listArrayPtr && ! ( *listArrayPtr
                                                    = (*listArrayPtr)->next ) )
                                  {
                                    *listArrayPtr = *( listArrayPtr + 1 );
                                    listArrayPtr--;
                                    listArrayPtr--;
                                  } /* while */
                              } /* if */
                            else
                              {
                                listArrayPtr++;
                                listArrayPtr++;
                              } /* else */
                          } /* while listArrayPtr*/
                      } /* while listArrayPtr != GL_listArray */
                  } /* if ( list ) */
                listArrayPtr = GL_listArray1;
                while ( *++listArrayPtr )
                  {
                    list_delete( listArrayPtr++ );
                  } /* while */
              } /* if */
            else
              {                                                  /* |*t| = 2 */
                *GL_listArray4 = NULL;
                *GL_listArray2 = (LIST) &item;
                if ( ! ( st2 = st->nextplace ))
                  st2 = st->prevplace;
                for ( list = (LIST) st2->place->inscript ; list ;
                                                            list = list->next )
                  {
/*
{
  LIST * lptr = GL_listArray1;
  Condition c=(Condition)*lptr;
item = list->item;
printf("TEST :   (%u): C%u(%s)",(Cardinal32)tr->inscript,c->numname,
                                                   ((Place)c->inscript)->name);
while (*++lptr)
  {
    c=(*(lptr++))->item;
    printf(", C%u(%s)",c->numname,((Place)c->inscript)->name);
  }
printf("\n");
}
*/
                    if ( ! Test_Bit( GL_conflictArray, list->item->numname ) )
                      {
                        item = list->item;
#if 0
#ifdef _EV_DISPLAY_IT_
{ LIST * lptr = GL_listArray1; Condition c=(Condition)*lptr;
printf("GET_PE=2 (%u): C%u(%s)",(Cardinal32)tr->inscript,c->numname,
                                                   ((Place)c->inscript)->name);
while (*++lptr)
  { c=(*(lptr++))->item;
 printf(", C%u(%s)",c->numname,((Place)c->inscript)->name); }
printf("\n"); }
#endif /* _EV_DISPLAY_IT_ */
#endif /* temporaer ausgeschaltet */
                        EV_insert_PE_queue_condlist( tr );
                      } /* if */
                  } /* for */
              } /* else */
          } /* if */
        else
          {                                                      /* |*t| = 1 */
            *GL_listArray2 = NULL;
#ifdef _EV_DISPLAY_IT_
/*
{ LIST * lptr = GL_listArray1; Condition c=(Condition)*lptr;
printf("GET_PE=1 (%u): C%u(%s)",(Cardinal32)tr->inscript,c->numname,
                                                   ((Place)c->inscript)->name);
while (*++lptr)
  { c=*(lptr++); printf(", C%u(%s)",c->numname,((Place)c->inscript)->name); }
printf("\n"); }
*/
#endif /* _EV_DISPLAY_IT_ */
            EV_insert_PE_queue_condlist( tr );
          } /* else */
      } /* for ( st ) */

  } /* Get_PE() */


/*****************************************************************************/
/* Calculate possible extensions for the start marking.                      */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void Get_PE_start( Condition condition )

#else

void Get_PE_start( condition )

  register Condition condition;

#endif

  {

    register Transition tr;
    register STEdge     st,
                        st2;
    register Place      pl;
    register Condition  * coptr;
    register bool       all_marked;

    *GL_CArray = condition;
    pl = (Place) condition->inscript;
    for ( st = pl->postset ; st ; st = st->nexttrans )
      {
        if ( ( st2 = ( tr = st->trans )->preset )->nextplace )
          {                                                      /* |*t| > 1 */
            if ( st2->place == pl )
              {
                coptr = GL_CArray;
                all_marked = True;
                while ( (st2 = st2->nextplace) )
                  {
                    if ( st2->place->marks )
                      {
                        *++coptr = ( (LIST) st2->place->inscript )->item;
                      } /* if */
                    else
                      {
                        all_marked = False;
                        break;
                      } /* else */
                  } /* while */
                /* Preset is in GL_CArray */
                if ( all_marked )
                  EV_insert_PE_queue_condarray( tr );
              } /* if */
          } /* if */
        else
          {                                                      /* |*t| = 1 */
            EV_insert_PE_queue_condarray( tr );
          } /* else */
      } /* for ( st ) */

  } /* Get_PE_start() */


