#ifndef __POSS_EXT_H__
#define __POSS_EXT_H__

#include "global.h"
#include "parikh.h"

/*****************************************************************************/
/* Type definitions for queue of possible extensions.                        */
/*****************************************************************************/

typedef struct PE_queue_entry_
  {
    Condition              * conds;
    PARIKH_VECTOR          parikh;
    struct PE_queue_entry_ * prev,
                           * next;
  } PE_QUEUE_Entry,
    * PE_QUEUE;

extern PE_QUEUE  GL_PE_queue,
                 GL_PE_queue_last;

/*****************************************************************************/
/* Some function pointer definitions.                                        */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

extern PE_QUEUE  (* EV_insert_PE_queue_condlist)( Transition );
extern PE_QUEUE  (* EV_insert_PE_queue_condarray)( Transition );

#else

extern PE_QUEUE  (* EV_insert_PE_queue_condlist)();
extern PE_QUEUE  (* EV_insert_PE_queue_condarray)();

#endif


/*****************************************************************************/
/* Calculate possible extensions for the actual finite prefix.               */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void Display_PE_Queue( void );

#else

void Display_PE_Queue();

#endif

/*****************************************************************************/
/* Insert a new possible extension in the queue.                             */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

PE_QUEUE insert_PE_queue_condarray( Transition trans );

#else

PE_QUEUE insert_PE_queue_condarray( trans );

#endif

/*****************************************************************************/
/* Insert a new possible extension in the queue.                             */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

PE_QUEUE insert_PE_queue_condlist( Transition trans );

#else

PE_QUEUE insert_PE_queue_condlist( trans );

#endif

/*****************************************************************************/
/* The GenEvents procedure.                                                  */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void GenEvents( Condition condition, LMPNet unfold_net );

#else

void GenEvents( condition, unfold_net );

#endif

/*****************************************************************************/
/* Calculate possible extensions for the actual finite prefix.               */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void Get_PE( Condition condition );

#else

void Get_PE( condition );

#endif

/*****************************************************************************/
/* Calculate possible extensions for the actual finite prefix.               */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void Get_PE_start( Condition condition );

#else

void Get_PE_start( condition );

#endif

#endif /* __POSS_EXT_H__ */
