#ifndef __SUB_UNF_H__
#define __SUB_UNF_H__

#include "global.h"

/*****************************************************************************/
/* Some function pointer definitions.                                        */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

extern bool  (* GL_LiConflictsFunction)( LIST * ),
             LiConflictsNet( LIST * );

#else

extern bool  (* GL_LiConflictsFunction)(),
             LiConflictsNet();

#endif

void start_clock(void);
void stop_clock(void);
void update_clock(void);
void print_time(FILE * file);

/*****************************************************************************/

#define IncCMark() \
    if ( ! ++GL_numCFlag ) \
      { \
        register Condition cnd; \
        for ( cnd = GL_unfold_net->Places ; cnd ; cnd = cnd->nextplace ) skip;\
        GL_numCFlag++; \
      } /* if */

#define CMark( _COND_ ) ( (_COND_)->component = GL_numCFlag )

#define IsCMarked( _COND_ ) ( (_COND_)->component == GL_numCFlag )


/*****************************************************************************/

#define IncEMark() \
    if ( ! ++GL_numEFlag ) \
      { \
        register Event evt; \
        for ( evt=GL_unfold_net->Transitions; evt; evt=evt->nexttrans ) skip;\
        GL_numEFlag++; \
      } /* if */

#define EMark( _EVENT_ ) ( ( _EVENT_ )->name = GL_numEFlag )

#define IsNotEMarked( _EVENT_ ) ( (_EVENT_)->name != GL_numEFlag )

/*****************************************************************************/
/*                 O P E R A T I O N S   O N   S T A C K S                   */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void CreateStacks( void );

#else

void CreateStacks( );

#endif

#if defined(__STDC__) || defined(__cplusplus)

void FreeStacks( void );

#else

void FreeStacks( );

#endif

#define PushCondition( _COND_ ) \
  ( (_COND_)->preset ? ( *++stackptr = (_COND_) ) : _COND_ )

#define PopCondition() ( *stackptr ? *(stackptr--) : NULL )

#define InitCStack() ( *( stackptr = GL_stackC ) = NULL )

#if defined(__STDC__) || defined(__cplusplus)

void ResizeCStack( Cardinal32 num );

#else

void ResizeCStack( num );

#endif

/****************************************************************************/

#define PushEvent( _COND_ ) \
    if ( (_COND_)->preset && IsNotEMarked( event = (_COND_)->preset->trans ) ) \
      EMark( *++stackEptr = event );

#define PopEvent() ( *stackEptr ? *(stackEptr--) : NULL )

#define InitEStack() ( *( stackEptr = GL_stackE ) = NULL )

#if defined(__STDC__) || defined(__cplusplus)

void ResizeEStack( Cardinal32 num );

#else

void ResizeEStack( num );

#endif

/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

BIT_ARRAY Calculate_Conflicts( BIT_ARRAY conflictArray, LMPNet unfold_net,
			       Transition trans);

#else

BIT_ARRAY Calculate_Conflicts( conflictArray, unfold_net, trans );

#endif

/*****************************************************************************/
/* Test whether there are any conflicts if the net would be expanded by      */
/* en event having the places stored in 'GL_listArray' in its preset.        */
/* ( This routine uses bit arrays to check if there are conflicts. )         */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

bool LiConflictsBit( LIST * listArrayPtr );

#else

bool LiConflictsBit( listArrayPtr );

#endif

/*****************************************************************************/
/* Test whether there are any conflicts if the net would be expanded by      */
/* an event having the places stored in 'GL_listArray' in its preset.        */
/* ( This routine checks the conflict property directly on the net. )        */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

bool LiConflictsNet( LIST * listArrayPtr );

#else

bool LiConflictsNet( listArrayPtr );

#endif

/****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

LIST CalculateCut( Event event, LMPNet unfold_net );

#else

LIST CalculateCut( event, unfold );

#endif

#if defined(__STDC__) || defined(__cplusplus)

void InsertTic( LMPNet unfold_net, LIST cut );

#else

void InsertTic( unfold_net, cut );

#endif

/****************************************************************************/

#endif /* __SUB_UNF_H__ */
