#ifndef __UNF_OUT_H__
#define __UNF_OUT_H__

#include "neunetze.h"

/****************************************************************************/
/*     O P E R A T I O N S   F O R   U N F O L D I N G   O U T P U T        */
/****************************************************************************/

/* Ausgabe des entfalteten Netzes mitsamt Cutoff-Events und maximalen       */
/* Prozessen in eine "*.ent"-Datei, die von Hartmut Truee innerhalb seiner  */
/* Diplomarbeit ( Model Checker ) gelesen werden kann.                      */

#if defined(__STDC__) || defined(__cplusplus)

void write_unfolding_ent( char * filename, LMPNet unfold_net );

#else

void write_unfolding_ent( filename, unfold_net );

#endif

/*****************************************************************************/
/* Schreiben des entfalteten Netzes in eine ".unf"-Datei.                    */
/* ( unf = unfolding ASCII file format )                                     */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void write_unfolding_UNF( char * filename, char * infilename, LMPNet unfold_net );

#else

void write_unfolding_UNF( filename, infilename, unfold_net );

#endif

/*****************************************************************************/
/* Schreiben des entfalteten Netzes in eine ".unf"-Datei.                    */
/* ( unf = unfolding ASCII file format )                                     */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void write_unfolding_UNF_extern( char * filename, char * infilename, LMPNet unfold_net );

#else

void write_unfolding_UNF_extern( filename, infilename, unfold_net );

#endif

/*****************************************************************************/
/* Schreiben des entfalteten Netzes in eine ".mci"-Datei.                    */
/* ( mci = model checker input file format )                                 */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void write_unfolding_MCI( char * filename, LMPNet unfold_net, LMPNet net );

#else

void write_unfolding_MCI( filename, unfold_net, net );

#endif

#endif /* __UNF_OUT_H__ */
