/* Alle Entfaltungsfunktionen. Es gibt insgesamt 5 verschiedene */

#ifndef __UNFOLD_H__
#define __UNFOLD_H__

#include "global.h"
#include "parikh.h"

/*****************************************************************************/
/* Some function pointer definitions.                                        */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

extern LMPNet(* unfold)( LMPNet );
extern int   (* IsNotCutoffPoint)( LIST, Event );
extern int   (* ERV_IsNotCutoffPoint)( LIST, Event );
extern LIST  (* FinalState)( Event, LMPNet );

extern int   (* IsNotCutoffEvent)( LIST, Event );
extern LIST  (* Mark)( Event, LMPNet );

#else

extern LMPNet(* unfold)();
extern int   (* IsNotCutoffPoint)();
extern int   (* ERV_IsNotCutoffPoint)();
extern LIST  (* FinalState)();

extern int   (* IsNotCutoffEvent)();
extern LIST  (* Mark)();

#endif

/*****************************************************************************/
/* The unfolding procedure according to McMillan.                            */
/* Now with possibility for time expansion.                                  */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

LMPNet M_unfold( LMPNet net );

#else

LMPNet M_unfold( net );

#endif

/*****************************************************************************/
/* The improved unfolding procedure.                                         */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

LMPNet EV_unfold( LMPNet net );

#else

LMPNet EV_unfold( net );

#endif

/*###########################################################################*/
/* EV2_unfold: Entfalten nach dem verbesserten Algorithmus.                  */
/*             Einsortieren in die Schlange erfolgt nur nach Groesse der Konf*/
/*             Einfuegen der Ereignisse erst nach Entfernen aus der Schlange.*/
/*###########################################################################*/

/*****************************************************************************/
/* The further improved unfolding procedure.                                 */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

LMPNet EV2_unfold( LMPNet net );

#else

LMPNet EV2_unfold( net );

#endif

/*###########################################################################*/

/*****************************************************************************/
/* The further improved unfolding procedure.                                 */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

LMPNet ERV_unfold( LMPNet net );

#else

LMPNet ERV_unfold( net );

#endif

/*###########################################################################*/

/*****************************************************************************/
/* The further improved unfolding procedure.                                 */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

LMPNet NERV_unfold( LMPNet net );

#else

LMPNet NERV_unfold( net );

#endif

#endif /* __UNFOLD_H__ */
