/**********************************/
/* symtab.h                       */
/* Burkhard Graves, 06.10.93      */
/* Lars Jenner, Juni 1994         */
/* Burkhard Graves, 24.02.95      */
/**********************************/

#ifndef __SYMTAB_H__
#define __SYMTAB_H__

#include "main.h"
#include "tree.h"

/**********************************/
/* Globale Defines                */
/**********************************/

/* Fuer s_special (bitweise Nummerierung */

#define _L_READING  1
#define _L_PRIMED   1
#define _L_WRITING  2
#define _L_UNPRIMED 2

#define _G_READING  16
#define _G_PRIMED   16
#define _G_WRITING  32
#define _G_UNPRIMED 32

#define _LG_READING  (_L_READING | _G_READING)
#define _LG_WRITING  (_L_WRITING | _G_WRITING)
#define _LG_PRIMED   (_L_PRIMED | _G_PRIMED)
#define _LG_UNPRIMED (_L_UNPRIMED | _G_UNPRIMED)

#define _L_RW (_L_READING | _L_WRITING)
#define _G_RW (_G_READING | _G_WRITING)

#define _L_PRUPR (_L_PRIMED | _L_UNPRIMED)
#define _G_PRUPR (_G_PRIMED | _G_UNPRIMED)

/* Fuer s_type (fortlaufende Nummerierung */

#define _UDEC       1
#define _VAR        2
#define _CHANNEL    3
#define _PROC       4
#define _PPROC      5
#define _STACK      6
#define MNET_CONST      7

/**********************************/
/* Globale Typdefinitionen        */
/**********************************/


/**********************************/
/* Globale Funktionen             */
/**********************************/

void              s_init PROTO ((void));

SymTabEntry    *s_lookup PROTO ((char *ptr));

SymTabEntry  *make_ident PROTO ((SymTabEntry *entry));
SymTabEntry    *make_par PROTO ((SymTabEntry *entry));

SymTabEntry   *chk_ident PROTO ((SymTabEntry *entry,int type,int partype));
SymTabEntry  *chk2_ident PROTO ((SymTabEntry *entry,int type1,int type2));

void          inc_blknum PROTO ((void));
SymTabEntry  *dec_blknum PROTO ((void));

void            give_typ PROTO ((int type,Range *range,int init_or_cap));

#endif

/**********************************/
/* END OF FILE symtab.h           */
/**********************************/
