/****************************************************************************/
/* box_sub.h                                                                */
/* Burkhard Graves, 26.6.'93                                                */
/* Martin Ackermann, Sommer 95                                              */
/* Burkhard Bieber 1995:                                                    */
/*   - Blocktypen ergaenzt                                                  */
/*   - Sync-/Phantom-Transitionen ergaenzt                                  */
/* Martin Ackermann, Winter 1996/97                                         */
/*   - Prozeduren, andere Referenzen, mehr Effizienz, Fehler beseitigt      */
/****************************************************************************/

#ifndef __BOX_SUB_H__
#define __BOX_SUB_H__

#include "mnet.h"
#include "compose.h"

extern Cardinal dead_eliminated; /* Anzahl der entfernten toten Transitionen */

/***********************/
/* Funktionsprototypen */
/***********************/

M_Net M_Iteration( alt_set_type alt, M_Net enter );
M_Net M_Choice( M_Net net1, M_Net net2 );
M_Net M_ConcurrentComposition( M_Net net1, M_Net net2 );
M_Net M_Sequence( M_Net net1, M_Net net2 );
M_Net M_Replacement ( M_Net net, M_Transition tr, M_Net box );
M_Net M_CreateBasicBox( MultiSet label, node_ptr tree, Integer *def,
                        Variables vars, RefNr ref );
M_Net M_Synchronisation( M_Net net, MultiSet mm, Cardinal max );
M_Net M_Restriction( M_Net net,MultiSet mm );
M_Net M_Scoping( M_Net net,MultiSet mm, Cardinal max );
M_Net M_OnlyPlaces( Cardinal n );

#endif

/*************************/
/* END OF FILE box_sub.h */
/*************************/
