/****************************************************************************/
/* F_PARSE.H                                                                */
/*                                                                          */
/* Martin Ackermann, Fruehjahr 95                                           */
/* Martin Ackermann, Winter 1996/97                                         */
/*   - Makros, Tupel und Konstanten hinzugefuegt                            */
/****************************************************************************/

#ifndef __F_PARSE_H__
#define __F_PARSE_H__

#include "mnet.h"

extern Cardinal     index_counter;/* markiert die Zuordnung Makros <-> Knoten */

extern bool         GL_AddActions;/* gibt an, ob geparsete Aktionsterme zu 
				     spec_actions hinzugefuegt werden sollen  */
extern Integer*     global_range[MAX_DIM];  
                                  /* darin werden Definitionen erzeugt        */
extern MultiSet     spec_actions; /* hier werden alle Aktionsterme gesammelt, 
                                     die in einem Template vorkommen          */
extern int          parsed_length;/* hier legen die Scanner die Laenge des
                                     gescannten Ausdrucks ab                  */
extern M_Transition parsed_trans; /* Transition, die die 'Variables' fuer 
                                     'akt_component' enthaelt                 */
extern Integer*    *parsed_range; /* hier traegt der ExprParser Kreuzprodukte
                                     als Wertebereiche von Stellen ein        */
extern Cardinal     parsed_index; /* Index der Einzelmenge in 'parsed_range', 
                                     die gerade geparst wird                  */
extern int          parser_start; /* <0 : es wurden schon Token geliefert
				     'F': zu Beginn eines Foreach-Parsings
                                     'R': zu Beginn eines   Range-Parsings
                                     'G': zu Beginn eines   Guard-Parsings    */

node_ptr ParseAnnotation( const char *string, M_Transition tr );
void     add_comvar( const char *name, const char *string, Variables vars );
ComVar   StrToCom( const char *name, Variables v_ptr, M_Transition tr );
VarMSet  StrToVarMSet(  const char *string, M_Transition tr );
MultiSet StrToMultiSet( const char *string, M_Transition tr );
char*    ConcatStrings( const char *s1, const char *s2 );
Integer  EP_Add_ident( char* str, Integer prj );
void     StringToRange( const char* str, Integer **range, int kind_of_cmds );
void     AddRangeToDef( Var com_nr );

#endif /* __F_PARSE_H__ */


/*****************************************************************************/
/* END OF FILE F_PARSE.H                                                     */
/*****************************************************************************/

