/* ptrans.h, Include-Datei fuer Phantomtransitionen */
/* Burkhard Bieber 1995/96                          */
/* last-update: 02.04.96                            */

#ifndef __PTRANS_H__
#define __PTRANS_H__ 1

  /************/
  /* includes */
  /************/

#include "mnet.h"

  /**************/
  /* Prototypen */
  /**************/

M_Transition M_allocPTrans(void);

  /* Der Transition "tr" wird ein Verweis auf Transition "add_tr"    */
  /* im Feld "phantoms" hinzugefuegt. Es ist unerheblich, welche der */
  /* beiden eine Phantomtransition ist.                              */
void M_AddPTransPhantom(M_Transition tr, M_Transition add_tr);

  /* Eine Funktion zum Kopieren der Phantomverweise aus der Transition src */
  /* in die Transition dest. Dabei wird der Speicher fuer die Verweise in  */
  /* der Zieltransition alloziert.                                         */
void M_CopyTransPhantomEntries(M_Transition dest, M_Transition src);

  /* Die Liste der Sync-Transitionen zu einer Phantomtransition */
  /* in die Datei im PEP-Format schreiben.                      */
void PrintPhantoms(FILE *ofp, M_Net net, M_Transition tr);

  /* Debug-Ausgabe fuer Phantomverweise einer Transition */
void debug_phantoms(Cardinal phantomentries, Cardinal32 *phantoms);

  /* Eine normale Transition kopieren, die Kopie ist dann eine */
  /* neue Phantomtransition.                                   */
M_Transition M_Copy2PTransition(M_Net net, M_Transition tr);

#endif  /* #ifndef __PTRANS_H__ */

  /*** Dateiende ptrans.h ***/

