/**********************************************************************/
/* box_sub.h                                                          */
/* Burkhard Graves, 26.6.'93                                          */
/* Aenderung 8.6.1999: CreateTr aus iter.c/dat_cha.c -Christian Stehno*/
/**********************************************************************/

#ifndef __BOX_SUB_H__
#define __BOX_SUB_H__

#include "lpnet.h"
#include "parser.h"
#include "boxxpars.h"

#ifndef SILENCE
#define OUT(A) printf(A)
#else
#define OUT(A)
#endif

/* Stack fuer Variablen etc. */

typedef struct StackElem_ {
    struct StackElem_   *previous;
    Var                 var;
    Cardinal            count;
    TTree               knoten;
} StackElem;

/*****************************************************************************/
/* Variablen und Funktionen zur Abarbeitung des Syntaxbaums                  */
/*****************************************************************************/

/* Sprungleiste : Array mit Zeigern auf Funktionen      */
/*                mit Parameter TTree und Resultat BOX. */

extern BOX (*Operation[])(TTree Knoten);

extern int bpn_modus;

/*****************************************************************************/
/* Makro zur Auswertung eines Syntaxbaum-Knotens.                            */

#define Eval(node) (*Operation[node->Operator-ACTION])(node)

/***********************/
/* Funktionsprototypen */
/***********************/

void push(Var var,Cardinal count,TTree knoten);
void pop(void);
StackElem *search(Var var);

/* Neue gemeinsam wartende Tic-Transitionen erstellen. Getrennt    */
/* schaltende auslassen, die neuen werden vorn in Netz1 eingefuegt */
LPNet     CommonWait(LPNet net1, LPNet net2                     );
LPNet  CreateBasicClocknet(MultiSet label, Time_stamp *timelabel);
LPNet   CLOCKRestriction(LPNet net, MultiSet mm                 );

LPNet     CreateBasicBox(MultiSet label, Time_stamp *time_label );
LPNet    Synchronisation(LPNet net,MultiSet mm,Cardinal max     );
LPNet        Restriction(LPNet net, MultiSet mm                 );
LPNet            Scoping(LPNet net,MultiSet mm,Cardinal max     );
LPNet         OnlyPlaces(Cardinal n                             );
Transition   CreateTr(LPNet net,MultiSet mm,int x_pos,int y_pos );
#endif

/*************************/
/* END OF FILE box_sub.h */
/*************************/
