/* This won't work: #define YYLMAX 32768 */

/* flex uses an array defined as char yytext[YYLMAX]*/
%array

/* Just one file per invocation so no yywrap needed */
%option noyywrap
/* No interactive mode */
%option never-interactive
/* No yymore as nothing is put back */
%option noyymore
%option nounput
/* No REJECT as only best matches are needed */
%option noreject

%{
#include <string.h>
#include "boxtypes.h"
#include "parser.h"
#include "boxxpars.h"
%}

/********************/
/* Globale Variable */
/********************/
  int line=1;
  int column=0;
  int bpn_modus=0;

/* Used to define states for the scanner */
%x COMMENT
%x QUOTE

%%


<<EOF>>  return 0;         /* Terminates the scanner */

[[:blank:]]* column+=yyleng; /* Skip blank */

<INITIAL>% BEGIN(COMMENT); /* Comments are used for settings !*/

<COMMENT>"@+" bpn_modus=1; /* Here bpn_mode ist set */

<COMMENT>.                 /* All other comments are skipped */

<COMMENT>\n {              /* Comment ends with the line */
    BEGIN(INITIAL);
    ++line;
    column=0;
    }

[\n] { /* only newline etc. as blanks are skipped earlier */
    ++line;
    column=0;
    }

rs {                       /* Plain text operators and functions */
    column+=yyleng;
    return RESTRICT;
    }

sy {
    column+=yyleng;
    return SYNCHRON;
    }

tie {
    column+=yyleng;
    return TIE;
    }

D_BOX {
    column+=yyleng;
    return D_BOX;
    }

C_BOX {
    column+=yyleng;
    return C_BOX;
    }

S_BOX {
    column+=yyleng;
    return S_BOX;
    }

STOP {
    column+=yyleng;
    return STOP_BOX;
    }

"@"/"[" {
     column++;
     return ATTIME;
   }

"@"   {
     column++;
     return RECURSION;
   }

";"   {
     column++;
     return SEQUENCE;
   }

":"   {
     column++;
     return SCOPE;
   }

"*"   {
     column++;
     return ITERATION;
   }

"^"   {
     column++;
     return CONJUGATE;
   }

"[]"  {
     column+=2;
     return CHOICE;
   }

"||"  {
     column+=2;
     return PARALLEL;
   }

"->"  {
     column+=2;
     return MAP;
   }

"<-"  {
     column+=2;
     return REFINE;
   }

tt { 
    column+=yyleng;
    yylval.String="1";
    return NUMBER;
   }

ff { 
    column+=yyleng;
    yylval.String="0";
    return NUMBER;
   }

[[:digit:]]+ {          /* Numbers and strings as used with PBC */
    column+=yyleng;
    yylval.String=yytext;
    return NUMBER;
    }
                                          /* Actionsymbols are all lowercase */
[[:lower:]][[:lower:][:digit:]_?!]*["+"-]? { /* Notice the extra symbols _?! */
    column+=yyleng;
    yylval.String=yytext;
    return ACTION;
    }

[[:upper:]][[:lower:]][[:lower:][:digit:]_?!]* { /* First letter is uppercase 
                                                    the rest lower */
    column+=yyleng;
    yylval.String=yytext;
    return FUNCTION;
    }

[[:upper:]][[:upper:][:digit:]_?!]* {  /* All letters uppercase */
    column+=yyleng;
    yylval.String=yytext;
    return VARIABLE;
    }

<INITIAL>\"  {                /* Filenames are quoted */
    column++;
    BEGIN(QUOTE);
    } 

<QUOTE>[^"\n]* {              /* Keep everything which could be a filename */
    column+=yyleng;
    yylval.String=yytext;
    }

<QUOTE>\n  {                  /* ...and skip the rest (Strange filename!) */
    line++;
    column=0;
    }    

<QUOTE>\"  {                  /* Finally found ! */
    column++;
    BEGIN(INITIAL);
    return FILENAME;
    }

\252 {                        /* Whatever this may be... */
     column++;
     return EMPTYSET;
   }

.     {                      /* This is the default rule: Just give      */
     column++;               /* the character back if it matches nothing */
     return *yytext;
   }
