/***************************************************************************/
/* iter.c                                                                  */
/* Burkhard Graves, 15.07.94                                               */
/* Aenderung 8.6.1999: CreateTr nach box_sub.c verschoben -Christian Stehno*/
/***************************************************************************/

#include <stdio.h>
#include "iter.h"
#include "boxtypes.h"
#include "box.h"
#include "move.h"
#include "box_sub.h"

/*****/
/*   */
/*****/

LPNet SmallIteration(TTree Knoten)
{
    register Place  pl1,pl2,pl3;
             Place  pl;
             LPNet  net_a,net_b,net_c;

             STEdge st,st1;
             TSEdge ts,ts1;

             int      pos;
             Cardinal dim;

    net_a=Eval(Knoten->Operand1);
    net_b=Eval(Knoten->Operand2);
    net_c=Eval(Knoten->Operand3);

    /*----------------------------------------------------*/
    /* Koordinaten und Dimension des (zuknftigen) Netzes */
    /*----------------------------------------------------*/

    /* Die tau-Transition */
    CreateTr(net_b,MScreate_empty_set()
                  ,net_b->x_pos-=2,net_b->y_pos+net_b->y_dim/2);
    ++net_b->NumTransitions;
    net_b->x_dim+=2;
    turn_left(net_b);

    /*--------------------------------------------*/
    /*  entry(net_b) * exit(net_a) * entry(net_c) */
    /*--------------------------------------------*/

    PreparePlaces(net_a,EXIT,EXIT);
    PreparePlaces(net_c,ENTRY,ENTRY);
    dim=0;
    pl1=net_b->LastPlace;
    while (pl1 && pl1->numname) {
        if (pl1->label==ENTRY) {
            pl2=net_a->LastPlace;
            while (pl2) {
                pl3=net_c->LastPlace;
                while (pl3) {
                    dim+=2;

(pl=DuplicatePlace(net_b,pl1,&st,&ts))->label=EMPTY;
(ts=LPNallocTSEdge())->weight=1;
ts->prevplace=NULL;
ts->prevtrans=NULL;
ts->nexttrans=NULL;
if ((ts->nextplace=net_b->Transitions->postset)!=NULL)
    ts->nextplace->prevplace=ts;
(ts->place=pl)->preset
=(ts->trans=net_b->Transitions)->postset=ts;
/*
if (ts) {
*/
    if ((ts->nexttrans=CopyPlacePreset(pl2,pl,&ts1))!=NULL) {
        ts->nexttrans->prevtrans=ts;
    }
/*
} else {
    pl->preset=CopyPlacePreset(pl2,pl,&ts);
}
*/
if (st) {
    if ((st->nexttrans=CopyPlacePostset(pl3,pl,&st1))!=NULL) {
        st->nexttrans->prevtrans=st;
    }
} else {
    pl->postset=CopyPlacePostset(pl3,pl,&st);
}

                    pl3=pl3->prevplace;
                }
                pl2=pl2->prevplace;
            }
            pl1=LPNRemovePlace(net_b,pl1);
        } else {
            if (pl1->label&EXIT) {
                pl1->label=EMPTY;
                (st=LPNallocSTEdge())->weight=1;
                st->prevplace=NULL;
                st->prevtrans=NULL;
                st->nexttrans=NULL;
                if ((st->nextplace=net_b->Transitions->preset)!=NULL)
                    st->nextplace->prevplace=st;
                (st->place=pl1)->postset
                =(st->trans=net_b->Transitions)->preset=st;
                ++pl1->y_pos;
            }
            pl1=pl1->prevplace;
        }
    }

    /*-----------------------------------------------*/
    /* Die neuen Stellen (links) zentriert anordnen. */
    /*-----------------------------------------------*/

    pos=((int)(net_b->y_dim-(--dim))>>1)+net_b->y_pos;
    if (dim>net_b->y_dim) {
        net_b->y_dim=dim;
        net_b->y_pos=pos;
    }
    pos+=--dim;
    while (pl1) {
        pos=(pl1->y_pos=pos)-2;
        pl1->numname=1;
        pl1=pl1->prevplace;
    }

#if 0

    move_hv(net_a,net_b->x_pos-net_a->x_pos-net_a->x_dim-1,
                  net_b->y_pos-net_a->y_pos-net_a->y_dim+3);
    move_hv(net_c,net_b->x_pos-net_c->x_pos-net_c->x_dim-1,
                  net_b->y_pos-net_c->y_pos+net_b->y_dim-3);

    if (net_a->x_pos<net_c->x_pos) {
        net_b->x_pos=net_a->x_pos;
        net_b->x_dim+=net_a->x_dim+1;
    } else {
        net_b->x_pos=net_c->x_pos;
        net_b->x_dim+=net_c->x_dim+1;
    }
    net_b->y_pos=net_a->y_pos;
    net_b->y_dim+=net_a->y_dim+net_c->y_dim-6;

#else

    /* Zentriere Netz C unter Netz B, nach unten direkt anschliessend */
    move_hv(net_c,net_b->x_pos-net_c->x_pos
                  +((int)(net_b->x_dim-net_c->x_dim)>>1)
                 ,net_b->y_pos-net_c->y_pos+net_b->y_dim-1);
    /* Das groessere Netz gibt die Masse vor */
    if (net_c->x_dim>net_b->x_dim) {
        net_b->x_dim=net_c->x_dim;
        net_b->x_pos=net_c->x_pos;
    }
    /* Nach unten wird das neue Netz auf jeden Fall laenger */
    net_b->y_dim+=net_c->y_dim-1;

    /* Dito fuer Netz A, nach oben anschliessend */
    move_hv(net_a,net_b->x_pos-net_a->x_pos
                  +((int)(net_b->x_dim-net_a->x_dim)>>1)
                 ,net_b->y_pos-net_a->y_pos-net_a->y_dim+1);
    if (net_a->x_dim>net_b->x_dim) {
        net_b->x_dim=net_a->x_dim;
        net_b->x_pos=net_a->x_pos;
    }
    /* Hier muss auch y_pos beachtet werden */
    net_b->y_dim+=net_a->y_dim-1;
    net_b->y_pos=net_a->y_pos;

#endif

    return DisjointNetUnion(net_b,DisjointNetUnion(RestoreKillPlaces(net_a,EXIT),RestoreKillPlaces(net_c,ENTRY)));
}

/*****/
/*   */
/*****/

LPNet BigIteration(TTree Knoten)
{
    register Place  pl1,pl2,pl3,pl4;
             Place  pl;
             Place  merke;
             Place  entry_pl,exit_pl;
             LPNet  a_net,b_net,c_net,
                    net_a,net_b,net_c;
             STEdge st,st1;
             TSEdge ts,ts1;
             int    pos;
             int    net_x_pos,net_y_pos;
             int    x_offset,y_offset;
             Cardinal dim;
             Cardinal net_x_dim,net_y_dim;
             Cardinal entry_x_dim,exit_x_dim;

    net_a=LPNCreateNetCopy(a_net=Eval(Knoten->Operand1));
    net_b=LPNCreateNetCopy(b_net=Eval(Knoten->Operand2));
    net_c=LPNCreateNetCopy(c_net=Eval(Knoten->Operand3));

    /*-----------------------------------------*/
    /* Das nach rechts gedrehte 'net_b' unter   */
    /* das nach links   gedrehte 'b_net' legen. */
    /*-----------------------------------------*/

    turn_right(net_b);
    turn_left(b_net);
    move_hv(net_b,b_net->x_pos-net_b->x_pos,
                  b_net->y_pos-net_b->y_pos+b_net->y_dim+1);

    /*----------------------------------------------------*/
    /* Koordinaten und Dimension des (zuknftigen) Netzes */
    /*----------------------------------------------------*/

    net_x_pos=b_net->x_pos;
    net_y_pos=b_net->y_pos;
    net_x_dim=b_net->x_dim;
    net_y_dim=b_net->y_dim*2+1;

    /*-------------------------------*/
    /*  entry(a_net) * entry(net_a)  */
    /*-------------------------------*/

    entry_x_dim=0;
    merke=PreparePlaces(net_a,EXIT,ENTRY);
    pl1=a_net->LastPlace;
    while (pl1 && pl1->numname) {
        if (pl1->label==ENTRY) {
            pl2=merke;
            while (pl2) {
                entry_x_dim+=2;
                if (DuplicatePlace(a_net,pl1,&st,&ts)->postset) {
                    if ((st->nexttrans
                         =CopyPlacePostset(pl2,a_net->Places,&st1))!=NULL)
                        st->nexttrans->prevtrans=st;
                } else
                    a_net->Places->postset
                    =CopyPlacePostset(pl2,a_net->Places,&st1);
                pl2=pl2->prevplace;
            }
            pl1=LPNRemovePlace(a_net,pl1);
        } else
            pl1=pl1->prevplace;
    }
    entry_pl=pl1;

    /*-----------------------------*/
    /*  exit(c_net) * exit(net_c)   */
    /*-----------------------------*/

    exit_x_dim=0;
    merke=PreparePlaces(net_c,ENTRY,EXIT);
    pl1=c_net->LastPlace;
    while (pl1 && pl1->numname) {
        if (pl1->label&EXIT) {
            pl2=merke;
            while (pl2) {
                exit_x_dim+=2;
                if (DuplicatePlace(c_net,pl1,&st,&ts)->preset) {
                    if ((ts->nexttrans
                         =CopyPlacePreset(pl2,c_net->Places,&ts1))!=NULL)
                        ts->nexttrans->prevtrans=ts;
                } else
                    c_net->Places->preset
                    =CopyPlacePreset(pl2,c_net->Places,&ts1);
                pl2=pl2->prevplace;
            }
            pl1=LPNRemovePlace(c_net,pl1);
        } else
            pl1=pl1->prevplace;
    }
    exit_pl=pl1;

    PreparePlaces(a_net,EXIT,EXIT);
    PreparePlaces(c_net,ENTRY,ENTRY);
    merke=PreparePlaces(net_b,ENTRY,EXIT);

    /*-----------------------------------------------------------*/
    /*  entry(b_net) * exit(net_b) * entry(c_net) * exit(a_net)  */
    /*-----------------------------------------------------------*/

    dim=0;
    pl1=b_net->LastPlace;
    while (pl1 && pl1->numname) {
        if (pl1->label==ENTRY) {
            pl2=merke;
            while (pl2) {
                pl3=c_net->LastPlace;
                while (pl3) {
                    pl4=a_net->LastPlace;
                    while (pl4) {
                        dim+=2;

(pl=DuplicatePlace(b_net,pl1,&st,&ts))->label=EMPTY;
pl->preset=CopyPlacePreset(pl2,pl,&ts);
if (st) {
    if ((st->nexttrans=CopyPlacePostset(pl3,pl,&st1))!=NULL) {
        st->nexttrans->prevtrans=st;
    }
} else {
    pl->postset=CopyPlacePostset(pl3,pl,&st);
}
if (ts) {
    if ((ts->nexttrans=CopyPlacePreset(pl4,pl,&ts1))!=NULL) {
        ts->nexttrans->prevtrans=ts;
    }
} else {
    pl->preset=CopyPlacePreset(pl4,pl,&ts);
}

                        pl4=pl4->prevplace;
                    }
                    pl3=pl3->prevplace;
                }
                pl2=pl2->prevplace;
            }
            pl1=LPNRemovePlace(b_net,pl1);
        } else
            pl1=pl1->prevplace;
    }

    /*-----------------------------------------------*/
    /* Die neuen Stellen (links) zentriert anordnen. */
    /*-----------------------------------------------*/

    pos=((int)(net_y_dim-(--dim))>>1)+net_y_pos;
    if (dim>net_y_dim) {
        net_y_dim=dim;
        net_y_pos=pos;
    }
    pos+=--dim;
    while (pl1) {
        pos=(pl1->y_pos=pos)-2;
        pl1->numname=1;
        pl1=pl1->prevplace;
    }

    /*-----------------------------------------------------------*/
    /*  exit(b_net) * entry(net_b) * entry(net_c) * exit(net_a)  */
    /*-----------------------------------------------------------*/

    dim=0;
    pl1=b_net->LastPlace;
    while (pl1 && pl1->numname) {
        if (pl1->label&EXIT) {
            pl2=net_b->LastPlace;
            while (pl2) {
                pl3=net_c->LastPlace;
                while (pl3) {
                    pl4=net_a->LastPlace;
                    while (pl4) {
                        dim+=2;

(pl=DuplicatePlace(b_net,pl1,&st,&ts))->label=EMPTY;
if ((pl->postset=CopyPlacePostset(pl2,pl,&st))!=0) {
    if ((st->nexttrans=CopyPlacePostset(pl3,pl,&st1))!=NULL) {
        st->nexttrans->prevtrans=st;
    }
} else {
    pl->postset=CopyPlacePostset(pl3,pl,&st);
}
if (ts) {
    if ((ts->nexttrans=CopyPlacePreset(pl4,pl,&ts1))!=NULL) {
        ts->nexttrans->prevtrans=ts;
    }
} else {
    pl->preset=CopyPlacePreset(pl4,pl,&ts);
}

                        pl4=pl4->prevplace;
                    }
                    pl3=pl3->prevplace;
                }
                pl2=pl2->prevplace;
            }
            pl1=LPNRemovePlace(b_net,pl1);
        } else
            pl1=pl1->prevplace;
    }

    /*------------------------------------------------*/
    /* Die neuen Stellen (rechts) zentriert anordnen. */
    /*------------------------------------------------*/

    pos=((int)(net_y_dim-(--dim))>>1)+net_y_pos;
    if (dim>net_y_dim) {
        net_y_dim=dim;
        net_y_pos=pos;
    }
    pos+=dim-1;
    while (pl1) {
        pos=(pl1->y_pos=pos)-2;
        pl1->numname=1;
        pl1=pl1->prevplace;
    }

    /*-------------------------------------------------------*/
    /* 'net_a' rechts neben 'a_net' legen. Dann diese beiden */
    /* oberhalb des bisher konstruierten Netzes zentrieren.  */
    /*-------------------------------------------------------*/

    move_hv(net_a,a_net->x_pos-net_a->x_pos+a_net->x_dim+1,
                  a_net->y_pos-net_a->y_pos);
    x_offset=net_x_pos-a_net->x_pos+net_x_dim/2-a_net->x_dim;
    y_offset=net_y_pos-a_net->y_pos-a_net->y_dim+1;
    move_hv(net_a,x_offset,y_offset);
    move_hv(a_net,x_offset,y_offset);
    net_y_dim+=a_net->y_dim-1;
    net_y_pos=a_net->y_pos;
    if (net_x_dim<(Cardinal)(1+2*a_net->x_dim)) {
        net_x_dim=1+2*a_net->x_dim;
        net_x_pos=a_net->x_pos;
    }

    pl1=entry_pl;
    pos=(int)(net_x_dim-(--entry_x_dim))/2+net_x_pos;
    if (entry_x_dim>net_x_dim) {
        net_x_dim=entry_x_dim;
        net_x_pos=pos;
    }
    pos+=entry_x_dim-1;
    while (pl1) {
        pos=(pl1->x_pos=pos)-2;
        pl1->numname=1;
        pl1=pl1->prevplace;
    }

    /*-------------------------------------------------------*/
    /* 'net_c' rechts neben 'c_net' legen. Dann diese beiden */
    /* unterhalb des bisher konstruierten Netzes zentrieren. */
    /*-------------------------------------------------------*/

    move_hv(net_c,c_net->x_pos-net_c->x_pos+c_net->x_dim+1,
                  c_net->y_pos-net_c->y_pos);
    x_offset=net_x_pos-c_net->x_pos+net_x_dim/2-c_net->x_dim;
    y_offset=net_y_pos-c_net->y_pos+net_y_dim-1;
    move_hv(net_c,x_offset,y_offset);
    move_hv(c_net,x_offset,y_offset);
    net_y_dim+=c_net->y_dim-1;
    if (net_x_dim<(Cardinal)(2*c_net->x_dim+1)) {
        net_x_dim=2*c_net->x_dim+1;
        net_x_pos=c_net->x_pos;
    }

    pl1=exit_pl;
    pos=(int)(net_x_dim-(--exit_x_dim))/2+net_x_pos;
    if (exit_x_dim>net_x_dim) {
        net_x_dim=exit_x_dim;
        net_x_pos=pos;
    }
    pos+=exit_x_dim-1;
    while (pl1) {
        pos=(pl1->x_pos=pos)-2;
        pl1->numname=1;
        pl1=pl1->prevplace;
    }

    /*---------*/
    /* Fertig. */
    /*---------*/

    b_net->x_pos=net_x_pos;
    b_net->y_pos=net_y_pos;
    b_net->x_dim=net_x_dim;
    b_net->y_dim=net_y_dim;

    return DisjointNetUnion(b_net,
            DisjointNetUnion(RestoreKillPlaces(net_b,ENTRY | EXIT),
             DisjointNetUnion(RestoreKillPlaces(c_net,ENTRY),
              DisjointNetUnion(RestoreKillPlaces(net_c,ENTRY | EXIT),
               DisjointNetUnion(RestoreKillPlaces(a_net,EXIT),
                                RestoreKillPlaces(net_a,ENTRY | EXIT)
                               )
                              )
                             )
                            )
                             );
}

/*****/
/*   */
/*****/

LPNet MediumIteration(TTree Knoten)
{
    register Place  pl1,pl2,pl3,pl4;
             Place  pl;
             Place  merke;
             Place  exit_pl;
             LPNet  net_a,net_b,net_c,
                    b_net,c_net;
             STEdge st,st1;
             TSEdge ts,ts1;
             int    pos;
             int    x_offset,y_offset;
             Cardinal dim;
             Cardinal exit_x_dim;

    net_a=Eval(Knoten->Operand1);
    net_b=LPNCreateNetCopy(b_net=Eval(Knoten->Operand2));
    net_c=LPNCreateNetCopy(c_net=Eval(Knoten->Operand3));

    /*------------------------------------------*/
    /* Das nach rechts gedrehte 'net_b' unter   */
    /* das nach links   gedrehte 'b_net' legen. */
    /*------------------------------------------*/

    turn_right(net_b);
    turn_left(b_net);
    move_hv(net_b,b_net->x_pos-net_b->x_pos,
                  b_net->y_pos-net_b->y_pos+b_net->y_dim+1);

    b_net->y_dim*=2; ++b_net->y_dim;

    /*---------------------------*/
    /* exit(c_net) * exit(net_c) */
    /*---------------------------*/

    exit_x_dim=0;
    merke=PreparePlaces(net_c,ENTRY,EXIT);
    pl1=c_net->LastPlace;
    while (pl1 && pl1->numname) {
        if (pl1->label&EXIT) {
            pl2=merke;
            while (pl2) {
                exit_x_dim+=2;
                if (DuplicatePlace(c_net,pl1,&st,&ts)->preset) {
                    if ((ts->nexttrans
                         =CopyPlacePreset(pl2,c_net->Places,&ts1))!=NULL)
                        ts->nexttrans->prevtrans=ts;
                } else
                    c_net->Places->preset
                    =CopyPlacePreset(pl2,c_net->Places,&ts1);
                pl2=pl2->prevplace;
            }
            pl1=LPNRemovePlace(c_net,pl1);
        } else
            pl1=pl1->prevplace;
    }
    exit_pl=pl1;

    PreparePlaces(net_a,EXIT,EXIT);
    PreparePlaces(c_net,ENTRY,ENTRY);
    merke=PreparePlaces(net_b,ENTRY,EXIT);

    /*---------------------------------------------------------*/
    /* entry(b_net) * exit(net_b) * entry(c_net) * exit(net_a) */
    /*---------------------------------------------------------*/

    dim=0;
    pl1=b_net->LastPlace;
    while (pl1 && pl1->numname) {
        if (pl1->label==ENTRY) {
            pl2=merke;
            while (pl2) {
                pl3=c_net->LastPlace;
                while (pl3) {
                    pl4=net_a->LastPlace;
                    while (pl4) {
                        dim+=2;

(pl=DuplicatePlace(b_net,pl1,&st,&ts))->label=EMPTY;
pl->preset=CopyPlacePreset(pl2,pl,&ts);
if (st) {
    if ((st->nexttrans=CopyPlacePostset(pl3,pl,&st1))!=NULL) {
        st->nexttrans->prevtrans=st;
    }
} else {
    pl->postset=CopyPlacePostset(pl3,pl,&st);
}
if (ts) {
    if ((ts->nexttrans=CopyPlacePreset(pl4,pl,&ts1))!=NULL) {
        ts->nexttrans->prevtrans=ts;
    }
} else {
    pl->preset=CopyPlacePreset(pl4,pl,&ts);
}

                        pl4=pl4->prevplace;
                    }
                    pl3=pl3->prevplace;
                }
                pl2=pl2->prevplace;
            }
            pl1=LPNRemovePlace(b_net,pl1);
        } else
            pl1=pl1->prevplace;
    }

    /*-----------------------------------------------*/
    /* Die neuen Stellen (links) zentriert anordnen. */
    /*-----------------------------------------------*/

    pos=((int)(b_net->y_dim-(--dim))>>1)+b_net->y_pos;
    if (dim>b_net->y_dim) {
        b_net->y_dim=dim;
        b_net->y_pos=pos;
    }
    pos+=--dim;
    while (pl1) {
        pos=(pl1->y_pos=pos)-2;
        pl1->numname=1;
        pl1=pl1->prevplace;
    }

    /*-------------------------------------------*/
    /* exit(b_net) * entry(net_b) * entry(net_c) */
    /*-------------------------------------------*/

    dim=0;
    pl1=b_net->LastPlace;
    while (pl1 && pl1->numname) {
        if (pl1->label&EXIT) {
            pl2=net_b->LastPlace;
            while (pl2) {
                pl3=net_c->LastPlace;
                while (pl3) {
                    dim+=2;

(pl=DuplicatePlace(b_net,pl1,&st,&ts))->label=EMPTY;
if ((pl->postset=CopyPlacePostset(pl2,pl,&st))!=0) {
    if ((st->nexttrans=CopyPlacePostset(pl3,pl,&st1))!=NULL) {
        st->nexttrans->prevtrans=st;
    }
} else {
    pl->postset=CopyPlacePostset(pl3,pl,&st);
}

                    pl3=pl3->prevplace;
                }
                pl2=pl2->prevplace;
            }
            pl1=LPNRemovePlace(b_net,pl1);
        } else
            pl1=pl1->prevplace;
    }

    /*------------------------------------------------*/
    /* Die neuen Stellen (rechts) zentriert anordnen. */
    /*------------------------------------------------*/

    pos=((int)(b_net->y_dim-(--dim))>>1)+b_net->y_pos;
    if (dim>b_net->y_dim) {
        b_net->y_dim=dim;
        b_net->y_pos=pos;
    }
    pos+=dim-1;
    while (pl1) {
        pos=(pl1->y_pos=pos)-2;
        pl1->numname=1;
        pl1=pl1->prevplace;
    }

    /*--------------------------------------------------------------*/
    /* 'net_a' oberhalb des bisher konstruierten Netzes zentrieren. */
    /*--------------------------------------------------------------*/

    move_hv(net_a,b_net->x_pos-net_a->x_pos+
                  ((int)(b_net->x_dim-net_a->x_dim)>>1),
                  b_net->y_pos-net_a->y_pos-net_a->y_dim+1);
    if (net_a->x_dim>b_net->x_dim) {
        b_net->x_dim=net_a->x_dim;
        b_net->x_pos=net_a->x_pos;
    }
    b_net->y_dim+=net_a->y_dim-1;
    b_net->y_pos=net_a->y_pos;

    /*-------------------------------------------------------*/
    /* 'net_c' rechts neben 'c_net' legen. Dann diese beiden */
    /* unterhalb des bisher konstruierten Netzes zentrieren. */
    /*-------------------------------------------------------*/

    move_hv(net_c,c_net->x_pos-net_c->x_pos+c_net->x_dim+1,
                  c_net->y_pos-net_c->y_pos);
    x_offset=b_net->x_pos-c_net->x_pos+b_net->x_dim/2-c_net->x_dim;
    y_offset=b_net->y_pos-c_net->y_pos+b_net->y_dim-1;
    move_hv(net_c,x_offset,y_offset);
    move_hv(c_net,x_offset,y_offset);
    b_net->y_dim+=c_net->y_dim-1;
    if (b_net->x_dim<(Cardinal)(c_net->x_dim*2+1)) {
        b_net->x_dim=c_net->x_dim*2+1;
        b_net->x_pos=c_net->x_pos;
    }

    pl1=exit_pl;
    pos=((int)(b_net->x_dim-(--exit_x_dim))>>1)+b_net->x_pos;
    if (exit_x_dim>b_net->x_dim) {
        b_net->x_dim=exit_x_dim;
        b_net->x_pos=pos;
    }
    pos+=exit_x_dim-1;
    while (pl1) {
        pos=(pl1->x_pos=pos)-2;
        pl1->numname=1;
        pl1=pl1->prevplace;
    }

    /*---------*/
    /* Fertig. */
    /*---------*/

    return DisjointNetUnion(b_net,
            DisjointNetUnion(RestoreKillPlaces(net_b,ENTRY | EXIT),
             DisjointNetUnion(RestoreKillPlaces(c_net,ENTRY),
              DisjointNetUnion(RestoreKillPlaces(net_c,ENTRY | EXIT),
                               RestoreKillPlaces(net_a,EXIT)
                              )
                             )
                            )
                           );
}

/*****************************/
/* Iteration bei Uhrennetzen */
/*****************************/

LPNet CLOCKSmallIteration(TTree Knoten)
{
    Place  pl1, pl2, pl3, pl;
    Transition tr, tr1, tr2;
    LPNet  net_a, net_b, net_c, net;

    STEdge st, st1, st2;
    TSEdge ts, ts1, ts2;

    Cardinal32 time, max1=MAX_INT, max2=MAX_INT;
    int        pos, max;
    Cardinal   dim;

    net_a=Eval(Knoten->Operand1);
    net_b=Eval(Knoten->Operand2);
    net_c=Eval(Knoten->Operand3);

    /*-----------------------------------------------------*/
    /* Koordinaten und Dimension des (zukuenftigen) Netzes */
    /*-----------------------------------------------------*/

    /* Die tau-Transition */
    CreateTr(net_b,MScreate_empty_set()
                  ,net_b->x_pos-=2,net_b->y_pos+net_b->y_dim/2);
    ++net_b->NumTransitions;
    net_b->x_dim+=2;
    turn_left(net_b);

    /*--------------------------------------------*/
    /*  entry(net_b) * exit(net_a) * entry(net_c) */
    /*--------------------------------------------*/

    PreparePlaces(net_a,EXIT,EXIT);
    PreparePlaces(net_c,ENTRY,ENTRY);
    dim=0;
    pl1=net_b->LastPlace;
    while (pl1 && pl1->numname)
      {
        /* Stelle mit den vorbereiteten zusammen multiplizieren */
        if (pl1->label==ENTRY)
          {
            pl2=net_a->LastPlace;
            while (pl2)
              {
                pl3=net_c->LastPlace;
                while (pl3)
                  {
                    dim+=2;

                    pl=DuplicatePlace(net_b,pl1,&st,&ts);
                    pl->label=EMPTY;
                    /* Kante von der tau-Transition */
                    ts=LPNallocTSEdge();
                    ts->weight=1;
                    ts->prevplace=NULL;
                    ts->prevtrans=NULL;
                    ts->nexttrans=NULL;
                    ts->nextplace=net_b->Transitions->postset;
                    if (ts->nextplace!=NULL)
                      ts->nextplace->prevplace=ts;
                    (ts->place=pl)->preset
                    =(ts->trans=net_b->Transitions)->postset=ts;
                    /* Alte Kanten von Netz A sichern */
                    if ((ts->nexttrans=CopyPlacePreset(pl2,pl,&ts1))!=NULL)
                      ts->nexttrans->prevtrans=ts;
                    /* Alte Kanten von Netz C sichern */
                    if (st)
                      {
                        if ((st->nexttrans=CopyPlacePostset(pl3,pl,&st1))!=NULL)
                          st->nexttrans->prevtrans=st;
                      }
                    else
                      pl->postset=CopyPlacePostset(pl3,pl,&st);
                    pl3=pl3->prevplace;
                  } /* while pl3 */
                pl2=pl2->prevplace;
              } /* while pl2 */
            pl1=LPNRemovePlace(net_b,pl1);
          } /* if pl1==ENTRY */
        else
          { /* Kante in die tau-Transition */
            if (pl1->label&EXIT)
              {
                pl1->label=EMPTY;
                (st=LPNallocSTEdge())->weight=1;
                st->prevplace=NULL;
                st->prevtrans=NULL;
                st->nexttrans=NULL;
                if ((st->nextplace=net_b->Transitions->preset)!=NULL)
                  st->nextplace->prevplace=st;
                (st->place=pl1)->postset
                =(st->trans=net_b->Transitions)->preset=st;
                ++pl1->y_pos;
              }
            pl1=pl1->prevplace;
          } /* else pl1&EXIT */
      } /* while pl1 */

    /*-----------------------------------------------*/
    /* Die neuen Stellen (links) zentriert anordnen. */
    /*-----------------------------------------------*/

    pos=((int)(net_b->y_dim-(--dim))>>1)+net_b->y_pos;
    if (dim>net_b->y_dim)
      {
        net_b->y_dim=dim;
        net_b->y_pos=pos;
      }
    pos+=--dim;
    while (pl1)
      {
        pos=(pl1->y_pos=pos)-2;
        pl1->numname=1;
        pl1=pl1->prevplace;
      }
#if 1
    /* Netz A links neben Netz B stellen, so dass Netz B links */
    /* oben an die rechte untere Ecke von Netz A stoesst       */
    move_hv(net_a,net_b->x_pos-(net_a->x_pos+1),
                  net_b->y_pos-(net_a->y_pos+net_a->y_dim+1));
    /* Netz C links neben Netz B stellen, so dass Netz B links */
    /* unten an die linke obere Ecke von Netz C stoesst        */
    move_hv(net_c,net_b->x_pos-(net_c->x_pos+1),
                  net_b->y_pos+net_b->y_dim+1-net_c->y_pos);

    /* Groesse anpassen */
    if (net_a->x_pos<net_c->x_pos) {
        net_b->x_pos=net_a->x_pos;
        net_b->x_dim+=net_a->x_dim+1;
    } else {
        net_b->x_pos=net_c->x_pos;
        net_b->x_dim+=net_c->x_dim+1;
    }
    net_b->y_pos=net_a->y_pos;
    net_b->y_dim+=net_a->y_dim+net_c->y_dim-6;

#else

    /* Zentriere Netz C unter Netz B, nach unten direkt anschliessend */
    move_hv(net_c,net_b->x_pos-net_c->x_pos
                  +((int)(net_b->x_dim-net_c->x_dim)>>1)
                 ,net_b->y_pos-net_c->y_pos+net_b->y_dim-1);
    /* Das groessere Netz gibt die Ma"se vor */
    if (net_c->x_dim>net_b->x_dim) {
        net_b->x_dim=net_c->x_dim;
        net_b->x_pos=net_c->x_pos;
    }
    /* Nach unten wird das neue Netz auf jeden Fall laenger */
    net_b->y_dim+=net_c->y_dim-1;

    /* Dito fuer Netz A, nach oben anschliessend */
    move_hv(net_a,net_b->x_pos-net_a->x_pos
                  +((int)(net_b->x_dim-net_a->x_dim)>>1)
                 ,net_b->y_pos-net_a->y_pos-net_a->y_dim+1);
    if (net_a->x_dim>net_b->x_dim) {
        net_b->x_dim=net_a->x_dim;
        net_b->x_pos=net_a->x_pos;
    }
    /* Hier muss auch y_pos beachtet werden */
    net_b->y_dim+=net_a->y_dim-1;
    net_b->y_pos=net_a->y_pos;

#endif


    /* Choice-Stellen reduzieren */
    for (pl=net_b->Places;pl;pl=pl->nextplace)
      {
        if (pl->label&CHOICEPL && pl->tokenage>max1)
          max1=pl->tokenage;
      }
    for (pl=net_c->Places;pl;pl=pl->nextplace)
      {
        if (pl->label&CHOICEPL && pl->tokenage>max2)
          max2=pl->tokenage;
      }
    max=(max1<max2)?max1:max2;
    for (pl=net_b->Places;pl;pl=pl->nextplace)
      {
        if (pl->label&CHOICEPL && pl->tokenage>max)
          pl->label&=~CHOICEPL;
      }
    for (pl=net_c->Places;pl;pl=pl->nextplace)
      {
        if (pl->label&CHOICEPL && pl->tokenage>max)
          pl->label&=~CHOICEPL;
      }

    for (pl1=net_b->Places;pl1;pl1=pl1->nextplace)
      {
        if ( pl1->label&CHOICEPL )
          {
            for (pl2=net_c->Places;pl2;pl2=pl2->nextplace)
              {
                if (pl2->tokenage==pl1->tokenage &&
                    pl2->label&pl1->label)
                  {
                    pl1->label|=DELETE;
                    pl=DuplicatePlace(net_b,pl1,&st,&ts);
                    pl->label&=~DELETE;
                    pl1->x_pos++;
                    if (ts && pl2->preset)
                      {
                        ts->nexttrans=CopyPlacePreset(pl2,pl,&ts1);
                        ts->nexttrans->prevtrans=ts;
                      }
                    else
                      {
                        if (pl2->preset)
                          pl->preset=CopyPlacePreset(pl2,pl,&ts1);
                      }
                    if (st && pl2->postset)
                      {
                        st->nexttrans=CopyPlacePostset(pl2,pl,&st1);
                        st->nexttrans->prevtrans=st;
                      }
                    else
                      {
                        if (pl2->postset)
                          pl->postset=CopyPlacePostset(pl2,pl,&st1);
                      }
                  } /* if label und tokenage gleich */
              } /* for pl2 */
            if ( pl1->label&DELETE )
              pl1=LPNRemovePlace(net_b, pl1);
          } /* if pl1->label */
      } /* for pl1 */
    /* Doppelte Stellen loeschen */
    RestoreKillPlaces(net_c, CHOICEPL);

    /* Falsche TICs loeschen */
    for (tr1=net_b->Transitions;tr1;tr1=tr1->nexttrans)
      {
        if (tr1->type==TIC)
          {
            tr1->type=NORMAL; /* zeigt an, dass diese zu loeschen ist */
            for (tr2=net_c->Transitions;tr2;tr2=tr2->nexttrans)
              {
                if (tr2->type==TIC)
                  {
                    for (st1=tr1->preset,st2=tr2->preset;
                         st1 && st2 && st1->place==st2->place;
                         st1=st1->nextplace,st2=st2->nextplace)
                      skip;
                    /* Entferne Duplikat */
                    if (!(st1||st2))
                      {
                        LPNRemoveTransition(net_c,tr2);
                        tr2=net_c->LastTransition;
                        tr1->type=TIC;
                      }
                  } /* if tr2==TIC */
              } /* for tr2 */
            if (tr1->type==NORMAL)
              tr1=LPNRemoveTransition(net_b,tr1);
          } /* if tr1==TIC */
      } /* for tr1 */
    for (tr2=net_c->Transitions;tr2;skip)
      {
        if (tr2->type==TIC)
          tr2=LPNRemoveTransition(net_c,tr2);
        if (tr2)
          tr2=tr2->nexttrans;
      }

    return DisjointNetUnion(net_b,DisjointNetUnion(RestoreKillPlaces(net_a,EXIT),RestoreKillPlaces(net_c,ENTRY)));
}

/**********************/
/* END OF FILE iter.c */
/**********************/
