/*****************************************************************************/
/*  moby_out.c                                                               */
/*  Di., 17.06.1993 - Di., 21.12.1993                         Stefan Roemer  */
/*  Aenderungen durch '!!!' gekennzeichnet, Burkhard Graves                  */
/*  Mo., 09.01.1995 - Mo., 09.01.1995 (neues PEP-Deteiformat) Stefan Roemer  */
/*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <math.h>
#include "moby_out.h"
#include "boxtypes.h"
#include "main.h"
#include "multiset.h"
#include "lpnet.h"
#include "parser.h"

#define __EXTENDED__

/*****************************************************************************/
/* Ausgabe eines Prozessnetzes als MOBY-ASCII-Netzdatei.                     */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void MOBY_STEdge( FILE * file, int x1, int y1, int x2, int y2 )

#else

void MOBY_STEdge( file, x1, y1, x2, y2 )

  FILE * file;
  int  x1, /* Koordinaten der Stelle */
       y1,
       x2, /* Koordinaten der Transition */
       y2;

#endif

  {
    
    int   x_1,
          x_2,
          y_1,
          y_2;

#ifdef __EXTENDED__    
    float m,
          b,
          dx,
          dy;

    dx = (float) ( x2 - x1 );
    dy = (float) ( y2 - y1 );
    m = (float) radius / hypot( dx, dy );
    x_1 = (int) ( (float) x1 + m * dx );
    y_1 = (int) ( (float) y1 + m * dy );

    if ( x1 == x2 )
      {
        x_2 = x2;
        if ( y1 < y2 )
          {
            y_2 = y2 - radius;
          } /* if */
        else if ( y1 > y2 )
          {
            y_2 = y2 + radius;
          } /* else if */
        else /* ( y1 == y2 ) */
          {
            printf( "MOBY_TSEdge(): Stelle ueberdeckt Transition!\n" );
            /* Hier war wohl ein Tippfehler: Habe 1 in 2 geaendert! */
            y_2 = y2;
          } /* else */
      } /* if */
    else /* ( x1 != x2 ) */
      {
        b = (float) y1 - ( m = dy / dx ) * (float) x1;
        if ( fabs( m ) > 1 )
          {
            if ( y1 < y2 )
              {
                y_2 = y2 - radius;
              } /* if */
            else /* ( y1 >= y2 ) */
              {
                y_2 = y2 + radius;
              } /* else */
            x_2 = (int) ( ( (float) y_2 - b ) / m );
          } /* else if */
        else /* ( fabs( m ) < 1 ) */
          {
            if ( x1 < x2 )
              {
                x_2 = x2 - radius;
              } /* if */
            else /* ( x2 >= x1 ) */
              {
                x_2 = x2 + radius;
              } /* else */
            y_2 = (int) ( m * (float) x_2 + b );
          } /* else */
      } /* else */

#else /* SIMPLE */
    x_1 = x1;
    y_1 = y1 + radius;
    x_2 = x2;
    y_2 = y2 - radius - 2;

#endif /* __EXTENDED__ */

    fprintf( file, "lpt: %d@%d lpt: %d@%d ", x_1, y_1, x_2, y_2 );

  } /* MOBY_STEdge() */


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void MOBY_TSEdge( FILE * file, int x1, int y1, int x2, int y2 )

#else

void MOBY_TSEdge( file, x1, y1, x2, y2 )

  FILE * file;
  int  x1,
       y1,
       x2,
       y2;

#endif
 
  {

    int   x_1,
          x_2,
          y_1,
          y_2;

#ifdef __EXTENDED__    
    float m,
          b,
          dx,
          dy;
 
    dx = (float) ( x2 - x1 );
    dy = (float) ( y2 - y1 );
    m = (float) radius / hypot( dx, dy );
    x_2 = (int) ( (float) x2 - m * dx );
    y_2 = (int) ( (float) y2 - m * dy );

    if ( x1 == x2 )
      {
        x_1 = x1;
        if ( y1 < y2 )
          {
            y_1 = y1 + radius;
          } /* if */
        else if ( y1 > y2 )
          {
            y_1 = y1 - radius;
          } /* else if */
        else /* ( y1 == y2 ) */
          {
            printf( "MOBY_TSEdge(): Stelle ueberdeckt Transition!\n" );
            y_1 = y1;
          } /* else */
      } /* if */
    else /* ( x1 != x2 ) */
      {
        b = (float) y1 - ( m = dy / dx ) * (float) x1;
        if ( fabs( m ) > 1 )
          {
            if ( y1 < y2 )
              {
                y_1 = y1 + radius;
              } /* if */
            else /* ( y1 >= y2 ) */
              {
                y_1 = y1 - radius;
              } /* else */
            x_1 = (int) ( ( (float) y_1 - b ) / m );
          } /* else if */
        else /* ( fabs( m ) < 1 ) */
          {
            if ( x1 < x2 )
              {
                x_1 = x1 + radius;
              } /* if */
            else /* ( x2 >= x1 ) */
              {
                x_1 = x1 - radius;
              } /* else */
            y_1 = (int) ( m * (float) x_1 + b );
          } /* else */
      } /* else */

#else /* SIMPLE */
    x_1 = x1;
    y_1 = y1 + radius;
    x_2 = x2;
    y_2 = y2 - radius - 2;

#endif /* __EXTENDED__ */

    fprintf( file, "lpt: %d@%d lpt: %d@%d ", x_1, y_1, x_2, y_2 );

  } /* MOBY_TSEdge() */


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void PEP_STEdge( FILE * file, int x1, int y1, int x2, int y2 )

#else

void PEP_STEdge( file, x1, y1, x2, y2 )

  FILE * file;
  int  x1, /* Koordinaten der Stelle */
       y1,
       x2, /* Koordinaten der Transition */
       y2;

#endif

  {
    
    int   x_1,
          x_2,
          y_1,
          y_2;

#ifdef __EXTENDED__    
    float m,
          b,
          dx,
          dy;

    dx = (float) ( x2 - x1 );
    dy = (float) ( y2 - y1 );
    m = (float) radius / hypot( dx, dy );
    x_1 = (int) ( (float) x1 + m * dx );
    y_1 = (int) ( (float) y1 + m * dy );

    if ( x1 == x2 )
      {
        x_2 = x2;
        if ( y1 < y2 )
          {
            y_2 = y2 - radius;
          } /* if */
        else if ( y1 > y2 )
          {
            y_2 = y2 + radius;
          } /* else if */
        else /* ( y1 == y2 ) */
          {
            printf( "PEP_STEdge(): Stelle ueberdeckt Transition!\n" );
            /* Hier war wohl ein Tippfehler: Habe 1 in 2 geaendert! */
            y_2 = y2;
          } /* else */
      } /* if */
    else /* ( x1 != x2 ) */
      {
        b = (float) y1 - ( m = dy / dx ) * (float) x1;
        if ( fabs( m ) > 1 )
          {
            if ( y1 < y2 )
              {
                y_2 = y2 - radius;
              } /* if */
            else /* ( y1 >= y2 ) */
              {
                y_2 = y2 + radius;
              } /* else */
            x_2 = (int) ( ( (float) y_2 - b ) / m );
          } /* else if */
        else /* ( fabs( m ) < 1 ) */
          {
            if ( x1 < x2 )
              {
                x_2 = x2 - radius;
              } /* if */
            else /* ( x2 >= x1 ) */
              {
                x_2 = x2 + radius;
              } /* else */
            y_2 = (int) ( m * (float) x_2 + b );
          } /* else */
      } /* else */

#else /* SIMPLE */
    x_1 = x1;
    y_1 = y1 + radius;
    x_2 = x2;
    y_2 = y2 - radius - 2;

#endif /* __EXTENDED__ */

    fprintf( file, "J%d@%d,%d@%d", x_1, y_1, x_2, y_2 );

  } /* PEP_STEdge() */


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void PEP_TSEdge( FILE * file, int x1, int y1, int x2, int y2 )

#else

void PEP_TSEdge( file, x1, y1, x2, y2 )

  FILE * file;
  int  x1,
       y1,
       x2,
       y2;

#endif
 
  {

    int   x_1,
          x_2,
          y_1,
          y_2;

#ifdef __EXTENDED__    
    float m,
          b,
          dx,
          dy;
 
    dx = (float) ( x2 - x1 );
    dy = (float) ( y2 - y1 );
    m = (float) radius / hypot( dx, dy );
    x_2 = (int) ( (float) x2 - m * dx );
    y_2 = (int) ( (float) y2 - m * dy );

    if ( x1 == x2 )
      {
        x_1 = x1;
        if ( y1 < y2 )
          {
            y_1 = y1 + radius;
          } /* if */
        else if ( y1 > y2 )
          {
            y_1 = y1 - radius;
          } /* else if */
        else /* ( y1 == y2 ) */
          {
            printf( "PEP_TSEdge(): Stelle ueberdeckt Transition!\n" );
            y_1 = y1;
          } /* else */
      } /* if */
    else /* ( x1 != x2 ) */
      {
        b = (float) y1 - ( m = dy / dx ) * (float) x1;
        if ( fabs( m ) > 1 )
          {
            if ( y1 < y2 )
              {
                y_1 = y1 + radius;
              } /* if */
            else /* ( y1 >= y2 ) */
              {
                y_1 = y1 - radius;
              } /* else */
            x_1 = (int) ( ( (float) y_1 - b ) / m );
          } /* else if */
        else /* ( fabs( m ) < 1 ) */
          {
            if ( x1 < x2 )
              {
                x_1 = x1 + radius;
              } /* if */
            else /* ( x2 >= x1 ) */
              {
                x_1 = x1 - radius;
              } /* else */
            y_1 = (int) ( m * (float) x_1 + b );
          } /* else */
      } /* else */

#else /* SIMPLE */
    x_1 = x1;
    y_1 = y1 + radius;
    x_2 = x2;
    y_2 = y2 - radius - 2;

#endif /* __EXTENDED__ */

    fprintf( file, "J%d@%d,%d@%d", x_1, y_1, x_2, y_2 );

  } /* PEP_TSEdge() */


/*****************************************************************************/
/* Ausgabe einer Multimenge fuer MOBY                                        */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

static Cardinal MOBY_Multiset( char * str, MultiSet mm )

#else

static Cardinal MOBY_Multiset( str, mm )

  char     * str;
  MultiSet mm;
  /* GLOBAL: bool MSdisplay_style; */

#endif

  {

    Cardinal i,
             len;
    char     dum[ 50 ];

    if ( *mm == 1 )
      {
        strcpy( str, VariableToStr( *(++mm), dum ) );
        len = strlen( dum );
      } /* if */
    else
      {
        strcpy( str, "" );
        len = 1;
        if ( *mm )
          {
            if ( MSdisplay_style )
              {
                if ( *(++mm) > 1 )
                  {
                    sprintf( dum, FORMAT_CARD, *mm );
                    len += strlen( dum );
                    strcat( str, dum );
                  } /* if */
                ActionToStr( *( (mm++) - 1 ), dum );
                if ( *dum == '^' ) { *dum = '^'; }
                strcat( str, dum );
                len += strlen( dum );
                while ( *mm )
                  {
                    strcat( str, "," );
                    len++;
                    if ( *(++mm) > 1 )
                      {
                        sprintf( dum, FORMAT_CARD, *mm );
                        strcat( str, dum );
                      } /* if */
                    ActionToStr( *( (mm++) - 1 ), dum );
                    if ( *dum == '^' ) { *dum = '^'; }
                    strcat( str, dum );
                    len += strlen( dum );
                  } /* while */
              } /* if */
            else /* WIDE */
              {
                ActionToStr( *mm, dum );
                if ( *dum == '^' ) { *dum = '^'; }
                strcat( str, dum );
                for ( i = 2 ; i <= *(mm+1) ; i++ )
                  {
                    ActionToStr( *mm, dum );
                    if ( *dum == '^' ) { *dum = '^'; }
                    strcat( str, "," );
                    strcat( str, dum );
                    len += strlen( dum );
                  } /* for */
                mm++; mm++;
                while ( *mm )
                  {
                    for ( i = 1 ; i <= *(mm+1) ; i++ )
                      {
                        ActionToStr( *mm, dum );
                        if ( *dum == '^' ) { *dum = '^'; }
                        strcat( str, "," );
                        strcat( str, dum );
                        len += strlen( dum );
                      } /* for */
                    mm++; mm++;
                  } /* while */
              } /* else */
            len++;
          } /* if */
        else
          {
            strcpy( str, "0" );
          } /* else */
      } /* else */

    return ( len );

  } /* MOBY_Multiset() */

/*****************************************************************************/
/* Konversion: Interne Datenstruktur --> MOBY-ASCII-Datei.                   */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void MOBY_Net(LPNet net,FILE *file)

#else

void MOBY_Net( net, file )

  LPNet net;
  FILE  * file;

#endif

{
    Place      pl;
    Transition tr;
    STEdge     st;
    TSEdge     ts;
    Cardinal32 count,
               x1, x2, y1, y2,
               nx,     /* Koordinaten Kopfknoten */
               ny;
    char       str[ 2000 ];

    f( "PEP\n" );
    f( "PetriBox\n" );
    f( "FORMAT_A\n" );
    f( "com:''\n" );
    f( "pap:  wis: 1 xnu: 10 ynu: 10 end:\n" );
    f( "set:  wgt: 1 ips: 10@10 ipo: 20@0 ipn: '' ipb: 1 iun: 5 ipp: 0 " );
    f( "ops: 10@10 opo: 20@0 opn: '' opb: 1 onu: 5 opp: 2 rts: 10@10 " );
    f( "rto: 20@0 rtn: '' rtb: 1 rnu: 5 rtp: 4 elw: 1 ena: '' vsi: 10@10 " );
    f( "vno: 20@0 vna: '' vbw: 1 nov: 5 vpm: 0 psi: 10@10 pno: 20@0 " );
    f( "pna: '' pbw: 1 nop: 5 ppm: 0 end:\n" );
    f( " end:\n" );

                                     /* MOBY-Identifikationsnummern erzeugen */
    count = 0;
    pl = net->Places;
    while ( pl )
      {
        pl->numname = ++count;
        pl = pl->nextplace;
      } /* while */
    tr = net->Transitions;
    while ( tr )
      {
        tr->numname = ++count;
        tr = tr->nexttrans;
      } /* while */

                                               /* Liste der Stellen ausgeben */
    pl = net->Places;
    while ( pl )
      {
        nx = pl->x_pos*2*radius;
        ny = pl->y_pos*2*radius;

        fx( "%s: ", ( pl->label&ENTRY ? "IPL"
                                      : pl->label&EXIT ? "OPL"
                                                             : "PLA" ) );
        fx( "idt: %u ", pl->numname );
        fx( "nam: 'P%u' ", pl->numname ); /* !!! */
        if (flag&EXT_LABEL && pl->name)
            fx( "mea: '%s' ", pl->name);
        fxy( "dnp: %u@%u ", nx + radius + 3, ny - radius - 2 ); /* !!! */
        fxy( "dsz: %u@%u ", radius, radius );
        fxy( "dpt: %u@%u ", nx, ny );
        f( "dwd: 2 " ); /* Linienstaerke */
#if 1
        fx( "cma: %u end:\n", ( pl->label&ENTRY ? 1 : 0 ) );
#else
        fxy( "cma: %u ima: %u end:\n", ( pl->label&ENTRY ? 1 : 0 ),
                                       ( pl->label&ENTRY ? 1 : 0 ) );
#endif
        pl = pl->nextplace;
      } /* while */
                                          /* Liste der Transitionen ausgeben */
    tr = net->Transitions;
    while ( tr )
      {
        nx = tr->x_pos*2*radius;
        ny = tr->y_pos*2*radius;

        fxy( "%s: idt: %u ", ( tr->label && (*tr->label == 1) ) ? "RTR" : "TRA",
                                                                  tr->numname );
        fx("nam: 'T%u' ",tr->numname-net->NumPlaces);
        if (flag&EXT_LABEL && (tr->bpn_label || tr->label)) {
            MOBY_Multiset(str,(tr->bpn_label)?tr->bpn_label:tr->label);
            fx("mea: '%s' ",str);
        }

        fxy( "dnp: %u@%u ", nx + radius + 3, ny - radius - 2 );
        fxy( "dsz: %u@%u ", radius, radius );
        fxy( "dpt: %u@%u ", nx, ny );
        f( "dwd: 2 end:\n" ); /* Linienstaerke */

        tr = tr->nexttrans;
      } /* while */
                                             /* Liste der ST-Kanten ausgeben */
    pl = net->Places;
    while ( pl )
      {
        x1 = pl->x_pos*2*radius;
        y1 = pl->y_pos*2*radius;
        st = pl->postset;
        while ( st )
          {
            tr = st->trans;
            x2 = tr->x_pos*2*radius;
            y2 = tr->y_pos*2*radius;
            fxy( "ARC: sou: %u des: %u dsz: 1 ", pl->numname, tr->numname );
            MOBY_STEdge( file, x1, y1, x2, y2 );
            f( "wgt: 1 end:\n" );
            st = st->nexttrans;
          } /* while */
        pl = pl->nextplace;
      } /* while */
    tr = net->Transitions;
    while ( tr )
      {
        x1 = tr->x_pos*2*radius;
        y1 = tr->y_pos*2*radius;
        ts = tr->postset;
        while ( ts )
          {
            pl = ts->place;
            x2 = pl->x_pos*2*radius;
            y2 = pl->y_pos*2*radius;
            fxy( "ARC: sou: %u des: %u dsz: 1 ", tr->numname, pl->numname );
            MOBY_TSEdge( file, x1, y1, x2, y2 );
            f( "wgt: 1 end:\n" );
            ts = ts->nextplace;
          } /* while */
        tr = tr->nexttrans;
      } /* while */

    f( "END:\n" );

  } /* MOBY_Net() */


/*****************************************************************************/
/* Konversion: Interne Datenstruktur --> PEP-Netzdatei (neues Format).       */
/* 09.01.1995                                                  Stefan Roemer */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void PEP_Net( LPNet net, FILE * file )

#else

void PEP_Net( net, file )

  LPNet net;
  FILE  * file;

#endif

  {
    register Place      pl;
    register Transition tr;
    register STEdge     st;
    register TSEdge     ts;
    Cardinal32          count,
                        x1, x2, y1, y2,
                        nx,     /* Koordinaten Kopfknoten */
                        ny;
    char                str[ 2001 ];

    f( "PEP\n" );
    f( "PetriBox\n" );
    f( "FORMAT_N\n" );
    fx( "DPL s7%st2\n", ( flag & WIDE_FORMAT )?"":"n10@-9" );
    fx( "DTR s7%st2\n", ( flag & WIDE_FORMAT )?"":"n10@-9" );
    f( "DPT w1t1\n" );

    /* Liste der Stellen ausgeben */
    f( "PL\n" );
    for ( count = 0, pl = net->Places ; pl ; pl = pl->nextplace )
      {
        pl->numname = ++count;
        if ( flag & WIDE_FORMAT )
          fx( "%u", count );
        nx = pl->x_pos * 2 * radius;
        ny = pl->y_pos * 2 * radius;
        /* Bei erweiterter Ausgabe mit Tokenalter! */
        if (flag&CLOCKNET)
          fxy( "\"P%u_%u\"", pl->numname,pl->tokenage );
        else
          fx( "\"P%u\"", pl->numname ); /* !!! */
        fxy( "%u@%u", nx, ny );
        if (flag&EXT_LABEL && pl->name)
          fx( "b\"%s\"", pl->name);
        if ( flag & WIDE_FORMAT )
          fxy( "N%d@%d", nx + radius + 3, ny - radius - 2 ); /* !!! */
        if ( pl->label )
          {
            fx( "%s", ( pl->label&ENTRY ? "em1M1" : pl->label&EXIT ?"x":"" ) );
            /* BG Initial und Current Marking ausgeben !!! */
          } /* if */
        f( "\n" );
      } /* for ( pl ... ) */
    /* Liste der Transitionen ausgeben */
    f( "TR\n" );
    for ( count = 0, tr = net->Transitions ; tr ; tr = tr->nexttrans )
      {
        tr->numname = ++count;
        if ( flag & WIDE_FORMAT )
          fx( "%u", count );
        nx = tr->x_pos * 2 * radius;
        ny = tr->y_pos * 2 * radius;
        fx("\"T%u\"",tr->numname);
        fxy( "%u@%u", nx, ny );
        if (flag&EXT_LABEL)
          {
            /* Neue Transitionstypen beachten !*/
            if (tr->type==NORMAL)
              {
                if (tr->bpn_label || tr->label)
                  {
                    MOBY_Multiset(str,(tr->bpn_label)?tr->bpn_label:tr->label);
                    fx("b\"%s\"", str);
                  } /* if */
              }
            else
              fx("b\"%s\"",(tr->type==TIC)?"TIC":"TIC2");
          }
        if ( flag&WITH_TIME && tr->time_label)
          {
            fx( "E%u", (unsigned) tr->time_label->low );
            fx( "L%u", (unsigned) tr->time_label->high );
          }
        if ( flag & WIDE_FORMAT )
          fxy( "N%d@%d", nx + radius + 3, ny - radius - 2 ); /* !!! */
        fx( "%s", ( tr->label && ( *tr->label == 1 ) )?"r":"" );
        f( "\n" );
      } /* for ( tr ... ) */
    /* Liste der TS-Kanten ausgeben */
    f( "TP\n" );
    for ( pl = net->Places ; pl ; pl = pl->nextplace )
      {
        if ( flag & WIDE_FORMAT )
          {
            x2 = pl->x_pos * 2 * radius;
            y2 = pl->y_pos * 2 * radius;
          } /* if */
        ts = pl->preset;
        while ( ts )
          {
            tr = ts->trans;
            fxy( "%u<%u", tr->numname, pl->numname );
            if ( flag & WIDE_FORMAT )
              {
                x1 = tr->x_pos * 2 * radius;
                y1 = tr->y_pos * 2 * radius;
                PEP_TSEdge( file, x1, y1, x2, y2 );
              } /* if */
            if ( ts->weight>1 || flag&WIDE_FORMAT )
              fx( "w%u", ts->weight );
            if ( flag & INVISIBLE_ARCS )
              /* Wenn genau ein Flag gesetzt ist als invisible markieren */
              /* das sind genau die zwischen Datenboxen und Kontrollfluss */
              fx( "%s", ( tr->flags ^ pl->marks) ?"v4":"" );
            f( "\n" );
            ts = ts->nexttrans;
          } /* while ts */
      } /* for pl */
    /* Liste der ST-Kanten ausgeben */
    f( "PT\n" );
    for ( pl = net->Places ; pl ; pl = pl->nextplace )
      {
        if ( flag & WIDE_FORMAT )
          {
            x1 = pl->x_pos * 2 * radius;
            y1 = pl->y_pos * 2 * radius;
          } /* if */
        st = pl->postset;
        while ( st )
          {
            tr = st->trans;
            fxy( "%u>%u", pl->numname, tr->numname );
            if ( flag & WIDE_FORMAT )
              {
                x2 = tr->x_pos * 2 * radius;
                y2 = tr->y_pos * 2 * radius;
                PEP_STEdge( file, x1, y1, x2, y2 );
              } /* if */
            if ( st->weight>1 || flag&WIDE_FORMAT )
              fx( "w%u", st->weight );
            if ( flag & INVISIBLE_ARCS )
              /* Wenn genau ein Flag gesetzt ist als invisible markieren */
              /* das sind genau die zwischen Datenboxen und Kontrollfluss */
              fx( "%s", ( tr->flags ^ pl->marks ) ?"v4":"" );
            f( "\n" );
            st = st->nexttrans;
          } /* while */
      } /* for ( pl ... ) */

    f( "TX\n" );
    f( "\n" );

  } /* PEP_Net() */


/*****************************************************************************/
/* END OF FILE moby_out.c                                                    */
/*****************************************************************************/

