/******************************************************************************/
/* FILE set.c                                                                 */
/* Stephan Merkel, May 95                                                     */
/* Martin Ackermann, Winter 1996/97                                           */
/******************************************************************************/

#include "set.h"

/******************************************************************************/
/* Funktionen                                                                 */
/******************************************************************************/


/******************************************************************************/
/********************* GenRange() *********************************************/
/******************************************************************************/
/* Liefert einen Zeiger auf eine Struktur, die die beiden Bereichsgrenzen     */
/* eines Set-Teilbereichs enthaelt.                                           */
/******************************************************************************/

Range *GenRange(Cardinal von,Cardinal bis)
{
    Range *ptr;
 
    (ptr=(Range *)MYmalloc(sizeof(Range)))->next=NULL;
    if (von<=bis) {
        ptr->von=von;
        ptr->bis=bis;
    } else {
        ptr->von=bis;
        ptr->bis=von;
    }
    return ptr;
}

/******************************************************************************/
/************************ insert_elem() ***************************************/
/******************************************************************************/
/* fuegt ein neues Element in die geordnete Liste von Bereichen/einzelnen     */
/* Zahlen ein, falls es nicht schon in einem anderen enthalten ist.           */
/******************************************************************************/

Range *GenRangeList(Range *range,Range *list)
{
    Range *ptr;

    ptr=list;
    if (!ptr)
        return range;
    for (;;) {
        if (range->bis>=ptr->von && range->von<=ptr->bis) {
            if (range->von<ptr->von)
                ptr->von=range->von;
            if (range->bis>ptr->bis)
                ptr->bis=range->bis;
            break;
        }
        if (ptr->next==NULL) {
            ptr->next=range;
            break;
        }
        ptr=ptr->next;
    }
    return list;
}

/******************************************************************************/
/*************************** delete_set() *************************************/
/******************************************************************************/

void KillRange(Range *range)
  {
    Range* akt;

    while ( range )
      {
        akt=range;
        range=range->next;
        MYfree(akt);
      } /* while */
  } /* delete_set() */


/******************************************************************************/
/* END OF FILE set.c                                                          */
/******************************************************************************/
