#ifndef BITS_H
#define BITS_H

/****************************************************************/
/*                                                              */
/*            C O D E - G E N E R A T O R  for B(PN)^2          */
/*                                                              */
/*            Universitaet Hildesheim                           */
/*            Institut fuer Informatik                          */
/*            Stephan Melzer                                    */
/****************************************************************/
/*            Diplomarbeit                                      */
/*            File        : bits.h                                        
              Version     : 1.0
	      Last Update : 18.10.1994
 ****************************************************************/
/*            Module information :                              */
/* This file is the header to the SET handling based on bit-handling.
   In the contemporary version the number of variables is limited to
   100 different ones. If the size is changed take care that 
       BIT_LENGTH * INT_WIDTH ~ #variables
   In this case
       12 * 8 ~ 100
*/
/****************************************************************/
/* Johannes Jaeger -- Sommer 1997 */

typedef unsigned short*	SET;

typedef struct{
  int counter;
  int max_configs;
  int size;
  unsigned short* cross_product;
  int* sizes;
} conf;


int is_element(SET u, int element);
int is_disjunct(SET left, SET right);
char* str_set(SET u);
int elements(SET s);
int get_element(SET u, int number);
void delete_element(SET u, int element);
int is_empty(SET u);
void insert_element(SET u, int element);
SET nil_set(void);
SET union_set(SET left, SET right);
conf* initialize_conf(unsigned short* sets, int number_of_sets);
int* get_next_config(conf* act);
int* check_loop_synchro(conf* c, int* act_config);
SET set_str(char* s);


#endif /* BITS_H */

/*-------------------------------------------------------------------------*/
/* End of file bits.h */
/*-------------------------------------------------------------------------*/
