#ifndef CONFIGURE_H
#define CONFIGURE_H

/*-------------------------------------------------------------------------*/
/*  configure.h                                                            */
/*-------------------------------------------------------------------------*/
/*  B(PN)^2 -> C Codegenerator                                              */
/*                                                                         */
/*  Johannes Jaeger --- Sommer 1997                                        */
/*-------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------*/
/* maximale Laenge eines B(PN)^2-Bezeichners */
#define MAX_IDENT_LENGTH 30

/*-------------------------------------------------------------------------*/
/* maximale Anzahl von Gueltigkeitsbereichen (Intervallen) einer */
/* B(PN)^2-Variablen */
#define MAX_INTERVALS 10

/*-------------------------------------------------------------------------*/
/* die max. Anzahl von Bezeichnern in einem B(PN)^2-Progamm ist aktuell */
/* auf 96 ( = 12 * sizeof(char) = 12 * 8) beschrnkt. Bei Aenderung     */
/* muessen die folgenden 'defines' entsprechend angepasst werden.  */
#define BIT_LENGTH	    12
#define INT_WIDTH	     8
#define	HASH_TABLE_SIZE     96
#define MAX_IDENT           96
#define BIT_LEN_DEFINE_STR  "#define BIT_LENGTH 12\n"
                            /* in c_code.c */

/*-------------------------------------------------------------------------*/
/* die Laenge der Transitions-Beschriftungen im Petrinetz */
#define SINGLE_LABEL_SIZE  20
#define MULTI_LABEL_SIZE  200

/*-------------------------------------------------------------------------*/
/* die Groesse der Prozess-Synchronisationstabelle */
#define MAX_PROCESS 30

/*-------------------------------------------------------------------------*/
/* die Groesse der Synchronisationsterme */
#define MAX_INTERLEAVING     200
#define MAX_INTERLEAVING_STR "#define MAX_INTERLEAVING 200\n\n"

/*-------------------------------------------------------------------------*/
/* Anzahl der freien Speicherbloecke */
#define MAX_GARBAGE 50

/*-------------------------------------------------------------------------*/
/* das Standardverzeichnis fuer den Codegenerator, die Laufzeitbibliothek  */
/* sowie die Header-Datei */
#define STD_LIB_PATH "/opt/pep/bin"

/*-------------------------------------------------------------------------*/
#ifndef RUN_LIB_NAME
#define RUN_LIB_NAME "bpn2c"
#endif /* RUN_LIB_NAME */ 

#define BPN2_SUFFIX ".bpn2"
#define C_SUFFIX    ".c"
#define H_SUFFIX    ".h"
#define PROT_SUFFIX ".prot"


/*-------------------------------------------------------------------------*/
/*  end of file configure.h                                                */
/*-------------------------------------------------------------------------*/

#endif /* CONFIGURE_H */
