#ifndef ERROR_H
#define ERROR_H

/****************************************************************/
/*                                                              */
/*            C O D E - G E N E R A T O R  for B(PN)^2          */
/*                                                              */
/*            Universitaet Hildesheim                           */
/*            Institut fuer Informatik                          */
/*            Stephan Melzer                                    */
/****************************************************************/
/*            Diplomarbeit                                      */
/*            File        : error.h              
              Version     : 1.0
	      Last Update : 18.10.1994
 ****************************************************************/
/*            Module information :                              */
/* This header file contains the error numbers for the compile-, 
   and runtime-system. 
*/
/****************************************************************/
/* Johannes Jaeger -- Sommer 1997 */

#include "misc.h" 

/* runtime error numbers */
#define ERR_FORK_DOES_NOT_WORK 0
#define ERR_STACK_FULL	       1
#define ERR_NOMEM              2
#define ERR_CANT_OPEN_FILE     3
#define ERR_MAX_TOO_SMALL      4
#define ERR_SIGEMPTYSET        5
#define ERR_SIGACTION          6

/* runtime warning numbers */
#define ERR_IS_EMPTY           0
#define ERR_IS_FULL            1


/* compile warning numbers */
#define WARN_INIFINITE_LOOP 0

/* compile error numbers */
#define ERR_ILLEGAL_POSTPRIMED 0
#define ERR_ASSIGNMENT         1
#define ERR_ILLEGAL_CHAN0_PAR  2
#define ERR_TOO_MANY_RANGES    3

/* functions */
void warning(int warn_number);
void compile_error(int number);
void runtime_error(int no);
void exec_error(int err_number, const char *name);

void warning_illegal_value(char name[], int val, Tscope scope);
void runtime_warning(int number);


#endif /* ERROR_H */

/*-------------------------------------------------------------------------*/
/* End of file error.h */
/*-------------------------------------------------------------------------*/
