/****************************************************************/
/*                                                              */
/*            C O D E - G E N E R A T O R  for B(PN)^2          */
/*                                                              */
/*            Universitaet Hildesheim                           */
/*            Institut fuer Informatik                          */
/*            Stephan Melzer                                    */
/****************************************************************/
/*            Diplomarbeit                                      */
/*            File        : gc_control.h
              Version     : 1.0
	      Last Update : 18.10.1994
 ****************************************************************/

#ifndef GC_CONTROL_H
#define GC_CONTROL_H

#include "var_mem_manage.h"

typedef struct{
  int (*bool_check) (container*, container*, int*); 
                            /* boolean expression of the atomic command   */
  char* proc_name; 	    /* account of the atomic command              */
  int is_channel_0_command; /* flag indicating if this is a channel_0 com */
  char*	input_vars;	    /* variables of the input interface	          */
  char*	output_vars;	    /* variables of the output interface	  */
  char*	all_vars;	    /* all used variables inthis command          */
} EXPR_CHECK;

typedef struct{
  EXPR_CHECK *expr_list;    /* list of guards          */
  container *pre;           /* list of pre containers  */
  container *post;          /* list of post containers */
  int is_possible;    /* flag indicating if this alt-set is active */
  int goon_further;   /* flag indicating if this alt-set is a repeat branch */
  int is_c_call;      /* flag indicating if the choosen guard is a c-routine*/
  int number_of_proc_list; /* number of different guards in one alt-set     */
  int checked_bool_proc;   /* number of the choosen guard                   */
} guarded_control;


void lookup_do_construct (guarded_control gc[], int gc_size);
void prepare_account(char* account, guarded_control gc[], int alt_set_numb);
int choose_one_possible_alt_set(guarded_control gc[], int gc_size);

void ExecGuard(guarded_control gc[], int num);

#endif /* GC_CONTROL_H */

/*-------------------------------------------------------------------------*/
/*  end of file gc_control.h                                               */
/*-------------------------------------------------------------------------*/
