#ifndef INCLUDES_H
#define INCLUDES_H

/****************************************************************/
/*                                                              */
/*            C O D E - G E N E R A T O R  for B(PN)^2          */
/*                                                              */
/*            Universitaet Hildesheim                           */
/*            Institut fuer Informatik                          */
/*            Stephan Melzer                                    */
/****************************************************************/
/*            Diplomarbeit                                      */
/*            File        : includes.h                                         
              Version     : 1.0
	      Last Update : 18.10.1994
 ****************************************************************/
/*            Module information :                              */
/* Header file for mostly all modules
*/
/****************************************************************/

#include "configure.h"

/*-------------------------------------------------------------------------*/
/*  Symbols from S. Melzers old scanner/parser frontend                    */
#define	EQU_	     1
#define	REPEAT_	     2
#define	EXIT_        3
#define	COMMA_       4
#define	BEGIN_       5
#define	AND_         6
#define	OR_          7
#define	NOT_         8
#define	UNEQU_       9
#define	GREA_       10
#define	LESS_       11
#define	EGREA_      12
#define	ELESS_      13
#define	PLUS_	    14
#define	MINUS_	    15
#define	MULT_	    16
#define	DIV_	    17
#define	MOD_        18
#define	UNARYMINUS_ 19
#define	SEQ_	    20
#define	CHOICE_	    21
#define	EXPR_BEGIN_ 22
#define	DO_	    23
#define	PARA_	    24
#define	IDENT_	    25

/*-------------------------------------------------------------------------*/
/* Range of the type INT and CARD */
#define MIN_INTEGER -32000
#define MAX_INTEGER  32000
#define MAX_CARD     32000

/*-------------------------------------------------------------------------*/
/* Abbr. for the formal parameter list of C routines */
#define FORMAL_CONST_BOOL "0"
#define FORMAL_CONST_INT  "1"
#define FORMAL_VAR_BOOL   "2"
#define FORMAL_VAR_INT    "3"
#define FORMAL_CHAN	  "4"

/*-------------------------------------------------------------------------*/
/* Types of B(PN)^2 Datatypes */
#define FUNCTION        0
#define	CHANNEL_TYPE	1
#define BOOLEAN_TYPE	2
#define USER_DEFINED	3
#define CARDINAL_TYPE	4
#define INTEGER_TYPE 	5

/*-------------------------------------------------------------------------*/
/* Types of C Datatypes */
#define BOOLEAN 	0
#define NUMERIC		1
#define POINTER	        2

/*-------------------------------------------------------------------------*/
#define UNDEF	     	2
#define CONST		1
#define VAR		0

/*-------------------------------------------------------------------------*/
/*zur Unterscheidung von STACK und CHANNEL */
#define NO_S_OR_C  0
#define STACK_VAR  1
#define CHAN_VAR   2

/*-------------------------------------------------------------------------*/
/* Struktur zur Aufnahme eines Gueltigkeitsbereichs einer BPN^2-Variablen */
typedef struct {
  int low;
  int high;
} Tinterval;

/* Struktur zur Aufnahme aller Gueltigkeitsbereiche einer BPN^2-Variablen */
typedef struct {
  Tinterval bounds[MAX_INTERVALS];   /* die Intervalle */
  unsigned int num_bounds;           /* deren Anzahl   */
} Tscope;

/*-------------------------------------------------------------------------*/
/* Struktur zur Aufnahme einer Referenz, */
/* d.h. Zeile und Spalte einer Anweisung */
/* in einem B(PN)^2-Programm             */
typedef struct {
  int start_l, start_c;
  int end_l, end_c;
  int RefNum;
} Reference;

/* Struktur zur Aufnahme eines Elements */
/* einer einfach verketteten Liste von  */
/* Refrenzen                            */
typedef struct RefListStruct {
  Reference ref;
  struct RefListStruct *nextRef;
} RefList;

/* Struktur fuer Informationen, die in   */
/* die Protokolldatei geschrieben werden */
typedef struct {
  char Msg[MAX_IDENT_LENGTH + 20];
  RefList *refs;
} ProtMsg;

#endif /* INCLUDES_H */

/*-------------------------------------------------------------------------*/
/* End of file includes.h */
/*-------------------------------------------------------------------------*/







