/****************************************************************/
/*                                                              */
/*            C O D E - G E N E R A T O R  for B(PN)^2          */
/*                                                              */
/*            Universitaet Hildesheim                           */
/*            Institut fuer Informatik                          */
/*            Stephan Melzer                                    */
/****************************************************************/
/*            Diplomarbeit                                      */
/*            File        : list.c                                       
              Version     : 1.0
	      Last Update : 18.10.1994
 ****************************************************************/

#include "misc.h"
#include "list.h"

/*------------------------------------------------------------------------*/
list* empty_list(void)
/* Creates a empty list.
*/
{
  return (list*) NULL;
}

/*------------------------------------------------------------------------*/
list* append_list(list* ident_list, char ident[], int ptype)
/* Inserts a new identifier in the list ident_list. If the identifier
   already exists in the list, already_used is set to TRUE.
   ident_list : list of identifiers
   ident : new identifier
*/
{
  list* result;
  list* ptr     = ident_list;
  list* new_one = (list*) Malloc(sizeof(list));

  strcpy(new_one->identifier, ident);
  new_one->partype = ptype;
  new_one->bucket  = -1;
  new_one->next = empty_list();

  if (ptr == empty_list())
    result = new_one;
  else {
    result = ident_list;

    while (ptr->next != empty_list()) {
      ptr = ptr->next;
    }
    ptr->next = new_one;
  }

  return result;
}

/*------------------------------------------------------------------------*/
list* get_ident(list* ident_list, char* ident, int* par_type)
/* Routine to read the next identifier from the list. The reaminder of the
   list is returned.
   ident_list : list of identifiers
   ident : contains the next identifier
*/
{
  list* dummy;

  if (ident_list != empty_list())
  {
    strcpy(ident, ident_list->identifier);
    *par_type = ident_list->partype;
    dummy = ident_list->next;
    /*    free(ident_list); */
    return dummy;
  }
  else
    return (list*) -1;
}
 
/*-------------------------------------------------------------------------*/
/* End of file list.c */
/*-------------------------------------------------------------------------*/
