#ifndef LOCAL_SHM_H
#define LOCAL_SHM_H

/****************************************************************/
/*                                                              */
/*            C O D E - G E N E R A T O R  for B(PN)^2          */
/*                                                              */
/*            Universitaet Hildesheim                           */
/*            Institut fuer Informatik                          */
/*            Stephan Melzer                                    */
/****************************************************************/
/*            Diplomarbeit                                      */
/*            File        : local_shm.h
              Version     : 1.0
	      Last Update : 18.10.1994
 ****************************************************************/
/*            Module information :                              */
/* Header file for shared memory management of external (not B(PN)^2
   variables) variables.
*/
/****************************************************************/

#include	<sys/shm.h>

#define shm_create_bits 0666
#define shm_remove_bits IPC_RMID
#define shm_ende 0


/* MACROS */

#define nil_block ((garbage_block*) NULL)
 
/* Page #0 is used for external variables 
   Page #1 is used for temporary variables */

#define stady_page 0
#define tmp_page   1

/* Linear garbage block chaining list */

typedef struct garbage_block_ptr{
  int	is_used;
  char*	block_begin;
  int	size;
  struct garbage_block_ptr* next;
} garbage_block;

/* Dataspace header */

typedef struct{
  int 		 shm_id;
  char* 	 shm_begin;
  garbage_block* free_blocks;
  key_t		 shm_name;
  int		 shm_size;
} dataspace;


void error(const char* s);
void initialize_shm(int side);
void initialize_shm_control(void);
void switch_page(int side);
char* shm_alloc(int need_size);
void shm_free(void* ptr, int size);
void release_shm_control(void);
void release_shm(int side);


#endif /* LOCAL_SHM_H */

/*-------------------------------------------------------------------------*/
/* End of file local_shm.h */
/*-------------------------------------------------------------------------*/
