/*-------------------------------------------------------------------------*/
/*  misc.h                                                                 */
/*-------------------------------------------------------------------------*/
/*  B(PN)^2 -> C Codegenerator                                              */
/*                                                                         */
/*  Johannes Jaeger --- Sommer 1997                                        */
/*-------------------------------------------------------------------------*/

#ifndef MISC_H
#define MISC_H

#include <stdio.h>
#include "bool.h"
#include "configure.h"
#include "includes.h"


/* globale Variable fuer Informationen, */
/* die von einem generierten Programm   */
/* zur Laufzeit in die Protokolldatei   */
/* geschrieben werden                   */
extern ProtMsg PMsg;

/* globale Variable, mit der die Eintragung */
/* von Referenzen in PMsg gesteuert wird.   */
/* Beim Testen von Guarded Commands (s.     */
/* gc_control.c) bzw. zu synchronisierenden */
/* Aktionen (s. scheduler.c) wird diese auf */
/* TRUE gesetzt, sonst auf FALSE.           */
extern boolean Testing;

/* Struktur fuer eine einfach verkettete */
/* Liste zur Aufnahme von Hash-Buckets   */
typedef struct BucketSwitchEntry {
  int oldbucket;
  int newbucket;
  struct BucketSwitchEntry* next;
} BucketSwitch;

extern boolean generate_executable,
            info_on;

extern FILE *BPN2_File,
            *C_File,
            *H_File,
            *Info_File;

extern char *BPN2_fname,
            *C_fname,
            *H_fname;

extern char Info_fname[1024];

extern char *lib_path;

void* Malloc( size_t size );
void* Realloc(void *ptr, size_t size);
void* Calloc(size_t nmemb, size_t size);
char* upper_name(char* name);
void Init(const char *Prog_path);
void InitPathNames(const char *path);
void CleanUp(void);
void OpenFile(FILE **fp, const char *fname, const char *mode);
void CloseFile(FILE **fp);

boolean legalvalue(int value, Tscope scope);
int createValue(Tscope scope);

void SetRef(Reference *ref, int startl, int startc,
	    int endl, int endc, int RNum);
RefList* AddRefListElem(RefList* RefListHead,
			int startl, int startc, int endl, int endc, int RNum);
void FreeRefList(RefList** refs);
void InitPMsg(void);

BucketSwitch* addbuckets(BucketSwitch* list, int old, int new);

#endif /* MISC_H */

/*-------------------------------------------------------------------------*/
/*  end of file misc.h                                                     */
/*-------------------------------------------------------------------------*/
