#ifndef SCHEDULER_H
#define SCHEDULER_H

/****************************************************************/
/*                                                              */
/*            C O D E - G E N E R A T O R  for B(PN)^2          */
/*                                                              */
/*            Universitaet Hildesheim                           */
/*            Institut fuer Informatik                          */
/*            Stephan Melzer                                    */
/****************************************************************/
/*            Diplomarbeit                                      */
/*            File        : scheduler.h                                   
              Version     : 1.0
	      Last Update : 18.10.1994
 ****************************************************************/

#include "configure.h"
#include "var_mem_manage.h"
#include "algebra.h"


#define	_INPUT_	 1
#define _OUTPUT_ 2

 
typedef char interleaving[MAX_INTERLEAVING];

typedef struct{
  int	semaphore;
  int	(*expr) (container*, container*, int*);
  int 	is_used;
  int	next_entry;
  unsigned short vars[BIT_LENGTH];
  unsigned short input[BIT_LENGTH];
  unsigned short output[BIT_LENGTH];
} process_entry;


extern process_entry* process;

void activate_sleeping_processes(int syn_semaphore, int tab_semaphore);

int insert_process(int sem, int (*bool_proc) (container*, container*, int*),
                   SET in, SET out, SET variables);

int delete_process(int number);

sequence* get_synchronisation(container* pre, container* post, int process);
void init_scheduler(void);
void init_timer_routine(int syn_semaphore, int tab_semaphore, char ** account);
void kill_timer_routine(void);

SET lock_for_synchronisation(int table_sem);
void unlock_for_synchronisation(int table_sem, SET all_vars);
void execute_sequence(sequence *s);

#endif /* SCHEDULER_H */

/*-------------------------------------------------------------------------*/
/* End of file scheduler.h */
/*-------------------------------------------------------------------------*/
