#ifndef SYMBOLTABLE_H
#define SYMBOLTABLE_H

/****************************************************************/
/*                                                              */
/*            C O D E - G E N E R A T O R  for B(PN)^2          */
/*                                                              */
/*            Universitaet Hildesheim                           */
/*            Institut fuer Informatik                          */
/*            Stephan Melzer                                    */
/****************************************************************/
/*            Diplomarbeit                                      */
/*            File        : symboltable.h                             
              Version     : 1.0
	      Last Update : 18.10.1994
 ****************************************************************/
/*            Module information :                              */
/* Header file for the symboltable handling.
*/
/****************************************************************/

#include <stdio.h>
#include "includes.h"
#include "configure.h"
#include "misc.h"


/* Offset for the rehash function */
#define hash_offset    13


/* Datastructure of the symboltable */

typedef struct {
  char	sym[MAX_IDENT_LENGTH];  /* Identifier                 */
  char*  func_params;           /* Prototype of C-Routine     */
  int	 channel_size;          /* Capacity of channels       */
  Tscope scope;                 /* Gueltigkeitsbereich        */
  int	 init_value;            /* initializing value         */
  int	 data_type;             /* Datatype of the variable   */
  int	 access_allowed;        /* Flag for Access            */
  int    bucket_free;           /* Indicator, if it`s used    */
  int	 covered_entry;         /* nested block covered entry */
  int	 access_noticed;        /* Flag indicates the its use */
  int    stack_or_chan;         /* Identifier is stack/channel/none */
  int    RefNum;
} entry;

int lookup(char* symbol);
void get_properties(int bucket, int* type, Tscope* scope,
		    int* chan_size, int* init, int* s_or_c);
void read_write_access(int bucket);
void add_hash_table(FILE* c_code);
void print_hashtab(FILE* ptr);
int entry_used(int bucket);
int overriding_insert(char* symbol, int type, Tscope scope, 
		      int chan_size, int init, int s_or_c, int RNum);
void recover_entry(int bucket);
char* get_procedure_type(int bucket);
void init_hashtab(void);
void insert_function(char* symbol, char* params);


#endif /* SYMBOLTABLE_H */

/*-------------------------------------------------------------------------*/
/* End of file symboltable.h */
/*-------------------------------------------------------------------------*/
