/**********************************/
/* calc.h                         */
/* Burkhard Graves, 06.10.93      */
/* Lars Jenner, Juni 1994         */
/**********************************/

#ifndef __CALC_H__
#define __CALC_H__

#include "../frontend/function.h"
#include "symtab.h"

/**********************************/
/* Globale Defines                */
/**********************************/

#define F_INT       "%i"
#define F_INT_KOMMA "%i,"
#define F_VAR       "%s_%i_%i"
#define F_CHAN_R    ",%s?%i"
#define F_CHAN_W    ",%s!%i"
#define MAPVAR1    ",%s_%d_%d"
#define MAPVAR2    "->%s_%d_%d"
#define MAPCHAN_R1 ",%s?%d"
#define MAPCHAN_R2 "->%s?%d"
#define MAPCHAN_W1 ",%s!%d"
#define MAPCHAN_W2 "->%s!%d"

/**********************************/
/* Globale Typdefinitionen        */
/**********************************/

typedef struct {
    int *set;
    int  wert;
} FTupel;

/**********************************/
/* Globale Datenstrukturen        */
/**********************************/

extern char txt_buffer[];

/*********************************/
/* Globale Funktionen            */
/*********************************/

void   init_elements PROTO ((void));
void remove_elements PROTO ((void));
void set_act_element PROTO ((int x));
int    calc_elements PROTO ((int n,SymTabEntry *entry));

void         un_primed PROTO ((SymTabEntry *entry));
void        pre_primed PROTO ((SymTabEntry *entry));
void       post_primed PROTO ((SymTabEntry *entry));
void       r_w_channel PROTO ((SymTabEntry *entry,int i));
void            simple PROTO ((int value));

void           calc_un PROTO ((int (*op)(int wert)));
void          calc_bin PROTO ((int (*op)(int wert1,int wert2)));
char        *translate PROTO ((void));

/**********************************/
/* END OF FILE calc.h             */
/**********************************/

#endif /* __CALC_H__ */
