/**********************************/
/* ops.c                          */
/* version 2.1                    */
/* Burkhard Graves, 06.10.93      */
/* Lars Jenner, Juni 1994         */
/* slight modifications 03/95     */
/*              by Stephan Merkel */
/**********************************/


#include "ops.h"
#include "../frontend/set.h"

/**********************************/
/* Implementierung                */
/**********************************/

int or(int wert1,int wert2)
{
    return (is_bool(wert1) && is_bool(wert2)) ?
        wert1 | wert2 : FF;
}

int and(int wert1,int wert2)
{
    return (is_bool(wert1) && is_bool(wert2)) ?
        wert1 & wert2 : FF;
}

int not(int wert)
{
    if (wert==FF)
        return TT;
    else
        return FF;
}

int equal(int wert1,int wert2)
{
    return (wert1==wert2)? TT : FF;
}

int nequal(int wert1,int wert2)
{
    return (wert1!=wert2)? TT : FF;
}

int lower(int wert1,int wert2)
{
    return (wert1<wert2)? TT : FF;
}

int greater(int wert1,int wert2)
{
    return (wert1>wert2)? TT : FF;
}

int gequal(int wert1,int wert2)
{
    return (wert1>=wert2)? TT : FF;
}

int lequal(int wert1,int wert2)
{
    return (wert1<=wert2)? TT : FF;
}

int plus(int wert1,int wert2)
{
    return (is_bool(wert1) || is_bool(wert2)) ?
        FF : wert1+wert2;
}

int minus(int wert1,int wert2)
{
    return (is_bool(wert1) || is_bool(wert2)) ?
        FF : wert1-wert2;
}

int multiplication(int wert1,int wert2)
{
    return (is_bool(wert1) || is_bool(wert2)) ?
        FF : wert1*wert2;
}

int division(int wert1,int wert2)
{
    return (is_bool(wert1) || is_bool(wert2)) ?
        FF : wert1/wert2;
}

int modulo(int wert1,int wert2)
{
    return (is_bool(wert1) || is_bool(wert2)) ?
        FF : wert1%wert2;
}

int negate(int wert)
{
    return (is_bool(wert)) ? FF : -wert;
}

/**********************************/
/* END OF FILE ops.c              */
/**********************************/
