/************************************/
/* function.c                       */
/* Burkhard Graves, 06.10.93        */
/* Lars Jenner, Juni 1994           */
/* Stephan Merkel, Feb. 95          */
/* Martin Ackermann, Winter 1996/97 */
/************************************/

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

#include "function.h"
#include "frontend.h"

/******************************************************************************/
/* Defines                                                                    */
/******************************************************************************/

#ifdef YACC
#define ERR_OFFS 1
#else /* using bison */
#define ERR_OFFS (Type==ERR?1:0)
#endif
  /* bison increments yynerrs before calling yyerror() */

#define EPSILON '\0'

#define err_out (msg_out?msg_out:stderr)

const char *MsgType[]={"info   ", "warning", "error  ", "fatal  "};

FILE* msg_out=NULL;

extern int   yynerrs;
extern int   yylineno;
extern char *yytext;

/******************************************************************************/
/* Implementierung                                                            */
/******************************************************************************/

void Msg( int Type, ... )
{
   va_list argptr;
   char *Fmt;

   va_start(argptr,Type);
   Fmt = va_arg(argptr,char*);
   if ( GL_ParserMsg )
     fprintf( err_out, "[line %3d] ", yylineno );
   fprintf( err_out, MsgType[0x3F & (int)Type]);
   if ( GL_ParserMsg && (0x3F & Type) == ERR )
     fprintf( err_out, " %-3d", yynerrs + ERR_OFFS );   
   if ( GL_ParserMsg && yytext[0] != EPSILON )
     fprintf( err_out, " (before or at '%s')", yytext );
   fprintf( err_out, ": " );
   vfprintf(err_out,Fmt,argptr);
   va_end(argptr);
   fprintf(err_out,"\n");

   if( Type==ERR )
     yynerrs++;
   else if ( Type==FAT ) 
     {
       fprintf(err_out,"\n");
       exit(1);
     }
}

/**********************************/
/* END OF FILE function.c         */
/**********************************/
