#include "list.h"
#include "function.h"

T_list alloc_list()
{
	T_list list = MYmalloc(sizeof(list_instance));

	list->end = NULL;
	list->count = 0;
	list->elems = NULL;

	return list;
}

void list_add_proc(T_list list, void *what)
{
	if ((list->count & 3) == 0)
	{
		list->elems = MYrealloc(list->elems,
			(list->count+4) * sizeof(void*));
		list->end = list->elems+list->count;
	}
	*(list->end++) = what;
	list->count++;
}

void revert_list(T_list list)
{
	void **startp, **endp, *tmp;

	if (!list->count) return;
	for (startp = list->elems, endp = list->end-1;
	     startp < endp; startp++, endp--)
	{
		tmp = *startp;
		*startp = *endp;
		*endp = tmp;
	}
}

void list_remove_tail(T_list list)
{
	if (!list->count) return;
	list->count--;
	list->end--;
}
