#ifndef __LIST_H__
#define __LIST_H__

typedef struct
{
	void **end;
	void **run;
	int count;
	void **elems;
} *T_list, list_instance;

extern T_list alloc_list(void);
extern void list_add_proc(T_list,void*);
extern void revert_list(T_list);
extern void list_remove_tail(T_list);

#define free_list(list) if (list && list->elems) free(list->elems); free(list)
#define list_elem(list,i,type) (*(type*)(list->elems+(i)))
#define list_add(list,what) (list_add_proc(list,(void*)(what)))
/* Vorsicht: keine verschachtelten for_list-Schleifen auf derselben Liste! */
#define for_list(list,elem,type) \
	if (list->elems) for (elem = *((type*)(list->run = list->elems));  \
		list->run < list->end; \
		elem = *((type*)++list->run))
#define list_pos(list) (list->run - list->elems)
#define list_set_pos(list,x) (list->run = list->elems + x)

#endif /* __LIST_H__ */
