/******************************************************************************/
/* FILE set.h                                                                 */
/* Stephan Merkel, May 95                                                     */
/* Martin Ackermann, Winter 1996/97                                           */
/******************************************************************************/

#ifndef __SET_H__
#define __SET_H__

#include <stdio.h>
#include "function.h"


/******************************************************************************/
/* Globale Defines                                                            */
/******************************************************************************/

#define is_bool(x)     (x==TT || x==FF)

#define fprintset( file, x ) fprintf(file, (x==TT)?"tt":((x==FF)?"ff":"%d"), x)

#define SET_MAX( x ) ( x->high )
  /* die high-komponente des kopfes enthaelt das maximum */


/******************************************************************************/
/* SetRange                                                                   */
/******************************************************************************/

typedef struct SetRange_
  /* Fuer die Zuweisung eines Wertebereichs eines Sets durch EINEN Zeiger */
  {
    int                low; /* Start des Wertebereichs */
    int                high; /* Ende des Wertebereichs */
    struct SetRange_ * next; /* Verkettung */

  } SetRange, *Set;


/******************************************************************************/
/* Globale Funktionen                                                         */
/******************************************************************************/

SetRange    * GenRange PROTO (( int low, int high ));
SetRange * insert_elem PROTO (( SetRange * new_elem, SetRange * old_head ));
int             cardin PROTO (( SetRange * set ));
bool                in PROTO (( Set set, int elem ));
int           nth_elem PROTO (( Set set, int ord_num ));
void         write_set PROTO (( FILE * file, Set set ));
bool           sub_set PROTO (( Set sub, Set super ));
bool           is_elem PROTO (( Set set, int elem ));
void        delete_set PROTO (( Set set ));


#endif /* __SET_H__ */

/******************************************************************************/
/* END OF FILE set.h                                                          */
/******************************************************************************/
