%option noyywrap
%option nounput
%{
#include "expr.h"

#define YY_INPUT(buf,result,max_size) \
 { \
 result = (*strptr == '\0') ? YY_NULL : (buf[0] = *strptr++, 1); \
 }
char* strptr;
%}

DIGIT [[:digit:]]
ID    [a-zA-WYZ@_\']
ID2   [[:alnum:]!?_@\']*
%%
[ \t\n]+	/* eat up white space */
ff		return FALSE;
tt		return TRUE;
dot		return DOTTOKEN;
and		return AND;
&		return AND;
or		return OR;
\|		return OR;
not		return NOT;
!		return NOT;
pr/{DIGIT}	return PROJ;
X		return CROSS;
\<=		return LE;
\>=		return GE;
\.\.		return DOTDOT;
{DIGIT}+	yylval.wert = atoi( yytext );return NUMBER;
{ID}{ID2}*	|
X{ID2}+		strcpy(yylval.string,yytext);return IDENT;
.		return yytext[0];
