#include <stdio.h>
#include <string.h>
#include "memlib.h"
#include "readlib.h"

char** read_fcdead(char* inname)
{
  FILE* filename;
  Cardinal32 trans_num=0,seq_num,i;
  char* name=NULL, *cmd;
  char** transitions, **sequence=NULL;

  if ((filename=fopen(inname,"r")))
  {
    name=(char*)MYmalloc(256*sizeof(char));
    while(!trans_num)
    {
      fscanf(filename,"%s",name);
      if (name[0]=='B')
	trans_num=atoi(name+1);
    }
    ReadNewline(filename);

    transitions=(char**)MYmalloc(trans_num*sizeof(char*));
    while(fscanf(filename,"%*c%d",&i))
    {
      cmd=RL_ReadEnclString(filename);
      ReadNewline(filename);
      transitions[i]=strdup(cmd);
    }

    ReadNewline(filename);
    fscanf(filename,"%s",name);
    seq_num=atoi(name+1)-1;
    ReadNewline(filename);

    sequence=(char**)MYmalloc(seq_num*sizeof(char*));
    sequence[seq_num]=NULL;

    while(seq_num--)
    {
      ReadNewline(filename);
      fscanf(filename,"%*s %*s %i",&i);
      sequence[seq_num]=transitions[i];
      ReadNewline(filename);
    }

    Free(name);
    fclose(filename);
  }

  return sequence;
}

int main(int argc, char** argv)
{

  char** seq;
  FILE* outfile=stdout;

  if ((argc<2)||(argc>3))
  {
    fprintf(stderr,"Usage: fcdead2pep <fc_dead_file> [<result_file>]\n");
    fprintf(stderr,"Convert counter example automaton into PEP sequence.\n");
    exit(1);
  }
  else
  {
    seq=read_fcdead(argv[1]);

    if (seq)
    {
      if ((argc==3)&&!(outfile=fopen(argv[2],"w")))
	PEPerror("Could not open file for writing.\n");
      fprintf(outfile,"_SEQUENCE:\n");
      while(*seq)
      {
        fprintf(outfile,"%s",*seq++);
	if (*seq)
	  fprintf(outfile,",");
      }
      fprintf(outfile,"\n");
    }
  }
  exit(0);
}
