#include <string.h>
#include <stdio.h>
#include "read_slist.h"
#include "readlib.h"
#include "readHL.h"

/*****************************************************************************/
/****************************** read_slist ***********************************/
/*****************************************************************************/

void create_unmarked(M_Net net, MPTupel pllist)
{
	M_Place pl = NULL;

	pl = M_fast_insert_place(net,++placecount,&pl);
	sprintf(sbuf, "U%u", net->NumInv);
	pl->charname = MYstrdup(sbuf);
	pl->invnum = net->NumInv;
	pl->index = 0;
	MPTT_AddValue(pllist,pl);
}

void read_slist(M_Net net, char *PEPfilename)
{
	register char	ch;
	register FILE	*infile;
	M_Place		pl;
	char		*c,*s,*cmd;
	int		index;
	MPTupel		pllist;

	NNinput_file = PEPfilename;
	NNinput_line = 1;

	/* Oeffne PEP-Datei */
	if (!(infile = fopen(PEPfilename, "r")))
	{
		fprintf(stderr, "ERROR: read_slist(): could not open file "
				"'%s' for reading.\n", PEPfilename);
		exit(2);
	} /* if */

	cmd=ReadCmdToken(infile);
	if (strcmp(cmd, "PEP"))
		PEPerror("keyword 'PEP' expected");

	ReadNewline(infile);
	cmd=ReadCmdToken(infile);
	if (strncmp(cmd, "S_List",6))
		PEPerror("format identifier 'S_List' expected");

	ReadNewline(infile);
	cmd=ReadCmdToken(infile);
	if (strncmp(cmd, "FORMAT_N", 8))
		PEPerror("keyword 'FORMAT_N' or 'FORMAT_N2' expected");

	ReadNewline(infile);
	cmd=ReadCmdToken(infile);
	if (strcmp(cmd, "LIST")) PEPerror("keyword 'LIST' expected");
	ReadNewline(infile);

	placecount = AnzPlNamen;
	net->NumInv = 0;
	net->invplist = MPT_Create();
	while ((ch = getc(infile)) && !feof(infile))
	{
		ungetc(ch,infile);

		index = 0;
		MPTT_AddValue(net->invplist,pllist = MPT_Create());
		create_unmarked(net,pllist);

		cmd=RL_ReadEnclString(infile);
		s = cmd;
		for (;;)
	 	{
			for (c = s; *c && *c != ','; c++);
			ch = *c;
			*c = '\0';
			for (pl = net->Places; pl; pl = pl->nextplace)
				if (!strcmp(pl->charname,s)) break;

			if (!pl) PEPerror("invalid place identifier");
			pl->invnum = net->NumInv;
			pl->index = ++index;
			MPTT_AddValue(pllist,pl);

			if (!ch) break;
			s = c+1;
		} 

		net->NumInv++;
		ReadNewline(infile);
	}

	fclose(infile);

} /* read_slist */
