#include <stdio.h>
#include "rw_fc2.h"
#include "readlib.h"

/*****************************************************************************/
/******************************** write_fc2 **********************************/
/*****************************************************************************/

void write_fc2(M_Net net, char *filename, char *structname)
{
	FILE            *file;
	int		i,j,k;
	M_Place		pl,tmppl;
	M_Transition	tr;
	MPTupel		pllist,trlist;

	if (!(file = fopen(filename, "w")))
		PEPerror("Could not open file for writing");

	fx("nets %u\n",net->NumInv+1);
	fx("   hook\"main\" > %u\n",net->NumInv);
	fx("   struct\"%s\"\n",structname);

	for (i = 0; i < net->NumInv; i++)
	{
		pllist = MT_PlaceMPT(net->invplist,i);
		trlist = MT_PlaceMPT(net->invtlist,i);

		fx("   net %u\n",i);

		fx("      structs %u\n",pllist->count+1);
		for (j = 0; j < pllist->count; j++)
			fxy("         :%u \"%s\"\n",
				j,MT_PlaceP(pllist,j)->charname);
		fxy("         :%u \"part%u\"\n",pllist->count,i);

		fx("      behavs %u\n",trlist->count);
		for (j = 0; j < trlist->count; j++)
			fxy("         :%u \"%s\"\n",
				j,MT_PlaceT(trlist,j)->charname);

		fx("      struct %u\n",pllist->count);
		
		pl = MT_PlaceP(pllist,0);
		for (j = 1; j < pllist->count; j++)
			if ((tmppl = MT_PlaceP(pllist,j))->label == ENTRY)
				pl = tmppl;
		fx("      logic \"initial\">%u\n",pl->index);

		f("      behav 0");
		for (j = 1; j < trlist->count; j++) fx("+%u",j);
		f("\n");

		f("      hook \"automaton\"\n");

		fx("      vertice %u\n",pllist->count);
		for (j = 0; j < pllist->count; j++)
		{
		    pl = MT_PlaceP(pllist,j);
		    fx("         vertex%u\n",j);
		    fx("            struct %u\n",j);
		    fx("            edges %u\n",pl->edges->count);

		    for (k = 0; k < pl->edges->count; k++)
		    {
			fx("               edge%u\n",k);
			fx("               behav %u\n", MT_Place(pl->edges,k));
			fx("                -> %u\n", MT_Place(pl->to,k));
		    }
		}
	}
	
	fx("   net %u\n",net->NumInv);
	fx("      behavs %u\n",net->numbridges);
	for (i = 0, tr = net->Transitions; tr; tr = tr->nexttrans)
		if (tr->invcounter >= 1)
			fxy("         :%u \"%s\"\n",i++,tr->charname);
	f("      struct _< 0");
	for (i = 1; i < net->NumInv; i++) fx(",%u",i);
	f("\n\n");
	f("      hook \"synch_vector\"\n");
	f("      vertice 1\n");
	f("         vertex 0\n");
	fx("         edges %u\n",net->numbridges);
	
	for (i = 0, tr = net->Transitions; tr; tr = tr->nexttrans)
		if (tr->invcounter >= 1)
		{
			fx("               edge %u\n",i);
			fx("behav %u < ",i++);
			for (j = 0; j < net->NumInv; j++)
			{
				if (j) f(",");
				if (tr->index[j] >= 0) fx("%u",tr->index[j]);
				else f("*");
			}
			f(" ->0\n");
		}

	fclose(file);

} /* write_fc2 */
