/********************************************************************/
/* Lib fuer Operationen im Binear-Baum                              */
/* Datei		: btree.c				    */
/* Autor		: Thomas Thielke                            */
/* letzte Aktualisierung: 22.08.1992                                */   
/********************************************************************/

/* Includes							*/
#include <string.h>
#include "btree.h"
#include "error.h"
#include "memlib.h"

/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/
/* Funktion: new_node(p1,p2,p3)					*/
/* Zweck   : Erzeugen eines neuen Knoten fuer Strukturbaum 	*/
/*	     und belegen des Feldes info mit Wert aus p1 und	*/
/*	     anhaengen der Zeiger p2,p3 als linker bzw. rechter	*/
/*	     Nachfolger						*/
/*	     Rueckgabewert: Zeiger auf neuen Knoten		*/
/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/

BTREE 
new_node(s,left_ptr,right_ptr)

char* s;			/* Belegung des Knotens		*/
BTREE left_ptr, right_ptr;	/* Zeiger auf Unterbaeume 	*/

{
   BTREE node;

   if((node = (BTREE) malloc(sizeof(NODE))) != NULL)
 
     {
 	if((node->info= strdup(s)) == NULL)
	{
	  mca_error(ERR1);
	  exit(1);
         }
	node->left_child  = left_ptr;
	node->right_child = right_ptr;
	return(node);
      }
    else
      {
        mca_error(ERR1);
	exit(1);
       }
 }


/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/
/* Funktion: copy_tree(p1)					*/
/* Zweck   : Erzeugen einer Kopie des Baumes p1, wenn !=NULL	*/
/*	     Rueckgabewert: Zeiger auf Wurzel der Kopie von p1	*/
/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/

BTREE 
copy_tree(tree)

BTREE tree;

{

   BTREE new_tree;

   if(tree != NULL)
   {
      new_tree = new_node(tree -> info, NULL, NULL);
      new_tree -> left_child  = copy_tree(tree -> left_child);
      new_tree -> right_child = copy_tree(tree -> right_child);
      return(new_tree);    
   }
   else
      return(NULL);   
}
