/********************************************************************/
/* Lib fuer Operationen in linearer Liste                           */
/* Datei		: list.c				    */
/* Autor		: Thomas Thielke                            */
/* letzte Aktualisierung: 23.08.1992                                */   
/********************************************************************/

/* Includes							*/
#include <stdlib.h>
#include "list.h"
#include "error.h"

/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/
/* Funtion: insert_list(p1,p2,p3)				*/
/* Zweck  : Einfuegen eines Elementes p2 in Liste p1 sortiert	*/
/*   	    nach Groesse des Wertes von p3			*/
/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/

void 
insert_list(head,word,val)

LINK   *head;
BTREE  *word;
int    val;

{
   LINK  curr;
   LINK  prev = NULL;
   LINK  temp;

/* Such Stelle zum Einfuegen oder Ende der Liste		*/
   for(curr=*head; curr!=NULL && val>curr->level; curr=curr->next)
	prev = curr;

/* Erzeuge neuen Knoten und fuege an richtiger Stelle ein	*/
   temp = new_element(word,val);

   temp->next = curr;
   if( prev ==  NULL )	/* fuege am Anfang der Liste ein	*/
     *head = temp; 
   else
     prev->next = temp;
}


/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/
/* Funtion: new_element(p1,p2)					*/
/* Zweck  : Erzeugen eines neuen Listenelements			*/
/*   	    und belegen des Felder info,level mit Wert p1,p2	*/
/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/

LINK 
new_element(word,val)
 
BTREE *word;
int   val;

{
   LINK  head;

   if((head = (LINK) malloc (sizeof(ELEMENT))) != NULL) 
     {
	head -> level = val;
	head -> info  = word;
	head -> next  = NULL;
	return(head);
     }
   else
     {
     	mca_error(ERR1);
	exit(1);
     }  
}


