%option noyywrap
%option nounput
%{
#include <string.h>
#include "btree.h"
#include "parser.tab.h"
%}

DIGIT	[[:digit:]]
ID	[_[:alpha:]]
%%
[ \t\n]+	;
%.*\n		;
{ID}({ID}|{DIGIT})*	return place;
\<=>		return equivalence;
=>		return implication;
-		return not;
#		return sbox;
\^		return diamond;
\+		return or;
\*		return and;
1		return true;
0		return false;
.		return yytext[0];

