/********************************************************************/
/* Lib fuer Operationen zum Anzeigen von Matrixen und Strukturbaum  */
/* Datei		: show.c				    */   
/* Autor		: Thomas Thielke			    */
/* letzte Aktualisierung: 10.09.1992				    */
/********************************************************************/

/* Includes							*/
#include <stdio.h>

#include "show.h"
#include "list.h"
#include "load.h"
#include "mca.h"

/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/
/* Funktion: print_tree(p1,p2)         	        		*/
/* Zweck   : Ausgabe des Strukurbaumes p1 inorder und Anzeigen 	*/
/* 	     derjeweiligen Hoehe p2 im Baum durch Einruecken	*/
/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/

void
print_tree(node,level)

BTREE node;
int   level;

{
   int i;

   if (node != NULL)
	{
	   print_tree(node ->left_child, level+1);
	   for (i=0; i<level; i++)
		printf("   ");
	   printf("-%s:%d\n", node->info,(int)node);
 	   print_tree(node -> right_child, level+1);
	}
}

								
/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/
/* Funktion: print_list(p1)         	        		*/
/* Zweck   :  Gibt  Liste p1 aus				*/
/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/

void
print_list(head)

LINK head;
{
   if(head == NULL)
	printf("NIL");
   else
	{
          printf("\ninfo: %d  level: %d",(int)head->info, head->level);
	  if (head->next) print_list(head->next);
	}
}


/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/
/* Funktion: print_matrix(p1,p2,p3)				*/
/* Zweck   : Fuer Testzwecke Belegung der I-Matrix p1 anzeigen	*/
/*	     entsprechend der Anzahlen p1/p2 der Stellen und	*/
/*	     Transitionen.					*/
/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/

void 
print_matrix(matrix, NP, NT)

IMX  matrix;
int  NP;
int  NT;

{
  int i, j;

 printf("\nIncidence matrix:");
 for(i=0; i<=NP; i++)
  {
     printf("\n %d ", i);

     if(plnamen[i] && DEB) printf(" %s ",plnamen[i]);/* 11.2.94*/
     for(j=0; j<=NT; j++)
     {
       printf(" %d ",(*(matrix+i)+j)->element);
     }
   }

 printf("\n\nLoops:");
 for(i=0; i<=NP; i++)
    {
	printf("\n %d ", i);
	for(j=0; j<=NT; j++)
	{
	  printf(" %d",(*(matrix+i)+j)->flag);
	}
     }
  printf("\n");
}

