/********************************************************************/
/* Utilities						       	    */
/* Datei		: util.c				    */   
/* Autor		: Thomas Thielke			    */
/* letzte Aktualisierung: 10.09.1992				    */
/********************************************************************/

/* Includes							*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "util.h"
#include "error.h"
#include "load.h"
#include "prep.h"
#include "mca.h"

/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/
/* Funktion: sread_num(p1,p2)             		    	*/
/* Zweck   : Nummer der S/T-Aussage p1 erkennen zurueckliefern  */
/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/

int
sread_num(s,i)

char* s;
int    *i;

{
    int num=0;
    while( isdigit(s[*i]) )
    {
      num = num * 10 + (s[*i]-'0');
      (*i)++;
    }
    return num;
}


/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/
/* Funktion: get_ptval(p1,p2,p3,p4,p5,p6,p7)			*/
/* Zweck   : Zerlegen einer Stellen/Transitionsaussage p1 in 	*/
/*	     einzelne Teile p2,p3,p4,p5				*/
/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/

void 
get_ptval(s,pt,num,op,val,np,nt)

char* s;
int    *pt;
int    *num;
int    *op;
int    *val;
int    np;
int    nt;

{
   /* counts read character */
   int i=0;  

/* Formel in Atome zerlegen	*/
  i+=strspn(s+i," ");
  if( s[i] == 'S' )
    *pt=0;
  else if( s[i] == 'T' )
    *pt=1;
  else
   {
     mca_error(ERR8);
     exit(8);
   }  
  i++;
  *num=sread_num(s,&i);

/* Gueltigkeit der Aussagen pruefen				*/
  if(!(*pt) && (*num)>np) 
	{
	  mca_error(ERR7);
	  exit(7);
	}
  if( (*pt) && (*num)>nt)
	{
	  mca_error(ERR7);
	  exit(7);
	}

  if( (*pt) )
  {
      i+=strspn(s+i," ");
      /* Typ des Op. der T-Aussage s erkennen und in op ablegen */
      if(s[i] == '<') *op = 1; 
      else if(s[i] == '>') *op = 2;
      else if(s[i] == '=') *op = 3;
      else
        {
          mca_error(ERR8);
          exit(8);
        }
      i++;
      if(*op == 1 || *op == 2)
        i++;
      i+=strspn(s+i," ");
      *val=sread_num(s,&i);
  }
}


/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/
/* Funktion: gen_pt(p1,p2,p3,p4,p5)				*/
/* Zweck   : Erzeugen einer Stellen/Transitionsaussage aus 	*/
/*	     einzelnen Teilen p1,p2,p3,p4			*/
/*	     Rueckgabewert: generierte Transitionsaussage	*/
/*FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF*/

char*
gen_pt(spt,num,sop,val)

char *spt;
char *sop;
int   num;
int   val;

{

  char s1[MAXLEN], s2[MAXLEN];	/*groesse bestimmen ???? 	*/

#if 0

  s1[0] = s2[0] = '\0';
  strcat(s1,spt);
  sprintf(s2,"%d",num);
  strcat(s1,s2);
  strcat(s1,sop);
  sprintf(s2,"%d",val);
  strcat(s1,s2);

  return(s1);

#else

  strcpy(s1,spt);
  sprintf(s2,"%d",num);
  strcat(s1,s2);
  strcat(s1,sop);
  sprintf(s2,"%d",val);
  strcat(s1,s2);

  return(strdup(s1));

#endif
}

