#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "neunetze.h"

bool change,*ev_used,*frozen,*places;
size_t bytes;
LMPNet net;
FILE *outfile;

static void printconfig(void)
{
  unsigned int i;

  for(i=1;i<=net->NumTransitions;++i)
  {
    if(ev_used[i])
    {
      if (outfile==stdout)
        fprintf(outfile,"E%d, ",i);
      else
        fprintf(outfile,"%d ",i);
    }
  }
  fprintf(outfile,"\n");
}

static bool freeze(Transition e)
{
  STEdge ce;
  TSEdge ec;

  if (ev_used[e->numname]) return False;
  if (frozen[e->numname]) return True;
  frozen[e->numname]=change=True;
  for(ec=e->postset;ec;ec=ec->nextplace)
    for (ce=ec->place->postset;ce;ce=ce->nexttrans)
      if (!freeze(ce->trans))
        return False;
  return True;
}

static bool max_conf(Transition e)
{
  STEdge ce,ce2;

  if (ev_used[e->numname]) return True;
  if (frozen[e->numname]) return False;
  ev_used[e->numname]=True;
  frozen[e->numname]=True;
  for(ce=e->preset;ce;ce=ce->nextplace)
  {
    if (ce->place->preset && !frozen[ce->place->preset->trans->numname] && !max_conf(ce->place->preset->trans))
      return False;
    for (ce2=ce->place->postset;ce2;ce2=ce2->nexttrans)
      if ((ce2->trans!=e) && !frozen[ce2->trans->numname] && (!freeze(ce2->trans)))
        return False;
  }
  return True;
}

static bool config(Transition e)
{
  Place pl;
  Transition tr;
  unsigned int i;
  bool real_change,maximal,only_first,found=False, *tmp_ev_used, *tmp_frozen;
  STEdge ce;
  TSEdge ec;

  tmp_ev_used=(bool*)MYmalloc(bytes);
  tmp_frozen=(bool*)MYmalloc(bytes);
  memcpy(tmp_ev_used,ev_used,bytes);
  memcpy(tmp_frozen,frozen,bytes);

  change=False;
#ifdef DEBUG
printf("E%d\n",e->numname);
#endif
  max_conf(e);
  only_first=!change;

  for(tr=net->Transitions; tr; tr=tr->nexttrans)
  {
//    if (!places[pl->numname]) continue;
    // useful only if tr is still useable
    if (!frozen[tr->numname])
    {
    // check if all ways are blocked
    ce=NULL;
    maximal=True;
    real_change=False;
    for(ec=tr->postset; ec && !ce; ec=ec->nextplace)
      for(ce=ec->place->postset; ce; ce=ce->nexttrans)
      {
	maximal=False;
	if (frozen[ce->trans->numname]!=tmp_frozen[ce->trans->numname])
	  real_change=True;
	if (!frozen[ce->trans->numname]) break;
      }
    if (!(ec||ce))
    {
#ifdef DEBUG
printf("%s\n",real_change?"Real":(maximal?"Max":"No"));
#endif
      //if so, a new one is found
      found=True;
      // don't use if maximal event which has been already checked, or
      // if another place has been done
      if (places[tr->postset->place->numname])
#ifdef DEBUG
	  {printf("Stop1\n");continue;}
#else
	continue;
#endif
#if 0
      if ((maximal || !real_change) && (tr->numname < e->numname))
#ifdef DEBUG
	  {printf("Stop\n");continue;}
#else
	continue;
#endif
#else
      if (maximal)
      {
        for(i=tr->numname; i<=net->NumTransitions && !ev_used[i]; ++i)
	  skip;
	if (i<=net->NumTransitions)
#ifdef DEBUG
	  {printf("Stop\n");continue;}
#else
	continue;
#endif
      }
      if (!real_change && (tr->numname < e->numname))
#ifdef DEBUG
	  {printf("Stop\n");continue;}
#else
	continue;
#endif
#endif
      config(tr);
#if 0
      if (config(tr))
	break;
#endif
    }
    }
  }
  if (!found)
    printconfig();
  memcpy(ev_used,tmp_ev_used,bytes);
  memcpy(frozen,tmp_frozen,bytes);
  free(tmp_ev_used);
  free(tmp_frozen);
#ifdef DEBUG
printf("Up\n",e->numname);
#endif
  return only_first;
}

void configs(LMPNet unfolding)
{
  unsigned int i;
  Transition tr;
  TSEdge ec;

  net=unfolding;
  bytes=(net->NumTransitions+1)*sizeof(bool);
  places=(bool*)MYmalloc((net->NumPlaces+1)*sizeof(bool));
  for(i=0; i<=net->NumPlaces; ++i)
    places[i]=False;
//    places[pl->numname]=((!pl->postset || pl->postset->trans->preset->nextplace) && pl->preset);
  ev_used=(bool*)MYmalloc(bytes);
  frozen=(bool*)MYmalloc(bytes);
  for(i=0;i<=net->NumTransitions;++i)
  {
    ev_used[i]=False;
    frozen[i]=False;
  }
  for(tr=net->Transitions; tr; tr=tr->nexttrans)
  {
    for(ec=tr->postset; ec && !ec->place->postset; ec=ec->nextplace)
      places[ec->place->numname]=True;
    if (ec)
      continue;
#ifdef DEBUG
printf("Start\n");
#endif
    config(tr);
    for(i=0;i<=net->NumTransitions;++i)
    {
      ev_used[i]=False;
      frozen[i]=False;
    }
  }
}

