/*****************************************************************************/
/* convertPEP.h                                 (c) Stefan Roemer 1993-1997  */
/*                                              Version h-1.5.1 (07.03.1997) */
/*****************************************************************************/
/* Schnittstellen-Bibliothek zum Lesen (Schreiben) des PEP-Netzdateiformats  */
/* in die (aus den) grundlegenden Datenstrukturen fuer Petri-Netze.          */
/*****************************************************************************/
/*                                    Stefan Roemer,  13.12.1993-07.03.1997  */
/*****************************************************************************/
/*                                                                           */
/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*                                                                           */
/* ACHTUNG: Diese Datei enthaelt elementare Routinen, die von vielen ver-    */
/* schiedenen Programmen benoetigt werden.                                   */
/*                                                                           */
/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*                                                                           */
/*****************************************************************************/

#ifndef __CONVERTPEP_H__
#define __CONVERTPEP_H__

#include "neunetze.h"


/*****************************************************************************/

typedef struct plist_
  {
    Place         item;
    struct plist_ * next;
  } P_LIST_ELEM,
    * P_LIST;

typedef struct mlist_
  {
    char          * meaning;
    P_LIST        list;
    Cardinal32    number;
    struct mlist_ * next;
  } M_LIST_ELEM,
    * M_LIST;

typedef struct coords_
  {
    int            x,
                   y;
    struct coords_ * next;
  } CoordEntry,
    * Coords;


/*****************************************************************************/

extern char       CM_nettype[];
extern bool       CM_storeMeaning,
                  CM_storeCoordinates,
                  CM_storeReferences,
                  CM_use_imarks;
extern M_LIST     CM_placeMList,
                  CM_transMList;
extern Cardinal32 CM_countMPlaces,
                  CM_countPMeanings,
                  CM_countMTransitions,
                  CM_countTMeanings;


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
extern void delete_meaning_list( M_LIST );
#else
extern void delete_meaning_list( /* M_LIST list */ );
#endif
  /* entfernt eine 'meaning-list' aus dem Speicher.                          */

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
extern LMPNet read_PEP( char * );
#else
extern LMPNet read_PEP( /* char * PEPfilename */ );
#endif
  /* liefert einen Pointer auf eine Matrix, in der das Netz gespeichert ist. */
  /* Ergebnis ist NULL-Pointer, wenn eine entsprechend benannte PEP-Datei   */
  /* nicht existiert.                                                        */

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
extern void write_PEP( LMPNet, char * );
#else
extern void write_PEP( /* LMPNet net, char * filename */ );
#endif
  /* Gibt die mit net bezeichnete Matrix als Inzidenzmatrix nach 'filename'  */
  /* aus.                                                                    */
  /* NOCH NICHT IMPLEMENTIERT !!! */

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
extern LMPNet read_new_PEP( char * );
#else
extern LMPNet read_new_PEP( /* char * PEPfilename */ );
#endif
  /* Liefert einen Pointer auf eine Matrix, in der das Netz gespeichert ist. */
  /* Ergebnis ist NULL-Pointer, wenn eine entsprechend benannte PEP-Datei    */
  /* nicht existiert.                                                        */
  /* Es wird das neue PEP-Dateiformat erwartet.                              */

/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
extern void write_new_PEP( LMPNet, char * );
#else
extern void write_new_PEP( /* LMPNet net, char * filename */ );
#endif
  /* Gibt die mit net bezeichnete Matrix als Inzidenzmatrix nach 'filename'  */
  /* aus. Verwendet das neue PEP-Netzdateiformat.                            */

/*****************************************************************************/

#endif /* __CONVERTPEP_H__ */
