/**************************************************************************/
/* CSC399 Individual Project, University of Newcastle upon Tyne           */
/* PEP2SMV - Converter from PEP .ll_net files to SMV specifications       */
/* (C) Oct. 1996 - Apr 1997 Guido Wimmel                                  */
/*                                                                        */
/* Components.h: structures for representing components (1-invariants)    */
/**************************************************************************/

#ifndef COMPONENTS_H
#define COMPONENTS_H

#include "neunetze.h"

struct PlaceList       /* --- Data structure for list of places */
{
  Place pl;            /* pointer to place */
  PlaceList *next;     /* pointer to next list entry */
};
struct Component       /* --- Data structure for components */
{
  Cardinal32 id;       /* unique identification number */
  char name[20];       /* name of component */
  PlaceList *places;   /* list of places belonging to component */
  int visited;         /* for verification purposes */
  Component *next;     /* next component in the list */
};

struct ComponentList   /* --- List of components a place belongs to */
{
  Component *comp;     /* pointer to component */
  ComponentList *next; /* pointer to next list entry */
};
#endif

/**************************************************************************/
/* END OF FILE Components.h                                               */
/**************************************************************************/
