/**********************************/
/* memlib.c                       */
/* Burkhard Graves, 06.10.93      */
/* Lars Jenner, Juni 1994         */
/**********************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/**********************************/
/* Implementation                 */
/**********************************/

#define ERROR_MEM_OVERFLOW( FUNCT ) \
   fprintf( stderr, "ERROR: NN.%s(): memory overflow.\n", FUNCT ), \
   exit ( 3 )

#if defined(__STDC__) || defined(__cplusplus)

void* MYmalloc( size_t size )

#else

void* MYmalloc( size )

  size_t size;

#endif

{
	void * m;

	if (!(m = calloc(size, 1)))
	  ERROR_MEM_OVERFLOW( "MYmalloc" );

	return (m);

} /* MYmalloc() */

#if defined(__STDC__) || defined(__cplusplus)

void * MYrealloc( void * ptr, size_t size )

#else

void * MYrealloc( ptr, size )

  void   * ptr;
  size_t size;

#endif

{
	void *r;

	if (!(r = realloc((char*) ptr, size)))
	  ERROR_MEM_OVERFLOW( "Realloc" );

	return (r);

} /* MYrealloc() */

#if defined(__STDC__) || defined(__cplusplus)

char * MYstrdup( char * string )

#else

char * MYstrdup( string )

  char * string;

#endif

{
	char *str;

	if (! (str = strdup(string)))
	  ERROR_MEM_OVERFLOW( "MYstrdup" );

	return (str);

} /* MYstrdup() */


/**********************************/
/* END OF FILE memlib.c           */
/**********************************/
