/*****************************************************************************/
/* readPEP.h                                                                 */
/*****************************************************************************/
/*                                  Stefan Schwoon, April 1997		     */
/*****************************************************************************/
/* Generic function for reading files in PEP's format, especially nets.	     */

#ifndef __READPEP_H__
#define __READPEP_H__

extern char *filetype;		/* Type of the file being processed (second
				   line in PEP file). */
extern char *blocktype;		/* Name of the block currently being processed,
				   can be accessed in hook functions. */

/* t_dest is used for specifying where data fields of
   interest should be stored (see readHL.c for example). */
typedef struct
{
	char c;		/* Identifying character. */
	void *ptr;	/* Memory location.	  */
} t_dest;

/* t_blockdest defines what to do with the data found in
   a block with matching name. If such a struct is left
   out for a certain block, data in that block is ignored
   altogether. */
typedef struct
{
	char *name;		/* Name of the block.			     */
	int  (*hookfunc)();	/* Function to be called every time an entity
				   (one line) in the block has been read.    */
	char **restptr;		/* Where to store additional data fields not
				   specified in destarray. Can be set to NULL
				   if additional data fields can be ignored. */
	t_dest *destarray;	/* Where to store which data field.	     */
} t_blockdest;

typedef struct
{
	int x,y;		/* Simple struct for storing x-y coordinates. */
} t_coords;

/** function declaration **/
extern void read_PEP_net(char *filename, t_blockdest *dest);

#endif

