#include <stdio.h>
#include <string.h>
#include "memlib.h"
#include "rw_mci.h"

extern bool GL_SwapNum;
extern Cardinal32 swap_endian( Cardinal32 in);

FILE *infile, *outfile;

#define MAX_EVENTS (1<<24)

inline Cardinal32 process_int(bool swap)
{
  Cardinal32 buf,swapped;

  buf=ReadNumMCI(infile);
  if (swap)
    swapped=swap_endian(buf);
  else
    swapped=buf;
  WriteNumMCI(swapped,outfile);
  return swapped;
}

int main(int argc, char** argv){

        Cardinal32 buf,i;
        Cardinal32 num_c, num_e;
	bool force=False;
	bool swap=False;

        int ch;

	if (argc<3)
	{
		fprintf(stderr,"Usage: convertMCI [-f] Infile Outfile\n");
		fprintf(stderr,"Convert Unfolding in Infile to big endian unfolding in Outfile\n");
		fprintf(stderr,"-f: Ignore current ordering and swap anyway.\n");
		exit(1);
	}
	else
	{
	  if ((strcmp(argv[1],"-f")==0)&&(argc=4))
	    {
		force=swap=True;
		if (!(infile=fopen(argv[2],"rb")))
		{
		  printf("Could not open input file\n");
		  exit(1);
		}
		if (!(outfile=fopen(argv[3],"wb")))
		{
		  printf("Could not open output file\n");
		  exit(1);
		}
	    }
	  else
	    {
		if (!(infile=fopen(argv[1],"rb")))
		{
		  printf("Could not open input file\n");
		  exit(1);
		}
		if (!(outfile=fopen(argv[2],"wb")))
		{
		  printf("Could not open output file\n");
		  exit(1);
		}
	    }

  	GL_SwapNum=False;
	/* Read number of Conditions and Events */
	/* Check if swapping is needed on the fly. */
	buf=ReadNumMCI(infile);
	if (buf>MAX_EVENTS)
	{
	  swap=True;
	  if (force)
		  force=False;
	  printf("Wrong endianess, swapping.\n");
	}
	if (swap)
	  buf=swap_endian(buf);
	WriteNumMCI(buf,outfile);
	if (force)
	  num_c=swap_endian(buf);
	else
	  num_c=buf;
	num_e=process_int(swap);
	if (force)
	  num_e=swap_endian(num_e);

	/* Process events */
        for(i=0;i<num_e;i++) {
		process_int(swap);
	}

	/* Process conditions */
        for(i=0;i<num_c;i++){
		/* Corresponding Place and Preset */
                process_int(swap);
                process_int(swap);
		
		/* Postset may be larger than 1, so read until NULL */
                do {buf=process_int(swap);} while(buf!=0);
        }

	/* Cutoffs with Event and Correpsonding event until NULL */
        buf=process_int(swap);
        while(buf!=0){
                process_int(swap);
                buf=process_int(swap);
        }

	/* Configurations ended by NULL*/
        buf=process_int(swap);
        while(buf!=0){
		/* And also separated by NULL */
                while(buf!=0) {
			buf=process_int(swap);
		}

                buf=process_int(swap);
        }

	/* Number of Places, Transitions in original net */
        process_int(swap);
        process_int(swap);
	/* Maximal length of name string */
        process_int(swap);

	/* Only chars to follow so copy to outfile */
        while((ch=fgetc(infile))!=EOF) fputc(ch,outfile);

        fclose(infile);
        fclose(outfile);
	exit(0);
	}
}
