#include <ctype.h>
#include <stdio.h>
#include "mtupel.h"

/*****************************************************************************/
/*** mt.h ********************************************************************/
/*****************************************************************************/

MTupel MT_Create()
{
	MTupel mt = MYmalloc(sizeof(MTupEl));
#if defined(sun)
	mt->count = 0;
	mt->realsize = 4;
	mt->place = MYmalloc(sizeof(Integer) * mt->realsize);
#else
	mt->count = mt->realsize = 0;
	mt->place = NULL;
#endif
	return mt;
}

void MT_AddValue(MTupel mt, Integer what)
{
	if (mt->count >= mt->realsize)
	{
		mt->realsize += 4;
		mt->place = MYrealloc(mt->place,
				sizeof(Integer) * mt->realsize);
	}
	mt->place[mt->count++] = what;
}


#define GetOverSpace() while (**str && isspace(**str)) { (*str)++; }

int read_posint(char** str)
{
        int val = **str - '0';
        while (isdigit(*++*str))
        {
                 val *= 10;
                 val += **str - '0';
        }
        GetOverSpace();
        return val;
}

Integer read_anyValue(char** str)
{
        if (isdigit(**str))
                return read_posint(str);
        if (**str == '-')
        {
                (*str)++;
                GetOverSpace();
                if (!isdigit(**str))  
                {
                        fprintf(stderr,"number expected after '-'");
                        exit(2);
                }
                return -read_posint(str);
        }
        if (**str == 'f' && *(*str+1) == 'f')
        {
                *str += 2;
                GetOverSpace();
                return FF;
        }
        if (**str == 't' && *(*str+1) == 't')
        {
                *str += 2;
                GetOverSpace();
                return TT;
        }
        if (**str == 'd' && *(*str+1) == 'o' && *(*str+2) == 't')
        {
                *str += 3;
                GetOverSpace();
                return DOT;
        }
        fprintf(stderr,"unknown number format");
        exit(2);
}

MTupel read_MTupel(char** str)
{
        MTupel mt = MT_Create();

        if (**str == '(')
        {
                (*str)++;
                do {
                        GetOverSpace();
                        MT_AddValue(mt,read_anyValue(str));
                } while (**str == ',' && (*str)++);
                if (**str != ')')
                {
                        fprintf(stderr,"Parsing error in value:"
                                        " ')' expected\n");
                        exit(20);
                }
                (*str)++;
                GetOverSpace();
        }
        else
                MT_AddValue(mt,read_anyValue(str));

        return mt;
}

int MT_Greater(MTupel mt1, MTupel mt2)
{
	int c1 = mt1->count;
	int c2 = mt2->count;

	while (c1-- && c2--)
	{
		if (MT_Place(mt1,c1) > MT_Place(mt2,c2)) return 1;
		if (MT_Place(mt1,c1) < MT_Place(mt2,c2)) return 0;
	}

	return c1 >= 0;
}

int MT_Equal(MTupel mt1, MTupel mt2)
{
	int c1 = mt1->count;
	int c2 = mt2->count;

	if (c1 != c2) return 0;
	while (c1-- && c2--)
		if (MT_Place(mt1,c1) != MT_Place(mt2,c2)) return 0;
	return 1;
}

int MT_Compare(MTupel mt1, MTupel mt2)
{
	int x;
	int c1 = mt1->count;
	int c2 = mt2->count;

	while (c1-- && c2--)
		if ((x = MT_Place(mt1,c1)-MT_Place(mt2,c2))) return x/abs(x);

	return c1 >= 0;
}

MPTupel MPT_Create()
{
	MPTupel mt = MYmalloc(sizeof(MTupEl));
#if defined(sun)
	mt->count = 0;
	mt->realsize = 4;
	mt->place = MYmalloc(sizeof(Integer*) * mt->realsize);
#else
	mt->count = mt->realsize = 0;
	mt->place = NULL;
#endif
	return mt;
}

void MPT_AddValue(MPTupel mt, Integer* what)
{
	if (mt->count >= mt->realsize)
	{
		mt->realsize += 4;
		mt->place = MYrealloc(mt->place,
				sizeof(Integer*) * mt->realsize);
	}
	mt->place[mt->count++] = what;
}

