/*****************************************************************************/
/* mtupel.h                                                                  */
/*****************************************************************************/

#ifndef __MTUPEL_H__
#define __MTUPEL_H__

#include "memlib.h"

/* count gives the dimension of the type?,
   realsize the number of fields allocated,
   place points to the array of type elements
     where the first contains the number of
     elements to follow.
   A type {1,2}x{3,4,5} would be
   count=2,realsize=8 (always 4 fields at a time)
   and place is [2,1,2,0],[3,3,4,5].
*/
typedef struct
{
	Integer count;
	Cardinal realsize;
	Integer* place;
} MTupEl, *MTupel;

typedef struct
{
	Integer count;
	Cardinal realsize;
	Integer** place;
} *MPTupel;

MTupel MT_Create();
void MT_AddValue(MTupel mt, Integer what);
int read_posint(char** str);
MTupel read_MTupel(char** str);
int MT_Greater(MTupel mt1, MTupel mt2);
int MT_Equal(MTupel mt1, MTupel mt2);
int MT_Compare(MTupel mt1, MTupel mt2);

MPTupel MPT_Create();
void MPT_AddValue(MPTupel mt, Integer* what);

#define MT_Place(mt,num) ((mt)->place[num])
#define MT_PlaceP(mt,num) ((M_Place)(mt)->place[num])
#define MT_PlaceT(mt,num) ((M_Transition)(mt)->place[num])
#define MT_PlaceMT(mt,num) ((MTupel)(mt)->place[num])
#define MT_PlaceMPT(mt,num) ((MPTupel)(mt)->place[num])

#define MPTT_AddValue(mt,what) MPT_AddValue(mt,(Integer *)what)

#endif /* __MTUPEL_H__ */

