#ifndef __NETARRAY_H__
#define __NETARRAY_H__

#include "convertPEP.h"

/*****************************************************************************/
/* Some type definitions.                                                    */
/*****************************************************************************/

typedef struct pl_mean_array_
  {
    char * meaning;
    P_LIST set;
  } PlMArrayEntry,
    * PlMArray;

/*****************************************************************************/
/* Store pointers to the places of the net in an array.                      */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
 
Place * GeneratePlArray( LMPNet net );

#else

Place * GeneratePlArray( net );

#endif


/*****************************************************************************/
/* Store pointers to the transitions of the net in an array.                 */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
 
Transition * GenerateTrArray( LMPNet net );

#else

Transition * GenerateTrArray( net );

#endif


/*****************************************************************************/
/* Copy the place meaning list into an array.                                */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
 
PlMArray GeneratePlMArray( void );

#else

PlMArray GeneratePlMArray();

#endif


/*****************************************************************************/
/* Remove the place meaning array.                                           */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void RemovePLMArray( PlMArray array );

#else

void RemovePLMArray( array );

#endif


/*****************************************************************************/
/* Find a place ( binary search ).                                           */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

Place find_place( char * name, Place* array, LMPNet net );

#else

Place find_place( name, array, net );

#endif


/*****************************************************************************/
/* Find a place ( binary search ).                                           */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

Transition find_transition( char * name, Transition* array, LMPNet net );

#else

Transition find_transition( name, array, net );

#endif


/*****************************************************************************/
/* Find an extended place labelling.                                         */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

P_LIST find_extPLabel( char * name, PlMArray array );

#else

P_LIST find_extPLabel( name, array );

#endif


#endif
