#include <ctype.h>
#include "pep_strings.h"
#include "neunetze.h"

/*****************************************************************************/
/* ERGAENZUNG: 04.05.1993 Stefan Roemer                                      */
/* Vergleichsfunktionen fuer Strings                                         */
/* In der vorliegenden Version: Sortierung nach lexikalischer Ordnung!!!     */
/*****************************************************************************/


#if defined(__STDC__) || defined(__cplusplus)

static bool LG_Kleiner( char * name1, char * name2 )

#else

static bool LG_Kleiner( name1, name2 )

  char * name1, * name2;

#endif

  {

    if (    ( (int) strlen( name1 ) < (int) strlen( name2 ) )
         || (    ( strlen( name1 ) == strlen( name2 ) )
              && ( strncmp( name1, name2, NAMELENGTH ) < 0 ) ) )
      {
        return ( True );
      } /* if */
    else
      {
        return ( False );
      } /* else */

  } /* LG_Kleiner() */


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

static bool LG_Gleich( char * name1, char * name2 )

#else

static bool LG_Gleich( name1, name2 )

  char * name1, * name2;

#endif

  { 

    if ( strncmp( name1, name2, NAMELENGTH ) == 0 )
      {
        return ( True );
      } /* if */
    else
      {
        return ( False );
      } /* else */

  } /* LG_Gleich() */


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

static bool SC_Kleiner( char * name1, char * name2 )

#else

static bool SC_Kleiner( name1, name2 )

  char * name1, * name2;

#endif

  { 

    return ( (bool) ( strncmp( name1, name2, NAMELENGTH ) < 0 ) );

  } /* SC_Kleiner() */


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

static bool SC_Gleich( char * name1, char * name2 )

#else

static bool SC_Gleich( name1, name2 )

  char * name1, * name2;

#endif

  { 

    return ( (bool) ! strncmp( name1, name2, NAMELENGTH ) );

  } /* SC_Gleich() */


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)
bool (* Kleiner)( char *, char * ) = LG_Kleiner;
bool (* Gleich)( char *, char * ) = LG_Gleich;
#else
bool (* Kleiner)() = LG_Kleiner;
bool (* Gleich)() = LG_Gleich;
#endif


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void strcmp_lexgraph( void )

#else

void strcmp_lexgraph()

#endif

  { 

    Kleiner = LG_Kleiner;
    Gleich = LG_Gleich;

  } /* strcmp_lexgraph() */


/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void strcmp_strcmp( void )

#else

void strcmp_strcmp()

#endif

  { 

    Kleiner = SC_Kleiner;
    Gleich = SC_Gleich;

  } /* strcmp_strcmp() */

/*-------------------------------------------------------------------------*/
/*-- wandelt in str Gross- in Kleinbuchstaben um und gibt das Ergebnis   --*/
/*-- zurueck                                                             --*/

#if defined(__STDC__) || defined(__cplusplus)

char * StrLower( char * str )

#else

char * StrLower( str )

  char * str;

#endif

  {

    register char *ptr = str;

    while (( *( ptr++ ) = tolower( *ptr ) ))
      skip;

    return ( str );

  } /* StrLower() */

