/*-------------------------------------------------------------------------*/
/*--                                                                     --*/
/*--  READ_MCI.H - Header-Datei fuer READ_MCI.C                          --*/
/*--                                                                     --*/
/*--  Stefan Roemer/Johannes Jaeger - Sommer 1994                        --*/
/*-------------------------------------------------------------------------*/

#ifndef _RW_MCI_H
#define _RW_MCI_H

#include "neunetze.h"

/*-------------------------------------------------------------------------*/
/*-- Interface-Routine zum Lesen einer Entfaltung aus einer Binaer-Datei.--*/
/*-- Parameter:                                                          --*/
/*--   char* MCIfilename : Dateiname der Binaerdatei mit einer Entfaltung--*/
/*--   LIST_POINTER *CutOffPoints:                                       --*/
/*--                    Adresse eines LIST_POINTERS, ueber den eine Liste--*/
/*--                    der Namen der Cut-Off-Punkte zurueckgegeben wird --*/
/*--   LIST_POINTER *MaxConfig:                                          --*/
/*--                    Adresse eines LIST_POINTERS, ueber den eine Liste--*/
/*--                    der Namen einer max. Konfiguration zurueckgegeben--*/
/*--                    wird, falls keine Cutoffpunkte existieren        --*/
/*--                                                                     --*/
/*-- Rueckgabe:                                                          --*/
/*--     Zeiger vom Typ LMPNet auf das eingelesene Netz                  --*/

#define readMC2 readMCI

LMPNet readMCI( FILE* MCIfile,
                LIST_POINTER *CutOffPoints,
                LIST_POINTER *MaxConfig   );

Cardinal32 ReadNum( FILE* MCIfile );
Cardinal32 ReadNumMCI( FILE* MCIfile );
void WriteNum( Cardinal32 number, FILE* MCIfile );
void WriteNumMCI( Cardinal32 number, FILE* MCIfile );

#define WriteChar( CHARPTR ) \
   fwrite( (CHARPTR), sizeof( char ), 1, MCIfile )

#endif

/*-----------------------------------------------------------------------*/
/*--                                                                   --*/
/*--  Ende RW_MCI.H                                                    --*/
/*--                                                                   --*/
/*-----------------------------------------------------------------------*/
