
#include <string.h>

#include "rw_prefix.h"
#include "rw_mci.h"
#include "rw_unf.h"
#include "readlib.h"
#ifdef WITH_ZLIB
#include "zlib.h"
#endif

#define E_RDPREF_NONAME   "readPrefix(): No file name!"
#define E_RDPREF_FNOTOPEN "readPrefix(): Could not open file '%s'!"

unsigned int GL_numCutoffs;

/* Read function for all finite prefix formats. */
/* Tries to find the correct format depending   */
/* on the file name extension.			*/

LMPNet readPrefix(char* filename,
		  LIST_POINTER* CutOffPoints,
		  LIST_POINTER* MaxConfig)
{
  FILE* file;
  char* suffix;
  LMPNet unfolding=NULL;

  /* Dateiname ueberpruefen */
  if ( ! filename || ! *filename )
    PEPerror( E_RDPREF_NONAME );

#ifdef WITH_ZLIB
  file=gzopen(filename,"rb9");
#else
  file=fopen(filename,"rb");
#endif
  if (file)
    {

      /* Set variables for possible error messages. */
      NNinput_file = filename;
      NNinput_line = 1;

      suffix=strchr(filename,'.');
      if (!strcmp(suffix,".gz"))
      {
	suffix[0]='\0';
	suffix=strchr(filename,'.');
      }
      if (!strcmp(suffix,".mci")||!strcmp(suffix,".mci.gz"))
	unfolding=readMCI(file,CutOffPoints,MaxConfig);
      else if (!strcmp(suffix,".unf"))
	unfolding=readUNF(file,CutOffPoints,MaxConfig);
      else if (!strcmp(suffix,".mc2")||!strcmp(suffix,".mc2.gz"))
	unfolding=readMC2(file,CutOffPoints,MaxConfig);
      else
	{
	  PEPwarn("Unknown file suffix. Defaulting to mc2 format.\n");
	  unfolding=readMC2(file,CutOffPoints,MaxConfig);
	}
    }
  else
    Error((errbuf, E_RDPREF_FNOTOPEN, filename));
  return unfolding;
}

