#include <string.h>
#include "rw_tobi.h"
#include "convertPEP.h"
#include "readlib.h"

/*****************************************************************************/
/***************************** write_new_Tobi ********************************/
/*****************************************************************************/
/*                                              Do.,19.01.1995 Stefan Roemer */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

void write_new_Tobi( LMPNet net, char * TobiFilename )

#else

void write_new_Tobi( net, TobiFilename )

  LMPNet net;
  char   * TobiFilename;

#endif

  {

    register Place      pl;
    register Transition tr;
    register STEdge     st;
    register TSEdge     ts;
    register Cardinal32 count;
    Coords              co;
    int                 x,
                        y;
    FILE                * file;

    if ( ! CM_storeCoordinates )
      {
        NNError( "Internal Error: 'CM_storeCoordinates' not set" );
      } /* if */

    if ( ! ( file = fopen( TobiFilename, "w" ) ) )
      {
        NNError( "Could not open file for writing" );
      } /* if */

    f( "Place\n" );
    for ( pl = net->Places ; pl ; pl = pl->nextplace )
      {
        fx( "Name %s ", pl->name );
        co = (Coords) pl->inscript;
        fxy( "Position %d %d\n", co->x, co->y );
        co = co->next;
        fxy( " %d %d", co->x, co->y );
        co = co->next;
        if ( *( (char *) co->x ) )
          {
            fx( "\"%s\"", (char *) co->x );
          } /* if */
        else if ( ! strcmp( CM_nettype, "HLNet" ) )
          {
            fx( "\"%c\"", "0ex"[ (int) pl->label ] );
          } /* else if */
        else
          {
            f( "\"\"" );
          } /* else */
        co = co->next;
        if ( *( (char *) co->x ) )
          {
            fx( " \"%s\"\n", (char *) co->x );
          } /* if */
        else if ( ! strcmp( CM_nettype, "HLNet" ) )
          {
            f( " \"dot\"\n" );
          } /* else if */
        else
          {
            f( " \"\"\n" );
          } /* else */
      } /* for */

    f( "\nTransition\n" );
    for ( tr = net->Transitions ; tr ; tr = tr->nexttrans )
      {
        fx( "Name %s ", tr->name );
        co = (Coords) tr->inscript;
        fxy( "Position %d %d\n", co->x, co->y );
        co = co->next;
        fxy( " %d %d", co->x, co->y );
        co = co->next;
        fx( "\"%s\"", (char *) co->x );
        co = co->next;
        if ( *( (char *) co->x ) )
          {
            fx( " \"%s\"\n", (char *) co->x );
          } /* if */
        else if ( ! strcmp( CM_nettype, "HLNet" ) )
          {
            f( " \"true\"\n" );
          } /* else if */
        else
          {
            f( " \"\"\n" );
          } /* else */
      } /* for */

    f( "\nEdge\n" );
    count = 0;
    for ( tr = net->Transitions ; tr ; tr = tr->nexttrans )
      {
        for ( ts = tr->postset ; ts ; ts = ts->nextplace )
          {
            fx( "Name HLEdge%u ", ++count );
            fx( "From %s ", ts->trans->name );
            fx( "To %s\n", ts->place->name );
            co = (Coords) ts->weight;
            x = ( (Coords) ts->trans->inscript )->x;
            y = ( (Coords) ts->place->inscript )->x;
            x += ( y - x ) >> 1;
            fx( " %d", x );
            x = ( (Coords) ts->trans->inscript )->y;
            y = ( (Coords) ts->place->inscript )->y;
            x += ( y - x ) >> 1;
            fx( " %d", x );
            co = co->next;
            fx( "\"%s\"\n", (char *) co->x );
          } /* for */
      } /* for */
    for ( pl = net->Places ; pl ; pl = pl->nextplace )
      {
        for ( st = pl->postset ; st ; st = st->nexttrans )
          {
            fx( "Name HLEdge%u ", ++count );
            fx( "From %s ", st->place->name );
            fx( "To %s\n", st->trans->name );
            co = (Coords) st->weight;
            x = ( (Coords) st->place->inscript )->x;
            y = ( (Coords) st->trans->inscript )->x;
            x += ( y - x ) >> 1;
            fx( " %d", x );
            x = ( (Coords) st->place->inscript )->y;
            y = ( (Coords) st->trans->inscript )->y;
            x += ( y - x ) >> 1;
            fx( " %d", x );
            co = co->next;
            fx( "\"%s\"\n", (char *) co->x );
          } /* for */
      } /* for */

    f( "\nToken\n" );
    for ( pl = net->Places ; pl ; pl = pl->nextplace )
      {
        co = ( (Coords) pl->inscript )->next->next;
        if ( co->y && *( (char *) co->y ) )
          {
            fx( "Name %s ", pl->name );
            fx( " \"%s\"\n", (char *) co->y );
          } /* if */
      } /* for */

    f( "\n" );

    fclose( file );

  } /* write_new_Tobi() */
