/*-------------------------------------------------------------------------*/
/*--                                                                     --*/
/*--  READ_UNF.H - Header-Datei fuer READ_UNF.C                          --*/
/*--                                                                     --*/
/*--  Johannes Jaeger - Sommer 1994                                      --*/
/*-------------------------------------------------------------------------*/

#ifndef _READ_UNF_H
#define _READ_UNF_H

#include "neunetze.h"
#include "list.h"

/*-------------------------------------------------------------------------*/
/*-- Interface-Routine zum Lesen einer Entfaltung aus einer ASCII-Datei. --*/
/*-- Parameter:                                                          --*/
/*--   char* unffile : Dateiname der Textdatei mit einer Entfaltung      --*/
/*--   LIST_POINTER *CutOffPoints:                                       --*/
/*--                    Adresse eines LIST_POINTERS, ueber den eine Liste--*/
/*--                    der Namen der Cut-Off-Punkte zurueckgegeben wird --*/
/*--   LIST_POINTER *MaxConfig:                                          --*/
/*--                    Adresse eines LIST_POINTERS, ueber den eine Liste--*/
/*--                    der Namen einer max. Konfiguration zurueckgegeben--*/
/*--                    wird, falls keine Cutoffpunkte existieren        --*/
/*--                                                                     --*/
/*-- Rueckgabe:                                                          --*/
/*--     Zeiger vom Typ LMPNet auf das eingelesene Netz                  --*/

extern LMPNet readUNF( FILE* unffile,
                       LIST_POINTER *CutOffPoints,
                       LIST_POINTER *MaxConfig   );

#endif /* _READ_UNF_H */

/*-------------------------------------------------------------------------*/
/*--                                                                     --*/
/*--  Ende READ_UNF.H                                                    --*/
/*--                                                                     --*/
/*-------------------------------------------------------------------------*/
