

/******************************************************************************************/
/*                                                                                        */
/* Programmname:                PEP2graph.c                                               */
/*                                                                                        */ 
/* Ersteller:                   Rami Muallam u. Hamid Keshavarzi                          */
/*                                                                                        */
/* Datum:                       01.08.1994                                                */
/*                                                                                        */
/* Das Programm PEP2graph.c dient zur Erzeugung von XFIG-Graphikdateien aus               */
/* PEP-Netzdateien. Das Programm kann, je nach Option, die XFIG-Graphikdateien            */
/* in verschiedenen Formate umwandeln. Die Optionen, die dafuer zustandig sind            */
/* lauten: -p fuer PostScript, -t fuer PiCTeX, -l fuer LaTeX und -f fuer                  */
/* PostScript mit automatischer Namensvergabe.                                            */
/* Nach der Eingabe der Option kann man die umgewandelte Datei mit einem selbstgewaehlten */
/* Namen versehen.                                                                        */
/* Falls man gar keine Option waehlt, dann wird die  PEP-Datei in PostScript              */
/* umgewandelt.                                                                           */
/*                                                                                        */
/******************************************************************************************/
 
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <math.h>

#define OFFSET 20 /* Die Verschiebung des Bildes um 20 Pixeln nach rechts und nach unten */
                  /* auf dem Papier.                                                     */
 
int xtrans, ytrans, xstelle, ystelle;

/***************************************************************************************/
/* Die Funkton Stelle dient zur Plazierung eines Stellenknotens                        */
/* ( Kreis mit Radius 'Radius' ) an den Koordinaten ( x, y ) ( Mittelpunkt ). Die      */
/* Stelle besitzt den Namen 'name' sowie die Beschriftung 'label'. Die Ausgabe erfolgt */
/* in die bereits zum Schreiben geoeffnete "xfig"-Datei, die mit 'file' angesprochen   */
/* wird.                                                                               */
/*                                                                 Erstellt von Hamid  */
/***************************************************************************************/

void Stelle( file, x, y, name, meaning, dick, radius, marke, tx, ty)

  FILE * file;
  int  x, dick, marke, radius, y, tx, ty;
  char * name, *meaning;
  {
    char * str;

    ty += 8;
    radius -= OFFSET;
    fprintf( file, "1 3 0 %d -1 0 0 0 0.000 1 0.000 %d %d %d %d %d %d %d %d\n",
                    dick, x, y, radius, radius, x, y, x+radius, y+radius );
      while (( str = strchr( name, '\n' ) ))
      {
        *str = '\0';
        fprintf( file, "4 0 1 10 0 -1 0 0.000 0 7 7 %d %d \n %s\001\n", 
                        tx, ty, name );
        name = str + 1;
        *str = '\n';
        ty += 10;
      }
    fprintf( file, "4 0 1 10 0 -1 0 0.000 0 7 7 %d %d \n %s\001\n", 
                    tx, ty, name );
    ty += 10;
    while (( str = strchr( meaning, '\n' ) ))
      {
        *str = '\0';
        fprintf( file, "4 0 1 10 0 -1 0 0.000 0 7 7 %d %d \n %s\001\n", 
                        tx, ty, meaning );
        meaning = str + 1;
        *str = '\n';
        ty += 10;
      }
    fprintf( file, "4 0 1 10 0 -1 0 0.000 0 7 7 %d %d \n %s\001\n", 
                    tx, ty, meaning );
    

  } /* Stelle() */


/******************************************************************************/
/* Die Funktion Transition dient zur Plazierung eines Transitionsknotens      */ 
/* ( Quadrat mit der Seitenlaenge '2*Radius' ) an den Koordinaten ( x, y )    */
/* ( Schwerpunkt ). Die Transition besitzt den Namen 'name' und die           */
/* (Multimengen-)Beschriftung 'label'.                                        */
/* Die Ausgabe erfolgt in die bereits geoeffnete "xfig"-Datei, die mit 'file' */
/* angesprochen wird.                                                         */
/*                                                          Erstellt von Rami */
/******************************************************************************/

void Transition( file, x, y, name, meaning, dick, radius, tx,ty)

  FILE * file;
  int  x,
       y, tx, ty;
  char * name, *meaning;
  {
    char * str;

    ty += 8;
    radius -= OFFSET;
    fprintf( file, "2 2 0 %d -1 0 0 0 0.000 0 0 0\n",dick );                 
    fprintf( file, "         %d %d %d %d %d %d %d %d %d %d 9999 9999\n",
                    x-radius, y-radius,
                    x+radius, y-radius,
                    x+radius, y+radius,
                    x-radius, y+radius,
                    x-radius, y-radius );
      while (( str = strchr( name, '\n' ) ))
      {
        *str = '\0';
        fprintf( file, "4 0 1 10 0 -1 0 0.000 0 7 7 %d %d \n %s\001\n", 
                   tx, ty, name );
        name = str + 1;
        *str = '\n';
        ty += 10;
      }
    fprintf( file, "4 0 1 10 0 -1 0 0.000 0 7 7 %d %d \n %s\001\n", 
                   tx, ty, name );
    ty += 10;
    while (( str = strchr( meaning, '\n' ) ))
      {
        *str = '\0';
        fprintf( file, "4 0 1 10 0 -1 0 0.000 0 7 7 %d %d \n %s\001\n", 
                   tx, ty, meaning );
        meaning = str + 1;
        *str = '\n';
        ty += 10;
      }
    fprintf( file, "4 0 1 10 0 -1 0 0.000 0 7 7 %d %d \n %s\001\n", 
                   tx, ty, meaning );
     
  } /* Transition() */


/************************************************************************************/
/* Die Funktion readcommand dient zum Lesen der Befehle, die in der  PEP--Dateien   */
/* enthalten sind. Und zwar wird gelesen bis ein Doppelpunkt auftaucht.             */
/* Das ist naemlich das Ende des Befehls.                                           */ 
/*                                                               Erstellt von Hamid */
/************************************************************************************/


void readcommand(infile, str)
  FILE * infile ;
  char * str ;

  {    
    char ch;
   
       
    while ( ( ( ch = getc( infile ) ) == ' ' ) || ( ch == '\t' )
           || ( ch == '\n' ) )
       { }
                     

    *str = ch;
    str[1] = getc( infile );
    str[2] = getc( infile );  
    str[3] = '\0'; 

   
    if ( ( ch = getc( infile ) ) != ':' )
      {
        printf( "':' erwartet!\n" );
        printf(" %c\n", ch);
        exit ( -1 );
      }

  } /* readcommand() */


/**************************************************************************************/
/* Die Funktion readcoordinates dient zum Lesen der Zeichenketten, die aus Zahlen und */
/* aus einer Affenschaukel "@" bestehen.                                              */
/*                                                                 Erstellt von Rami  */
/**************************************************************************************/


/* readcoordinates list die x-und y-Koordinaten */

void readcoordinates(infile, x, y) 
   FILE * infile ;
   int *x, *y ;
  {
    char ch;
    int  i;

    while ( ( ( ch = getc( infile ) ) == ' ' ) || ( ch == '\t' ) || (ch == '-')
            || ( ch == '\n' ) )
       { }
    if ( ! isdigit( ch ) )
      {
        printf( "Integer erwartet!\n" );
        exit ( -1 );
      }
    i = ch - '0';
     
       while ( isdigit( ch = getc( infile ) ) )
         {
          i = 10 * i + ch - '0';
      }
    *x = i+OFFSET;
    
  if ( ch != '@' )
     {
       printf( " @ erwartet!\n" );
       exit ( -1 );
     } 
  ch = getc( infile );
     i = ch - '0';
 
    while ( isdigit( ch = getc( infile ) ) )
      {
        i = 10 * i + ch - '0';
      }
     *y = i+OFFSET;
    ungetc( ch, infile );
     
  } /* readcoordinates() */


/***************************************************************************************/
/* Die Funktion readstring dient zum Lesen der Zeichenketten, die sich in Hochkommata  */
/* befinden.                                                                           */
/*                                                                  Erstellt von Hamid */
/***************************************************************************************/

void readstring(infile, str)
  FILE * infile ;
  char * str ;

  {
    char ch,
         *strptr = str;

    while ( ( ( ch = getc( infile ) ) == ' ' ) || ( ch == '\t' )
            || ( ch == '\n' ) )
       { }
    if ( ch != '\'' )
      {
        printf("erste Kommata\n");
        printf(" %c\n",ch);
        printf( "' erwartet!\n" );
        exit ( -1 );
      }

    while (  ( ch = getc( infile ) ) != '\'' )   
      { 
        *(strptr++) = ch;
      }
    
    *strptr = '\0';   

    if ( ch != '\'' )
      {
        printf( "' erwartet!\n" );
        exit ( -1 );
      }

  } /* readstring() */

 
/*******************************************************************************************/
/* Die Funktion readnumber dient zum Lesen der Zeichenketten, die nur aus Ziffern bestehen */
/*                                                                      Erstellt von Hamid */
/*******************************************************************************************/

int readnumber(infile)
  FILE * infile ;
  {
    char ch, str[6];
    int  i;
    while ( ( ( ch = getc( infile ) ) == ' ' ) || ( ch == '\t' )
            || ( ch == '\n' ) )
       { }
    if ( isdigit( ch ) )                              /* Die Funktion readnumber() liest die Ziffer  */
      {                                               /* nach den Zeichenketten idt, ima, dwd, cma,  */
      i = ch - '0';                                   /* des, usz, sou, cap und  wgt.                */
      while ( isdigit( ch = getc( infile ) ) )
       {
          i = 10 * i + ch - '0';
       }
      ungetc( ch, infile );
      return ( i );
      }
    else
      {
       *str = ch;
      str[1] = getc( infile );
      str[2] = getc( infile );
      str[3] = getc( infile );  
      str[4] = getc( infile ); 
      str[5] = '\0'; 
      if (strcmp( str, "Omega" ))
         {
           printf(" Omega erwartet\n");
           exit (-1);
         }
      return( 0x7FFFFFFF );
      }
    
    } /* readnumber() */


/***************************************************************************************/
/* Die Funktion readbisende dient zum Ueberlesen der nach der Kommentarzeile folgenden */
/* Zeilen, bis der Befehl "end:" zweimal auftaucht                                     */
/*                                                                 Erstellt von Rami   */
/***************************************************************************************/


void readbisende( infile, str )
    FILE * infile;
    char *str;
   {
     int x, y;
       
     readcommand(infile,str);
     while ( strcmp( str, "end" ) )
     {

          if ( !strcmp( str, "wis" ) || !strcmp( str, "xnu" ) || 
               !strcmp( str, "ynu" ) || !strcmp( str, "wgt" ) ||
               !strcmp( str, "ipb" ) || !strcmp( str, "iun" ) ||
               !strcmp( str, "ipp" ) || !strcmp( str, "opb" ) ||
               !strcmp( str, "onu" ) || !strcmp( str, "opp" ) ||
               !strcmp( str, "rtb" ) || !strcmp( str, "rnu" ) || 
               !strcmp( str, "rtp" ) || !strcmp( str, "elw" ) ||
               !strcmp( str, "vbw" ) || !strcmp( str, "nov" ) ||
               !strcmp( str, "vpm" ) || !strcmp( str, "pbw" ) ||
               !strcmp( str, "nop" ) || !strcmp( str, "ppm" ) ||
               !strcmp( str, "ima" ))
              {
                 readnumber( infile ); 
                 readcommand(infile,str); 
              }         
           else if ( !strcmp( str, "pap" ) || !strcmp( str, "set" ) )
              {
                
                 readcommand( infile, str );
              }
           else if ( !strcmp( str, "ips" ) || !strcmp( str, "ipo" ) || 
                     !strcmp( str, "ops" ) || !strcmp( str, "opo" ) ||
                     !strcmp( str, "rts" ) || !strcmp( str, "rto" ) ||
                     !strcmp( str, "vno" ) ||   !strcmp( str, "pno" ) )
              {
                 readcoordinates(infile, &x, &y);   
                 readcommand(infile,str);
              }
           else if  (!strcmp( str, "vsi" ))
              { 
                 readcoordinates(infile, &xtrans, &ytrans);   
                 readcommand(infile,str);
              }
            else if  (!strcmp( str, "psi" ))
              { 
                 readcoordinates(infile, &xstelle, &ystelle);   
                 readcommand(infile,str);  
              }

            else if (!strcmp( str, "cap" )) 
              {
                 readnumber( infile );
                 readcommand(infile,str);
              }     
            else 
              {
                 readstring(infile, str);
                 readcommand(infile,str);
              }
      }  /* readbisende */
                          
 }


/*****************************************************************************/
/*                            Hauptprogramm.                                 */
/*****************************************************************************/

int main( argc, argv )       /* Parameter fuer die eingegebene Zeichenketten */
                             /* bei dem Aufruf des Programmes                */

  int  argc;
  char ** argv;
  
{
  
  FILE * infile,
       * outfile, *of;
  int  x, y, i, rx, ry, tx, ty, dick, marke, gewicht,
       listarke, * xx, capazit,
       * yy, big, x1, x2, y1, y2, count;
  char ch, str[2049], name[100], label[100], text[100], outfilename[40], 
       meaning[100], *fn, sss[2000];

  count = 0;
  big = 2;      /* Speicherplatz reservieren fuer beliebige */
                /* Knickpunkte, die zwischen einer Stelle   */
                /* und Transition sein koennen              */
  xx = (int *) malloc( big * sizeof( int ) );
  yy = (int *) malloc( big * sizeof( int ) ); 


  if (( argc < 2 ) || ( !strcmp(argv[1],"--")))  /* USAGE fuer den Programmaufruf,  */
     {                                           /* und zwar nach der Eingabe       */
                                                 /* PEP2graph -- oder PEP2graph     */
	/*
       system ("clear");
	*/
       printf( " USAGE:  PEP2graph filename options [gewuenschter Dateiname]        \n");
       printf( " ---------------------------------------------------------------\n\n");
       printf( "  -f        : Umwandlung der PEP-Datei in XFIG-Format.\n" );
       printf( "  -l        : Umwandlung der PEP-Datei in LaTeX-Format.\n" );
       printf( "  -t        : Umwandlung der PEP-Datei in PiCTeX-Format.\n" );
       printf( "  -p        : Umwandlung der PEP-Datei in Postscript-Format mit\n");
       printf( "              Portrait-Darstellung (default).\n" );
       printf( "  -q        : Umwandlung der PEP-Datei in Postscript-Format mit\n");
       printf( "            : Landscape-Darstellung.\n" );
       exit( -1 );                 /* ansonsten bricht das Programm ab.             */
     }
                            /* Falls die eingegebene  PEP-Datei zum Lesen    */
                            /* nicht geoeffnet werden kann.                  */

  if ( ! ( infile = fopen( argv[1], "r" ) ) )     
    {                                             
      printf( "Datei konnte nicht geoeffnet werden!\n" );
      exit ( -1 );
    } /* if */

   printf("Konversion laeuft.\n");     /* PEP-Datei erfolgreich zum Lesen geoffnet     */
                                       /* worden.                                      */

   strcpy( outfilename, "HAMRAM.FIG" ); /* Benennung der zu schreibenden FIG-Datei in    */
                                        /* HAMRAM.FIG.                                   */
   fscanf( infile, "%s\n", str );       /* Lesen der ersten Zeile in der  PEP-Datei      */ 

   if ( strcmp( str, "PEP" ) )         /* Falls die eingegebene Datei keine  PEP-Datei  */
     {                                  /* ist, dann bricht das Programm ab. ( Die       */
                                        /* Zeichenkette  PEP steht in der ersten Zeile   */
                                        /* jeder  PEP-Datei.                             */
       printf( " PEP-Datei erwartet!\n" ); 
       exit ( -1 );                          } 
   
   fscanf( infile, "%s\n3", str );      /* Lesen der zweiten Zeile in der  PEP-Datei.    */     
                                        /* Es ist erforderlich, dass in der */
                                        /* zweiten Zeile der  PEP-Datei     */
                                        /* einer der Zeichenketten PetriBox,*/
                                        /* Net, PTNet oder CENet steht.     */

   if ( strcmp( str, "PetriBox" ) &&  strcmp( str, "Net" ) &&  
        strcmp( str, "PTNet" ) &&  strcmp( str, "CENet" ))     
     {                                                        
       printf( "PetriBox oder Net oder PTNet oder CENet erwartet!\n" ); 
       exit ( -1 );                                                    
     }  
 
   fscanf(infile, "%s\n", str );      /* Ueberlesen der dritten Zeile der   PEP-Datei.  */ 
   readcommand(infile,str);           /* Ueberlesen des Kommentars in der  PEP-Datei    */
   readstring(infile, str);                       
   readbisende( infile, str);         /* Ueberlesen der Zeilen nach dem                 */
   readbisende( infile, str);         /* Kommentar bis zu den zwei hintereinander       */
   readbisende( infile, str);         /* folgenden Zeichenketten "end:"                 */
  

   if (( outfile = fopen( outfilename, "w" ) )) /* Falls die Ausgabedatei erfolgreich zum */   
     {                                    /* Schreiben geoffnet worden ist, wird in die */ 
       fprintf( outfile, "#FIG 2.1\n" );/* erste Zeile die Zeichenkette #FIG 2.1        */
       fprintf( outfile, "80 2\n" );    /* geschrieben, und in die zweite Zeile die     */
                                        /* Zeichenkette 80 2.                           */

       while ( ( ch = getc(infile) ) != EOF )/* Falls Ende der zum Lesen geoeffneten    */
         {                                   /*  PEP-Datei nicht erreicht ist.          */

           ungetc(ch,infile);           /* Ab hier werden Befehle in der  PEP-Datei     */
           readcommand(infile,str);     /* gelesen und mit IPL, PLA und OPL verglichen. */
           if ( !strcmp( str, "IPL" ) || /* Anschliessend wird die Funktion Stelle()    */
                !strcmp( str, "PLA" ) || /* aufgerufen und da wird ein Stellenknoten    */
                !strcmp( str, "OPL" ) )  /* an den gelesenen Koordinaten plaziert.      */ 
                           
             {
               rx = xstelle; ry = ystelle; dick = 2;
               *name = '\0';
               *meaning = '\0';
               x = y = capazit = marke = 0;
               ungetc( ch, infile );
               while ( ( ch = getc( infile ) ) != EOF )
                 {            
                      /* Ueberlesen der Zeichenkette idt, die den   */ 
                      /* Identifikator der Stelle darstellt         */
                   if ( ! strcmp( str, "idt" ) )
                     {                              
                       readnumber( infile );       
                     }                               
                     /* Ueberlesen der Zeichenkette ima            */
                   else if ( ! strcmp( str, "ima" ) )
                     {
                       readnumber( infile );
                     }
                    /* Hier wird die in den Hochkommata         */
                    /* befindliche Zeichenkette durch die       */  
                    /* Funktion readstring() gelesen und der    */
                    /* Variablename uebergeben.name, meaning,   */
                    /* dick, rx, marke, tx, ty werden beim      */
                    /* Funktionsaugruf von Stelle benoetigt     */

                   else if ( ! strcmp( str, "nam" ) ) 
                     {                               
                       readstring( infile, name );    
                     }                                
                                                      
                   else if ( ! strcmp( str, "mea" ) ) 
                     {
                       readstring( infile, meaning );             
                     }
                   else if ( ! strcmp( str, "cap" ) )
                     {
                       capazit = readnumber( infile );     
                     }
                     /* Hier werden die Koordinaten der Stelle         */
                     /* durch die Funktion readcoordinates() gelesen   */

                   else if ( ! strcmp( str, "dnp" ) )
                     { 
                       readcoordinates(infile, &tx, &ty); 
                     }
                   else if ( ! strcmp( str, "dsz" ) )
                     { 
                      /* Ueberlesen von ry, die bei der       */
                      /* Funktion Stelle nicht benoetigt wird */

                       readcoordinates(infile, &rx, &ry);
                     }                                   
                   else if ( ! strcmp( str, "dpt" ) )     
                     {  
                       readcoordinates(infile, &x, &y); /* Ueberlesen von x und y */                  
                     }
                   else if ( ! strcmp( str, "dwd" ) )
                     {
                       dick = readnumber( infile );
                     }
                   else if ( ! strcmp( str, "cma" ) )
                     { 
                       marke = readnumber( infile );
                     }
                   else if ( ! strcmp( str, "end" ) )  
                     { 
                       break;         
                     }  
                   readcommand(infile, str);
                 }
                                            /* Aufruf der Funktion Stelle().    */
               Stelle( outfile, x, y, name, meaning, dick, rx, marke, tx, ty  ); 

                }
                   /* Ab hier werden Befehle in der        */
                   /* PEP-Datei mit                        */
                   /* TRA (einfache Transition) und        */ 
                   /*  RTR (Verfeinerungstransition)       */
                   /* verglichen.  Anschliessend wird      */
                   /* die Funktion Transition()            */
                   /* aufgerufen und da werden die         */
                   /* Transitionsknoten an den ermittelten */
                   /* Koordinaten plaziert                 */ 

           else if ( !strcmp( str, "TRA" ) || !strcmp( str, "RTR" ) )
               {                                                   
                rx = xtrans; ry = ytrans; dick = 2;                
                *name = '\0';                                     
                *meaning = '\0';                                   
                x = y = 0;                                         
                ungetc( ch, infile );                              
                while ( ( ch = getc( infile ) ) != EOF )      
                 {                                           
                   if ( ! strcmp( str, "idt" ) )  /* Ueberlesen der Zeichenkette idt  */
                     {
                       readnumber( infile );
                     }
                   else if ( ! strcmp( str, "nam" ) )
                     {
                       readstring( infile, name );
                     }
                   else if ( ! strcmp( str, "mea" ) )
                     {
                       readstring( infile, meaning );             
                     }
                   else if ( ! strcmp( str, "dnp" ) )
                     {
                       readcoordinates(infile, &tx, &ty);
                     }
                   else if ( ! strcmp( str, "dsz" ) )
                     {
                       readcoordinates(infile, &rx, &ry);  /* Ueberlesen von ry       */       
                     }
                   else if ( ! strcmp( str, "dpt" ) )
                     {
                       readcoordinates(infile, &x, &y);
                     }
                   else if ( ! strcmp( str, "dwd" ) )
                     {
                       dick = readnumber( infile );
                     }
                   else if ( ! strcmp( str, "end" ) ) 
                     { 
                       break;
                     }
                   readcommand(infile, str);               
                 }                                 /* Aufruf der  Funktion Transition().*/
               Transition( outfile, x, y, name, meaning, dick, rx, tx, ty /*, label*/ ); 
             }                                                                                 
        
           else if ( ! strcmp( str, "ARC" ) )      /* Ab hier werden Befehle in der     */
             {                                     /* PEP-Datei mit                     */
               count = 0;                          /* ARC (Kante) abgearbeitet.         */
               listarke = 1; dick = 1;                          
               ungetc( ch, infile );                            
               while ( ( ch = getc( infile ) ) != EOF )
                 {  
                   if ( ! strcmp( str, "sou" ) )/*Ueberlesen der Zeichenkette sou, die den*/ 
                     {                          /*Identifikator der Quelle darstellt      */
                       readnumber( infile );
                     }
                   else if ( ! strcmp( str, "nam" ) )
                     {
                       readstring( infile, name );
                     }
                   else if ( ! strcmp( str, "des" ) )/* Ueberlesen der Zeichenkette des, */
                     {                    /* die den Identifikator des Zieles  darstellt */
                       readnumber( infile );
                     }
                   else if ( ! strcmp( str, "dpt" ) )
                     {
                       readcoordinates(infile, &rx, &ry);
                     }
                   else if ( ! strcmp( str, "dsz" ) )
                     {
                       listarke = readnumber( infile );                 
                     }
                   else if ( ! strcmp( str, "lpt" ) )
                     {
                       readcoordinates(infile, &rx, &ry);
                       if (count >= big)          
             /* Knickpunkte beruecksichtigen, falls mehrere lpt-Befehle in der */ 
             /* PEP-Datei existieren also mehrere Koordinaten, die die Kanten darstellen. */
             /* Es kann mehrere Knickpunkte geben, die gespeichert werden muessen. */
                         {                          
                           big += 100;             
                           xx = (int *) realloc( (char *) xx, big * sizeof( int ) );
                           yy = (int *) realloc( (char *) yy, big * sizeof( int ) );
                         }                                                           
                       xx[count] = rx;                                                
                       yy[count] = ry;                                               
                       count++;
                     }
                   else if ( ! strcmp( str, "wgt" ) )
                     {
                       gewicht = readnumber( infile );
                     }
                   else if ( ! strcmp( str, "dwd" ) )    
                     {
                       dick = readnumber( infile );
                     }
                   else if ( ! strcmp( str, "end" ) )  
                     { 
                       break;
                     }
                   readcommand(infile, str);
                              }
                /* if ( gewicht != 1 )
                     { 
                       fprintf( outfile, "4 1 1 8 0 -1 0 0.000 0 7 7 %d %d  %d\001\n", 
                                             x1+(x2-x1)/2+3, y1+(y2-y1)/2, gewicht );  
                     } */

                   fprintf( outfile, "2 1 0 %d -1 0 0 0 0.000 -1 1 0\n", listarke ); 
                               /* Ausgabe der Werten  in XFIG-Format, die zum Zeichnen */   
                               /* der Pfeile dienen, wobei auch die Knickpunkte        */
                               /* beruecksichtigt werden.                              */

                   fprintf( outfile, "   0 0 1.000 4.000 8.000\n" );                
                   fprintf( outfile, "   "); 
                   for (i = 0; i < count; i++)                                   
                               
                     {                                            
                       fprintf( outfile, " %d %d ", xx[i], yy[i]);                   
                     }             
                   fprintf( outfile, " 9999 9999\n");
                 }

           else if ( ! strcmp( str, "TXT" ) ) /* Ab hier werden Befehle in der    */
             {                                /* PEP-Datei mit  TXT (Textobjekt)  */
               ungetc( ch, infile );          /* abgearbeitet und anschliessend   */ 
               while ( ( ch = getc( infile ) ) != EOF ) /* wird der Text im XFIG-Format */
                 {                                      /* geschrieben.                 */
                   if ( ! strcmp( str, "str" ) )
                     {
                       readstring( infile, text );
                     }
                   else if ( ! strcmp( str, "dpt" ) )
                     {
                       readcoordinates(infile, &x, &y);
                     }  
                   else    /* ( ! strcmp( str, "end" ) )  */
                     { 
                       break;
                     }
                   readcommand(infile, str);
                   printf("TXT\n");
                 }
               fprintf( outfile, "4 0 1 6 0 -1 0 0.000 0 7 7 %d %d %s\001\n", 
                                      x, y, text);
             }

          else if ( ! strcmp( str, "END" ) ) /* Falls Ende der Datei erreicht worden ist. */
            {
              break;          
            }
          }                
 
        fclose( outfile );
      }
    free( (char *) xx ); 
    free( (char *) yy );

    if ( argc > 2 && *argv[2] == '-' )
      {
        switch( argv[2][1] )                         

          { 
            case 'f' : if ( argc == 4 )                             
                         {
            /* Umbenennung der erzeugten Ausgabedatei in dem angegebenen Namen.*/
                           sprintf( str, "mv HAMRAM.FIG %s", argv[3] );
                           system( str );   
                         }
                       else
                         {
           /* Umbenennung der erzeugten Ausgabedatei in dem gleichen            */
           /*  PEP-Dateinamen mit der  Endung fig, falls kein                   */
           /* Name angegeben  worden ist.                                       */
 
                           sprintf( str, "mv HAMRAM.FIG %s.fig", argv[1] ); 
                           system( str ); 
                         }                
                       break;             
         /* Die Umwandlung der XFIG-Datei in den verschiedenen Formaten */                                 
            case 'l' : if ( argc == 4 )
                         {
                           /* Aufruf des Programmes fig2dev mit der Option -l,        */
                           /* um die erzeugte XFIG-Datei in Latex-Format umzuwandeln. */

                           sprintf( str, "fig2dev -L latex HAMRAM.FIG > %s", argv[3] );
                           fn = argv[3];            
                           system( str );                          
                         }                                         
                       else               
                         {
                           /* Umbenennung der erzeugten Ausgabedatei             */
                           /* in dem gleichen  PEP-Dateinamen mit der            */
                           /* Endung tex, falls kein  Name angegeben worden ist. */

                           strcat( strcpy( name, argv[1] ), ".tex" );
                           sprintf( str, "fig2dev -L latex HAMRAM.FIG > %s", name ); 
                           fn = name;                  
                           system( str );     
                         }
 
                       of = fopen( "fff", "w" );
                                    /* Zum Binden der Latex-Datei in einem Tex-Dokument. */

                       fprintf( of, "\\documentstyle[german,12pt]{article}\n" );
                       fprintf( of, "\\begin{document}\n" ); 
                       fprintf( of, "\\begin{figure}\n" ); 
                                                /* Fuer diesen Zweck wird die Datei fff, */
                /* die anfaenglich aus den untenstehenden drei Zeilen besteht, benuetzt. */

                       fclose( of );
                /* Anhaengen der erzeugten Latex-Datei an der Datei fff.                 */
                       sprintf( sss, "cat %s >> fff", fn );
                       system( sss );                      
                       of = fopen( "fff", "a" );
                /* Zum Binden der Latex-Datei in einem Tex-Dokument.                     */

                       fprintf( of, "\\end{figure}\n" );       
                       fprintf( of, "\\end{document}\n" );     
                       fclose( of );
               /* Die erzeugte Format-Datei wird in dem angegebenen Namen umbenannt.     */

                       sprintf( sss, "mv fff %s", fn );   
                       system( sss );                         
                       system( "rm HAMRAM.FIG" );
                  /*   system( "rm fff" );  */
                       break;

            case 'q' :  if ( argc == 4 )                                                 
                         {        
                                    /* Aufruf des Programmes fig2dev mit der Option -q, */
                                    /* um die erzeugte XFIG-Datei                       */
                                    /* in PostScript-Format umzuwandeln,                */
                                    /* und zwar in Landscape-Darstellung.               */ 

                           sprintf( str, "fig2dev -L ps -l dummy -P HAMRAM.FIG > %s",
                                    argv[3]); 
                           system( str );                    
                         }                             
                        else                                           
                         { 
                              /* Umbenennung der erzeugten Ausgabedatei */
                              /* in dem gleichen  PEP-Dateinamen        */
                              /* mit der Endung ps, falls kein          */
                              /* Name angegeben worden ist.             */

                           strcat( strcpy( name, argv[1] ), ".ps" ); 
                           sprintf( str, "fig2dev -L ps -l dummy -P HAMRAM.FIG > %s", name );
                           system( str );                                               
                         }                                               
                        system( "rm HAMRAM.FIG" );   
                        break;

 
            case 'p' :  if ( argc == 4 )     
                         {  
           /* Aufruf des Programmes fig2dev mit der Option -p, um die erzeugte XFIG-Datei */
           /* in PostScript-Format umzuwandeln, und zwar in Portrait-Darstellung.         */

                           sprintf( str, "fig2dev -L ps -P HAMRAM.FIG > %s", argv[3] );
                           system( str );                                            
                         }                                       
                        else
                         {
             /* Umbenennung der erzeugten Ausgabedatei in dem gleichen  PEP-Dateinamen */
             /* mit der Endung ps, falls kein Name angegeben worden ist.               */

                           strcat( strcpy( name, argv[1] ), ".ps" ); 
                           sprintf( str, "fig2dev -L ps -P HAMRAM.FIG > %s", name );         
                           system( str );                                                
                         }                                                     
                                                                                   
                        system( "rm HAMRAM.FIG" );
                        break;
                                        
            case 't' :  if ( argc == 4 )

            /* Aufruf des Programmes fig2dev mit der Option -t,        */
            /* um die erzeugte XFIG-Datei in Pictex-Format umzuwandeln */

                         {                          
                           sprintf( str, "fig2dev -L pictex HAMRAM.FIG > %s", argv[3] );
                           fn = argv[3];                                                 
                           system( str );
                         }
                        else
                         {
            /* Umbenennung der erzeugten Ausgabedatei in dem gleichen                    */
            /*  PEP-Dateinamen mit der Endung tex, falls kein Name angegeben worden ist. */
                           strcat( strcpy( name, argv[1] ), ".pictex" );
                           sprintf( str, "fig2dev -L pictex HAMRAM.FIG > %s", name );
                           fn = name;                
                           system( str );                                 
                         } 
                        of = fopen( "fff", "w" );
                         /* Zum Binden der Latex-Datei in einem in einem Tex-Dokument.*/
                        fprintf( of, "\\documentstyle[german,12pt]{article}\n" ); 
                        fprintf( of, "\\input{prepictex}\n"); 
                        fprintf( of, "\\input{pictex}\n");
                        fprintf( of, "\\input{postpictex}\n");
                        fprintf( of, "\\begin{document}\n");
                        fprintf( of, "\\begin{figure}\n" );
                        fclose( of );
                        /* Anhaengen der erzeugten Latex-Datei an der Datei fff.*/
                        sprintf( sss, "cat %s >> fff", fn );  
                        system( sss );                        
                        of = fopen( "fff", "a" );
                        /* Zum Binden der Latex-Datei in einem Tex-Dokument.    */
                        fprintf( of, "\\end{figure}\n" );   
                        fprintf( of, "\\end{document}\n" );  
                        fclose( of );
                    /* Die erzeugte Format-Datei wird in dem angegebenen Namen umbenannt. */ 
                        sprintf( sss, "mv fff %s", fn );   
                        system( sss );                              
                        system( "rm HAMRAM.FIG" );  
                     /* system( "rm fff" ); */
                        break;
                                           
            default  :;
          }
        strcpy( outfilename, argv[2] );
      }
    else                                                       
      {
        /* Falls keine Option und kein Name angegeben worden sind, wird    */
        /* die erzeugte XFIG-Datei durch das aufgerufene Programm fig2dev  */
        /* in PostScript-Datei umgewandelt und behaelt                     */ 
        /* den urspruenglichen  PEP-Dateinamen mit der Endung ps.          */

         strcat( strcpy( name, argv[1] ), ".ps" );  
         sprintf( str, "fig2dev -L ps -P -l ddd HAMRAM.FIG > %s", name ); 
         system( str );        
         system( "rm HAMRAM.FIG" );                
      }
    exit (0);
}



