#!/usr/bin/wish

proc prj_ana_lola_dlg {{with_pep true}} {
  global gvar

  set prjnum $gvar(actprj)
  upvar #0 prj$prjnum prjx

    # Menupunkt abschalten, spaeter wieder einschalten
  if {$with_pep} {
    $prjx(project.ana.menu.widget) entryconfigure "Net Analysis (LoLA)*" -state disabled
  }

    # Dialog aufbauen
  if [catch {set tl [toplevel .ana_lola_dlg$prjnum]}] {
    return
  }  ;# if doppelt
#  add_dlg_widget $prjnum $tl
  wm title $tl "LoLA Analysis"
#  wm protocol $tl WM_DELETE_WINDOW "dlg_option_wm_delete $prjnum $tl \
    {$prjx(project.ana.menu.widget) entryconfigure {Net Analysis (LoLA)*} \
    -state normal}"

    # Eingabebereich
  frame $tl.input  -bd 2
  pack $tl.input  -side top  -fill both

  if {! $with_pep} {
  frame $tl.input.file
  pack $tl.input.file -side top
  button $tl.input.file.load -text "Choose File" \
	-command {global prj0; set prj0(ll_net.filename) [tk_getOpenFile];\
		.ana_lola_dlg0.input.file.filename configure -state normal;\
		.ana_lola_dlg0.input.file.filename delete 0 end;\
		.ana_lola_dlg0.input.file.filename insert 0 [file tail $prj0(ll_net.filename)];\
		.ana_lola_dlg0.input.file.filename configure -state readonly}
  entry $tl.input.file.filename -bd 0 -text $prjx(ll_net.filename)\
	-width 60 -state normal
  pack $tl.input.file.load $tl.input.file.filename -side left
  }

  frame $tl.input.cap -bd 0
  label $tl.input.max_capacity_label -text "Max Capacity" -bd 2
  set gvar(option.ana_lola.max_capacity) \
    $prjx(ll_net.ana.lola.max_capacity)
  entry $tl.input.max_capacity -bd 2 -width 6 \
    -textvariable gvar(option.ana_lola.max_capacity) -state disabled
  label $tl.input.hash_label -text "Hash size" -bd 2
  set gvar(option.ana_lola.hash) $prjx(ll_net.ana.lola.hash)
  entry $tl.input.hash -bd 2 -width 4 \
    -textvariable gvar(option.ana_lola.hash)
  pack $tl.input.cap -fill x
  pack $tl.input.max_capacity_label -side left -in $tl.input.cap
  pack $tl.input.max_capacity -side left -fill x -expand 1 -in $tl.input.cap
  pack $tl.input.hash_label -side left -in $tl.input.cap
  pack $tl.input.hash -side left -fill x -expand 1 -in $tl.input.cap

  labelframe $tl.input.reduction -bd 2 -text "Reduction technique(s)"
  pack $tl.input.reduction -side top -fill both
  set gvar(option.ana_lola.cover) $prjx(ll_net.ana.lola.cover)
  checkbutton $tl.input.reduction.cover -bd 2 \
    -text "Cover" -variable gvar(option.ana_lola.cover)
  set gvar(option.ana_lola.stubborn) $prjx(ll_net.ana.lola.stubborn)
  checkbutton $tl.input.reduction.stubborn -bd 2 \
    -text "Stubborn" -variable gvar(option.ana_lola.stubborn)
  set gvar(option.ana_lola.symmetry) $prjx(ll_net.ana.lola.symmetry)
  checkbutton $tl.input.reduction.symmetry -bd 2 \
    -text "Symmetry" -variable gvar(option.ana_lola.symmetry)
  set gvar(option.ana_lola.relaxed) $prjx(ll_net.ana.lola.relaxed)
  checkbutton $tl.input.reduction.relaxed -bd 2 \
    -text "Relaxed Stubborn" -variable gvar(option.ana_lola.relaxed)
  pack $tl.input.reduction.cover $tl.input.reduction.stubborn \
    $tl.input.reduction.symmetry $tl.input.reduction.relaxed -side left -fill x -expand 1

  labelframe $tl.input.exploration -bd 2 -text "Graph exploration strategy"
  pack $tl.input.exploration -side top -fill both
  set gvar(option.ana_lola.depthfirst) $prjx(ll_net.ana.lola.depthfirst)
  radiobutton $tl.input.exploration.depth -text "Depth first" \
    -variable gvar(option.ana_lola.depthfirst) -value "true"
  radiobutton $tl.input.exploration.breadth -text "Breadth first" \
    -variable gvar(option.ana_lola.depthfirst) -value "false"
  pack $tl.input.exploration.depth $tl.input.exploration.breadth \
    -side left -fill x -expand 1

  labelframe $tl.input.analysis -bd 2 -text "Analysis type"
  pack $tl.input.analysis -side top -fill both
  set gvar(option.ana_lola.analysis) $prjx(ll_net.ana.lola.analysis)
  radiobutton $tl.input.analysis.reachability -text "Reachability" \
    -variable gvar(option.ana_lola.analysis) -value "1"
  radiobutton $tl.input.analysis.reversibility -text "Reversibility" \
    -variable gvar(option.ana_lola.analysis) -value "2"
  radiobutton $tl.input.analysis.homestate -text "Home states" \
    -variable gvar(option.ana_lola.analysis) -value "3"
  radiobutton $tl.input.analysis.net_bounded -text "Bounded Net" \
    -variable gvar(option.ana_lola.analysis) -value "6"
  radiobutton $tl.input.analysis.place_bounded -text "Bounded Place" \
    -variable gvar(option.ana_lola.analysis) -value "5"
  radiobutton $tl.input.analysis.dead_transition -text "Dead Transition" \
    -variable gvar(option.ana_lola.analysis) -value "4"
  radiobutton $tl.input.analysis.modelcheck -text "Model Check" \
    -variable gvar(option.ana_lola.analysis) -value "7"
  radiobutton $tl.input.analysis.findpath -text "Find Path" \
    -variable gvar(option.ana_lola.analysis) -value "8"
  radiobutton $tl.input.analysis.stategraph -text "Compute State Graph" \
    -variable gvar(option.ana_lola.analysis) -value "11"
  radiobutton $tl.input.analysis.deadlock -text "Deadlock" \
    -variable gvar(option.ana_lola.analysis) -value "9"
  radiobutton $tl.input.analysis.state_predicate -text "State Predicate" \
    -variable gvar(option.ana_lola.analysis) -value "10"
  radiobutton $tl.input.analysis.none -text "None (get generating set)" \
    -variable gvar(option.ana_lola.analysis) -value "12"

  grid $tl.input.analysis.reachability $tl.input.analysis.reversibility \
    $tl.input.analysis.homestate -sticky w
  grid $tl.input.analysis.net_bounded $tl.input.analysis.place_bounded \
    $tl.input.analysis.dead_transition -sticky w
  grid $tl.input.analysis.modelcheck $tl.input.analysis.findpath \
    $tl.input.analysis.stategraph -sticky w
  grid $tl.input.analysis.deadlock $tl.input.analysis.state_predicate \
    $tl.input.analysis.none -sticky w

  frame $tl.input.analysis.mp -bd 0
  set gvar(option.ana_lola.extendedctl) $prjx(ll_net.ana.lola.extendedctl)
  checkbutton $tl.input.analysis.ext_ctl -bd 2 \
    -text "Extended CTL" -variable gvar(option.ana_lola.extendedctl)
  label $tl.input.analysis.maxpath_label -text "Max path size"  -bd 2
  set gvar(option.ana_lola.maxpath) \
    $prjx(ll_net.ana.lola.maxpath)
  entry $tl.input.analysis.maxpath -bd 2 -width 10 \
    -textvariable gvar(option.ana_lola.maxpath)
  grid $tl.input.analysis.mp -columnspan 2
  grid $tl.input.analysis.ext_ctl -row 4 -column 2
  pack $tl.input.analysis.maxpath_label $tl.input.analysis.maxpath \
    -in $tl.input.analysis.mp -side left

  labelframe $tl.input.spec -bd 2 -text {Analysis task}
  pack $tl.input.spec -fill x -expand 1
  entry $tl.input.spec.entry -width 40 -textvariable gvar(option.ana_lola.spec)
  pack $tl.input.spec.entry -side left -fill x -expand 1

    # Ausgabebereich
  frame $tl.output  -relief sunken  -bd 2
  pack $tl.output  -side top  -fill both  -expand 1
  label $tl.output.result_label  -text "Result of the previous Test:"
  text $tl.output.result -width 60 -height 15 -state disabled
  pack $tl.output.result_label -side top  -anchor w
  pack  $tl.output.result -side top -fill both -expand 1

  frame $tl.commands  -relief raised  -bd 2
  pack $tl.commands  -side bottom  -fill x
  button $tl.commands.ok  -text "Check" \
    -command "prj_ana_lola $with_pep"
  if {$with_pep} {
    button $tl.commands.cancel  -text "Close" \
      -command "$prjx(project.ana.menu.widget) entryconfigure {Net Analysis (LoLA)*} \
      -state normal; destroy $tl"
  } else {
    button $tl.commands.cancel  -text "Close" -command "destroy $tl"
  }

  pack $tl.commands.ok $tl.commands.cancel \
    -side left -expand yes
}  ;# prj_ana_bounded_dlg

proc prj_ana_lola {with_pep} {
  # If LL-net exists, configure lola and execute.
  global gvar
  global errorCode

    # get project number
  set prjnum $gvar(actprj)
    # set name for project variable
  upvar #0 prj$prjnum prjx
    # save directory
  set actdir [pwd]
    # Change to project directory
  cd "$prjx(actdir)"
   .ana_lola_dlg$prjnum.output.result configure -state normal
   .ana_lola_dlg$prjnum.output.result delete 1.0 end
   .ana_lola_dlg$prjnum.output.result configure -state disabled
    # Test if net exists
  if [file exists "$prjx(ll_net.filename)"] {
    set lola_filename [file rootname $prjx(ll_net.filename)].lola
    if {$with_pep || ([file extension $prjx(ll_net.filename)]==".ll_net")} {
    set sys_str "exec $gvar(ll_net_ana_pep_2_lola.name) $prjx(ll_net.filename) \
      $lola_filename"
    set errorCode "NONE"
    set sys_res [catch {eval $sys_str} result_text]
    }
    set task_filename [file rootname $prjx(ll_net.filename)].ll_net_lola_ana
    if {![catch {set taskfile [open $task_filename w]}]} {
    switch $gvar(option.ana_lola.analysis) {
	1 {
	  puts $taskfile "ANALYSE MARKING $gvar(option.ana_lola.spec)"
	}
	4 {
	  puts $taskfile "ANALYSE TRANSITION $gvar(option.ana_lola.spec)"
	}
	5 {
	  puts $taskfile "ANALYSE PLACE $gvar(option.ana_lola.spec)"
	}
	7 {
	  puts $taskfile "ANALYSE FORMULA $gvar(option.ana_lola.spec)"
	}
	8 {
	  puts $taskfile "ANALYSE FORMULA $gvar(option.ana_lola.spec)"
	}
	10 {
	  puts $taskfile "ANALYSE FORMULA $gvar(option.ana_lola.spec)"
	}
    }
    close $taskfile
    }
    set result_filename \
      [file rootname $prjx(ll_net.filename)].ll_net_lola_res
    set opts "-c=$gvar(option.ana_lola.analysis) -H=$gvar(option.ana_lola.hash)\
	-X=$gvar(option.ana_lola.maxpath)"
    if [file exists $task_filename] {
      append opts " -a $task_filename"
    }
    if {$gvar(option.ana_lola.relaxed)=="true"} {
      append opts " -r"
    }
    if {$gvar(option.ana_lola.depthfirst)!="true"} {
      append opts " -b"
    }
    if {$gvar(option.ana_lola.symmetry)} {
      append opts " -R=y"
    }
    set sys_str "exec $gvar(ll_net_ana_lola.name) $opts $lola_filename \
      -p $result_filename"
    set errorCode "NONE"
    set sys_res [catch {eval $sys_str} result_text]
    switch -regexp $result_text {
      "is reachable"  {set prjx(ll_net.ana.lola) "YES"}
      "is not reachable"  {set prjx(ll_net.ana.lola) "NO"}
      default  {set prjx(ll_net.ana.lola) "UNKNOWN"}
    }  ;# switch $result
    file delete $task_filename
    file delete $result_filename
   .ana_lola_dlg$prjnum.output.result configure -state normal
   .ana_lola_dlg$prjnum.output.result insert 1.0 $result_text
   .ana_lola_dlg$prjnum.output.result configure -state disabled
#    new_project_msg $prjnum "LL Net tested for T-System \
      [format_ana_result_string $prjx(ll_net.ana.t_system)]"
#    update_project_infos $prjnum
  } else {
    error_msg "LL Net $prjx(actdir)/$prjx(ll_net.filename) does not exist"
  }  ;# else, Source ist nicht vorhanden
  cd $actdir
}

proc init_lola_defaults {} {
  global gvar

  set prjnum $gvar(actprj)
  upvar #0 prj$prjnum prjx

  if [catch {set prjx(ll_net.ana.lola)}] {
    set prjx(ll_net.ana.lola) "UNKNOWN"
    set prjx(ll_net.ana.lola.max_capacity) 0
    set prjx(ll_net.ana.lola.maxpath) 3000000
    set prjx(ll_net.ana.lola.hash) 13
    set prjx(ll_net.ana.lola.cover) false
    set prjx(ll_net.ana.lola.stubborn) false
    set prjx(ll_net.ana.lola.symmetry) false
    set prjx(ll_net.ana.lola.relaxed) false
    set prjx(ll_net.ana.lola.depthfirst) true
    set prjx(ll_net.ana.lola.analysis) 1
    set prjx(ll_net.ana.lola.extendedctl) false
  }
}

if [catch {set gvar(pep_version)}] {
  set gvar(actprj) 0
  set gvar(ll_net_ana_lola.name) ./lola
  set gvar(ll_net_ana_pep_2_lola.name) ./pep2lola
  set prj0(actdir) .
  set prj0(ll_net.filename) ""
  init_lola_defaults
  prj_ana_lola_dlg false
}

