/******************************************************************************/

#include "conv_pep.h"
 
#if defined(__STDC__) || defined(__cplusplus)
static void inc_mat (lprec *lp, int row, int col, REAL offset)
#else
static void inc_mat (lp, row, col, offset)
	lprec *lp;
	int row;
	int col;
	REAL offset;
#endif
{
	set_mat (lp, row, col, mat_elm (lp, row, col) + offset);
}

#if defined(__STDC__) || defined(__cplusplus)
void convertPEP2reach (lprec *lp, LMPNet net, 
		       unsigned int start_trap, 
		       unsigned int start_inv,
		       unsigned int s0,
		       unsigned int s1,
		       unsigned int s2,
		       unsigned int s3,
		       int          without_traps,
		       int          without_invariants,
		       REAL         max_coeff)
#else
void convertPEP2reach (lp, net, start_trap, start_inv, 
                       s0, s1, s2, s3, without_traps, 
		       without_invariants, max_coeff)
	lprec	*lp;
	LMPNet 	net;
	unsigned int start_row;
	unsigned int start_inv;
	unsigned int s0;
	unsigned int s1;
	unsigned int s2;
	unsigned int s3;
	int          without_traps;
	int          without_invariants;
	REAL	     max_coeff;
#endif
{
	Place   p = net->Places;
	STEdge	post;
	TSEdge  pre;
	nstring      dummy;

	while (p != (Place) NULL)
	  {if (! without_traps)
	     {set_rh (lp, start_trap + p->numname, 
                          (p->marks == undef) ? 0.0 : ((REAL) p->marks) * A_2);
	      if (p->label == ENTRY)
	        set_mat (lp, start_trap + p->numname, s1, init_marking[p->numname] * A_1);
	      set_constr_type (lp, start_trap + p->numname, LE);
	      sprintf (dummy, "Y%s", p->name);
	      set_row_name (lp, start_trap + p->numname, dummy);
	     };

	   
           for (post = p->postset; post != (STEdge) NULL; post = post->nexttrans)
	     {if (! without_traps)
	        inc_mat (lp, start_trap + p->numname, 
                             post->trans->numname + s0, (-(REAL) 1.0) * A_0);
	      if (! without_invariants)
		inc_mat (lp, start_inv + p->numname, 
                             post->trans->numname + s3, (REAL) 1.0);
	      };

           for (pre = p->preset; pre != (TSEdge) NULL; pre = pre->nexttrans)
	     {if (! without_traps)
                inc_mat (lp, start_trap + p->numname, 
                             pre->trans->numname + s0, ((REAL) pre->weight) * A_0);
	      if (! without_invariants)
		inc_mat (lp, start_inv + p->numname, 
                             pre->trans->numname + s3, -(REAL) 1.0);
	     };

	   if (p->marks == undef)
	     {if (! without_invariants)
		{set_mat (lp, start_inv + p->numname, 
                              ((int) p->component) + s2, 1.0);
	         set_rh  (lp, start_inv + p->numname, 
                              (p->label == ENTRY) ? init_marking[p->numname] : 0.0);
	        };

              if (! without_traps)
		set_mat (lp, start_trap + p->numname,
			     ((int) p->component) + s2, -1.0 * A_2);
	     }
	   else
	     if (! without_invariants)
               set_rh (lp, start_inv + p->numname, 
		       ((p->label == ENTRY) ? init_marking[p->numname] : 0.0) -((REAL) p->marks));

	   if (! without_invariants)     
 	     {set_constr_type (lp, start_inv  + p->numname, EQ);
	      sprintf (dummy, "I%s", p->name);
	      set_row_name (lp, start_inv + p->numname, dummy);
	     };
	
	   p = p->nextplace;
	  };
}

#if defined(__STDC__) || defined(__cplusplus)
void convertPEP2reach_stabil (lprec *lp, LMPNet net, 
		              unsigned int start_trap, 
		              unsigned int start_inv,
		              unsigned int s0,
		              unsigned int s1,
		              unsigned int s2,
		              unsigned int s3,
		              int          without_traps,
		              int          without_invariants,
		              REAL         max_coeff)
#else
void convertPEP2reach_stabil (lp, net, start_trap, start_inv, 
                              s0, s1, s2, s3, without_traps, 
		              without_invariants, max_coeff)
	lprec	*lp;
	LMPNet 	net;
	unsigned int start_row;
	unsigned int start_inv;
	unsigned int s0;
	unsigned int s1;
	unsigned int s2;
	unsigned int s3;
	int          without_traps;
	int          without_invariants;
	REAL	     max_coeff;
#endif
{
	Place      p  = net->Places;
	Transition tr = net->Transitions;
	STEdge	post;
	TSEdge  pre;
	nstring      dummy;

	while (p != (Place) NULL)
	  {if (! without_traps)
	     {set_rh (lp, start_trap + p->numname, 
                          (p->marks == undef) ? 0.0 : ((REAL) p->marks) * A_2);
	      if (p->label == ENTRY)
	        set_mat (lp, start_trap + p->numname, s1, init_marking[p->numname] * A_1);
	      set_constr_type (lp, start_trap + p->numname, LE);
	      sprintf (dummy, "Y%s", p->name);
	      set_row_name (lp, start_trap + p->numname, dummy);
	     };

	   
           for (post = p->postset; post != (STEdge) NULL; post = post->nexttrans)
	     {if (! without_invariants)
		inc_mat (lp, start_inv + p->numname, 
                             post->trans->numname + s3, (REAL) 1.0);
	      };

           for (pre = p->preset; pre != (TSEdge) NULL; pre = pre->nexttrans)
	     {if (! without_invariants)
		inc_mat (lp, start_inv + p->numname, 
                             pre->trans->numname + s3, -(REAL) 1.0);
	     };

	   if (p->marks == undef)
	     {if (! without_invariants)
		{set_mat (lp, start_inv + p->numname, 
                              ((int) p->component) + s2, 1.0);
	         set_rh  (lp, start_inv + p->numname, 
                              (p->label == ENTRY) ? init_marking[p->numname] : 0.0);
	        };

              if (! without_traps)
		set_mat (lp, start_trap + p->numname,
			     ((int) p->component) + s2, -1.0 * A_2);
	     }
	   else
	     if (! without_invariants)
               set_rh (lp, start_inv + p->numname, 
		       ((p->label == ENTRY) ? init_marking[p->numname] : 0.0) -((REAL) p->marks));

	   if (! without_invariants)     
 	     {set_constr_type (lp, start_inv  + p->numname, EQ);
	      sprintf (dummy, "I%s", p->name);
	      set_row_name (lp, start_inv + p->numname, dummy);
	     };
	
	   p = p->nextplace;
	  };

     if (! without_traps)
       {STEdge pre; 
	TSEdge post;
 
	tr = net->Transitions;
	while (tr != (Transition) NULL)
	  {pre = tr->preset;
	   while (pre != (STEdge) NULL)
	     {set_mat (lp, start_trap + pre->place->numname, 
                       s0 + pre->weight, -1.0);
	      post = tr->postset;
	      while (post != (TSEdge) NULL)
	        {set_mat (lp, start_trap + post->place->numname, 
                          s0 + pre->weight, 1.0);
		 post = post->nextplace;
	        };
	      pre = pre->nextplace;
	     };
	   tr = tr->nexttrans;
	  };
	};
}

#if defined(__STDC__) || defined(__cplusplus)
void convertPEP2dead  (lprec *lp, LMPNet net, 
		       unsigned int start_trap, 
		       unsigned int start_inv,
		       unsigned int start_dead,
		       unsigned int s0,
		       unsigned int s1,
		       unsigned int s2,
		       unsigned int s3,
		       int      without_traps,
		       int      without_invariants,
		       REAL	max_coeff)
#else
void convertPEP2dead (lp, net, start_trap, start_inv, start_dead, 
                      s0, s1, s2, s3, without_traps, without_invariants
		      max_coeff)
	lprec	*lp;
	LMPNet 	net;
	unsigned int start_row;
	unsigned int start_inv;
	unsigned int start_dead;
	unsigned int s0;
	unsigned int s1;
	unsigned int s2;
	unsigned int s3;
	int          without_traps;
	int          without_invariants;
	REAL	     max_coeff;
#endif
{
	Place   p = net->Places;
	Transition t = net->Transitions;
	STEdge	post;
	TSEdge  pre;

 	while (p != (Place) NULL)
	  {if (! without_traps)
	     {set_rh (lp, start_trap + p->numname, 
                          (p->marks == undef) ? 0.0 : ((REAL) p->marks) * A_2);
	      if (p->label == ENTRY)
	        set_mat (lp, start_trap + p->numname, s1, init_marking[p->numname] * A_1);
	      set_constr_type (lp, start_trap + p->numname, LE);
	     };

	   
           for (post = p->postset; post != (STEdge) NULL; post = post->nexttrans)
	     {if (! without_traps)
	        inc_mat (lp, start_trap + p->numname, 
                             post->trans->numname + s0, (-(REAL) 1.0) * A_0);
	      if (! without_invariants)
		inc_mat (lp, start_inv + p->numname, 
                             post->trans->numname + s3, (REAL) 1.0);
	      };

           for (pre = p->preset; pre != (TSEdge) NULL; pre = pre->nexttrans)
	     {if (! without_traps)
                inc_mat (lp, start_trap + p->numname, 
                             pre->trans->numname + s0, 
                             ((REAL) pre->weight) * A_0);
	      if (! without_invariants)
		inc_mat (lp, start_inv + p->numname, 
                             pre->trans->numname + s3, -(REAL) 1.0);
	     };

	   if (p->marks == undef)
	     {if (! without_invariants)
		{set_mat (lp, start_inv + p->numname, 
                              ((int) p->component) + s2, 1.0);
	         set_rh  (lp, start_inv + p->numname, 
                              (p->label == ENTRY) ? init_marking[p->numname] : 0.0);
	        };

              if (! without_traps)
		set_mat (lp, start_trap + p->numname,
			     ((int) p->component) + s2, -1.0 * A_2);
	     }
	   else
	     if (! without_invariants)
               set_rh (lp, start_inv + p->numname, 
		       ((p->label == ENTRY) ? init_marking[p->numname] : 0.0) -((REAL) p->marks));

	   if (! without_invariants)     
 	     set_constr_type (lp, start_inv  + p->numname, EQ);
	
	   p = p->nextplace;
	  };

	while (t != (Transition) NULL)
	  {set_rh (lp, start_dead + t->numname, 
                   ((REAL) t->postset->weight) - 1.0);
	   set_constr_type (lp, start_dead + t->numname, LE);
	   post = t->preset;
	   while (post != (STEdge) NULL)
	     {set_mat (lp, start_dead + t->numname, post->place->component + s2,
			1.0);
	      post = post->nextplace;
	     };
	   t = t->nexttrans;
	  };
}

#if defined(__STDC__) || defined(__cplusplus)
void convertPEP2dead_unf  (lprec *lp, LMPNet net, 
 		           unsigned int start_inv,
		           unsigned int start_dead,
		           unsigned int s0,
		           unsigned int s1,
 		           REAL	    max_coeff)
#else
void convertPEP2dead_unf (lp, net, start_inv, start_dead, s0, s1, max_coeff)
	lprec	*lp;
	LMPNet 	net;
 	unsigned int start_inv;
	unsigned int start_dead;
	unsigned int s0;
	unsigned int s1;
 	REAL	     max_coeff;
#endif
{
	Place      p = net->Places;
	Transition t = net->Transitions;
	STEdge	post;
	TSEdge  pre;

 	while (p != (Place) NULL)
	  { 
	   
           for (post = p->postset; post != (STEdge) NULL; post = post->nexttrans)
	     if (post->trans->preset->weight != 0)
 		inc_mat (lp, start_inv + p->numname, 
                             post->trans->preset->weight + s1 - 1, (REAL) 1.0);
	     

           for (pre = p->preset; pre != (TSEdge) NULL; pre = pre->nexttrans)
	     if (pre->trans->preset->weight != 0)
		inc_mat (lp, start_inv + p->numname, 
                             pre->trans->preset->weight + s1 - 1, -(REAL) 1.0);

	   if (p->marks == undef)
             {set_mat (lp, start_inv + p->numname, 
                              ((int) p->component) + s0, 1.0);
	      set_rh  (lp, start_inv + p->numname, 
                              (p->label == ENTRY) ? 1.0 : 0.0);
	     }
 	   else
              set_rh (lp, start_inv + p->numname, 
		       ((p->label == ENTRY) ? 1.0 : 0.0) - ((REAL) p->marks));

  	   set_constr_type (lp, start_inv  + p->numname, EQ);
	   p = p->nextplace;
	  };

	while (t != (Transition) NULL)
	  {set_rh (lp, start_dead + t->numname, 
                   ((REAL) t->postset->weight) - 1.0);
	   set_constr_type (lp, start_dead + t->numname, LE);
	   post = t->preset;
	   while (post != (STEdge) NULL)
	     {set_mat (lp, start_dead + t->numname, 
                           post->place->component + s0, 1.0);
	      post = post->nextplace;
	     };
	   t = t->nexttrans;
	  };
}

#if defined(__STDC__) || defined(__cplusplus)
void convertPEP2dead_stabil  (lprec *lp, LMPNet net, 
		              unsigned int start_trap, 
		              unsigned int start_inv,
		              unsigned int start_dead,
		              unsigned int s0,
		              unsigned int s1,
		              unsigned int s2,
		              unsigned int s3,
		              int      without_traps,
		              int      without_invariants,
		              REAL     max_coeff)
#else
void convertPEP2dead_stabil (lp, net, start_trap, start_inv, start_dead, 
                             s0, s1, s2, s3, without_traps, without_invariants
		             max_coeff)
	lprec	*lp;
	LMPNet 	net;
	unsigned int start_trap;
	unsigned int start_inv;
	unsigned int start_dead;
	unsigned int s0;
	unsigned int s1;
	unsigned int s2;
	unsigned int s3;
	int          without_traps;
	int          without_invariants;
	REAL	     max_coeff;
#endif
{
 	Transition t = net->Transitions;
	STEdge	post;
 
  	convertPEP2reach_stabil (lp, net, start_trap, start_inv, 
			         s0, s1, s2, s3, without_traps,
			 	 without_invariants, max_coeff);

	while (t != (Transition) NULL)
	  {set_rh (lp, start_dead + t->numname, 
                   ((REAL) t->postset->weight) - 1.0);
	   set_constr_type (lp, start_dead + t->numname, LE);
	   post = t->preset;
	   while (post != (STEdge) NULL)
	     {set_mat (lp, start_dead + t->numname, post->place->component + s2,
			1.0);
	      post = post->nextplace;
	     };
	   t = t->nexttrans;
	  };
}

