#ifndef __CONV_PEP_H__
#define __CONV_PEP_H__

#include <stdio.h>
#include "neunetze.h"
#include "lp_misc.h"

#if defined(__STDC__) || defined(__cplusplus)
void convertPEP2reach (lprec *lp, LMPNet net, 
		       unsigned int start_trap, 
		       unsigned int start_inv,
		       unsigned int s0,
		       unsigned int s1,
		       unsigned int s2,
		       unsigned int s3,
		       int          without_traps,
		       int          without_invariants,
		       REAL         max_coeff);
#else
void convertPEP2reach (lp, net, start_trap, start_inv, 
                       s0, s1, s2, s3, without_traps, 
		       without_invariants, max_coeff);
#endif

#if defined(__STDC__) || defined(__cplusplus)
void convertPEP2reach_stabil (lprec *lp, LMPNet net, 
		              unsigned int start_trap, 
		              unsigned int start_inv,
		              unsigned int s0,
		              unsigned int s1,
		              unsigned int s2,
		              unsigned int s3,
		              int          without_traps,
		              int          without_invariants,
		              REAL         max_coeff);
#else
void convertPEP2reach_stabil (lp, net, start_trap, start_inv, 
                              s0, s1, s2, s3, without_traps, 
		              without_invariants, max_coeff);
#endif

#if defined(__STDC__) || defined(__cplusplus)
void convertPEP2dead  (lprec *lp, LMPNet net, 
		       unsigned int start_trap, 
		       unsigned int start_inv,
		       unsigned int start_dead,
		       unsigned int s0,
		       unsigned int s1,
		       unsigned int s2,
		       unsigned int s3,
		       int      without_traps,
		       int      without_invariants,
		       REAL	max_coeff);
#else
void convertPEP2dead (lp, net, start_trap, start_inv, start_dead, 
                      s0, s1, s2, s3, without_traps, without_invariants
		      max_coeff);
#endif

#if defined(__STDC__) || defined(__cplusplus)
void convertPEP2dead_unf  (lprec *lp, LMPNet net, 
 		           unsigned int start_inv,
		           unsigned int start_dead,
		           unsigned int s0,
		           unsigned int s1,
 		           REAL	    max_coeff);
#else
void convertPEP2dead_unf (lp, net, start_inv, start_dead, s0, s1, max_coeff);
#endif

#if defined(__STDC__) || defined(__cplusplus)
void convertPEP2dead_stabil  (lprec *lp, LMPNet net, 
		              unsigned int start_trap, 
		              unsigned int start_inv,
		              unsigned int start_dead,
		              unsigned int s0,
		              unsigned int s1,
		              unsigned int s2,
		              unsigned int s3,
		              int      without_traps,
		              int      without_invariants,
		              REAL     max_coeff);
#else
void convertPEP2dead_stabil (lp, net, start_trap, start_inv, start_dead, 
                             s0, s1, s2, s3, without_traps, without_invariants
		             max_coeff);
#endif

#endif
