#!/bin/sh

SRC="[!A]*.ll_net"
DEST="*.comp *.smv"
LOG=test.result
TIME="time"

rm -f $LOG

#create output
for i in ${SRC}; do
  echo Checking $i with gencomp;
  $TIME /opt/pep/bin/gencomp $i;
done

for i in ${SRC}; do
  for j in 1 2 3 4 5; do
    echo Checking $i with pep2smv model $j;
    $TIME ../pep2smv $i -o=`basename $i .ll_net`_$j.smv -b=`basename $i .ll_net`.comp.correct -m=$j;
  done
done

#check correctness
for i in ${DEST}; do
  if `diff $i $i.correct >/dev/null`; then
    rm $i;
    echo File $i passed ...;
  else
    echo File $i failed ...;
    echo `pwd`/$i >>$LOG;
  fi
done
