/* pep_arc.cpp */
/* Ez a file tartalmazza a blokk tipus pep_bl.h fileban daklaralt muveleteinek
 implementaciojat */

#include "pep_arc.h"
#include "pep_def.h"
#include <math.h>

typedef enum { num, crd, box, drc, phch} tstate;

void InitArc( ptarc Arc, arctypes AT, int AW, pticoord AWP)
 {
  int X, Y;

  Arc->ArcType = AT;
  Arc->Weight = AW;
  Arc->Invis = 0;
  GetICoord(AWP, &X, &Y);
  SetICoord(&(Arc->WeightCoord), X, Y);
  Arc->BezFlag = FALSE;
  Arc->Valid = FALSE;
 }


tphase ProcLineArc(ptarc Arc, tline Line)
 {
   short CountLine; // Az aktualis sorbol mar elolvasott karakterek szama
   short CountChar ;  //Az eppen olvasott lex. egys. hossza
   tstate ActState; // Az aktualis lexikai egys. tipusa
   string ActString; // Az eppen olvasott lex. egyseg tarolasara
   char ActCommand; // Az aktualis opcio karaktere
   char ActChar;     //Az aktualis karakter
   string TempX, TempY; // A koordinatak karaktereinek ideiglenes tarolasara
   string TempS, TempE; // A kezdo es veg pontok azonositoinak ideiglenes tarolasara
   short Cnt, LenX; 	     //Szamlalo, X coordinata hossza


   ActCommand = 's'; //Kezdoertek az aktualis opcionak, Start box azonosito
   CountLine = 0;
   CountChar = 0;
   ActChar = Line[CountLine++];
   ActString[CountChar++] = ActChar;
   while (ActChar != '\n')
    {
     switch (ActChar)
      {
       case '\t':
       case ' ' :
		 ActChar = Line[CountLine++];
		 ActString[CountChar++] = ActChar;
		 break;

       case '-' :ActState = crd;             // Ha '-'-al kezdodik a lex. egys.
		 while (ActChar != '@')	    // akkor koordinatanak kell lennie
		  {
		   ActChar = Line[CountLine++];
		   ActString[CountChar++] = ActChar;
		  }
		 ActChar = Line[CountLine++];
		 ActString[CountChar++] = ActChar;
		 if (ActChar == '-')
		  {                        // Ha a masodik koordinata negativ
		   ActChar = Line[CountLine++];
		   ActString[CountChar++] = ActChar;
		   while (isdigit(ActChar))
		    {
		     ActChar = Line[CountLine++];
		     ActString[CountChar++] = ActChar;
		    }
		  }
		 else
		  {
		 //  ActChar = Line[CountLine++];
		 //  ActString[CountChar++] = ActChar;
		   while (isdigit(ActChar))
		    {
		     ActChar = Line[CountLine++];
		     ActString[CountChar++] = ActChar;
		    }
		  }
		 break;

       case '0':
       case '1':
       case '2':
       case '3':       // Szamot olvas
       case '4':
       case '5':
       case '6':
       case '7':
       case '8':
       case '9':
		 Arc->Valid = TRUE;
		 ActState = num;
		 while (isdigit(ActChar))
		  {
		   ActChar = Line[CountLine++];
		   ActString[CountChar++] = ActChar;
		  }
		 if (ActChar == '@')
		  {			// Koordinatat olvas
		   ActState = crd;
		   ActChar = Line[CountLine++];
		   ActString[CountChar++] = ActChar;
		   if (ActChar == '-')
		    {                        // Ha a masodik koordinata negativ
		     ActChar = Line[CountLine++];
		     ActString[CountChar++] = ActChar;
		     while (isdigit(ActChar))
		      {
		       ActChar = Line[CountLine++];
		       ActString[CountChar++] = ActChar;
		      }
		    }
		   else
		    {                      // Ha a masodik koordinata pozitiv
		     while (isdigit(ActChar))
		      {
		       ActChar = Line[CountLine++];
		       ActString[CountChar++] = ActChar;
		      }
		    }
		  }
		 if ((ActChar == '>') || (ActChar == '<'))
		  {                     // Az iv kezdo es vegpontjat  olvassa
		   ActState = box;
		   ActChar = Line[CountLine++];
		   ActString[CountChar++] = ActChar;
		   while (isdigit(ActChar))
		    {
		     ActChar = Line[CountLine++];
		     ActString[CountChar++] = ActChar;
		    }
		  }
		 break;

       case 'w':
       case 'n':
       case 'v':
       case 'J':
		 ActState = drc;
		 ActChar = Line[CountLine++];
		 ActString[CountChar++] = ActChar;
		 break;

       case 'T':
		  ActState = phch;
		  ActChar = Line[CountLine++];      // Itt olvas P-t vagy X-t
		  ActString[CountChar++] = ActChar;
		  ActChar = Line[CountLine++];      // Itt olvas elore
		  ActString[CountChar++] = ActChar;
		  break;

       case 'P':  ActState = phch;
		  ActChar = Line[CountLine++];      // Itt olvas P-t vagy T-t
		  ActString[CountChar++] = ActChar;
		  ActChar = Line[CountLine++];      // Itt olvas P-t T-t vagy whitespace-t
		  ActString[CountChar++] = ActChar;
		  ActChar = Line[CountLine++];      // Eloreolvas
		  ActString[CountChar++] = ActChar;
		  break;

       case '%': ActChar = '\n'; //Ami a % utan van az erdektelen
		 break;

       default :  // nem csinal semmit, mert feltettuk, hogy helyes az input
		 break;
     }   // end switch

    ActString[CountChar-1] = '\0'; //Lezarja az aktualis stringet

      switch (ActState)
       {		// A lex. egys tipustol fuggoen csinal vele valamit

	 case num:  if (ActCommand == 'w') // a szamot, az aktualis 
					   //vezerlo karaktertol fuugoen beirja
		     Arc->Weight =  atoi(ActString);  // a suly
		    if (ActCommand == 'v')     //vagy  
		     Arc->Invis = atoi(ActString);   // a lathatatlansag mezobe
		    break;

	 case crd:  Cnt = 0;           // Ha koordinata az aktualis lex. egys.
		    while (ActString[Cnt] != '@')
		     {                 // TempX-be masolja az elso koordinatat
		      TempX[Cnt] = ActString[Cnt];
		      Cnt++;
		     }
		    TempX[Cnt] = '\0';       // Lezarja TempX-t
		    LenX = Cnt+1;
		    Cnt++;
		    while ( ActString[Cnt] != '\0')
		     {
		      TempY[Cnt-LenX] = ActString[Cnt];
		      Cnt++;
		     }
		    TempY[Cnt-LenX] = '\0'; //Lezarja TempY-t
		    if (ActCommand == 'J')
		     {
		      SetICoord(&(Arc->BezCoord), atoi(TempX), atoi(TempY));
		      Arc->BezFlag = TRUE;
		     }
		    if (ActCommand == 'n')
		     SetICoord(&(Arc->WeightCoord), atoi(TempX), atoi(TempY));
		    break;

	 case box:
		    Cnt = 0;          // Ha doboz az aktualis lex. egys.
		    while ((ActString[Cnt] != '<') && (ActString[Cnt] != '>'))
		     {                // TempS-be masolja a kezdo pontot
		      TempS[Cnt] = ActString[Cnt];
		      Cnt++;
		     }
		    TempS[Cnt] = '\0';       // Lezarja TempS-t
		    LenX = Cnt+1;
		    Cnt++;
		    while ( ActString[Cnt] != '\0')
		     {
		      TempE[Cnt-LenX] = ActString[Cnt];
		      Cnt++;
		     }
		    TempE[Cnt-LenX] = '\0'; //Lezarja TempE-t
		    Arc->StartID = atoi(TempS);
		    Arc->EndID = atoi(TempE);
		    break;

	 case drc:
		    ActCommand = ActString[0];
		    break;

	 case phch: if (!strncmp(ActString, "TP", 2))
		      return (PhTP);
		    if (!strncmp(ActString, "PTP", 3)) //Ezt kell elobb vizsgalni,
		       return (PhPTP);		       //kulonben PT-t ad vissza helyette
		    if (!strncmp(ActString, "PT", 2))
		      return (PhPT);
		    if (!strncmp(ActString, "PPT", 3))
		       return (PhPPT);
		    if (!strncmp(ActString, "TX", 2))
		      return (PhTX);
		    break;
       }

      CountChar = 0;
      ActString[CountChar++] = ActChar; // Az aktualis string elejere irja
				// az utoljara olvasott karaktert,
				//ami mar nem tartozik az elozo lex elemhez
				// (ez a ciklus invarians)
    }  // end while

    switch (Arc->ArcType)
     {                         // Ha nem tortent fazisvaltas,
				// akkor visszaadja az aktualis box
				//tipusanak megfelelo erteket
      case TP: return (PhTP);
      case PT: return (PhPT);
      case PTP: return (PhPTP);
      case PPT: return (PhPPT);
     }
 }


 void MaxArcCoord(ptarc Arc, int *MaxX, int *MaxY)
  {
   if (Arc->BezFlag)
    GetICoord(&(Arc->BezCoord), MaxX, MaxY);
  }


 void ConvertArc(ptarc Arc, int MaxY, ptlist SList, ptlist EList, ptlist BList)
  {
   int XS, YS, XE, YE, XB, YB, XW, YW;
   double ArcXS, ArcYS, ArcXE, ArcYE ,ArcXT, ArcYT,
			Dist1, Dist2, alpha;
   ticoord Coord;
   boxlist Blocks;
   int NoBlock;
   int SBlock, EBlock;
   short i;


   if ((GetElemForBid(SList, Arc->StartID)) || (GetElemForBid(EList, Arc->EndID)))
    {                          // Ha az iv kezdo vagy vegpontja letiltott,
			      // akkor az iv lathatatlan
      Arc->Invis = 5;
      return;
    }

   if (GetElemInvis(SList, Arc->StartID))
		// Ha az iv kezdopontja nem latszik
    {           // megkeresi azt a blokkot, amihez tartozik
		//es ami latszik is.
      NoBlock = GetElemBList(SList, Arc->StartID, Blocks);
      for (i=0; i<NoBlock; i++)
       {
	if (!GetElemInvis(BList, Blocks[i]))
	 {
	  GetElemCoord(BList, Blocks[i], &Coord);
	  SBlock = Blocks[i];
	 }
       }
	       // Ha az iv blokkbol fog indulni, atallitja a tipusat
      switch (Arc->ArcType)
       {
	 case PT:
		  Arc->ArcType = BT;
		  break;
	 case TP:
	 case PTP:
		  Arc->ArcType = BP;
		  break;
	 case PPT:
		  Arc->ArcType = BPT;
		  break;
       }
    }
   else
    {
     GetElemCoord(SList, Arc->StartID, &Coord);
    }

   GetICoord(&Coord, &XS, &YS);   	//Kiindulo box koordinatai

   if (GetElemInvis(EList, Arc->EndID))
    {                        // Ha az iv vegpontja nem latszik ld. kezdopont
     NoBlock = GetElemBList(EList, Arc->EndID, Blocks);
      for (i=0; i<NoBlock; i++)
       {
	if (!GetElemInvis(BList, Blocks[i]))
	 {
	  GetElemCoord(BList, Blocks[i], &Coord);
	  EBlock = Blocks[i];
	 }
       }

		  // Atalitja az iv tipusat
      switch (Arc->ArcType)
       {
	 case PT:
		  Arc->ArcType = PB;
		  break;
	 case TP:
		  Arc->ArcType = TB;
		  break;
	 case PTP:
		  Arc->ArcType = PTB;
		  break;
	 case PPT:
		  Arc->ArcType = PB;
		  break;
	 case BT:
	 case BP:
	 case BPT:
		  Arc->ArcType = BB;
		  break;

       }
    }
   else
    {
     GetElemCoord(EList, Arc->EndID, &Coord);
    }

   if ((EBlock == SBlock) && (Arc->ArcType == BB))
    {            // ha az iv egy blokkon belul van;
     Arc->Invis = 5;
     return;
    }

   GetICoord(&Coord, &XE, &YE);        // Cel box koordinatai

   if (Arc->BezFlag)                   // A Bezier pont koordinatai
    GetICoord(&(Arc->BezCoord), &XB, &YB);

   if ((Arc->Weight) > 1)           // A suly koordinatai
    GetICoord(&(Arc->WeightCoord), &XW, &YW);

	      // Az iv kezdopontjanak szamitasa
   switch (Arc->ArcType)
    {
     case TP:
     case PTP:
     case TB:              // negyzetbol indul
     case PTB:

	     if (Arc->BezFlag)
	      {              // ha van Bezier pont adva
	       if ((XB != XS) && (YB != YS))
		{
		 alpha = min((double)TRANSSIZE/(double)abs(XB-XS)/2,
							(double)TRANSSIZE/(double)abs(YB-YS)/2);
		 ArcXS = XS+alpha*(XB-XS);
		 ArcYS = YS+alpha*(YB-YS);
		}
	       else
		{
		 if (XB == XS)
		  {
		   ArcXS = XS;
		   ArcYS = YS+(YB-YS)/abs(YB-YS)*TRANSSIZE/2;
		  }
		 else
		  {
		   ArcYS = YS;
		   ArcXS = XS+(XB-XS)/abs(XB-XS)*TRANSSIZE/2;
		  }
		}
	      }
	     else
	      {               // ha nincs Bezier pont adva
			 if ((XE != XS) && (YE != YS))
		{
		 alpha = min((double)TRANSSIZE/(double)abs(XE-XS)/2, (double)TRANSSIZE/(double)abs(YE-YS)/2);
		 ArcXS = XS+alpha*(XE-XS);
		 ArcYS = YS+alpha*(YE-YS);
		}
	       else
		{
		 if (XE == XS)
		  {
		   ArcXS = XS;
		   ArcYS = YS+(YE-YS)/abs(YE-YS)*TRANSSIZE/2;
		  }
		 else
		  {
		   ArcYS = YS;
		   ArcXS = XS+(XE-XS)/abs(XE-XS)*TRANSSIZE/2;
		  }
		}
	      }

		  break;
	  case PT:
	  case PPT:
	  case PB:      // ha  korbol
		       if (Arc->BezFlag)
			{              // ha van Bezier pont adva
			 if (XS != XB)
			   alpha = atan2(YB-YS, XS-XB);
			 else
			   alpha = (YS-YB)/abs(YS-YB)*PI/2;


			 ArcXT = XS+PLACESIZE/2*cos(alpha+PI);
			 ArcYT = YS-PLACESIZE/2*sin(alpha+PI);
			 ArcXS = XS+PLACESIZE/2*cos(alpha);
			 ArcYS = YS-PLACESIZE/2*sin(alpha);


			 Dist1 =  (ArcYS-YB)*(ArcYS-YB);
			 Dist1 += (ArcXS-XB)*(ArcXS-XB);
			 Dist2 =  (ArcYT-YB)*(ArcYT-YB);
			 Dist2 += (ArcXT-XB)*(ArcXT-XB);

			 if ( Dist1 > Dist2 )
			  {
			   ArcXS = ArcXT;
			   ArcYS = ArcYT;
			  }
			}
		       else
			{               // ha nincs Bezier pont adva
			 if (XE != XS)
			  alpha = atan2(YE-YS, XS-XE);
			 else
			  alpha = (YS-YE)/abs(YE-YS)*PI/2;


			 ArcXT = XS+PLACESIZE/2*cos(alpha+PI);
			 ArcYT = YS-PLACESIZE/2*sin(alpha+PI);
			 ArcXS = XS+PLACESIZE/2*cos(alpha);
			 ArcYS = YS-PLACESIZE/2*sin(alpha);


			 Dist1 = (ArcYS-YE)*(ArcYS-YE);
			 Dist1 += (ArcXS-XE)*(ArcXS-XE);
			 Dist2 = (ArcYT-YE)*(ArcYT-YE);
			 Dist2 += (ArcXT-XE)*(ArcXT-XE);

			 if ( Dist1 > Dist2 )
			  {
			   ArcXS = ArcXT;
			   ArcYS = ArcYT;
			  }
			}

		  break;

	  case BP:
	  case BT:
	  case BPT:    // ha blokk-bol indula
	  case BB:
		  if (Arc->BezFlag)
		   {              // ha van Bezier pont adva
		    if ((XB != XS) && (YB != YS))
		     {
		      alpha = min((double)BLOCKSIZE/(double)abs(XB-XS)/2,
							(double)BLOCKSIZE/(double)abs(YB-YS)/2);
		      ArcXS = XS+alpha*(XB-XS);
		      ArcYS = YS+alpha*(YB-YS);
		     }
		    else
		     {
		      if (XB == XS)
		       {
			ArcXS = XS;
			ArcYS = YS+(YB-YS)/abs(YB-YS)*BLOCKSIZE/2;
		       }
		      else
		       {
			ArcYS = YS;
			ArcXS = XS+(XB-XS)/abs(XB-XS)*BLOCKSIZE/2;
		       }
		     }
		   }
		  else
		   {               // ha nincs Bezier pont adva
		    if ((XE != XS) && (YE != YS))
		     {
		      alpha = min((double)BLOCKSIZE/(double)abs(XE-XS)/2,
				(double)BLOCKSIZE/(double)abs(YE-YS)/2);
		      ArcXS = XS+alpha*(XE-XS);
		      ArcYS = YS+alpha*(YE-YS);
		     }
		    else
		     {
		      if (XE == XS)
		       {
			ArcXS = XS;
			ArcYS = YS+(YE-YS)/abs(YE-YS)*BLOCKSIZE/2;
		       }
		      else
		       {
			ArcYS = YS;
			ArcXS = XS+(XE-XS)/abs(XE-XS)*BLOCKSIZE/2;
		       }
		     }
		   }
		  break;

	 }

		// Iv vegpontjanak meghatarozasa
   switch (Arc->ArcType)
    {
     case TP:
     case PTP: //ha korben vegzodik
     case BP:
	     if (Arc->BezFlag)
	      {              // ha van Bezier pont adva
	       if (XE != XB)
		alpha = atan2(YB-YE, XE-XB);
	       else
		alpha = (YE-YB)/abs(YE-YB)*PI/2;

	       ArcXT = XE+PLACESIZE/2*cos(alpha+PI);
	       ArcYT = YE-PLACESIZE/2*sin(alpha+PI);
	       ArcXE = XE+PLACESIZE/2*cos(alpha);
	       ArcYE = YE-PLACESIZE/2*sin(alpha);

	       Dist1 = (ArcYE-YB)*(ArcYE-YB);
	       Dist1 +=(ArcXE-XB)*(ArcXE-XB);
	       Dist2 = (ArcYT-YB)*(ArcYT-YB);
	       Dist2 +=(ArcXT-XB)*(ArcXT-XB);

	       if (Dist1 > Dist2)
		{
		  ArcXE = ArcXT;
		  ArcYE = ArcYT;
		}
	      }
	     else
	      {               // ha nincs Bezier pont adva
	       if (XE != XS)
		alpha = atan2(YS-YE, XE-XS);
	       else
		alpha = (YE-YS)/abs(YE-YS)*PI/2;

	       ArcXT = XE+PLACESIZE/2*cos(alpha+PI);
	       ArcYT = YE-PLACESIZE/2*sin(alpha+PI);
	       ArcXE = XE+PLACESIZE/2*cos(alpha);
	       ArcYE = YE-PLACESIZE/2*sin(alpha);


	       Dist1 = (ArcYE-YS)*(ArcYE-YS);
	       Dist1 +=(ArcXE-ArcXS)*(ArcXE-ArcXS);
	       Dist2 = (ArcYT-YS)*(ArcYT-YS);
	       Dist2 +=(ArcXT-ArcXS)*(ArcXT-ArcXS);

	       if (Dist1 > Dist2)
		{
		  ArcXE = ArcXT;
		  ArcYE = ArcYT;
		}
	      }
	   break;

      case PT:
      case PPT:    // ha negyzetben vegzodik
      case BT:
      case BPT:
		    if (Arc->BezFlag)
		     {              // ha van Bezier pont adva
		       if ((XB != XE) && (YB != YE))
			{
			 alpha = min((double)TRANSSIZE/(double)abs(XB-XE)/2,
				(double)TRANSSIZE/(double)abs(YB-YE)/2);
			 ArcXE = XE+alpha*(XB-XE);
			 ArcYE = YE+alpha*(YB-YE);
			}
		       else
			{
			 if (XB == XE)
			  {
			   ArcXE = XE;
			   ArcYE = YE+(YB-YE)/abs(YB-YE)*TRANSSIZE/2;
			  }
			 else
			  {
			   ArcYE = YE;
			   ArcXE = XE+(XB-XE)/abs(XB-XE)*TRANSSIZE/2;
			  }
			}
		     }
		    else
		     {               // ha nincs Bezier pont adva
		      if ((XE != XS) && (YE != YS))
		       {
			alpha = min((double)TRANSSIZE/(double)abs(XE-XS)/2,
				(double)TRANSSIZE/(double)abs(YE-YS)/2);
			ArcXE = XE+alpha*(XS-XE);
			ArcYE = YE+alpha*(YS-YE);
		       }
		      else
		       {
			if (XE == XS)
			 {
			  ArcXE = XE;
			  ArcYE = YE+(YS-YE)/abs(YE-YS)*TRANSSIZE/2;
			 }
			else
			 {
			  ArcYE = YE;
			  ArcXE = XE+(XS-XE)/abs(XE-XS)*TRANSSIZE/2;
			 }
		       }
		     }
		break;

      case PB:
      case TB:       // ha blokkban vegzodik
      case PTB:
      case BB:
		    if (Arc->BezFlag)
		     {              // ha van Bezier pont adva
		       if ((XB != XE) && (YB != YE))
			{
			 alpha = min((double)BLOCKSIZE/(double)abs(XB-XE)/2,
				(double)BLOCKSIZE/(double)abs(YB-YE)/2);
			 ArcXE = XE+alpha*(XB-XE);
			 ArcYE = YE+alpha*(YB-YE);
			}
		       else
			{
			 if (XB == XE)
			  {
			   ArcXE = XE;
			   ArcYE = YE+(YB-YE)/abs(YB-YE)*BLOCKSIZE/2;
			  }
			 else
			  {
			   ArcYE = YE;
			   ArcXE = XE+(XB-XE)/abs(XB-XE)*BLOCKSIZE/2;
			  }
			}
		     }
		    else
		     {               // ha nincs Bezier pont adva
		      if ((XE != XS) && (YE != YS))
		       {
			alpha = min((double)BLOCKSIZE/(double)abs(XE-XS)/2,
				(double)BLOCKSIZE/(double)abs(YE-YS)/2);
			ArcXE = XE+alpha*(XS-XE);
			ArcYE = YE+alpha*(YS-YE);
		       }
		      else
		       {
			if (XE == XS)
			 {
			  ArcXE = XE;
			  ArcYE = YE+(YS-YE)/abs(YE-YS)*BLOCKSIZE/2;
			 }
			else
			 {
			  ArcYE = YE;
			  ArcXE = XE+(XS-XE)/abs(XE-XS)*BLOCKSIZE/2;
			 }
		       }
		     }
	       break;
    }

   SetFCoord(&(Arc->StartPos), ArcXS, MaxY-ArcYS);
   SetFCoord(&(Arc->EndPos), ArcXE, MaxY-ArcYE);
   SetFCoord(&(Arc->BezPos), XB, MaxY-YB);
   if (Arc->BezFlag)
    SetFCoord(&(Arc->WeightPos), XW+XB, MaxY-(YW+YB));
   else
    SetFCoord(&(Arc->WeightPos), XW+(XE+XS)/2, MaxY-(YW+(YE+YS)/2));

  }

 void DrawArc(ptarc Arc, FILE *OutF, fontind FontInd, boolean Bezier, boolean InvisIn)
  {
    const double Slopes[] = {0.0,0.25,0.33,0.5,0.67,0.75,1.0,
			     1.33, 1.5, 2.0, 3.0, 4.0, 100.0};
    double XS, YS, XE, YE, XB, YB, XW, YW,
		NoBG, NoBG1, NoBG2, SlopeRatio, DSlopeX, DSlopeY, Length;
    int SlopeX, SlopeY;
    short i = -1;

    if (Arc->Invis == 5)
     {
      return;
     }

    if ((Arc->Invis == 4) &&  (!InvisIn))
     {
      return;
     }

    if (Arc->Weight > 1)
      {                       // Ha adott a sulya az ivnek
       GetFCoord(&(Arc->WeightPos), &XW, &YW);
       fprintf(OutF,"\\%s\n", FontSizes[FontInd[1]]);
       fprintf(OutF, "\\put(%f, %f){%d}\n", XW, YW, Arc->Weight);
      }

    GetFCoord(&(Arc->StartPos), &XS, &YS);
    GetFCoord(&(Arc->EndPos), &XE, &YE);

    if (Arc->BezFlag)		// Ha adott a Bezier gorbe harmadik pontja,
				//lekerdezi,
     GetFCoord(&(Arc->BezPos), &XB, &YB);
    else
     {                           //kulonben kiszamol egy pontot a ket vegpont
											//altal adott szakaszon
      XB = (XS+XE)/2;
      YB = (YS+YE)/2;
     }

	  NoBG1 = (XB-XS)*(XB-XS);
	  NoBG1 +=(YB-YS)*(YB-YS);
	  NoBG1 = sqrt(NoBG1);   // A kezdopont es Bezier pont kozotti tavolsag
	  NoBG2 = (XB-XE)*(XB-XE);
	  NoBG2 += (YE-YB)*(YE-YB);
	  NoBG2 = sqrt(NoBG2);   // A Bezier pont es a vegpont kozotti tavolsag
	  NoBG = NoBG1+NoBG2;	//Bezier gorbe pontjainak szama

     if (Arc->BezFlag)   // ha bezier gorbe
      if (Bezier)  // es bezier gorbekent is kell kirajzolni
       fprintf(OutF,"\\bezier{%d}(%6.2f,%6.2f)(%6.2f,%6.2f)(%6.2f,%6.2f)\n",
					(int)NoBG, XS, YS, XB, YB, XE, YE);
      else
       {          // kulonben negy szakaszbol rajzolja meg
	 fprintf(OutF,"\\emline{%6.2f}{%6.2f}{1}{%6.2f}{%6.2f}{2}",
			XS, YS, (3*XS+XB)/4, (3*YS+YB)/4);
	 fprintf(OutF,"\\emline{%6.2f}{%6.2f}{1}{%6.2f}{%6.2f}{2}",
			(3*XS+XB)/4, (3*YS+YB)/4,(XS+2*XB+XE)/4, (YS+2*YB+YE)/4);
	 fprintf(OutF,"\\emline{%6.2f}{%6.2f}{1}{%6.2f}{%6.2f}{2}",
			(XS+2*XB+XE)/4, (YS+2*YB+YE)/4 , (XB+3*XE)/4, (YB+3*YE)/4);
	 fprintf(OutF,"\\emline{%6.2f}{%6.2f}{1}{%6.2f}{%6.2f}{2}",
			(XB+3*XE)/4, (YB+3*YE)/4, XE, YE);
       }
     else
      {		// ha egyenes
	fprintf(OutF,"\\emline{%6.2f}{%6.2f}{1}{%6.2f}{%6.2f}{2}",
					 XS, YS, XE, YE);
      }

		       // Meredekseget szamol a nyilak kirajzolasahoz
     SlopeX = (XE-XB);
     SlopeY = (YE-YB);

     if (SlopeX == 0)
      {
       SlopeY = SlopeY/abs(SlopeY);
       fprintf(OutF, "\\put(%6.2f, %6.2f){\\vector(%d, %d){1}}\n",
					XE, YE-SlopeY, SlopeX, SlopeY);
       return;
      }

     if (SlopeY == 0)
      {
       SlopeX = SlopeX/abs(SlopeX);
       fprintf(OutF, "\\put(%6.2f, %6.2f){\\vector(%d, %d){1}}\n",
					XE-SlopeX, YE, SlopeX, SlopeY);
       return;
      }

     DSlopeX = (double)SlopeX;
     DSlopeY = (double)SlopeY;

     SlopeRatio = fabs(DSlopeX/DSlopeY);

     while((Slopes[++i] < SlopeRatio) && (i<12));  //Keresi, a legkisebb abrazolhato
				  //meredekseget, ami mar nagyobb a kivantnal
     if ((SlopeRatio-Slopes[i-1]) < (Slopes[i]-SlopeRatio))
      {
       SlopeRatio = Slopes[i-1];
       i--;
      }
     else                             //Azt a meredekseget valasztja,
      {                              //amelyik kozelebb van az eredetihez
       SlopeRatio = Slopes[i];
      }

      switch (i)
       {
	case 0: SlopeX = 0;                    // fuggoleges
		SlopeY = SlopeY/abs(SlopeY);
		Length = 1;
		 break;

	case 1: SlopeX = SlopeX/abs(SlopeX);   // 1:4
		SlopeY = 4*SlopeY/abs(SlopeY);
		Length = sqrt(SlopeX*SlopeX+SlopeY*SlopeY);
		 break;

	case 2: SlopeX = SlopeX/abs(SlopeX);   // 1:3
		SlopeY = 3*SlopeY/abs(SlopeY);
		Length = sqrt(SlopeX*SlopeX+SlopeY*SlopeY);
		 break;

	case 3: SlopeX = SlopeX/abs(SlopeX);   // 1:2
		SlopeY = 2*SlopeY/abs(SlopeY);
		Length = sqrt(SlopeX*SlopeX+SlopeY*SlopeY);
		 break;

	case 4: SlopeX = 2*SlopeX/abs(SlopeX);   // 2:3
		SlopeY = 3*SlopeY/abs(SlopeY);
		Length = sqrt(SlopeX*SlopeX+SlopeY*SlopeY);
		 break;

	case 5: SlopeX = 3*SlopeX/abs(SlopeX);   // 3:4
		SlopeY = 4*SlopeY/abs(SlopeY);
		Length = sqrt(SlopeX*SlopeX+SlopeY*SlopeY);
		 break;

	case 6: SlopeX = SlopeX/abs(SlopeX);   // 1:1
		SlopeY = SlopeY/abs(SlopeY);
		Length = sqrt(SlopeX*SlopeX+SlopeY*SlopeY);
		 break;

	case 7: SlopeX = 4*SlopeX/abs(SlopeX);   // 4:3
		SlopeY = 3*SlopeY/abs(SlopeY);
		Length = sqrt(SlopeX*SlopeX+SlopeY*SlopeY);
		 break;

	case 8: SlopeX = 3*SlopeX/abs(SlopeX);   // 3:2
		SlopeY = 2*SlopeY/abs(SlopeY);
		Length = sqrt(SlopeX*SlopeX+SlopeY*SlopeY);
		 break;

	case 9: SlopeX = 2*SlopeX/abs(SlopeX);   // 2:1
		SlopeY = SlopeY/abs(SlopeY);
		Length = sqrt(SlopeX*SlopeX+SlopeY*SlopeY);
		 break;

	case 10: SlopeX = 3*SlopeX/abs(SlopeX);   // 3:1
		 SlopeY = SlopeY/abs(SlopeY);
		 Length = sqrt(SlopeX*SlopeX+SlopeY*SlopeY);
		 break;

	case 11: SlopeX = 4*SlopeX/abs(SlopeX);   // 4:1
		 SlopeY = SlopeY/abs(SlopeY);
		 Length = sqrt(SlopeX*SlopeX+SlopeY*SlopeY);
		 break;

	case 12: SlopeX = 1;                     //vizszintes
		 SlopeY = SlopeY/abs(SlopeY);
		 Length = 1;
		 break;
       }

     fprintf(OutF, "\\put(%6.2f, %6.2f){\\vector(%d, %d){1}}\n",
		     XE-2*SlopeX/Length, YE-2*SlopeY/Length, SlopeX, SlopeY);



  }

 boolean IsValidArc(ptarc Arc)
  {
   return Arc->Valid;
  }
