/* pep_arc.h */
/* Ez a file tartalmazza az arc tipus strukturajat es
muveleteit */

#include <stdio.h>
#include "pep_def.h"
#include "pep_cons.h"
#include "pep_list.h"

typedef enum {TP, PT, PTP, PPT, BP, PB, BT, TB, PTB, BPT , BB} arctypes;
				// Iv tipusok

typedef struct {
		// A PEP-tool filebol beolvasott adatok tarolasara
		arctypes ArcType;
		int StartID, EndID;
		ticoord WeightCoord, BezCoord;
		int Weight, Invis;
		boolean BezFlag; //Tarolja hogy van-e harmadik pont adva az ivhez
		boolean Valid; // Ervenyes-e az iv

		// A Latex fileba valo kiirashoz hasznalt adatok tarolasara
		tfcoord StartPos; //Kezdo pont
		tfcoord EndPos; // Vegpont
		tfcoord WeightPos; // Suly helye
		tfcoord BezPos; // Bezier gorbe harmadik pontjanak helye
	      } tarc, *ptarc;

void InitArc(ptarc Arc, arctypes AT, int AW, pticoord AWP);
	/* Ivek inicializalasa tipussal es alapertelmezett adatokkal*/

tphase ProcLineArc(ptarc Arc, tline Line);
	/* Pep filebol olvasott sor adatainak tarolasa egy Arc strukturaban
		Visszateresi erteke a Arc struktura ArcType ertekenek
		megfelelo, vagy a Line-ban jelzett uj fazis */

void MaxArcCoord(ptarc Arc, int *MaxX, int *MaxY);
	/* Kiszamitja a Line-ban adott elemek maximalis coordinatait */

void ConvertArc(ptarc Arc, int MaxY, ptlist SList, ptlist EList, ptlist BList);
	/* Kiszamitja a PEP-bol kapott adatok es a meretekre, orientaciora
	vonatkozo egyeb informaciok alapjan a Latex koordinatakat */

void DrawArc(ptarc Arc, FILE *OutF, fontind FontInd, boolean Bezier, boolean InvisIn);
	/* Kiirja a Latex file-ba az utasitasokat */

boolean IsValidArc(ptarc Arc);
	 /* Megadja, hogy ervenyes-e az iv */

