/* pep_bl.cpp */
/* Ez a file tartalmazza a blokk tipus pep_bl.h fileban daklaralt muveleteinek
 implementaciojat */

#include "pep_def.h"
#include "pep_bl.h"

typedef enum { num, str, crd, drc, phch, whitespace} tstate; // Lexikalis egysegek fajtai

void InitBox( ptbox Box, boxtypes BT, pticoord NC, pticoord MC, int Count)
 {
  int X, Y;

  Box->BoxType = BT;
  Box->BoxID = Count;
  GetICoord(NC, &X, &Y);
  SetICoord(&(Box->NameCoord), X, Y);
  GetICoord(MC, &X, &Y);
  SetICoord(&(Box->MeanCoord), X, Y);
  strcpy(Box->BoxName , "");
  strcpy(Box->BoxMean,  "");
  Box->Token = 0;
  Box->NoBL = 0;
  Box->NoTL = 0;
  Box->Entry = FALSE;
  Box->Exit = FALSE;
  Box->Synchron = FALSE;
  if (BT == BL)
	Box->Invis = TRUE;
  else
	Box->Invis = FALSE;
  Box->Forbid = FALSE;
  Box->Expl = TRUE;
  Box->Valid = FALSE;
 }


tphase ProcLineBox(ptbox Box, tline Line)
 {
	short CountLine; // Az aktualis sorbol mar elolvasott karakterek szama
	short CountChar ;  //Az eppen olvasott lex. egys. hossza
	tstate ActState; // Az aktualis lexikai egys. tipusa
	string ActString; // Az eppen olvasott lex. egyseg tarolasara
	char ActCommand; // Az aktualis opcio karaktere
	char ActChar;     //Az aktualis karakter
	string TempX, TempY, Numb; // A koordinatak karaktereinek ideiglenes tarolasara
	short Cnt, LenX, CntList, CntListElem;  //Szamlalo, X coordinata hossza,
					// lista-karakter szamlalo
					// lista elem szamlalo


	ActCommand = 's'; //Kezdoertek az aktualis opcionak, ID felismeresere
	CountLine = 0;
	CountChar = 0;
	ActChar = Line[CountLine++];
	ActString[CountChar++] = ActChar;
	while (ActChar != '\n')
	 {
	  switch (ActChar)
		{
		 case '\t':
		 case ' ' :             //whitespace-k atolvasasa
		 ActState = whitespace;
		 ActChar = Line[CountLine++];
		 ActString[CountChar++] = ActChar;
		 break;

		 case '-' :ActState = crd;             // Ha '-'-al kezdodik a lex. egys.,
		 while (ActChar != '@')	    // akkor koordinatanak kell lennie
		  {
			ActChar = Line[CountLine++];
			ActString[CountChar++] = ActChar;
		  }
		 ActChar = Line[CountLine++];
		 ActString[CountChar++] = ActChar;
		 if (ActChar == '-')
		  {                        // Ha a masodik koordinata negativ
			ActChar = Line[CountLine++];
		   ActString[CountChar++] = ActChar;
			while (isdigit(ActChar))
			 {
			  ActChar = Line[CountLine++];
			  ActString[CountChar++] = ActChar;
		    }
		  }
		 else
		  {			// Ha a masodik koordinata pozitiv
		   while (isdigit(ActChar))
			 {
			  ActChar = Line[CountLine++];
		     ActString[CountChar++] = ActChar;
			 }
		  }
		 break;

       case '0':
       case '1':
		 case '2':
		 case '3':       // Szamot olvas
       case '4':
		 case '5':
       case '6':
		 case '7':
		 case '8':
		 case '9':
		 ActState = num;
		 while (isdigit(ActChar))
		  {
		   ActChar = Line[CountLine++];
			ActString[CountChar++] = ActChar;
		  }
		 if (ActChar == '@')
		  {
		   ActState = crd;
		   ActChar = Line[CountLine++];
			ActString[CountChar++] = ActChar;
			if (ActChar == '-')
		    {                        // Ha a masodik koordinata negativ
			  ActChar = Line[CountLine++];
		     ActString[CountChar++] = ActChar;
		     while (isdigit(ActChar))
				{
				 ActChar = Line[CountLine++];
				 ActString[CountChar++] = ActChar;
				}
		    }
		   else
			 {			// Ha a masodik koordinata pozitiv
			  while (isdigit(ActChar))
		      {
				 ActChar = Line[CountLine++];
		       ActString[CountChar++] = ActChar;
		      }
			 }
		  }
		 break;

       case '"':                   // Szoveget olvas
		 ActState = str;
		 ActChar = Line[CountLine++];
		 CountChar--;  //Csokkenti CountChar-t, hogy a stringnyito '"'
				// ne keruljon be a tarolt stringbe
		 switch (ActChar)
		  {              // Ha specialis karakterek vannak a
			case '$':     // szovegben, elejuk szur egy '\'-t
			case '&':
			case '%':
			case '#':
			case '_':
			case '{':
			case '}':
			case '\\':
				  ActString[CountChar++] = '\\';
				  break;
		  }
		 ActString[CountChar++] = ActChar;
		 while ( ActChar != '"')
		  {
			ActChar = Line[CountLine++];
			switch (ActChar)
			 {              // Ha specialis karakterek vannak a
			  case '$':     // szovegben, elejuk szur egy '\'-t
			  case '&':
			  case '%':
			  case '#':
			  case '_':
			  case '{':
			  case '}':
			  case '\\':
				  ActString[CountChar++] = '\\';
				  break;
			 }
			ActString[CountChar++] = ActChar;
		  }
		 ActChar = Line[CountLine++];
		 ActString[CountChar++] = ActChar;
		 break;

		 case 'a':
		 case 'n':
		 case 'b':
		 case 'R':
		 case 'u':       // Vezerlo karaktert olvas
		 case 'M':
		 case 'm':
		 case 'k':
		 case 'S':
		 case 'e':
		 case 'x':
		 ActState = drc;
		 ActChar = Line[CountLine++];
		 ActString[CountChar++] = ActChar;
		 break;

		 case 'P':
		 ActState = drc;
		 ActChar = Line[CountLine++];
		 ActString[CountChar++] = ActChar;
		 if (ActChar == 'L')
		  ActState = phch;
		 if (ActChar == 'T')
		  {
			ActState = phch;
			ActChar = Line[CountLine++];      // Itt kell R-t olvasni
			ActString[CountChar++] = ActChar;
		  }
		 if (ActChar != '"')
		  {              // ha a P utan szoveg jon, akkor nem kell
				// elore olvasni
			ActChar = Line[CountLine++];      // Eloreolvas
			ActString[CountChar++] = ActChar;
		  }
		 break;

		 case 'T':
		 ActState = phch;
		 ActChar = Line[CountLine++];      // Itt olvas P-t vagy R-t
		 ActString[CountChar++] = ActChar;
		 ActChar = Line[CountLine++];      //Eloreolvas
		 ActString[CountChar++] = ActChar;
		 break;

		 case '%': ActChar = '\n'; //Ami a % utan van az erdektelen
		 break;

		 default :  // nem csinal semmit, mert feltettuk, hogy helyes az input
		 break;
		} // end switch

		ActString[CountChar-1] = '\0'; //Lezarja az aktualis stringet

		switch (ActState)
		 {			// A lex. egys fajtajatoltol fuggoen csinal vele
					//valamit

	 case num:  if (ActCommand == 's')	// a szamot beirja
			  Box->BoxID =  atoi(ActString);  // az azonosito
			 else                                //vagy
			  Box->Token = atoi(ActString);   // a tokenszam mezobe
			 break;

	 case crd:
			 Box->Valid = TRUE;         // Ha mar olvasott egy koordinatat,
							// akkor ervenyes a box
			 Cnt = 0;            // Ha koordinata az aktualis lex. egys.
			 while (ActString[Cnt] != '@')
			  {                  // TempX-be masolja az elso koordinatat
				TempX[Cnt] = ActString[Cnt];
				Cnt++;
			  }
			 TempX[Cnt] = '\0';       // Lezarja TempX-t
			 LenX = Cnt+1;
			 Cnt++;
			 while ( ActString[Cnt] != '\0')
			  {
				TempY[Cnt-LenX] = ActString[Cnt];
				Cnt++;
			  }
			 TempY[Cnt-LenX] = '\0'; //Lezarja TempY-t
			 if (ActCommand == 's')
			  SetICoord(&(Box->BoxCoord), atoi(TempX), atoi(TempY));
			 if (ActCommand == 'n')
			  SetICoord(&(Box->NameCoord), atoi(TempX), atoi(TempY));
			 if (ActCommand == 'a')
			  SetICoord(&(Box->MeanCoord), atoi(TempX), atoi(TempY));
			 break;

	 case str:
			 ActString[strlen(ActString)-1] = '\0'; //Lezarja a stringet a '"' helyen
			 if (ActCommand == 's')
				strcpy(Box->BoxName, ActString);
			 if (ActCommand == 'b')
				strcpy(Box->BoxMean, ActString);
			 if ((ActCommand == 'u') || (ActCommand == 'P'))
			  {  // Block- vagy transition listat olvasott
				CntListElem = 0;  // A lista elemeinek szamlaloja
				CntList = 1;     // A lista karaktereinek szamlaloja
					// Egyrol indul, mert a kezdo karaktert
					// '('-t atlepi
				while ( ActString[CntList] != '\0')
				 {
			 Cnt = 0;   // A Numb aktualis pozicioja
			 // amig vesszot nem talal, Numb-ba masolja a sztringet
			 while ((ActString[CntList] != ',') && (ActString[CntList] != ')'))
			  {
				Numb[Cnt] = ActString[CntList];
				Cnt++;
				CntList++;
			  }
			 Numb[Cnt] = '\0';  // Numb lezarasa
			 if (ActCommand == 'u')   // Numb ertekenek beirasa
						// a block-listaba
				Box->BlockList[CntListElem] = atoi(Numb);
			 else                   // a transition-listaba
				Box->TransList[CntListElem] = atoi(Numb);

			 CntList++; // Atolvassa a ','-t
			 CntListElem++;
				 }
				if (ActCommand == 'u')
				 Box->NoBL = CntListElem;
				else
				 Box->NoTL = CntListElem;

			  }
			 break;

	 case drc:
			 ActCommand = ActString[0];
			 if (ActCommand == 'e')
			  {                      // Ha kezdo hely
				Box->Entry = TRUE;
			  }
			  if (ActCommand == 'x')
			  {                      // Ha vegso hely
				Box->Exit = TRUE;
			  }
			 if (ActCommand == 'S')
			  {                      // Ha szinkronizacios trans.
				Box->Synchron = TRUE;
			  }
			 break;


	 case phch: if (!strncmp(ActString, "PL", 2))
				return (PhPL);
			 if (!strncmp(ActString, "PTR", 3))
				return (PhPTR);
			 if (!strncmp(ActString, "TP", 2))
				return (PhTP);
			 if (!strncmp(ActString, "TR", 2))
				return (PhTR);
			 break;
		 }

		 CountChar = 0;
		 ActString[CountChar++] = ActChar; // Az aktualis string elejere irja
				// az utoljara olvasott karaktert,
				//ami mar nem tartozik az elozo lex elemhez
				// (ez a ciklus invarians)

	 } // end while

	 switch (Box->BoxType)
	  {                         // Ha nem tortent fazisvaltas,
				// akkor visszaadja az aktualis box
				//tipusanak megfelelo erteket
		case BL: return (PhBL);
		case PL: return (PhPL);
		case TR: return (PhTR);
		case PTR: return (PhPTR);
	  }
 }



 void DrawBox(ptbox Box, FILE *OutF, fontind FontInd, boolean DrawName, boolean DrawMean)
  {
	 double X, Y;
	 short i;

	if (Box->Invis)
	 {          // Ha lathatatlan a box
	  return;
	 }

	GetFCoord(&(Box->BoxPos), &X, &Y); // Lekerdezi a ref. pont koordinatait
	switch (Box->BoxType)
	 {
	  case BL:
			fprintf(OutF, "\\put( %6.2f, %6.2f){\\oval(%6.2f, %6.2f)}\n",
					X,Y,Box->Width, Box->Height);
			break;

	  case PL:
			if (!(Box->Exit))
			 fprintf(OutF, "\\put( %6.2f, %6.2f){\\circle{%6.2f}}\n",
					 X, Y, Box->Width);
					 //Width tartalmazza az atmerot
			else
			  fprintf(OutF, "\\put( %6.2f, %6.2f){\\circle*{%6.2f}}\n",
					 X, Y, Box->Width);

			if (Box->Entry)
			 {
				fprintf(OutF, "\\emline{%6.2f}{%6.2f}{1}{%6.2f}{%6.2f}{2}\n",
					 X-Box->Width*0.707/2, Y+Box->Width*0.707/2,
					 X+Box->Width*0.707/2, Y-Box->Width*0.707/2);
				fprintf(OutF, "\\emline{%6.2f}{%6.2f}{1}{%6.2f}{%6.2f}{2}\n",
					 X+Box->Width*0.707/2, Y+Box->Width*0.707/2,
					 X-Box->Width*0.707/2, Y-Box->Width*0.707/2);
			 }

			if (Box->Token <= MAXTOKEN)
			 for (i=0; i<Box->Token; i++)
		{
		 GetFCoord(&((Box->MarkPos)[i]), &X, &Y);
		 fprintf(OutF, "\\put(%6.2f, %6.2f){\\circle*{%d}}\n",
							X, Y, TOKENSIZE);
		}
			else
			 {
		GetFCoord(&(Box->BoxPos), &X, &Y);
					 fprintf(OutF, "\\put(%6.2f, %6.2f){#%d}\n", X, Y, Box->Token);
			 }
			 break;

	  case TR:

			X -= Box->Width/2;   // Mert a framebox referenciapontja
			Y -= Box->Height/2;   // nem a kozepe, hanem a bal also sarka
			if (Box->Synchron)
			 {
			  fprintf(OutF,
				  "\\put( %6.2f, %6.2f){\\rule{%6.0f\\unitlength}{%6.0f\\unitlength} {}}\n",
					  X,Y,Box->Width, Box->Height);
			 }
			else
			 {
			  fprintf(OutF, "\\put( %6.2f, %6.2f){\\framebox(%6.2f, %6.2f) {}}\n",
					  X,Y,Box->Width, Box->Height);
			 }
			break;

	  case PTR:
			X -= Box->Width/2;   // Mert a framebox referenciapontja
			Y -= Box->Height/2;   // nem a kozepe, hanem a bal also sarka
			fprintf(OutF, "\\put( %6.2f, %6.2f){\\dashbox{%6.2f}(%6.2f, %6.2f) {}}\n",
					  X,Y, Box->Width/10, Box->Width, Box->Height);
			break;

	 }
	 if (DrawName)
	  {          // ha ki kell irni a box-ok nevet
		GetFCoord(&(Box->NamePos), &X, &Y); //Lekerdezi a nev koordinatait
		fprintf(OutF,"\\%s\n",FontSizes[FontInd[1]]);
		fprintf(OutF,"\\bf\n");
		fprintf(OutF,"\\put( %6.2f, %6.2f) { %s}\n", X, Y, Box->BoxName);
	  }

	 if ((strlen(Box->BoxMean)) && DrawMean)
	  {                    // Ha nem ures a "jelentes" mezo es ki kell irni a jelentest
		 GetFCoord(&(Box->MeanPos), &X, &Y); //Lekerdezi a jelentes koordinatait
		 fprintf(OutF,"\\%s\n\\tt\n", FontSizes[FontInd[0]]);
		 fprintf(OutF,"\\put( %6.2f, %6.2f) { %s}\n", X, Y, Box->BoxMean);
	  }

  }

 void MaxBoxCoord(ptbox Box, int *MaxX, int *MaxY)
  {
   int ActMaxX, ActMaxY, NX, NY, RefX, RefY, MX, MY;

   GetICoord(&(Box->BoxCoord), &RefX, &RefY); // A box kozepenek koordinatai

   GetICoord(&(Box->NameCoord), &NX, &NY);
   NX += RefX+strlen(Box->BoxName)*NAMEWIDTH;
   NY += RefY+NAMEHEIGHT;                  // A boxnev jobb also sarka

   GetICoord(&(Box->MeanCoord), &MX, &MY);
   MX += RefX+strlen(Box->BoxMean)*MEANWIDTH;
   MY += RefY+MEANHEIGHT;                  // A boxjelentes jobb also sarka

   switch (Box->BoxType)
    {                                    // A box jobb also sarka
     case BL:
	     RefX += BLOCKSIZE/2;
		  RefY += BLOCKSIZE/2;
	     break;

     case PL:
	      RefX += PLACESIZE/2;
	      RefY += PLACESIZE/2;
	      break;
     case TR:
     case PTR:
	      RefX += TRANSSIZE/2;
	      RefY += TRANSSIZE/2;
	      break;
    }
					 // Maximumkereses
    ActMaxX = max(RefX, NX);
    ActMaxY = max(RefY, NY);

    ActMaxX = max(ActMaxX, MX);
    ActMaxY = max(ActMaxY, MY);

	 *MaxX = ActMaxX;
	 *MaxY = ActMaxY;

  }


 void StoreBoxToList(ptbox Box, ptlist List)
  {
	int X,Y;
	ticoord Crd;

	GetICoord(&(Box->BoxCoord), &X, &Y);
	SetICoord(&Crd, X, Y);
	InsertList(List, Box->BoxID, &Crd, Box->BlockList, Box->TransList,
		Box->NoBL, Box->NoTL, Box->Invis, Box->Synchron, Box->Forbid, Box->Expl);
  }

 void StoreBoxToTree(ptbox Box, blocktree BlTree)
  {
	InsertBlockTree(BlTree, Box->BoxID, Box->BlockList, Box->NoBL);
  }

 void ConvertBox(ptbox Box, ptlist BList, int MaxY)
  {
   int AbsX, AbsY, RelX, RelY, TokX, TokY;
   short i;

   GetICoord(&(Box->BoxCoord), &AbsX, &AbsY);   // Box koordinatak konvertalasa
   SetFCoord(&(Box->BoxPos), AbsX, MaxY-AbsY);

   if (strlen(Box->BoxName))
    {			// ha van neve a boxnak
	  GetICoord(&(Box->NameCoord), &RelX, &RelY);
					// Boxnev koordinatak konvertalasa
					// A boxnev helye a box helyehez
					// viszonyitott relativ koordinatakkal
					// adott
     SetFCoord(&(Box->NamePos), AbsX+RelX, MaxY-(AbsY+RelY+NAMEHEIGHT));
    }

   if (strlen(Box->BoxMean))
    {			// ha van jelentese a boxnak
     GetICoord(&(Box->MeanCoord), &RelX, &RelY);  // Boxjelentes koordinatak konvertalasa
     SetFCoord(&(Box->MeanPos), AbsX+RelX, MaxY-(AbsY+RelY+MEANHEIGHT));
					// szinten relativ koordinatak
	 }

   switch (Box->BoxType)       // a box magassag es szelesseg megadasa
    {
     case BL:
	     Box->Width = BLOCKSIZE;
	     Box->Height = BLOCKSIZE;
	     break;
	  case PL:
	     Box->Width = PLACESIZE; //ez a koratmero
			// tokenek helyenek meghatarozasa
	     switch(Box->Token)
	      {
			 case 1:          // Ha csak egy token van, akkor kozepre kerul
		      SetFCoord(&((Box->MarkPos)[0]), AbsX, MaxY-AbsY);
		      break;
	       case 5:          // Ha ot token van
		      SetFCoord(&((Box->MarkPos)[4]), AbsX, MaxY-AbsY);

	       case 4:         // Ha negy token van
		      TokX = AbsX;
		      TokY = AbsY+PLACESIZE/2-TOKENSIZE/2;
		      SetFCoord(&((Box->MarkPos)[3]), TokX, MaxY-TokY);
	       case 3:         // Ha harom token van
		      TokX = AbsX;
		      TokY = AbsY-PLACESIZE/2+TOKENSIZE/2;
				SetFCoord(&((Box->MarkPos)[2]), TokX, MaxY-TokY);
	       case 2:              // Ha ket token van
		      TokX = AbsX-PLACESIZE/2+TOKENSIZE/2;
				TokY = AbsY;
		      SetFCoord(&((Box->MarkPos)[1]), TokX, MaxY-TokY);
		      TokX = AbsX+PLACESIZE/2-TOKENSIZE/2;
		      SetFCoord(&((Box->MarkPos)[0]), TokX, MaxY-TokY);
		      break;

	      }
	     break;
	  case TR:
     case PTR:
			Box->Width = TRANSSIZE;
	      Box->Height = TRANSSIZE;
	      break;
    }


	switch (Box->BoxType)       // ellenorzi, hogy lathato-e a box
	 {

	  case PL:                 // akkor lathatatlan, ha barmelyik blokk,
				  //	amihez tartozik, lathato
			 for (i=0; i<Box->NoBL; i++)
		{
		 Box->Invis |= !GetElemInvis(BList, (Box->BlockList)[i]);
		}

			 break;
	  case TR:
			{

			if  (Box->Forbid)
			 Box->Invis = TRUE;
			else
			 {
				if (!Box->Synchron)
				 {
				  for (i=0; i<Box->NoBL; i++)
					{
					 Box->Invis |= !GetElemInvis(BList, (Box->BlockList)[i]);
					}
				 }
				else
				 {
				  for (i=0; i<Box->NoBL; i++)
					 Box->Invis |= (GetElemInvis(BList, (Box->BlockList)[i]) &&
										  !GetElemExpl(BList,  (Box->BlockList)[i]));
				 }
			 }
			break;
			}
	  case PTR:
			if(Box->Forbid)
			 {
		Box->Invis = TRUE;
	       }
	      else
	       {
		for (i=0; i<Box->NoBL; i++)
		 {
		  Box->Invis |= !GetElemInvis(BList, (Box->BlockList)[i]);
		 }
	       }
	      break;
		 }


  }

 int GetBoxID(ptbox Box)
  {
	return Box->BoxID;
  }

 void SetBoxID(ptbox Box, int ID)
  {
   Box->BoxID = ID;
  }

 boolean IsSyncBox(ptbox Box)
  {
   return Box->Synchron;
  }

 void SetForbid(ptbox Box, boolean FB)
  {
	Box->Forbid = FB;
  }

 boolean IsForbid(ptbox Box)
  {
	return Box->Forbid;
  }

 boolean IsValidBox(ptbox Box)
  {
	return Box->Valid;
  }

 void GetBLTreeInfo(ptbox Box, blocktree BlTree)
  {
    Box->Expl = IsExplBlock(BlTree, Box->BoxID);
    Box->Invis = IsInvisBlock(BlTree, Box->BoxID);
  }
