/* pep_bl.h */
/* Ez a file tartalmazza a blokk tipus strukturajat es
muveleteinek deklaraciojat */

#include <stdio.h>
#include "pep_def.h"
#include "pep_cons.h"
#include "pep_list.h"
#include "pep_tree.h"





typedef struct {
		// A PEP-tool filebol beolvasott adatok tarolasara
		boxtypes BoxType;
		int BoxID;
		ticoord BoxCoord, NameCoord, MeanCoord;
		string BoxName, BoxMean;
		int Token;
		boxlist BlockList, TransList; // Block-ok es transition-ok
						// listaja, amelyekhez a box tartozik
		int NoBL, NoTL; // Taroljak, hogy hany elem van
				//BlockListben es TransList-ben
		boolean Entry, Exit; // Jelzi, hogy a hely kezdo, vagy vegso
		boolean Synchron; // Jelzi, hogy a transition szinkronizacios-e

		//Lathatosagi parameterek
		boolean Invis; // jelzi, hogy lathatatlan-e a box
					 // (Mert a tartalmazo blokk latszik,
					 // vagy egy kibontott blokk
		boolean Forbid; // jelzi, hogy  nem kell mutatni a box-ot
				// (Szinkronizacios tr, vagy fantom tr.)
		boolean Expl; // Jelzi, hogy egy block kibontott-e
		boolean Valid; // Jelzi, hogy ervenyes-e a box
				// Nem ervenyes, ha megjegyzest, vagy
				// uj faziskezdetet olvasott

		// A Latex fileba valo kiirashoz hasznalt adatok tarolasara
		tfcoord BoxPos; //Referencia pont koordinatai
		float Width, Height; //Box meretei
		tfcoord NamePos; // Nev helye
		tfcoord MeanPos; // Jelentes helye
		tfcoord MarkPos[MAXTOKEN]; //Token(ek) helye
			} tbox, *ptbox;

void InitBox( ptbox Box, boxtypes BT, pticoord NC, pticoord MC, int Count);
	/* Blokk, allapot(atmenet) inicializalasa tipussal es alapertelmezett
		adatokkal*/

tphase ProcLineBox( ptbox Box, tline Line);
	/* Pep filebol olvasott sor adatainak tarolasa egy Box strukturaban.
		Visszateresi erteke a Box struktura BoxType ertekenek
		megfelelo, vagy a Line-ban jelzett uj fazis */

void MaxBoxCoord(ptbox Box, int *MaxX, int *MaxY);
	/* Kiszamitja a Line-ban adott elemek maximalis koordinatait */

void ConvertBox(ptbox Box, ptlist BList, int MaxY);
	/* Kiszamitja a PEP-bol kapott adatok es a meretekre, orientaciora
	vonatkozo egyeb informaciok alapjan a Latex koordinatakat */

void DrawBox(ptbox Box, FILE *OutF, fontind FontInd, boolean DrawName, boolean DrawMean);
	/* Kiirja a Latex file-ba az utasitasokat */

void StoreBoxToList(ptbox Box, ptlist List);
	/* A Box koordinatait elmenti a List lancolt lista vegere */

void StoreBoxToTree(ptbox Box, blocktree BlTree);
	/* Blokkok eltarolasa egy vektorban */

int GetBoxID(ptbox Box);
	/* Visszaadja a Box azonositojat */

void SetBoxID(ptbox Box, int ID);
	/* Beallitja a Box azonositojat ID-re */

boolean IsSyncBox(ptbox Box);
	/*Megadja, hogy szinkronizacios trans. -e a box */

void SetForbid(ptbox Box, boolean FB);
	/*Beallitja a Box ForBid mezojet FB-re */

boolean IsForbid(ptbox Box);
	/*Megadja, hogy a box letiltott-e*/

boolean IsExplBox(ptbox Box);
	/* Megadja, hogy kibontott-e a blokk*/

boolean IsValidBox(ptbox Box);
	/* Megadja, hogy ervenyes-e a box (uj adat van-e benne) */

void GetBLTreeInfo(ptbox Box, blocktree BlTree);
	/*A blokk-fabol az lathatosagi es kibontottsagi informaciokat
	 atmasolja a Box-ba */

