/* pep_list.cpp */
/* Ez a file tartalmazza a pep_list tipus pep_list.h-ban deklaralt
 muveleteinek implementaciojat */

 #include "pep_list.h"

 ptlist InitList()
  {
	ptlist PList;

	if ((PList = (ptlist )malloc(sizeof(tlist))) == NULL )
	 {
	  printf("Not enough memory\n");
	  exit(4);
	 }
	PList->ListHead = NULL;
	PList->ListTail = NULL;

	return PList;
  }


  void InsertList(ptlist List, int BoxID, pticoord Crd, boxlist BLlist,
		boxlist TLlist, int NoBlock, int NoTrans, boolean Invis,
		boolean Sync, boolean Forbid, boolean Expl)
	{
	 ptelem PElem, PLast;
	 int X,Y, i;

	 if ((PElem = (ptelem )malloc(sizeof(telem))) == NULL )
	  {
		printf("Nincs eleg memoria\n");
		exit(4);
	  }

	 GetICoord(Crd, &X, &Y); // Lekerdezi a Crd elemeit

	 PElem->ID = BoxID; // Erteket ad az uj elem mezoinek
	 SetICoord(&(PElem->Coord), X, Y);
	 PElem->NoBL = NoBlock;
	 PElem->NoTL = NoTrans;
	 for (i=0; i<NoBlock; i++)
	  {
		PElem->BList[i] = BLlist[i];
	  }
	 for (i=0; i<NoTrans; i++)
	  {
		PElem->TList[i] = TLlist[i];
	  }
	 PElem->Invis = Invis;
	 PElem->IsSyn = Sync;
	 PElem->IsForbid = Forbid;
	 PElem->IsExpl = Expl;
	 PElem->Ptr = NULL; //Az uj elem a lista vegere kerult, igy NULL-ra mutat

	 if (List->ListHead == NULL)
	  {                        //Ha ures volt a lista
		List->ListHead = PElem;
		List->ListTail = PElem;
	  }
	 else
	  {
		 PLast = List->ListTail;     // A jelenlegi utolso elem
		 PLast->Ptr = PElem;         // mutatojat atallitja az uj elemre
		 List->ListTail = PElem;     // A listavege mutatot is atallitja
					// az uj elemre
	  }
	}

 boxtypes GetElemType(ptlist List, int BoxID)
  {
	ptelem PElem;

	PElem = List->ListHead;
	while (PElem->ID != BoxID)  // Keresi a BoxID azonositoju elemet
	 PElem = (ptelem)PElem->Ptr;

	return (PElem-> BoxType);
  }

 void GetElemCoord(ptlist List, int BoxID, pticoord Crd)
  {
	ptelem PElem;
	int X,Y;

	PElem = List->ListHead;
	while (PElem->ID != BoxID)  // Keresi a BoxID azonositoju elemet
	 PElem = (ptelem)PElem->Ptr;

	GetICoord(&(PElem->Coord), &X, &Y); // Atadja a BoxID azonositoju
	SetICoord(Crd, X, Y);           // elem koordinatait Crd-nek

  }

 int GetElemBList(ptlist List, int BoxID, boxlist BLlist)
  {
	ptelem PElem;
	short i;

	PElem = List->ListHead;
	while (PElem->ID != BoxID)  // Keresi a BoxID azonositoju elemet
	 PElem = (ptelem)PElem->Ptr;

	for (i=0; i<PElem->NoBL; i++)
	 {
	  BLlist[i] = (PElem->BList)[i];
	 }
	return PElem->NoBL;
  }

 int GetElemTList(ptlist List, int BoxID, boxlist TLlist)
  {
	ptelem PElem;
	short i;

	PElem = List->ListHead;
	while (PElem->ID != BoxID)  // Keresi a BoxID azonositoju elemet
	 PElem = (ptelem)PElem->Ptr;

	for (i=0; i<PElem->NoTL; i++)
	 {
	  TLlist[i] = (PElem->TList)[i];
	 }
	return PElem->NoTL;
  }

 boolean GetElemSync(ptlist List, int BoxID)
  {
	ptelem PElem;

	PElem = List->ListHead;
	while (PElem->ID != BoxID)  // Keresi a BoxID azonositoju elemet
	 PElem = (ptelem)PElem->Ptr;

	return PElem->IsSyn;
  }

 boolean GetElemInvis(ptlist List, int BoxID)
  {
	ptelem PElem;

	PElem = List->ListHead;
	while (PElem->ID != BoxID)  // Keresi a BoxID azonositoju elemet
	 PElem = (ptelem)PElem->Ptr;

	return PElem->Invis;
  }

 boolean GetElemForBid(ptlist List, int BoxID)
  {
	ptelem PElem;

	PElem = List->ListHead;
	while (PElem->ID != BoxID)  // Keresi a BoxID azonositoju elemet
	 PElem = (ptelem)PElem->Ptr;

	return PElem->IsForbid;
  }

boolean GetElemExpl(ptlist List, int BoxID)
  {
	ptelem PElem;

	PElem = List->ListHead;
	while (PElem->ID != BoxID)  // Keresi a BoxID azonositoju elemet
	 PElem = (ptelem)PElem->Ptr;

	return PElem->IsExpl;
  }

void DestroyList(ptlist *List)
  {
	ptelem PElemAct, PElemNext;

	if (*List)
	 {
	  PElemAct = (*List)->ListHead;
	  while (PElemAct->Ptr != NULL)
		{
		 PElemNext = (ptelem)PElemAct->Ptr;
		 free(PElemAct);
		 PElemAct = PElemNext;
		}

	  free(*List);
	  *List = NULL;
	}
  }