/* pep_list.h */
/* Ez a File tartalmazza a pep2tex programhoz hasznalt lancolt
 lista tipus strukturajat es muveleteinek deklaraciojat */

 #include <stdlib.h>
 #include "pep_def.h"

#ifndef PEP_LIST
 #define PEP_LIST

 typedef struct {
		 boxtypes BoxType;      // box tipusa
		 int ID;
		 ticoord Coord;         // box koordinatak
		 boxlist BList, TList;  // block-ok, ill. trans-ok,
					// amelyekhez a box tartozik
		 int NoBL, NoTL;        // Blist ill. TList elemeinek szama
		 boolean Invis, IsSyn, IsForbid, IsExpl;
					 // lathatatlansag, szinkronitas, letiltott
		 void *Ptr;             // a lista kovetkezo elemere mutato
					// pointer
		}  telem, *ptelem;      // A lista alapeleme

 typedef struct {
		 telem *ListHead, *ListTail;
		}  tlist, *ptlist;       // A lista fejeleme


 ptlist InitList(); // Inicializalja a listat
 void InsertList( ptlist List, int BoxID, pticoord Crd, boxlist BLlist,
		boxlist TLlist, int NoBlock, int NoTrans, boolean Invis,
		boolean Sync, boolean Forbid, boolean Expl); //Beszur egy elemet a lista vegere							 //BoxID azonositoval
					 // Crd koordinatakkal , stb...

 boxtypes GetElemType(ptlist List, int BoxID); // visszaadja az elem tipusat

 void GetElemCoord(ptlist List, int BoxID, pticoord Crd);  //Visszaadja a BoxID
						      //azonositoju elem
						      //koordinatait Crd-ben

 int GetElemBList(ptlist List, int BoxID, boxlist BLlist); //Megadja a BoxID
			//azonositoju elem block-listajat
			// visszateresi erteke a lista elemszama

 int GetElemTList(ptlist List, int BoxID, boxlist TLlist); //Megadja a BoxID
			 //azonositoju elem trans. listajat
			 // visszateresi erteke a lista elemszama

 boolean GetElemSync(ptlist List, int BoxID); //Megadja, hogy a BoxID
						      //azonositoju elem
						      // szinkronizacios tr. -e
 boolean GetElemInvis(ptlist List, int BoxID); //Megadja, hogy a BoxID
					       //azonositoju elem
					       // lathatalan-e
 boolean GetElemForBid(ptlist List, int BoxID); // Megadja, hogy a BoxID
						//azonositoju elem
							// letiltott-e

 boolean GetElemExpl(ptlist List, int BoxID);  // Megadja, hogy a BoxID
						//azonositoju elem
							// kibontott-e

 void DestroyList(ptlist *List);
						// Felszabaditja a lista altal elfoglalt memoriat;
#endif
