/* Ez a file tartalmazza a blokk struktura tarolasahoz szukseges
blocktree tipus szerkezetet es muveleteinek deklaraciojat */

#include <stdio.h>
// #include <conio.h>
#include "pep_cons.h"
#include "pep_def.h"

#ifndef PEP_TREE
 #define  PEP_TREE

typedef struct  {
			int ChID;
		   void *ChPtr;
		  } child;  // a leszarmazottak azonositojat
				 // es a rajuk mutato pointert tartalmazo szerekzet


typedef struct  {
		   int ID;   // csucs azonositoja
		   int AncID;   // az os azonositoja
			child Children[MAXCHILD];  // a leszarmazottak vektora
			int NoCh;      // a leszarmazottak szama
			boolean Expl;   // jelzi, hogy kibontott-e a block
			boolean Invis; // jelzi, hogy lathato-e a block
			boolean Valid;  // jelzi, hogy a csucs kibontottsaga
					//  meg lett-e mar hatarozva
			int X, Y; // a megjeleniteshez hasznalt koordinatak
			int BlockLevel, BlockPos;
		 } tbltree_elem, *ptbltree_elem;
		  // a fa egy csucsa

typedef ptbltree_elem blocktree[MAXBLOCK];   // a blokk-fat tartalmazo vektor

void InitBlockTree(blocktree BlTree);   // A blokk-fat tartalmazo vektor inicializalasa

void InsertBlockTree(blocktree BlTree, int ID, boxlist ChList, int NoBL);  // Uj csucs elhelyezese a blokk-fa vektorban

void FindRelatives(blocktree BlTree);  // Felepiti az os/leszarmazott kapcsolatokat
					// a blokk-faban

void AskExplBl(blocktree BlTree); // A felhasznalo kivansaga szerint beallitja, hogy
				// mely blokkok legyenek kibontottak

void ExplNoBl(blocktree BlTree); // Nem bont ki egy blokkot sem

void ModBlock(blocktree BlTree, int ID); // Modositja /az ID azonositoju
													// blokk kibontottsagat

void CalcBlockCoords(blocktree BlTree, int *Width, int *Height, int *No);
			// Kiszamitja a blokkok megjelenitesehez szukseges
			// koordinatakat, visszaadja a maximalis mereteket,
			// blokkok szamat

boolean IsExplBlock(blocktree BlTree, int ID); // visszaadja, hogy az ID
					// azonositoju blokk kibontott-e

boolean IsInvisBlock(blocktree BlTree, int ID); // visszaadja, hogy az ID
					// azonositoju blokk lathato-e

ptbltree_elem GetBlock(blocktree BlTree, int ID);
				// Megkeresi a blokk-faban az ID
				// azonositoju csucsot

int GetBlockNo(blocktree BlTree);
				 // Megadja, hany blokk van BlTree-ben

void GetBlockInfoByNum(blocktree BlTree, int Num, int *ID, int *X, int *Y,
						boolean *Expl);
				  // Num sorszamu blokkrol ad informaciokat

void GetBlockInfoByID(blocktree BlTree, int ID, int *X, int *Y,
						boolean *Expl);
				  // Az ID azonositoju blokkrol ad informaciot		

int GetBlockRelations(blocktree BlTree, int *Relations);
				// Megadja BlTree blokkjai kozti kapcsolatokat
				// visszateresi erteke a relaciok szama

void DestroyBlockTree(blocktree BlTree);
#endif
