/* pep_text.cpp */
/* Ez a file tartalmazza ttext tipus pep_text.h-ban
deklaralt muveleteinek implementaciojat */

#include "pep_tx.h"
#include "pep_def.h"

typedef enum { str, crd, drc } tstate; // Az lexikalis egyseg fajtai

void InitText(pttext Text)
 {
  Text->Valid = FALSE;
 }


tphase ProcLineText(pttext Text, tline Line)
 {
  short CountLine; // Az aktualis sorbol mar elolvasott karakterek szama
   short CountChar ;  //Az eppen olvasott lex. egys. hossza
   tstate ActState; // Az aktualis lexikai egys. tipusa
   char ActString[MAXLINE-10]; // Az eppen olvasott lex. egyseg tarolasara
   char ActChar;     //Az aktualis karakter
   string TempX, TempY; // A koordinatak karaktereinek ideiglenes tarolasara
   short Cnt, LenX; 	     //Szamlalo, X coordinata hossza

   CountLine = 0;
   CountChar = 0;
   ActChar = Line[CountLine++];
   ActString[CountChar++] = ActChar;
   while (ActChar != '\n')
    {
     switch (ActChar)
      {
       case '\t':
       case ' ' :
		 ActChar = Line[CountLine++];
		 ActString[CountChar++] = ActChar;
		 break;

       case '0':
       case '1':
       case '2':
       case '3':       // Szamot olvas (negativ szamot nem
       case '4':      // olvashat, mert a szoveg abszolut
       case '5':      // koordinatakkal adott
       case '6':
       case '7':
       case '8':
       case '9': ActState = crd;
		 Text->Valid = TRUE;
		 while (isdigit(ActChar))
		  {
		   ActChar = Line[CountLine++];
		   ActString[CountChar++] = ActChar;
		  }

		   ActChar = Line[CountLine++];
		   ActString[CountChar++] = ActChar;
		   if (ActChar == '-')
		    {                        // Ha a masodik koordinata negativ
		     ActChar = Line[CountLine++];
		     ActString[CountChar++] = ActChar;
		     while (isdigit(ActChar))
		      {
		       ActChar = Line[CountLine++];
		       ActString[CountChar++] = ActChar;
		      }
		    }
		   else
		    {
		     while (isdigit(ActChar))
		      {
		       ActChar = Line[CountLine++];
		       ActString[CountChar++] = ActChar;
		      }
		    }
		 break;

       case '"':                   // Szoveget olvas
		 ActState = str;
		 ActChar = Line[CountLine++];
		 CountChar--;  //Csokkenti CountChar-t, hogy a stringnyito '"'
				// ne keruljon be a tarolt stringbe
		 ActString[CountChar++] = ActChar;
		 while ( ActChar != '"')
		  {
		   ActChar = Line[CountLine++];
		   ActString[CountChar++] = ActChar;
		  }
		 ActChar = Line[CountLine++];
		 ActString[CountChar++] = ActChar;
		 break;

       case 'N': ActState = drc;
		 ActChar = Line[CountLine++];
		 ActString[CountChar++] = ActChar;
		 break;

       case '%': ActChar = '\n'; //Ami a % utan van az erdektelen
		 break;

       default :  // nem csinal semmit, mert feltettuk, hogy helyes az input
		 break;
      }  // End switch

     ActString[CountChar-1] = '\0'; //Lezarja az aktualis stringet

     switch (ActState)
       {		// A lex. egys tipustol fuggoen csinal vele valamit
	case crd:  Cnt = 0;           // Ha koordinata az aktualis lex. egys.
		    while (ActString[Cnt] != '@')
		     {                // TempX-be masolja az elso koordinatat
		      TempX[Cnt] = ActString[Cnt];
		      Cnt++;
		     }
		    TempX[Cnt] = '\0';       // Lezarja TempX-t
		    LenX = Cnt+1;
		    Cnt++;
		    while ( ActString[Cnt] != '\0')
		     {
		      TempY[Cnt-LenX] = ActString[Cnt];
		      Cnt++;
		     }
		    TempY[Cnt-LenX] = '\0'; //Lezarja TempY-t

		    SetICoord(&(Text->TextCoord), atoi(TempX), atoi(TempY));
		    break;

	 case str:
		    ActString[strlen(ActString)-1] = '\0'; //Lezarja a stringet a '"' helyen
		    strcpy(Text->TextString, ActString);
		    break;

	 case drc:         // Semmit nem kell csinalni az 'N' vezerlo
			  // karakterrel
		    break;

       }

      CountChar = 0;
      ActString[CountChar++] = ActChar; // Az aktualis string elejere irja
				// az utoljara olvasott karaktert,
				//ami mar nem tartozik az elozo lex elemhez
				// (ez a ciklus invarians)
    } // end while

   return (PhTX);

 }

 void MaxTextCoord(pttext Text, int *MaxX, int *MaxY)
  {
   GetICoord(&(Text->TextCoord), MaxX, MaxY);
	*MaxX += strlen(Text->TextString)*TEXTWIDTH;
   *MaxY += TEXTHEIGHT;
  }

 void ConvertText(pttext Text, int MaxY)
  {
	int X, Y, Length;

	Length = strlen(Text->TextString)*TEXTWIDTH;
	GetICoord(&(Text->TextCoord), &X, &Y);
   SetFCoord(&(Text->TextPos), X-Length/2, MaxY-(Y+TEXTHEIGHT));
  }

 void DrawText(pttext Text, FILE *OutF, fontind FontInd)
  {
   double X, Y;
   GetFCoord(&(Text->TextPos), &X, &Y);
   fprintf(OutF, "\\%s\n\\sl\n", FontSizes[FontInd[2]]);
   fprintf(OutF, "\\put(%6.2f, %6.2f){%s}\n", X, Y, Text->TextString);
  }

 boolean IsValidText(pttext Text)
  {
   return Text->Valid;
  }




