/* pep_tx.h */
/* Ez a file tartalmazza a pep2tex program Text tipusanak strukturajat 
 	es muveleteit.*/

#include <stdio.h>
#include "pep_def.h"
#include "pep_cons.h"

typedef struct  {
		// A PEP-tool filebol beolvasott adatok tarolasara
		char TextString[MAXLINE-10];
		ticoord TextCoord;
                boolean Valid;

		// A Latex fileba valo kiirashoz hasznalt adatok tarolasara
		tfcoord TextPos;
	      } ttext, *pttext;

void InitText(pttext Text);
	/* A text tipus inicializalasa */

tphase ProcLineText(pttext Text, tline Line);
	/* Pep filebol olvasott sor adatait tarolja Text-ben */

void MaxTextCoord(pttext Text, int *MaxX, int *MaxY);
	/* Kiszamitja a Line-ban adott szoveg maximalis koordinatait. */

void ConvertText(pttext Text, int MaxY);
	/* Kiszamitja a PEP-bol kapott adatok es a meretekre, orientaciora
	vonatkozo egyeb informaciok alapjan a Latex koordinatakat */

void DrawText(pttext Text, FILE *OutF, fontind FontInd);
	/* Kiirja a Latex file-ba az utasitasokat */

boolean IsValidText(pttext Text);
	/*Megadja, hogy ervenyes-e a szoveg */

