package provide pep_edit 1.0

########################################
# Kommunikationsprozeduren des Editors #
########################################

# Fuegt an der aktuellen Corsorposition den String $ins
# ein.
proc insert_string {ins} {
  .tedit insert insert $ins
}


proc save_editor_contents {new_name} {
  global editor

  set editor(filename) $new_name
  Save
}

proc reload_editor_contents {new_name} {
  Open $newname
}

proc end_session {save} {
  global anim

  # Animation anhalten
  set anim 0

  if {$save == "JA"} {
    if {[.tedit edit modified]} {
      Save
      file_changed_server
    }
  }
  destroy .
}

#############################################################################
proc simulate_trans {sim_str loop_str} {
 global sim_string sim_end loop_end loop_string tmp_sim tmp_loop

 set sim_str [split $sim_str =]
 set loop_str [split $loop_str =]

 # Save nice view in tmp_* for Sequence dialog and real list
 # in *_string for further processing
 set tmp_sim [lindex $sim_str 1]
 set tmp_loop [lindex $loop_str 1]
 regsub -all {,} $tmp_sim " " sim_string
 regsub -all {,} $tmp_loop " " loop_string

 set sim_end "[expr ([llength $sim_string] - 1)]"
 set loop_end "[expr ([llength $loop_string] - 1)]"

 enter_sim_mode
}

proc read_reference_from_hl_file {name} {
  delete_reference_hl
  delete_ref_tags
  read_def_file $name
  read_pl_hl_file
  read_tr_hl_file
}

proc read_reference_from_ll_file {name} {
  delete_reference_ll
  delete_ref_tags 
  read_def_file $name
  read_pl_ll_file
  read_tr_ll_file
}

proc read_reference_from_pfa_file {name} {
  delete_reference_pfa
  delete_ref_tags
  read_def_file $name
  read_ar_pfa_file
} ;# read_reference_from_pfa_file 

proc delete_reference { } {
 delete_reference_ll 
 delete_reference_hl
 delete_reference_pfa
}

proc delete_reference_ll { } {
 global ref_pl_ll ref_tr_ll

 if {[array exists ref_pl_ll]} {
     unset ref_pl_ll
 }
 if {[array exists ref_tr_ll]} {
     unset ref_tr_ll
 }
}

proc delete_reference_hl { } {
 global ref_pl_hl ref_tr_hl
 
 if {[array exists ref_pl_hl]} {
     unset ref_pl_hl
 }
 if {[array exists ref_tr_hl]} {
     unset ref_tr_hl
 }
}

proc delete_reference_pfa {} {
  global ref_ar_pfa

  if {[array exists ref_ar_pfa]} {
    unset ref_ar_pfa
  }
}

proc show_ref_in_bpn2 {names} {
 global ref_mode

 set at {{-hl_net 1 hl_ref} {-ll_net 1 ll_ref} {-pfa 1 pfa_ref}}
 set names [argparse $names $at]

 clear_all

 if {$hl_ref != ""} {
	if {$ref_mode != 1} {
 		enter_ref_mode
		update
	}
 	highlight_reference_from_hl [lindex $hl_ref 1]

 } elseif {$ll_ref != ""} {
	if {$ref_mode != 1} {
 		enter_ref_mode
		update
	}
 	highlight_reference_from_ll [lindex $ll_ref 1]
 } elseif {$pfa_ref != ""} {
 	if {$ref_mode != 1} {
		enter_ref_mode
		update
	}
	highlight_reference_from_pfa [lindex $pfa_ref 1]
 } else {
 	return
 }
}

