package provide pep_edit 1.0

proc Cut { } {
#
# Parameter: keine
#
# Rueckgabe: nichts
#
# Bemerkung: Wenn ein Textauschnitt markiert ist, so wird dieser
#            erst kopiert und dann geloescht.

   if {[Copy]} {
     .tedit delete sel.first sel.last
   }
}

proc Copy { } {
#
# Parameter: keine
#
# Rueckgabe: 1 - Textausschnitt wurde in das XClipboard uebernommen
#            0 - Kein Textausschnitt selektiert
#
# Bemerkung: 

global clipboard_load

  if {[.tedit tag ranges sel] != ""} {
     clipboard clear
     clipboard append [selection get]
     set clipboard_load 1
     return 1
  } else {
     tk_dialog .d { } {No Selection - Command Ignored } warning 0 {Ok}
     return 0
  }
}

proc Paste { } {
#
# Parameter: keine
#
# Rueckgabe: nichts
#
# Bemerkung: Der Inhalt des XClipboard wird an die aktuelle Cursorposition
#            gesetzt.

    .tedit insert insert [selection get -displayof .tedit -selection CLIPBOARD]
}

proc Save {} {
#
# Parameter: keine (Filename steht in globaler Variable $editor(filename))
#
# Rueckgabe: nichts
#
# Bemerkung:

    global editor cnnect def gvar

    if {$editor(filename) != "<noname>"} {

        if {$gvar(prgtype)!="sdl"} {
	  # Ausgabe der Abstrakten Positionen
	  save_mv_refs $editor(filename)
	}

	convert_text_for_save $editor(filename)
        if {$cnnect && [.tedit edit modified]} {
           file_changed_server
	   delete_ref_tags
        }
    	.tedit edit modified no
    }
}

proc Save_As {name} {
#
# Parameter: name - Name der Datei
#
# Rueckgabe: nichts
#
# Bemerkung:

    global editor cnnect

    set editor(filename) $name

    if {[file exists $editor(filename)] == 1} {
	set ok [tk_dialog .d {Warning} {File Already Exists !} warning 1\
		{Overwrite} {Cancel}]
    } else {set ok 0}

    if {$ok == 0} {
      convert_text_for_save $editor(filename)
      .file configure -text $editor(filename)
      new_filename_server $editor(filename)
      .tedit edit modified no
    }
}

proc Open {name} {
#
# Parameter: name (Name der Datei, die geladen werden soll)
#
# Rueckgabe: nichts
#
# Bemerkung: Nachdem die Datei geladen wurde, wird dem Server dies noch
#            mitgeteilt.


    global editor cnnect
    set editor(filename) $name

    .file configure -text $editor(filename)
    reload

    # dem Server den neuen Dateinamen melden
    if {$cnnect} {
        new_filename_server $editor(filename)
    }
}

proc reload { } {
#
# Parameter: keine
#
# Rueckgabe: nichts
#
# Bemerkung: Die aktuelle Datei wird ohne weiteres Nachfragen
#            erneut in den Editor geladen.

 global editor

 if {$editor(filename) != "<noname>"} {

    read_file_2_textwidget .tedit $editor(filename) end true
    #grummel grummel
    convert_loaded_text
    .tedit edit reset
    .tedit edit modified 0

    #Textscan
    scan_text
    .tedit mark set insert 1.0
    update_cursor
 }
}

proc Import {name} {
#
# Parameter: name - Name der Datei, die importiert werden soll
#
# Rueckgabe: nichts
#
# Bemerkung:

    read_file_2_textwidget .tedit $name insert
    convert_loaded_text
    scan_text
}

proc Export_Clipboard {name} {
#
# Parameter: name = Name der Datei in die der Inhalt des Clipboards
#                   gespeichert werden soll.
#
# Rueckgabe: nichts
#
# Bemerkung: Diese Prozedur wird ueber die FS_Box aufgerufen.

   echo [selection get -displayof .tedit -selection CLIPBOARD] $name
}

proc export { } {
#
# Parameter: keine
#
# Rueckgabe: nichts
#
# Bemerkung: Diese Prozedur ueberprueft, ob ein Textausschnitt ausgewaehlt
#            wurde und ruft dann die FS_Box auf.

global clipboard_load

  if {$clipboard_load} {
      FSBox Export_Clipboard "Export Clipboard" "" . save
  } else {
     tk_dialog .d { } {Nothing To Export ... } warning 0 {Ok}
  } 
}

proc save2tex {name} {
 
  global editor
 
     if {[.tedit edit modified]} {
       set ok [tk_dialog .d {Warning} {You Have Unsaved Changes} \
                warning 0 {Save Changes} {Continue} {Cancel}]
 
       if {$ok == 0} {
          Save
       }
       if {$ok == 2} {
          return
       }
     }
     catch {exec bpn2tex $editor(filename) $name}
}

