package provide pep_edit 1.0

proc main_window {} {
  global editor argc argv my_bitmaps_path gvar rc

###########
# Widgets #
###########

wm title . "PEP Editor"
#######################

frame	  .menu -relief raised -borderwidth 1
frame	  .insert -relief raised

text      .tedit -yscroll ".yscroll set" -xscroll ".xscroll set" -font\
          $editor(font) -borderwidth 1 -bd 2 -setgrid true -wrap none\
	  -undo true -autoseparators true

scrollbar .yscroll -command ".tedit yview"
scrollbar .xscroll -orient horiz -command ".tedit xview"
frame     .msgfr
message	  .file -justify left -width 900 -text $editor(filename)
message   .edited
frame     .statusfr -relief sunken
message   .wheremsg -width 100 -text "Pos:"
message   .where -width 100 -text "1.0"
entry     .cmd -textvariable cmd
message   .cmd_msg -width 200 -text "cmd:"
button 	  .insert.scan -bitmap @$my_bitmaps_path/scan -command "scan_text"
button	  .quit -text "Close Editor" -command "end_session_local"

##############
# Menuezeile #
##############

menubutton .menu.file -text "File" -menu .menu.file.m -underline 0 
menubutton .menu.edit -text "Edit" -menu .menu.edit.m -underline 0
menubutton .menu.action -text "Action" -menu .menu.action.m -underline 0
menubutton .menu.mode -text "Modes" -menu .menu.mode.m -underline 0
menubutton .menu.option -text "Option" -menu .menu.option.m -underline 0
menubutton .menu.formula_mode -text "Modes" -menu .menu.formula_mode.m -underline 0

menubutton .menu.info -text "Info" -menu .menu.info.m -underline 0

# File 
#######

menu .menu.file.m -tearoff no
.menu.file.m add command -label "Reload" -command "reload" -underline 0
.menu.file.m add separator
.menu.file.m add command -label "Save" -command "Save" \
	     -underline 0 -state disabled
.menu.file.m add separator
.menu.file.m add command -label "Import File" -command "FSBox Import"\
             -underline 0
.menu.file.m add command -label "Export Clipboard" \
             -command "export" -underline 0
.menu.file.m add separator
.menu.file.m add command -label "Quit" -command "end_session_local"\
             -underline 0

# Edit
#######

menu .menu.edit.m -tearoff no
.menu.edit.m add command -label "Cut" -command "Cut" -underline 0\
             -accelerator Control+x
.menu.edit.m add command -label "Copy" -command "Copy" -underline 1\
             -accelerator Control+c
.menu.edit.m add command -label "Paste" -command "Paste" -underline 0\
             -accelerator Control+v
.menu.edit.m add separator
.menu.edit.m add command -label "Search" -command "Search Search"\
            -underline 0
.menu.edit.m add command -label "Undo" -command "catch {.tedit edit undo}"\
            -underline 0
.menu.edit.m add command -label "Redo" -command "catch {.tedit edit redo}"
.menu.edit.m add command -label "Replace" -command "Search Replace"\
             -underline 0

# Action
#########

menu .menu.action.m -tearoff no
.menu.action.m add command -label "B(PN) Syntax Check"\
             -command "bpn2_syntax_check" -underline 0
.menu.action.m add command -label "B(PN) To TeX"\
             -command {FSBox save2tex "Export to TeX" {{Tex File} .tex} . save} \
             -underline 10

# Options
#########

menu .menu.option.m -tearoff no
.menu.option.m add check -label "Show Reference in HL" -variable rc(show_ref_in_hl)
.menu.option.m add check -label "Show Reference in LL" -variable rc(show_ref_in_ll)
.menu.option.m add check -label "Show Reference in Formula" -variable rc(show_ref_in_formula)
#.menu.option.m add check -label "Show Reference in PFA" -variable rc(show_ref_in_pfa)\
#		-state disabled
.menu.option.m add separator
.menu.option.m add check -label "Show All Values" -variable rc(show_all_values)
.menu.option.m add separator
.menu.option.m add command -label "Preferences" -underline 0\
             -command "set_preferences"
.menu.option.m add separator
.menu.option.m add command -label "Save Options" -underline 0\
             -command "save_options"

# Modes
########

menu .menu.mode.m -tearoff no
.menu.mode.m add command -label "Enter Edit Mode" -command {enter_edit_mode} -state disabled
.menu.mode.m add command -label "Enter Reference Mode" -command {enter_ref_mode}
.menu.mode.m add command -label "Enter Simulation Mode" -command {enter_sim_mode} 

menu .menu.formula_mode.m -tearoff no

# Info
#######

menu .menu.info.m -tearoff no
.menu.info.m add command -label "Info" -command "info_dialog" -underline 0

# Textmenue
############

menu .textmenu -tearoff no
.textmenu add command -label "Cut" -command "Cut"
.textmenu add command -label "Copy" -command "Copy"
.textmenu add command -label "Paste" -command "Paste"

# Toolbar
#########

frame .toolbar -relief raised -borderwidth 1

frame .toolbar.f1 -relief raised

set toolbar_new [image create photo -file [file join $my_bitmaps_path new.gif]]
button .toolbar.f1.new -image $toolbar_new -command {.tedit delete 0.1 end}

set toolbar_open [image create photo -file [file join $my_bitmaps_path open.gif]]
button .toolbar.f1.open -image $toolbar_open -command {.menu.file.m invoke 0}

set toolbar_save [image create photo -file [file join $my_bitmaps_path save.gif]]
button .toolbar.f1.save -image $toolbar_save -command {Save} -state disabled

set toolbar_cut [image create photo -file [file join $my_bitmaps_path cut.gif]]
button .toolbar.cut -image $toolbar_cut -command {Cut}

set toolbar_copy [image create photo -file [file join $my_bitmaps_path copy.gif]]
button .toolbar.copy -image $toolbar_copy -command {Copy}

set toolbar_paste [image create photo -file [file join $my_bitmaps_path paste.gif]]
button .toolbar.paste -image $toolbar_paste -command {Paste}

set toolbar_undo [image create photo -file [file join $my_bitmaps_path undo.gif]]
button .toolbar.undo -image $toolbar_undo -command {.menu.edit.m invoke Undo}

set toolbar_redo [image create photo -file [file join $my_bitmaps_path redo.gif]]
button .toolbar.redo -image $toolbar_redo -command {.menu.edit.m invoke Redo}

#add font selector here
label .toolbar.labelsize -padx 5 -text "Font size: "
entry .toolbar.size -relief sunken -width 5 -textvariable rc(editor.fontsize)

#bind .toolbar.size <Deactivate> "puts Treffer\n;font configure $editor(font) \
#	-size $rc(editor.fontsize)"
bind .toolbar.size <Return> {\
	font configure $editor(font) -size $rc(editor.fontsize);\
	font configure $editor(keywordfont) -size $rc(editor.fontsize);\
	font configure $editor(remarkfont) -size $rc(editor.fontsize);\
	}

##########
# Packer #
##########

pack .menu -side top -fill x
pack .toolbar -fill x
pack .toolbar.f1 -side left -in .toolbar -fill x
frame .toolbar.sep1 -width 3 -relief raised -borderwidth 1
pack .toolbar.sep1 -side left -in .toolbar -fill y -padx 4 -pady 2
pack .toolbar.f1.new .toolbar.f1.open .toolbar.f1.save -side left -in .toolbar.f1
pack .toolbar.cut -side left -in .toolbar 
pack .toolbar.copy .toolbar.paste -side left -in .toolbar 
frame .toolbar.sep2 -width 3 -relief raised -borderwidth 1
pack .toolbar.sep2 -side left -in .toolbar -fill y -padx 4 -pady 2
pack .toolbar.undo .toolbar.redo -side left -in .toolbar 
pack .toolbar.labelsize .toolbar.size -side left -in .toolbar 

pack .insert -fill x

pack .statusfr -side bottom -fill x
pack .msgfr -side bottom -fill x
pack .xscroll -side bottom -fill x
pack .yscroll -side right -fill y

pack .tedit -expand yes -fill both

pack .cmd_msg -side left -in .statusfr
pack .cmd -side left -in .statusfr

pack .file -side left -in .msgfr

pack .edited -side left -in .msgfr
pack .quit -side right -in .statusfr
pack .where -side right -in .msgfr
pack .wheremsg -side right -in .msgfr

#############################
# Oeffnen der Default-Datei #
#############################

if {$argc >= 1} {
    set editor(filename) [lindex $argv 0]
    if {[string first "/" $editor(filename)"] == -1} {
       set editor(filename) [file join [pwd] $editor(filename)]
    }
    .tedit delete 1.0 end
    .file configure -text $editor(filename)
    if {[file exists $editor(filename)] == 1} {
        read_file_2_textwidget .tedit $editor(filename) end
	convert_loaded_text
    }
    .tedit edit reset
    .tedit edit modified 0
}

# Initialisierung
##################

scan_text
focus .
.tedit mark set insert 1.0
update_cursor

# Initialisierung des XClipboards
clipboard append ""

######################################
# Menueeintraege der Spezialeditoren #
######################################

global hl_ref_ext ll_ref_ext pfa_ref_ext

    switch -regexp $gvar(prgtype) {

formula.normal {
    set formulatype {{Formulae file} .form}

     wm geometry . $rc(formula.normal.geometry)
    .menu.file.m insert 0 command -label "Open" -command \
           {FSBox Open "Open Formula" $formulatype} -underline 0
    .menu.file.m insert 4 command -label "Save as" -command \
           {FSBox Save_As "Save As" $formulatype . save} -underline 1

    .menu.formula_mode.m add command -label "Enter PEP Mode" \
   	-command {enter_pep_mode} -state disabled
    .menu.formula_mode.m add command -label "Enter SPIN Mode" \
   	-command {enter_spin_mode} -state active
    .menu.formula_mode.m add command -label "Enter SMV Mode" \
   	-command {enter_smv_mode} -state active

    message .insert.msg -text "PEP Mode" -relief sunken -width 200

    pack .menu.file .menu.edit .menu.formula_mode -side left
    pack .insert.msg -side right -in .insert -padx 2m

 ### Buttons ###
 # PEP mode
   button .insert.not -bitmap @$my_bitmaps_path/not -command "insert_text not"
   button .insert.and -bitmap @$my_bitmaps_path/and -command "insert_text and"
   button .insert.or -bitmap @$my_bitmaps_path/or -command "insert_text or"
   button .insert.iff -bitmap @$my_bitmaps_path/iff -command "insert_text iff"
   button .insert.implicate -bitmap @$my_bitmaps_path/implicate -command "insert_text implicate"
   button .insert.forAll -bitmap @$my_bitmaps_path/ForAll -command "insert_text ForAll"
   button .insert.exists -bitmap @$my_bitmaps_path/Exists -command "insert_text Exists"
   button .insert.true -bitmap @$my_bitmaps_path/true -command "insert_text true"
   button .insert.false -bitmap @$my_bitmaps_path/false -command "insert_text false"
   button .insert.box -bitmap @$my_bitmaps_path/Box -command "insert_text Box"
   button .insert.diamond -bitmap @$my_bitmaps_path/Diamond -command "insert_text Diamond"
 # SPIN mode
   button .insert.spin_always -bitmap @$my_bitmaps_path/spin_always\
                -command "insert_text spin_always"
   button .insert.spin_and -bitmap @$my_bitmaps_path/spin_and\
                -command "insert_text spin_and"
   button .insert.spin_dual -bitmap @$my_bitmaps_path/spin_dual\
                -command "insert_text spin_dual"
   button .insert.spin_equal -bitmap @$my_bitmaps_path/spin_equal\
                -command "insert_text spin_equal"
   button .insert.spin_eventually -bitmap @$my_bitmaps_path/spin_eventually\
                -command "insert_text spin_eventually"
   button .insert.spin_false -bitmap @$my_bitmaps_path/spin_false\
                -command "insert_text spin_false"
   button .insert.spin_implicate -bitmap @$my_bitmaps_path/spin_implicate\
                -command "insert_text spin_implicate"
   button .insert.spin_not -bitmap @$my_bitmaps_path/spin_not\
                -command "insert_text spin_not"
   button .insert.spin_or -bitmap @$my_bitmaps_path/spin_or\
                -command "insert_text spin_or"
   button .insert.spin_st_until -bitmap @$my_bitmaps_path/spin_st_until\
                -command "insert_text spin_st_until"
   button .insert.spin_true -bitmap @$my_bitmaps_path/spin_true\
                -command "insert_text spin_true"
 # SMV mode
   button .insert.smv_all -bitmap @$my_bitmaps_path/smv_all\
                -command "insert_text smv_all"
   button .insert.smv_and -bitmap @$my_bitmaps_path/smv_and\
                -command "insert_text smv_and"
   button .insert.smv_exist -bitmap @$my_bitmaps_path/smv_exist\
                -command "insert_text smv_exist"
   button .insert.smv_future -bitmap @$my_bitmaps_path/smv_future\
                -command "insert_text smv_future"
   button .insert.smv_globally -bitmap @$my_bitmaps_path/smv_globally\
                -command "insert_text smv_globally"
   button .insert.smv_iff -bitmap @$my_bitmaps_path/smv_iff\
                -command "insert_text smv_iff"
   button .insert.smv_implicate -bitmap @$my_bitmaps_path/smv_implicate\
                -command "insert_text smv_implicate"
   button .insert.smv_next -bitmap @$my_bitmaps_path/smv_next\
                -command "insert_text smv_next"
   button .insert.smv_not -bitmap @$my_bitmaps_path/smv_not\
                -command "insert_text smv_not"
   button .insert.smv_or -bitmap @$my_bitmaps_path/smv_or\
                -command "insert_text smv_or"
   button .insert.smv_until -bitmap @$my_bitmaps_path/smv_until\
                -command "insert_text smv_until"

   enter_pep_mode
    }
    
bpn2.normal {

    # Dateinamen der Referenzdateien (erstmal...)
    set hl_ref_ext ".bpn2_hl_ref"
    set ll_ref_ext ".bpn2_ll_ref"
    set pfa_ref_ext ".pfa_bpn2_ref"

    # Dann die Referenzdateien einlesen 
    read_references

    set bpn2type {{B(PN) file} .bpn2}
    wm geometry . $rc(bpn2.normal.geometry)
   .menu.file.m insert 0 command -label "Open" -command \
          "FSBox Open {Open} $bpn2type" -underline 0
   .menu.file.m insert 4 command -label "Save as" -command \
          "FSBox Save_As {Save As} $bpn2type . save" -underline 1
   .menu.edit.m add separator
   .menu.edit.m add command -label "Add Comment" -command "comment add"
   .menu.edit.m add command -label "Delete Comment" -command "comment delete"

   .textmenu add command -label "Add Comment" -command "comment add"
   .textmenu add command -label "Delete Comment" -command "comment delete"
   .textmenu add separator
   .textmenu add command -label "Shift Right" -command "shift right"
   .textmenu add command -label "Shift Left" -command "shift left"

    message .insert.msg -text "Edit Mode" -relief sunken -width 200

    button .insert.do -bitmap @$my_bitmaps_path/do\
              -command "insert_text do"
    button .insert.begin -bitmap @$my_bitmaps_path/begin\
           -command "insert_text begin"
    button .insert.var -bitmap @$my_bitmaps_path/var\
           -command "insert_text var"
    button .insert.chan -bitmap @$my_bitmaps_path/chan\
           -command "insert_text chan"
    button .insert.stack -bitmap @$my_bitmaps_path/stack\
           -command "insert_text stack"
    button .insert.bool -bitmap @$my_bitmaps_path/bool\
           -command "insert_text bool"
    button .insert.proc -bitmap @$my_bitmaps_path/proc\
           -command "insert_text proc"
    button .insert.const -bitmap @$my_bitmaps_path/const\
           -command "insert_text const"

    pack .menu.file .menu.edit .menu.action .menu.mode\
	 .menu.option -side left
    pack .insert.proc .insert.begin .insert.var .insert.bool .insert.chan\
         .insert.stack .insert.const .insert.do .insert.scan -side left -padx 1m
    pack .insert.msg -side right -in .insert -padx 1m
    }

bpn2.expand {

    # Dateinamen der Referenzdateien (erstmal...)
    set hl_ref_ext ".exp_bpn2_hl_ref"
    set ll_ref_ext ".exp_bpn2_ll_ref"
    set pfa_ref_ext ".pfa_bpn2_ref"

    # Dann die Referenzdateien einlesen 
    read_references

    set bpn2type {{Expanded B(PN) file} .bpn2_exp}
    wm geometry . $rc(bpn2.expand.geometry)
   .menu.file.m insert 0 command -label "Open" -command \
          "FSBox Open {Open} $bpn2type" -underline 0
   .menu.file.m insert 4 command -label "Save as" -command \
          "FSBox Save_As {Save As} $bpn2type . save" -underline 1
   .menu.edit.m add separator

    message .insert.msg -text "Edit Mode" -relief sunken -width 200
    button .insert.do -bitmap @$my_bitmaps_path/do\
              -command "insert_text do"
    button .insert.begin -bitmap @$my_bitmaps_path/begin\
           -command "insert_text begin"
    button .insert.var -bitmap @$my_bitmaps_path/var\
           -command "insert_text var"
    button .insert.chan -bitmap @$my_bitmaps_path/chan\
           -command "insert_text chan"
    button .insert.stack -bitmap @$my_bitmaps_path/stack\
           -command "insert_text stack"
    button .insert.bool -bitmap @$my_bitmaps_path/bool\
           -command "insert_text bool"
    button .insert.proc -bitmap @$my_bitmaps_path/proc\
           -command "insert_text proc"
    button .insert.const -bitmap @$my_bitmaps_path/const\
           -command "insert_text const"

    pack .menu.file .menu.edit .menu.action .menu.mode .menu.option  -side left

    pack .insert.proc .insert.begin .insert.var .insert.bool .insert.chan\
         .insert.stack .insert.do .insert.scan -side left -padx 2m
    pack .insert.msg -side right -padx 1m
    }

doc {
    set doctype {{Doc file} .doc}
   wm geometry . $rc(doc.geometry)
    .menu.file.m insert 0 command -label "Open" -command \
            {FSBox Open "Open Document" $doctype} -underline 0
    .menu.file.m insert 4 command -label "Save as" -command \
            {FSBox Save_As "Save As" $doctype . save} -underline 1
    pack .menu.file .menu.edit -side left}
boxexpr {
    set boxtype {{Box expression file} .box_expr}
   wm geometry . $rc(boxexpr.geometry)
    .menu.file.m insert 0 command -label "Open" -command \
            {FSBox Open "Open" $boxtype} -underline 0
    .menu.file.m insert 4 command -label "Save as" -command \
            {FSBox Save_As "Save As" $boxtype . save} -underline 1
    pack .menu.file .menu.edit -side left}
c_source {
    set ctype {{C file} .c}
    .menu.file.m insert 0 command -label "Open" -command \
            {FSBox Open "Open C-Source" $ctype} -underline 0
    .menu.file.m insert 4 command -label "Save as" -command \
            {FSBox Save_As "Save As" $ctype .save} -underline 1
    pack .menu.file .menu.edit -side left}

sdl_properties {
    menubutton .menu.sdl_file -text "File" -menu .menu.sdl_file.m -underline 0
    menu .menu.sdl_file.m -tearoff no
    .menu.sdl_file.m add command -label "Save" -command "Save" -underline 0
    pack .menu.sdl_file -side left
    }
sdl {
   wm geometry . $rc(sdl.geometry)

    # Dateiname der Referenzdatei (erstmal...)
    set hl_ref_ext ".sdl_hl_ref"
    set ll_ref_ext ".sdl_ll_ref"
    set pfa_ref_ext ".pfa_bpn2_ref"

    # Dann die Referenzdateien einlesen 
    read_references

    set sdltype {{SDL file} {.sdl .pr}}
    .menu.file.m insert 0 command -label "Open" -command \
            {FSBox Open "Open SDL" $sdltype} -underline 0
    .menu.file.m insert 4 command -label "Save as" -command \
            {FSBox Save_As "Save As" $sdltype . save} -underline 1
    .menu.file.m insert 5 command -label "Open graphical editor" -command \
            {exec wish -f [file join $env(PEPHOME) lib sdl main.tcl] &} -underline 5
    .menu.file.m insert 5 command -label "Edit SDL Properties" \
            -command {
	      open_sdl_prop_editor
	    } -underline 9
    .menu.file.m insert 5 separator

    .textmenu add command -label "Add Comment" -command "comment add"
    .textmenu add command -label "Delete Comment" -command "comment delete"
    .textmenu add separator
    .textmenu add command -label "Shift Right" -command "shift right"
    .textmenu add command -label "Shift Left" -command "shift left"
 
    message .insert.msg -text "Edit Mode" -relief sunken -width 200
 
    button .insert.block -text "Block" \
      -command "insert_text sdl_block"
    button .insert.channel -text "Channel" \
      -command "insert_text sdl_channel"
    button .insert.connect -text "Connect" \
      -command "insert_text sdl_connect"
    button .insert.type -text "Type" \
      -command "insert_text sdl_type"
    button .insert.process -text "Process" \
      -command "insert_text sdl_process"
    button .insert.procedure -text "Procedure" \
      -command "insert_text sdl_procedure"
    button .insert.decision -text "Decision" \
      -command "insert_text sdl_decision"

    pack .menu.file .menu.edit .menu.mode\
         .menu.option -side left
    pack .insert.block .insert.channel .insert.connect\
         .insert.type .insert.process .insert.procedure .insert.decision\
	 -side left
    pack .insert.msg -side right -padx 1m
    }
default {
    .menu.file.m insert 0 command -label "Open" -command \
            {FSBox Open "Open"} -underline 0
    .menu.file.m insert 4 command -label "Save as" -command \
            {FSBox Save_As "Save As" "" . save} -underline 1
     pack .menu.file .menu.edit -side left}
  }

### widgets for all kinds
 # Simulation
 button   .insert.reset -text "Reset" -command "sim_reset"
 button   .insert.next -text "Next" -command "sim_next"
 button   .insert.prev -text "Previous" -command "sim_prev"
 button   .insert.start -text "Start" -command "sim_start"
 button   .insert.sequence -text "Sequence" -command "insert_sim_sequence_dlg"
 label    .insert.act -text "" -width 8 -relief sunken
 message  .insert.loop_msg -text ""
 # References
 message  .insert.value -text "Value:" -width 80
 entry    .insert.glob_value -textvariable glob_value
 button   .insert.send -text "Send" -command "send_ref_name"
 button   .insert.clear -text "Clear" -command "clear_all"
 button   .insert.set_name -text "Set Name" -command "abstr_name_dlg" -state disabled

pack .menu.info -side right

################################
#           Bindings           #
################################

##########
# Global #
##########

bind . <Control-x> {Cut}
bind . <Control-c> {Copy}
bind . <Control-v> {Paste}
bind . <1> {update_cursor}
bind . <<Modified>> {edited [.tedit edit modified]}

###############
# Text-Widget #
###############

set_binding edit

#################
# Command-Zeile #
#################

bind .cmd <Return> {cmd_prc; .cmd configure -text ""}
bind .cmd <Escape> {set cmd ""; focus .tedit}

bindtags .tedit {Text .tedit . all}
}

##############
# Prozeduren #
##############

proc cmd_prc { } {
#
# Parameter: keine
#
# Rueckgabe: nichts
#
# Bemerkung: 

  global cmd gvar
  switch -regexp $gvar(prgtype) {
    bpn2(.)* {
      switch $cmd {
             x {Save; end_session_local;focus .tedit;return}
             w {Save; set cmd "";focus .tedit;return}
             q {end_session_local;focus .tedit;return}
             r {reload;set cmd "";focus .tedit;return}
             s {scan_text;set cmd "";focus .tedit;return}
             sy {bpn2_syntax_check ;set cmd "";focus .tedit;return}
             1 {insert_text proc ;set cmd "";focus .tedit;return}
             2 {insert_text begin ;set cmd "";focus .tedit;return}
             3 {insert_text var ;set cmd "";focus .tedit;return}
             4 {insert_text bool ;set cmd "";focus .tedit;return}
             5 {insert_text chan ;set cmd "";focus .tedit;return}
             6 {insert_text stack ;set cmd "";focus .tedit;return}
             7 {insert_text do ;set cmd "";focus .tedit;return}

      } 
      tk_dialog .d { } {Command Not Found} warning 0 {Ok}}
    [^bpn2] {
      switch $cmd {
             x {Save; end_session_local;focus .tedit;return}
             w {Save; set cmd "";focus .tedit;return}
             q {end_session_local;focus .tedit;return}
             r {reload;set cmd "";focus .tedit;return}
      } 
      tk_dialog .d { } {Command Not Found} warning 0 {Ok}}
   }
   focus .tedit
}

proc end_session_local { } {
#
# Parameter: keine
#
# Rueckgabe: nichts
#
# Bemerkung: Beenden des Editors

   global cnnect

   if {[.tedit edit modified]} {
       set ok [tk_dialog .d {Warning} {You Have Unsaved Changes !} warning 0\
		{Save Changes} {Discard Changes} {Cancel}]
	
       if {$ok == 2} {return}
       if {$ok == 0} {Save}
   }
   if {$cnnect} {
       goodbye_server
       destroy .
   } else {
       destroy .
   }
}


proc insert_text {item} {
#
# Parameter: item - Name des Textbausteins, der eingesetzt werden soll
#
# Rueckgabe: nichts
#
# Bemerkung: insert_text wird von den Buttons und durch die
#            Befehlseingabe aufgrufen.

   switch $item {

   do {.tedit insert insert "do  < true > enter
    <  >; repeat\n \[\] <  >; exit\nod\n"}
   begin {.tedit insert insert "begin\n\nend\n"}
   var {.tedit insert insert "var name: {1,3..5} init 1;\n"}
   chan {.tedit insert insert "var name: chan capacity of {1,3..5};\n"}
   stack {.tedit insert insert "var name: stack capacity of {1,3..5};\n"}
   bool {.tedit insert insert "var name: {false,true} init true;\n"}
   not {.tedit insert insert "-"}
   and {.tedit insert insert "*"}
   const {.tedit insert insert "const A=1;"}
   or {.tedit insert insert "+"}
   iff {.tedit insert insert "<=>"}
   implicate {.tedit insert insert "=>"}
   ForAll {.tedit insert insert "!"}
   Exists {.tedit insert insert "?"}
   true {.tedit insert insert "1"}
   false {.tedit insert insert "0"}
   Box {.tedit insert insert "#"}
   proc {.tedit insert insert \
"proc procname ( val par1: {0..2}, const par2: {1..3},
                ref par3: {2,4..5}, ref par4: chan 0 of {0,1} ) _max_ 2
begin\n\nend;\n"}
   Diamond {.tedit insert insert "^"}

   # SPIN
   spin_always {.tedit insert insert "\[\]"}
   spin_and {.tedit insert insert "&&"}
   spin_dual {.tedit insert insert "V"}
   spin_equal {.tedit insert insert "<->"}
   spin_eventually {.tedit insert insert "<>"}
   spin_false {.tedit insert insert "false"}
   spin_implicate {.tedit insert insert "->"}
   spin_not {.tedit insert insert "!"}
   spin_or {.tedit insert insert "||"}
   spin_st_until {.tedit insert insert "U"}
   spin_true {.tedit insert insert "true"}

   # SMV

   smv_all {.tedit insert insert "A"}
   smv_and {.tedit insert insert "&"}
   smv_exist {.tedit insert insert "E"}
   smv_future {.tedit insert insert "F"}
   smv_globally {.tedit insert insert "G"}
   smv_iff {.tedit insert insert "<->"}
   smv_implicate {.tedit insert insert "->"}
   smv_next {.tedit insert insert "X"}
   smv_not {.tedit insert insert "!"}
   smv_or {.tedit insert insert "|"}
   smv_until {.tedit insert insert "U"}

   # SDL
   sdl_block {.tedit insert insert \
     "block <ident>;\n\nendblock <ident>;\n"}
   sdl_channel {.tedit insert insert \
     "channel <ident>\nfrom <ident1> to <ident2> with <siglist>;\nendchannel <ident>;\n"}
   sdl_connect {.tedit insert insert \
     "connect <ident1> and <ident2>;\n"}
   sdl_type {.tedit insert insert \
     "syntype <ident1> = <ident2>\n"}
   sdl_process {.tedit insert insert \
     "process <ident>;\n  start;\n\nendprocess <ident>;\n"}
   sdl_procedure {.tedit insert insert \
     "procedure <ident>;\n  start;\n\nendprocedure <ident>;\n"}
   sdl_decision {.tedit insert insert \
     "decision <expr>;\n  (<reply>): <code>\n\n  else: <code>\n\nenddecision;\n"}
}
   scan_text
}

proc info_dialog {} {
#
# Parameter: keine
#
# Rueckgabe: nichts
#
# Bemerkung: Infofenster (uebernommen von Tobias Himstedt)

global my_bitmaps_path

    destroy .info
    toplevel .info
    
    wm title .info "Information"
    frame .info.mess -bd 2 -relief sunken
    frame .info.action -bd 2 -relief sunken
    pack .info.mess .info.action -side left -fill both -expand yes
    message .info.mess.titel -text \
	"The PEP\nB(PN), PBC,\nFormula\nand\nDocument Editor\n(V 1.20)" \
	-font "-Adobe-Times-*-r-*-*-18-*-*-*-*-*-*-*"\
	-justify center

    message .info.mess.message -aspect 500 -justify left -text \
	"Michael Kater, 1997\n\nUniversitt Hildesheim
Institut fr Informatik\nDipl.-Inform. Bernd Grahlmann
Prof. Dr. Eike Best"
    pack .info.mess.titel .info.mess.message -fill both -expand yes -side top
    set spock [image create photo -file \
	[file join $my_bitmaps_path spock_b.gif] -gamma 0]
    label .info.action.b -image $spock
    button .info.action.l -text "Fascinating" -command { destroy .info }
    pack .info.action.b .info.action.l -side top -expand yes -anchor center
    
    set old_focus [focus]
    tkwait visibility .info
    grab .info
    focus .info

    tkwait window .info
}

proc mini_help {which} {
#
# Parameter: which - Art der Hilfeseite
#
# Rueckgabe: nichts
#
# Bemerkung: Oeffnet ein Hilfefenster.

if {[winfo exist .minihelp]} {
    destroy .minihelp
}

toplevel .minihelp
wm title .minihelp "Editor Help"
message .minihelp.top -justify center -width 500
message .minihelp.m -width 500 -relief sunken
button .minihelp.b -text "Close" -command "destroy .minihelp"

switch -regexp $which {
search {.minihelp.top configure -text "Search"
.minihelp.m configure -text "*  The user can enter the search term.
*  The direction of the search can be specified.
*  The behaviour of the search algorithm is controlled by some options:
   -	Either the search stops at the end of the text or it is continued at
	the beginning.
   -	The search algorithm accepts % offers the possibility to handle
	regular expressions (described below).

Regular Expressions

A powerful way to express a search string is by specifying a regular
expression.
It has a general pattern specification syntax including
the ability to extract substrings from the matching string.
A pattern is a sequence of a literal character,
a matching character, a repetition clause, an alternation clause,
or a sub-pattern grouped by parentheses.
The syntax (which is not necessarily the most convenient one, but which is
predetermined by Tcl/Tk) is summarized in the following table:


.	Matches any character.
*	Matches zero or more characters.
+	Matches one or more characters. 
	(Repetition operator)
?	Matches zero or one character.
( )	Groups a sub-pattern.
	Subsequent repetition operators or enclosing alternation operators
	apply to the whole sub-pattern.
|	Alternation operator.
\[ \]	Delimits a set of characters.
	Ranges are specified as x-y. (E.g. \[ae-g\] searches for a,e,f or g).
	If the first character (after the opening braket) in the set is ^,
	then there is a match if the remaining characters (whithin the brackets)
	are not present. (E.g. \[^ae-g\] seraches for characters that are not
	equal to a,e,f or g).
^	Represents the beginning of a line. (Only when it is the first character
	of the search string.)
$	Represents the end of a line. (Only when it is the last character of the
	search string.) "}

replace {
.minihelp.top configure -text "Replace"
.minihelp.m configure -text \
"*  The user can enter a term that is to be replaced.
*  The user can enter the term that will be inserted instead.
*  The direction of the search can be chosen.
*  The behaviour of the search algorithm is controlled by some options:
   -	Either the search stops at the end of the text or it is continued at
	the beginning.
   -	The search algorithm accepts regular expressions (described below).
	
Regular Expressions

A powerful way to express a search string is by specifying a regular
expression.
It has a general pattern specification syntax including
the ability to extract substrings from the matching string.
A pattern is a sequence of a literal character,
a matching character, a repetition clause, an alternation clause,
or a sub-pattern grouped by parentheses.
The syntax (which is not necessarily the most convenient one, but which is
predetermined by Tcl/Tk) is summarized in the following table:


.	Matches any character.
*	Matches zero or more characters.
+	Matches one or more characters. 
	(Repetition operator)
?	Matches zero or one character.
( )	Groups a sub-pattern.
	Subsequent repetition operators or enclosing alternation operators
	apply to the whole sub-pattern.
|	Alternation operator.
\[ \]	Delimits a set of characters.
	Ranges are specified as x-y. (E.g. \[ae-g\] searches for a,e,f or g).
	If the first character (after the opening braket) in the set is ^,
	then there is a match if the remaining characters (whithin the brackets)
	are not present. (E.g. \[^ae-g\] seraches for characters that are not
	equal to a,e,f or g).
^	Represents the beginning of a line. (Only when it is the first character
	of the search string.)
$	Represents the end of a line. (Only when it is the last character of the
	search string.) "}

fs_box {
.minihelp.top configure -text "File Selection Box"
.minihelp.m configure -text \
"*	Every time a user wants to open (save or export) a file,
	a file browser is used for choosing it.
*	In the left part of the window the directory hierarchy can be traversed 
	by double-clicking on the directory names.
*	In the right part the existing files in the current directory are 
        displayed.
*	The list can be restricted by a filter. For example all B(PN) 
        programs can
	be listed by selecting *.bpn2 as a filter, provided you follow the 
	naming 
	conventions and do not name a B(PN) program, say, 'bill.txt'.
*	The current selection is displayed at the bottom of the window.
*	A file can be opened either by a double-click on its name
	or by a click on the OK button when the file is selected.
*	To save (export) a file (clipboard) please type the new filename in the
	selection at the bottom of the Window and press <ENTER> or the OK
	button.
*	The file browser can be closed by a click on the Cancel button.
*	The Help button invokes this help page. "}
syntax {
.minihelp.top configure -text "Syntax Checker"
.minihelp.m configure -text "Please invoke the Helpviewer in the Project-Window"}

}

pack .minihelp.top -fill x
pack .minihelp.m
pack .minihelp.b
}

