package provide pep_edit 1.0

# Options, Preferences und Modes
#################################
# Diese Prozedur loescht alle erstellten Referenzen
proc clear_all { } {
 global ref_string def glob_value

 set ref_string ""
 set glob_value ""
 for {set i 1} {$i <= [array size def]} {incr i} {
   .tedit tag configure tag$i -background {}
 }
 check_name_button
 abstr_name_dlg update
}

proc set_preferences { } {
 global rc

 toplevel .pref
 wm title .pref "Preferences"
 wm minsize .pref 300 130

 message .pref.msg -text "Select Delay for Animation:" -width 400
 scale   .pref.delay -orient horizontal -from 0 -to 1000 \
 	  -variable anim_delay -tickinterval 200

 frame   .pref.button_fr
 button  .pref.apply -text "Apply" -command {set rc(anim_delay) $anim_delay; destroy .pref}
 button  .pref.cancel -text "Cancel" -command {destroy .pref}

 pack .pref.msg -anchor w
 pack .pref.delay -fill x 
 pack .pref.button_fr
 pack .pref.apply -side left -in .pref.button_fr -pady 3 -padx 2m
 pack .pref.cancel -side left -in .pref.button_fr -pady 3 -padx 2m

 .pref.delay set $rc(anim_delay)
}

proc enter_ref_mode { } {
# Der Editor soll nun in den Referenz Modus gehen.
# Dazu: 1. Ueberpruefen, ob eine Refenzdatei gelesen wurde.
#       2. Referenzen in Tags uebernehmen
#       3. Bindings umsetzen.
#       4. Am Ende wieder in den Edit-Modus gehen.

 global def ref_mode sim_mode ref_pl_ll ref_pl_hl ref_ar_pfa

 set ref_mode 1
 set sim_mode 0

 if {!([array exists def] &&
      ([array exists ref_pl_ll] || [array exists ref_pl_hl]
        || [array exists ref_ar_pfa]))} {
     tk_dialog .d { } {No Reference ! Please recompile.} warning 0 {Ok}
     set ref_mode 0
     return 0
 }

 clear_all

 for {set i 1} {$i <= [array size def]} {incr i} {
    .tedit tag bind tag$i <Any-Enter> "toggle_tag_color $i in"
    .tedit tag bind tag$i <Any-Leave> "toggle_tag_color $i out"
    .tedit tag bind tag$i <1> "mark_tag before $i"
    .tedit tag bind tag$i <2> "mark_tag normal $i"
    .tedit tag bind tag$i <3> "mark_tag after $i"
 }

 set_binding ref
 set_ref_buttons
 .insert.msg configure -text "Reference"

 .menu.mode.m entryconfigure 0 -state active
 .menu.mode.m entryconfigure 1 -state disabled
 .menu.mode.m entryconfigure 2 -state active
}

proc enter_sim_mode { } {

 global def sim_string loop_string ref_mode sim_mode

 set ref_mode 0
 set sim_mode 1

 if {![test_sim]} {
     set sim_string ""
     set loop_string ""
     insert_sim_sequence_dlg
     clear_all
     update_act
     tk_dialog .d { } {No simulation sequence!} warning 0 {Ok}
 }

 # Setzen der Tags

 for {set i 1} {$i <= [array size def]} {incr i} {
    .tedit tag bind tag$i <Any-Enter> ""
    .tedit tag bind tag$i <Any-Leave> ""
    .tedit tag bind tag$i <1> ""
    .tedit tag bind tag$i <2> ""
    .tedit tag bind tag$i <3> ""
 }

 set_binding sim
 set_sim_buttons
 .insert.msg configure -text "Simulation"

 sim_reset

 .menu.mode.m entryconfigure 0 -state active
 .menu.mode.m entryconfigure 1 -state active
 .menu.mode.m entryconfigure 2 -state disabled
}

proc enter_edit_mode { } {

 global def ref_mode

 set ref_mode 0
 set sim_mode 0
 set_edit_buttons
 set_binding edit
 .menu.mode.m entryconfigure 0 -state disabled
 .menu.mode.m entryconfigure 1 -state active
 .menu.mode.m entryconfigure 2 -state active

 .insert.msg configure -text "Edit Mode"
 for {set i 1} {$i <= [array size def]} {incr i} {
   .tedit tag bind tag$i <Any-Enter> ""
   .tedit tag bind tag$i <Any-Leave> ""
   .tedit tag bind tag$i <1> ""
   .tedit tag bind tag$i <2> ""
   .tedit tag bind tag$i <3> ""
   .tedit tag configure tag$i -background {}
 }
}

proc enter_pep_mode { } {
 set_pep_buttons
 .menu.formula_mode.m entryconfigure 0 -state disabled
 .menu.formula_mode.m entryconfigure 1 -state active
 .menu.formula_mode.m entryconfigure 2 -state active
 .insert.msg configure -text "PEP Mode"
}

proc enter_spin_mode { } {
 set_spin_buttons
 .menu.formula_mode.m entryconfigure 0 -state active
 .menu.formula_mode.m entryconfigure 1 -state disabled
 .menu.formula_mode.m entryconfigure 2 -state active
 .insert.msg configure -text "SPIN Mode"
}

proc enter_smv_mode { } {
 set_smv_buttons
 .menu.formula_mode.m entryconfigure 0 -state active
 .menu.formula_mode.m entryconfigure 1 -state active
 .menu.formula_mode.m entryconfigure 2 -state disabled
 .insert.msg configure -text "SMV Mode"
}

proc set_ref_buttons { } {
 pack forget .insert.block .insert.channel .insert.signalroute\
   .insert.connect .insert.type .insert.process .insert.procedure\
   .insert.decision
 pack forget .insert.proc .insert.begin .insert.var .insert.bool .insert.chan\
   .insert.stack .insert.do .insert.scan .insert.const
 pack forget .insert.reset .insert.next .insert.prev .insert.start\
   .insert.sequence .insert.act .insert.loop_msg

 pack .insert.value .insert.glob_value .insert.send .insert.clear\
   .insert.set_name -side left -padx 2m
 bind .insert.glob_value <Return> {focus .insert.send}
}

proc set_edit_buttons { } {
 global gvar

 pack forget .insert.value .insert.glob_value .insert.send .insert.clear .insert.set_name
 pack forget .insert.reset .insert.next .insert.prev .insert.start \
   .insert.sequence .insert.act .insert.loop_msg

 switch $gvar(prgtype) {
  sdl {
    pack .insert.block .insert.channel .insert.connect\
         .insert.type .insert.process .insert.procedure .insert.decision\
         -side left -padx 1m
  }
  default {
    pack .insert.proc .insert.begin .insert.var .insert.bool .insert.chan\
            .insert.stack .insert.const .insert.do .insert.scan \
            -side left -padx 1m
  }
 }
}

proc set_sim_buttons { } {
 global sim_string

 pack forget .insert.value .insert.glob_value .insert.send .insert.clear .insert.set_name
 pack forget .insert.block .insert.channel .insert.connect\
   .insert.type .insert.process .insert.procedure .insert.decision
 pack forget .insert.proc .insert.begin .insert.var .insert.bool .insert.chan\
   .insert.stack .insert.do .insert.scan .insert.const

 pack .insert.reset .insert.next .insert.prev .insert.start \
   .insert.sequence .insert.act .insert.loop_msg -side left -padx 2m
}


# Setzen der neuen Buttons fuer den Formeleditor
proc set_pep_buttons { } {
 pack forget .insert.spin_always .insert.spin_and .insert.spin_dual .insert.spin_equal\
	.insert.spin_eventually .insert.spin_false .insert.spin_implicate\
	.insert.spin_not .insert.spin_or .insert.spin_st_until .insert.spin_true
 pack forget .insert.smv_all .insert.smv_and .insert.smv_exist .insert.smv_future\
	.insert.smv_globally .insert.smv_iff .insert.smv_implicate .insert.smv_next\
	.insert.smv_not .insert.smv_or .insert.smv_until

 pack .insert.not .insert.and .insert.or .insert.iff .insert.implicate\
	.insert.forAll .insert.exists .insert.true .insert.false\
	.insert.box .insert.diamond -side left -padx 0m
}

proc set_spin_buttons { } {
 pack forget .insert.not .insert.and .insert.or .insert.iff .insert.implicate\
	.insert.forAll .insert.exists .insert.true .insert.false\
	.insert.box .insert.diamond
 pack forget .insert.smv_all .insert.smv_and .insert.smv_exist .insert.smv_future\
	.insert.smv_globally .insert.smv_iff .insert.smv_implicate .insert.smv_next\
	.insert.smv_not .insert.smv_or .insert.smv_until

 pack .insert.spin_always .insert.spin_eventually .insert.spin_st_until \
 	.insert.spin_dual .insert.spin_and .insert.spin_or .insert.spin_not\
	.insert.spin_implicate .insert.spin_equal .insert.spin_true .insert.spin_false\
	-side left -padx 0m
}

proc set_smv_buttons { } {
 pack forget .insert.not .insert.and .insert.or .insert.iff .insert.implicate\
	.insert.forAll .insert.exists .insert.true .insert.false\
	.insert.box .insert.diamond
 pack forget .insert.spin_always .insert.spin_and .insert.spin_dual .insert.spin_equal\
	.insert.spin_eventually .insert.spin_false .insert.spin_implicate\
	.insert.spin_not .insert.spin_or .insert.spin_st_until .insert.spin_true

 pack .insert.smv_all .insert.smv_exist .insert.smv_next .insert.smv_future\
	.insert.smv_globally .insert.smv_until .insert.smv_not .insert.smv_and\
	.insert.smv_or .insert.smv_implicate .insert.smv_iff\
	-side left -padx 0m
}

proc save_options { } {
 global rc rcpath

 set rc_string "
##################################################################
#                                                                #
#  .pep_editrc                                                   #
#  -----------                                                   #
#                                                                #
#  Configurationfile                                             # 
#                                                                #
##################################################################

# Defaultfont
editor.font = $rc(editor.font)
editor.fontsize = $rc(editor.fontsize)

#################################################################
# B(PN)2 Normal

# Defaultsize
bpn2.normal.geometry = $rc(bpn2.normal.geometry)

#################################################################
# B(PN)2 Expand

# Defaultsize
bpn2.expand.geometry = $rc(bpn2.expand.geometry)

#################################################################
# Formula

# Defaultsize
formula.normal.geometry = $rc(formula.normal.geometry)

#################################################################
# Document

# Defaultsize
doc.geometry = $rc(doc.geometry)

################################################################
# PBC

# Defaultsize
boxexpr.geometry = $rc(boxexpr.geometry)

################################################################
# Defaultentries (Optionsmenu)

show_ref_in_hl = $rc(show_ref_in_hl)
show_ref_in_ll = $rc(show_ref_in_ll)
show_ref_in_formula = $rc(show_ref_in_formula)

show_all_values = $rc(show_all_values)

anim_delay = $rc(anim_delay)"

 set editrcfile [file join $rcpath .pep_editrc]
 if {[file exists $editrcfile]} {
	file rename $editrcfile $editrcfile$gvar(bak_extension)
 }
 echo $rc_string $editrcfile
 tk_dialog .d {Notice} {Options Saved} warning 0 {Ok}
}

#################################################
# Einlesen der Defaultwerte aus der .pep_editrc #
#################################################
proc read_options { } {
  global rcpath debug rc

  set rcfile [file join $rcpath .pep_editrc]
  if {[file exists $rcfile]} {
    set fileid [open $rcfile]
    set rc(rcfile) 1

    if {$debug} {
      puts "--- Initialisation file found! ---"
    }

    while {![eof $fileid]} {
      gets $fileid rcline
      set rcline [string trim $rcline]
      if {$rcline != "" && [string index $rcline 0] != "#"} {
        if {$debug} {
          puts $rcline
        }
        set rcline [split $rcline "="]
        set rcvar [lindex $rcline 0]
        set rcvalue [lindex $rcline 1]
        set rc([string trim $rcvar]) [string trim $rcvalue]
      }
    }
  close $fileid
  }
}

