package provide pep_edit 1.0

proc Search {cmd} {
#
# Parameter:
#
#   cmd: "Search" or "Replace" choosing the action to perform
#
# Rueckgabe:
#
# Bemerkung:

  global direction wrap regular

  if {[winfo exists .search]} {
    destroy .search
  }

  toplevel .search
  wm title .search $cmd
  wm minsize .search 500 250

  frame		.search.searchfr -borderwidth 10
  frame		.search.replacefr -borderwidth 10
  frame		.search.optionfr -borderwidth 2 
  frame		.search.optionleftfr -borderwidth 4
  frame		.search.optionrightfr -borderwidth 4
  frame		.search.buttonfr -borderwidth 10
  frame		.search.nextfr -borderwidth 1 -relief sunken
  frame		.search.cancelfr -borderwidth 1
  frame		.search.helpfr -borderwidth 1
  frame		.search.verifyfr -borderwidth 1
  frame		.search.allfr -borderwidth 1

  message	.search.search_msg -text "Search" -width 70
  entry		.search.search_entry -relief sunken -textvariable search_string
  message	.search.replace_msg -text "Replace" -width 70
  entry		.search.replace_entry -relief sunken\
		-textvariable replace_string

  message	.search.direction_msg -text "Direction" -width 150
  message	.search.option_msg -text "Options" -width 100
  radiobutton	.search.direction_for -text "Forward" -variable direction\
		-relief flat -value "-forwards" -command "selection clear"
  radiobutton	.search.direction_back -text "Backward" -variable direction\
		-relief flat -value "-backwards" -command "selection clear"
  checkbutton	.search.option_wrap -text "Wrap" -variable wrap -relief flat
  checkbutton	.search.option_reg -text "Regular Expr." -variable regular\
		-relief flat
  if {$cmd == "Replace"} {
      button	.search.help -text "Help" -command {mini_help replace}
  } else {
      button	.search.help -text "Help" -command {mini_help search}
  }
  button	.search.cancel -text "Cancel" -command {destroy .minihelp; destroy .search}
  button	.search.verify -text "Replace"\
		-command {verify}
  button	.search.next -text "Search" -command {search}
  button	.search.all -text "Replace all"\
		-command {all}
  ##########
  # Packer #
  ##########

  pack	.search.searchfr -side top -fill x

  if {$cmd == "Replace"} {
    pack .search.replacefr -side top -fill x
    pack .search.replace_msg -side left -in .search.replacefr
    pack .search.replace_entry -side right -expand yes\
          -fill x -in .search.replacefr
  }

  pack	.search.optionfr -side top -fill x
  pack	.search.buttonfr -side bottom -fill x

  pack	.search.optionleftfr -side left -anchor n -padx 10\
	-in .search.optionfr
  pack	.search.optionrightfr -side right -anchor n -padx 10\
	-in .search.optionfr

  pack	.search.search_msg -side left -in .search.searchfr
  pack	.search.search_entry -side right -expand yes -fill x\
	-in .search.searchfr
  pack	.search.direction_msg .search.direction_for .search.direction_back\
	-side top -anchor w -in .search.optionleftfr
  pack	.search.option_msg .search.option_wrap .search.option_reg \
	-side top -anchor w -in .search.optionrightfr

  if {$cmd == "Search"} {
	pack	.search.nextfr .search.cancelfr .search.helpfr\
		-side left -in .search.buttonfr -pady 3 -padx 2m 
	pack	.search.next -side left -in .search.nextfr -fill x\
		-padx 1m -pady 1m -ipady 1m -ipadx 1m
  } else {
        pack	.search.verifyfr .search.allfr .search.cancelfr .search.helpfr\
		-side left -in .search.buttonfr -pady 3 -padx 2m
	pack	.search.verify -side left -in .search.verifyfr -fill x\
		-padx 1m -pady 1m -ipady 1m -ipadx 1m
	pack	.search.all -side left -in .search.allfr -fill x\
		-padx 1m -pady 1m -ipady 1m -ipadx 1m
  }

  pack	.search.cancel -side left -in .search.cancelfr -fill x\
	-padx 1m -pady 1m -ipady 1m -ipadx 1m
  pack	.search.help -side left -in .search.helpfr -fill x\
	-padx 1m -pady 1m -ipady 1m -ipadx 1m

  ####################
  # Defaultselection #
  ####################

  .search.direction_for select
  .search.option_wrap select
  .search.option_reg select

  ############
  # Bindings #
  ############

  bind .search.search_entry <Return> {next}
}

proc next { } {

# Sucht einen String, setzt Cursor und markiert Wort.
#
# Rueckgabe: 0, wenn search_string nicht gefunden wurde
#            1, sonst
# Bemerkung: search_string = Gesuchter String
#            direction = Suchrichtung, -forwards oder -backwards
#            wrap = Suche wieder am Anfang beginnen ? (0 oder 1)
#            regular = Suche nach regulaerem Ausdruck ? (0 oder 1)

   global search_string string_length direction wrap regular

   # Options

   if {($regular)} {
      set op1 "-regexp"
   } else {
      set op1 "-exact"
   }
     
   if {($wrap)} {
       if { $direction == "-forwards"} { 
            set pos [.tedit search $direction $op1 -count string_length --\
                     $search_string [.tedit index "insert + [sel_exist] c"]]
       } else {
            set pos [.tedit search $direction $op1 -count string_length --\
                     $search_string [.tedit index "insert - 1 c"]]
       }
    } else {
       if { $direction == "-forwards"} { 
            set pos [.tedit search $direction $op1 -count string_length --\
                   $search_string [.tedit index "insert + [sel_exist] c"] \
                   [.tedit index end]]
       } else {
            set pos [.tedit search $direction $op1 -count string_length --\
                   $search_string [.tedit index "insert - 1 c"] 1.0]
       }
    }

   if {$pos == ""} {
       selection clear -displayof .tedit
       return 0
   }

   .tedit mark set insert "$pos + $string_length c"
   .tedit see insert
   .tedit tag remove sel 1.0 end
   .tedit tag add sel $pos insert
   update_cursor
   return $pos
}

proc verify { } {

# Sucht "search_string" und ersetzt ihn mit "replace_string",
# wenn gewuenscht.
#
# Parameter: none
#
# Rueckgabe: nichts
#
# Bemerkung: 

   while {[next] != 0} {
       set ok [tk_dialog .d { } {Replace Selection ?} question 1\
               {Replace} {Next} {Cancel}]
       if {$ok == 2} {return}
       if {$ok == 0} {
           replace
       }
   }
   tk_dialog .d { } {No More Strings Found !} warning 0 {Ok} 
}

proc search { } {

# Sucht "search_string" 
#
# Parameter: search_string = zu suchender String
#
# Rueckgabe: nichts
#
# Bemerkung: 

   if {[next] != 0} {
       return
   } else {
       tk_dialog .d { } {String Not Found !} warning 0 {Ok} 
       return
   }
}

proc replace { } {

global replace_string direction

  Cut
  .tedit insert insert $replace_string

  if {$direction == "-forwards"} {
     return
  } else {
     .tedit mark set insert "[.tedit index insert] - \
             [string length $replace_string] c"
     puts [.tedit index insert]
  }
}

proc all { } {

# Parameter: keine
#
# Rueckgabe: nichts
#
# Bemerkung: Macht das Gleiche wie verify, nur ohne Nachfragen

   if {[set oldpos [next]] != 0} {
        replace
   } else {
        tk_dialog .d { } {String Not Found !} warning 0 {Ok} 
        return
   }
   
   set newpos [next]

   while {$newpos != $oldpos && $newpos != 0 } {
       replace
       set newpos [next]
   }
   selection clear -displayof .tedit
   tk_dialog .d { } {No More Strings Found !} warning 0 {Ok} 
}

   destroy .minihelp
   destroy .search

proc sel_exist { } {
 if {[.tedit tag ranges sel] == ""} {
    return 0
 } else {
    return 1
 }
}

# ende Search.tcl
