package provide pep_edit 1.0

proc sim_next { } {
 global sim_string lft sim_end loop loop_string loop_end

 if {![test_sim]} {return}
 incr lft

 if {$lft > $sim_end && !$loop} {
    if {$loop_string != ""} {
       set loop 1
       set lft 0
    } else {
       set lft $sim_end
       return 0
    }
 }
 if {$lft > $loop_end && $loop} {
    set lft 0
 }
 show_trans
 return 1
}

proc sim_prev { } {
 global sim_string lft sim_end loop loop_string loop_end

 if {![test_sim]} {return}
 incr lft -1

 if {$lft < 0 && $loop} {
       set lft $loop_end
 }
 if {$lft < 0 && !$loop} {
    set lft 0
    return 0
 }
 show_trans
 return 1
}

proc sim_reset { } {
 global sim_string lft loop
 if {![test_sim]} {return}

 set lft 0
 set loop 0
 show_trans
}

proc sim_start { } {
 global sim_string lft sim_end rc anim
 if {![test_sim]} {return}

 set anim 1
 set_binding anim
 .insert.start configure -text "Stop" -command "sim_stop"

 while {[sim_next] && $anim} {
   update
   after $rc(anim_delay)
 }
 sim_stop
 set_binding sim
}

proc sim_stop { } {
 global  anim
 .insert.start configure -text "Start" -command "sim_start"
 set anim 0
 if {![test_sim]} {return}
}

proc show_trans { } {
global lft loop sim_string loop_string

 if {![test_sim]} {return}
 clear_all
 if {!$loop} {
    set act_trans [lindex $sim_string $lft]
 } else {
    set act_trans [lindex $loop_string $lft]
 }
 highlight_reference_from_ll $act_trans
 update_act $act_trans
}

proc test_sim { } {
 global sim_string loop_string

 if {![info exists sim_string] && ![info exists loop_string]} {
    return 0
 }
 if {$sim_string == "" && $loop_string == ""} {
    return 0
 }

 return 1
}

# Display current Transition in text entry
proc update_act {{trans ""}} {
  if {[winfo exists .insert.act]} {
     .insert.act configure -text $trans
  }
}

proc insert_sim_sequence_dlg { } {
 global tmp_sim tmp_loop sim_string loop_string

 set w .sim_sequence

 if {[winfo exists $w]} {
    return
 }

 #MK: 21.06.97
 # Nur damit es netter aussieht. Muss wieder RAUS !
 regsub -all -- { } $sim_string "," tmp_sim
 regsub -all -- { } $loop_string "," tmp_loop

 toplevel $w
 wm title $w "Simulation"

 frame $w.input  -bd 2
 pack $w.input  -side top  -fill both
 label $w.input.sim_label  -anchor w -text "SEQUENCE:"  -bd 2 -width 60
 label $w.input.loop_label  -anchor w -text "LOOP:"  -bd 2

 entry $w.input.sim_string  -bd 2 -textvariable tmp_sim
 entry $w.input.loop_string  -bd 2 -textvariable tmp_loop

 pack $w.input.sim_label $w.input.sim_string \
      $w.input.loop_label $w.input.loop_string \
      -side top  -anchor w  -fill x  -expand 1

 # Buttons
 frame $w.commands -relief raised  -bd 2
 pack $w.commands -side bottom  -fill x
 button $w.commands.ok -text "Ok" -command { \
 	simulate_trans -sequence=$tmp_sim -loop=$tmp_loop
 }
 button $w.commands.cancel -text "Cancel" -command {
         destroy .sim_sequence
 }
 pack $w.commands.ok $w.commands.cancel \
        -in $w.commands -side left  -expand 1
}

