package provide pep_edit 1.0

proc convert_text_for_save {file} {
#
# insert PEP header if needed
 global gvar

 set text [.tedit get 1.0 "end - 1 c"]

 # right now SDL Properties is the only file with header
 if {$gvar(prgtype)=="sdl_properties"} {
   set header "PEP\nSDL_Properties\nFORMAT_N\n"
   echo $header$text $file
 } else {
   echo $text $file
 }
}

proc convert_loaded_text { } {
# Don't show the header in editor
 global gvar
 if {$gvar(prgtype)=="sdl_properties"} {
   set l1 [.tedit get 1.0 "1.0 lineend"]
   set l2 [.tedit get 2.0 "2.0 lineend"]
   set l3 [.tedit get 3.0 "3.0 lineend"]
   if {$l1=="PEP" && $l2=="SDL_Properties" && $l3=="FORMAT_N"} {
      # If header is correct, remove from text
     .tedit delete 1.0 "3.0 lineend + 1 c"
   } else {
      # But what to do with incorrect headers? Just an error message...
     puts "The header of .sdl_prop is not correct!"
   }
 }
}

proc ForAllMatches {pattern leftoffset rightoffset {start 1} {stop 0}} {

# Prozedur aus Tcl/Tk Buch. Sucht String zeilenweise im ganzen Text und
# haengt ihn an den keywords-tag
#
# Parameter: pattern = Gesuchter String
#
# Rueckgabe: nichts
#
   # find number of lines if not given
   if {! $stop} {
   	scan [.tedit index end] %d stop
   }
   # Walk through text line by line
   for {set i $start} {$i <= $stop} {incr i} {
      #set last to begin of line
      .tedit mark set last $i.0
      #while keyword found after last
      while {[regexp -indices $pattern \
                   [.tedit get last "last lineend"] indices]} {
	 #start of keyword is marked by first, offset is extra char in pattern
         .tedit mark set first "last + [lindex $indices 0] c + $leftoffset c"
	 #last is calculated analogously
         .tedit mark set last "last + 1 c + [lindex $indices 1] c \
	           - $rightoffset c"
         .tedit tag add keywords first last
      } 
   } 
}

proc scan_text { }  {

# Durchsucht den Text nach Schluesselworten/Bemerkungen und setzt diese 
# fett/kursiv
#
# Parameter: keine
#
# Rueckgabe: nichts
#
# Bemerkung: In $gvar(prgtype) steht, welche Art Programm der Editor
#            gerade anzeigt. Danach werden die Schluesselworte ausgewaehlt.
#
 global gvar rc editor

 # Cursorposition merken
 set oldpos [.tedit index insert]
 # Loeschen der alten Schluesselworte
 .tedit tag delete keywords
 .tedit tag delete remark

  switch -regexp $gvar(prgtype) {
    bpn2.normal|bpn2.expand {
      ForAllMatches "((^|\t| )(begin|var|and|or|val|const|init|chan|of|stack|do|enter|od|repeat|exit|false|true|proc|procgrp|endgrp|ref|choice|not|parallel|end)(\t|$| ))" 0 0
      ForAllMatches "((^|\t| )do;|do<|true;|true>|false;|od;|end;)" 0 1
      ForAllMatches "(;begin|;var|;do|;repeat|;exit|;proc|;ref|\\(ref|;const(\t|$| ))" 1 0
      ForAllMatches "(<true>|<false>|{false,|,false}|{true,|,true}|=false>|_max_|_MAX_)" 1 1
      .tedit tag configure keywords -font $editor(keywordfont)
      mark_lines "//" $editor(remarkfont)}

    sdl$ {
      ForAllMatches "((^| |\t)(system|endsystem|block|endblock|channel|endchannel|from|to|with|nodelay|signal|signalroute|connect|and|process|endprocess|start|state|input|output|nextstate|stop|via|synonym|syntype|endsyntype|default|constants|dcl|task|or|xor|and|mod|rem|not|decision|any|else|enddecision|procedure|endprocedure|call|return|fpar|in|out|create|none|join)($| |\t))" 0 0
      ForAllMatches "(\[^0-9A-Za-z_ \t\](system|endsystem|block|endblock|channel|endchannel|from|to|with|nodelay|signal|signalroute|connect|and|process|endprocess|start|state|input|output|nextstate|stop|via|synonym|syntype|endsyntype|default|constants|dcl|task|or|xor|and|mod|rem|not|decision|any|else|enddecision|procedure|endprocedure|call|return|fpar|in|out|create|none|join)($| |\t))" 1 0
      ForAllMatches "((^| |\t)(system|endsystem|block|endblock|channel|endchannel|from|to|with|nodelay|signal|signalroute|connect|and|process|endprocess|start|state|input|output|nextstate|stop|via|synonym|syntype|endsyntype|default|constants|dcl|task|or|xor|and|mod|rem|not|decision|any|else|enddecision|procedure|endprocedure|call|return|fpar|in|out|create|none|join)\[^0-9A-Za-z_ \t\])" 0 1
      ForAllMatches "(\[^0-9A-Za-z_ \t\](system|endsystem|block|endblock|channel|endchannel|from|to|with|nodelay|signal|signalroute|connect|and|process|endprocess|start|state|input|output|nextstate|stop|via|synonym|syntype|endsyntype|default|constants|dcl|task|or|xor|and|mod|rem|not|decision|any|else|enddecision|procedure|endprocedure|call|return|fpar|in|out|create|none|join)\[^0-9A-Za-z_ \t\])" 1 1
      .tedit tag configure keywords -font $editor(keywordfont)
      mark_lines "//" $editor(remarkfont)}
   boxexpr {
      ForAllMatches "(rs|sy|tie|D_BOX|C_BOX|S_BOX|STOP)" 0 0
      .tedit tag configure keywords -font $editor(keywordfont)
      mark_lines "%" $editor(remarkfont)}
   formula.normal {
      mark_lines "%" $editor(remarkfont)}
  }
  # end switch

 # Cursor wieder auf die alte Position setzen
 .tedit mark set insert $oldpos
}

proc scan_line { {actline -1} }  {

 global gvar rc editor

 # Cursorposition merken
 set oldpos [.tedit index insert]
 if {$actline == -1} {
     scan $oldpos %d actline
 }

 # Loeschen der Schluesselworte der aktuelle Zeile
 .tedit tag remove keywords $actline.0 $actline.end
 .tedit tag remove remark $actline.0 $actline.end

  switch -regexp $gvar(prgtype) {
    bpn2.normal|bpn2.expand {
      ForAllMatches "((^|\t| )(begin|var|and|or|val|const|init|chan|of|stack|do|enter|od|repeat|exit|false|true|proc|procgrp|endgrp|ref|choice|not|parallel|end)(\t|$| ))" 0 0 $actline $actline 
      ForAllMatches "((^|\t| )do;|do<|true;|true>|false;|od;|end;)" 0 1 $actline $actline 
      ForAllMatches "(;begin|;var|;do|;repeat|;exit|;proc|;ref|\\(ref|;const(\t|$| ))" 1 0 $actline $actline 
      ForAllMatches "(<true>|<false>|{false,|,false}|{true,|,true}|=false>|_max_|_MAX_)" 1 1 $actline $actline 
      .tedit tag configure keywords -font $editor(keywordfont)
      mark_lines "//" $editor(remarkfont) $actline  $actline}

    sdl$ {
      ForAllMatches "((^|\t| )(system|endsystem|block|endblock|channel|endchannel|from|to|with|nodelay|signal|signalroute|connect|and|process|endprocess|start|state|input|output|nextstate|stop|via|synonym|syntype|endsyntype|default|constants|dcl|task|or|xor|and|mod|rem|not|decision|any|else|enddecision|procedure|endprocedure|call|return|fpar|in|out|create|none|join)($| |\t))" 0 0 $actline $actline
      ForAllMatches "(\[^0-9A-Za-z_ \t\](system|endsystem|block|endblock|channel|endchannel|from|to|with|nodelay|signal|signalroute|connect|and|process|endprocess|start|state|input|output|nextstate|stop|via|synonym|syntype|endsyntype|default|constants|dcl|task|or|xor|and|mod|rem|not|decision|any|else|enddecision|procedure|endprocedure|call|return|fpar|in|out|create|none|join)($| \t))" 1 0 $actline $actline
      ForAllMatches "((^| |\t)(system|endsystem|block|endblock|channel|endchannel|from|to|with|nodelay|signal|signalroute|connect|and|process|endprocess|start|state|input|output|nextstate|stop|via|synonym|syntype|endsyntype|default|constants|dcl|task|or|xor|and|mod|rem|not|decision|any|else|enddecision|procedure|endprocedure|call|return|fpar|in|out|create|none|join)\[^0-9A-Za-z_ \t\])" 0 1 $actline $actline
      ForAllMatches "(\[^0-9A-Za-z_ \t\](system|endsystem|block|endblock|channel|endchannel|from|to|with|nodelay|signal|signalroute|connect|and|process|endprocess|start|state|input|output|nextstate|stop|via|synonym|syntype|endsyntype|default|constants|dcl|task|or|xor|and|mod|rem|not|decision|any|else|enddecision|procedure|endprocedure|call|return|fpar|in|out|create|none|join)\[^0-9A-Za-z_ \t\])" 1 1 $actline $actline
      .tedit tag configure keywords -font $editor(keywordfont)
      mark_lines "//" $editor(remarkfont) $actline  $actline}
   boxexpr {
      ForAllMatches "(rs|sy|tie|D_BOX|C_BOX|S_BOX|STOP)" 0 0 $actline $actline
      .tedit tag configure keywords -font $editor(keywordfont)
      mark_lines "%" $editor(remarkfont)}
   formula.normal {
      mark_lines "%" $editor(remarkfont)}
  }
  # end switch

 # Cursor wieder auf die alte Position setzen
 .tedit mark set insert $oldpos
}


proc calc_sel_range { } {
#
# Gibt die Start- und Endzeile der aktuellen Selektion zurueck

 if {[.tedit tag ranges sel] != ""} {
    set first [split [.tedit index sel.first] .]
    set last [split [.tedit index sel.last] .]

    set firstline [ lindex $first 0 ]
    set lastline [ lindex $last 0 ]

    if {[ lindex $last 1 ] == 0} {
    	incr lastline -1
    }
   } else {
    tk_dialog .d { } {No Selection - Command Ignored } warning 0 {Ok}
    return 0
 }
 return "$firstline $lastline"
}

proc comment {method} {
#
# method = add -> Einsetzen von Bemerkungen
# method = delete -> Loeschen von Bemerkungen

 set sel_range [calc_sel_range]
 set firstline [lindex $sel_range 0]
 set lastline [lindex $sel_range 1]

 for {set i $firstline} {$i <= $lastline} {incr i} {
 	if {$method == "add"} {
        	.tedit insert $i.0 "//"
		scan_line $i
	} else {
		if {[.tedit get $i.0 $i.2] == "//"} {
			.tedit delete $i.0 $i.2
		        scan_line $i
		}
	}
 }
}

proc shift {direction} {
 set sel_range [calc_sel_range]
 set firstline [lindex $sel_range 0]
 set lastline [lindex $sel_range 1]

 for {set i $firstline} {$i <= $lastline} {incr i} {
 	if {$direction == "right"} {
        	.tedit insert $i.0 "  "
		scan_line $i
	} else {
		if {[.tedit get $i.0 $i.2] == "  "} {
			.tedit delete $i.0 $i.2
		         scan_line $i
		}
	}
 }
}

proc for_line_matches {pattern start stop} {
#
# Parameter: pattern = Gesuchter String
#            script = Tcl-Prozedur, die nach dem Finden gestartet wird.

   # feststellen der Zeilenanzahl
   for {set i $start} {$i <= $stop} {incr i} {

      .tedit mark set last $i.0

      while {[regexp -indices -- $pattern [.tedit get last "last lineend"] indices]} {
         .tedit mark set first "last + [lindex $indices 0] c"
         .tedit mark set last "last lineend"
	 .tedit tag add remark first last
      }
   }
}

proc mark_lines {pattern markfont {start 1} {stop -1}} {
#
# Markiert alle Zeile mit "markfont" ab der Position "pos".
# "pos" ist die Positon, in der der regulaere Ausdruck "pattern" vorkommt.

 if {$stop == -1} {
   scan [.tedit index end] %d stop
 }

   for_line_matches $pattern $start $stop

   .tedit tag configure remark -font $markfont
}


#########################
# Stringkonvertierungen #
#########################

proc string2tag {string tag} {

  global $tag
  global gvar

  if {$gvar(prgtype)=="sdl"} {
    regsub -all -- {\(|\)|,|;|\*|#|:} $string " " tag_list
  } else {
    regsub -all -- {\(|\)|,|;|\*|#} $string " " tag_list
  }
  if {[winfo exists .tedit]} {
    .tedit tag add $tag \
      [lindex $tag_list 0].[expr {[lindex $tag_list 1]-1}] \
      [lindex $tag_list 2].[expr {[lindex $tag_list 3]-1}]
  }
}

proc set_ref_tags { } {
 global def

 for {set i 1} {$i <= [array size def]} {incr i} {
    string2tag $def($i) tag$i
 }
}

proc delete_ref_tags { } {
 global def

 if {[winfo exists .tedit]} {
    for {set i 1} {$i <= [array size def]} {incr i} {
      .tedit tag delete tag$i
    }
 }
 if {[array exists def]} {
     unset def
 }
}

proc update_cursor { } {
   .where configure -text [.tedit index insert]
}

# Da die Referenzdateien fuer die x-pos bei 1 anfangen, werden
# durch incr_pos und decr_pos die x Werte der Pos.Strings
# um 1 inkrementiert bzw. dekrementiert:

proc incr_pos { pos_string } {
   regsub -all -- {\.} $pos_string " " pos_string
   regsub -all -- {\+} $pos_string " " pos_string

   for {set i 0} {$i < 4} {incr i} {
      set v$i [lindex $pos_string $i]
   }
   incr v1
   incr v3

   return "$v0.$v1+$v2.$v3"
}

proc edited {yn} {
   if {$yn} {
      .edited configure -text "*"
      .toolbar.f1.save configure -state normal
      .menu.file.m entryconfigure 3 -state normal
      delete_reference
   } else {
      .edited configure -text ""
      .toolbar.f1.save configure -state disabled
      .menu.file.m entryconfigure 3 -state disabled
   }
}
