proc about_dlg {} {
  # shows a not-so-trivial dialog

  if [catch {toplevel .about}] {
    raise .about
  }  ;# if already open
  wm title .about "About the PEP Tool"

    # Frame for all
  frame .about.fr  -bd 2
  pack .about.fr  -side top  -fill both  -expand 1
    # Info sign
  label .about.fr.bi  -bitmap info  -bd 20
  pack .about.fr.bi  -side left
    # Text and its widget
  frame .about.fr.tf  -relief ridge  -bd 1
  pack .about.fr.tf  -padx 5  -pady 5  -side left  -fill both  -expand 1
  text .about.fr.tf.text  -width 75  -wrap word \
    -yscrollcommand {.about.fr.tf.sy set} \
    -xscrollcommand {.about.fr.tf.pad.sx set}
  .about.fr.tf.text insert end \
"PEP version 2.0, Copyright (C) 1993-2003, Parallel Systems group.\n
PEP comes with ABSOLUTELY NO WARRANTY; for details\
read gpl.txt in pep/Doc/.  This is free software, and you are\
welcome to redistribute it under certain conditions; read gpl.txt\
in pep/Doc/ for details.\n
The development of the PEP system has been started in 1993 - 1994\
as part of a common project of the Universities of Hildesheim and\
Oldenburg sponsored by the DFG (Deutsche Forschungsgemeinschaft).\n
The project was initiated by Eike Best and Hans Fleischhack,\
based on theoretical work done by Eike Best and others in the
EU Basic Research projects DEMON (Design Methods based On Nets)\
and CALIBAN (CAusal CalcuLI BAsed on Nets).\
In particular, Javier Esparza developed the theory behind the\
unfolding-based model checking algorithm used in PEP.\n
Bernd Grahlmann led the Hildesheim group (around Eike Best) of\
the PEP project. He designed and supervised the implementation of PEP,\
and held overall responsibility for the product.\n
During the first two years, this was carried out in cooperation\
with the Oldenbourg group (around Hans Fleischhack), mainly\
in interaction with Matthias Damm, Marc Langnickel, Andree Seidel\
and the STONE group of students.\
From 1995 to 1998 the PEP project had been continued in cooperation\
with Peter H. Starke of the Humboldt-Universitt zu Berlin.\
Lutz Pogrell was responsible for the integration of INA (Integrated Net\
Analyzer) into PEP. At present, Stephan Roch is continuing this work.\n
Moreover, we are lucky to receive strong support from the group around\
Javier Esparza (Universitt Stuttgart, Model Checking Kit).\n
Some years ago, Eike Best and his group moved to Oldenburg, and as a\
consequence, the Oldenburg contributions to PEP increased.\
In 1999 Christian Stehno took over responsibility for the development\
and support of PEP which lead to the new releases of PEP 2.x\n
The following persons made contributions to the implementation\
(in alphabetical order):\n
Martin Ackermann\n
Implemented the compiler from a B(PN) program to an M-net.\n
Ulrich Anhalt and Matthias Moeller\n
Implemented a graphical editor and an input filter for prallel finite automata.\n
Burkhard Bieber\n
Implemented the main part of the graphical user interface spending a vast amount of time to make it user-friendly.\n
Ulf Fildebrandt\n
Improved the implementation of the Petri net editors and simulators, as well as new `programming with nets' features.\n
Burkhard Graves\n
Implemented some of the compilers and the model checking algorithm for safe Petri nets, and improved the theory.\n
Keijo (Kepa) Heljanko\n
Contributed a number of analysis tools, e.g. mcsmodels, unfsmodels and boundsmodels. Together with a number of other people he developed PROD.\n
Tobias Himstedt\n
Initiated the implementation of the Petri net editors and simulators.\n
Johannes Jger\n
Improved and extended the C code generator and implemented the McM deadlock checker.\n
Lars Jenner\n
Developed and implemented the low level procedure semantics.\n
Michael Kater\n
Implemented various text editors, improved the reference component, and contributed to the Linux port. Since 1996 he continued the work of Burkhard Bieber on the graphical user interface. Moreover, he developed and implemented the 3D visualisation component.\n
Viktor Khomenko\n
Developed and implemented the clp checker and the parallel unfolder punf.\n
Stephan Melzer\n
Developed and implemented the C code generator and built a linear programming part together with Javier Esparza.\n
Stephan Merkel\n
Improved the functionality of some of the compilers.\n
Carola Pohl\n
Integrated the SPIN verification package and implemented the online help system.\n
Stephan Ptak\n
Continued the work of Burkhard Bieber and Michael Kater on the graphical user interface.\n
Stefan Rmer\n
Designed and implemented efficient data structures and operations for Petri net and multiset representation. Was the main designer of the basic net file format. Implemented input/output routines, converter programs, and a wide variety of algorithms (e.g. the prefix builder, the boundedness-checker, and original versions of the formula translator, and the HL-net to LL-net unfolder) and optimised the McM deadlock checker.\n
Stefan Schwoon\n
Extended the general input/output routines for Petri nets, improved the implementation of some compilers and algorithms, and implemented the compiler from SDL to M-nets and from PFA to M-nets.\n
Christian Stehno\n
Implemented time boxes and time unfolding, reviewed all tools and GUI components, built the PEP I/O library and lead the PEP development after 1.8\n
Andre Stille\n
Improved the input filter for parallel finite automata.\n
Thomas Thielke\n
Implemented a dedicated model checking algorithm for T-systems.\n
Guido Wimmel\n
Integrated the SMV verification package.\n
\n
Further contributions were made by\n
Farzad Eghtessadi, Eberhard Meisel, Steffen Mller, Robert Riemann, Hartmut Tre and Fatma Uzel.\n
\n
We integrated the following external program packages: FC2Tools, SMV and SPIN.\
Their licence agreements must be read and obeyed.\n
The FC2Tools were developed at INRIA (Sophia Antipolis) by Robert de Simone,\
Valrie Roy, Annie Ressouche, Michel Bourdelles, Amar Bouali and others.\
Please, have a look at their Web page:\n
http://www.inria.fr/meije/verification/index.html\n
SMV (Symbolic Model Verifier) was developed at the Carnegie Mellon University\
by Edmund Clarke, Ken McMillan and others. Please, have a look at their Web page:\n
http://almond.srv.cs.cmu.edu/afs/cs.cmu.edu/project/modck/pub/www/smv.html\n
SPIN was developed at Bell Labs (mainly by Gerard Holzmann) in the formal\
methods and verification group. Please, have a look at their Web page:\n
http://netlib.bell-labs.com/netlib/spin/whatispin.html\n
The linear programming part uses the lp_solve packet by\
M.R.C.M. Berkelaar (Eindhoven University of Technology)."

  scrollbar .about.fr.tf.sy -orient vertical \
    -command {.about.fr.tf.text yview}
  frame .about.fr.tf.pad
  scrollbar .about.fr.tf.pad.sx -orient horizontal \
    -command {.about.fr.tf.text xview}
  set pad [expr [.about.fr.tf.sy cget  -width] + 2 * \
    ([.about.fr.tf.sy cget -bd] + \
     [.about.fr.tf.sy cget -highlightthickness])]
  frame .about.fr.tf.pad.it -width $pad -height $pad
  pack .about.fr.tf.pad -side bottom -fill x
  pack .about.fr.tf.pad.it -side right
  pack .about.fr.tf.pad.sx -side bottom -fill x
  pack .about.fr.tf.sy -side right -fill y
  pack .about.fr.tf.text -side left -fill both -expand 1

    # Buttons
  frame .about.bfr -bd 1 -relief raised
  pack .about.bfr -ipadx 5 -ipady 5 -side bottom -fill both
  button .about.bfr.ok -text "Well done!" \
    -command {destroy .about}
  pack .about.bfr.ok -expand 1
  grab set .about
}  ;# about_dlg

