# debugi.tcl, Debug procedures and windows for PEP
# started: 25.02.95, last-update: 30.09.95

  ###################
  # Init debug file #
  ###################

proc init_debug_file {} {
  # Open debug file if needed
  global gvar

  if {$gvar(file_debug)} {
    if {[catch {open $gvar(debug_filename) w} gvar(debug_file)]} {
      puts "Could not open debug file for writing"
      set gvar(file_debug) false
    } else {
      puts $gvar(debug_file) "DEBUG output from: $gvar(pep_version)"
      puts $gvar(debug_file) [clock format [clock seconds]]
    }
  }  ;# if debugging to a file
}  ;# init_debug_file

proc close_debug_file {} {
  # Close debug file if open, to check don't use
  # gvar(file_debug), but gvar(debug_file)=File-Handle.
  global gvar

  if {![catch {set gvar(debug_file)}]} {
    close $gvar(debug_file)
    unset gvar(debug_file)
  }  ;# file was open
}  ;# close_debug_file

  ###############################
  # Procedures for debug output #
  ###############################

proc DEBUG text {
  # print text to stdout, if gvar(debug) is set,
  # and write to a file if gvar(file_debug) is set.
  # text - output for stdout/file
  global gvar

  if {$gvar(debug)} {
    puts $text
  }  ;# if to stdout
  if {$gvar(file_debug)} {
    puts $gvar(debug_file) $text
    flush $gvar(debug_file)
  }  ;# if to file
}  ;# DEBUG

  #*** end of file debugi.tcl ***

