# pepm.tcl, Hauptprogramm f"ur das PEPTool

  #####################
  # Globale Variablen #
  #####################

  # allgemeine Vorbelegungen
set gvar(debug) 0
set gvar(file_debug) 1
set gvar(debug_filename) "peptool.log"
set gvar(bak_extension) ".bak"
set gvar(prjcount) 0
set gvar(prjlevel) 0
set gvar(actprj) -1
set gvar(project.version) "0.42"
set gvar(copy.project.all) 1
set gvar(rename.project.all) 1
set gvar(delete.project.all) 0
set gvar(pep_version) "PEP, Version 2.0beta1, 31. October 2003 (Halloween release)"
set gvar(bottom_msg) $gvar(pep_version)
set gvar(actuelldir) [pwd]
set gvar(new_project_name) ""
set rc(rcfile) 0
set rc(my_colors) "azure2"
set viewrc(viewrcfile) 0

listbox .dirlist
listbox .projectlist

  ###########
  # Sourcen #
  ###########

  # 1. den Oberpfad holen und ablegen
if [catch {set env(PEPHOME)}] {
  set gvar(pephome.path) "/opt/pep"
} else {
  set gvar(pephome.path) $env(PEPHOME)
}  ;# else, die Pfadangabe war vorhanden
  # 2. den Autopath zusammenbauen und setzen
  # 2.1 die normalen Sachen
set gvar(color_auto_path.path) "$gvar(pephome.path)/lib"
set auto_path [linsert $auto_path 0 $gvar(color_auto_path.path)]

set gvar(my_auto_path.path) "$gvar(pephome.path)/lib/peptool"
set gvar(my_bitmap.path) "$gvar(pephome.path)/bitmaps/peptool"
set auto_path [linsert $auto_path 0 $gvar(my_auto_path.path)]
  # 2.2 INA einbauen
set gvar(tkina_auto_path.path) "$gvar(pephome.path)/lib/tkina"
set auto_path [linsert $auto_path 0 $gvar(tkina_auto_path.path)]

package require Tcl_RPC
rpc_readabletimeout cancel

  # 3. den Pfad zu den Bins zusammensetzen
set gvar(bin.path) "[file join $gvar(pephome.path) bin]"

  # Programmnamen (Editoren, ...)
  # 1. Editoren
set gvar(text_editor.name) \
  "wish -f [file join $gvar(pephome.path) lib pep_edit pep_edit.tcl]"
set gvar(ll_net_editor.name) \
  "wish -f [file join $gvar(pephome.path) lib net LL NetLLEdit.tcl]"
set gvar(hl_net_editor.name) \
  "wish -f [file join $gvar(pephome.path) lib net HL NetHLEdit.tcl]"
set gvar(pfa_editor.name) \
  "wish -f [file join $gvar(pephome.path) lib pfa pfaPEPInit.tcl]"
set gvar(sdl_editor.name) \
  "wish -f [file join $gvar(pephome.path) lib sdl main.tcl]"
  # 2. Konverter u."a.
set gvar(bpn2_syntaxchecker.name) "[file join $gvar(bin.path) bpn2pbc]"
set gvar(bpn2_to_boxexpr.name) "[file join $gvar(bin.path) bpn2pbc]"
set gvar(boxexpr_to_ll_net.name) "[file join $gvar(bin.path) box]"
set gvar(bpn2_exp.name) "[file join $gvar(bin.path) b2b]"
set gvar(bpn2_to_hl_net.name) "[file join $gvar(bin.path) bpn2mnet]"
set gvar(hl_net_to_ll_net.name) "[file join $gvar(bin.path) hl2ll]"
set gvar(bpn2_2_c_source.name) "[file join $gvar(bin.path) bpn2c]"
set gvar(hl_net_sync.name) "[file join $gvar(bin.path) bpn2mnet]"
set gvar(ll_net_to_unfolding.name) "[file join $gvar(bin.path) Unfold]"
set gvar(parallel_unfolder.name) "[file join $gvar(bin.path) punf]"
set gvar(formula_2_formula_exp.name) "[file join $gvar(bin.path) TransForm]"
set gvar(ll_net_to_ina.name) "[file join $gvar(bin.path) pep2ina]"
set gvar(ll_net_ana_pep_2_lola.name) "[file join $gvar(bin.path) pep2lola]"
set gvar(ll_net_to_spin.name) "[file join $gvar(bin.path) pep2spin]"
set gvar(ll_net_to_fc2.name) "[file join $gvar(bin.path) inria5pep]"
set gvar(ll_net_to_slist.name) "[file join $gvar(bin.path) slist]"
set gvar(ll_net_to_prod.name) "[file join $gvar(bin.path) pep2prod]"
set gvar(upper_to_lower.name) "[file join $gvar(bin.path) x_f]"
set gvar(formel_to_LTL.name) "[file join $gvar(bin.path) lexan]"
set gvar(ana_model_check_smv.name) "[file join $gvar(bin.path) smv]"
set gvar(pep_to_smv.name) "[file join $gvar(bin.path) pep2smv]"
set gvar(ana_model_check_trans.name) "[file join $gvar(bin.path) transsmv]"
  # 3. Analyseprogramme
set gvar(ll_net_ana_t_system.name) "[file join $gvar(bin.path) T_SYSTEM]"
set gvar(ll_net_ana_free_choice.name) "[file join $gvar(bin.path) FREECHOICE]"
set gvar(ll_net_ana_bounded.name) "[file join $gvar(bin.path) BOUNDED]"
set gvar(ll_net_ana_reachability.name) "[file join $gvar(bin.path) SCHALTFOLGEN]"
set gvar(ll_net_ana_lp.name) "[file join $gvar(bin.path) pep2lp]"
set gvar(ll_net_ana_clp.name) "[file join $gvar(bin.path) clp]"
set gvar(unfolding_text_ana_deadlock_free.name) "[file join $gvar(bin.path) dlcheck]"
set gvar(unfolding_ana_mcs_deadlock_free.name) "[file join $gvar(bin.path) mcsmodels]"
set gvar(unfolding_ana_unfsmodels.name) "[file join $gvar(bin.path) unfsmodels]"
set gvar(ll_net_ana_boundsmodels.name) "[file join $gvar(bin.path) boundsmodels]"
set gvar(ll_net_ana_boundsmodels_extras.name) "| [file join $gvar(bin.path) pparse] | [file join $gvar(bin.path) smodels]"
set gvar(ll_net_ana_model_check_t_system.name) "[file join $gvar(bin.path) mca]"
set gvar(ll_net_ana_model_check_qq.name) "[file join $gvar(bin.path) qq]"
set gvar(ll_net_ana_lola.name) "[file join $gvar(bin.path) lola]"
set gvar(unfolding_text_ana_model_check_safe.name) "[file join $gvar(bin.path) mm]"
set gvar(pfa_to_hl_net.name) "[file join $gvar(bin.path) pfa2mnet]"
set gvar(sdl_hl_net.name) "[file join $gvar(bin.path) s2m]"

set gvar(promela_text_ana_model_check_spin.name) "[file join $gvar(bin.path) spin]"
set gvar(pfa_bpn2.name) "[file join $gvar(bin.path) pfa2bpn]"
set gvar(fc2_to_fc2_dead.name) "[file join $gvar(bin.path) fc2implicit]"
set gvar(fc2_ana_deadlock_free.name) "[file join $gvar(bin.path) fcdead2pep]"

  # 4. Tools (Help Viewer)
set gvar(help.view.name) \
  "wish -f [file join $gvar(pephome.path) lib help help.tcl]"
set gvar(ina.name) \
  "wish -f [file join $gvar(pephome.path) lib tkina tkina.tcl]"

  # 5. Simulator/Animator
set gvar(simulator.name) \
  "$gvar(bin.path)/simulator"
set gvar(animator.name) \
  "$gvar(bin.path)/animator"

  # Liste der offenen Projekte, hier nur mit der Anzahl (= 0) initialisiert
set open_projects(open_count) 0

 # setzen von Umgebungsvariablen
set env(BPN2_CODEGENERATOR_LIB) $env(PEPHOME)/bin
set env(BPN2_CODEGENERATOR_KEY) 160

  #########
  # Inits #
  #########

read_rc_file
init_debug_file
init_util
init_server_com
init_project_info
init_options_dialog_values
init_view_defaults 0
read_viewrc_file

#check_version
version_warning_msg
check_utils

init_color_palette

  # only for debugging purpose
#rpc_debug all

  #################
  # Zusatzdialoge #
  #################


  ###################
  # Hilfsprozeduren #
  ###################

proc get_all_dirs {} {
  # Read all Directory entries from current directory

  set dirs [glob -nocomplain *]
  set dirs [lsort $dirs]
  .dirlist delete 0 end
  .dirlist insert end ".."
  .dirlist insert end "HOME sweet HOME"
  foreach dir $dirs {
    if {[file isdirectory $dir]} {
      .dirlist insert end $dir
    }  ;# if file is a directory
  }  ;# foreach possible directory in the list
}  ;# get_all_dirs

proc get_all_projects {} {
  # Read all project files from the current dir.

  set projects [glob -nocomplain *.project]
  set projects [lsort $projects]
  .projectlist delete 0 end
  foreach proj $projects {
    if {[file isfile $proj]} {
      .projectlist insert end $proj
    }  ;# if file is a project
  }  ;# foreach possible project
}  ;# get_all_projects

proc peptool_wm_delete_window {} {
  # Der User hat "uber den Close-Button des Window-Frames
  # zum Beenden des PEPTools aufgerufen.
  DEBUG "*** PEPTool via Window Manager <Close> terminated ***"
  quit_peptool
}  ;# peptool_wm_delete_window

  ###########
  # Widgets #
  ###########

wm title . "The fabulous PEP Tool"
wm protocol . WM_DELETE_WINDOW peptool_wm_delete_window

  # Framewidget f"ur das Men"u
frame .topmen -relief raised -bd 2
pack .topmen -side top -fill x

  # File-Men"u
menubutton .topmen.file -text "File" \
  -menu .topmen.file.m -underline 0
pack .topmen.file -side left
menu .topmen.file.m -tearoff 0
.topmen.file.m add command -label "New Project" \
  -command {
    incr gvar(prjcount); incr gvar(prjlevel)
    set prj$gvar(prjlevel)(project.level) $gvar(prjlevel)
    new_project_dialog
  } -underline 0
.topmen.file.m add command -label "Open Project" \
  -command {
      # neues Projekt vorbereiten
    incr gvar(prjcount); incr gvar(prjlevel)
    set prj$gvar(prjlevel)(project.level) $gvar(prjlevel)
    open_project prj$gvar(prjlevel)
  } -underline 0
.topmen.file.m add separator
.topmen.file.m add command -label "Reread Directory" \
  -command {
    get_all_dirs
    get_all_projects
  } -underline 0
.topmen.file.m add command -label "Change Directory" \
  -command {change_dir} -underline 0
.topmen.file.m add command -label "Make Directory" \
  -command {make_dir} -underline 0
.topmen.file.m add separator
.topmen.file.m add command  -label "Quit" \
  -command quit_peptool -underline 0

  # Edit-Men"u
menubutton .topmen.edit  -text "Edit" \
  -menu .topmen.edit.m  -underline 0
pack .topmen.edit  -side left
menu .topmen.edit.m  -tearoff 0
.topmen.edit.m add command  -label "Copy Project" \
  -command {copy_project}  -underline 0
.topmen.edit.m add command  -label "Rename Project" \
  -command {rename_project}  -underline 0
.topmen.edit.m add command  -label "Delete Project" \
  -command {delete_project}  -underline 0

  # Project-Men"u
menubutton .topmen.project  -text "Project" \
  -menu .topmen.project.m  -underline 0
pack .topmen.project  -side left
menu .topmen.project.m  -tearoff 0
.topmen.project.m add command  -label "Project List" \
  -command {project_list}  -underline 0

  # Option-Men"u
menubutton .topmen.option  -text "Option" \
  -menu .topmen.option.m  -underline 0
pack .topmen.option  -side left
menu .topmen.option.m  -tearoff 0
.topmen.option.m add checkbutton  -label "Display Debug" \
  -variable gvar(debug)  -underline 0 
.topmen.option.m add checkbutton  -label "File Debug" \
  -variable gvar(file_debug)  -underline 0 \
  -command {if {$gvar(file_debug)} {init_debug_file} else {close_debug_file}}
.topmen.option.m add command  -label "Show Com" \
  -command {display_com_state}  -underline 5
.topmen.option.m add command  -label "Show Architecture" \
  -command {puts [GetTclEnvInfoStr]}  -underline 5
.topmen.option.m add separator

.topmen.option.m add command  -label "Preferences" \
  -command {preferences} -underline 0

menubutton .topmen.help  -text "Help" \
  -menu .topmen.help.m  -underline 0
pack .topmen.help  -side right
menu .topmen.help.m -tearoff 0
.topmen.help.m add command -label "About" \
  -command {about_dlg}

# TODO: Help-Men"u einbauen

  # die FileSelection-Box einbauen

  # Ausgabe f"ur den aktuellen Pfad
entry .actdir -width 64 -relief sunken -textvariable gvar(actuelldir)
pack .actdir -fill x
bind .actdir <Return> {
  set savedir [pwd]
  if [catch {cd $gvar(actuelldir)}] {
    set gvar(actuelldir) $savedir
  } else {
    set gvar(actuelldir) [pwd]
    get_all_dirs
    get_all_projects
  }  ;# else, Pfad vorhanden
}  ;# Binding f"ur die Verzeichniszeile

  # Liste der Verzeichnisse, Widget ist bereits oben definiert worden
.dirlist configure  -relief raised  -borderwidth 2 \
  -yscrollcommand ".dirlistscroll set"
pack .dirlist  -side left  -expand 1  -fill both
scrollbar .dirlistscroll  -command ".dirlist yview"
pack .dirlistscroll  -side left  -fill y
set newdir ""
bind .dirlist <Button-1> {
  set newdir [%W get @%x,%y]
}  ;# Binding f"ur die Verzeichnisauswahl
bind .dirlist <Double-Button-1> {
  set newdir [%W get @%x,%y]
  change_dir
}  ;# Binding f"ur die Verzeichnisauswahl
get_all_dirs

  # Liste der Projekte
.projectlist configure -relief raised -borderwidth 2 \
  -yscrollcommand ".projectlistscroll set"
pack .projectlist -side left -expand 1 -fill both
scrollbar .projectlistscroll -command ".projectlist yview"
pack .projectlistscroll -side left -fill y
bind .projectlist <Button-1> {
  set gvar(new_project_name) [%W get @%x,%y]
}
bind .projectlist <Double-Button-1> {
  set gvar(new_project_name) [%W get @%x,%y]
  .topmen.file.m invoke "Open Project"
}
get_all_projects

  # Buttons am unteren Fensterende
frame .bottommen -relief raised -bd 2
pack .bottommen -side bottom -before .actdir -fill x

button .bottommen.newproject -text "New Project" \
  -command { \
  incr gvar(prjcount); incr gvar(prjlevel); \
  set prj$gvar(prjlevel)(project.level) $gvar(prjlevel); \
  new_project_dialog \
}  -underline 0
button .bottommen.openproject -text "Open Project" \
  -command {.topmen.file.m invoke "Open Project"} -underline 0
  # Hinweisfeld
label .bottommen.msg  -width 30 -anchor w -textvariable gvar(bottom_msg)
button .bottommen.quit  -text "Quit" -command quit_peptool  -underline 0
pack .bottommen.newproject .bottommen.openproject -side left
pack .bottommen.quit  -side right
pack .bottommen.msg -fill x -expand true -side left

  ##################################
  # Prozeduren f"ur das File-Men"u #
  ##################################

proc new_project {new_name project {projType 0}} {
  # Hilfsfunktion f"ur das Anlegen des Projektes $new_name.
  # new_name - der Name des neuen Projektes
  # project  - die Projektvariable
  # projType - Listenindex in $gvar(view.projecttypes)
  # Das Ergbnis der Prozedur ist ein String (so "ahnlich wie):
  #   "OK" - alles hat funktioniert
  #   "Project name not allowed" - ung"ultiger Projektname
  #   "Project name exists" - Project mit diesem Namen bereits vorhanden
  # Ablauf:
  # 0. Pr"ufen, ob Name erlaubt
  # 1. Pr"ufen, ob Name in diesem Verzeichnis bereits vergeben wurde
  # 2. Falls noch nicht: Variable f"ullen
  # 3. eine Datei mit dem Name anlegen
  # 4. Projektfenster aufmachen
  global gvar

    # Zugriff auf die Projektvariable erhalten
  upvar $project prjx
    # gleich mal den aktuellen Pfad merken
  set prjx(actdir) [pwd]

    # 0. Pr"ufen, ob Name erlaubt
  if {![well_formated_project_file_name new_name txt]} {
    return $txt
  }  ;# if Name ungut

    # 1. Pr"ufen, ob Name bereits vergeben wurde und 2.-4.
  if [catch {glob $new_name}] {

    # Set project infos
    set prjx(project.filename) $new_name
    set date_time [clock format [clock seconds] -format "%d.%m.%y %H:%M:%S"]
    set date [lindex $date_time 0]
    set prjx(DATE) $date
    set prjx(VERSION) $gvar(project.version)
    set prjx(project.comment_1) "This Project was created $date."
    set prjx(project.comment_2) "You can edit this comment for your own purpose."
    set prjx(type) projType

    # save into new file, reread to fill with defaults
    write_project $new_name prjx
    read_project $new_name prjx
    get_all_projects
      # aktuelles Verzeichnis im Projekt merken
    set prjx(actdir) [pwd]
    new_project_frame prjx
      # Soweit ist alles klar.
    return "Ok"
  } else {
    return "Project name exists"
  }  ;# if $new_name ist vorhanden
}  ;# new_project

proc new_project_dialog {} {
  # Create new project, set name from user input.
  global gvar

    # Link project variable
  upvar #0 prj$gvar(prjlevel) prjx

    # Create toplevel for input of new project name
  toplevel .new_project_box
  wm title .new_project_box "New Project"
  wm minsize .new_project_box 260 310

    # Input frame with all elements needed
  frame .new_project_box.fr
  pack .new_project_box.fr -fill both -expand 1
  label .new_project_box.fr.l -text "New Project Name "  -anchor w
  entry .new_project_box.fr.o -width 26  -relief sunken \
    -textvariable gvar(new_project_name)
  pack .new_project_box.fr.l .new_project_box.fr.o \
    -side top  -fill x
  bind .new_project_box.fr.o <Return> {
    set msg [new_project $gvar(new_project_name) prj$gvar(prjlevel)]
    switch $msg {
      "Ok"  {unset msg; destroy .new_project_box}
      default {.new_project_box.fr.msg configure  -text $msg}
    }
  }  ;# Binding for input line of project name
  label .new_project_box.fr.msg \
    -text "Suffix .project is appended automatically."
  pack .new_project_box.fr.msg  -side top -side left

  frame .new_project_box.types
  label .new_project_box.types.label -text "Available project types"
  listbox .new_project_box.types.lbox -height 0 -listvariable gvar(view.projecttypes)
  .new_project_box.types.lbox selection set 0
  pack .new_project_box.types.label -side top -fill x
  pack .new_project_box.types.lbox -side top -fill both -expand yes
  pack .new_project_box.types -fill both -expand yes -pady 5

    # Button bar
  frame .new_project_box.bfr  -relief raised  -bd 1
  pack .new_project_box.bfr  -side bottom  -fill both
  button .new_project_box.bfr.ok  -text "Ok" \
    -command { \
      set msg [new_project $gvar(new_project_name) prj$gvar(prjlevel)]; \
      switch $msg {
        "Ok"  {unset msg; destroy .new_project_box}
        default {.new_project_box.fr.msg configure -text $msg}
      }  ;# switch ber das Ergebnis
    }
  button .new_project_box.bfr.cancel  -text "Cancel" \
    -command {catch {unset msg}; destroy .new_project_box}
  pack .new_project_box.bfr.ok \
    .new_project_box.bfr.cancel \
    -side left  -expand 1
  grab set .new_project_box
}  ;# new_project_dialog 

proc open_project project {
  # Das aktuelle Projekt "offnen.
  global gvar

  if {$gvar(new_project_name)==""} {
    error_msg "Please select a project"
    return
  }

    # Testen, ob damit eine Datei gemeint sein k"onnte
  if {[file isfile $gvar(new_project_name)] == 0} {
    error_msg "No proper file selected"
    return
  }  ;# if keine Datei

    # Projektvariable bekanntmachen
  upvar #0 prj$gvar(prjlevel) prjx
    # aktuelles Verzeichnis im Projekt merken
  set prjx(actdir) [pwd]
    # Pr"ufen, ob das Projekt bereits offen ist
  if [search_open_project_filename $prjx(actdir) $gvar(new_project_name)] {
    error_msg "Project $gvar(new_project_name) is already open"
    return
  }
    # Projektdatei lesen und Angaben in neuer Variable ablegen
  if {[catch {read_project $gvar(new_project_name) prjx}]} {
    error_msg "Failed reading project $gvar(new_project_name)"
  } else {
      # neues TopLevel erzeugen und anzeigen
    new_project_frame prjx
  }

}  ;# open_project

proc change_dir {} {
  # Nachschauen, ob eine Selektion vorliegt, und ggf. in das
  # Verzeichnis wechseln.
  global gvar env newdir

    # altes Verzeichnis sichern
  set savedir [pwd]
    # Selektion holen, sodenn vorhanden
  if {$newdir==""} {
    error_msg "Please select a directory"
    return
  }
    # normales Verzeichnis oder HOME gemeint
  if [string compare $newdir "HOME sweet HOME"] {
    set newdir "$gvar(actuelldir)/$newdir"
  } else {
    set newdir "$env(HOME)"
  }
    # versuchsweise das Verzeichnis wechseln
  if [catch {cd $newdir}] {
    # do nothing
  } else {
    set gvar(actuelldir) [pwd]
    get_all_dirs
    get_all_projects
  }  ;# if Verzeichniswechsel hat geklappt
}  ;# change_dir

proc make_dir {} {
  # Dialog aufmachen f"ur den Namen eines neuen Verzeichnisses.
  # Falls es keine Probleme gibt, das Verzeichnis anlegen.
  global gvar

    # Men"ueintrag ausblenden
  .topmen.file.m entryconfigure "Make Directory"  -state disabled
    # Textvariable vorbelegen
  set gvar(newdir) ""
    # Neuen Dialog bereitstellen
  toplevel .make_dir_toplvl
  wm title .make_dir_toplvl "Make Directory"

    # Eingabebereich
  frame .make_dir_toplvl.entry_f
  pack .make_dir_toplvl.entry_f  -side top  -fill x
  label .make_dir_toplvl.entry_f.l  -text "New Directory Name "  -anchor w
  pack .make_dir_toplvl.entry_f.l  -side top
  entry .make_dir_toplvl.entry_f.e  -width 30  -relief sunken  -bd 2 \
    -textvariable gvar(newdir)
  pack .make_dir_toplvl.entry_f.e \
    -side top
  bind .make_dir_toplvl.entry_f.e <Return> {
    if [catch {file mkdir $gvar(newdir)} emsg] {
      error_msg "Making new directory '$gvar(newdir)' failed, because $emsg"
    } else {
      get_all_dirs
    }  ;# else, neues Verzeichnis konnte angelegt werden
    .topmen.file.m entryconfigure "Make Directory"  -state normal
    destroy .make_dir_toplvl
  }  ;# Binding f"ur Return im Entry

    # Button-Leiste
  frame .make_dir_toplvl.bfr  -relief raised  -bd 1
  pack .make_dir_toplvl.bfr  -side bottom  -fill both
  button .make_dir_toplvl.bfr.ok  -text "Ok" \
    -command {
      if [catch {file mkdir $gvar(newdir)} emsg] {
        error_msg "Making new directory '$gvar(newdir)' failed, because $emsg"
      } else {
        get_all_dirs
      }  ;# else, neues Verzeichnis konnte angelegt werden
      .topmen.file.m entryconfigure "Make Directory"  -state normal
      destroy .make_dir_toplvl
    }  ;# Kommando zu Ok
  button .make_dir_toplvl.bfr.cancel  -text "Cancel" \
    -command {
      .topmen.file.m entryconfigure "Make Directory"  -state normal
      destroy .make_dir_toplvl
    }  ;# Kommando zu Cancel
  pack .make_dir_toplvl.bfr.ok \
    .make_dir_toplvl.bfr.cancel \
    -side left  -expand 1
  grab set .make_dir_toplvl
}  ;# make_dir

proc quit_peptool {} {
  # Das PEP Tool wurde per WM oder Quit-Button zum Beenden aufgefordert.
  # Vor dem Ende m"ussen die Projektfenster und die zugeh"origen
  # Editoren beendet werden. Die Dateiinhalte werden, falls n"otig,
  # gesichert.
  global gvar open_projects

  foreach p [array names open_projects] {
    if {$p != "open_count"} {
      set gvar(actprj) [lindex $open_projects($p) 1]
      prj_close "JA"
    }  ;# if nicht die Angabe wieviele Projekte
  }  ;# foreach Projekt in der Liste
  exit
}  ;# quit_peptool

  ##################################
  # Prozeduren f"ur das Edit-Men"u #
  ##################################

proc copy_project {} {
  # Nachschauen, ob eine Selektion vorliegt, und ggf. das Projekt kopieren.
  global gvar

    # Set name if one is selected
  set gvar(copy.project.old_name) $gvar(new_project_name)

    # Men"ueintrag ausblenden
  .topmen.edit.m entryconfigure "Copy Project"  -state disabled
    # Neuen Dialog bereitstellen
  if [catch {set d [toplevel .cp_prj_toplvl]}] {
   raise .cp_prj_toplvl
   return
  }  ;# if doppelt
  add_dlg_widget -1 $d
  wm title $d "Copy Project"
  wm protocol $d WM_DELETE_WINDOW "dlg_option_wm_delete -1 $d \
    {.topmen.edit.m entryconfigure {Copy Project}  -state normal}"

    # Eingabebereich
  frame .cp_prj_toplvl.entry_f
  pack .cp_prj_toplvl.entry_f -side top -fill x
    # Eingabe f"ur den Projektnamen (alt)
  frame .cp_prj_toplvl.entry_f.pn -bd 1
  pack .cp_prj_toplvl.entry_f.pn -side top -fill x
  label .cp_prj_toplvl.entry_f.pn.l -text "Project Name (old) " \
    -width 20 -anchor w
  pack .cp_prj_toplvl.entry_f.pn.l -side left
  entry .cp_prj_toplvl.entry_f.pn.e -width 30 -relief sunken -bd 2 \
    -textvariable gvar(copy.project.old_name)
  pack .cp_prj_toplvl.entry_f.pn.e \
    -side left -anchor w -fill x -expand 1
    # Eingabe f"ur den Projektnamen (neu)
  frame .cp_prj_toplvl.entry_f.pnn -bd 1
  pack .cp_prj_toplvl.entry_f.pnn -side top -fill x
  label .cp_prj_toplvl.entry_f.pnn.l -text "Project Name (new) " \
    -width 20 -anchor w
  pack .cp_prj_toplvl.entry_f.pnn.l -side left
  entry .cp_prj_toplvl.entry_f.pnn.e -width 30 -relief sunken -bd 2 \
    -textvariable gvar(copy.project.new_name)
  pack .cp_prj_toplvl.entry_f.pnn.e \
    -side left -anchor w -fill x -expand 1
    # Hinweisfeld
  frame .cp_prj_toplvl.entry_f.hint
  pack .cp_prj_toplvl.entry_f.hint -side top -fill x
  label .cp_prj_toplvl.entry_f.hint.l \
    -text "Suffix .project is appended automatically."
  pack .cp_prj_toplvl.entry_f.hint.l -fill x -expand 1
    # Schalter
  frame .cp_prj_toplvl.entry_f.flags -bd 1
  pack .cp_prj_toplvl.entry_f.flags -side top -fill x
  checkbutton .cp_prj_toplvl.entry_f.flags.copy_all \
    -text "Copy all Data Files" \
    -variable gvar(copy.project.all) -anchor w
  pack .cp_prj_toplvl.entry_f.flags.copy_all \
    -anchor w -fill x

    # Button-Leiste
  frame .cp_prj_toplvl.bfr -relief raised -bd 1
  pack .cp_prj_toplvl.bfr -side bottom -fill both
  button .cp_prj_toplvl.bfr.ok -text "Ok" \
    -command {
      copy_project_file $gvar(copy.project.old_name) \
        $gvar(copy.project.new_name) $gvar(copy.project.all)
      .topmen.edit.m entryconfigure "Copy Project" -state normal
      unset gvar(copy.project.old_name)
      unset gvar(copy.project.new_name)
      get_all_projects
      del_dlg_widget -1 .cp_prj_toplvl
      destroy .cp_prj_toplvl
    }  ;# Kommando zu Ok
  button .cp_prj_toplvl.bfr.cancel -text "Cancel" \
    -command {
      .topmen.edit.m entryconfigure "Copy Project" -state normal
      unset gvar(copy.project.old_name)
      unset gvar(copy.project.new_name)
      del_dlg_widget -1 .cp_prj_toplvl
      destroy .cp_prj_toplvl
    }  ;# Kommando zu Cancel
  pack .cp_prj_toplvl.bfr.ok \
    .cp_prj_toplvl.bfr.cancel \
    -side left -expand 1
  grab set .cp_prj_toplvl
}  ;# copy_project

proc rename_project {} {
  # Nachschauen, ob eine Selektion vorliegt, und ggf. das Projekt umbenennen.
  global gvar

  set gvar(rename.project.old_name) $gvar(new_project_name)

    # Men"ueintrag ausblenden
  .topmen.edit.m entryconfigure "Rename Project"  -state disabled
    # Neuen Dialog bereitstellen
  if [catch {set d [toplevel .ren_prj_toplvl]}] {
    raise .ren_prj_toplvl
    return
  }  ;# if doppelt
  add_dlg_widget -1 $d
  wm title $d "Rename Project"
  wm protocol $d WM_DELETE_WINDOW "dlg_option_wm_delete -1 $d \
    {.topmen.edit.m entryconfigure {Rename Project} -state normal}"

    # Eingabebereich
  frame .ren_prj_toplvl.entry_f
  pack .ren_prj_toplvl.entry_f -side top -fill x
    # Eingabe f"ur den Projektnamen (alt)
  frame .ren_prj_toplvl.entry_f.pn -bd 1
  pack .ren_prj_toplvl.entry_f.pn -side top -fill x
  label .ren_prj_toplvl.entry_f.pn.l -text "Project Name (old) " \
    -width 20 -anchor w
  pack .ren_prj_toplvl.entry_f.pn.l -side left
  entry .ren_prj_toplvl.entry_f.pn.e  -width 30  -relief sunken  -bd 2 \
    -textvariable gvar(rename.project.old_name)
  pack .ren_prj_toplvl.entry_f.pn.e \
    -side left  -anchor w  -fill x  -expand 1
    # Eingabe f"ur den Projektnamen (neu)
  frame .ren_prj_toplvl.entry_f.pnn  -bd 1
  pack .ren_prj_toplvl.entry_f.pnn  -side top  -fill x
  label .ren_prj_toplvl.entry_f.pnn.l  -text "Project Name (new) " \
    -width 20  -anchor w
  pack .ren_prj_toplvl.entry_f.pnn.l  -side left
  entry .ren_prj_toplvl.entry_f.pnn.e  -width 30  -relief sunken  -bd 2 \
    -textvariable gvar(rename.project.new_name)
  pack .ren_prj_toplvl.entry_f.pnn.e \
    -side left  -anchor w  -fill x  -expand 1
    # Hinweisfeld
  frame .ren_prj_toplvl.entry_f.hint
  pack .ren_prj_toplvl.entry_f.hint  -side top  -fill x
  label .ren_prj_toplvl.entry_f.hint.l \
    -text "Suffix .project is appended automatically."
  pack .ren_prj_toplvl.entry_f.hint.l  -fill x  -expand 1
    # Schalter
  frame .ren_prj_toplvl.entry_f.flags  -bd 1
  pack .ren_prj_toplvl.entry_f.flags  -side top  -fill x
  checkbutton .ren_prj_toplvl.entry_f.flags.rename_all \
    -text "Rename all Data Files" \
    -variable gvar(rename.project.all)  -anchor w
  pack .ren_prj_toplvl.entry_f.flags.rename_all \
    -anchor w  -fill x

    # Button-Leiste
  frame .ren_prj_toplvl.bfr  -relief raised  -bd 1
  pack .ren_prj_toplvl.bfr  -side bottom  -fill both
  button .ren_prj_toplvl.bfr.ok  -text "Ok" \
    -command {
      rename_project_file $gvar(rename.project.old_name) \
        $gvar(rename.project.new_name) $gvar(rename.project.all)
      .topmen.edit.m entryconfigure "Rename Project"  -state normal
      unset gvar(rename.project.old_name)
      unset gvar(rename.project.new_name)
      get_all_projects
      del_dlg_widget -1 .ren_prj_toplvl
      destroy .ren_prj_toplvl
    }  ;# Kommando zu Ok
  button .ren_prj_toplvl.bfr.cancel  -text "Cancel" \
    -command {
      .topmen.edit.m entryconfigure "Rename Project"  -state normal
      unset gvar(rename.project.old_name)
      unset gvar(rename.project.new_name)
      del_dlg_widget -1 .ren_prj_toplvl
      destroy .ren_prj_toplvl
    }  ;# Kommando zu Cancel
  pack .ren_prj_toplvl.bfr.ok \
    .ren_prj_toplvl.bfr.cancel \
    -side left  -expand 1
  grab set .ren_prj_toplvl
}  ;# rename_project

proc delete_project {} {
  # Nachschauen, ob eine Selektion vorliegt, und ggf. das Projekt l"oschen.
  global gvar

  set gvar(delete.project.name) $gvar(new_project_name)

    # Men"ueintrag ausblenden
  .topmen.edit.m entryconfigure "Delete Project"  -state disabled
    # Neuen Dialog bereitstellen
  if [catch {set d [toplevel .del_prj_toplvl]}] {
    raise .del_prj_toplvl
    return
  }  ;# if doppelt
  add_dlg_widget -1 $d
  wm title $d "Delete Project"
  wm protocol $d WM_DELETE_WINDOW "dlg_option_wm_delete -1 $d \
    {.topmen.edit.m entryconfigure {Delete Project}  -state normal}"

    # Eingabebereich
  frame .del_prj_toplvl.entry_f
  pack .del_prj_toplvl.entry_f  -side top  -fill x
    # Eingabe f"ur den Projektnamen
  frame .del_prj_toplvl.entry_f.pn  -bd 1
  pack .del_prj_toplvl.entry_f.pn  -side top  -fill x
  label .del_prj_toplvl.entry_f.pn.l  -text "Project Name "  -anchor w
  pack .del_prj_toplvl.entry_f.pn.l  -side left
  entry .del_prj_toplvl.entry_f.pn.e  -relief sunken  -bd 2 \
    -textvariable gvar(delete.project.name)
  pack .del_prj_toplvl.entry_f.pn.e \
    -side left  -anchor w  -fill x  -expand 1
  bind .del_prj_toplvl.entry_f.pn.e <Return> {
    delete_project_file $gvar(delete.project.name) $gvar(delete.project.all)
    .topmen.edit.m entryconfigure "Delete Project"  -state normal
    unset gvar(delete.project.name)
    get_all_projects
    del_dlg_widget -1 .del_prj_toplvl
    destroy .del_prj_toplvl
  }  ;# Binding f"ur Return im Entry
    # Hinweisfeld
  frame .del_prj_toplvl.entry_f.hint
  pack .del_prj_toplvl.entry_f.hint  -side top  -fill x
  label .del_prj_toplvl.entry_f.hint.l \
    -text "Suffix .project is appended automatically."
  pack .del_prj_toplvl.entry_f.hint.l  -fill x  -expand 1
    # Schalter
  frame .del_prj_toplvl.entry_f.flags  -bd 1
  pack .del_prj_toplvl.entry_f.flags  -side top  -fill x
  checkbutton .del_prj_toplvl.entry_f.flags.delete_all \
    -text "Delete all Data Files" \
    -variable gvar(delete.project.all)  -anchor w
  pack .del_prj_toplvl.entry_f.flags.delete_all \
    -anchor w  -fill x

    # Button-Leiste
  frame .del_prj_toplvl.bfr  -relief raised  -bd 1
  pack .del_prj_toplvl.bfr  -side bottom  -fill both
  button .del_prj_toplvl.bfr.ok  -text "Ok" \
    -command {
      delete_project_file $gvar(delete.project.name) $gvar(delete.project.all)
      .topmen.edit.m entryconfigure "Delete Project"  -state normal
      unset gvar(delete.project.name)
      get_all_projects
      del_dlg_widget -1 .del_prj_toplvl
      destroy .del_prj_toplvl
    }  ;# Kommando zu Ok
  button .del_prj_toplvl.bfr.cancel  -text "Cancel" \
    -command {
      .topmen.edit.m entryconfigure "Delete Project"  -state normal
      unset gvar(delete.project.name)
      del_dlg_widget -1 .del_prj_toplvl
      destroy .del_prj_toplvl
    }  ;# Kommando zu Cancel
  pack .del_prj_toplvl.bfr.ok \
    .del_prj_toplvl.bfr.cancel \
    -side left  -expand 1
  grab set .del_prj_toplvl
}  ;# delete_project

  #####################################
  # Prozeduren f"ur das Project-Men"u #
  #####################################

proc project_list {} {
  # Die Liste aller offenen Projekte anzeigen.
  global open_projects

    # Men"ueintrag abschalten
  .topmen.project.m entryconfigure "Project List"  -state disabled

    # den Dialog aufbauen
  if [catch {set d [toplevel .project_list]}] {
    raise .project_list
    return
  }  ;# if doppelt
  add_dlg_widget -1 $d
  wm title $d "Project List"
  wm protocol $d WM_DELETE_WINDOW "dlg_option_wm_delete -1 $d \
    {.topmen.project.m entryconfigure {Project List}  -state normal}"

    # Eingabebereich mit der Liste und den Scrollbars
  frame .project_list.in
  pack .project_list.in  -side top  -fill both  -expand 1
    # Liste
  listbox .project_list.in.l  -relief raised  -borderwidth 2 \
    -xscrollcommand ".project_list.in.pad.sx set" \
    -yscrollcommand ".project_list.in.sy set" \
    -width 40
    # Liste der offenen Projekte einbauen
  set p [lsort [array names open_projects]]
  foreach el $p {
    if {$el == "open_count"} {
      # do nothing
    } else {
      .project_list.in.l insert end $el
    }  ;# else, nicht die Angabe wieviele Projekte
  }  ;# foreach Projekt in der Liste
  bind .project_list.in.l <Double-Button-1> { \
    set pr [%W get @%x,%y]
    if {[string length $pr] > 0} {
      set pn [lindex $open_projects($pr) 1]
      set prjtoplvlx ".prjtoplvl$pn"
      raise $prjtoplvlx
      .topmen.project.m entryconfigure "Project List"  -state normal
      del_dlg_widget -1 .project_list
      destroy .project_list
      break
    }  ;# if da war was
  }  ;# Binding f"ur einen Eintrag
    # Scrollbars
  scrollbar .project_list.in.sy  -orient vertical \
    -command ".project_list.in.pl yview"
  frame .project_list.in.pad
  scrollbar .project_list.in.pad.sx  -orient horizontal \
    -command ".project_list.in.l xview"
  set pad [expr [.project_list.in.sy cget -width] + 2 * \
    ([.project_list.in.sy cget -bd] + \
     [.project_list.in.sy cget -highlightthickness])]
  frame .project_list.in.pad.it  -width $pad  -height $pad
  pack .project_list.in.pad  -side bottom  -fill x
  pack .project_list.in.pad.it  -side right
  pack .project_list.in.pad.sx  -side bottom  -fill x
  pack .project_list.in.sy  -side right  -fill y
  pack .project_list.in.l  -side left  -expand 1  -fill both

    # Aktionsbereich mit den Buttons
  frame .project_list.ac  -relief raised  -bd 2
  pack .project_list.ac  -side top  -fill x
  button .project_list.ac.ok  -text "Ok" \
    -command { \
      .topmen.project.m entryconfigure "Project List"  -state normal; \
      del_dlg_widget -1 .project_list; \
      destroy .project_list \
    }
  pack .project_list.ac.ok
  grab set .project_list
}  ;# project_list

  #*** Dateiende von pepm.tcl ***

