# projed.tcl, Projekteditoren aufmachen
# begonnen: 28.09.95, last-update: 14.01.97
# BG Abgleich Andre's PFA, Ptak FC2 und Peedy Animator 10.2.98


  ####################################
  # Alles zum Thema Editor aufmachen #
  ####################################

proc open_an_editor {prjnum name} {
  # Den zu name und prjnum zugehrigen Editor aufmachen.
  # prjnum - Projektnummer
  # name   - Editorname (bpn2.normal oder so)

 global gvar 

  switch $name {
    bpn2.normal     {open_editor_by_name $prjnum $name "B(PN)" $gvar(text_editor.name)}
    bpn2.expanded   {open_editor_by_name $prjnum $name "Expanded B(PN)" $gvar(text_editor.name)}
    boxexpr         {open_editor_by_name $prjnum $name "PBC" $gvar(text_editor.name)}
    ll_net          {open_editor_by_name $prjnum $name "LL Net" $gvar(ll_net_editor.name)}
    hl_net          {open_editor_by_name $prjnum $name "HL Net" $gvar(hl_net_editor.name)}
    c_source        {open_editor_by_name $prjnum $name "C Source" $gvar(text_editor.name)}
    formula.normal  {open_editor_by_name $prjnum $name "Formula" $gvar(text_editor.name)}
    doc             {open_editor_by_name $prjnum $name "Document" $gvar(text_editor.name)}
    ina             {open_editor_by_name $prjnum $name "INA" $gvar(ina.name)}
    pfa             {open_editor_by_name $prjnum $name "PFA" $gvar(pfa_editor.name)}
    simulator       {open_editor_by_name $prjnum $name "Simulator" $gvar(simulator.name)}
    animator	    {open_editor_by_name $prjnum $name "Animator" $gvar(animator.name)}
    sdl             {open_editor_by_name $prjnum $name "SDL" $gvar(text_editor.name)}
    sdl_properties  {open_editor_by_name $prjnum $name "SDL Properties" $gvar(text_editor.name)}
    default {
      error_msg "Internal error: Unknown program $name\n\
        in proc open_an_editor"
    }
  }  ;# switch ber den Namen
}  ;# open_an_editor

proc open_editor_by_name {prjnum name menu_entry exec_command} {
  # Den Editor aufmachen.
  # prjnum - Projektnummer
  global gvar

    # Verzeichnis merken
  set actdir [pwd]
    # Projektvariable
  upvar #0 prj$prjnum prjx
    # Menubutton abschalten
  .prjtoplvl$prjnum.mbar.edit.menu.open entryconfigure $menu_entry \
    -state disabled
    # Status des Verbindung eintragen
  set prjx($name.comstate) "comming up"
  if [catch {set prjx($name.server)}] {
  } else {
    unset prjx($name.server)
  }  ;# else, Server l"oschen
    # Hinweis ausgeben, tricky, denn -textvariable geht nicht
  new_project_msg $prjnum "Open $menu_entry Editor ..."
  update idletasks
    # in das passende Verzeichnis wechseln
  cd "$prjx(actdir)"

    # den Editor aufmachen
  set sys_str "exec $exec_command \
    $prjx($name.filename) \
    -prjnum=$prjnum \
    -prjname=$prjx(project.name) \
    -prgtype=$name \
    -color_palette=$gvar(color_palette) \
    -pepcom=$gvar(server_host),$gvar(server_port),$gvar(server_sock) &"
  DEBUG "Aufruf: $sys_str"
  eval $sys_str
    # und wieder zur"uck in das alte Verzeichnis
  cd "$actdir"

    # Warten, bis der Editor gespr"achsbereit ist.
    # "Ubel kompliziert, mu"s aber so sein da prjx kein g"ultiger
    # globaler Variablenname ist.
  set wait1 "tkwait variable prj$prjnum"
  set wait2 "($name.comstate)"
  set wait "$wait1$wait2"
  eval $wait

  # Simulator
  send_open_to_simulator $prjnum $name

}  ;# open_editor_by_name


  ###################################
  # Alles zum Thema Editor zumachen #
  ###################################

proc close_an_editor {prjnum name save_flag} {
  # Den zu name und prjnum zugeh"origen Editor schlie"sen.
  # prjnum - Projektnummer
  # name   - Editorname (bpn2.normal oder so)
  # save_flag - falls "JA", dann Speicher, falls "NEIN", dann eben nicht
  # TODO: INA erst mal definieren
  switch $name {
    bpn2.normal    {close_editor_by_name $prjnum $save_flag $name "B(PN)"}
    bpn2.expanded  {close_editor_by_name $prjnum $save_flag $name "Expanded B(PN)"}
    boxexpr        {close_editor_by_name $prjnum $save_flag $name "PBC"}
    ll_net         {close_editor_by_name $prjnum $save_flag $name "LL Net"}
    hl_net         {close_editor_by_name $prjnum $save_flag $name "HL Net"}
    c_source       {close_editor_by_name $prjnum $save_flag $name "C Source"}
    formula.normal {close_editor_by_name $prjnum $save_flag $name "Formula"}
    doc            {close_editor_by_name $prjnum $save_flag $name "Document"}
    ina            {close_editor_by_name $prjnum $save_flag $name "INA"}
    pfa            {close_editor_by_name $prjnum $save_flag $name "PFA"}
    simulator      {close_editor_by_name $prjnum $save_flag $name "Simulator"}
    animator       {close_editor_by_name $prjnum $save_flag $name "Animator"}
    sdl_properties {close_editor_by_name $prjnum $save_flag $name "SDL Properties"}
    sdl            {close_editor_by_name $prjnum $save_flag $name "SDL"}
    default {
      error_msg "Internal error: Unknown program $name\n\
        in proc close_an_editor"
    }
  }  ;# switch "uber den Namen
}  ;# close_an_editor

proc close_editor_by_name {prjnum save_flag name menu_entry} {
  # Den Editor schlie"sen.
  # prjnum - Projektnummer
  # save_flag - falls "JA", dann Speicher, falls "NEIN", dann eben nicht
    # der Projectvariable einen Namen geben
  upvar #0 prj$prjnum prjx
  if {$prjx($name.comstate) == "connected"} {
      # Hinweis ausgeben
    new_project_msg $prjnum "Closing $menu_entry Editor ..."
    update idletasks
      # Zumachen.
    #puts  $prjx($name.port)
    if [catch {RPC "end_session $save_flag" localhost $prjx($name.port)}] {
      DEBUG "close_editor_by_name ($name) : no connection to the editor"
    }  ;# if Fehler
    .prjtoplvl$prjnum.mbar.edit.menu.open entryconfigure $menu_entry \
      -state normal
  } else {
    DEBUG "close_editor_by_name ($name): editor is closed"
  }  ;# else, Editor war nicht auf
    # Status der Verbindung eintragen
  set prjx($name.comstate) "disconnected"

  # Simulator
  send_close_to_simulator $prjnum $name

}  ;# close_editor_by_name

  #*** Dateiende projed.tcl ***

