# projfr.tcl, Projektfenster aufmachen und verwalten
# begonnen: 06.02.95, last-update: 17.03.97
# BG 24.3.97 versucht minimize HL einzufuehren
# Sollte beim Unfolden jetzt auch funktionieren, wenn die
# Namen vernuenftig sind.
# BG syncmnet gegen pn2mnet ausgetauscht 11.7.97
# CP letzte "Anderung am 06.10.1997
# BG bpn2_c wieder reingenommen 27.11.97
# BG Abgleich Andre's PFA, Ptak FC2, Peedy Animator 10.2.98


  ###################
  # Hilfsfunktionen #
  ###################

proc new_project_msg {project_number msg} {
  # Die Projektstatuszeile wird mit dem neuen Text belegt.
  # project_number - die Nummer der globale Projektvariable
  # msg            - der neue Text
  upvar #0 prj$project_number prjx
  $prjx(prjmsg.widget) configure  -text $msg
}  ;# new_project_msg

proc update_project_infos project_number {
  # Den Inhalt der Informationsanzeige veraendern anhand der
  # Angaben aus der Projektvariablen.
  global gvar

    # Zugriff auf die Projektvariable erlangen
  upvar #0 prj$project_number prjx

    # die allgemeinen Informationen aendern
  $prjx(project.infos.widget).name configure \
    -text "Project  $prjx(project.name) - $prjx(DATE)"
  $prjx(project.infos.widget).comment1 configure \
    -text $prjx(project.comment_1)
  $prjx(project.infos.widget).comment2 configure \
    -text $prjx(project.comment_2)

    # die Angaben zu den Analyseergebnissen anpassen
  $prjx(project.ana.menu.widget) entryconfigure "T-System*" \
    -label "T-System [format_ana_result_string $prjx(ll_net.ana.t_system)]"
  $prjx(project.ana.menu.widget) entryconfigure "FC System*" \
    -label "FC System [format_ana_result_string $prjx(ll_net.ana.free_choice)]"
  $prjx(project.ana.menu.widget) entryconfigure "Safe System*" \
    -label "Safe System [format_ana_result_string $prjx(ll_net.ana.safe)]"
  $prjx(project.ana.menu.widget) entryconfigure "Bounded System*" \
    -label "Bounded System [format_ana_result_string $prjx(ll_net.ana.bounded) \
    $prjx(ll_net.ana.bounded.number)]"
  $prjx(project.ana.menu.widget) entryconfigure "Reachability*" \
    -label "Reachability [format_ana_result_string \
      $prjx(ll_net.ana.reachability)]"
  $prjx(project.ana.menu.widget) entryconfigure "LP Reachability*" \
    -label "LP Reachability [format_ana_result_string \
      $prjx(ll_net.ana.lp_reachability)]"
  $prjx(project.ana.menu.widget) entryconfigure "PO Reachability*" \
    -label "PO Reachability [format_ana_result_string \
      $prjx(ll_net.ana.clp_reachability)]"
  $prjx(project.ana.menu.widget) entryconfigure "PO Mutual Exclusion*" \
    -label "PO Mutual Exclusion [format_ana_result_string \
    $prjx(ll_net.ana.clp_mutex)]"
  $prjx(project.ana.menu.widget) entryconfigure "Deadlock-free System*" \
    -label "Deadlock-free System [format_ana_result_string \
    $prjx(unfolding.text.ana.deadlock_free)]"
  $prjx(project.ana.menu.widget) entryconfigure "CTL Model Checker (T-System)*" \
    -label "CTL Model Checker (T-System) [format_ana_result_string \
    $prjx(ll_net.ana.model_check_t_system)]"
  $prjx(project.ana.menu.widget) entryconfigure "CTL Model Checker (Safe)*" \
    -label "CTL Model Checker (Safe) [format_ana_result_string \
    $prjx(unfolding.text.ana.model_check_safe)]"
  $prjx(project.ana.menu.widget) entryconfigure "LTL Model Checker (SPIN)*" \
    -label "LTL Model Checker (SPIN) [format_ana_result_string \
    $prjx(promela.text.ana.model_check_spin)]"
  $prjx(project.ana.menu.widget) entryconfigure "CTL Model Checker (SMV)*" \
    -label "CTL Model Checker (SMV) [format_ana_result_string \
    $prjx(unfolding.text.ana.model_check_smv)]"
  $prjx(project.ana.menu.widget) entryconfigure "LTL Model Checker (unfsmodels)*" \
    -label "LTL Model Checker (unfsmodels) [format_ana_result_string \
    $prjx(unfolding.text.ana.model_check_unfsmodels)]"
  $prjx(project.ana.menu.widget) entryconfigure "LTL Model Checker (boundsmodels)*" \
    -label "LTL Model Checker (boundsmodels) [format_ana_result_string \
    $prjx(ll_net.ana.model_check_boundsmodels)]"
  $prjx(project.ana.menu.widget) entryconfigure "LTL Model Checker (qq)*" \
    -label "LTL Model Checker (qq) [format_ana_result_string \
    $prjx(unfolding.text.ana.model_check_qq)]"

}  ;# update_project_infos

  ############################
  # Callbacks fuer Edit-Menu #
  ############################

proc prj_edit_project_info {} {
  # Die Projektkommentare editieren.
  global gvar

    # die Projektnummer abholen
  set prjnum $gvar(actprj)
    # der Projectvariable einen Namen geben
  upvar #0 prj$prjnum prjx

    # Neues TopLevel fuer die Editierung der Kommentare
  if [catch {set d [toplevel .prjedi$prjnum]}] {
    raise .prjedi$prjnum
    return
  }  ;# if doppelt
  add_dlg_widget $prjnum $d
  wm title $d "Edit Infos, Project $prjx(project.name)"
  wm protocol $d WM_DELETE_WINDOW "dlg_option_wm_delete $prjnum $d"

    # Frame fuer die Eingabezeilen
  frame $d.input  -bd 2
  pack $d.input  -side top  -fill both  -expand 1
  set gvar(project.$prjnum.comment_1) $prjx(project.comment_1)
  set gvar(project.$prjnum.comment_2) $prjx(project.comment_2)
  entry $d.input.comment_1  -width 40  -relief sunken  -bd 2 \
    -textvariable gvar(project.$prjnum.comment_1)
  entry $d.input.comment_2  -width 40  -relief sunken  -bd 2 \
    -textvariable gvar(project.$prjnum.comment_2)
  pack $d.input.comment_1 \
    $d.input.comment_2 \
    -side top

    # Frame fuer die Buttons
  frame $d.buttons  -relief raised  -bd 1
  pack $d.buttons  -side bottom  -fill x
  button $d.buttons.ok  -text "Ok" \
    -command {
        # prjnum ist per Binding bekannt
      upvar #0 prj$prjnum prjx; \
      set prjx(project.comment_1) $gvar(project.$prjnum.comment_1)
      set prjx(project.comment_2) $gvar(project.$prjnum.comment_2)
      unset gvar(project.$prjnum.comment_1)
      unset gvar(project.$prjnum.comment_2)
      del_dlg_widget $prjnum .prjedi$prjnum
      destroy .prjedi$prjnum
      update_project_infos $prjnum
    }  ;# Kommando des Buttons
  bind $d.buttons.ok <Enter> {
    set prjnum [strip_prj_num %W]
  }  ;# Binding zum Ok-Button
  button $d.buttons.cancel -text "Cancel" -command {
      unset gvar(project.$prjnum.comment_1)
      unset gvar(project.$prjnum.comment_2)
      del_dlg_widget $prjnum .prjedi$prjnum
      destroy .prjedi$prjnum
  }
  pack $d.buttons.cancel $d.buttons.ok -side left -fill both -expand yes
}  ;# prj_edit_project_info

proc prj_save_prj_info {} {
  # Die Projektdatei speichern, nicht die zugehoerigen Dateien.
  global gvar

    # die Projektnummer abholen
  set prjnum $gvar(actprj)
    # der Projectvariable einen Namen geben
  upvar #0 prj$prjnum prjx
    # die Projektdatei speichern
  write_project $prjx(project.filename) prjx
  new_project_msg $prjnum "Project Info saved"
}  ;# prj_save_prj_info

proc prj_save_entire_project {} {
  # Die Projektdatei speichern, inklusive der zugehoerigen Dateien.
  global gvar

    # die Projektnummer abholen
  set prjnum $gvar(actprj)
    # der Projectvariable einen Namen geben
  upvar #0 prj$prjnum prjx

    # B(PN) Kram erledigen
  if [string compare $prjx(bpn2.normal.comstate) "connected"] {
  } else {
      # Hinweis ausgeben
    new_project_msg $prjnum "Saving B(PN) ..."
    RPC "save_editor_contents $prjx(bpn2.normal.filename)" \
       $prjx(bpn2.normal.host) $prjx(bpn2.normal.port) 
  }  ;# if Editor ist auf und gespraechsbereit

    # Expanded B(PN) Kram erledigen
  if [string compare $prjx(bpn2.expanded.comstate) "connected"] {
  } else {
      # Hinweis ausgeben
    new_project_msg $prjnum "Saving Expanded B(PN) ..."
    RPC "save_editor_contents $prjx(bpn2.expanded.filename)"\
       $prjx(bpn2.expanded.host) $prjx(bpn2.expanded.port) 
  }  ;# if Editor ist auf und gespraechsbereit

    # BoxExpr Kram erledigen
  if [string compare $prjx(boxexpr.comstate) "connected"] {
  } else {
      # Hinweis ausgeben
    new_project_msg $prjnum "Saving PBC ..."
    RPC "save_editor_contents $prjx(boxexpr.filename)"\
       $prjx(boxexpr.host) $prjx(boxexpr.port) 
  }  ;# if Editor ist auf und gespraechsbereit

    # LL-Netz Kram erledigen
  if [string compare $prjx(ll_net.comstate) "connected"] {
  } else {
      # Hinweis ausgeben
    new_project_msg $prjnum "Saving LL Net ..."
    RPC "save_editor_contents $prjx(ll_net.filename)"\
      $prjx(ll_net.host) $prjx(ll_net.port)
  }  ;# if Editor ist auf und gespraechsbereit

    # HL-Netz Kram erledigen
  if [string compare $prjx(hl_net.comstate) "connected"] {
  } else {
      # Hinweis ausgeben
    new_project_msg $prjnum "Saving HL Net ..."
    RPC "save_editor_contents $prjx(hl_net.filename)" \
      $prjx(hl_net.host) $prjx(hl_net.port)
  }  ;# if Editor ist auf und gespraechsbereit

    # C-Source Kram erledigen ( TODO )
  if [string compare $prjx(c_source.comstate) "connected"] {
  } else {
      # Hinweis ausgeben
    new_project_msg $prjnum "Saving C Source ..."
    RPC "save_editor_contents $prjx(c_source.filename)" \
      $prjx(c_source.host) $prjx(c_source.port)
  }  ;# if Editor ist auf und gespraechsbereit

    # Formel Kram erledigen
  if [string compare $prjx(formula.normal.comstate) "connected"] {
  } else {
      # Hinweis ausgeben
    new_project_msg $prjnum "Saving Formula ..."
    RPC "save_editor_contents $prjx(formula.normal.filename)" \
       $prjx(formula.normal.host) $prjx(formula.normal.port)
  }  ;# if Editor ist auf und gespraechsbereit

    # Doc Kram erledigen
  if [string compare $prjx(doc.comstate) "connected"] {
  } else {
      # Hinweis ausgeben
    new_project_msg $prjnum "Saving Document ..."
    RPC "save_editor_contents $prjx(doc.filename)" \
      $prjx(doc.host) $prjx(doc.port)
  }  ;# if Editor ist auf und gespraechsbereit

#TODO
# all this for smv, spin & unfolding.text ???
# ... only if editors available!

    # die Projektdatei speichern
  write_project $prjx(project.filename) prjx
  new_project_msg $prjnum "Project Complete saved"
}  ;# prj_save_entire_project

  #################################
  # Allgemeine Projekt-Callback's #
  #################################

proc prj_close save_flag {
  # Evtl. noch die Editoren schliessen u.a.
  # Die Projektdatei wird auf jeden Fall gespeichert!
  # save_flag - JA oder NEIN fuer die Sicherung
  global gvar

    # die Projektnummer abholen
  set prjnum $gvar(actprj)
    # der Projectvariable einen Namen geben
  upvar #0 prj$prjnum prjx

   # Die Fenstergroesse in der Projektvariablen abspeichern
  scan [wm geometry .prjtoplvl$prjnum] "%dx%d%s" width height position
  set prjx(view.window,width) $width
  set prjx(view.window,height) $height

  close_an_editor $prjnum "bpn2.normal" $save_flag
  close_an_editor $prjnum "bpn2.expanded" $save_flag
  close_an_editor $prjnum "boxexpr" $save_flag
  close_an_editor $prjnum "ll_net" $save_flag
  close_an_editor $prjnum "hl_net" $save_flag
  close_an_editor $prjnum "c_source" $save_flag
  close_an_editor $prjnum "formula.normal" $save_flag
  close_an_editor $prjnum "doc" $save_flag
  close_an_editor $prjnum "ina" $save_flag
  close_an_editor $prjnum "pfa" $save_flag
  close_an_editor $prjnum "simulator" $save_flag
  close_an_editor $prjnum "animator" $save_flag
  close_an_editor $prjnum "sdl" $save_flag
  close_an_editor $prjnum "sdl_properties" $save_flag ;# PTAK

  dlg_option_prj_close $prjnum

    # Die naechste Zeile ist sauwichtig, denne (nach 2 Stunden hatte ich
    # es endlich raus) sonst wird ein evtl. Abspeichern und eine somit
    # erforderliche Aenderung der Referenzen NACH dem Speichern der
    # Projektdatei vorgenommen.
# TODO: pr"ufen!!
  # dp_update

    # Projektdatei speichern
  write_project $prjx(project.filename) prjx
    # aus der Liste der offenen Projekte entfernen
  delete_open_project $prjx(actdir) $prjx(project.filename)
}  ;# prj_close

proc prj_wm_delete {prjnum} {
  # Der Benutzer haette das Projektfenster gerne geschlossen.
  # Der Aufruf kam vom Window-Manager.
  global gvar

  prj_close "JA"
  set gvar(prjcount) [expr $gvar(prjcount)-1]
  destroy .prjtoplvl$prjnum
}  ;# prj_wm_delete

proc init_view_defaults {{projType 0}} {
 # setzen der defaults fuer die Ansicht im Projektfenster
  global gvar

   # Achtung bei den Koordinaten fuer die Pfeile:
   # Pfeil gvar(default.view.von->nach) von (x1,y1) ueber (x2,y2) nach (x3,y3)
   # Quelle und Ziel werden als Distanz zum jeweiligen Icon angegeben
   # Der mittlere Punkt wird in absoluten Koordinaten angegeben!

 # Alles zwischen diesen Markierungen kan mit der
 # Prozedur save_view_to_file (util.tcl) in eine Datei gespeichert
 # und dann hier eingefuegt werden!

###############################
# 
  set gvar(default.view.boxexpr,show) 1
  set gvar(default.view.boxexpr,x) 357
  set gvar(default.view.boxexpr,y) 184
  set gvar(default.view.boxexpr->ll_net,show) 1
  set gvar(default.view.boxexpr->ll_net,x1) 14
  set gvar(default.view.boxexpr->ll_net,x2) 371
  set gvar(default.view.boxexpr->ll_net,x3) 47
  set gvar(default.view.boxexpr->ll_net,y1) 42
  set gvar(default.view.boxexpr->ll_net,y2) 266
  set gvar(default.view.boxexpr->ll_net,y3) -4
  set gvar(default.view.bpn2.expanded,show) 1
  set gvar(default.view.bpn2.expanded,x) 208
  set gvar(default.view.bpn2.expanded,y) 151
  set gvar(default.view.bpn2.expanded->hl_net,show) 1
  set gvar(default.view.bpn2.expanded->hl_net,x1) -34
  set gvar(default.view.bpn2.expanded->hl_net,x2) 146
  set gvar(default.view.bpn2.expanded->hl_net,x3) 45
  set gvar(default.view.bpn2.expanded->hl_net,y1) 39
  set gvar(default.view.bpn2.expanded->hl_net,y2) 211
  set gvar(default.view.bpn2.expanded->hl_net,y3) -30
  set gvar(default.view.bpn2.normal,show) 1
  set gvar(default.view.bpn2.normal,x) 344
  set gvar(default.view.bpn2.normal,y) 53
  set gvar(default.view.bpn2.normal->boxexpr,show) 1
  set gvar(default.view.bpn2.normal->boxexpr,x1) 18
  set gvar(default.view.bpn2.normal->boxexpr,x2) 367
  set gvar(default.view.bpn2.normal->boxexpr,x3) 11
  set gvar(default.view.bpn2.normal->boxexpr,y1) 42
  set gvar(default.view.bpn2.normal->boxexpr,y2) 121
  set gvar(default.view.bpn2.normal->boxexpr,y3) -42
  set gvar(default.view.bpn2.normal->bpn2.expanded,show) 1
  set gvar(default.view.bpn2.normal->bpn2.expanded,x1) -45
  set gvar(default.view.bpn2.normal->bpn2.expanded,x2) 272
  set gvar(default.view.bpn2.normal->bpn2.expanded,x3) 43
  set gvar(default.view.bpn2.normal->bpn2.expanded,y1) 22
  set gvar(default.view.bpn2.normal->bpn2.expanded,y2) 92
  set gvar(default.view.bpn2.normal->bpn2.expanded,y3) -33
  set gvar(default.view.bpn2.normal->c_source,show) 1
  set gvar(default.view.bpn2.normal->c_source,x1) 45
  set gvar(default.view.bpn2.normal->c_source,x2) 404
  set gvar(default.view.bpn2.normal->c_source,x3) -47
  set gvar(default.view.bpn2.normal->c_source,y1) 1
  set gvar(default.view.bpn2.normal->c_source,y2) 54
  set gvar(default.view.bpn2.normal->c_source,y3) 3
  set gvar(default.view.bpn2.normal->hl_net,show) 1
  set gvar(default.view.bpn2.normal->hl_net,x1) -23
  set gvar(default.view.bpn2.normal->hl_net,x2) 276
  set gvar(default.view.bpn2.normal->hl_net,x3) 47
  set gvar(default.view.bpn2.normal->hl_net,y1) 41
  set gvar(default.view.bpn2.normal->hl_net,y2) 223
  set gvar(default.view.bpn2.normal->hl_net,y3) -5
  set gvar(default.view.c_source,show) 1
  set gvar(default.view.c_source,x) 467
  set gvar(default.view.c_source,y) 51
  set gvar(default.view.doc,show) 1
  set gvar(default.view.doc,x) 466
  set gvar(default.view.doc,y) 150
  set gvar(default.view.editable) 0
  set gvar(default.view.fc2,show) 1
  set gvar(default.view.fc2,x) 257
  set gvar(default.view.fc2,y) 366
  set gvar(default.view.formula.normal,show) 1
  set gvar(default.view.formula.normal,x) 462
  set gvar(default.view.formula.normal,y) 254
  set gvar(default.view.hl_net,show) 1
  set gvar(default.view.hl_net,x) 77
  set gvar(default.view.hl_net,y) 247
  set gvar(default.view.hl_net->ll_net,show) 1
  set gvar(default.view.hl_net->ll_net,x1) 47
  set gvar(default.view.hl_net->ll_net,x2) 160
  set gvar(default.view.hl_net->ll_net,x3) -47
  set gvar(default.view.hl_net->ll_net,y1) 20
  set gvar(default.view.hl_net->ll_net,y2) 272
  set gvar(default.view.hl_net->ll_net,y3) 1
  set gvar(default.view.ina,show) 1
  set gvar(default.view.ina,x) 162
  set gvar(default.view.ina,y) 366
  set gvar(default.view.ll_net,show) 1
  set gvar(default.view.ll_net,x) 259
  set gvar(default.view.ll_net,y) 265
  set gvar(default.view.ll_net->fc2,show) 1
  set gvar(default.view.ll_net->fc2,x1) -1
  set gvar(default.view.ll_net->fc2,x2) 259
  set gvar(default.view.ll_net->fc2,x3) 0
  set gvar(default.view.ll_net->fc2,y1) 42
  set gvar(default.view.ll_net->fc2,y2) 318
  set gvar(default.view.ll_net->fc2,y3) -35
  set gvar(default.view.ll_net->ina,show) 1
  set gvar(default.view.ll_net->ina,x1) -36
  set gvar(default.view.ll_net->ina,x2) 202
  set gvar(default.view.ll_net->ina,x3) 26
  set gvar(default.view.ll_net->ina,y1) 39
  set gvar(default.view.ll_net->ina,y2) 318
  set gvar(default.view.ll_net->ina,y3) -31
  set gvar(default.view.ll_net->smv,show) 1
  set gvar(default.view.ll_net->smv,x1) 31
  set gvar(default.view.ll_net->smv,x2) 328
  set gvar(default.view.ll_net->smv,x3) -25
  set gvar(default.view.ll_net->smv,y1) 38
  set gvar(default.view.ll_net->smv,y2) 313
  set gvar(default.view.ll_net->smv,y3) -32
  set gvar(default.view.ll_net->spin,show) 1
  set gvar(default.view.ll_net->spin,x1) 47
  set gvar(default.view.ll_net->spin,x2) 410
  set gvar(default.view.ll_net->spin,x3) -26
  set gvar(default.view.ll_net->spin,y1) 17
  set gvar(default.view.ll_net->spin,y2) 307
  set gvar(default.view.ll_net->spin,y3) -29
  set gvar(default.view.ll_net->unfolding.text,show) 1
  set gvar(default.view.ll_net->unfolding.text,x1) -47
  set gvar(default.view.ll_net->unfolding.text,x2) 132
  set gvar(default.view.ll_net->unfolding.text,x3) 21
  set gvar(default.view.ll_net->unfolding.text,y1) 17
  set gvar(default.view.ll_net->unfolding.text,y2) 295
  set gvar(default.view.ll_net->unfolding.text,y3) -34
  set gvar(default.view.pfa,show) 1
  set gvar(default.view.pfa,x) 175
  set gvar(default.view.pfa,y) 51
  set gvar(default.view.pfa->bpn2.normal,show) 1
  set gvar(default.view.pfa->bpn2.normal,x1) 47
  set gvar(default.view.pfa->bpn2.normal,x2) 286
  set gvar(default.view.pfa->bpn2.normal,x3) -47
  set gvar(default.view.pfa->bpn2.normal,y1) -9
  set gvar(default.view.pfa->bpn2.normal,y2) 32
  set gvar(default.view.pfa->bpn2.normal,y3) -19
  set gvar(default.view.pfa->hl_net,show) 1
  set gvar(default.view.pfa->hl_net,x1) -19
  set gvar(default.view.pfa->hl_net,x2) 155
  set gvar(default.view.pfa->hl_net,x3) 37
  set gvar(default.view.pfa->hl_net,y1) 41
  set gvar(default.view.pfa->hl_net,y2) 149
  set gvar(default.view.pfa->hl_net,y3) -40
  set gvar(default.view.sdl,show) 1
  set gvar(default.view.sdl,x) 66
  set gvar(default.view.sdl,y) 120
  set gvar(default.view.sdl->hl_net,x1) -6
  set gvar(default.view.sdl->hl_net,y1) 42
  set gvar(default.view.sdl->hl_net,x2) 60
  set gvar(default.view.sdl->hl_net,y2) 177
  set gvar(default.view.sdl->hl_net,x3) -11
  set gvar(default.view.sdl->hl_net,y3) -42
  set gvar(default.view.sdl->hl_net,show) 1
  set gvar(default.view.smv,show) 1
  set gvar(default.view.smv,x) 372
  set gvar(default.view.smv,y) 366
  set gvar(default.view.spin,show) 1
  set gvar(default.view.spin,x) 468
  set gvar(default.view.spin,y) 363
  set gvar(default.view.unfolding.text,show) 1
  set gvar(default.view.unfolding.text,x) 59
  set gvar(default.view.unfolding.text,y) 367
  set gvar(default.view.window,height) 609
  set gvar(default.view.window,width) 523
#
###############################

   # von den Icons ausgehende Pfeile:
  set gvar(view.doc,arrow_to) {}
  set gvar(view.pfa,arrow_to) {hl_net bpn2.normal}
  set gvar(view.bpn2.normal,arrow_to) {hl_net bpn2.expanded boxexpr c_source}
  set gvar(view.bpn2.expanded,arrow_to) {hl_net}
  set gvar(view.hl_net,arrow_to) {ll_net}
  set gvar(view.boxexpr,arrow_to) {ll_net}
  set gvar(view.ll_net,arrow_to) {unfolding.text ina smv spin fc2}
  set gvar(view.formula.normal,arrow_to) {}
  set gvar(view.unfolding.text,arrow_to) {}
  set gvar(view.ina,arrow_to) {}
  set gvar(view.smv,arrow_to) {}
  set gvar(view.spin,arrow_to) {}
  set gvar(view.fc2,arrow_to) {}
  set gvar(view.c_source,arrow_to) {}
  set gvar(view.sdl,arrow_to) {hl_net}
   # eingehende Pfeile ermitteln:
  foreach i $gvar(view.icon_list) {
    set gvar(view.$i,arrow_from) {}
  }
  foreach i $gvar(view.icon_list) {
    foreach j $gvar(view.$i,arrow_to) {
      lappend gvar(view.$j,arrow_from) $i
    }
  }
} ;# init_view_defaults

proc graphViewLoadPepDefault prj_num {
  # setzt koordinaten usw. des projekts auf pep-defaults
  # prj_num -> project number
  global gvar
    # Zugriff auf die Projektvariable erhalten
  upvar #0 prj$prj_num prjx

    # alle Variablen mit gvar(default.view.*) in die
    # Projektvariable kopieren
  foreach variable [array names gvar default.view.*] {
     # "default." vom namen der variablen abschneiden
    set v [string range $variable 8 end]
    set prjx($v) $gvar($variable)
  }
} ;# graphViewLoadPepDefault

proc graphViewLoadUserDefault prj_num {
  # setzt koordinaten usw. des projekts auf user-defaults
  # prj_num -> project number
  global gvar viewrc
    # Zugriff auf die Projektvariable erhalten
  upvar #0 prj$prj_num prjx

  foreach variable [array names viewrc view.*] {
    set prjx($variable) $viewrc($variable)
  }
   # Default: nicht editierbar!
  set prjx(view.editable) 0
} ;# graphViewLoadUserDefault 

proc graphViewInit {pn project} {
 # Initialisiert die Koordinaten usw. fuer die Projektansicht
 # pn      -> Projekt-Nummer
 # project -> projektvariable

  global gvar viewrc
  upvar $project prj

    # alle Variablen mit gvar(default.view.*) in die
    # Projektvariable kopieren

   foreach variable [array names gvar default.view.*] {
      # "default." vom namen der variablen abschneiden
     set v [string range $variable 8 end]
      # Existiert die Variable? Ja   -> gut so!
                           #    Nein -> auf User-Default setzen
     if [catch {set prj($v)}] {
        # Existiert hierfuer User-Default?  Ja   -> hierauf setzen
	                            #       Nein -> auf PEP-Default setzen
       if [catch {set viewrc($v)}] {
         set prj($v) $gvar($variable)
       } else {
         set prj($v) $viewrc($v)
       }
     }
   }
} ;# graphViewInit

proc viewStartConverter {prj_num Name} {
 # startet den durch $Name angegebenen Konverter

  switch $Name {
    bpn2.normal->hl_net {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "B(PN) -> HL Net"
     }
    bpn2.normal->boxexpr {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "B(PN) -> PBC"
     }
    boxexpr->ll_net {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "PBC -> LL Net"
     }
    bpn2.expanded->hl_net {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "Expanded B(PN) -> HL Net"
     }
    hl_net->ll_net {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "HL Net -> LL Net"
     }
    bpn2.normal->bpn2.expanded {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "B(PN) -> Expanded B(PN)"
     }
    pfa->bpn2.normal {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "PFA -> B(PN)"
     }
    pfa->hl_net {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "PFA -> HL Net"
     }
    ll_net->unfolding.text {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "LL Net -> Prefix"
     }
    ll_net->ina {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "LL Net -> INA"
     }
    ll_net->spin {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "LL Net -> SPIN"
     }
    ll_net->fc2 {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "LL Net -> FC2"
     }
    bpn2.normal->c_source {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "B(PN) -> C Source"
     }
    ll_net->smv {
      # Fuer diesen Pfeil gibt es keinen Konverter!
     }
    sdl->hl_net {
      .prjtoplvl$prj_num.mbar.exe.menu invoke "SDL -> HL Net"
     }
    default {
      error_msg "Internal Error!\n\n \
                 which Converter shall I use?\n \
                 Choose One from the Execute Menu!"
     }
  }
} ;# viewStartConverter

proc viewOpenOptionsDlg {prj_num Name} {
 # oeffnet den Dialog mit den Optionen  fuer den
 # durch $Name angegebenen Konverter
  upvar #0 prj$prj_num prjx

  $prjx(infotext_1.widget) configure -text " "
  $prjx(infotext_2.widget) configure -text " "
  switch $Name {
    pfa->hl_net {
      .prjtoplvl$prj_num.mbar.option.menu.conv invoke "PFA -> HL Net"
     }
    ll_net->spin {
      .prjtoplvl$prj_num.mbar.option.menu.conv invoke "LL Net -> SPIN"
     }
    ll_net->ina {
      .prjtoplvl$prj_num.mbar.option.menu.conv invoke "LL Net -> INA"
     }
    hl_net->ll_net {
      .prjtoplvl$prj_num.mbar.option.menu.conv invoke "HL Net -> LL Net"
     }
    bpn2.normal->boxexpr {
      .prjtoplvl$prj_num.mbar.option.menu.conv invoke "B(PN) -> PBC"
     }
    bpn2.normal->hl_net {
      .prjtoplvl$prj_num.mbar.option.menu.conv invoke "B(PN) -> HL Net"
     }
    boxexpr->ll_net {
      .prjtoplvl$prj_num.mbar.option.menu.conv invoke "PBC -> LL Net"
     }
    bpn2.normal->bpn2.expanded {
      .prjtoplvl$prj_num.mbar.option.menu.conv invoke "B(PN) Expander"
     }
    bpn2.expanded->hl_net {
      .prjtoplvl$prj_num.mbar.option.menu.conv invoke "B(PN) -> HL Net"
     }
    ll_net->unfolding.text {
      .prjtoplvl$prj_num.mbar.option.menu.conv invoke "Prefix Builder"
     }
    ll_net->smv {
      $prjx(infotext_1.widget) configure \
      -text "Click Right on the Model Checker (SMV) Icon to get Options!"
     }
    pfa->bpn2.normal {
      .prjtoplvl$prj_num.mbar.option.menu.conv invoke "PFA -> B(PN)"
     }
    ll_net->fc2 {
      $prjx(infotext_1.widget) configure \
        -text "No options available for LL Net -> FC2"
     }
    bpn2.normal->c_source {
      $prjx(infotext_1.widget) configure \
        -text "No options available for B(PN) -> C Source"
     }
    sdl->hl_net {
      $prjx(project.option.menu.widget).conv invoke "SDL -> HL Net"
    }
    smv {
      $prjx(project.option.menu.widget).conv invoke "CTL Model Checker (SMV)"
    }
    unfolding.text {
      $prjx(project.option.menu.widget).conv invoke "CTL Model Checker (Safe)"
    }
    fc2 {
    }
    ina {
    }
    spin {
      $prjx(project.option.menu.widget).conv invoke "LTL Model Checker (SPIN)"
    }
    default {
      ; # error_msg "No Options available for $Name !"
     }
  }
} ;# viewOpenOptionsDlg

proc viewChangeEditState {prj_num} {
# wechsel zwischen editierbar oder nicht
# - Menupunkte disable/enable
# - Neue Bindings (durch komplettes neuzeichnen)
  upvar #0 prj$prj_num prjx
  if {$prjx(view.editable)} {
    .prjtoplvl$prj_num.mbar.view.menu entryconfigure {Show icons:} \
      -state normal
    .prjtoplvl$prj_num.mbar.view.menu entryconfigure {Show references:} \
      -state normal
     # Damit die Bindings stimmen... alles neu zeichnen!
    graphViewDrawAll .prjtoplvl$prj_num $prj_num
    $prjx(infotext_1.widget) configure -text "You can edit your Project View!"
    $prjx(infotext_2.widget) configure -text "Use the menu to show or hide items"
    $prjx(prjmsg.widget) configure -text "Move the items by dragging them with the mouse"
  } else {
    .prjtoplvl$prj_num.mbar.view.menu entryconfigure {Show icons:} \
      -state disabled
    .prjtoplvl$prj_num.mbar.view.menu entryconfigure {Show references:} \
      -state disabled
     # Damit die Bindings stimmen... alles neu zeichnen!
    graphViewDrawAll .prjtoplvl$prj_num $prj_num
     # update der Referenzen(anzeige)
    update_project_graph_files $prj_num
    $prjx(infotext_1.widget) configure -text " "
    $prjx(infotext_2.widget) configure -text " "
    $prjx(prjmsg.widget) configure -text "Left View Edit-mode..."
  }
} ;# viewChangeEditState

proc viewIconUpdate {prj_num name} {
 # loescht oder zeichnet die Icons
 # prj_num -> Projekt-Nummer
 # name    -> Name der Box
  upvar prj$prj_num prjx
  global gvar

  # ggf. erst eimal arrowEditPoints entfernen
  .prjtoplvl$prj_num.cnvs delete arrowEditPoint
  if {$prjx(view.$name,show)==1} {
     # icon soll dargestellt werden -> tun wir es!
    viewIconDraw .prjtoplvl$prj_num $prj_num $name
     # eventuell Pfeile Zeichnen?

    foreach pfeil_nach $gvar(view.$name,arrow_to) {
      viewArrowDraw .prjtoplvl$prj_num $prj_num $name $pfeil_nach
    }
    foreach pfeil_von $gvar(view.$name,arrow_from) {
      viewArrowDraw .prjtoplvl$prj_num $prj_num $pfeil_von $name
    }
     # Menu update
    viewMenuUpdate $prj_num
  } else {
     # icon loeschen
    .prjtoplvl$prj_num.cnvs delete icon$name
     # pfeile loeschen
    .prjtoplvl$prj_num.cnvs delete arrow_$name
     # Menu update
    viewMenuUpdate $prj_num
  }
} ;# viewIconUpdate

proc viewArrowUpdate { pn von nach } {
 # Ein/Ausschalten einzelner Referenz-Pfeile
 # pn   -> project number
 # von  -> Pfeil-Ursprung
 # nach -> Pfeil-Ziel
  upvar #0 prj$pn prjx

  if $prjx(view.$von->$nach,show) {
    viewArrowDraw .prjtoplvl$pn $pn $von $nach
  } else {
    .prjtoplvl$pn.cnvs delete arrow$von->$nach
  }
} ;# viewArrowUpdate

proc viewMenuUpdate {prj_num} {
 # aendert den Status der Menueintraege im View-Menu
 # (enable/disable references)
  global gvar
  upvar #0 prj$prj_num prjx

  foreach arrowSrc $gvar(view.icon_list) {
    foreach arrowDest $gvar(view.$arrowSrc,arrow_to) {
      if [expr $prjx(view.$arrowSrc,show) && $prjx(view.$arrowDest,show)] {
        .prjtoplvl$prj_num.mbar.view.menu.refs entryconfigure \
	  "$gvar(view.$arrowSrc.name) -> $gvar(view.$arrowDest.name)" \
	  -state normal
      } else {
        .prjtoplvl$prj_num.mbar.view.menu.refs entryconfigure \
	  "$gvar(view.$arrowSrc.name) -> $gvar(view.$arrowDest.name)" \
	  -state disabled
      }
    }
  }
} ;# viewMenuUpdate

proc viewEditDefaults { mode prj_num } {
  switch $mode {
    LoadPEP {
       # PEP Defaults laden
      graphViewLoadPepDefault $prj_num
       # Fenstergroesse korrigieren
      upvar #0 prj$prj_num prjx
      wm geometry .prjtoplvl$prj_num \
          $prjx(view.window,width)x$prjx(view.window,height)
       # Alles neu zeichnen
      graphViewDrawAll .prjtoplvl$prj_num $prj_num
       # Menueintraege korrigieren, infos updaten
      viewMenuUpdate $prj_num
      update_project_graph_files $prj_num
      viewChangeEditState $prj_num
    }
    SetUser {
        # User Defaults in .pep_viewrc schreiben
      save_viewrc_file $prj_num
    }
    LoadUser {
       # User Defaults laden 
      graphViewLoadUserDefault $prj_num
       # Fenstergroesse korrigieren
      upvar #0 prj$prj_num prjx
      wm geometry .prjtoplvl$prj_num \
          $prjx(view.window,width)x$prjx(view.window,height)
       # Alles neu zeichnen
      graphViewDrawAll .prjtoplvl$prj_num $prj_num
       # Menueintraege korrigieren, infos updaten
      viewMenuUpdate $prj_num
      update_project_graph_files $prj_num
      viewChangeEditState $prj_num
    }
    default {
      error_msg "Internal Error!\n\
                 Unknown mode in proc viewEditDefaults: $mode"
    }
  }
}

  ################################
  # Das Projektfenster aufmachen #
  ################################
proc new_project_frame project {
  # Ein neues Projekt auf den Schirm bringen.
  global gvar

    # Zugriff auf die Projektvariable erhalten
  upvar $project prj
    # neue Projektnummer zwischenspeichern
  set pn $gvar(prjlevel)
    # in die Liste der offenen Projekte eintragen
  insert_open_project $prj(actdir) $prj(project.filename) $prj(project.name) $pn

    # Com-Status eintragen
  set prj(bpn2.normal.comstate) "disconnected"
  set prj(bpn2.expanded.comstate) "disconnected"
  set prj(boxexpr.comstate) "disconnected"
  set prj(ll_net.comstate) "disconnected"
  set prj(hl_net.comstate) "disconnected"
  set prj(c_source.comstate) "disconnected"
  set prj(formula.normal.comstate) "disconnected"
  set prj(doc.comstate) "disconnected"
  set prj(help.view.comstate) "disconnected"
  set prj(ina.comstate) "disconnected"
  set prj(pfa.comstate) "disconnected"
  # Simulator
  set prj(simulator.comstate) "disconnected"
  set prj(animator.comstate) "disconnected"
  set prj(sdl.comstate) "disconnected"
  set prj(sdl_properties.comstate) "disconnected"

    # Top-Level f"ur dieses Projekt erzeugen
  toplevel .prjtoplvl$pn
  wm title .prjtoplvl$pn "Project $prj(project.name)"
  wm protocol .prjtoplvl$pn WM_DELETE_WINDOW "prj_wm_delete $pn"
  wm minsize .prjtoplvl$pn 350 300

    # Kopfleiste f"ur das Pulldown
  frame .prjtoplvl$pn.mbar  -relief raised  -bd 2
  pack .prjtoplvl$pn.mbar  -side top  -fill x

    # Edit-Button und Edit-Menu
  menubutton .prjtoplvl$pn.mbar.edit  -text "Edit" \
    -underline 0  -menu .prjtoplvl$pn.mbar.edit.menu
  set em [menu .prjtoplvl$pn.mbar.edit.menu  -tearoff 0]
  $em add cascade  -label "Open"  -menu $em.open  -underline 0
  $em add command  -label "Edit Project Info" \
    -command {prj_edit_project_info}  -underline 0
  $em add separator
  $em add command  -label "Save Project Info" \
    -command {prj_save_prj_info}  -underline 13
  $em add command  -label "Save entire Project" \
    -command {prj_save_entire_project} -underline 13
  $em add separator
  $em add cascade  -label "Close"  -menu $em.close  -underline 0
    # Edit-Open-Menu
  set eo [menu $em.open  -tearoff 0]
  $eo add command  -label "B(PN)"  -underline 0 \
    -command {open_an_editor $gvar(actprj) "bpn2.normal"}
  $eo add command  -label "Expanded B(PN)"  -underline 0 \
    -command {open_an_editor $gvar(actprj) "bpn2.expanded"}
  $eo add command  -label "PBC"  -underline 0 \
    -command {open_an_editor $gvar(actprj) "boxexpr"}
  $eo add command  -label "LL Net"  -underline 0 \
    -command {open_an_editor $gvar(actprj) "ll_net"}
  $eo add command  -label "HL Net"  -underline 0 \
    -command {open_an_editor $gvar(actprj) "hl_net"}
  $eo add command  -label "PFA"  -underline 1 \
    -command {open_an_editor $gvar(actprj) "pfa"}
  $eo add command  -label "C Source"  -underline 0 \
    -command {open_an_editor $gvar(actprj) "c_source"}
  $eo add command  -label "Formula"  -underline 0 \
    -command {open_an_editor $gvar(actprj) "formula.normal"}
  $eo add command  -label "Document"  -underline 0 \
    -command {open_an_editor $gvar(actprj) "doc"}
  $eo add command  -label "INA"  -underline 0 \
    -command {open_an_editor $gvar(actprj) "ina"}

  # Simulator/Animator
  $eo add command  -label "Simulator"  -underline 0 \
    -command {open_an_editor $gvar(actprj) "simulator"}
  $eo add command  -label "Animator"  -underline 0 \
    -command {open_an_editor $gvar(actprj) "animator"}
  $eo add command  -label "SDL"  -underline 0 \
    -command {open_an_editor $gvar(actprj) "sdl"}
  $eo add command  -label "SDL Properties" \
    -command {open_an_editor $gvar(actprj) "sdl_properties"}

    # Edit-Close-Menu
  set ec [menu $em.close  -tearoff 0]
  $ec add command  -label "Save Files" \
    -command {
      prj_close "JA"
      set gvar(prjcount) [expr $gvar(prjcount)-1]
      destroy .prjtoplvl$gvar(actprj)
    }  -underline 0
  $ec add command  -label "Discard Files" \
    -command {
      prj_close "NEIN"
      set gvar(prjcount) [expr $gvar(prjcount)-1]
      destroy .prjtoplvl$gvar(actprj)
    }  -underline 0

    # Execute-Button und Execute-Men"u
  menubutton .prjtoplvl$pn.mbar.exe  -text "Execute" \
    -underline 1  -menu .prjtoplvl$pn.mbar.exe.menu
  set xm [menu .prjtoplvl$pn.mbar.exe.menu  -tearoff 0]
  set prj(project.exe.menu.widget) $xm
  $xm add command  -label "B(PN) -> PBC"  -command {prj_exe_bpn2_boxexpr}
  $xm add command  -label "PBC -> LL Net"  -command {prj_exe_boxexpr_ll_net}
  $xm add command  -label "B(PN) -> LL Net (via PBC)" \
    -command {prj_exe_bpn2_ll_net_via_boxexpr}
  $xm add separator
  $xm add command  -label "B(PN) -> HL Net"  -command {prj_exe_bpn2_hl_net}
  $xm add command  -label "Expanded B(PN) -> HL Net" \
    -command {prj_exe_bpn2_exp_hl_net}
  $xm add command  -label "HL Net -> LL Net"  -command {prj_exe_hl_net_ll_net}
  $xm add command  -label "B(PN) -> LL Net (via HL Net)" \
    -command {prj_exe_bpn2_ll_net_via_hl_net}
  $xm add separator
  $xm add command  -label "B(PN) -> Expanded B(PN)" \
    -command {prj_exe_bpn2_bpn2_exp}
  $xm add command  -label "B(PN) -> C Source" \
    -command {prj_exe_bpn2_c_source}
  $xm add separator
  $xm add command  -label "Sync HL Net"  -command {prj_exe_sync_hl_net_dlg}
  $xm add separator
  $xm add command  -label "LL Net -> Prefix" \
    -command {prj_exe_ll_net_unfolding}
  $xm add command  -label "Minimize LL Net"  -command {prj_exe_ll_net_minimize}
  $xm add command  -label "LL Net -> INA" \
    -command {prj_exe_ll_net_ina}
  $xm add command  -label "LL Net -> SPIN" \
    -command {prj_exe_ll_net_spin}
  $xm add command  -label "LL Net -> FC2"  -command {prj_exe_ll_net_fc2}
  $xm add separator
  $xm add command  -label "PFA -> B(PN)" \
    -command {prj_exe_pfa_bpn2}
  $xm add command  -label "PFA -> HL Net"  -command {prj_exe_pfa_hl_net}
  $xm add command  -label "SDL -> HL Net"  -command {prj_exe_sdl_hl_net}

    # Analyse-Button und Analyse-Men"u, Men"u im Projekt merken
  menubutton .prjtoplvl$pn.mbar.ana  -text "Analyse" \
    -underline 1  -menu .prjtoplvl$pn.mbar.ana.menu
  set am [menu .prjtoplvl$pn.mbar.ana.menu  -tearoff 0]
  set prj(project.ana.menu.widget) $am
  $am add command  -label "T-System"  -command {prj_ana_t_system}
  $am add command  -label "FC System"  -command {prj_ana_free_choice}
  $am add command  -label "Safe System"  -command {prj_ana_safe}
  $am add command  -label "Bounded System"  -command {prj_ana_bounded_dlg}
  $am add separator
  $am add command  -label "Reachability"  -command {prj_ana_reachability_dlg}
  $am add command  -label "LP Reachability" \
    -command {prj_ana_lp_reachability_dlg}
  $am add command  -label "PO Reachability" \
    -command {prj_ana_clp_reachability_dlg}
  $am add separator
  $am add command  -label "PO Mutual Exclusion" \
    -command {prj_ana_clp_mutex_dlg}
  $am add separator
  $am add command  -label "Deadlock-free System" \
    -command {prj_ana_deadlock_dlg}
  $am add separator
  $am add command  -label "CTL Model Checker (T-System)" \
    -command {prj_ana_model_check_t_system}
  $am add command  -label "CTL Model Checker (Safe)" \
    -command {prj_ana_model_check_dlg safe}
  $am add command  -label "LTL Model Checker (SPIN)" \
    -command {prj_ana_model_check_dlg spin}
  $am add command  -label "CTL Model Checker (SMV)" \
    -command {prj_ana_model_check_dlg smv}
  $am add command  -label "LTL Model Checker (unfsmodels)" \
    -command {prj_ana_model_check_dlg unfsmodels}
  $am add command  -label "LTL Model Checker (boundsmodels)" \
    -command {prj_ana_model_check_dlg boundsmodels}
  $am add command  -label "LTL Model Checker (qq)" \
    -command {prj_ana_model_check_dlg qq}
  $am add command  -label "Net Analysis (LoLA)" \
    -command {prj_ana_lola_dlg}

    # Option-Button und Option-Men"u
  menubutton .prjtoplvl$pn.mbar.option  -text "Option" \
    -underline 1  -menu .prjtoplvl$pn.mbar.option.menu
  set om [menu .prjtoplvl$pn.mbar.option.menu  -tearoff 0]
  set prj(project.option.menu.widget) $om
  $om add cascade  -label "Converter Options" \
    -menu $om.conv  -underline 0
  $om add cascade  -label "Debug Output" \
    -menu $om.debug  -underline 0
    # Option-Converter-Menu
  set oc [menu $om.conv  -tearoff 0]
  $oc add command  -label "Syntax Checker"  -command {option_syntax_check_dlg}
  $oc add command  -label "B(PN) -> PBC"  -command {option_bpn2_box_expr_dlg}
  $oc add command  -label "PBC -> LL Net"  -command {option_box_expr_ll_net_dlg}
  $oc add command  -label "B(PN) -> HL Net"  -command {option_bpn2_hl_net_dlg}
  $oc add command  -label "HL Net -> LL Net" \
    -command {option_hl_net_ll_net_dlg}
  $oc add command  -label "Sync HL Net"  -command {option_sync_hl_net_dlg}
  $oc add command  -label "Prefix Builder"  -command {option_unfolding_text_dlg}
  $oc add command  -label "Boundedness Analyser" \
    -command {option_ana_bounded_dlg}
  $oc add command  -label "Reachability Analyser" \
    -command {option_ana_reachability_dlg}
  $oc add command  -label "LP Analyser" \
    -command {option_ana_lp_dlg}
  $oc add command  -label "PO Analyser" \
    -command {option_ana_clp_dlg}
  $oc add command  -label "Model Checker (Safe)" \
    -command {option_ana_model_check_safe_dlg}
  $oc add command  -label "Model Checker (SMV)" \
    -command {option_ana_model_check_smv_dlg}
  $oc add command  -label "Model Checker (SPIN)" \
    -command {create_promela_f $gvar(actprj) 1}
  $oc add command  -label "B(PN) Expander"  -command {option_bpn2_exp_dlg}
  $oc add command  -label "LL Net -> INA"  -command {option_pep_to_ina_dlg}
  $oc add command  -label "LL Net -> SPIN"  -command {option_pep_to_spin_dlg}
  $oc add command  -label "PFA -> HL Net"  -command {option_pfa_hl_net_dlg}
  $oc add command  -label "PFA -> B(PN)"  -command {option_pfa_bpn2_dlg}
  $oc add command  -label "SDL -> HL Net"  -command {option_sdl_hl_net_dlg}

    # Debug-Menu
  menu $om.debug  -tearoff 0
  $om.debug add command  -label "Show prjx" \
    -command { \
       set prjnum $gvar(actprj); \
       upvar #0 prj$prjnum prjx; \
       print_array prjx \
    }  -underline 0

  menubutton .prjtoplvl$pn.mbar.view -text "Cosmetics" \
    -underline 0  -menu .prjtoplvl$pn.mbar.view.menu
  set vm [menu .prjtoplvl$pn.mbar.view.menu  -tearoff 0]
  set prj(project.view.menu.widget) $vm

   $vm add checkbutton -label Edit \
       -command "viewChangeEditState $pn" -variable prj$pn\(view.editable)
   $vm add separator
   $vm add cascade -label "Defaults" \
     -menu .prjtoplvl$pn.mbar.view.menu.defaults
   set vmd [menu .prjtoplvl$pn.mbar.view.menu.defaults -tearoff 0]
     $vmd add command -label "Load PEP Default" \
       -command "viewEditDefaults LoadPEP $pn"
     $vmd add command -label "Load User Default" \
       -command "viewEditDefaults LoadUser $pn"
     $vmd add command -label "Save as User Default" \
       -command "viewEditDefaults SetUser $pn"
   $vm add separator
   # 'Show icons' Menu
   $vm add cascade -label "Show icons:" -state disabled \
       -menu .prjtoplvl$pn.mbar.view.menu.icons
   set vmi [menu .prjtoplvl$pn.mbar.view.menu.icons -tearoff 0]

  graphViewInit $pn prj

  foreach iconName $gvar(view.icon_list) {
    $vmi add checkbutton -label $gvar(view.$iconName.name) \
      -command "viewIconUpdate $pn $iconName" \
      -variable prj$pn\(view.$iconName,show)
  } ;#foreach

   # 'Show references' Menu
  $vm add cascade -label "Show references:" \
    -menu .prjtoplvl$pn.mbar.view.menu.refs -state disabled
  set vmr [menu .prjtoplvl$pn.mbar.view.menu.refs -tearoff 0]

  foreach iconName $gvar(view.icon_list) {
    foreach arrow_to $gvar(view.$iconName,arrow_to) {
      $vmr add checkbutton \
        -label "$gvar(view.$iconName.name) -> $gvar(view.$arrow_to.name)" \
	-command "viewArrowUpdate $pn $iconName $arrow_to" \
	-variable prj$pn\(view.$iconName->$arrow_to,show)
    }
  wm geometry .prjtoplvl$pn $prj(view.window,width)x$prj(view.window,height)
  }
   # Eintraege im Menu _richtig_ setzen (state disabled/normal)...
  viewMenuUpdate $pn

    # Help-Button und Help-Men"u
  menubutton .prjtoplvl$pn.mbar.help  -text "Help" \
    -underline 1  -menu .prjtoplvl$pn.mbar.help.menu
  set hm [menu .prjtoplvl$pn.mbar.help.menu  -tearoff 0]
  set prj(project.help.menu.widget) $hm
  $hm add command  -label "Help Viewer"  -command "help_view $pn"

    # Die Buttons packen.
  pack .prjtoplvl$pn.mbar.edit \
    .prjtoplvl$pn.mbar.exe \
    .prjtoplvl$pn.mbar.ana \
    .prjtoplvl$pn.mbar.option \
    .prjtoplvl$pn.mbar.view \
    -side left
  pack .prjtoplvl$pn.mbar.help \
    -side right

    # Die Men"uleiste binden, um sp"ater an das aktive Projekt zu gelangen.
  bind .prjtoplvl$pn <Enter> {+
    set gvar(actprj) [strip_prj_num %W]
  }  ;# neues Binding f"ur die Menuleiste auf Enter hin

    # Keyboard-Traversal einschalten, TODO
#  tk_menuBar .prjtoplvl$pn.mbar \
#    .prjtoplvl$pn.mbar.edit \
#    .prjtoplvl$pn.mbar.exe
#  focus .prjtoplvl$pn.mbar

    # das Informationsfeld erzeugen und merken
  set prj(project.infos.widget) [frame .prjtoplvl$pn.infos  -bd 2]
  pack .prjtoplvl$pn.infos  -side top  -fill both  -expand 0
    # Projektnamen und Datum anzeigen
  label .prjtoplvl$pn.infos.name \
    -text "Project  $prj(project.name) - $prj(DATE)"
  label .prjtoplvl$pn.infos.comment1  -text $prj(project.comment_1)
  label .prjtoplvl$pn.infos.comment2  -text $prj(project.comment_2)
  pack .prjtoplvl$pn.infos.name \
    .prjtoplvl$pn.infos.comment1 \
    .prjtoplvl$pn.infos.comment2 \
    -side top  -anchor w  -expand 1

    # das Projekt anzeigen...
  create_graph_file_view .prjtoplvl$pn $pn

    # das Hinweisfeld aufbauen
  frame .prjtoplvl$pn.msgfr  -bd 1m
  pack .prjtoplvl$pn.msgfr  -fill x
    # das Widget fuer den Hinweis, tricky
  set prj(prjmsg.widget) [label .prjtoplvl$pn.msgfr.msg \
    -text "Project is now open"]
  pack .prjtoplvl$pn.msgfr.msg  -fill x

    # das Frame f"ur die unteren Buttons
  frame .prjtoplvl$pn.lmbar  -relief raised  -bd 2
  pack .prjtoplvl$pn.lmbar  -side bottom  -fill x

    # Close-Project-Button
  button .prjtoplvl$pn.lmbar.ende  -text {Close Project} \
    -underline 0 \
    -command { \
      prj_close "JA"
      set gvar(prjcount) [expr $gvar(prjcount)-1]
      destroy .prjtoplvl$gvar(actprj)
    }
  bind .prjtoplvl$pn.lmbar.ende <Enter> {+
    set gvar(actprj) [strip_prj_num %W]
  }  ;# bind
  pack .prjtoplvl$pn.lmbar.ende  -side right

    # Die Analyseergebnisse anzeigen
  update_project_infos $pn
}  ;# new_project_frame

  #*** Dateiende projfr.tcl ***

