# projhelp.tcl, help for PEP
# started: 25.10.95, last-update: 13.12.96

proc help_view {prjnum} {
  # open help browser
  # prjnum - Project number
  global gvar

    # store current dir
  set actdir [pwd]
    # project variable
  upvar #0 prj$prjnum prjx
    # disable menu entry
  .prjtoplvl$prjnum.mbar.help.menu entryconfigure "Help Viewer" \
    -state disabled
    # State of connection
  set prjx(help.view.comstate) "disconnected"
  if [catch {set prjx(help.view.server)}] {
  } else {
    unset prjx(help.view.server)
  }  ;# else, delete Server
    # Print message, tricky, as -textvariable does not work
  new_project_msg $prjnum "Open Help Viewer ..."
  update idletasks
    # open viewer
  set sys_str "exec $gvar(help.view.name) \
    contents.html \
    -prjnum=$prjnum \
    -prjname=$prjx(project.name) \
    -prgtype=help.view \
    -color_palette=$gvar(color_palette) \
    -pepcom=$gvar(server_host),$gvar(server_port),$gvar(server_sock) &"
  DEBUG "Aufruf: $sys_str"
  eval $sys_str
    # Wait until viewer is up
  set wait1 "tkwait variable prj$prjnum"
  set wait2 "(help.view.comstate)"
  set wait "$wait1$wait2"
  eval $wait
}  ;# help_view

proc close_help_view {prjnum save_flag} {
  # Close help browser
  # prjnum - Project number
  # save_flag - if "JA", then save, else "NEIN" so not.
    # name the project variable
  upvar #0 prj$prjnum prjx
  if {$prjx(help.view.comstate) == "connected"} {
      # Print message, see above
    new_project_msg $prjnum "Closing Help Viewer ..."
    update idletasks
      # Close it.
    if [catch {RPC "end_session $save_flag" \
      $prjx(help.view.host) $prjx(help.view.port)}] {
      DEBUG "close_help_view: viewer is not connected"
    }  ;# if error
    .prjtoplvl$prjnum.mbar.help.menu entryconfigure "Help Viewer" \
      -state normal
  } else {
    DEBUG "close_help_view: viewer is closed"
  }  ;# else, wasn't open
    # Save State of connection
  set prjx(help.view.comstate) "disconnected"
}  ;# close_help_view

  #*** end of file projhelp.tcl ***
