# projinfo.tcl, graphische Anzeige der Dateiabh"angigkeiten
# begonnen: 08.05.95, last-update: 16.7.97
# BG Typos raus

  ##########
  # Helper #
  ##########

proc strip_prj_num window_name {
  # Liefert aus dem window_name die Nummer des Projektes.
    # den ersten Namen suchen, sollte prjtoplvlXXX sein
  set a [split $window_name .]
  set b [lindex $a 1]
    # per regulaerem Ausdruck die Ziffern am Ende extrahieren
  regexp {[0-9]+} $b c
  return [set c]
}  ;# strip_prj_num

  #########
  # Inits #
  #########

proc init_project_info {} {
  # Voreinstellungen f"ur alle Projektfenster.
  global gvar

  set gvar(reference_ok.color) forestgreen
  set gvar(reference_broken.color) red
  set gvar(file_exists.color) "sea green"
  set gvar(file_exists_not.color) red
  set gvar(editor_open.color) "sea green"
  set gvar(editor_not_open.color) red

#TODO:
# von dem hier koennte einiges ueberfluessig werden...
  image create photo frame_pattern \
    -file "$gvar(my_bitmap.path)/frame_pattern.gif"
  image create bitmap file_exists \
    -file $gvar(my_bitmap.path)/file_exists.bitmap \
    -foreground $gvar(file_exists.color)
  image create bitmap file_exists_not \
    -file $gvar(my_bitmap.path)/file_exists_not.bitmap \
    -foreground $gvar(file_exists_not.color)
  image create bitmap text_editor_open \
    -file $gvar(my_bitmap.path)/text_editor_open.bitmap \
    -foreground $gvar(editor_open.color)
  image create bitmap text_editor_not_open \
    -file $gvar(my_bitmap.path)/text_editor_not_open.bitmap \
    -foreground $gvar(editor_not_open.color)
  image create bitmap net_editor_open \
    -file $gvar(my_bitmap.path)/net_editor_open.bitmap \
    -foreground $gvar(editor_open.color)
  image create bitmap net_editor_not_open \
    -file $gvar(my_bitmap.path)/net_editor_not_open.bitmap \
    -foreground $gvar(editor_not_open.color)

   # hintergrund-photos
  image create photo image_frame_pattern_rect \
    -file "$gvar(my_bitmap.path)/frame_pattern_rect.gif"
  image create photo image_frame_pattern_oval \
    -file "$gvar(my_bitmap.path)/frame_pattern_oval.gif"
  image create photo image_frame_pattern_round \
    -file "$gvar(my_bitmap.path)/frame_pattern_round.gif"
   # Icons
  image create bitmap image_doc \
    -file "$gvar(my_bitmap.path)/doc.bitmap"
  image create bitmap image_boxexpr \
    -file "$gvar(my_bitmap.path)/boxexpr.bitmap"
  image create bitmap image_bpn2.normal \
    -file "$gvar(my_bitmap.path)/bpn2.bitmap"
  image create bitmap image_bpn2.expanded \
    -file "$gvar(my_bitmap.path)/bpn2_exp.bitmap"
  image create bitmap image_formula.normal \
    -file "$gvar(my_bitmap.path)/formula.bitmap"
  image create bitmap image_hl_net \
    -file "$gvar(my_bitmap.path)/hl_net.bitmap"
  image create bitmap image_ina \
    -file "$gvar(my_bitmap.path)/ina.bitmap"
  image create bitmap image_ll_net \
    -file "$gvar(my_bitmap.path)/ll_net.bitmap"
  image create bitmap image_pfa \
    -file "$gvar(my_bitmap.path)/pfa.bitmap"
  image create bitmap image_smv \
    -file "$gvar(my_bitmap.path)/smv.bitmap"
  image create bitmap image_spin \
    -file "$gvar(my_bitmap.path)/spin.bitmap"
  image create bitmap image_unfolding.text \
    -file "$gvar(my_bitmap.path)/unfolding.bitmap"
  image create bitmap image_fc2 \
    -file "$gvar(my_bitmap.path)/fc2.bitmap"
  image create bitmap image_c_source \
    -file "$gvar(my_bitmap.path)/c_source.bitmap"
  image create bitmap image_sdl \
    -file "$gvar(my_bitmap.path)/sdl.bitmap"

   # Liste aller Icons, die im Projektfenster dargestellt werden koennen
  set gvar(view.icon_list) {doc pfa bpn2.normal bpn2.expanded hl_net\
                        boxexpr ll_net formula.normal\
                        unfolding.text ina smv spin\
			fc2 c_source sdl}
  set gvar(view.projecttypes) {All B(PN) SDL PFA {HL Net} {LL Net} {Time HL Net} {Time LL Net} PBC tPBC}
   # Diese Variablen werden z.B. als Menue-Eintraege verwendet
  set gvar(view.doc.name) "DOC"
  set gvar(view.pfa.name) "PFA"
  set gvar(view.bpn2.normal.name) "B(PN)"
  set gvar(view.bpn2.expanded.name) "Expanded B(PN)"
  set gvar(view.hl_net.name) "HL Net"
  set gvar(view.boxexpr.name) "PBC"
  set gvar(view.ll_net.name) "LL Net"
  set gvar(view.formula.normal.name) "Formula"
  set gvar(view.unfolding.text.name) "Prefix"
  set gvar(view.ina.name) "INA"
  set gvar(view.smv.name) "SMV"
  set gvar(view.spin.name) "SPIN"
  set gvar(view.fc2.name) "FC2"
  set gvar(view.c_source.name) "C Source"
  set gvar(view.sdl.name) "SDL"
   # welches Icon bekommt welche Form?
   # z.Z. gibt es rect (rechteckig), oval (rechteckig mit abgerundeten Ecken)
   # und round (wie oval, jedoch staerker abgerundet)
  set gvar(view.doc,frame_pattern) rect
  set gvar(view.pfa,frame_pattern) oval
  set gvar(view.bpn2.normal,frame_pattern) oval
  set gvar(view.bpn2.expanded,frame_pattern) oval
  set gvar(view.hl_net,frame_pattern) oval
  set gvar(view.boxexpr,frame_pattern) oval
  set gvar(view.ll_net,frame_pattern) oval
  set gvar(view.formula.normal,frame_pattern) oval
  set gvar(view.unfolding.text,frame_pattern) round
  set gvar(view.ina,frame_pattern) round
  set gvar(view.smv,frame_pattern) round
  set gvar(view.spin,frame_pattern) round
  set gvar(view.fc2,frame_pattern) round
  set gvar(view.c_source,frame_pattern) oval
  set gvar(view.sdl,frame_pattern) oval
   # Masse der frame patterns
  set gvar(view.frame_pattern_rect,x) 89
  set gvar(view.frame_pattern_rect,y) 84
  set gvar(view.frame_pattern_oval,x) 94
  set gvar(view.frame_pattern_oval,y) 84
  set gvar(view.frame_pattern_round,x) 86
  set gvar(view.frame_pattern_round,y) 71
   # Welches Editor-Bitmap?
   # z.Z. "text", "net" oder " " (kein Editor)
   # ! Ist kein editor_bitmap definiert, passiert auch nix beim
   # Doppelklick auf das Icon!
  set gvar(view.doc,editor_bitmap) "text"
  set gvar(view.pfa,editor_bitmap) "net"
  set gvar(view.bpn2.normal,editor_bitmap) "text"
  set gvar(view.bpn2.expanded,editor_bitmap) "text"
  set gvar(view.boxexpr,editor_bitmap) "text"
  set gvar(view.ll_net,editor_bitmap) "net"
  set gvar(view.hl_net,editor_bitmap) "net"
  set gvar(view.unfolding.text,editor_bitmap) " "
  set gvar(view.formula.normal,editor_bitmap) "text"
  set gvar(view.ina,editor_bitmap) " "
  set gvar(view.smv,editor_bitmap) " "
  set gvar(view.spin,editor_bitmap) " "
  set gvar(view.fc2,editor_bitmap) " "
  set gvar(view.c_source,editor_bitmap) "text"
set gvar(view.sdl,editor_bitmap) "text"
}  ;# init_project_info

  ##################################
  # Beide Darstellungen betreffend #
  ##################################

proc update_project_files project_number {
  # Der Inhalt der Informationsanzeige ver"andern
  # anhand der Angaben aus der Projektvariablen.

  update_project_graph_files $project_number
}  ;# update_project_files

  ##########################
  # Graphische Darstellung #
  ##########################

proc graph_check_file {project_number name} {
  # Checks the actual file state and saves it
  # to the project variable.
  # project_number - the project number
  # name - file descriptor (not file name!)
  global gvar

  upvar #0 prj$project_number prjx

  set cur_dir [pwd]
  cd $prjx(actdir)
  if [catch {file stat $prjx($name.filename) result}] {
    set prjx($name.filestate_text_1) "does not exist!"
    set prjx($name.filestate_text_2) " "
    set prjx($name.filestate_flag) false
  } else {
    set prjx($name.filestate_text_1) "exists."
    set date_time [clock format $result(mtime) -format "%d.%m.%y %H:%M:%S"]
    set prjx($name.filestate_text_2) \
      "Size: $result(size) Byte(s) / Date: $date_time"
    set prjx($name.filestate_flag) true
  }  ;# else, file is available
  cd $cur_dir
}  ;# graph_check_file

proc display_graph_reference_state {project_number refname refstr} {
  # Den Zustand der Referenz im Graphen anzeigen.
  # project_number - die Projektnummer
  # refname - Name des Tags f"ur den Referenzpfeil
  # refstr - String aus der Projektvariablen
  global gvar

  if {$refstr == "None"} {
    .prjtoplvl$project_number.cnvs itemconfigure arrow$refname \
      -fill $gvar(reference_broken.color) \
      -width 4  -stipple @$gvar(my_bitmap.path)/dotted.bitmap
  } else {
    .prjtoplvl$project_number.cnvs itemconfigure arrow$refname \
      -fill $gvar(reference_ok.color) \
      -width 4  -stipple @$gvar(my_bitmap.path)/solid.bitmap
  }  ;# else, die Referenz besteht
}  ;# display_graph_reference_state

proc display_graph_file_state {project_number name} {
  # Zeigt den Status der Datei an.
  # project_number - die Projektnummer
  # name - der Bezeichner der Datei (nicht der Dateiname!)
  global gvar

  upvar #0 prj$project_number prjx

    # infotexte erstmal leer initialisieren
  set infotext_1 " "
  set infotext_2 " "

   # Filestatus checken...
    graph_check_file $project_number $name

   # Bitmap anpassen
  if {$prjx($name.filestate_flag)} {
    .prjtoplvl$project_number.cnvs itemconfigure $name.file \
      -image file_exists
  } else {
    .prjtoplvl$project_number.cnvs itemconfigure $name.file \
      -image file_exists_not
  }  ;# else, Datei nicht vorhanden

   # Infotext erneuern...
  switch $name {
    bpn2.normal {
      set infotext_1 "B(PN) File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
    bpn2.expanded {
      set infotext_1 "Expanded B(PN) File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)" 
      set infotext_2 $prjx($name.filestate_text_2)
    }
    boxexpr {
      set infotext_1 "PBC File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
    ll_net {
      set infotext_1 "LL Net File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
    hl_net {
      set infotext_1 "HL Net File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
    c_source {
      set infotext_1 "C Source File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
    unfolding.text {
      set infotext_1 "Prefix File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
    doc {
      set infotext_1 "Document File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
    formula.normal {
      set infotext_1 "Formula File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
    pfa {
      set infotext_1 "PFA File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
    ina {
      set infotext_1 "INA File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
    smv {
      set infotext_1 "SMV File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
    spin {
#TODO:
# Welcher filename gilt fuer spin???  was soll angezeigt werden?
#      set infotext_1 "SPIN File ($prjx($name.filename)) \
#        $prjx($name.filestate_text_1)"
#      set infotext_2 $prjx($name.filestate_text_2)
    }
    fc2 {
      set infotext_1 "FC2 File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
    sdl {
      set infotext_1 "SDL File ($prjx($name.filename)) \
        $prjx($name.filestate_text_1)"
      set infotext_2 $prjx($name.filestate_text_2)
    }
  }  ;# switch ueber die Namen
  .prjtoplvl$project_number.infotext_1 configure  -text $infotext_1
  .prjtoplvl$project_number.infotext_2 configure  -text $infotext_2
}  ;# display_graph_file_state

proc display_graph_editor_state {project_number name} {
  # Zeigt den Status des Dateieditors an.
  # project_number - die Projektnummer
  # name - der Bezeichner der Datei (nicht der Dateiname!)
  global gvar

  upvar #0 prj$project_number prjx

  switch $name {
    bpn2.normal {
      if {$prjx(bpn2.normal.comstate) == "disconnected"} {
        set infotext_1 "B(PN) Editor is not open (Double Click to open)"
        set bitmapname text_editor_not_open
      } else {
        set infotext_1 "B(PN) Editor is open (Double Click to raise window)"
        set bitmapname text_editor_open
      }  ;# else, Editor ist auf
    }
    bpn2.expanded {
      if {$prjx(bpn2.expanded.comstate) == "disconnected"} {
        set infotext_1 \
          "Expanded B(PN) Editor is not open (Double Click to open)"
        set bitmapname text_editor_not_open
      } else {
        set infotext_1 \
          "Expanded B(PN) Editor is open (Double Click to raise window)"
        set bitmapname text_editor_open
      }  ;# else, Editor ist auf
    }
    boxexpr {
      if {$prjx(boxexpr.comstate) == "disconnected"} {
        set infotext_1 "PBC Editor is not open (Double Click to open)"
        set bitmapname text_editor_not_open
      } else {
        set infotext_1 "PBC Editor is open (Double Click to raise window)"
        set bitmapname text_editor_open
      }  ;# else, Editor ist auf
    }
    ll_net {
      if {$prjx(ll_net.comstate) == "disconnected"} {
        set infotext_1 "LL Net Editor is not open (Double Click to open)"
        set bitmapname net_editor_not_open
      } else {
        set infotext_1 "LL Net Editor is open (Double Click to raise window)"
        set bitmapname net_editor_open
      }  ;# else, Editor ist auf
    }
    hl_net {
      if {$prjx(hl_net.comstate) == "disconnected"} {
        set infotext_1 "HL Net Editor is not open (Double Click to open)"
        set bitmapname net_editor_not_open
      } else {
        set infotext_1 "HL Net Editor is open (Double Click to raise window)"
        set bitmapname net_editor_open
      }  ;# else, Editor ist auf
    }
    c_source {
      if {$prjx(c_source.comstate) == "disconnected"} {
        set infotext_1 "C Source Editor is not open (Double Click to open)"
        set bitmapname text_editor_not_open
      } else {
        set infotext_1 "C Source Editor is open (Double Click to raise window)"
        set bitmapname text_editor_open
      }  ;# else, Editor ist auf
    }
    doc {
      if {$prjx(doc.comstate) == "disconnected"} {
        set infotext_1 "Document Editor is not open (Double Click to open)"
        set bitmapname text_editor_not_open
      } else {
        set infotext_1 "Document Editor is open (Double Click to raise window)"
        set bitmapname text_editor_open
      }  ;# else, Editor ist auf
    }
    formula.normal {
      if {$prjx(formula.normal.comstate) == "disconnected"} {
        set infotext_1 "Formula Editor is not open (Double Click to open)"
        set bitmapname text_editor_not_open
      } else {
        set infotext_1 "Formula Editor is open (Double Click to raise window)"
        set bitmapname text_editor_open
      }  ;# else, Editor ist auf
    }
    pfa {
      if {$prjx(pfa.comstate) == "disconnected"} {
        set infotext_1 "PFA Editor is not open (Double Click to open)"
        set bitmapname text_editor_not_open
      } else {
        set infotext_1 "PFA Editor is open (Double Click to raise window)"
        set bitmapname text_editor_open
      }  ;# else, Editor ist auf
    }
    ina {
      if {$prjx(ina.comstate) == "disconnected"} {
        set infotext_1 "INA is not open (Double Click to open)"
        set bitmapname ina_editor_not_open
      } else {
        set infotext_1 "INA is open (Double Click to raise window)"
        set bitmapname ina_editor_open
      }  ;# else, Editor ist auf
    }
    sdl {
      if {$prjx(sdl.comstate) == "disconnected"} {
        set infotext_1 "SDL Editor is not open (Double Click to open)"
        set bitmapname text_editor_not_open
      } else {
        set infotext_1 "SDL Editor is open (Double Click to raise window)"
        set bitmapname text_editor_open
      }  ;# else, Editor ist auf
    }
  }  ;# switch ueber die Namen
  .prjtoplvl$project_number.infotext_1 configure  -text $infotext_1
  .prjtoplvl$project_number.infotext_2 configure  -text " "
    # Bitmap anpassen
  .prjtoplvl$project_number.cnvs itemconfigure $name.editor \
    -image $bitmapname
}  ;# display_graph_editor_state

proc update_project_graph_files project_number {
  # Den Inhalt der Informationsanzeige (Graphdarstellung) ver"andern 
  # anhand der Angaben aus der Projektvariablen.
  # project_number - Die Projektnummer.

#TODO
# Das geht alles einfacher (ohne switches), da die moeglichen referenzen
# alle ueber view.$name,arrow_to bzw arrow_from ermittelbar sind...
# Na ja... ich weiss, was ich meine :)
# ausserdem kann man die switches mit nur zwei alternativen auch
# enorm vereinfachen, aber so ist's halt uebersichtlicher
#
    # Zugriff auf die Projektvariable erlangen
  upvar #0 prj$project_number prjx

    # Angaben "uber die Dateiabh"angigkeiten (Referenzen)
  switch $prjx(bpn2.expanded.ref) {
    "None" { display_graph_reference_state $project_number \
               "bpn2.normal->bpn2.expanded" "None"
      }
    "B(PN)" { display_graph_reference_state $project_number \
                 "bpn2.normal->bpn2.expanded" "B(PN)"
      }
  }  ;# switch ueber bpn2.expanded Netzreferenz
  switch $prjx(boxexpr.ref) {
    "None" {   display_graph_reference_state $project_number \
                 "bpn2.normal->boxexpr" "None"
      }
    "B(PN)" { display_graph_reference_state $project_number \
                 "bpn2.normal->boxexpr" "B(PN)"
      }
  }  ;# switch ueber boxexpr Netzreferenz
  switch $prjx(ll_net.ref) {
    "None" { display_graph_reference_state $project_number \
               "hl_net->ll_net" "None"
             display_graph_reference_state $project_number \
               "boxexpr->ll_net" "None"
      }
    "PBC" { display_graph_reference_state $project_number \
              "hl_net->ll_net" "None"
            display_graph_reference_state $project_number \
              "boxexpr->ll_net" "PBC"
      }
    "HL-Net" { display_graph_reference_state $project_number \
                 "hl_net->ll_net" "HL-Net"
               display_graph_reference_state $project_number \
                 "boxexpr->ll_net" "None"
      }
  }  ;# switch ueber LL-Netzreferenz
  switch $prjx(hl_net.ref) {
    "None" {
        display_graph_reference_state $project_number \
         "bpn2.normal->hl_net" "None"
        display_graph_reference_state $project_number \
          "bpn2.expanded->hl_net" "None"
        display_graph_reference_state $project_number \
          "sdl->hl_net" "None"
        display_graph_reference_state $project_number \
          "pfa->hl_net" "None"
      }
    "B(PN)" { display_graph_reference_state $project_number \
                 "bpn2.normal->hl_net" "B(PN)"
               display_graph_reference_state $project_number \
                 "bpn2.expanded->hl_net" "None"
               display_graph_reference_state $project_number \
                 "sdl->hl_net" "None"
               display_graph_reference_state $project_number \
                 "pfa->hl_net" "None"
      }
    "Exp-B(PN)" { display_graph_reference_state $project_number \
                     "bpn2.normal->hl_net" "None"
                   display_graph_reference_state $project_number \
                     "bpn2.expanded->hl_net" "Exp-B(PN)"
                   display_graph_reference_state $project_number \
                     "sdl->hl_net" "None"
                   display_graph_reference_state $project_number \
                     "pfa->hl_net" "None"
      }
    "PFA" { display_graph_reference_state $project_number \
                     "bpn2.normal->hl_net" "None"
                   display_graph_reference_state $project_number \
                     "bpn2.expanded->hl_net" "None"
                   display_graph_reference_state $project_number \
                     "sdl->hl_net" "None"
                   display_graph_reference_state $project_number \
                     "pfa->hl_net" "PFA"
      }
     "SDL" { display_graph_reference_state $project_number \
                     "bpn2.normal->hl_net" "None"
                   display_graph_reference_state $project_number \
                     "bpn2.expanded->hl_net" "None"
                   display_graph_reference_state $project_number \
                     "pfa->hl_net" "None"
                   display_graph_reference_state $project_number \
                     "sdl->hl_net" "SDL"
      }
  }  ;# switch "uber HL-Netzreferenz
  switch $prjx(unfolding.text.ref) {
    "None" { display_graph_reference_state $project_number \
      "ll_net->unfolding.text" "None"
      }
    "LL-Net" { display_graph_reference_state $project_number \
      "ll_net->unfolding.text" "LL-Net"
      }
  }  ;# switch ueber unfolding.text (Prefix) Netzreferenz
  switch $prjx(bpn2.normal.ref) {
    "None" { display_graph_reference_state $project_number \
               "pfa->bpn2.normal" "None"
      }
    "PFA" { display_graph_reference_state $project_number \
               "pfa->bpn2.normal" "PFA"
      }
  }  ;# switch ueber B(PN) Netzreferenz
  switch $prjx(ina.ref) {
    "None" { display_graph_reference_state $project_number \
      "ll_net->ina" "None"
      }
    "LL-Net" { display_graph_reference_state $project_number \
      "ll_net->ina" "LL-Net"
      }
  }  ;# switch ueber INA-Netzreferenz
#TODO: 
# ersteinmal ist der Pfeil ll_net->smv gruen, solange ein LL-Net da ist!
  if [file exists $prjx(ll_net.filename)] {
    display_graph_reference_state $project_number \
      "ll_net->smv" "LL-Net"
  } else {
    display_graph_reference_state $project_number \
      "ll_net->smv" "None"
  }
#  switch $prjx(smv.ref) {
#    "None" { display_graph_reference_state $project_number \
#      "ll_net->smv" "None"
#      }
#    "LL-Net" { display_graph_reference_state $project_number \
#      "ll_net->smv" "LL-Net"
#      }
#  }  ;# switch ueber SMV-Netzreferenz
  switch $prjx(spin.ref) {
    "None" { display_graph_reference_state $project_number \
      "ll_net->spin" "None"
      }
    "LL-Net" { display_graph_reference_state $project_number \
      "ll_net->spin" "LL-Net"
      }
  }  ;# switch ueber SPIN-Netzreferenz
  switch $prjx(fc2.ref) {
    "None" { display_graph_reference_state $project_number \
      "ll_net->fc2" "None"
      }
    "LL-Net" { display_graph_reference_state $project_number \
      "ll_net->fc2" "LL-Net"
      }
  }  ;# switch ueber FC2-Referenz

  display_graph_reference_state $project_number \
    "bpn2.normal->c_source" $prjx(c_source.ref)

    # Angaben "uber das Vorhandensein von Dateien holen
  foreach type {bpn2.normal bpn2.expanded boxexpr c_source ll_net \
	hl_net unfolding.text doc formula.normal pfa ina spin smv fc2 sdl} {
    graph_check_file $project_number $type
  }
    # Angaben "uber die Dateien ausgeben
  foreach type {bpn2.normal bpn2.expanded boxexpr c_source ll_net \
	hl_net doc formula.normal pfa ina sdl unfolding.text spin smv fc2} {
    display_graph_file_state $project_number $type
  }
    # Zustand der Editoren ausgeben
  foreach type {bpn2.normal bpn2.expanded boxexpr c_source ll_net \
	hl_net doc formula.normal pfa ina sdl} {
    display_graph_editor_state $project_number $type
  }
    # Informationstext auf etwas vern"unftiges setzen
  .prjtoplvl$project_number.infotext_1 configure  -text "No object selected"
}  ;# update_project_graph_files

proc graph_enter_frame_pattern {win taglist} {
  # Anzeigen der Daten f"ur das zugeh"orige Dateiobjekt in dem Graphen.
  # win - Widget-Name aus dem Binding
  # taglist - Liste der Tag-Namen des Dateiobjektes

  set project_number [strip_prj_num $win]

  upvar #0 prj$project_number prjx

  set infotext_2 " "
  set name [lindex $taglist 0]
  switch $name {
    bpn2.normal {
      set infotext_1 "Basic Petri Net Programming Notation (B(PN))"
      set infotext_2 "Syntax Check - $prjx(bpn2.normal.syntax_ok)"
      set infotext_2 "$infotext_2 / Procedures - $prjx(bpn2.normal.procs)"
    }
    bpn2.expanded {
      set infotext_1 "Expanded B(PN)"
    }
    boxexpr {
      set infotext_1 "Petri Box Calculus (PBC)"
    }
    ll_net {
      set infotext_1 "Low Level Petri Net"
    }
    hl_net {
      set infotext_1 "High Level Petri Net"
    }
    c_source {
      set infotext_1 "C Language Source"
    }
    unfolding.text {
      set infotext_1 "Modelchecker (Safe)"
    }
    doc {
      set infotext_1 "Project Documentation"
    }
    formula.normal {
      set infotext_1 "Formula"
    }
    ina {
      set infotext_1 "Integrated Net Analyzer"
    }
    smv {
      set infotext_1 "Modelchecker (SMV)"
    }
    spin {
      set infotext_1 "Modelchecker (SPIN)"
    }
    pfa {
      set infotext_1 "PFA"
    }
    fc2 {
      set infotext_1 "FC2 Deadlock-free System"
    }
    sdl {
      set infotext_1 "SDL"
    }
    default {
      set infotext_1 "Oops: Unknown Tagname ($name)"
    }
  }  ;# switch "uber den Namen des Dateiobjektes als Tag-Name
  .prjtoplvl$project_number.infotext_1 configure  -text $infotext_1
  .prjtoplvl$project_number.infotext_2 configure  -text $infotext_2
}  ;# graph_enter_frame_pattern

proc graph_leave_frame_pattern {win taglist} {
  # Zur"ucksetzen des Informationstextes f"ur den Graphen.
  # win - Widget-Name aus dem Binding
  # taglist - Liste der Tag-Namen des Dateiobjektes

  set project_number [strip_prj_num $win]

  .prjtoplvl$project_number.infotext_1 configure  -text "No Object selected"
  .prjtoplvl$project_number.infotext_2 configure  -text " "
}  ;# graph_leave_frame_pattern

proc viewEnterArrow {win Name} {
 # Infoanzeige setzen, wenn cursor ueber einer Referenz
 # win  -> Widget-Name aus dem Binding
 # Name -> Name der Referenz (von->nach)
  set prj_num [strip_prj_num $win]
  upvar #0 prj$prj_num prjx
  set infotext_1 " "
  set infotext_2 "Double Click to start Converter,\
                  Click right to open Options Dialog"
   # Ausgabe: Existiert die Referenz oder nicht?
  switch $Name {
    bpn2.normal->bpn2.expanded {
      set infotext_1 "Reference B(PN) -> Expanded B(PN)\
      [expr {[string compare $prjx(bpn2.expanded.ref) B(PN)] \
      ? "does not exist" : "exists"}]"
    }
    bpn2.normal->boxexpr {
      set infotext_1 "Reference B(PN) -> PBC\
      [expr {[string compare $prjx(boxexpr.ref) B(PN)] \
      ? "does not exist" : "exists"}]"
    }
    boxexpr->ll_net {
      set infotext_1 "Reference PBC -> LL Net\
      [expr {[string compare $prjx(ll_net.ref) PBC] \
      ? "does not exist" : "exists"}]"
    }
    hl_net->ll_net {
      set infotext_1 "Reference HL Net -> LL Net\
      [expr {[string compare $prjx(ll_net.ref) HL-Net] \
      ? "does not exist" : "exists"}]"
    }
    pfa->hl_net {
      set infotext_1 "Reference PFA -> HL Net\
      [expr {[string compare $prjx(hl_net.ref) PFA] \
      ? "does not exist" : "exists"}]"
     }
    bpn2.normal->hl_net {
      set infotext_1 "Reference B(PN) -> HL Net\
      [expr {[string compare $prjx(hl_net.ref) B(PN)] \
      ? "does not exist" : "exists"}]"
     }
    bpn2.expanded->hl_net {
      set infotext_1 "Reference Expanded B(PN) -> HL Net\
      [expr {[string compare $prjx(hl_net.ref) "Exp-B(PN)"] \
      ? "does not exist" : "exists"}]"
     }
    ll_net->unfolding.text {
      set infotext_1 "Reference LL Net -> Prefix\
      [expr {[string compare $prjx(unfolding.text.ref) LL-Net] \
      ? "does not exist" : "exists"}]"
     }
    pfa->bpn2.normal {
      set infotext_1 "Reference PFA -> B(PN)\
      [expr {[string compare $prjx(bpn2.normal.ref) PFA] \
      ? "does not exist" : "exists"}]"
     }
    ll_net->ina {
      set infotext_1 "Reference LL Net -> INA\
      [expr {[string compare $prjx(ina.ref) LL-Net] \
      ? "does not exist" : "exists"}]"
     }
    ll_net->smv {
      set infotext_1 "Reference LL Net -> SMV\
        [expr {[string compare $prjx(smv.ref) LL-Net] \
        ? "does not exist" : "exists"}]"
      set infotext_2 " "
     }
    ll_net->spin {
      set infotext_1 "Reference LL Net -> SPIN\
      [expr {[string compare $prjx(spin.ref) LL-Net] \
      ? "does not exist" : "exists"}]"
     }
    bpn2.normal->c_source {
      set infotext_1 "Reference B(PN) -> C Source\
      [expr {[string compare $prjx(c_source.ref) "B(PN)"] \
      ? "does not exist" : "exists"}]"
     }
    ll_net->fc2 {
      set infotext_1 "Reference LL Net -> FC2\
      [expr {[string compare $prjx(fc2.ref) LL-Net] \
      ? "does not exist" : "exists"}]"
     }
    sdl->hl_net {
      set infotext_1 "Reference SDL -> HL Net\
      [expr {[string compare $prjx(hl_net.ref) SDL] \
      ? "does not exist" : "exists"}]"
     }
  } ;# switch Name
  .prjtoplvl$prj_num.infotext_1 configure  -text $infotext_1
  .prjtoplvl$prj_num.infotext_2 configure  -text $infotext_2
}  ;# viewEnterArrow

# viewLeaveArrow # Infoanzeige setzen, wenn cursor eine Referenz verlaesst
 # win  -> Widget-Name aus dem Binding
proc viewLeaveArrow {win} {
  set project_number [strip_prj_num $win]
  .prjtoplvl$project_number.infotext_1 configure  -text "No Object selected"
  .prjtoplvl$project_number.infotext_2 configure  -text " "
}  ;# viewLeaveArrow

proc graph_enter_editor {win taglist} {
  # Anzeigen der Editordaten f"ur das zugeh"orige Dateiobjekt in dem Graphen.
  # win - Widget-Name aus dem Binding
  # taglist - Liste der Tag-Namen des Dateiobjektes

  set project_number [strip_prj_num $win]

  upvar #0 prj$project_number prjx

    # Welcher Editor ist gemeint?
  set tag [lindex $taglist [lsearch -glob $taglist {*.editor*}]]
  set name [string range $tag 0 [expr [string first ".editor" $tag] - 1]]
  switch $name {
    bpn2.normal {
      display_graph_editor_state $project_number bpn2.normal
    }
    bpn2.expanded {
      display_graph_editor_state $project_number bpn2.expanded
    }
    boxexpr {
      display_graph_editor_state $project_number boxexpr
    }
    ll_net {
      display_graph_editor_state $project_number ll_net
    }
    hl_net {
      display_graph_editor_state $project_number hl_net
    }
    c_source {
      display_graph_editor_state $project_number c_source
    }
    doc {
      display_graph_editor_state $project_number doc
    }
    formula.normal {
      display_graph_editor_state $project_number formula.normal
    }
    sdl {
      display_graph_editor_state $project_number sdl
    }
    default {
      error_msg "Internal error: Unknown name $name\n\
        in proc graph_enter_editor"
    }
  }  ;# switch "uber den Namen des Dateiobjektes als Tag-Name
}  ;# graph_enter_editor

proc graph_leave_editor {win taglist} {
  # Zur"ucksetzen des Informationstextes f"ur den Graphen.
  # win - Widget-Name aus dem Binding
  # taglist - Liste der Tag-Namen des Dateiobjektes

  set project_number [strip_prj_num $win]

  .prjtoplvl$project_number.infotext_1 configure  -text "No Object selected"
  .prjtoplvl$project_number.infotext_2 configure  -text " "
}  ;# graph_leave_editor

proc graph_show_or_open_editor { win name } {
#proc graph_show_or_open_editor {win taglist} 
  # Falls der Editor offen ist, diesen auf dem Bildschirm nach
  # nach oben verlagern. Wenn der Editor nicht auf ist, dann "offnen
  # win - Widget-Name aus dem Binding
  # taglist - Liste der Tag-Namen des Dateiobjektes

    # Projektnummer und -variable bestimmen
  set prjnum [strip_prj_num $win]

  global gvar
  upvar #0 prj$prjnum prjx

    # Welcher Editor ist gemeint?

  if {$gvar(view.$name,editor_bitmap)!=" "} {
  }
     # Aktion einleiten
    if {$prjx($name.comstate) == "disconnected"} {
      open_an_editor $prjnum $name
    } elseif {$prjx($name.comstate) != "comming up"} {
      raise_an_editor $prjnum $name
    }  ;# elseif, Editor ist auf, also nach oben
}  ;# graph_show_or_open_editor 

proc graph_show_or_open_analyzer { win name } {
 # startet einen Punkt aus dem Analyse-Menue (wenn dieser gerade
 # disabled ist, passiert halt nix!
#TODO: wenn der analyzer bereit offen ist, sollte er nach
# vorn gebracht werden!

    # Projektnummer und -variable bestimmen
  set prjnum [strip_prj_num $win]

  global gvar
  upvar #0 prj$prjnum prjx

  switch $name {
    unfolding.text {
      $prjx(project.ana.menu.widget) invoke "CTL Model Checker (Safe)*"
    }
    smv {
      $prjx(project.ana.menu.widget) invoke "CTL Model Checker (SMV)*"
    }
    spin {
      $prjx(project.ana.menu.widget) invoke "LTL Model Checker (SPIN)*"
    }
    fc2 {
      $prjx(project.ana.menu.widget) invoke "Deadlock-free System*"
    }
    default {
      DEBUG "proc graph_show_or_open_analyzer: unknown tag name: $name !"
    }
  } ;# switch $name
} ;# proc graph_show_or_open_analyzer

proc graphViewDrawAll { prjtoplvl project_number } {
 # zeichnet den Canvas-Inhalt (alles was dargestellt werden soll)
 # prjtoplvl -> Projekt-Toplevel
 # proj_num  -> Projekt-Nummer

  global gvar
    # Zugriff auf die Projektvariable erlangen
  upvar #0 prj$project_number prjx

  # erstmal alles loeschen...
  $prjtoplvl.cnvs delete all
  # ...dann alles neu zeichnen
  # zuerst alle Icons
  foreach i $gvar(view.icon_list) {
    if {$prjx(view.$i,show)==1} {
      viewIconDraw $prjtoplvl $project_number $i
    }
  }
  # dann die pfeile obendrueber
  foreach i $gvar(view.icon_list) {
    if {$prjx(view.$i,show)==1} {
      foreach j $gvar(view.$i,arrow_to) {
        if {$prjx(view.$j,show)==1} {
	  viewArrowDraw $prjtoplvl $project_number $i $j
	}
      }
    }
  }
} ;# graphViewDrawAll

proc viewIconDraw { prjtoplvl prj_num iName } {
 # Prozedur zum zeichnen eines Icons
 # prjtoplvl      -> Projekt-Toplevel
 # project_number -> Projekt-Nummer
 # iName          -> Name des zu zeichnenden Icons (IconName)

    # Zugriff auf die Projektvariable erlangen
  upvar #0 prj$prj_num prjx
  global gvar

   # Koordinaten des Icons (Icon-Mitte)
  set x $prjx(view.$iName,x)
  set y $prjx(view.$iName,y)

   # Grundflaeche erzeugen
  $prjtoplvl.cnvs create image $x $y \
    -image image_frame_pattern_$gvar(view.$iName,frame_pattern) \
    -anchor center \
    -tags "icon$iName $iName.frame"
   # Icon auf die Grundflaeche malen
  $prjtoplvl.cnvs create image [expr $x - 4] $y \
    -image image_$iName \
    -anchor e \
    -tags "icon$iName $iName.frame"

  switch $gvar(view.$iName,editor_bitmap) {
    analyzer {
     }
    " " {
       # "Datei ist vorhanden"-Anzeige
      $prjtoplvl.cnvs create rectangle [expr $x - 2] [expr $y - 17] \
        [expr $x + 31] [expr $y + 15]  -width 0  -fill cornsilk3 \
        -tags icon$iName
      $prjtoplvl.cnvs create image [expr $x - 1] [expr $y - 1] \
        -anchor w  -tags "icon$iName $iName.file"  -image file_exists
       # Binding fuer den Doppelklick
      if {$iName!="ina"} {
        set binding_Double1 "graph_show_or_open_analyzer %W $iName"
      } else {
        set binding_Double1 "graph_show_or_open_editor %W ina"
      } ;# if $iName!=ina
     }
    default {
       # "Datei ist vorhanden"-Anzeige
      $prjtoplvl.cnvs create rectangle [expr $x - 2] [expr $y - 2] \
        [expr $x + 31] [expr $y - 34]  -width 0  -fill cornsilk3 \
        -tags icon$iName
      $prjtoplvl.cnvs create image [expr $x - 1] [expr $y - 1] \
        -anchor sw  -tags "icon$iName $iName.file"  -image file_exists

       # "Editor ist ge"offnet"-Anzeige
      $prjtoplvl.cnvs create rectangle [expr $x - 2] [expr $y + 2] \
        [expr $x + 31] [expr $y + 34]  -width 0  -fill cornsilk3 \
        -tags icon$iName
      $prjtoplvl.cnvs create image [expr $x - 1] [expr $y + 2] \
        -anchor nw  -tags "icon$iName $iName.editor" \
	-image $gvar(view.$iName,editor_bitmap)_editor_open
       # Binding fuer den Doppelklick
      set binding_Double1 "graph_show_or_open_editor %W $iName"
     }
  }

  # was hat die Maus damit zu tun? -> Bindings setzen
  if {$prjx(view.editable)} {
    $prjtoplvl.cnvs bind $iName.frame <Enter> {}
    $prjtoplvl.cnvs bind $iName.frame <Leave> {}
    $prjtoplvl.cnvs bind $iName.file <Enter> {}
    $prjtoplvl.cnvs bind $iName.file <Leave> {}
    $prjtoplvl.cnvs bind $iName.editor <Enter> {}
    $prjtoplvl.cnvs bind $iName.editor <Leave> {}
    $prjtoplvl.cnvs bind icon$iName <B1-Motion> \
      "viewIconMove $prj_num $iName %x %y"
    $prjtoplvl.cnvs bind icon$iName <Double-1> {}
    $prjtoplvl.cnvs bind icon$iName <Delete> \
	"set $prjx(view.$iName,show) 0"
    $prjtoplvl.cnvs bind icon$iName <ButtonPress-3> {}
    $prjtoplvl.cnvs bind icon$iName <ButtonRelease> \
      "$prjtoplvl.cnvs raise arrow; $prjtoplvl.cnvs delete arrowEditPoint"
  } else {
    $prjtoplvl.cnvs bind $iName.frame <Enter> \
       "graph_enter_frame_pattern %W $iName"
    $prjtoplvl.cnvs bind $iName.frame <Leave> \
       "graph_leave_frame_pattern %W $iName"
    $prjtoplvl.cnvs bind $iName.file <Enter> \
       "display_graph_file_state $prj_num $iName"
    $prjtoplvl.cnvs bind $iName.editor <Enter> \
       "display_graph_editor_state $prj_num $iName"
    $prjtoplvl.cnvs bind icon$iName <B1-Motion> {}
    $prjtoplvl.cnvs bind icon$iName <ButtonPress-3> \
       "viewOpenOptionsDlg $prj_num $iName"
    $prjtoplvl.cnvs bind icon$iName <Double-1> $binding_Double1
    $prjtoplvl.cnvs bind icon$iName <ButtonRelease> {}
  }
} ;# viewIconDraw 

# viewArrowDraw # zeichnet ggf. einen Pfeil :)
proc viewArrowDraw { prjtoplvl prj_num von nach } {
  global gvar
   # Zugriff auf die Projektvariable erlangen
  upvar #0 prj$prj_num prjx

  set pfeil "$von->$nach"
  # darf der Pfeil ueberhaupt gezeichnet werden?
  if { ($prjx(view.$von,show)==1) \
        && ($prjx(view.$nach,show)==1) \
        && ($prjx(view.$pfeil,show)==1) } {
            # Ja! auf geht's:
            set x1 [expr $prjx(view.$von,x)+$prjx(view.$pfeil,x1)]
            set y1 [expr $prjx(view.$von,y)+$prjx(view.$pfeil,y1)]
            set x3 [expr $prjx(view.$nach,x)+$prjx(view.$pfeil,x3)]
            set y3 [expr $prjx(view.$nach,y)+$prjx(view.$pfeil,y3)]
            $prjtoplvl.cnvs create line $x1 $y1 \
              $prjx(view.$pfeil,x2) $prjx(view.$pfeil,y2) \
              $x3 $y3 \
              -arrow last -width 4 \
              -arrowshape { 4 10 6 } \
              -smooth true \
              -splinesteps 9 \
              -fill $gvar(reference_ok.color) \
              -tags " alles arrow arrow$pfeil arrow_$von arrow_$nach"
            if {$prjx(view.editable)} {
              $prjtoplvl.cnvs bind arrow$pfeil <ButtonPress> \
                "viewMarkArrowEdit $prj_num $von $nach"
              $prjtoplvl.cnvs bind arrow$pfeil <Double-1> \
	        "viewArrowStraighten $prj_num $von $nach"
              $prjtoplvl.cnvs bind arrow$pfeil <Delete> \
	        "set $prjx(view.$pfeil,show) 0"
              $prjtoplvl.cnvs bind arrow$pfeil <ButtonPress-3> {}
	      $prjtoplvl.cnvs bind arrow$pfeil <Enter> {}
	      $prjtoplvl.cnvs bind arrow$pfeil <Leave> {}
            } else {
              $prjtoplvl.cnvs bind arrow$pfeil <ButtonPress> {}
              $prjtoplvl.cnvs bind arrow$pfeil <Double-1> \
	        "viewStartConverter $prj_num $pfeil"
              $prjtoplvl.cnvs bind arrow$pfeil <ButtonPress-3> \
                "viewOpenOptionsDlg $prj_num $pfeil"
	      $prjtoplvl.cnvs bind arrow$pfeil <Enter> \
	        "viewEnterArrow %W $pfeil"
	      $prjtoplvl.cnvs bind arrow$pfeil <Leave> \
	        "viewLeaveArrow %W"
            }
  } ;# if Referenz soll dargestellt werden
} ;# viewArrowDraw

proc viewIconMove {pn name x y } {
 # boxMove # Prozedur zum Bewegen der Box
 # pn   -> project number
 # name -> Name des zu bewegenden Icons
 # x,y  -> move
  global gvar
  upvar #0 prj$pn prjx

   # zugriff auf Canvas ueber $c
  set c .prjtoplvl$pn.cnvs
  $c raise icon$name
  # ggf. erst einmal arrowEditPoints entfernen...
  $c delete arrowEditPoint
  # Bewegung ausrechnen
  set xMovement [expr $x-$prjx(view.$name,x)]
  set yMovement [expr $y-$prjx(view.$name,y)]
  # neue Koordinaten setzen
  set prjx(view.$name,x) $x
  set prjx(view.$name,y) $y
  # alle beruehrenden Pfeile loeschen
  $c delete arrow_$name
  # Icon bewegen
  $c move icon$name $xMovement $yMovement
  # ausgehende Pfeile neu zeichnen
  foreach pfeil $gvar(view.$name,arrow_to) {
    # mittlere Koordinate neu berechnen
    set prjx(view.$name->$pfeil,x2) \
      [expr $prjx(view.$name->$pfeil,x2)+$xMovement]
    set prjx(view.$name->$pfeil,y2) \
      [expr $prjx(view.$name->$pfeil,y2)+$yMovement]
    viewArrowDraw .prjtoplvl$pn $pn $name $pfeil
  }
  # eingehende Pfeile neu zeichnen
  foreach pfeil $gvar(view.$name,arrow_from) {
    # mittlere Koordinate neu berechnen
    set prjx(view.$pfeil->$name,x2) \
      [expr $prjx(view.$pfeil->$name,x2)+$xMovement]
    set prjx(view.$pfeil->$name,y2) \
      [expr $prjx(view.$pfeil->$name,y2)+$yMovement]
    viewArrowDraw .prjtoplvl$pn $pn $pfeil $name
  }
};# viewIconMove

proc viewMarkArrowEdit { pn von nach } {
 # Markiert einen Pfeil (Referenz) zum Verschieben
 # pn   -> project number
 # von  -> Pfeil-Ursprung
 # nach -> Pfeil-Ziel
  upvar #0 prj$pn prjx

  set c .prjtoplvl$pn.cnvs
  $c delete arrowEditPoint
  set pfeil "$von->$nach"
  $c create rect [expr $prjx(view.$von,x)+$prjx(view.$pfeil,x1)-5] \
        [expr $prjx(view.$von,y)+$prjx(view.$pfeil,y1)-5] \
        [expr $prjx(view.$von,x)+$prjx(view.$pfeil,x1)+5] \
        [expr $prjx(view.$von,y)+$prjx(view.$pfeil,y1)+5] \
        -fill black \
        -tags " alles arrowEditPoint arrowEditPoint1 "
  $c bind arrowEditPoint1 <B1-Motion> "viewArrowEdit $pn $von $nach 1 %x %y"
   # eigentlich waer's ja schoener, wenn der mittlere Punkt auf
   # dem Spline laege...
  $c create rect [expr $prjx(view.$pfeil,x2)-5] \
        [expr $prjx(view.$pfeil,y2)-5] \
        [expr $prjx(view.$pfeil,x2)+5] \
        [expr $prjx(view.$pfeil,y2)+5] \
        -fill black \
        -tags " alles arrowEditPoint arrowEditPoint2 "
  $c bind arrowEditPoint2 <B1-Motion> "viewArrowEdit $pn $von $nach 2 %x %y"
  $c create rect [expr $prjx(view.$nach,x)+$prjx(view.$pfeil,x3)-5] \
        [expr $prjx(view.$nach,y)+$prjx(view.$pfeil,y3)-5] \
        [expr $prjx(view.$nach,x)+$prjx(view.$pfeil,x3)+5] \
        [expr $prjx(view.$nach,y)+$prjx(view.$pfeil,y3)+5] \
        -fill black \
        -tags " alles arrowEditPoint arrowEditPoint3 "
  $c bind arrowEditPoint3 <B1-Motion> "viewArrowEdit $pn $von $nach 3 %x %y"
  $c bind arrowEditPoint <ButtonRelease-1> "$c delete arrowEditPoint"
} ;# viewMarkArrowEdit

proc viewArrowEdit { pn von nach punkt x y } {
 # verschieben der Pfeil-Koordinaten
 # pn    -> project number
 # von   -> Quelle
 # nach  -> Ziel
 # punkt -> 1=Ursprung, 2=Mitte, 3=Ziel
 # x,y   -> Koordinaten
  upvar #0 prj$pn prjx
  global gvar

  set pfeil "$von->$nach"
  set c .prjtoplvl$pn.cnvs
  $c delete arrow$pfeil

  set breite 45
  set hoehe 35

  switch $punkt {
    1 {
       # wie weit darf der Pfeilursprung vom Ursprung entfernt liegen?
      set pattern $gvar(view.$von,frame_pattern)
      set breite [expr $gvar(view.frame_pattern_$pattern,x)/2]
      set hoehe [expr $gvar(view.frame_pattern_$pattern,y)/2]

       # Abstand zwischen Icon (Zentrum) und EditPoint berechnen
      set xdiff [expr $x - $prjx(view.$von,x)]
      set ydiff [expr $y - $prjx(view.$von,y)]
       # Abstand zu gross? Verkleinern!
      set xdiff \
           [expr {($xdiff>$breite) ? $breite : $xdiff}]
      set xdiff \
           [expr {($xdiff<[expr -$breite]) ? [expr -$breite] : $xdiff}]
      set ydiff \
           [expr {($ydiff>$hoehe) ? $hoehe : $ydiff}]
      set ydiff \
           [expr {($ydiff<[expr -$hoehe]) ? [expr -$hoehe] : $ydiff}]
       # Abstand zu klein?
       # egal!  Pfeil darf innerhalb des Icons beginnen oder enden.
      set x_alt $prjx(view.$pfeil,x1)
      set y_alt $prjx(view.$pfeil,y1)
      set prjx(view.$pfeil,x1) $xdiff
      set prjx(view.$pfeil,y1) $ydiff

      viewArrowDraw .prjtoplvl$pn $pn $von $nach
      $c move arrowEditPoint1 \
          [expr $xdiff-$x_alt] \
          [expr $ydiff-$y_alt]
    }
    2 {
      set x_alt $prjx(view.$pfeil,x2)
      set y_alt $prjx(view.$pfeil,y2)
      set prjx(view.$pfeil,x2) $x
      set prjx(view.$pfeil,y2) $y
      viewArrowDraw .prjtoplvl$pn $pn $von $nach
      $c move arrowEditPoint2 [expr $x-$x_alt] [expr $y-$y_alt]
    }
    3 {
       # wie weit darf die Pfeilspitze vom Ursprung entfernt liegen?
      set pattern $gvar(view.$nach,frame_pattern)
      set breite [expr $gvar(view.frame_pattern_$pattern,x)/2]
      set hoehe [expr $gvar(view.frame_pattern_$pattern,y)/2]

       # Abstand zwischen box (Mitte) und EditPoint berechnen
      set xdiff [expr $x - $prjx(view.$nach,x)]
      set ydiff [expr $y - $prjx(view.$nach,y)]
       # Abstand zu gross? Verkleinern!
      set xdiff \
           [expr {($xdiff>$breite) ? $breite : $xdiff}]
      set xdiff \
           [expr {($xdiff<[expr -$breite]) ? [expr -$breite] : $xdiff}]
      set ydiff \
           [expr {($ydiff>$hoehe) ? $hoehe : $ydiff}]
      set ydiff \
           [expr {($ydiff<[expr -$hoehe]) ? [expr -$hoehe] : $ydiff}]
       # Abstand zu klein? Vergroessern!
       # egal!  Pfeil darf innerhalb des Icons beginnen oder enden.
      set x_alt $prjx(view.$pfeil,x3)
      set y_alt $prjx(view.$pfeil,y3)
      set prjx(view.$pfeil,x3) $xdiff
      set prjx(view.$pfeil,y3) $ydiff

      viewArrowDraw .prjtoplvl$pn $pn $von $nach
      $c move arrowEditPoint3 \
          [expr $xdiff-$x_alt] \
          [expr $ydiff-$y_alt]
    }
  }
} ;# viewArrowEdit

proc viewArrowStraighten { prj_num von nach } {
 # richtet einen Pfeil gerade
 # (Notloesung) damit man den mittleren EditPoint ggf. wieder
 #              ins Bild bekommt
  upvar prj$prj_num prjx

  set pfeil "$von->$nach"
   # Koordinaten des mittleren Punktes berechnen
  set x [expr ($prjx(view.$von,x)+$prjx(view.$pfeil,x1) \
               +$prjx(view.$nach,x)+$prjx(view.$pfeil,x3) \
	       )/2 ]
  set y [expr ($prjx(view.$von,y)+$prjx(view.$pfeil,y1) \
               +$prjx(view.$nach,y)+$prjx(view.$pfeil,y3) \
	       )/2 ]
  set prjx(view.$pfeil,x2) $x
  set prjx(view.$pfeil,y2) $y
   # den alten Pfeil loeschen
  .prjtoplvl$prj_num.cnvs delete arrow$pfeil
  viewArrowDraw .prjtoplvl$prj_num $prj_num $von $nach
  viewMarkArrowEdit $prj_num $von $nach
} ;# proc viewArrowStraighten

proc create_graph_file_view {prjtoplvl project_number} {
  # Einen Graphen fuer das Projekt einbauen.
  # prjtoplvl -  Das TopLevel des Projektes.
  # project_number - Die Nummer der Projektvariablen.

    # Zugriff auf die Projektvariable erlangen
  upvar #0 prj$project_number prjx

   # Canvas erstellen
   # Die Hintergrundfarbe des Canvas kann leider nicht so leicht auf
   # etwas anderes gesetzt werden, da hierfuer dann auch der Hintergrund
   # der frames_pattern geaendert werden muss (s. proc ViewSetPalette)
  set cnvs [canvas $prjtoplvl.cnvs -relief sunken -bd 2 \
    -width 200 -height 100]
  pack $cnvs -side top -fill both -expand true
  set prjx(infotext_1.widget) [label $prjtoplvl.infotext_1 \
    -text "No object selected"]
  pack $prjtoplvl.infotext_1 -side top -fill x
  set prjx(infotext_2.widget) [label $prjtoplvl.infotext_2 \
    -text " "]
  pack $prjtoplvl.infotext_2 -side top -fill x

   # inhalt des Canvas (Graph Darstellung) zeichnen
  graphViewDrawAll $prjtoplvl $project_number

   # update der Referenzen(anzeige)
  update_project_graph_files $project_number
}  ;# create_graph_file_view

  #*** Dateiende projinfo.tcl ***

