#ifndef ARRAY_H
#define ARRAY_H

#include "assert.h"
#include <stdio.h>
#include <sys/types.h>

template <class T> class _Array
{
  public:
    T data;
    _Array *next;
    _Array();
    ~_Array();
};

template <class T>_Array<T>::_Array()
{
  next=NULL;
}

template <class T>_Array<T>::~_Array()
{
}

template <class T> class Array
{
  protected:
    _Array<T> *array_ptr;
    int size;
  public:
    Array();
    ~Array();
    Array(const Array<T> &x);
    int GetSize() const;
    T& operator[](int x) const;
    void DeleteHead();
    void Add(const T x);
    void AddHead(const T x);
    void AddAt(int index, const T x);
    void Copy(const Array<T> &x);
    void Copy(const Array<T> &x, int i);
    int contains(T x) const;
    void Clear();
};

template <class T>Array<T>::Array()
{
  array_ptr=NULL;
  size=0;
}

template <class T>Array<T>::~Array()
{
  _Array<T> *p1,*p2;
  p1=array_ptr;
  while (p1)
  {
    p2=p1;
    p1=p1->next;
//    delete p2;
  }
  array_ptr=NULL;
  size=0;
}

template <class T>int Array<T>::GetSize() const
{
  return size;
}

template <class T>T& Array<T>::operator [](int x) const
{
  assert((x>=0) && (x<size));
  _Array<T> *p=array_ptr;
  for (int i=0; i<x; i++)
    p=p->next;
  return p->data;
}

template <class T>void Array<T>::Add(const T x)
{
  size++;
  _Array<T> *p=new _Array<T>;
  p->data=x;
  if (!array_ptr)
  {
    array_ptr=p;
    return;
  }
  _Array<T> *p1=array_ptr;
  while (p1->next)
    p1=p1->next;
  p1->next=p;
}

template <class T>void Array<T>::AddHead(const T x)
{
  size++;
  _Array<T> *p=new _Array<T>;
  p->data=x;
  p->next=array_ptr;
  array_ptr=p;
}


// Einfuegen nach Element index
template <class T>void Array<T>::AddAt(int index, const T x)
{
  if (index>=size)
    Add(x);
  size++;
  _Array<T> *p=new _Array<T>;
  p->data=x;
  _Array<T> *p1=array_ptr;
  for (int i=0; i<index; i++)
    p1=p1->next;
  assert(p1!=NULL);
  p->next=p1->next;
  p1->next=p;
}

template <class T>void Array<T>::DeleteHead()
{
  if (!size)
    return;
  size--;
  _Array<T> *p=array_ptr;
  array_ptr=p->next;
//  delete p;
}

template <class T>void Array<T>::Copy(const Array<T> &x)
{
  Clear();
  for (int i=0; i<x.GetSize(); i++)
    Add(x[i]);
}

template <class T>void Array<T>::Copy(const Array<T> &x, int i)
{
  Clear();
  for (int j=i; j<x.GetSize(); j++)
    Add(x[j]);
}

template <class T>int Array<T>::contains(T x) const
{
  _Array<T> *p=array_ptr;
  while (p)
  {
    if (p->data==x)
      return 1;
    p=p->next;
  }
  return 0;
}

template <class T>void Array<T>::Clear()
{
  _Array<T> *p1,*p2;
  p1=array_ptr;
  while (p1)
  {
    p2=p1;
    p1=p1->next;
//    delete p2;
  }
  array_ptr=NULL;
  size=0;
}

template <class T>Array<T>::Array(const Array<T> &x)
{
  array_ptr=NULL;
  size=0;
  Copy(x);
}


typedef Array<char *> SArray;

typedef Array<int> IntArray;

#endif


