#include <sys/types.h>
#include <malloc.h>
#include <string.h>
#include "place.h"

#define CLASS "PlaceMark/PlaceMarkArray"

PlaceMark::PlaceMark()
{
  plusinnr=united=branchinfo=done=-1;
}

PlaceMark::PlaceMark(int _done, int _plusinnr, int _united, 
                     int _branchinfo, EdgeArray _RepeatEdges, 
                     StructArray _StructQ)
{
  done=_done;
  plusinnr=_plusinnr;
  united=_united;
  branchinfo=_branchinfo;
  RepeatEdges.Copy(_RepeatEdges);
  StructQ.Copy(_StructQ);
}


PlaceMark::~PlaceMark()
{
}

PlaceMark::PlaceMark(const PlaceMark& e)
{
  done=e.done;
  plusinnr=e.plusinnr;
  united=e.united;
  branchinfo=e.branchinfo;
  RepeatEdges.Copy(e.RepeatEdges);
  StructQ.Copy(e.StructQ);
}

PlaceMark& PlaceMark::operator=(const PlaceMark& e)
{
  done=e.done;
  plusinnr=e.plusinnr;
  united=e.united;
  branchinfo=e.branchinfo;
  RepeatEdges.Copy(e.RepeatEdges);
  StructQ.Copy(e.StructQ);
  return *this;
}

PlaceMarkArray::PlaceMarkArray()
{
  id=-1;
}

PlaceMarkArray::PlaceMarkArray(int _id, _PlaceMarkArray _Data)
{
  id=_id;
  Data.Copy(_Data);
}

PlaceMarkArray::~PlaceMarkArray()
{
}

PlaceMarkArray::PlaceMarkArray(const PlaceMarkArray& e)
{
  id=e.id;
  Data.Copy(e.Data);
}

PlaceMarkArray& PlaceMarkArray::operator=(const PlaceMarkArray& e)
{
  id=e.id;
  Data.Copy(e.Data);
  return *this;
}

