#ifndef PLACE_H
#define PLACE_H

#include "array.h"
#include "edge.h"
#include "struct.h"

class PlaceMark
{
  public:
    int done;
    int plusinnr;
    int united;
    int branchinfo;
    EdgeArray RepeatEdges;
    StructArray StructQ;

    PlaceMark();
    PlaceMark(int _done, int _plusinnr, int _united, int _branchinfo,
              EdgeArray _RepeatEdges, StructArray _StructQ);
    virtual ~PlaceMark();
    PlaceMark(const PlaceMark &p);
    PlaceMark& operator=(const PlaceMark &p);
    virtual char *GetClassName() { return "PlaceMark"; };
};

typedef Array<PlaceMark> _PlaceMarkArray;

class PlaceMarkArray
{
  public:
    int id;
    _PlaceMarkArray Data;
    PlaceMarkArray();
    PlaceMarkArray(int _id, _PlaceMarkArray _Data);
    virtual ~PlaceMarkArray();
    PlaceMarkArray(const PlaceMarkArray &p);
    PlaceMarkArray& operator=(const PlaceMarkArray &p);
    virtual char *GetClassName() { return "PlaceMarkArray"; };
};

typedef Array<PlaceMarkArray> PlaceMarkList;

#endif
