#include <string.h>
#include "project.h"
#include "misc.h"
#include "errors.h"
#include <ctype.h>
    Edge *blah;

char identifier[160],set[160];
int const_expr;
IntArray ConstValue, LConstValue;
SArray ConstName, LConstName;

int GetNextToken(char *&input)
{
  while (*input==' ')
    input++;

  if (!strncmp(input, "const", 5))
  {
    input+=5;
    return I_CONST;
  }

  if (!strncmp(input, "var", 3))
  {
    input+=3;
    return I_VAR;
  }

  if (*input=='=')
  {
    input++;
    return I_ASSIGN;
  }

  if (*input=='{')
  {
    input++;
    return I_BRACE_OPEN;
  }

  if (*input=='}')
  {
    input++;
    return I_BRACE_CLOSE;
  }

  if (!strncmp(input,"..",2))
  {
    input+=2;
    return I_RANGE;
  }

  if (*input==':')
  {
    input++;
    return I_COLON;
  }

  if (*input==',')
  {
    input++;
    return I_COMMA;
  }

  if (!strncmp(input,"init",4))
  {
    input+=4;
    return I_INIT;
  }

  if (!strncmp(input,"chan",4))
  {
    input+=4;
    return I_CHAN;
  }

  if (!strncmp(input,"stack",5))
  {
    input+=5;
    return I_STACK;
  }

  if (!strncmp(input,"of",2))
  {
    input+=2;
    return I_OF;
  }

  /* Test auf const_expr */
  char *tmp=input;
  int neg=0,value=0;
  if ((*input=='-') || (isdigit(*input)))
  {
    if (*input=='-')
    {
      neg=1;
      tmp++;
    }
    while (isdigit(*tmp))
    {
      value=value*10+(*tmp-'0');
      tmp++;
    }
    if (neg)
      const_expr=-value;
    else
      const_expr=value;
    input=tmp;
    return I_CONST_EXPR;
  }

  /* Test auf identifier */
  tmp=input;
  if (isalpha(*input))
  {
    sprintf(identifier,"%c", *input);
    tmp++;
    while ((isalpha(*tmp)) || (isdigit(*tmp) || (*tmp=='_')))
    {
      sprintf(identifier,"%s%c",identifier, *tmp);
      tmp++;
    }
    input=tmp;
    return I_IDENT;
  }
  return I_ERROR;
}

int zeilenr, refnr=1;
FILE *reffile;

void SetBlock(int &xmin, int &ymin, int &xmax, int &ymax, char *string)
{
  int blank, count,i;
  ymin=zeilenr;

  for (i=0, blank=0, count=0; i<(int)strlen(string); i++)
  {
    if ((!count) && (string[i]==' '))
      blank++;
    if (((count) && (string[i]>=32)) || (string[i]>32))
      count++;
  }
  ymax=zeilenr;
  xmin=blank;
  xmax=blank+count;
  zeilenr++;
}

void PrintBlock(FILE *f, FILE *reffile, char *string, int par)
{
  int xmin,xmax,ymin,ymax;
  char zeile[160];
  SetBlock(xmin,ymin,xmax,ymax, string);
  strncpy(zeile, string+xmin, xmax-xmin+1);
  zeile[xmax-xmin+1]=0;
  if (reffile)
    fprintf(reffile, "%d R\"(%d,%d;%d,%d)\"E\"%d\"b\"%s\"\n", refnr, ymin,
xmin+1, ymax, xmax+1, par, zeile);
  fprintf(f, "%s\n", string);

  refnr++;
}  

int ReadSet(char *&string)
{
  int token,pass=0,i;
  *set=0;
  
  token=GetNextToken(string);
  if (token!=I_BRACE_OPEN)
    return 0;

  strcpy(set, "{");

  /* pass: 0 = noch nichts da
           1 = const_expr
	   2 = const_expr .. oder const_expr, 
  */

  for (;;)
  {
    token=GetNextToken(string);
    switch (token)
    {
      case I_BRACE_CLOSE:
        if (pass==1)
	{
	  strcat(set,"}");
	  return 1;
	}
	printf("Invalid set at line %d!\n", zeilenr-1);
	return 0;
      case I_CONST_EXPR:
	if (pass==1)
	{
	  printf("Invalid set at line %d!\n", zeilenr-1);
	  return 0;
	}
	sprintf(set, "%s%d", set, const_expr);
	pass=1;
	break;
      case I_IDENT:
	if (pass==1)
	{
	  printf("Invalid set at line %d!\n", zeilenr-1);
	  return 0;
	}
	/* Der Identifier muss vorher definiert worden sein */
	/* Zuerst die lokalen Konstanten */
	for (i=0; i<LConstName.GetSize(); i++)
	{
	  if (!strcmp(identifier,LConstName[i]))
	    sprintf(identifier, "%d", LConstValue[i]);
	}
	/* Danach die globalen Konstanten, falls es eine lokale Konstante gab,
           wurde der Bezeichner schon durch eine Zahl ersetzt und kann somit
           nicht mehr von einer globalen Konstante ersetzt werden */
	for (i=0; i<ConstName.GetSize(); i++)
	{
	  if (!strcmp(identifier,ConstName[i]))
	    sprintf(identifier, "%d", ConstValue[i]);
	}
	sprintf(set, "%s%s", set, identifier);
	pass=1;
	break;
      case I_COMMA:
	if (pass!=1)
	{
	  printf("Invalid set at line %d!\n", zeilenr-1);
	}
	pass=2;
	strcat(set,",");
	break;
      case I_RANGE:
	if (pass!=1)
	{
	  printf("Invalid set at line %d!\n", zeilenr-1);
	}
	pass=2;
	strcat(set,"..");
	break;

      default:
	printf("Invalid set at line %d!\n", zeilenr-1);
	return 0;
    }
  }
  return 0; /* never reached */
}

int ReadIdentList(char *&string, IntArray &xmin, IntArray &xmax, SArray &varnames, int offset)
{
  char *tmp=string,*tmp1=string;
  int token,pass=0,oldx;
  for (;;)
  {
    while (*string==' ')
    {
      string++;
      offset++;
    }
    tmp=string;
    oldx=offset+string-tmp1;
    token=GetNextToken(string);
    if (token==I_IDENT)
    {
      if (pass!=1)
      {
	xmin.Add(oldx);
	varnames.Add(strdup(identifier));
	xmax.Add(strlen(identifier)+oldx);
	pass=1;
      }
      else
      {
	printf("Invalid identifier list at line %d!\n", zeilenr-1);
	return 0;
      }
    }
    if (token==I_COMMA)
    {
      if (pass==1)
      {
	pass=2;
      }
      else
      {
	printf("Invalid identifier list at line %d!\n", zeilenr-1);
	return 0;
      }
    }
    if ((token!=I_COMMA) && (token!=I_IDENT))
    {
      if (pass!=1)
      {
	printf("Invalid identifier list at line %d!\n", zeilenr-1);
	return 0;
      }
      else
      {
	string=tmp;
	return 1;
      }
    }
  }  
}

void PrintVar(FILE *f, FILE *reffile, char *string, int local)
{
  int ymin,ymax,i;
  char range[160];
  SArray varnames;
  IntArray xmin,xmax;
  int channel=0,stack=0;
  int value;
#ifdef DEBUG
  printf("PrintVar : |%s|\n", string);
#endif

  char *string1=string;
  int token;

  ymin=ymax=zeilenr;
  fprintf(f, "%s\n", string);
  zeilenr++;

  token=GetNextToken(string);
  if (token==I_VAR)
  {
    /* variable declaration */
    if (!ReadIdentList(string, xmin, xmax, varnames, string-string1))
    {
      printf("Identifier expected at line %d!\n", zeilenr-1);
      return;
    }

    token=GetNextToken(string);
    if (token!=I_COLON)
    {
      printf("':' expected after identifier at line %d!\n", zeilenr-1);
      return;
    }

    token=GetNextToken(string);
    switch (token)
    {
      case I_BRACE_OPEN:
        string--;
	if (!ReadSet(string))
	{
	  printf("Misformated set found at line %d!\n", zeilenr-1);
	  return;
	}
	strcpy(range, set);
	token=GetNextToken(string);
	if (token==I_INIT)
	{
	  token=GetNextToken(string);
	  if (token!=I_CONST_EXPR)
	  {
	    printf("Constant expression expected after 'init' at line %d!\n", zeilenr-1);
	    return;
	  }
	}
	break;
      case I_CHAN:
	channel=1;
        token=GetNextToken(string);
	if (token!=I_CONST_EXPR)
	{
	  printf("Constant expression expected after 'chan' at line %d!\n", zeilenr-1);
	  return;
	}
	value=const_expr;
	token=GetNextToken(string);
	if (token!=I_OF)
	{
	  printf("'of' expected at line %d!\n", zeilenr-1);
	  return;
	}
	if (!ReadSet(string))
	{
	  printf("Misformated set found at line %d!\n", zeilenr-1);
	  return;
	}
	sprintf(range, "{%d}%s", value, set);
	break;
      case I_STACK:
	stack=1;
        token=GetNextToken(string);
	if (token!=I_CONST_EXPR)
	{
	  printf("Constant expression expected after 'stack' at line %d!\n", zeilenr-1);
	  return;
	}
	value=const_expr;
	token=GetNextToken(string);
	if (token!=I_OF)
	{
	  printf("'of' expected at line %d!\n", zeilenr-1);
	  return;
	}
	if (!ReadSet(string))
	{
	  printf("Misformated set found at line %d!\n", zeilenr-1);
	  return;
	}
	sprintf(range, "{%d}%s", value, set);
	break;
      default:
	printf("Invalid variable declaration at line %d!\n", zeilenr-1);
	return;
    }
    if (reffile)
    {
      for (i=0; i<varnames.GetSize(); i++)
      {
	if ((!channel) && (!stack))
	{
	  fprintf(reffile, "%d R\"(%d,%d;%d,%d)\"V\"%s\"b\"%s\"\n", refnr, ymin, xmin[i], ymax, xmax[i], range, varnames[i]);
	  refnr++;
	}
	if (channel)
	{
	  fprintf(reffile, "%d R\"(%d,%d;%d,%d)\"C\"%s\"b\"%s\"\n", refnr, ymin, xmin[i], ymax, xmax[i], range, varnames[i]);
	  refnr++;
	}
	if (stack)
	{
	  fprintf(reffile, "%d R\"(%d,%d;%d,%d)\"S\"%s\"b\"%s\"\n", refnr, ymin, xmin[i], ymax, xmax[i], range, varnames[i]);
	  refnr++;
	}
      }
    }
  }
  
  if (token==I_CONST)
  {
    /* Const declaration */
    token=GetNextToken(string);
    if (token!=I_IDENT)
    {
      printf("Identifier expected at line %d!\n", zeilenr-1);
      return;
    }
    token=GetNextToken(string);
    if (token!=I_ASSIGN)
    {
      printf("'=' expected at line %d!\n", zeilenr-1);
      return;
    }
    token=GetNextToken(string);
    if (token!=I_CONST_EXPR)
    {
      printf("Constant expression expected at line %d!\n", zeilenr-1);
      return;
    }
    value=const_expr;
    if (!local)
    {
      ConstName.Add(strdup(identifier));
      ConstValue.Add(value);
    }
    else
    {
      LConstName.Add(strdup(identifier));
      LConstValue.Add(value);
    }
  }
  
}

int PrintAction(FILE *f, FILE *reffile, char *string)
{
  int xmin,xmax,ymin,ymax,ret;
  char zeile[160];

  ymin=ymax=zeilenr;
  for (xmin=0; xmin<(int)strlen(string); xmin++)
    if (string[xmin]=='<')
      break;
  for (xmax=xmin; xmax<(int)strlen(string); xmax++)
    if (string[xmax]=='>')
      break;
  strncpy(zeile,string+xmin,xmax-xmin+1); 
  zeile[xmax-xmin+1]=0;
  
  if (reffile)
    fprintf(reffile, "%d R\"(%d,%d;%d,%d)\"Ab\"%s\"\n", refnr, ymin, xmin+1,
ymax, xmax+2, zeile);
  fprintf(f, "%s\n", string);
  ret=refnr;
  refnr++;
  zeilenr++;
  return ret;
}

int Project::Load(char *fname)
{
  FILE *f;
  char buffer[160];
  FA *fa;

  f=fopen(fname, "rt");

  if (!f)
  {
    fprintf(stderr, FILE_OPEN_ERR, fname);
    return 0;
  }

  if (!fgets(buffer, 160, f))
  {
    fprintf(stderr, FIRST_LINE_ERR);
    fclose(f);
    return 0;
  }

  if (strncmp(buffer, "PEP", 3))
  {
    fprintf(stderr, NO_PEP);
    fclose(f);
    return 0;
  }

  if (!fgets(buffer, 160, f))
  {
    fprintf(stderr, SECOND_LINE_ERR);
    fclose(f);
    return 0;
  }

  if (strncmp(buffer, "PROJECT_pepPFA", 14))
  {
    fprintf(stderr, INVALID_PRJ);
    fclose(f);
    return 0;
  }

  if (!fgets(buffer, 160, f))
  {
    fprintf(stderr, THIRD_LINE_ERR);
    fclose(f);
    return 0;
  }

  if (strncmp(buffer, "VAR", 3))
  {
    fprintf(stderr, NO_VAR);
    fclose(f);
    return 0;
  }
  
  for (;;)
  {
    if (!fgets(buffer, 160, f))
    {
      fprintf(stderr, EOF_ERR);
      fclose(f);
      return 0;
    }

    if (!strncmp(buffer, "FA", 2))
      break;
    ConvertString(buffer);
    Vars.Add(strdup(buffer));
  }
  if ((Vars.GetSize()==1) && (strlen(Vars[0])==0))
    Vars.Clear();

  for (;;)
  {
    if (!fgets(buffer, 160, f))
    {
      fclose(f);
      return 1;
    }

    fa=new FA();
    ConvertString(buffer);
    if (!fa->Load(buffer))
    {
      fprintf(stderr, FA_ERR, buffer);
      fclose(f);
      return 0;
    }
    FAs.Add(*fa);
  }
}

void Project::Dump()
{
  int i;

  printf("Globale Variablen :\n");
  for (i=0; i<Vars.GetSize(); i++)
    printf("  |%s|\n", Vars[i]);
  printf("\n");
  for (i=0; i<FAs.GetSize(); i++)
    FAs[i].Dump();
  printf("\n");
}

int Project::ExistArcsEntire()
{
  int i,res=0;

  for (i=0; i<FAs.GetSize(); i++)
    res|=FAs[i].ExistArcs();

  return res;
}

void Project::PrintDecl(FILE *f)
{
  int i;
  char buffer[160];
  for (i=0; i<Vars.GetSize(); i++)
  {
    sprintf(buffer, "    %s", Vars[i]);
    PrintVar(f, reffile, buffer);
  }
}

int Project::CompileBPN2(char *fname)
{
  FILE *f;
  int i,j,k;

  f=fopen(fname, "wt");
  if (!f)
  {
    fprintf(stderr, FILE_OPEN_ERR, fname);
    return -1;
  }

  if (refname)
  {
    reffile=fopen(refname, "wt");
    if (!reffile)
    {
      fprintf(stderr, FILE_OPEN_ERR, refname);
      return -1;
    }
    fprintf(reffile, "PEP\nReferences_PFA_BPN2\nFORMAT_N2\nDEF\n");  
  }
  else
    reffile=NULL;

  if (!ExistArcsEntire())
    return -2;

  zeilenr=1;
  PrintBlock(f, reffile, "begin", FAs.GetSize()>1);

  PrintDecl(f);

  for (i=0; i<FAs.GetSize(); i++)
    if (i==0) 
      FAs[i].Compile(f, "    ");
    else
      FAs[i].Compile(f, "||");
  
  fprintf(f, "end\n");
  fclose(f);

  if (reffile)
  {
    fprintf(reffile, "AR\n");
    for (i=0; i<FAs.GetSize(); i++)
    {
      for (j=0; j<FAs[i].Vertices.GetSize(); j++)
      {
	for (k=0; k<FAs[i].Vertices[j].EdgeSame.GetSize(); k++)
        {
	  fprintf(reffile, "%d T\"%d:0\"\n", FAs[i].Vertices[j].EdgeSame[k].id,
FAs[i].Vertices[j].EdgeSame[k].ref);
	}
	for (k=0; k<FAs[i].Vertices[j].EdgeOut.GetSize(); k++)
        {
	  fprintf(reffile, "%d T\"%d:0\"\n", FAs[i].Vertices[j].EdgeOut[k].id,
FAs[i].Vertices[j].EdgeOut[k].ref);
	}
      }
    }
    fclose(reffile);    
  }

  return 0;
}

int Project::CompileBPN2Struct(char *fname)
{
  FILE *f;
  int i,j,k;
  char parsym[160];
  strcpy(parsym, "        \n");
  int parnum=1;

#ifdef DEBUG
  Dump();
#endif

  f=fopen(fname, "wt");
  if (!f)
  {
    fprintf(stderr, FILE_OPEN_ERR, fname);
    return -1;
  }
  
  if (refname)
  {
    reffile=fopen(refname, "wt");
    if (!reffile)
    {
      fprintf(stderr, FILE_OPEN_ERR, refname);
      return -1;
    }
    fprintf(reffile, "PEP\nReferences_PFA_BPN2\nFORMAT_N2\nDEF\n");  
  }
  else
    refname=NULL;

  if (!ExistArcsEntire())
    return -2;

  zeilenr=1;
  PrintBlock(f, reffile, "begin", FAs.GetSize()>1);

  PrintDecl(f);

  if (FAs.GetSize()==1)
  {
    FAs[0].PrintDeclStruct(f, 4);
    if (!FAs[0].CompileStruct(f, 4))
    {
      return 0;
    }
  }
  else
  {
    for (i=0; i<FAs.GetSize(); i++)
    {
      if (FAs[i].ExistArcs())
      {
        buffer[0]=0;
	if (i!=0)
	{
	  fprintf(f, "%s\n", parsym);
	  zeilenr++;
	}
        sprintf(buffer, "    begin");
        PrintBlock(f, reffile, buffer, 0);
        buffer[0]=0;
        FAs[i].PrintDeclStruct(f, 8);
        if (!FAs[i].CompileStruct(f, 8))
	{
	  printf("Error!\n");
          return 0;
        }
	// Semikolon vor letztem end eines Automaten entfernen
        fflush(f);
        fseek(f, -2, SEEK_CUR);
	fprintf(f, "\n    end\n");
	zeilenr++;
        strcpy(parsym, "||");
        parnum=2;
      }
    }
  }
  // Wenn nur ein Automat uebersetzt wird,  Semikolon vor letztem end entfernen
  fflush(f);
  if (FAs.GetSize()==1)
  {
    fseek(f, -2, SEEK_CUR);
    fprintf(f, "\nend\n");
  }
  else
    fprintf(f, "end\n");
  fclose(f);
  if (reffile)
  {
    fprintf(reffile, "AR\n");
    for (i=0; i<FAs.GetSize(); i++)
    {
      for (j=0; j<FAs[i].Vertices.GetSize(); j++)
      {
	for (k=0; k<FAs[i].Vertices[j].EdgeSame.GetSize(); k++)
	{
	  fprintf(reffile, "%d T\"%d:0\"\n", FAs[i].Vertices[j].EdgeSame[k].id,
FAs[i].Vertices[j].EdgeSame[k].ref);
	}
	for (k=0; k<FAs[i].Vertices[j].EdgeOut.GetSize(); k++)
        {
	  blah = &FAs[i].Vertices[j].EdgeOut[k];
	  fprintf(reffile, "%d T\"%d:0\"\n", FAs[i].Vertices[j].EdgeOut[k].id,
FAs[i].Vertices[j].EdgeOut[k].ref);
	}
      }
    }
    fclose(reffile);    
  }

  return 0;
}

void Project::CutBuffer()
{
  char *c;
  c=strchr(buffer, ';');
  if (c)
    *c=' ';
}
