#ifndef PROJECT_H
#define PROJECT_H

#include "pfa.h"
#include <stdio.h>

extern int zeilenr;
extern FILE *reffile;

/* Die Tokens */
#define I_ERROR		0   
#define I_CONST		1
#define I_VAR           2
#define I_ASSIGN	3
#define I_BRACE_OPEN	4
#define	I_BRACE_CLOSE	5
#define I_RANGE		6
#define I_COLON		7
#define I_INIT		8
#define I_CHAN		9
#define I_STACK		10
#define I_OF		11
#define I_CONST_EXPR	12
#define I_IDENT		13
#define I_COMMA         14

void PrintBlock(FILE *f, FILE*reffile, char *string, int par);
void PrintVar(FILE *f, FILE *reffile, char *string, int local=0);
int PrintAction(FILE *f, FILE *reffile, char *string);

class Project
{ 
  protected:
    FAArray FAs;
    SArray Vars;
  public:
    Project() {};
    int Load(char *fname);
    void Dump();
    int ExistArcsEntire();
    void PrintDecl(FILE *f);
    int CompileBPN2(char *s);
    int CompileBPN2Struct(char *fname);
    void CutBuffer();
    virtual char *GetClassName() { return "Project"; };
};

#endif
