#ifndef QUEUE_H
#define QUEUE_H

#include "assert.h"
#include <sys/types.h>

  template <class T> class _Queue
  {
    public:
      T data;
      _Queue *next;
      _Queue();
      ~_Queue();
  };

template <class T> class Queue
{
  public:
    _Queue<T> *head;
    _Queue<T> *tail;
    int count;

    Queue();
    ~Queue();
    Queue(const Queue<T> &x);
    void Enqueue(const T item);
    T& Dequeue();
    T& GetHead() const;
    T& GetTail() const;
    void SetHead(const T item);
    void Copy(const Queue<T> &x);
    void AddTail(const T item);
    T& operator[](int i) const;
    int GetSize() const;
};

template <class T>_Queue<T>::_Queue()
{
  next=NULL;
}

template <class T>_Queue<T>::~_Queue()
{
}


template <class T>Queue<T>::Queue()
{
  head=NULL;
  tail=NULL;
  count=0;
}

template <class T>Queue<T>::~Queue()
{
  _Queue<T> *ptr=head, *ptr2;

  while (ptr)
  {
    ptr2=ptr;
    ptr=ptr->next;
    delete ptr2;
  }
}
 
template <class T>void Queue<T>::Enqueue(const T item)
{
  _Queue<T> *entry;

  entry=new _Queue<T>;
  entry->data=item;
  entry->next=NULL;

  if (head)
  {
    tail->next=entry;
    tail=entry;
  }
  else
    head=tail=entry;
  count++;
}

template <class T>T& Queue<T>::Dequeue()
{
  
  if (head)
  {
    T &item=head->data;
    head=head->next;
    count --;
    return item;
  }
  assert(1);
}

template <class T>T& Queue<T>::GetHead() const
{
  if (head)
    return head->data;
  assert(1);
}

template <class T>T& Queue<T>::GetTail() const
{
  if (tail)
    return tail->data;
  assert(1);
}

template <class T>void Queue<T>::SetHead(const T item)
{
  if (head)
    head->data=item;
  else
    assert(1);
}

template <class T>void Queue<T>::Copy(const Queue<T> &q)
{
  _Queue<T> *ptr,*ptr2;

  if (count)
  {
    ptr=head;
    while (ptr)
    {
      ptr2=ptr;
      ptr=ptr->next;
//      delete ptr2;
    }
  }

  ptr=q.head;
  head=tail=NULL;

  while (ptr)
  {
    ptr2=new Queue();
    ptr2->data=ptr->data;
    
    if (!head)
      head=tail=ptr2;
    else
    {
      tail->next=ptr2;
      tail=ptr2;
    }
    ptr=ptr->next;
  }

  count=q.count;
}

template <class T>void Queue<T>::AddTail(const T item)
{
  _Queue<T> *entry;

  entry=new _Queue<T>();
  entry->data=item;
  entry->next=NULL;
  
  if (!tail)
  {
    head=tail=entry;
  }
  else
  {
    tail->next=entry;
  }
  count ++;
}    

template <class T>T& Queue<T>::operator[](int i) const
{
  _Queue<T> *ptr=head;
  while (i)
  {
    if (!ptr)
      assert(1);
    ptr=ptr->next;
    i--;
  }
  return ptr->data;
}

template <class T>int Queue<T>::GetSize() const
{
  return count;
}

template <class T>Queue<T>::Queue(const Queue<T> &x)
{
  head=tail=NULL;
  size=0;
  Copy(x);
}


#endif

