#include <stdlib.h>
#include <string.h>
#include "vertex.h"

#define CLASS "Vertex"

Vertex::Vertex()
{
  id=typ=compile_id=0;
  name=NULL;
}

Vertex::~Vertex()
{
  if (name)
    free(name);
}

Vertex::Vertex(const Vertex& v)
{
  id=v.id;
  typ=v.typ;
  name=strdup(v.name);
  compile_id=v.compile_id;
  EdgeOut.Copy(v.EdgeOut);
  EdgeSame.Copy(v.EdgeSame);
  EdgeIn.Copy(v.EdgeIn);
}

Vertex& Vertex::operator=(const Vertex& v)
{
  id=v.id;
  typ=v.typ;
  name=strdup(v.name);
  compile_id=v.compile_id;
  EdgeOut.Copy(v.EdgeOut);
  EdgeSame.Copy(v.EdgeSame);
  EdgeIn.Copy(v.EdgeIn);
  return *this;
}
