#include "main.h"
#include "mnet.h"
#include "decls.h"
#include "macros.h"
#include "tables.h"
#include "f_parse.h"
#include "evaltree.h"
#include "multiset.h"
#include <string.h>

/******************************************************************************/

void RenameBack(SymTabEntry *ptr)
{
	for (; ptr; ptr = ptr->s_parlist)
		if (ptr->s_partype == _REF) *strrchr(ptr->s_name,'@') = '\0';
}

void parse_vars(char *vars)
{
	strptr = vars;
	inc_blknum();

	if (!*vars) return;
	yyleng = 0; yyparse();
	if (ParseType) yyerror("got expression instead of vardecls");

}

decl_type handle_vars()
{
	SymTabEntry *dummy;
	decl_type decls;

	spec_actions = MScreate_empty_set();
	decls = HandleDecls(invert_list(dec_blknum()),&dummy);
	decls.scope_actions = spec_actions;

	return decls;

}

void Copy_Action(Action *a1, Action *a2)
{ 
	Cardinal i;

	a1->anzahl = a2->anzahl;
	a1->nr = a2->nr;
	a1->arity = a2->arity;
  
	for (i = 0; i < a2->arity; i++) a1->com[i] = a2->com[i];

}

void throwout(char *t)
{
	register MultiSet r,w;
	char t2[30];

	r = w = spec_actions;
	while (r->anzahl)
	{
		ActionToStr(r->nr,t2);
		if (strstr(t2,t) != t2) Copy_Action(w++,r);
		r++;
	}
	w->anzahl = 0;
}
	
M_Net add_procbox(M_Net net, int procbox, int id1, int id2)
{
	SymTabEntry *ptr = ProcId;
	decl_type decls;
	char tmpstr[30];

	if (!(procbox*id1*id2)) return net;

	macro_ref = StructToRef((ShortEntryPtr) ptr);
	macro_name = ptr->s_name;
	macro_new_ids = macro_id_set;
	macro_id_set = dot_set;
	macro_max = id2-id1+1;
	macro_body = net;

	RenameRefPars(ptr->s_parlist,ptr->s_name);

	spec_actions = MScreate_empty_set();
	GL_AddActions = True;
	net = GetBox(procbox == 1? PROC_BOX_SET : PROC_BOX, False);
	GL_AddActions = False;

	if (ptr->s_parlist) HandlePars(ptr->s_parlist,&net);

	sprintf(tmpstr,"^%s",ptr->s_name);
	throwout(tmpstr);
	for (ptr = ptr->s_parlist; ptr; ptr = ptr->s_parlist)
		if (ptr->s_partype == _REF) 
		{
			sprintf(tmpstr,"^%s",ptr->s_name);
			throwout(tmpstr);
		}

	decls.scope_actions = spec_actions;
	decls.var_net = NULL;
	decls.init_net = NULL;
	decls.exit_net = NULL;
	
	return Scope(net,decls);
}

