#!wish 

set w 200
set h 200

button .b1 -text ende -command exit
pack .b1

canvas .c -width 500 -height 500 -background grey

pack .c -fill both -expand yes

# eigentliche canvas

set actframe [frame .c.f -relief sunken\
		  -borderwidth 3\
		  -background lightgrey
	     ]

set toplabel [button $actframe.l\
		  -text "top-label"\
		  -background lightgrey\
		  -height 1 -font 6x9\
		  -relief raised -border 3
	      ]

set right_frame [frame $actframe.f_right]

set scrollY [scrollbar $right_frame.scrollbarY \
		 -background grey\
		 -command { .c.f.canv yview }\
		 -relief raised -width 12
	     ]

set sizeButton [button $right_frame.b\
		    -background blue\
		    -bitmap {@bitmap/mkstartv.bm}\
		    -width 6 -height 8
	       ]

pack $scrollY -side top -fill y -expand yes

pack $sizeButton -side bottom


set scrollX [ scrollbar $actframe.scrollbarX \
		  -background grey\
		  -command { .c.f.canv xview }\
		  -orient horizontal -relief raised\
		  -width 12
	     ]

pack $toplabel -side top -fill x

pack $right_frame -in $actframe\
    -side right -fill y
    
pack $scrollX -in $actframe\
    -side bottom -fill x


set can [canvas ${actframe}.canv\
	     -background red\
	     -insertofftime {600}\
	     -relief raised\
	     -borderwidth 0\
	     -scrollregion {0 0 40c 40c}\
	     -xscrollcommand {.c.f.scrollbarX set}\
	     -yscrollcommand {.c.f.f_right.scrollbarY set}\
	     ]

pack  $can -in $actframe\
    -expand yes -fill both

$can create text 20 20 -text depp 

set xCan 150
set yCan 150

set ulli [.c create window $xCan $yCan\
	      -anchor nw\
	      -window $actframe\
	      -width $w\
	      -height $h
	  ]




bind $toplabel <1> { xySet %x %y; makeRaster }
bind $toplabel <B1-Motion> { areaMove %x %y }
bind $toplabel <ButtonRelease-1> { windowMove %x %y }
bind $sizeButton <1> " set xW %x; set yW %y "
bind $sizeButton <B1-Motion> "sizeWindow %x %y"


bind $actframe <Any-Enter> { $actframe configure -background red}
bind $actframe <Any-Leave> { $actframe configure -background yellow}
bind $actframe <1> { puts hallo}



proc xySet { x y } {

  global xg yg

  set xg [.c canvasx $x]
  set yg [.c canvasx $y]
}


proc makeRaster {} {

    global xg yg xCan yCan ulli area windowDiffX windowDiffY

    set windowDiffX 0
    set windowDiffY 0

    set w [.c itemcget $ulli -width]
    set h [.c itemcget $ulli -height]
    set rightDownX [expr $xCan + $w]
    set rightDownY [expr $yCan + $h]


    puts "$xCan $yCan $rightDownX $rightDownY"
    set area [.c create rect $xCan $yCan $rightDownX $rightDownY\
		  -outline black]

    .c itemconfigure $area -fill DarkTurquoise -stipple gray25 
#    .c coords area $xCan $yCan $rightDownX $rightDownY
#    .c lower area

}



proc areaMove {x y} {
    global xg yg area windowDiffX windowDiffY
    

    set xn [.c canvasx $x]
    set yn [.c canvasy $y]
    set xdiff [expr $xn - $xg] 
    set ydiff [expr $yn - $yg]

    set windowDiffX [expr $windowDiffX + $xdiff]
    set windowDiffY [expr $windowDiffY + $ydiff]

    set xg $xn
    set yg $yn

    .c move $area $xdiff $ydiff

}



proc windowMove {x y} {
    global windowDiffX windowDiffY ulli area

    .c move $ulli $windowDiffX $windowDiffY
    .c delete $area

}


proc sizeWindow {x y} {
    global xW yW ulli w h

    set xd [expr $x - $xW]
    set yd [expr $y - $yW]
    set xW $x
    set yW $y
    set w [expr $w + $xd]
    set h [expr $h + $yd]
    
    .c itemconfigure $ulli\
	-width  $w\
	-height $h
}
