#ifndef __PFA_COMPILE_H__
#define __PFA_COMPILE_H__

#include "pfa.h"
#include "memlib.h"

/*
 *************************************************************************
 *
 *  Deklaration der lokalen Strukturen
 *
 *************************************************************************
 */

typedef struct IntList {
    int             id;
    struct IntList *next;
} IntList;

typedef struct StructEntry {
    int                 canvas_id;
    int                 count;
    int                 number;
    struct StructEntry *next;
} StructEntry;


/*
 *  Funktionen in pfaCompile.c
 *  --------------------------
 */

Vertex_type *GetKantenZiel( EdgeList_type *kante, Tcl_HashTable placetable,
			    Tcl_HashTable arctable);

EdgeList_type *CopyKante(EdgeList_type *kante);

IntList *CopyArcIdElem(IntList *kante);

char *GetKantenLabel( EdgeList_type *kante, Tcl_HashTable arctable);

int tk_Highlight(ClientData cd, Tcl_Interp * interp,
                          int objc, Tcl_Obj *CONST objv[]);

int tk_GetEdgeToLine(ClientData cd, Tcl_Interp * interp,
                            int objc, Tcl_Obj *CONST objv[]);

int tk_ExistEditor(ClientData cd, Tcl_Interp * interp,
                          int objc, Tcl_Obj *CONST objv[]);

int tk_Editors(ClientData cd, Tcl_Interp * interp,
                      int objc, Tcl_Obj *CONST objv[]);

int tk_GetEdgeToRef(ClientData cd, Tcl_Interp * interp,
                            int objc, Tcl_Obj *CONST objv[]);

int tk_HighlightEdge(ClientData cd, Tcl_Interp * interp,
                            int objc, Tcl_Obj *CONST objv[]);

int tk_Compile(ClientData cd, Tcl_Interp * interp,
		      int objc, Tcl_Obj *CONST objv[]);

int tk_Compile_Struct(ClientData cd, Tcl_Interp * interp,
		      int objc, Tcl_Obj *CONST objv[]);

#endif

