/*
###########################################################################
###########################################################################
##                                                                       ##
##  Datei   :    `pfaEditor.c'                                           ##
##               -------------                                           ##
##                                                                       ##
##  Inhalt  :    Funktion, die den neuen Tcl-Befehl des                  ##
##               `Editor'-Men"us implementiert.                          ##
##                                                                       ##
###########################################################################
###########################################################################
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>	
#include "pfa.h"

/*  tk_ChangeFA
 *--------------------------------------------------------------
 *   
 *  sucht in der Liste aller Editor-Strukturen nach der
 *  Struktur, dessen Nummer als Parameter "ubergeben wurde.
 *  "Uber die  globale Zeiger-Variable actualEd kann dann 
 *  auf diese Struktur zugegriffen werden.
 *
 *--------------------------------------------------------------
 */

int tk_ChangeFA( ClientData cd, Tcl_Interp * interp,\
		 int objc, Tcl_Obj *CONST objv[])
{
    Editor_type *searchActEd = NULL;
    int num;

    if (objc != 2) {
	Tcl_WrongNumArgs(interp, 1, objv, "pfanum");
        return TCL_ERROR;
    }

    searchActEd = firstEd;
    while( searchActEd != NULL ) {
	if (Tcl_GetIntFromObj(interp, objv[1], &num) != TCL_OK)
	  return TCL_ERROR;
	if( searchActEd->number != num ) {
	    searchActEd = searchActEd->next;
	} else {
	    actualEd = searchActEd;
	    return TCL_OK;
	}
    }
    return TCL_ERROR;
}

