###########################################################################
###########################################################################
##                                                                       ##
##  Datei   :     `pfaEditor.tcl'                            		 ##
##                -------------                              		 ##
##                                                           		 ##
##  Inhalt  :     Prozeduren, die die Funktionalit"at        		 ##
##                des `Editor'-Men"us gew"ahrleisten.        		 ##
##                                                           	         ##
###########################################################################
###########################################################################


##  TakeOtherFA
##-----------------------------------------------------------
##  Es wird in den Editor mit der Nummer $newNumber
##  umgeschaltet.
##
##-----------------------------------------------------------
##
proc TakeOtherFA { newNumber } {
    global faNumber histList editor opt

    ##  Die alte Zeichenfl"ache wird in den
    ##  Hintergrund verlegt.
    ##
    if {$opt(ruler) == "on"} {
	CanvasNormalBindings
    }
    pack forget $editor(frame)

    ##  Die Nummer des neuen aktuellen Editors
    ##  wird in der Ed-Liste an die richtige
    ##  Stelle gesetzt.
    ##
    set faNumber(actual) $newNumber
    set rightPlace [ lsearch $histList $faNumber(actual) ]
    set histList [lreplace $histList $rightPlace $rightPlace]
    lappend histList $faNumber(actual)

    ##  Es wird auf die C-Strukturen des neuen Editors
    ##  gewechselt und dessen Zeichenfl"ache dann in
    ##  den Vordergrund gesetzt.
    ##
    pfa_ChangeFA $faNumber(actual)
    set name ".fr1a.fr2ru.fr3FA$faNumber(actual)"
    set editor(frame) $name
    set editor(canvas) "$name.canv"
    set editor(scrollX) "$name.scrollbarX"
    set editor(scrollY) "$name.f_right.scrollbarY"
    pack $editor(frame) -in .fr1a.fr2ru -expand true -fill both
    update idletask
    focus $editor(canvas)
    FreeMode
    set opt(code) $editor($faNumber(actual),code)
    set fileName [file tail $editor($faNumber(actual),fullPath)]
    wm title . "pepPFA - $fileName"

    ##  Wenn das Lineal eingeschaltet ist
    ##  werden die Bindings f"ur den neuen
    ##  FA gesetzt.
    ##
    if {$opt(ruler) == "on"} {
	CanvasRulerBindings
    }
}


##  TakeFirstFA
##-----------------------------------------------------------
##  Es wird in den ersten ge"offneten Editor
##  der Liste umgeschaltet.
##
##-----------------------------------------------------------
##
proc TakeFirstFA {} {
    global histList opt

    set j [ lindex $histList 0]
    foreach i $histList {
	if { $i < $j} { set j $i}
    }
    TakeOtherFA $j
    set opt(messageText) ""
}


##  TakeLastFA
##-----------------------------------------------------------
##  Es wird in den letzten ge"offneten Editor
##  der Liste umgeschaltet.
##
##-----------------------------------------------------------
##
proc TakeLastFA {} {
    global histList opt

    set j [ lindex $histList 0]
    foreach i $histList {
	if { $i > $j} { set j $i}
    }
    TakeOtherFA $j
    set opt(messageText) ""
}


##  TakeNextFA
##-----------------------------------------------------------
##  Es wird in den n"achsten ge"offneten Editor
##  der Liste umgeschaltet.
##
##-----------------------------------------------------------
##
proc TakeNextFA {} {
    global faNumber opt histList

    set sortList  [lsort -integer $histList]
    set rightPlace [ lsearch $sortList $faNumber(actual) ]
    set bigIndex [expr [llength $sortList] -1]
    if { $rightPlace <  $bigIndex} {
	set opt(messageText) ""
	set newAct [lindex $sortList [incr rightPlace +1]]
	TakeOtherFA $newAct
    } else {
	set opt(messageText) "This Is The Last FA"
    }
}


##  TakeNextFA
##-----------------------------------------------------------
##  Es wird in den vorherigen ge"offneten Editor
##  der Liste umgeschaltet.
##
##-----------------------------------------------------------
##
proc TakePreviousFA {} {
    global faNumber opt histList

    set sortList  [lsort -integer $histList]
    set rightPlace [ lsearch $sortList $faNumber(actual) ]
    set smallIndex 0
    if { $rightPlace >  $smallIndex} {
	set opt(messageText) ""
	set newAct [lindex $sortList [incr rightPlace -1]]
	TakeOtherFA $newAct
    } else {
	set opt(messageText) "This Is The First FA"
    }
}
