###########################################################################
###########################################################################
##                                                                       ##
##  Datei   :     `pfaGUI.tcl'                                  	 ##
##                -------------                                 	 ##
##                                                           		 ##
##  Inhalt  :     Prozeduren, die f"ur den Aufbau der        		 ##
##                graphischen Benutzeroberfl"ache             		 ##
##                zust"andig sind.                            		 ##
##                                                           		 ##
###########################################################################
###########################################################################
# verndert von Burkhard Bieber 1996
# 5.12.2000, CS: Farben normalisiert
# last-update: 05.12.2000


##  MainWindow
##-----------------------------------------------------------
##  Alle Widgets fuer die Darstellung des Haupfensters,
##  bis auf die Zeichenflaeche, werden erstellt und
##  gepackt.
##-----------------------------------------------------------
##
proc MainWindow {} {
  global faNumber editor opt

    ##  Einstellungen fuer das Hauptfenster
    ##

    wm positionfrom . user
    wm sizefrom . user

## Peedy: Das Positionieren des Fensters habe ich erstmal rausgenommen.
##  wm geometry . 420x400+0+0

    wm minsize . 420 400
    wm iconname . "pepPFA"

    ##  Der Frame in den alle Widgets
    ##  integriert werden
    ##
    frame .fr1a -borderwidth 1


    ##  Der Frame in den spaeter die
    ##  Zeichenflaeche integriert wird
    ##
    frame .fr1a.fr2ru -width 400 -height 300

    ##  Der frame fuer das Menue
    ##
    frame .fr1a.fr2m \
      -borderwidth 2\
      -relief raised

    ##  Das File-Menue wird erstellt
    ##

    menubutton .fr1a.fr2m.mb1 \
      -text File\
      -underline 0\
      -menu .fr1a.fr2m.mb1.m\
      -font $opt(edFont)
    menu .fr1a.fr2m.mb1.m \
      -font $opt(edFont)
    .fr1a.fr2m.mb1.m add command\
      -command { AddNewFA }\
      -label "New FA"\
      -accelerator "Ctrl-n"
    .fr1a.fr2m.mb1.m add command\
      -command {FilemanagerOpenFA}\
      -label "Open FA"\
      -accelerator "Ctrl-o"
    .fr1a.fr2m.mb1.m add command\
      -command {ReloadFA}\
      -label "Reload FA"\
      -accelerator "Ctrl-r"
    .fr1a.fr2m.mb1.m add command\
      -command {SaveFA}\
      -label "Save FA"\
      -accelerator "Ctrl-s"
    .fr1a.fr2m.mb1.m add command\
      -command {FilemanagerSaveAs}\
      -label "Save As ...  "\
      -accelerator "Ctrl-a"
    .fr1a.fr2m.mb1.m add command\
      -command {CloseDialog}\
      -label "Close FA"\
      -accelerator "Ctrl-d"
    .fr1a.fr2m.mb1.m add separator
    .fr1a.fr2m.mb1.m add cascade\
      -label "Project"\
      -menu .fr1a.fr2m.mb1.m.prj\
      -underline 3
    menu .fr1a.fr2m.mb1.m.prj\
      -font $opt(edFont)
    .fr1a.fr2m.mb1.m.prj add command\
      -command { ExistProject }\
      -label "Open Project  "\
      -accelerator "Ctrl-i"
    .fr1a.fr2m.mb1.m.prj add command\
      -command {FilemanagerSaveProject}\
      -label "Save Project"\
      -accelerator "Ctrl-j"
    .fr1a.fr2m.mb1.m add cascade\
      -label "PostScript"\
      -menu .fr1a.fr2m.mb1.m.post\
      -underline 0
    menu .fr1a.fr2m.mb1.m.post\
      -font $opt(edFont)
    .fr1a.fr2m.mb1.m.post add command\
      -label "Export Entire Screen"\
      -font $opt(edFont)\
      -command {FilemanagerPostscript PostscriptAll}
    .fr1a.fr2m.mb1.m.post add command\
      -label "Export Entire Screen DinA4"\
      -font $opt(edFont)\
      -command {FilemanagerPostscript PostscriptAllA4}
    .fr1a.fr2m.mb1.m.post add command\
      -label "Export Area"\
      -font $opt(edFont)\
      -command {FilemanagerPostscript PostscriptArea}
    .fr1a.fr2m.mb1.m add separator
    .fr1a.fr2m.mb1.m add command\
      -command {ExitDialog}\
      -label "Exit"\
      -accelerator "Ctrl-q"

    ##  Das Edit-Menue wird erstellt
    ##
    menubutton .fr1a.fr2m.mb2 \
      -text "Edit"\
      -underline 0\
      -font $opt(edFont)\
      -menu .fr1a.fr2m.mb2.m
    menu .fr1a.fr2m.mb2.m \
      -font $opt(edFont)
    .fr1a.fr2m.mb2.m add command\
      -command {Cut}\
      -label "Cut"\
      -accelerator "Ctrl-x"\
      -state disabled
    .fr1a.fr2m.mb2.m add command\
      -command {Copy}\
      -label "Copy"\
      -accelerator "Ctrl-c"\
      -state disabled
    .fr1a.fr2m.mb2.m add command\
      -command {PasteInit}\
      -label "Paste"\
      -accelerator "Ctrl-v"\
      -state disabled
    .fr1a.fr2m.mb2.m add separator
    .fr1a.fr2m.mb2.m add command\
      -command {Unset}\
      -label "Unset"\
      -accelerator "Ctrl-u"
    .fr1a.fr2m.mb2.m add command\
      -command {Undelete}\
      -label "Undelete  "\
      -accelerator "Ctrl-y"
    .fr1a.fr2m.mb2.m add separator
    .fr1a.fr2m.mb2.m add cascade\
      -label "Modes"\
      -menu .fr1a.fr2m.mb2.m.modes\
      -underline 0
    menu .fr1a.fr2m.mb2.m.modes \
      -font $opt(edFont)
    .fr1a.fr2m.mb2.m.modes add command\
      -command {StartVertexMode}\
      -label "S-Vertex  "\
      -accelerator "s"
    .fr1a.fr2m.mb2.m.modes add command\
      -command {NormalVertexMode}\
      -label "Vertex"\
      -accelerator "v"
    .fr1a.fr2m.mb2.m.modes add command\
      -command {FinalVertexMode}\
      -label "F-Vertex"\
      -accelerator "f"
    .fr1a.fr2m.mb2.m.modes add command\
      -command {EdgeMode}\
      -label "Edge"\
      -accelerator "e"
    .fr1a.fr2m.mb2.m.modes add command\
      -command {CommentMode}\
      -label "Comment"\
      -accelerator "c"
    .fr1a.fr2m.mb2.m.modes add separator
    .fr1a.fr2m.mb2.m.modes add command\
      -command {AreaMode}\
      -label "Area"\
      -accelerator "a"
    .fr1a.fr2m.mb2.m.modes add command\
      -command {DeleteMode}\
      -label "Delete"\
      -accelerator "d"
    .fr1a.fr2m.mb2.m.modes add cascade\
      -label "Line-Up"\
      -menu .fr1a.fr2m.mb2.m.modes.lineup\
      -underline 0
    menu .fr1a.fr2m.mb2.m.modes.lineup \
      -font $opt(edFont)
    .fr1a.fr2m.mb2.m.modes.lineup add command\
      -command {LineUpMode}\
      -label "Set-Tags"\
      -accelerator "t"
    .fr1a.fr2m.mb2.m.modes.lineup add command\
      -command {LineUpX}\
      -label "Line-Up-X  "\
      -accelerator "x"\
      -state disabled
    .fr1a.fr2m.mb2.m.modes.lineup add command\
      -command {LineUpY}\
      -label "Line-Up-Y  "\
      -accelerator "y"\
      -state disabled
    .fr1a.fr2m.mb2.m.modes add command\
      -command {TextMoveMode}\
      -label "Move-Text"\
      -accelerator "m"
    .fr1a.fr2m.mb2.m.modes add command\
      -command {RenameMode}\
      -label "Rename"\
      -accelerator "r"
    .fr1a.fr2m.mb2.m.modes add command\
      -command {ResetEdgeMode}\
      -label "Reset-Edge  "\
      -accelerator "g"

    ##  Das Option-Menue wird erstellt
    ##
    menubutton .fr1a.fr2m.mb3 \
      -font $opt(edFont)\
      -menu .fr1a.fr2m.mb3.m\
      -text "Options"\
      -underline 0
    menu .fr1a.fr2m.mb3.m \
      -font $opt(edFont)
    .fr1a.fr2m.mb3.m add command\
      -command {Preferences}\
      -label "Preferences"\
      -accelerator "Ctrl-p"
    .fr1a.fr2m.mb3.m add command\
      -command {FontSelection}\
      -label "Font-Selection  "\
      -accelerator "Ctrl-f"
    .fr1a.fr2m.mb3.m add command\
      -command {ZoomWindow}\
      -label "Zoom"\
      -accelerator "Ctrl-z"
    .fr1a.fr2m.mb3.m add separator
    .fr1a.fr2m.mb3.m add cascade\
      -label "Ruler"\
      -menu .fr1a.fr2m.mb3.m.ruler\
      -underline 0
    menu .fr1a.fr2m.mb3.m.ruler \
      -font $opt(edFont)
    .fr1a.fr2m.mb3.m.ruler add radiobutton\
      -label "On"\
      -variable opt(ruler)\
      -value on\
      -command { SetRuler}
    .fr1a.fr2m.mb3.m.ruler add radiobutton\
      -label "Off"\
      -value off\
      -state disabled\
      -variable opt(ruler)\
      -command { AskNoRuler}


    ##  Das Action-Menue wird erstellt
    ##
    menubutton .fr1a.fr2m.mb4 \
      -text "Action"\
      -underline 0\
      -font $opt(edFont)\
      -menu .fr1a.fr2m.mb4.m
    menu .fr1a.fr2m.mb4.m \
      -font $opt(edFont)
    .fr1a.fr2m.mb4.m add command\
      -label "Show B(PN)"\
      -accelerator "Ctrl-t"\
      -command {TextEditor}
    .fr1a.fr2m.mb4.m add separator
    .fr1a.fr2m.mb4.m add command\
      -command {CheckNFA}\
      -label "CheckNFA"
    .fr1a.fr2m.mb4.m add command\
      -command {CheckNFAPath}\
      -label "CheckNFAPath"
    .fr1a.fr2m.mb4.m add command\
      -command {CheckDFA}\
      -label "CheckDFA"
    .fr1a.fr2m.mb4.m add command\
      -command {CheckDFAPath}\
      -label "CheckDFAPath"
    .fr1a.fr2m.mb4.m add separator
       .fr1a.fr2m.mb4.m add cascade\
      -label "Set Variables"\
      -menu .fr1a.fr2m.mb4.m.var\
      -underline 0
    menu .fr1a.fr2m.mb4.m.var \
      -font $opt(edFont)
    .fr1a.fr2m.mb4.m.var add command\
      -label "Global  "\
      -command {SetVariables global}
    .fr1a.fr2m.mb4.m.var add command\
      -label "Local"\
      -command {SetVariables local}

    .fr1a.fr2m.mb4.m add command\
      -command { PFAtoBPN2 }\
      -label "PFA=>B(PN)"\
      -accelerator "Ctrl-g"
    .fr1a.fr2m.mb4.m add command\
      -command {PFAtoBPN2 yes}\
      -label "PFAStruct=>B(PN)  "\
      -accelerator "Ctrl-h"
    .fr1a.fr2m.mb4.m add separator
    .fr1a.fr2m.mb4.m add command\
      -command {DeleteMarks}\
      -label "Delete-Marks"\
      -accelerator "Ctrl-m"

    ##  Das Editor-Menue wird erstellt.
    ##  Dieses Menue laesst sich erst aufrufen,
    ##  wenn ein Editor aktiviert wurde.
    ##
    menubutton .fr1a.fr2m.mb5 \
      -text "Editor"\
      -underline 1\
      -font $opt(edFont)\
      -state disabled\
      -menu .fr1a.fr2m.mb5.m
    menu .fr1a.fr2m.mb5.m \
      -font $opt(edFont)

    ##  Das Help-Menue wird erstellt.
    ##
    menubutton .fr1a.fr2m.mb6 \
    -text "Help"\
      -underline 0\
      -font $opt(edFont)\
      -menu .fr1a.fr2m.mb6.m
    menu .fr1a.fr2m.mb6.m \
      -font $opt(edFont)
    .fr1a.fr2m.mb6.m add command\
      -command {ShortKeys}\
      -label "Key-Reference"
    .fr1a.fr2m.mb6.m add command\
      -command {PfaInfo}\
      -label "About"

    ##  Alle Menues werden in die
    ##  Menue-Leiste gepackt.
    ##
    pack .fr1a.fr2m.mb1 .fr1a.fr2m.mb2 .fr1a.fr2m.mb3 \
      .fr1a.fr2m.mb4 .fr1a.fr2m.mb5\
      -side left -padx 4
    pack .fr1a.fr2m.mb6\
      -side right -padx 4
    tk_menuBar .fr1a.fr2m\
      .fr1a.fr2m.mb1\
      .fr1a.fr2m.mb2\
      .fr1a.fr2m.mb3\
      .fr1a.fr2m.mb4\
      .fr1a.fr2m.mb6

    ##  Die Bitmap-Button werden erstellt
    ##  und in einen eigenen Frame gepackt
    ##
    frame .fr1a.fr2b \
      -background grey\
      -borderwidth 2
    frame .fr1a.fr2b.fr3 \
      -background grey\
      -borderwidth 2
    button .fr1a.fr2b.fr3.startvertex \
      -bitmap "@$opt(bitmapPath)/mkstartv.bm"\
      -command {StartVertexMode}

    button .fr1a.fr2b.fr3.vertex \
      -bitmap "@$opt(bitmapPath)/mkvertex.bm"\
      -command {NormalVertexMode}

    button .fr1a.fr2b.fr3.finalvertex \
      -bitmap "@$opt(bitmapPath)/mkfinalv.bm"\
      -command {FinalVertexMode}

    button .fr1a.fr2b.fr3.edge \
      -bitmap "@$opt(bitmapPath)/mkedge.bm"\
      -command {EdgeMode}

    button .fr1a.fr2b.fr3.comment \
      -bitmap "@$opt(bitmapPath)/comment.bm"\
      -command {CommentMode}

    pack .fr1a.fr2b.fr3.startvertex\
      .fr1a.fr2b.fr3.vertex\
      .fr1a.fr2b.fr3.finalvertex\
      .fr1a.fr2b.fr3.edge\
      .fr1a.fr2b.fr3.comment\
      -side left

    frame .fr1a.fr2b.fr4 \
      -background grey\
      -borderwidth 2
    button .fr1a.fr2b.fr4.delete \
      -bitmap "@$opt(bitmapPath)/delete.bm"\
      -command {DeleteMode}

    button .fr1a.fr2b.fr4.settags \
      -bitmap "@$opt(bitmapPath)/settags.bm"\
      -command {LineUpMode}

    button .fr1a.fr2b.fr4.rename \
      -bitmap "@$opt(bitmapPath)/rename.bm"\
      -command {RenameMode}

    button .fr1a.fr2b.fr4.copy \
      -bitmap "@$opt(bitmapPath)/copy.bm"\
      -command {AreaMode}

    pack .fr1a.fr2b.fr4.delete\
      .fr1a.fr2b.fr4.settags\
      .fr1a.fr2b.fr4.rename\
      .fr1a.fr2b.fr4.copy\
      -side left\
      -expand 1

    pack .fr1a.fr2b.fr3 .fr1a.fr2b.fr4\
      -side left -padx 1

    ##  Die Eingabefenster werden erstellt
    ##  und in den Frame der Informationsleiste gepackt.
    ##  Der erste Entry ist dabei fuer die Header-Information
    ##  zustandig, der zweite fuer die Texteingabe.
    ##
    frame .fr1a.fr2bo -borderwidth 2
    entry .fr1a.fr2bo.entry1 \
      -relief sunken\
      -borderwidth 1\
      -font $opt(edFont)\
      -textvariable opt(messageHeader)\
      -state disabled\
      -width 6
    entry .fr1a.fr2bo.entry2 \
      -borderwidth 1\
      -font $opt(edFont)\
      -width 30\
      -relief sunken\
      -justify center\
      -state disabled\
      -textvariable opt(messageText)
    pack .fr1a.fr2bo.entry2 \
      -side left\
      -pady 1m\
      -fill x

    ##  Der Haupframe des Root-Windows wird
    ##  gepackt.
    ##
    pack .fr1a -expand true -fill both

    ##  Die Frames fuer die Menues, die Bitmap-Button,
    ##  die Zeichenflaeche und die Informationsleiste
    ##  werden der Reihe nach in den Hauptframe gepackt.
    ##
    pack .fr1a.fr2m -side top -fill x
    pack .fr1a.fr2b -side top -fill x
    pack propagate .fr1a.fr2ru 0
    pack .fr1a.fr2ru -side top\
      -expand true -fill both
    pack .fr1a.fr2bo -side bottom -fill x


    ##  Mit Hilfe der Bitmap-Bindings kann man sich die
    ##  Bedeutung eines Bitmap-Button im Informationsfenster
    ##  anzeigen lassen, wenn man mit dem Mauszeiger
    ##  ueber die entsprechende Bitmap geht.
    ##
    BitmapBindings

    ##  Wenn die Hot-Keys aufgerufen werden bevor
    ##  ein Editor aktiviert wurde, erscheint ein
    ##  Meldungsfenster.
    ##
    HotKeyBindings .fr1a.fr2ru
    bind .fr1a.fr2ru <1> { InitialQuestion }
    bind .fr1a.fr2ru <2> { InitialQuestion }
    bind .fr1a.fr2ru <3> { InitialQuestion }
    focus .fr1a.fr2ru
}


##  CreateNewCanvas
##-----------------------------------------------------------
##  erstellt einen Frame in den alle Elemente der Zeichen-
##  flaeche integriert werden. Dazu gehoeren eine Canvas
##  und zwei Scrollbars. CreateNewCanvas wird waehren des
##  Programmablaufs bei jeder Erstellung eines neuen
##  Editors aufgerufen.
##-----------------------------------------------------------
##
proc CreateNewCanvas {} {
    global faNumber editor opt

    ##  Der Frame der Zeichenflaeche wird erstellt.
    ##
    set editor(frame) [frame .fr1a.fr2ru.fr3FA$faNumber(sum)]

    ##  Der vertikale Scrollbar der Zeichenflaeche wird mit
    ##  einem Rahmen, der diese nach oben an die Zeichenflaeche
    ##  angleichen soll, erstellt und gepackt.
    ##
    set rightFrame [frame $editor(frame).f_right]
    set editor(scrollY) [scrollbar $rightFrame.scrollbarY \
			     -relief raised\
			     -command "$editor(frame).canv yview"\
			     -width 12]
    set bottomFrame [frame $rightFrame.f\
			 -borderwidth 0\
			 -width 12\
			 -height 20]
    pack $editor(scrollY)\
	-side top\
	-fill y\
	-expand yes
    pack $bottomFrame\
	-side bottom
    pack $rightFrame\
	-in $editor(frame)\
	-side right\
	-fill y

    ##  Der horizontale Scrollbar der Zeichenflaeche wird erstellt
    ##  und gepackt.
    ##
    set editor(scrollX) [ scrollbar $editor(frame).scrollbarX\
			      -command "$editor(frame).canv xview"\
			      -relief raised\
			      -orient horizontal\
			      -width 12]
    pack $editor(scrollX)\
	-in $editor(frame)\
	-side bottom\
	-fill x

    ##  Die Haupt-Canvas wird erstellt
    ##  und gepackt.
    ##
    set editor(canvas) [canvas $editor(frame).canv\
		    -insertofftime 600\
		    -borderwidth 0\
		    -scrollregion "0 0 $opt(canScroll) $opt(canScroll)"\
		    -xscrollcommand {XCommand}\
		    -yscrollcommand {YCommand}\
		    -xscrollincrement 3m\
		    -yscrollincrement 3m\
		    -closeenough 4.0]
    pack   $editor(canvas) -expand yes -fill both

    focus $editor(canvas)
    set opt(messageText) ""
}


##  ScrollY ScrollY XCommand YCommand
##-----------------------------------------------------------
##  stellen die Verbindung zwischen der Canvas und den
##  Scrollbars her.
##-----------------------------------------------------------
##

proc XCommand {a b } {
    global faNumber

    ".fr1a.fr2ru.fr3FA$faNumber(actual).scrollbarX" set $a $b
}
proc YCommand {a b } {
    global faNumber

   ".fr1a.fr2ru.fr3FA$faNumber(actual).f_right.scrollbarY" set $a $b
}


##  EntryWindow
##-----------------------------------------------------------
##  Das Texteingabefenster unten links wird aktiviert und
##  der eingegebene Text wird abschlie"send zur"uckgegeben.
##-----------------------------------------------------------
##
proc EntryWindow { itemtext } {
    global editor prompt opt


    ##  Das Textfenster wird aktiviert und die
    ##  ben"otigten Variablen werden gesetzt.
    ##
    pack forget .fr1a.fr2bo.entry2
    .fr1a.fr2bo.entry2 configure -state normal -justify left\
	-width 24
    pack .fr1a.fr2bo.entry1 .fr1a.fr2bo.entry2 \
	-side left -pady 1m -fill x
    set opt(messageHeader) "Label:"
    set opt(messageText) [$editor(canvas) itemcget $itemtext -text]
    set merk $opt(messageText)
    if { [string match kante* [ItemName $itemtext]] } {
        set opt(messageText) \
	    [string range $opt(messageText) 1\
		 [expr [string length $opt(messageText)] - 2]]
    }

    ##  W"ahrend der Texteingabe m"ussen die Bindings umgesetzt
    ##  werden.
    ##
    DeleteBitmapBindings
    $editor(canvas) bind kante <Any-Enter> {
        EdgeEnterColor [$editor(canvas) find withtag current]
    }
    $editor(canvas) bind kante <Any-Leave> {
        EdgeLeaveColor [$editor(canvas) find withtag current]
    }

    ##  Mit Return oder Ctrl-c kann das Text-
    ##  Fenster verlassen werden.
    ##
    bind .fr1a.fr2bo.entry2  <Return> {set prompt(ok) 1}
    bind .fr1a.fr2bo.entry2 <Control-c> {set prompt(ok) 0}


    tkwait visibility .fr1a.fr2bo.entry2
    focus .fr1a.fr2bo.entry2
    grab .fr1a.fr2bo.entry2
    update idletask
    set syntax_ok 0
    while {!$syntax_ok} {
	tkwait variable prompt(ok)
	while { [string first \" $opt(messageText)] != -1 } {
	    regsub \" $opt(messageText) ` opt(messageText)
	    if { [string first \" $opt(messageText)] != -1} {
		regsub \" $opt(messageText) ' opt(messageText)
	    }
	}
	if {($prompt(ok) == 0) || ([ItemType $itemtext] != "kante")} {
	    break
	}
	set syntax_ok [SyntaxCheck "<$opt(messageText)>"]
        if {($opt(messageText) != "") && ($syntax_ok == 1)} {
	    set opt(messageText) "<$opt(messageText)>"
	}
    }

    set prompt(result) $opt(messageText)
    set opt(messageText) ""
    grab release .fr1a.fr2bo.entry2
    focus $editor(canvas)
    pack forget .fr1a.fr2bo.entry1
    pack .fr1a.fr2bo.entry2 \
	-side left\
	-padx 1m\
	-pady 1m\
	-fill x
    .fr1a.fr2bo.entry2 configure -state disabled -justify center\
	-width 30

    BitmapBindings
    $editor(canvas) bind kante <Any-Enter> {
        EdgeEnterColor [$editor(canvas) find withtag current]
        highlight [ItemBase [$editor(canvas) find withtag current]]
    }
    $editor(canvas) bind kante <Any-Leave> {
        EdgeLeaveColor [$editor(canvas) find withtag current]
        highlightend
    }


    ##  Wenn das Fenster "uber Return verlassen wird,
    ##  wird die neue Texteingabe zur"uckgegeben und
    ##  sonst der alte Text des Items
    ##
    if { $prompt(ok) } {
	return $prompt(result)
    } else {
	return $merk
    }
}


##  SetMouse
##-----------------------------------------------------------
##  Die drei Mousebutton unten rechts werden als Label
##  dargestellt, mit denen eine Variable 'opt(mouse#)'
##  verbunden ist. Durch Aenderung dieser Variablen erscheint
##  dann der jeweils entsprechende Text.
##-----------------------------------------------------------
##
proc SetMouse {} {

  frame .fr1a.fr2bo.fr3mou\
      -borderwidth 2
  label .fr1a.fr2bo.fr3mou.label2 \
      -borderwidth 2\
      -font 6x10\
      -relief raised\
      -textvariable opt(mouse1)\
      -width 7
  label .fr1a.fr2bo.fr3mou.label3 \
      -borderwidth 2\
      -font 6x10\
      -relief raised\
      -textvariable opt(mouse2)\
      -width 7
  label .fr1a.fr2bo.fr3mou.label4 \
      -borderwidth 2\
      -font 6x10\
      -relief raised\
      -textvariable opt(mouse3)\
      -width 7
  pack .fr1a.fr2bo.fr3mou.label4\
      .fr1a.fr2bo.fr3mou.label3\
      .fr1a.fr2bo.fr3mou.label2\
      -side right
  pack .fr1a.fr2bo.fr3mou\
      -side right

}

##  NoMouse
##-----------------------------------------------------------
##  Die Anzeige der Mousebutton wird zerstoert.
##-----------------------------------------------------------
##
proc NoMouse {} {

    destroy .fr1a.fr2bo.fr3mou
}


##  win_dialog
##-----------------------------------------------------------
##  stellt ein Dialogfenster zur Verf"ugung, dem ein
##  beliebiger Text "ubergeben werden kann.
##-----------------------------------------------------------
##
proc win_dialog {w title text bitmap default args} {
    global tkPriv opt

    set 9x15b -misc-fixed-bold-r-normal--15-120-100-100-c-90-iso8859-1
    # 1. Create the top-level window and divide it into top
    # and bottom parts.

    destroy $w
    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w Dialog
    wm protocol $w WM_DELETE_WINDOW { }
    wm transient $w [winfo toplevel [winfo parent $w]]
    frame $w.top -relief raised -bd 1
    pack $w.top -side top -fill both
    frame $w.bot -relief raised -bd 1
    pack $w.bot -side bottom -fill both

    # 2. Fill the top part with bitmap and message.

    label $w.msg  -justify left -wraplength 6i -text $text \
         -font $9x15b
    pack $w.msg -in $w.top -side right -expand 1\
	-fill both -padx 3m -pady 3m
    if {$bitmap != ""} {
	label $w.bitmap  -bitmap "@$opt(bitmapPath)/$bitmap.bm"\

	pack $w.bitmap -in $w.top -side left -padx 3m -pady 3m
    }

    # 3. Create a row of buttons at the bottom of the dialog.

    set i 0
    foreach but $args {
	button $w.button$i -text $but -command "set tkPriv(button) $i" \
                           -font $9x15b
	if {$i == $default} {
	    frame $w.default -relief sunken -bd 1
	    raise $w.button$i $w.default
	    pack $w.default -in $w.bot -side left -expand 1\
		-padx 3m -pady 2m
	    pack $w.button$i -in $w.default -padx 2m -pady 2m
	    bind $w <Return> "$w.button$i flash; set tkPriv(button) $i"
	} else {
	    pack $w.button$i -in $w.bot -side left -expand 1 \
		    -padx 3m -pady 2m
	}
	incr i
    }

    # 4. Withdraw the window, then update all the geometry information
    # so we know how big it wants to be, then center the window in the
    # display and de-iconify it.

    wm withdraw $w
    update idletasks
    set x [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
	    - [winfo vrootx [winfo parent $w]]]
    set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
	    - [winfo vrooty [winfo parent $w]]]
    wm geom $w +$x+$y
    wm deiconify $w

    # 5. Set a grab and claim the focus too.

    set oldFocus [focus]
    grab $w
    tkwait visibility $w
    if {$default >= 0} {
	focus $w.button$default
    } else {
	focus $w
    }

    # 6. Wait for the user to respond, then restore the focus and
    # return the index of the selected button.

    tkwait variable tkPriv(button)
    destroy $w
    catch {focus $oldFocus}
    return $tkPriv(button)
}
