###########################################################################
###########################################################################
##                                                                       ##
##  Datei   :     `pfaHelp.tcl'                              		 ##
##                -------------                              		 ##
##                                                           		 ##
##  Inhalt  :     Prozeduren, die die Funktionalit"at        		 ##
##                des `Help'-Men"us gew"ahrleisten.          		 ##
##                                                           		 ##
###########################################################################
###########################################################################



###########################################################################
##									 ##
##  Einrichten der Short-Key-Reference					 ##
##  des Help-Menues							 ##
##									 ##
###########################################################################


##  ShortKeys
##-----------------------------------------------------------
##  Es wird ein Toplevel-Fenster eingerichtet in dem zwischen
##  der Erklaerung der Ctrl-Keys und der verschiedenen
##  Modes umgeschaltet werden kann.
##-----------------------------------------------------------
##
proc ShortKeys {} {
    global hot keyInfo

    destroy .keys
    toplevel .keys -relief {raised}
    wm title .keys "pepPFA  Reference-Card"
    wm geometry .keys 295x725+650+0
    wm maxsize .keys 325 725
    wm minsize .keys 325 725

    ##  Frame mit den Radiobutton, die das
    ##  Umschalten ermoeglichen
    ##
    frame .keys.choose\
	-relief ridge\
	-borderwidth 4
    set cho [frame .keys.choose.c]
    label $cho.la\
	-text "Selection:"\
	-width 7\
	-anchor w\
	-padx 10\
	-font "-*-times-bold-I-Normal--*-140-*"
    radiobutton $cho.keys\
	-text "Ctrl-Keys" -value keys\
	-variable keyInfo \
	-command {KeyRef}
    radiobutton $cho.modes\
	-text "Mode-Keys" -value modes\
	-variable keyInfo \
	-command {ModesRef}
    pack $cho.la $cho.keys $cho.modes\
	-side left
    pack $cho -side top -pady 4m -fill x

    ##  Canvas fuer die Darstellung der verschiedenen
    ##  Tastaturerklaerungen
    ##
    set hot [canvas .keys.inf_can\
		 -relief ridge\
		 -borderwidth 4\
		 -height 560]

    ##  Erstellung des unteren Bereichs mit den
    ##  einem Abschlussbutton
    ##
    frame .keys.exit\
	-relief ridge\
	-borderwidth 4
    set sunk [frame .keys.exit.sa\
		  -bd 1 -relief sunken ]
    button $sunk.save\
	-text "Cancel" -command { destroy .keys}
    pack $sunk.save\
	-padx 2m -pady 2m
    pack $sunk \
	-side left\
	-expand 1\
	-padx 3m -pady 2m


    ##  Packen der drei Bereiche in das
    ##  Toplevel-Fenster
    ##
    pack .keys.choose .keys.inf_can .keys.exit\
	-side top\
	-fill both\
	-expand yes\
	-padx 1m\
	-pady 1m

    ##  Voreingestellt ist die Tabelle
    ##  mit den Ctrl-Keys
    ##
    set keyInfo keys
    KeyRef
}

##  KeyRef
##-----------------------------------------------------------
##  Die Tabelle mit den Ctrl-Keys wird auf der Canvas
##  erstellt.
##-----------------------------------------------------------
##
proc KeyRef {} {
    global hot

    $hot delete all
    $hot create text 45 25 \
	-text "Hot-Key" \
	-font "-*-times-bold-I-Normal--*-140-*"
    $hot create text 170 25 \
	-text Function \
	-font "-*-times-bold-I-Normal--*-140-*"


    ##  Die Linien der Tabelle werden gezeichnet
    ##
    ##
    $hot create line 15 15 15 555 -width 2 -fill slategrey
    $hot create line 80 15 80 555 -width 2 -fill slategrey
    $hot create line 275 15 275 555 -width 2 -fill slategrey

    $hot create line 15 15 275 15 -width 2 -fill slategrey
    $hot create line 15 35 275 35 -width 2 -fill slategrey
    $hot create line 15 155 275 155 -fill slategrey
    $hot create line 15 195 275 195 -fill slategrey
    $hot create line 15 215 275 215 -width 2 -fill slategrey
    $hot create line 15 315 275 315 -width 2 -fill slategrey
    $hot create line 15 375 275 375 -width 2 -fill slategrey
    $hot create line 15 475 275 475 -width 2 -fill slategrey
    $hot create line 15 555 275 555 -width 2 -fill slategrey

    ##  Der Text wird dargestellt
    ##
    ##
    $hot create text 25 45 -text "Ctrl-n" -tags k1 -anchor w
    $hot create text 25 65 -text "Ctrl-o" -tags k2 -anchor w
    $hot create text 25 85 -text "Ctrl-r" -tags k3 -anchor w
    $hot create text 25 105 -text "Ctrl-s" -tags k4 -anchor w
    $hot create text 25 125 -text "Ctrl-a" -tags k5 -anchor w
    $hot create text 25 145 -text "Ctrl-d" -tags k6 -anchor w
    $hot create text 25 165 -text "Ctrl-i" -tags k7 -anchor w
    $hot create text 25 185 -text "Ctrl-j" -tags k8 -anchor w
    $hot create text 25 205 -text "Ctrl-q" -tags k9 -anchor w
    $hot create text 25 225 -text "Ctrl-x" -tags k10 -anchor w
    $hot create text 25 245 -text "Ctrl-c" -tags k11 -anchor w
    $hot create text 25 265 -text "Ctrl-v" -tags k12 -anchor w
    $hot create text 25 285 -text "Ctrl-u" -tags k13 -anchor w
    $hot create text 25 305 -text "Ctrl-y" -tags k14 -anchor w
    $hot create text 25 325 -text "Ctrl-p" -tags k15 -anchor w
    $hot create text 25 345 -text "Ctrl-f" -tags k16 -anchor w
    $hot create text 25 365 -text "Ctrl-z" -tags k17 -anchor w
    $hot create text 25 385 -text "Ctrl-t" -tags k18 -anchor w
    $hot create text 25 405 -text "Ctrl-w" -tags k19 -anchor w
    $hot create text 25 425 -text "Ctrl-g" -tags k20 -anchor w
    $hot create text 25 445 -text "Ctrl-h" -tags k21 -anchor w
    $hot create text 25 465 -text "Ctrl-m" -tags k22 -anchor w
    $hot create text 25 485 -text "HOME" -tags k23 -anchor w
    $hot create text 25 505 -text "END" -tags k24 -anchor w
    $hot create text 25 525 -text "Ctrl-+" -tags k25 -anchor w
    $hot create text 25 545 -text "Ctrl--" -tags k26 -anchor w
    $hot create text 90 45 -text "New FA"\
	-tags f1 -anchor w
    $hot create text 90 65 -text "Open FA"\
	-tags f2 -anchor w
    $hot create text 90 85 -text "Reload FA" \
	-tags f3 -anchor w
    $hot create text 90 105 -text "Save FA"\
	-tags f4 -anchor w
    $hot create text 90 125 -text "Save FA As"\
	-tags f5 -anchor w
    $hot create text 90 145 -text "Close FA"\
	-tags f6 -anchor w
    $hot create text 90 165 -text "Open Project"\
	-tags f7 -anchor w
    $hot create text 90 185 -text "Save Project"\
	-tags f8 -anchor w
    $hot create text 90 205 -text "Exit"\
	-tags f9 -anchor w
    $hot create text 90 225 -text "Cut"\
	-tags f10 -anchor w
    $hot create text 90 245 -text "Copy"\
	-tags f11 -anchor w
    $hot create text 90 265 -text "Paste"\
	-tags f12 -anchor w
    $hot create text 90 285 -text "Unset"\
	-tags f13 -anchor w
    $hot create text 90 305 -text "Undelete"\
	-tags f14 -anchor w
    $hot create text 90 325 -text "Preferences-Window"\
	-tags f15 -anchor w
    $hot create text 90 345 -text "Font-Selection-Window"\
	-tags f16 -anchor w
    $hot create text 90 365 -text "Zoom-Window"\
	-tags f17 -anchor w
    $hot create text 90 385 -text "Show B(PN)"\
	-tags f18 -anchor w
   $hot create text 90 405 -text "Set Variables"\
	-tags f19 -anchor w
    $hot create text 90 425 -text "Compiler: PFA=>B(PN)"\
	-tags f20 -anchor w
    $hot create text 90 445 -text "Compiler: PFAStruct=>B(PN)"\
	-tags f21 -anchor w
    $hot create text 90 465 -text "Delete-Marks"\
	-tags f22 -anchor w
    $hot create text 90 485 -text "Show First FA In List"\
	-tags f23 -anchor w
    $hot create text 90 505 -text "Show Last FA In List"\
	-tags f24 -anchor w
    $hot create text 90 525 -text "Show Next FA In List"\
	-tags f25 -anchor w
    $hot create text 90 545 -text "Show Previous FA In List"\
	-tags f26 -anchor w

    ##  Die Bindings werden gesetzt. Wenn der Mauszeiger sich ueber
    ##  einer Erklaerung befindet, wird der zugehoerige Ctrl-Key
    ##  markiert und umgekehrt.
    ##
    for { set i 1} {$i<27} {incr i} {

	$hot bind k$i <Any-Enter> "$hot itemconfigure f$i -fill red"
	$hot bind k$i <Any-Leave> "$hot itemconfigure f$i -fill black"

	$hot bind f$i <Any-Enter> "$hot itemconfigure k$i -fill red"
	$hot bind f$i <Any-Leave> "$hot itemconfigure k$i -fill black"
    }

}

##  ModesRef
##-----------------------------------------------------------
##  Die Tabelle mit den Mode-Keys wird auf der Canvas
##  erstellt.
##-----------------------------------------------------------
##
proc ModesRef {} {
    global hot

    $hot delete all

    $hot create text 45 25 \
	-text "Hot-Key" \
	-font "-*-times-bold-I-Normal--*-140-*"
    $hot create text 170 25 \
	-text Mode \
	-font "-*-times-bold-I-Normal--*-140-*"

    ##  Die Linien der Tabelle werden gezeichnet
    ##
    ##
    $hot create line 15 15 15 295 -width 2 -fill slategrey
    $hot create line 80 15 80 295 -width 2 -fill slategrey
    $hot create line 275 15 275 295 -width 2 -fill slategrey

    $hot create line 15 15 275 15 -width 2 -fill slategrey
    $hot create line 15 35 275 35 -width 2 -fill slategrey
    $hot create line 15 175 275 175 -fill slategrey
    $hot create line 15 235 275 235 -fill slategrey
    $hot create line 15 295 275 295 -width 2 -fill slategrey

    ##  Der Text wird dargestellt
    ##
    ##
    $hot create text 45 45 -text "s" -tags k1
    $hot create text 45 65 -text "v" -tags k2
    $hot create text 45 85 -text "f" -tags k3
    $hot create text 45 105 -text "e" -tags k4
    $hot create text 45 125 -text "c" -tags k5
    $hot create text 45 145 -text "a" -tags k6
    $hot create text 45 165 -text "d" -tags k7
    $hot create text 45 185 -text "t" -tags k8
    $hot create text 45 205 -text "x" -tags k9
    $hot create text 45 225 -text "y" -tags k10
    $hot create text 45 245 -text "m" -tags k11
    $hot create text 45 265 -text "r" -tags k12
    $hot create text 45 285 -text "g" -tags k13

    $hot create text 90 45 -text "Start-Vertex-Mode"\
	-tags m1 -anchor w
    $hot create text 90 65 -text "Vertex-Mode"\
	-tags m2 -anchor w
    $hot create text 90 85 -text "Final-Vertex-Mode"\
	-tags m3 -anchor w
    $hot create text 90 105 -text "Edge-Mode"\
	-tags m4 -anchor w
    $hot create text 90 125 -text "Comment-Mode"\
	-tags m5 -anchor w
    $hot create text 90 145 -text "Area-Mode"\
	-tags m6 -anchor w
    $hot create text 90 165 -text "Delete-Mode"\
	-tags m7 -anchor w
    $hot create text 90 185 -text "Set-Tags"\
	-tags m8 -anchor w
    $hot create text 90 205 -text "Line-Up-X"\
	-tags m9 -anchor w
    $hot create text 90 225 -text "Line-Up-Y"\
	-tags m10 -anchor w
    $hot create text 90 245 -text "Move-Text-Mode"\
	-tags m11 -anchor w
    $hot create text 90 265 -text "Rename-Mode"\
	-tags m12 -anchor w
    $hot create text 90 285 -text "Reset-Edge-Mode"\
	-tags m13 -anchor w

    ##  Die Bindings werden gesetzt. Wenn der Mauszeiger sich ueber
    ##  einer Erklaerung befindet, wird der zugehoerige Mode
    ##  markiert und umgekehrt.
    ##
    for { set i 1} {$i<14} {incr i} {

	$hot bind k$i <Any-Enter> "$hot itemconfigure m$i -fill red"
	$hot bind k$i <Any-Leave> "$hot itemconfigure m$i -fill black"

	$hot bind m$i <Any-Enter> "$hot itemconfigure k$i -fill red"
	$hot bind m$i <Any-Leave> "$hot itemconfigure k$i -fill black"
    }

}



###########################################################################
##									 ##
##  Einrichten der Short-Key-Reference					 ##
##  des Help-Menues							 ##
##									 ##
###########################################################################


##  PfaInfo
##-----------------------------------------------------------
##  Es wird ein Toplevel-Fenster mit Informationen "uber den
##  Editor eingerichtet.
##-----------------------------------------------------------
##
proc PfaInfo {} {
    global inf

    destroy .inf
    toplevel .inf -relief {raised}
    wm title .inf "pepPFA  Information"
    wm geometry .inf 340x495+500+0
    wm maxsize .inf 340 495
    wm minsize .inf 340 495
    
    set inf [canvas .inf.inf_can\
		 -relief ridge -borderwidth 4\
		 -width 340 -height 400]

    ##  Erstellung des unteren Bereichs mit den
    ##  einem Abschlussbutton
    ##
    frame .inf.exit -relief ridge\
	-borderwidth 4
    set sunk [frame .inf.exit.sa\
		  -bd 1 -relief sunken ]
    button $sunk.save\
	-text "Cancel" -command { destroy .inf}
    pack $sunk.save -padx 2m -pady 2m
    pack $sunk -side left -expand 1\
	-padx 3m -pady 2m


    ##  Packen der drei Bereiche in das
    ##  Toplevel-Fenster
    ##
    pack .inf.inf_can .inf.exit\
	-side top -fill both -expand yes\
	-padx 1m -pady 1m

HeadInfo
}


proc HeadInfo {} {
    global inf

    $inf delete all
    destroy $inf.b

    $inf create text 165 35\
	    -anchor n\
	    -font "-*-Times-Bold-R-Normal--*-240-*"\
	    -text "pepPFA -"

    append txt1 "A Graphical Editor For\n"
    append txt1 "Systems Of Finite Automata\n"
    append txt1 "With Compiler Into The\n"
    append txt1 "Parallel Language B(PN)"

    $inf create text 70 120\
	    -justify center\
	    -anchor w\
	    -font "-*-Times-Bold-R-Normal--*-140-*"\
	    -text  $txt1

    #create 'square' letter
    $inf create text 235 139\
	    -font "-*-Times-Bold-R-Normal--*-80-*"\
	    -text "2"


    $inf create text 110 210 -justify center\
	    -anchor w\
	    -text "Ulrich Anhalt\nMatthias Moeller"

    append txt2 "Universitt Hildesheim\n"
    append txt2 "Institut fr Informatik\n"
    append txt2 "Dipl.-Inform. Bernd Grahlmann\n"
    append txt2 "Prof.Dr. Eike Best"
    $inf create text 70 285 -justify center\
	    -anchor w -text $txt2

    set but [button $inf.b -text more\
	    -command {MoreInfo} ]
    set win [$inf create window 165 380\
	    -window $but -width 60 -height 30
    ]

}


proc MoreInfo {} {
    global inf

    $inf delete all
    destroy $inf.b

    # leave space for 'squared' letters
    append txt1 "The pepPFA-Tool presents a comfortable graphic\n"
    append txt1 "editor for  the  modelling of systems  of  finite\n"
    append txt1 "automata. For those a great variety of functions\n"
    append txt1 "for labelling, testing for  special characteristics\n"
    append txt1 "and translation into B(PN)  is provided. One of\n"
    append txt1 "the integrated compilers (PFAStruct->B(PN)  ) is\n"
    append txt1 "able to translate a particular class of finite auto-\n"
    append txt1 "mata and the related systems into well-structured\n"
    append txt1 "B(PN) -programmes,  which  can  be used as  in-\n"
    append txt1 "put for the PEP-System.\n\n"
    append txt1 "For further information see:"

    $inf create text 15 110\
	    -justify left\
	    -anchor w\
	    -font "-*-Times-Bold-R-Normal--*-140-*"\
	    -text  $txt1

    #create 'square' letter
    $inf create text 55 142\
	    -font "-*-Times-Bold-R-Normal--*-80-*"\
	    -text "2"
    $inf create text 180 82\
	    -font "-*-Times-Bold-R-Normal--*-80-*"\
	    -text "2"
    $inf create text 293 97\
	    -font "-*-Times-Bold-R-Normal--*-80-*"\
	    -text "2"

    set txt2a "1. Ulrich Anhalt, Matthias Moeller"
    $inf create text 15 220 -justify left\
	    -anchor w -text  $txt2a
    append txt2b "Ein graphischer Editor fr Systeme von endlichen\n"
    append txt2b "Automaten mit Compiler in eine parallele Sprache.\n"
    append txt2b "Diplomarbeit, Universitt Hildesheim 1995\n"
    $inf create text 29 257 -justify left\
	    -anchor w -text $txt2b

    set txt3a "2. Eike Best, Bernd Grahlmann"
    $inf create text 15 290 -justify left\
	    -anchor w -text $txt3a
    append txt3b "Programming Environment based on Petri nets.\n"
    append txt3b "Documentation and User Guide. Version 1.4.\n"
    append txt3b "Universitt Hildesheim, Institut fr Informatik 1995\n"
    $inf create text 29 327 -justify left\
	    -anchor w -text $txt3b

    set but [button $inf.b -text back\
	    -command {HeadInfo} ]
    set win [$inf create window 165 380\
	    -window $but -width 60 -height 30
    ]
}
