###########################################################################
###########################################################################
##                                                                       ##
##  Datei   :     `pfaInit.tcl'                                          ##
##                -------------                                          ##
##                                                                       ##
##  Inhalt  :     Dieses File wird direkt nach dem Start                 ##
##                aufgerufen. Es werden globale Variablen                ##
##                initialisiert und die Prozedur zur Er-                 ##
##                stellung der graphischen Benutzerober-                 ##
##                fl"ache aufgerufen.                                    ##
##                                                                       ##
###########################################################################
###########################################################################

if [catch {set env(PEPHOME)}] {
  set opt(autoPath) "/opt/pep/lib/pfa"
  set opt(misc.autoPath) "/opt/pep/lib"
  set opt(bitmapPath) "/opt/pep/bitmaps/pfa"
} else {
  set opt(autoPath) "$env(PEPHOME)/lib/pfa"
  set opt(misc.autoPath) "$env(PEPHOME)/lib"
  set opt(bitmapPath) "$env(PEPHOME)/bitmaps/pfa"
}  ;# else, eine Path-Angabe war vorhanden
set auto_path [lappend auto_path $opt(misc.autoPath)]
set auto_path [lappend auto_path $opt(autoPath)]

package require pfa

global argc
global argv
global xfLoadInfo
global xfLoadPath
set xfLoadInfo 0

set opt(workingDir) [pwd]
set opt(ruler) off
set opt(zoom) 1.0
set opt(globalDecl) ""
set opt(mouse1) Free
set opt(mouse2) Free
set opt(mouse3) Free
set opt(bpn2Editor) off
set opt(changed) NULL
set opt(vertexRad) 14     ;# Durchmesser der Knoten
set opt(canScroll) 1400   ;# Gr"o"se der Canvas (immer in pts angeben!) 
set opt(itemColor) white
set opt(redMarked) 0
set opt(edFont)  -adobe-courier-medium-r-normal--*-120*
set opt(rcfile) pepPFA.rc
set opt(filename) syntax.dat
set opt(filename.erg) syntaxaus.dat
set opt(filename.res) syntaxres.dat
set editor(filter,prj) {{PFA project} .prj}
set editor(filter,net) {{PFA file} .net}
set editor(filter,bpn2) {{B(PN) file} .bpn2}
set editor(filter,ps) {{Postscript} .ps}

set pos(x) 0
set pos(y) 0


## Font-Voreinstellung
##

set fontType(family) Courier
set fontType(weight) Medium
set fontType(slant) R
set fontType(size) 140


## Es ist noch kein Editor vorhanden
##
set faNumber(actual) 0     ;# Nummer des aktuellen Editors
set faNumber(sum) 0        ;# Anzahl aller Editore
set histList {}            ;# Liste, in der alle Editor-Nummern aufgef"uhrt
                           ;# werden.

# Kommunikation betreiben
init_client_com

# Die Prozedure end_session definieren, ist unvollstndig,
# da die Dateiinhalte wahrscheinlich nicht gesichert werden.
# TODO
# der Inhalt ist aus pfaFile.tcl ExitDialog, leicht modifiziert
proc end_session {save_first} {
  # save_first - erst speichern oder eben nicht
  global faNumber histList

  foreach i $histList {
    TakeOtherFA $i
    update idletasks
  }
  goodbye_server
  destroy .
}  ;# end_session

# TODO: Die Prozeduren reload_editor_contents und save_editor_contents fehlen.

## Das Hauptfenster wird aufgerufen
##
MainWindow

## Die abgespeicherten Optionen werden geladen
##
LoadPreferences

## Projekt laden
##
set prjname [lindex $argv 0]
if [file exists "$prjname"] {
  OpenProject $prjname
} else {
  set opt(projectName) $prjname
  set opt(project) "yes"
}
  #*** Dateiende pfaPEPInit.tcl ***
