#ifndef __PFA_STRUCTURE_H__
#define __PFA_STRUCTURE_H__

#include "pfa.h"

/*
 *************************************************************************
 *
 *  Deklaration der lokalen Strukturen
 *
 *************************************************************************
 */

typedef struct PlaceMarkList {
    int                   done;
    int                   plusinnr;
    int                   united;
    int                   branchinfo;
    EdgeList_type        *repeatedges;
    StructEntry          *structentry;
    struct PlaceMarkList *next;
} PlaceMarkList;

typedef struct QueueCell {
    Vertex_type       *vertexObject;
    StructEntry      *structentry;
    int               plusinnr;
    int               changed;
    struct QueueCell *next;
} QueueCell;

typedef struct Queue {
    QueueCell *front;
    QueueCell *end;
} Queue;


/*
 *  Funktionen in pfaStructure.c
 *  --------------------------
 */

int StructNaming (Vertex_type *vertexObject, Tcl_HashTable placetable,
                  Tcl_HashTable arctable);

StructEntry *CopyStructList( StructEntry *structentry);

int ExZulKanteEndStart(Tcl_HashTable placetable, Tcl_HashTable arctable);

int InRepeatKanten(EdgeList_type *kante, Vertex_type *vertexObject);

Vertex_type *GetStartState(Tcl_HashTable placetable);

EdgeList_type *GetRepeatKanten(Vertex_type *vertexObject);

PlaceMarkList *GetPlaceMarkList(Vertex_type *vertexObject);

EdgeList_type *Get1EchteKante(Vertex_type *vertexObject);

Edge_type *GetKanteObject (Tcl_HashTable arctable, char *arc_kante);

Vertex_type *GetPlaceObject (Tcl_HashTable placetable, char *knoten_ziel);

int *GetChanObject  (char *chan_label);

int *GetTextObject  (char *text_label);

int BranchClose(Vertex_type *vertexObject, StructEntry *structentry);

int CountOut (Vertex_type *vertexObject);

int AnzahlEchteKanten(Vertex_type *vertexObject);

int NrStartStates(Tcl_HashTable placetable);

int NrRealStartStates(Tcl_HashTable placetable);

int NrRealFinalStates(Tcl_HashTable placetable);

int NrStates(Tcl_HashTable placetable, int nrstartstates);

void ClearSymbolTables (void);

void ClearStructTable(void); 

void ClearIntList (IntList *intlist);

void ClearStructList(StructEntry *structlist);

void ClearQueue(Queue queuelocal);


#endif

