###########################################################################
###########################################################################
##                                                                       ##
##  Datei   :     `pfaTextscan.tcl'                              	 ##
##                ----------------------                           	 ##
##                                                                       ##
##  Die folgenden Prozeduren sind im Rahmen einer Studienarbeit an der   ##
##  Universitaet Hildesheim von Michael Kater erstellt worden.           ##
##                                                                       ##
###########################################################################
###########################################################################


##
#aus textscan.tcl

proc PFAhighlight_line {line} {
# Zeile im Text highlighten
# 
# Parameter: line (ist wohl klar)

   tkTextSetCursor .watch.text_frame.t $line.0
   tkTextKeySelect .watch.text_frame.t \
	   [.watch.text_frame.t index "insert lineend"]
#   .where configure -text [.watch.text_frame.t index insert]
}

proc PFAdel_multi_sel { } {

   .watch.text_frame.t tag delete multi
}
proc PFAmulti_sel { } {

    if {[.watch.text_frame.t tag ranges sel] != ""} {
	.watch.text_frame.t tag add multi sel.first sel.last 
	.watch.text_frame.t tag remove sel sel.first sel.last
	.watch.text_frame.t tag configure multi -background aquamarine3
    }
}


#####################################################################
##
##  Die folgenden Prozeduren setzen B(PN)-Schl"usselw"orter im 
##  B(PN)-Editor fett.
##
#####################################################################


proc PFAscan_text { }  {

# Durchsucht den Text nach Schluesselworten/Bemerkungen und setzt diese 
# fett/kursiv
#
# Parameter: keine
#
# Rueckgabe: nichts
#
# Bemerkung: In $gvar(prgtype) steht, welche Art Programm der Editor
#            gerade anzeigt. Danach werden die Schluesselworte ausgewaehlt.
#
global cnnet gvar

# Cursorposition merken
set oldpos [.watch.text_frame.t index insert]

      PFAscan_keywords \
       "(( )+begin$|^begin( )+|\tbegin( )+|( )+begin( )+|^begin$|\tbegin$)"
      PFAscan_keywords \
       "(( )+var$|^var( )+|\tvar( )+|( )+var( )+|^var$|\tvar$)"
      PFAscan_keywords \
       "(( )+and$|^and( )+|\tand( )+|( )+and( )+|^and$|\tand$)"
      PFAscan_keywords \
       "(( )+or$|^or( )+|\tor( )+|( )+or( )+|^or$|\tor$)"
      PFAscan_keywords \
       "(( )+init$|^init( )+|\tinit( )+|( )+init( )+|^init$|\tinit$)"
      PFAscan_keywords \
       "(( )+chan$|^chan( )+|\tchan( )+|( )+chan( )+|^chan$|\tchan$)"
      PFAscan_keywords \
       "(( )+of$|^of( )+|\tof( )+|( )+of( )+|^of$|\tof$)"
      PFAscan_keywords \
       "(( )+stack$|^stack( )+|\tstack( )+|( )+stack( )+|^stack$|\tstack$)"
      PFAscan_keywords \
       "(( )+do$|^do( )+|\tdo( )+|( )+do( )+|^do$|\tdo$)"
      PFAscan_keywords \
       "(( )+enter$|^enter( )+|\tenter( )+|( )+enter( )+|^enter$|\tenter$)"
      PFAscan_keywords "(( )+od$|^od( )+|\tod( )+|( )+od( )+|^od$|\tod$)"
      PFAscan_keywords \
       "(( )+od;$|^od;( )+|\tod;( )+|( )+od;( )+|^od;$|\tod;$)"
      PFAscan_keywords \
 "(( )+repeat$|^repeat( )+|\trepeat( )+|( )+repeat( )+|^repeat$|\trepeat$)"
      PFAscan_keywords \
       "(( )+exit$|^exit( )+|\texit( )+|( )+exit( )+|^exit$|\texit$)"
      PFAscan_keywords \
       "(( )+false$|^false( )+|\tfalse( )+|( )+false( )+|^false$|\tfalse$)"
      PFAscan_keywords \
       "(( )+true$|^true( )+|\ttrue( )+|( )+true( )+|^true$|\ttrue$)"
      PFAscan_keywords \
       "(( )+proc$|^proc( )+|\tproc( )+|( )+proc( )+|^proc$|\tproc$)"
      PFAscan_keywords \
       "(( )+procgrp$|^procgrp( )+|\tprocgrp( )+|( )+procgrp( )+|^procgrp$|\tprocgrp$)"
      PFAscan_keywords \
        "(( )+endgrp$|^endgrp( )+|\tendgrp( )+|( )+endgrp( )+|^endgrp$|\tendgrp$)"
      PFAscan_keywords \
        "(( )+ref$|^ref( )+|\tref( )+|( )+ref( )+|^ref$|\tref$)"
      PFAscan_keywords \
         "(( )+choice$|^choice( )+|\tchioce( )+|( )+chioce( )+|^chioce$|\tchioce$)"
      PFAscan_keywords \
       "(( )+not$|^not( )+|\tnot( )+|( )+not( )+|^not$|\tnot$)"
      PFAscan_keywords "(( )+parallel$|^parallel( )+|\tparallel( )+|( )+parallel( )+|^parallel$|\tparallel$)"
      PFAscan_keywords \
        "(( )+end$|^end( )+|\tend( )+|( )+end( )+|^end$|\tend$)"
      PFAmark_lines "//" "-adobe-courier-medium-o-normal--*-120*"
     
# Cursor wieder auf die alte Position setzen
tkTextSetCursor .watch.text_frame.t $oldpos
}


proc PFAscan_keywords {key} {

# Markiert beim Laden eines Textes werden Schluesselwoerter fett.
#
# Parameter: 
#
# Rueckgabe:
#
# Bemerkung:
#

   PFAForAllMatches $key {
       .watch.text_frame.t tag add keywords first last
   }
   .watch.text_frame.t tag configure keywords \
	   -font -adobe-courier-bold-r-normal--*-120*
}

proc PFAmark_lines {pattern markfont} {

# Markiert alle Zeile mit "markfont" ab der Position "pos".
# "pos" ist die Positon, in der der regulaere Ausdruck "pattern" vorkommt.
#
# Parameter:
#
# Rueckgabe:
#
# Bemerkung:
#

   PFAfor_line_matches $pattern {
      .watch.text_frame.t tag add remark first last
   }
   .watch.text_frame.t tag configure remark -font $markfont
}


proc PFAForAllMatches {pattern script} {

# Prozedur aus Tcl/Tk Buch. Sucht String zeilenweise im ganzen
# Text und startet uplevel-proc.
#
# Parameter: pattern = Gesuchter String
#            script = Tcl-Prozedur, die nach dem Finden gestartet wird.
#
# Rueckgabe:
#
# Bemerkung:
#

   # feststellen der Zeilenanzahl
   scan [.watch.text_frame.t index end] %d numLines
   # Zeilenweise durch den Text gehen
   for {set i 1} {$i < $numLines} {incr i} {
      # 
      .watch.text_frame.t mark set last $i.0
      while {[regexp -indices $pattern \
            [.watch.text_frame.t get last "last lineend"] indices]} {
         .watch.text_frame.t mark set first "last + [lindex $indices 0] c"
         .watch.text_frame.t  mark set last \
		 "last + 1 c + [lindex $indices 1] c"
         # starte Tcl-Script
         uplevel $script
      }
   }
}


proc PFAfor_line_matches {pattern script} {

#
# Parameter: pattern = Gesuchter String
#            script = Tcl-Prozedur, die nach dem Finden gestartet wird.
#
# Rueckgabe:
#
# Bemerkung:
#

   # feststellen der Zeilenanzahl
   scan [.watch.text_frame.t index end] %d numLines
   # Zeilenweise durch den Text gehen
   for {set i 1} {$i < $numLines} {incr i} {

      .watch.text_frame.t mark set last $i.0

      while {[regexp -indices $pattern \
                   [.watch.text_frame.t get last \
		   "last lineend"] indices]} {
         .watch.text_frame.t mark set first "last + [lindex $indices 0] c"
         .watch.text_frame.t  mark set last "last lineend"
         # starte Tcl-Script
         uplevel $script
      }
      #end while
   }
   #end for
}
