#ifndef __ACTIONS_H__
#define __ACTIONS_H__

#include "list.h"
#include "symtab.h"
#include "function.h"
#include "ref.h"

typedef struct {
	T_list states;		/* wenn NULL, ist es die Start-Transition */
	T_list signals;		/* todo: allgemeiner fassen */
	T_list actions;		/* Liste mit Anweisungen */
	T_ref ref;
} structdef(transition);

enum {	ACTION_NEXTSTATE,
	ACTION_OUTPUT,
	ACTION_TASK,
	ACTION_DECISION,
	ACTION_CALL,
	ACTION_CREATE,
	ACTION_JOIN
     };

typedef struct {
	T_list signals;
	T_symbol dst;
	T_list via;
} structdef(output);

/* diese hier sind weitgehend dieselben wie die N_.*-Defines,
   aber ich benutze lieber meine eigenen (muss die node-Struktur
   hinterher ohnehin umwandeln)					*/

enum {	NODE_CONST, NODE_VAR,
	NODE_PAREN,
	NODE_IMPLIES,
	NODE_OR, NODE_XOR,
	NODE_AND,
	NODE_EQ, NODE_NE,
	NODE_GT, NODE_GE,
	NODE_LT, NODE_LE,
	NODE_PLUS, NODE_MINUS, NODE_MULT,
	NODE_DIV, NODE_MOD, NODE_REM,
	NODE_NEG, NODE_NOT
     };

enum {	ETYPE_INTEGER,
	ETYPE_BOOLEAN,
	ETYPE_PID,
	ETYPE_ANY
     };

typedef struct t_node_type {
	char type;
	char sort;
	bool    constant;
	struct t_node_type *op1;
	struct t_node_type *op2;
} structdef(node);

typedef struct {
	T_symbol var;
	T_node expr;
	T_ref ref;
} structdef(assignment);

typedef struct {
	T_node question;
	T_list answers;
	T_list transitions;
	T_list refs;
} structdef(decision);

typedef struct {
	T_symbol sym;
	T_list actparms;
	T_list fmlparms;
} structdef(call);

typedef union {
	T_symbol state;
	T_output output;
	T_decision decision;
	T_list list;
	T_call call;
	T_symbol goal;
} action_data;

typedef struct {
	char type;
	bool    terminating;
	T_symbol label;
	action_data e;
	T_ref ref;
} structdef(action);

enum {	PARM_CONST,
	PARM_VARIABLE,
	PARM_UNUSED
     };

typedef struct {
	char flag;
	Integer value;
	T_symbol var;
} structdef(parameter);

typedef struct {
	T_symbol sym;
	T_parameter parm;
} structdef(signaluse);

typedef struct {
	bool    type;	/* True entspricht in/out */
	T_symbol sym;	/* Name, Typ steht in sym->e.syntype */
} structdef(fmlparm);

typedef struct {
	T_symbol parent;
	T_symbol child;
} structdef(createreq);

#define alloc_action() (MYmalloc(sizeof(action_instance)))
#define alloc_output() (MYmalloc(sizeof(output_instance)))
#define alloc_node() (MYmalloc(sizeof(node_instance)))
#define alloc_assignment() (MYmalloc(sizeof(assignment_instance)))
#define alloc_decision() (MYmalloc(sizeof(decision_instance)))
#define alloc_call() (MYmalloc(sizeof(call_instance)))
#define alloc_parameter() (MYmalloc(sizeof(parameter_instance)))
#define alloc_signaluse() (MYmalloc(sizeof(signaluse_instance)))
#define alloc_fmlparm() (MYmalloc(sizeof(fmlparm_instance)))
#define alloc_createreq() (MYmalloc(sizeof(createreq_instance)))

#endif /* __ACTIONS_H__ */
