#include "proc2net.h"
#include "symtab.h"
#include "mnet.h"
#include "macros.h"
#include "signet.h"
#include "intset.h"
#include "function.h"
#include "box_sub.h"
#include "f_parse.h"
#include "strbuf.h"

void add_sig_guard(char *var, intset set)
{
	/* aus mnet.c:PrintSingleRange abgewandelt */
	Integer first, *z, *ep = set+*set;
	char tmp[32];

	addbuf("(");
	for (z = set+1; z < ep; z++)
	{
		if (z != set+1) addbuf("|");

		first = *z;
		while (z+1 < ep && *z == *(z+1)-1) z++;
		if (first == *z || (first == *z-1 && z--))
			sprintf(tmp,"%s=%d",var,first);
		else
			sprintf(tmp,"(%s>=%d&%s<=%d)",var,first,var,*z);
		addbuf(tmp);
	}
	addbuf(")");
}

void handle_one_way(T_symbol relay, T_symbol goal, char nr)
{
	M_Net net;

	macro_name = MYmalloc(strlen(relay->name)+3);
	sprintf(macro_name,"%s@%u",relay->name,nr);
	macro_arg = MYmalloc(strlen(goal->name)+2);
	sprintf(macro_arg,"%s%s",goal->name,
		goal->type == TYPE_CONNECT?
			( goal->blknum - relay->blknum? "i" : "o" ) : "");

	macro_ref = relay->ref->nr + nr;

	sig_get_relaysets(relay,&macro_decl_set,&macro_id_set,
				&macro_new_ids,nr);
	if (relay->e.relay->is_channel)
	{
		macro_capacity = relay->e.relay->capacity;
		macro_capacity_plus_eins = relay->e.relay->capacity+1;

		change_net_version(SDL_CHANNEL,&sdl_lastchanused,
			relay->e.relay->version);

		net = GetBox(SDL_CHANNEL,True);
	}
	else
	{
		M_Transition tr;

		initbuf();
		add_sig_guard("sig",macro_decl_set);
		addbuf("&");
		add_sig_guard("sen",macro_id_set);
		addbuf("&");
		add_sig_guard("rec",macro_new_ids);

		trans_mark[MARK_PAR_PRE] = NULL;
		net = GetBox(SDL_SIGNALROUTE,True);
		tr = check_mark(MARK_PAR_PRE,SDL_SIGNALROUTE);

		add_guard(tr,ParseAnnotation(strbuf,tr));
	}

	add_to_current(net);

	macro_ref = global_ref;
	net = GetBox(SDL_INIT,True);
	global_init = global_init? M_Sequence(global_init,net) : net;
	net = GetBox(SDL_TERM,True);
	global_term = global_term? M_Sequence(global_term,net) : net;

	macro_arg = MYrealloc(macro_arg,strlen(macro_name)+6);
	sprintf(macro_arg,"%s@init",macro_name);
	add_action(&global_actions,macro_arg,0);
	sprintf(macro_arg,"%s@term",macro_name);
	add_action(&global_actions,macro_arg,0);
	sprintf(macro_arg,"%s!",macro_name);
	add_action(&current_actions,macro_arg,3);
	free(macro_arg);
	free(macro_name);

}

void handle_relay(T_symbol relay)
{
	T_relay relinf = relay->e.relay;

	handle_one_way(relay,relinf->ep2,0);
	if (relinf->bidirectional)
		handle_one_way(relay,relinf->ep1,1);

}

