#ifndef __PARSEDEFS_H__
#define __PARSEDEFS_H__

#include "list.h"
#include "function.h"
#include "intset.h"

extern int num_pi_ids;

typedef struct t_struc_type {
	int subtype;		/* system, block, process */
	T_list entities;	/* Enthaltene Entities */
	T_symbol symtab;	/* Enthaltene Symbole */
	int num_connects;	/* Anzahl der Connectors */
	struct t_prcsinf_type *prcsinf;
} structdef(structure);

typedef struct t_relay_type {
	bool bidirectional;
	bool	is_channel;	/* True = channel, False = signalroute */
	T_symbol ep1;		/* Endpunkte */
	T_symbol ep2;
	T_list siglist1;	/* Liste von T_entity */
	T_list siglist2;
	int capacity;
	int version;
} structdef(relay);

typedef struct t_signal_type {
	int number;
	int highest;
	T_list args;		/* Liste von Sorten, NULL wenn keine Args */
	Integer *ground;	/* niedrigste Werte */
	Integer *width;		/* Spannbreiten: hoechste-niedrigste+1 */
} structdef(signal);

typedef struct t_connect_type {
	T_list outlist;
	T_list inlist;
} structdef(connect);

typedef struct t_syntype_type {
	int def_init;		/* wenn DOT, nicht vorhanden */
	intset set;
	T_list range;		/* obere/untere 16 bit = oberer/unterer Wert */
} structdef(syntype);

typedef struct t_prcsinf_type {
	int num_states;
	intset idset;
	T_list called_procs;
	T_list fmlparms;
	int initial;		/* Anzahl von Instanzen bei Prozessen */
	int maximum;
	int capacity;		/* Kapazitaet der Input-Queue */
	int version;
} structdef(prcsinf);

#define alloc_structure() (MYmalloc(sizeof(structure_instance)))
#define alloc_relay() (MYmalloc(sizeof(relay_instance)))
#define alloc_signal() (MYmalloc(sizeof(signal_instance)))
#define alloc_connect() (MYmalloc(sizeof(connect_instance)))
#define alloc_syntype() (MYmalloc(sizeof(syntype_instance)))
#define alloc_transition() (MYmalloc(sizeof(transition_instance)))
#define alloc_prcsinf() (MYmalloc(sizeof(prcsinf_instance)))

#endif /* __PARSEDEFS_H__ */
