#ifndef __PROC2NET_H__
#define __PROC2NET_H__

#include "symtab.h"
#include "main.h"
#include "multiset.h"
#include "mnet.h"
#include "function.h"
#include "list.h"

extern M_Net global_init;	/* der globale Kontrollfluss */
extern M_Net global_create;
extern M_Net global_term;
extern RefNr global_ref;	/* RefNr des globalen Kontrolflusses */
extern M_Net current_net;
extern RefNr current_ref;	/* RefNr der/s aktuellen Prozedur/Prozesses */

extern MultiSet global_actions;
extern MultiSet process_actions;
extern MultiSet current_actions;

extern T_symbol current_proc;
extern bool use_nextstate;

extern void add_action(MultiSet*,char*,int);
extern void add_var_use(M_Transition,T_symbol,bool);
extern void add_guard(M_Transition,node_ptr);
extern M_Transition check_mark(int,int);
extern M_Transition DuplicateTrans(M_Net,M_Transition);
extern void add_place_ref(M_Place,RefNr,Cardinal);
extern void add_trans_ref(M_Transition,RefNr,Cardinal);
extern void set_correct_dimensions(M_Net);
extern void change_net_version(int,int*,int);
extern M_Net sync_net(M_Net,MultiSet);
extern M_Net sys2net(T_symbol);

extern void handle_connect(T_symbol,T_symbol);
extern void handle_relay(T_symbol);

extern void relabel_parms(T_symbol,T_list);
extern void restore_parm_names(T_list);
extern void create_procedure_net(T_symbol,M_Net*,MultiSet*);
extern void handle_process(T_symbol);

extern void copy_to_comarray(Variables,Variables);
extern M_Net create_basic_prenet(RefNr);
extern M_Net body2net(T_list);
extern M_Net create_trans_net(T_list);

#define add_to_current(net) \
    current_net = current_net? M_ConcurrentComposition(current_net,net) : net;

#endif /* __PROC2NET_H__ */

