#include <stdio.h>
#include <string.h>

#include "function.h"
#include "readlib.h"
#include "list.h"
#include "property.h"
#include "strbuf.h"

T_list sdl_properties;

void read_sdl_properties(char *filename, int warn)
{
	register char	ch;
	register FILE	*infile;
	T_key		key;
	char		c[2],*cmd;
	int		ident;

	NNinput_file = filename;
	NNinput_line = 1;

	sdl_properties = alloc_list();

	if (!(infile = fopen(filename, "r")))
	{
		if (warn)
		    Msg(WAR,"could not find properties in file %s\n",filename);
		return;
	}

	printf("Reading properties from %s\n",filename);

	cmd=ReadCmdToken(infile);
	if (strcmp(sbuf, "PEP"))
		Msg(FAT,"keyword 'PEP' expected");

	ReadNewline(infile);
	cmd=ReadCmdToken(infile);
	if (strncmp(sbuf, "SDL_Properties",14))
		Msg(FAT,"format identifier 'SDL_Properties' expected");

	ReadNewline(infile);
	cmd=ReadCmdToken(infile);
	if (strncmp(sbuf, "FORMAT_N", 8))
		Msg(FAT,"keyword 'FORMAT_N' or 'FORMAT_N2' expected");

	ReadNewline(infile);
	
	c[1] = 0;

	for (;;)
	{
		initbuf();
		for (;;)
		{
			ch = getc(infile);
			if (feof(infile) || ch == ' ' || ch == '=') break;
			*c = ch;
			addbuf(c);
		}
		if (feof(infile)) break;

		ungetc(ch,infile);
		if (ReadWhiteSpace(infile) != '=') Msg(FAT,"'=' expected");
		ident=ReadNumber(infile);

		key = alloc_key();
		key->name = MYstrdup(strbuf);
		key->value = ident;
		list_add(sdl_properties,key);

		ReadNewline(infile);
	}
	fclose(infile);
}

int prop_find_key(char *string, int def)
{
	T_key key;
	for_list (sdl_properties,key,T_key)
		if (!strcmp(key->name,string)) return key->value;
	return def;
}
