
#include <stdio.h>

#include "BasicTypes.h"
#include "Converter.h"

//*******************************************************************************************************
olSDL::ClsPoint::ClsPoint(int x, int y) {
	m_x = x;
	m_y = y;
} ;
//*******************************************************************************************************
int olSDL::ClsPoint::get_x() {
	return m_x ;
} ;
//*******************************************************************************************************
int olSDL::ClsPoint::get_y() {
	return m_y ;
} ;

//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsRecPaS::ClsRecPaS(const int x, const int y, const int width, const int height)
	: m_x(x), m_y(y), m_width(width), m_height(height) {

} ;
//*******************************************************************************************************
void olSDL::ClsRecPaS::set_PaS(const int x, const int y, const int width, const int height) {

	m_x = x ;
	m_y = y ;
	m_width = width ;
	m_height = height ;
} ;
//*******************************************************************************************************
void olSDL::ClsRecPaS::set_PaS(const ClsRecPaS & PaS) {

	m_x = PaS.get_x_left_up() ;
	m_y = PaS.get_y_left_up() ;
	m_width = PaS.get_width() ;
	m_height = PaS.get_height() ;

} ;
//*******************************************************************************************************
void olSDL::ClsRecPaS::ClsRecPaS::get_BoundingBox(list<int> & IntList) const {

	IntList.clear() ;

	IntList.push_back(m_x) ;
	IntList.push_back(m_y) ;
	IntList.push_back(m_x+m_width) ;
	IntList.push_back(m_y+m_height) ;

} ;
//*******************************************************************************************************
int olSDL::ClsRecPaS::get_x_left_up() const {
	return m_x ;
} ;
//*******************************************************************************************************
int olSDL::ClsRecPaS::get_y_left_up() const {
	return m_y ;
} ;
//*******************************************************************************************************
int olSDL::ClsRecPaS::get_x_right_down() const {
	return (m_x+m_width) ;
} ;
//*******************************************************************************************************
int olSDL::ClsRecPaS::get_y_right_down() const {
	return (m_y+m_height) ;
} ;

//*******************************************************************************************************
void olSDL::ClsRecPaS::get_PaS_as_IntList(list<int> & IntList) const {

	IntList.clear() ;

	IntList.push_back(m_x) ;
	IntList.push_back(m_y) ;
	IntList.push_back(m_width) ;
	IntList.push_back(m_height) ;
} ;
//*******************************************************************************************************
list<int> olSDL::ClsRecPaS::get_PaS_as_IntList() const {

	list<int> IntList ;

	IntList.push_back(m_x) ;
	IntList.push_back(m_y) ;
	IntList.push_back(m_width) ;
	IntList.push_back(m_height) ;

	return IntList ;
} ;
//*******************************************************************************************************
olSDL::ClsRecPaS olSDL::ClsRecPaS::get_PaS() const {

	return ClsRecPaS(m_x, m_y, m_width, m_height) ;
} ;
//*******************************************************************************************************
int olSDL::ClsRecPaS::get_width() const {
	return m_width ;
} ;
//*******************************************************************************************************
int olSDL::ClsRecPaS::get_height() const {
	return m_height ;
} ;
//*******************************************************************************************************
string olSDL::ClsRecPaS::get_PaS_as_String( ) const {

	string result ;

	result.append(olSDL::Converter::Int_to_String(get_x_left_up())) ;
	result.append(" ") ;

	result.append(olSDL::Converter::Int_to_String(get_y_left_up())) ;
	result.append(" ") ;

	result.append(olSDL::Converter::Int_to_String(get_width())) ;
	result.append(" ") ;

	result.append(olSDL::Converter::Int_to_String(get_height())) ;

	return result ;
} ;
//*******************************************************************************************************



