
using namespace std;

#include <stdio.h>

#include "Converter.h"
#include "MyConst.h"
#include <ctype.h>

//******************************************************************************
string olSDL::Converter::replace(const string & s, const string & Substring, const string & NewSubstring) {

	string::size_type StartPos ;

	string Prefix ;
	string MatchPart ;
	string Suffix ;

	int PrefixLength ;

	int LengthSubString = Substring.length() ;


	if (Substring.length() == 0) {
		return s ;
	} ;

	if (s.length() == 0) {
		return s ;
	} ;


	StartPos = s.find(Substring) ;

	if ( StartPos == string::npos) {

		return s ;
	} else {

		PrefixLength = StartPos ;

		Prefix = s.substr(0,PrefixLength) ;

		Suffix = s.substr(StartPos+LengthSubString, string::npos) ;

		return (replace(Prefix, Substring, NewSubstring) + NewSubstring + replace(Suffix, Substring, NewSubstring)) ;

	} ;
} ;
//******************************************************************************
string olSDL::Converter::StringToMAR_String(const string & s) {

	string MAR_String ;

	MAR_String = replace(s, "}", "a\\}") ;

	MAR_String = replace(MAR_String, "{", "a\\{") ;

	return MAR_String ;

} ;
//******************************************************************************
bool olSDL::Converter::String_To_Int(const string & IntString, int & Value) {

	for (unsigned int i=0; i<IntString.length(); i++) {

		if (! isdigit(IntString.at(i))) {
			return false ;
		} ;
	} ;

	Value = atoi(IntString.c_str()) ;
	return true ;
} ;
//******************************************************************************
string olSDL::Converter::Int_to_String(int Value) {

	string str_Value ;
	char * pTempChar ;

	pTempChar = new char[SIZE_INT_AS_STR] ;
	snprintf(pTempChar, SIZE_INT_AS_STR, "%d", Value) ;
	str_Value = pTempChar ;
	delete [ ] pTempChar ;

	return str_Value ;
} ;
//******************************************************************************
string olSDL::Converter::IntList_to_String(list<int> & IntList) {

	string Result = "" ;
	list<int>::iterator iterIntList ;

	iterIntList=IntList.begin();

	while (iterIntList != IntList.end()) {

		Result = Result + Int_to_String(*iterIntList) ;

		iterIntList++ ;

		if (iterIntList != IntList.end()) {
			Result = Result + " " ;
		} ;
	} ;

	return Result ;
} ;
//******************************************************************************
bool olSDL::Converter::IntListString_To_IntList(string strIntList, list<int> & IntList) {

	IntList.clear() ;

	int StringLength = strIntList.length( ) ;

	string PartString ;
	int PartInt ;

	int StartIndex = 0 ;
	for (int i=0; i<StringLength; i++) {

		if ( strIntList.substr(i,1).compare(" ") == 0 ) {

			PartString = strIntList.substr(StartIndex, i-StartIndex) ;

			if (! String_To_Int (PartString, PartInt) ) { return false; } ;

			IntList.push_back(PartInt) ;
			StartIndex = i + 1 ;
		} ;

	} ;

	PartString = strIntList.substr(StartIndex, (StringLength-1)) ;

	if (! String_To_Int (PartString, PartInt) ) { return false; } ;

	IntList.push_back(PartInt) ;

	return true ;
}  ;
//******************************************************************************
