
#include "FlowLine.h"
#include "Helper.h"
#include "Converter.h"


//*******************************************************************************************************
olSDL::ClsFlowLine::ClsFlowLine(const int FlowLineID, const int Page_ID, const e_FlowLineType FlowLineType, const list<int> & FlowLineCoords,
			const int FlowLineSourceModel_ID, const int FlowLineDestModel_ID)
			: ClsObjectWithModel_ID(FlowLineID), ClsPageObject(Page_ID) {


	m_FlowLineType = FlowLineType ;

	m_FlowLineCoords = FlowLineCoords ;

	m_FlowLineSourceModel_ID = FlowLineSourceModel_ID ;
	m_FlowLineDestModel_ID = FlowLineDestModel_ID ;
} ;
//*******************************************************************************************************
olSDL::ClsFlowLine::~ClsFlowLine() {

	m_FlowLineCoords.clear() ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsFlowLine::e_FlowLineType olSDL::ClsFlowLine::get_FlowLineType() const {

	return m_FlowLineType ;
} ;
//*******************************************************************************************************
void olSDL::ClsFlowLine::get_Coords_as_IntList(list<int> & IntList) const {

	IntList = m_FlowLineCoords ;
} ;
//*******************************************************************************************************
int olSDL::ClsFlowLine::get_SourceID_as_Int() const {

	return m_FlowLineSourceModel_ID ;
} ;
//*******************************************************************************************************
int olSDL::ClsFlowLine::get_DestID_as_Int() const {

	return m_FlowLineDestModel_ID ;
} ;
//*******************************************************************************************************
string olSDL::ClsFlowLine::get_SourceID_as_String() const {

	return (olSDL::Converter::Int_to_String(m_FlowLineSourceModel_ID)) ;
} ;
//*******************************************************************************************************
string olSDL::ClsFlowLine::get_DestID_as_String() const {

	return (olSDL::Converter::Int_to_String(m_FlowLineDestModel_ID)) ;
} ;
//*******************************************************************************************************
void olSDL::ClsFlowLine::modify_FlowLineCoords(const list<int> & FlowLineCoords) {

	m_FlowLineCoords = FlowLineCoords ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsNormalFlowLine::ClsNormalFlowLine(const int FlowLineID, const int Page_ID, const list<int> & FlowLineCoords,
		const int FlowLineSourceModel_ID, const int FlowLineDestModel_ID)
		: ClsFlowLine(FlowLineID, Page_ID, ClsFlowLine::normal, FlowLineCoords, FlowLineSourceModel_ID, FlowLineDestModel_ID) {



} ;
//*******************************************************************************************************
olSDL::ClsNormalFlowLine::~ClsNormalFlowLine() {


} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsNormalFlowLine::get_MoEleType() const {

	return olSDL::ClsMoEleType::NormalFlowLine ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsDecisionFlowLine::ClsDecisionFlowLine(const int FlowLineID, const int Page_ID, const list<int> & FlowLineCoords,
		const int FlowLineSourceModel_ID, const int FlowLineDestModel_ID, const string & content, const ClsRecPaS & PaS)
		: m_content(content), m_area(PaS),
		  ClsFlowLine(FlowLineID, Page_ID, ClsFlowLine::decision, FlowLineCoords, FlowLineSourceModel_ID, FlowLineDestModel_ID) {

} ;
//*******************************************************************************************************
olSDL::ClsDecisionFlowLine::~ClsDecisionFlowLine() {


} ;
//*******************************************************************************************************
list<int> olSDL::ClsDecisionFlowLine::get_PaS_as_IntList() const {

	return  m_area.get_PaS_as_IntList() ;
} ;
//*******************************************************************************************************
olSDL::ClsRecPaS olSDL::ClsDecisionFlowLine::get_PaS() const {

	return m_area ;
} ;
//*******************************************************************************************************
string olSDL::ClsDecisionFlowLine::get_Content() const {

	return m_content ;
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsDecisionFlowLine::get_MoEleType() const {

	return olSDL::ClsMoEleType::DecisionFlowLine ;
} ;
//*******************************************************************************************************
void olSDL::ClsDecisionFlowLine::modify_DecisionFlowLinePaS(const ClsRecPaS & PaS) {

	m_area = PaS ;
} ;
//*******************************************************************************************************
void olSDL::ClsDecisionFlowLine::modify_DecisionFlowLineContent(const string Content) {

	m_content = Content;
} ;
//*******************************************************************************************************




