#include "Helper.h"
#include "Converter.h"

//******************************************************************************
//******************************************************************************
string olSDL::DebugPrinter::NameDebugFile = "" ;
olSDL::DebugPrinter * olSDL::DebugPrinter::pDebugPrinter = NULL  ;
FILE *olSDL::DebugPrinter::pFile = NULL ;
//******************************************************************************
//******************************************************************************


//******************************************************************************
void olSDL::DebugPrinter::get_Instance(string FileName) {

	if (pDebugPrinter==NULL) {
		pDebugPrinter = new DebugPrinter(FileName) ;
	} ;

} ;
//******************************************************************************
void olSDL::DebugPrinter::free_Instance() {

	if (pFile!=NULL) {
		fclose(pFile);
	} ;

	if (pDebugPrinter!=NULL) {
		delete pDebugPrinter ;
	} ;

} ;
//******************************************************************************
olSDL::DebugPrinter::DebugPrinter(string FileName)  {

	NameDebugFile = FileName ;

	if (!NameDebugFile.compare("")) {
		pFile = NULL ;
	} else {
		pFile = fopen(NameDebugFile.c_str(),"w") ;
	} ;
	
} ;
//******************************************************************************
void olSDL::DebugPrinter::print(const string message, const bool withNewline) {

	if (withNewline) {
		if (pFile==NULL) {
			fprintf(stderr, "%s\n", message.c_str() ) ;
		} else {
			fprintf(pFile, "%s\n", message.c_str() ) ;
		} ;
	} else {
		if (pFile==NULL) {
			fprintf(stderr, "%s", message.c_str() ) ;
		} else {
			fprintf(pFile, "%s", message.c_str() ) ;
		} ;
	} ;

} ;
//******************************************************************************
void olSDL::DebugPrinter::print_iNumber(const int number, const bool withNewline) {

	print(olSDL::Converter::Int_to_String(number), withNewline) ;
} ;
//******************************************************************************
void olSDL::DebugPrinter::print_iList(const list<int> & iList) {

	string Result ;
	list<int>::const_iterator iter ;

	iter = iList.begin() ;
	while ( iter != iList.end() ) {

		Result.append(olSDL::Converter::Int_to_String(*iter)) ;
		Result.append(" ") ;
		iter++ ;
	} ;

	print(Result) ;
} ;
//******************************************************************************
olSDL::DebugPrinter::~DebugPrinter() {

} ;
//******************************************************************************

