
#include "MoAccessInfo.h"

//*******************************************************************************************************
olSDL::ClsMoAccess_ErrorReporter::ClsMoAccess_ErrorReporter(e_ErrorType ErrorType) {

	m_ErrorType = ErrorType ;
} ;
//*******************************************************************************************************
olSDL::ClsMoAccess_ErrorReporter::e_ErrorType olSDL::ClsMoAccess_ErrorReporter::get_ErrorType() const {

	return m_ErrorType ;
} ;
//*******************************************************************************************************
string olSDL::ClsMoAccess_ErrorReporter::get_ErrorMessage() const {

	string str_ErrMessage ;

	switch (m_ErrorType) {

		case get_wrong_symbol_type:
		{
			str_ErrMessage = "GET: requested symbol not part of location" ;
		}
		case get_page_unknown:
		{
			str_ErrMessage = "GET: page unknown" ;
		}
		case insert_unconsidered_symbol:
		{
			str_ErrMessage = "INSERT: unconsidered symbol" ;
		}
		case insert_no_diagram:
		{
			str_ErrMessage = "INSERT: location no diagram" ;
		}
		case insert_page_unknown:
		{
			str_ErrMessage = "INSERT: page unknown" ;
		}
		case page_insert_ID_exists:
		{
			str_ErrMessage = "PAGE-INSERT: page ID exists" ;
		}
		case page_insert_ancestor_unknown:
		{
			str_ErrMessage = "PAGE-INSERT: ancestor page unknown" ;
		}
		case page_delete_one_page_needed:
		{
			str_ErrMessage = "PAGE-DELETE: one page needed" ;
		}
		default:
		{
			str_ErrMessage = "unspecified error" ;
		}
	} ; // switch

	return str_ErrMessage ;

} ;

//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsMoAccessInfo::ClsMoAccessInfo( ) : m_Result(none) {

} ;
//*******************************************************************************************************
void olSDL::ClsMoAccessInfo::set_Info(const e_ResultType Result) {
	m_Result = Result ;
} ;
//*******************************************************************************************************
olSDL::ClsMoAccessInfo::e_ResultType olSDL::ClsMoAccessInfo::get_Info() const {
	return m_Result ;
} ;
//*******************************************************************************************************
char* olSDL::ClsMoAccessInfo::get_Info_Message() const {

	switch (m_Result) {
		case get_wrong_symbol_type:
		{
			return "GET: requested symbol not part of location" ;
		}
		case get_page_unknown:
		{
			return "GET: page unknown" ;
		}
		case insert_unconsidered_symbol:
		{
			return "INSERT: unconsidered symbol" ;
		}
		case insert_no_diagram:
		{
			return "INSERT: location no diagram" ;
		}
		case insert_page_unknown:
		{
			return "INSERT: page unknown" ;
		}
		case page_insert_ID_exists:
		{
			return "PAGE-INSERT: page ID exists" ;
		}
		case page_insert_ancestor_unknown:
		{
			return "PAGE-INSERT: ancestor page unknown" ;
		}
		case page_delete_one_page_needed:
		{
			return "PAGE-DELETE: one page needed" ;
		}
		default:
		{
			return "GetInfo-Error" ;
		}
	} ; // switch

} ;
//*******************************************************************************************************
