
#include "MoEleMap.h"
#include "Helper.h"

//*******************************************************************************************************
olSDL::ClsMoEleMap::ClsMoEleInfo::ClsMoEleInfo( ) {

	#ifdef olSDL_DL_ONE
	// DebugPrinter::print("Kon: olSDL::ClsMoEleInfo::ClsMoEleInfo( )") ;
	#endif

	m_MoEleBasicType = basic_none ;
	m_MoEleType = olSDL::ClsMoEleType::none ;
	m_pDiagram = NULL ;
} ;
//*******************************************************************************************************
olSDL::ClsMoEleMap::ClsMoEleInfo::ClsMoEleInfo(const ClsMoEleType::e_MoEle MoEleType , olSDL::Diagram * const pDiagram) {

	m_MoEleType = MoEleType ;
	m_pDiagram = pDiagram ;

	switch (m_MoEleType) {
		case olSDL::ClsMoEleType::TextSym:
		case olSDL::ClsMoEleType::BlkInstRefSym:
		case olSDL::ClsMoEleType::BlkTypeRefSym:
		case olSDL::ClsMoEleType::ProInstRefSym:
		case olSDL::ClsMoEleType::ProTypeRefSym:
		case olSDL::ClsMoEleType::ProcedureInstRefSym:
		{
			m_MoEleBasicType = Symbol ;
			break ;
		} ;
		case olSDL::ClsMoEleType::SysDia:
		case olSDL::ClsMoEleType::BlkDia:
		case olSDL::ClsMoEleType::ProDia:
		case olSDL::ClsMoEleType::BlkTypeDia:
		case olSDL::ClsMoEleType::ProTypeDia:
		case olSDL::ClsMoEleType::ProcedureDia:
		{
			m_MoEleBasicType = Diagram ;
			break ;
		}
		case olSDL::ClsMoEleType::StateMachineSymStart:
		case olSDL::ClsMoEleType::StateMachineSymState:
		case olSDL::ClsMoEleType::StateMachineSymOutput:
		case olSDL::ClsMoEleType::StateMachineSymInput:
		case olSDL::ClsMoEleType::StateMachineSymStop:
		case olSDL::ClsMoEleType::StateMachineSymTask:
		case olSDL::ClsMoEleType::StateMachineSymCondition:
		case olSDL::ClsMoEleType::StateMachineSymDecision:
		case olSDL::ClsMoEleType::StateMachineSymCreatePro:
		case olSDL::ClsMoEleType::StateMachineSymCallProcedure:
		case olSDL::ClsMoEleType::StateMachineSymProcedureStartState:
		case olSDL::ClsMoEleType::StateMachineSymProcedureReturn:
		{
			m_MoEleBasicType = StateMachineSymbol ;
			break ;
		}
		case olSDL::ClsMoEleType::NormalFlowLine:
		case olSDL::ClsMoEleType::DecisionFlowLine:
		{
			m_MoEleBasicType = FlowLine ;
			break ;
		}
		case olSDL::ClsMoEleType::ChanSym:
		{
			m_MoEleBasicType = Channel ;
			break ;
		}
		default:
			#ifdef olSDL_DL_TWO
			{
			DebugPrinter::print("error in: olSDL::ClsMoEleMap::ClsMoEleInfo::ClsMoEleInfo(...") ;
			DebugPrinter::print("unconsidered type!!!") ;
			}
			#endif
			m_MoEleBasicType = ClsMoEleInfo::basic_none ;
			m_pDiagram = NULL ;
	} ;
	// switch (MoEleType)
} ;
//*******************************************************************************************************
olSDL::ClsMoEleMap::ClsMoEleInfo::ClsMoEleInfo(const ClsMoEleInfo & Element) {

	#ifdef olSDL_DL_ONE
	// DebugPrinter::print("Copy: olSDL::ClsMoEleInfo::ClsMoEleInfo(const ClsMoEleInfo & Element)") ;
	#endif

	this->m_MoEleBasicType = Element.m_MoEleBasicType ;
	this->m_MoEleType = Element.m_MoEleType ;
	this->m_pDiagram = Element.m_pDiagram ;
} ;
//*******************************************************************************************************
olSDL::ClsMoEleMap::ClsMoEleInfo & olSDL::ClsMoEleMap::ClsMoEleInfo::operator=(const ClsMoEleInfo & Element) {

	#ifdef olSDL_DL_ONE
	// DebugPrinter::print("Assign: olSDL::ClsMoEleInfo::operator=(const ClsMoEleInfo & Element)") ;
	#endif

	if (this != &Element) {
		this->m_MoEleBasicType = Element.m_MoEleBasicType ;
		this->m_MoEleType = Element.m_MoEleType ;
		this->m_pDiagram = Element.m_pDiagram ;
	} ;
	return (*this) ;
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsMoEleMap::ClsMoEleInfo::get_MoEleType( )  const {
	return m_MoEleType ;
} ;
//*******************************************************************************************************
olSDL::ClsMoEleMap::ClsMoEleInfo::e_MoEleBasic olSDL::ClsMoEleMap::ClsMoEleInfo::get_MoEleBasicType() const {
	return m_MoEleBasicType ;
} ;
//*******************************************************************************************************
olSDL::Diagram * olSDL::ClsMoEleMap::ClsMoEleInfo::get_Diagram( ) const {

	#ifdef olSDL_DL_TWO
	{
		if (get_MoEleBasicType()!=olSDL::ClsMoEleMap::ClsMoEleInfo::Diagram) {
		DebugPrinter::print("olSDL::Diagram * olSDL::ClsMoEleInfo::get_Diagram( )") ;
		} ;
	}
	#endif

	return m_pDiagram ;
} ;
//*******************************************************************************************************
olSDL::Diagram * olSDL::ClsMoEleMap::ClsMoEleInfo::get_EnclosingDiagram( ) const {

	#ifdef olSDL_DL_TWO
	{
		if (  (get_MoEleBasicType() != ClsMoEleInfo::Symbol)  &&  (get_MoEleBasicType() != ClsMoEleInfo::Channel) &&
			(get_MoEleBasicType() != ClsMoEleInfo::StateMachineSymbol) && (get_MoEleBasicType() != ClsMoEleInfo::FlowLine) ) {
		DebugPrinter::print("error in olSDL::Diagram * olSDL::ClsMoEleInfo::get_EnclosingDiagram( )") ;
		} ;
	}
	#endif

	return m_pDiagram ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsMoEleMap::ClsMoEleMap() {

	m_max_generated_ID = 0 ;
} ;
//*******************************************************************************************************
int olSDL::ClsMoEleMap::get_ID() {

	int ID ;
	int max_ID_in_Map ;

	// use released ID if  possible
	if (m_ID_Pool.size() > 0)
	{

		ID = m_ID_Pool.back() ;
		m_ID_Pool.pop_back() ;

	} else {

		ID = m_max_generated_ID + 1 ;
	} ;


	if ( ID>m_max_generated_ID ) {
		m_max_generated_ID = ID ;
	} ;


	// Test
	if (ID_exists_in_Map(ID)) {
		printf("%s\n", "error in olSDL::ClsMoEleMap::get_ID") ;
	} ;
	// END: Test


	return ID ;
} ;
//*******************************************************************************************************
bool olSDL::ClsMoEleMap::ID_exists_in_Map(int ID) {

	typ_MoEleMap::const_iterator iter ;

	iter = m_InternalMoEleMap.find(ID) ;

	if ( iter==m_InternalMoEleMap.end() ) {
		return false ;
	} else {
		return true ;
	} ;
} ;
//*******************************************************************************************************
int olSDL::ClsMoEleMap::get_max_ID_from_Map() {

	int max_ID = 1 ;

	for (typ_MoEleMap::const_iterator iter=m_InternalMoEleMap.begin(); iter!=m_InternalMoEleMap.end(); iter++) {
		if ( (iter->first) > max_ID) {
			max_ID = iter->first ;
		} ;
	} ;

	return max_ID ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
void olSDL::ClsMoEleMap::add_MoEle (const ClsObjectWithModel_ID * const pObjectWithModel_ID, Diagram * const pDiagram) {

	int ObjectModel_ID ;
	int ParentDiagramID  ;


	switch (pObjectWithModel_ID->get_MoEleType()) {

		case olSDL::ClsMoEleType::ChanSym:
		case olSDL::ClsMoEleType::NormalFlowLine:
		case olSDL::ClsMoEleType::DecisionFlowLine:
		case olSDL::ClsMoEleType::TextSym:
		case olSDL::ClsMoEleType::BlkInstRefSym:
		case olSDL::ClsMoEleType::BlkTypeRefSym:
		case olSDL::ClsMoEleType::ProInstRefSym:
		case olSDL::ClsMoEleType::ProTypeRefSym:
		case olSDL::ClsMoEleType::ProcedureInstRefSym:
		case olSDL::ClsMoEleType::StateMachineSymStart:
		case olSDL::ClsMoEleType::StateMachineSymState:
		case olSDL::ClsMoEleType::StateMachineSymOutput:
		case olSDL::ClsMoEleType::StateMachineSymInput:
		case olSDL::ClsMoEleType::StateMachineSymStop:
		case olSDL::ClsMoEleType::StateMachineSymTask:
		case olSDL::ClsMoEleType::StateMachineSymCondition:
		case olSDL::ClsMoEleType::StateMachineSymDecision:
		case olSDL::ClsMoEleType::StateMachineSymCreatePro:
		case olSDL::ClsMoEleType::StateMachineSymCallProcedure:
		case olSDL::ClsMoEleType::StateMachineSymProcedureStartState:
		case olSDL::ClsMoEleType::StateMachineSymProcedureReturn:
		{
			ObjectModel_ID = pObjectWithModel_ID->get_Model_ID() ;

			// Object-ID exists
			#ifdef olSDL_DL_TWO
			typ_MoEleMap::const_iterator iterA ;
			iterA = m_InternalMoEleMap.find(ObjectModel_ID) ;
			if (iterA!=m_InternalMoEleMap.end()) {
				DebugPrinter::print("error in: void olSDL::ClsMoEleMap::add_MoEle(...)") ;
				DebugPrinter::print("Object-Model-ID exists !!!") ;
			} ;
			#endif

			// Parent Diagram ID in map ??
			#ifdef olSDL_DL_TWO
			ParentDiagramID = pDiagram->get_Model_ID() ;
			typ_MoEleMap::const_iterator iterB ;
			iterB = m_InternalMoEleMap.find(ParentDiagramID) ;
			if (iterB==m_InternalMoEleMap.end()) {
				DebugPrinter::print("error in: void olSDL::ClsMoEleMap::add_MoEle(...)") ;
				DebugPrinter::print("Parent not in Map !!!") ;
			} ;
			#endif

			ClsMoEleInfo ElementInfo(pObjectWithModel_ID->get_MoEleType(), pDiagram) ;
			m_InternalMoEleMap[ObjectModel_ID] = ElementInfo ;

			break ;
		}
		case olSDL::ClsMoEleType::SysDia:
		case olSDL::ClsMoEleType::ProDia:
		case olSDL::ClsMoEleType::ProTypeDia:
		case olSDL::ClsMoEleType::BlkDia:
		case olSDL::ClsMoEleType::BlkTypeDia:
		case olSDL::ClsMoEleType::ProcedureDia:
		{
			ObjectModel_ID = pObjectWithModel_ID->get_Model_ID() ;

			// Diagram-Model-ID exists ?
			#ifdef olSDL_DL_TWO
			typ_MoEleMap::const_iterator iter ;
			iter = m_InternalMoEleMap.find(ObjectModel_ID) ;
			if (iter!=m_InternalMoEleMap.end()) {
				DebugPrinter::print("error in: void olSDL::ClsMoEleMap::add_MoEle(...)") ;
				DebugPrinter::print("Object-Model-ID exists !!!") ;
			} ;
			#endif

			ClsMoEleInfo ElementInfo(pObjectWithModel_ID->get_MoEleType(), pDiagram) ;

			// add to map
			m_InternalMoEleMap[ObjectModel_ID] = ElementInfo ;

			break ;
		}
		default:
			#ifdef olSDL_DL_TWO
			{
				DebugPrinter::print("error in: void olSDL::ClsMoEleMap::add_MoEle(...)") ;
				DebugPrinter::print("unconsidered type!!!") ;
			}
			#endif
			;
	} ;
} ;
//*******************************************************************************************************
void olSDL::ClsMoEleMap::delete_MoEle(int Model_ID, ClsMoAccessInfo & Info) {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("olSDL::ClsMoEleMap::delete_MoEle(int Model_ID)") ;
	#endif

	typ_MoEleMap::iterator iter ;
	iter = m_InternalMoEleMap.find(Model_ID) ;
	if (iter==m_InternalMoEleMap.end()) {
		Info.set_Info(ClsMoAccessInfo::delete_object_unknown) ;
		return ;
	} ;

	m_InternalMoEleMap.erase(Model_ID) ;
	Info.set_Info(ClsMoAccessInfo::delete_OK) ;
} ;
//*******************************************************************************************************
olSDL::Diagram * olSDL::ClsMoEleMap::find_MoEle(const int MoEle_ID, const EnumAccessType AccessType, ClsMoAccessInfo & Info)  const {

	Diagram * pDiagram = NULL ;

	typ_MoEleMap::const_iterator iter ;

	switch (AccessType) {
		case get_enclosing_diagram:
		{
			iter = m_InternalMoEleMap.find(MoEle_ID) ;

			// object exits ?
			if (iter==m_InternalMoEleMap.end()) {
				//not found
				Info.set_Info(ClsMoAccessInfo::get_enclosing_diagram_object_not_found_in_map) ;
				return NULL;
			} ;

			// symbol ?
			if (!(  (((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::Symbol) ||
				(((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::StateMachineSymbol) ||
				(((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::FlowLine) )) {
				Info.set_Info(ClsMoAccessInfo::get_enclosing_diagram_object_wrong_type) ;
				return NULL;
			} ;

			pDiagram = (iter->second).get_EnclosingDiagram() ;
			Info.set_Info(ClsMoAccessInfo::get_enclosing_diagram_OK) ;
			return pDiagram ;

			break ;
		}
		case get_enclosing_diagram_for_deleting_object:
		{
			iter = m_InternalMoEleMap.find(MoEle_ID) ;

			// object exits ?
			if (iter==m_InternalMoEleMap.end()) {
				//not found
				Info.set_Info(ClsMoAccessInfo::delete_object_not_found_in_map) ;
				return NULL;
			} ;

			// deletable object ?
			if (!(  (((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::Symbol) ||
				(((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::Channel) ||
				(((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::StateMachineSymbol) ||
				(((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::FlowLine) )) {
				Info.set_Info(ClsMoAccessInfo::delete_object_wrong_type) ;
				return NULL;
			} ;

			pDiagram = (iter->second).get_EnclosingDiagram() ;
			Info.set_Info(ClsMoAccessInfo::delete_OK) ;
			return pDiagram ;

			break ;
		}
		case get_enclosing_diagram_for_modifying_object:
		{
			iter = m_InternalMoEleMap.find(MoEle_ID) ;

			// object exits ?
			if (iter==m_InternalMoEleMap.end()) {
				//not found
				Info.set_Info(ClsMoAccessInfo::modify_object_not_found_in_map) ;
				return NULL;
			} ;

			// "modifyable" object
			if (!(  (((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::Channel)  ||
				(((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::Symbol) ||
				(((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::StateMachineSymbol) ||
				(((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::FlowLine))) {
				Info.set_Info(ClsMoAccessInfo::modify_object_wrong_type) ;
				return NULL;
			} ;

			pDiagram = (iter->second).get_EnclosingDiagram() ;
			Info.set_Info(ClsMoAccessInfo::modify_OK) ;
			return pDiagram ;

			break ;
		}
		case insert_into_diagram:
		{
			iter = m_InternalMoEleMap.find(MoEle_ID) ;

			// object exits ?
			if (iter==m_InternalMoEleMap.end()) {
				//not found
				Info.set_Info(ClsMoAccessInfo::insert_diagram_not_found_in_map) ;
				return NULL;
			} ;

			// object is diagram ?
			if (!(  ((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::Diagram  )) {
				Info.set_Info(ClsMoAccessInfo::insert_object_is_not_diagram) ;
				return NULL;
			} ;

			pDiagram = (iter->second).get_Diagram() ;
			Info.set_Info(ClsMoAccessInfo::insert_OK) ;
			return pDiagram ;

			break ;
		}
		case get_diagram:
		{

			iter = m_InternalMoEleMap.find(MoEle_ID) ;

			// object exits ?
			if (iter==m_InternalMoEleMap.end()) {
				//not found
				Info.set_Info(ClsMoAccessInfo::get_diagram_not_found_in_map) ;
				return NULL;
			} ;

			// object is diagram ?
			if (!(  ((*iter).second).get_MoEleBasicType() == ClsMoEleInfo::Diagram  )) {
				Info.set_Info(ClsMoAccessInfo::get_object_is_not_diagram) ;
				return NULL;
			} ;

			pDiagram = (iter->second).get_Diagram() ;
			Info.set_Info(ClsMoAccessInfo::get_OK) ;
			return pDiagram ;

			break ;

		}
		default:
			{
			Info.set_Info(ClsMoAccessInfo::access_type_unknown) ;
			return NULL;
			}

	} ; // switch (AccessType)
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsMoEleMap::get_MoEleType(const int MoEle_ID) const {

	typ_MoEleMap::const_iterator iter ;

	iter = m_InternalMoEleMap.find(MoEle_ID) ;
	return( (iter->second).get_MoEleType() ) ;
} ;


//*******************************************************************************************************
//*******************************************************************************************************
void olSDL::ClsMoEleMap::print_Map() const {

	DebugPrinter::print("void olSDL::ClsMoEleMap::print_Map()") ;

	for (typ_MoEleMap::const_iterator iter=m_InternalMoEleMap.begin(); iter!=m_InternalMoEleMap.end(); iter++) {

		DebugPrinter::print("MAP-ID: ", false) ;
		DebugPrinter::print_iNumber(iter->first) ;

		DebugPrinter::print("Element-type: ",false) ;

		olSDL::ClsMoEleType::e_MoEle MoEleType = (iter->second).get_MoEleType( ) ;
		switch (MoEleType) {
			case olSDL::ClsMoEleType::SysDia:
			{
				DebugPrinter::print("SysDia") ;
				break ;
			}
			case olSDL::ClsMoEleType::BlkDia:
			{
				DebugPrinter::print("BlkDia") ;
				break ;
			}
			case olSDL::ClsMoEleType::ProDia:
			{
				DebugPrinter::print("ProDia") ;
				break ;
			}
			case olSDL::ClsMoEleType::TextSym:
			{
				DebugPrinter::print("TextSym") ;
				break ;
			}
			case olSDL::ClsMoEleType::ProInstRefSym:
			{
				DebugPrinter::print("ProInstRefSym") ;
				break ;
			}
			case olSDL::ClsMoEleType::ProTypeRefSym:
			{
				DebugPrinter::print("ProTypeRefSym") ;
				break ;
			}
			case olSDL::ClsMoEleType::BlkInstRefSym:
			{
				DebugPrinter::print("BlkInstRefSym") ;
				break;
			}
			case olSDL::ClsMoEleType::BlkTypeRefSym:
			{
				DebugPrinter::print("BlkTypeRefSym") ;
				break;
			}
			case olSDL::ClsMoEleType::ChanSym:
			{
				DebugPrinter::print("ChanSym") ;
				break;
			}
			case olSDL::ClsMoEleType::StateMachineSymStart:
			{
				DebugPrinter::print("StateMachineSymStart") ;
				break;
			}
			case olSDL::ClsMoEleType::StateMachineSymState:
			{
				DebugPrinter::print("StateMachineSymState") ;
				break;
			}
			case olSDL::ClsMoEleType::StateMachineSymOutput:
			{
				DebugPrinter::print("StateMachineSymOutput") ;
				break;
			}
			case olSDL::ClsMoEleType::StateMachineSymInput:
			{
				DebugPrinter::print("StateMachineSymInput") ;
				break;
			}
			case olSDL::ClsMoEleType::StateMachineSymStop:
			{
				DebugPrinter::print("StateMachineSymStop") ;
				break;
			}
			case olSDL::ClsMoEleType::StateMachineSymTask:
			{
				DebugPrinter::print("StateMachineSymTask") ;
				break;
			}
			case olSDL::ClsMoEleType::StateMachineSymCondition:
			{
				DebugPrinter::print("StateMachineSymCondition") ;
				break;
			}
			case olSDL::ClsMoEleType::StateMachineSymDecision:
			{
				DebugPrinter::print("StateMachineSymDecision") ;
				break;
			}
			case olSDL::ClsMoEleType::StateMachineSymCreatePro:
			{
				DebugPrinter::print("StateMachineSymCreatePro") ;
				break;
			}
			case olSDL::ClsMoEleType::NormalFlowLine:
			{
				DebugPrinter::print("NormalFlowLine") ;
				break;
			}
			case olSDL::ClsMoEleType::DecisionFlowLine:
			{
				DebugPrinter::print("DecisionFlowLine") ;
				break;
			}
			default:
				#ifdef olSDL_DL_TWO
				{
					DebugPrinter::print("error in: void olSDL::ClsMoEleMap::print_Map()") ;
					DebugPrinter::print("unconsidered type!!!") ;
				}
				#endif
				;
		} ; // switch
	} ; //for

	DebugPrinter::print("END: void olSDL::ClsMoEleMap::print_Map()") ;
} ;
//*******************************************************************************************************

