#include "ProcessDia.h"
#include "Helper.h"

//*******************************************************************************************************
olSDL::ClsProcessDia::ClsProcessDia(const int Diagram_ID, const string & HeaderPart_Name, const int First_Page_ID, const Symbol * const pReferencingSymbol)
	: Diagram(Diagram_ID, EnumDia::ProDia, HeaderPart_Name, First_Page_ID, pReferencingSymbol) {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("olSDL::ClsProcessDia::ClsProcessDia(...)") ;
	#endif
} ;
//*******************************************************************************************************
olSDL::ClsProcessDia::~ClsProcessDia() {

} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsProcessDia::get_MoEleType() const {
	return olSDL::ClsMoEleType::ProDia ;
} ;
//*******************************************************************************************************
bool olSDL::ClsProcessDia::is_referenced_Diagram() const {
	return true ;
} ;

//*******************************************************************************************************
//*******************************************************************************************************
void olSDL::ClsProcessDia::get_Syms(const EnumSym::Type SymbolType, const int Page_ID, type_ListOf_Poi_to_ConstSym & ResultList,
					ClsMoAccessInfo & Info) const {

	if ( (SymbolType == EnumSym::BlkInstRefSym) || (SymbolType == EnumSym::BlkTypeRefSym) ) {

		Info.set_Info(ClsMoAccessInfo::get_wrong_symbol_type);
		return ;

	} else {

		Diagram::get_Syms(SymbolType, Page_ID, ResultList, Info) ;
		return ;

	} ;

} ;
//*******************************************************************************************************
const olSDL::Symbol * olSDL::ClsProcessDia::insert_Symbol(const EnumSym::Type SymbolType, const int Symbol_ID, const int Page_ID,
						   		   const int x_left_up, const int y_left_up, const int width, const int height , const string content,
								   const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID,
					           		   ClsMoAccessInfo & Info) {


	if ( (SymbolType == EnumSym::BlkInstRefSym) || (SymbolType == EnumSym::BlkTypeRefSym) ) {

		Info.set_Info(ClsMoAccessInfo::insert_wrong_symbol);
		return NULL;

	} else {

		return Diagram::insert_Symbol(SymbolType, Symbol_ID, Page_ID, x_left_up, y_left_up, width, height , content,
					ReferencedDiagramID, ReferencedDiagramFirstPageID, Info);

	} ;

} ;
//*******************************************************************************************************

