
using namespace std;

#include "SDL_PR_Writer.h"
#include "Helper.h"


const string olSDL::ClsSDL_PR_Writer::KW_SYSDIA = "SYSTEM" ;
const string olSDL::ClsSDL_PR_Writer::KW_BLKDIA = "BLOCK" ;
const string olSDL::ClsSDL_PR_Writer::KW_PRODIA = "PROCESS" ;
const string olSDL::ClsSDL_PR_Writer::KW_PROCEDUREDIA = "PROCEDURE" ;

const string olSDL::ClsSDL_PR_Writer::KW_END_SYSDIA = "ENDSYSTEM" ;
const string olSDL::ClsSDL_PR_Writer::KW_END_BLKDIA = "ENDBLOCK" ;
const string olSDL::ClsSDL_PR_Writer::KW_END_PRODIA = "ENDPROCESS" ;
const string olSDL::ClsSDL_PR_Writer::KW_END_PROCEDUREDIA = "ENDPROCEDURE" ;

const string olSDL::ClsSDL_PR_Writer::KW_CHANNEL = "CHANNEL" ;
const string olSDL::ClsSDL_PR_Writer::KW_END_CHANNEL = "ENDCHANNEL" ;
const string olSDL::ClsSDL_PR_Writer::KW_CHANNEL_DELAY = "DELAY" ;
const string olSDL::ClsSDL_PR_Writer::KW_CHANNEL_NODELAY = "NODELAY" ;

const string olSDL::ClsSDL_PR_Writer::KW_CHANNEL_FROM = "FROM" ;
const string olSDL::ClsSDL_PR_Writer::KW_CHANNEL_TO = "TO" ;
const string olSDL::ClsSDL_PR_Writer::KW_CHANNEL_WITH = "WITH" ;
const string olSDL::ClsSDL_PR_Writer::KW_CHANNEL_VIA = "VIA" ;
const string olSDL::ClsSDL_PR_Writer::KW_CHANNEL_ENVIROMENT = "ENV" ;

const string olSDL::ClsSDL_PR_Writer::KW_CHANNEL_CONNECT = "CONNECT";
const string olSDL::ClsSDL_PR_Writer::KW_CHANNEL_AND = "AND";


const string olSDL::ClsSDL_PR_Writer::KW_BLOCK_REFERENCED = "BLOCK" ;
const string olSDL::ClsSDL_PR_Writer::KW_BLOCK_TYPE_REFERENCED = "BLOCK TYPE" ;

const string olSDL::ClsSDL_PR_Writer::KW_PROCESS_REFERENCED = "PROCESS" ;
const string olSDL::ClsSDL_PR_Writer::KW_PROCESS_TYPE_REFERENCED = "PROCESS TYPE" ;
const string olSDL::ClsSDL_PR_Writer::KW_PROCEDURE_REFERENCED = "PROCEDURE" ;

const string olSDL::ClsSDL_PR_Writer::KW_REFERENCED = "REFERENCED" ;

const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_START_SYM = "START" ;
const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_STATE_SYM = "STATE" ;
const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_INPUT_SYM = "INPUT" ;
const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_CONDITION_SYM = "PROVIDED" ;
const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_OUTPUT_SYM = "OUTPUT" ;
const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_TASK_SYM = "TASK" ;
const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_STOP_SYM = "STOP" ;
const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_DECISION_SYM = "DECISION" ;
const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_CREATE_PROC_SYM = "CREATE" ;
const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_CALL_PROCEDURE_SYM = "CALL" ;
const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_PROCEDURE_START_STATE_SYM = "START" ;
const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_PROCEDURE_RETURN_SYM = "RETURN" ;


const string olSDL::ClsSDL_PR_Writer::KW_STATE_MA_ENDDECISION = "ENDDECISION" ;

const string olSDL::ClsSDL_PR_Writer::KW_NEXTSTATE = "NEXTSTATE" ;

const string olSDL::ClsSDL_PR_Writer::KW_JOIN = "JOIN" ;


//*******************************************************************************************************
olSDL::ClsSDL_PR_Writer::ClsSDL_PR_Writer() {

	m_pOutStream = NULL ;
	m_pSystemSpec = NULL ;
} ;
//*******************************************************************************************************
olSDL::ClsSDL_PR_Writer::~ClsSDL_PR_Writer() {

	if (m_pOutStream != NULL) {

		if (m_pOutStream->is_open()) {
			m_pOutStream->close() ;
		} ;

		delete m_pOutStream ;
	} ;

	m_pSystemSpec = NULL ;
} ;
//*******************************************************************************************************
void olSDL::ClsSDL_PR_Writer::write_SysSpec(const SysSpec * pSystemSpec, const string & FileName, const bool b_Inline) {

	if (m_pOutStream != NULL) {

		if (m_pOutStream->is_open()) {
			m_pOutStream->close() ;
		} ;

		delete m_pOutStream ;
		m_FileName = "" ;
	} ;

	m_FileName = FileName ;

	m_pOutStream = new ofstream(m_FileName.c_str(), ios::out) ;

	if (! *m_pOutStream) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	m_pOutStream->exceptions(ios::badbit | ios::failbit | ios::eofbit) ;

	// init Helper
	reset_Helper() ;


	m_pSystemSpec = pSystemSpec ;
	write_Dia(m_pSystemSpec->get_SysDia(), b_Inline) ;


	m_pOutStream->close() ;

	if (! *m_pOutStream) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

} ;
//*******************************************************************************************************
//*******************************************************************************************************
void olSDL::ClsSDL_PR_Writer::write_Dia(const Diagram * pDiagram, const bool b_Inline) {

	switch (pDiagram->get_DiagramType()) {

		case EnumDia::SysDia:
		case EnumDia::BlkDia:
		{
			write_HL_InstDia (pDiagram, b_Inline) ;
			break ;
		}
		case EnumDia::ProDia:
		{
			write_ProDia((ClsProcessDia *) pDiagram, b_Inline) ;
			break ;
		}
		case EnumDia::ProcedureDia:
		{
			write_ProcedureDia((ClsProcedureDia *) pDiagram, b_Inline) ;
			break ;
		}
		default:
		{
			throw ClsSDL_PR_Writer_UnspecifiedError() ;
			break ;
		}
	} ; //switch (pDiagram->get_DiagramType())

} ;
//*******************************************************************************************************
void olSDL::ClsSDL_PR_Writer::write_HL_InstDia(const Diagram * pHL_InstDiagram, const bool b_Inline) {

	string EndString ;
	string str_DiaName ;

	list<int> IDsOfPages ;
	list<int>::iterator iterIDsOfPages ;

	ClsMoAccessInfo Info ;
	type_ListOf_Poi_to_ConstSym RecSymResultList ;
	type_ListOf_Poi_to_ConstSym::const_iterator iterRecSymResultList ;

	type_ListOf_Poi_to_ConstChannel ChannelResultList ;
	type_ListOf_Poi_to_ConstChannel::const_iterator iterChannelResultList ;

	list<const Diagram *> ReferencedDiagrams ;
	list<const Diagram *>::const_iterator iterReferencedDiagrams ;


	switch (pHL_InstDiagram->get_DiagramType()) {

		case EnumDia::SysDia:
		{
			pHL_InstDiagram->get_HeaderPart_Name(str_DiaName) ;

			write_StringBlockToFile(-1, -1, false, false, KW_SYSDIA) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(pHL_InstDiagram->get_Model_ID(), pHL_InstDiagram->get_Model_ID(), true, false, str_DiaName) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;

  	 		EndString = KW_END_SYSDIA ;
			break ;
		}
		case EnumDia::BlkDia:
		{
			pHL_InstDiagram->get_HeaderPart_Name(str_DiaName) ;

			write_StringBlockToFile(-1, -1, false, false, KW_BLKDIA) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(pHL_InstDiagram->get_Model_ID(), pHL_InstDiagram->get_Model_ID(), true, false, str_DiaName) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;

   			EndString = KW_END_BLKDIA ;
			break ;
		}
		default:
		{
			throw ClsSDL_PR_Writer_UnspecifiedError() ;
			break ;
		}
	} ; // switch (pHL_InstDiagram->get_DiagramType())

	// ===============================================

	pHL_InstDiagram->get_IDsOfPages(IDsOfPages) ;

	// ===============================================

	// ===============================================
	// write text symbols

	for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)
	{
		RecSymResultList.clear() ;
		pHL_InstDiagram->get_Syms(EnumSym::TextSym, *iterIDsOfPages, RecSymResultList, Info) ;
		for (iterRecSymResultList=RecSymResultList.begin(); iterRecSymResultList != RecSymResultList.end(); iterRecSymResultList++) {

			write_RecSym(*iterRecSymResultList, pHL_InstDiagram->get_Model_ID()) ;
		} ;
	} ;

	// write text symbols
	// ===============================================

	// ===============================================
	// write channels

	for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)
	{
		ChannelResultList.clear() ;
		pHL_InstDiagram->get_Channels(*iterIDsOfPages, ChannelResultList, Info) ;

		for (iterChannelResultList=ChannelResultList.begin(); iterChannelResultList != ChannelResultList.end() ; iterChannelResultList++)
		{
			write_Channel(*iterChannelResultList, pHL_InstDiagram->get_Model_ID()) ;
		} ;

	} ; // for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)

	// write channels
	// ===============================================

	// ===============================================
	// write channel connections

	if ( pHL_InstDiagram->get_DiagramType() == EnumDia::BlkDia)  {

		for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)
		{
			ChannelResultList.clear() ;
			pHL_InstDiagram->get_Channels(*iterIDsOfPages, ChannelResultList, Info) ;

			for (iterChannelResultList=ChannelResultList.begin(); iterChannelResultList != ChannelResultList.end() ; iterChannelResultList++)
			{
				write_ChannelConnection(*iterChannelResultList, pHL_InstDiagram->get_Model_ID()) ;
			} ;

		} ; // for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)

	} ;

	// write channel connections
	// ===============================================

	// ===============================================
	// ===============================================
	// write proc and blk syms

	for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)
	{
		// BlkInstRef
		RecSymResultList.clear() ;
		pHL_InstDiagram->get_Syms(EnumSym::BlkInstRefSym, *iterIDsOfPages, RecSymResultList, Info) ;
		for (iterRecSymResultList=RecSymResultList.begin(); iterRecSymResultList != RecSymResultList.end(); iterRecSymResultList++) {

			if (!b_Inline) {

				write_RecSym(*iterRecSymResultList, pHL_InstDiagram->get_Model_ID()) ;
				if ((*iterRecSymResultList)->is_referencing_Symbol()) {
					ReferencedDiagrams.push_back((*iterRecSymResultList)->get_referenced_Diagram()) ;
				} ;

			} else {

				if ((*iterRecSymResultList)->is_referencing_Symbol()) {
					write_Dia ((*iterRecSymResultList)->get_referenced_Diagram(), b_Inline) ;
				} ;

			} ;

		} ;

	} ; // for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)

	for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)
	{
		// ProInstRefSym
		RecSymResultList.clear() ;
		pHL_InstDiagram->get_Syms(EnumSym::ProInstRefSym, *iterIDsOfPages, RecSymResultList, Info) ;
		for (iterRecSymResultList=RecSymResultList.begin(); iterRecSymResultList != RecSymResultList.end(); iterRecSymResultList++) {

			if (!b_Inline) {

				write_RecSym(*iterRecSymResultList, pHL_InstDiagram->get_Model_ID()) ;
				if ((*iterRecSymResultList)->is_referencing_Symbol()) {
					ReferencedDiagrams.push_back((*iterRecSymResultList)->get_referenced_Diagram()) ;
				} ;

			} else {

				if ((*iterRecSymResultList)->is_referencing_Symbol()) {
					write_Dia ((*iterRecSymResultList)->get_referenced_Diagram(), b_Inline) ;
				} ;

			} ;

		} ;

	} ; // for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)

	// write proc and blk syms
	// ===============================================
	// ===============================================

	write_StringBlockToFile(pHL_InstDiagram->get_Model_ID(), pHL_InstDiagram->get_Model_ID(), false, false, EndString) ;
	write_StringBlockToFile(-1, -1, false, false, " ") ;
	write_StringBlockToFile(-1, -1, false, false, str_DiaName) ;
	write_StringBlockToFile(-1, -1, false, true, ";") ;


	/*==============================*/
	// Referenced Diagrams

	if (!b_Inline) {

		for (iterReferencedDiagrams=ReferencedDiagrams.begin(); iterReferencedDiagrams != ReferencedDiagrams.end(); iterReferencedDiagrams++) {

			write_Dia(*iterReferencedDiagrams, b_Inline) ;
		} ;

	} ;

	// END: Referenced Diagrams
	/*==============================*/

} ;
//*******************************************************************************************************
void olSDL::ClsSDL_PR_Writer::write_ProDia(const ClsProcessDia * pProcessDia, const bool b_Inline) {

	string str_DiaName ;

	list<int> IDsOfPages ;
	list<int>::iterator iterIDsOfPages ;

	ClsMoAccessInfo Info ;
	type_ListOf_Poi_to_ConstSym RecSymResultList ;
	type_ListOf_Poi_to_ConstSym::const_iterator iterRecSymResultList ;

	type_ListOf_Poi_to_ConstChannel ChannelResultList ;
	type_ListOf_Poi_to_ConstChannel::const_iterator iterChannelResultList ;

	list<const Diagram *> ReferencedDiagrams ;
	list<const Diagram *>::const_iterator iterReferencedDiagrams ;


	pProcessDia->get_HeaderPart_Name(str_DiaName) ;

	write_StringBlockToFile(-1, -1, false, false, KW_PRODIA) ;
	write_StringBlockToFile(-1, -1, false, false, " ") ;
	write_StringBlockToFile(pProcessDia->get_Model_ID(), pProcessDia->get_Model_ID(), true, false, str_DiaName) ;
	write_StringBlockToFile(-1, -1, false, true, ";") ;

	// ===============================================

	pProcessDia->get_IDsOfPages(IDsOfPages) ;

	// ===============================================

	// ===============================================
	// write text symbols

	for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)
	{
		RecSymResultList.clear() ;
		pProcessDia->get_Syms(EnumSym::TextSym, *iterIDsOfPages, RecSymResultList, Info) ;
		for (iterRecSymResultList=RecSymResultList.begin(); iterRecSymResultList != RecSymResultList.end(); iterRecSymResultList++) {

			write_RecSym(*iterRecSymResultList, pProcessDia->get_Model_ID()) ;
		} ;
	} ;

	// write text symbols
	// ===============================================

	// ===============================================
	// write channels

	for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)
	{
		ChannelResultList.clear() ;
		pProcessDia->get_Channels(*iterIDsOfPages, ChannelResultList, Info) ;

		for (iterChannelResultList=ChannelResultList.begin(); iterChannelResultList != ChannelResultList.end() ; iterChannelResultList++)
		{
			write_Channel(*iterChannelResultList, pProcessDia->get_Model_ID()) ;
		} ;

	} ; // for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)

	// write channels
	// ===============================================

	// ===============================================
	// ===============================================
	// write proc syms

	for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)
	{
		// ProInstRefSym
		RecSymResultList.clear() ;
		pProcessDia->get_Syms(EnumSym::ProInstRefSym, *iterIDsOfPages, RecSymResultList, Info) ;
		for (iterRecSymResultList=RecSymResultList.begin(); iterRecSymResultList != RecSymResultList.end(); iterRecSymResultList++) {

			if (!b_Inline) {

				write_RecSym(*iterRecSymResultList, pProcessDia->get_Model_ID()) ;
				if ((*iterRecSymResultList)->is_referencing_Symbol()) {
					ReferencedDiagrams.push_back((*iterRecSymResultList)->get_referenced_Diagram()) ;
				} ;

			} else {

				if ((*iterRecSymResultList)->is_referencing_Symbol()) {

					write_Dia ((*iterRecSymResultList)->get_referenced_Diagram(), b_Inline) ;

				} ;

			} ;

		} ;

	} ; // for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)

	// write proc syms
	// ===============================================
	// ===============================================

	// ===============================================
	// ===============================================
	// write procedure syms

	for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)
	{
		// ProInstRefSym
		RecSymResultList.clear() ;
		pProcessDia->get_Syms(EnumSym::ProcedureInstRefSym, *iterIDsOfPages, RecSymResultList, Info) ;
		for (iterRecSymResultList=RecSymResultList.begin(); iterRecSymResultList != RecSymResultList.end(); iterRecSymResultList++) {

			if (!b_Inline) {

				write_RecSym(*iterRecSymResultList, pProcessDia->get_Model_ID()) ;
				if ((*iterRecSymResultList)->is_referencing_Symbol()) {
					ReferencedDiagrams.push_back((*iterRecSymResultList)->get_referenced_Diagram()) ;
				} ;

			} else {

				if ((*iterRecSymResultList)->is_referencing_Symbol()) {

					write_Dia ((*iterRecSymResultList)->get_referenced_Diagram(), b_Inline) ;

				} ;

			} ;
		} ;

	} ; // for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)

	// write procedure syms
	// ===============================================
	// ===============================================

	// ===============================================
	// ===============================================
	// write StateMaSyms

	type_ListOfPoi_to_ConstStateMachineSymbol StateMaSymResultList ;
	type_ListOfPoi_to_ConstStateMachineSymbol::const_iterator iterStateMaSymResultList ;

	// ===============================================
	// Starting StateMaStartSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::start,
		pProcessDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	for (iterStateMaSymResultList = StateMaSymResultList.begin(); iterStateMaSymResultList != StateMaSymResultList.end() ; iterStateMaSymResultList++) {

		write_StateMaSymAndSuccessors(true, *iterStateMaSymResultList, pProcessDia->get_Model_ID()) ;
	} ;

	// Starting StateMaStartSym
	// ===============================================

	// ===============================================
	// Starting StateMaStateSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::state,
		pProcessDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	for (iterStateMaSymResultList = StateMaSymResultList.begin(); iterStateMaSymResultList != StateMaSymResultList.end() ; iterStateMaSymResultList++) {

		write_StateMaSymAndSuccessors(true, *iterStateMaSymResultList, pProcessDia->get_Model_ID()) ;
	} ;

	// Starting StateMaStateSym
	// ===============================================

	// ===============================================
	// Starting StateMaInputSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::input,
		pProcessDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// Starting StateMaInputSym
	// ===============================================

	// ===============================================
	// Starting StateMaOutputSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::output,
		pProcessDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// Starting StateMaOutputSym
	// ===============================================

	// ===============================================
	// Starting StateMaTaskSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::task,
		pProcessDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// Starting StateMaTaskSym
	// ===============================================

	// ===============================================
	// Starting StateMaStopSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::stop,
		pProcessDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// Starting StateMaStopSym
	// ===============================================

	// ===============================================
	// Starting StateMaDecisionSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::decision,
		pProcessDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// Starting StateMaDecisionSym
	// ===============================================

	// ===============================================
	// Starting StateMaCreateProSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::create_pro,
		pProcessDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// Starting StateMaCreateProSym
	// ===============================================

	// ===============================================
	// Starting StateMaCallProcedureSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::call_procedure,
		pProcessDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// StateMaCallProcedureSym
	// ===============================================

	// write StateMaSyms
	// ===============================================
	// ===============================================

	write_StringBlockToFile(pProcessDia->get_Model_ID(), pProcessDia->get_Model_ID(), false, false, KW_END_PRODIA) ;
	write_StringBlockToFile(-1, -1, false, false, " ") ;
	write_StringBlockToFile(-1, -1, false, false, str_DiaName) ;
	write_StringBlockToFile(-1, -1, false, true, ";") ;

	/*==============================*/
	// Referenced Diagrams

	if (!b_Inline) {

		for (iterReferencedDiagrams=ReferencedDiagrams.begin(); iterReferencedDiagrams != ReferencedDiagrams.end(); iterReferencedDiagrams++) {

			write_Dia(*iterReferencedDiagrams, b_Inline) ;
		} ;

	} ;

	// END: Referenced Diagrams
	/*==============================*/

} ;
//*******************************************************************************************************
void olSDL::ClsSDL_PR_Writer::write_ProcedureDia(const ClsProcedureDia * pProcedureDia, const bool b_Inline) {

	string str_DiaName ;

	list<int> IDsOfPages ;
	list<int>::iterator iterIDsOfPages ;

	ClsMoAccessInfo Info ;
	type_ListOf_Poi_to_ConstSym RecSymResultList ;
	type_ListOf_Poi_to_ConstSym::const_iterator iterRecSymResultList ;

	list<const Diagram *> ReferencedDiagrams ;
	list<const Diagram *>::const_iterator iterReferencedDiagrams ;


	pProcedureDia->get_HeaderPart_Name(str_DiaName) ;

	write_StringBlockToFile(-1, -1, false, false, KW_PROCEDUREDIA) ;
	write_StringBlockToFile(-1, -1, false, false, " ") ;
	write_StringBlockToFile(pProcedureDia->get_Model_ID(), pProcedureDia->get_Model_ID(), true, false, str_DiaName) ;
	write_StringBlockToFile(-1, -1, false, true, ";") ;

	// ===============================================

	pProcedureDia->get_IDsOfPages(IDsOfPages) ;

	// ===============================================

	// ===============================================
	// write formal parameters

	write_StringBlockToFile(-1, -1, false, false, pProcedureDia->get_FormalParameters()) ;
	write_StringBlockToFile(-1, -1, false, true, ";") ;

	// write formal parameters
	// ===============================================

	// ===============================================
	// write text symbols

	for (iterIDsOfPages=IDsOfPages.begin(); iterIDsOfPages != IDsOfPages.end(); iterIDsOfPages++)
	{
		RecSymResultList.clear() ;
		pProcedureDia->get_Syms(EnumSym::TextSym, *iterIDsOfPages, RecSymResultList, Info) ;
		for (iterRecSymResultList=RecSymResultList.begin(); iterRecSymResultList != RecSymResultList.end(); iterRecSymResultList++) {

			write_RecSym(*iterRecSymResultList, pProcedureDia->get_Model_ID()) ;
		} ;
	} ;

	// write text symbols
	// ===============================================

	// ===============================================
	// ===============================================
	// write StateMaSyms

	type_ListOfPoi_to_ConstStateMachineSymbol StateMaSymResultList ;
	type_ListOfPoi_to_ConstStateMachineSymbol::const_iterator iterStateMaSymResultList ;

	// ===============================================
	// Starting StateMaProcedureStartStateSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::procedure_start_state,
		pProcedureDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	for (iterStateMaSymResultList = StateMaSymResultList.begin(); iterStateMaSymResultList != StateMaSymResultList.end() ; iterStateMaSymResultList++) {

		write_ProcedureStateMaSymAndSuccessors(true, *iterStateMaSymResultList, pProcedureDia->get_Model_ID()) ;
	} ;

	// Starting StateMaProcedureStartStateSym
	// ===============================================

	// ===============================================
	// Starting StateMaStateSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::state,
		pProcedureDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	for (iterStateMaSymResultList = StateMaSymResultList.begin(); iterStateMaSymResultList != StateMaSymResultList.end() ; iterStateMaSymResultList++) {

		write_ProcedureStateMaSymAndSuccessors(true, *iterStateMaSymResultList, pProcedureDia->get_Model_ID()) ;
	} ;

	// Starting StateMaStateSym
	// ===============================================

	// ===============================================
	// Starting StateMaInputSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::input,
		pProcedureDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// Starting StateMaInputSym
	// ===============================================

	// ===============================================
	// Starting StateMaOutputSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::output,
		pProcedureDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// Starting StateMaOutputSym
	// ===============================================

	// ===============================================
	// Starting StateMaTaskSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::task,
		pProcedureDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// Starting StateMaTaskSym
	// ===============================================

	// ===============================================
	// Starting StateMaProcedureReturnSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::procedure_return,
		pProcedureDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// Starting StateMaProcedureReturnSym
	// ===============================================

	// ===============================================
	// Starting StateMaDecisionSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::decision,
		pProcedureDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// Starting StateMaDecisionSym
	// ===============================================

	// ===============================================
	// Starting StateMaCreateProSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::create_pro,
		pProcedureDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// Starting StateMaCreateProSym
	// ===============================================

	// ===============================================
	// Starting StateMaCallProcedureSym

	StateMaSymResultList.clear() ;

	m_pSystemSpec->get_StartingStateMachineSymsFromDiagram(ClsStateMachineSymbol::call_procedure,
		pProcedureDia->get_Model_ID(), StateMaSymResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	if (StateMaSymResultList.size() > 0) {

		iterStateMaSymResultList = StateMaSymResultList.begin();

		throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec, (*iterStateMaSymResultList), ClsSDL_PR_Writer_StateMaSymError::sms_illegal_start_state) ;
	} ;

	// StateMaCallProcedureSym
	// ===============================================

	// write StateMaSyms
	// ===============================================
	// ===============================================

	write_StringBlockToFile(pProcedureDia->get_Model_ID(), pProcedureDia->get_Model_ID(), false, false, KW_END_PROCEDUREDIA) ;
	write_StringBlockToFile(-1, -1, false, false, " ") ;
	write_StringBlockToFile(-1, -1, false, false, str_DiaName) ;
	write_StringBlockToFile(-1, -1, false, true, ";") ;

	/*==============================*/
	// Referenced Diagrams

	if (!b_Inline) {

		for (iterReferencedDiagrams=ReferencedDiagrams.begin(); iterReferencedDiagrams != ReferencedDiagrams.end(); iterReferencedDiagrams++) {

			write_Dia(*iterReferencedDiagrams, b_Inline) ;
		} ;

	} ;

	// END: Referenced Diagrams
	/*==============================*/

} ;
//*******************************************************************************************************
void olSDL::ClsSDL_PR_Writer::write_RecSym(const Symbol * pSymbol, const int ParentDiagram_Model_ID) const {

	switch (pSymbol->get_SymbolType()) {
		case EnumSym::TextSym:
		{
			write_StringBlockToFile(pSymbol->get_Model_ID(), ParentDiagram_Model_ID, true, true, pSymbol->get_content()) ;
			break ;
		}
		case EnumSym::BlkInstRefSym:
		{
			write_StringBlockToFile(-1, -1, false, false, KW_BLOCK_REFERENCED) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(pSymbol->get_Model_ID(), ParentDiagram_Model_ID, true, false, pSymbol->get_content()) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(-1, -1, false, false, KW_REFERENCED) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;
			break ;
		}
		case EnumSym::BlkTypeRefSym:
		{
			write_StringBlockToFile(-1, -1, false, false, KW_BLOCK_TYPE_REFERENCED) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(pSymbol->get_Model_ID(), ParentDiagram_Model_ID, true, false, pSymbol->get_content()) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(-1, -1, false, false, KW_REFERENCED) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;
			break ;
		}
		case EnumSym::ProInstRefSym:
		{
			write_StringBlockToFile(-1, -1, false, false, KW_PROCESS_REFERENCED) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(pSymbol->get_Model_ID(), ParentDiagram_Model_ID, true, false, pSymbol->get_content()) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(-1, -1, false, false, KW_REFERENCED) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;
			break ;
		}
		case EnumSym::ProTypeRefSym:
		{
			write_StringBlockToFile(-1, -1, false, false, KW_PROCESS_TYPE_REFERENCED) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(pSymbol->get_Model_ID(), ParentDiagram_Model_ID, true, false, pSymbol->get_content()) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(-1, -1, false, false, KW_REFERENCED) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;
			break ;
		}
		case EnumSym::ProcedureInstRefSym:
		{
			write_StringBlockToFile(-1, -1, false, false, KW_PROCEDURE_REFERENCED) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(pSymbol->get_Model_ID(), ParentDiagram_Model_ID, true, false, pSymbol->get_content()) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(-1, -1, false, false, KW_REFERENCED) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;
			break ;
		}
		default:
		{
			throw ClsSDL_PR_Writer_UnspecifiedError() ;
		}
	} ; //switch (pSymbol->get_SymbolType())
} ;
//*******************************************************************************************************
//*******************************************************************************************************
void olSDL::ClsSDL_PR_Writer::write_ProcedureStateMaSymAndSuccessors(const bool b_TransitionStart, const ClsStateMachineSymbol * pStateMachineSymbol,
			const int ParentDiagram_Model_ID) {

	type_ListOfPoi_to_ConstFlowLine OutgoingFlowLinesResultList ;
	type_ListOfPoi_to_ConstFlowLine::const_iterator iterOutgoingFlowLinesResultList ;
	type_ListOfPoi_to_ConstFlowLine temp_OutgoingFlowLinesResultList ;
	type_ListOfPoi_to_ConstFlowLine InComingFlowLinesResultList ;

	 ClsMoAccessInfo Info ;

	// ===================================================
	// check, if symbol has already been written

	if ( StateMaSym_written(pStateMachineSymbol->get_Model_ID()) ) {

		// join
		write_StringBlockToFile(-1, -1, false, false, KW_JOIN) ;
		write_StringBlockToFile(-1, -1, false, false, " ") ;
		write_StringBlockToFile(-1, -1, false, false, get_Label( pStateMachineSymbol->get_Model_ID() )) ;
		write_StringBlockToFile(-1, -1, false, true, ";") ;

		return ;
	} ;

	// check, if symbol has already been written
	// ===================================================

	// ===================================================
	// check for Incoming FlowLines

	InComingFlowLinesResultList.clear() ;
	m_pSystemSpec->get_InComingFlowLinesFromStateMaSym(pStateMachineSymbol->get_Model_ID(),
		InComingFlowLinesResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	// check for Incoming FlowLines
	// ===================================================

	// ===============
	// ===============

	if ( ! set_StateMaSym_written(pStateMachineSymbol->get_Model_ID()) ) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	// ===============
	// ===============

	switch (pStateMachineSymbol->get_SymbolType() ) {

		case ClsStateMachineSymbol::procedure_start_state:
		case ClsStateMachineSymbol::state:
		case ClsStateMachineSymbol::output:
		case ClsStateMachineSymbol::input:
		case ClsStateMachineSymbol::condition:
		case ClsStateMachineSymbol::stop:
		case ClsStateMachineSymbol::procedure_return:
		case ClsStateMachineSymbol::create_pro:
		case ClsStateMachineSymbol::call_procedure:
		{
			if ( InComingFlowLinesResultList.size() > 1 ) {

				write_StringBlockToFile(-1, -1, false, false, get_Label( pStateMachineSymbol->get_Model_ID() )) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
				write_StringBlockToFile(-1, -1, false, true, ":") ;
			} ;

			// ====
			if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::procedure_start_state) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_PROCEDURE_START_STATE_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_STATE_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::output) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_OUTPUT_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::input) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_INPUT_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::condition) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_CONDITION_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::procedure_return) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_PROCEDURE_RETURN_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::task) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_TASK_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::create_pro) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_CREATE_PROC_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::call_procedure) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_CALL_PROCEDURE_SYM) ;

			} else {

				throw ClsSDL_PR_Writer_UnspecifiedError() ;
			} ;
			// ====


			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(-1, -1, false, false, pStateMachineSymbol->get_content()) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;

			break ;
		}
		case ClsStateMachineSymbol::decision:
		{
			// ===
			if ( InComingFlowLinesResultList.size() > 1 ) {

				write_StringBlockToFile(-1, -1, false, false, get_Label( pStateMachineSymbol->get_Model_ID() )) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
				write_StringBlockToFile(-1, -1, false, true, ":") ;
			} ;
			// ===

			write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_DECISION_SYM) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(-1, -1, false, false, "(") ;
			write_StringBlockToFile(-1, -1, false, false, pStateMachineSymbol->get_content()) ;
			write_StringBlockToFile(-1, -1, false, false, ")") ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;

			// ===
			OutgoingFlowLinesResultList.clear() ;
			m_pSystemSpec->get_OutgoingFlowLinesFromStateMaSym(pStateMachineSymbol->get_Model_ID(), OutgoingFlowLinesResultList, Info) ;

			if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
				throw ClsSDL_PR_Writer_UnspecifiedError() ;
			} ;

			// ===

			if (OutgoingFlowLinesResultList.size() <= 1) {
				throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec,
					pStateMachineSymbol, ClsSDL_PR_Writer_StateMaSymError::sms_transition_not_complete) ;
			} ;

			// ===

			for (iterOutgoingFlowLinesResultList = OutgoingFlowLinesResultList.begin();
				iterOutgoingFlowLinesResultList != OutgoingFlowLinesResultList.end();
				iterOutgoingFlowLinesResultList++) {

				if ( (*iterOutgoingFlowLinesResultList)->get_FlowLineType() != ClsFlowLine::decision ) {
					throw ClsSDL_PR_Writer_UnspecifiedError() ;
				} ;

				write_StringBlockToFile(-1, -1, false, false, "(") ;
				write_StringBlockToFile(-1, -1, false, false, ((ClsDecisionFlowLine*)(*iterOutgoingFlowLinesResultList))->get_Content()  ) ;
				write_StringBlockToFile(-1, -1, false, false, ")") ;
				write_StringBlockToFile(-1, -1, false, true, ":") ;

				const ClsStateMachineSymbol * pSuccessorStateMachineSymbol =
					m_pSystemSpec->get_StateMachineSymbol((*iterOutgoingFlowLinesResultList)->get_DestID_as_Int(),Info) ;

				if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
					throw ClsSDL_PR_Writer_UnspecifiedError() ;
				} ;

				//=====
				// ==
				if ( pSuccessorStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state ) {

					// end of recursion ?

					if ( StateMaSym_written(pSuccessorStateMachineSymbol->get_Model_ID()) ) {

						write_StringBlockToFile(-1, -1, false, false, KW_JOIN) ;
						write_StringBlockToFile(-1, -1, false, false, " ") ;
						write_StringBlockToFile(-1, -1, false, false, get_Label( pSuccessorStateMachineSymbol->get_Model_ID() )) ;
						write_StringBlockToFile(-1, -1, false, true, ";") ;

					} else {

						if ( ! set_StateMaSym_written(pSuccessorStateMachineSymbol->get_Model_ID()) ) {
							throw ClsSDL_PR_Writer_UnspecifiedError() ;
						} ;

						InComingFlowLinesResultList.clear() ;
						m_pSystemSpec->get_InComingFlowLinesFromStateMaSym(pSuccessorStateMachineSymbol->get_Model_ID(),
							InComingFlowLinesResultList, Info) ;

						if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
							throw ClsSDL_PR_Writer_UnspecifiedError() ;
						} ;

						if ( InComingFlowLinesResultList.size() > 1 ) {

							write_StringBlockToFile(-1, -1, false, false, get_Label( pSuccessorStateMachineSymbol->get_Model_ID() )) ;
							write_StringBlockToFile(-1, -1, false, false, " ") ;
							write_StringBlockToFile(-1, -1, false, true, ":") ;
						} ;

						// ===

						write_StringBlockToFile(-1, -1, false, false, KW_NEXTSTATE) ;
						write_StringBlockToFile(-1, -1, false, false, " ") ;
						write_StringBlockToFile(-1, -1, false, false, pSuccessorStateMachineSymbol->get_content()) ;
						write_StringBlockToFile(-1, -1, false, true, ";") ;


						m_pSystemSpec->get_OutgoingFlowLinesFromStateMaSym(
							pSuccessorStateMachineSymbol->get_Model_ID(), temp_OutgoingFlowLinesResultList, Info) ;

						if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
							throw ClsSDL_PR_Writer_UnspecifiedError() ;
						} ;

						if (temp_OutgoingFlowLinesResultList.size() != 0) {

							if (pSuccessorStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state) {

								write_ProcedureStateMaSymEnclosedState(pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
							} else {

								write_ProcedureStateMaSymAndSuccessors(false, pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
							} ;

						} ;

					} ; // if ( StateMaSym_written(pSuccessorStateMachineSymbol->get_Model_ID()) )

				} else {

					// recursion
					write_ProcedureStateMaSymAndSuccessors(false, pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
				} ;

				// ==
				//=====

			} ; // for (iterOutgoingFlowLinesResultList

			write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_ENDDECISION) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;

			return ;

			break ;
		}
		default:
		{
			throw ClsSDL_PR_Writer_UnspecifiedError() ;
		}

	} ; // switch ( (*iterStateMachineSymbolContainer)->get_SymbolType() )


	// ===============
	// ===============

	OutgoingFlowLinesResultList.clear() ;
	m_pSystemSpec->get_OutgoingFlowLinesFromStateMaSym(pStateMachineSymbol->get_Model_ID(), OutgoingFlowLinesResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;


	switch (pStateMachineSymbol->get_SymbolType() ) {

		case ClsStateMachineSymbol::procedure_start_state:
		case ClsStateMachineSymbol::state:
		case ClsStateMachineSymbol::output:
		case ClsStateMachineSymbol::input:
		case ClsStateMachineSymbol::condition:
		case ClsStateMachineSymbol::procedure_return:
		case ClsStateMachineSymbol::task:
		case ClsStateMachineSymbol::create_pro:
		case ClsStateMachineSymbol::call_procedure:
		{
			// ===============

			if (OutgoingFlowLinesResultList.size() == 0) {
				if ( (pStateMachineSymbol->get_SymbolType() != ClsStateMachineSymbol::state) &&
					(pStateMachineSymbol->get_SymbolType() != ClsStateMachineSymbol::procedure_return) ) {

						throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec,
							pStateMachineSymbol, ClsSDL_PR_Writer_StateMaSymError::sms_transition_not_complete) ;
				} else {

					if ( (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state) && b_TransitionStart) {

						throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec,
							pStateMachineSymbol, ClsSDL_PR_Writer_StateMaSymError::sms_transition_not_complete) ;
					} ;
				} ;
			} ;

			// ===============

			for (iterOutgoingFlowLinesResultList = OutgoingFlowLinesResultList.begin(); iterOutgoingFlowLinesResultList != OutgoingFlowLinesResultList.end();
				iterOutgoingFlowLinesResultList++) {

				const ClsStateMachineSymbol * pSuccessorStateMachineSymbol =
					m_pSystemSpec->get_StateMachineSymbol((*iterOutgoingFlowLinesResultList)->get_DestID_as_Int(),Info) ;

				if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
					throw ClsSDL_PR_Writer_UnspecifiedError() ;
				} ;

				if ( pSuccessorStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state ) {

					// end of recursion ?

					if ( StateMaSym_written(pSuccessorStateMachineSymbol->get_Model_ID()) ) {

						write_StringBlockToFile(-1, -1, false, false, KW_JOIN) ;
						write_StringBlockToFile(-1, -1, false, false, " ") ;
						write_StringBlockToFile(-1, -1, false, false, get_Label( pSuccessorStateMachineSymbol->get_Model_ID() )) ;
						write_StringBlockToFile(-1, -1, false, true, ";") ;

					} else {

						if ( ! set_StateMaSym_written(pSuccessorStateMachineSymbol->get_Model_ID()) ) {
							throw ClsSDL_PR_Writer_UnspecifiedError() ;
						} ;

						InComingFlowLinesResultList.clear() ;
						m_pSystemSpec->get_InComingFlowLinesFromStateMaSym(pSuccessorStateMachineSymbol->get_Model_ID(),
							InComingFlowLinesResultList, Info) ;

						if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
							throw ClsSDL_PR_Writer_UnspecifiedError() ;
						} ;

						if ( InComingFlowLinesResultList.size() > 1 ) {

							write_StringBlockToFile(-1, -1, false, false, get_Label( pSuccessorStateMachineSymbol->get_Model_ID() )) ;
							write_StringBlockToFile(-1, -1, false, false, " ") ;
							write_StringBlockToFile(-1, -1, false, true, ":") ;
						} ;

						// ===

						write_StringBlockToFile(-1, -1, false, false, KW_NEXTSTATE) ;
						write_StringBlockToFile(-1, -1, false, false, " ") ;
						write_StringBlockToFile(-1, -1, false, false, pSuccessorStateMachineSymbol->get_content()) ;
						write_StringBlockToFile(-1, -1, false, true, ";") ;


						if (  (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::procedure_start_state) &&
						      (pSuccessorStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state) ) {

							write_ProcedureStateMaSymEnclosedState(pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;

						} else {

							m_pSystemSpec->get_OutgoingFlowLinesFromStateMaSym(
								pSuccessorStateMachineSymbol->get_Model_ID(), temp_OutgoingFlowLinesResultList, Info) ;

							if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
								throw ClsSDL_PR_Writer_UnspecifiedError() ;
							} ;

							if (temp_OutgoingFlowLinesResultList.size() != 0) {

								if (pSuccessorStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state) {

									write_ProcedureStateMaSymEnclosedState(pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
								} else {

									write_ProcedureStateMaSymAndSuccessors(false, pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
								} ;
							} ;
						} ;


					} ; // if ( StateMaSym_written(pSuccessorStateMachineSymbol->get_Model_ID()) )

				} else {

					// recursion
					write_ProcedureStateMaSymAndSuccessors(false, pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
				} ;

			} ; // for (iterOutgoingFlowLinesResultList

			break ;
		}
		default:
		{
			throw ClsSDL_PR_Writer_UnspecifiedError() ;
		}
	} ; // switch ( (*iterStateMachineSymbolContainer)->get_SymbolType() )

} ;
//*******************************************************************************************************
//*******************************************************************************************************
void olSDL::ClsSDL_PR_Writer::write_StateMaSymAndSuccessors(const bool b_TransitionStart, const ClsStateMachineSymbol * pStateMachineSymbol,
			const int ParentDiagram_Model_ID) {

	type_ListOfPoi_to_ConstFlowLine OutgoingFlowLinesResultList ;
	type_ListOfPoi_to_ConstFlowLine::const_iterator iterOutgoingFlowLinesResultList ;
	type_ListOfPoi_to_ConstFlowLine temp_OutgoingFlowLinesResultList ;
	type_ListOfPoi_to_ConstFlowLine InComingFlowLinesResultList ;

	 ClsMoAccessInfo Info ;

	// ===================================================
	// check, if symbol has already been written

	if ( StateMaSym_written(pStateMachineSymbol->get_Model_ID()) ) {

		// join
		write_StringBlockToFile(-1, -1, false, false, KW_JOIN) ;
		write_StringBlockToFile(-1, -1, false, false, " ") ;
		write_StringBlockToFile(-1, -1, false, false, get_Label( pStateMachineSymbol->get_Model_ID() )) ;
		write_StringBlockToFile(-1, -1, false, true, ";") ;

		return ;
	} ;

	// check, if symbol has already been written
	// ===================================================

	// ===================================================
	// check for Incoming FlowLines

	InComingFlowLinesResultList.clear() ;
	m_pSystemSpec->get_InComingFlowLinesFromStateMaSym(pStateMachineSymbol->get_Model_ID(),
		InComingFlowLinesResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	// check for Incoming FlowLines
	// ===================================================

	// ===============
	// ===============

	if ( ! set_StateMaSym_written(pStateMachineSymbol->get_Model_ID()) ) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;

	// ===============
	// ===============

	switch (pStateMachineSymbol->get_SymbolType() ) {

		case ClsStateMachineSymbol::start:
		case ClsStateMachineSymbol::state:
		case ClsStateMachineSymbol::output:
		case ClsStateMachineSymbol::input:
		case ClsStateMachineSymbol::condition:
		case ClsStateMachineSymbol::stop:
		case ClsStateMachineSymbol::task:
		case ClsStateMachineSymbol::create_pro:
		case ClsStateMachineSymbol::call_procedure:
		{
			if ( InComingFlowLinesResultList.size() > 1 ) {

				write_StringBlockToFile(-1, -1, false, false, get_Label( pStateMachineSymbol->get_Model_ID() )) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
				write_StringBlockToFile(-1, -1, false, true, ":") ;
			} ;

			// ====
			if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::start) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_START_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_STATE_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::output) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_OUTPUT_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::input) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_INPUT_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::condition) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_CONDITION_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::stop) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_STOP_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::task) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_TASK_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::create_pro) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_CREATE_PROC_SYM) ;

			} else if (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::call_procedure) {

				write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_CALL_PROCEDURE_SYM) ;

			} else {

				throw ClsSDL_PR_Writer_UnspecifiedError() ;
			} ;
			// ====


			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(-1, -1, false, false, pStateMachineSymbol->get_content()) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;

			break ;
		}
		case ClsStateMachineSymbol::decision:
		{
			// ===
			if ( InComingFlowLinesResultList.size() > 1 ) {

				write_StringBlockToFile(-1, -1, false, false, get_Label( pStateMachineSymbol->get_Model_ID() )) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
				write_StringBlockToFile(-1, -1, false, true, ":") ;
			} ;
			// ===

			write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_DECISION_SYM) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;
			write_StringBlockToFile(-1, -1, false, false, "(") ;
			write_StringBlockToFile(-1, -1, false, false, pStateMachineSymbol->get_content()) ;
			write_StringBlockToFile(-1, -1, false, false, ")") ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;

			// ===
			OutgoingFlowLinesResultList.clear() ;
			m_pSystemSpec->get_OutgoingFlowLinesFromStateMaSym(pStateMachineSymbol->get_Model_ID(), OutgoingFlowLinesResultList, Info) ;

			if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
				throw ClsSDL_PR_Writer_UnspecifiedError() ;
			} ;

			// ===

			if (OutgoingFlowLinesResultList.size() <= 1) {
				throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec,
					pStateMachineSymbol, ClsSDL_PR_Writer_StateMaSymError::sms_transition_not_complete) ;
			} ;

			// ===

			for (iterOutgoingFlowLinesResultList = OutgoingFlowLinesResultList.begin();
				iterOutgoingFlowLinesResultList != OutgoingFlowLinesResultList.end();
				iterOutgoingFlowLinesResultList++) {

				if ( (*iterOutgoingFlowLinesResultList)->get_FlowLineType() != ClsFlowLine::decision ) {
					throw ClsSDL_PR_Writer_UnspecifiedError() ;
				} ;

				write_StringBlockToFile(-1, -1, false, false, "(") ;
				write_StringBlockToFile(-1, -1, false, false, ((ClsDecisionFlowLine*)(*iterOutgoingFlowLinesResultList))->get_Content()  ) ;
				write_StringBlockToFile(-1, -1, false, false, ")") ;
				write_StringBlockToFile(-1, -1, false, true, ":") ;

				const ClsStateMachineSymbol * pSuccessorStateMachineSymbol =
					m_pSystemSpec->get_StateMachineSymbol((*iterOutgoingFlowLinesResultList)->get_DestID_as_Int(),Info) ;

				if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
					throw ClsSDL_PR_Writer_UnspecifiedError() ;
				} ;

				//=====
				// ==
				if ( pSuccessorStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state ) {

					// end of recursion ?

					if ( StateMaSym_written(pSuccessorStateMachineSymbol->get_Model_ID()) ) {

						write_StringBlockToFile(-1, -1, false, false, KW_JOIN) ;
						write_StringBlockToFile(-1, -1, false, false, " ") ;
						write_StringBlockToFile(-1, -1, false, false, get_Label( pSuccessorStateMachineSymbol->get_Model_ID() )) ;
						write_StringBlockToFile(-1, -1, false, true, ";") ;

					} else {

						if ( ! set_StateMaSym_written(pSuccessorStateMachineSymbol->get_Model_ID()) ) {
							throw ClsSDL_PR_Writer_UnspecifiedError() ;
						} ;

						InComingFlowLinesResultList.clear() ;
						m_pSystemSpec->get_InComingFlowLinesFromStateMaSym(pSuccessorStateMachineSymbol->get_Model_ID(),
							InComingFlowLinesResultList, Info) ;

						if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
							throw ClsSDL_PR_Writer_UnspecifiedError() ;
						} ;

						if ( InComingFlowLinesResultList.size() > 1 ) {

							write_StringBlockToFile(-1, -1, false, false, get_Label( pSuccessorStateMachineSymbol->get_Model_ID() )) ;
							write_StringBlockToFile(-1, -1, false, false, " ") ;
							write_StringBlockToFile(-1, -1, false, true, ":") ;
						} ;

						// ===

						write_StringBlockToFile(-1, -1, false, false, KW_NEXTSTATE) ;
						write_StringBlockToFile(-1, -1, false, false, " ") ;
						write_StringBlockToFile(-1, -1, false, false, pSuccessorStateMachineSymbol->get_content()) ;
						write_StringBlockToFile(-1, -1, false, true, ";") ;


						m_pSystemSpec->get_OutgoingFlowLinesFromStateMaSym(
							pSuccessorStateMachineSymbol->get_Model_ID(), temp_OutgoingFlowLinesResultList, Info) ;

						if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
							throw ClsSDL_PR_Writer_UnspecifiedError() ;
						} ;

						if (temp_OutgoingFlowLinesResultList.size() != 0) {

							if (pSuccessorStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state) {

								write_StateMaSymEnclosedState(pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
							} else {

								write_StateMaSymAndSuccessors(false, pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
							} ;

						} ;

					} ; // if ( StateMaSym_written(pSuccessorStateMachineSymbol->get_Model_ID()) )

				} else {

					// recursion
					write_StateMaSymAndSuccessors(false, pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
				} ;

				// ==
				//=====

			} ; // for (iterOutgoingFlowLinesResultList

			write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_ENDDECISION) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;

			return ;

			break ;
		}
		default:
		{
			throw ClsSDL_PR_Writer_UnspecifiedError() ;
		}

	} ; // switch ( (*iterStateMachineSymbolContainer)->get_SymbolType() )


	// ===============
	// ===============

	OutgoingFlowLinesResultList.clear() ;
	m_pSystemSpec->get_OutgoingFlowLinesFromStateMaSym(pStateMachineSymbol->get_Model_ID(), OutgoingFlowLinesResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;


	switch (pStateMachineSymbol->get_SymbolType() ) {

		case ClsStateMachineSymbol::start:
		case ClsStateMachineSymbol::state:
		case ClsStateMachineSymbol::output:
		case ClsStateMachineSymbol::input:
		case ClsStateMachineSymbol::condition:
		case ClsStateMachineSymbol::stop:
		case ClsStateMachineSymbol::task:
		case ClsStateMachineSymbol::create_pro:
		case ClsStateMachineSymbol::call_procedure:
		{
			// ===============

			if (OutgoingFlowLinesResultList.size() == 0) {
				if ( (pStateMachineSymbol->get_SymbolType() != ClsStateMachineSymbol::state) &&
					(pStateMachineSymbol->get_SymbolType() != ClsStateMachineSymbol::stop) ) {

						throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec,
							pStateMachineSymbol, ClsSDL_PR_Writer_StateMaSymError::sms_transition_not_complete) ;
				} else {

					if ( (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state) && b_TransitionStart) {

						throw ClsSDL_PR_Writer_StateMaSymError(m_pSystemSpec,
							pStateMachineSymbol, ClsSDL_PR_Writer_StateMaSymError::sms_transition_not_complete) ;
					} ;
				} ;
			} ;

			// ===============

			for (iterOutgoingFlowLinesResultList = OutgoingFlowLinesResultList.begin(); iterOutgoingFlowLinesResultList != OutgoingFlowLinesResultList.end();
				iterOutgoingFlowLinesResultList++) {

				const ClsStateMachineSymbol * pSuccessorStateMachineSymbol =
					m_pSystemSpec->get_StateMachineSymbol((*iterOutgoingFlowLinesResultList)->get_DestID_as_Int(),Info) ;

				if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
					throw ClsSDL_PR_Writer_UnspecifiedError() ;
				} ;

				if ( pSuccessorStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state ) {

					// end of recursion ?

					if ( StateMaSym_written(pSuccessorStateMachineSymbol->get_Model_ID()) ) {

						write_StringBlockToFile(-1, -1, false, false, KW_JOIN) ;
						write_StringBlockToFile(-1, -1, false, false, " ") ;
						write_StringBlockToFile(-1, -1, false, false, get_Label( pSuccessorStateMachineSymbol->get_Model_ID() )) ;
						write_StringBlockToFile(-1, -1, false, true, ";") ;

					} else {

						if ( ! set_StateMaSym_written(pSuccessorStateMachineSymbol->get_Model_ID()) ) {
							throw ClsSDL_PR_Writer_UnspecifiedError() ;
						} ;

						InComingFlowLinesResultList.clear() ;
						m_pSystemSpec->get_InComingFlowLinesFromStateMaSym(pSuccessorStateMachineSymbol->get_Model_ID(),
							InComingFlowLinesResultList, Info) ;

						if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
							throw ClsSDL_PR_Writer_UnspecifiedError() ;
						} ;

						if ( InComingFlowLinesResultList.size() > 1 ) {

							write_StringBlockToFile(-1, -1, false, false, get_Label( pSuccessorStateMachineSymbol->get_Model_ID() )) ;
							write_StringBlockToFile(-1, -1, false, false, " ") ;
							write_StringBlockToFile(-1, -1, false, true, ":") ;
						} ;

						// ===

						write_StringBlockToFile(-1, -1, false, false, KW_NEXTSTATE) ;
						write_StringBlockToFile(-1, -1, false, false, " ") ;
						write_StringBlockToFile(-1, -1, false, false, pSuccessorStateMachineSymbol->get_content()) ;
						write_StringBlockToFile(-1, -1, false, true, ";") ;


						if (  (pStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::start) &&
						      (pSuccessorStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state) ) {

							write_StateMaSymEnclosedState(pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;

						} else {

							m_pSystemSpec->get_OutgoingFlowLinesFromStateMaSym(
								pSuccessorStateMachineSymbol->get_Model_ID(), temp_OutgoingFlowLinesResultList, Info) ;

							if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
								throw ClsSDL_PR_Writer_UnspecifiedError() ;
							} ;

							if (temp_OutgoingFlowLinesResultList.size() != 0) {

								if (pSuccessorStateMachineSymbol->get_SymbolType() == ClsStateMachineSymbol::state) {

									write_StateMaSymEnclosedState(pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
								} else {

									write_StateMaSymAndSuccessors(false, pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
								} ;
							} ;
						} ;


					} ; // if ( StateMaSym_written(pSuccessorStateMachineSymbol->get_Model_ID()) )

				} else {

					// recursion
					write_StateMaSymAndSuccessors(false, pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
				} ;

			} ; // for (iterOutgoingFlowLinesResultList

			break ;
		}
		default:
		{
			throw ClsSDL_PR_Writer_UnspecifiedError() ;
		}
	} ; // switch ( (*iterStateMachineSymbolContainer)->get_SymbolType() )

} ;
//*******************************************************************************************************
void olSDL::ClsSDL_PR_Writer::write_ProcedureStateMaSymEnclosedState(const ClsStateMachineSymbol * pStateMachineSymbol,
											      const int ParentDiagram_Model_ID) {

	type_ListOfPoi_to_ConstFlowLine OutgoingFlowLinesResultList ;
	type_ListOfPoi_to_ConstFlowLine::const_iterator iterOutgoingFlowLinesResultList ;

	ClsMoAccessInfo Info ;


	write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_STATE_SYM) ;

	write_StringBlockToFile(-1, -1, false, false, " ") ;
	write_StringBlockToFile(-1, -1, false, false, pStateMachineSymbol->get_content()) ;
	write_StringBlockToFile(-1, -1, false, true, ";") ;


	OutgoingFlowLinesResultList.clear() ;
	m_pSystemSpec->get_OutgoingFlowLinesFromStateMaSym(pStateMachineSymbol->get_Model_ID(), OutgoingFlowLinesResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;


	for (iterOutgoingFlowLinesResultList = OutgoingFlowLinesResultList.begin(); iterOutgoingFlowLinesResultList != OutgoingFlowLinesResultList.end();
		iterOutgoingFlowLinesResultList++) {

		const ClsStateMachineSymbol * pSuccessorStateMachineSymbol =
				m_pSystemSpec->get_StateMachineSymbol((*iterOutgoingFlowLinesResultList)->get_DestID_as_Int(),Info) ;

		if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
			throw ClsSDL_PR_Writer_UnspecifiedError() ;
		} ;

		write_ProcedureStateMaSymAndSuccessors(false, pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
	} ;

} ;
//*******************************************************************************************************
void olSDL::ClsSDL_PR_Writer::write_StateMaSymEnclosedState(const ClsStateMachineSymbol * pStateMachineSymbol,
											      const int ParentDiagram_Model_ID) {

	type_ListOfPoi_to_ConstFlowLine OutgoingFlowLinesResultList ;
	type_ListOfPoi_to_ConstFlowLine::const_iterator iterOutgoingFlowLinesResultList ;

	ClsMoAccessInfo Info ;


	write_StringBlockToFile(-1, -1, false, false, KW_STATE_MA_STATE_SYM) ;

	write_StringBlockToFile(-1, -1, false, false, " ") ;
	write_StringBlockToFile(-1, -1, false, false, pStateMachineSymbol->get_content()) ;
	write_StringBlockToFile(-1, -1, false, true, ";") ;


	OutgoingFlowLinesResultList.clear() ;
	m_pSystemSpec->get_OutgoingFlowLinesFromStateMaSym(pStateMachineSymbol->get_Model_ID(), OutgoingFlowLinesResultList, Info) ;

	if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
		throw ClsSDL_PR_Writer_UnspecifiedError() ;
	} ;


	for (iterOutgoingFlowLinesResultList = OutgoingFlowLinesResultList.begin(); iterOutgoingFlowLinesResultList != OutgoingFlowLinesResultList.end();
		iterOutgoingFlowLinesResultList++) {

		const ClsStateMachineSymbol * pSuccessorStateMachineSymbol =
				m_pSystemSpec->get_StateMachineSymbol((*iterOutgoingFlowLinesResultList)->get_DestID_as_Int(),Info) ;

		if (Info.get_Info() != ClsMoAccessInfo::get_OK) {
			throw ClsSDL_PR_Writer_UnspecifiedError() ;
		} ;

		write_StateMaSymAndSuccessors(false, pSuccessorStateMachineSymbol, ParentDiagram_Model_ID) ;
	} ;

} ;
//*******************************************************************************************************
void olSDL::ClsSDL_PR_Writer::write_Channel(const ClsChannel * pChannel, const int ParentDiagram_Model_ID) const {

	ClsMoAccessInfo Info;

	string str_DelayType ;
	string str_DirectionType ;

	const ClsChanName* pChanName ;
	const ClsChanSourceSigList* pChanSourceSigList ;
	const ClsChanSourceCon* pChanSourceCon ;
	const ClsChanDestSigList* pChanDestSigList ;
	const ClsChanDestCon* pChanDestCon ;

	pChanName = pChannel->get_ChanName() ;

	switch (pChannel->get_DelayType()) {
		case ClsChannel::delay:
		{
			str_DelayType = KW_CHANNEL_DELAY ;
			break ;
		}
		case ClsChannel::no_delay:
		{
			str_DelayType = KW_CHANNEL_NODELAY ;
			break ;
		}
		default:
		{
			throw ClsSDL_PR_Writer_UnspecifiedError() ;
		}
	} ; // switch (pChannel->get_DelayType())


	write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL) ;
	write_StringBlockToFile(-1, -1, false, false, " ") ;

	write_StringBlockToFile(-1, -1, true, false, pChanName->get_content()) ;
	write_StringBlockToFile(-1, -1, false, false, " ") ;

	write_StringBlockToFile(-1, -1, false, true, str_DelayType) ;


	switch (pChannel->get_DirectionType()) {
		case ClsChannel::both:
		{
			pChanSourceSigList = pChannel->get_ChanSourceSigList() ;
			pChanSourceCon = pChannel->get_ChanSourceCon() ;
			pChanDestSigList = pChannel->get_ChanDestSigList() ;
			pChanDestCon = pChannel->get_ChanDestCon() ;

			write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_FROM) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;

			if (pChannel->Source_is_Env()) {
				write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_ENVIROMENT) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} else {
				int Source_ID = pChannel->get_SourceID_as_Int() ;

				write_StringBlockToFile(-1, -1, false, false, (m_pSystemSpec->get_RecSymbol(Source_ID, Info))->get_content()) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} ;

			write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_TO) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;

			if (pChannel->Destination_is_Env()) {
				write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_ENVIROMENT) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} else {
				int Dest_ID = pChannel->get_DestID_as_Int() ;

				write_StringBlockToFile(-1, -1, false, false, (m_pSystemSpec->get_RecSymbol(Dest_ID, Info))->get_content()) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} ;

			write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_WITH) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;

			write_StringBlockToFile(-1, -1, false, false, pChanSourceSigList->get_content()) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;

			// ==========================

			write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_FROM) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;

			if (pChannel->Destination_is_Env()) {
				write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_ENVIROMENT) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} else {
				int Dest_ID = pChannel->get_DestID_as_Int() ;

				write_StringBlockToFile(-1, -1, false, false, (m_pSystemSpec->get_RecSymbol(Dest_ID, Info))->get_content()) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} ;

			write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_TO) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;

			if (pChannel->Source_is_Env()) {
				write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_ENVIROMENT) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} else {
				int Source_ID = pChannel->get_SourceID_as_Int() ;

				write_StringBlockToFile(-1, -1, false, false, (m_pSystemSpec->get_RecSymbol(Source_ID, Info))->get_content()) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} ;

			write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_WITH) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;

			write_StringBlockToFile(-1, -1, false, false, pChanDestSigList->get_content()) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;

			break ;
		}
		case ClsChannel::from_source:
		{
			pChanSourceSigList = pChannel->get_ChanSourceSigList() ;
			pChanSourceCon = pChannel->get_ChanSourceCon() ;

			write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_FROM) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;

			if (pChannel->Source_is_Env()) {
				write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_ENVIROMENT) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} else {
				int Source_ID = pChannel->get_SourceID_as_Int() ;

				write_StringBlockToFile(-1, -1, false, false, (m_pSystemSpec->get_RecSymbol(Source_ID, Info))->get_content()) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} ;

			write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_TO) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;

			if (pChannel->Destination_is_Env()) {
				write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_ENVIROMENT) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} else {
				int Dest_ID = pChannel->get_DestID_as_Int() ;

				write_StringBlockToFile(-1, -1, false, false, (m_pSystemSpec->get_RecSymbol(Dest_ID, Info))->get_content()) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} ;

			write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_WITH) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;

			write_StringBlockToFile(-1, -1, false, false, pChanSourceSigList->get_content()) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;

			break ;
		}
		case ClsChannel::from_destination:
		{
			pChanDestSigList = pChannel->get_ChanDestSigList() ;
			pChanDestCon = pChannel->get_ChanDestCon() ;

			write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_FROM) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;

			if (pChannel->Destination_is_Env()) {
				write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_ENVIROMENT) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} else {
				int Dest_ID = pChannel->get_DestID_as_Int() ;

				write_StringBlockToFile(-1, -1, false, false, (m_pSystemSpec->get_RecSymbol(Dest_ID, Info))->get_content()) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} ;

			write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_TO) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;

			if (pChannel->Source_is_Env()) {
				write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_ENVIROMENT) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} else {
				int Source_ID = pChannel->get_SourceID_as_Int() ;

				write_StringBlockToFile(-1, -1, false, false, (m_pSystemSpec->get_RecSymbol(Source_ID, Info))->get_content()) ;
				write_StringBlockToFile(-1, -1, false, false, " ") ;
			} ;

			write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_WITH) ;
			write_StringBlockToFile(-1, -1, false, false, " ") ;

			write_StringBlockToFile(-1, -1, false, false, pChanDestSigList->get_content()) ;
			write_StringBlockToFile(-1, -1, false, true, ";") ;

			break ;
		}
		default:
		{
			throw ClsSDL_PR_Writer_UnspecifiedError() ;
			return ;
		}
	} ; // switch (pChannel->get_DirectionType())


	write_StringBlockToFile(-1, -1, false, false, KW_END_CHANNEL) ;
	write_StringBlockToFile(-1, -1, false, false, " ") ;
	write_StringBlockToFile(-1, -1, false, false, pChanName->get_content()) ;
	write_StringBlockToFile(-1, -1, false, true, ";") ;

} ;
//*******************************************************************************************************
void olSDL::ClsSDL_PR_Writer::write_ChannelConnection(const ClsChannel * pChannel, const int ParentDiagram_Model_ID) const {

	ClsMoAccessInfo Info;

	string str_ChannelName ;
	string str_ConnectionChannelName ;

	const ClsChanName* pChanName ;

	pChanName = pChannel->get_ChanName();
	str_ChannelName = pChanName->get_content();

	if ( pChannel->Source_is_Env() ) {

		write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_CONNECT) ;
		write_StringBlockToFile(-1, -1, false, false, " ") ;
		write_StringBlockToFile(-1, -1, false, false, pChannel->get_DestConContent()) ;
		write_StringBlockToFile(-1, -1, false, false, " ") ;
		write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_AND) ;
		write_StringBlockToFile(-1, -1, false, false, " ") ;
		write_StringBlockToFile(-1, -1, false, false, str_ChannelName) ;
		write_StringBlockToFile(-1, -1, false, true, ";") ;

	} ;

	if ( pChannel->Destination_is_Env() ) {

		write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_CONNECT) ;
		write_StringBlockToFile(-1, -1, false, false, " ") ;
		write_StringBlockToFile(-1, -1, false, false, pChannel->get_SourceConContent()) ;
		write_StringBlockToFile(-1, -1, false, false, " ") ;
		write_StringBlockToFile(-1, -1, false, false, KW_CHANNEL_AND) ;
		write_StringBlockToFile(-1, -1, false, false, " ") ;
		write_StringBlockToFile(-1, -1, false, false, str_ChannelName) ;
		write_StringBlockToFile(-1, -1, false, true, ";") ;

	} ;

} ;
//*******************************************************************************************************
// Helper
//*******************************************************************************************************
string olSDL::ClsSDL_PR_Writer::create_StartStringFromName(const string & Name, const string & Content) const {

	return (Name + " " + Content + ";" + "\n") ;

} ;
//******************************************************************************
void olSDL::ClsSDL_PR_Writer::write_StringBlockToFile(const int Model_ID, 
		const int ParentDiagram_Model_ID, const bool b_is_GR_Component, 
		const bool b_WithEndingNewline, const string & s) const {
	(*m_pOutStream) << s ;

	if (b_WithEndingNewline) {
		(*m_pOutStream) << "\n" ;
	}
}
//******************************************************************************
//******************************************************************************
// Error Reporter
//******************************************************************************
//******************************************************************************
olSDL::ClsSDL_PR_Writer_ErrorReporter::ClsSDL_PR_Writer_ErrorReporter(e_ErrorType ErrorType) {

	m_ErrorType = ErrorType ;
} ;
//*******************************************************************************************************
olSDL::ClsSDL_PR_Writer_ErrorReporter::e_ErrorType olSDL::ClsSDL_PR_Writer_ErrorReporter::get_ErrorType() const {

	return m_ErrorType ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsSDL_PR_Writer_UnspecifiedError::ClsSDL_PR_Writer_UnspecifiedError() : ClsSDL_PR_Writer_ErrorReporter(not_specified) {


} ;
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsSDL_PR_Writer_StateMaSymError::ClsSDL_PR_Writer_StateMaSymError(const SysSpec * pSysSpec,
		const ClsStateMachineSymbol * pStateMachineSymbol, e_StateMaErrorType ErrorType)
		: ClsSDL_PR_Writer_ErrorReporter(StateMaSym) {

	ClsMoAccessInfo Info ;

	m_StateMaErrorType = ErrorType ;

	m_StateMaSymID = pStateMachineSymbol->get_Model_ID() ;

	m_PageID = pStateMachineSymbol->get_Page_ID() ;

	m_DiagramID = pSysSpec->get_EnclosingDiagramID(m_StateMaSymID, Info) ;

} ;
//*******************************************************************************************************
olSDL::ClsSDL_PR_Writer_StateMaSymError::e_StateMaErrorType olSDL::ClsSDL_PR_Writer_StateMaSymError::get_StateMaErrorType() const {

	return m_StateMaErrorType ;
} ;
//*******************************************************************************************************
int olSDL::ClsSDL_PR_Writer_StateMaSymError::get_Symbol_ID() const {

	return m_StateMaSymID ;
} ;
//*******************************************************************************************************
int olSDL::ClsSDL_PR_Writer_StateMaSymError::get_PageID() const {

	return m_PageID ;
} ;
//*******************************************************************************************************
int olSDL::ClsSDL_PR_Writer_StateMaSymError::get_DiagramID() const  {

	return m_DiagramID ;
} ;
//*******************************************************************************************************
// Error Reporter
//*******************************************************************************************************
//*******************************************************************************************************

