
#include "StateMachineSymbol.h"

#include "Helper.h"

//*******************************************************************************************************
olSDL::ClsStateMachineSymbol::ClsStateMachineSymbol(const int Symbol_ID, const e_StateMachineSymbolType SymbolType,
		   			const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsPageObject(Page_ID), ClsRecPaS(x_pos, y_pos, width, height),
					ClsObjectWithModel_ID(Symbol_ID), m_SymbolType(SymbolType), m_content(content) {


} ;
//*******************************************************************************************************
olSDL::ClsStateMachineSymbol::~ClsStateMachineSymbol() {


} ;
//*******************************************************************************************************
//*******************************************************************************************************
void olSDL::ClsStateMachineSymbol::modify_Content(const string Content) {
	m_content = Content ;
} ;
//*******************************************************************************************************
olSDL::ClsStateMachineSymbol::e_StateMachineSymbolType olSDL::ClsStateMachineSymbol::get_SymbolType( ) const {
	return m_SymbolType ;
} ;
//*******************************************************************************************************
string olSDL::ClsStateMachineSymbol::get_content( ) const {
	return m_content ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
bool olSDL::ClsStateMachineSymbol::operator==(const ClsStateMachineSymbol & s) const {
	return (get_Model_ID() == s.get_Model_ID()) ;
} ;


//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsStateMachineStartSymbol::ClsStateMachineStartSymbol(const int Symbol_ID,
					const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsStateMachineSymbol(Symbol_ID, olSDL::ClsStateMachineSymbol::start,
						x_pos, y_pos, width, height, content, Page_ID) {

} ;
//*******************************************************************************************************
olSDL::ClsStateMachineStartSymbol::~ClsStateMachineStartSymbol() {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("DEST: olSDL::ClsStateMachineStartSymbol::~ClsStateMachineStartSymbol()") ;
	//DebugPrinter::print("ProcessStartSym-ID: ") ;
	//DebugPrinter::print_iNumber(get_Model_ID()) ;
	#endif
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsStateMachineStartSymbol::get_MoEleType() const {
	return olSDL::ClsMoEleType::StateMachineSymStart ;
} ;

//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsStateMachineStateSymbol::ClsStateMachineStateSymbol(const int Symbol_ID,
					const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsStateMachineSymbol(Symbol_ID, olSDL::ClsStateMachineSymbol::state,
						x_pos, y_pos, width, height, content, Page_ID) {

} ;
//*******************************************************************************************************
olSDL::ClsStateMachineStateSymbol::~ClsStateMachineStateSymbol() {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("DEST: olSDL::ClsStateMachineStateSymbol::~ClsStateMachineStateSymbol()") ;
	//DebugPrinter::print("ProcessStateSym-ID: ") ;
	//DebugPrinter::print_iNumber(get_Model_ID()) ;
	#endif
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsStateMachineStateSymbol::get_MoEleType() const {
	return olSDL::ClsMoEleType::StateMachineSymState ;
} ;

//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsStateMachineOutputSymbol::ClsStateMachineOutputSymbol(const int Symbol_ID,
					const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsStateMachineSymbol(Symbol_ID, olSDL::ClsStateMachineSymbol::output,
						x_pos, y_pos, width, height, content, Page_ID) {

} ;
//*******************************************************************************************************
olSDL::ClsStateMachineOutputSymbol::~ClsStateMachineOutputSymbol() {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("DEST: ClsStateMachineOutputSymbol::~ClsStateMachineOutputSymbol()") ;
	//DebugPrinter::print("ProcessOutputSym-ID: ") ;
	//DebugPrinter::print_iNumber(get_Model_ID()) ;
	#endif
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsStateMachineOutputSymbol::get_MoEleType() const {
	return olSDL::ClsMoEleType::StateMachineSymOutput ;
} ;

//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsStateMachineInputSymbol::ClsStateMachineInputSymbol(const int Symbol_ID,
					const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsStateMachineSymbol(Symbol_ID, olSDL::ClsStateMachineSymbol::input,
						x_pos, y_pos, width, height, content, Page_ID) {

} ;
//*******************************************************************************************************
olSDL::ClsStateMachineInputSymbol::~ClsStateMachineInputSymbol() {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("DEST: ClsStateMachineInputSymbol::~ClsStateMachineInputSymbol()") ;
	//DebugPrinter::print("ProcessInputSym-ID: ") ;
	//DebugPrinter::print_iNumber(get_Model_ID()) ;
	#endif

} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsStateMachineInputSymbol::get_MoEleType() const {
	return olSDL::ClsMoEleType::StateMachineSymInput ;
} ;

//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsStateMachineStopSymbol::ClsStateMachineStopSymbol(const int Symbol_ID,
					const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsStateMachineSymbol(Symbol_ID, olSDL::ClsStateMachineSymbol::stop,
						x_pos, y_pos, width, height, content, Page_ID) {

} ;
//*******************************************************************************************************
olSDL::ClsStateMachineStopSymbol::~ClsStateMachineStopSymbol() {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("DEST: ClsStateMachineStopSymbol::~ClsStateMachineStopSymbol()") ;
	//DebugPrinter::print("ProcessStopSym-ID: ") ;
	//DebugPrinter::print_iNumber(get_Model_ID()) ;
	#endif
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsStateMachineStopSymbol::get_MoEleType() const {
	return olSDL::ClsMoEleType::StateMachineSymStop ;
} ;

//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsStateMachineTaskSymbol::ClsStateMachineTaskSymbol(const int Symbol_ID,
					const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsStateMachineSymbol(Symbol_ID, olSDL::ClsStateMachineSymbol::task,
						x_pos, y_pos, width, height, content, Page_ID) {

} ;
//*******************************************************************************************************
olSDL::ClsStateMachineTaskSymbol::~ClsStateMachineTaskSymbol() {


} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsStateMachineTaskSymbol::get_MoEleType() const {

	return olSDL::ClsMoEleType::StateMachineSymTask ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsStateMachineConditionSymbol::ClsStateMachineConditionSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsStateMachineSymbol(Symbol_ID, olSDL::ClsStateMachineSymbol::condition,
						x_pos, y_pos, width, height, content, Page_ID) {


} ;
//*******************************************************************************************************
olSDL::ClsStateMachineConditionSymbol::~ClsStateMachineConditionSymbol() {


} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsStateMachineConditionSymbol::get_MoEleType() const {

	return olSDL::ClsMoEleType::StateMachineSymCondition ;
} ;
//*******************************************************************************************************
olSDL::ClsStateMachineDecisionSymbol::ClsStateMachineDecisionSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsStateMachineSymbol(Symbol_ID, olSDL::ClsStateMachineSymbol::decision,
						x_pos, y_pos, width, height, content, Page_ID) {


} ;
//*******************************************************************************************************
olSDL::ClsStateMachineDecisionSymbol::~ClsStateMachineDecisionSymbol() {


} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsStateMachineDecisionSymbol::get_MoEleType() const {

	return olSDL::ClsMoEleType::StateMachineSymDecision ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsStateMachineCreateProSymbol::ClsStateMachineCreateProSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsStateMachineSymbol(Symbol_ID, olSDL::ClsStateMachineSymbol::create_pro,
						x_pos, y_pos, width, height, content, Page_ID) {


} ;
//*******************************************************************************************************
olSDL::ClsStateMachineCreateProSymbol::~ClsStateMachineCreateProSymbol() {


} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsStateMachineCreateProSymbol::get_MoEleType() const {

	return olSDL::ClsMoEleType::StateMachineSymCreatePro ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsStateMachineCallProcedureSymbol::ClsStateMachineCallProcedureSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsStateMachineSymbol(Symbol_ID, olSDL::ClsStateMachineSymbol::call_procedure,
						x_pos, y_pos, width, height, content, Page_ID) {


} ;
//*******************************************************************************************************
olSDL::ClsStateMachineCallProcedureSymbol::~ClsStateMachineCallProcedureSymbol() {


} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsStateMachineCallProcedureSymbol::get_MoEleType() const {

	return olSDL::ClsMoEleType::StateMachineSymCreatePro ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsStateMachineProcedureStartStateSymbol::ClsStateMachineProcedureStartStateSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsStateMachineSymbol(Symbol_ID, olSDL::ClsStateMachineSymbol::procedure_start_state,
						x_pos, y_pos, width, height, content, Page_ID) {


} ;
//*******************************************************************************************************
olSDL::ClsStateMachineProcedureStartStateSymbol::~ClsStateMachineProcedureStartStateSymbol() {


} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsStateMachineProcedureStartStateSymbol::get_MoEleType() const {

	return olSDL::ClsMoEleType::StateMachineSymProcedureStartState ;
} ;
//*******************************************************************************************************
//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsStateMachineProcedureReturnSymbol::ClsStateMachineProcedureReturnSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID)
					: ClsStateMachineSymbol(Symbol_ID, olSDL::ClsStateMachineSymbol::procedure_return,
						x_pos, y_pos, width, height, content, Page_ID) {


} ;
//*******************************************************************************************************
olSDL::ClsStateMachineProcedureReturnSymbol::~ClsStateMachineProcedureReturnSymbol() {


} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsStateMachineProcedureReturnSymbol::get_MoEleType() const {

	return olSDL::ClsMoEleType::StateMachineSymProcedureReturn ;
} ;
//*******************************************************************************************************

