
#include "Syms.h"

#include "Helper.h"

//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsTextSym::ClsTextSym(const int Model_ID, const int x_pos, const int y_pos,
				    const int width, const int height, const int Page_ID,
				    const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID)
				    : Symbol (Model_ID, EnumSym::TextSym, x_pos, y_pos, width, height, "", Page_ID,
				    ReferencedDiagramID, ReferencedDiagramFirstPageID) {

} ;
//*******************************************************************************************************
olSDL::ClsTextSym::ClsTextSym(const int Model_ID, const int x_pos, const int y_pos,
		     		    const int width, const int height, const string content, const int Page_ID,
				    const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID)
				    : Symbol (Model_ID, EnumSym::TextSym, x_pos, y_pos, width, height, content, Page_ID,
				    ReferencedDiagramID, ReferencedDiagramFirstPageID) {

} ;
//*******************************************************************************************************
olSDL::ClsTextSym::~ClsTextSym() {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("DEST:    olSDL::ClsTextSym::~ClsTextSym()") ;
	//DebugPrinter::print("TextSym-ID: ") ;
	//DebugPrinter::print_iNumber(get_Model_ID()) ;
	#endif

} ;
//*******************************************************************************************************
bool olSDL::ClsTextSym::is_referencing_Symbol() const {
	return false ;
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsTextSym::get_MoEleType() const {
	return olSDL::ClsMoEleType::TextSym ;
} ;
//*******************************************************************************************************

//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsProInstRefSym::ClsProInstRefSym(const int Model_ID, const int x_pos, const int y_pos,
				    const int width, const int height, const int Page_ID,
				    const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID)
				    : Symbol (Model_ID, olSDL::EnumSym::ProInstRefSym, x_pos, y_pos, width, height, "", Page_ID,
				    ReferencedDiagramID, ReferencedDiagramFirstPageID) {

} ;
//*******************************************************************************************************
olSDL::ClsProInstRefSym::ClsProInstRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     		    const int width, const int height, const string content, const int Page_ID,
				    const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID)
				    : Symbol (Model_ID, olSDL::EnumSym::ProInstRefSym, x_pos, y_pos, width, height, content, Page_ID,
				    ReferencedDiagramID, ReferencedDiagramFirstPageID) {

} ;
//*******************************************************************************************************
olSDL::ClsProInstRefSym::~ClsProInstRefSym() {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("DEST:    olSDL::ClsProInstRefSym::~ClsProInstRefSym()") ;
	//DebugPrinter::print("ProInstRefSym-ID: ") ;
	//DebugPrinter::print_iNumber(get_Model_ID()) ;
	#endif

} ;
//*******************************************************************************************************
bool olSDL::ClsProInstRefSym::is_referencing_Symbol() const {
	return true ;
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsProInstRefSym::get_MoEleType() const {
	return olSDL::ClsMoEleType::ProInstRefSym ;
} ;
//*******************************************************************************************************


//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsProTypeRefSym::ClsProTypeRefSym(const int Model_ID, const int x_pos, const int y_pos,
				    const int width, const int height,  const int Page_ID,
				    const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID)
				    : Symbol (Model_ID, olSDL::EnumSym::ProTypeRefSym, x_pos, y_pos, width, height, "", Page_ID,
				    ReferencedDiagramID, ReferencedDiagramFirstPageID) {

} ;
//*******************************************************************************************************
olSDL::ClsProTypeRefSym::ClsProTypeRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     		    const int width, const int height, const string content, const int Page_ID,
				    const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID)
				    : Symbol (Model_ID, olSDL::EnumSym::ProTypeRefSym, x_pos, y_pos, width, height, content, Page_ID,
				    ReferencedDiagramID, ReferencedDiagramFirstPageID) {

} ;
//*******************************************************************************************************
olSDL::ClsProTypeRefSym::~ClsProTypeRefSym() {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("DEST:    olSDL::ClsProTypeRefSym::~ClsProTypeRefSym()") ;
	//DebugPrinter::print("ProTypeRefSym-ID: ") ;
	//DebugPrinter::print_iNumber(get_Model_ID()) ;
	#endif

} ;
//*******************************************************************************************************
bool olSDL::ClsProTypeRefSym::is_referencing_Symbol() const {
	return false ;
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsProTypeRefSym::get_MoEleType() const {
	return olSDL::ClsMoEleType::ProTypeRefSym ;
} ;
//*******************************************************************************************************

//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsBlkInstRefSym::ClsBlkInstRefSym(const int Model_ID, const int x_pos, const int y_pos,
				    const int width, const int height, const int Page_ID,
				    const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID)
				    : Symbol (Model_ID, olSDL::EnumSym::BlkInstRefSym, x_pos, y_pos, width, height, "", Page_ID,
				    ReferencedDiagramID, ReferencedDiagramFirstPageID) {

} ;
//*******************************************************************************************************
olSDL::ClsBlkInstRefSym::ClsBlkInstRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     		    const int width, const int height, const string content, const int Page_ID,
				    const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID)
				    : Symbol (Model_ID, olSDL::EnumSym::BlkInstRefSym, x_pos, y_pos, width, height, content, Page_ID,
				    ReferencedDiagramID, ReferencedDiagramFirstPageID) {

} ;
//*******************************************************************************************************
olSDL::ClsBlkInstRefSym::~ClsBlkInstRefSym() {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("DEST:    olSDL::ClsBlkInstRefSym::~ClsBlkInstRefSym()") ;
	//DebugPrinter::print("BlkInstRefSym-ID: ") ;
	//DebugPrinter::print_iNumber(get_Model_ID()) ;
	#endif

} ;
//*******************************************************************************************************
bool olSDL::ClsBlkInstRefSym::is_referencing_Symbol() const {
	return true ;
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsBlkInstRefSym::get_MoEleType() const {
	return olSDL::ClsMoEleType::BlkInstRefSym ;
} ;
//*******************************************************************************************************



//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsBlkTypeRefSym::ClsBlkTypeRefSym(const int Model_ID, const int x_pos, const int y_pos,
				    const int width, const int height, const int Page_ID,
				    const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID)
				    : Symbol (Model_ID, olSDL::EnumSym::BlkTypeRefSym, x_pos, y_pos, width, height, "", Page_ID,
				    ReferencedDiagramID, ReferencedDiagramFirstPageID) {

} ;
//*******************************************************************************************************
olSDL::ClsBlkTypeRefSym::ClsBlkTypeRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     		    const int width, const int height, const string content, const int Page_ID,
				    const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID)
				    : Symbol (Model_ID, olSDL::EnumSym::BlkTypeRefSym, x_pos, y_pos, width, height, content, Page_ID,
				    ReferencedDiagramID, ReferencedDiagramFirstPageID) {

} ;
//*******************************************************************************************************
olSDL::ClsBlkTypeRefSym::~ClsBlkTypeRefSym() {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("DEST:    olSDL::ClsBlkTypeRefSym::~ClsBlkTypeRefSym()") ;
	//DebugPrinter::print("BlkTypeRefSym-ID: ") ;
	//DebugPrinter::print_iNumber(get_Model_ID()) ;
	#endif

} ;
//*******************************************************************************************************
bool olSDL::ClsBlkTypeRefSym::is_referencing_Symbol() const {
	return false ;
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsBlkTypeRefSym::get_MoEleType() const {
	return olSDL::ClsMoEleType::BlkTypeRefSym ;
} ;
//*******************************************************************************************************




//*******************************************************************************************************
//*******************************************************************************************************
olSDL::ClsProcedureInstRefSym::ClsProcedureInstRefSym(const int Model_ID, const int x_pos, const int y_pos,
				    const int width, const int height, const int Page_ID,
				    const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID)
				    : Symbol (Model_ID, olSDL::EnumSym::ProcedureInstRefSym, x_pos, y_pos, width, height, "", Page_ID,
				    ReferencedDiagramID, ReferencedDiagramFirstPageID) {

} ;
//*******************************************************************************************************
olSDL::ClsProcedureInstRefSym::ClsProcedureInstRefSym(const int Model_ID, const int x_pos, const int y_pos,
		     		    const int width, const int height, const string content, const int Page_ID,
				    const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID)
				    : Symbol (Model_ID, olSDL::EnumSym::ProcedureInstRefSym, x_pos, y_pos, width, height, content, Page_ID,
				    ReferencedDiagramID, ReferencedDiagramFirstPageID) {

} ;
//*******************************************************************************************************
olSDL::ClsProcedureInstRefSym::~ClsProcedureInstRefSym() {

	#ifdef olSDL_DL_ONE
	//DebugPrinter::print("DEST:    olSDL::ClsProInstRefSym::~ClsProInstRefSym()") ;
	//DebugPrinter::print("ProInstRefSym-ID: ") ;
	//DebugPrinter::print_iNumber(get_Model_ID()) ;
	#endif

} ;
//*******************************************************************************************************
bool olSDL::ClsProcedureInstRefSym::is_referencing_Symbol() const {
	return true ;
} ;
//*******************************************************************************************************
olSDL::ClsMoEleType::e_MoEle olSDL::ClsProcedureInstRefSym::get_MoEleType() const {
	return olSDL::ClsMoEleType::ProcedureInstRefSym ;
} ;
//*******************************************************************************************************



