
#ifndef olSDL_FLOW_LINE_H
#define olSDL_FLOW_LINE_H

#include "PageObject.h"
#include "ObjectWithModel_ID.h"
#include "BasicTypes.h"

#include <list>
#include <string>

namespace olSDL{

	class ClsFlowLine : public ClsPageObject, public ClsObjectWithModel_ID {

	public:
	enum e_FlowLineType {normal, decision} ;

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	e_FlowLineType m_FlowLineType ;

	list<int> m_FlowLineCoords ;

	int m_FlowLineSourceModel_ID ;
	int m_FlowLineDestModel_ID ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsFlowLine(const int FlowLineID, const int Page_ID, const e_FlowLineType FlowLineType, const list<int> & FlowLineCoords,
		const int FlowLineSourceModel_ID, const int FlowLineDestModel_ID) ;

	// Copy

	// Assign

	// Des
	~ClsFlowLine() ;

	//============
	// getter
	e_FlowLineType get_FlowLineType() const ;

	void get_Coords_as_IntList(list<int> & IntList) const ;

	string get_SourceID_as_String() const ;
	string get_DestID_as_String() const ;

	int get_SourceID_as_Int() const ;
	int get_DestID_as_Int() const ;

	//============
	// setter
	void modify_FlowLineCoords(const list<int> & FlowLineCoords) ;

	} ; // class

	//============================================================
	//============================================================

	class ClsNormalFlowLine : public ClsFlowLine {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------

	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsNormalFlowLine(const int FlowLineID, const int Page_ID, const list<int> & FlowLineCoords,
		const int FlowLineSourceModel_ID, const int FlowLineDestModel_ID) ;

	// Copy

	// Assign

	// Des
	~ClsNormalFlowLine() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	//============
	// setter

	} ; // class

	//============================================================
	//============================================================

	class ClsDecisionFlowLine : public ClsFlowLine {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	string m_content ;
	ClsRecPaS m_area ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------

	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsDecisionFlowLine(const int FlowLineID, const int Page_ID, const list<int> & FlowLineCoords,
		const int FlowLineSourceModel_ID, const int FlowLineDestModel_ID, const string & content, const ClsRecPaS & PaS) ;

	// Copy

	// Assign

	// Des
	~ClsDecisionFlowLine() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	ClsRecPaS get_PaS() const ;
	list<int> get_PaS_as_IntList() const ;
	string get_Content() const ;

	//============
	// setter
	void modify_DecisionFlowLinePaS(const ClsRecPaS & PaS) ;
	void modify_DecisionFlowLineContent(const string Content) ;


	} ; // class ClsDecisionFlowLine

} // END: namespace ol_SDL


#endif
