#ifndef olSDL_MO_ACCESS_INFO_H
#define olSDL_MO_ACCESS_INFO_H

using namespace std;

#include "MyEnums.h"
#include <string>

namespace olSDL{


	// ===================================================================
	// ===================================================================

	class ClsMoAccess_ErrorReporter {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	public:
	enum e_ErrorType {none,
		get_diagram_not_found_in_map, get_object_is_not_diagram, get_wrong_symbol_type, get_channel_unknown,
		get_flowline_unknown, get_page_unknown, get_object_unknown, get_unconsidered_diagram_type,
		insert_object_is_not_diagram, insert_diagram_not_found_in_map, insert_unconsidered_symbol, insert_wrong_symbol, insert_no_diagram,
		insert_page_unknown, insert_chan_source_unknown, insert_chan_dest_unknown, insert_ProcDiaSym_unknown,
		insert_flowline_source_unknown, insert_flowline_dest_unknown,
		page_get_predecessor_unknown, page_get_ancestor_unknown, page_get_page_unknown, page_insert_predecessor_unknown,
		page_insert_ID_exists, page_insert_ancestor_unknown, page_delete_one_page_needed,
		page_modify_unknown_page,
		modify_object_unknown, modify_object_wrong_type, modify_object_not_found_in_map, modify_wrong_page_coords,
		delete_object_unknown, delete_object_wrong_type, delete_object_not_found_in_map, delete_unconsidered_diagram_type,
		get_enclosing_diagram_object_not_found_in_map, get_enclosing_diagram_object_wrong_type, access_type_unknown} ;

	private:
		e_ErrorType m_ErrorType ;

	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsMoAccess_ErrorReporter(e_ErrorType ErrorType) ;

	//============
	// getter
	e_ErrorType get_ErrorType() const ;
	string get_ErrorMessage() const ;

	} ;

	// ===================================================================
	// ===================================================================


	class ClsMoAccessInfo {

	//-------------------------------------------------------
	// enumerations
	//-------------------------------------------------------
	public:

	enum e_ResultType {none,
	get_OK,
	get_diagram_not_found_in_map,
	get_object_is_not_diagram,
	get_wrong_symbol_type,
	get_channel_unknown,
	get_flowline_unknown,
	get_page_unknown,
	get_object_unknown,
	get_unconsidered_diagram_type,
	insert_OK,
	insert_object_is_not_diagram,
	insert_diagram_not_found_in_map,
	insert_unconsidered_symbol,
	insert_wrong_symbol,
	insert_no_diagram,
	insert_page_unknown,
	insert_chan_source_unknown,
	insert_chan_dest_unknown,
	insert_ProcDiaSym_unknown,
	insert_flowline_source_unknown,
	insert_flowline_dest_unknown,
	page_get_OK,
	page_get_predecessor_unknown,
	page_get_ancestor_unknown,
	page_get_page_unknown,
	page_insert_OK,
	page_insert_predecessor_unknown,
	page_insert_ID_exists,
	page_insert_ancestor_unknown,
	page_delete_one_page_needed,
	page_delete_OK,
	page_modify_unknown_page,
	page_modify_OK,
	modify_OK,
	modify_object_unknown,
	modify_object_wrong_type,
	modify_object_not_found_in_map,
	modify_wrong_page_coords,
	delete_OK,
	delete_object_unknown,
	delete_object_wrong_type,
	delete_object_not_found_in_map,
	delete_unconsidered_diagram_type,
	get_enclosing_diagram_OK,
	get_enclosing_diagram_object_not_found_in_map,
	get_enclosing_diagram_object_wrong_type,
	access_type_unknown} ;


	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	e_ResultType m_Result ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------

	//============
	//Constructor, Copy-Constructor, Assign-Op, ...

	public:
	ClsMoAccessInfo( ) ;

	//============
	//setter
	void set_Info(const e_ResultType Result) ;

	//============
	//getter
	e_ResultType get_Info() const ;
	char* get_Info_Message() const ;


	} ; // class ClsMoAccessInfo

} // END: namespace ol_SDL


#endif
