
#ifndef olSDL_PAGE_H
#define olSDL_PAGE_H

#include "BasicTypes.h"
#include "ObjectWithModel_ID.h"
#include "MoAccessInfo.h"

namespace olSDL {

	class ClsPage : public ClsObjectWithModel_ID{

		class ClsPageFrame {
		//-------------------------------------------------------
		// member variable
		//-------------------------------------------------------
		private :
		ClsRecPaS * m_pArea ;
		//-------------------------------------------------------
		//methods
		//-------------------------------------------------------
		public:
		//============
		//Constructor, Copy-Constructor, Assign-Op
		ClsPageFrame(const int x_left_up, const int y_left_up, const int width, const int height) ;
		ClsPageFrame() ;
		// Copy
		ClsPageFrame(const ClsPageFrame & PageFrame) ;
		// Assign
		ClsPageFrame& operator=(const ClsPageFrame & PageFrame) ;
		// Des
		~ClsPageFrame() ;

		//============
		// setter
		void modify_PaS(const int x_left_up, const int y_left_up, const int FrameWidth, const int FrameHeight) ;

		//============
		// getter
		ClsRecPaS get_PaS() const ;

		} ; // class ClsPageFrame

	//-------------------------------------------------------
	// defaults
	//-------------------------------------------------------
	static const int PAGEWIDTH ;
	static const int PAGEHEIGHT ;
	static const int FRAME_PERCENT ;

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	int m_PageWidth ;
	int m_PageHeight ;
	ClsPageFrame m_Frame ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op
	ClsPage(const int Page_ID) ;
	~ClsPage( ) ;

	//============
	// getter
	int get_PageWidth( ) const ;
	int get_PageHeight( ) const  ;
	void get_FramePaS(ClsRecPaS & PaS) const ;

	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	//============
	// setter
	void modify_PageWidth(const int PageWidth, ClsMoAccessInfo & Info) ;
	void modify_PageHeight(const int PageHeight, ClsMoAccessInfo & Info) ;

	void modify_FramePaS(const int x_left_up, const int y_left_up, const int FrameWidth, const int FrameHeight, ClsMoAccessInfo & Info) ;

	} ; //END: class ClsPage

	//=============================================================================
	// function object for use with "find_if" from <algorithm>

	class PageHasID {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	int m_ID ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------

	//============
	//Constructor, Copy-Constructor, Assign-Op
	public:
	PageHasID(const int ID): m_ID(ID) {}

	bool operator() (const ClsPage & p) { return (p.get_Model_ID() == m_ID) ;} ;

	}; //class PageHasID

} // END: namespace ol_SDL


#endif
