
#ifndef olSDL_PAGE_MANAGER_H
#define olSDL_PAGE_MANAGER_H

#include <list>
#include "Page.h"
#include "MoAccessInfo.h"

namespace olSDL{

	class ClsPageManager {

	typedef list<ClsPage> type_PageContainer ;

	public:
	enum e_PageIndex {first, middle, last} ;

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	type_PageContainer m_Pages ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op
	ClsPageManager(const int FirstPage_ID) ;

	//============
	// setter
	void modify_PageWidth(const int Page_ID, const int PageWidth, ClsMoAccessInfo & Info) ;
	void modify_PageHeight(const int Page_ID, const int PageHeight, ClsMoAccessInfo & Info) ;

	void modify_PageFramePaS(const int Page_ID, const int x_left_up, const int y_left_up, const int FrameWidth, const int FrameHeight, ClsMoAccessInfo & Info) ;

	//============
	// getter
	int get_NumberOfPages() const ;
	bool Page_exists(const int Page_ID) const ;

	int get_PageIndex(const int Page_ID, ClsMoAccessInfo & Info) const ;
	void get_PageSize(const int Page_ID, int & PageWidth, int & PageHeight, ClsMoAccessInfo & Info) const  ;
	void get_FramePaS(const int Page_ID, ClsRecPaS & PaS, ClsMoAccessInfo & Info) const ;

	int get_NextPageID(const int PredecessorPage_ID, e_PageIndex & PageIndex, ClsMoAccessInfo & Info) const ;
	int get_PreviousPageID(const int AncestorPage_ID, e_PageIndex & PageIndex, ClsMoAccessInfo & Info) const ;
	int get_FirstPageID(ClsMoAccessInfo & Info) const ;
	int get_LastPageID(ClsMoAccessInfo & Info) const ;

	void get_IDsOfPages(list<int> & IDsOfPages) const ;

	//============
	void add_NewPage_after(const int NewPage_ID, const int PredecessorPage_ID, ClsMoAccessInfo & Info) ;
	void delete_Page(const int Page_ID, ClsMoAccessInfo & Info) ;

	} ; // class ClsPageManager

} // END: namespace ol_SDL


#endif
