#ifndef olSDL_PROCESS_DIAGRAM_SYMBOL_H
#define olSDL_PROCESS_DIAGRAM_SYMBOL_H

#include <string>

#include "BasicTypes.h"
#include "PageObject.h"
#include "ObjectWithModel_ID.h"

namespace olSDL{

	class ClsStateMachineSymbol : public ClsPageObject, public ClsObjectWithModel_ID, public ClsRecPaS {

	public:
	enum e_StateMachineSymbolType {none, start, state, output, input, stop, task, condition, decision, create_pro, call_procedure, procedure_start_state, procedure_return} ;

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	string m_content ;
	e_StateMachineSymbolType m_SymbolType ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineSymbol(const int Symbol_ID, const e_StateMachineSymbolType SymbolType,
		   			const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Copy

	// Assign

	// Des
	~ClsStateMachineSymbol() ;

	//============
	bool operator==(const ClsStateMachineSymbol & s) const ;

	//============
	// getter
	e_StateMachineSymbolType get_SymbolType( ) const ;

	string get_content( ) const ;

	//============
	// setter
	void modify_Content(const string Content) ;

	} ; // class

	//========================================================================================
	//========================================================================================
	class ClsStateMachineStartSymbol : public ClsStateMachineSymbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineStartSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Des
	~ClsStateMachineStartSymbol() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsStateMachineStartSymbol
	//========================================================================================
	//========================================================================================
	class ClsStateMachineStateSymbol : public ClsStateMachineSymbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineStateSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Des
	~ClsStateMachineStateSymbol() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsStateMachineStateSymbol
	//========================================================================================
	//========================================================================================
	class ClsStateMachineOutputSymbol : public ClsStateMachineSymbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineOutputSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Des
	~ClsStateMachineOutputSymbol() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsStateMachineOutputSymbol
	//========================================================================================
	//========================================================================================
	class ClsStateMachineInputSymbol : public ClsStateMachineSymbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineInputSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Des
	~ClsStateMachineInputSymbol() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsStateMachineInputSymbol
	//========================================================================================
	//========================================================================================
	class ClsStateMachineStopSymbol : public ClsStateMachineSymbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineStopSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Des
	~ClsStateMachineStopSymbol() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsStateMachineStopSymbol

	//========================================================================================
	//========================================================================================
	class ClsStateMachineTaskSymbol : public ClsStateMachineSymbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineTaskSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Des
	~ClsStateMachineTaskSymbol() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsStateMachineTaskSymbol


	//========================================================================================
	//========================================================================================
	class ClsStateMachineConditionSymbol : public ClsStateMachineSymbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineConditionSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Des
	~ClsStateMachineConditionSymbol() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsStateMachineConditionSymbol


	//========================================================================================
	//========================================================================================
	class ClsStateMachineDecisionSymbol : public ClsStateMachineSymbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineDecisionSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Des
	~ClsStateMachineDecisionSymbol() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsStateMachineDecisionSymbol


	//========================================================================================
	//========================================================================================
	class ClsStateMachineCreateProSymbol : public ClsStateMachineSymbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineCreateProSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Des
	~ClsStateMachineCreateProSymbol() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsStateMachineCreateProSymbol

	//========================================================================================
	//========================================================================================
	class ClsStateMachineCallProcedureSymbol : public ClsStateMachineSymbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineCallProcedureSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Des
	~ClsStateMachineCallProcedureSymbol() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsStateMachineCallProcedureSymbol

	//========================================================================================
	//========================================================================================
	class ClsStateMachineProcedureStartStateSymbol : public ClsStateMachineSymbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineProcedureStartStateSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Des
	~ClsStateMachineProcedureStartStateSymbol() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsStateMachineProcedureStartStateSymbol

	//========================================================================================
	//========================================================================================
	class ClsStateMachineProcedureReturnSymbol : public ClsStateMachineSymbol {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsStateMachineProcedureReturnSymbol(const int Symbol_ID, const int x_pos, const int y_pos, const int width, const int height,
		   			const string content, const int Page_ID) ;

	// Des
	~ClsStateMachineProcedureReturnSymbol() ;

	//============
	// getter
	olSDL::ClsMoEleType::e_MoEle get_MoEleType() const ;

	} ; // class ClsStateMachineProcedureReturnSymbol

} // END: namespace ol_SDL


#endif
