
#ifndef olSDL_SYMBOL_H
#define olSDL_SYMBOL_H

#include <string>

#include "BasicTypes.h"
#include "MyEnums.h"
#include "PageObject.h"
#include "ObjectWithModel_ID.h"


namespace olSDL{

	class Diagram ;

	class Symbol : public ClsPageObject, public ClsObjectWithModel_ID, public ClsRecPaS {

	public:

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	string m_content ;
	EnumSym::Type m_SymbolType ;

	Diagram * m_pReferencedDiagram ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:

	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	Symbol(const int Symbol_ID,
		   const EnumSym::Type SymbolType,
		   const int x_pos, const int y_pos,
		   const int width, const int height,
		   const string content,
		   const int Page_ID,
		   const int ReferencedDiagramID, const int ReferencedDiagramFirstPageID) ;

	// Des
	~Symbol() ;

	//============
	bool operator==(const Symbol & s) const ;

	//============
	// setter
	void modify_Content(const string Content) ;

	//============
	// getter

	EnumSym::Type get_SymbolType( ) const ;

	virtual bool is_referencing_Symbol() const =0 ;
	Diagram * get_referenced_Diagram() const ;
	int get_referenced_Diagram_Model_ID() const ;

	string get_content( ) const ;

	} ; // class Symbol

} // END: namespace ol_SDL

#endif
