
#ifndef olSDL_XML_WRITER_H
#define olSDL_XML_WRITER_H

#include <string>
#include <fstream>

#include "XML_Basic.h"
#include "ProcessDia.h"
#include "SysDia.h"
#include "ProcedureDia.h"

namespace olSDL {

	class ClsXML_Writer : public ClsXML_Basic {

	//-------------------------------------------------------
	// member variable
	//-------------------------------------------------------
	private:
	static const string TAG_PROLOG ;

	string m_FileName ;
	ofstream * m_pOutStream ;

	//-------------------------------------------------------
	//methods
	//-------------------------------------------------------
	public:
	//============
	//Constructor, Copy-Constructor, Assign-Op, ...
	ClsXML_Writer() ;

	// Copy

	// Assign

	// Des
	~ClsXML_Writer() ;

	//============
	bool write_SysSpec(const ClsSysDia * pSysDia, const string & FileName) ;

	//============
	// getter

	//============
	// setter

	// write methods for different Diagram Types
	private:

	void write_ProDia(const ClsProcessDia * pProcessDia) const ;
	void write_HL_InstDia(const Diagram * pHL_InstDiagram) const ;
	void write_ProcedureDia(const ClsProcedureDia * pProcedureDia) const ;

	void write_Dia(const Diagram * pDiagram) const ;

	void write_Page(const Diagram * pDia, const int PageID) const ;
	void write_PageFrame(const Diagram * pDia, const int PageID) const ;

	void write_PaS(const int x_left_up, const int y_left_up, const int width, const int height) const ;

	void write_RecSym(const Symbol * pSymbol) const ;
	void write_Channel(const ClsChannel * pChannel) const ;
	void write_ChanComp(const ClsChanComp * pChanComp) const ;
	void write_StateMaSym(const ClsStateMachineSymbol * pStateMachineSymbol) const ;
	void write_FlowLine(const ClsFlowLine * pFlowLine) const ;

	// helper and converter
	string create_StartTagFromName(const string & Name) const ;
	string create_EndTagFromName(const string & Name) const ;

	void add_AttrToTag(string & Tag, const string & AttrName, const string & AttrValue) const ;
	void add_AttrToTag(string & Tag, const string & AttrName, const int & AttrValue) const ;

	void write_Element(const string & TagName, const int Value, const bool b_WithNewline=true) const ;
	void write_Element(const string & TagName, const string & Content, const bool b_WithNewline=true) const ;


	} ; // class


} // END: namespace ol_SDL


#endif
