
package provide olSDL_BlkDiaView 1

namespace eval olSDL_BlkDiaView {
	namespace eval EH {
	}
}
########################################################################################################
# Konstruktor fr System Diagram Views
proc ::olSDL_BlkDiaView::create {ViewID TempArrName TempCanInfoArr CanvasPathName Dia_Model_ID PageID ButBoxPathName}  {

	upvar #0 ::olSDL_MAR::arr_MAR MAR

	#########
	# create toolbar

	create_Toolbar $ButBoxPathName $TempArrName $TempCanInfoArr

	# END : create toolbar
	#########

	#########
	# get page size

	get_PageSize_from_Model $Dia_Model_ID $PageID
	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set PageHeight $MAR(PageHeight)
	set PageWidth $MAR(PageWidth)

	# END: get page size
	#########

	########
	# setup Canvas Info array

	variable $TempCanInfoArr
	array set $TempCanInfoArr { }

	_init_Canvas_Info_Arr $TempCanInfoArr

	set ${TempCanInfoArr}(state) normal
	set ${TempCanInfoArr}(PageID) $PageID
	set ${TempCanInfoArr}(PageWidth) $PageWidth
	set ${TempCanInfoArr}(PageHeight) $PageHeight
	set ${TempCanInfoArr}(Dia_Model_ID) $Dia_Model_ID
	set ${TempCanInfoArr}(ViewID) $ViewID
	set ${TempCanInfoArr}(CanvasPathName) $CanvasPathName
	set ${TempCanInfoArr}(DiaType) BlkDia

	# END: setup Canvas Info array
	########

	upvar #0 $TempCanInfoArr CanInfo

	########
	# setup scrollregion

	::olSDL_Views::set_PageScrollregion $CanvasPathName $PageWidth $PageHeight

	# END: setup scrollregion
	########

	########
	# setup stacking order

	::olSDL_Views::AllViews::setup_stacking_order $CanvasPathName

	# END: setup stacking order
	########

	########
	# setup PageFrame Environment

	set ${TempCanInfoArr}(EnvironmentRectangle) [$CanvasPathName create rectangle 0 0 $PageWidth $PageHeight -tag EnvironmentRectangle -width 0]
	$CanvasPathName lower $CanInfo(EnvironmentRectangle) stack_EnvironmentRectangle

	# END: setup PageFrame Environment
	########

	variable $TempArrName
	array set $TempArrName { }

	# Frame and Header
	::olSDL_Views::get_and_draw_PageFrame_and_PageHeader $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID $PageID

	foreach symtype $::olSDL_Views::RecSym::RecSym {
	  ::olSDL_Views::get_and_draw_Symbols $symtype $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID $PageID
	}

	# Channels
	::olSDL_Views::get_and_draw_Channels $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID $PageID

	################
	# setup PageFrame Background

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $CanInfo(PageFramePaS) t_x1 t_y1 t_x2 t_y2
	set CanInfo(BackgroundRectangle) [$CanvasPathName create rectangle $t_x1 $t_y1 $t_x2 $t_y2 -tag BackgroundRectangle -width 0]

	$CanvasPathName lower $CanInfo(BackgroundRectangle) stack_BackgroundRectangle

	# END : setup PageFrame Background
	################

	#########
	# create Canvas Pop-Up Menus

	::olSDL_Views::AllViews::create_PopUpMenus $TempArrName $TempCanInfoArr

	# END : create Canvas Pop-Up Menus
	#########

	################
	# setup Event handling (tags)

	setup_EventHandling $TempArrName $TempCanInfoArr

	# END: setup Event handling (tags)
	################

	################
	# create bindings

	setup_Bindings $TempArrName $TempCanInfoArr

	# END : create bindings
	################

	################
	#
	set_canvas_state $TempArrName $TempCanInfoArr normal dummy
	#
	################
}
########################################################################################################
proc	::olSDL_BlkDiaView::_init_Canvas_Info_Arr {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanInfo(allObj) { }
	set CanInfo(selObj) { }

	set CanInfo(Place_TypeOfNewRecObject) ""
	set CanInfo(Place_NewRec_x) ""
	set CanInfo(Place_NewRec_y) ""
	set CanInfo(Place_NewRec_FrameID) ""

	set CanInfo(Resize_ActionType) ""
	set CanInfo(Resize_PointParentID) ""
	set CanInfo(Resize_FrameID) ""

	set CanInfo(Move_start_x) ""
	set CanInfo(Move_start_y) ""
	set CanInfo(Move_MovedObjID) ""
	set CanInfo(Move_Obj_moved) ""
	set CanInfo(Move_MoveFrameID) ""

	set CanInfo(BackgroundRectangle) ""

	set CanInfo(connect_Source_ID) ""
	set CanInfo(connect_SourcePaS) ""
	set CanInfo(connect_afterSource) false
	set CanInfo(connect_Source_x) ""
	set CanInfo(connect_Source_y) ""
 	set CanInfo(connect_afterFirstPart) false
	set CanInfo(connect_Channel_ID) ""
	set CanInfo(connect_ChannelCoords) { }
}
########################################################################################################
proc ::olSDL_BlkDiaView::setup_Bindings {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	foreach element $CanInfo(allObj) {
		if { [::olSDL_Views::is_RecSym $ObjArr($element,Type)] } {
			setup_Bindings_for_RecSym $CanvasPathName $element
		}
	}
}
########################################################################################################
proc ::olSDL_BlkDiaView::setup_EventHandling {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	#########
	# Event Handler for RecSym

	set Callback "::olSDL_Views::RecSym::ClickOnRecSymbol $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::RecSym::DoubleClickOnRecSymbol $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Double-1> "$Callback"

	set Callback "::olSDL_Views::RecSym::MidClickOnRecSymbol $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Button-2> "$Callback"

	set Callback "::olSDL_Views::RecSym::EnterRecSymbol $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Enter> "$Callback"

	set Callback "::olSDL_Views::RecSym::LeaveRecSymbol $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Leave> "$Callback"

	set Callback "::olSDL_Views::RecSym::show_PopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Button-3> "$Callback %x %y"

	# END : Event Handler for RecSym
	#########

	#########
	# Event Handler for moving RecSymbols

	set Callback "::olSDL_Views::MoveRecSym::StartMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableRecSym <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::MoveRecSym::ProcessMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableRecSym <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::MoveRecSym::EndMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableRecSym <ButtonRelease-1> "$Callback %x %y"

	# Event Handler for moving RecSymbols
	#########

	#########
	# Event Handler for Resize Points of RecSymbols

	set Callback "::olSDL_Views::RecObjRP::RP_Enter $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <Enter> "$Callback"

	set Callback "::olSDL_Views::RecObjRP::RP_Leave $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <Leave> "$Callback"

	## Resizing
	set Callback "::olSDL_Views::ResizeRecSym::RP_StartResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::ResizeRecSym::RP_ProcessResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::ResizeRecSym::RP_EndResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <ButtonRelease-1> "$Callback"

	# END: Event Handler for Resize Points of RecSymbols
	#########

	#########
	# Event Handler for Background

	set Callback "::olSDL_BlkDiaViewBack::StartBackground $ObjArrName $CanInfoArr"
	$CanvasPathName bind BackgroundRectangle <Button-1> "$Callback %x %y"

	set Callback "::olSDL_BlkDiaViewBack::ProcessBackground $ObjArrName $CanInfoArr"
	$CanvasPathName bind BackgroundRectangle <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_BlkDiaViewBack::EndBackground $ObjArrName $CanInfoArr"
	$CanvasPathName bind BackgroundRectangle <ButtonRelease-1> "$Callback %x %y"

	# Event Handler for Background
	#########

	#########
	# Event Handler for Environment

	set Callback "::olSDL_Views::Env::ClickOnEnvironment $ObjArrName $CanInfoArr"
	$CanvasPathName bind EnvironmentRectangle <Button-1> "$Callback %x %y"

	# Event Handler for Environment
	#########

	#########
	# Event Handler for Channels

	set Callback "::olSDL_Views::Channel::ClickOnChannel $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableChannel <Button-1> "$Callback"

	set Callback "::olSDL_Views::Channel::ClickOnChannelArrow $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableChannelArrow <Button-1> "$Callback"


	set Callback "::olSDL_Views::Channel::show_PopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableChannel <Button-3> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::show_PopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableChannelArrow <Button-3> "$Callback %x %y"


	set Callback "::olSDL_Views::Channel::StartChanMP $ObjArrName $CanInfoArr"
	$CanvasPathName bind ChanMP <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::ProcessChanMP $ObjArrName $CanInfoArr"
	$CanvasPathName bind ChanMP <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::EndChanMP $ObjArrName $CanInfoArr"
	$CanvasPathName bind ChanMP <ButtonRelease-1> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::show_MP_PopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind ChanMP <ButtonRelease-3> "$Callback %x %y"

	# END: Event Handler for Channels
	#########

	#########
	# Event Handler for Channels Comp

	set Callback "::olSDL_Views::Channel::ClickOnRecChanComp $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRecChanComp <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::EnterRecChanComp $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRecChanComp <Enter> "$Callback"

	set Callback "::olSDL_Views::Channel::LeaveRecChanComp $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRecChanComp <Leave> "$Callback"

	set Callback "::olSDL_Views::Channel::show_CompPopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRecChanComp <Button-3> "$Callback %x %y"

	# END: Event Handler for Channels Comp
	#########

	#########
	# Event Handler for moving Channels Comp

	set Callback "::olSDL_Views::Channel::StartChanCompMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind movableChanComp <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::ProcessChanCompMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind movableChanComp <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::EndChanCompMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind movableChanComp <ButtonRelease-1> "$Callback %x %y"

	# Event Handler for moving Channels Comp
	#########

	#########
	# Event Handler for Resize Points of Channels Comp

	set Callback "::olSDL_Views::RecObjRP::RP_Enter $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecChanCompRP <Enter> "$Callback"

	set Callback "::olSDL_Views::RecObjRP::RP_Leave $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecChanCompRP <Leave> "$Callback"


	## Resizing
	set Callback "::olSDL_Views::Channel::RP_StartResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecChanCompRP <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::RP_ProcessResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecChanCompRP <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::RP_EndResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecChanCompRP <ButtonRelease-1> "$Callback"

	# Event Handler for Resize Points of Channels Comp
	#########
}
########################################################################################################
# method for creating toolbar
########################################################################################################
proc ::olSDL_BlkDiaView::create_Toolbar {ButBoxPathName ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set ButBox $ButBoxPathName

	####
	set Callback "::olSDL_BlkDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr normal dummy"
	set SelectionArrowImage ${olSDL_AppVar::MyImagesPath}/olSDL_SelectionArrow
	set CanInfo(tbb,SelectionArrow) [$ButBox add -image [Bitmap::get $SelectionArrowImage] \
 							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
  							-helptext "Selection" -command "$Callback"]

	####
	set Callback "::olSDL_BlkDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr connection dummy"
	set ConnectionImage ${olSDL_AppVar::MyImagesPath}/olSDL_ChannelBoth
	set CanInfo(tbb,Connection) [$ButBox add -image [Bitmap::get $ConnectionImage] \
 							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
  							-helptext "Connection" -command "$Callback"]

	####
	set Callback "::olSDL_BlkDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_new_rec_obj TextSym"
	set TextSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_TextSym_neu
	set CanInfo(tbb,TextSym) [$ButBox add -image [Bitmap::get $TextSymImage] \
 						-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
  						-helptext "Text" -command "$Callback"]

	####
	set Callback "::olSDL_BlkDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_new_rec_obj ProInstRefSym"
	set ProInstRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_ProInstRefSym
	set CanInfo(tbb,ProInstRefSym) [$ButBox add -image [Bitmap::get $ProInstRefSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Process" -command "$Callback"]

	####
	set Callback "::olSDL_BlkDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_new_rec_obj ProTypeRefSym"
	set ProTypeRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_ProTypeRefSym
	set CanInfo(tbb,ProTypeRefSym) [$ButBox add -image [Bitmap::get $ProTypeRefSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "ProTypeRef" -command "$Callback"]

	####
	set Callback "::olSDL_BlkDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_new_rec_obj BlkInstRefSym"
	set BlkInstRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_BlkInstRefSym
	set CanInfo(tbb,BlkInstRefSym) [$ButBox add -image [Bitmap::get $BlkInstRefSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Block" -command "$Callback"]

	####
	set Callback "::olSDL_BlkDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_new_rec_obj BlkTypeRefSym"
	set BlkTypeRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_BlkTypeRefSym
	set CanInfo(tbb,BlkTypeRefSym) [$ButBox add -image [Bitmap::get $BlkTypeRefSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "BlkTypeRef" -command "$Callback"]

	####
	set Callback "::olSDL_BlkDiaView::delete_Object $ObjArrName $CanInfoArr"
	set DeleteRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_DeleteRecSymSign
	$ButBox add -image [Bitmap::get $DeleteRefSymImage] \
   		-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Delete" -command "$Callback"

	####
	set Callback "::olSDL_BlkDiaView::Diagram_up $ObjArrName $CanInfoArr"
	set DeleteRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_DiagramUp
	$ButBox add -image [Bitmap::get $DeleteRefSymImage] \
   		-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Diagram up" -command "$Callback"

	pack $ButBox -side top -anchor n
}
########################################################################################################
proc ::olSDL_BlkDiaView::setup_Bindings_for_RecSym {CanvasPathName CanObjID} {

	$CanvasPathName itemconfigure $CanObjID -tag {selectableRec moveableRecSym}
}
########################################################################################################
proc ::olSDL_BlkDiaView::set_canvas_state {ObjArrName CanInfoArr State ObjType} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	if { $CanInfo(state) == "connection" }  {
		::olSDL_Views::Channel::delete_ConnectionHelperObjects $CanInfoArr
	}

	set CanInfo(state) $State
	set CanInfo(Place_TypeOfNewRecObject) $ObjType

	###########

	$CanInfo(tbb,SelectionArrow) configure -relief raised
	$CanInfo(tbb,TextSym) configure -relief raised
	$CanInfo(tbb,ProInstRefSym) configure -relief raised
	$CanInfo(tbb,ProTypeRefSym) configure -relief raised
	$CanInfo(tbb,BlkInstRefSym) configure -relief raised
	$CanInfo(tbb,BlkTypeRefSym) configure -relief raised
	$CanInfo(tbb,Connection) configure -relief raised

	###########

	if { $State == "normal" } {
		$CanInfo(tbb,SelectionArrow) configure -relief sunken
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
		return
	}

	if { $State == "single_obj_selected" } {
		$CanInfo(tbb,SelectionArrow) configure -relief sunken
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
		return
	}

	if { $State == "connection" } {
		$CanInfo(tbb,Connection) configure -relief sunken
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
		return
	}

	if { [string compare $State "place_new_rec_obj"] == 0 } {

		switch -exact $ObjType {
			TextSym {
				$CanInfo(tbb,TextSym) configure -relief sunken
				return
			}
			ProInstRefSym {
				$CanInfo(tbb,ProInstRefSym) configure -relief sunken
				return
			}
			ProTypeRefSym {
				$CanInfo(tbb,ProTypeRefSym) configure -relief sunken
				return
			}
			BlkInstRefSym {
				$CanInfo(tbb,BlkInstRefSym) configure -relief sunken
				return
			}
			BlkTypeRefSym {
				$CanInfo(tbb,BlkTypeRefSym) configure -relief sunken
				return
			}
			default {
				error "unknown canvas state1"
			}
		}
		# switch -exact $ObjType
	}
	# if {$State ==place_new_rec_ob}

	error "unknown canvas state2"
}
##############################################################################
proc ::olSDL_BlkDiaView::Diagram_up {ObjArrName CanInfoArr } {

	::olSDL_Views::ViewsManager::All_Diagram_up $ObjArrName $CanInfoArr
	
}
##############################################################################
proc ::olSDL_BlkDiaView::delete_Object {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	foreach selectedObj $CanInfo(selObj) {

		set AllTags [$CanvasPathName gettags $selectedObj]

		if { [lsearch -exact $AllTags selectableRec] != -1 } {

			###################
			# delete RecSyms
			###################

			###################
			#update SDL-Tree

			if { [ ::olSDL_Views::is_ReferencingSymbol $ObjArr($selectedObj,Type)] } {
				::olSDL_ViewsTree::ReferencingSymbolDeleted $ObjArr($selectedObj,RefDia_Model_ID)
			}

			#update SDL-Tree
			###################

			# delete Resize Points
			::olSDL_ViewsDrawMethods::delete_RecSym_RP_from_Canvas $ObjArrName $CanInfoArr $selectedObj

			::olSDL_Views::RecSym::delete_RecSym_from_T_M_C $ObjArrName $CanInfoArr $selectedObj

			###################
			# delete all neighbouring channels

			set ConnectedChannels [::olSDL_Views::RecSym::get_connected_Channels $ObjArrName $CanInfoArr $selectedObj]

			foreach ConChan $ConnectedChannels {

				::olSDL_Views::Channel::delete_Chan_and_all_Comp_from_T_M_C $ObjArrName $CanInfoArr $ConChan

			}
			# END: delete all neighbouring channels
			###################

		} elseif { ([lsearch -exact $AllTags selectableChannel] != -1) } {

			###################
			# delete Channel
			###################

			# delete MP
			::olSDL_ViewsDrawMethods::delete_Channel_MP_from_Canvas $ObjArrName $CanInfoArr $selectedObj

			::olSDL_Views::Channel::delete_Chan_and_all_Comp_from_T_M_C $ObjArrName $CanInfoArr $selectedObj

		}

	}
	# foreach selectedObj $CanInfo(selObj)

	set_canvas_state $ObjArrName $CanInfoArr normal dummy
}
##############################################################################
proc ::olSDL_BlkDiaView::delete_all_Selections {ObjArrName CanInfoArr} {

}
########################################################################################################
proc ::olSDL_BlkDiaView::EH::set_canvas_state {ObjArrName CanInfoArr State ObjType} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	::olSDL_Views::AllViews::delete_all_Selections $ObjArrName $CanInfoArr

	::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr $State $ObjType
}
########################################################################################################

