package provide olSDL_ViewsChan 1

namespace eval olSDL_Views {
	namespace eval Channel {
	}
}

##############################################################################
proc ::olSDL_Views::cut_Text_for_ChanConMenu {in_Text} {

	set temp_out_Text [string range $in_Text 0 10]

	set NewLineIndex [string first "\n" $temp_out_Text]

	if { $NewLineIndex == -1 } {
		return $temp_out_Text
	} else {
		return [string range $temp_out_Text 0 [expr $NewLineIndex -1]]
	}
}
##############################################################################
proc ::olSDL_Views::_get_Index_ClosestChannelPart {ObjArrName CanInfoArr Coords x y} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	set cntMP [expr int( ([llength $Coords]-2) / 2) ]

	for {set i 0} { $i < $cntMP} {incr i} {

		set temp_index [expr $i *2]

		set temp_x1 [lindex $Coords $temp_index]
		set temp_y1 [lindex $Coords [expr $temp_index + 1]]

		set temp_x2 [lindex $Coords [expr $temp_index + 2]]
		set temp_y2 [lindex $Coords [expr $temp_index + 3]]

		$CanvasPathName create line $temp_x1 $temp_y1 $temp_x2 $temp_y2 -tag "dummy_temp_line dummy_temp_line_index$i"

	}

	$CanvasPathName lower dummy_temp_line

	$CanvasPathName create line $x $y $x $y -tag dummy_temp_point

	$CanvasPathName raise dummy_temp_point dummy_temp_line

	set Closest [$CanvasPathName find closest $x $y 1 dummy_temp_point]

	set AllTags [$CanvasPathName gettags $Closest]

	set ID_Tag_Index [lsearch -glob $AllTags dummy_temp_line_index*]

	set str_Index [lindex $AllTags $ID_Tag_Index]

	set Index [string range $str_Index 21 end]

	#### TEST

	# $CanvasPathName raise $Closest
	# $CanvasPathName itemconfigure $Closest -fill red

	#### TEST

	$CanvasPathName delete dummy_temp_point
	$CanvasPathName delete dummy_temp_line

	return $Index
}
##############################################################################
proc ::olSDL_Views::_ChanMP_exists {Coords x y} {
	foreach {MP_x MP_y} $Coords {
		if { ($MP_x == $x) && ($MP_y == $y) } {
			return true
		}
	}
	return false
}
##############################################################################
proc ::olSDL_Views::_is_valid_Channel_Source {SymbolType} {

	switch -exact $SymbolType {

		TextSym {return false}
		BlkInstRefSym {return true}
		BlkTypeRefSym {return false}
		ProInstRefSym {return true}
		ProTypeRefSym {return false}
		ProcedureInstRefSym {return false}
		default {
			error "unkown Symbol Type"
			return false
		}
	}
}
##############################################################################
proc ::olSDL_Views::_is_valid_Channel_Destination {SymbolType} {

	switch -exact $SymbolType {

		TextSym {return false}
		BlkInstRefSym {return true}
		BlkTypeRefSym {return false}
		ProInstRefSym {return true}
		ProTypeRefSym {return false}
		ProcedureInstRefSym {return false}
		default {
			error "unkown Symbol Type"
			return false
		}
	}
}
##############################################################################
proc ::olSDL_Views::Channel::get_ChannelsOnBorder {ObjArrName CanInfoArr Side CoorValue} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set ConnectedChannels { }
	set AllChannels [::olSDL_Views::Channel::get_all_channels $CanInfoArr]

	foreach ChanID $AllChannels {
		if { [::olSDL_Views::Channel::is_OnBorder $ObjArrName $CanInfoArr $ChanID $Side $CoorValue] } {
			lappend ConnectedChannels $ChanID
		}
	}

	return $ConnectedChannels
}
##############################################################################
proc ::olSDL_Views::Channel::is_OnBorder {ObjArrName CanInfoArr ChanID Side CoorValue} {

	upvar #0 $ObjArrName ObjArr

	switch -exact $Side {
		right {
			if { $ObjArr($ChanID,SourceID) == "ENV" } {
				if { [lindex $ObjArr($ChanID,Coords) 0] == $CoorValue } {
					return true
				}
			}
			if { $ObjArr($ChanID,DestinationID) == "ENV" } {
				if { [lindex $ObjArr($ChanID,Coords) [expr [llength $ObjArr($ChanID,Coords)] - 2]  ] == $CoorValue } {
					return true
				}
			}
		}
		bottom {
			if { $ObjArr($ChanID,SourceID) == "ENV" } {
				if { [lindex $ObjArr($ChanID,Coords) 1] == $CoorValue } {
					return true
				}
			}
			if { $ObjArr($ChanID,DestinationID) == "ENV" } {
				if { [lindex $ObjArr($ChanID,Coords) [expr [llength $ObjArr($ChanID,Coords)] - 1]  ] == $CoorValue } {
					return true
				}
			}
		}
		default {
			error "unknown side"
		}
	}
	# switch -exact $Side

	return false

}
##############################################################################
proc ::olSDL_Views::Channel::get_AllCompsOfAllChannels {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set Comps [$CanvasPathName find withtag selectableRecChanComp]
	return $Comps
}
##############################################################################
proc ::olSDL_Views::Channel::get_all_channels {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set Channels [$CanvasPathName find withtag BasicChanLine]
	return $Channels
}
##############################################################################
proc ::olSDL_Views::Channel::is_connected {ObjArrName Channel_ID Obj_ID} {

	upvar #0 $ObjArrName ObjArr

	if { $ObjArr($Channel_ID,Type) != "Channel" } {
		error "object isn't channel"
		return false
	}

	if { $ObjArr($Channel_ID,SourceID) == $Obj_ID } {
		return true
	}
	if { $ObjArr($Channel_ID,DestinationID) == $Obj_ID } {
		return true
	}

	return false
}
##############################################################################
proc ::olSDL_Views::Channel::modify_DestinationConnectionPoint_in_Tcl_and_Model {ObjArrName CanInfoArr Channel_ID x y} {

	upvar #0 $ObjArrName ObjArr

	if { $ObjArr($Channel_ID,Type) != "Channel" } {
		error "no Channel"
		return
	}

	::olSDL_Views::Channel::store_ChanCoords_in_Tcl_and_Model $ObjArrName $CanInfoArr $Channel_ID \
		[ lreplace $ObjArr($Channel_ID,Coords) [expr [llength $ObjArr($Channel_ID,Coords)] - 2] end $x $y ]
}
##############################################################################
proc ::olSDL_Views::Channel::modify_SourceConnectionPoint_in_Tcl_and_Model {ObjArrName CanInfoArr Channel_ID x y} {

	upvar #0 $ObjArrName ObjArr

	if { $ObjArr($Channel_ID,Type) != "Channel" } {
		error "no Channel"
		return
	}

	::olSDL_Views::Channel::store_ChanCoords_in_Tcl_and_Model $ObjArrName $CanInfoArr $Channel_ID \
		[ lreplace $ObjArr($Channel_ID,Coords) 0 1 $x $y ]
}
##############################################################################
proc ::olSDL_Views::Channel::get_DestinationConnectionPoint {ObjArrName Channel_ID} {

	upvar #0 $ObjArrName ObjArr

	if { $ObjArr($Channel_ID,Type) != "Channel" } {
		error "no Channel"
		return
	}

	set Point [lrange $ObjArr($Channel_ID,Coords) [expr [llength $ObjArr($Channel_ID,Coords)] - 2] end]
	return $Point
}
##############################################################################
proc ::olSDL_Views::Channel::get_SourceConnectionPoint {ObjArrName Channel_ID} {

	upvar #0 $ObjArrName ObjArr

	if { $ObjArr($Channel_ID,Type) != "Channel" } {
		error "no Channel"
		return
	}

	set Point [lrange $ObjArr($Channel_ID,Coords) 0 1]
	return $Point
}
##############################################################################
proc ::olSDL_Views::Channel::get_ConnectionSide {PaS Point} {

	set x [lindex $Point 0]
	set y [lindex $Point 1]

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x_left_up y_left_up x_right_down y_right_down

	if { ($x_left_up <= $x) && ($x <= $x_right_down) && ($y == $y_left_up) } {
		return top
	} elseif { ($x_left_up <= $x) && ($x <= $x_right_down) && ($y == $y_right_down) } {
		return bottom
	} elseif { ($y_left_up < $y) && ($y < $y_right_down) && ($x == $x_left_up) } {
		return left
	} elseif { ($y_left_up < $y) && ($y < $y_right_down) && ($x == $x_right_down) } {
		return right
	} else {
		error "no connection point"
	}
}
##############################################################################
proc ::olSDL_Views::Channel::modify_Channel_Coords {ObjArrName CanInfoArr Channel_ID Obj_ID old_PaS new_PaS} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set ConnectionPoint { }
	set ConnectionPoint_x ""
	set ConnectionPoint_y ""

	set NewConnectionPoint_x ""
	set NewConnectionPoint_y ""

	if { $ObjArr($Channel_ID,Type) != "Channel" } {
		error "no Channel"
		return
	}

	if { $ObjArr($Channel_ID,SourceID) == $Obj_ID } {
		set ConnectionType "source"
		set ConnectionPoint [get_SourceConnectionPoint $ObjArrName $Channel_ID]
	} elseif { $ObjArr($Channel_ID,DestinationID) == $Obj_ID } {
		set ConnectionType "destination"
		set ConnectionPoint [get_DestinationConnectionPoint $ObjArrName $Channel_ID]
	} else {
		error "no connection"
		return
	}

	set ConnectionPoint_x [lindex $ConnectionPoint 0]
	set ConnectionPoint_y [lindex $ConnectionPoint 1]

	set scale_x [expr double([lindex $new_PaS 2]) / double([lindex $old_PaS 2]) ]
	set scale_y [expr double([lindex $new_PaS 3]) / double([lindex $old_PaS 3]) ]

	set ConnectionSide [get_ConnectionSide $old_PaS $ConnectionPoint]

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $old_PaS old_x_left_up old_y_left_up old_x_right_down old_y_right_down

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $new_PaS new_x_left_up new_y_left_up new_x_right_down new_y_right_down

	switch -exact $ConnectionSide {
		top {
			set NewConnectionPoint_x [expr $new_x_left_up + ($scale_x * ($ConnectionPoint_x - $old_x_left_up)) ]
			set NewConnectionPoint_y $new_y_left_up
		}
		bottom {
			set NewConnectionPoint_x [expr $new_x_left_up + ($scale_x * ($ConnectionPoint_x - $old_x_left_up)) ]
			set NewConnectionPoint_y $new_y_right_down
		}
		left {
			set NewConnectionPoint_x $new_x_left_up
			set NewConnectionPoint_y [expr $new_y_left_up + ($scale_y * ($ConnectionPoint_y - $old_y_left_up)) ]
		}
		right {
			set NewConnectionPoint_x $new_x_right_down
			set NewConnectionPoint_y [expr $new_y_left_up + ($scale_y * ($ConnectionPoint_y - $old_y_left_up)) ]
		}
		default {
			error "unknown connection side"
		}
	}
	# switch -exact $ConnectionSide

	set NewConnectionPoint_x [expr int ($NewConnectionPoint_x)]
	set NewConnectionPoint_y [expr int ($NewConnectionPoint_y)]

	switch -exact $ConnectionType {
		"source" {
			# move ChanComp
			::olSDL_Views::Channel::MoveChanComp_OuterMP $ObjArrName $CanInfoArr \
				$Channel_ID \
				0 $NewConnectionPoint_x $NewConnectionPoint_y \
				$CanInfo(PageWidth) $CanInfo(PageHeight)

			modify_SourceConnectionPoint_in_Tcl_and_Model $ObjArrName $CanInfoArr \
				$Channel_ID $NewConnectionPoint_x $NewConnectionPoint_y
		}
		"destination" {
			# move ChanComp
			::olSDL_Views::Channel::MoveChanComp_OuterMP $ObjArrName $CanInfoArr \
				$Channel_ID \
				[expr int ( ([llength $ObjArr($Channel_ID,Coords)] / 2.0) -1) ] \
				$NewConnectionPoint_x $NewConnectionPoint_y \
				$CanInfo(PageWidth) $CanInfo(PageHeight)

			modify_DestinationConnectionPoint_in_Tcl_and_Model $ObjArrName $CanInfoArr \
				$Channel_ID $NewConnectionPoint_x $NewConnectionPoint_y
		}
		default {
			error "wrong connection type"
		}
	}
}
##############################################################################
proc ::olSDL_Views::Channel::get_ChanID_and_ChanCompType_from_ChanComp {ObjArrName CanInfoArr ChanCompID out_ChanID out_ChanCompType} {

	upvar #0 $CanInfoArr CanInfo

	upvar $out_ChanID ChanID
	upvar $out_ChanCompType ChanCompType

	set CanvasPathName $CanInfo(CanvasPathName)

	set AllTags [$CanvasPathName gettags $ChanCompID]

	set ChanID_Index [lsearch -glob $AllTags ChanName*]
	if { $ChanID_Index != -1} {
		set str_ChanID [lindex $AllTags $ChanID_Index]
		set ChanID [string range $str_ChanID 8 end]
		set ChanCompType ChanName
		return
	}

	set ChanID_Index [lsearch -glob $AllTags ChanSourceSig*]
	if { $ChanID_Index != -1} {
		set str_ChanID [lindex $AllTags $ChanID_Index]
		set ChanID [string range $str_ChanID 13 end]
		set ChanCompType ChanSourceSig
		return
	}

	set ChanID_Index [lsearch -glob $AllTags ChanDestSig*]
	if { $ChanID_Index != -1} {
		set str_ChanID [lindex $AllTags $ChanID_Index]
		set ChanID [string range $str_ChanID 11 end]
		set ChanCompType ChanDestSig
		return
	}

	set ChanID_Index [lsearch -glob $AllTags ChanSourceCon*]
	if { $ChanID_Index != -1} {
		set str_ChanID [lindex $AllTags $ChanID_Index]
		set ChanID [string range $str_ChanID 13 end]
		set ChanCompType ChanSourceCon
		return
	}

	set ChanID_Index [lsearch -glob $AllTags ChanDestCon*]
	if { $ChanID_Index != -1} {
		set str_ChanID [lindex $AllTags $ChanID_Index]
		set ChanID [string range $str_ChanID 11 end]
		set ChanCompType ChanDestCon
		return
	}

	error "unknown ChanComp"
}
##############################################################################
##############################################################################
##############################################################################
proc ::olSDL_Views::Channel::calc_ChannelMP_On_BorderToEnv {ObjArrName CanInfoArr RecSymPaS CurrentZone Current_x Current_y } {

	set ResultCoords { }

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $RecSymPaS x_left_up y_left_up x_right_down y_right_down


	if { $CurrentZone == "1" } {
		lappend ResultCoords $x_left_up
		lappend ResultCoords $y_left_up
	} elseif { $CurrentZone == "2" } {
		lappend ResultCoords $Current_x
		lappend ResultCoords $y_left_up
	} elseif { $CurrentZone == "3" } {
		lappend ResultCoords $x_right_down
		lappend ResultCoords $y_left_up
	} elseif { $CurrentZone == "4" } {
		lappend ResultCoords $x_left_up
		lappend ResultCoords $Current_y
	} elseif { $CurrentZone == "5" } {
		lappend ResultCoords $Current_x
		lappend ResultCoords $y_left_up
	} elseif { $CurrentZone == "6" } {
		lappend ResultCoords $x_right_down
		lappend ResultCoords $Current_y
	} elseif { $CurrentZone == "7" } {
		lappend ResultCoords $x_left_up
		lappend ResultCoords $y_right_down
	} elseif { $CurrentZone == "8" } {
		lappend ResultCoords $Current_x
		lappend ResultCoords $y_right_down
	} elseif { $CurrentZone == "9" } {
		lappend ResultCoords $x_right_down
		lappend ResultCoords $y_right_down
	}
	return $ResultCoords

}
##############################################################################
proc ::olSDL_Views::Channel::calc_ChannelMP_On_RecSym {ObjArrName CanInfoArr RecSymPaS \
	NeighbouringMP_Zone CurrentZone Current_x Current_y } {

	set ResultCoords { }

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $RecSymPaS x_left_up y_left_up x_right_down y_right_down

	if { $NeighbouringMP_Zone == "1" } {

		if { $CurrentZone == "1" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "2" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "3" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "4" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "5" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "6" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "7" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "8" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "9" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_right_down
		}
		return $ResultCoords
	} elseif { $NeighbouringMP_Zone == "2" } {

		if { $CurrentZone == "1" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "2" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "3" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "4" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "5" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "6" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "7" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "8" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "9" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_right_down
		}
		return $ResultCoords
	} elseif { $NeighbouringMP_Zone == "3" } {

		if { $CurrentZone == "1" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "2" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "3" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "4" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "5" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "6" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "7" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "8" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "9" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_right_down
		}
		return $ResultCoords
	} elseif { $NeighbouringMP_Zone == "4" } {

		if { $CurrentZone == "1" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "2" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "3" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "4" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "5" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "6" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "7" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "8" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "9" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_right_down
		}
		return $ResultCoords
	} elseif { $NeighbouringMP_Zone == "5" } {

		if { $CurrentZone == "1" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "2" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "3" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "4" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "5" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "6" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "7" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "8" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "9" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_right_down
		}
		return $ResultCoords
	} elseif { $NeighbouringMP_Zone == "6" } {

		if { $CurrentZone == "1" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "2" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "3" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "4" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "5" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "6" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "7" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "8" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "9" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_right_down
		}
		return $ResultCoords
	} elseif { $NeighbouringMP_Zone == "7" } {

		if { $CurrentZone == "1" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "2" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "3" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "4" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "5" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "6" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "7" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "8" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "9" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_right_down
		}
		return $ResultCoords
	} elseif { $NeighbouringMP_Zone == "8" } {

		if { $CurrentZone == "1" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "2" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "3" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "4" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "5" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "6" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "7" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "8" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "9" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_right_down
		}
		return $ResultCoords
	} elseif { $NeighbouringMP_Zone == "9" } {

		if { $CurrentZone == "1" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "2" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "3" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_left_up
		} elseif { $CurrentZone == "4" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "5" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "6" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $Current_y
		} elseif { $CurrentZone == "7" } {
			lappend ResultCoords $x_left_up
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "8" } {
			lappend ResultCoords $Current_x
			lappend ResultCoords $y_right_down
		} elseif { $CurrentZone == "9" } {
			lappend ResultCoords $x_right_down
			lappend ResultCoords $y_right_down
		}
		return $ResultCoords
	}

	error "prog error"
}
##############################################################################
