package provide olSDL_ViewsChan 1

namespace eval olSDL_Views {
	namespace eval Channel {
	}
	namespace eval Env {
	}
}

##############################################################################
proc ::olSDL_Views::Channel::_init_ConnectHelperObjects {ObjArrName CanInfoArr SourceID Source_is_Env x y} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanInfo(connect_Destination_is_Env) ""
	set CanInfo(connect_Destination_ID) ""
	set CanInfo(connect_DestinationPaS) ""

	set CanInfo(connect_Source_is_Env) $Source_is_Env

	if {$Source_is_Env} {
		set CanInfo(connect_Source_ID) "ENV"
		set CanInfo(connect_SourcePaS) ""
	} else {
		set CanInfo(connect_Source_ID) $SourceID
		set CanInfo(connect_SourcePaS) $ObjArr($SourceID,PaS)
	}

	set CanInfo(connect_afterSource) true

	set CanInfo(connect_Source_x) $x
	set CanInfo(connect_Source_y) $y

	set CanInfo(connect_afterFirstPart) false

	set CanInfo(connect_ChannelCoords) { }
	set CanInfo(connect_Channel_ID) ""

	set CanInfo(connect_DelayType) ""
	set CanInfo(connect_DirectionType) ""
}
##############################################################################
proc ::olSDL_Views::Channel::delete_ConnectionHelperObjects {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	$CanvasPathName delete $CanInfo(connect_Channel_ID)
	set CanInfo(connect_Channel_ID) " "
	set CanInfo(connect_ChannelCoords) { }

	set CanInfo(connect_Destination_is_Env) ""
	set CanInfo(connect_Destination_ID) ""
	set CanInfo(connect_DestinationPaS) ""

	set CanInfo(connect_Source_is_Env) ""
	set CanInfo(connect_Source_ID) ""
	set CanInfo(connect_SourcePaS) ""

	set CanInfo(connect_afterSource) false

	set CanInfo(connect_Source_x) ""
	set CanInfo(connect_Source_y) ""

	set CanInfo(connect_afterFirstPart) false

	set CanInfo(connect_DelayType) ""
	set CanInfo(connect_DirectionType) ""
}
##############################################################################
proc ::olSDL_Views::Channel::_get_IDs_from_all_ChanComp {ObjArrName CanInfoArr Channel_ID} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	set AllComps [$CanvasPathName find withtag ChanName$Channel_ID]

	lappend AllComps [$CanvasPathName find withtag ChanSourceSig$Channel_ID]
	lappend AllComps [$CanvasPathName find withtag ChanSourceCon$Channel_ID]

	lappend AllComps [$CanvasPathName find withtag ChanDestCon$Channel_ID]
	lappend AllComps [$CanvasPathName find withtag ChanDestSig$Channel_ID]

	return $AllComps
}
##############################################################################
proc ::olSDL_Views::Channel::_get_Channel_ID_from_Arrow {ObjArrName CanInfoArr Arrow_ID} {
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	set AllTags [$CanvasPathName gettags $Arrow_ID]

	set ParentChannel_ID_Index [lsearch -glob $AllTags ParentChannel*]
	set str_ParentChannel_ID [lindex $AllTags $ParentChannel_ID_Index]

	return [string range $str_ParentChannel_ID 13 end]
}
##############################################################################
proc ::olSDL_Views::Channel::ClickOnChannel {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set Channel_ID [$CanvasPathName find withtag current]

	set CanvasState $CanInfo(state)

	if { $CanvasState == "flowline" } {
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
		return
	}

	if { ($CanvasState != "single_obj_selected") && ($CanvasState != "normal")  } {
		# do nothing
		return
	}

	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr
	::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $Channel_ID

}
##############################################################################
proc ::olSDL_Views::Channel::ClickOnChannelArrow {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]
	set CanvasState $CanInfo(state)

	if { $CanvasState == "flowline" } {
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
		return
	}

	if { ($CanvasState != "single_obj_selected") && ($CanvasState != "normal")  } {
		# do nothing
		return
	}

	set Channel_ID [_get_Channel_ID_from_Arrow $ObjArrName $CanInfoArr $currentObject]

	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr
	::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $Channel_ID

}
##############################################################################
proc ::olSDL_Views::Channel::StartChanMP {ObjArrName CanInfoArr x y} {

	#puts ::olSDL_Views::Channel::StartChanMP

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	set x [expr int([$CanvasPathName canvasx $x])]
	set y [expr int([$CanvasPathName canvasy $y])]

	set InnerChanMP_Index [_get_ICMP_Index_from_MP $ObjArrName $CanInfoArr $currentObject]

	if { $InnerChanMP_Index == -1 } {

			_init_OCMP_MoveHelper $ObjArrName $CanInfoArr

			set CanInfo(OCMP_Move_ChanID) [_get_ChanID_from_MP $ObjArrName $CanInfoArr $currentObject]

			set CanInfo(OCMP_Move_OCMP_Type) [_get_OuterChanMP_Type $ObjArrName $CanInfoArr $currentObject]

			set CanInfo(OCMP_Move_NeighbouringMP_Coords) \
				[_get_NeighbouringMP_Coords $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_ChanID) $CanInfo(OCMP_Move_OCMP_Type)]

			if { $CanInfo(OCMP_Move_OCMP_Type) == "SOURCE_RECSYM" } {
				set CanInfo(OCMP_Move_RecSymPaS) $ObjArr($ObjArr($CanInfo(OCMP_Move_ChanID),SourceID),PaS)
			} elseif { $CanInfo(OCMP_Move_OCMP_Type) == "DEST_RECSYM" } {
				set CanInfo(OCMP_Move_RecSymPaS) $ObjArr($ObjArr($CanInfo(OCMP_Move_ChanID),DestinationID),PaS)
			}

			return
	} else {

		_init_ICMP_MoveHelper $ObjArrName $CanInfoArr

		set CanInfo(ICMP_Move_ChanID) [_get_ChanID_from_MP $ObjArrName $CanInfoArr $currentObject]

		set CanInfo(ICMP_Move_PredecessorMP_Coords) \
			[_get_PredecessorMP_Coords $ObjArrName $CanInfoArr $CanInfo(ICMP_Move_ChanID) $InnerChanMP_Index]

		set CanInfo(ICMP_Move_SuccessorMP_Coords) \
			[_get_SuccessorMP_Coords $ObjArrName $CanInfoArr $CanInfo(ICMP_Move_ChanID) $InnerChanMP_Index]

		################
		# draw PreviewLine

		set PreviewLineID ""
		::olSDL_ViewsDrawMethods::draw_ICMP_PreviewLine $CanInfoArr $CanInfo(ICMP_Move_PredecessorMP_Coords) \
			$x $y $CanInfo(ICMP_Move_SuccessorMP_Coords) PreviewLineID
		set CanInfo(ICMP_Move_PreviewLineID) $PreviewLineID

		# END: draw PreviewLine
		################

		return
	}
}
##############################################################################
proc ::olSDL_Views::Channel::ProcessChanMP {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	set x [expr int([$CanvasPathName canvasx $x])]
	set y [expr int([$CanvasPathName canvasy $y])]

	set InnerChanMP_Index [_get_ICMP_Index_from_MP $ObjArrName $CanInfoArr $currentObject]

	if { $InnerChanMP_Index == -1 } {

			if { ($CanInfo(OCMP_Move_OCMP_Type) == "SOURCE_RECSYM") || \
			     ($CanInfo(OCMP_Move_OCMP_Type) == "DEST_RECSYM") } {

				set NeighbouringMP_Zone [::olSDL_ViewsCalcCoor::ZoneIndex $CanInfo(OCMP_Move_RecSymPaS) \
					[lindex $CanInfo(OCMP_Move_NeighbouringMP_Coords) 0] \
					[lindex $CanInfo(OCMP_Move_NeighbouringMP_Coords) 1] ]

				set CurrentZone [::olSDL_ViewsCalcCoor::ZoneIndex $CanInfo(OCMP_Move_RecSymPaS) $x $y]

				set ResultCoords [calc_ChannelMP_On_RecSym $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_RecSymPaS) \
					$NeighbouringMP_Zone $CurrentZone $x $y]

				$CanvasPathName delete $CanInfo(OCMP_Move_PreviewLineID)

				set CanInfo(OCMP_Move_PreviewLineID) [$CanvasPathName create line [lindex $CanInfo(OCMP_Move_NeighbouringMP_Coords) 0] \
					[lindex $CanInfo(OCMP_Move_NeighbouringMP_Coords) 1] [lindex $ResultCoords 0] [lindex $ResultCoords 1] -dash {2 4} -width 2]

			} elseif { ($CanInfo(OCMP_Move_OCMP_Type) == "SOURCE_ENV") || \
				    ($CanInfo(OCMP_Move_OCMP_Type) == "DEST_ENV") } {

				set CurrentZone [::olSDL_ViewsCalcCoor::ZoneIndex $CanInfo(PageFramePaS) $x $y]

				set ResultCoords [::olSDL_Views::Channel::calc_ChannelMP_On_BorderToEnv $ObjArrName $CanInfoArr \
					$CanInfo(PageFramePaS) $CurrentZone $x $y]

				$CanvasPathName delete $CanInfo(OCMP_Move_PreviewLineID)

				set CanInfo(OCMP_Move_PreviewLineID) [$CanvasPathName create line [lindex $CanInfo(OCMP_Move_NeighbouringMP_Coords) 0] \
					[lindex $CanInfo(OCMP_Move_NeighbouringMP_Coords) 1] [lindex $ResultCoords 0] [lindex $ResultCoords 1] -dash {2 4} -width 2]

			} else {
				error "prog error"
			}

			return
	} else {

		$CanvasPathName delete $CanInfo(ICMP_Move_PreviewLineID)

		################
		# draw PreviewLine

		set PreviewLineID ""
		::olSDL_ViewsDrawMethods::draw_ICMP_PreviewLine $CanInfoArr $CanInfo(ICMP_Move_PredecessorMP_Coords) \
			$x $y $CanInfo(ICMP_Move_SuccessorMP_Coords) PreviewLineID
		set CanInfo(ICMP_Move_PreviewLineID) $PreviewLineID

		# END: draw PreviewLine
		################
	}
}
##############################################################################
proc ::olSDL_Views::Channel::EndChanMP {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	set x [expr int([$CanvasPathName canvasx $x])]
	set y [expr int([$CanvasPathName canvasy $y])]

	set InnerChanMP_Index [_get_ICMP_Index_from_MP $ObjArrName $CanInfoArr $currentObject]

	if { $InnerChanMP_Index == -1 } {

		if { ($CanInfo(OCMP_Move_OCMP_Type) == "SOURCE_RECSYM") || \
		     ($CanInfo(OCMP_Move_OCMP_Type) == "DEST_RECSYM") } {

			set NeighbouringMP_Zone [::olSDL_ViewsCalcCoor::ZoneIndex $CanInfo(OCMP_Move_RecSymPaS) \
				[lindex $CanInfo(OCMP_Move_NeighbouringMP_Coords) 0] \
				[lindex $CanInfo(OCMP_Move_NeighbouringMP_Coords) 1] ]

			set CurrentZone [::olSDL_ViewsCalcCoor::ZoneIndex $CanInfo(OCMP_Move_RecSymPaS) $x $y]

			set ResultCoords [calc_ChannelMP_On_RecSym $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_RecSymPaS) \
				$NeighbouringMP_Zone $CurrentZone $x $y]

			##############
			# valid channel Part

			set TempChannelPartCoords [concat $ResultCoords $CanInfo(OCMP_Move_NeighbouringMP_Coords)]

			if { ![ ::olSDL_ViewsDrawMethods::valid_Channel_Part $TempChannelPartCoords] } {

				_delete_OCMP_MoveHelper $ObjArrName $CanInfoArr
				return
			}

			# valid channel Part
			##############

			##############
			# modify Coords in Tcl

			if { ($CanInfo(OCMP_Move_OCMP_Type) == "SOURCE_RECSYM") } {

				::olSDL_Views::Channel::MoveChanComp_OuterMP $ObjArrName $CanInfoArr \
					$CanInfo(OCMP_Move_ChanID) \
					0 [lindex $ResultCoords 0] [lindex $ResultCoords 1] \
					$CanInfo(PageWidth) $CanInfo(PageHeight)

				modify_ChanMP_in_Tcl_and_Model $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_ChanID) \
					0 [lindex $ResultCoords 0] [lindex $ResultCoords 1]
			} else {

				::olSDL_Views::Channel::MoveChanComp_OuterMP $ObjArrName $CanInfoArr \
					$CanInfo(OCMP_Move_ChanID) \
					[expr int ( ([llength $ObjArr($CanInfo(OCMP_Move_ChanID),Coords)] / 2.0) -1) ] [lindex $ResultCoords 0] [lindex $ResultCoords 1] \
					$CanInfo(PageWidth) $CanInfo(PageHeight)

				modify_ChanMP_in_Tcl_and_Model $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_ChanID) \
					[expr int ( ([llength $ObjArr($CanInfo(OCMP_Move_ChanID),Coords)] / 2.0) -1) ] [lindex $ResultCoords 0] [lindex $ResultCoords 1]
			}

			# modify Coords in Tcl
			##############

			# delete old channel comp
			::olSDL_ViewsDrawMethods::delete_ChannelComp_from_Canvas $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_ChanID)

			# delete old MP
			::olSDL_ViewsDrawMethods::delete_Channel_MP_from_Canvas $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_ChanID)

			# draw Channel
			 ::olSDL_ViewsDrawMethods::draw_Channel $CanvasPathName \
				$ObjArr($CanInfo(OCMP_Move_ChanID),Coords) \
				$ObjArr($CanInfo(OCMP_Move_ChanID),DelayType) $ObjArr($CanInfo(OCMP_Move_ChanID),DirectionType) \
				true $CanInfo(OCMP_Move_ChanID) NewChannel_ID

			# draw MovePoints
			::olSDL_ViewsDrawMethods::draw_Channel_MovePoints $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_ChanID)

			_delete_OCMP_MoveHelper $ObjArrName $CanInfoArr

		} elseif { ($CanInfo(OCMP_Move_OCMP_Type) == "SOURCE_ENV") || \
			    ($CanInfo(OCMP_Move_OCMP_Type) == "DEST_ENV") } {

			set CurrentZone [::olSDL_ViewsCalcCoor::ZoneIndex $CanInfo(PageFramePaS) $x $y]

			set ResultCoords [::olSDL_Views::Channel::calc_ChannelMP_On_BorderToEnv $ObjArrName $CanInfoArr \
				$CanInfo(PageFramePaS) $CurrentZone $x $y]

			##############
			# valid channel Part

			set TempChannelPartCoords [concat $ResultCoords $CanInfo(OCMP_Move_NeighbouringMP_Coords)]

			if { ![ ::olSDL_ViewsDrawMethods::valid_Channel_Part $TempChannelPartCoords] } {

				_delete_OCMP_MoveHelper $ObjArrName $CanInfoArr
				return
			}

			# valid channel Part
			##############

			##############
			# modify Coords in Tcl

			if { ($CanInfo(OCMP_Move_OCMP_Type) == "SOURCE_ENV") } {

				::olSDL_Views::Channel::MoveChanComp_OuterMP $ObjArrName $CanInfoArr \
					$CanInfo(OCMP_Move_ChanID) \
					0 [lindex $ResultCoords 0] [lindex $ResultCoords 1] \
					$CanInfo(PageWidth) $CanInfo(PageHeight)

				modify_ChanMP_in_Tcl_and_Model $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_ChanID) \
					0 [lindex $ResultCoords 0] [lindex $ResultCoords 1]
			} else {

				::olSDL_Views::Channel::MoveChanComp_OuterMP $ObjArrName $CanInfoArr \
					$CanInfo(OCMP_Move_ChanID) \
					[expr int ( ([llength $ObjArr($CanInfo(OCMP_Move_ChanID),Coords)] / 2.0) -1) ] [lindex $ResultCoords 0] [lindex $ResultCoords 1] \
					$CanInfo(PageWidth) $CanInfo(PageHeight)

				modify_ChanMP_in_Tcl_and_Model $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_ChanID) \
					[expr int ( ([llength $ObjArr($CanInfo(OCMP_Move_ChanID),Coords)] / 2.0) -1) ] [lindex $ResultCoords 0] [lindex $ResultCoords 1]
			}

			# modify Coords in Tcl
			##############

			# delete old channel comp
			::olSDL_ViewsDrawMethods::delete_ChannelComp_from_Canvas $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_ChanID)

			# delete old MP
			::olSDL_ViewsDrawMethods::delete_Channel_MP_from_Canvas $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_ChanID)

			# draw Channel
			 ::olSDL_ViewsDrawMethods::draw_Channel $CanvasPathName \
				$ObjArr($CanInfo(OCMP_Move_ChanID),Coords) \
				$ObjArr($CanInfo(OCMP_Move_ChanID),DelayType) $ObjArr($CanInfo(OCMP_Move_ChanID),DirectionType) \
				true $CanInfo(OCMP_Move_ChanID) NewChannel_ID

			# draw MovePoints
			::olSDL_ViewsDrawMethods::draw_Channel_MovePoints $ObjArrName $CanInfoArr $CanInfo(OCMP_Move_ChanID)

			_delete_OCMP_MoveHelper $ObjArrName $CanInfoArr

		} else {
			error "prog error"
		}

		return
	} else {

		##################
		# check for valid movement

		if { ! [_is_valid_InnerChanMP $ObjArrName $CanInfoArr $x $y $currentObject] } {
			_delete_ICMP_MoveHelper $ObjArrName $CanInfoArr
			return
		}
		# check for valid movement
		##################

		::olSDL_Views::Channel::MoveChanComp_InnerMP $ObjArrName $CanInfoArr $CanInfo(ICMP_Move_ChanID) $InnerChanMP_Index \
			$x $y $CanInfo(PageWidth) $CanInfo(PageHeight)

		# modify Coords in Tcl
		modify_ChanMP_in_Tcl_and_Model $ObjArrName $CanInfoArr $CanInfo(ICMP_Move_ChanID) $InnerChanMP_Index $x $y

		# delete old channel comp
		::olSDL_ViewsDrawMethods::delete_ChannelComp_from_Canvas $ObjArrName $CanInfoArr $CanInfo(ICMP_Move_ChanID)

		# delete old MP
		::olSDL_ViewsDrawMethods::delete_Channel_MP_from_Canvas $ObjArrName $CanInfoArr $CanInfo(ICMP_Move_ChanID)


		# draw Channel
		 ::olSDL_ViewsDrawMethods::draw_Channel $CanvasPathName \
			$ObjArr($CanInfo(ICMP_Move_ChanID),Coords) \
			$ObjArr($CanInfo(ICMP_Move_ChanID),DelayType) $ObjArr($CanInfo(ICMP_Move_ChanID),DirectionType) \
			true $CanInfo(ICMP_Move_ChanID) NewChannel_ID

		# draw MovePoints
		::olSDL_ViewsDrawMethods::draw_Channel_MovePoints $ObjArrName $CanInfoArr $CanInfo(ICMP_Move_ChanID)

		# delete Helper
		_delete_ICMP_MoveHelper $ObjArrName $CanInfoArr
	}
}
##############################################################################
proc ::olSDL_Views::Channel::_is_valid_InnerChanMP {ObjArrName CanInfoArr x y MP_ID} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	#################################
	# in Frame ?

	set PageFrameInnerZoneCoords [::olSDL_ViewsCalcCoor::calc_PageFrameInnerZoneCoords $CanInfo(PageFramePaS)]

	if { !  [::olSDL_ViewsCalcCoor::Point_in_Rectangle $x $y $PageFrameInnerZoneCoords] } {
		return false
	}
	# END:  in Frame ?
	#################################

	#################################
	# overlapping ?

	set temp_x_left_up [expr $x - $::olSDL_ViewsDrawMethods::ResizePointsSize]
	set temp_y_left_up [expr $y - $::olSDL_ViewsDrawMethods::ResizePointsSize]
	set temp_x_right_down [expr $x + $::olSDL_ViewsDrawMethods::ResizePointsSize]
	set temp_y_right_down [expr $y + $::olSDL_ViewsDrawMethods::ResizePointsSize]

	set tempCoords [list $temp_x_left_up $temp_y_left_up $temp_x_right_down $temp_y_right_down]

	if { [::olSDL_Views::Obj_covered $CanvasPathName $tempCoords $MP_ID selectableRec] } {
		return false
	}

	if { [::olSDL_Views::Obj_covered $CanvasPathName $tempCoords $MP_ID ChanMP] } {
		return false
	}

	# END : overlapping ?
	#################################

	#################################
	# valid channel part length

	set PrePartCoords $CanInfo(ICMP_Move_PredecessorMP_Coords)
	set SucPartCoords $CanInfo(ICMP_Move_SuccessorMP_Coords)

	lappend PrePartCoords $x
	lappend PrePartCoords $y

	lappend SucPartCoords $x
	lappend SucPartCoords $y

	if { ! [::olSDL_ViewsDrawMethods::valid_Channel_Part $PrePartCoords] } {
		return false
	}

	if { ! [::olSDL_ViewsDrawMethods::valid_Channel_Part $SucPartCoords] } {
		return false
	}

	# END : valid channel part length
	#################################

	return true
}
##############################################################################
proc ::olSDL_Views::Channel::modify_ChanMP_in_Tcl_and_Model {ObjArrName CanInfoArr Channel_ID MP_Index new_x new_y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set ModifyIndex [expr $MP_Index * 2]

	::olSDL_Views::Channel::store_ChanCoords_in_Tcl_and_Model $ObjArrName $CanInfoArr $Channel_ID \
		[lreplace $ObjArr($Channel_ID,Coords) $ModifyIndex [expr $ModifyIndex + 1] $new_x $new_y]
}
##############################################################################
proc ::olSDL_Views::Channel::_init_ICMP_MoveHelper {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanInfo(ICMP_Move_ChanID) ""
	set CanInfo(ICMP_Move_PredecessorMP_Coords) ""
	set CanInfo(ICMP_Move_SuccessorMP_Coords) ""
	set CanInfo(ICMP_Move_PreviewLineID) ""
}
##############################################################################
proc ::olSDL_Views::Channel::_delete_ICMP_MoveHelper {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	# delete PreviewLine from Canvas
	$CanvasPathName delete $CanInfo(ICMP_Move_PreviewLineID)

	set CanInfo(ICMP_Move_ChanID) ""
	set CanInfo(ICMP_Move_PredecessorMP_Coords) ""
	set CanInfo(ICMP_Move_SuccessorMP_Coords) ""
	set CanInfo(ICMP_Move_PreviewLineID) ""
}
##############################################################################
proc ::olSDL_Views::Channel::_get_OuterChanMP_Type {ObjArrName CanInfoArr MP_ID} {
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	set AllTags [$CanvasPathName gettags $MP_ID]

	set OuterChanMP_Type_Index [lsearch -glob $AllTags OuterChanMPType*]

	if { $OuterChanMP_Type_Index == -1 } {
		error "no channel outer MP"
	} else {
		set str_OuterChanMP_Type [lindex $AllTags $OuterChanMP_Type_Index]
		set str_Result [string range $str_OuterChanMP_Type 15 end]
		return $str_Result
	}
}
##############################################################################
proc ::olSDL_Views::Channel::_get_ICMP_Index_from_MP {ObjArrName CanInfoArr MP_ID} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	set AllTags [$CanvasPathName gettags $MP_ID]

	set InnerChanMP_Index_Index [lsearch -glob $AllTags InnerChanMP*]

	if { $InnerChanMP_Index_Index == -1 } {
		return -1
	} else {
		set str_InnerChanMP_Index [lindex $AllTags $InnerChanMP_Index_Index]
		set InnerChanMP_Index [string range $str_InnerChanMP_Index  11 end]
		return $InnerChanMP_Index
	}
}
##############################################################################
proc ::olSDL_Views::Channel::_get_NeighbouringMP_Coords {ObjArrName CanInfoArr Channel_ID OuterMPType} {

	upvar #0 $ObjArrName ObjArr

	set ChannelCoords $ObjArr($Channel_ID,Coords)
	set CoordsLength [llength $ObjArr($Channel_ID,Coords)]

	if { ($OuterMPType == "SOURCE_ENV") || ($OuterMPType == "SOURCE_RECSYM") } {

		set MP_Coords [lindex $ChannelCoords 2]
		lappend MP_Coords [lindex $ChannelCoords 3]

	} elseif { ($OuterMPType == "DEST_ENV") || ($OuterMPType == "DEST_RECSYM") } {

		set MP_Coords [lindex $ChannelCoords [expr $CoordsLength - 4] ]
		lappend MP_Coords [lindex $ChannelCoords [expr $CoordsLength - 3] ]
	}

	return $MP_Coords
}
##############################################################################
proc ::olSDL_Views::Channel::_get_PredecessorMP_Coords {ObjArrName CanInfoArr Channel_ID MP_Index} {

	upvar #0 $ObjArrName ObjArr

	set ChannelCoords $ObjArr($Channel_ID,Coords)

	set MP_Coords [lindex $ChannelCoords [expr ($MP_Index * 2) - 2] ]
	lappend MP_Coords [lindex $ChannelCoords [expr ($MP_Index * 2) - 1] ]

	return $MP_Coords
}
##############################################################################
proc ::olSDL_Views::Channel::_get_SuccessorMP_Coords {ObjArrName CanInfoArr Channel_ID MP_Index} {

	upvar #0 $ObjArrName ObjArr

	set ChannelCoords $ObjArr($Channel_ID,Coords)

	set MP_Coords [lindex $ChannelCoords [expr ($MP_Index * 2) + 2] ]
	lappend MP_Coords [lindex $ChannelCoords [expr ($MP_Index * 2) + 3] ]

	return $MP_Coords
}
##############################################################################
proc ::olSDL_Views::Channel::_get_ChanID_from_MP {ObjArrName CanInfoArr MP_ID} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	set AllTags [$CanvasPathName gettags $MP_ID]

	set ChanID_Index [lsearch -glob $AllTags MPparent*]

	if { $ChanID_Index == -1 } {
		error "MP without Channel"
		return
	}

	set str_ChanID [lindex $AllTags $ChanID_Index]
	set ChanID [string range $str_ChanID 8 end]

	return $ChanID
}
##############################################################################
proc ::olSDL_Views::Channel::_init_OCMP_MoveHelper {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanInfo(OCMP_Move_ChanID) ""
	set CanInfo(OCMP_Move_OCMP_Type) ""
	set CanInfo(OCMP_Move_RecSymPaS) ""
	set CanInfo(OCMP_Move_NeighbouringMP_Coords) ""
	set CanInfo(OCMP_Move_PreviewLineID) ""
}
##############################################################################
proc ::olSDL_Views::Channel::_delete_OCMP_MoveHelper {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	$CanvasPathName delete $CanInfo(OCMP_Move_PreviewLineID)

	set CanInfo(OCMP_Move_ChanID) ""
	set CanInfo(OCMP_Move_OCMP_Type) ""
	set CanInfo(OCMP_Move_RecSymPaS) ""
	set CanInfo(OCMP_Move_NeighbouringMP_Coords) ""
	set CanInfo(OCMP_Move_PreviewLineID) ""
}
##############################################################################
proc ::olSDL_Views::Channel::toogleDirection {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	if { $CanInfo(changeCT_DirectionType) == "from_source" } {

		set CanInfo(changeCT_DirectionType) "from_destination"

	} elseif { $CanInfo(changeCT_DirectionType) == "from_destination" } {

		set CanInfo(changeCT_DirectionType) "from_source"

	} else {
		error "unknown Direction Type"
	}

	OnChangeChannelType $ObjArrName $CanInfoArr
}
##############################################################################
proc ::olSDL_Views::Channel::OnChangeChannelDirectionType {ObjArrName CanInfoArr DirectionType} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set Channel_ID $CanInfo(changeCT_Channel_ID)

	if { $DirectionType == "bi" } {
		set CanInfo(changeCT_DirectionType) "both"
	} elseif { $DirectionType == "uni" } {
		set CanInfo(changeCT_DirectionType) "from_source"
	} else {
		error "unknown direction type"
	}

	OnChangeChannelType $ObjArrName $CanInfoArr
}
##############################################################################
proc ::olSDL_Views::Channel::show_CompPopUpMenu {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	# unpost CM
	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr

	# set selected
	::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $currentObject

	set x_in_can [expr int (round ($x))]
	set y_in_can [expr int (round ($y))]

	set PopUp_x [expr $x_in_can + [winfo rootx $CanvasPathName]]
	set PopUp_y [expr $y_in_can + [winfo rooty $CanvasPathName]]

	set CanInfo(PU_ChanComp_Object_ID) $currentObject

	$CanInfo(menu_ChanCompPopUp) post $PopUp_x $PopUp_y
}
##############################################################################
proc ::olSDL_Views::Channel::EditChanCompContent {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set ChanCompCanID $CanInfo(PU_ChanComp_Object_ID)
	::olSDL_Views::Channel::get_ChanID_and_ChanCompType_from_ChanComp $ObjArrName $CanInfoArr $ChanCompCanID Channel_ID dummy

	##################################
	# determine title for different ChanComp

	switch -exact $ObjArr($ChanCompCanID,CompType) {
		ChanName {
			set DlgTitle "Channel Component Name"
		}
		ChanSourceSig {
			set DlgTitle "Channel Component Signallist"
		}
		ChanDestSig {
			set DlgTitle "Channel Component Signallist"
		}
		ChanSourceCon {
			set DlgTitle "Channel Component Connect"
		}
		ChanDestCon {
			set DlgTitle "Channel Component Connect"
		}
		default {
			error "unkown Chan Comp Type"
		}
	}
	# switch -exact $ObjArr($ChanCompCanID,CompType)

	# determine title for different RecSyms
	##################################

	set dlg [Dialog .chan_comp_edit -parent . -modal local -title Edit -geometry 300x300+200+100]

	set dTitleFrame [TitleFrame [$dlg getframe].tf]
	$dTitleFrame configure -text $DlgTitle

	set sw [ScrolledWindow [$dTitleFrame getframe].sw -relief sunken -borderwidth 2]
	set dtext [text [$sw getframe].tx ]
	$sw setwidget $dtext

	$dtext delete 1.0 end
	$dtext insert 1.0 $ObjArr($ChanCompCanID,Text)

	pack $sw -fill both -expand true
	pack $dTitleFrame -fill both -expand true

	$dlg add -name ok
	$dlg add -name clear -text clear -command "$dtext delete 1.0 end"
	$dlg add -name cancel

	set DiaResult [$dlg draw]

	if { $DiaResult == 0 } {

		set NewText [string trimright [$dtext get 1.0 end]]

		::olSDL_Views::Channel::modify_ChanCompContent_in_Model_in_T_M_C $ObjArrName $CanInfoArr $ChanCompCanID $NewText

	}
	# if { $DiaResult == 0 }

	destroy $dlg
}
##############################################################################
proc ::olSDL_Views::Channel::show_MP_PopUpMenu {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	set x_in_can [expr int (round ($x))]
	set y_in_can [expr int (round ($y))]

	set PopUp_x [expr $x_in_can + [winfo rootx $CanvasPathName]]
	set PopUp_y [expr $y_in_can + [winfo rooty $CanvasPathName]]

	set InnerChanMP_Index [_get_ICMP_Index_from_MP $ObjArrName $CanInfoArr $currentObject]

	# unpost CM
	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr

	#####
	# prepare PopUp

	if { $InnerChanMP_Index == -1 } {

		set CanInfo(ICMP_del_ChanID) " "
		set CanInfo(ICMP_del_MP_Index) " "

		$CanInfo(menu_ChannelMP_PopUp) entryconfigure 0 -state disabled
	} else {

		set CanInfo(ICMP_del_ChanID) [_get_ChanID_from_MP $ObjArrName $CanInfoArr $currentObject]
		set CanInfo(ICMP_del_MP_Index) $InnerChanMP_Index

		$CanInfo(menu_ChannelMP_PopUp) entryconfigure 0 -state normal
	}


	# prepare PopUp
	#####

	$CanInfo(menu_ChannelMP_PopUp) post $PopUp_x $PopUp_y

}
##############################################################################
proc ::olSDL_Views::Channel::show_PopUpMenu {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	if { [info exists ObjArr($currentObject,Type)] } {
		if { $ObjArr($currentObject,Type) == "Channel" } {
			set Channel_ID $currentObject
		} else {
			error "no channel"
		}
	} else {
		set Channel_ID [_get_Channel_ID_from_Arrow $ObjArrName $CanInfoArr [$CanvasPathName find withtag current]]
	}

	# unpost CM
	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr

	# set selected
	::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $Channel_ID

	set x_in_can [expr int (round ($x))]
	set y_in_can [expr int (round ($y))]

	set CanInfo(PU_Chan_Current_X) $x_in_can
	set CanInfo(PU_Chan_Current_Y) $y_in_can

	set PopUp_x [expr $x_in_can + [winfo rootx $CanvasPathName]]
	set PopUp_y [expr $y_in_can + [winfo rooty $CanvasPathName]]

	#####
	# prepare PopUp

	set CanInfo(changeCT_Channel_ID) $Channel_ID

	set CanInfo(changeCT_DelayType) $ObjArr($Channel_ID,DelayType)
	set CanInfo(changeCT_DirectionType) $ObjArr($Channel_ID,DirectionType)

	if { $CanInfo(changeCT_DirectionType) == "both" } {

		set CanInfo(changeCT_DirectionTypeHelper) "bi"
		$CanInfo(menu_ChannelPopUp) entryconfigure 1 -state disabled

		$CanInfo(menu_ChannelPopUp) entryconfigure 6 -state normal
		$CanInfo(menu_ChannelPopUp) entryconfigure 7 -state normal
		$CanInfo(menu_ChannelPopUp) entryconfigure 8 -state normal
		$CanInfo(menu_ChannelPopUp) entryconfigure 9 -state normal

	} elseif { ($CanInfo(changeCT_DirectionType) == "from_source") || ($CanInfo(changeCT_DirectionType) == "from_destination") } {

		set CanInfo(changeCT_DirectionTypeHelper) "uni"
		$CanInfo(menu_ChannelPopUp) entryconfigure 1 -state normal

		if { ($CanInfo(changeCT_DirectionType) == "from_source") } {
			$CanInfo(menu_ChannelPopUp) entryconfigure 6 -state normal
			$CanInfo(menu_ChannelPopUp) entryconfigure 7 -state normal
			$CanInfo(menu_ChannelPopUp) entryconfigure 8 -state disabled
			$CanInfo(menu_ChannelPopUp) entryconfigure 9 -state disabled
		}

		if { ($CanInfo(changeCT_DirectionType) == "from_destination") } {
			$CanInfo(menu_ChannelPopUp) entryconfigure 6 -state disabled
			$CanInfo(menu_ChannelPopUp) entryconfigure 7 -state disabled
			$CanInfo(menu_ChannelPopUp) entryconfigure 8 -state normal
			$CanInfo(menu_ChannelPopUp) entryconfigure 9 -state normal
		}

	} else {
		error "wrong direction type"
	}

	set CanInfo(PU_Chan_Channel_ID) $Channel_ID

	set CanInfo(PU_Chan_NameID) [$CanvasPathName find withtag ChanName$Channel_ID]

	set ChanSourceID $ObjArr($Channel_ID,SourceID)
	if { $ChanSourceID == "ENV" } {
		set ChanSourceText "ENV"
	} else {
		set ChanSourceText $ObjArr($ChanSourceID,Text)
	}
	set CanInfo(PU_Chan_SourceSigID) [$CanvasPathName find withtag ChanSourceSig$Channel_ID]
	set CanInfo(PU_Chan_SourceConID) [$CanvasPathName find withtag ChanSourceCon$Channel_ID]

	set ChanDestID $ObjArr($Channel_ID,DestinationID)
	if { $ChanDestID == "ENV" } {
		set ChanDestText "ENV"
	} else {
		set ChanDestText $ObjArr($ChanDestID,Text)
	}
	set CanInfo(PU_Chan_DestSigID) [$CanvasPathName find withtag ChanDestSig$Channel_ID]
	set CanInfo(PU_Chan_DestConID) [$CanvasPathName find withtag ChanDestCon$Channel_ID]


	$CanInfo(menu_ChannelPopUp) entryconfigure 5 -label "Name HL"
	$CanInfo(menu_ChannelPopUp) entryconfigure 6 -label "[::olSDL_Views::cut_Text_for_ChanConMenu $ChanSourceText] Sig HL"
	$CanInfo(menu_ChannelPopUp) entryconfigure 7 -label "[::olSDL_Views::cut_Text_for_ChanConMenu $ChanSourceText] Con HL"
	$CanInfo(menu_ChannelPopUp) entryconfigure 8 -label "[::olSDL_Views::cut_Text_for_ChanConMenu $ChanDestText] Sig HL"
	$CanInfo(menu_ChannelPopUp) entryconfigure 9 -label "[::olSDL_Views::cut_Text_for_ChanConMenu $ChanDestText] Con HL"


	if { $ObjArr($CanInfo(PU_Chan_NameID),HL_Style) == $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::chan_membership } {
		set CanInfo(PU_Chan_hl_ChanName) 1
	} elseif { $ObjArr($CanInfo(PU_Chan_NameID),HL_Style) == $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal } {
		set CanInfo(PU_Chan_hl_ChanName) 0
	} else {
		error "unknown HL state"
	}

	if { $ObjArr($CanInfo(PU_Chan_SourceSigID),HL_Style) == $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::chan_membership } {
		set CanInfo(PU_Chan_hl_SourceSig) 1
	} elseif { $ObjArr($CanInfo(PU_Chan_SourceSigID),HL_Style) == $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal } {
			set CanInfo(PU_Chan_hl_SourceSig) 0
	} else {
		error "unknown HL state"
	}

	if { $ObjArr($CanInfo(PU_Chan_SourceConID),HL_Style) == $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::chan_membership } {
		set CanInfo(PU_Chan_hl_SourceCon) 1
	} elseif { $ObjArr($CanInfo(PU_Chan_SourceConID),HL_Style) == $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal } {
			set CanInfo(PU_Chan_hl_SourceCon) 0
	} else {
		error "unknown HL state"
	}

	if { $ObjArr($CanInfo(PU_Chan_DestSigID),HL_Style) == $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::chan_membership } {
		set CanInfo(PU_Chan_hl_DestSig) 1
	} elseif { $ObjArr($CanInfo(PU_Chan_DestSigID),HL_Style) == $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal } {
			set CanInfo(PU_Chan_hl_DestSig) 0
	} else {
		error "unknown HL state"
	}

	if { $ObjArr($CanInfo(PU_Chan_DestConID),HL_Style) == $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::chan_membership } {
		set CanInfo(PU_Chan_hl_DestCon) 1
	} elseif { $ObjArr($CanInfo(PU_Chan_DestConID),HL_Style) == $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal } {
			set CanInfo(PU_Chan_hl_DestCon) 0
	} else {
		error "unknown HL state"
	}

	# END: prepare PopUp
	#####

	$CanInfo(menu_ChannelPopUp) post $PopUp_x $PopUp_y
}
##############################################################################
proc ::olSDL_Views::Channel::OnChangeChannelType {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set CanvasState $CanInfo(state)

	########
	# read result from PopUp

	set Channel_ID $CanInfo(changeCT_Channel_ID)

	set ObjArr($Channel_ID,DelayType) $CanInfo(changeCT_DelayType)
	set ObjArr($Channel_ID,DirectionType) $CanInfo(changeCT_DirectionType)

	# read result from PopUp
	########


	modify_Chan_Type_in_Model $ObjArr($Channel_ID,Model_ID) \
		$ObjArr($Channel_ID,DelayType) $ObjArr($Channel_ID,DirectionType)


	########
	# draw channel

	::olSDL_ViewsDrawMethods::delete_ChannelComp_from_Canvas $ObjArrName $CanInfoArr $Channel_ID

	# draw Channel
	 ::olSDL_ViewsDrawMethods::draw_Channel $CanvasPathName \
		$ObjArr($Channel_ID,Coords) \
		$ObjArr($Channel_ID,DelayType) $ObjArr($Channel_ID,DirectionType) \
		true $Channel_ID NewChannel_ID

	# draw channel
	########
}
##############################################################################
##############################################################################
##############################################################################
proc ::olSDL_Views::Env::ClickOnEnvironment {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]
	set CanvasState $CanInfo(state)

	set x [expr int([$CanvasPathName canvasx $x])]
	set y [expr int([$CanvasPathName canvasy $y])]

	if { ! ($CanvasState == "connection") } {

		::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr
		::olSDL_Views::AllViews::delete_all_Selections $ObjArrName $CanInfoArr

		return
	}

	###############
	# case A
	###############

	if { ! ($CanInfo(connect_afterSource)) } {
		::olSDL_Views::Channel::_init_ConnectHelperObjects $ObjArrName $CanInfoArr $currentObject true $x $y
		return
	}

	###############
	# case B
	###############

	if { $CanInfo(connect_afterSource) && (! ($CanInfo(connect_Source_is_Env)) ) } {

		if { $CanInfo(connect_afterFirstPart) } {
			###############
			# case B.1
			###############

			set ConPointB [::olSDL_ViewsCalcCoor::calc_ConnPointOnBorderToEnv $CanInfo(PageFramePaS) $x $y]

			set EndLinieCoords { }
			lappend EndLinieCoords [expr [llength $CanInfo(connect_ChannelCoords)] -2]
			lappend EndLinieCoords [expr [llength $CanInfo(connect_ChannelCoords)] -1]
			set EndLinieCoords [concat $EndLinieCoords $ConPointB]

			if { ! [::olSDL_ViewsDrawMethods::valid_Channel_Part $EndLinieCoords] } {
				return
			}

			set CanInfo(connect_ChannelCoords) [concat $CanInfo(connect_ChannelCoords) $ConPointB]
			set CanInfo(connect_Destination_ID) "ENV"
			set CanInfo(connect_Destination_is_Env) true

		} else {
			###############
			# case B.2
			###############

			set ConPointB [::olSDL_ViewsCalcCoor::calc_ConnPointOnBorderToEnv $CanInfo(PageFramePaS) $x $y]

			set ConPointA [::olSDL_ViewsCalcCoor::calc_ConnectionPointOnRecSym $CanInfo(connect_SourcePaS) \
				$CanInfo(connect_Source_x) $CanInfo(connect_Source_y) \
				[lindex $ConPointB 0] [lindex $ConPointB 1] ]

			set StartLinieCoords [concat $ConPointA $ConPointB]

			if { ! [::olSDL_ViewsDrawMethods::valid_Channel_Part $StartLinieCoords] } {
				return
			}

			set CanInfo(connect_ChannelCoords) $StartLinieCoords
			set CanInfo(connect_Destination_ID) "ENV"
			set CanInfo(connect_Destination_is_Env) true

		}

		###########################
		##### DRAW + UPDATE
		###########################

		set Diagram_ID $CanInfo(Dia_Model_ID)
		set PageID $CanInfo(PageID)

		set CanInfo(connect_DelayType) $::olSDL_Views::default_ChannelDelayType
		set CanInfo(connect_DirectionType) $::olSDL_Views::default_ChannelDirectionType

		set ChanNamePaS [concat [::olSDL_Views::Channel::calc_PositionOfChannelName $CanInfo(connect_ChannelCoords)] \
			$::olSDL_ViewsDrawMethods::default_Size_ChannelName]
		set ChanSourceSigPaS [concat [::olSDL_Views::Channel::calc_PositionOfChanSourceSig $CanInfo(connect_ChannelCoords)] \
			$::olSDL_ViewsDrawMethods::default_Size_ChannelSig]
		set ChanDestSigPaS [concat [::olSDL_Views::Channel::calc_PositionOfChanDestSig $CanInfo(connect_ChannelCoords)] \
			$::olSDL_ViewsDrawMethods::default_Size_ChannelSig]
		set ChanSourceConPaS [concat [::olSDL_Views::Channel::calc_PositionOfChanSourceCon $CanInfo(connect_ChannelCoords)] \
			$::olSDL_ViewsDrawMethods::default_Size_ChannelCon]
		set ChanDestConPaS [concat [::olSDL_Views::Channel::calc_PositionOfChanDestCon $CanInfo(connect_ChannelCoords)] \
			$::olSDL_ViewsDrawMethods::default_Size_ChannelCon]

		#################
		# draw channel and components


		::olSDL_ViewsDrawMethods::draw_Channel $CanvasPathName $CanInfo(connect_ChannelCoords) \
			$CanInfo(connect_DelayType) $CanInfo(connect_DirectionType) false dummy NewCanChannel_ID

			#####

		set NewChanNameID ""
		::olSDL_ViewsDrawMethods::draw_ChannelName $CanvasPathName $NewCanChannel_ID $ChanNamePaS \
			$::olSDL_ViewsDrawMethods::default_Text_ChanName false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanNameID

			#####

		set NewChanSourceSigID ""
		::olSDL_ViewsDrawMethods::draw_ChanSourceSig $CanvasPathName $NewCanChannel_ID $ChanSourceSigPaS \
			$::olSDL_ViewsDrawMethods::default_Text_ChanSourceSig false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanSourceSigID

		set NewChanDestSigID ""
		::olSDL_ViewsDrawMethods::draw_ChanDestSig $CanvasPathName $NewCanChannel_ID $ChanDestSigPaS \
			$::olSDL_ViewsDrawMethods::default_Text_ChanDestSig false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanDestSigID

			#####

		set NewChanSourceConID ""
		::olSDL_ViewsDrawMethods::draw_ChanSourceCon $CanvasPathName $NewCanChannel_ID $ChanSourceConPaS \
			$::olSDL_ViewsDrawMethods::default_Text_ChanSourceCon false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanSourceConID

		set NewChanDestConID ""
		::olSDL_ViewsDrawMethods::draw_ChanDestCon $CanvasPathName $NewCanChannel_ID $ChanDestConPaS \
			$::olSDL_ViewsDrawMethods::default_Text_ChanDestCon false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanDestConID

		# draw channel and components
		#################

		#############
		# store channel in Tcl and Model

		::olSDL_Views::Channel::store_Chan_and_Comp_in_Tcl_and_Model $ObjArrName $CanInfoArr \
			$Diagram_ID $PageID $NewCanChannel_ID \
			$CanInfo(connect_DelayType) $CanInfo(connect_DirectionType) \
			$CanInfo(connect_Source_ID) $CanInfo(connect_Destination_ID) \
			$CanInfo(connect_ChannelCoords) \
			$NewChanNameID $::olSDL_ViewsDrawMethods::default_Text_ChanName $ChanNamePaS \
			$NewChanSourceSigID $::olSDL_ViewsDrawMethods::default_Text_ChanSourceSig $ChanSourceSigPaS \
			$NewChanSourceConID $::olSDL_ViewsDrawMethods::default_Text_ChanSourceCon $ChanSourceConPaS \
			$NewChanDestSigID $::olSDL_ViewsDrawMethods::default_Text_ChanDestSig $ChanDestSigPaS \
			$NewChanDestConID $::olSDL_ViewsDrawMethods::default_Text_ChanDestCon $ChanDestConPaS

		# store channel in Tcl and Model
		#############

		# delete Helper Objects
		::olSDL_Views::Channel::delete_ConnectionHelperObjects $CanInfoArr

		# change canvas mode
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy

		###########################
		##### END: DRAW + UPDATE
		###########################

		return
	}
	# if { $CanInfo(connect_afterSource) && (! ($CanInfo(connect_Source_is_Env)) ) }
}
##############################################################################
# T_M_C - methods
##############################################################################
proc ::olSDL_Views::Channel::modify_ChanCompContent_in_Model_in_T_M_C {ObjArrName CanInfoArr ChanCompCanID NewContent} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	::olSDL_Views::Channel::get_ChanID_and_ChanCompType_from_ChanComp $ObjArrName $CanInfoArr $ChanCompCanID Channel_ID dummy

	##############
	# tcl

	set ObjArr($ChanCompCanID,Text) $NewContent

	# tcl
	##############

	##############
	# model

	modify_ChanComp_in_Model $ObjArr($ChanCompCanID,Model_ID) $ObjArr($ChanCompCanID,CompType) \
		$ObjArr($ChanCompCanID,Text) $ObjArr($ChanCompCanID,PaS)

	# model
	##############

	##############
	# canvas

	::olSDL_ViewsDrawMethods::delete_ChanComp_Comp_from_Canvas $ObjArrName $CanInfoArr $ChanCompCanID

	switch -exact $ObjArr($ChanCompCanID,CompType) {
		ChanName {
			::olSDL_ViewsDrawMethods::draw_ChannelName $CanvasPathName $Channel_ID \
				$ObjArr($ChanCompCanID,PaS) $ObjArr($ChanCompCanID,Text) true $ChanCompCanID \
				$ObjArr($ChanCompCanID,HL_Style) CanObjID
		}
		ChanSourceSig {
			::olSDL_ViewsDrawMethods::draw_ChanSourceSig $CanvasPathName $Channel_ID \
				$ObjArr($ChanCompCanID,PaS) $ObjArr($ChanCompCanID,Text) true $ChanCompCanID \
				$ObjArr($ChanCompCanID,HL_Style) CanObjID
		}
		ChanDestSig {
			::olSDL_ViewsDrawMethods::draw_ChanDestSig $CanvasPathName $Channel_ID \
				$ObjArr($ChanCompCanID,PaS) $ObjArr($ChanCompCanID,Text) true $ChanCompCanID \
				$ObjArr($ChanCompCanID,HL_Style) CanObjID
		}
		ChanSourceCon {
			::olSDL_ViewsDrawMethods::draw_ChanSourceCon $CanvasPathName $Channel_ID \
				$ObjArr($ChanCompCanID,PaS) $ObjArr($ChanCompCanID,Text) true $ChanCompCanID \
				$ObjArr($ChanCompCanID,HL_Style) CanObjID
		}
		ChanDestCon {
			::olSDL_ViewsDrawMethods::draw_ChanDestCon $CanvasPathName $Channel_ID \
				$ObjArr($ChanCompCanID,PaS) $ObjArr($ChanCompCanID,Text) true $ChanCompCanID \
				$ObjArr($ChanCompCanID,HL_Style) CanObjID
		}
		default {
			error "unkown Chan Comp Type"
		}
	}

	# canvas
	##############
}
##############################################################################
proc ::olSDL_Views::Channel::modify_ChanComp_PaS_in_T_M_C {ActionType ObjArrName CanInfoArr ChanCompCanID NewCoords} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ($ActionType != "scale")  && ($ActionType != "move") } {
		error "unknown action type"
		return
	}

	set NewPaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $NewCoords]
	set OldPaS $ObjArr($ChanCompCanID,PaS)

	##############
	# canvas
	if { $ActionType == "move" } {
		set dx [expr [lindex $NewPaS 0] - [lindex $OldPaS 0]]
		set dy [expr [lindex $NewPaS 1] - [lindex $OldPaS 1]]
		$CanvasPathName	move PartOfChanComp$ChanCompCanID $dx $dy
		$CanvasPathName	move $ChanCompCanID $dx $dy
	} else {
		set dx [expr double([lindex $NewPaS 2]) / [lindex $OldPaS 2]]
		set dy [expr double([lindex $NewPaS 3]) / [lindex $OldPaS 3]]
		if {[lindex $NewPaS 0] == [lindex $OldPaS 0]} {
		  set origx [lindex $OldPaS 0]
		} else {
		  set origx [expr [lindex $OldPaS 0]+[lindex $OldPaS 2]]
		}
		if {[lindex $NewPaS 1] == [lindex $OldPaS 1]} {
		  set origy [lindex $OldPaS 1]
		} else {
		  set origy [expr [lindex $OldPaS 1]+[lindex $OldPaS 3]]
		}
		$CanvasPathName	scale PartOfChanComp$ChanCompCanID $origx $origy $dx $dy
		$CanvasPathName	scale $ChanCompCanID $origx $origy $dx $dy
	}
	# canvas
	##############

	##############
	# tcl

	set ObjArr($ChanCompCanID,PaS) $NewPaS
	if { $ActionType == "scale" } {
		::olSDL_Views::Channel::modify_ChanCompContent_in_Model_in_T_M_C $ObjArrName $CanInfoArr $ChanCompCanID $ObjArr($ChanCompCanID,Text)
	}

	# tcl
	##############

	##############
	# model

	set ChanComp_Model_ID $ObjArr($ChanCompCanID,Model_ID)

	modify_ChanComp_in_Model $ChanComp_Model_ID $ObjArr($ChanCompCanID,CompType) \
		$ObjArr($ChanCompCanID,Text) $ObjArr($ChanCompCanID,PaS)

	# model
	##############
}
##############################################################################
proc ::olSDL_Views::Channel::delete_Chan_and_all_Comp_from_T_M_C {ObjArrName CanInfoArr ChanCanID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set AllChanCompIDs [::olSDL_Views::Channel::_get_IDs_from_all_ChanComp $ObjArrName $CanInfoArr $ChanCanID]

	##############
	# canvas

	::olSDL_ViewsDrawMethods::delete_Chan_and_all_Comp_from_Canvas $ObjArrName $CanInfoArr $ChanCanID

	# canvas
	##############

	##############
	# tcl, model

	::olSDL_Views::Channel::delete_Chan_and_all_Comp_from_Tcl_and_Model $ObjArrName $CanInfoArr $ChanCanID $AllChanCompIDs

	# tcl, model
	##############
}
##############################################################################
# END: T_M_C - methods
##############################################################################

