package provide olSDL_ViewsChan 1

namespace eval olSDL_Views {
	namespace eval Channel {
	}
}

##############################################################################
# methods for Channel Components like Channel Name, Channel Signal List etc.
##############################################################################

proc ::olSDL_Views::Channel::EnterRecChanComp {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	if { [lsearch $CanInfo(selObj) $currentObject] != -1 } {
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Selected
	}
}
##############################################################################
proc ::olSDL_Views::Channel::LeaveRecChanComp {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	if { [lsearch $CanInfo(selObj) $currentObject] != -1 } {
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
	}
}

##############################################################################
proc ::olSDL_Views::Channel::ClickOnRecChanComp {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasState $CanInfo(state)
	set CanvasPathName $CanInfo(CanvasPathName)

	set x [expr int([$CanvasPathName canvasx $x])]
	set y [expr int([$CanvasPathName canvasy $y])]

	set currentObject [$CanvasPathName find withtag current]

	######## case A ###########

	if { ($CanvasState == "single_obj_selected") || ($CanvasState == "normal") } {

		::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr
		::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $currentObject

		return
	}
	# if
}
##############################################################################
proc ::olSDL_Views::Channel::DeleteInnerChanMP {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)


	set Channel_ID $CanInfo(ICMP_del_ChanID)

	set DeleteIndex $CanInfo(ICMP_del_MP_Index)

	set OldChannelCoords $ObjArr($Channel_ID,Coords)

	set NewCoords [lreplace $OldChannelCoords [expr $DeleteIndex * 2] [expr ($DeleteIndex * 2) +1] ]

	#####
	::olSDL_Views::AllViews::delete_all_Selections $ObjArrName $CanInfoArr
	#####

	# delete old channel comp
	::olSDL_ViewsDrawMethods::delete_ChannelComp_from_Canvas $ObjArrName $CanInfoArr $Channel_ID

	# store new Coords
	::olSDL_Views::Channel::store_ChanCoords_in_Tcl_and_Model $ObjArrName $CanInfoArr $Channel_ID $NewCoords

	# draw Channel
 	::olSDL_ViewsDrawMethods::draw_Channel $CanvasPathName \
		$ObjArr($Channel_ID,Coords) $ObjArr($Channel_ID,DelayType) $ObjArr($Channel_ID,DirectionType) \
		true $Channel_ID NewChannel_ID

	# draw Channel MP
	::olSDL_ViewsDrawMethods::draw_Channel_MovePoints $ObjArrName $CanInfoArr $Channel_ID

	lappend CanInfo(selObj) $Channel_ID

}
##############################################################################
proc ::olSDL_Views::Channel::AddInnerChanMP {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set Channel_ID $CanInfo(PU_Chan_Channel_ID)
	set Current_X $CanInfo(PU_Chan_Current_X)
	set Current_Y $CanInfo(PU_Chan_Current_Y)

	set OldChannelCoords $ObjArr($Channel_ID,Coords)

	##################
	::olSDL_Views::AllViews::delete_all_Selections $ObjArrName $CanInfoArr
	##################


	##################
	# delete old MP

	::olSDL_ViewsDrawMethods::delete_Channel_MP_from_Canvas $ObjArrName $CanInfoArr $Channel_ID

	# END: delete old MP
	##################

	##################
	# MP already exists ?

	if { [::olSDL_Views::_ChanMP_exists $OldChannelCoords $Current_X $Current_Y] } {

		::olSDL_Dialogs::MP_PositionNotAllowed
		return
	}

	# END: MP already exists ?
	##################

	##################
	# valid Channel Parts

	foreach {MP_x MP_y} $OldChannelCoords {

		set TempChannelPartCoords [list $MP_x $MP_y $Current_X $Current_Y]

		if { ! [::olSDL_ViewsDrawMethods::valid_Channel_Part $TempChannelPartCoords] } {

			::olSDL_Dialogs::MP_PositionNotAllowed
			return
		}
	}

	# END: valid Channel Parts
	##################


	set InsertIndex [::olSDL_Views::_get_Index_ClosestChannelPart $ObjArrName $CanInfoArr $OldChannelCoords $Current_X $Current_Y]

	set NewCoords [linsert $OldChannelCoords [expr ($InsertIndex +1)*2] $Current_X $Current_Y]

	# delete old channel comp
	::olSDL_ViewsDrawMethods::delete_ChannelComp_from_Canvas $ObjArrName $CanInfoArr $Channel_ID

	# store new Coords
	::olSDL_Views::Channel::store_ChanCoords_in_Tcl_and_Model $ObjArrName $CanInfoArr $Channel_ID $NewCoords

	# draw Channel
 	::olSDL_ViewsDrawMethods::draw_Channel $CanvasPathName \
		$ObjArr($Channel_ID,Coords) $ObjArr($Channel_ID,DelayType) $ObjArr($Channel_ID,DirectionType) \
		true $Channel_ID NewChannel_ID

	# draw Channel MP
	::olSDL_ViewsDrawMethods::draw_Channel_MovePoints $ObjArrName $CanInfoArr $Channel_ID

	lappend CanInfo(selObj) $Channel_ID

}
##############################################################################
proc ::olSDL_Views::Channel::ResetAllChanCompHighLight {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	###########
	set ObjArr($CanInfo(PU_Chan_NameID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal

	::olSDL_ViewsDrawMethods::delete_ChanComp_Comp_from_Canvas $ObjArrName $CanInfoArr $CanInfo(PU_Chan_NameID)

	olSDL_ViewsDrawMethods::draw_ChannelName $CanvasPathName \
		$CanInfo(PU_Chan_Channel_ID) \
		$ObjArr($CanInfo(PU_Chan_NameID),PaS) $ObjArr($CanInfo(PU_Chan_NameID),Text) \
		true $CanInfo(PU_Chan_NameID) \
		$ObjArr($CanInfo(PU_Chan_NameID),HL_Style) dummy

	###########
	set ObjArr($CanInfo(PU_Chan_SourceSigID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal

	::olSDL_ViewsDrawMethods::delete_ChanComp_Comp_from_Canvas $ObjArrName $CanInfoArr $CanInfo(PU_Chan_SourceSigID)

	olSDL_ViewsDrawMethods::draw_ChanSourceSig $CanvasPathName \
		$CanInfo(PU_Chan_Channel_ID) \
		$ObjArr($CanInfo(PU_Chan_SourceSigID),PaS) $ObjArr($CanInfo(PU_Chan_SourceSigID),Text) \
		true $CanInfo(PU_Chan_SourceSigID) \
		$ObjArr($CanInfo(PU_Chan_SourceSigID),HL_Style) dummy

	###########
	set ObjArr($CanInfo(PU_Chan_SourceConID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal

	::olSDL_ViewsDrawMethods::delete_ChanComp_Comp_from_Canvas $ObjArrName $CanInfoArr $CanInfo(PU_Chan_SourceConID)

	olSDL_ViewsDrawMethods::draw_ChanSourceCon $CanvasPathName \
		$CanInfo(PU_Chan_Channel_ID) \
		$ObjArr($CanInfo(PU_Chan_SourceConID),PaS) $ObjArr($CanInfo(PU_Chan_SourceConID),Text) \
		true $CanInfo(PU_Chan_SourceConID) \
		$ObjArr($CanInfo(PU_Chan_SourceConID),HL_Style) dummy

	###########
	set ObjArr($CanInfo(PU_Chan_DestSigID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal

	::olSDL_ViewsDrawMethods::delete_ChanComp_Comp_from_Canvas $ObjArrName $CanInfoArr $CanInfo(PU_Chan_DestSigID)

	olSDL_ViewsDrawMethods::draw_ChanDestSig $CanvasPathName \
		$CanInfo(PU_Chan_Channel_ID) \
		$ObjArr($CanInfo(PU_Chan_DestSigID),PaS) $ObjArr($CanInfo(PU_Chan_DestSigID),Text) \
		true $CanInfo(PU_Chan_DestSigID) \
		$ObjArr($CanInfo(PU_Chan_DestSigID),HL_Style) dummy

	###########
	set ObjArr($CanInfo(PU_Chan_DestConID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal

	::olSDL_ViewsDrawMethods::delete_ChanComp_Comp_from_Canvas $ObjArrName $CanInfoArr $CanInfo(PU_Chan_DestConID)

	olSDL_ViewsDrawMethods::draw_ChanDestCon $CanvasPathName \
		$CanInfo(PU_Chan_Channel_ID) \
		$ObjArr($CanInfo(PU_Chan_DestConID),PaS) $ObjArr($CanInfo(PU_Chan_DestConID),Text) \
		true $CanInfo(PU_Chan_DestConID) \
		$ObjArr($CanInfo(PU_Chan_DestConID),HL_Style) dummy

	###########
}
##############################################################################
proc ::olSDL_Views::Channel::OnChangeChanCompHighLight {ObjArrName CanInfoArr Type} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set dummy ""

	switch -exact $Type {
		ChanName {
			set temp_ChanCompID $CanInfo(PU_Chan_NameID)

			::olSDL_ViewsDrawMethods::delete_ChanComp_Comp_from_Canvas $ObjArrName $CanInfoArr $temp_ChanCompID

			if { $CanInfo(PU_Chan_hl_ChanName) } {
				set ObjArr($CanInfo(PU_Chan_NameID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::chan_membership
			} else {
				set ObjArr($CanInfo(PU_Chan_NameID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal
			}
			olSDL_ViewsDrawMethods::draw_ChannelName $CanvasPathName \
				$CanInfo(PU_Chan_Channel_ID) \
				$ObjArr($CanInfo(PU_Chan_NameID),PaS) $ObjArr($CanInfo(PU_Chan_NameID),Text) \
				true $CanInfo(PU_Chan_NameID) \
				$ObjArr($CanInfo(PU_Chan_NameID),HL_Style) dummy
		}
		SourceSig {
			set temp_ChanCompID $CanInfo(PU_Chan_SourceSigID)

			::olSDL_ViewsDrawMethods::delete_ChanComp_Comp_from_Canvas $ObjArrName $CanInfoArr $temp_ChanCompID

			if { $CanInfo(PU_Chan_hl_SourceSig) } {
				set ObjArr($CanInfo(PU_Chan_SourceSigID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::chan_membership
			} else {
				set ObjArr($CanInfo(PU_Chan_SourceSigID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal
			}
			olSDL_ViewsDrawMethods::draw_ChanSourceSig $CanvasPathName \
				$CanInfo(PU_Chan_Channel_ID) \
				$ObjArr($CanInfo(PU_Chan_SourceSigID),PaS) $ObjArr($CanInfo(PU_Chan_SourceSigID),Text) \
				true $CanInfo(PU_Chan_SourceSigID) \
				$ObjArr($CanInfo(PU_Chan_SourceSigID),HL_Style) dummy
		}
		SourceCon {
			set temp_ChanCompID $CanInfo(PU_Chan_SourceConID)

			::olSDL_ViewsDrawMethods::delete_ChanComp_Comp_from_Canvas $ObjArrName $CanInfoArr $temp_ChanCompID

			if { $CanInfo(PU_Chan_hl_SourceCon) } {
				set ObjArr($CanInfo(PU_Chan_SourceConID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::chan_membership
			} else {
				set ObjArr($CanInfo(PU_Chan_SourceConID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal
			}
			olSDL_ViewsDrawMethods::draw_ChanSourceCon $CanvasPathName \
				$CanInfo(PU_Chan_Channel_ID) \
				$ObjArr($CanInfo(PU_Chan_SourceConID),PaS) $ObjArr($CanInfo(PU_Chan_SourceConID),Text) \
				true $CanInfo(PU_Chan_SourceConID) \
				$ObjArr($CanInfo(PU_Chan_SourceConID),HL_Style) dummy
		}
		DestSig {
			set temp_ChanCompID $CanInfo(PU_Chan_DestSigID)

			::olSDL_ViewsDrawMethods::delete_ChanComp_Comp_from_Canvas $ObjArrName $CanInfoArr $temp_ChanCompID

			if { $CanInfo(PU_Chan_hl_DestSig) } {
				set ObjArr($CanInfo(PU_Chan_DestSigID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::chan_membership
			} else {
				set ObjArr($CanInfo(PU_Chan_DestSigID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal
			}
			olSDL_ViewsDrawMethods::draw_ChanDestSig $CanvasPathName \
				$CanInfo(PU_Chan_Channel_ID) \
				$ObjArr($CanInfo(PU_Chan_DestSigID),PaS) $ObjArr($CanInfo(PU_Chan_DestSigID),Text) \
				true $CanInfo(PU_Chan_DestSigID) \
				$ObjArr($CanInfo(PU_Chan_DestSigID),HL_Style) dummy
		}
		DestCon {
			set temp_ChanCompID $CanInfo(PU_Chan_DestConID)

			::olSDL_ViewsDrawMethods::delete_ChanComp_Comp_from_Canvas $ObjArrName $CanInfoArr $temp_ChanCompID

			if { $CanInfo(PU_Chan_hl_DestCon) } {
				set ObjArr($CanInfo(PU_Chan_DestConID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::chan_membership
			} else {
				set ObjArr($CanInfo(PU_Chan_DestConID),HL_Style) $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal
			}
			olSDL_ViewsDrawMethods::draw_ChanDestCon $CanvasPathName \
				$CanInfo(PU_Chan_Channel_ID) \
				$ObjArr($CanInfo(PU_Chan_DestConID),PaS) $ObjArr($CanInfo(PU_Chan_DestConID),Text) \
				true $CanInfo(PU_Chan_DestConID) \
				$ObjArr($CanInfo(PU_Chan_DestConID),HL_Style) dummy
		}
		default {
			error "unknown command source"
		}
	}
	# switch -exact $Type

}
##############################################################################


	###################
	# HELPER
	###################

####################################################
proc ::olSDL_Views::Channel::calc_PositionOfChannelName {Coords} {

	if { [llength $Coords] < 4 } {
		error "no line coords"
		return
	}

	if { [llength $Coords] == 4 } {
		return [::olSDL_ViewsCalcCoor::calc_CenterOfLineSegment $Coords]
	}

	set LineSegIndex [expr ([llength $Coords] - 2) / 2 ]
	set LineSegIndex [expr ($LineSegIndex / 2.0) + 0.1 ]
	set LineSegIndex [expr int(round ($LineSegIndex)) ]

	set Index [expr ($LineSegIndex - 1) * 2]

	return [::olSDL_ViewsCalcCoor::calc_CenterOfLineSegment [lrange $Coords $Index [expr $Index + 3]] ]
}
####################################################
proc ::olSDL_Views::Channel::calc_PositionOfChanSourceCon {Coords} {

	if { [llength $Coords] < 4 } {
		error "no line coords"
		return
	}

	set length [llength $Coords]

	return [lrange $Coords [expr $length - 2] [expr $length - 1] ]
}
####################################################
proc ::olSDL_Views::Channel::calc_PositionOfChanSourceSig {Coords} {

	if { [llength $Coords] < 4 } {
		error "no line coords"
		return
	}

	if { [llength $Coords] == 4 } {
		set Center [::olSDL_ViewsCalcCoor::calc_CenterOfLineSegment $Coords]
		return [::olSDL_ViewsCalcCoor::calc_CenterOfLineSegment [concat $Center [lrange $Coords 2 3]] ]
	}

	set length [llength $Coords]
	return [::olSDL_ViewsCalcCoor::calc_CenterOfLineSegment [lrange $Coords [expr $length -4 ] [expr $length -1]]  ]
}
####################################################
proc ::olSDL_Views::Channel::calc_PositionOfChanDestCon {Coords} {

	if { [llength $Coords] < 4 } {
		error "no line coords"
		return
	}

	return [lrange $Coords 0 1]
}
####################################################
proc ::olSDL_Views::Channel::calc_PositionOfChanDestSig {Coords} {

	if { [llength $Coords] < 4 } {
		error "no line coords"
		return
	}

	if { [llength $Coords] == 4 } {
		set Center [::olSDL_ViewsCalcCoor::calc_CenterOfLineSegment $Coords]
		return [::olSDL_ViewsCalcCoor::calc_CenterOfLineSegment [concat [lrange $Coords 0 1] $Center] ]
	}

	return [::olSDL_ViewsCalcCoor::calc_CenterOfLineSegment [lrange $Coords 0 3] ]

}

##############################################################################
# END: methods for Channel Components like Channel Name, Channel Signal List etc.
##############################################################################

##############################################################################
# methods for Resize Points of Channel Components like Channel Name, Channel Signal List etc.
##############################################################################

##############################################################################
proc ::olSDL_Views::Channel::RP_StartResize {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)
	set currentObject [$CanvasPathName find withtag current]

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	::olSDL_Views::RecObjRP::init_ResizeHelperObjects $ObjArrName $CanInfoArr

	set Resize_start_x [expr int([$CanvasPathName canvasx $x])]
	set Resize_start_y [expr int([$CanvasPathName canvasy $y])]

 	set CanInfo(Resize_ActionType) [::olSDL_Views::RecObjRP::determine_ResizeActionType $ObjArrName $CanInfoArr $currentObject]
	set CanInfo(Resize_PointParentID) [::olSDL_Views::RecObjRP::get_Parent_from_ResizePoint $ObjArrName $CanInfoArr $currentObject]

	set ResizeFrameCoords [::olSDL_Views::RecObjRP::calc_ResizeFrameCoords \
		$ObjArrName $CanInfoArr $Resize_start_x $Resize_start_y]

	set ResizeFrame [$CanvasPathName create rectangle $ResizeFrameCoords -dash {2 4} -width 2]

	set CanInfo(Resize_FrameID) $ResizeFrame
}
##############################################################################
proc ::olSDL_Views::Channel::RP_ProcessResize {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	set Resize_current_x [expr int([$CanvasPathName canvasx $x])]
	set Resize_current_y [expr int([$CanvasPathName canvasy $y])]

	set ResizeFrameCoords [::olSDL_Views::RecObjRP::calc_ResizeFrameCoords \
		$ObjArrName $CanInfoArr $Resize_current_x $Resize_current_y]

	$CanvasPathName coords $CanInfo(Resize_FrameID) $ResizeFrameCoords
}
##############################################################################
proc ::olSDL_Views::Channel::RP_EndResize {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	set Parent_ID $CanInfo(Resize_PointParentID)

	set ResizeFrameCoords { }
	set ResizeFrameCoords [$CanvasPathName coords $CanInfo(Resize_FrameID)]
	set ResizeFrameCoords [::olSDL_ViewsCalcCoor::convert_to_IntList $ResizeFrameCoords]

	####################
	# admissible new size ?
	if  {! [::olSDL_Views::admissibleRecObjSize $ResizeFrameCoords]}  {
		::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
		return
	}
	# END: admissible new size ?
	####################

	####################
	# object still in Page ?

	set tempPageCoords [list 0 0 $CanInfo(PageWidth) $CanInfo(PageHeight)]
	if {! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $tempPageCoords $ResizeFrameCoords]} {
		::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
		return
	}

	# END: object still in Page ?
	####################

	####################
	#	RESIZE
	####################

	set temp_old_PaS $ObjArr($CanInfo(Resize_PointParentID),PaS)
	set temp_new_PaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $ResizeFrameCoords]

	####################
	#  "move" symbol

	# tcl, model, canvas
	::olSDL_Views::Channel::modify_ChanComp_PaS_in_T_M_C "scale" $ObjArrName $CanInfoArr $CanInfo(Resize_PointParentID) $ResizeFrameCoords

	# "move" symbol
	####################

	####################
	#  "move" Resize Points

	 ::olSDL_ViewsDrawMethods::delete_ChanComp_RP_from_Canvas $ObjArrName $CanInfoArr $CanInfo(Resize_PointParentID)

	::olSDL_ViewsDrawMethods::draw_RecChanComp_ResizePoints $ObjArrName $CanInfoArr $CanInfo(Resize_PointParentID)

	#  "move" Resize Points
	####################

	 ::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
}
##############################################################################
# END: methods for Resize Points of Channel Components like Channel Name, Channel Signal List etc.
##############################################################################

##############################################################################
# methods for Moving Channel Components like Channel Name, Channel Signal List etc.
##############################################################################

##############################################################################
proc ::olSDL_Views::Channel::StartChanCompMove {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasState $CanInfo(state)
	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	::olSDL_Views::MoveRecSym::_init_MoveHelperObjects $ObjArrName $CanInfoArr

	set Move_start_x [expr int([$CanvasPathName canvasx $x])]
	set Move_start_y [expr int([$CanvasPathName canvasy $y])]

	set CanInfo(Move_start_x) $Move_start_x
	set CanInfo(Move_start_y) $Move_start_y
	set CanInfo(Move_MovedObjID) $currentObject

	#create MoveFrame, but in state hidden
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $ObjArr($CanInfo(Move_MovedObjID),PaS) \
		MoveFrame_x1 MoveFrame_y1 MoveFrame_x2 MoveFrame_y2

	set MoveFrame [$CanvasPathName create rectangle $MoveFrame_x1 $MoveFrame_y1 $MoveFrame_x2 $MoveFrame_y2 -state hidden -dash {2 4} -width 2]
	set CanInfo(Move_MoveFrameID) $MoveFrame
}
##############################################################################
proc ::olSDL_Views::Channel::ProcessChanCompMove {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	set CanInfo(Move_Obj_moved) true

	set move_dx [expr int([$CanvasPathName canvasx $x] - $CanInfo(Move_start_x))]
	set move_dy [expr int([$CanvasPathName canvasy $y] - $CanInfo(Move_start_y))]

	$CanvasPathName itemconfigure $CanInfo(Move_MoveFrameID) -state normal
	$CanvasPathName move $CanInfo(Move_MoveFrameID) $move_dx $move_dy

	set CanInfo(Move_start_x) [expr $CanInfo(Move_start_x) + $move_dx]
	set CanInfo(Move_start_y) [expr $CanInfo(Move_start_y) + $move_dy]
}
##############################################################################
proc ::olSDL_Views::Channel::EndChanCompMove {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { $CanvasState == "flowline" } {
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
		return
	}

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	if { ! $CanInfo(Move_Obj_moved) } {
		::olSDL_Views::MoveRecSym::_delete_MoveHelperObjects $CanInfoArr
		return
	}

	set MoveFrameCoords [$CanvasPathName coords $CanInfo(Move_MoveFrameID)]
	set MoveFrameCoords [::olSDL_ViewsCalcCoor::convert_to_IntList $MoveFrameCoords]

	####################
	# object still on Page?

	set tempPageCoords [list 0 0 $CanInfo(PageWidth) $CanInfo(PageHeight)]
	if {! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $tempPageCoords $MoveFrameCoords]} {
		::olSDL_Views::MoveRecSym::_delete_MoveHelperObjects $CanInfoArr
		return
	}

	# END: object still on Page?
	####################

	####################
	# MOVE
	####################

	set temp_old_PaS $ObjArr($CanInfo(Move_MovedObjID),PaS)
	set temp_new_PaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $MoveFrameCoords]

	####################
	# "move" symbol

	# tcl, model, canvas
	::olSDL_Views::Channel::modify_ChanComp_PaS_in_T_M_C "move" $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID) $MoveFrameCoords

	# "move" symbol
	####################

	####################
	# "move" ResizePoints

	::olSDL_ViewsDrawMethods::delete_ChanComp_RP_from_Canvas $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID)

	::olSDL_ViewsDrawMethods::draw_RecChanComp_ResizePoints $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID)

	# "move" ResizePoints
	####################

	::olSDL_Views::MoveRecSym::_delete_MoveHelperObjects $CanInfoArr
}
##############################################################################
# END: methods for Moving Channel Components like Channel Name, Channel Signal List etc.
##############################################################################

##############################################################################
proc ::olSDL_Views::Channel::MoveChanComp_OuterMP {ObjArrName CanInfoArr Channel_ID MP_Index new_x new_y PageWidth PageHeight} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set ModifyIndex [expr $MP_Index * 2]

	::olSDL_Views::Channel::MoveChanComps_MP $ObjArrName $CanInfoArr $Channel_ID \
		[lreplace $ObjArr($Channel_ID,Coords) $ModifyIndex [expr $ModifyIndex + 1] $new_x $new_y] \
		$PageWidth $PageHeight

}
##############################################################################
proc ::olSDL_Views::Channel::MoveChanComp_InnerMP {ObjArrName CanInfoArr Channel_ID MP_Index new_x new_y PageWidth PageHeight} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set ModifyIndex [expr $MP_Index * 2]

	::olSDL_Views::Channel::MoveChanComps_MP $ObjArrName $CanInfoArr $Channel_ID \
		[lreplace $ObjArr($Channel_ID,Coords) $ModifyIndex [expr $ModifyIndex + 1] $new_x $new_y] \
		$PageWidth $PageHeight

}
##############################################################################
proc ::olSDL_Views::Channel::MoveChanComps_MP {ObjArrName CanInfoArr Channel_ID NewChannelCoords PageWidth PageHeight} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	######
	# calculate old RefPoi

	set ChanNameOldRefPoi [::olSDL_Views::Channel::calc_PositionOfChannelName $ObjArr($Channel_ID,Coords)]
	set ChanSourceSigOldRefPoi [::olSDL_Views::Channel::calc_PositionOfChanSourceSig $ObjArr($Channel_ID,Coords)]
	set ChanSourceConOldRefPoi [::olSDL_Views::Channel::calc_PositionOfChanSourceCon $ObjArr($Channel_ID,Coords)]
	set ChanDestSigOldRefPoi [::olSDL_Views::Channel::calc_PositionOfChanDestSig $ObjArr($Channel_ID,Coords)]
	set ChanDestConOldRefPoi [::olSDL_Views::Channel::calc_PositionOfChanDestCon $ObjArr($Channel_ID,Coords)]

	set OldRefPoi_x_Name [lindex $ChanNameOldRefPoi 0]
	set OldRefPoi_y_Name [lindex $ChanNameOldRefPoi 1]

	set OldRefPoi_x_SourceCon [lindex $ChanSourceConOldRefPoi 0]
	set OldRefPoi_y_SourceCon [lindex $ChanSourceConOldRefPoi 1]

	set OldRefPoi_x_DestCon [lindex $ChanDestConOldRefPoi 0]
	set OldRefPoi_y_DestCon [lindex $ChanDestConOldRefPoi 1]

	set OldRefPoi_x_SourceSig [lindex $ChanSourceSigOldRefPoi 0]
	set OldRefPoi_y_SourceSig [lindex $ChanSourceSigOldRefPoi 1]

	set OldRefPoi_x_DestSig [lindex $ChanDestSigOldRefPoi 0]
	set OldRefPoi_y_DestSig [lindex $ChanDestSigOldRefPoi 1]

	#
	####

	######
	# calculate new RefPoi

	set ChanNameNewRefPoi [::olSDL_Views::Channel::calc_PositionOfChannelName $NewChannelCoords]
	set ChanSourceSigNewRefPoi [::olSDL_Views::Channel::calc_PositionOfChanSourceSig $NewChannelCoords]
	set ChanSourceConNewRefPoi [::olSDL_Views::Channel::calc_PositionOfChanSourceCon $NewChannelCoords]
	set ChanDestSigNewRefPoi [::olSDL_Views::Channel::calc_PositionOfChanDestSig $NewChannelCoords]
	set ChanDestConNewRefPoi [::olSDL_Views::Channel::calc_PositionOfChanDestCon $NewChannelCoords]

	set NewRefPoi_x_Name [lindex $ChanNameNewRefPoi 0]
	set NewRefPoi_y_Name [lindex $ChanNameNewRefPoi 1]

	set NewRefPoi_x_SourceCon [lindex $ChanSourceConNewRefPoi 0]
	set NewRefPoi_y_SourceCon [lindex $ChanSourceConNewRefPoi 1]

	set NewRefPoi_x_DestCon [lindex $ChanDestConNewRefPoi 0]
	set NewRefPoi_y_DestCon [lindex $ChanDestConNewRefPoi 1]

	set NewRefPoi_x_SourceSig [lindex $ChanSourceSigNewRefPoi 0]
	set NewRefPoi_y_SourceSig [lindex $ChanSourceSigNewRefPoi 1]

	set NewRefPoi_x_DestSig [lindex $ChanDestSigNewRefPoi 0]
	set NewRefPoi_y_DestSig [lindex $ChanDestSigNewRefPoi 1]

	#
	####

	####
	# get CompIDs

	set Chan_NameID [$CanvasPathName find withtag ChanName$Channel_ID]

	set Chan_SourceSigID [$CanvasPathName find withtag ChanSourceSig$Channel_ID]
	set Chan_SourceConID [$CanvasPathName find withtag ChanSourceCon$Channel_ID]

	set Chan_DestSigID [$CanvasPathName find withtag ChanDestSig$Channel_ID]
	set Chan_DestConID [$CanvasPathName find withtag ChanDestCon$Channel_ID]

	# get CompIDs
	####

	####
	# dx, dy

	set dx_Name [expr [lindex $ObjArr($Chan_NameID,PaS) 0] - $OldRefPoi_x_Name]
	set dy_Name [expr [lindex  $ObjArr($Chan_NameID,PaS) 1] - $OldRefPoi_y_Name]

	set dx_SourceCon [expr [lindex $ObjArr($Chan_SourceConID,PaS) 0] - $OldRefPoi_x_SourceCon]
	set dy_SourceCon [expr [lindex $ObjArr($Chan_SourceConID,PaS) 1] - $OldRefPoi_y_SourceCon]

	set dx_DestCon [expr [lindex $ObjArr($Chan_DestConID,PaS) 0] - $OldRefPoi_x_DestCon]
	set dy_DestCon [expr [lindex $ObjArr($Chan_DestConID,PaS) 1] - $OldRefPoi_y_DestCon]

	set dx_SourceSig [expr [lindex $ObjArr($Chan_SourceSigID,PaS) 0] - $OldRefPoi_x_SourceSig]
	set dy_SourceSig [expr [lindex $ObjArr($Chan_SourceSigID,PaS) 1] - $OldRefPoi_y_SourceSig]

	set dx_DestSig [expr [lindex $ObjArr($Chan_DestSigID,PaS) 0] - $OldRefPoi_x_DestSig]
	set dy_DestSig [expr [lindex $ObjArr($Chan_DestSigID,PaS) 1] - $OldRefPoi_y_DestSig]

	#
	####

	####
	# calculate New Position

	set NewPosition_x_Name [expr $NewRefPoi_x_Name + $dx_Name]
	set NewPosition_y_Name [expr $NewRefPoi_y_Name + $dy_Name]

	set NewPosition_x_SourceCon [expr $NewRefPoi_x_SourceCon + $dx_SourceCon]
	set NewPosition_y_SourceCon [expr $NewRefPoi_y_SourceCon + $dy_SourceCon]

	set NewPosition_x_DestCon [expr $NewRefPoi_x_DestCon + $dx_DestCon]
	set NewPosition_y_DestCon [expr $NewRefPoi_y_DestCon + $dy_DestCon]

	set NewPosition_x_SourceSig [expr $NewRefPoi_x_SourceSig + $dx_SourceSig]
	set NewPosition_y_SourceSig [expr $NewRefPoi_y_SourceSig + $dy_SourceSig]

	set NewPosition_x_DestSig [expr $NewRefPoi_x_DestSig + $dx_DestSig]
	set NewPosition_y_DestSig [expr $NewRefPoi_y_DestSig + $dy_DestSig]

	#
	####

	####
	# move

	set PageCoords [list 0 0 $PageWidth $PageHeight]

	####
	# SourceCon
	set NewSourceConCoords [list $NewPosition_x_SourceCon $NewPosition_y_SourceCon \
		[expr int ( $NewPosition_x_SourceCon + [lindex $ObjArr($Chan_SourceConID,PaS) 2]) ] \
		[expr int ( $NewPosition_y_SourceCon + [lindex $ObjArr($Chan_SourceConID,PaS) 3]) ] ]

	if { [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageCoords $NewSourceConCoords] } {

		::olSDL_Views::Channel::modify_ChanComp_PaS_in_T_M_C "move" $ObjArrName $CanInfoArr $Chan_SourceConID \
			$NewSourceConCoords
	} else {
		# nop
	}
	#
	####

	####
	# SourceSig
	set NewSourceSigCoords [list $NewPosition_x_SourceSig $NewPosition_y_SourceSig \
		[expr int ( $NewPosition_x_SourceSig + [lindex $ObjArr($Chan_SourceSigID,PaS) 2]) ] \
		[expr int ( $NewPosition_y_SourceSig + [lindex $ObjArr($Chan_SourceSigID,PaS) 3]) ] ]

	if { [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageCoords $NewSourceSigCoords] } {

		::olSDL_Views::Channel::modify_ChanComp_PaS_in_T_M_C "move" $ObjArrName $CanInfoArr $Chan_SourceSigID \
			$NewSourceSigCoords

	} else {
		# nop
	}
	#
	####

	####
	# DestCon
	set NewDestConCoords [list $NewPosition_x_DestCon $NewPosition_y_DestCon \
		[expr int ( $NewPosition_x_DestCon + [lindex $ObjArr($Chan_DestConID,PaS) 2]) ] \
		[expr int ( $NewPosition_y_DestCon + [lindex $ObjArr($Chan_DestConID,PaS) 3]) ] ]

	if { [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageCoords $NewDestConCoords] } {

		::olSDL_Views::Channel::modify_ChanComp_PaS_in_T_M_C "move" $ObjArrName $CanInfoArr $Chan_DestConID \
			$NewDestConCoords

	} else {
		# nop
	}
	#
	####

	####
	# DestSig
	set NewDestSigCoords [list $NewPosition_x_DestSig $NewPosition_y_DestSig \
		[expr int ( $NewPosition_x_DestSig + [lindex $ObjArr($Chan_DestSigID,PaS) 2]) ] \
		[expr int ( $NewPosition_y_DestSig + [lindex $ObjArr($Chan_DestSigID,PaS) 3]) ] ]

	if { [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageCoords $NewDestSigCoords] } {

		::olSDL_Views::Channel::modify_ChanComp_PaS_in_T_M_C "move" $ObjArrName $CanInfoArr $Chan_DestSigID \
			$NewDestSigCoords

	} else {
		# nop
	}
	#
	####

	####
	# Name
	set NewNameCoords [list $NewPosition_x_Name $NewPosition_y_Name \
		[expr int ( $NewPosition_x_Name + [lindex $ObjArr($Chan_NameID,PaS) 2]) ] \
		[expr int ( $NewPosition_y_Name + [lindex $ObjArr($Chan_NameID,PaS) 3]) ] ]

	if { [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageCoords $NewNameCoords] } {

		::olSDL_Views::Channel::modify_ChanComp_PaS_in_T_M_C "move" $ObjArrName $CanInfoArr $Chan_NameID \
			$NewNameCoords

	} else {
		# nop
	}

	# End: Move
	####

}
##############################################################################
