package provide olSDL_ViewsChan 1

namespace eval olSDL_Views {
	namespace eval Channel {
	}
}

##############################################################################
proc ::olSDL_Views::Channel::store_Chan_and_Comp_in_Tcl_and_Model  {ObjArrName CanInfoArr \
		Diagram_Model_ID PageID ChannelCanID DelayType DirectionType SourceCanID DestCanID \
		ChanCoords ChannelNameID ChanNameContent ChanNamePaS ChanSourceSigID \
		ChanSourceSigContent ChanSourceSigPaS ChanSourceConID ChanSourceConContent \
		ChanSourceConPaS ChanDestSigID ChanDestSigContent ChanDestSigPaS \
		ChanDestConID ChanDestConContent ChanDestConPaS } {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	upvar #0 ::olSDL_MAR::arr_MAR MAR

	##############################
	# store channel in Tcl

	store_Channel_in_Tcl $ObjArrName $CanInfoArr $ChannelCanID $DelayType $DirectionType $SourceCanID $DestCanID XXXModel_IDXXX $ChanCoords

	# store channel in Tcl
	##############################

	##############################
	# store channel comp in Tcl

	_store_ChanComp_in_Tcl $ObjArrName $CanInfoArr $ChannelNameID ChanName \
		$ChanNameContent XXXModel_IDXXX $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal \
		$ChanNamePaS
			####

	_store_ChanComp_in_Tcl $ObjArrName $CanInfoArr $ChanSourceSigID ChanSourceSig \
		$ChanSourceSigContent XXXModel_IDXXX $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal \
		$ChanSourceSigPaS
			####
	_store_ChanComp_in_Tcl $ObjArrName $CanInfoArr $ChanDestSigID ChanDestSig \
		$ChanDestSigContent XXXModel_IDXXX $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal \
		$ChanDestSigPaS
			####
	_store_ChanComp_in_Tcl $ObjArrName $CanInfoArr $ChanSourceConID ChanSourceCon \
		$ChanSourceConContent XXXModel_IDXXX $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal \
		$ChanSourceConPaS
			####
	_store_ChanComp_in_Tcl $ObjArrName $CanInfoArr $ChanDestConID ChanDestCon \
		$ChanDestConContent XXXModel_IDXXX $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal \
		$ChanDestConPaS

	# END: store channel comp in Tcl
	##############################

	##############################
	# store channel and comp in Model

	if { $ObjArr($ChannelCanID,SourceID) == "ENV" } {
		set temp_SourceModel_ID "ENV"
	} else {
		set temp_SourceModel_ID $ObjArr($ObjArr($ChannelCanID,SourceID),Model_ID)
	}

	if { $ObjArr($ChannelCanID,DestinationID) == "ENV" } {
		set temp_DestModel_ID "ENV"
	} else {
		set temp_DestModel_ID $ObjArr($ObjArr($ChannelCanID,DestinationID),Model_ID)
	}


	insert_BidirecChannel_into_Model $Diagram_Model_ID $PageID $ObjArr($ChannelCanID,DelayType) \
		$temp_SourceModel_ID $temp_DestModel_ID \
		$ObjArr($ChannelCanID,Coords) \
		$ObjArr($ChannelNameID,Text) $ObjArr($ChannelNameID,PaS) \
		$ObjArr($ChanSourceSigID,Text) $ObjArr($ChanSourceSigID,PaS) \
		$ObjArr($ChanSourceConID,Text) $ObjArr($ChanSourceConID,PaS) \
		$ObjArr($ChanDestSigID,Text) $ObjArr($ChanDestSigID,PaS) \
		$ObjArr($ChanDestConID,Text) $ObjArr($ChanDestConID,PaS)


	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set NewObj_Model_ID $MAR(NewObj_Model_ID)

	# END: store channel and comp in Model
	##############################


	set ObjArr($ChannelCanID,Model_ID) $NewObj_Model_ID

	set ObjArr($ChannelNameID,Model_ID) $NewObj_Model_ID
	set ObjArr($ChanSourceSigID,Model_ID) $NewObj_Model_ID
	set ObjArr($ChanSourceConID,Model_ID) $NewObj_Model_ID
	set ObjArr($ChanDestSigID,Model_ID) $NewObj_Model_ID
	set ObjArr($ChanDestConID,Model_ID) $NewObj_Model_ID

}
##############################################################################
proc ::olSDL_Views::Channel::store_Channel_in_Tcl  {ObjArrName CanInfoArr Channel_ID \
											DelayType DirectionType SourceID DestinationID Model_ID Coords} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set ObjArr($Channel_ID,Type) Channel

	if { ($DelayType != "delay") && ($DelayType != "no_delay") } {
		error "wrong Delay Type"
	}
	set ObjArr($Channel_ID,DelayType) $DelayType


	if { ($DirectionType != "both") && ($DirectionType != "from_source") && ($DirectionType != "from_destination") } {
		error "wrong Direction Type"
	}
	set ObjArr($Channel_ID,DirectionType) $DirectionType


	set ObjArr($Channel_ID,SourceID) $SourceID
	set ObjArr($Channel_ID,DestinationID) $DestinationID
	set ObjArr($Channel_ID,Model_ID) $Model_ID
	set ObjArr($Channel_ID,Coords) $Coords

	lappend CanInfo(allObj) $Channel_ID

}
##############################################################################
proc ::olSDL_Views::Channel::store_ChanType_in_Tcl_and_Model  {ObjArrName CanInfoArr Channel_ID \
	DelayType DirectionType} {


	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	if { ($DelayType != "delay") && ($DelayType != "no_delay") } {
		error "wrong Delay Type"
	}
	set ObjArr($Channel_ID,DelayType) $DelayType


	if { ($DirectionType != "both") && ($DirectionType != "from_source") && ($DirectionType != "from_destination") } {
		error "wrong Direction Type"
	}
	set ObjArr($Channel_ID,DirectionType) $DirectionType


	set Channel_Model_ID $ObjArr($Channel_ID,Model_ID)
	modify_Chan_Type_in_Model $Channel_Model_ID $ObjArr($Channel_ID,DelayType) $ObjArr($Channel_ID,DirectionType)
}
##############################################################################
proc ::olSDL_Views::Channel::store_ChanCoords_in_Tcl_and_Model {ObjArrName CanInfoArr Channel_ID Coords} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set ObjArr($Channel_ID,Coords) $Coords

	set Channel_Model_ID $ObjArr($Channel_ID,Model_ID)
	modify_Chan_Coords_in_Model $Channel_Model_ID $ObjArr($Channel_ID,Coords)
}
##############################################################################
proc ::olSDL_Views::Channel::_store_ChanComp_in_Tcl  {ObjArrName CanInfoArr ChanCompID \
				ChanCompType Text Model_ID HL_Style PaS} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set ObjArr($ChanCompID,Type) ChanComp
	set ObjArr($ChanCompID,CompType) $ChanCompType

	set ObjArr($ChanCompID,Text) $Text

	set ObjArr($ChanCompID,Model_ID) $Model_ID
	set ObjArr($ChanCompID,PaS) $PaS

	set ObjArr($ChanCompID,HL_Style) $HL_Style

	lappend CanInfo(allObj) $ChanCompID

}
##############################################################################
proc ::olSDL_Views::Channel::delete_Chan_and_all_Comp_from_Tcl_and_Model {ObjArrName CanInfoArr Channel_ID CompIDs} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set Channel_Model_ID $ObjArr($Channel_ID,Model_ID)

	#############
	# delete from tcl

	foreach component $CompIDs {
		foreach element [lsort [array names ObjArr]] {
			if { [string first "$component," $element ] == 0} {
				unset ${ObjArrName}($element)
			}
		}
		set del_index [lsearch $CanInfo(allObj) $component]
		set CanInfo(allObj) [lreplace $CanInfo(allObj) $del_index $del_index]
	}


	foreach element [lsort [array names ObjArr]] {
		if { [string first "$Channel_ID," $element ] == 0} {
			unset ${ObjArrName}($element)
		}
	}
	set del_index [lsearch $CanInfo(allObj) $Channel_ID]
	set CanInfo(allObj) [lreplace $CanInfo(allObj) $del_index $del_index]

	set del_index [lsearch $CanInfo(selObj) $Channel_ID]
	set CanInfo(selObj) [lreplace $CanInfo(selObj) $del_index $del_index]

	# delete from tcl
	#############

	#############
	# delete from Model

	delete_Chan_from_Model $Channel_Model_ID

	# delete from Model
	#############

	# TEST
	#::olSDL_Helper::printMessage "nach Lschen von Kanal"
	#::olSDL_Helper::printMessage $Channel_ID
	#::olSDL_Helper::printArray $CanInfoArr
	#::olSDL_Helper::printArray $ObjArrName
}
##############################################################################
