
package provide olSDL_Views 1

namespace eval olSDL_Dialogs {

}

################################################################################
proc ::olSDL_Dialogs::SaveRequest { } {
	set DlgResult [MessageDlg .save_request -icon question -type yesnocancel -message "Save current specification?"]
	return $DlgResult
}

################################################################################
proc ::olSDL_Dialogs::Save_PR_Error { } {
	MessageDlg .save_pr_error -icon info -type ok -message "Generating PR failed"
}

################################################################################
proc ::olSDL_Dialogs::Save_PR_Error_StateMaSym {Type Symbol_ID Page_ID Diagram_ID} {
	set MyMessage "Generating PR failed\n"

	append MyMessage "Error source: StateMaSym\n"

	if { $Type == "sms_transition_not_complete" } {

		append MyMessage "Error type: Transition not complete\n"

	} elseif { $Type == "sms_illegal_start_state"} {

		append MyMessage "Error type: Illegal transition start state\n"

	} else {

		append MyMessage "Error type: Not specified\n"
	}

	append MyMessage "Symbol-ID: $Symbol_ID\n"
	append MyMessage "Page-ID: $Page_ID\n"
	append MyMessage "Diagram-ID: $Diagram_ID"

	MessageDlg .save_pr_error -icon info -type ok -message $MyMessage
}

################################################################################
proc ::olSDL_Dialogs::Save_PR_OK { } {

	MessageDlg .save_pr_ok -icon info -type ok -message "Generating PR successful"
}

################################################################################
proc ::olSDL_Dialogs::StoreFileOK { } {
	MessageDlg .store_file_ok -icon info -type ok -message "Successful storing"
}

################################################################################
proc ::olSDL_Dialogs::StoreFileError {} {

	MessageDlg .store_file_error -icon error -type ok -message "Storing failed"
}

################################################################################
proc ::olSDL_Dialogs::LoadFromFileOK { } {

	MessageDlg .load_from_file_ok -icon info -type ok -message "Successful loading"
}

################################################################################
proc ::olSDL_Dialogs::LoadFromFileError {errMessage} {
	MessageDlg .load_from_file_error -icon error -title "Error while loading" -type ok -message $errMessage
}

################################################################################
proc ::olSDL_Dialogs::MP_PositionNotAllowed { } {
	MessageDlg .mp_position_not_allowed -icon info -type ok -message "No valid position"
}

################################################################################
proc ::olSDL_Dialogs::FL_ConnectionNotAllowed { } {
	MessageDlg .con_not_allowed -icon info -type ok -message "Flow line between those objects not allowed"
}

################################################################################
proc ::olSDL_Dialogs::FL_InvalidNumberOfOutgoingFlowLines { } {

	MessageDlg .con_not_allowed -icon info -type ok -message "Invalid number of outgoing flow lines"
}

################################################################################
proc ::olSDL_Dialogs::FL_NotValidSource { } {
	MessageDlg .not_valid_source -icon info -type ok -message "No valid flow line source"
}

################################################################################
proc ::olSDL_Dialogs::TODO { } {
	MessageDlg .todo -icon info -type ok -message "Not yet implemented"
}

################################################################################
proc ::olSDL_Dialogs::AtLeastOnePage { } {
	MessageDlg .at_least_one_page -icon info -type ok -message "At least one page needed"
}

################################################################################
proc ::olSDL_Dialogs::MinPageWidth { } {
	MessageDlg .page_warning -icon info -type ok -message "Invalid page width"
}

################################################################################
proc ::olSDL_Dialogs::MinPageHeight { } {
	MessageDlg .page_warning -icon info -type ok -message "Invalid page height"
}

################################################################################
proc ::olSDL_Dialogs::PageOrFrameWarning {ObjectType} {
	switch -exact $ObjectType {
		"RecSym" {
			set MyMessage "Not all symbols in page frame"
		}
		"ChanComp" {
			set MyMessage "Not all channel comps on page"
		}
		"Channel" {
			set MyMessage "Not all channels in page frame"
		}
		"StateMaSym" {
			set MyMessage "Not all statemachine symbols in page frame"
		}
		"FlowLine" {
			set MyMessage "Not all flow lines in page frame"
		}
		"DecFlowLine" {
			set MyMessage "Not all decision flow lines in page frame"
		}
		"DecFlowLineComp" {
			set MyMessage "Not all decision flow line comps on page"
		}
		default {
			set MyMessage "Not all objects in page frame and on page"
		}
	}
	# switch -exact $ObjectType
	MessageDlg .page_warning -icon info -type ok -message $MyMessage
}

