package provide olSDL_Views 1

namespace eval olSDL_MainMenu {

}

########################################################################################################
proc ::olSDL_MainMenu::AskSave { } {

	set SaveRequestResult [::olSDL_Dialogs::SaveRequest]

	if { $SaveRequestResult == 0 } {

		# save current specification
		FileSaveCommand

	} elseif { $SaveRequestResult == 1 } {

	} else {
		return -code return
	}
}
########################################################################################################
########################################################################################################
proc ::olSDL_MainMenu::ExitEditor { } {
	AskSave
	exit
}
########################################################################################################
########################################################################################################
proc ::olSDL_MainMenu::CreateEmptySysSpec { } {
	AskSave

	create_EmptySysSpec

	AfterLoadSysSpec

	set ::olSDL_AppVar::OptionVar::FileNameCurrentSysSpec {}
	::olSDL_MainMenu::update_Title

}

########################################################################################################
########################################################################################################
proc ::olSDL_MainMenu::FileLoadCommand { } {
	AskSave

	set fileName [tk_getOpenFile -initialdir $::olSDL_AppVar::MyProjectsDir -filetypes { {{SDL Files}	{.xml}		} }]

	if { $fileName != "" } {
	  _load_SysSpec_from_file $fileName
	}
}
########################################################################################################
proc ::olSDL_MainMenu::_load_SysSpec_from_file {FileName} {

	upvar #0 ::olSDL_MAR::arr_MAR MAR

	load_Model_from_File $FileName

	if {$MAR(LoadingState) != "OK"} {

		if {$MAR(ErrorType) == "ReaderError"} {

			::olSDL_Dialogs::LoadFromFileError $MAR(ErrorMessage)
			return

		} else {

			::olSDL_Dialogs::LoadFromFileError "not specified"
			return
		}

	} else {

		set ::olSDL_AppVar::OptionVar::FileNameCurrentSysSpec $FileName

		AfterLoadSysSpec

		::olSDL_MainMenu::update_Title

		# ::olSDL_Dialogs::LoadFromFileOK
	}
}
########################################################################################################
proc ::olSDL_MainMenu::AfterLoadSysSpec { } {

	upvar #0 ::olSDL_Views::arr_Views Views
	upvar #0 ::olSDL_MAR::arr_MAR MAR

	##############
	# delete old view

	if {![catch {set CurrentViewID $Views(Current)}]} {
		::olSDL_Views::ViewsManager::delete_View $CurrentViewID
	}

	# delete old view
	##############

	##############
	# delete old tree view

	$::olSDL_AppVar::SystemTree delete [$::olSDL_AppVar::SystemTree nodes root]

	# delete old tree view
	##############

	##############
	# create new tree view

	::olSDL_ViewsTree::load_RootDia_from_Model

	# load TreeView
	##############

	##############
	# create new view

	get_System_Model_ID
	set System_Model_ID $MAR(System_Model_ID)

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	get_FirstPageID_from_Model $System_Model_ID

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set FirstPageID $MAR(FirstPageID)

	::olSDL_Views::ViewsManager::createView SysDia $System_Model_ID $FirstPageID

	# create new view
	##############

	::olSDL_ViewsTree::ShowCurrentDiagram $System_Model_ID

	::olSDL_MainMenu::update_Indicator
}

########################################################################################################
########################################################################################################
proc ::olSDL_MainMenu::FileSaveAsCommand { } {

	set FileName [tk_getSaveFile -initialdir $::olSDL_AppVar::MyProjectsDir -filetypes { {{SDL Files}	{.xml}		} }]

	if { $FileName != "" } {
	  _store_SysSpec_in_file $FileName
	}
}
###############################################################################
proc ::olSDL_MainMenu::FileSaveCommand { } {
	if {$::olSDL_AppVar::OptionVar::FileNameCurrentSysSpec != ""} {
	  _store_SysSpec_in_file $::olSDL_AppVar::OptionVar::FileNameCurrentSysSpec
	} else {
	  ::olSDL_MainMenu::FileSaveAsCommand
	}
}
###############################################################################
proc ::olSDL_MainMenu::_store_SysSpec_in_file {FileName} {

	upvar #0 ::olSDL_MAR::arr_MAR MAR

	store_Model_in_File $FileName

	if {$MAR(StoringState) != "OK"} {

		::olSDL_Dialogs::StoreFileError

	} else {

		set ::olSDL_AppVar::OptionVar::FileNameCurrentSysSpec $FileName

		::olSDL_MainMenu::update_Title
	}
}
########################################################################################################
proc ::olSDL_MainMenu::SavePR_Command {{Inline false}} {
	set FileName [tk_getSaveFile -initialdir $::olSDL_AppVar::MyProjectsDir -filetypes { {{PR Files}	{.pr}		} }]

	if { $FileName != "" } {
	  _store_PR_in_file $FileName $Inline
	}
}
########################################################################################################
proc ::olSDL_MainMenu::_store_PR_in_file {FileName b_Inline} {

	upvar #0 ::olSDL_MAR::arr_MAR MAR

	save_SDL_PR_in_File $FileName $b_Inline

	if {$MAR(GeneratingPR_State) != "OK"} {

		if { ($MAR(ErrorType) == "sms_transition_not_complete") || \
			($MAR(ErrorType) == "sms_illegal_start_state") || \
			($MAR(ErrorType) == "sms_none") } {

			::olSDL_Dialogs::Save_PR_Error_StateMaSym $MAR(ErrorType) \
				$MAR(Symbol_ID) $MAR(Page_ID) $MAR(Diagram_ID)
		} else {

			::olSDL_Dialogs::Save_PR_Error
		}

	} else {

		::olSDL_Dialogs::Save_PR_OK
	}
}
########################################################################################################
proc ::olSDL_MainMenu::SaveEPS_Command { } {
	set FileName [tk_getSaveFile -initialdir $::olSDL_AppVar::MyProjectsDir -filetypes { {{EPS Files}	{.eps}		} }]

	if { $FileName != "" } {
	  _store_EPS_in_file $FileName
	}
}
########################################################################################################
proc ::olSDL_MainMenu::_store_EPS_in_file {FileName} {

	upvar #0 ::olSDL_Views::arr_Views Views

	set CurrentViewID $Views(Current)
	set CurrentCanInfoArr $Views($CurrentViewID,NameOfCanInfoArr)

	upvar #0 $CurrentCanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	$CanvasPathName postscript -file $FileName \
		-width [lindex [$CanvasPathName cget -scrollregion] 2] \
		-height [lindex [$CanvasPathName cget -scrollregion] 3]

}
########################################################################################################
########################################################################################################
proc ::olSDL_MainMenu::GrowPageFrameX {Pixel} {

	upvar #0 ::olSDL_Views::arr_Views Views

	set CurrentViewID $Views(Current)
	set CurrentObjArr $Views($CurrentViewID,NameOfObjArr)
	set CurrentCanInfoArr $Views($CurrentViewID,NameOfCanInfoArr)

	upvar #0 $CurrentCanInfoArr CanInfo
	upvar #0 $CurrentObjArr ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	::olSDL_Views::AllViews::delete_all_Selections $CurrentObjArr $CurrentCanInfoArr
	::olSDL_Views::AllViews::set_canvas_state $CurrentObjArr $CurrentCanInfoArr normal dummy

	set OldFrameWidth [lindex $CanInfo(PageFramePaS) 2]
	set NewFrameWidth [expr int($OldFrameWidth + $Pixel)]

	set OldPaS $CanInfo(PageFramePaS)
	set NewPaS [lreplace $OldPaS 2 2 $NewFrameWidth]

	set OldPageWidth $CanInfo(PageWidth)
	set NewPageWidth [expr int ($OldPageWidth + $Pixel)]

	set OldPageHeight $CanInfo(PageHeight)

	################
	# store in Tcl and Model and Redraw

	::olSDL_PageFrame::store_Page_and_PageFrame_in_Tcl_and_Model_and_Redraw \
		$CurrentObjArr $CurrentCanInfoArr true $NewPageWidth $OldPageHeight $NewPaS

	# store in Tcl and Model and Redraw
	################

	# move channels
	::olSDL_PageFrame::move_AllChannelOnBorderToEnvironment $CurrentObjArr $CurrentCanInfoArr right $OldPaS $NewPaS
}
########################################################################################################
proc ::olSDL_MainMenu::GrowPageFrameY {Pixel} {

	upvar #0 ::olSDL_Views::arr_Views Views

	set CurrentViewID $Views(Current)
	set CurrentObjArr $Views($CurrentViewID,NameOfObjArr)
	set CurrentCanInfoArr $Views($CurrentViewID,NameOfCanInfoArr)

	upvar #0 $CurrentCanInfoArr CanInfo
	upvar #0 $CurrentObjArr ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	::olSDL_Views::AllViews::delete_all_Selections $CurrentObjArr $CurrentCanInfoArr
	::olSDL_Views::AllViews::set_canvas_state $CurrentObjArr $CurrentCanInfoArr normal dummy

	set OldFrameHeight [lindex $CanInfo(PageFramePaS) 3]
	set NewFrameHeight [expr int($OldFrameHeight + $Pixel)]

	set OldPaS $CanInfo(PageFramePaS)
	set NewPaS [lreplace $OldPaS 3 3 $NewFrameHeight]

	set OldPageHeight $CanInfo(PageHeight)
	set NewPageHeight [expr int ($OldPageHeight + $Pixel)]

	set OldPageWidth $CanInfo(PageWidth)

	################
	# store in Tcl and Model

	::olSDL_PageFrame::store_Page_and_PageFrame_in_Tcl_and_Model_and_Redraw \
		$CurrentObjArr $CurrentCanInfoArr true $OldPageWidth $NewPageHeight $NewPaS

	# store in Tcl and Model
	################

	# move channels
	::olSDL_PageFrame::move_AllChannelOnBorderToEnvironment $CurrentObjArr $CurrentCanInfoArr bottom $OldPaS $NewPaS
}
########################################################################################################
proc ::olSDL_MainMenu::ShrinkPageFrameX {Pixel} {

	upvar #0 ::olSDL_Views::arr_Views Views

	set CurrentViewID $Views(Current)
	set CurrentObjArr $Views($CurrentViewID,NameOfObjArr)
	set CurrentCanInfoArr $Views($CurrentViewID,NameOfCanInfoArr)

	upvar #0 $CurrentCanInfoArr CanInfo
	upvar #0 $CurrentObjArr ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	::olSDL_Views::AllViews::delete_all_Selections $CurrentObjArr $CurrentCanInfoArr
	::olSDL_Views::AllViews::set_canvas_state $CurrentObjArr $CurrentCanInfoArr normal dummy

	set OldFrameWidth [lindex $CanInfo(PageFramePaS) 2]
	set NewFrameWidth [expr int($OldFrameWidth - $Pixel)]

	set OldPaS $CanInfo(PageFramePaS)
	set NewPaS [lreplace $OldPaS 2 2 $NewFrameWidth]

	set OldPageWidth $CanInfo(PageWidth)
	set NewPageWidth [expr int ($OldPageWidth - $Pixel)]

	set OldPageHeight $CanInfo(PageHeight)

	############
	# check new page width

	if { $NewFrameWidth < $::olSDL_AppVar::MIN_FRAME_WIDTH } {

		::olSDL_Dialogs::MinPageWidth
		return
	}

	# check new page width
	############

	#################
	# check ShrinkZone

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $OldPaS OldFrame_x1 OldFrame_y1 OldFrame_x2 OldFrame_y2

	set ShrinkZoneCoords [list [expr int($OldFrame_x2 - $Pixel)] $OldFrame_y1 $OldFrame_x2 $OldFrame_y2]

	if { ! [::olSDL_PageFrame::ObjectsInPageFrameAndOnPage $CurrentObjArr $CurrentCanInfoArr $ShrinkZoneCoords $NewPageWidth $OldPageHeight \
	 	$NewPaS right $OldFrame_x2] } {
		return
	}

	# check ShrinkZone
	#################

	################
	# store in Tcl and Model

	::olSDL_PageFrame::store_Page_and_PageFrame_in_Tcl_and_Model_and_Redraw \
		$CurrentObjArr $CurrentCanInfoArr false $NewPageWidth $OldPageHeight $NewPaS

	# store in Tcl and Model
	################

	# move channels
	::olSDL_PageFrame::move_AllChannelOnBorderToEnvironment $CurrentObjArr $CurrentCanInfoArr right $OldPaS $NewPaS
}
########################################################################################################
proc ::olSDL_MainMenu::ShrinkPageFrameY {Pixel} {

	upvar #0 ::olSDL_Views::arr_Views Views

	set CurrentViewID $Views(Current)
	set CurrentObjArr $Views($CurrentViewID,NameOfObjArr)
	set CurrentCanInfoArr $Views($CurrentViewID,NameOfCanInfoArr)

	upvar #0 $CurrentCanInfoArr CanInfo
	upvar #0 $CurrentObjArr ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	::olSDL_Views::AllViews::delete_all_Selections $CurrentObjArr $CurrentCanInfoArr
	::olSDL_Views::AllViews::set_canvas_state $CurrentObjArr $CurrentCanInfoArr normal dummy

	set OldFrameHeight [lindex $CanInfo(PageFramePaS) 3]
	set NewFrameHeight [expr int($OldFrameHeight - $Pixel)]

	set OldPaS $CanInfo(PageFramePaS)
	set NewPaS [lreplace $OldPaS 3 3 $NewFrameHeight]

	set OldPageHeight $CanInfo(PageHeight)
	set NewPageHeight [expr int ($OldPageHeight - $Pixel)]

	set OldPageWidth $CanInfo(PageWidth)

	############
	# check new page height

	if { $NewFrameHeight < $::olSDL_AppVar::MIN_FRAME_HEIGHT } {

		::olSDL_Dialogs::MinPageHeight
		return
	}

	# check new page height
	############

	#################
	# check ShrinkZone

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $OldPaS OldFrame_x1 OldFrame_y1 OldFrame_x2 OldFrame_y2

	set ShrinkZoneCoords [list $OldFrame_x1 [expr int($OldFrame_y2 - $Pixel)] $OldFrame_x2 $OldFrame_y2]

	if { ! [::olSDL_PageFrame::ObjectsInPageFrameAndOnPage $CurrentObjArr $CurrentCanInfoArr $ShrinkZoneCoords $OldPageWidth $NewPageHeight \
	 	$NewPaS bottom $OldFrame_y2] } {
		return
	}

	# check ShrinkZone
	#################

	################
	# store in Tcl and Model

	::olSDL_PageFrame::store_Page_and_PageFrame_in_Tcl_and_Model_and_Redraw \
		$CurrentObjArr $CurrentCanInfoArr false $OldPageWidth $NewPageHeight $NewPaS

	# store in Tcl and Model
	################

	# move channels
	::olSDL_PageFrame::move_AllChannelOnBorderToEnvironment $CurrentObjArr $CurrentCanInfoArr bottom $OldPaS $NewPaS
}
########################################################################################################
proc ::olSDL_MainMenu::update_Indicator { } {

	upvar #0 ::olSDL_Views::arr_Views Views

	set CurrentViewID $Views(Current)
	set CurrentObjArr $Views($CurrentViewID,NameOfObjArr)
	set CurrentCanInfoArr $Views($CurrentViewID,NameOfCanInfoArr)

	upvar #0 $CurrentCanInfoArr CanInfo
	upvar #0 $CurrentObjArr ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	$::olSDL_AppVar::IndicatorPageWidth configure -text "PW: $CanInfo(PageWidth)"
	$::olSDL_AppVar::IndicatorPageHeight configure -text "PH: $CanInfo(PageHeight)"

	$::olSDL_AppVar::IndicatorFrameWidth configure -text "FW: [lindex $CanInfo(PageFramePaS) 2]"
	$::olSDL_AppVar::IndicatorFrameHeight configure -text "FH: [lindex $CanInfo(PageFramePaS) 3]"
}
########################################################################################################
proc ::olSDL_MainMenu::update_Title { } {

	upvar #0 ::olSDL_Views::arr_Views Views

	set CurrentViewID $Views(Current)
	set CurrentObjArr $Views($CurrentViewID,NameOfObjArr)
	set CurrentCanInfoArr $Views($CurrentViewID,NameOfCanInfoArr)

	upvar #0 $CurrentCanInfoArr CanInfo
	upvar #0 $CurrentObjArr ObjArr

	set TitleText [list {SDL/GR-2000-Editor} ++ $::olSDL_AppVar::OptionVar::FileNameCurrentSysSpec ++]

	wm title . $TitleText

}
########################################################################################################


########################################################################################################
# PAGE
########################################################################################################

proc ::olSDL_MainMenu::AddPage { } {

	upvar #0 ::olSDL_Views::arr_Views Views
	upvar #0 ::olSDL_MAR::arr_MAR MAR

	set CurrentViewID $Views(Current)
	set CurrentObjArr $Views($CurrentViewID,NameOfObjArr)
	set CurrentCanInfoArr $Views($CurrentViewID,NameOfCanInfoArr)

	upvar #0 $CurrentCanInfoArr CanInfo
	upvar #0 $CurrentObjArr ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set CurrentDiagramID $CanInfo(Dia_Model_ID)
	set CurrentPageID $CanInfo(PageID)
	set CurrentDiagramType $CanInfo(DiaType)

	############
	# add new page in model

	add_NewPage_after_in_Model $CurrentDiagramID $CurrentPageID

	# add new page in model
	############

	get_NextPageID_from_Model $CurrentDiagramID $CurrentPageID

	############
	# change view

	::olSDL_Views::ViewsManager::DeleteOldViewAndChangeToNewView $CanInfo(ViewID) $CurrentDiagramType $CurrentDiagramID $MAR(NextPageID)

	# change view
	############

	# indicator
	::olSDL_MainMenu::update_Indicator

}
########################################################################################################
proc ::olSDL_MainMenu::DeletePage { } {

	upvar #0 ::olSDL_Views::arr_Views Views
	upvar #0 ::olSDL_MAR::arr_MAR MAR

	set CurrentViewID $Views(Current)
	set CurrentObjArr $Views($CurrentViewID,NameOfObjArr)
	set CurrentCanInfoArr $Views($CurrentViewID,NameOfCanInfoArr)

	upvar #0 $CurrentCanInfoArr CanInfo
	upvar #0 $CurrentObjArr ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set CurrentDiagramID $CanInfo(Dia_Model_ID)
	set CurrentPageID $CanInfo(PageID)
	set CurrentDiagramType $CanInfo(DiaType)

	get_NextPageID_from_Model $CurrentDiagramID $CurrentPageID

	if { $MAR(NextPageExists) == "true" } {

		# delete Page
		delete_Page_from_Model $CurrentDiagramID $CurrentPageID

		############
		# change view

		::olSDL_Views::ViewsManager::DeleteOldViewAndChangeToNewView $CanInfo(ViewID) $CurrentDiagramType $CurrentDiagramID $MAR(NextPageID)

		# change view
		############

		#update tree
		::olSDL_ViewsTree::PageDeleted $CurrentDiagramID

		return
	}


	get_PreviousPageID_from_Model $CurrentDiagramID $CurrentPageID

	if { $MAR(PreviousPageExists) == "true" } {

		# delete Page
		delete_Page_from_Model $CurrentDiagramID $CurrentPageID

		############
		# change view

		::olSDL_Views::ViewsManager::DeleteOldViewAndChangeToNewView $CanInfo(ViewID) $CurrentDiagramType $CurrentDiagramID $MAR(PreviousPageID)

		# change view
		############

		#update tree
		::olSDL_ViewsTree::PageDeleted $CurrentDiagramID

		# indicator
		::olSDL_MainMenu::update_Indicator

		return
	}

	::olSDL_Dialogs::AtLeastOnePage
}
################################################################################
# page may be first, last, next, previous or a number
proc ::olSDL_MainMenu::GotoPage {page} {
	upvar #0 ::olSDL_Views::arr_Views Views
	upvar #0 ::olSDL_MAR::arr_MAR MAR

	set CurrentViewID $Views(Current)
	set CurrentObjArr $Views($CurrentViewID,NameOfObjArr)
	set CurrentCanInfoArr $Views($CurrentViewID,NameOfCanInfoArr)

	upvar #0 $CurrentCanInfoArr CanInfo
	upvar #0 $CurrentObjArr ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set CurrentDiagramID $CanInfo(Dia_Model_ID)
	set CurrentPageID $CanInfo(PageID)
	set CurrentDiagramType $CanInfo(DiaType)

	switch $page {
		first {
			get_FirstPageID_from_Model $CurrentDiagramID

			if {$CurrentPageID > $MAR(FirstPageID)} {
				set PageID $MAR(FirstPageID)
			} else {
				return
			}
		}
		last {
			get_LastPageID_from_Model $CurrentDiagramID

			if {$CurrentPageID < $MAR(LastPageID)} {
				set PageID $MAR(LastPageID)
			} else {
				return
			}
		}
		previous {
			get_PreviousPageID_from_Model $CurrentDiagramID $CurrentPageID

			if { $MAR(PreviousPageExists) != "true" } {
				return
			}
			set PageID $MAR(PreviousPageID)
		}
		next {
			get_NextPageID_from_Model $CurrentDiagramID $CurrentPageID
			if { $MAR(NextPageExists) != "true" } {
				return
			}
			set PageID $MAR(NextPageID)
		}
		default {
			if {[string is integer page] && {$page <= $MAR(LastPageID)} && {$page != $CurrentPageID} } {
			  set PageID $page
			} else {
				return
			}
		}
	}
	::olSDL_Views::ViewsManager::DeleteOldViewAndChangeToNewView $CanInfo(ViewID) $CurrentDiagramType $CurrentDiagramID $PageID

	::olSDL_MainMenu::update_Indicator
}
########################################################################################################
proc ::olSDL_MainMenu::OnChanCompBorderChange { } {

	upvar #0 ::olSDL_Views::arr_Views Views
	upvar #0 ::olSDL_MAR::arr_MAR MAR

	set CurrentViewID $Views(Current)
	set CurrentCanInfoArr $Views($CurrentViewID,NameOfCanInfoArr)

	upvar #0 $CurrentCanInfoArr CanInfo

	set CurrentDiagramID $CanInfo(Dia_Model_ID)
	set CurrentPageID $CanInfo(PageID)
	set CurrentDiagramType $CanInfo(DiaType)

	############
	# change view

	::olSDL_Views::ViewsManager::DeleteOldViewAndChangeToNewView $CanInfo(ViewID) $CurrentDiagramType $CurrentDiagramID $CurrentPageID

	# change view
	############

	# indicator
	::olSDL_MainMenu::update_Indicator

}
########################################################################################################
########################################################################################################
########################################################################################################
proc ::olSDL_MainMenu::show_ProgressDlg {title progmsg} {

	set progmsg "hallo"

	ProgressDlg .progress -parent . -title "Wait..." \
		-type	infinite \
        	-width 20 \
        	-textvariable progmsg \

	update_ProgressDlg
}
########################################################################################################
proc ::olSDL_MainMenu::update_ProgressDlg { } {

    if { [winfo exists .progress] } {
        after 20 ::olSDL_MainMenu::update_ProgressDlg
    }
}
########################################################################################################
proc ::olSDL_MainMenu::delete_ProgressDlg { } {

	destroy .progress
}
########################################################################################################
