
package provide olSDL_ProDiaView 1

namespace eval olSDL_ProDiaView {
	namespace eval EH {
	}
}
################################################################################
# Constructor for System Diagram Views
proc ::olSDL_ProDiaView::create {ViewID TempArrName TempCanInfoArr CanvasPathName Dia_Model_ID PageID ButBoxPathName}  {

	upvar #0 ::olSDL_MAR::arr_MAR MAR

	# create toolbar
	create_Toolbar $ButBoxPathName $TempArrName $TempCanInfoArr

	# get page size
	get_PageSize_from_Model $Dia_Model_ID $PageID
	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set PageHeight $MAR(PageHeight)
	set PageWidth $MAR(PageWidth)

	# setup Canvas Info array

	variable $TempCanInfoArr
	array set $TempCanInfoArr { }

	_init_Canvas_Info_Arr $TempCanInfoArr

	set ${TempCanInfoArr}(state) normal
	set ${TempCanInfoArr}(PageID) $PageID
	set ${TempCanInfoArr}(PageWidth) $PageWidth
	set ${TempCanInfoArr}(PageHeight) $PageHeight
	set ${TempCanInfoArr}(Dia_Model_ID) $Dia_Model_ID
	set ${TempCanInfoArr}(ViewID) $ViewID
	set ${TempCanInfoArr}(CanvasPathName) $CanvasPathName
	set ${TempCanInfoArr}(DiaType) ProDia

	upvar #0 $TempCanInfoArr CanInfo

	# setup scrollregion
	::olSDL_Views::set_PageScrollregion $CanvasPathName $PageWidth $PageHeight
	# setup stacking order
	::olSDL_Views::AllViews::setup_stacking_order $CanvasPathName

	# setup PageFrame Environment
	set ${TempCanInfoArr}(EnvironmentRectangle) [$CanvasPathName create rectangle 0 0 $PageWidth $PageHeight -tag EnvironmentRectangle -width 0]
	$CanvasPathName lower $CanInfo(EnvironmentRectangle) stack_EnvironmentRectangle

	variable $TempArrName
	array set $TempArrName { }

	# Frame and Header
	::olSDL_Views::get_and_draw_PageFrame_and_PageHeader $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID $PageID

	foreach symtype {TextSym ProInstRefSym ProTypeRefSym ProcedureInstRefSym} {
	  ::olSDL_Views::get_and_draw_Symbols $symtype $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID $PageID
	}
	
	foreach symtype $::olSDL_Views::StateMaSym::StateSym {
	  ::olSDL_Views::get_and_draw_StateMaSyms $symtype $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID $PageID
	}

#TODO: Why channels in Processes?
	# Channels
	::olSDL_Views::get_and_draw_Channels $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID $PageID

	# FlowLines
	::olSDL_Views::get_and_draw_FlowLines $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID $PageID


	# setup PageFrame Background
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $CanInfo(PageFramePaS) t_x1 t_y1 t_x2 t_y2
	set CanInfo(BackgroundRectangle) [$CanvasPathName create rectangle $t_x1 $t_y1 $t_x2 $t_y2 -tag BackgroundRectangle -width 0]
	$CanvasPathName lower $CanInfo(BackgroundRectangle) stack_BackgroundRectangle

	# create Canvas Pop-Up Menus
	::olSDL_Views::AllViews::create_PopUpMenus $TempArrName $TempCanInfoArr

	# setup Event handling (tags)
	setup_EventHandling $TempArrName $TempCanInfoArr

	# create bindings
	setup_Bindings $TempArrName $TempCanInfoArr

	set_canvas_state $TempArrName $TempCanInfoArr normal dummy
}
########################################################################################################
proc	::olSDL_ProDiaView::_init_Canvas_Info_Arr {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanInfo(allObj) { }
	set CanInfo(selObj) { }

	set CanInfo(Place_TypeOfNewRecObject) ""
	set CanInfo(Place_NewRec_x) ""
	set CanInfo(Place_NewRec_y) ""
	set CanInfo(Place_NewRec_FrameID) ""

	set CanInfo(Resize_ActionType) ""
	set CanInfo(Resize_PointParentID) ""
	set CanInfo(Resize_FrameID) ""

	set CanInfo(Move_start_x) ""
	set CanInfo(Move_start_y) ""
	set CanInfo(Move_MovedObjID) ""
	set CanInfo(Move_Obj_moved) ""
	set CanInfo(Move_MoveFrameID) ""

	set CanInfo(BackgroundRectangle) ""

	set CanInfo(connect_Source_ID) ""
	set CanInfo(connect_SourcePaS) ""
	set CanInfo(connect_afterSource) false
	set CanInfo(connect_Source_x) ""
	set CanInfo(connect_Source_y) ""
 	set CanInfo(connect_afterFirstPart) false
	set CanInfo(connect_Channel_ID) ""
	set CanInfo(connect_ChannelCoords) { }
}
########################################################################################################
proc ::olSDL_ProDiaView::setup_Bindings {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	foreach element $CanInfo(allObj) {
		if {[::olSDL_Views::is_RecSym $ObjArr($element,Type)]} {
			setup_Bindings_for_RecSym $CanvasPathName $element
		} elseif {[::olSDL_Views::is_StateMaSym $ObjArr($element,Type)]} {
			setup_Bindings_for_StateMaSym $CanvasPathName $element
		}
	}
}
########################################################################################################
proc ::olSDL_ProDiaView::setup_EventHandling {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	#########
	# Event Handler for RecSym

	set Callback "::olSDL_Views::RecSym::ClickOnRecSymbol $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::RecSym::EnterRecSymbol $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Enter> "$Callback"

	set Callback "::olSDL_Views::RecSym::LeaveRecSymbol $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Leave> "$Callback"

	set Callback "::olSDL_Views::RecSym::show_PopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Button-3> "$Callback %x %y"

	# END : Event Handler for RecSym
	#########

	#########
	# Event Handler for moving RecSymbols

	set Callback "::olSDL_Views::MoveRecSym::StartMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableRecSym <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::MoveRecSym::ProcessMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableRecSym <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::MoveRecSym::EndMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableRecSym <ButtonRelease-1> "$Callback %x %y"

	# Event Handler for moving RecSymbols
	#########

	#########
	# Event Handler for Resize Points of RecSymbols

	set Callback "::olSDL_Views::RecObjRP::RP_Enter $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <Enter> "$Callback"

	set Callback "::olSDL_Views::RecObjRP::RP_Leave $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <Leave> "$Callback"

	## Resizing
	set Callback "::olSDL_Views::ResizeRecSym::RP_StartResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::ResizeRecSym::RP_ProcessResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::ResizeRecSym::RP_EndResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <ButtonRelease-1> "$Callback"

	# END: Event Handler for Resize Points of RecSymbols
	#########

	#########
	# Event Handler for Background

	set Callback "::olSDL_ProDiaViewBack::StartBackground $ObjArrName $CanInfoArr"
	$CanvasPathName bind BackgroundRectangle <Button-1> "$Callback %x %y"

	set Callback "::olSDL_ProDiaViewBack::ProcessBackground $ObjArrName $CanInfoArr"
	$CanvasPathName bind BackgroundRectangle <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_ProDiaViewBack::EndBackground $ObjArrName $CanInfoArr"
	$CanvasPathName bind BackgroundRectangle <ButtonRelease-1> "$Callback %x %y"

	# Event Handler for Background
	#########

	#########
	# Event Handler for Environment

	set Callback "::olSDL_Views::Env::ClickOnEnvironment $ObjArrName $CanInfoArr"
	$CanvasPathName bind EnvironmentRectangle <Button-1> "$Callback %x %y"

	# Event Handler for Environment
	#########

	#########
	# Event Handler for Channels

	set Callback "::olSDL_Views::Channel::ClickOnChannel $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableChannel <Button-1> "$Callback"

	set Callback "::olSDL_Views::Channel::ClickOnChannelArrow $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableChannelArrow <Button-1> "$Callback"


	set Callback "::olSDL_Views::Channel::show_PopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableChannel <Button-3> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::show_PopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableChannelArrow <Button-3> "$Callback %x %y"


	set Callback "::olSDL_Views::Channel::StartChanMP $ObjArrName $CanInfoArr"
	$CanvasPathName bind ChanMP <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::ProcessChanMP $ObjArrName $CanInfoArr"
	$CanvasPathName bind ChanMP <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::EndChanMP $ObjArrName $CanInfoArr"
	$CanvasPathName bind ChanMP <ButtonRelease-1> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::show_MP_PopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind ChanMP <ButtonRelease-3> "$Callback %x %y"

	# END: Event Handler for Channels
	#########

	#########
	# Event Handler for Channels Comp

	set Callback "::olSDL_Views::Channel::ClickOnRecChanComp $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRecChanComp <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::EnterRecChanComp $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRecChanComp <Enter> "$Callback"

	set Callback "::olSDL_Views::Channel::LeaveRecChanComp $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRecChanComp <Leave> "$Callback"

	set Callback "::olSDL_Views::Channel::show_CompPopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRecChanComp <Button-3> "$Callback %x %y"

	# END: Event Handler for Channels Comp
	#########

	#########
	# Event Handler for moving Channels Comp

	set Callback "::olSDL_Views::Channel::StartChanCompMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind movableChanComp <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::ProcessChanCompMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind movableChanComp <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::EndChanCompMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind movableChanComp <ButtonRelease-1> "$Callback %x %y"

	# Event Handler for moving Channels Comp
	#########

	#########
	# Event Handler for Resize Points of Channels Comp

	set Callback "::olSDL_Views::RecObjRP::RP_Enter $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecChanCompRP <Enter> "$Callback"

	set Callback "::olSDL_Views::RecObjRP::RP_Leave $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecChanCompRP <Leave> "$Callback"

	## Resizing
	set Callback "::olSDL_Views::Channel::RP_StartResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecChanCompRP <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::RP_ProcessResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecChanCompRP <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::Channel::RP_EndResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecChanCompRP <ButtonRelease-1> "$Callback"

	# Event Handler for Resize Points of Channels Comp
	#########

	#########
	# Event Handler for StateMaSym

	set Callback "::olSDL_Views::StateMaSym::ClickOnStateMaSym $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableStateMaSym <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::StateMaSym::EnterStateMaSym $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableStateMaSym <Enter> "$Callback"

	set Callback "::olSDL_Views::StateMaSym::LeaveStateMaSym $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableStateMaSym <Leave> "$Callback"

	set Callback "::olSDL_Views::StateMaSym::show_StateMaSymPopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableStateMaSym <Button-3> "$Callback %x %y"

	# END : Event Handler for StateMaSym
	#########

	#########
	# Event Handler for moving StateMaSym

	set Callback "::olSDL_Views::MoveStateMaSym::StartMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableStateMaSym <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::MoveStateMaSym::ProcessMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableStateMaSym <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::MoveStateMaSym::EndMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableStateMaSym <ButtonRelease-1> "$Callback %x %y"

	# Event Handler for moving StateMaSym
	#########

	#########
	# Event Handler for Resize Points of StateMaSym

	set Callback "::olSDL_Views::RecObjRP::RP_Enter $ObjArrName $CanInfoArr"
	$CanvasPathName bind StateMaSymRP <Enter> "$Callback"

	set Callback "::olSDL_Views::RecObjRP::RP_Leave $ObjArrName $CanInfoArr"
	$CanvasPathName bind StateMaSymRP <Leave> "$Callback"

	## Resizing
	set Callback "::olSDL_Views::ResizeStateMaSym::RP_StartResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind StateMaSymRP <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::ResizeStateMaSym::RP_ProcessResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind StateMaSymRP <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::ResizeStateMaSym::RP_EndResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind StateMaSymRP <ButtonRelease-1> "$Callback"

	# END: Event Handler for Resize Points of StateMaSym
	#########

	#########
	# Event Handler for FlowLines

	set Callback "::olSDL_Views::FlowLine::ClickOnFlowLine $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableFlowLine <Button-1> "$Callback"

	set Callback "::olSDL_Views::FlowLine::ClickOnDecFlowLine $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableDecisionFlowLine <Button-1> "$Callback"

	# Event Handler for FlowLines
	#########

	#########
	# Event Handler for DecFlowLines

	set Callback "::olSDL_Views::FlowLine::show_DecFlowLinePopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableDecisionFlowLine <Button-3> "$Callback %x %y"

	# Event Handler for DecFlowLines
	#########

	#########
	# Event Handler for DecFlowLinesComp

	set Callback "::olSDL_Views::FlowLine::ClickOnDecFlowLineComp $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableDecFlowLineComp <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::FlowLine::show_DecFlowLineCompPopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableDecFlowLineComp <Button-3> "$Callback %x %y"

	# Event Handler for DecFlowLinesComp
	#########

	#########
	# Event Handler for moving DecFlowLinesComp

	set Callback "::olSDL_Views::FlowLine::StartDecFlowLineCompMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind movableDecFlowLineComp <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::FlowLine::ProcessDecFlowLineCompMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind movableDecFlowLineComp <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::FlowLine::EndDecFlowLineCompMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind movableDecFlowLineComp <ButtonRelease-1> "$Callback %x %y"

	# Event Handler for moving DecFlowLinesComp
	#########
	#########

	#########
	# Event Handler for Resize Points of DecFlowLinesComp

	set Callback "::olSDL_Views::RecObjRP::RP_Enter $ObjArrName $CanInfoArr"
	$CanvasPathName bind DecisionFlowLineCompRP <Enter> "$Callback"

	set Callback "::olSDL_Views::RecObjRP::RP_Leave $ObjArrName $CanInfoArr"
	$CanvasPathName bind DecisionFlowLineCompRP <Leave> "$Callback"

	## Resizing
	set Callback "::olSDL_Views::FlowLine::RP_StartResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind DecisionFlowLineCompRP <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::FlowLine::RP_ProcessResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind DecisionFlowLineCompRP <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::FlowLine::RP_EndResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind DecisionFlowLineCompRP <ButtonRelease-1> "$Callback"

	# Event Handler for Resize Points of DecFlowLinesComp
	#########


	#########
	# Event Handler for whole Canvas

	set Callback "::olSDL_ProDiaView::EH::MouseMoved $ObjArrName $CanInfoArr"
	bind $CanvasPathName <Motion> "$Callback %x %y"

	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr normal dummy"
	bind $CanvasPathName <Escape> "$Callback %x %y"

	# Event Handler for whole Canvas
	#########

}
########################################################################################################
# method for creating toolbar
########################################################################################################
proc ::olSDL_ProDiaView::create_Toolbar {ButBoxPathName ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set ButBox $ButBoxPathName

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr normal dummy"
	set SelectionArrowImage ${olSDL_AppVar::MyImagesPath}/olSDL_SelectionArrow
	set CanInfo(tbb,SelectionArrow) [$ButBox add -image [Bitmap::get $SelectionArrowImage] \
 							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
  							-helptext "Selection" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr connection dummy"
	set ConnectionImage ${olSDL_AppVar::MyImagesPath}/olSDL_ChannelBoth
	set CanInfo(tbb,Connection) [$ButBox add -image [Bitmap::get $ConnectionImage] \
 							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
  							-helptext "Connection" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_new_rec_obj TextSym"
	set TextSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_TextSym_neu
	set CanInfo(tbb,TextSym) [$ButBox add -image [Bitmap::get $TextSymImage] \
 						-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
  						-helptext "Text" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_new_rec_obj ProInstRefSym"
	set ProInstRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_ProInstRefSym
	set CanInfo(tbb,ProInstRefSym) [$ButBox add -image [Bitmap::get $ProInstRefSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Process" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_new_rec_obj ProTypeRefSym"
	set ProTypeRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_ProTypeRefSym
	set CanInfo(tbb,ProTypeRefSym) [$ButBox add -image [Bitmap::get $ProTypeRefSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "ProTypeRef" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_new_rec_obj ProcedureInstRefSym"
	set ProcedureInstRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_ProcedureInstRefSym
	set CanInfo(tbb,ProcedureInstRefSym) [$ButBox add -image [Bitmap::get $ProcedureInstRefSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "ProcedureInstRefSym" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaStartStateSym"
	set StateMachineStartSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_StartState
	set CanInfo(tbb,StateMaStartStateSym) [$ButBox add -image [Bitmap::get $StateMachineStartSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "StartState" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaStateSym"
	set StateMachineStateSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_NextState
	set CanInfo(tbb,StateMaStateSym) [$ButBox add -image [Bitmap::get $StateMachineStateSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "State" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaOutputSym"
	set StateMachineOutputSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_Output
	set CanInfo(tbb,StateMaOutputSym) [$ButBox add -image [Bitmap::get $StateMachineOutputSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Output" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaInputSym"
	set StateMachineInputSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_Input
	set CanInfo(tbb,StateMaInputSym) [$ButBox add -image [Bitmap::get $StateMachineInputSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Input" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaConditionSym"
	set StateMaConditionSym ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_Condition
	set CanInfo(tbb,StateMaConditionSym) [$ButBox add -image [Bitmap::get $StateMaConditionSym] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Condition" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaTaskSym"
	set StateMachineTaskSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_Task
	set CanInfo(tbb,StateMaTaskSym) [$ButBox add -image [Bitmap::get $StateMachineTaskSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Task" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaStopSym"
	set StateMachineStopSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_Stop
	set CanInfo(tbb,StateMaStopSym) [$ButBox add -image [Bitmap::get $StateMachineStopSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Stop" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaDecisionSym"
	set StateMachineDecisionSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_Decision
	set CanInfo(tbb,StateMaDecisionSym) [$ButBox add -image [Bitmap::get $StateMachineDecisionSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Decision" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaCreateProSym"
	set StateMachineCreateProSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_CreatePro
	set CanInfo(tbb,StateMaCreateProSym) [$ButBox add -image [Bitmap::get $StateMachineCreateProSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "CreateProcess" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaCallProcedureSym"
	set StateMaCallProcedureSym ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_CallProcedure
	set CanInfo(tbb,StateMaCallProcedureSym) [$ButBox add -image [Bitmap::get $StateMaCallProcedureSym] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "CallProcedure" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr flowline dummy"
	set FlowLineImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_FlowLine
	set CanInfo(tbb,FlowLineSym) [$ButBox add -image [Bitmap::get $FlowLineImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Flow Line" -command "$Callback"]

	####
	set Callback "::olSDL_ProDiaView::delete_Object $ObjArrName $CanInfoArr"
	set DeleteRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_DeleteRecSymSign
	$ButBox add -image [Bitmap::get $DeleteRefSymImage] \
   		-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Delete" -command "$Callback"

	####
	set Callback "::olSDL_ProDiaView::Diagram_up $ObjArrName $CanInfoArr"
	set DeleteRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_DiagramUp
	$ButBox add -image [Bitmap::get $DeleteRefSymImage] \
   		-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Diagram up" -command "$Callback"

	pack $ButBox -side top -anchor n
}
########################################################################################################
proc ::olSDL_ProDiaView::setup_Bindings_for_StateMaSym {CanvasPathName CanObjID} {
	$CanvasPathName itemconfigure $CanObjID -tag {selectableStateMaSym moveableStateMaSym}
}
########################################################################################################
proc ::olSDL_ProDiaView::setup_Bindings_for_RecSym {CanvasPathName CanObjID} {
	$CanvasPathName itemconfigure $CanObjID -tag {selectableRec moveableRecSym}
}
########################################################################################################
proc ::olSDL_ProDiaView::set_canvas_state {ObjArrName CanInfoArr State ObjType} {
	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	if { $CanInfo(state) == "connection" }  {
		::olSDL_Views::Channel::delete_ConnectionHelperObjects $CanInfoArr
	}

	set CanInfo(state) $State
	set CanInfo(Place_TypeOfNewRecObject) $ObjType

	###########

	$CanInfo(tbb,SelectionArrow) configure -relief raised

	$CanInfo(tbb,TextSym) configure -relief raised
	$CanInfo(tbb,ProInstRefSym) configure -relief raised
	$CanInfo(tbb,ProTypeRefSym) configure -relief raised
	$CanInfo(tbb,ProcedureInstRefSym) configure -relief raised
	$CanInfo(tbb,Connection) configure -relief raised

	$CanInfo(tbb,StateMaStartStateSym) configure -relief raised
	$CanInfo(tbb,StateMaStateSym) configure -relief raised
	$CanInfo(tbb,StateMaInputSym) configure -relief raised
	$CanInfo(tbb,StateMaOutputSym) configure -relief raised
	$CanInfo(tbb,StateMaTaskSym) configure -relief raised
	$CanInfo(tbb,StateMaStopSym) configure -relief raised
	$CanInfo(tbb,StateMaDecisionSym) configure -relief raised
	$CanInfo(tbb,StateMaCreateProSym) configure -relief raised
	$CanInfo(tbb,StateMaCallProcedureSym) configure -relief raised
	$CanInfo(tbb,StateMaConditionSym) configure -relief raised

	$CanInfo(tbb,FlowLineSym) configure -relief raised

	###########
	switch -exact $State {
	  normal {
		$CanInfo(tbb,SelectionArrow) configure -relief sunken
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
		return
	  }

	  single_obj_selected {
		$CanInfo(tbb,SelectionArrow) configure -relief sunken
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
		return
	  }

	  connection {
		$CanInfo(tbb,Connection) configure -relief sunken
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
		return
	  }

	  flowline {
		::olSDL_Views::FlowLine::init_FL_ConnectHelperObjects $CanInfoArr
		$CanInfo(tbb,FlowLineSym) configure -relief sunken
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
		return
	  }

	  place_new_rec_obj {
		if [::olSDL_Views::is_RecSym $ObjType] {
			$CanInfo(tbb,$ObjType) configure -relief sunken
			return
		} else {
			error "unknown rectangular symbol"
		}
	  }

	  place_state_machine_sym {
		if [::olSDL_Views::is_StateMaSym $ObjType] {
			$CanInfo(tbb,$ObjType) configure -relief sunken
			return
		} else {
			error "unknown state machine symbol"
		}
	  }

	  default {
		error "unknown placement mode"
	  }
	}
}
##############################################################################
proc ::olSDL_ProDiaView::Diagram_up {ObjArrName CanInfoArr } {

	::olSDL_Views::ViewsManager::All_Diagram_up $ObjArrName $CanInfoArr

}
##############################################################################
proc ::olSDL_ProDiaView::delete_Object {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	foreach selectedObj $CanInfo(selObj) {

		set AllTags [$CanvasPathName gettags $selectedObj]

		if { [lsearch -exact $AllTags selectableRec] != -1 } {

			###################
			# delete RecSyms
			###################

			###################
			#update SDL-Tree

			if { [ ::olSDL_Views::is_ReferencingSymbol $ObjArr($selectedObj,Type)] } {
				::olSDL_ViewsTree::ReferencingSymbolDeleted $ObjArr($selectedObj,RefDia_Model_ID)
			}

			#update SDL-Tree
			###################

			# delete Resize Points
			::olSDL_ViewsDrawMethods::delete_RecSym_RP_from_Canvas $ObjArrName $CanInfoArr $selectedObj

			::olSDL_Views::RecSym::delete_RecSym_from_T_M_C $ObjArrName $CanInfoArr $selectedObj

			###################
			# delete all neighbouring channels

			set ConnectedChannels [::olSDL_Views::RecSym::get_connected_Channels $ObjArrName $CanInfoArr $selectedObj]

			foreach ConChan $ConnectedChannels {

				::olSDL_Views::Channel::delete_Chan_and_all_Comp_from_T_M_C $ObjArrName $CanInfoArr $ConChan

			}
			# END: delete all neighbouring channels
			###################

		} elseif { ([lsearch -exact $AllTags selectableChannel] != -1) } {

			###################
			# delete Channel
			###################

			# delete MP
			::olSDL_ViewsDrawMethods::delete_Channel_MP_from_Canvas $ObjArrName $CanInfoArr $selectedObj

			::olSDL_Views::Channel::delete_Chan_and_all_Comp_from_T_M_C $ObjArrName $CanInfoArr $selectedObj

		} elseif { ([lsearch -exact $AllTags selectableFlowLine] != -1) } {

			###################
			# delete FlowLine
			###################

			# delete MP
			::olSDL_ViewsDrawMethods::delete_FlowLine_MP_from_Canvas $ObjArrName $CanInfoArr $selectedObj

			# delete flow line from canvas, tcl, model
			::olSDL_Views::FlowLine::delete_NormalFlowLine_from_T_M_C $ObjArrName $CanInfoArr $selectedObj

		} elseif { ([lsearch -exact $AllTags selectableDecisionFlowLine] != -1) } {

			###################
			# delete DecFlowLine
			###################

			# delete MP
			::olSDL_ViewsDrawMethods::delete_DecisionFlowLine_MP_from_Canvas $ObjArrName $CanInfoArr $selectedObj

			# delete dec flow line from canvas, tcl, model
			::olSDL_Views::FlowLine::delete_DecisionFlowLine_from_T_M_C $ObjArrName $CanInfoArr $selectedObj

		} elseif { ([lsearch -exact $AllTags selectableStateMaSym] != -1) } {

			###################
			# delete StateMaSym
			###################

			# delete Resize Points
			::olSDL_ViewsDrawMethods::delete_StateMaSym_RP_from_Canvas $ObjArrName $CanInfoArr $selectedObj

			# delete state ma sym form tcl, canvas, model
			::olSDL_Views::StateMaSym::delete_StateMaSym_from_T_M_C $ObjArrName $CanInfoArr $selectedObj

			###################
			# delete connected FlowLines
			###################

				###################
				# normal flow line

				set ConnectedFlowLines [::olSDL_Views::StateMaSym::get_connected_NormalFlowLines $ObjArrName $CanInfoArr $selectedObj]

				foreach FlowLine $ConnectedFlowLines {

					# delete flow line from canvas, tcl, model
					::olSDL_Views::FlowLine::delete_NormalFlowLine_from_T_M_C $ObjArrName $CanInfoArr $FlowLine

				}

				# normal flow line
				###################

				###################
				# dec flow line

				set ConnectedFlowLines [::olSDL_Views::StateMaSym::get_connected_DecisionFlowLines $ObjArrName $CanInfoArr $selectedObj]

				foreach FlowLine $ConnectedFlowLines {

					# delete dec flow line from canvas, tcl, model
					::olSDL_Views::FlowLine::delete_DecisionFlowLine_from_T_M_C $ObjArrName $CanInfoArr $FlowLine

				}

				# dec flow line
				###################

			#::olSDL_Helper::printMessage "nach lschen von state ma sym"
			#::olSDL_Helper::printArray $CanInfoArr
			#::olSDL_Helper::printArray $ObjArrName
			#::olSDL_Helper::printMessage "END: nach lschen von state ma sym"

			###################
			# END: delete connected FlowLines
			###################

		}
	}
	# foreach selectedObj $CanInfo(selObj)



	set_canvas_state $ObjArrName $CanInfoArr normal dummy
}
##############################################################################
proc ::olSDL_ProDiaView::delete_all_Selections {ObjArrName CanInfoArr} {

}
########################################################################################################
proc ::olSDL_ProDiaView::EH::set_canvas_state {ObjArrName CanInfoArr State ObjType} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	::olSDL_Views::AllViews::delete_all_Selections $ObjArrName $CanInfoArr

	::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr $State $ObjType
}
########################################################################################################
proc ::olSDL_ProDiaView::EH::MouseMoved {ObjArrName CanInfoArr x y} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

        
	if { $CanInfo(state) != "flowline" } {
		return
	}

	set Canvas $CanInfo(CanvasPathName)

	set x [$Canvas canvasx $x]
	set y [$Canvas canvasy $y]

	if { $CanInfo(flowline_PreviewLineID) != "" } {
	  $Canvas coords $CanInfo(flowline_PreviewLineID) $CanInfo(flowline_Source_x) $CanInfo(flowline_Source_y) $x $y
	}
}

