
package provide olSDL_ProDiaView 1

namespace eval olSDL_ProDiaViewBack {

}

##############################################################################
# methods for whole Canvas
##############################################################################
proc ::olSDL_ProDiaViewBack::StartBackground {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	set x [expr int([$CanvasPathName canvasx $x])]
	set y [expr int([$CanvasPathName canvasy $y])]

	switch -exact $CanvasState {
		"normal" {
			::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr
			return
		}
		"flowline" {
			return
		}
		"single_obj_selected" {
			::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr
			::olSDL_Views::AllViews::delete_all_Selections $ObjArrName $CanInfoArr
			return
		}
		"place_new_rec_obj" {
			::olSDL_Views::PlaceRecSym::_init_PlaceHelperObjects $ObjArrName $CanInfoArr

			set CanInfo(Place_NewRec_x) $x
			set CanInfo(Place_NewRec_y) $y

			#create PlacementFrame, but in state hidden
			set PlacementFrame [$CanvasPathName create rectangle $CanInfo(Place_NewRec_x) $CanInfo(Place_NewRec_y) 10 10 -state hidden -dash {2 4} -width 2]

			set CanInfo(Place_NewRec_FrameID) $PlacementFrame
			return
		}
		"place_state_machine_sym" {
			::olSDL_Views::PlaceRecSym::_init_PlaceHelperObjects $ObjArrName $CanInfoArr

			set CanInfo(Place_NewRec_x) $x
			set CanInfo(Place_NewRec_y) $y

			#create PlacementFrame, but in state hidden
			set PlacementFrame [$CanvasPathName create rectangle $CanInfo(Place_NewRec_x) $CanInfo(Place_NewRec_y) 10 10 -state hidden -dash {2 4} -width 2]

			set CanInfo(Place_NewRec_FrameID) $PlacementFrame
			return
		}
		"connection" {
			if { $CanInfo(connect_afterSource) } {

				if { ! ($CanInfo(connect_afterFirstPart)) } {

					set StartLinieCoords { }

					if { $CanInfo(connect_Source_is_Env) } {

						set ConPointA [::olSDL_ViewsCalcCoor::calc_ConnPointOnBorderToEnv $CanInfo(PageFramePaS) \
							$CanInfo(connect_Source_x) $CanInfo(connect_Source_y)]

						set StartLinieCoords $ConPointA
						lappend StartLinieCoords $x
						lappend StartLinieCoords $y

					} else {

						set ConPoint [::olSDL_ViewsCalcCoor::calc_ConnectionPointOnRecSym \
							$CanInfo(connect_SourcePaS) \
							$CanInfo(connect_Source_x) $CanInfo(connect_Source_y)  \
							$x $y ]

						set StartLinieCoords $ConPoint
						lappend StartLinieCoords $x
						lappend StartLinieCoords $y
					}

					#################################
					# in Frame ?

					set PageFrameInnerZoneCoords [::olSDL_ViewsCalcCoor::calc_PageFrameInnerZoneCoords $CanInfo(PageFramePaS)]

					if { !  [::olSDL_ViewsCalcCoor::Point_in_Rectangle [lindex $StartLinieCoords 2] [lindex $StartLinieCoords 3] $PageFrameInnerZoneCoords] } {
						return
					}
					# END:  in Frame ?
					#################################

					#################################
					# valid length ?

					if { ! [::olSDL_ViewsDrawMethods::valid_Channel_Part $StartLinieCoords] } {
						return
					}
					# END : valid length ?
					#################################

					set CanInfo(connect_ChannelCoords) $StartLinieCoords

					set CanInfo(connect_afterFirstPart) true

					set CanInfo(connect_Channel_ID) [$CanvasPathName create line $CanInfo(connect_ChannelCoords)]

					return

				} else {

					set tempLineCoords { }
					lappend tempLineCoords [lindex $CanInfo(connect_ChannelCoords) [expr [llength $CanInfo(connect_ChannelCoords)] - 2] ]
					lappend tempLineCoords [lindex $CanInfo(connect_ChannelCoords) [expr [llength $CanInfo(connect_ChannelCoords)] - 1] ]
					lappend tempLineCoords $x
					lappend tempLineCoords $y

					#################################
					# in Frame ?

					set PageFrameInnerZoneCoords [::olSDL_ViewsCalcCoor::calc_PageFrameInnerZoneCoords $CanInfo(PageFramePaS)]

					if { !  [::olSDL_ViewsCalcCoor::Point_in_Rectangle $x $y $PageFrameInnerZoneCoords] } {
						return
					}
					# END:  in Frame ?
					#################################

					#################################
					# valid length ?

					if { ! [::olSDL_ViewsDrawMethods::valid_Channel_Part $tempLineCoords] } {
						return
					}

					# valid length ?
					#################################

					$CanvasPathName delete $CanInfo(connect_Channel_ID)

					lappend CanInfo(connect_ChannelCoords) $x
					lappend CanInfo(connect_ChannelCoords) $y

					set CanInfo(connect_Channel_ID) [$CanvasPathName create line $CanInfo(connect_ChannelCoords)]

					return
				}
				# if { ! ($CanInfo(connect_afterFirstPart)) }

			} else {
				#  if {$CanInfo(connect_afterSource)}
				puts "not after Source"
			}
			#  if {$CanInfo(connect_afterSource)}

			return
		}
		default {
			error "unkown canvas"
			return
		}
	}
	# switch -exact $CanvasState
}
##############################################################################
proc ::olSDL_ProDiaViewBack::ProcessBackground {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	set x [expr int([$CanvasPathName canvasx $x])]
	set y [expr int([$CanvasPathName canvasy $y])]

	switch -exact $CanvasState {
		"place_new_rec_obj" -
		"place_state_machine_sym" {
			set Placement_current_x $x
			set Placement_current_y $y
			$CanvasPathName itemconfigure $CanInfo(Place_NewRec_FrameID) -state normal
			$CanvasPathName coords $CanInfo(Place_NewRec_FrameID) $CanInfo(Place_NewRec_x) $CanInfo(Place_NewRec_y) \
				$Placement_current_x $Placement_current_y
			return
		}
		"normal" -
		"flowline" -
		"single_obj_selected" -
		"connection" {
			return
		}
		default {
			error "unknown canvas state"
			return
		}
	}
	# switch -exact $CanvasState
}
##############################################################################
proc ::olSDL_ProDiaViewBack::EndBackground {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	set x [expr int([$CanvasPathName canvasx $x])]
	set y [expr int([$CanvasPathName canvasy $y])]

	switch -exact $CanvasState {
		"place_new_rec_obj" {

			set CoordsNewRecObj [$CanvasPathName coords $CanInfo(Place_NewRec_FrameID)]
			set CoordsNewRecObj [::olSDL_ViewsCalcCoor::convert_to_IntList $CoordsNewRecObj]

			# admissible new size ?
			if  {! [::olSDL_Views::admissibleRecObjSize $CoordsNewRecObj]}  {
				::olSDL_Views::PlaceRecSym::_delete_PlaceHelperObjects $CanInfoArr
				::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
				return
			}

			####################
			# symbols covered ?

			if { [::olSDL_Views::Obj_covered $CanvasPathName $CoordsNewRecObj "none" selectableRec] }  {
				::olSDL_Views::PlaceRecSym::_delete_PlaceHelperObjects $CanInfoArr
				::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
				return
			}

			if { [::olSDL_Views::Obj_covered $CanvasPathName $CoordsNewRecObj "none" moveableStateMaSym] }  {
				::olSDL_Views::PlaceRecSym::_delete_PlaceHelperObjects $CanInfoArr
				::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
				return
			}

			# symbols covered ?
			####################

			# object in PageFrame ?
			set PageFrameInnerZoneCoords [::olSDL_ViewsCalcCoor::calc_PageFrameInnerZoneCoords $CanInfo(PageFramePaS)]
			if {! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageFrameInnerZoneCoords $CoordsNewRecObj]} {
				::olSDL_Views::PlaceRecSym::_delete_PlaceHelperObjects $CanInfoArr
				::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
				return
			}

			# draw and set symbol in Model and Tcl
			set NewRecObj_PaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $CoordsNewRecObj]
			::olSDL_Views::draw_and_set_RecSym $CanInfo(Place_TypeOfNewRecObject) $NewRecObj_PaS "" $ObjArrName $CanInfoArr NewCanObjID

			# create bindings
			::olSDL_ProDiaView::setup_Bindings_for_RecSym $CanvasPathName $NewCanObjID

			###################
			#update SDL-Tree

			if { [ ::olSDL_Views::is_ReferencingSymbol $CanInfo(Place_TypeOfNewRecObject) ] } {
				::olSDL_ViewsTree::ReferencingSymbolAdded $CanInfo(Dia_Model_ID) $ObjArr($NewCanObjID,RefDia_Model_ID)
			}

			#update SDL-Tree
			###################

			::olSDL_Views::PlaceRecSym::_delete_PlaceHelperObjects $CanInfoArr
			::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy

			return
		}
		"place_state_machine_sym" {

			set CoordsNewRecObj [$CanvasPathName coords $CanInfo(Place_NewRec_FrameID)]
			set CoordsNewRecObj [::olSDL_ViewsCalcCoor::convert_to_IntList $CoordsNewRecObj]

			# admissible new size ?
			if  {! [::olSDL_Views::admissibleRecObjSize $CoordsNewRecObj]}  {
				::olSDL_Views::PlaceRecSym::_delete_PlaceHelperObjects $CanInfoArr
				::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
				return
			}

			##################
			# symbols covered ?

			if { [::olSDL_Views::Obj_covered $CanvasPathName $CoordsNewRecObj "none" selectableRec] }  {
				::olSDL_Views::PlaceRecSym::_delete_PlaceHelperObjects $CanInfoArr
				::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
				return
			}

			if { [::olSDL_Views::Obj_covered $CanvasPathName $CoordsNewRecObj "none" moveableStateMaSym] }  {
				::olSDL_Views::PlaceRecSym::_delete_PlaceHelperObjects $CanInfoArr
				::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
				return
			}

			# symbols covered ?
			##################


			# object in PageFrame ?
			set PageFrameInnerZoneCoords [::olSDL_ViewsCalcCoor::calc_PageFrameInnerZoneCoords $CanInfo(PageFramePaS)]
			if {! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageFrameInnerZoneCoords $CoordsNewRecObj]} {
				::olSDL_Views::PlaceRecSym::_delete_PlaceHelperObjects $CanInfoArr
				::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
				return
			}

			# draw and set symbol in Model and Tcl
			set NewRecObj_PaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $CoordsNewRecObj]
			::olSDL_Views::draw_and_set_StateMaSym $CanInfo(Place_TypeOfNewRecObject) $NewRecObj_PaS "" $ObjArrName $CanInfoArr NewCanObjID

			# create bindings
			::olSDL_ProDiaView::setup_Bindings_for_StateMaSym $CanvasPathName $NewCanObjID

			::olSDL_Views::PlaceRecSym::_delete_PlaceHelperObjects $CanInfoArr
			::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy

			return
		}
		"single_obj_selected" {
			::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
			return
		}
		"normal" -
		"flowline" -
		"connection" {
			return
		}
		default {
			error "unknown canvas state"
			return
		}
	}
	# switch -exact $CanvasState
}
##############################################################################
# END: methods for whole Canvas
##############################################################################

