
package provide olSDL_ProcedureDiaView 1

namespace eval olSDL_ProcedureDiaView {
	namespace eval EH {
	}
}
########################################################################################################
# Konstruktor fr System Diagram Views
proc ::olSDL_ProcedureDiaView::create  {ViewID TempArrName TempCanInfoArr CanvasPathName Dia_Model_ID PageID ButBoxPathName}  {

	upvar #0 ::olSDL_MAR::arr_MAR MAR

	#########
	# create toolbar

	create_Toolbar $ButBoxPathName $TempArrName $TempCanInfoArr

	# END : create toolbar
	#########

	#########
	# get page size

	get_PageSize_from_Model $Dia_Model_ID $PageID
	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set PageHeight $MAR(PageHeight)
	set PageWidth $MAR(PageWidth)

	# END: get page size
	#########

	########
	# setup Canvas Info array

	variable $TempCanInfoArr
	array set $TempCanInfoArr { }

	_init_Canvas_Info_Arr $TempCanInfoArr

	set ${TempCanInfoArr}(state) normal
	set ${TempCanInfoArr}(PageID) $PageID
	set ${TempCanInfoArr}(PageWidth) $PageWidth
	set ${TempCanInfoArr}(PageHeight) $PageHeight
	set ${TempCanInfoArr}(Dia_Model_ID) $Dia_Model_ID
	set ${TempCanInfoArr}(ViewID) $ViewID
	set ${TempCanInfoArr}(CanvasPathName) $CanvasPathName
	set ${TempCanInfoArr}(DiaType) ProcedureDia

	# END: setup Canvas Info array
	########

	upvar #0 $TempCanInfoArr CanInfo

	########
	# setup scrollregion

	::olSDL_Views::set_PageScrollregion $CanvasPathName $PageWidth $PageHeight

	# END: setup scrollregion
	########

	########
	# setup stacking order

	::olSDL_Views::AllViews::setup_stacking_order $CanvasPathName

	# END: setup stacking order
	########

	########
	# setup PageFrame Environment

	set ${TempCanInfoArr}(EnvironmentRectangle) [$CanvasPathName create rectangle 0 0 $PageWidth $PageHeight -tag EnvironmentRectangle -width 0]
	$CanvasPathName lower $CanInfo(EnvironmentRectangle) stack_EnvironmentRectangle

	# END: setup PageFrame Environment
	########

	variable $TempArrName
	array set $TempArrName { }

	# Frame and Header
	::olSDL_Views::get_and_draw_PageFrame_and_PageHeader $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID $PageID

	# Formal Parameters
	get_and_draw_Formal_Parameters $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID

	# text symbols
	::olSDL_Views::get_and_draw_Symbols TextSym $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID $PageID

	foreach symtype $::olSDL_Views::StateMaSym::StateSym {
	  ::olSDL_Views::get_and_draw_StateMaSyms $symtype $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID $PageID
	}

	# FlowLines
	::olSDL_Views::get_and_draw_FlowLines $TempArrName $TempCanInfoArr $CanvasPathName $Dia_Model_ID $PageID

	################
	# setup PageFrame Background

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $CanInfo(PageFramePaS) t_x1 t_y1 t_x2 t_y2
	set CanInfo(BackgroundRectangle) [$CanvasPathName create rectangle $t_x1 $t_y1 $t_x2 $t_y2 -tag BackgroundRectangle -width 0]

	$CanvasPathName lower $CanInfo(BackgroundRectangle) stack_BackgroundRectangle

	# END : setup PageFrame Background
	################

	#########
	# create Canvas Pop-Up Menus

	::olSDL_Views::AllViews::create_PopUpMenus $TempArrName $TempCanInfoArr

	# END : create Canvas Pop-Up Menus
	#########

	################
	# setup Event handling (tags)

	setup_EventHandling $TempArrName $TempCanInfoArr

	# END: setup Event handling (tags)
	################

	################
	# create bindings

	setup_Bindings $TempArrName $TempCanInfoArr

	# END : create bindings
	################

	################
	#
	set_canvas_state $TempArrName $TempCanInfoArr normal dummy
	#
	################
}
########################################################################################################
proc	::olSDL_ProcedureDiaView::_init_Canvas_Info_Arr {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanInfo(allObj) { }
	set CanInfo(selObj) { }

	set CanInfo(Place_TypeOfNewRecObject) ""
	set CanInfo(Place_NewRec_x) ""
	set CanInfo(Place_NewRec_y) ""
	set CanInfo(Place_NewRec_FrameID) ""

	set CanInfo(Resize_ActionType) ""
	set CanInfo(Resize_PointParentID) ""
	set CanInfo(Resize_FrameID) ""

	set CanInfo(Move_start_x) ""
	set CanInfo(Move_start_y) ""
	set CanInfo(Move_MovedObjID) ""
	set CanInfo(Move_Obj_moved) ""
	set CanInfo(Move_MoveFrameID) ""

	set CanInfo(BackgroundRectangle) ""

	set CanInfo(connect_Source_ID) ""
	set CanInfo(connect_SourcePaS) ""
	set CanInfo(connect_afterSource) false
	set CanInfo(connect_Source_x) ""
	set CanInfo(connect_Source_y) ""
 	set CanInfo(connect_afterFirstPart) false
	set CanInfo(connect_Channel_ID) ""
	set CanInfo(connect_ChannelCoords) { }

	set CanInfo(flowline_Source_x) ""
	set CanInfo(flowline_Source_y) ""
	set CanInfo(flowline_SourceID) ""
	set CanInfo(flowline_SourcePaS) ""
	set CanInfo(flowline_afterSource) ""
	set CanInfo(flowline_DestinationID) ""
	set CanInfo(flowline_DestinationPaS) ""
	set CanInfo(flowline_PreviewLineID) ""
}
########################################################################################################
proc ::olSDL_ProcedureDiaView::setup_Bindings {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	foreach element $CanInfo(allObj) {
		if {[::olSDL_Views::is_RecSym $ObjArr($element,Type)]} {
			setup_Bindings_for_RecSym $CanvasPathName $element
		} elseif {[::olSDL_Views::is_StateMaSym $ObjArr($element,Type)]} {
			setup_Bindings_for_StateMaSym $CanvasPathName $element
		}
	}
}
########################################################################################################
proc ::olSDL_ProcedureDiaView::setup_EventHandling {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	#########
	# Event Handler for FormalParameters

	set Callback "::olSDL_ProcedureDiaView::ClickOnFormalParameters $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableFormalParameters <Button-1> "$Callback %x %y"

	set Callback "::olSDL_ProcedureDiaView::show_FormalParametersPopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableFormalParameters <Button-3> "$Callback %x %y"

	# Event Handler for FormalParameters
	#########

	#########
	# Event Handler for RecSym

	set Callback "::olSDL_Views::RecSym::ClickOnRecSymbol $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::RecSym::EnterRecSymbol $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Enter> "$Callback"

	set Callback "::olSDL_Views::RecSym::LeaveRecSymbol $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Leave> "$Callback"

	set Callback "::olSDL_Views::RecSym::show_PopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableRec <Button-3> "$Callback %x %y"

	# END : Event Handler for RecSym
	#########

	#########
	# Event Handler for moving RecSymbols

	set Callback "::olSDL_Views::MoveRecSym::StartMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableRecSym <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::MoveRecSym::ProcessMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableRecSym <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::MoveRecSym::EndMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableRecSym <ButtonRelease-1> "$Callback %x %y"

	# Event Handler for moving RecSymbols
	#########

	#########
	# Event Handler for Resize Points of RecSymbols

	set Callback "::olSDL_Views::RecObjRP::RP_Enter $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <Enter> "$Callback"

	set Callback "::olSDL_Views::RecObjRP::RP_Leave $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <Leave> "$Callback"

	## Resizing
	set Callback "::olSDL_Views::ResizeRecSym::RP_StartResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::ResizeRecSym::RP_ProcessResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::ResizeRecSym::RP_EndResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind RecObjRP <ButtonRelease-1> "$Callback"

	# END: Event Handler for Resize Points of RecSymbols
	#########

	#########
	# Event Handler for Background

	set Callback "::olSDL_ProDiaViewBack::StartBackground $ObjArrName $CanInfoArr"
	$CanvasPathName bind BackgroundRectangle <Button-1> "$Callback %x %y"

	set Callback "::olSDL_ProDiaViewBack::ProcessBackground $ObjArrName $CanInfoArr"
	$CanvasPathName bind BackgroundRectangle <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_ProDiaViewBack::EndBackground $ObjArrName $CanInfoArr"
	$CanvasPathName bind BackgroundRectangle <ButtonRelease-1> "$Callback %x %y"

	# Event Handler for Background
	#########

	#########
	# Event Handler for Environment

	set Callback "::olSDL_Views::Env::ClickOnEnvironment $ObjArrName $CanInfoArr"
	$CanvasPathName bind EnvironmentRectangle <Button-1> "$Callback %x %y"

	# Event Handler for Environment
	#########

	#########
	# Event Handler for StateMaSym

	set Callback "::olSDL_Views::StateMaSym::ClickOnStateMaSym $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableStateMaSym <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::StateMaSym::EnterStateMaSym $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableStateMaSym <Enter> "$Callback"

	set Callback "::olSDL_Views::StateMaSym::LeaveStateMaSym $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableStateMaSym <Leave> "$Callback"

	set Callback "::olSDL_Views::StateMaSym::show_StateMaSymPopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableStateMaSym <Button-3> "$Callback %x %y"

	# END : Event Handler for StateMaSym
	#########

	#########
	# Event Handler for moving StateMaSym

	set Callback "::olSDL_Views::MoveStateMaSym::StartMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableStateMaSym <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::MoveStateMaSym::ProcessMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableStateMaSym <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::MoveStateMaSym::EndMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind moveableStateMaSym <ButtonRelease-1> "$Callback %x %y"

	# Event Handler for moving StateMaSym
	#########

	#########
	# Event Handler for Resize Points of StateMaSym

	set Callback "::olSDL_Views::RecObjRP::RP_Enter $ObjArrName $CanInfoArr"
	$CanvasPathName bind StateMaSymRP <Enter> "$Callback"

	set Callback "::olSDL_Views::RecObjRP::RP_Leave $ObjArrName $CanInfoArr"
	$CanvasPathName bind StateMaSymRP <Leave> "$Callback"

	## Resizing
	set Callback "::olSDL_Views::ResizeStateMaSym::RP_StartResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind StateMaSymRP <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::ResizeStateMaSym::RP_ProcessResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind StateMaSymRP <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::ResizeStateMaSym::RP_EndResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind StateMaSymRP <ButtonRelease-1> "$Callback"

	# END: Event Handler for Resize Points of StateMaSym
	#########

	#########
	# Event Handler for FlowLines

	set Callback "::olSDL_Views::FlowLine::ClickOnFlowLine $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableFlowLine <Button-1> "$Callback"

	set Callback "::olSDL_Views::FlowLine::ClickOnDecFlowLine $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableDecisionFlowLine <Button-1> "$Callback"

	# Event Handler for FlowLines
	#########

	#########
	# Event Handler for DecFlowLines

	set Callback "::olSDL_Views::FlowLine::show_DecFlowLinePopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableDecisionFlowLine <Button-3> "$Callback %x %y"

	# Event Handler for DecFlowLines
	#########

	#########
	# Event Handler for DecFlowLinesComp

	set Callback "::olSDL_Views::FlowLine::ClickOnDecFlowLineComp $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableDecFlowLineComp <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::FlowLine::show_DecFlowLineCompPopUpMenu $ObjArrName $CanInfoArr"
	$CanvasPathName bind selectableDecFlowLineComp <Button-3> "$Callback %x %y"

	# Event Handler for DecFlowLinesComp
	#########

	#########
	# Event Handler for moving DecFlowLinesComp

	set Callback "::olSDL_Views::FlowLine::StartDecFlowLineCompMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind movableDecFlowLineComp <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::FlowLine::ProcessDecFlowLineCompMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind movableDecFlowLineComp <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::FlowLine::EndDecFlowLineCompMove $ObjArrName $CanInfoArr"
	$CanvasPathName bind movableDecFlowLineComp <ButtonRelease-1> "$Callback %x %y"

	# Event Handler for moving DecFlowLinesComp
	#########
	#########

	#########
	# Event Handler for Resize Points of DecFlowLinesComp

	set Callback "::olSDL_Views::RecObjRP::RP_Enter $ObjArrName $CanInfoArr"
	$CanvasPathName bind DecisionFlowLineCompRP <Enter> "$Callback"

	set Callback "::olSDL_Views::RecObjRP::RP_Leave $ObjArrName $CanInfoArr"
	$CanvasPathName bind DecisionFlowLineCompRP <Leave> "$Callback"

	## Resizing
	set Callback "::olSDL_Views::FlowLine::RP_StartResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind DecisionFlowLineCompRP <Button-1> "$Callback %x %y"

	set Callback "::olSDL_Views::FlowLine::RP_ProcessResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind DecisionFlowLineCompRP <B1-Motion> "$Callback %x %y"

	set Callback "::olSDL_Views::FlowLine::RP_EndResize $ObjArrName $CanInfoArr"
	$CanvasPathName bind DecisionFlowLineCompRP <ButtonRelease-1> "$Callback"

	# Event Handler for Resize Points of DecFlowLinesComp
	#########

	#########
	# Event Handler for whole Canvas

	set Callback "::olSDL_ProcedureDiaView::EH::MouseMoved $ObjArrName $CanInfoArr"
	bind $CanvasPathName <Motion> "$Callback %x %y"

	# Event Handler for whole Canvas
	#########

}
########################################################################################################
# method for creating toolbar
########################################################################################################
proc ::olSDL_ProcedureDiaView::create_Toolbar {ButBoxPathName ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set ButBox $ButBoxPathName

	####
	set Callback "::olSDL_ProcedureDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr normal dummy"
	set SelectionArrowImage ${olSDL_AppVar::MyImagesPath}/olSDL_SelectionArrow
	set CanInfo(tbb,SelectionArrow) [$ButBox add -image [Bitmap::get $SelectionArrowImage] \
 							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
  							-helptext "Selection" -command "$Callback"]

	####
	set Callback "::olSDL_ProcedureDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_new_rec_obj TextSym"
	set TextSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_TextSym_neu
	set CanInfo(tbb,TextSym) [$ButBox add -image [Bitmap::get $TextSymImage] \
 						-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
  						-helptext "Text" -command "$Callback"]

	####
	set Callback "::olSDL_ProcedureDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaProcedureStartStateSym"
	set StateMachineProcedureStartStateSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_ProcedureStartState
	set CanInfo(tbb,StateMaProcedureStartStateSym) [$ButBox add -image [Bitmap::get $StateMachineProcedureStartStateSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Procedure Start" -command "$Callback"]

	####
	set Callback "::olSDL_ProcedureDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaStateSym"
	set StateMachineStateSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_NextState
	set CanInfo(tbb,StateMaStateSym) [$ButBox add -image [Bitmap::get $StateMachineStateSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "State" -command "$Callback"]

	####
	set Callback "::olSDL_ProcedureDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaOutputSym"
	set StateMachineOutputSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_Output
	set CanInfo(tbb,StateMaOutputSym) [$ButBox add -image [Bitmap::get $StateMachineOutputSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Output" -command "$Callback"]

	####
	set Callback "::olSDL_ProcedureDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaInputSym"
	set StateMachineInputSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_Input
	set CanInfo(tbb,StateMaInputSym) [$ButBox add -image [Bitmap::get $StateMachineInputSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Input" -command "$Callback"]

	####
	set Callback "::olSDL_ProcedureDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaTaskSym"
	set StateMachineTaskSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_Task
	set CanInfo(tbb,StateMaTaskSym) [$ButBox add -image [Bitmap::get $StateMachineTaskSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Task" -command "$Callback"]

	####
	set Callback "::olSDL_ProcedureDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaDecisionSym"
	set StateMachineDecisionSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_Decision
	set CanInfo(tbb,StateMaDecisionSym) [$ButBox add -image [Bitmap::get $StateMachineDecisionSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Decision" -command "$Callback"]

	####
	set Callback "::olSDL_ProcedureDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaCreateProSym"
	set StateMachineCreateProSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_CreatePro
	set CanInfo(tbb,StateMaCreateProSym) [$ButBox add -image [Bitmap::get $StateMachineCreateProSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "CreateProcess" -command "$Callback"]

	####
	set Callback "::olSDL_ProcedureDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaCallProcedureSym"
	set StateMachineCallProcedureSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_CallProcedure
	set CanInfo(tbb,StateMaCallProcedureSym) [$ButBox add -image [Bitmap::get $StateMachineCallProcedureSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "CallProcedure" -command "$Callback"]

	####
	set Callback "::olSDL_ProcedureDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr place_state_machine_sym StateMaProcedureReturnSym"
	set StateMachineProcedureReturnSymImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_Return
	set CanInfo(tbb,StateMaProcedureReturnSym) [$ButBox add -image [Bitmap::get $StateMachineProcedureReturnSymImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Return" -command "$Callback"]

	####
	set Callback "::olSDL_ProcedureDiaView::EH::set_canvas_state $ObjArrName $CanInfoArr flowline dummy"
	set FlowLineImage ${olSDL_AppVar::MyImagesPath}/StateMaSym/olSDL_FlowLine
	set CanInfo(tbb,FlowLineSym) [$ButBox add -image [Bitmap::get $FlowLineImage] \
   							-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    							-helptext "Flow Line" -command "$Callback"]

	####
	set Callback "::olSDL_ProcedureDiaView::delete_Object $ObjArrName $CanInfoArr"
	set DeleteRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_DeleteRecSymSign
	$ButBox add -image [Bitmap::get $DeleteRefSymImage] \
   		-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Delete" -command "$Callback"

	####
	set Callback "::olSDL_ProcedureDiaView::Diagram_up $ObjArrName $CanInfoArr"
	set DeleteRefSymImage ${olSDL_AppVar::MyImagesPath}/olSDL_DiagramUp
	$ButBox add -image [Bitmap::get $DeleteRefSymImage] \
   		-highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Diagram up" -command "$Callback"

	pack $ButBox -side top -anchor n
}
########################################################################################################
proc ::olSDL_ProcedureDiaView::setup_Bindings_for_StateMaSym {CanvasPathName CanObjID} {
	$CanvasPathName itemconfigure $CanObjID -tag {selectableStateMaSym moveableStateMaSym}
}
########################################################################################################
proc ::olSDL_ProcedureDiaView::setup_Bindings_for_RecSym {CanvasPathName CanObjID} {
	$CanvasPathName itemconfigure $CanObjID -tag {selectableRec moveableRecSym}
}
########################################################################################################
proc ::olSDL_ProcedureDiaView::set_canvas_state {ObjArrName CanInfoArr State ObjType} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	set CanInfo(state) $State
	set CanInfo(Place_TypeOfNewRecObject) $ObjType

	###########

	$CanInfo(tbb,SelectionArrow) configure -relief raised
	$CanInfo(tbb,TextSym) configure -relief raised

	$CanInfo(tbb,StateMaStateSym) configure -relief raised
	$CanInfo(tbb,StateMaInputSym) configure -relief raised
	$CanInfo(tbb,StateMaOutputSym) configure -relief raised
	$CanInfo(tbb,StateMaTaskSym) configure -relief raised
	$CanInfo(tbb,StateMaDecisionSym) configure -relief raised
	$CanInfo(tbb,StateMaCreateProSym) configure -relief raised
	$CanInfo(tbb,StateMaCallProcedureSym) configure -relief raised
	$CanInfo(tbb,StateMaProcedureStartStateSym) configure -relief raised
	$CanInfo(tbb,StateMaProcedureReturnSym) configure -relief raised

	$CanInfo(tbb,FlowLineSym) configure -relief raised


	###########

	if { $State == "normal" } {
		$CanInfo(tbb,SelectionArrow) configure -relief sunken
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
		return
	}

	if { $State == "single_obj_selected" } {
		$CanInfo(tbb,SelectionArrow) configure -relief sunken
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
		return
	}

	if { $State == "flowline" } {
		$CanInfo(tbb,FlowLineSym) configure -relief sunken
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
		return
	}


	if { [string compare $State "place_new_rec_obj"] == 0 } {

		switch -exact $ObjType {
			TextSym {
				$CanInfo(tbb,TextSym) configure -relief sunken
				return
			}
			default {
				error "unknown canvas state1"
			}
		}
		# switch -exact $ObjType
	}
	# if {$State ==place_new_rec_ob}

	if { [string compare $State "place_state_machine_sym"] == 0 } {

		switch -exact $ObjType {
			StateMaStateSym {
				$CanInfo(tbb,StateMaStateSym) configure -relief sunken
				return
			}
			StateMaInputSym {
				$CanInfo(tbb,StateMaInputSym) configure -relief sunken
				return
			}
			StateMaOutputSym {
				$CanInfo(tbb,StateMaOutputSym) configure -relief sunken
				return
			}
			StateMaTaskSym {
				$CanInfo(tbb,StateMaTaskSym) configure -relief sunken
				return
			}
			StateMaDecisionSym {
				$CanInfo(tbb,StateMaDecisionSym) configure -relief sunken
				return
			}
			StateMaCreateProSym {
				$CanInfo(tbb,StateMaCreateProSym) configure -relief sunken
				return
			}
			StateMaCallProcedureSym {
				$CanInfo(tbb,StateMaCallProcedureSym) configure -relief sunken
				return
			}
			StateMaProcedureStartStateSym {
				$CanInfo(tbb,StateMaProcedureStartStateSym) configure -relief sunken
				return
			}
			StateMaProcedureReturnSym {
				$CanInfo(tbb,StateMaProcedureReturnSym) configure -relief sunken
				return
			}
			default {
				error "unknown canvas state2"
			}
		}
		# switch -exact $ObjType
	}
	# if {$State == "place_state_machine_sym"}

	error "unknown canvas state3"
}
##############################################################################
proc ::olSDL_ProcedureDiaView::Diagram_up {ObjArrName CanInfoArr} {

	::olSDL_Views::ViewsManager::All_Diagram_up $ObjArrName $CanInfoArr

}
##############################################################################
proc ::olSDL_ProcedureDiaView::delete_Object {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	foreach selectedObj $CanInfo(selObj) {

		set AllTags [$CanvasPathName gettags $selectedObj]

		if { [lsearch -exact $AllTags selectableRec] != -1 } {

			###################
			# delete RecSyms
			###################

			###################
			#update SDL-Tree

			if { [ ::olSDL_Views::is_ReferencingSymbol $ObjArr($selectedObj,Type)] } {
				::olSDL_ViewsTree::ReferencingSymbolDeleted $ObjArr($selectedObj,RefDia_Model_ID)
			}

			#update SDL-Tree
			###################

			# delete Resize Points
			::olSDL_ViewsDrawMethods::delete_RecSym_RP_from_Canvas $ObjArrName $CanInfoArr $selectedObj

			::olSDL_Views::RecSym::delete_RecSym_from_T_M_C $ObjArrName $CanInfoArr $selectedObj

		} elseif { ([lsearch -exact $AllTags selectableFlowLine] != -1) } {

			###################
			# delete FlowLine
			###################

			# delete MP
			::olSDL_ViewsDrawMethods::delete_FlowLine_MP_from_Canvas $ObjArrName $CanInfoArr $selectedObj

			# delete flow line from canvas, tcl, model
			::olSDL_Views::FlowLine::delete_NormalFlowLine_from_T_M_C $ObjArrName $CanInfoArr $selectedObj

		} elseif { ([lsearch -exact $AllTags selectableDecisionFlowLine] != -1) } {

			###################
			# delete DecFlowLine
			###################

			# delete MP
			::olSDL_ViewsDrawMethods::delete_DecisionFlowLine_MP_from_Canvas $ObjArrName $CanInfoArr $selectedObj

			# delete dec flow line from canvas, tcl, model
			::olSDL_Views::FlowLine::delete_DecisionFlowLine_from_T_M_C $ObjArrName $CanInfoArr $selectedObj

		} elseif { ([lsearch -exact $AllTags selectableStateMaSym] != -1) } {

			###################
			# delete StateMaSym
			###################

			# delete Resize Points
			::olSDL_ViewsDrawMethods::delete_StateMaSym_RP_from_Canvas $ObjArrName $CanInfoArr $selectedObj

			# delete state ma sym form tcl, canvas, model
			::olSDL_Views::StateMaSym::delete_StateMaSym_from_T_M_C $ObjArrName $CanInfoArr $selectedObj

			###################
			# delete connected FlowLines
			###################

				###################
				# normal flow line

				set ConnectedFlowLines [::olSDL_Views::StateMaSym::get_connected_NormalFlowLines $ObjArrName $CanInfoArr $selectedObj]

				foreach FlowLine $ConnectedFlowLines {

					# delete flow line from canvas, tcl, model
					::olSDL_Views::FlowLine::delete_NormalFlowLine_from_T_M_C $ObjArrName $CanInfoArr $FlowLine

				}

				# normal flow line
				###################

				###################
				# dec flow line

				set ConnectedFlowLines [::olSDL_Views::StateMaSym::get_connected_DecisionFlowLines $ObjArrName $CanInfoArr $selectedObj]

				foreach FlowLine $ConnectedFlowLines {

					# delete dec flow line from canvas, tcl, model
					::olSDL_Views::FlowLine::delete_DecisionFlowLine_from_T_M_C $ObjArrName $CanInfoArr $FlowLine

				}

				# dec flow line
				###################

			###################
			# END: delete connected FlowLines
			###################
		}
	}
	# foreach selectedObj $CanInfo(selObj)

	set_canvas_state $ObjArrName $CanInfoArr normal dummy
}
##############################################################################
proc ::olSDL_ProcedureDiaView::delete_all_Selections {ObjArrName CanInfoArr} {

}
########################################################################################################
proc ::olSDL_ProcedureDiaView::get_and_draw_Formal_Parameters {ObjArrName CanInfoArr CanvasPathName DiagramID} {

	upvar #0 ::olSDL_MAR::arr_MAR MAR
	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	get_ProcedureFormalParameters_from_Model $DiagramID

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set HP_FormalParameters [::olSDL_Views::MAR_StringToString $MAR(HP_FormalParameters)]


	# search for Diagram_TypeAndName_CanID
	foreach element [array names ObjArr] {
		if { [string first ",Type" $element] != -1 } {
			if { ($ObjArr($element) == "HP_PageName") } {
				set tempIndex [string first , $element]
				if { $tempIndex == -1 } {
					error	"index not found"
					return
				}
				set Diagram_TypeAndName_CanID [string range $element 0 [expr $tempIndex -1]]
			}
		}
	}

	# get Diagram_TypeAndName_PaS
	set Diagram_TypeAndName_PaS $ObjArr($Diagram_TypeAndName_CanID,PaS)


	::olSDL_ViewsDrawMethods::draw_FormalParameters $CanvasPathName $Diagram_TypeAndName_PaS $HP_FormalParameters \
		CanObjID Comp ParametersPaS

	set ${ObjArrName}(${CanObjID},Type) "HP_FormalParameters"
	set ${ObjArrName}(${CanObjID},Name) $HP_FormalParameters
	set ${ObjArrName}(${CanObjID},Comp) $Comp
	set ${ObjArrName}(${CanObjID},PaS) $ParametersPaS


	lappend CanInfo(allObj) $CanObjID
}
########################################################################################################
proc ::olSDL_ProcedureDiaView::ClickOnFormalParameters {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasState $CanInfo(state)
	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	if { ($CanvasState == "single_obj_selected") || ($CanvasState == "normal") } {

		::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr

		# set previous selected object unselected
		::olSDL_Views::AllViews::delete_all_Selections $ObjArrName $CanInfoArr

		#draw resize points
		::olSDL_ViewsDrawMethods::draw_ProcedureFormalParameters_ResizePoints $ObjArrName $CanInfoArr $currentObject

		# set new canvas state
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr single_obj_selected dummy

		lappend CanInfo(selObj) $currentObject

		return
	}

}
########################################################################################################
proc ::olSDL_ProcedureDiaView::show_FormalParametersPopUpMenu {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr

	set x_in_can [expr int (round ($x))]
	set y_in_can [expr int (round ($y))]

	set PopUp_x [expr $x_in_can + [winfo rootx $CanvasPathName]]
	set PopUp_y [expr $y_in_can + [winfo rooty $CanvasPathName]]

	set CanInfo(PU_FormalParametersCanID) $currentObject

	$CanInfo(menu_FormalParameters_PopUp) post $PopUp_x $PopUp_y
}
########################################################################################################
proc ::olSDL_ProcedureDiaView::EditFormalParameters {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set FormalParametersCanID $CanInfo(PU_FormalParametersCanID)

	set DlgTitle "Formal Parameters"

	set dlg [Dialog .formal_parameters_edit -parent . -modal local -title Edit -geometry 300x300+200+100]

	set dTitleFrame [TitleFrame [$dlg getframe].tf]

	$dTitleFrame configure -text $DlgTitle

	set sw [ScrolledWindow [$dTitleFrame getframe].sw -relief sunken -borderwidth 2]
	set dtext [text [$sw getframe].tx ]
	$sw setwidget $dtext

	$dtext delete 1.0 end
	$dtext insert 1.0 $ObjArr($FormalParametersCanID,Name)

	pack $sw -fill both -expand true
	pack $dTitleFrame -fill both -expand true

	$dlg add -name ok
	$dlg add -name clear -text clear -command "$dtext delete 1.0 end"
	$dlg add -name cancel


	set DiaResult [$dlg draw]

	if { $DiaResult == 0 } {

		set NewText [string trimright [$dtext get 1.0 end]]

		::olSDL_ViewsDrawMethods::redraw_ProcedureFormalParameters $ObjArrName $CanInfoArr $FormalParametersCanID \
			$NewText NewPaS

		#############
		# store in Tcl

		set ObjArr($FormalParametersCanID,Name) $NewText
		set ObjArr($FormalParametersCanID,PaS) $NewPaS

		# store in Tcl
		#############

		#############
		# store in Model

		modify_ProcedureDiaFormalParameters_in_Model $CanInfo(Dia_Model_ID) $NewText

		# store in Model
		#############

		#############
		# redraw resize points

		# set previous selected object unselected
		::olSDL_Views::AllViews::delete_all_Selections $ObjArrName $CanInfoArr

		#draw resize points
		::olSDL_ViewsDrawMethods::draw_ProcedureFormalParameters_ResizePoints $ObjArrName $CanInfoArr $FormalParametersCanID

		# set new canvas state
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr single_obj_selected dummy

		# redraw resize points
		#############

		lappend CanInfo(selObj) $FormalParametersCanID

	}
	# if { $DiaResult == 0 }

	destroy $dlg
}

########################################################################################################
########################################################################################################
proc ::olSDL_ProcedureDiaView::EH::set_canvas_state {ObjArrName CanInfoArr State ObjType} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	::olSDL_Views::AllViews::delete_all_Selections $ObjArrName $CanInfoArr

	::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr $State $ObjType
}
########################################################################################################
proc ::olSDL_ProcedureDiaView::EH::MouseMoved {ObjArrName CanInfoArr x y} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	return

	set CanvasPathName $CanInfo(CanvasPathName)

	set x [expr int([$CanvasPathName canvasx $x])]
	set y [expr int([$CanvasPathName canvasy $y])]


	if { $CanInfo(flowline_afterSource) != "true" } {
		return
	}

	if { $CanInfo(flowline_PreviewLineID) != "" } {

		$CanvasPathName coords $CanInfo(flowline_PreviewLineID) $CanInfo(flowline_Source_x) $CanInfo(flowline_Source_y) $x $y
	} else {

		set CanInfo(flowline_PreviewLineID) [$CanvasPathName create line $CanInfo(flowline_Source_x) $CanInfo(flowline_Source_y) $x $y -width 1]
	}

}

