package provide olSDL_Views 1

namespace eval olSDL_Views {
	namespace eval RecObjRP {
	}
}

##############################################################################
# methods for RESIZING StateMaSym
##############################################################################
proc ::olSDL_Views::RecObjRP::RP_Leave {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
}
##############################################################################
proc ::olSDL_Views::RecObjRP::RP_Enter {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	set AllTags [$CanvasPathName gettags $currentObject]

	set RP_Type_Index [lsearch -glob $AllTags RecObjRP_type*]
	set RP_Type [lindex $AllTags $RP_Type_Index]

	switch -exact $RP_Type {
		RecObjRP_type_left_up {
			$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_RP_left_up
		}
		RecObjRP_type_right_up {
			$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_RP_right_up
		}
		RecObjRP_type_left_down {
			$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_RP_left_down
		}
		RecObjRP_type_right_down {
			$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_RP_right_down
		}
		RecObjRP_type_up {
			$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_RP_up
		}
		RecObjRP_type_down {
			$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_RP_down
		}
		RecObjRP_type_right {
			$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_RP_right
		}
		RecObjRP_type_left {
			$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_RP_left
		}
		default {
			error "unkown Resize Point Type"
		}
	}
	# switch -exact $RP_Type
}
##############################################################################
proc ::olSDL_Views::RecObjRP::get_Parent_from_ResizePoint {ObjArrName CanInfoArr RP_ID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set AllTags [$CanvasPathName gettags $RP_ID]

	set RP_Type_Index [lsearch -glob $AllTags RPparent*]
	set RP_Parent [lindex $AllTags $RP_Type_Index]

	set parent_ID [string range $RP_Parent 8 end]

	return $parent_ID
}
##############################################################################
proc ::olSDL_Views::RecObjRP::calc_ResizeFrameCoords {ObjArrName CanInfoArr Resize_current_x Resize_current_y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	##############
	# determine Parent

	set Parent_ID $CanInfo(Resize_PointParentID)
	set ParentPaS $ObjArr($Parent_ID,PaS)
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $ParentPaS Parent_x1 Parent_y1 Parent_x2 Parent_y2

	set RP_Type $CanInfo(Resize_ActionType)

	switch -exact $RP_Type {
		RecObjRP_type_left_up {
			set ResizeFrame_x1 $Resize_current_x
			set ResizeFrame_y1 $Resize_current_y
			set ResizeFrame_x2 $Parent_x2
			set ResizeFrame_y2 $Parent_y2
		}
		RecObjRP_type_right_up {
			set ResizeFrame_x1 $Parent_x1
			set ResizeFrame_y1 $Resize_current_y
			set ResizeFrame_x2 $Resize_current_x
			set ResizeFrame_y2 $Parent_y2
		}
		RecObjRP_type_left_down {
			set ResizeFrame_x1 $Resize_current_x
			set ResizeFrame_y1 $Parent_y1
			set ResizeFrame_x2 $Parent_x2
			set ResizeFrame_y2 $Resize_current_y
		}
		RecObjRP_type_right_down {
			set ResizeFrame_x1 $Parent_x1
			set ResizeFrame_y1 $Parent_y1
			set ResizeFrame_x2 $Resize_current_x
			set ResizeFrame_y2 $Resize_current_y
		}
		RecObjRP_type_up {
			set ResizeFrame_x1 $Parent_x1
			set ResizeFrame_y1 $Resize_current_y
			set ResizeFrame_x2 $Parent_x2
			set ResizeFrame_y2 $Parent_y2
		}
		RecObjRP_type_down {
			set ResizeFrame_x1 $Parent_x1
			set ResizeFrame_y1 $Parent_y1
			set ResizeFrame_x2 $Parent_x2
			set ResizeFrame_y2 $Resize_current_y
		}
		RecObjRP_type_right {
			set ResizeFrame_x1 $Parent_x1
			set ResizeFrame_y1 $Parent_y1
			set ResizeFrame_x2 $Resize_current_x
			set ResizeFrame_y2 $Parent_y2
		}
		RecObjRP_type_left {
			set ResizeFrame_x1 $Resize_current_x
			set ResizeFrame_y1 $Parent_y1
			set ResizeFrame_x2 $Parent_x2
			set ResizeFrame_y2 $Parent_y2
		}
		default {
			error "unkown Resize Point Type"
		}
	}
	# switch -exact $RP_Type

	return [list $ResizeFrame_x1 $ResizeFrame_y1 $ResizeFrame_x2 $ResizeFrame_y2]
}
##############################################################################
proc ::olSDL_Views::RecObjRP::determine_ResizeActionType {ObjArrName CanInfoArr RP_ID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set AllTags [$CanvasPathName gettags $RP_ID]

	set RP_Type_Index [lsearch -glob $AllTags RecObjRP_type*]
	set RP_Type [lindex $AllTags $RP_Type_Index]

	switch -exact $RP_Type {
		RecObjRP_type_left_up {
			return RecObjRP_type_left_up
		}
		RecObjRP_type_right_up {
			return RecObjRP_type_right_up
		}
		RecObjRP_type_left_down {
			return RecObjRP_type_left_down
		}
		RecObjRP_type_right_down {
			return RecObjRP_type_right_down
		}
		RecObjRP_type_up {
			return RecObjRP_type_up
		}
		RecObjRP_type_down {
			return RecObjRP_type_down
		}
		RecObjRP_type_right {
			return RecObjRP_type_right
		}
		RecObjRP_type_left {
			return RecObjRP_type_left
		}
		default {
			error "unkown Resize Point Type"
		}
	}
	# switch -exact $RP_Type
}
##############################################################################
proc ::olSDL_Views::RecObjRP::init_ResizeHelperObjects {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanInfo(Resize_ActionType) ""
	set CanInfo(Resize_PointParentID) ""
	set CanInfo(Resize_FrameID) ""
}
##############################################################################
proc ::olSDL_Views::RecObjRP::delete_ResizeHelperObjects {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	# delete ResizeFrame from Canvas
	$CanvasPathName delete $CanInfo(Resize_FrameID)

	set CanInfo(Resize_ActionType) ""
	set CanInfo(Resize_PointParentID) ""
	set CanInfo(Resize_FrameID) ""
}
##############################################################################

