
package provide olSDL_Views 1

namespace eval olSDL_Views {
	namespace eval ResizeRecSym {
	}
	namespace eval MoveRecSym {
	}
	namespace eval PlaceRecSym {
	}
	namespace eval RecSym {
	  set RecSym {TextSym BlkInstRefSym BlkTypeRefSym ProInstRefSym ProTypeRefSym ProcedureInstRefSym}
	}
}
##############################################################################
# methods for RecObj like text symbol, block instance reference symbol, .......
##############################################################################
proc ::olSDL_Views::RecSym::EnterRecSymbol {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	if { [lsearch $CanInfo(selObj) $currentObject] != -1 } {
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Selected
	}
}
##############################################################################
proc ::olSDL_Views::RecSym::LeaveRecSymbol {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
}
##############################################################################
proc ::olSDL_Views::RecSym::ZoomIn {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	upvar #0 ::olSDL_Views::arr_Views Views
	upvar #0 ::olSDL_MAR::arr_MAR MAR

	set ObjectType $ObjArr($CanInfo(PU_RecSym_Object_ID),Type)
	set ZoomDiagramID $ObjArr($CanInfo(PU_RecSym_Object_ID),RefDia_Model_ID)

	##############
	# get FirstPageID

	get_FirstPageID_from_Model $ZoomDiagramID

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set FirstPageID $MAR(FirstPageID)

	# END: get FirstPageID
	##############

	::olSDL_Views::ViewsManager::DeleteOldViewAndChangeToNewView $CanInfo(ViewID) $ObjectType $ZoomDiagramID $FirstPageID

	###################
	#update SDL-Tree

	::olSDL_ViewsTree::ShowCurrentDiagram $ZoomDiagramID

	#update SDL-Tree
	###################

	# indicator
	::olSDL_MainMenu::update_Indicator
}
##############################################################################
proc ::olSDL_Views::RecSym::EditContent {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set RecSymCanID $CanInfo(PU_RecSym_Object_ID)

	##################################
	# determine title for different RecSyms

	switch -exact $ObjArr($RecSymCanID,Type) {
		TextSym {
			set DlgTitle "Text Symbol"
			EditDialog_Text $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
			return
		}
		BlkInstRefSym {
			set DlgTitle "Block Instance Reference Symbol"
		}
		BlkTypeRefSym {
			set DlgTitle "Block Type Reference Symbol"
		}
		ProInstRefSym {
			set DlgTitle "Process Instance Reference Symbol"
		}
		ProTypeRefSym {
			set DlgTitle "Process Type Reference Symbol"
		}
		ProcedureInstRefSym {
			set DlgTitle "Procedure Inst Reference Symbol"
		}
		default {
			error "unkown Symbol Type"
		}
	}
	# switch -exact $ObjArr($RecSymCanID,Type)

	# determine title for different RecSyms
	##################################

	EditDialog_Agent $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
}
##############################################################################
proc ::olSDL_Views::RecSym::EditDialog_Text {DlgTitle ObjArrName CanInfoArr RecSymCanID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set dlg [Dialog .rec_sym_edit -parent . -modal local -title Edit -geometry 300x300+200+100]

	set dTitleFrame [TitleFrame [$dlg getframe].tf]
	$dTitleFrame configure -text $DlgTitle

	set sw [ScrolledWindow [$dTitleFrame getframe].sw -relief sunken -borderwidth 2]
	set dtext [text [$sw getframe].tx ]
	$sw setwidget $dtext

	$dtext delete 1.0 end
	$dtext insert 1.0 $ObjArr($RecSymCanID,Text)

	pack $sw -fill both -expand true
	pack $dTitleFrame -fill both -expand true

	$dlg add -name ok
	$dlg add -name clear -text clear -command "$dtext delete 1.0 end"
	$dlg add -name cancel

	set DiaResult [$dlg draw]

	if { $DiaResult == 0 } {
		set NewText [string trimright [$dtext get 1.0 end]]

		::olSDL_Views::RecSym::modify_RecSym_Content_in_T_M_C $ObjArrName $CanInfoArr $RecSymCanID $NewText
	}

	destroy $dlg
}
##############################################################################
proc ::olSDL_Views::RecSym::EditDialog_Agent {DlgTitle ObjArrName CanInfoArr RecSymCanID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	global maxunb

	set init_def 1
	set init_min 0
	set max_def 1
	set max_min 1
	set maxunb 1

	set dlg [Dialog .rec_sym_edit -parent . -modal local -title Edit -geometry 300x300+200+100]

	set dTitleFrame [TitleFrame [$dlg getframe].tf]
	$dTitleFrame configure -text $DlgTitle

	set tframe [$dTitleFrame getframe]

	set params [split $ObjArr($RecSymCanID,Text)]
	set agent_name [lindex $params 0]
	
	if [regexp {\((\d*),(\d*)\)} [lindex $params 1] out min max] {
	  if {$min != ""} {set init_def $min}
	  if {$max != ""} {set max_def $max; set maxunb 0}
	}
	set type ""
	if {[llength $params]>2} {
	  regexp {:?\s*(\w*)} [lindex $params end] out type
	}

	set dname [LabelEntry $tframe.name]
	$dname configure -label Name -text $agent_name
	pack $dname -fill x

	set dinstl [Label $tframe.instl -text Instances -anchor w]
	pack $dinstl -fill x

	set dinstf [frame $tframe.instf]
	set dminl [Label $tframe.instf.minl -text Initial]
	set dmin [SpinBox $tframe.instf.min -range {0 100 1} -width 4 -text $init_def]
# -modifycmd {if {[$dmaxl getvalue] < [$dminl getvalue]} {$dmaxl setvalue [$dmaxl setvalue]]}}
	set dmaxl [Label $tframe.instf.maxl -text Max]
	set dmax [SpinBox $tframe.instf.max -range {1 100 1} -width 4 -text $max_def -modifycmd "$tframe.instf.unb deselect"]
	set dmaxunbl [Label $tframe.instf.maxunbl -text Unbounded]
	set dmaxunb [checkbutton $tframe.instf.unb -variable maxunb]
	pack $dminl $dmin $dmaxl $dmax $dmaxunbl $dmaxunb -side left -fill x -expand true
	pack $dinstf -fill x

	set dtype [LabelEntry $tframe.type]
	$dtype configure -label Type -text $type
	pack $dtype -fill x -pady 2

	pack $dTitleFrame -fill both -expand true

	$dlg add -name ok
	$dlg add -name clear -text clear -command "$dname delete 0 end; $dtype delete 0 end;"
	$dlg add -name cancel

	set DiaResult [$dlg draw]

	if { $DiaResult == 0 } {

		set NewText [string trimright [$dname get]]
		set num_inst "("
		if {[$dmin getvalue] != 1} {
		  append num_inst [expr [$dmin getvalue]+$init_min]
		}
		append num_inst ","
		if {$maxunb == 0} {
		  append num_inst [expr [$dmax getvalue]+$max_min]
		}
		append num_inst ")"
		if {$num_inst !="(,)"} {
		  append NewText " " $num_inst
		}
		set type [string trimright [$dtype get]]
		if {$type !=""} {
		  append NewText " : " $type
		}

		::olSDL_Views::RecSym::modify_RecSym_Content_in_T_M_C $ObjArrName $CanInfoArr $RecSymCanID $NewText

		###################
		#update SDL-Tree

		if { [ ::olSDL_Views::is_ReferencingSymbol $ObjArr($RecSymCanID,Type)] } {
			::olSDL_ViewsTree::ReferencingSymbolModified $ObjArr($RecSymCanID,RefDia_Model_ID) $ObjArr($RecSymCanID,Text)
		}

		#update SDL-Tree
		###################

	}
	# if { $DiaResult == 0 }

	destroy $dlg
}
##############################################################################
proc ::olSDL_Views::RecSym::show_PopUpMenu {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	set x_in_can [expr int (round ($x))]
	set y_in_can [expr int (round ($y))]

	set PopUp_x [expr $x_in_can + [winfo rootx $CanvasPathName]]
	set PopUp_y [expr $y_in_can + [winfo rooty $CanvasPathName]]

	set CanInfo(PU_RecSym_Object_ID) $currentObject

	# unpost CM
	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr

	# set selected
	::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $currentObject


	#############
	#prepare Pop Up

	if { [::olSDL_Views::is_ReferencingSymbol $ObjArr($CanInfo(PU_RecSym_Object_ID),Type)] } {
		$CanInfo(menu_RecSymPopUp) entryconfigure 1 -state normal
	} else {
		$CanInfo(menu_RecSymPopUp) entryconfigure 1 -state disabled
	}

	#prepare Pop Up
	#############

	$CanInfo(menu_RecSymPopUp) post $PopUp_x $PopUp_y
}
##############################################################################
proc ::olSDL_Views::RecSym::move_connected_channels {ObjArrName CanInfoArr Obj_ID old_PaS new_PaS} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	set ConnectedChannels [::olSDL_Views::RecSym::get_connected_Channels $ObjArrName $CanInfoArr $Obj_ID]

	foreach Chan $ConnectedChannels {

		::olSDL_Views::Channel::modify_Channel_Coords $ObjArrName $CanInfoArr $Chan $Obj_ID $old_PaS $new_PaS

		::olSDL_ViewsDrawMethods::delete_ChannelComp_from_Canvas $ObjArrName $CanInfoArr $Chan

		# draw Channel
		 ::olSDL_ViewsDrawMethods::draw_Channel $CanvasPathName \
			$ObjArr($Chan,Coords) \
			$ObjArr($Chan,DelayType) $ObjArr($Chan,DirectionType) \
			true $Chan \
			NewChannel_ID

	}
	# foreach Chan $ConnectedChannels
}
##############################################################################
proc ::olSDL_Views::RecSym::get_connected_Channels {ObjArrName CanInfoArr Obj_ID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set ConnectedChannels { }
	set AllChannels [::olSDL_Views::Channel::get_all_channels $CanInfoArr]

	foreach Chan $AllChannels {
		if { [::olSDL_Views::Channel::is_connected $ObjArrName $Chan $Obj_ID] } {
			lappend ConnectedChannels $Chan
		}
	}
	#foreach Chan $AllChannels

	return $ConnectedChannels
}
##############################################################################
proc ::olSDL_Views::RecSym::ClickOnRecSymbol {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasState $CanInfo(state)
	set CanvasPathName $CanInfo(CanvasPathName)

	set x [expr int([$CanvasPathName canvasx $x])]
	set y [expr int([$CanvasPathName canvasy $y])]

	set currentObject [$CanvasPathName find withtag current]

	######## case A ###########

	if { ($CanvasState == "single_obj_selected") || ($CanvasState == "normal") } {

		::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr
		::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $currentObject

		return
	}
	# if

	######## case B ###########

	if { $CanvasState == "place_new_rec_obj" } {
		return
	}

	######## case C ###########
	#
	if { $CanvasState == "connection" } {

		###########################
		##### C1
		###########################

		if { ! ($CanInfo(connect_afterSource)) } {

			if { ! [::olSDL_Views::_is_valid_Channel_Source $ObjArr($currentObject,Type)] } {
				return
			}
			::olSDL_Views::Channel::_init_ConnectHelperObjects $ObjArrName $CanInfoArr $currentObject false $x $y

			return
		}
		# if { ! ($CanInfo(connect_afterSource)) }

		if { ($CanInfo(connect_afterSource)) } {

			###########################
			##### C2
			###########################

			if { $CanInfo(connect_afterFirstPart) } {

				#puts "after source, after first part"

				if { ! ($CanInfo(connect_Source_is_Env)) } {
					if { $currentObject == $CanInfo(connect_Source_ID) } {
						return
					}
				}

				if { ! [::olSDL_Views::_is_valid_Channel_Destination $ObjArr($currentObject,Type)] } {
					return
				}

				set CanInfo(connect_Destination_ID) $currentObject
				set CanInfo(connect_DestinationPaS) $ObjArr($currentObject,PaS)

				set ConPoint [::olSDL_ViewsCalcCoor::calc_ConnectionPointOnRecSym $CanInfo(connect_DestinationPaS) \
					$x $y \
					[lindex $CanInfo(connect_ChannelCoords) [expr [llength $CanInfo(connect_ChannelCoords)] -2]  ] \
					[lindex $CanInfo(connect_ChannelCoords) [expr [llength $CanInfo(connect_ChannelCoords)] -1]  ] \
					]

				set EndLinieCoords { }
				lappend EndLinieCoords [expr [llength $CanInfo(connect_ChannelCoords)] -2]
				lappend EndLinieCoords [expr [llength $CanInfo(connect_ChannelCoords)] -1]
				set EndLinieCoords [concat $EndLinieCoords $ConPoint]

				if { ! [::olSDL_ViewsDrawMethods::valid_Channel_Part $EndLinieCoords] } {
					return
				}

				lappend CanInfo(connect_ChannelCoords) [lindex $EndLinieCoords 2]
				lappend CanInfo(connect_ChannelCoords) [lindex $EndLinieCoords 3]

			}
			# if { $CanInfo(connect_afterFirstPart) }
			###########################
			##### END: C2
			###########################

			###########################
			##### C3
			###########################

			if { (!($CanInfo(connect_afterFirstPart))) && ($CanInfo(connect_Source_is_Env))} {

				if { ! [::olSDL_Views::_is_valid_Channel_Destination $ObjArr($currentObject,Type)] } {
					return
				}

				set CanInfo(connect_Destination_ID) $currentObject
				set CanInfo(connect_DestinationPaS) $ObjArr($currentObject,PaS)

				set PointOnBorderToEnv [::olSDL_ViewsCalcCoor::calc_ConnPointOnBorderToEnv \
					$CanInfo(PageFramePaS) $CanInfo(connect_Source_x) $CanInfo(connect_Source_y) ]

				set ConPoint [::olSDL_ViewsCalcCoor::calc_ConnectionPointOnRecSym $CanInfo(connect_DestinationPaS) \
					$x $y [lindex $PointOnBorderToEnv 0] [lindex $PointOnBorderToEnv 1] ]

				set StartLinieCoords [concat $PointOnBorderToEnv $ConPoint]

				if { ! [::olSDL_ViewsDrawMethods::valid_Channel_Part $StartLinieCoords] } {
					return
				}

				set CanInfo(connect_ChannelCoords) $StartLinieCoords

			}
			# if { (!($CanInfo(connect_afterFirstPart))) && ($CanInfo(connect_Source_is_Env))}
			###########################
			##### END: C3
			###########################

			###########################
			##### C4
			###########################

			if { (!($CanInfo(connect_afterFirstPart))) && (!($CanInfo(connect_Source_is_Env)))} {

				#puts "after source, source no enviroment, no first part"

				if { $currentObject == $CanInfo(connect_Source_ID) } {
					return
				}

				if { ! [::olSDL_Views::_is_valid_Channel_Destination $ObjArr($currentObject,Type)] } {
					return
				}

				set CanInfo(connect_Destination_ID) $currentObject
				set CanInfo(connect_DestinationPaS) $ObjArr($currentObject,PaS)

				set ConPointB [::olSDL_ViewsCalcCoor::calc_ConnectionPointOnRecSym $CanInfo(connect_DestinationPaS) \
					$x $y \
					$CanInfo(connect_Source_x) $CanInfo(connect_Source_y) ]

				set ConPointA [::olSDL_ViewsCalcCoor::calc_ConnectionPointOnRecSym $CanInfo(connect_SourcePaS) \
					$CanInfo(connect_Source_x) $CanInfo(connect_Source_y) \
					[lindex $ConPointB 0] [lindex $ConPointB 1] ]

				set StartLinieCoords [concat $ConPointA $ConPointB]

				if { ! [::olSDL_ViewsDrawMethods::valid_Channel_Part $StartLinieCoords] } {
					return
				}

				set CanInfo(connect_ChannelCoords) $StartLinieCoords

			}
			# if { (!($CanInfo(connect_afterFirstPart))) && (!($CanInfo(connect_Source_is_Env)))}

			###########################
			##### END: C4
			###########################

		###########################
		##### DRAW + UPDATE
		###########################

		set Diagram_ID $CanInfo(Dia_Model_ID)
		set PageID $CanInfo(PageID)

		set CanInfo(connect_DelayType) $::olSDL_Views::default_ChannelDelayType
		set CanInfo(connect_DirectionType) $::olSDL_Views::default_ChannelDirectionType

		set ChanNamePaS [concat [::olSDL_Views::Channel::calc_PositionOfChannelName $CanInfo(connect_ChannelCoords)] \
			$::olSDL_ViewsDrawMethods::default_Size_ChannelName]
		set ChanSourceSigPaS [concat [::olSDL_Views::Channel::calc_PositionOfChanSourceSig $CanInfo(connect_ChannelCoords)] \
			$::olSDL_ViewsDrawMethods::default_Size_ChannelSig]
		set ChanDestSigPaS [concat [::olSDL_Views::Channel::calc_PositionOfChanDestSig $CanInfo(connect_ChannelCoords)] \
			$::olSDL_ViewsDrawMethods::default_Size_ChannelSig]
		set ChanSourceConPaS [concat [::olSDL_Views::Channel::calc_PositionOfChanSourceCon $CanInfo(connect_ChannelCoords)] \
			$::olSDL_ViewsDrawMethods::default_Size_ChannelCon]
		set ChanDestConPaS [concat [::olSDL_Views::Channel::calc_PositionOfChanDestCon $CanInfo(connect_ChannelCoords)] \
			$::olSDL_ViewsDrawMethods::default_Size_ChannelCon]

		#############
		# draw Channel and components

		::olSDL_ViewsDrawMethods::draw_Channel $CanvasPathName $CanInfo(connect_ChannelCoords) \
			$CanInfo(connect_DelayType) $CanInfo(connect_DirectionType) false dummy NewCanChannel_ID

			#####

		set NewChannelNameID ""
		::olSDL_ViewsDrawMethods::draw_ChannelName $CanvasPathName $NewCanChannel_ID $ChanNamePaS \
			$::olSDL_ViewsDrawMethods::default_Text_ChanName false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChannelNameID

			#####

		set NewChanSourceSigID ""
		::olSDL_ViewsDrawMethods::draw_ChanSourceSig $CanvasPathName $NewCanChannel_ID $ChanSourceSigPaS \
			$::olSDL_ViewsDrawMethods::default_Text_ChanSourceSig  false dummy  \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanSourceSigID

		set NewChanDestSigID ""
		::olSDL_ViewsDrawMethods::draw_ChanDestSig $CanvasPathName $NewCanChannel_ID $ChanDestSigPaS \
			$::olSDL_ViewsDrawMethods::default_Text_ChanDestSig false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanDestSigID

			#####

		set NewChanSourceConID ""
		::olSDL_ViewsDrawMethods::draw_ChanSourceCon $CanvasPathName $NewCanChannel_ID $ChanSourceConPaS \
			$::olSDL_ViewsDrawMethods::default_Text_ChanSourceCon false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanSourceConID

		set NewChanDestConID ""
		::olSDL_ViewsDrawMethods::draw_ChanDestCon $CanvasPathName $NewCanChannel_ID $ChanDestConPaS \
			$::olSDL_ViewsDrawMethods::default_Text_ChanDestCon false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanDestConID


		# END: draw Channel and components
		#############

		#############
		# store channel in Tcl and Model

		::olSDL_Views::Channel::store_Chan_and_Comp_in_Tcl_and_Model $ObjArrName $CanInfoArr \
			$Diagram_ID $PageID $NewCanChannel_ID \
			$CanInfo(connect_DelayType) $CanInfo(connect_DirectionType) \
			$CanInfo(connect_Source_ID) $CanInfo(connect_Destination_ID) \
			$CanInfo(connect_ChannelCoords) \
			$NewChannelNameID $::olSDL_ViewsDrawMethods::default_Text_ChanName $ChanNamePaS \
			$NewChanSourceSigID $::olSDL_ViewsDrawMethods::default_Text_ChanSourceSig $ChanSourceSigPaS \
			$NewChanSourceConID $::olSDL_ViewsDrawMethods::default_Text_ChanSourceCon $ChanSourceConPaS \
			$NewChanDestSigID $::olSDL_ViewsDrawMethods::default_Text_ChanDestSig $ChanDestSigPaS \
			$NewChanDestConID $::olSDL_ViewsDrawMethods::default_Text_ChanDestCon $ChanDestConPaS

		# store channel in Tcl and Model
		#############


		# delete Helper Objects
		::olSDL_Views::Channel::delete_ConnectionHelperObjects $CanInfoArr

		# change canvas mode
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy

		##############################

		###########################
		##### END: DRAW + UPDATE
		###########################

#		::olSDL_Helper::printMessage "nach Einfgen von Kanal"
#		::olSDL_Helper::printArray $CanInfoArr
#		::olSDL_Helper::printArray $ObjArrName
#		::olSDL_Helper::printMessage "END: nach Einfgen von Kanal"

		return

		}
		# if { ($CanInfo(connect_afterSource)) }

	}
	# if { $CanvasState == "connection" }
	#
	######## case C ###########

	######## case D ###########
	#
	if { $CanvasState == "place_state_machine_sym" } {
		return
	}
	#
	######## case D ###########

	######## case E ###########
	#
	if { $CanvasState == "flowline" } {
		return
	}
	#
	######## case E ###########

	error "canvas state unknown"
}
##############################################################################
proc ::olSDL_Views::RecSym::DoubleClickOnRecSymbol {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasState $CanInfo(state)
	set CanvasPathName $CanInfo(CanvasPathName)

	set currentObject [$CanvasPathName find withtag current]
	set CanInfo(PU_RecSym_Object_ID) $currentObject

	# unpost CM
	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr

	# set selected
	::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $currentObject

	EditContent $ObjArrName $CanInfoArr
}
##############################################################################
proc ::olSDL_Views::RecSym::MidClickOnRecSymbol {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasState $CanInfo(state)
	set CanvasPathName $CanInfo(CanvasPathName)

	set currentObject [$CanvasPathName find withtag current]
	set CanInfo(PU_RecSym_Object_ID) $currentObject

	# unpost CM
	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr

	# set selected
	::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $currentObject

	if {[::olSDL_Views::is_ReferencingSymbol $ObjArr($currentObject,Type)]} {
		ZoomIn $ObjArrName $CanInfoArr
	}
}
##############################################################################
# END: methods for RecObj like text symbol, block instance reference symbol, .......
##############################################################################

##############################################################################
# methods for RESIZING RecObj like text symbol, block instance reference symbol, .......
##############################################################################
proc ::olSDL_Views::ResizeRecSym::RP_StartResize {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)
	set currentObject [$CanvasPathName find withtag current]

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	::olSDL_Views::RecObjRP::init_ResizeHelperObjects $ObjArrName $CanInfoArr

	set Resize_start_x [expr int([$CanvasPathName canvasx $x])]
	set Resize_start_y [expr int([$CanvasPathName canvasy $y])]

 	set CanInfo(Resize_ActionType) [::olSDL_Views::RecObjRP::determine_ResizeActionType $ObjArrName $CanInfoArr $currentObject]
	set CanInfo(Resize_PointParentID) [::olSDL_Views::RecObjRP::get_Parent_from_ResizePoint $ObjArrName $CanInfoArr $currentObject]

	set ResizeFrameCoords [::olSDL_Views::RecObjRP::calc_ResizeFrameCoords \
		$ObjArrName $CanInfoArr $Resize_start_x $Resize_start_y]

	set ResizeFrame [$CanvasPathName create rectangle $ResizeFrameCoords -dash {2 4} -width 2]

	set CanInfo(Resize_FrameID) $ResizeFrame
}
##############################################################################
proc ::olSDL_Views::ResizeRecSym::RP_ProcessResize {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	set Resize_current_x [expr int([$CanvasPathName canvasx $x])]
	set Resize_current_y [expr int([$CanvasPathName canvasy $y])]

	set ResizeFrameCoords [::olSDL_Views::RecObjRP::calc_ResizeFrameCoords \
		$ObjArrName $CanInfoArr $Resize_current_x $Resize_current_y]

	$CanvasPathName coords $CanInfo(Resize_FrameID) $ResizeFrameCoords
}
##############################################################################
proc ::olSDL_Views::ResizeRecSym::RP_EndResize {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	set Parent_ID $CanInfo(Resize_PointParentID)

	set ResizeFrameCoords { }
	set ResizeFrameCoords [$CanvasPathName coords $CanInfo(Resize_FrameID)]
	set ResizeFrameCoords [::olSDL_ViewsCalcCoor::convert_to_IntList $ResizeFrameCoords]


	####################
	# admissible new size ?
	if  {! [::olSDL_Views::admissibleRecObjSize $ResizeFrameCoords]}  {
		#puts "not admissible"
		::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
		return
	}
	# END: admissible new size ?
	####################

	####################
	# symbols covered ?

	if { [::olSDL_Views::Obj_covered $CanvasPathName $ResizeFrameCoords $Parent_ID selectableRec] }  {
		::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
		return
	}

	if { [::olSDL_Views::Obj_covered $CanvasPathName $ResizeFrameCoords $Parent_ID moveableStateMaSym] }  {
		::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
		return
	}

	# END: symbols covered ?
	####################

	####################
	# object still in PageFrame ?

	set PageFrameInnerZoneCoords [::olSDL_ViewsCalcCoor::calc_PageFrameInnerZoneCoords $CanInfo(PageFramePaS)]

	if {! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageFrameInnerZoneCoords $ResizeFrameCoords]} {
		#puts "out of Frame"
		::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
		return
	}

	# END: object still in PageFrame ?
	####################

	####################
	#	RESIZE
	####################

	set temp_old_PaS $ObjArr($CanInfo(Resize_PointParentID),PaS)
	set temp_new_PaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $ResizeFrameCoords]

	# tcl, model, canvas
	::olSDL_Views::RecSym::modify_RecSym_PaS_in_T_M_C "scale" $ObjArrName $CanInfoArr $CanInfo(Resize_PointParentID) $ResizeFrameCoords

	####################
	#  "move" Resize Points

	::olSDL_ViewsDrawMethods::delete_RecSym_RP_from_Canvas $ObjArrName $CanInfoArr $CanInfo(Resize_PointParentID)

	olSDL_ViewsDrawMethods::draw_RecSym_ResizePoints $ObjArrName $CanInfoArr $CanInfo(Resize_PointParentID)

	#  "move" Resize Points
	####################

	####################
	# "move" all connected channels

	::olSDL_Views::RecSym::move_connected_channels $ObjArrName $CanInfoArr \
		$CanInfo(Resize_PointParentID) $temp_old_PaS $temp_new_PaS

	# END : "move" all connected channels
	####################

	::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
}
##############################################################################

##############################################################################
##############################################################################
# END : methods for RESIZING RecObj like text symbol, block instance reference symbol, .......
##############################################################################
##############################################################################

##############################################################################
##############################################################################
# methods for MOVING RecObj like text symbol, block instance reference symbol, .......
##############################################################################
##############################################################################
proc ::olSDL_Views::MoveRecSym::StartMove {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasState $CanInfo(state)
	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	_init_MoveHelperObjects $ObjArrName $CanInfoArr

	set Move_start_x [expr int([$CanvasPathName canvasx $x])]
	set Move_start_y [expr int([$CanvasPathName canvasy $y])]

	set CanInfo(Move_start_x) $Move_start_x
	set CanInfo(Move_start_y) $Move_start_y
	set CanInfo(Move_MovedObjID) $currentObject
}
##############################################################################
proc ::olSDL_Views::MoveRecSym::ProcessMove {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	set CanInfo(Move_Obj_moved) true

	set move_dx [expr int([$CanvasPathName canvasx $x] - $CanInfo(Move_start_x))]
	set move_dy [expr int([$CanvasPathName canvasy $y] - $CanInfo(Move_start_y))]

	if {$CanInfo(Move_MoveFrameID) == ""} {
		#create MoveFrame, but in state hidden
		::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $ObjArr($CanInfo(Move_MovedObjID),PaS) \
			MoveFrame_x1 MoveFrame_y1 MoveFrame_x2 MoveFrame_y2

		set MoveFrame [$CanvasPathName create rectangle $MoveFrame_x1 $MoveFrame_y1 $MoveFrame_x2 $MoveFrame_y2 -dash {2 4} -width 2]
		set CanInfo(Move_MoveFrameID) $MoveFrame
	} else {
		$CanvasPathName move $CanInfo(Move_MoveFrameID) $move_dx $move_dy
	}

	set CanInfo(Move_start_x) [expr $CanInfo(Move_start_x) + $move_dx]
	set CanInfo(Move_start_y) [expr $CanInfo(Move_start_y) + $move_dy]
}
##############################################################################
proc ::olSDL_Views::MoveRecSym::EndMove {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { $CanvasState == "place_new_rec_obj" } {
		::olSDL_Views::PlaceRecSym::_delete_part_data_structure $CanInfoArr
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
		return
	}

	if { $CanvasState == "place_state_machine_sym" } {
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
		return
	}

	if { $CanvasState == "flowline" } {
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
		return
	}

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	if { ($CanInfo(Move_Obj_moved) == "") || ($CanInfo(Move_MoveFrameID) == "") } {
		_delete_MoveHelperObjects $CanInfoArr
		return
	}

	set MoveFrameCoords [$CanvasPathName coords $CanInfo(Move_MoveFrameID)]
	set MoveFrameCoords [::olSDL_ViewsCalcCoor::convert_to_IntList $MoveFrameCoords]

	####################
	# symbols covered ?

	if { [::olSDL_Views::Obj_covered $CanvasPathName $MoveFrameCoords $CanInfo(Move_MovedObjID) selectableRec] }  {
		_delete_MoveHelperObjects $CanInfoArr
		return
	}

	if { [::olSDL_Views::Obj_covered $CanvasPathName $MoveFrameCoords $CanInfo(Move_MovedObjID) moveableStateMaSym] }  {
		_delete_MoveHelperObjects $CanInfoArr
		return
	}

	# END: symbols covered ?
	####################

	####################
	# object still in PageFrame ?

	set PageFrameInnerZoneCoords [::olSDL_ViewsCalcCoor::calc_PageFrameInnerZoneCoords $CanInfo(PageFramePaS)]

	if {! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageFrameInnerZoneCoords $MoveFrameCoords]} {
		#puts "after move out of Frame"

		_delete_MoveHelperObjects $CanInfoArr
		return
	}

	# END: object still in PageFrame ?
	####################

	####################
	# MOVE
	####################

	set temp_old_PaS $ObjArr($CanInfo(Move_MovedObjID),PaS)
	set temp_new_PaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $MoveFrameCoords]

	# tcl, model, canvas
	::olSDL_Views::RecSym::modify_RecSym_PaS_in_T_M_C "move" $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID) $MoveFrameCoords


	####################
	# "move" ResizePoints

	::olSDL_ViewsDrawMethods::delete_RecSym_RP_from_Canvas $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID)

	olSDL_ViewsDrawMethods::draw_RecSym_ResizePoints $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID)

	# "move" ResizePoints
	####################

	####################
	# "move" all connected channels

	::olSDL_Views::RecSym::move_connected_channels $ObjArrName $CanInfoArr \
		$CanInfo(Move_MovedObjID) $temp_old_PaS $temp_new_PaS

	# END : "move" all connected channels
	####################


	#::olSDL_Helper::printMessage "after move obj"
	#::olSDL_Helper::printMessage "bewegtes Objekt"
	#::olSDL_Helper::printMessage $CanInfo(Move_MovedObjID)
	#::olSDL_Helper::printArray $CanInfoArr
	#::olSDL_Helper::printArray $ObjArrName

	_delete_MoveHelperObjects $CanInfoArr
}
##############################################################################
proc ::olSDL_Views::MoveRecSym::_init_MoveHelperObjects {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanInfo(Move_start_x) ""
	set CanInfo(Move_start_y) ""
	set CanInfo(Move_MovedObjID) ""
	set CanInfo(Move_Obj_moved) false
	set CanInfo(Move_MoveFrameID) ""
}
##############################################################################
proc ::olSDL_Views::MoveRecSym::_delete_MoveHelperObjects {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	# delete MoveFrame from Canvas
	$CanvasPathName delete $CanInfo(Move_MoveFrameID)

	set CanInfo(Move_start_x) ""
	set CanInfo(Move_start_y) ""
	set CanInfo(Move_MovedObjID) ""
	set CanInfo(Move_Obj_moved) ""
	set CanInfo(Move_MoveFrameID) ""
}
##############################################################################
# methods for MOVING RecObj like text symbol, block instance reference symbol, .......
##############################################################################

##############################################################################
# methods for PLACING RecObj like text symbol, block instance reference symbol, .......
##############################################################################
proc ::olSDL_Views::PlaceRecSym::_delete_part_data_structure {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanInfo(Place_TypeOfNewRecObject) ""

}
##############################################################################
proc ::olSDL_Views::PlaceRecSym::_init_PlaceHelperObjects {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanInfo(Place_NewRec_x) ""
	set CanInfo(Place_NewRec_y) ""
	set CanInfo(Place_NewRec_FrameID) ""
}
##############################################################################
proc ::olSDL_Views::PlaceRecSym::_delete_PlaceHelperObjects {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	# delete PlacementFrame from Canvas
	$CanvasPathName delete $CanInfo(Place_NewRec_FrameID)

	_delete_part_data_structure $CanInfoArr

	set CanInfo(Place_NewRec_x) ""
	set CanInfo(Place_NewRec_y) ""
	set CanInfo(Place_NewRec_FrameID) ""
}
##############################################################################
# END: methods for PLACING RecObj like text symbol, block instance reference symbol, .......
##############################################################################

##############################################################################
# T_M_C - methods
##############################################################################
proc ::olSDL_Views::RecSym::modify_RecSym_PaS_in_T_M_C {ActionType ObjArrName CanInfoArr RecSymCanID NewCoords} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ($ActionType != "scale")  && ($ActionType != "move") } {
		error "unknown action type"
		return
	}

	set NewPaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $NewCoords]
	set OldPaS $ObjArr($RecSymCanID,PaS)

	##############
	# canvas
	if { $ActionType == "move" } {
		set dx [expr [lindex $NewPaS 0] - [lindex $OldPaS 0]]
		set dy [expr [lindex $NewPaS 1] - [lindex $OldPaS 1]]
		$CanvasPathName	move PartOf$RecSymCanID $dx $dy
		$CanvasPathName	move $RecSymCanID $dx $dy
	} else {
		set dx [expr double([lindex $NewPaS 2]) / [lindex $OldPaS 2]]
		set dy [expr double([lindex $NewPaS 3]) / [lindex $OldPaS 3]]
		if {[lindex $NewPaS 0] == [lindex $OldPaS 0]} {
		  set origx [lindex $OldPaS 0]
		} else {
		  set origx [expr [lindex $OldPaS 0]+[lindex $OldPaS 2]]
		}
		if {[lindex $NewPaS 1] == [lindex $OldPaS 1]} {
		  set origy [lindex $OldPaS 1]
		} else {
		  set origy [expr [lindex $OldPaS 1]+[lindex $OldPaS 3]]
		}
		$CanvasPathName	scale PartOf$RecSymCanID $origx $origy $dx $dy
		$CanvasPathName	scale $RecSymCanID $origx $origy $dx $dy
	}
	# canvas
	##############

	##############
	# tcl

	set ObjArr($RecSymCanID,PaS) $NewPaS
	if { $ActionType == "scale" } {
		::olSDL_Views::RecSym::modify_RecSym_Content_in_T_M_C $ObjArrName $CanInfoArr $RecSymCanID $ObjArr($RecSymCanID,Text)
	}

	# tcl
	##############

	####################
	# model

	set PaS_x [lindex $NewPaS 0]
	set PaS_y [lindex $NewPaS 1]
	set PaS_width [lindex $NewPaS 2]
	set PaS_height [lindex $NewPaS 3]

	set_RecSymbolPaS_in_Model $ObjArr($RecSymCanID,Model_ID) $PaS_x $PaS_y $PaS_width $PaS_height

	# model
	####################
}
##############################################################################
proc ::olSDL_Views::RecSym::modify_RecSym_Content_in_T_M_C {ObjArrName CanInfoArr RecSymCanID NewContent} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	##############
	# tcl

	set ObjArr($RecSymCanID,Text) $NewContent

	# tcl
	##############

	##############
	# model

	modify_RecSym_Content_in_Model $ObjArr($RecSymCanID,Model_ID) $ObjArr($RecSymCanID,Text)

	# model
	##############

	##############
	# canvas

	set RecSym {TextSym BlkInstRefSym BlkTypeRefSym ProInstRefSym ProTypeRefSym ProcedureInstRefSym}

	set RecSymIndex [lsearch $RecSym $ObjArr($RecSymCanID,Type)]
	if { $RecSymIndex > -1} {
		::olSDL_ViewsDrawMethods::delete_RecSymComp_from_Canvas $ObjArrName $CanInfoArr $RecSymCanID

		::olSDL_ViewsDrawMethods::draw_[lindex $RecSym $RecSymIndex] \
		  $CanvasPathName $ObjArr($RecSymCanID,PaS) $ObjArr($RecSymCanID,Text) \
				true $RecSymCanID false CanObjID
	} else {
		error "unkown Symbol Type"
	}

	# canvas
	##############

}
##############################################################################
proc ::olSDL_Views::RecSym::delete_RecSym_from_T_M_C {ObjArrName CanInfoArr RecSymCanID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	##############
	# canvas

	::olSDL_ViewsDrawMethods::delete_RecSymComp_from_Canvas $ObjArrName $CanInfoArr $RecSymCanID

	$CanvasPathName delete $RecSymCanID

	# canvas
	##############

	##############
	# model

	delete_RecSym_from_Model $ObjArr($RecSymCanID,Model_ID)

	# model
	##############

	##############
	# tcl

	foreach element [lsort [array names ObjArr]] {
		if { [string first "$RecSymCanID," $element ] == 0} {
			unset ${ObjArrName}($element)
		}
	}

	# tcl
	##############

	set del_index [lsearch $CanInfo(allObj) $RecSymCanID]
	set CanInfo(allObj) [lreplace $CanInfo(allObj) $del_index $del_index]

	set del_index [lsearch $CanInfo(selObj) $RecSymCanID]
	set CanInfo(selObj) [lreplace $CanInfo(selObj) $del_index $del_index]
}
##############################################################################
# END: T_M_C - methods
##############################################################################
