package provide olSDL_Views 1

namespace eval olSDL_Views {
	namespace eval FlowLine {
	}
}

##############################################################################
proc ::olSDL_Views::FlowLine::init_FL_ConnectHelperObjects {CanInfoArr} {
	upvar #0 $CanInfoArr CanInfo

	set CanInfo(flowline_Source_x) ""
	set CanInfo(flowline_Source_y) ""
	set CanInfo(flowline_SourceID) ""
	set CanInfo(flowline_SourcePaS) ""
	set CanInfo(flowline_DestinationID) ""
	set CanInfo(flowline_DestinationPaS) ""
	if [catch {set CanInfo(flowline_PreviewLineID)}] {
	  set CanInfo(flowline_PreviewLineID) ""
	} elseif {$CanInfo(flowline_PreviewLineID) != "" } {
	  $CanInfo(CanvasPathName) delete $CanInfo(flowline_PreviewLineID) 
	  set CanInfo(flowline_PreviewLineID) ""
	}
}

##############################################################################
proc ::olSDL_Views::FlowLine::set_FL_ConnectHelperObjects {ObjArrName CanInfoArr SourceID x y} {
	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanInfo(flowline_Source_x) $x
	set CanInfo(flowline_Source_y) $y
	set CanInfo(flowline_SourceID) $SourceID
	set CanInfo(flowline_SourcePaS) $ObjArr($SourceID,PaS)
	set CanInfo(flowline_DestinationID) ""
	set CanInfo(flowline_DestinationPaS) ""
	set CanInfo(flowline_PreviewLineID) [$CanInfo(CanvasPathName) create line $x $y $x $y -width 1]
	$CanInfo(CanvasPathName) lower $CanInfo(flowline_PreviewLineID) stack_StateMaSym_Bottom
}

##############################################################################
proc ::olSDL_Views::FlowLine::calc_FL_Coords {SourcePas DestPas} {
	set Source_x_left_up [lindex $SourcePas 0]
	set Source_y_left_up [lindex $SourcePas 1]
	set SourceWidth [lindex $SourcePas 2]
	set SourceHeight [lindex $SourcePas 3]

	set Dest_x_left_up [lindex $DestPas 0]
	set Dest_y_left_up [lindex $DestPas 1]
	set DestWidth [lindex $DestPas 2]
	set DestHeight [lindex $DestPas 3]

	set Source_x [expr  $Source_x_left_up + ($SourceWidth / 2)]
	set Source_y [expr  $Source_y_left_up + $SourceHeight]

	set Dest_x [expr  $Dest_x_left_up + ($DestWidth / 2)]
	set Dest_y [expr  $Dest_y_left_up]

	set LengthSourceSeg 11
	set LengthDestSeg $LengthSourceSeg
	set MinDist_StateMaSym_FlowLine 7
	set MinHorizontalDist [expr (2* $MinDist_StateMaSym_FlowLine) +1]

	set VerticalDistStateMaSym [expr $Dest_y_left_up - ($Source_y_left_up + $SourceHeight)]

	if { [expr $VerticalDistStateMaSym >= ($LengthSourceSeg + $LengthDestSeg)] } {
		lappend FlowLineCoords $Source_x $Source_y \
				 $Source_x [expr $Source_y + $LengthDestSeg] \
				 $Source_x [expr $Dest_y_left_up - $LengthSourceSeg] \
				 $Dest_x [expr $Dest_y_left_up - $LengthSourceSeg] \
				 $Dest_x $Dest_y
		return [::olSDL_ViewsCalcCoor::convert_to_IntList $FlowLineCoords]
	} else {
		# Eingang hher als Ausgang
		# liegt der Eingang links oder rechts vom Ausgang ?

		if { $Source_x <= $Dest_x } {
			#hher und Eingang rechts vom Ausgang
			#ist Platz zwischen Quelle und Ziel ?

			if { ( $Dest_x_left_up - ($Source_x_left_up+ $SourceWidth) ) >= $MinHorizontalDist } {
				#zwischen den Objekten zeichnen

				lappend FlowLineCoords $Source_x $Source_y \
					$Source_x [expr $Source_y + $LengthDestSeg] \
					[expr $Dest_x_left_up - $MinDist_StateMaSym_FlowLine] [expr $Source_y + $LengthDestSeg] \
					[expr $Dest_x_left_up - $MinDist_StateMaSym_FlowLine] [expr $Dest_y_left_up - $LengthSourceSeg] \
					$Dest_x [expr $Dest_y_left_up - $LengthSourceSeg] \
					$Dest_x $Dest_y
				return [::olSDL_ViewsCalcCoor::convert_to_IntList $FlowLineCoords]
			} else {
				#rechts um das Zielobjekt herum
				#rechts von rechtester Kante

				if { ($Source_x_left_up+ $SourceWidth) >= ($Dest_x_left_up+ $DestWidth)} {
					set EastEdge [expr $Source_x_left_up+ $SourceWidth]
				} else {
					set EastEdge [expr $Dest_x_left_up+ $DestWidth]
				}

				lappend FlowLineCoords $Source_x $Source_y \
					$Source_x [expr $Source_y + $LengthDestSeg] \

				if { ($Source_y + $LengthDestSeg) >= ($Dest_y_left_up + $DestHeight + $MinDist_StateMaSym_FlowLine) } {
					set BottomEdge [expr $Source_y + $LengthDestSeg]
				} else {
					set BottomEdge [expr $Dest_y_left_up + $DestHeight + $MinDist_StateMaSym_FlowLine]
					lappend FlowLineCoords $Source_x $BottomEdge
				}

				lappend FlowLineCoords [expr $EastEdge + $MinDist_StateMaSym_FlowLine] $BottomEdge \
						    [expr $EastEdge + $MinDist_StateMaSym_FlowLine] [expr $Dest_y - $LengthSourceSeg] \
						    $Dest_x [expr $Dest_y - $LengthSourceSeg] \
						    $Dest_x $Dest_y

				return [::olSDL_ViewsCalcCoor::convert_to_IntList $FlowLineCoords]
			}
		} else {
			#hher und Eingang links vom Ausgang

			if {  $Source_x_left_up >= ( $Dest_x_left_up + $DestWidth + $MinHorizontalDist) } {

				#zwischen den Objekten zeichnen
				lappend FlowLineCoords $Source_x $Source_y \
						    $Source_x [expr $LengthDestSeg + $Source_y] \
						    [expr $Dest_x_left_up + $DestWidth + $MinDist_StateMaSym_FlowLine] [expr $LengthDestSeg + $Source_y] \
						    [expr $Dest_x_left_up + $DestWidth + $MinDist_StateMaSym_FlowLine] [expr $Dest_y - $LengthSourceSeg] \
						    $Dest_x [expr $Dest_y - $LengthSourceSeg] \
						    $Dest_x $Dest_y
				return [::olSDL_ViewsCalcCoor::convert_to_IntList $FlowLineCoords]
			} else {
				#links um das Zielobjekt herum
				#links von linkesten Kante

				if { $Dest_x_left_up <= $Source_x_left_up } {
					set WestEdge $Dest_x_left_up
				} else {
					set WestEdge $Source_x_left_up
				}

				lappend FlowLineCoords $Source_x $Source_y \
					$Source_x [expr $Source_y + $LengthDestSeg]

				if { ($Source_y + $LengthDestSeg) >= ($Dest_y_left_up + $DestHeight + $MinDist_StateMaSym_FlowLine) } {
					set BottomEdge [expr $Source_y + $LengthDestSeg]
				} else {
					set BottomEdge [expr $Dest_y_left_up + $DestHeight + $MinDist_StateMaSym_FlowLine]
					lappend FlowLineCoords $Source_x $BottomEdge
				}

				lappend FlowLineCoords [expr $WestEdge - $MinDist_StateMaSym_FlowLine] $BottomEdge \
						    [expr $WestEdge - $MinDist_StateMaSym_FlowLine] [expr $Dest_y - $LengthSourceSeg] \
						    $Dest_x [expr $Dest_y - $LengthSourceSeg] \
						    $Dest_x $Dest_y
				return [::olSDL_ViewsCalcCoor::convert_to_IntList $FlowLineCoords]
			}
			#zwischen den Objekten zeichnen
		}
		#hher und Eingang links vom Ausgang
	}
	# Eingang hher als Ausgang
}
##############################################################################
proc ::olSDL_Views::FlowLine::ClickOnDecFlowLine {ObjArrName CanInfoArr} {
	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set DecFlowLineID [$CanvasPathName find withtag current]
	set CanvasState $CanInfo(state)

	if { ($CanvasState != "single_obj_selected") && ($CanvasState != "normal")  } {
		# do nothing
		return
	}

	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr
	::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $DecFlowLineID
}
##############################################################################
proc ::olSDL_Views::FlowLine::ClickOnFlowLine {ObjArrName CanInfoArr} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set FlowLineID [$CanvasPathName find withtag current]
	set CanvasState $CanInfo(state)

	if { ($CanvasState != "single_obj_selected") && ($CanvasState != "normal")  } {
		# do nothing
		return
	}

	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr
	::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $FlowLineID
}
##############################################################################
proc ::olSDL_Views::FlowLine::store_NormalFlowLine_in_Tcl {ObjArrName CanInfoArr FlowLineID SourceID DestinationID Model_ID Coords} {
	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set ObjArr($FlowLineID,Type) FlowLine
	set ObjArr($FlowLineID,SourceID) $SourceID
	set ObjArr($FlowLineID,DestinationID) $DestinationID
	set ObjArr($FlowLineID,Model_ID) $Model_ID
	set ObjArr($FlowLineID,Coords) $Coords

	lappend CanInfo(allObj) $FlowLineID
}
##############################################################################
proc ::olSDL_Views::FlowLine::store_NormalFlowLine_in_Tcl_and_Model {ObjArrName CanInfoArr \
		Diagram_Model_ID PageID FlowLineCanID SourceCanID DestCanID FlowLineCoords } {
	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo
	upvar #0 ::olSDL_MAR::arr_MAR MAR

	##############################
	# store flow line in Tcl

	store_NormalFlowLine_in_Tcl $ObjArrName $CanInfoArr $FlowLineCanID $SourceCanID $DestCanID XXXModel_IDXXX $FlowLineCoords

	# store flow line in Tcl
	##############################

	##############################
	# store flow line in Model

	set temp_SourceModel_ID $ObjArr($ObjArr($FlowLineCanID,SourceID),Model_ID)
	set temp_DestModel_ID $ObjArr($ObjArr($FlowLineCanID,DestinationID),Model_ID)

	insert_FlowLine_into_Model $Diagram_Model_ID $PageID $temp_SourceModel_ID $temp_DestModel_ID $FlowLineCoords

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set NewObj_Model_ID $MAR(NewObj_Model_ID)

	# END: store flow line in Model
	##############################

	set ObjArr($FlowLineCanID,Model_ID) $NewObj_Model_ID
}
##############################################################################
proc ::olSDL_Views::FlowLine::is_connected {ObjArrName FlowLineID ObjID} {
	upvar #0 $ObjArrName ObjArr

	if { ($ObjArr($FlowLineID,Type) != "FlowLine") && ($ObjArr($FlowLineID,Type) != "DecisionFlowLine") } {
		error "object is not a FlowLine"
		return false
	}

	if { $ObjArr($FlowLineID,SourceID) == $ObjID } {
		return true
	}

	if { $ObjArr($FlowLineID,DestinationID) == $ObjID } {
		return true
	}

	return false
}
##############################################################################
proc ::olSDL_Views::FlowLine::get_all_FlowLines {CanInfoArr} {
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set FlowLines [get_NormalFlowLines $CanInfoArr]

	set FlowLines [concat $FlowLines [get_DecisionFlowLines $CanInfoArr] ]

	return $FlowLines
}
##############################################################################
proc ::olSDL_Views::FlowLine::validNumberOfOutgoingFlowLines {ObjArrName CanInfoArr StateMaSymID} {
	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	switch -exact $ObjArr($StateMaSymID,Type) {
		StateMaStateSym -
		StateMaDecisionSym -
		StateMaInputSym {
			return true
		}
		default {
			set AllFlowLines [get_all_FlowLines $CanInfoArr]

			foreach FlowLine $AllFlowLines {
				if { $ObjArr($FlowLine,SourceID) == $StateMaSymID } {
					return false
				}
			}
			return true
		}
	}
}
##############################################################################
proc ::olSDL_Views::FlowLine::FlowLine_exists {ObjArrName CanInfoArr SourceID DestID} {
	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set AllFlowLines [get_all_FlowLines $CanInfoArr]

	foreach FlowLine $AllFlowLines {
		if { ($ObjArr($FlowLine,SourceID) == $SourceID) && ($ObjArr($FlowLine,DestinationID) == $DestID) } {
			return true
		}
	}
	return false
}

##############################################################################
####### Normal Flow Line
##############################################################################
proc ::olSDL_Views::FlowLine::delete_NormalFlowLine_from_T_M_C {ObjArrName CanInfoArr FlowLineID} {
	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	::olSDL_ViewsDrawMethods::delete_NormalFlowLine_from_Canvas $ObjArrName $CanInfoArr $FlowLineID

	delete_NormalFlowLine_from_Tcl_and_Model $ObjArrName $CanInfoArr $FlowLineID
}
##############################################################################
proc ::olSDL_Views::FlowLine::delete_NormalFlowLine_from_Tcl_and_Model {ObjArrName CanInfoArr FlowLineID} {
	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set FlowLine_Model_ID $ObjArr($FlowLineID,Model_ID)

	#############
	# delete from tcl

	foreach element [lsort [array names ObjArr]] {
		if { [string first "$FlowLineID," $element ] == 0} {
			unset ${ObjArrName}($element)
		}
	}

	set del_index [lsearch $CanInfo(allObj) $FlowLineID]
	set CanInfo(allObj) [lreplace $CanInfo(allObj) $del_index $del_index]

	set del_index [lsearch $CanInfo(selObj) $FlowLineID]
	set CanInfo(selObj) [lreplace $CanInfo(selObj) $del_index $del_index]

	# delete from tcl
	#############

	#############
	# delete from Model

	delete_FlowLine_from_Model $FlowLine_Model_ID

	# delete from Model
	#############
}
##############################################################################
proc ::olSDL_Views::FlowLine::modify_NormalFlowLineCoords_in_Tcl_and_Model {ObjArrName CanInfoArr FlowLineCanID NewFlowLineCoords} {
	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set ObjArr($FlowLineCanID,Coords) $NewFlowLineCoords

	modify_FlowLineCoords_in_Model $ObjArr($FlowLineCanID,Model_ID) $ObjArr($FlowLineCanID,Coords)
}
##############################################################################
proc ::olSDL_Views::FlowLine::get_NormalFlowLines {CanInfoArr} {
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set FlowLines [$CanvasPathName find withtag FlowLine]

	return $FlowLines
}
##############################################################################
proc ::olSDL_Views::FlowLine::FlowLineInPageFrame {ObjArrName CanInfoArr FlowLineID ModifiedStateMaSymID ResizeFrameCoords} {
	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set ResizeFramePaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $ResizeFrameCoords]

	set PageFrameCoords [::olSDL_ViewsCalcCoor::get_RecCoordsAsList_fromPaS $CanInfo(PageFramePaS)]

	set SourceCanID $ObjArr($FlowLineID,SourceID)
	set DestCanID $ObjArr($FlowLineID,DestinationID)

	if {$ModifiedStateMaSymID == $SourceCanID} {
		set NewFlowLineCoords [::olSDL_Views::FlowLine::calc_FL_Coords \
			$ResizeFramePaS $ObjArr($DestCanID,PaS)]
	} elseif {$ModifiedStateMaSymID == $DestCanID} {
		set NewFlowLineCoords [::olSDL_Views::FlowLine::calc_FL_Coords \
			$ObjArr($SourceCanID,PaS) $ResizeFramePaS]
	} else {
		error "prog"
	}

	if { ! [::olSDL_ViewsCalcCoor::LineInRectangle $NewFlowLineCoords $PageFrameCoords] } {
		return false
	}

	return true
}
##############################################################################
proc ::olSDL_Views::FlowLine::FlowLineEndsInNextstate {ObjArrName CanInfoArr SuccessorStateMaSymID}  {
	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	if { ($ObjArr($SuccessorStateMaSymID,Type) == "StateMaStateSym") } {
		return true
	} else {
		return false
	}
}
##############################################################################
####### END: Normal Flow Line
##############################################################################

##############################################################################
####### Decision Flow Line
##############################################################################
proc ::olSDL_Views::FlowLine::delete_DecisionFlowLine_from_T_M_C {ObjArrName CanInfoArr DecFlowLineID}  {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set FlowLineCompID [::olSDL_Views::FlowLine::_get_ID_from_DecFlowLineComp $ObjArrName $CanInfoArr $DecFlowLineID]

	# delete dec flow line from canvas
	::olSDL_ViewsDrawMethods::delete_DecisionFlowLine_and_Comp_from_Canvas $ObjArrName $CanInfoArr $DecFlowLineID

	# delete dec flow line from Tcl and Model
	::olSDL_Views::FlowLine::delete_DecisionFlowLine_from_Tcl_and_Model $ObjArrName $CanInfoArr $DecFlowLineID $FlowLineCompID
}
##############################################################################
proc ::olSDL_Views::FlowLine::delete_DecisionFlowLine_from_Tcl_and_Model {ObjArrName CanInfoArr FlowLineID CompID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set FlowLine_Model_ID $ObjArr($FlowLineID,Model_ID)

	#############
	# delete dec flow line from tcl

	foreach element [lsort [array names ObjArr]] {
		if { [string first "$FlowLineID," $element ] == 0} {
			unset ${ObjArrName}($element)
		}
	}

	set del_index [lsearch $CanInfo(allObj) $FlowLineID]
	set CanInfo(allObj) [lreplace $CanInfo(allObj) $del_index $del_index]

	set del_index [lsearch $CanInfo(selObj) $FlowLineID]
	set CanInfo(selObj) [lreplace $CanInfo(selObj) $del_index $del_index]

	# delete dec flow line from tcl
	#############

	#############
	# delete dec flow line comp from tcl

	foreach element [lsort [array names ObjArr]] {
		if { [string first "$CompID," $element ] == 0} {
			unset ${ObjArrName}($element)
		}
	}

	set del_index [lsearch $CanInfo(allObj) $CompID]
	set CanInfo(allObj) [lreplace $CanInfo(allObj) $del_index $del_index]

	# delete dec flow line comp from tcl
	#############

	#############
	# delete from Model

	delete_FlowLine_from_Model $FlowLine_Model_ID

	# delete from Model
	#############
}
##############################################################################
proc ::olSDL_Views::FlowLine::modify_DecisionFlowLineCoords_in_Tcl_and_Model {ObjArrName CanInfoArr FlowLineCanID NewFlowLineCoords} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set ObjArr($FlowLineCanID,Coords) $NewFlowLineCoords

	modify_FlowLineCoords_in_Model $ObjArr($FlowLineCanID,Model_ID) $ObjArr($FlowLineCanID,Coords)
}
##############################################################################
proc ::olSDL_Views::FlowLine::calc_PositionOfDecisionFlowLineComp {Coords} {

	if { [llength $Coords] < 6 } {
		error "no flow line coords"
		return
	}

	set Index 2

	return [::olSDL_ViewsCalcCoor::calc_CenterOfLineSegment [lrange $Coords $Index [expr $Index + 3]] ]
}
##############################################################################
proc ::olSDL_Views::FlowLine::store_DecisionFlowLine_in_Tcl {ObjArrName CanInfoArr DecisionFlowLineID SourceID DestinationID Model_ID Coords} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set ObjArr($DecisionFlowLineID,Type) DecisionFlowLine

	set ObjArr($DecisionFlowLineID,SourceID) $SourceID
	set ObjArr($DecisionFlowLineID,DestinationID) $DestinationID
	set ObjArr($DecisionFlowLineID,Model_ID) $Model_ID
	set ObjArr($DecisionFlowLineID,Coords) $Coords

	lappend CanInfo(allObj) $DecisionFlowLineID
}
##############################################################################
proc ::olSDL_Views::FlowLine::store_DecisionFlowLineComp_in_Tcl {ObjArrName CanInfoArr DecisionFlowLineCompID \
											 Text Model_ID HL_Style PaS }  {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set ObjArr($DecisionFlowLineCompID,Type) DecisionFlowLineComp

	set ObjArr($DecisionFlowLineCompID,Text) $Text

	set ObjArr($DecisionFlowLineCompID,Model_ID) $Model_ID
	set ObjArr($DecisionFlowLineCompID,PaS) $PaS

	set ObjArr($DecisionFlowLineCompID,HL_Style) $HL_Style

	lappend CanInfo(allObj) $DecisionFlowLineCompID
}
##############################################################################
proc ::olSDL_Views::FlowLine::store_DecisionFlowLine_and_Comp_in_Tcl_and_Model {ObjArrName CanInfoArr \
		Diagram_Model_ID PageID DecisionFlowLineCanID SourceCanID DestCanID FlowLineCoords \
		DecisionFlowLineCompID DecisionFlowLineCompContent DecisionFlowLineCompPaS} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	upvar #0 ::olSDL_MAR::arr_MAR MAR

	##############################
	# store decision flow line in Tcl

	store_DecisionFlowLine_in_Tcl $ObjArrName $CanInfoArr $DecisionFlowLineCanID $SourceCanID $DestCanID XXXModel_IDXXX $FlowLineCoords

	# END: store decision flow line in Tcl
	##############################

	##############################
	# store decision flow line comp in Tcl

	store_DecisionFlowLineComp_in_Tcl $ObjArrName $CanInfoArr $DecisionFlowLineCompID \
		$DecisionFlowLineCompContent XXXModel_IDXXX $::olSDL_ViewsDrawMethods::DecFlowLineComp_HL_Style::normal \
		$DecisionFlowLineCompPaS

	# store decision flow line comp in Tcl
	##############################

	##############################
	# store decision flow line and comp in Model

	set temp_SourceModel_ID $ObjArr($ObjArr($DecisionFlowLineCanID,SourceID),Model_ID)

	set temp_DestModel_ID $ObjArr($ObjArr($DecisionFlowLineCanID,DestinationID),Model_ID)


	insert_DecisionFlowLine_into_Model $Diagram_Model_ID $PageID $temp_SourceModel_ID $temp_DestModel_ID $FlowLineCoords \
		$DecisionFlowLineCompContent $DecisionFlowLineCompPaS

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set NewObj_Model_ID $MAR(NewObj_Model_ID)

	# END: store decision flow line and comp in Model
	##############################

	set ObjArr($DecisionFlowLineCanID,Model_ID) $NewObj_Model_ID
	set ObjArr($DecisionFlowLineCompID,Model_ID) $NewObj_Model_ID
}
##############################################################################
proc ::olSDL_Views::FlowLine::get_DecisionFlowLines {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set FlowLines [$CanvasPathName find withtag DecisionFlowLine]

	return $FlowLines
}
##############################################################################
proc ::olSDL_Views::FlowLine::_get_ID_from_DecFlowLineComp {ObjArrName CanInfoArr DecFlowLineID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set AllComps { }
	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_DecisionFlowLine $ObjArr($DecFlowLineID,Type)] } {
		error "object no decision flow line"
		return
	}

	return [$CanvasPathName find withtag FlowLineComp$DecFlowLineID]
}
##############################################################################
####### END: Decision Flow Line
##############################################################################

##############################################################################
####### Decision Flow Line Comp
##############################################################################
proc ::olSDL_Views::FlowLine::ClickOnDecFlowLineComp {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasState $CanInfo(state)
	set CanvasPathName $CanInfo(CanvasPathName)

	set x [expr int([$CanvasPathName canvasx $x])]
	set y [expr int([$CanvasPathName canvasy $y])]

	set currentObject [$CanvasPathName find withtag current]

	######## case A ###########

	if { ($CanvasState == "single_obj_selected") || ($CanvasState == "normal") } {

		::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr
		::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $currentObject

		return
	}
	# if
}
##############################################################################
proc ::olSDL_Views::FlowLine::RP_StartResize {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)
	set currentObject [$CanvasPathName find withtag current]

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	::olSDL_Views::RecObjRP::init_ResizeHelperObjects $ObjArrName $CanInfoArr

	set Resize_start_x [expr int([$CanvasPathName canvasx $x])]
	set Resize_start_y [expr int([$CanvasPathName canvasy $y])]

 	set CanInfo(Resize_ActionType) [::olSDL_Views::RecObjRP::determine_ResizeActionType $ObjArrName $CanInfoArr $currentObject]
	set CanInfo(Resize_PointParentID) [::olSDL_Views::RecObjRP::get_Parent_from_ResizePoint $ObjArrName $CanInfoArr $currentObject]

	set ResizeFrameCoords [::olSDL_Views::RecObjRP::calc_ResizeFrameCoords \
		$ObjArrName $CanInfoArr $Resize_start_x $Resize_start_y]

	set ResizeFrame [$CanvasPathName create rectangle $ResizeFrameCoords -dash {2 4} -width 2]

	set CanInfo(Resize_FrameID) $ResizeFrame
}
##############################################################################
proc ::olSDL_Views::FlowLine::RP_ProcessResize {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	set Resize_current_x [expr int([$CanvasPathName canvasx $x])]
	set Resize_current_y [expr int([$CanvasPathName canvasy $y])]

	set ResizeFrameCoords [::olSDL_Views::RecObjRP::calc_ResizeFrameCoords \
		$ObjArrName $CanInfoArr $Resize_current_x $Resize_current_y]

	$CanvasPathName coords $CanInfo(Resize_FrameID) $ResizeFrameCoords
}
##############################################################################
proc ::olSDL_Views::FlowLine::RP_EndResize {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	set Parent_ID $CanInfo(Resize_PointParentID)

	set ResizeFrameCoords { }
	set ResizeFrameCoords [$CanvasPathName coords $CanInfo(Resize_FrameID)]
	set ResizeFrameCoords [::olSDL_ViewsCalcCoor::convert_to_IntList $ResizeFrameCoords]

	####################
	# admissible new size ?
	if  {! [::olSDL_Views::admissibleRecObjSize $ResizeFrameCoords]}  {
		#puts "not admissible"
		::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
		return
	}
	# END: admissible new size ?
	####################

	####################
	# object still in Page ?

	set tempPageCoords [list 0 0 $CanInfo(PageWidth) $CanInfo(PageHeight)]
	if {! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $tempPageCoords $ResizeFrameCoords]} {
		::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
		return
	}

	# END: object still in Page ?
	####################

	####################
	#	RESIZE
	####################

	set temp_old_PaS $ObjArr($CanInfo(Resize_PointParentID),PaS)
	set temp_new_PaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $ResizeFrameCoords]

	####################
	#  "move" symbol

	modify_DecisionFlowLineComp_PaS_in_T_M_C "scale" $ObjArrName $CanInfoArr $CanInfo(Resize_PointParentID) $ResizeFrameCoords

	# "move" symbol
	####################

	####################
	#  "move" Resize Points

	 ::olSDL_ViewsDrawMethods::delete_DecisionFlowLineComp_ResizePoints $ObjArrName $CanInfoArr $CanInfo(Resize_PointParentID)

	::olSDL_ViewsDrawMethods::draw_DecisionFlowLineComp_ResizePoints $ObjArrName $CanInfoArr $CanInfo(Resize_PointParentID)

	#  "move" Resize Points
	####################

	 ::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
}
##############################################################################
proc ::olSDL_Views::FlowLine::StartDecFlowLineCompMove {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasState $CanInfo(state)
	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	::olSDL_Views::MoveRecSym::_init_MoveHelperObjects $ObjArrName $CanInfoArr

	set Move_start_x [expr int([$CanvasPathName canvasx $x])]
	set Move_start_y [expr int([$CanvasPathName canvasy $y])]

	set CanInfo(Move_start_x) $Move_start_x
	set CanInfo(Move_start_y) $Move_start_y
	set CanInfo(Move_MovedObjID) $currentObject

	#create MoveFrame, but in state hidden
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $ObjArr($CanInfo(Move_MovedObjID),PaS) \
		MoveFrame_x1 MoveFrame_y1 MoveFrame_x2 MoveFrame_y2

	set MoveFrame [$CanvasPathName create rectangle $MoveFrame_x1 $MoveFrame_y1 $MoveFrame_x2 $MoveFrame_y2 -state hidden -dash {2 4} -width 2]
	set CanInfo(Move_MoveFrameID) $MoveFrame
}
##############################################################################
proc ::olSDL_Views::FlowLine::ProcessDecFlowLineCompMove {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	set CanInfo(Move_Obj_moved) true

	set move_dx [expr int([$CanvasPathName canvasx $x] - $CanInfo(Move_start_x))]
	set move_dy [expr int([$CanvasPathName canvasy $y] - $CanInfo(Move_start_y))]

	$CanvasPathName itemconfigure $CanInfo(Move_MoveFrameID) -state normal
	$CanvasPathName move $CanInfo(Move_MoveFrameID) $move_dx $move_dy

	set CanInfo(Move_start_x) [expr $CanInfo(Move_start_x) + $move_dx]
	set CanInfo(Move_start_y) [expr $CanInfo(Move_start_y) + $move_dy]
}
##############################################################################
proc ::olSDL_Views::FlowLine::EndDecFlowLineCompMove {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	#TODO

	if { $CanvasState == "flowline" } {
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
		return
	}

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	if { ! $CanInfo(Move_Obj_moved) } {
		::olSDL_Views::MoveRecSym::_delete_MoveHelperObjects $CanInfoArr
		return
	}

	set MoveFrameCoords [$CanvasPathName coords $CanInfo(Move_MoveFrameID)]
	set MoveFrameCoords [::olSDL_ViewsCalcCoor::convert_to_IntList $MoveFrameCoords]

	####################
	# object still on Page?

	set tempPageCoords [list 0 0 $CanInfo(PageWidth) $CanInfo(PageHeight)]
	if {! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $tempPageCoords $MoveFrameCoords]} {
		::olSDL_Views::MoveRecSym::_delete_MoveHelperObjects $CanInfoArr
		return
	}

	# END: object still on Page?
	####################

	####################
	# MOVE
	####################

	set temp_old_PaS $ObjArr($CanInfo(Move_MovedObjID),PaS)
	set temp_new_PaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $MoveFrameCoords]

	####################
	# "move" symbol

	modify_DecisionFlowLineComp_PaS_in_T_M_C "move" $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID) $MoveFrameCoords

	# "move" symbol
	####################

	####################
	# "move" ResizePoints

	::olSDL_ViewsDrawMethods::delete_DecisionFlowLineComp_ResizePoints $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID)

	 ::olSDL_ViewsDrawMethods::draw_DecisionFlowLineComp_ResizePoints $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID)

	# "move" ResizePoints
	####################

	::olSDL_Views::MoveRecSym::_delete_MoveHelperObjects $CanInfoArr
}
##############################################################################
proc ::olSDL_Views::FlowLine::get_AllFlowLines {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set FlowLines [$CanvasPathName find withtag FlowLine]
	return $FlowLines
}
##############################################################################
proc ::olSDL_Views::FlowLine::get_AllDecFlowLines {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set DecFlowLines [$CanvasPathName find withtag DecisionFlowLine]
	return $DecFlowLines
}
##############################################################################
proc ::olSDL_Views::FlowLine::get_AllCompsOfAllDecFlowLines {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)
	set Comps [$CanvasPathName find withtag selectableDecFlowLineComp]
	return $Comps

}
##############################################################################
proc ::olSDL_Views::FlowLine::get_DecisionFlowLineID_from_DecisionFlowLineComp {ObjArrName CanInfoArr DecisionFlowLineCompID out_DecisionFlowLineID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	upvar $out_DecisionFlowLineID DecisionFlowLineID


	set CanvasPathName $CanInfo(CanvasPathName)

	set AllTags [$CanvasPathName gettags $DecisionFlowLineCompID]


	set DecisionFlowLineID_Index [lsearch -glob $AllTags FlowLineComp*]
	if { $DecisionFlowLineID_Index != -1} {
		set str_DecisionFlowLineID [lindex $AllTags $DecisionFlowLineID_Index]
		set DecisionFlowLineID [string range $str_DecisionFlowLineID 12 end]
		return
	}
}
##############################################################################
proc ::olSDL_Views::FlowLine::show_DecFlowLineCompPopUpMenu {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	# unpost CM
	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr

	# set selected
	::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $currentObject

	set x_in_can [expr int (round ($x))]
	set y_in_can [expr int (round ($y))]

	set PopUp_x [expr $x_in_can + [winfo rootx $CanvasPathName]]
	set PopUp_y [expr $y_in_can + [winfo rooty $CanvasPathName]]

	set CanInfo(PU_DecFlowLineComp_Object_ID) $currentObject

	$CanInfo(menu_DecFlowLineComp) post $PopUp_x $PopUp_y
}
##############################################################################
proc ::olSDL_Views::FlowLine::EditDecFlowLineCompContent {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set DecFlowLineCompID $CanInfo(PU_DecFlowLineComp_Object_ID)

	get_DecisionFlowLineID_from_DecisionFlowLineComp $ObjArrName $CanInfoArr $DecFlowLineCompID DecisionFlowLineID

	set DlgTitle "Decision Flow Line"

	set dlg [Dialog .dec_flow_line_comp_edit -parent . -modal local -title Edit -geometry 300x300+200+100]

	set dTitleFrame [TitleFrame [$dlg getframe].tf]

	$dTitleFrame configure -text $DlgTitle

	set sw [ScrolledWindow [$dTitleFrame getframe].sw -relief sunken -borderwidth 2]
	set dtext [text [$sw getframe].tx ]
	$sw setwidget $dtext

	$dtext delete 1.0 end
	$dtext insert 1.0 $ObjArr($DecFlowLineCompID,Text)

	pack $sw -fill both -expand true
	pack $dTitleFrame -fill both -expand true

	$dlg add -name ok
	$dlg add -name clear -text clear -command "$dtext delete 1.0 end"
	$dlg add -name cancel

	set DiaResult [$dlg draw]

	if { $DiaResult == 0 } {

		set NewText [string trimright [$dtext get 1.0 end]]

		::olSDL_Views::FlowLine::modify_DecisionFlowLineContent_in_T_M_C $ObjArrName $CanInfoArr $DecFlowLineCompID $NewText
	}
	# if { $DiaResult == 0 }

	destroy $dlg
}
##############################################################################
proc ::olSDL_Views::FlowLine::OnChangeDecFlowLineCompHighLight {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set temp_DecisionFlowLineID $CanInfo(PU_DecFlowLineID)
	set temp_DecFlowLineCompID $CanInfo(PU_DecFlowLineCompID)

	if { $CanInfo(PU_hl_DecFlowLineComp) } {
		set ObjArr($temp_DecFlowLineCompID,HL_Style) $::olSDL_ViewsDrawMethods::DecFlowLineComp_HL_Style::flowline_membership
	} else {
		set ObjArr($temp_DecFlowLineCompID,HL_Style) $::olSDL_ViewsDrawMethods::DecFlowLineComp_HL_Style::normal
	}

	::olSDL_ViewsDrawMethods::delete_DecisionFlowLineComp_Comp_from_Canvas $ObjArrName $CanInfoArr $temp_DecFlowLineCompID

	::olSDL_ViewsDrawMethods::draw_DecisionFlowLineComp $CanvasPathName \
		$temp_DecisionFlowLineID $ObjArr($temp_DecFlowLineCompID,PaS) $ObjArr($temp_DecFlowLineCompID,Text) \
		true $temp_DecFlowLineCompID $ObjArr($temp_DecFlowLineCompID,HL_Style) dummy
}
##############################################################################
proc ::olSDL_Views::FlowLine::show_DecFlowLinePopUpMenu {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	set DecisionFlowLineID $currentObject

	# unpost CM
	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr

	# set selected
	::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $currentObject


	set x_in_can [expr int (round ($x))]
	set y_in_can [expr int (round ($y))]

	set CanInfo(PU_Chan_Current_X) $x_in_can
	set CanInfo(PU_Chan_Current_Y) $y_in_can

	set PopUp_x [expr $x_in_can + [winfo rootx $CanvasPathName]]
	set PopUp_y [expr $y_in_can + [winfo rooty $CanvasPathName]]

	#####
	# prepare PopUp

	set CanInfo(PU_DecFlowLineID) $DecisionFlowLineID
	set CanInfo(PU_DecFlowLineCompID) [$CanvasPathName find withtag FlowLineComp$DecisionFlowLineID]

	if { $ObjArr($CanInfo(PU_DecFlowLineCompID),HL_Style) == $::olSDL_ViewsDrawMethods::DecFlowLineComp_HL_Style::flowline_membership } {
		set CanInfo(PU_hl_DecFlowLineComp) 1
	} elseif { $ObjArr($CanInfo(PU_DecFlowLineCompID),HL_Style) == $::olSDL_ViewsDrawMethods::DecFlowLineComp_HL_Style::normal } {
		set CanInfo(PU_hl_DecFlowLineComp) 0
	} else {
		error "unknown HL state"
	}

	# prepare PopUp
	#####

	$CanInfo(menu_DecFlowLinePopUp) post $PopUp_x $PopUp_y
}
##############################################################################
####### END: Decision Flow Line Comp
##############################################################################

##############################################################################
# T_M_C - methods
##############################################################################
proc ::olSDL_Views::FlowLine::modify_DecisionFlowLineComp_PaS_in_T_M_C {ActionType ObjArrName CanInfoArr DecFlowLineCompCanID NewCoords} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ($ActionType != "scale")  && ($ActionType != "move") } {
		error "unknown action type"
		return
	}

	set NewPaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $NewCoords]
	set OldPaS $ObjArr($DecFlowLineCompCanID,PaS)

	##############
	# canvas
	if { $ActionType == "move" } {
		set dx [expr [lindex $NewPaS 0] - [lindex $OldPaS 0]]
		set dy [expr [lindex $NewPaS 1] - [lindex $OldPaS 1]]
		$CanvasPathName	move PartOfFlowLineComp$DecFlowLineCompCanID $dx $dy
		$CanvasPathName	move $DecFlowLineCompCanID $dx $dy
	} else {
		set dx [expr double([lindex $NewPaS 2]) / [lindex $OldPaS 2]]
		set dy [expr double([lindex $NewPaS 3]) / [lindex $OldPaS 3]]
		if {[lindex $NewPaS 0] == [lindex $OldPaS 0]} {
		  set origx [lindex $OldPaS 0]
		} else {
		  set origx [expr [lindex $OldPaS 0]+[lindex $OldPaS 2]]
		}
		if {[lindex $NewPaS 1] == [lindex $OldPaS 1]} {
		  set origy [lindex $OldPaS 1]
		} else {
		  set origy [expr [lindex $OldPaS 1]+[lindex $OldPaS 3]]
		}
		$CanvasPathName	scale PartOfFlowLineComp$DecFlowLineCompCanID $origx $origy $dx $dy
		$CanvasPathName	scale $DecFlowLineCompCanID $origx $origy $dx $dy
	}
	# canvas
	##############

	##############
	# tcl

	set ObjArr($DecFlowLineCompCanID,PaS) $NewPaS
	if { $ActionType == "scale" } {
		::olSDL_Views::FlowLine::modify_DecisionFlowLineContent_in_T_M_C $ObjArrName $CanInfoArr $DecFlowLineCompCanID $ObjArr($DecFlowLineCompCanID,Text)
	}

	# tcl
	##############

	##############
	# model

	get_DecisionFlowLineID_from_DecisionFlowLineComp $ObjArrName $CanInfoArr $DecFlowLineCompCanID DecisionFlowLineID
	set DecisionFlowLineComp_Model_ID $ObjArr($DecisionFlowLineID,Model_ID)

	modify_DecisionFlowLinePaS_in_Model $DecisionFlowLineComp_Model_ID \
		[lindex $ObjArr($DecFlowLineCompCanID,PaS) 0] [lindex $ObjArr($DecFlowLineCompCanID,PaS) 1] \
		[lindex $ObjArr($DecFlowLineCompCanID,PaS) 2] [lindex $ObjArr($DecFlowLineCompCanID,PaS) 3]

	# model
	##############

}
##############################################################################
proc ::olSDL_Views::FlowLine::modify_DecisionFlowLineContent_in_T_M_C {ObjArrName CanInfoArr DecFlowLineCompCanID NewContent} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	get_DecisionFlowLineID_from_DecisionFlowLineComp $ObjArrName $CanInfoArr $DecFlowLineCompCanID DecisionFlowLineID

	##############
	# tcl

	set ObjArr($DecFlowLineCompCanID,Text) $NewContent

	# tcl
	##############

	##############
	# model

	modify_DecisionFlowLineContent_in_Model $ObjArr($DecFlowLineCompCanID,Model_ID) $ObjArr($DecFlowLineCompCanID,Text)

	# model
	##############

	##############
	# canvas

	::olSDL_ViewsDrawMethods::delete_DecisionFlowLineComp_Comp_from_Canvas $ObjArrName $CanInfoArr $DecFlowLineCompCanID

	::olSDL_ViewsDrawMethods::draw_DecisionFlowLineComp $CanvasPathName $DecisionFlowLineID \
		$ObjArr($DecFlowLineCompCanID,PaS) $ObjArr($DecFlowLineCompCanID,Text) $DecFlowLineCompCanID \
		$ObjArr($DecFlowLineCompCanID,HL_Style) CanObjID

	# canvas
	##############
}
##############################################################################
# END: T_M_C - methods
##############################################################################

