
package provide olSDL_Views 1

namespace eval olSDL_Views {
	namespace eval ResizeStateMaSym {
	}
	namespace eval MoveStateMaSym {
	}
	namespace eval StateMaSym {
	  set StateSym {StateMaStartStateSym StateMaStateSym StateMaInputSym StateMaOutputSym StateMaTaskSym StateMaStopSym StateMaConditionSym StateMaDecisionSym StateMaCreateProSym StateMaCallProcedureSym StateMaProcedureStartStateSym StateMaProcedureReturnSym}
	}
}

##############################################################################
# methods for State Machine Symbols like StartState, State, Input, Output
##############################################################################
proc ::olSDL_Views::StateMaSym::EnterStateMaSym {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	if { [lsearch $CanInfo(selObj) $currentObject] != -1 } {
		$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Selected
	}
}
##############################################################################
proc ::olSDL_Views::StateMaSym::LeaveStateMaSym {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	$CanvasPathName configure -cursor $::olSDL_ViewsDrawMethods::CursStyle_Normal
}
##############################################################################
proc ::olSDL_Views::StateMaSym::delete_StateMaSym_from_T_M_C {ObjArrName CanInfoArr StateMaSymID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	###########
	# canvas

	::olSDL_ViewsDrawMethods::delete_StateMaSym_and_Comp_from_Canvas $ObjArrName $CanInfoArr $StateMaSymID

	# canvas
	###########

	#############
	# model

	set StateMaSym_Model_ID $ObjArr($StateMaSymID,Model_ID)

	delete_StateMachineSymbol_from_Model $StateMaSym_Model_ID

	# model
	#############

	#############
	# tcl

	foreach element [lsort [array names ObjArr]] {
		if { [string first "$StateMaSymID," $element ] == 0} {
			unset ${ObjArrName}($element)
		}
	}

	# tcl
	#############

	set del_index [lsearch $CanInfo(allObj) $StateMaSymID]
	set CanInfo(allObj) [lreplace $CanInfo(allObj) $del_index $del_index]

	set del_index [lsearch $CanInfo(selObj) $StateMaSymID]
	set CanInfo(selObj) [lreplace $CanInfo(selObj) $del_index $del_index]
}
##############################################################################
proc ::olSDL_Views::StateMaSym::ClickOnStateMaSym {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasState $CanInfo(state)
	set CanvasPathName $CanInfo(CanvasPathName)

	set x [expr int([$CanvasPathName canvasx $x])]
	set y [expr int([$CanvasPathName canvasy $y])]

	set currentObject [$CanvasPathName find withtag current]

	switch -exact $CanvasState {
	  single_obj_selected -
	  normal {
		::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr
		::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $currentObject
		return
	  }
	  place_new_rec_obj -
	  connection -
	  place_state_machine_sym {
		return
	  }
	  flowline {
		if { $CanInfo(flowline_SourceID) == "" } {
			# case: source unknown
			if { [is_valid_FlowLineSource $ObjArr($currentObject,Type)] } {
				::olSDL_Views::FlowLine::set_FL_ConnectHelperObjects $ObjArrName $CanInfoArr $currentObject [expr [lindex $ObjArr($currentObject,PaS) 0]+([lindex $ObjArr($currentObject,PaS) 2]/2)] [expr [lindex $ObjArr($currentObject,PaS) 1]+[lindex $ObjArr($currentObject,PaS) 3]]
				return
			} else {
				::olSDL_Views::FlowLine::init_FL_ConnectHelperObjects $CanInfoArr
				::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
				::olSDL_Dialogs::FL_NotValidSource
				return
			}
		} else {
			# case: source known

			if { [is_valid_FlowLineDestination $ObjArr($CanInfo(flowline_SourceID),Type) $ObjArr($currentObject,Type)] && \
				($CanInfo(flowline_SourceID) != $currentObject) && \
				! [::olSDL_Views::FlowLine::FlowLine_exists $ObjArrName $CanInfoArr $CanInfo(flowline_SourceID) $currentObject] && \
				[::olSDL_Views::FlowLine::validNumberOfOutgoingFlowLines $ObjArrName $CanInfoArr $CanInfo(flowline_SourceID)] } {

				set Diagram_ID $CanInfo(Dia_Model_ID)
				set PageID $CanInfo(PageID)

				set PageFrameCoords [::olSDL_ViewsCalcCoor::get_RecCoordsAsList_fromPaS $CanInfo(PageFramePaS)]

				set FlowLineCoords [::olSDL_Views::FlowLine::calc_FL_Coords $ObjArr($CanInfo(flowline_SourceID),PaS) $ObjArr($currentObject,PaS)]

				if { [::olSDL_ViewsCalcCoor::LineInRectangle $FlowLineCoords $PageFrameCoords] } {

					if { $ObjArr($CanInfo(flowline_SourceID),Type) == "StateMaDecisionSym" } {

						###########
						# draw FlowLine

						set b_EndingArrow [::olSDL_Views::FlowLine::FlowLineEndsInNextstate $ObjArrName $CanInfoArr $currentObject]

						::olSDL_ViewsDrawMethods::draw_DecisionFlowLine $CanvasPathName $b_EndingArrow $FlowLineCoords none NewFlowLineCanObjID

						# draw FlowLine
						###########

						###########
						# draw FlowLine Comp

						set DecisionFlowLineCompPaS [concat [::olSDL_Views::FlowLine::calc_PositionOfDecisionFlowLineComp $FlowLineCoords]  \
							$::olSDL_ViewsDrawMethods::default_Size_DecFlowLineComp]

						set DecisionFlowLineCompContent $::olSDL_ViewsDrawMethods::default_Text_DecFlowLine

						::olSDL_ViewsDrawMethods::draw_DecisionFlowLineComp $CanvasPathName $NewFlowLineCanObjID \
							$DecisionFlowLineCompPaS $DecisionFlowLineCompContent none \
							$::olSDL_ViewsDrawMethods::DecFlowLineComp_HL_Style::normal NewFlowLineCompCanObjID

						# draw FlowLine Comp
						###########

						#############
						# store FlowLine in Tcl and Model

						::olSDL_Views::FlowLine::store_DecisionFlowLine_and_Comp_in_Tcl_and_Model $ObjArrName $CanInfoArr \
							$Diagram_ID $PageID $NewFlowLineCanObjID $CanInfo(flowline_SourceID) $currentObject $FlowLineCoords \
							$NewFlowLineCompCanObjID $DecisionFlowLineCompContent $DecisionFlowLineCompPaS


						# store FlowLine in Tcl and Model
						#############

					} else {

						###########
						# draw FlowLine

						set b_EndingArrow [::olSDL_Views::FlowLine::FlowLineEndsInNextstate $ObjArrName $CanInfoArr $currentObject]

						::olSDL_ViewsDrawMethods::draw_FlowLine $CanvasPathName $b_EndingArrow $FlowLineCoords none NewFlowLineCanObjID

						# draw FlowLine
						###########

						#############
						# store FlowLine in Tcl and Model

						::olSDL_Views::FlowLine::store_NormalFlowLine_in_Tcl_and_Model $ObjArrName $CanInfoArr \
							$Diagram_ID $PageID $NewFlowLineCanObjID $CanInfo(flowline_SourceID) $currentObject $FlowLineCoords

						# store FlowLine in Tcl and Model
						#############
					}
					# if { $ObjArr($CanInfo(flowline_SourceID),Type) == "StateMaDecisionSym" }

				}
				# if { [::olSDL_ViewsCalcCoor::LineInRectangle $FlowLineCoords $PageFrameCoords] }

			} else {

				if { ! [::olSDL_Views::FlowLine::validNumberOfOutgoingFlowLines $ObjArrName $CanInfoArr $CanInfo(flowline_SourceID)] } {

					::olSDL_Dialogs::FL_InvalidNumberOfOutgoingFlowLines
				} else {

					::olSDL_Dialogs::FL_ConnectionNotAllowed
				}
			}

			# delete Helper
			::olSDL_Views::FlowLine::init_FL_ConnectHelperObjects $CanInfoArr

			# change canvas mode
			::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy

			return
		}
	  }
	  default {
		error "canvas state unknown"
	  }
	}
}
##############################################################################
proc ::olSDL_Views::StateMaSym::is_valid_FlowLineDestination {SourceStateMaSymType DestinationStateMaSymType} {

	switch -exact $SourceStateMaSymType {
		StateMaStateSym {
			if {[lsearch {StateMaInputSym StateMaConditionSym StateMaTaskSym StateMaOutputSym StateMaCreateProSym StateMaDecisionSym StateMaCallProcedureSym StateMaStateSym StateMaStopSym StateMaProcedureReturnSym} $DestinationStateMaSymType] > -1} {
				return true
			} else {
				return false
			}
		}
		StateMaInputSym {
			if {[lsearch {StateMaConditionSym StateMaTaskSym StateMaOutputSym StateMaCreateProSym StateMaDecisionSym StateMaCallProcedureSym StateMaStateSym StateMaStopSym StateMaProcedureReturnSym} $DestinationStateMaSymType] > -1} {
				return true
			} else {
				return false
			}
		}
		StateMaStartStateSym -
		StateMaProcedureStartStateSym -
		StateMaConditionSym -
		StateMaTaskSym -
		StateMaOutputSym -
		StateMaCreateProSym -
		StateMaDecisionSym -
		StateMaCallProcedureSym {
			if {[lsearch {StateMaTaskSym StateMaOutputSym StateMaCreateProSym StateMaDecisionSym StateMaCallProcedureSym StateMaStateSym StateMaStopSym StateMaProcedureReturnSym} $DestinationStateMaSymType] > -1} {
				return true
			} else {
				return false
			}
		}
		StateMaProcedureReturnSym -
		StateMaStopSym {
			return false
		}
		default {
			error "unkown StateMaSym"
			return false
		}
	}
	# switch -exact $StateMaSymType
}
##############################################################################
proc ::olSDL_Views::StateMaSym::is_valid_FlowLineSource {StateMaSymType} {

	switch -exact $StateMaSymType {
		StateMaProcedureReturnSym -
		StateMaStopSym { return false}
		default {return [::olSDL_Views::is_StateMaSym $StateMaSymType]}
	}
}
##############################################################################
# methods for RESIZING StateMaSym
##############################################################################
proc ::olSDL_Views::ResizeStateMaSym::RP_StartResize {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)
	set currentObject [$CanvasPathName find withtag current]

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	::olSDL_Views::RecObjRP::init_ResizeHelperObjects $ObjArrName $CanInfoArr

	set Resize_start_x [expr int([$CanvasPathName canvasx $x])]
	set Resize_start_y [expr int([$CanvasPathName canvasy $y])]

 	set CanInfo(Resize_ActionType) [::olSDL_Views::RecObjRP::determine_ResizeActionType $ObjArrName $CanInfoArr $currentObject]
	set CanInfo(Resize_PointParentID) [::olSDL_Views::RecObjRP::get_Parent_from_ResizePoint $ObjArrName $CanInfoArr $currentObject]

	set ResizeFrameCoords [::olSDL_Views::RecObjRP::calc_ResizeFrameCoords \
		$ObjArrName $CanInfoArr $Resize_start_x $Resize_start_y]

	set ResizeFrame [$CanvasPathName create rectangle $ResizeFrameCoords -dash {2 4} -width 2]

	set CanInfo(Resize_FrameID) $ResizeFrame
}
##############################################################################
proc ::olSDL_Views::ResizeStateMaSym::RP_ProcessResize {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	set Resize_current_x [expr int([$CanvasPathName canvasx $x])]
	set Resize_current_y [expr int([$CanvasPathName canvasy $y])]

	set ResizeFrameCoords [::olSDL_Views::RecObjRP::calc_ResizeFrameCoords \
		$ObjArrName $CanInfoArr $Resize_current_x $Resize_current_y]

	$CanvasPathName coords $CanInfo(Resize_FrameID) $ResizeFrameCoords
}
##############################################################################
proc ::olSDL_Views::ResizeStateMaSym::RP_EndResize {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	set Parent_ID $CanInfo(Resize_PointParentID)

	set ResizeFrameCoords { }
	set ResizeFrameCoords [$CanvasPathName coords $CanInfo(Resize_FrameID)]
	set ResizeFrameCoords [::olSDL_ViewsCalcCoor::convert_to_IntList $ResizeFrameCoords]

	####################
	# admissible new size ?
	if  {! [::olSDL_Views::admissibleRecObjSize $ResizeFrameCoords]}  {
		::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
		return
	}
	# END: admissible new size ?
	####################

	####################
	# symbols covered ?

	if { [::olSDL_Views::Obj_covered $CanvasPathName $ResizeFrameCoords $Parent_ID selectableRec] }  {
		::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
		return
	}

	if { [::olSDL_Views::Obj_covered $CanvasPathName $ResizeFrameCoords $Parent_ID moveableStateMaSym] }  {
		::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
		return
	}

	# END: symbols covered ?
	####################

	####################
	# object still in PageFrame ?

	set PageFrameInnerZoneCoords [::olSDL_ViewsCalcCoor::calc_PageFrameInnerZoneCoords $CanInfo(PageFramePaS)]

	if {! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageFrameInnerZoneCoords $ResizeFrameCoords]} {
		::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
		return
	}

	# END: object still in PageFrame ?
	####################

	####################
	# connected FlowLines still in PageFrame ?

	set ConnectedFlowLines [::olSDL_Views::StateMaSym::get_connected_NormalFlowLines $ObjArrName $CanInfoArr $Parent_ID]

	foreach FlowLineID $ConnectedFlowLines {

		if { ! [::olSDL_Views::FlowLine::FlowLineInPageFrame $ObjArrName $CanInfoArr $FlowLineID $Parent_ID $ResizeFrameCoords] } {

			::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
			return
		}
	}

	# connected FlowLines still in PageFrame ?
	####################

	####################
	# connected DecFlowLines still in PageFrame ?

	set ConnectedDecFlowLines [::olSDL_Views::StateMaSym::get_connected_DecisionFlowLines $ObjArrName $CanInfoArr $Parent_ID]

	foreach DecFlowLineID $ConnectedDecFlowLines {

		if { ! [::olSDL_Views::FlowLine::FlowLineInPageFrame $ObjArrName $CanInfoArr $DecFlowLineID $Parent_ID $ResizeFrameCoords] } {

			::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
			return
		}
	}

	# connected FlowLines still in PageFrame ?
	####################

	####################
	#	RESIZE
	####################

	# tcl, canvas, model
	::olSDL_Views::StateMaSym::modify_StateMaSym_PaS_in_T_M_C "scale" $ObjArrName $CanInfoArr $CanInfo(Resize_PointParentID) $ResizeFrameCoords

	####################
	#  "move" Resize Points

	::olSDL_ViewsDrawMethods::delete_StateMaSym_RP_from_Canvas $ObjArrName $CanInfoArr $CanInfo(Resize_PointParentID)

	olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $CanInfo(Resize_PointParentID)

	#  "move" Resize Points
	####################

	####################
	#  "move" connected flow lines

	::olSDL_Views::StateMaSym::move_connected_NormalFlowLine $ObjArrName $CanInfoArr $Parent_ID

	::olSDL_Views::StateMaSym::move_connected_DecisionFlowLine $ObjArrName $CanInfoArr $Parent_ID

	#  END: "move" connected flow lines
	####################

	::olSDL_Views::RecObjRP::delete_ResizeHelperObjects $CanInfoArr
}
##############################################################################
# END: methods for RESIZING StateMaSym
##############################################################################

##############################################################################
# methods for MOVING State Machine Symbols like StartState, State, Input, Output
##############################################################################
proc ::olSDL_Views::MoveStateMaSym::StartMove {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasState $CanInfo(state)
	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	_init_MoveHelperObjects $ObjArrName $CanInfoArr

	set Move_start_x [expr int([$CanvasPathName canvasx $x])]
	set Move_start_y [expr int([$CanvasPathName canvasy $y])]

	set CanInfo(Move_start_x) $Move_start_x
	set CanInfo(Move_start_y) $Move_start_y
	set CanInfo(Move_MovedObjID) $currentObject

	#create MoveFrame, but in state hidden
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $ObjArr($CanInfo(Move_MovedObjID),PaS) \
		MoveFrame_x1 MoveFrame_y1 MoveFrame_x2 MoveFrame_y2

	set MoveFrame [$CanvasPathName create rectangle $MoveFrame_x1 $MoveFrame_y1 $MoveFrame_x2 $MoveFrame_y2 -state hidden -dash {2 4} -width 2]
	set CanInfo(Move_MoveFrameID) $MoveFrame
}
##############################################################################
proc ::olSDL_Views::MoveStateMaSym::ProcessMove {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	set CanInfo(Move_Obj_moved) true

	set move_dx [expr int([$CanvasPathName canvasx $x] - $CanInfo(Move_start_x))]
	set move_dy [expr int([$CanvasPathName canvasy $y] - $CanInfo(Move_start_y))]

	$CanvasPathName itemconfigure $CanInfo(Move_MoveFrameID) -state normal
	$CanvasPathName move $CanInfo(Move_MoveFrameID) $move_dx $move_dy

	set CanInfo(Move_start_x) [expr $CanInfo(Move_start_x) + $move_dx]
	set CanInfo(Move_start_y) [expr $CanInfo(Move_start_y) + $move_dy]
}
##############################################################################
proc ::olSDL_Views::MoveStateMaSym::EndMove {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set CanvasState $CanInfo(state)

	if { $CanvasState == "place_new_rec_obj" } {
		::olSDL_Views::PlaceRecSym::_delete_part_data_structure $CanInfoArr
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
		return
	}

	if { $CanvasState == "place_state_machine_sym" } {
		::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr normal dummy
		return
	}

	if { [string compare $CanvasState "single_obj_selected"] != 0 } {
		# do nothing
		return
	}

	if { ! $CanInfo(Move_Obj_moved) } {
		#puts "nothing happend"
		_delete_MoveHelperObjects $CanInfoArr
		return
	}

	set MoveFrameCoords [$CanvasPathName coords $CanInfo(Move_MoveFrameID)]
	set MoveFrameCoords [::olSDL_ViewsCalcCoor::convert_to_IntList $MoveFrameCoords]

	####################
	# symbols covered ?

	foreach type {selectableRec moveableStateMaSym} {
		if { [::olSDL_Views::Obj_covered $CanvasPathName $MoveFrameCoords $CanInfo(Move_MovedObjID) $type] }  {
			_delete_MoveHelperObjects $CanInfoArr
			return
		}
	}

	# END: symbols covered ?
	####################

	####################
	# object still in PageFrame ?

	set PageFrameInnerZoneCoords [::olSDL_ViewsCalcCoor::calc_PageFrameInnerZoneCoords $CanInfo(PageFramePaS)]

	if {! [::olSDL_ViewsCalcCoor::RecA_contains_RecB $PageFrameInnerZoneCoords $MoveFrameCoords]} {
		#puts "after move out of Frame"

		_delete_MoveHelperObjects $CanInfoArr
		return
	}

	# END: object still in PageFrame ?
	####################

	####################
	# connected FlowLines still in PageFrame ?

	set ConnectedFlowLines [::olSDL_Views::StateMaSym::get_connected_NormalFlowLines $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID)]

	foreach FlowLineID $ConnectedFlowLines {

		if { ! [::olSDL_Views::FlowLine::FlowLineInPageFrame $ObjArrName $CanInfoArr $FlowLineID $CanInfo(Move_MovedObjID) $MoveFrameCoords] } {

			_delete_MoveHelperObjects $CanInfoArr
			return
		}
	}

	# connected FlowLines still in PageFrame ?
	####################

	####################
	# connected DecFlowLines still in PageFrame ?

	set ConnectedDecFlowLines [::olSDL_Views::StateMaSym::get_connected_DecisionFlowLines $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID)]

	foreach DecFlowLineID $ConnectedDecFlowLines {

		if { ! [::olSDL_Views::FlowLine::FlowLineInPageFrame $ObjArrName $CanInfoArr $DecFlowLineID $CanInfo(Move_MovedObjID) $MoveFrameCoords] } {

			_delete_MoveHelperObjects $CanInfoArr
			return
		}
	}

	# connected FlowLines still in PageFrame ?
	####################

	####################
	# MOVE
	####################

	# tcl, canvas, model
	::olSDL_Views::StateMaSym::modify_StateMaSym_PaS_in_T_M_C "move" $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID) $MoveFrameCoords

	####################
	# "move" ResizePoints

	::olSDL_ViewsDrawMethods::delete_StateMaSym_RP_from_Canvas $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID)

	olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID)

	# "move" ResizePoints
	####################

	####################
	#  "move" connected flow lines

	::olSDL_Views::StateMaSym::move_connected_NormalFlowLine $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID)

	::olSDL_Views::StateMaSym::move_connected_DecisionFlowLine $ObjArrName $CanInfoArr $CanInfo(Move_MovedObjID)

	#  END: "move" connected flow lines
	####################


	_delete_MoveHelperObjects $CanInfoArr
}
##############################################################################
proc ::olSDL_Views::MoveStateMaSym::_init_MoveHelperObjects {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanInfo(Move_start_x) ""
	set CanInfo(Move_start_y) ""
	set CanInfo(Move_MovedObjID) ""
	set CanInfo(Move_Obj_moved) false
	set CanInfo(Move_MoveFrameID) ""
}
##############################################################################
proc ::olSDL_Views::MoveStateMaSym::_delete_MoveHelperObjects {CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	# delete MoveFrame from Canvas
	$CanvasPathName delete $CanInfo(Move_MoveFrameID)

	set CanInfo(Move_start_x) ""
	set CanInfo(Move_start_y) ""
	set CanInfo(Move_MovedObjID) ""
	set CanInfo(Move_Obj_moved) ""
	set CanInfo(Move_MoveFrameID) ""
}
##############################################################################
# END: methods for MOVING State Machine Symbols like StartState, State, Input, Output
##############################################################################

##############################################################################
proc ::olSDL_Views::StateMaSym::show_StateMaSymPopUpMenu {ObjArrName CanInfoArr x y} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set currentObject [$CanvasPathName find withtag current]

	# unpost CM
	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr

	# set selected
	::olSDL_Views::AllViews::set_SingleObjSelected $ObjArrName $CanInfoArr $currentObject

	set x_in_can [expr int (round ($x))]
	set y_in_can [expr int (round ($y))]

	set PopUp_x [expr $x_in_can + [winfo rootx $CanvasPathName]]
	set PopUp_y [expr $y_in_can + [winfo rooty $CanvasPathName]]

	set CanInfo(PU_StateMaSym_Object_ID) $currentObject

	#############
	#prepare Pop Up

	if { ($ObjArr($CanInfo(PU_StateMaSym_Object_ID),Type) == "StateMaStopSym") || \
	    ($ObjArr($CanInfo(PU_StateMaSym_Object_ID),Type) == "StateMaStartStateSym") || \
	    ($ObjArr($CanInfo(PU_StateMaSym_Object_ID),Type) == "StateMaProcedureStartStateSym") } {
		$CanInfo(menu_StateMaSymPopUp) entryconfigure 0 -state disabled
	} else {

		$CanInfo(menu_StateMaSymPopUp) entryconfigure 0 -state normal
	}

	#prepare Pop Up
	#############

	$CanInfo(menu_StateMaSymPopUp) post $PopUp_x $PopUp_y
}
##############################################################################
proc ::olSDL_Views::StateMaSym::EditContent {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set RecSymCanID $CanInfo(PU_StateMaSym_Object_ID)

	##################################
	# determine title for different StateMaSym

	switch -exact $ObjArr($RecSymCanID,Type) {
		StateMaStartStateSym {
		# No edit dialog yet
		}
		StateMaStateSym {
			set DlgTitle "State Symbol"
			EditDialog_Text $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
		}
		StateMaInputSym {
			set DlgTitle "Input Symbol"
			EditDialog_Input $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
		}
		StateMaOutputSym {
			set DlgTitle "Output Symbol"
			EditDialog_Text $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
		}
		StateMaTaskSym {
			set DlgTitle "Task Symbol"
			EditDialog_Text $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
		}
		StateMaStopSym {
			set DlgTitle "Stop Symbol"
			EditDialog_Text $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
		}
		StateMaConditionSym {
			set DlgTitle "Condition Symbol"
			EditDialog_Text $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
		}
		StateMaDecisionSym {
			set DlgTitle "Decision Symbol"
			EditDialog_Text $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
		}
		StateMaCreateProSym {
			set DlgTitle "Create Process Symbol"
			EditDialog_Text $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
		}
		StateMaCallProcedureSym {
			set DlgTitle "Call Procedure Symbol"
			EditDialog_Text $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
		}
		StateMaProcedureStartStateSym {
			set DlgTitle "Procedure Start State Symbol"
			EditDialog_Text $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
		}
		StateMaProcedureReturnSym {
			set DlgTitle "Procedure Return Symbol"
			EditDialog_Text $DlgTitle $ObjArrName $CanInfoArr $RecSymCanID
		}
		default {
			error "unkown Symbol Type"
		}
	}
	# switch -exact $ObjArr($RecSymCanID,Type)
}
##############################################################################
proc ::olSDL_Views::StateMaSym::EditDialog_Text {DlgTitle ObjArrName CanInfoArr RecSymCanID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set dlg [Dialog .rec_sym_edit -parent . -modal local -title Edit -geometry 300x300+200+100]

	set dTitleFrame [TitleFrame [$dlg getframe].tf]
	$dTitleFrame configure -text $DlgTitle

	set sw [ScrolledWindow [$dTitleFrame getframe].sw -relief sunken -borderwidth 2]
	set dtext [text [$sw getframe].tx ]
	$sw setwidget $dtext

	$dtext delete 1.0 end
	$dtext insert 1.0 $ObjArr($RecSymCanID,Text)

	pack $sw -fill both -expand true
	pack $dTitleFrame -fill both -expand true

	$dlg add -name ok
	$dlg add -name clear -text clear -command "$dtext delete 1.0 end"
	$dlg add -name cancel

	set DiaResult [$dlg draw]

	if { $DiaResult == 0 } {
		set NewText [string trimright [$dtext get 1.0 end]]
		::olSDL_Views::StateMaSym::modify_StateMachineSymbol_Content_in_Model_in_T_M_C $ObjArrName $CanInfoArr $RecSymCanID $NewText

	}
	destroy $dlg
}
##############################################################################
proc ::olSDL_Views::StateMaSym::EditDialog_Input {DlgTitle ObjArrName CanInfoArr RecSymCanID} {

	global aster prio
	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set dlg [Dialog .rec_sym_edit -parent . -modal local -title Edit -geometry 300x300+200+100]

	set dTitleFrame [TitleFrame [$dlg getframe].tf -text $DlgTitle]

	set mainframe [$dTitleFrame getframe]
	set name [string trim $ObjArr($RecSymCanID,Text) "* "]
	set aster [regexp {\*} $ObjArr($RecSymCanID,Text)]
	if [catch {set prio $ObjArr($RecSymCanID,AddParams)}] {
	  set prio ""
	}
	set dname [LabelEntry $mainframe.name -label Input -text $name]
	set asterisk [checkbutton $mainframe.aster -text Asterisk -command {if {$aster==1} {set prio 0}}]
	set priority [checkbutton $mainframe.prio -text Priority -command {if {$prio==1} {set aster 0}}]

	pack $dname -fill x -expand true
	pack $asterisk $priority -fill x -expand true
	pack $dTitleFrame -fill both -expand true

	$dlg add -name ok
	$dlg add -name clear -text clear -command {set name ""}
	$dlg add -name cancel

	set DiaResult [$dlg draw]

	if { $DiaResult == 0 } {
		set NewText [string trimright $name]
		if {$aster != 0} {
		  set NewText "*$NewText"
		}
		
		::olSDL_Views::StateMaSym::modify_StateMachineSymbol_Content_in_Model_in_T_M_C $ObjArrName $CanInfoArr $RecSymCanID $NewText $prio

	}
	destroy $dlg
}
##############################################################################
##############################################################################
proc ::olSDL_Views::StateMaSym::get_connected_NormalFlowLines {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set ConnectedFlowLines { }
	set AllFlowLines [::olSDL_Views::FlowLine::get_NormalFlowLines $CanInfoArr]

	foreach FlowLine $AllFlowLines {
		if { [::olSDL_Views::FlowLine::is_connected $ObjArrName $FlowLine $ObjID] } {
			lappend ConnectedFlowLines $FlowLine
		}
	}
	#foreach FlowLine $AllFlowLines

	return $ConnectedFlowLines
}
##############################################################################
proc ::olSDL_Views::StateMaSym::move_connected_NormalFlowLine {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set ConnectedFlowLines [get_connected_NormalFlowLines $ObjArrName $CanInfoArr $ObjID]

	foreach FlowLine $ConnectedFlowLines {

		set SourceCanID $ObjArr($FlowLine,SourceID)
		set DestCanID $ObjArr($FlowLine,DestinationID)

		set NewFlowLineCoords [::olSDL_Views::FlowLine::calc_FL_Coords $ObjArr($SourceCanID,PaS) $ObjArr($DestCanID,PaS)]

		::olSDL_Views::FlowLine::modify_NormalFlowLineCoords_in_Tcl_and_Model \
			$ObjArrName $CanInfoArr $FlowLine $NewFlowLineCoords

		set b_EndingArrow [::olSDL_Views::FlowLine::FlowLineEndsInNextstate $ObjArrName $CanInfoArr $DestCanID]

		::olSDL_ViewsDrawMethods::draw_FlowLine $CanvasPathName $b_EndingArrow $ObjArr($FlowLine,Coords) $FlowLine dummyNewFlowLine

	}
	# foreach FlowLine $ConnectedFlowLines
}

##############################################################################
##############################################################################
proc ::olSDL_Views::StateMaSym::get_connected_DecisionFlowLines {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set ConnectedFlowLines { }
	set AllFlowLines [::olSDL_Views::FlowLine::get_DecisionFlowLines $CanInfoArr]

	foreach FlowLine $AllFlowLines {
		if { [::olSDL_Views::FlowLine::is_connected $ObjArrName $FlowLine $ObjID] } {
			lappend ConnectedFlowLines $FlowLine
		}
	}
	return $ConnectedFlowLines
}
##############################################################################
proc ::olSDL_Views::StateMaSym::move_connected_DecisionFlowLine {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	set ConnectedFlowLines [get_connected_DecisionFlowLines $ObjArrName $CanInfoArr $ObjID]


	foreach FlowLine $ConnectedFlowLines {

		set SourceCanID $ObjArr($FlowLine,SourceID)
		set DestCanID $ObjArr($FlowLine,DestinationID)

		set NewFlowLineCoords [::olSDL_Views::FlowLine::calc_FL_Coords $ObjArr($SourceCanID,PaS) $ObjArr($DestCanID,PaS)]

		::olSDL_Views::FlowLine::modify_DecisionFlowLineCoords_in_Tcl_and_Model \
			$ObjArrName $CanInfoArr $FlowLine $NewFlowLineCoords

		set b_EndingArrow [::olSDL_Views::FlowLine::FlowLineEndsInNextstate $ObjArrName $CanInfoArr $DestCanID]

		::olSDL_ViewsDrawMethods::draw_DecisionFlowLine $CanvasPathName $b_EndingArrow $ObjArr($FlowLine,Coords) $FlowLine dummyNewFlowLine

	}
	# foreach FlowLine $ConnectedFlowLines

}

##############################################################################
# T_M_C - methods
##############################################################################
proc ::olSDL_Views::StateMaSym::modify_StateMachineSymbol_Content_in_Model_in_T_M_C {ObjArrName CanInfoArr StateMaSymCanID NewContent {AddParams ""}} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	##############
	# tcl

	set ObjArr($StateMaSymCanID,Text) $NewContent
	if {$AddParams != ""} {
	  set ObjArr($StateMaSymCanID,AddParams) $AddParams
	}

	# tcl
	##############

	##############
	# model

	modify_StateMachineSymbol_Content_in_Model $ObjArr($StateMaSymCanID,Model_ID) $ObjArr($StateMaSymCanID,Text)

	# model
	##############

	##############
	# canvas

	if {[lsearch $::olSDL_Views::StateMaSym::StateSym $ObjArr($StateMaSymCanID,Type)] > -1} {
		foreach item [$CanvasPathName find withtag PartOf$StateMaSymCanID] {
		  if {[$CanvasPathName type $item] == "text"} {
		    set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $ObjArr($StateMaSymCanID,PaS) $ObjArr($StateMaSymCanID,Type)]
		    set CutText [::olSDL_ViewsCalcCoor::cut_Text $ObjArr($StateMaSymCanID,Text) $TextPaS]
		    $CanvasPathName itemconfigure $item -text $CutText
		    $CanvasPathName coords $item [lindex $TextPaS 0] [lindex $TextPaS 1]
		  }
		  if {$ObjArr($StateMaSymCanID,Type)=="StateMaInputSym" && [$CanvasPathName type $item] == "line"} {
		    set coords [$CanvasPathName coords $item]
		    if {$ObjArr($StateMaSymCanID,AddParams)==1 && [llength $coords]==12} {
		    set offset [expr ([lindex $coords 8] - [lindex $coords 0])/3]
		    lappend coords [expr [lindex $coords 10] + $offset] [lindex $coords 11]
		    lappend coords [expr [lindex $coords 8] + $offset] [lindex $coords 9]
		    lappend coords [expr [lindex $coords 6] + $offset] [lindex $coords 7]
		    $CanvasPathName coords $item $coords
		    }
		    if {$ObjArr($StateMaSymCanID,AddParams)==0 && [llength $coords==18]} {
		    set coords [lrange $coords 0 11]
		    $CanvasPathName coords $item $coords
		    }
		    
		  }
		}
	} else {
		error "unknown state machine symbol"
	}

	# canvas
	##############
}
##############################################################################
proc ::olSDL_Views::StateMaSym::modify_StateMaSym_PaS_in_T_M_C {ActionType ObjArrName CanInfoArr StateMaSymCanID NewCoords} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ($ActionType != "scale")  && ($ActionType != "move") } {
		error "unknown action type"
		return
	}

	set NewPaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $NewCoords]
	set OldPaS $ObjArr($StateMaSymCanID,PaS)

	##############
	# canvas
	if { $ActionType == "move" } {
		set dx [expr [lindex $NewPaS 0] - [lindex $OldPaS 0]]
		set dy [expr [lindex $NewPaS 1] - [lindex $OldPaS 1]]
		$CanvasPathName	move PartOf$StateMaSymCanID $dx $dy
		$CanvasPathName	move $StateMaSymCanID $dx $dy
	} else {
		set dx [expr double([lindex $NewPaS 2]) / [lindex $OldPaS 2]]
		set dy [expr double([lindex $NewPaS 3]) / [lindex $OldPaS 3]]
		if {[lindex $NewPaS 0] == [lindex $OldPaS 0]} {
		  set origx [lindex $OldPaS 0]
		} else {
		  set origx [expr [lindex $OldPaS 0]+[lindex $OldPaS 2]]
		}
		if {[lindex $NewPaS 1] == [lindex $OldPaS 1]} {
		  set origy [lindex $OldPaS 1]
		} else {
		  set origy [expr [lindex $OldPaS 1]+[lindex $OldPaS 3]]
		}
		$CanvasPathName	scale PartOf$StateMaSymCanID $origx $origy $dx $dy
		$CanvasPathName	scale $StateMaSymCanID $origx $origy $dx $dy
	}
	# canvas
	##############

	##############
	# tcl

	set ObjArr($StateMaSymCanID,PaS) $NewPaS
	if { $ActionType == "scale" } {
		::olSDL_Views::StateMaSym::modify_StateMachineSymbol_Content_in_Model_in_T_M_C $ObjArrName $CanInfoArr $StateMaSymCanID $ObjArr($StateMaSymCanID,Text)
	}
 
	# tcl
	##############

	##############
	# model

	set PaS_x [lindex $ObjArr($StateMaSymCanID,PaS) 0]
	set PaS_y [lindex $ObjArr($StateMaSymCanID,PaS) 1]
	set PaS_width [lindex $ObjArr($StateMaSymCanID,PaS) 2]
	set PaS_height [lindex $ObjArr($StateMaSymCanID,PaS) 3]

	modify_StateMachineSymbol_PaS_in_Model $ObjArr($StateMaSymCanID,Model_ID) $PaS_x $PaS_y $PaS_width $PaS_height

	# model
	##############
}
##############################################################################
# END: T_M_C - methods
##############################################################################

