
package provide olSDL_Views 1

####################################################
# namespace olSDL_Views
####################################################

namespace eval olSDL_Views {

	variable NameOfObjArr arr_ObjOfView
	variable NameOfCanInfoArr arr_CanInfo
	variable CanvasBgColor white

	variable default_ChannelDirectionType "both"

	variable default_ChannelDelayType "no_delay"

	# das Array arr_Views enthlt Informationen ber alle aktuell vorhandenen Views. Die Views
	# drfen zu unterschiedliche Viewstypen gehren.
	# arr_Views($view_ID$,Type) = SysDia, BlkDia, ....
	# arr_Views($view_ID$,Model_ID) = SysDia, BlkDia, ....
	# arr_Views($view_ID$,NameOfObjArr) = Name des Array, das die Objekte aus dem View view_ID enthlt
	# arr_Views($view_ID$,Model_ID)
	# arr_Views($view_ID$,CanvasPathName)
	# arr_Views($view_ID$,PageID)

	variable arr_Views
	array set arr_Views { }

	####################################################
	# namespace SymDefaultValues
	namespace eval SymDefaultValues {

		variable TextSym_width 300
		variable BlkInstRefSym_width 50
		variable BlkTypeRefSym_width 50
		variable ProInstRefSym_width 50
		variable ProTypeRefSym_width 50

		variable TextSym_height 50
		variable BlkInstRefSym_height 50
		variable BlkTypeRefSym_height 50
		variable ProInstRefSym_height 50
		variable ProTypeRefSym_height 50

	}
	# END: namespace SysDiaView
	####################################################

	namespace eval ViewsManager {

	}
	namespace eval AllViews {

	}
}
####################################################
# END: namespace olSDL_Views
####################################################

########################################################################################################
#### Methoden zum Zeichnen und Ablegen von einzelnen Symbolen
########################################################################################################

########################################################################################################
proc ::olSDL_Views::get_and_draw_FlowLines {ObjArrName CanInfoArr CanvasPathName Dia_Model_ID PageID}  {

	upvar #0 ::olSDL_MAR::arr_MAR MAR
	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	get_FlowLines_from_Model $Dia_Model_ID $PageID

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	foreach FlowLineID $MAR(IDs) {

		if { $MAR($FlowLineID,Type) == "normal" } {

			###########
			# draw FlowLine

			set CanDestID [::olSDL_Views::_get_Canvas_ID_from_Model_ID $ObjArrName $MAR($FlowLineID,Dest_Model_ID)]

			set b_EndingArrow [::olSDL_Views::FlowLine::FlowLineEndsInNextstate $ObjArrName $CanInfoArr $CanDestID]

			::olSDL_ViewsDrawMethods::draw_FlowLine $CanvasPathName $b_EndingArrow $MAR($FlowLineID,Coords) none NewCanFlowLineID

			# draw FlowLine
			###########

			#############
			# store FlowLine in Tcl and Model

			set CanSourceID [::olSDL_Views::_get_Canvas_ID_from_Model_ID $ObjArrName $MAR($FlowLineID,Source_Model_ID)]
			set CanDestID [::olSDL_Views::_get_Canvas_ID_from_Model_ID $ObjArrName $MAR($FlowLineID,Dest_Model_ID)]

			::olSDL_Views::FlowLine::store_NormalFlowLine_in_Tcl $ObjArrName $CanInfoArr $NewCanFlowLineID \
				$CanSourceID $CanDestID $FlowLineID $MAR($FlowLineID,Coords)

			# store FlowLine in Tcl and Model
			#############

		} elseif { $MAR($FlowLineID,Type) == "decision" } {

			###########
			# draw decision flow line

			set CanDestID [::olSDL_Views::_get_Canvas_ID_from_Model_ID $ObjArrName $MAR($FlowLineID,Dest_Model_ID)]

			set b_EndingArrow [::olSDL_Views::FlowLine::FlowLineEndsInNextstate $ObjArrName $CanInfoArr $CanDestID]

			::olSDL_ViewsDrawMethods::draw_DecisionFlowLine $CanvasPathName $b_EndingArrow $MAR($FlowLineID,Coords) none NewCanFlowLineID

			# END: draw decision flow line
			###########

			###########
			# draw FlowLine Comp

			set DecisionFlowLineCompPaS $MAR($FlowLineID,PaS)

			set DecisionFlowLineCompContent [::olSDL_Views::MAR_StringToString $MAR($FlowLineID,Content)]

			::olSDL_ViewsDrawMethods::draw_DecisionFlowLineComp $CanvasPathName $NewCanFlowLineID \
					$DecisionFlowLineCompPaS $DecisionFlowLineCompContent none \
					$::olSDL_ViewsDrawMethods::DecFlowLineComp_HL_Style::normal NewFlowLineCompCanObjID

			# draw FlowLine Comp
			###########

			###########
			# store decision flow line in Tcl

			set CanSourceID [::olSDL_Views::_get_Canvas_ID_from_Model_ID $ObjArrName $MAR($FlowLineID,Source_Model_ID)]
			set CanDestID [::olSDL_Views::_get_Canvas_ID_from_Model_ID $ObjArrName $MAR($FlowLineID,Dest_Model_ID)]

			::olSDL_Views::FlowLine::store_DecisionFlowLine_in_Tcl $ObjArrName $CanInfoArr \
				$NewCanFlowLineID $CanSourceID $CanDestID $FlowLineID $MAR($FlowLineID,Coords)

			# store decision flow line in Tcl
			###########

			###########
			# store decision flow line comp in Tcl

			::olSDL_Views::FlowLine::store_DecisionFlowLineComp_in_Tcl $ObjArrName $CanInfoArr \
				$NewFlowLineCompCanObjID $DecisionFlowLineCompContent $FlowLineID \
				$::olSDL_ViewsDrawMethods::DecFlowLineComp_HL_Style::normal $DecisionFlowLineCompPaS

			# store decision flow line comp in Tcl
			###########

		} else {
			error "no flow line"
		}

	}
	# foreach FlowLineID $MAR(IDs)

}
########################################################################################################
proc ::olSDL_Views::get_and_draw_Channels {ObjArrName CanInfoArr CanvasPathName Dia_Model_ID PageID}  {

	upvar #0 ::olSDL_MAR::arr_MAR MAR
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	get_Channels_from_Model $Dia_Model_ID $PageID

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	foreach Channel_ID $MAR(IDs) {

		::olSDL_ViewsDrawMethods::draw_Channel $CanvasPathName $MAR($Channel_ID,Coords) \
			$MAR($Channel_ID,DelayType) $MAR($Channel_ID,DirectionType) false dummy NewCanChannel_ID

			#####

		set NewChanNameID ""
		::olSDL_ViewsDrawMethods::draw_ChannelName $CanvasPathName $NewCanChannel_ID $MAR($Channel_ID,NamePaS) \
			[::olSDL_Views::MAR_StringToString $MAR($Channel_ID,NameContent)] false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanNameID

			#####

		set NewChanSourceSigID ""
		::olSDL_ViewsDrawMethods::draw_ChanSourceSig $CanvasPathName $NewCanChannel_ID $MAR($Channel_ID,SourceSigListPaS) \
			[::olSDL_Views::MAR_StringToString $MAR($Channel_ID,SourceSigListContent)] false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanSourceSigID

			#####

		set NewChanDestSigID ""
		::olSDL_ViewsDrawMethods::draw_ChanDestSig $CanvasPathName $NewCanChannel_ID $MAR($Channel_ID,DestSigListPaS) \
			[::olSDL_Views::MAR_StringToString $MAR($Channel_ID,DestSigListContent)] false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanDestSigID

			#####

		set NewChanSourceConID ""
		::olSDL_ViewsDrawMethods::draw_ChanSourceCon $CanvasPathName $NewCanChannel_ID $MAR($Channel_ID,SourceConPaS) \
			[::olSDL_Views::MAR_StringToString $MAR($Channel_ID,SourceConContent)] false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanSourceConID

			#####

		set NewChanDestConID ""
		::olSDL_ViewsDrawMethods::draw_ChanDestCon $CanvasPathName $NewCanChannel_ID $MAR($Channel_ID,DestConPaS) \
			[::olSDL_Views::MAR_StringToString $MAR($Channel_ID,DestConContent)] false dummy \
			$::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal NewChanDestConID

		##############################
		# store channel in Tcl

		if { $MAR($Channel_ID,Source_Model_ID) == "ENV" } {
			set SourceCanID "ENV"
		} else {
			set SourceCanID [::olSDL_Views::_get_Canvas_ID_from_Model_ID $ObjArrName $MAR($Channel_ID,Source_Model_ID)]
		}


		if { $MAR($Channel_ID,Dest_Model_ID) == "ENV" } {
			set DestCanID "ENV"
		} else {
			set DestCanID [::olSDL_Views::_get_Canvas_ID_from_Model_ID $ObjArrName $MAR($Channel_ID,Dest_Model_ID)]
		}


		::olSDL_Views::Channel::store_Channel_in_Tcl $ObjArrName $CanInfoArr \
			$NewCanChannel_ID $MAR($Channel_ID,DelayType) $MAR($Channel_ID,DirectionType) \
			$SourceCanID $DestCanID $Channel_ID $MAR($Channel_ID,Coords)


		# store channel in Tcl
		##############################

		##############################
		# store channel comp in Tcl

		::olSDL_Views::Channel::_store_ChanComp_in_Tcl $ObjArrName $CanInfoArr \
			$NewChanNameID ChanName \
			[::olSDL_Views::MAR_StringToString $MAR($Channel_ID,NameContent)] $Channel_ID $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal \
			$MAR($Channel_ID,NamePaS)
				####
		::olSDL_Views::Channel::_store_ChanComp_in_Tcl $ObjArrName $CanInfoArr \
			$NewChanSourceSigID ChanSourceSig \
			[::olSDL_Views::MAR_StringToString $MAR($Channel_ID,SourceSigListContent)] $Channel_ID $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal \
			$MAR($Channel_ID,SourceSigListPaS)
				####
		::olSDL_Views::Channel::_store_ChanComp_in_Tcl $ObjArrName $CanInfoArr \
			$NewChanDestSigID ChanDestSig \
			[::olSDL_Views::MAR_StringToString $MAR($Channel_ID,DestSigListContent)] $Channel_ID $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal \
			$MAR($Channel_ID,DestSigListPaS)
				####
		::olSDL_Views::Channel::_store_ChanComp_in_Tcl $ObjArrName $CanInfoArr \
			$NewChanSourceConID ChanSourceCon \
			[::olSDL_Views::MAR_StringToString $MAR($Channel_ID,SourceConContent)] $Channel_ID $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal \
			$MAR($Channel_ID,SourceConPaS)
				####
		::olSDL_Views::Channel::_store_ChanComp_in_Tcl $ObjArrName $CanInfoArr \
			$NewChanDestConID ChanDestCon \
			[::olSDL_Views::MAR_StringToString $MAR($Channel_ID,DestConContent)] $Channel_ID $::olSDL_ViewsDrawMethods::ChanComp_HL_Style::normal \
			$MAR($Channel_ID,DestConPaS)

		# END: store channel comp in Tcl
		##############################
	}
}
####################################################
proc ::olSDL_Views::draw_and_set_RecSym {SymbolType PaS Text ObjArrName CanInfoArr out_CanObjID}  {

	upvar $out_CanObjID return_CanObjID

	upvar #0 ::olSDL_MAR::arr_MAR MAR
	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set Model_ID $CanInfo(Dia_Model_ID)
	set PageID $CanInfo(PageID)

	#################
	# draw symbol

	if { [::olSDL_Views::is_RecSym $SymbolType]} {
		::olSDL_ViewsDrawMethods::draw_$SymbolType $CanvasPathName $PaS $Text false none false CanObjID
	} else {
		error "unkown Symbol Type"
	}

	set return_CanObjID $CanObjID

	#################
	# insert symbol into model

	insert_RecSym_into_Model $Model_ID $PageID $SymbolType [lindex $PaS 0] [lindex $PaS 1] [lindex $PaS 2] [lindex $PaS 3] $Text

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set NewObj_Model_ID $MAR(NewObj_Model_ID)

	if { [::olSDL_Views::is_ReferencingSymbol $SymbolType]} {
		set ReferencedDiagram_Model_ID $MAR(RefDia_Model_ID)
	} else {
		set ReferencedDiagram_Model_ID ""
	}

	# END: insert symbol into model
	#################

	#################
	# store symbol in Tcl

	store_RecSym_in_Tcl $ObjArrName $CanInfoArr $SymbolType $CanObjID $NewObj_Model_ID $PaS $Text $ReferencedDiagram_Model_ID

	# store symbol in Tcl
	#################

}
########################################################################################################
proc ::olSDL_Views::draw_and_set_StateMaSym {SymbolType PaS Text ObjArrName CanInfoArr out_CanObjID}  {

	upvar $out_CanObjID return_CanObjID

	upvar #0 ::olSDL_MAR::arr_MAR MAR
	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)
	set Model_ID $CanInfo(Dia_Model_ID)
	set PageID $CanInfo(PageID)

	set StateSymIndex [lsearch $::olSDL_Views::StateMaSym::StateSym $SymbolType]

	if {$StateSymIndex > -1} {
		set CanObjID [::olSDL_ViewsDrawMethods::draw_$SymbolType $CanvasPathName $PaS $Text none false]
	} else {
		error "unknown state machine symbol"
	}

	set return_CanObjID $CanObjID

	#################
	# insert symbol into model

	insert_StateMachineSymbol_into_Model $Model_ID $PageID $SymbolType [lindex $PaS 0] [lindex $PaS 1] [lindex $PaS 2] [lindex $PaS 3] $Text

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set NewObj_Model_ID $MAR(NewObj_Model_ID)

	# END: insert symbol into model
	#################

	#################
	# store symbol in Tcl

	store_StateMaSym_in_Tcl $ObjArrName $CanInfoArr $SymbolType $CanObjID $NewObj_Model_ID $PaS $Text

	# store symbol in Tcl
	#################

}
########################################################################################################
#### END: Methoden zum Zeichnen und Ablegen von einzelnen Symbolen
########################################################################################################

########################################################################################################
#### Methoden zum Holen und Zeichnen von Symbolen
########################################################################################################

proc ::olSDL_Views::get_and_draw_Symbols {SymbolType ObjArrName CanInfoArr CanvasPathName Dia_Model_ID PageID}  {

	upvar #0 ::olSDL_MAR::arr_MAR MAR
	upvar #0 $CanInfoArr CanInfo

	if { [::olSDL_Views::is_RecSym $SymbolType]} {
		get_Symbols_from_Model $SymbolType $Dia_Model_ID $PageID
	} else {
		error "unkown Symbol Type"
	}

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	foreach Symbol $MAR(IDs) {

		set PaS $MAR(${Symbol},PaS)
		set Text [::olSDL_Views::MAR_StringToString $MAR(${Symbol},Text)]

		if { [::olSDL_Views::is_ReferencingSymbol $SymbolType]} {
			set ReferencedDiagram_Model_ID $MAR(${Symbol},RefDia_Model_ID)
		} else {
			set ReferencedDiagram_Model_ID ""
		}

		##############
		# draw Symbol

		::olSDL_ViewsDrawMethods::draw_$SymbolType $CanvasPathName $PaS $Text false none false CanObjID

		##############
		# store symbol

		store_RecSym_in_Tcl $ObjArrName $CanInfoArr $SymbolType $CanObjID $Symbol $PaS $Text $ReferencedDiagram_Model_ID

		# store symbol
		##############
	}
	# foreach Symbol $MAR(IDs)
}
########################################################################################################
proc ::olSDL_Views::get_and_draw_PageFrame_and_PageHeader {ObjArrName CanInfoArr CanvasPathName DiagramID PageID} {

	upvar #0 ::olSDL_MAR::arr_MAR MAR
	upvar #0 $CanInfoArr CanInfo

	get_PageFrameInfo_from_Model $DiagramID $PageID

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set HP_DiaType $MAR(HP_DiaType)
	set HP_Name [::olSDL_Views::MAR_StringToString $MAR(HP_Name)]
	set HP_Index $MAR(HP_Index)
	set FramePaS $MAR(FramePaS)

	::olSDL_ViewsDrawMethods::draw_PageFrame $CanvasPathName $FramePaS false dummy CanObjID

	set CanInfo(PageFramePaS) $FramePaS
	set CanInfo(PageFrameCanID) $CanObjID

	::olSDL_ViewsDrawMethods::draw_PageHeader $CanvasPathName $FramePaS $HP_DiaType $HP_Name $HP_Index CanObjID Comp TypeAndNamePaS

	set ${ObjArrName}(${CanObjID},Type) "HP_PageName"
	set ${ObjArrName}(${CanObjID},Name) $HP_Name
	set ${ObjArrName}(${CanObjID},Comp) $Comp
	set ${ObjArrName}(${CanObjID},PaS) $TypeAndNamePaS

	set CanInfo(PageIndexCanID) [lindex $Comp 2]

	lappend CanInfo(allObj) $CanObjID

}
########################################################################################################
#### END: Methoden zum Holen und Zeichnen von Symbolen
########################################################################################################
proc ::olSDL_Views::store_StateMaSym_in_Tcl {ObjArrName CanInfoArr SymbolType CanObjID Model_ID PaS Text} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	if { [::olSDL_Views::is_StateMaSym $SymbolType]} {
		set ObjArr($CanObjID,Type) $SymbolType
	} else {
		error "unkown Symbol Type $SymbolType"
	}

	set ObjArr($CanObjID,Model_ID) $Model_ID
	set ObjArr($CanObjID,PaS) $PaS
	set ObjArr($CanObjID,Text) $Text

	lappend CanInfo(allObj) $CanObjID
}
########################################################################################################
proc ::olSDL_Views::store_RecSym_in_Tcl {ObjArrName CanInfoArr SymbolType CanObjID Model_ID PaS Text ReferencedDiagram_Model_ID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	if { [::olSDL_Views::is_RecSym $SymbolType]} {
		set ObjArr($CanObjID,Type) $SymbolType
	} else {
		error "unkown Symbol Type"
	}

	if {[::olSDL_Views::is_ReferencingSymbol $SymbolType]} {
		set ObjArr($CanObjID,RefDia_Model_ID) $ReferencedDiagram_Model_ID
	}

	set ObjArr($CanObjID,Model_ID) $Model_ID
	set ObjArr($CanObjID,PaS) $PaS
	set ObjArr($CanObjID,Text) $Text

	lappend CanInfo(allObj) $CanObjID
}
########################################################################################################
proc ::olSDL_Views::set_PageScrollregion {CanvasPathName PageWidth PageHeight} {

	$CanvasPathName configure -scrollregion [list 0 0 $PageWidth $PageHeight]
}
#############################################################################
proc ::olSDL_Views::Obj_covered {CanvasPathName RecAreaCoords ObjID TagOfObjs_to_check} {

	set RecArea_x1 [lindex $RecAreaCoords 0]
	set RecArea_y1 [lindex $RecAreaCoords 1]
	set RecArea_x2 [lindex $RecAreaCoords 2]
	set RecArea_y2 [lindex $RecAreaCoords 3]

	set coveredObj [$CanvasPathName find overlapping $RecArea_x1 $RecArea_y1 $RecArea_x2 $RecArea_y2]

	set coveredRecObj { }

	foreach element $coveredObj {
		set AllTags [$CanvasPathName gettags $element]

		if { [lsearch -exact $AllTags $TagOfObjs_to_check] != -1 } {
			if {$ObjID != $element} {
				lappend coveredRecObj $element
			}
		}
	}


	if { [llength $coveredRecObj] > 0 } {
		return true
	} else {
		return false
	}
}
#############################################################################
proc ::olSDL_Views::admissibleRecObjSize {ResizeFrameCoords} {

	set ResizeFrame_x1 [lindex $ResizeFrameCoords 0]
	set ResizeFrame_y1 [lindex $ResizeFrameCoords 1]
	set ResizeFrame_x2 [lindex $ResizeFrameCoords 2]
	set ResizeFrame_y2 [lindex $ResizeFrameCoords 3]

	set ResizeFrameWidth [expr $ResizeFrame_x2 - $ResizeFrame_x1]
	set ResizeFrameHeight [expr $ResizeFrame_y2 - $ResizeFrame_y1]

	if [expr ( (6 * $::olSDL_ViewsDrawMethods::ResizePointsSize) + 2) <= $ResizeFrameWidth  ] {
		if [expr ( (6 * $::olSDL_ViewsDrawMethods::ResizePointsSize) + 2) <= $ResizeFrameHeight ] {
			return true
		} else {
			return false
		}
	} else {
		return false
	}
}
##############################################################################
proc ::olSDL_Views::is_StateMaSym {SymbolType} {

	if {[lsearch $::olSDL_Views::StateMaSym::StateSym $SymbolType] != -1} {
		return true
	} else {
		return false
	}
}
##############################################################################
proc ::olSDL_Views::is_RecSym {SymbolType} {

	if {[lsearch $::olSDL_Views::RecSym::RecSym $SymbolType] != -1} {
		return true
	} else {
		return false
	}
}
##############################################################################
proc ::olSDL_Views::is_Channel {ObjectType} {
	if { ( [string compare $ObjectType "Channel"] != 0 ) } {
		return false
	} else {
		return true
	}
}
##############################################################################
proc ::olSDL_Views::is_DecisionFlowLine {ObjectType} {

	if { ( [string compare $ObjectType "DecisionFlowLine"] != 0 ) } {
		return false
	} else {
		return true
	}
}
##############################################################################
proc ::olSDL_Views::is_FlowLine {ObjectType} {
	if { ( [string compare $ObjectType "FlowLine"] != 0 ) } {
		return false
	} else {
		return true
	}
}
##############################################################################
proc ::olSDL_Views::is_ChanComp {ObjectType} {
	if { ( [string compare $ObjectType "ChanComp"] != 0 ) } {
		return false
	} else {
		return true
	}
}
##############################################################################
proc ::olSDL_Views::is_DecFlowLineComp {ObjectType} {
	if { ( [string compare $ObjectType "DecisionFlowLineComp"] != 0 ) } {
		return false
	} else {
		return true
	}
}
##############################################################################
proc ::olSDL_Views::_get_Canvas_ID_from_Model_ID {ObjArrName Model_ID}  {
	upvar #0 $ObjArrName ObjArr

	foreach element [array names ObjArr] {
		if { [regexp ",Model_ID" $element] == 1 } {
			if { ($ObjArr($element) == $Model_ID) } {
				set tempIndex [string first , $element]
				if { $tempIndex == -1 } {
					error	"index not found"
					return
				}
				return [string range $element 0 [expr $tempIndex -1]]
			}
		}
	}

	error	"canvas ID not found"
}
##############################################################################
proc ::olSDL_Views::is_ReferencingSymbol {SymbolType} {

	switch -exact $SymbolType {
		TextSym {
			return false
		}
		BlkInstRefSym {
			return true
		}
		BlkTypeRefSym {
			return false
		}
		ProInstRefSym {
			return true
		}
		ProTypeRefSym {
			return false
		}
		ProcedureInstRefSym {
			return true
		}
		default {
			error "unkown Symbol Type"
		}
	}
	# switch
}
##############################################################################
proc ::olSDL_Views::ViewsManager::All_Diagram_up {ObjArrName CanInfoArr } {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	upvar #0 ::olSDL_MAR::arr_MAR MAR

	##############
	# get ParentDiagramID

	set ParentDiagramID [get_ReferencingDiagramID_from_Model $CanInfo(Dia_Model_ID)]

	# END: get ParentDiagramID
	##############

	##############
	# get FirstPageID

	get_FirstPageID_from_Model $ParentDiagramID

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set FirstPageID $MAR(FirstPageID)

	# END: get FirstPageID
	##############

	##############
	# get Parent Diagram Type

	get_PageFrameInfo_from_Model $ParentDiagramID $FirstPageID

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set ParentDiagramType $MAR(HP_DiaType)

	# get Parent Diagram Type
	##############

	::olSDL_Views::ViewsManager::DeleteOldViewAndChangeToNewView $CanInfo(ViewID) $ParentDiagramType $ParentDiagramID $FirstPageID

	###################
	#update SDL-Tree

	::olSDL_ViewsTree::ShowCurrentDiagram $ParentDiagramID

	#update SDL-Tree
	###################

	# indicator
	::olSDL_MainMenu::update_Indicator

}
##############################################################################
proc ::olSDL_Views::ViewsManager::DeleteOldViewAndChangeToNewView {OldViewID DiagramType DiagramID PageID} {

	::olSDL_Views::ViewsManager::delete_View $OldViewID

	switch -exact $DiagramType {
		system -
		SysDia {
			::olSDL_Views::ViewsManager::createView SysDia $DiagramID $PageID
		}
		block -
		BlkInstRefSym -
		BlkDia {
			::olSDL_Views::ViewsManager::createView BlkDia $DiagramID $PageID
		}
		process -
		ProInstRefSym -
		ProDia {
			::olSDL_Views::ViewsManager::createView ProDia $DiagramID $PageID
		}
		procedure -
		ProcedureInstRefSym -
		ProcedureDia {
			::olSDL_Views::ViewsManager::createView ProcedureDia $DiagramID $PageID
		}
		default {
			error "unkown Diagram Type"
		}
	}
	# switch -exact $DiagramType
}
##############################################################################
proc ::olSDL_Views::ViewsManager::createView {ViewType Dia_Model_ID Page_ID} {

	upvar #0 ::olSDL_Views::arr_Views Views

	set NewViewID 1

	#########
	# create array name for canvas objects ...

	set TempArrName ::olSDL_Views::${::olSDL_Views::NameOfObjArr}${NewViewID}
	if [array exists $TempArrName] {
		error "Views: object array exists"
	}

	# END : create array name for canvas objects ...
	#########

	#########
	# create array for canvas (view) informations ....

	set TempCanInfoArr ::olSDL_Views::${::olSDL_Views::NameOfCanInfoArr}${NewViewID}
	if [array exists $TempCanInfoArr] {
		error "Views: Canvas Info array exists"
	}

	# END : create array for canvas (view) informations ....
	#########

	# create canvas ...
	set SDLViewCanvas \
		[canvas ${::olSDL_AppVar::SDLViewScrolledWindow}.viewCanvas -scrollregion {0 0 800 800} -bg $::olSDL_Views::CanvasBgColor]

	$::olSDL_AppVar::SDLViewScrolledWindow setwidget $SDLViewCanvas

	# create Toolbar ButtonBox
	set ::olSDL_AppVar::ButBoxPathName \
		[ButtonBox ${::olSDL_AppVar::SDLViewToolbarFrame}.bbox1 -spacing 1 -orient vertical -padx 1 -pady 1]

	switch -exact $ViewType {
		SysDia {
			::olSDL_SysDiaView::create $NewViewID $TempArrName $TempCanInfoArr \
				$SDLViewCanvas $Dia_Model_ID $Page_ID $::olSDL_AppVar::ButBoxPathName
		}
		BlkDia {
			::olSDL_BlkDiaView::create $NewViewID $TempArrName $TempCanInfoArr \
				$SDLViewCanvas $Dia_Model_ID $Page_ID $::olSDL_AppVar::ButBoxPathName
		}
		ProDia {
			::olSDL_ProDiaView::create $NewViewID $TempArrName $TempCanInfoArr \
				$SDLViewCanvas $Dia_Model_ID $Page_ID $::olSDL_AppVar::ButBoxPathName
		}
		ProcedureDia {
			::olSDL_ProcedureDiaView::create $NewViewID $TempArrName $TempCanInfoArr \
				$SDLViewCanvas $Dia_Model_ID $Page_ID $::olSDL_AppVar::ButBoxPathName
		}
		default {
			error "unkown View Type"
		}
	}

	set Views($NewViewID,NameOfObjArr) $TempArrName
	set Views($NewViewID,NameOfCanInfoArr) $TempCanInfoArr
	set Views($NewViewID,Dia_Model_ID) $Dia_Model_ID
	set Views($NewViewID,Page_ID) $Page_ID
	set Views($NewViewID,CanvasPathName) $SDLViewCanvas
	set Views($NewViewID,ButBoxPathName) $::olSDL_AppVar::ButBoxPathName

	set Views(Current) $NewViewID
}
##############################################################################
proc ::olSDL_Views::ViewsManager::delete_View {View_ID} {

	upvar #0 ::olSDL_Views::arr_Views Views

	set CanvasPathName $Views($View_ID,CanvasPathName)
	set ButBoxPathName $Views($View_ID,ButBoxPathName)

	destroy $CanvasPathName
	destroy $ButBoxPathName

	upvar #0 $Views($View_ID,NameOfCanInfoArr) CanInfo
	upvar #0 $Views($View_ID,NameOfObjArr) ObjArr

	unset CanInfo
	unset ObjArr

	# delete from Views
	foreach element [array names Views] {
		if { [string first "$View_ID," $element ] != -1} {
			unset Views($element)
		}
	}
}
##############################################################################
proc ::olSDL_Views::AllViews::delete_SelectedObjects {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	switch -exact $CanInfo(DiaType) {
		SysDia {
			::olSDL_SysDiaView::delete_Object $ObjArrName $CanInfoArr
		}
		BlkDia {
			olSDL_BlkDiaView::delete_Object $ObjArrName $CanInfoArr
		}
		ProDia {
			olSDL_ProDiaView::delete_Object $ObjArrName $CanInfoArr
		}
		ProcedureDia {
			olSDL_ProcedureDiaView::delete_Object $ObjArrName $CanInfoArr
		}
		default {
			error "unknown View Type"
		}
	}
	# switch -exact ViewType

}
##############################################################################
proc ::olSDL_Views::AllViews::unpost_CM {ObjArrName CanInfoArr} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	switch -exact $CanInfo(DiaType) {
		SysDia {
			# menu for channels
			$CanInfo(menu_ChannelPopUp) unpost

			# menu for ChanComp
			$CanInfo(menu_ChanCompPopUp) unpost

			# menu for channel MPs
			$CanInfo(menu_ChannelMP_PopUp) unpost

			# menu for RecSym
			$CanInfo(menu_RecSymPopUp) unpost

			# menu for DiagramHeader
			$CanInfo(menu_DiagramHeader_PopUp) unpost
		}
		BlkDia {
			# menu for channels
			$CanInfo(menu_ChannelPopUp) unpost

			# menu for RecSym
			$CanInfo(menu_RecSymPopUp) unpost

			# menu for ChanComp
			$CanInfo(menu_ChanCompPopUp) unpost

			# menu for channel MPs
			$CanInfo(menu_ChannelMP_PopUp) unpost
		}
		ProDia {
			# menu for channels
			$CanInfo(menu_ChannelPopUp) unpost

			# menu for RecSym
			$CanInfo(menu_RecSymPopUp) unpost

			# menu for ChanComp
			$CanInfo(menu_ChanCompPopUp) unpost

			# menu for channel MPs
			$CanInfo(menu_ChannelMP_PopUp) unpost

			# menu for StateMaSym
			$CanInfo(menu_StateMaSymPopUp) unpost

			# menu for DecFlowLineComp
			$CanInfo(menu_DecFlowLineComp) unpost

			# menu for DecFlowLine
			$CanInfo(menu_DecFlowLinePopUp) unpost
		}
		ProcedureDia {
			# menu for RecSym
			$CanInfo(menu_RecSymPopUp) unpost

			# menu for StateMaSym
			$CanInfo(menu_StateMaSymPopUp) unpost

			# menu for DecFlowLineComp
			$CanInfo(menu_DecFlowLineComp) unpost

			# menu for DecFlowLine
			$CanInfo(menu_DecFlowLinePopUp) unpost

			# menu for FormalParameters
			$CanInfo(menu_FormalParameters_PopUp) unpost
		}
		default {
			error "unknown View Type"
		}
	}
	# switch -exact ViewType

}
##############################################################################
proc ::olSDL_Views::AllViews::set_SingleObjSelected {ObjArrName CanInfoArr ObjCanID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	# set previous selected object unselected
	::olSDL_Views::AllViews::delete_all_Selections $ObjArrName $CanInfoArr

	#draw resize points

	switch -exact $ObjArr($ObjCanID,Type) {
		TextSym {
			::olSDL_ViewsDrawMethods::draw_RecSym_ResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		BlkInstRefSym {
			::olSDL_ViewsDrawMethods::draw_RecSym_ResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		BlkTypeRefSym {
			::olSDL_ViewsDrawMethods::draw_RecSym_ResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		ProInstRefSym {
			::olSDL_ViewsDrawMethods::draw_RecSym_ResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		ProTypeRefSym {
			::olSDL_ViewsDrawMethods::draw_RecSym_ResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		ProcedureInstRefSym {
			::olSDL_ViewsDrawMethods::draw_RecSym_ResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		StateMaStartStateSym {
			::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		StateMaStateSym {
			::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		StateMaInputSym {
			::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		StateMaOutputSym {
			::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		StateMaTaskSym {
			::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		StateMaStopSym {
			::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		StateMaConditionSym {
			::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		StateMaDecisionSym {
			::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		StateMaCreateProSym {
			::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		StateMaCallProcedureSym {
			::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		StateMaProcedureStartStateSym {
			::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		StateMaProcedureReturnSym {
			::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		FlowLine {
			::olSDL_ViewsDrawMethods::draw_FlowLine_MovePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		DecisionFlowLine {
			::olSDL_ViewsDrawMethods::draw_DecisionFlowLine_MovePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		DecisionFlowLineComp {
			::olSDL_ViewsDrawMethods::draw_DecisionFlowLineComp_ResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		Channel {
			::olSDL_ViewsDrawMethods::draw_Channel_MovePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		ChanComp {
			::olSDL_ViewsDrawMethods::draw_RecChanComp_ResizePoints $ObjArrName $CanInfoArr $ObjCanID
		}
		default {
			error "unknown Object Type"
		}
	}
	# switch -exact


	# set new canvas state
	::olSDL_Views::AllViews::set_canvas_state $ObjArrName $CanInfoArr single_obj_selected dummy

	lappend CanInfo(selObj) $ObjCanID

}
##############################################################################
proc ::olSDL_Views::AllViews::delete_all_Selections {ObjArrName CanInfoArr} {

	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	foreach selectedObj $CanInfo(selObj) {

		set ObjType $ObjArr($selectedObj,Type)

		if [::olSDL_Views::is_StateMaSym $ObjType] {
			::olSDL_ViewsDrawMethods::delete_StateMaSym_RP_from_Canvas $ObjArrName $CanInfoArr $selectedObj
		} elseif [::olSDL_Views::is_RecSym $ObjType] {
			::olSDL_ViewsDrawMethods::delete_RecSym_RP_from_Canvas $ObjArrName $CanInfoArr $selectedObj
		} elseif [::olSDL_Views::is_Channel $ObjType] {
			::olSDL_ViewsDrawMethods::delete_Channel_MP_from_Canvas $ObjArrName $CanInfoArr $selectedObj
		} elseif [::olSDL_Views::is_ChanComp $ObjType] {
			olSDL_ViewsDrawMethods::delete_ChanComp_RP_from_Canvas $ObjArrName $CanInfoArr $selectedObj
		} elseif [::olSDL_Views::is_FlowLine $ObjType] {
			::olSDL_ViewsDrawMethods::delete_FlowLine_MP_from_Canvas $ObjArrName $CanInfoArr $selectedObj
		} elseif [::olSDL_Views::is_DecisionFlowLine $ObjType] {
			::olSDL_ViewsDrawMethods::delete_DecisionFlowLine_MP_from_Canvas $ObjArrName $CanInfoArr $selectedObj
		} elseif [::olSDL_Views::is_DecFlowLineComp $ObjType] {
			::olSDL_ViewsDrawMethods::delete_DecisionFlowLineComp_ResizePoints $ObjArrName $CanInfoArr $selectedObj
		} elseif {$ObjType == "HP_PageName"} {
			::olSDL_ViewsDrawMethods::delete_SysDiaName_ResizePoints_from_Canvas $ObjArrName $CanInfoArr $selectedObj
		} elseif {$ObjType == "HP_FormalParameters"} {
			::olSDL_ViewsDrawMethods::delete_ProcedureFormalParameters_ResizePoints_from_Canvas $ObjArrName $CanInfoArr $selectedObj
		} else {
			error "unknown Object Type"
		}

		set del_index [lsearch $CanInfo(selObj) $selectedObj]
		set CanInfo(selObj) [lreplace $CanInfo(selObj) $del_index $del_index]
	}
	# foreach selectedObj $CanInfo(selObj)

	set DiaType {SysDia BlkDia ProDia ProcedureDia}
	if {[lsearch $DiaType $CanInfo(DiaType)] > -1} {
		::olSDL_${CanInfo(DiaType)}View::delete_all_Selections $ObjArrName $CanInfoArr
	} else {
		error "unknown View Type"
	}
}
##############################################################################
proc ::olSDL_Views::AllViews::set_canvas_state {ObjArrName CanInfoArr State ObjType} {
	upvar #0 $CanInfoArr CanInfo

	# unpost CM
	::olSDL_Views::AllViews::unpost_CM $ObjArrName $CanInfoArr

	set DiaType {SysDia BlkDia ProDia ProcedureDia}
	if {[lsearch $DiaType $CanInfo(DiaType)] > -1} {
		::olSDL_${CanInfo(DiaType)}View::set_canvas_state $ObjArrName $CanInfoArr $State $ObjType
	} else {
		error "unknown View Type"
	}
}
########################################################################################################
proc ::olSDL_Views::AllViews::create_PopUpMenus {ObjArrName CanInfoArr} {
	upvar #0 $ObjArrName ObjArr
	upvar #0 $CanInfoArr CanInfo

	set CanvasPathName $CanInfo(CanvasPathName)

	##########################
	# menu for channels

	set CanInfo(menu_ChannelPopUp) [menu ${CanvasPathName}.canPopUpM1 -tearoff 0]

	$CanInfo(menu_ChannelPopUp) add cascade -label "Direction Type" -menu $CanInfo(menu_ChannelPopUp).m_subDirec

	set m_subDirec [menu $CanInfo(menu_ChannelPopUp).m_subDirec -tearoff 0]

	set callback "::olSDL_Views::Channel::OnChangeChannelDirectionType $ObjArrName $CanInfoArr bi"
	$m_subDirec add radio -label "Bidirectional" -variable ${CanInfoArr}(changeCT_DirectionTypeHelper) -value "bi"  -command "$callback"
	set callback "::olSDL_Views::Channel::OnChangeChannelDirectionType $ObjArrName $CanInfoArr uni"
	$m_subDirec add radio -label "Unidirectional" -variable ${CanInfoArr}(changeCT_DirectionTypeHelper) -value "uni" -command "$callback"


	set callback "::olSDL_Views::Channel::toogleDirection $ObjArrName $CanInfoArr"
	$CanInfo(menu_ChannelPopUp) add command -label "Change Direction" -command "$callback"

	$CanInfo(menu_ChannelPopUp) add separator

	$CanInfo(menu_ChannelPopUp) add cascade -label "Delay Type" -menu $CanInfo(menu_ChannelPopUp).m_subDelay


	set m_subDelay [menu $CanInfo(menu_ChannelPopUp).m_subDelay -tearoff 0]

	set callback "::olSDL_Views::Channel::OnChangeChannelType $ObjArrName $CanInfoArr"
	$m_subDelay add radio -label "Delay" -variable ${CanInfoArr}(changeCT_DelayType) -value "delay" \
		-command "$callback"
	$m_subDelay add radio -label "No-Delay" -variable ${CanInfoArr}(changeCT_DelayType) -value "no_delay" \
		-command "$callback"


	$CanInfo(menu_ChannelPopUp) add separator

	set callback "::olSDL_Views::Channel::OnChangeChanCompHighLight $ObjArrName $CanInfoArr ChanName"
	$CanInfo(menu_ChannelPopUp) add check -label "HL on" -variable ${CanInfoArr}(PU_Chan_hl_ChanName) -command "$callback"

	set callback "::olSDL_Views::Channel::OnChangeChanCompHighLight $ObjArrName $CanInfoArr SourceSig"
	$CanInfo(menu_ChannelPopUp) add check -label "Source Sig on" -variable ${CanInfoArr}(PU_Chan_hl_SourceSig) -command "$callback"

	set callback "::olSDL_Views::Channel::OnChangeChanCompHighLight $ObjArrName $CanInfoArr SourceCon"
	$CanInfo(menu_ChannelPopUp) add check -label "Source Con on" -variable ${CanInfoArr}(PU_Chan_hl_SourceCon) -command "$callback"

	set callback "::olSDL_Views::Channel::OnChangeChanCompHighLight $ObjArrName $CanInfoArr DestSig"
	$CanInfo(menu_ChannelPopUp) add check -label "Dest Sig on" -variable ${CanInfoArr}(PU_Chan_hl_DestSig) -command "$callback"

	set callback "::olSDL_Views::Channel::OnChangeChanCompHighLight $ObjArrName $CanInfoArr DestCon"
	$CanInfo(menu_ChannelPopUp) add check -label "Dest Con on" -variable ${CanInfoArr}(PU_Chan_hl_DestCon) -command "$callback"


	$CanInfo(menu_ChannelPopUp) add separator

	set callback "::olSDL_Views::Channel::ResetAllChanCompHighLight $ObjArrName $CanInfoArr"
	$CanInfo(menu_ChannelPopUp) add command -label "Reset HL" -command "$callback"


	$CanInfo(menu_ChannelPopUp) add separator

	set callback "::olSDL_Views::Channel::AddInnerChanMP $ObjArrName $CanInfoArr"
	$CanInfo(menu_ChannelPopUp) add command -label "Add Point" -command "$callback"

	$CanInfo(menu_ChannelPopUp) add separator

	set callback "::olSDL_Views::AllViews::delete_SelectedObjects $ObjArrName $CanInfoArr"
	$CanInfo(menu_ChannelPopUp) add command -label "Delete" -command "$callback"

	# END: menu for channels
	##########################

	##########################
	# menu for RecSym

	set CanInfo(menu_RecSymPopUp) [menu ${CanvasPathName}.canPopUpM2 -tearoff 0]

	set callback "::olSDL_Views::RecSym::EditContent $ObjArrName $CanInfoArr"
	$CanInfo(menu_RecSymPopUp) add command -label "Edit" -command "$callback"

	set callback "::olSDL_Views::RecSym::ZoomIn $ObjArrName $CanInfoArr"
	$CanInfo(menu_RecSymPopUp) add command -label "Goto Diagram" -command "$callback"

	$CanInfo(menu_RecSymPopUp) add separator

	set callback "::olSDL_Views::AllViews::delete_SelectedObjects $ObjArrName $CanInfoArr"
	$CanInfo(menu_RecSymPopUp) add command -label "Delete" -command "$callback"

	# END: menu for RecSym
	##########################

	##########################
	# menu for ChanComp

	set CanInfo(menu_ChanCompPopUp) [menu ${CanvasPathName}.canPopUpM3 -tearoff 0]

	set callback "::olSDL_Views::Channel::EditChanCompContent $ObjArrName $CanInfoArr"
	$CanInfo(menu_ChanCompPopUp) add command -label "Edit" -command "$callback"

	# END: menu for ChanComp
	##########################

	##########################
	# menu for channel MPs
	set CanInfo(menu_ChannelMP_PopUp) [menu ${CanvasPathName}.canPopUpM4 -tearoff 0]

	set callback "::olSDL_Views::Channel::DeleteInnerChanMP $ObjArrName $CanInfoArr"
	$CanInfo(menu_ChannelMP_PopUp) add command -label "Delete" -command "$callback"

	# END: menu for channel MPs
	##########################

	##########################
	# menu for DiagramHeader

	set CanInfo(menu_DiagramHeader_PopUp) [menu ${CanvasPathName}.canPopUpM5 -tearoff 0]

	set callback "::olSDL_SysDiaView::EditDiagramHeader $ObjArrName $CanInfoArr"
	$CanInfo(menu_DiagramHeader_PopUp) add command -label "Edit" -command "$callback"

	# menu for DiagramHeader
	##########################

	##########################
	# menu for StateMaSym

	set CanInfo(menu_StateMaSymPopUp) [menu ${CanvasPathName}.canPopUpM6 -tearoff 0]

	set callback "::olSDL_Views::StateMaSym::EditContent $ObjArrName $CanInfoArr"
	$CanInfo(menu_StateMaSymPopUp) add command -label "Edit" -command "$callback"

	$CanInfo(menu_StateMaSymPopUp) add separator

	set callback "::olSDL_Views::AllViews::delete_SelectedObjects $ObjArrName $CanInfoArr"
	$CanInfo(menu_StateMaSymPopUp) add command -label "Delete" -command "$callback"

	# END: menu for StateMaSym
	##########################

	##########################
	# menu for DecFlowLineComp

	set CanInfo(menu_DecFlowLineComp) [menu ${CanvasPathName}.canPopUpM7 -tearoff 0]

	set callback "::olSDL_Views::FlowLine::EditDecFlowLineCompContent $ObjArrName $CanInfoArr"
	$CanInfo(menu_DecFlowLineComp) add command -label "Edit" -command "$callback"

	# END: menu for DecFlowLineComp
	##########################

	##########################
	# menu for DecFlowLine

	set CanInfo(menu_DecFlowLinePopUp) [menu ${CanvasPathName}.canPopUpM8 -tearoff 0]

	set callback "::olSDL_Views::FlowLine::OnChangeDecFlowLineCompHighLight $ObjArrName $CanInfoArr"

	$CanInfo(menu_DecFlowLinePopUp) add check -label "HL on" -variable ${CanInfoArr}(PU_hl_DecFlowLineComp) -command "$callback"

	$CanInfo(menu_DecFlowLinePopUp) add separator

	set callback "::olSDL_Views::AllViews::delete_SelectedObjects $ObjArrName $CanInfoArr"
	$CanInfo(menu_DecFlowLinePopUp) add command -label "Delete" -command "$callback"

	# END: menu for DecFlowLine
	##########################

	##########################
	# menu for FormalParameters

	set CanInfo(menu_FormalParameters_PopUp) [menu ${CanvasPathName}.canPopUpM9 -tearoff 0]

	set callback "::olSDL_ProcedureDiaView::EditFormalParameters $ObjArrName $CanInfoArr"
	$CanInfo(menu_FormalParameters_PopUp) add command -label "Edit" -command "$callback"

	# menu for FormalParameters
	##########################
}

##############################################################################
proc ::olSDL_Views::get_and_draw_StateMaSyms {SymbolType ObjArrName CanInfoArr CanvasPathName Dia_Model_ID PageID}  {

	upvar #0 ::olSDL_MAR::arr_MAR MAR
	upvar #0 $CanInfoArr CanInfo

	set StateSymIndex [lsearch $::olSDL_Views::StateMaSym::StateSym $SymbolType]

	if {$StateSymIndex > -1} {
		set StateSym [lindex $::olSDL_Views::StateMaSym::StateSym $StateSymIndex] 
	} else {
		error "unknown state machine symbol"
	}
	get_StateMachineSyms_from_Model $StateSym $Dia_Model_ID $PageID

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}


	foreach Symbol $MAR(IDs) {

		set PaS $MAR(${Symbol},PaS)
		set Text [::olSDL_Views::MAR_StringToString $MAR(${Symbol},Text)]

		if {$StateSymIndex > -1} {
			set CanObjID [::olSDL_ViewsDrawMethods::draw_$StateSym $CanvasPathName $PaS $Text none false]
		} else {
			error "unknown state machine symbol"
		}

		##############
		# store symbol

		store_StateMaSym_in_Tcl $ObjArrName $CanInfoArr $SymbolType $CanObjID $Symbol $PaS $Text

		# store symbol
		##############
	}
	# foreach Symbol $MAR(IDs)
}
##############################################################################
proc ::olSDL_Views::MAR_StringToString {MAR_String}  {

	regsub -all {a\\\}} $MAR_String "\}" Result

	regsub -all {a\\\{} $Result "\{" Result

	return $Result
}
##############################################################################
proc ::olSDL_Views::AllViews::setup_stacking_order {CanvasPathName}  {

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_EnvironmentRectangle
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_BackgroundRectangle

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_PageFrame
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_PageFrameHeader
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_PageFrameHeader_RP_Bottom

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_FormalParameters
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_FormalParameters_RP_Bottom

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_StateMaSym_Bottom
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_StateMaSymRP_Bottom

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_RecSym_Bottom
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_RecSym_RP_Bottom

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_Channel_Bottom
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_Channel_MP_Bottom

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_FlowLine_Bottom
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_FlowLine_MP_Bottom

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_DecisionFlowLine_Bottom
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_DecisionFlowLine_MP_Bottom

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_ChannelName_Bottom
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_ChannelName_RP_Bottom

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_ChannelSig_Bottom
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_ChannelSig_RP_Bottom

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_ChannelConnect_Bottom
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_ChannelConnect_RP_Bottom

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_DecFlowLine_CompDec_Bottom
	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_DecFlowLine_CompDec_RP_Bottom

	$CanvasPathName create rectangle 0 0 1 1 -width 0 -tag stack_TopOfAll
}
##############################################################################
proc ::olSDL_Views::AllViews::get_StackOrderSuccessor { StackOrderTag }  {

	switch -exact $StackOrderTag {
		stack_EnvironmentRectangle {
			return stack_BackgroundRectangle
		}
		stack_BackgroundRectangle {
			return stack_PageFrame
		}
		stack_PageFrame {
			return stack_PageFrameHeader
		}
		stack_PageFrameHeader {
			return stack_PageFrameHeader_RP_Bottom
		}
		stack_PageFrameHeader_RP_Bottom {
			return stack_FormalParameters
		}
		stack_FormalParameters {
			return stack_FormalParameters_RP_Bottom
		}
		stack_FormalParameters_RP_Bottom {
			return stack_StateMaSym_Bottom
		}
		stack_StateMaSym_Bottom {
			return stack_StateMaSymRP_Bottom
		}
		stack_StateMaSymRP_Bottom {
			return stack_RecSym_Bottom
		}
		stack_RecSym_Bottom {
			return stack_RecSym_RP_Bottom
		}
		stack_RecSym_RP_Bottom {
			return stack_Channel_Bottom
		}
		stack_Channel_Bottom {
			return stack_Channel_MP_Bottom
		}
		stack_Channel_MP_Bottom {
			return stack_FlowLine_Bottom
		}
		stack_FlowLine_Bottom {
			return stack_FlowLine_MP_Bottom
		}
		stack_FlowLine_MP_Bottom {
			return stack_DecisionFlowLine_Bottom
		}
		stack_DecisionFlowLine_Bottom {
			return stack_DecisionFlowLine_MP_Bottom
		}
		stack_DecisionFlowLine_MP_Bottom {
			return stack_ChannelName_Bottom
		}
		stack_ChannelName_Bottom {
			return stack_ChannelName_RP_Bottom
		}
		stack_ChannelName_RP_Bottom {
			return stack_ChannelSig_Bottom
		}
		stack_ChannelSig_Bottom {
			return stack_ChannelSig_RP_Bottom
		}
		stack_ChannelSig_RP_Bottom {
			return stack_ChannelConnect_Bottom
		}
		stack_ChannelConnect_Bottom {
			return stack_ChannelConnect_RP_Bottom
		}
		stack_ChannelConnect_RP_Bottom {
			return stack_DecFlowLine_CompDec_Bottom
		}
		stack_DecFlowLine_CompDec_Bottom {
			return stack_DecFlowLine_CompDec_RP_Bottom
		}
		stack_DecFlowLine_CompDec_RP_Bottom {
			return stack_TopOfAll
		}
		default {
			error "unkown stack order tag"
		}
	}
	# switch

	error "unkown stack order tag"
}
##############################################################################


