
package provide olSDL_ViewsCalcCoor 1

namespace eval olSDL_ViewsCalcCoor {

}

####################################################
proc ::olSDL_ViewsCalcCoor::calc_PaS_from_Coords {Coords} {
	set Width [expr [lindex $Coords 2] - [lindex $Coords 0] ]
	set Height [expr [lindex $Coords 3] - [lindex $Coords 1] ]

	return [concat [lrange $Coords 0 1] $Width $Height]
}
####################################################
proc ::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS {PaS out_x1 out_y1 out_x2 out_y2} {
	upvar $out_x1 x1
	upvar $out_y1 y1

	upvar $out_x2 x2
	upvar $out_y2 y2

	set x1 [lindex $PaS 0]
	set y1 [lindex $PaS 1]
	set x2 [expr $x1 + [lindex $PaS 2]]
	set y2 [expr $y1 + [lindex $PaS 3]]
}
####################################################
proc ::olSDL_ViewsCalcCoor::get_RecCoordsAsList_fromPaS {PaS} {

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	return [list $x1 $y1 $x2 $y2]
}
####################################################
proc ::olSDL_ViewsCalcCoor::calc_TextSymPolygon {x1 y1 width height x_indent y_indent} {
	set next_y [expr $y1 + $height]
	set Polygon [list $x1 $y1 $x1 $next_y]

	set next_x [expr $x1 + $width]
	lappend Polygon $next_x $next_y

	set next_y [expr $next_y - $height + $y_indent]
	lappend Polygon $next_x $next_y

	set next_y [expr $next_y - $y_indent]
	set next_x [expr $next_x - $x_indent]
	lappend Polygon $next_x $next_y $x1 $y1

	return $Polygon
}
####################################################
proc ::olSDL_ViewsCalcCoor::calc_ProcSymPolygon {x1 y1 width height x_indent y_indent} {
	set x2 [expr $x1 + $width]
	set y2 [expr $y1 + $height]

	set next_x $x1
	set next_y [expr $y1 + $y_indent]
	lappend Polygon $next_x $next_y

	set next_y [expr $y2 - $y_indent]
	lappend Polygon $next_x $next_y

	set next_x [expr $x1 + $x_indent]
	set next_y $y2
	lappend Polygon $next_x $next_y

	set next_x [expr $x2 - $x_indent]
	set next_y $y2
	lappend Polygon $next_x $next_y

	set next_x $x2
	set next_y [expr $y2 - $y_indent]
	lappend Polygon $next_x $next_y

	set next_x $x2
	set next_y [expr $y1 + $y_indent]
	lappend Polygon $next_x $next_y

	set next_x [expr $x2 - $x_indent]
	set next_y $y1
	lappend Polygon $next_x $next_y

	set next_x [expr $x1 + $x_indent]
	lappend Polygon $next_x $next_y $x1 [expr $y1 + $y_indent ]

	return $Polygon
}
####################################################
proc ::olSDL_ViewsCalcCoor::calc_LineFromPaS {PaSList} {
	set next_x [lindex $PaSList 0]
	set next_y [lindex $PaSList 1]
	set width [lindex $PaSList 2]
	set height [lindex $PaSList 3]

	set Line [list $next_x $next_y]

	set next_y [expr $next_y + $height]
	lappend Line $next_x $next_y

	set next_x [expr $next_x + $width]
	lappend Line $next_x $next_y

	set next_y [expr $next_y - $height]
	lappend Line $next_x $next_y

	set next_x [expr $next_x - $width]
	lappend Line $next_x $next_y

	return $Line
}
####################################################
proc ::olSDL_ViewsCalcCoor::calc_ProcSymInnerPolygon {x1 y1 x2 y2 inner_width inner_height borderwidth x_indent y_indent} {
	set next_x [expr $x1 + $borderwidth]
	set next_y [expr $y1 + $y_indent]
	set Polygon [list $next_x $next_y]

	set next_y [expr $next_y + $inner_height]
	lappend Polygon $next_x $next_y

	set next_x [expr $x1 + $x_indent]
	set next_y [expr $y2 - $borderwidth]
	lappend Polygon $next_x $next_y

	set next_x [expr $next_x + $inner_width]
	lappend Polygon $next_x $next_y

	set next_x [expr $x2 - $borderwidth]
	set next_y [expr $y2 - $y_indent]
	lappend Polygon $next_x $next_y

	set next_y [expr $next_y - $inner_height]
	lappend Polygon $next_x $next_y

	set next_x [expr $x2 - $x_indent]
	set next_y [expr $y1 + $borderwidth]
	lappend Polygon $next_x $next_y

	set next_x [expr $next_x - $inner_width]
	lappend Polygon $next_x $next_y
        lappend Polygon [expr $x1 + $borderwidth] [expr $y1 + $y_indent]

	return $Polygon
}
####################################################
proc ::olSDL_ViewsCalcCoor::calc_PageFrameInnerZoneCoords {PageFramePaS} {
	set InnerZone_x1 [expr [lindex $PageFramePaS 0] + $::olSDL_ViewsDrawMethods::min_Distance_to_PageFrame]
	set InnerZone_y1 [expr [lindex $PageFramePaS 1] + $::olSDL_ViewsDrawMethods::min_Distance_to_PageFrame]
	set InnerZone_x2 [expr [lindex $PageFramePaS 0] + [lindex $PageFramePaS 2] - ($::olSDL_ViewsDrawMethods::min_Distance_to_PageFrame)]
	set InnerZone_y2 [expr [lindex $PageFramePaS 1] + [lindex $PageFramePaS 3]  - ($::olSDL_ViewsDrawMethods::min_Distance_to_PageFrame)]

	return [list $InnerZone_x1 $InnerZone_y1 $InnerZone_x2 $InnerZone_y2]
}
####################################################
proc ::olSDL_ViewsCalcCoor::RecA_contains_RecB {RecA RecB} {

	set RecA_x1 [lindex $RecA 0]
	set RecA_y1 [lindex $RecA 1]
	set RecA_x2 [lindex $RecA 2]
	set RecA_y2 [lindex $RecA 3]

	set RecB_x1 [lindex $RecB 0]
	set RecB_y1 [lindex $RecB 1]
	set RecB_x2 [lindex $RecB 2]
	set RecB_y2 [lindex $RecB 3]

	if {$RecA_x1 > $RecB_x1} {return false}
	if {$RecA_y1 > $RecB_y1} {return false}

	if {$RecA_x2 < $RecB_x2} {return false}
	if {$RecA_y2 < $RecB_y2} {return false}

	return true
}
####################################################
proc ::olSDL_ViewsCalcCoor::Point_in_Rectangle {x y RecCoords} {

	set rec_x_left_up [lindex $RecCoords 0]
	set rec_y_left_up [lindex $RecCoords 1]
	set rec_x_right_down [lindex $RecCoords 2]
	set rec_y_right_down [lindex $RecCoords 3]

	if { ($rec_x_left_up <= $x) && ($x <= $rec_x_right_down) && ($rec_y_left_up <= $y) && ($y <= $rec_y_right_down) } {
		return true
	} else {
		return false
	}
}
####################################################
proc ::olSDL_ViewsCalcCoor::calc_ChannelArrow {Coords out_ArrowCoords} {

	set x1 [lindex $Coords 0]
	set y1 [lindex $Coords 1]
	set x2 [lindex $Coords 2]
	set y2 [lindex $Coords 3]

	set x [expr $x1 - $x2]
	set y [expr $y1 - $y2]

	set ArrowCoords [list [expr int ($x2)] [expr int ($y2)]]

	########################
	# special cases

	if { $x == 0 } {
		if { $y == 0 } {
			error "invalid Channel Part length"
			return
		} else {
			lappend ArrowCoords $x2
			lappend ArrowCoords [expr $y2 + $::olSDL_ViewsDrawMethods::Channel_Percent * $y]
			return
		}
	} else {
		if { $y == 0 } {
			lappend ArrowCoords [expr $x2 + ($::olSDL_ViewsDrawMethods::Channel_Percent * $x)]
			lappend ArrowCoords $y2
			return
		}
	}

	# END: special cases
	########################

	set length [expr hypot ($x,$y)]

	set length_part [expr $::olSDL_ViewsDrawMethods::Channel_Percent * $length]

	set x_part [ expr $x * ($length_part / $length) ]
	set y_part [ expr $y * ($length_part / $length) ]

	lappend ArrowCoords [expr int ($x2 + $x_part)] [expr int ($y2 + $y_part)]
	return $ArrowCoords
}
####################################################
proc ::olSDL_ViewsCalcCoor::calc_ConnectionPointOnRecSym {PaS_RecSym Point_in_RecSym_x Point_in_RecSym_y Point_outside_RecSym_x Point_outside_RecSym_y} {

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS_RecSym Rec_Obj_x_left_up Rec_Obj_y_left_up \
		Rec_Obj_x_right_down Rec_Obj_y_right_down

	if { $Point_outside_RecSym_x < $Rec_Obj_x_left_up } {
		set Con_x $Rec_Obj_x_left_up
		set Con_y $Point_in_RecSym_y
	} elseif { $Point_outside_RecSym_x < $Rec_Obj_x_right_down } {
		set Con_x $Point_in_RecSym_x
		if { $Point_outside_RecSym_y < $Point_in_RecSym_y } {
			set Con_y $Rec_Obj_y_left_up
		} else {
			set Con_y $Rec_Obj_y_right_down
		}
	} else {
		set Con_x $Rec_Obj_x_right_down
		set Con_y $Point_in_RecSym_y
	}

	return [list [expr int($Con_x)] [expr int($Con_y)] ]
}
####################################################
proc ::olSDL_ViewsCalcCoor::calc_ConnPointOnBorderToEnv {PageFramePaS EnvPoint_x EnvPoint_y} {

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PageFramePaS \
		Frame_x_left_up Frame_y_left_up Frame_x_right_down Frame_y_right_down

	if { $EnvPoint_y <= $Frame_y_left_up } {
		# place top

		set Con_y $Frame_y_left_up

		if { $EnvPoint_x < $Frame_x_left_up } {
			set Con_x $Frame_x_left_up
		} elseif { $EnvPoint_x < $Frame_x_right_down } {
			set Con_x $EnvPoint_x
		} else {
			set Con_x $Frame_x_right_down
		}

	} elseif { $EnvPoint_y < $Frame_y_right_down } {
		#place right or left

		set Con_y $EnvPoint_y

		if { $EnvPoint_x <= $Frame_x_left_up } {
			set Con_x $Frame_x_left_up
		} else {
			set Con_x $Frame_x_right_down
		}

	} else {
		# place bottom

		set Con_y $Frame_y_right_down

		if { $EnvPoint_x < $Frame_x_left_up } {
			set Con_x $Frame_x_left_up
		} elseif { $EnvPoint_x < $Frame_x_right_down } {
			set Con_x $EnvPoint_x
		} else {
			set Con_x $Frame_x_right_down
		}
	}

	return [list [expr int($Con_x)] [expr int($Con_y)] ]
}
####################################################
proc ::olSDL_ViewsCalcCoor::calc_CenterOfLineSegment {Coords} {

	if { [llength $Coords] != 4 } {
		error "no line"
		return
	}

	set x_part [expr ([lindex $Coords 2] - [lindex $Coords 0]) / 2 ]
	set y_part [expr ([lindex $Coords 3] - [lindex $Coords 1]) / 2 ]

	return [concat [expr int ([lindex $Coords 0] + $x_part) ]\
		[expr int ([lindex $Coords 1] + $y_part) ]]
}
####################################################
proc ::olSDL_ViewsCalcCoor::calc_left_brace_coords_for_SigSym {PaS} {

	set length 4

	get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	return [list [expr $x1 + $length] $y1 $x1 $y1 $x1 $y2 [expr $x1 + $length] $y2]
}
####################################################
proc ::olSDL_ViewsCalcCoor::calc_right_brace_coords_for_SigSym {PaS} {

	set length 4

	get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	return [list [expr $x2 - $length] $y1 $x2 $y1 $x2 $y2 [expr $x2 - $length] $y2]
}
####################################################
proc ::olSDL_ViewsCalcCoor::LineInRectangle {LineCoords RectangleCoords} {

	foreach {Point_x Point_y} $LineCoords {
		if { ! [::olSDL_ViewsCalcCoor::Point_in_Rectangle $Point_x $Point_y $RectangleCoords] } {
			return false
		}
	}

	return true
}
####################################################
proc ::olSDL_ViewsCalcCoor::calc_TextPaS {PaS Type} {

	set Fontsize 8
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2
	set TextPaSX $x1
	set TextPaSY $y1
	set width [expr $x2 - $x1]
	set height [expr $y2 - $y1]
	set TextPaSWidth $width
	set TextPaSHeight $height
	set Anchor nw

	switch -exact $Type {
		StateMaStateSym -
		StateMaProcedureReturnSym -
		StateMaProcedureStartStateSym -
		StateMaStartStateSym {
		  if {$width > 15} {
		    set TextPaSWidth [expr $width -15]
		  }
		  set TextPaSHeight [expr int ($height *(3.0/5.0))]
		  set TextPaSX [expr $x1 + ($width /2)]
		  set TextPaSY [expr $y1 + ($height /2) + ($Fontsize)]
		  set Anchor center
		}
		StateMaConditionSym -
		StateMaInputSym {
		  set TextPaSX [expr $x1 + int(0.2*$width) +1]
		  set TextPaSY [expr $y1 + 1]
		  set TextPaSWidth [expr $width - int(0.2*$width) -1]
		  set TextPaSHeight [expr $height -2]
		  set Anchor nw
		}
		StateMaOutputSym {
		  set TextPaSX [expr $x1 + 1]
		  set TextPaSY [expr $y1 + 1]
		  set TextPaSWidth [expr 0.8*$width]
		  set TextPaSHeight [expr $height -2]
		  set Anchor nw
		}
		StateMaTaskSym {
		  set TextPaSX [expr $x1 + 1]
		  set TextPaSY [expr $y1 + 1]
		  set TextPaSWidth [expr $width -2]
		  set TextPaSHeight [expr $height -2]
		  set Anchor nw
		}
		StateMaStopSym {
		}
		StateMaDecisionSym {
		  if {$width > 30} {
		    set TextPaSWidth [expr $width -30]
		  }
		  set TextPaSHeight [expr int ($height *(2.0/5.0))]
		  set TextPaSX [expr $x1 + ($width/2)]
		  set TextPaSY [expr $y1 + ($height/2) + $Fontsize]
		  set Anchor center
		}
		StateMaCreateProSym {
		  set TextPaSX [expr $x1 + 1]
		  set TextPaSY [expr $y1 + 4]
		  set TextPaSWidth [expr $width -2]
		  set TextPaSHeight [expr $height -8]
		  set Anchor nw
		}
		StateMaCallProcedureSym {
		  set TextPaSX [expr $x1 + 3]
		  set TextPaSY [expr $y1 + 1]
		  set TextPaSWidth [expr $width -6]
		  set TextPaSHeight [expr $height -2]
		  set Anchor nw
		}
	}
	return [list $TextPaSX $TextPaSY $TextPaSWidth $TextPaSHeight $Anchor]
}
####################################################
proc ::olSDL_ViewsCalcCoor::cut_Text {in_Text PaS} {

	set Text {}

	set CharWidth 6.5
	set CharHeight 7.45

	set Width [lindex $PaS 2]
	set Height [lindex $PaS 3]

	set MaxNrColumns [expr int ($Width / $CharWidth) ]
	set MaxNrRows [expr int ($Height / $CharHeight)-1 ]

	set Rows [split $in_Text '\n']

# set cur_font [font create -family Helvetica]

	for {set j 0} { $j < $MaxNrRows} {incr j} {
		set tempString [lindex $Rows $j]

		while { [string length $tempString] > 0 } {
			set Text "$Text[string range $tempString 0 $MaxNrColumns]\n"
# puts [font measure $cur_font $Text]
			set tempString [string range $tempString [expr $MaxNrColumns+1] end]
			if {$j < $MaxNrRows} {
			  incr MaxNrRows -1
			} else {
			  return $Text
			}
		}
	}
	return $Text
}
####################################################
proc ::olSDL_ViewsCalcCoor::convert_to_IntList {IntList} {

	set ResultList { }

	foreach element $IntList {
		lappend ResultList [expr int($element)]
	}

	return $ResultList
}
####################################################
proc ::olSDL_ViewsCalcCoor::ZoneIndex {PaS x y} {

	get_RecCoords_fromPaS $PaS x_left_up y_left_up x_right_down y_right_down

	if { ($x <= $x_left_up) && ($y <= $y_left_up) } {
		return 1
	} elseif { ($x_left_up < $x ) && ($x <= $x_right_down) && ($y <= $y_left_up) } {
		return 2
	} elseif { ($x_right_down < $x ) && ($y <= $y_left_up) } {
		return 3
	} elseif { ($x <= $x_left_up) && ($y_left_up < $y) && ($y <= $y_right_down) } {
		return 4
	} elseif { ($x_left_up < $x ) && ($x <= $x_right_down) && ($y_left_up < $y) && ($y <= $y_right_down) } {
		return 5
	} elseif { ($x_right_down < $x ) && ($y_left_up < $y) && ($y <= $y_right_down) } {
		return 6
	} elseif { ($x <= $x_left_up) && ($y_right_down < $y) } {
		return 7
	} elseif { ($x_left_up < $x ) && ($x <= $x_right_down) && ($y_right_down < $y) } {
		return 8
	} elseif { ($x_right_down < $x ) && ($y_right_down < $y) } {
		return 9
	} else {
		error "prog error"
	}
}
####################################################

