
package provide olSDL_ViewsDrawMethods 1

########################################################################################################
#### procs for drawing
########################################################################################################

namespace eval olSDL_ViewsDrawMethods {

	variable ResizePointsColor green
	variable PassiveResizePointsColor gray72

	variable ResizePointsSize 3
	variable min_Distance_to_PageFrame 6

	variable min_Channel_Part_Length 20

	variable Channel_Percent 0.8

	variable CursStyle_Selected cross

	variable CursStyle_RP_left_up top_left_corner
	variable CursStyle_RP_left_down bottom_left_corner
	variable CursStyle_RP_right_up top_right_corner
	variable CursStyle_RP_right_down bottom_right_corner

	variable CursStyle_RP_up top_side
	variable CursStyle_RP_down bottom_side
	variable CursStyle_RP_left left_side
	variable CursStyle_RP_right right_side

	variable CursStyle_Normal left_ptr

	variable default_Size_ChannelName {80 20}
	variable default_Size_ChannelSig {80 20}
	variable default_Size_ChannelCon {80 20}

	variable default_Text_ChanName "Chan Name"
	variable default_Text_ChanSourceSig "Source Sig"
	variable default_Text_ChanDestSig "Dest Sig"
	variable default_Text_ChanSourceCon "Source Con"
	variable default_Text_ChanDestCon "Dest Con"

	namespace eval ChanComp_HL_Style {
		variable normal "normal"
		variable chan_membership "cmem"
		variable color_name_membership "dark orange"
		variable color_sig_membership "OrangeRed3"
		variable color_con_membership "RosyBrown4"
	}
}
########################################################################################################
# methods for drawing RecSym like TextSym, BlkInstRefSym, ......
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_TextExtSym {can PaS Text useOldObj OldObjID OnTopOfSO out_CanObjID} {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]
	set x_indent 8
	set y_indent $x_indent

	# sensitive, unsichtbare Flche erzeugen
	if { $useOldObj } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_RecSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_RecSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set Polygon [expr $x1+$width] $y1 $x1 $y1 $x1 [expr $y1+$height] [expr $x1+$width] [expr $y1+$height]
	set CompObjID [$can create line $Polygon -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $PaS]

	set CompObjID [$can create text [expr $x1 +1] $y1 -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
}
proc ::olSDL_ViewsDrawMethods::draw_TextSym {can PaS Text useOldObj OldObjID OnTopOfSO out_CanObjID} {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]
	set x_indent 8
	set y_indent $x_indent

	# sensitive, unsichtbare Flche erzeugen
	if { $useOldObj } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_RecSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_RecSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set Polygon [::olSDL_ViewsCalcCoor::calc_TextSymPolygon $x1 $y1 $width $height $x_indent $y_indent]
	set CompObjID [$can create line $Polygon -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# kleiner Knick
	set next_x [expr $x1 + $width - $x_indent]
	set next_y $y1
	lappend Fold $next_x $next_y
	set next_y [expr $next_y + $y_indent]
	lappend Fold $next_x $next_y
	set next_x [expr $next_x + $x_indent]
	lappend Fold $next_x $next_y
	set CompObjID [$can create line $Fold -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [list $x1 $y1 [expr $width - $x_indent -1] $height]
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [expr $x1 +1] $y1 -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
}
####################################################
proc ::olSDL_ViewsDrawMethods::draw_BlkInstRefSym {can PaS Text useOldObj OldObjID OnTopOfSO out_CanObjID} {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]

	# sensitive, unsichtbare Flche erzeugen
	if { $useOldObj } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_RecSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]

	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_RecSym_Bottom]
	}

	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 1 -tag $TagList]
	if [regexp ":" $Text] {
	  $can itemconfigure $CompObjID -dash -
	}
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $PaS]

	set CompObjID [$can create text [expr $x1 +1] $y1 -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
}
####################################################
proc ::olSDL_ViewsDrawMethods::draw_BlkTypeRefSym {can PaS Text useOldObj OldObjID OnTopOfSO out_CanObjID} {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]

	# sensitive, unsichtbare Flche erzeugen
	if { $useOldObj } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_RecSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]

	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_RecSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer doppelter Rahmen
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# inner border
	set borderwidth 3
	set inner_x1 [expr $x1 + $borderwidth]
	set inner_y1 [expr $y1 + $borderwidth]
	set inner_x2 [expr $x2 - $borderwidth]
	set inner_y2 [expr $y2 - $borderwidth]

	set CompObjID [$can create rectangle $inner_x1 $inner_y1 $inner_x2 $inner_y2 -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [list [expr $x1 + $borderwidth + 1] [expr $y1 + $borderwidth] [expr $width - 2*($borderwidth+1)] [expr $height - 2*($borderwidth)] ]
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [expr $x1 + $borderwidth + 1] [expr $y1 + $borderwidth] -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
}
####################################################
proc ::olSDL_ViewsDrawMethods::draw_ProInstRefSym {can PaS Text useOldObj OldObjID OnTopOfSO out_CanObjID}  {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]
	set x_indent 9
	set y_indent $x_indent

	# sensitive, unsichtbare Flche erzeugen
	if { $useOldObj } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_RecSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_RecSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set Polygon [::olSDL_ViewsCalcCoor::calc_ProcSymPolygon $x1 $y1 $width $height $x_indent $y_indent]
	set CompObjID [$can create line $Polygon -width 1 -tag $TagList]
	if [regexp ":" $Text] {
	  $can itemconfigure $CompObjID -dash -
	}
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [list [expr $x1 + $x_indent +1] $y1 [expr $width - 2*($x_indent +1)] $height]
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [expr $x1 + $x_indent +1] $y1 -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
}
####################################################
proc ::olSDL_ViewsDrawMethods::draw_ProcedureInstRefSym {can PaS Text useOldObj OldObjID OnTopOfSO out_CanObjID}  {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]
	set x_indent 9
	set y_indent $x_indent

	# sensitive, unsichtbare Flche erzeugen
	if { $useOldObj } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_RecSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_RecSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set Polygon [::olSDL_ViewsCalcCoor::calc_ProcSymPolygon $x1 $y1 $width $height $x_indent $y_indent]
	set CompObjID [$can create line $Polygon -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# lines
	set CompObjID [$can create line [expr $x1 + $x_indent] [expr $y1] [expr $x1 + $x_indent] [expr $y2] -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	set CompObjID [$can create line [expr $x2 - $y_indent] [expr $y1] [expr $x2 - $y_indent] [expr $y2] -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [list [expr $x1 + $x_indent +1] $y1 [expr $width - 2*($x_indent +1)] $height]
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [expr $x1 + $x_indent +1] $y1 -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
}
####################################################
proc ::olSDL_ViewsDrawMethods::draw_ProTypeRefSym {can PaS Text useOldObj OldObjID OnTopOfSO out_CanObjID}  {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]
	set x_indent 9
	set y_indent $x_indent

	# sensitive, unsichtbare Flche erzeugen
	if { $useOldObj } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_RecSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_RecSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set Polygon [::olSDL_ViewsCalcCoor::calc_ProcSymPolygon $x1 $y1 $width $height $x_indent $y_indent]
	set CompObjID [$can create line $Polygon -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# sichtbarer innerer Rahmen
	set borderwidth 3
	set Polygon [::olSDL_ViewsCalcCoor::calc_ProcSymInnerPolygon $x1 $y1 \
	    $x2 $y2 \
	    [expr $width - (2 * $x_indent)] [expr $height - (2 * $y_indent)] \
	    $borderwidth $x_indent $y_indent]
	set CompObjID [$can create line $Polygon -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS \
		[list [expr $x1 + $x_indent + $borderwidth +1] [expr $y1 + $borderwidth +1] [expr $width - 2*($x_indent + $borderwidth +1)] [expr $height - 2*($borderwidth +1)] ]
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [expr $x1 + $x_indent + $borderwidth +1] [expr $y1 + $borderwidth +1] -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::delete_RecSymComp_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_RecSym $ObjArr($ObjID,Type)] } {
		error "unknown symbol type"
		return
	}

	$CanvasPathName delete PartOf$ObjID
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::delete_RecSym_RP_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_RecSym $ObjArr($ObjID,Type)] } {
		error "unknown symbol type"
		return
	}

	$CanvasPathName delete RPparent$ObjID
}
########################################################################################################
# END: methods for drawing RecSym like TextSym, BlkInstRefSym, ......
########################################################################################################
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_ProcedureFormalParameters_ResizePoints {ObjArrName CanInfoArr ObjID} {

	variable PassiveResizePointsColor

	set TagList [list FormalParametersHeaderRP RPparent$ObjID stack_FormalParameters_RP_Bottom]

	set StackOrderSuccessorTag [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_FormalParameters_RP_Bottom]

	::olSDL_ViewsDrawMethods::draw_RecObjects_ResizePoints $ObjArrName $CanInfoArr $TagList $StackOrderSuccessorTag $ObjID $PassiveResizePointsColor
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::delete_ProcedureFormalParameters_ResizePoints_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! ($ObjArr($ObjID,Type) == "HP_FormalParameters")} {
		error "wrong object type"
		return
	}

	$CanvasPathName delete RPparent$ObjID
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_SysDiaName_ResizePoints {ObjArrName CanInfoArr ObjID} {

	variable PassiveResizePointsColor

	set TagList [list PageFrameHeaderRP RPparent$ObjID stack_PageFrameHeader_RP_Bottom]

	set StackOrderSuccessorTag [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_PageFrameHeader_RP_Bottom]

	::olSDL_ViewsDrawMethods::draw_RecObjects_ResizePoints $ObjArrName $CanInfoArr $TagList $StackOrderSuccessorTag $ObjID $PassiveResizePointsColor
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::delete_SysDiaName_ResizePoints_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! ($ObjArr($ObjID,Type) == "HP_PageName")} {
		error "wrong object type"
		return
	}

	$CanvasPathName delete RPparent$ObjID
}
########################################################################################################
# methods for drawing symbols which belong  to RecSym
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_RecSym_ResizePoints {ObjArrName CanInfoArr ObjID} {

	variable ResizePointsColor

	set TagList [list RecObjRP RPparent$ObjID stack_RecSym_RP_Bottom]

	set StackOrderSuccessorTag [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_RecSym_RP_Bottom]

	::olSDL_ViewsDrawMethods::draw_RecObjects_ResizePoints $ObjArrName $CanInfoArr $TagList $StackOrderSuccessorTag $ObjID $ResizePointsColor
}
########################################################################################################
# END: methods for drawing symbols which belong  to RecSym
########################################################################################################

########################################################################################################
# methods for drawing channels
########################################################################################################
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_ChanSourceCon {can Channel_ID PaS Text useOldObj OldObjID HL_Style out_CanObjID} {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	# sensitive, unsichtbare Flche erzeugen
	if { $useOldObj } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set TagList [list ChanSourceCon$Channel_ID selectableRecChanComp movableChanComp]
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -tag $TagList -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOfChanComp$tempObjID stack_ChannelConnect_Bottom]

	if { $HL_Style == $ChanComp_HL_Style::normal } {

		# set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -tag $TagList]

	} elseif { $HL_Style == $ChanComp_HL_Style::chan_membership } {
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $ChanComp_HL_Style::color_con_membership -tag $TagList]
	} else {
		error "wrong highlight style"
	}

	$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_ChannelConnect_Bottom]
	set PredecessorID $CompObjID


	set TagList [list PartOfChanComp$tempObjID]


	# Border ?
	if { $::olSDL_AppVar::SettingVar::ChanpCompWithBorder } {

		# sichtbarer Rahmen
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 1 -outline gray40 -tag $TagList]
		$can raise $CompObjID $PredecessorID
		set PredecessorID $CompObjID

	} else {

		# sichtbarer Rahmen
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -tag $TagList]
		$can raise $CompObjID $PredecessorID
		set PredecessorID $CompObjID

	}

	# Text
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $PaS] 

	set CompObjID [$can create text $x1 $y1 -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# sensitive, unsichtbare Flche nach oben
	$can raise $tempObjID $PredecessorID
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_ChanDestCon {can Channel_ID PaS Text useOldObj OldObjID HL_Style out_CanObjID} {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	# sensitive, unsichtbare Flche erzeugen
	if { $useOldObj } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set TagList [list ChanDestCon$Channel_ID selectableRecChanComp movableChanComp]
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -tag $TagList -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOfChanComp$tempObjID stack_ChannelConnect_Bottom]

	if { $HL_Style == $ChanComp_HL_Style::normal } {

		# set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -tag $TagList]

	} elseif { $HL_Style == $ChanComp_HL_Style::chan_membership } {
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $ChanComp_HL_Style::color_con_membership -tag $TagList]
	} else {
		error "wrong highlight style"
	}

	$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_ChannelConnect_Bottom]
	set PredecessorID $CompObjID

	set TagList [list PartOfChanComp$tempObjID]


	# Border ?
	if { $::olSDL_AppVar::SettingVar::ChanpCompWithBorder } {

		# sichtbarer Rahmen
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 1 -outline gray40 -tag $TagList]
		$can raise $CompObjID $PredecessorID
		set PredecessorID $CompObjID

	} else {

		# sichtbarer Rahmen
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -tag $TagList]
		$can raise $CompObjID $PredecessorID
		set PredecessorID $CompObjID

	}

	# Text
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $PaS]

	set CompObjID [$can create text $x1 $y1 -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# sensitive, unsichtbare Flche nach oben
	$can raise $tempObjID $PredecessorID
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_ChanDestSig {can Channel_ID PaS Text useOldObj OldObjID HL_Style out_CanObjID} {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	# sensitive, unsichtbare Flche erzeugen
	if { $useOldObj } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set TagList [list ChanDestSig$Channel_ID selectableRecChanComp movableChanComp]
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -tag $TagList -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOfChanComp$tempObjID stack_ChannelSig_Bottom]

	if { $HL_Style == $ChanComp_HL_Style::normal } {
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	} elseif { $HL_Style == $ChanComp_HL_Style::chan_membership } {
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $ChanComp_HL_Style::color_sig_membership -tag $TagList]
	} else {
		error "wrong highlight style"
	}

	$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_ChannelSig_Bottom]
	set PredecessorID $CompObjID


	set TagList [list PartOfChanComp$tempObjID]

	set CompObjID [$can create line [::olSDL_ViewsCalcCoor::calc_left_brace_coords_for_SigSym $PaS] -width 2 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	set CompObjID [$can create line [::olSDL_ViewsCalcCoor::calc_right_brace_coords_for_SigSym $PaS] -width 2 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $PaS]

	set CompObjID [$can create text $x1 $y1 -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# sensitive, unsichtbare Flche nach oben
	$can raise $tempObjID $PredecessorID
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_ChanSourceSig {can Channel_ID PaS Text useOldObj OldObjID HL_Style out_CanObjID} {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	# sensitive, unsichtbare Flche erzeugen
	if { $useOldObj } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set TagList [list ChanSourceSig$Channel_ID selectableRecChanComp movableChanComp]
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -tag $TagList -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOfChanComp$tempObjID stack_ChannelSig_Bottom]

	if { $HL_Style == $ChanComp_HL_Style::normal } {
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	} elseif { $HL_Style == $ChanComp_HL_Style::chan_membership } {
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $ChanComp_HL_Style::color_sig_membership -tag $TagList]
	} else {
		error "wrong highlight style"
	}

	$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_ChannelSig_Bottom]
	set PredecessorID $CompObjID


	set TagList [list PartOfChanComp$tempObjID]

	set CompObjID [$can create line [::olSDL_ViewsCalcCoor::calc_left_brace_coords_for_SigSym $PaS] -width 2 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	set CompObjID [$can create line [::olSDL_ViewsCalcCoor::calc_right_brace_coords_for_SigSym $PaS] -width 2 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $PaS]

	set CompObjID [$can create text $x1 $y1 -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# sensitive, unsichtbare Flche nach oben
	$can raise $tempObjID $PredecessorID
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_ChannelName {can Channel_ID PaS Text useOldObj OldObjID HL_Style out_CanObjID} {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	# sensitive, unsichtbare Flche erzeugen
	if { $useOldObj } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set TagList [list ChanName$Channel_ID selectableRecChanComp movableChanComp]
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -tag $TagList -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOfChanComp$tempObjID stack_ChannelName_Bottom]

	if { $HL_Style == $ChanComp_HL_Style::normal } {

		# set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -tag $TagList]

	} elseif { $HL_Style == $ChanComp_HL_Style::chan_membership } {
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $ChanComp_HL_Style::color_name_membership -tag $TagList]
	} else {
		error "wrong highlight style"
	}

	$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_ChannelName_Bottom]
	set PredecessorID $CompObjID

	set TagList [list PartOfChanComp$tempObjID]


	if { $::olSDL_AppVar::SettingVar::ChanpCompWithBorder } {

		# sichtbarer Rahmen
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 1 -outline gray40 -dash {2 2} -tag $TagList]
		$can raise $CompObjID $PredecessorID
		set PredecessorID $CompObjID

	} else {

		# sichtbarer Rahmen
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -tag $TagList]
		$can raise $CompObjID $PredecessorID
		set PredecessorID $CompObjID

	}


	# Text
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $PaS]

	set CompObjID [$can create text $x1 $y1 -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# sensitive, unsichtbare Flche nach oben
	$can raise $tempObjID $PredecessorID
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_Channel {CanvasPathName Coords DelayType DirectionType useOldObj OldObjID out_CanObjID} {

	upvar $out_CanObjID CanObjID

	set ArrowWidth 1

	if { ! $useOldObj } {
		set CanObjID [$CanvasPathName create line $Coords -width 1 -tag {selectableChannel BasicChanLine stack_Channel_Bottom} ]
		set tempChanID $CanObjID
	} else {
		$CanvasPathName coords $OldObjID $Coords
		set tempChanID $OldObjID
	}

	$CanvasPathName lower $tempChanID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_Channel_Bottom]
	set PredecessorID $tempChanID

	set CoordsLength [llength $Coords]

	set SourceChannelPart_x1 [lindex $Coords 0]
	set SourceChannelPart_y1 [lindex $Coords 1]
	set SourceChannelPart_x2 [lindex $Coords 2]
	set SourceChannelPart_y2 [lindex $Coords 3]

	set DestinationChannelPart_x1 [lindex $Coords [expr $CoordsLength - 4] ]
	set DestinationChannelPart_y1 [lindex $Coords [expr $CoordsLength - 3] ]
	set DestinationChannelPart_x2 [lindex $Coords [expr $CoordsLength - 2] ]
	set DestinationChannelPart_y2 [lindex $Coords [expr $CoordsLength - 1] ]

	set SourceArrowCoords { }
	set DestinationArrowCoords { }

	set TagList [list selectableChannelArrow ParentChannel$tempChanID PartOfChan$tempChanID stack_Channel_Bottom]

	if  { $DelayType == "no_delay" } {

		############
		# case A
		############

		if { $DirectionType == "both" } {
			############
			# case A1

			set SourceArrowID [$CanvasPathName create line \
				$DestinationChannelPart_x1 $DestinationChannelPart_y1 $DestinationChannelPart_x2 $DestinationChannelPart_y2 \
				-arrow last -width $ArrowWidth -tag $TagList]
			$CanvasPathName raise $SourceArrowID $PredecessorID

			set DestinationArrowID [$CanvasPathName create line \
				$SourceChannelPart_x2 $SourceChannelPart_y2 $SourceChannelPart_x1 $SourceChannelPart_y1 \
				-arrow last -width $ArrowWidth -tag $TagList]
			$CanvasPathName raise $DestinationArrowID $PredecessorID

		} elseif { $DirectionType == "from_source" } {
			############
			# case A2

			set SourceArrowID [$CanvasPathName create line \
				$DestinationChannelPart_x1 $DestinationChannelPart_y1 $DestinationChannelPart_x2 $DestinationChannelPart_y2 \
				-arrow last -width $ArrowWidth -tag $TagList]
			$CanvasPathName raise $SourceArrowID $PredecessorID


		} elseif { $DirectionType == "from_destination" } {
			############
			# case A3

			set DestinationArrowID [$CanvasPathName create line \
				$SourceChannelPart_x2 $SourceChannelPart_y2 $SourceChannelPart_x1 $SourceChannelPart_y1 \
				-arrow last -width $ArrowWidth -tag $TagList]
			$CanvasPathName raise $DestinationArrowID $PredecessorID

		} else {
			error "unknown Channel Type"
		}
	} elseif { $DelayType == "delay" } {
		############
		# case B
		############

		if { $DirectionType == "both" } {
			############
			# case B1

			set SourceArrowCoords \
				[::olSDL_ViewsCalcCoor::calc_ChannelArrow \
				[list $DestinationChannelPart_x2 $DestinationChannelPart_y2 $DestinationChannelPart_x1 $DestinationChannelPart_y1] ]

			set SourceArrowID [$CanvasPathName create line $SourceArrowCoords -arrow last -width $ArrowWidth -tag $TagList]
			$CanvasPathName raise $SourceArrowID $PredecessorID

			set DestinationArrowCoords \
				[::olSDL_ViewsCalcCoor::calc_ChannelArrow \
				[list $SourceChannelPart_x1 $SourceChannelPart_y1 $SourceChannelPart_x2 $SourceChannelPart_y2] ]

			set DestinationArrowID [$CanvasPathName create line $DestinationArrowCoords -arrow last -width $ArrowWidth -tag $TagList]
			$CanvasPathName raise $DestinationArrowID $PredecessorID

		} elseif { $DirectionType == "from_source" } {
			############
			# case B2

			set SourceArrowCoords \
				[::olSDL_ViewsCalcCoor::calc_ChannelArrow \
				[list $DestinationChannelPart_x2 $DestinationChannelPart_y2 $DestinationChannelPart_x1 $DestinationChannelPart_y1] ]

			set SourceArrowID [$CanvasPathName create line $SourceArrowCoords -arrow last -width $ArrowWidth -tag $TagList]
			$CanvasPathName raise $SourceArrowID $PredecessorID

		} elseif { $DirectionType == "from_destination" } {
			############
			# case B3

			set DestinationArrowCoords \
				[::olSDL_ViewsCalcCoor::calc_ChannelArrow \
				[list $SourceChannelPart_x1 $SourceChannelPart_y1 $SourceChannelPart_x2 $SourceChannelPart_y2] ]

			set DestinationArrowID [$CanvasPathName create line $DestinationArrowCoords -arrow last -width $ArrowWidth -tag $TagList]
			$CanvasPathName raise $DestinationArrowID $PredecessorID

		} else {
			error "unknown Channel Type"
		}

	} else {
		error "unknown Channel Type"
	}
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::valid_Channel_Part {LineCoords} {

	set x1 [lindex $LineCoords 0]
	set y1 [lindex $LineCoords 1]

	set x2 [lindex $LineCoords 2]
	set y2 [lindex $LineCoords 3]

	set Part_Length [expr hypot ($x2 - $x1,$y2 - $y1)]

	if { $Part_Length >= $::olSDL_ViewsDrawMethods::min_Channel_Part_Length } {
		return true
	} else {
		return false
	}
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::delete_ChannelComp_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_Channel $ObjArr($ObjID,Type)] } {
		error "object no channel"
		return
	}

	$CanvasPathName delete PartOfChan$ObjID
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::delete_Channel_MP_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_Channel $ObjArr($ObjID,Type)] } {
		error "object no channel"
		return
	}

	$CanvasPathName delete MPparent$ObjID
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::delete_ChanComp_RP_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_ChanComp $ObjArr($ObjID,Type)] } {
		error "object no channel component"
		return
	}

	$CanvasPathName delete RPparent$ObjID
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::delete_ChanComp_Comp_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_ChanComp $ObjArr($ObjID,Type)] } {
		error "object no Chan Comp"
		return
	}

	$CanvasPathName delete PartOfChanComp$ObjID
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::delete_Chan_and_all_Comp_from_Canvas {ObjArrName CanInfoArr Channel_ID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_Channel $ObjArr($Channel_ID,Type)] } {
		error "object no channel"
		return
	}

	set AllChanCompIDs [::olSDL_Views::Channel::_get_IDs_from_all_ChanComp $ObjArrName $CanInfoArr $Channel_ID]

	foreach component $AllChanCompIDs {
		delete_ChanComp_Comp_from_Canvas $ObjArrName $CanInfoArr $component
		$CanvasPathName delete $component
	}

	delete_ChannelComp_from_Canvas $ObjArrName $CanInfoArr $Channel_ID

	$CanvasPathName delete $Channel_ID
}
########################################################################################################
# END: methods for drawing channels
########################################################################################################

########################################################################################################
# methods for drawing symbols which belong to channels
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_RecChanComp_ResizePoints {ObjArrName CanInfoArr ChanCompID} {

	variable ResizePointsColor

	set ChanID ""
	set ChanCompType ""

	::olSDL_Views::Channel::get_ChanID_and_ChanCompType_from_ChanComp $ObjArrName $CanInfoArr $ChanCompID ChanID ChanCompType

	switch -exact $ChanCompType {
		ChanName {
			set stack_order_label stack_ChannelName_RP_Bottom
		}
		ChanSourceSig {
			set stack_order_label stack_ChannelSig_RP_Bottom
		}
		ChanDestSig {
			set stack_order_label stack_ChannelSig_RP_Bottom
		}
		ChanSourceCon {
			set stack_order_label stack_ChannelConnect_RP_Bottom
		}
		ChanDestCon {
			set stack_order_label stack_ChannelConnect_RP_Bottom
		}
		default {
			error "unknown ChanCompType"
		}
	}
	# switch -exact $ChanCompType


	set StackOrderSuccessorTag [::olSDL_Views::AllViews::get_StackOrderSuccessor $stack_order_label]

	set TagList [list RecChanCompRP RPparent$ChanCompID $stack_order_label]


	::olSDL_ViewsDrawMethods::draw_RecObjects_ResizePoints $ObjArrName $CanInfoArr $TagList $StackOrderSuccessorTag \
		$ChanCompID $ResizePointsColor
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_Channel_MovePoints {ObjArrName CanInfoArr Channel_ID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	variable ResizePointsColor
	variable ResizePointsSize

	set CanvasPathName $CanInfo(CanvasPathName)

	set InnerChannelMP_Index 0
	set MP_Number [expr [llength $ObjArr($Channel_ID,Coords)] / 2]

	foreach {MP_x MP_y} "$ObjArr($Channel_ID,Coords)" {

		if { ($InnerChannelMP_Index != 0) && ($InnerChannelMP_Index != ($MP_Number -1)) } {
			set TagList [list ChanMP InnerChanMP$InnerChannelMP_Index MPparent$Channel_ID stack_Channel_MP_Bottom]
		} else {

			if { ($InnerChannelMP_Index == 0) } {

				if { $ObjArr($Channel_ID,SourceID) == "ENV" } {
					set TagList [list ChanMP MPparent$Channel_ID OuterChanMPTypeSOURCE_ENV stack_Channel_MP_Bottom]
				} else {
					set TagList [list ChanMP MPparent$Channel_ID OuterChanMPTypeSOURCE_RECSYM stack_Channel_MP_Bottom]
				}
			} elseif { ($InnerChannelMP_Index == ($MP_Number -1)) } {

				if { $ObjArr($Channel_ID,DestinationID) == "ENV" } {
					set TagList [list ChanMP MPparent$Channel_ID OuterChanMPTypeDEST_ENV stack_Channel_MP_Bottom]
				} else {
					set TagList [list ChanMP MPparent$Channel_ID OuterChanMPTypeDEST_RECSYM stack_Channel_MP_Bottom]
				}
			} else {
				error "no channel outer MP"
			}

		}

		set x_left_up [expr $MP_x - $ResizePointsSize]
		set y_left_up [expr $MP_y - $ResizePointsSize]
		set x_right_down [expr $MP_x + $ResizePointsSize]
		set y_right_down [expr $MP_y + $ResizePointsSize]

		set MPObjID [$CanvasPathName create rectangle \
				$x_left_up $y_left_up $x_right_down $y_right_down \
				-fill $ResizePointsColor -tag $TagList]

		$CanvasPathName lower $MPObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_Channel_MP_Bottom]

		incr InnerChannelMP_Index 1
	}
}
########################################################################################################
proc ::olSDL_ViewsDrawMethods::draw_ICMP_PreviewLine {CanInfoArr PreCoords x y SucCoords out_PreviewLineID} {

	upvar #0 $CanInfoArr CanInfo
	upvar $out_PreviewLineID PreviewLineID

	set CanvasPathName $CanInfo(CanvasPathName)

	set coords $PreCoords
	lappend coords $x
	lappend coords $y
	set coords [concat $coords $SucCoords]

	set PreviewLineID [$CanvasPathName create line $coords -dash {2 4} -width 2]
}
########################################################################################################
# END: methods for drawing symbols which belong to channels
########################################################################################################

####################################################
proc ::olSDL_ViewsDrawMethods::draw_PageFrame {CanvasPathName PaS useOldObj OldObjID out_CanObjID} {

	upvar $out_CanObjID CanObjID

	set Line [::olSDL_ViewsCalcCoor::calc_LineFromPaS $PaS]

	# sichtbaren (!)  Rahmen erzeugen
	if { $useOldObj } {
		$CanvasPathName coords $OldObjID $Line
		set tempObjID $OldObjID
	} else {
		set CanObjID [$CanvasPathName create line $Line -width 1]
		set tempObjID $CanObjID
	}

	$CanvasPathName lower $tempObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_PageFrame]

}
##################################################################
proc ::olSDL_ViewsDrawMethods::redraw_SystemDiagramPageHeader {ObjArrName CanInfoArr DiagramHeaderID HP_Name out_TypeAndNamePaS} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	upvar $out_TypeAndNamePaS TypeAndNamePaS

	set CanvasPathName $CanInfo(CanvasPathName)

	$CanvasPathName itemconfigure [lindex $ObjArr($DiagramHeaderID,Comp) 1] -text $HP_Name

	set TextBoundingBox [$CanvasPathName bbox [lindex $ObjArr($DiagramHeaderID,Comp) 0] [lindex $ObjArr($DiagramHeaderID,Comp) 1]]

	$CanvasPathName coords $DiagramHeaderID $TextBoundingBox

	set TypeAndNamePaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $TextBoundingBox]
}
##################################################################
proc ::olSDL_ViewsDrawMethods::redraw_ProcedureFormalParameters {ObjArrName CanInfoArr FormalParametersCanID HP_FormalParameters out_NewPaS} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	upvar $out_NewPaS NewPaS

	set CanvasPathName $CanInfo(CanvasPathName)

	$CanvasPathName itemconfigure [lindex $ObjArr($FormalParametersCanID,Comp) 0] -text $HP_FormalParameters

	set TextBoundingBox [$CanvasPathName bbox [lindex $ObjArr($FormalParametersCanID,Comp) 0]]

	$CanvasPathName coords $FormalParametersCanID $TextBoundingBox

	set NewPaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $TextBoundingBox]
}
##################################################################
proc ::olSDL_ViewsDrawMethods::draw_FormalParameters {CanvasPathName Diagram_TypeAndName_PaS HP_FormalParameters out_CanObjID out_Comp out_ParametersPaS} {

	upvar $out_CanObjID CanObjID
	upvar $out_Comp Comp
	upvar $out_ParametersPaS ParametersPaS

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $Diagram_TypeAndName_PaS DTN_PaS_x1 DTN_PaS_y1 DTN_PaS_x2 DTN_PaS_y2

	set CompObjID_FormalParameters [$CanvasPathName create text \
		[expr $DTN_PaS_x1] [expr $DTN_PaS_y2 + 3] -text $HP_FormalParameters  -anchor nw]
	lappend Comp $CompObjID_FormalParameters
	$CanvasPathName lower $CompObjID_FormalParameters [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_PageFrameHeader]


	# sensitive, unsichtbare Flche erzeugen
	set TextBoundingBox [$CanvasPathName bbox $CompObjID_FormalParameters]
	set CanObjID [$CanvasPathName create rectangle $TextBoundingBox -tag selectableFormalParameters -width 0]

	set ParametersPaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $TextBoundingBox]

	$CanvasPathName lower $CanObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_PageFrameHeader]

}
##################################################################
proc ::olSDL_ViewsDrawMethods::draw_PageHeader {CanvasPathName FramePaS HP_DiaType HP_Name HP_Index out_CanObjID out_Comp out_TypeAndNamePaS} {

	upvar $out_CanObjID CanObjID
	upvar $out_Comp Comp
	upvar $out_TypeAndNamePaS TypeAndNamePaS

	set Comp { }

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $FramePaS Frame_x1 Frame_y1 Frame_x2 Frame_y2


	#DiaType
	set CompObjID_DiaType [$CanvasPathName create text [expr $Frame_x1 + 5] [expr $Frame_y1 + 4 ] -text $HP_DiaType  \
		-font *-*-bold-*-*--13-*-*-*-*-*-*-* -anchor nw]
	lappend Comp $CompObjID_DiaType
	$CanvasPathName lower $CompObjID_DiaType [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_PageFrameHeader]

	set DiaTypeTextBoundingBox [$CanvasPathName bbox $CompObjID_DiaType]
	set DiaTypeTextBoxWidth [expr [lindex $DiaTypeTextBoundingBox 2] - [lindex $DiaTypeTextBoundingBox 0] ]

	#DiaName
	set CompObjID_DiaName [$CanvasPathName create text [expr $Frame_x1 + $DiaTypeTextBoxWidth + 6] [expr $Frame_y1 + 4] -text $HP_Name  -anchor nw]
	lappend Comp $CompObjID_DiaName
	$CanvasPathName lower $CompObjID_DiaName [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_PageFrameHeader]

	# index
	set CompObjID [$CanvasPathName create text [expr $Frame_x2 - 5] [expr $Frame_y1 + 4 ] -text $HP_Index -anchor ne]
	lappend Comp $CompObjID
	$CanvasPathName lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_PageFrameHeader]

	# sensitive, unsichtbare Flche erzeugen
	set TextBoundingBox [$CanvasPathName bbox $CompObjID_DiaType $CompObjID_DiaName]
	set CanObjID [$CanvasPathName create rectangle $TextBoundingBox -tag selectableDiagramHeader -width 0]

	set TypeAndNamePaS [::olSDL_ViewsCalcCoor::calc_PaS_from_Coords $TextBoundingBox]

	$CanvasPathName lower $CanObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_PageFrameHeader]
}
##################################################################
##################################################################
proc ::olSDL_ViewsDrawMethods::draw_RecObjects_ResizePoints {ObjArrName CanInfoArr PartTagList StackOrderSuccessorTag ObjID RP_Color} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	variable ResizePointsSize

	set CanvasPathName $CanInfo(CanvasPathName)
	set PaS $ObjArr($ObjID,PaS)

	set x_left_up [lindex $PaS 0]
	set y_left_up [lindex $PaS 1]

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]


	set TagList  [concat $PartTagList {RecObjRP_type_left_up} ]
	set CompObjID [$CanvasPathName create rectangle \
				[expr $x_left_up-$ResizePointsSize] \
				[expr $y_left_up-$ResizePointsSize] \
				[expr $x_left_up+$ResizePointsSize] \
				[expr $y_left_up+$ResizePointsSize] \
				-fill $RP_Color -tag $TagList ]
	$CanvasPathName lower $CompObjID $StackOrderSuccessorTag

	set TagList [concat $PartTagList {RecObjRP_type_right_up} ]
	set CompObjID [$CanvasPathName create rectangle \
				[expr $x_left_up-$ResizePointsSize+$width] \
				[expr $y_left_up-$ResizePointsSize] \
				[expr $x_left_up+$ResizePointsSize+$width] \
				[expr $y_left_up+$ResizePointsSize] \
				-fill $RP_Color -tag $TagList]
	$CanvasPathName lower $CompObjID $StackOrderSuccessorTag

	set TagList  [concat $PartTagList {RecObjRP_type_left_down} ]
	set CompObjID [$CanvasPathName create rectangle \
				[expr $x_left_up-$ResizePointsSize] \
				[expr $y_left_up-$ResizePointsSize+$height] \
				[expr $x_left_up+$ResizePointsSize] \
				[expr $y_left_up+$ResizePointsSize+$height] \
				-fill $RP_Color -tag $TagList]
	$CanvasPathName lower $CompObjID $StackOrderSuccessorTag


	set TagList  [concat $PartTagList {RecObjRP_type_right_down} ]
	set CompObjID [$CanvasPathName create rectangle \
				[expr $x_left_up-$ResizePointsSize+$width] \
				[expr $y_left_up-$ResizePointsSize+$height] \
				[expr $x_left_up+$ResizePointsSize+$width] \
				[expr $y_left_up+$ResizePointsSize+$height] \
				-fill $RP_Color -tag $TagList]
	$CanvasPathName lower $CompObjID $StackOrderSuccessorTag

	set TagList  [concat $PartTagList {RecObjRP_type_up} ]
	set CompObjID [$CanvasPathName create rectangle \
				[expr $x_left_up-$ResizePointsSize+($width/2)] \
				[expr $y_left_up-$ResizePointsSize] \
				[expr $x_left_up+$ResizePointsSize+($width/2)] \
				[expr $y_left_up+$ResizePointsSize] \
				-fill $RP_Color -tag $TagList]
	$CanvasPathName lower $CompObjID $StackOrderSuccessorTag

	set TagList  [concat $PartTagList {RecObjRP_type_down} ]
	set CompObjID [$CanvasPathName create rectangle \
				[expr $x_left_up-$ResizePointsSize+($width/2)] \
				[expr $y_left_up-$ResizePointsSize+$height] \
				[expr $x_left_up+$ResizePointsSize+($width/2)] \
				[expr $y_left_up+$ResizePointsSize+$height] \
				-fill $RP_Color -tag $TagList]
	$CanvasPathName lower $CompObjID $StackOrderSuccessorTag

	set TagList  [concat $PartTagList {RecObjRP_type_right} ]
	set CompObjID [$CanvasPathName create rectangle \
				[expr $x_left_up-$ResizePointsSize+$width] \
				[expr $y_left_up-$ResizePointsSize+($height/2)] \
				[expr $x_left_up+$ResizePointsSize+$width] \
				[expr $y_left_up+$ResizePointsSize+($height/2)] \
				-fill $RP_Color -tag $TagList]
	$CanvasPathName lower $CompObjID $StackOrderSuccessorTag

	set TagList  [concat $PartTagList {RecObjRP_type_left} ]
	set CompObjID [$CanvasPathName create rectangle \
				[expr $x_left_up-$ResizePointsSize] \
				[expr $y_left_up-$ResizePointsSize+($height/2)] \
				[expr $x_left_up+$ResizePointsSize] \
				[expr $y_left_up+$ResizePointsSize+($height/2)] \
				-fill $RP_Color -tag $TagList]
	$CanvasPathName lower $CompObjID $StackOrderSuccessorTag

}
##################################################################
