
package provide olSDL_ViewsDrawMethods 1

###############################################################################
#### procs for drawing
###############################################################################

namespace eval olSDL_ViewsDrawMethods {

	variable default_Text_DecFlowLine "DecFlowLine"

	variable default_Size_DecFlowLineComp {60 20}

	variable FlowLineMP_Color gray72

	namespace eval DecFlowLineComp_HL_Style {
		variable normal "normal"
		variable flowline_membership "flowlinemem"
		variable color_condition_membership "dark orange"
	}
}

###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaProcedureStartStateSym {can PaS Text OldObjID OnTopOfSO} {
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_StateMaSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set CompObjID [$can create oval $x1 $y1 $x2 $y2 -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# lines
	set Ell_a [expr abs( $x2 - $x1)/2.0]
	set Ell_b [expr abs( $y2 - $y1)/2.0]

	set x1_right_line [expr $Ell_a * 0.7660]
	set y1_right_line [expr $Ell_b * 0.6427]

	set CompObjID [$can create line [expr $x1 + $Ell_a - $x1_right_line] [expr $y1 + $Ell_b - $y1_right_line] [expr $x1 + $Ell_a - $x1_right_line] [expr $y1 + $Ell_b + $y1_right_line] -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	set CompObjID [$can create line [expr $x1 + $Ell_a + $x1_right_line] [expr $y1 + $Ell_b - $y1_right_line] [expr $x1 + $Ell_a + $x1_right_line] [expr $y1 + $Ell_b + $y1_right_line] -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $PaS StateMaProcedureStartStateSym] 
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [lindex $TextPaS 0] [lindex $TextPaS 1] -text $CutText -anchor [lindex $TextPaS 4] -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
	return $CanObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaStartStateSym {can PaS Text OldObjID OnTopOfSO} {
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_StateMaSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSym_Bottom]
	}
	set PredecessorID $CompObjID


	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set CompObjID [$can create oval $x1 $y1 $x2 $y2 -width 2 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $PaS StateMaStartStateSym] 
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [lindex $TextPaS 0] [lindex $TextPaS 1] -text $CutText -anchor [lindex $TextPaS 4] -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
	return $CanObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaStateSym {can PaS Text OldObjID OnTopOfSO} {
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_StateMaSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set CompObjID [$can create oval $x1 $y1 $x2 $y2 -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $PaS StateMaStateSym] 
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [lindex $TextPaS 0] [lindex $TextPaS 1] -text $CutText -anchor [lindex $TextPaS 4] -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
	return $CanObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaConditionSym {can PaS Text OldObjID OnTopOfSO} {
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_StateMaSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	set l1_x [expr int( $x1 + (($x2 - $x1)/4) )]
	set l1_y $y1
	set l2_x $x1
	set l2_y [expr int( $y1 + (($y2 - $y1)/2) )]
	set l3_x $l1_x
	set l3_y $y2

	set tempLineCoords_left [list $l1_x $l1_y $l2_x $l2_y $l3_x $l3_y]

	set l1_x [expr int( $x2 - (($x2 - $x1)/4) )]
	set l1_y $y1
	set l2_x $x2
	set l2_y [expr int( $y1 + (($y2 - $y1)/2) )]
	set l3_x $l1_x
	set l3_y $y2

	set tempLineCoords_right [list $l1_x $l1_y $l2_x $l2_y $l3_x $l3_y]

	# sichtbarer Rahmen
	set CompObjID [$can create line $tempLineCoords_left -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID
	set CompObjID [$can create line $tempLineCoords_right -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $PaS StateMaConditionSym] 
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [lindex $TextPaS 0] [lindex $TextPaS 1] -text $CutText -anchor [lindex $TextPaS 4] -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
	return $CanObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaDecisionSym {can PaS Text OldObjID OnTopOfSO} {
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_StateMaSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	set l1_x [expr int( $x1+ (($x2 - $x1)/2) )]
	set l1_y $y1

	set l2_x $x2
	set l2_y [expr int( $y1 + (($y2 - $y1)/2) )]

	set l3_x [expr int( $x1+ (($x2 - $x1)/2) )]
	set l3_y $y2

	set l4_x $x1
	set l4_y [expr int( $y1 + (($y2 - $y1)/2) )]

	set tempLineCoords [list $l1_x $l1_y $l2_x $l2_y $l3_x $l3_y $l4_x $l4_y $l1_x $l1_y]

	# sichtbarer Rahmen
	set CompObjID [$can create line $tempLineCoords -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $PaS StateMaDecisionSym] 
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [lindex $TextPaS 0] [lindex $TextPaS 1] -text $CutText -anchor [lindex $TextPaS 4] -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
	return $CanObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaTaskSym {can PaS Text OldObjID OnTopOfSO} {
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_StateMaSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSym_Bottom]
	}
	set PredecessorID $CompObjID


	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $PaS StateMaTaskSym] 
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [lindex $TextPaS 0] [lindex $TextPaS 1] -text $CutText -anchor [lindex $TextPaS 4] -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
	return $CanObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaCreateProSym {can PaS Text OldObjID OnTopOfSO} {
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_StateMaSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSym_Bottom]
	}
	set PredecessorID $CompObjID


	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# lines
	set CompObjID [$can create line $x1 [expr $y1 + 2] $x2 [expr $y1 + 2] -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	set CompObjID [$can create line $x1 [expr $y2 - 2] $x2 [expr $y2 - 2] -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $PaS StateMaCreateProSym] 
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [lindex $TextPaS 0] [lindex $TextPaS 1] -text $CutText -anchor [lindex $TextPaS 4] -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
	return $CanObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaCallProcedureSym {can PaS Text OldObjID OnTopOfSO} {
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_StateMaSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# lines
	set CompObjID [$can create line [expr $x1 + 2] [expr $y1] [expr $x1 + 2] [expr $y2] -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	set CompObjID [$can create line [expr $x2 - 2] [expr $y1] [expr $x2 - 2] [expr $y2] -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $PaS StateMaCallProcedureSym] 
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [lindex $TextPaS 0] [lindex $TextPaS 1] -text $CutText -anchor [lindex $TextPaS 4] -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
	return $CanObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaOutputSym {can PaS Text OldObjID OnTopOfSO} {
	set ArrowLengthInPercent 0.8

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_StateMaSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set Polygon [_calc_StateMaOutputSym $x1 $y1 $width $height $ArrowLengthInPercent]
	set CompObjID [$can create line $Polygon -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $PaS StateMaOutputSym] 
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [lindex $TextPaS 0] [lindex $TextPaS 1] -text $CutText -anchor [lindex $TextPaS 4] -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
	return $CanObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaInputSym {can PaS Text OldObjID OnTopOfSO} {
	set ArrowLengthInPercent 0.2

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_StateMaSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set Polygon [_calc_StateMaInputSym $x1 $y1 $width $height $ArrowLengthInPercent]
	set CompObjID [$can create line $Polygon -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $PaS StateMaInputSym] 
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [lindex $TextPaS 0] [lindex $TextPaS 1] -text $CutText -anchor [lindex $TextPaS 4] -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
	return $CanObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaStopSym {can PaS Text OldObjID OnTopOfSO} {
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_StateMaSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# "sichtbarer Rahmen"
	set CompObjID [$can create line [list $x1 $y1 $x2 $y2] -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	set CompObjID [$can create line [list $x2 $y1 $x1 $y2] -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $PaS StateMaStopSym] 
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [lindex $TextPaS 0] [lindex $TextPaS 1] -text $CutText -anchor [lindex $TextPaS 4] -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
	return $CanObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaProcedureReturnSym {can PaS Text OldObjID OnTopOfSO} {
	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	set width [lindex $PaS 2]
	set height [lindex $PaS 3]

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOf$tempObjID stack_StateMaSym_Bottom]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
	if { ! ($OnTopOfSO) } {
		$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSym_Bottom]
	}
	set PredecessorID $CompObjID

	set TagList [list PartOf$tempObjID]

	# sichtbarer Rahmen
	set CompObjID [$can create oval $x1 $y1 $x2 $y2 -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# lines
	set Ell_a [expr abs( $x2 - $x1)/2.0]
	set Ell_b [expr abs( $y2 - $y1)/2.0]

	set x1_right_line [expr $Ell_a * 0.7071]
	set y1_right_line [expr $Ell_b * 0.7071]

	set CompObjID [$can create line [expr $x1 + $Ell_a - $x1_right_line] [expr $y1 + $Ell_b - $y1_right_line] [expr $x1 + $Ell_a + $x1_right_line] [expr $y1 + $Ell_b + $y1_right_line] -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	set CompObjID [$can create line [expr $x1 + $Ell_a + $x1_right_line] [expr $y1 + $Ell_b - $y1_right_line] [expr $x1 + $Ell_a - $x1_right_line] [expr $y1 + $Ell_b + $y1_right_line] -width 1 -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set TextPaS [::olSDL_ViewsCalcCoor::calc_TextPaS $PaS StateMaProcedureReturnSym] 
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $TextPaS]

	set CompObjID [$can create text [lindex $TextPaS 0] [lindex $TextPaS 1] -text $CutText -anchor [lindex $TextPaS 4] -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	$can raise $tempObjID $PredecessorID
	return $CanObjID
}
###############################################################################
###############################################################################
proc ::olSDL_ViewsDrawMethods::_calc_StateMaOutputSym {x1 y1 width height ArrowLengthInPercent} {
	lappend Polygon $x1 $y1

	set next_x [expr int ($x1 + ($ArrowLengthInPercent * $width))]
	set next_y $y1
	lappend Polygon $next_x $next_y

	set next_x [expr int($x1 + $width)]
	set next_y [expr int( $y1 + ( $height / 2.0 ) )]
	lappend Polygon $next_x $next_y

	set next_x [expr int ($x1 + ($ArrowLengthInPercent * $width))]
	set next_y [expr int($y1 + $height)]
	lappend Polygon $next_x $next_y

	set next_x $x1
	set next_y [expr int($y1 + $height)]
	lappend Polygon $next_x $next_y $x1 $y1
	return $Polygon
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::_calc_StateMaInputSym {x1 y1 width height ArrowLengthInPercent} {

	lappend Polygon $x1 $y1

	set next_x [expr int ($x1 + $width)]
	lappend Polygon $next_x $y1

	set next_y [expr int ($y1 + $height)]
	lappend Polygon $next_x $next_y

	set next_x $x1
	lappend Polygon $next_x $next_y

	set next_x [expr int($x1 + ($ArrowLengthInPercent * $width))]
	set next_y [expr int( $y1 + ( $height / 2.0 ) )]
	lappend Polygon $next_x $next_y $x1 $y1
	return $Polygon
}
###############################################################################
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_StateMaSymResizePoints {ObjArrName CanInfoArr ObjID} {

	variable ResizePointsColor

	set TagList [list StateMaSymRP RPparent$ObjID stack_StateMaSymRP_Bottom]

	set StackOrderSuccessorTag [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_StateMaSymRP_Bottom]

	::olSDL_ViewsDrawMethods::draw_RecObjects_ResizePoints $ObjArrName $CanInfoArr $TagList $StackOrderSuccessorTag \
		$ObjID $ResizePointsColor
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::delete_StateMaSym_RP_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_StateMaSym $ObjArr($ObjID,Type)] } {
		error "unknown symbol type"
		return
	}

	$CanvasPathName delete RPparent$ObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::delete_StateMaSymComp_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_StateMaSym $ObjArr($ObjID,Type)] } {
		error "unknown symbol type"
		return
	}

	$CanvasPathName delete PartOf$ObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::delete_StateMaSym_and_Comp_from_Canvas {ObjArrName CanInfoArr StateMaSymID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_StateMaSym $ObjArr($StateMaSymID,Type)] } {
		error "object no StateMaSym"
		return
	}

	delete_StateMaSymComp_from_Canvas $ObjArrName $CanInfoArr $StateMaSymID

	$CanvasPathName delete $StateMaSymID
}

###############################################################################
# FlowLine
###############################################################################
proc ::olSDL_ViewsDrawMethods::delete_NormalFlowLine_from_Canvas {ObjArrName CanInfoArr FlowLineID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_FlowLine $ObjArr($FlowLineID,Type)] } {
		error "object no flow line"
		return
	}

	$CanvasPathName delete $FlowLineID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_FlowLine {CanvasPathName b_EndingArrow Coords OldObjID out_CanObjID} {

	upvar $out_CanObjID CanObjID

	if { $OldObjID != "none" } {
		$CanvasPathName coords $OldObjID $Coords
		set tempChanID $OldObjID
	} else {
		if { $b_EndingArrow } {
			set CanObjID [$CanvasPathName create line $Coords -width 1 -arrow last -tag {FlowLine selectableFlowLine stack_FlowLine_Bottom} ]
		} else {
			set CanObjID [$CanvasPathName create line $Coords -width 1 -tag {FlowLine selectableFlowLine stack_FlowLine_Bottom} ]
		}
		set tempChanID $CanObjID
	}

	$CanvasPathName lower $tempChanID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_FlowLine_Bottom]
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_FlowLine_MovePoints {ObjArrName CanInfoArr FlowLineID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	variable FlowLineMP_Color
	variable ResizePointsSize

	set CanvasPathName $CanInfo(CanvasPathName)

	set InnerFlowLineMP_Index 0
	set MP_Number [expr [llength $ObjArr($FlowLineID,Coords)] / 2]

	foreach {MP_x MP_y} "$ObjArr($FlowLineID,Coords)" {

		if { ($InnerFlowLineMP_Index != 0) && ($InnerFlowLineMP_Index != ($MP_Number -1)) } {
			#
		} else {
			set TagList [list FlowLineMP MPparent$FlowLineID stack_FlowLine_MP_Bottom]

			set x_left_up [expr $MP_x - $ResizePointsSize]
			set y_left_up [expr $MP_y - $ResizePointsSize]
			set x_right_down [expr $MP_x + $ResizePointsSize]
			set y_right_down [expr $MP_y + $ResizePointsSize]

			set MPObjID [$CanvasPathName create rectangle \
				$x_left_up $y_left_up $x_right_down $y_right_down \
				-fill $FlowLineMP_Color -tag $TagList]

			$CanvasPathName lower $MPObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_FlowLine_MP_Bottom]
		}

		incr InnerFlowLineMP_Index 1
	}
	# foreach {MP_x MP_y} "$ObjArr($FlowLineID,Coords)"

}
###############################################################################
proc ::olSDL_ViewsDrawMethods::delete_FlowLine_MP_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_FlowLine $ObjArr($ObjID,Type)] } {
		error "object no FlowLine"
		return
	}

	$CanvasPathName delete MPparent$ObjID
}
###############################################################################
# END: FlowLine
###############################################################################

###############################################################################
# DecisionFlowLine
###############################################################################

proc ::olSDL_ViewsDrawMethods::draw_DecisionFlowLine {CanvasPathName b_EndingArrow Coords OldObjID out_CanObjID} {

	upvar $out_CanObjID CanObjID

	if { $OldObjID != "none" } {
		$CanvasPathName coords $OldObjID $Coords
		set DecisionFlowLineID $OldObjID
	} else {
		if {$b_EndingArrow} {
			set CanObjID [$CanvasPathName create line $Coords -width 1 -arrow last -tag {DecisionFlowLine selectableDecisionFlowLine stack_DecisionFlowLine_Bottom} ]
		} else {
			set CanObjID [$CanvasPathName create line $Coords -width 1 -tag {DecisionFlowLine selectableDecisionFlowLine stack_DecisionFlowLine_Bottom} ]
		}
		set DecisionFlowLineID $CanObjID
	}

	$CanvasPathName lower $DecisionFlowLineID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_DecisionFlowLine_Bottom]
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::delete_DecisionFlowLine_and_Comp_from_Canvas {ObjArrName CanInfoArr DecisionFlowLineID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_DecisionFlowLine $ObjArr($DecisionFlowLineID,Type)] } {
		error "object no decision flow line"
		return
	}

	set DecFlowLineCompID [::olSDL_Views::FlowLine::_get_ID_from_DecFlowLineComp $ObjArrName $CanInfoArr $DecisionFlowLineID]


	$CanvasPathName delete $DecisionFlowLineID

	$CanvasPathName delete FlowLineComp$DecisionFlowLineID

	$CanvasPathName delete PartOfFlowLineComp$DecFlowLineCompID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_DecisionFlowLine_MovePoints {ObjArrName CanInfoArr DecisionFlowLineID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	variable FlowLineMP_Color
	variable ResizePointsSize

	set CanvasPathName $CanInfo(CanvasPathName)

	set InnerFlowLineMP_Index 0
	set MP_Number [expr [llength $ObjArr($DecisionFlowLineID,Coords)] / 2]

	foreach {MP_x MP_y} "$ObjArr($DecisionFlowLineID,Coords)" {

		if { ($InnerFlowLineMP_Index != 0) && ($InnerFlowLineMP_Index != ($MP_Number -1)) } {
			#
		} else {
			set TagList [list DecisionFlowLineMP MPparent$DecisionFlowLineID stack_DecisionFlowLine_MP_Bottom]

			set x_left_up [expr $MP_x - $ResizePointsSize]
			set y_left_up [expr $MP_y - $ResizePointsSize]
			set x_right_down [expr $MP_x + $ResizePointsSize]
			set y_right_down [expr $MP_y + $ResizePointsSize]

			set MPObjID [$CanvasPathName create rectangle \
				$x_left_up $y_left_up $x_right_down $y_right_down \
				-fill $FlowLineMP_Color -tag $TagList]

			$CanvasPathName lower $MPObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_DecisionFlowLine_MP_Bottom]
		}

		incr InnerFlowLineMP_Index 1
	}
	# foreach {MP_x MP_y} "$ObjArr($DecisionFlowLineID,Coords)"
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::delete_DecisionFlowLine_MP_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_DecisionFlowLine $ObjArr($ObjID,Type)] } {
		error "object no DecisionFlowLine"
		return
	}

	$CanvasPathName delete MPparent$ObjID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_DecisionFlowLineComp {can DecisionFlowLineID PaS Text OldObjID HL_Style out_CanObjID} {

	upvar $out_CanObjID CanObjID

	::olSDL_ViewsCalcCoor::get_RecCoords_fromPaS $PaS x1 y1 x2 y2

	# sensitive, unsichtbare Flche erzeugen
	if { $OldObjID != "none" } {
		$can coords $OldObjID $x1 $y1 $x2 $y2
		set tempObjID $OldObjID
	} else {
		set TagList [list FlowLineComp$DecisionFlowLineID selectableDecFlowLineComp movableDecFlowLineComp]
		set CanObjID [$can create rectangle $x1 $y1 $x2 $y2 -tag $TagList -width 0]
		set tempObjID $CanObjID
	}

	# massiver Hintergrund
	set TagList [list PartOfFlowLineComp$tempObjID stack_DecFlowLine_CompDec_Bottom]

	if { $HL_Style == $DecFlowLineComp_HL_Style::normal } {

		# set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $::olSDL_Views::CanvasBgColor -tag $TagList]
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -tag $TagList]

	} elseif { $HL_Style == $DecFlowLineComp_HL_Style::flowline_membership } {
		set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -fill $DecFlowLineComp_HL_Style::color_condition_membership -tag $TagList]
	} else {
		error "wrong highlight style"
	}

	$can lower $CompObjID [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_DecFlowLine_CompDec_Bottom]
	set PredecessorID $CompObjID

	set TagList [list PartOfFlowLineComp$tempObjID]


	# sichtbarer Rahmen
	# set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 1 -tag $TagList]
	set CompObjID [$can create rectangle $x1 $y1 $x2 $y2 -width 0 -tag $TagList]

	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# Text
	set CutText [::olSDL_ViewsCalcCoor::cut_Text $Text $PaS]

	set CompObjID [$can create text [expr $x1 + 1] $y1 -text $CutText -anchor nw -tag $TagList]
	$can raise $CompObjID $PredecessorID
	set PredecessorID $CompObjID

	# sensitive, unsichtbare Flche nach oben
	$can raise $tempObjID $PredecessorID
}
###############################################################################
proc ::olSDL_ViewsDrawMethods::delete_DecisionFlowLineComp_Comp_from_Canvas {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_DecFlowLineComp $ObjArr($ObjID,Type)] } {
		error "object no decision flow line component"
		return
	}

	$CanvasPathName delete PartOfFlowLineComp$ObjID
}
###############################################################################
###############################################################################
proc ::olSDL_ViewsDrawMethods::draw_DecisionFlowLineComp_ResizePoints {ObjArrName CanInfoArr DecisionFlowLineCompID} {

	variable ResizePointsColor

	set TagList [list DecisionFlowLineCompRP RPparent$DecisionFlowLineCompID stack_DecFlowLine_CompDec_RP_Bottom]

	set StackOrderSuccessorTag [::olSDL_Views::AllViews::get_StackOrderSuccessor stack_DecFlowLine_CompDec_RP_Bottom]

	::olSDL_ViewsDrawMethods::draw_RecObjects_ResizePoints $ObjArrName $CanInfoArr $TagList $StackOrderSuccessorTag \
		$DecisionFlowLineCompID $ResizePointsColor

}
###############################################################################
proc ::olSDL_ViewsDrawMethods::delete_DecisionFlowLineComp_ResizePoints {ObjArrName CanInfoArr ObjID} {

	upvar #0 $CanInfoArr CanInfo
	upvar #0 $ObjArrName ObjArr

	set CanvasPathName $CanInfo(CanvasPathName)

	if { ! [::olSDL_Views::is_DecFlowLineComp $ObjArr($ObjID,Type)] } {
		error "object no decision flow line component"
		return
	}

	$CanvasPathName delete RPparent$ObjID
}
###############################################################################


###############################################################################
# END: DecisionFlowLine
###############################################################################

