package provide olSDL_Views 1

####################################################
# namespace olSDL_Views
####################################################

namespace eval olSDL_ViewsTree {

}

##########################################################################
proc ::olSDL_ViewsTree::load_RootDia_from_Model { }  {

	upvar #0 ::olSDL_MAR::arr_MAR MAR

	get_System_Model_ID

	set System_Model_ID $MAR(System_Model_ID)

	get_AllReferencedDiagrams_from_Model $System_Model_ID

	set SysDiaImage ${olSDL_AppVar::MyImagesPath}/Tree/olSDL_TreeSysDia

	$::olSDL_AppVar::SystemTree insert end root $System_Model_ID -text [_cut_Text [::olSDL_Views::MAR_StringToString $MAR(Text)]] -image [Bitmap::get $SysDiaImage] -fill black

	ShowCurrentDiagram $System_Model_ID

	foreach RefDiagramID $MAR(IDs) {
		load_from_Model $System_Model_ID $RefDiagramID
	}
}
##########################################################################
proc ::olSDL_ViewsTree::load_from_Model {ParentDiagramID Diagram_Model_ID}  {

	upvar #0 ::olSDL_MAR::arr_MAR MAR

	get_AllReferencedDiagrams_from_Model $Diagram_Model_ID

	if { $MAR(DiaType) == "BlkDia" } {
		set Image ${olSDL_AppVar::MyImagesPath}/Tree/olSDL_TreeBlkInstDia
	} elseif { $MAR(DiaType) == "ProDia" } {
		set Image ${olSDL_AppVar::MyImagesPath}/Tree/olSDL_TreeProInstDia
	} elseif { $MAR(DiaType) == "ProcedureDia" } {
		set Image ${olSDL_AppVar::MyImagesPath}/Tree/olSDL_TreeProcedureInstDia
	}

	$::olSDL_AppVar::SystemTree insert end $ParentDiagramID $Diagram_Model_ID -text [_cut_Text [::olSDL_Views::MAR_StringToString $MAR(Text)]] -image [Bitmap::get $Image] -fill black

	foreach RefDiagramID $MAR(IDs) {
		load_from_Model $Diagram_Model_ID $RefDiagramID
	}
}
##########################################################################
proc ::olSDL_ViewsTree::ReferencingSymbolAdded {ParentDiagramID Diagram_Model_ID}  {

	load_from_Model $ParentDiagramID $Diagram_Model_ID
}
##########################################################################
proc ::olSDL_ViewsTree::ReferencingSymbolDeleted {Diagram_Model_ID} {

	$::olSDL_AppVar::SystemTree delete [list $Diagram_Model_ID]
}
##########################################################################
proc ::olSDL_ViewsTree::PageDeleted {Diagram_Model_ID} {

	set ParentID [$::olSDL_AppVar::SystemTree parent $Diagram_Model_ID]

	$::olSDL_AppVar::SystemTree delete [list $Diagram_Model_ID]


	if { $ParentID == "root" } {
		load_RootDia_from_Model
	} else {
		load_from_Model $ParentID $Diagram_Model_ID
	}

	ShowCurrentDiagram $Diagram_Model_ID
}
##########################################################################
proc ::olSDL_ViewsTree::ReferencingSymbolModified {Diagram_Model_ID NewText} {

	$::olSDL_AppVar::SystemTree itemconfigure $Diagram_Model_ID -text [_cut_Text $NewText]
}
##########################################################################
proc ::olSDL_ViewsTree::SysDiaNameModified {NewText} {

	upvar #0 ::olSDL_MAR::arr_MAR MAR

	get_System_Model_ID
	set System_Model_ID $MAR(System_Model_ID)

	$::olSDL_AppVar::SystemTree itemconfigure $System_Model_ID -text [_cut_Text $NewText]
}
##########################################################################
proc ::olSDL_ViewsTree::ShowCurrentDiagram {Diagram_Model_ID} {

	$::olSDL_AppVar::SystemTree selection set [list $Diagram_Model_ID]

	_show_whole_Path $Diagram_Model_ID
}
##########################################################################
proc ::olSDL_ViewsTree::TextSingleClick {node} {
	upvar #0 ::olSDL_Views::arr_Views Views
	upvar #0 ::olSDL_MAR::arr_MAR MAR

	set CurrentViewID $Views(Current)
	set CurrentObjArr $Views($CurrentViewID,NameOfObjArr)
	set CurrentCanInfoArr $Views($CurrentViewID,NameOfCanInfoArr)

	##############
	# get FirstPageID

	get_FirstPageID_from_Model $node

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set FirstPageID $MAR(FirstPageID)

	# END: get FirstPageID
	##############

	##############
	# get Parent Diagram Type

	get_PageFrameInfo_from_Model $node $FirstPageID

	if {$MAR(Result) != "MAR_OK"} {
		error "Model Access"
	}

	set ParentDiagramType $MAR(HP_DiaType)

	# get Parent Diagram Type
	##############

	::olSDL_Views::ViewsManager::DeleteOldViewAndChangeToNewView $CurrentViewID $ParentDiagramType $node $FirstPageID

	###################
	#update SDL-Tree

	::olSDL_ViewsTree::ShowCurrentDiagram $node

	#update SDL-Tree
	###################

	# indicator
	::olSDL_MainMenu::update_Indicator

}
##########################################################################
proc ::olSDL_ViewsTree::TextDoubleClick {node} {
	if {[$::olSDL_AppVar::SystemTree visible [$::olSDL_AppVar::SystemTree nodes $node 0]]} {
		$::olSDL_AppVar::SystemTree closetree $node
	} else {
		$::olSDL_AppVar::SystemTree opentree $node false
	}
	::olSDL_ViewsTree::TextSingleClick $node
}
##########################################################################

##########################################################################
##########################################################################
proc ::olSDL_ViewsTree::_show_whole_Path {Diagram_Model_ID} {

	set ParentID [$::olSDL_AppVar::SystemTree parent $Diagram_Model_ID]

	if { $ParentID != "root" } {

		if { [$::olSDL_AppVar::SystemTree itemcget $ParentID -open] != 1 } {
			$::olSDL_AppVar::SystemTree itemconfigure $ParentID -open 1
		}

		_show_whole_Path $ParentID
	}
}
##########################################################################
proc ::olSDL_ViewsTree::_cut_Text {InText} {

	set MaxTextLength 15

	set FirstRow [lindex [split $InText] 0]

	set LengthFirstRow [string length $FirstRow]

	if { $LengthFirstRow <= $MaxTextLength } {
		return $FirstRow
	} else {
		return [string range $FirstRow 0 [expr $MaxTextLength -1]]
	}

}
##########################################################################
proc ::olSDL_ViewsTree::_printAllNodes {ParentNode} {

	puts Parent
	puts $ParentNode

	set AllChildren [$::olSDL_AppVar::SystemTree nodes $ParentNode]
	puts Children
	puts $AllChildren

	foreach Child $AllChildren {
		_printAllNodes $Child
	}

}
##########################################################################
