# globale Variablen

global dummy_test_canvas

namespace eval olSDL_AppVar {
#TODO Fix dependencies between library and path settings
	if {[catch {set env(PEPHOME)}]} {
	  variable ApplInstPath .

	  variable MyTclPath [file join $ApplInstPath tcl]
	  variable MyImagesPath [file join $MyTclPath images]
	} else {
	  variable MyTclPath [file join $env(PEPHOME) lib sdl]
	  variable MyImagesPath [file join $env(PEPHOME) bitmaps sdl]
	}
	variable MyTclLibPath [file join $MyTclPath lib]

	lappend auto_path $MyTclPath
	lappend auto_path $MyTclLibPath

	package require sdl

	variable MyProjectsDir $::DefaultProjectsDir

	variable MIN_FRAME_WIDTH 640
	variable MIN_FRAME_HEIGHT 480

	variable IndicatorPageWidth
	variable IndicatorPageHeight
	variable IndicatorFrameWidth
	variable IndicatorFrameHeight

	variable mainFrame
	variable panedWin
	variable TreeViewArea
	variable SystemTree
	variable SDLViewArea
	variable SDLViewToolbarFrame
	variable MainMenu

	namespace eval OptionVar {

		variable FileNameCurrentSysSpec {}
	}

	namespace eval SettingVar {

		variable ChanpCompWithBorder false
	}

	unset ::ApplInstPath
	unset ::DefaultProjectsDir
}
####################################################
# namespace olSDL_MAR
####################################################
namespace eval olSDL_MAR {

	variable arr_MAR
	array set arr_MAR { }
}
####################################################
# namespace olSDL_Editor
####################################################
namespace eval olSDL_Editor {

}
####################################################
proc ::olSDL_Editor::Main  { } {
	global argv argc
	upvar #0 ::olSDL_MAR::arr_MAR MAR

	_Paket_Index_erzeugen
	_Pakete_importieren

	_Oberflaeche_erzeugen

	if {$argc >0} {
	  ::olSDL_MainMenu::_load_SysSpec_from_file [lindex $argv 0]
	} else {
		create_EmptySysSpec
		::olSDL_MainMenu::AfterLoadSysSpec
		set ::olSDL_AppVar::OptionVar::CurrentSysSpecStored false
		set ::olSDL_AppVar::OptionVar::FileNameCurrentSysSpec {}
		::olSDL_MainMenu::update_Title
	}
}
####################################################
proc ::olSDL_Editor::_Paket_Index_erzeugen { } {
	# Paketindex pkgIndex.tcl erzeugen

	pkg_mkIndex $::olSDL_AppVar::MyTclLibPath \
		Views/sdlViews.tcl \
		Views/sdlViewsDrawMethods.tcl \
		Views/sdlViewsDrawMethodsStateMaSym.tcl \
		Views/sdlViewsCalcCoor.tcl \
		Views/sdlViewsTree.tcl \
		MainMenu/MainMenu.tcl \
		Dialogs/sdlDialogs.tcl \
		helper.tcl \
		PageFrame/sdlPageFrame.tcl \
		SysDia/sdlSysDiaView.tcl \
		SysDia/sdlSysDiaViewBack.tcl \
		BlkDia/sdlBlkDiaView.tcl \
		BlkDia/sdlBlkDiaViewBack.tcl \
		ProDia/sdlProDiaView.tcl \
		ProDia/sdlProDiaViewBack.tcl \
		ProcedureDia/sdlProcedureDiaView.tcl \
		ProcedureDia/sdlProcedureDiaViewBack.tcl \
		RecObjRP/sdlRecObjRP.tcl \
		RecSym/sdlViewsRecSym.tcl \
		StateMaSym/sdlViewsStateMaSym.tcl \
		StateMaSym/sdlViewsFlowLine.tcl \
		Channel/sdlViewsChanA.tcl \
		Channel/sdlViewsChanB.tcl \
		Channel/sdlViewsChanC.tcl \
		Channel/sdlViewsChanStore.tcl
}
####################################################
proc ::olSDL_Editor::_Pakete_importieren { } {

	package require BWidget 1.6.0

	package require -exact olSDL_Views 1
	package require -exact olSDL_ViewsDrawMethods 1
	package require -exact olSDL_ViewsCalcCoor 1

	package require -exact olSDL_Helper 1

	package require -exact olSDL_ViewsChan 1

	package require -exact olSDL_SysDiaView 1
	package require -exact olSDL_BlkDiaView 1
	package require -exact olSDL_ProDiaView 1
	package require -exact olSDL_ProcedureDiaView 1

}
####################################################
proc ::olSDL_Editor::_Oberflaeche_erzeugen { } {

	###########################
	# MainWindow: Gre, Position
	wm minsize . 400 400
	wm geometry . 650x500+300+100
	wm title . {SDL/GR-2000-Editor}
	wm protocol . WM_DELETE_WINDOW ::olSDL_MainMenu::ExitEditor

	###########################
	#Menbeschreibung
	set descmenu {
       		"&File" all file 0 {
			{command "&New" {} "new SysSpec" {} -command "::olSDL_MainMenu::CreateEmptySysSpec"}
			{command "&Load" {} "load SysSpec" {} -command "::olSDL_MainMenu::FileLoadCommand"}
			{command "&Save" {} "save SysSpec" {} -command "::olSDL_MainMenu::FileSaveCommand"}
			{command "Save &As" {} "save SysSpec as" {} -command "::olSDL_MainMenu::FileSaveAsCommand"}
           		{command "E&xit" {} "Exit Editor" {} -command "::olSDL_MainMenu::ExitEditor"}
       		}
		"F&rame" {} pageframe 0 {
			{cascad "Grow X" {} growx 0 {
				{command "50" {} {} {} -command {::olSDL_MainMenu::GrowPageFrameX 50} }
				{command "100" {} {} {} -command {::olSDL_MainMenu::GrowPageFrameX 100} }
				{command "300" {} {} {} -command {::olSDL_MainMenu::GrowPageFrameX 300} }
				}
			}
			{cascad "Grow Y" {} growy 0 {
				{command "50" {} {} {} -command {::olSDL_MainMenu::GrowPageFrameY 50} }
				{command "100" {} {} {} -command {::olSDL_MainMenu::GrowPageFrameY 100} }
				{command "300" {} {} {} -command {::olSDL_MainMenu::GrowPageFrameY 300} }
				}
			}
			{cascad "Shrink X" {} shrinkx 0 {
				{command "50" {} {} {} -command {::olSDL_MainMenu::ShrinkPageFrameX 50} }
				{command "100" {} {} {} -command {::olSDL_MainMenu::ShrinkPageFrameX 100} }
				{command "300" {} {} {} -command {::olSDL_MainMenu::ShrinkPageFrameX 300} }
				}
			}
			{cascad "Shrink Y" {} shrinky 0 {
				{command "50" {} {} {} -command {::olSDL_MainMenu::ShrinkPageFrameY 50} }
				{command "100" {} {} {} -command {::olSDL_MainMenu::ShrinkPageFrameY 100} }
				{command "300" {} {} {} -command {::olSDL_MainMenu::ShrinkPageFrameY 300} }
				}
			}
		}
		"&Page" {} page 0 {
			{command "Add Page" {} {} {} -command {::olSDL_MainMenu::AddPage} }
			{command "Delete Page" {} {} {} -command {::olSDL_MainMenu::DeletePage} }
			{cascad "Goto Page" {} gotopage 0 {
				{command "Next" {} {} {} -command {::olSDL_MainMenu::GotoPage next} }
				{command "Previous" {} {} {} -command {::olSDL_MainMenu::GotoPage previous} }
				{command "First" {} {} {} -command {::olSDL_MainMenu::GotoPage first} }
				{command "Last" {} {} {} -command {::olSDL_MainMenu::GotoPage last} }
				}
			}
		}
		"&Settings" {} setting 0 {
			{checkbutton "ChanCompBorder" {} "Show/Hide Channel Comp Border" {}
				-variable ::olSDL_AppVar::SettingVar::ChanpCompWithBorder
				-command ::olSDL_MainMenu::OnChanCompBorderChange
			}
		}
	}

	###########################
	# MainFrame
	set ::olSDL_AppVar::mainFrame [MainFrame .mainFrame -menu $descmenu]

	###########################
	# indicator

	set ::olSDL_AppVar::IndicatorPageWidth [$::olSDL_AppVar::mainFrame addindicator -text "PW: "]
	set ::olSDL_AppVar::IndicatorPageHeight [$::olSDL_AppVar::mainFrame addindicator -text "PH: "]
	set ::olSDL_AppVar::IndicatorFrameWidth [$::olSDL_AppVar::mainFrame addindicator -text "FW: "]
	set ::olSDL_AppVar::IndicatorFrameHeight [$::olSDL_AppVar::mainFrame addindicator -text "FH: "]

	# indicator
	###########################

	###########################
	#Toolbar
	set tb1  [$::olSDL_AppVar::mainFrame addtoolbar]

		######

 	set bbox [ButtonBox $tb1.bbox1 -spacing 0 -padx 1 -pady 1]

	set Callback "::olSDL_MainMenu::CreateEmptySysSpec"
  	$bbox add -image [Bitmap::get new] \
   		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "New SysSpec" -command "$Callback"

	set Callback "::olSDL_MainMenu::FileLoadCommand"
	$bbox add -image [Bitmap::get open] \
   		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Load SysSpec" -command "$Callback"

	set Callback "::olSDL_MainMenu::FileSaveCommand"
	$bbox add -image [Bitmap::get save] \
   		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Save SysSpec" -command "$Callback"

	pack $bbox -side left -anchor w

		######

	set sepA [Separator $tb1.sepA -orient vertical]
	pack $sepA -side left -fill y -padx 4 -anchor w

 	set bbox3 [ButtonBox $tb1.bbox3 -spacing 0 -padx 1 -pady 1]

	set Callback "::olSDL_MainMenu::SaveEPS_Command"
	set EPS_Image ${olSDL_AppVar::MyImagesPath}/MainToolbarButton/olSDL_eps
	$bbox3 add -image [Bitmap::get $EPS_Image] \
   		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Save Page As EPS" -command "$Callback"

	pack $bbox3 -side left -anchor w

		######

	set sepB [Separator $tb1.sepB -orient vertical]
	pack $sepB -side left -fill y -padx 4 -anchor w

 	set bbox4 [ButtonBox $tb1.bbox4 -spacing 0 -padx 1 -pady 1]

	set Callback "::olSDL_MainMenu::SavePR_Command false"
	set PR_Image ${olSDL_AppVar::MyImagesPath}/MainToolbarButton/olSDL_pr
	$bbox4 add -image [Bitmap::get $PR_Image] \
   		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "generate PR" -command "$Callback"

	pack $bbox4 -side left -anchor w

		######

	set sepD [Separator $tb1.sepD -orient vertical]
	pack $sepD -side left -fill y -padx 4 -anchor w

 	set bbox5 [ButtonBox $tb1.bbox5 -spacing 0 -padx 1 -pady 1]

	set Callback "::olSDL_MainMenu::SavePR_Command true"
	set PR_Image ${olSDL_AppVar::MyImagesPath}/MainToolbarButton/olSDL_pr_inline
	$bbox5 add -image [Bitmap::get $PR_Image] \
   		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "generate Inline-PR" -command "$Callback"

	pack $bbox5 -side left -anchor w

		######

	set sepC [Separator $tb1.sepC -orient vertical]
	pack $sepC -side left -fill y -padx 4 -anchor w

 	set bbox2 [ButtonBox $tb1.bbox2 -spacing 0 -padx 1 -pady 1]

	set Callback "::olSDL_MainMenu::GotoPage first"
	set FirstPageImage ${olSDL_AppVar::MyImagesPath}/MainToolbarButton/olSDL_FirstPage
	$bbox2 add -image [Bitmap::get $FirstPageImage] \
   		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "First Page" -command "$Callback"

	set Callback "::olSDL_MainMenu::GotoPage previous"
	set PreviousPageImage ${olSDL_AppVar::MyImagesPath}/MainToolbarButton/olSDL_PreviousPage
	$bbox2 add -image [Bitmap::get $PreviousPageImage] \
   		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Previous Page" -command "$Callback"

	set Callback "::olSDL_MainMenu::GotoPage next"
	set NextPageImage ${olSDL_AppVar::MyImagesPath}/MainToolbarButton/olSDL_NextPage
	$bbox2 add -image [Bitmap::get $NextPageImage] \
   		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Next Page" -command "$Callback"

	set Callback "::olSDL_MainMenu::GotoPage last"
	set LastPageImage ${olSDL_AppVar::MyImagesPath}/MainToolbarButton/olSDL_LastPage
	$bbox2 add -image [Bitmap::get $LastPageImage] \
   		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Last Page" -command "$Callback"

	set Callback "::olSDL_MainMenu::AddPage"
	set AddPageImage ${olSDL_AppVar::MyImagesPath}/MainToolbarButton/olSDL_AddPage
	$bbox2 add -image [Bitmap::get $AddPageImage] \
   		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Add Page" -command "$Callback"

	set Callback "::olSDL_MainMenu::DeletePage"
	set DeletePageImage ${olSDL_AppVar::MyImagesPath}/MainToolbarButton/olSDL_DeletePage
	$bbox2 add -image [Bitmap::get $DeletePageImage] \
   		-highlightthickness 0 -takefocus 0 -relief link -borderwidth 1 -padx 1 -pady 1 \
    		-helptext "Delete Page" -command "$Callback"

	pack $bbox2 -side left -anchor w

	###########################
	#PanedWindow
	set frame [$::olSDL_AppVar::mainFrame getframe]

	# Toolbar Frame
	set ::olSDL_AppVar::SDLViewToolbarFrame [frame ${frame}.tbf_SDLView -width 100]

	set ::olSDL_AppVar::panedWin [PanedWindow ${frame}.pw1 -weights available]

		###########################
		#TreeViewArea als Pane
		set ::olSDL_AppVar::TreeViewArea [$::olSDL_AppVar::panedWin add -minsize 100 -weight 1]
		#puts $::olSDL_AppVar::TreeViewArea

			###########################
			# create Tree

    			set ViewTitleFrame [TitleFrame ${::olSDL_AppVar::TreeViewArea}.titf -text {SDL-Tree}]
			set sw [ScrolledWindow [$ViewTitleFrame getframe].sw -relief sunken -borderwidth 2]

			set ::olSDL_AppVar::SystemTree \
				[Tree ${sw}.tree -relief sunken -borderwidth 1 -width 30 -highlightthickness 1 -selectbackground white]

			$::olSDL_AppVar::SystemTree bindText <ButtonPress-1> "::olSDL_ViewsTree::TextSingleClick"
			$::olSDL_AppVar::SystemTree bindImage <ButtonPress-1> "::olSDL_ViewsTree::TextSingleClick"

			$::olSDL_AppVar::SystemTree bindText <Double-ButtonPress-1> "::olSDL_ViewsTree::TextDoubleClick"
			$::olSDL_AppVar::SystemTree bindImage <Double-ButtonPress-1> "::olSDL_ViewsTree::TextDoubleClick"

		 	$sw setwidget $::olSDL_AppVar::SystemTree

			pack $sw -fill both -expand true
			pack $ViewTitleFrame -fill both -expand true

			# create Tree
			###########################

		###########################
		#SDLViewArea als Pane
		set ::olSDL_AppVar::SDLViewArea [$::olSDL_AppVar::panedWin add -minsize 100 -weight 4]

			# scrolbares canvas erzeugen
  			set SDLViewAreaTitleFrame [TitleFrame ${::olSDL_AppVar::SDLViewArea}.titf -text {SDL-View-Area}]

			set frame [$SDLViewAreaTitleFrame getframe]

			set ::olSDL_AppVar::SDLViewScrolledWindow [ScrolledWindow ${frame}.sw -relief sunken -auto both]

			pack $::olSDL_AppVar::SDLViewScrolledWindow -fill both -expand true
			pack $SDLViewAreaTitleFrame -fill both -expand true

	###########################
	#packen

	pack $::olSDL_AppVar::SDLViewToolbarFrame -side right -fill y

	pack $::olSDL_AppVar::panedWin -fill both -expand true
	pack $::olSDL_AppVar::mainFrame -fill both -expand true
}
# ENDE: _Oberflaeche_erzeugen
####################################################
####################################################

####################################################
# ENDE: namespace olSDL_Editor
####################################################

#Start
::olSDL_Editor::Main

