/*
       Threads. java
 */

import dnx.lr.*;
import dnx.lr.node.*;
import dnx.lr.app.*;
import dnx.lr.field.*;
import dnx.geom.*;
import dnx.awtutil.*;
import java.awt.Toolkit;
import java.awt.Image;
import java.net.MalformedURLException;
import java.io.File;
import java.util.*;
import java.awt.*;
import java.net.URL;
import java.applet.*;
import java.io.*;
import java.lang.*;
import Browse;
import jcom;

class AppearanceThread extends Thread {

   MaterialNode mn;
   float d1, d2, d3, e1, e2, e3, spec, shin, amb,trans;
   int maxSteps;
   String id;

   // Constructor
   public AppearanceThread (MaterialNode mn, float d1, float d2, float d3, float e1, float e2, float e3,
				float spec, float shin, float amb, float trans, int maxSteps, String id) {

	this.mn = mn;
	this.d1 = d1 ;
	this.d2 = d2;
	this.d3 = d3;
	this.e1 = e1;
	this.e2 = e2;
	this.e3 = e3;
	this.spec = spec;
	this.shin = shin;
	this.amb = amb;
	this.trans = trans;
	this.maxSteps = maxSteps;
	this.id = id;
	this.start();
   }

   public void init() { }

   public void run() {

	int i;

	//System.out.println( mn.diffuseColor.toString() );

	float current_d1    = mn.diffuseColor.getRed();
	float current_d2    = mn.diffuseColor.getGreen();
	float current_d3    = mn.diffuseColor.getBlue();
	float current_e1    = mn.emissiveColor.getRed();
	float current_e2    = mn.emissiveColor.getGreen();
	float current_e3    = mn.emissiveColor.getBlue();
	float current_spec  = mn.specularColor.getRed();
	float current_shin  = mn.shininess.getValue();
	float current_amb   = mn.ambientIntensity.getValue();
	float current_trans = mn.transparency.getValue();

	if (d1 == -1) { d1 = current_d1;}
	if (d2 == -1) { d2 = current_d2;}
	if (d3 == -1) { d3 = current_d3;}
	if (e1 == -1) { e1 = current_e1;}
	if (e2 == -1) { e2 = current_e2;}
	if (e3 == -1) { e3 = current_e3;}
	if (spec  == -1) { spec  = current_spec;}
	if (shin  == -1) { shin  = current_shin;}
	if (amb   == -1) { amb   = current_amb;}
	if (trans == -1) { trans = current_trans;}

	float dd1 = (current_d1 - d1)/maxSteps;
	float dd2 = (current_d2 - d2)/maxSteps;
	float dd3 = (current_d3 - d3)/maxSteps;
	float de1 = (current_e1 - e1)/maxSteps;
	float de2 = (current_e2 - e2)/maxSteps;
	float de3 = (current_e3 - e3)/maxSteps;
	float dspec  = (current_spec  - spec)/maxSteps;
	float dshin  = (current_shin  - shin)/maxSteps;
	float damb   = (current_amb   - amb)/maxSteps;
	float dtrans = (current_trans - trans)/maxSteps;

        for ( i=1; i<=maxSteps; i++) {

           current_d1    -= dd1;
           current_d2    -= dd2;
           current_d3    -= dd3;
           current_e1    -= de1;
           current_e2    -= de2;
           current_e3    -= de3;
           current_spec  -= dspec;
           current_shin  -= dshin;
           current_amb   -= damb;
           current_trans -= dtrans;

	   mn.diffuseColor.setValue( current_d1, current_d2, current_d3);
	   mn.emissiveColor.setValue( current_e1, current_e2, current_e3);
	   mn.specularColor.setValue( current_spec, current_spec, current_spec);
	   mn.shininess.setValue(current_shin);
	   mn.ambientIntensity.setValue(current_amb);
	   mn.transparency.setValue( current_trans );
	   
	   try { Thread.sleep( 20 ); }
	   catch (Exception e) {}; 
	}
	   mn.diffuseColor.setValue( d1, d2, d3);
	   mn.emissiveColor.setValue( e1, e2, e3);
	   mn.specularColor.setValue( spec, spec, spec);
	   mn.shininess.setValue(shin);
	   mn.ambientIntensity.setValue(amb);
	   mn.transparency.setValue( trans );

	// Finish
	jcom.send( "animationReady "+id );
   }
}

