/*
 * Browse.java
 */

import java.net.MalformedURLException;
import java.awt.*;
import java.net.URL;
import java.net.*;
import java.applet.*;
import java.io.*;
import java.lang.*;
import VrmlWindow;
import java.util.*;
import jcom;

public class Browse extends Frame {

   static String file, serverPort, clientPort;
   static VrmlWindow vrmlWindow;
   static VrmlWindow vrmlWindowNew;
   static Frame browse;
   static Button examine, walk, wire, flat, smooth, resetView, quit;
   static jcom comThread;
   static Panel vrmlPanel;

   public static void main( String argv[] ) throws IOException {
	if (argv.length != 3)
	{
          System.out.println( "Usage: Browse filename serverport vrmlport" );
	  System.exit(0);
	}
	browse = new Browse( argv[0], argv[1], argv[2] );
   }

   public Browse( String file, String serverPort, String clientPort ) 
			throws IOException {

	this.file = file;
	this.setTitle( "VRML Browser" );

	// Resize Frame
	// this.setSize(new Dimension(500, 400));   // JDK1.1.1
        this.resize(new Dimension(500, 400));  // JDK1.0.2 

	// Panels
	vrmlPanel   = new Panel();
	Panel buttonPanel = new Panel();

	// Objects
	vrmlWindow = new VrmlWindow( file );
	quit       = new Button("Quit");
	examine    = new Button("Examine");
	walk       = new Button("Walk");
	flat	   = new Button("Flat");
	smooth	   = new Button("Smooth");
	wire	   = new Button("Wire");
	resetView  = new Button("reset View");

	// Init Comunication
	comThread = new jcom( Integer.parseInt( serverPort ),
			Integer.parseInt( clientPort ));

	// Layout
	buttonPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 15, 10));
	vrmlWindow.setLayout(new BorderLayout());

	// Plop it in the Appletspace
	this.add("Center", vrmlWindow.view.getComponent() );

	// Plop button in the buttonPanel
	buttonPanel.add(examine);
	buttonPanel.add(walk);
	buttonPanel.add(wire);
	buttonPanel.add(flat);
	buttonPanel.add(smooth);
	buttonPanel.add(resetView);
	buttonPanel.add(quit);
   
	// Add buttonPanel 
	this.add("South",buttonPanel);
	//this.setVisible( true ); // JDK 1.1.1
	this.show();             // JDK 1.0.2
	
	// Send all NodeNames
	vrmlWindow.getAllNodeNames();

   }
// JDK 1.1.1
//   public void processEvent ( AWTEvent e ) {
//          Hier sind die entsprechenden AWTEvents abzufragen.
//	System.out.println( e.toString() );
//   }

// JDK 1.0.2
   public boolean handleEvent( Event e ) {

	if (e.target == quit) {
	   this.endSession();
	} else if (e.target == examine) {
	   vrmlWindow.setExamineViewer();
	} else if (e.target == walk) {
	   vrmlWindow.setWalkViewer();
	} else if (e.target == wire) {
	   jcom.send("msg Wireframe");
	   vrmlWindow.setRenderWireFrame();
	} else if (e.target == flat) {
	   jcom.send("msg Flat");
	   vrmlWindow.setRenderFlat();
	} else if (e.target == smooth) {
	   vrmlWindow.setRenderSmooth();
	   jcom.send("msg Smooth");
	} else if (e.target == resetView) {
	   vrmlWindow.resetViewpoint();
        } else {
          // System.out.println( "Unknown Event" );
           return false;
        }
        return true;
   }

   public static void endSession ( ) {
       jcom.send ("vrmlClosed");
       System.exit(0);
   }

   public static void endSessionServer ( ) {
       System.exit(0);
   }
}
