/*
       Threads. java
 */

import dnx.lr.*;
import dnx.lr.node.*;
import dnx.lr.app.*;
import dnx.lr.field.*;
import dnx.geom.*;
import dnx.awtutil.*;
import java.awt.Toolkit;
import java.awt.Image;
import java.net.MalformedURLException;
import java.io.File;
import java.util.*;
import java.awt.*;
import java.net.URL;
import java.applet.*;
import java.io.*;
import java.lang.*;
import Browse;
import jcom;

class JumpThread extends Thread {

   TransformNode tn;
   float dx, dy, dz, x, y, z, v0, g, alpha, jump_val, c1, c2, v0_2;
   float tan_1, cos_2, sin_2, sin2a, sm, dsm;
   Double angle_d, pi_d;
   Double angle;
   int maxSteps;
   String id;

   // Constructor
   public JumpThread (TransformNode tn, float x, float y, float z, float v0,
				float g, float alpha, int maxSteps, String id) {

	this.tn = tn;
	this.x = x;
	this.y = y;
	this.z = z;
	this.v0 = v0;
	this.g  = g;
	this.alpha = alpha;
	this.maxSteps = maxSteps;
	this.id = id;
	this.start();
   }

   public void init() { }

   public void run() {
	int i;
	float s = 0;

	angle_d = new Double( alpha );
	pi_d    = new Double( Math.PI/180 );

	alpha = pi_d.floatValue() * angle_d.floatValue();

	float[] translation = new float[3];
	tn.translation.getValue( translation );

	dx = (translation[0] - x) / maxSteps;
	dy = (translation[1] - y) / maxSteps;
	dz = (translation[2] - z) / maxSteps;

	tan_1 = (new Float (Math.tan(alpha))).floatValue();
	cos_2 = (new Float (Math.pow(Math.cos(alpha),2.0f))).floatValue();
	sin_2 = (new Float (Math.pow(Math.sin(alpha),2.0f))).floatValue();
	sin2a = (new Float (Math.sin( 2 * alpha) )).floatValue();
	v0_2  = (new Float (Math.pow(v0,2.0f))).floatValue();

	c1  = tan_1;
	c2  = g/( 2 * v0_2 * cos_2 );
	sm  = (v0_2 * sin2a) / g;
	dsm = sm / maxSteps;
		
        for ( i=0; i<maxSteps; i++) {

	   jump_val = (s*c1) - (s*s*c2);
	   s += dsm;

	   translation[0] -= dx;
	   translation[1] -= dy;
	   translation[2] -= dz;

	   tn.translation.setValue(translation[0], translation[1]+jump_val,
                                                translation[2]);
	   try { Thread.sleep( 20 ); }
	   catch (Exception e) {}; 
	}
	tn.translation.setValue(x, y, z);

	// Finish
	jcom.send( "animationReady "+id );
   }
}
