/*
       Threads. java
 */

import dnx.lr.*;
import dnx.lr.node.*;
import dnx.lr.app.*;
import dnx.lr.field.*;
import dnx.geom.*;
import dnx.awtutil.*;
import java.awt.Toolkit;
import java.awt.Image;
import java.net.MalformedURLException;
import java.io.File;
import java.util.*;
import java.awt.*;
import java.net.URL;
import java.applet.*;
import java.io.*;
import java.lang.*;
import Browse;
import jcom;

class RotateThread extends Thread {

   TransformNode tn;
   int useWorld, useCenter, maxSteps;
   float x, y, z, da, angle, cx, cy, cz;
   Double angle_d;
   Quaternion q, q_akt;
   String id;

   // Constructor
   public RotateThread (TransformNode tn, float x, float y, float z, float angle, 
			int useWorld, int useCenter, float cx, float cy, float cz, int maxSteps, String id) {

	this.tn        = tn;
	this.x         = x;
	this.y         = y;
	this.z         = z;
	this.angle     = angle;
	this.useCenter = useCenter;
	this.useWorld  = useWorld;
	this.cx        = cx;
	this.cy        = cy;
	this.cz        = cz;
	this.maxSteps  = maxSteps;
	this.id        = id;
	this.start();
   }

   public void init() { }

   public void run() {
	int i;

	// Wenn keine Achse eingegeben wurde...
	if ( x == 0 && y == 0 && z == 0) {
	   jcom.send( "animationReady "+id );
	   return;
	}

	// Winkel umrechnen
	angle_d = new Double ( angle );
	da = (float) ( (Math.PI/180) * angle_d.doubleValue() ) / maxSteps ;

	// Quaternion bzgl. Objektkoordinaten erzeugen
	float[] akt_rot = new float[4];
	tn.rotation.getValue( akt_rot );
	Vector3 vec_tmp = new Vector3 (akt_rot[0], akt_rot[1], akt_rot[2] );
	q_akt = new Quaternion( vec_tmp, akt_rot[3] );

	if ( useCenter == 1 ) {
	   VrmlWindow.changeCenter( tn, cx, cy, cz);
	}

	// Erzeugen des Rotationsvektors
	Vector3 rotationVector = new Vector3( x, y, z );
	rotationVector.normalize();

	// Rotations-Quaternion erzeugen
	q = new Quaternion ( );
	q.rotation(rotationVector, da);
	q.normalize( );

        for ( i=1; i<=maxSteps; i++) {    

	   if ( useWorld == 0 ) {
		// Objekt-Koordinaten
		q_akt.preMultiply( q );
	   } else {
		// Welt-Koordinaten
		q_akt.postMultiply( q );		
	   }

	   // Rotationswert setzen
           tn.rotation.setValue( q_akt );

	   try { Thread.sleep( 20 ); }
	   catch (Exception e) {}; 
	}

	// Finish
	jcom.send( "animationReady "+id );
   }
}
