/*
       Threads. java
 */

import dnx.lr.*;
import dnx.lr.node.*;
import dnx.lr.app.*;
import dnx.lr.field.*;
import dnx.geom.*;
import dnx.awtutil.*;
import java.awt.Toolkit;
import java.awt.Image;
import java.net.MalformedURLException;
import java.io.File;
import java.util.*;
import java.awt.*;
import java.net.URL;
import java.applet.*;
import java.io.*;
import java.lang.*;
import Browse;
import jcom;

class ScaleThread extends Thread {

   TransformNode tn;
   float dx, dy, dz, cx, cy, cz;
   int maxSteps, useCenter;
   String id;

   public ScaleThread (TransformNode tn, float dx, float dy, float dz, int useCenter,
			float cx, float cy, float cz, int maxSteps, String id) {

	this.tn        = tn;
	this.dx        = dx;
	this.dy        = dy;
	this.dz        = dz;
	this.cx        = cx;
	this.cy        = cy;
	this.cz        = cz;
	this.useCenter = useCenter;
	this.maxSteps  = maxSteps;
	this.id        = id;
	this.start();
   }

   public void init() { }

   public void run() {
	int i;

	if ( useCenter == 1 ) {
	   VrmlWindow.changeCenter( tn, cx, cy, cz);
	}

	// get current values
        float[] scale = new float[3];
	tn.scale.getValue( scale );
		
        for ( i=1; i<=maxSteps; i++) {
	   scale[0] -= dx;
	   scale[1] -= dy;
	   scale[2] -= dz;
	   tn.scale.setValue(scale[0], scale[1], scale[2]);

	   try { Thread.sleep( 20 ); }
	   catch (Exception e) {}; 
	}

	// Finish
	jcom.send( "animationReady "+id );
   }
}
