/*
       Threads. java
 */

import dnx.lr.*;
import dnx.lr.node.*;
import dnx.lr.app.*;
import dnx.lr.field.*;
import dnx.geom.*;
import dnx.awtutil.*;
import java.awt.Toolkit;
import java.awt.Image;
import java.net.MalformedURLException;
import java.io.File;
import java.util.*;
import java.awt.*;
import java.net.URL;
import java.applet.*;
import java.io.*;
import java.lang.*;
import Browse;
import jcom;

class appearance_thread extends Thread {

   MaterialNode mn;
   float d1, d2, d3, e1, e2, e3, spec, shin, amb,trans;
   int maxSteps;
   String id;

   // Constructor
   public appearance_thread (MaterialNode mn, float d1, float d2, float d3, float e1, float e2, float e3,
				float spec, float shin, float amb, float trans, int maxSteps, String id) {

	this.mn = mn;
	this.d1 = d1 ;
	this.d2 = d2;
	this.d3 = d3;
	this.e1 = e1;
	this.e2 = e2;
	this.e3 = e3;
	this.spec = spec;
	this.shin = shin;
	this.amb = amb;
	this.trans = trans;
	this.maxSteps = maxSteps;
	this.id = id;
	this.start();
   }

   public void init() { }

   public void run() {

	int i;

	//System.out.println( mn.diffuseColor.toString() );

	float current_d1    = mn.diffuseColor.getRed();
	float current_d2    = mn.diffuseColor.getGreen();
	float current_d3    = mn.diffuseColor.getBlue();
	float current_e1    = mn.emissiveColor.getRed();
	float current_e2    = mn.emissiveColor.getGreen();
	float current_e3    = mn.emissiveColor.getBlue();
	float current_spec  = mn.specularColor.getRed();
	float current_shin  = mn.shininess.getValue();
	float current_amb   = mn.ambientIntensity.getValue();
	float current_trans = mn.transparency.getValue();

	if (d1 == -1) { d1 = current_d1;}
	if (d2 == -1) { d2 = current_d2;}
	if (d3 == -1) { d3 = current_d3;}
	if (e1 == -1) { e1 = current_e1;}
	if (e2 == -1) { e2 = current_e2;}
	if (e3 == -1) { e3 = current_e3;}
	if (spec  == -1) { spec  = current_spec;}
	if (shin  == -1) { shin  = current_shin;}
	if (amb   == -1) { amb   = current_amb;}
	if (trans == -1) { trans = current_trans;}

	float dd1 = (current_d1 - d1)/maxSteps;
	float dd2 = (current_d2 - d2)/maxSteps;
	float dd3 = (current_d3 - d3)/maxSteps;
	float de1 = (current_e1 - e1)/maxSteps;
	float de2 = (current_e2 - e2)/maxSteps;
	float de3 = (current_e3 - e3)/maxSteps;
	float dspec  = (current_spec  - spec)/maxSteps;
	float dshin  = (current_shin  - shin)/maxSteps;
	float damb   = (current_amb   - amb)/maxSteps;
	float dtrans = (current_trans - trans)/maxSteps;

        for ( i=1; i<=maxSteps; i++) {

           current_d1    -= dd1;
           current_d2    -= dd2;
           current_d3    -= dd3;
           current_e1    -= de1;
           current_e2    -= de2;
           current_e3    -= de3;
           current_spec  -= dspec;
           current_shin  -= dshin;
           current_amb   -= damb;
           current_trans -= dtrans;

	   mn.diffuseColor.setValue( current_d1, current_d2, current_d3);
	   mn.emissiveColor.setValue( current_e1, current_e2, current_e3);
	   mn.specularColor.setValue( current_spec, current_spec, current_spec);
	   mn.shininess.setValue(current_shin);
	   mn.ambientIntensity.setValue(current_amb);
	   mn.transparency.setValue( current_trans );
	   
	   try { Thread.sleep( 20 ); }
	   catch (Exception e) {}; 
	}
	   mn.diffuseColor.setValue( d1, d2, d3);
	   mn.emissiveColor.setValue( e1, e2, e3);
	   mn.specularColor.setValue( spec, spec, spec);
	   mn.shininess.setValue(shin);
	   mn.ambientIntensity.setValue(amb);
	   mn.transparency.setValue( trans );

	// Finish
	jcom.send( "animationReady "+id );
   }
}

class translate_thread extends Thread {

   TransformNode tn;
   float dx, dy, dz;
   int maxSteps;
   String id;

   // Constructor
   public translate_thread (TransformNode tn, float dx, float dy, float dz,
				int maxSteps, String id) {

	this.tn = tn;
	this.dx = dx;
	this.dy = dy;
	this.dz = dz;
	this.maxSteps = maxSteps;
	this.id = id;
	this.start();
   }

   public void init() { }

   public void run() {
	int i;
	// get current values
        float[] translation = new float[3];
	tn.translation.getValue( translation );
		
        for ( i=1; i<=maxSteps; i++) {
	   translation[0] -= dx;
	   translation[1] -= dy;
	   translation[2] -= dz;

	   tn.translation.setValue(translation[0], translation[1],
                                                translation[2]);
	   try { Thread.sleep( 20 ); }
	   catch (Exception e) {}; 
	}

	// Finish
	jcom.send( "animationReady "+id );
   }
}

class jump_thread extends Thread {

   TransformNode tn;
   float dx, dy, dz, x, y, z, v0, g, alpha, jump_val, c1, c2, v0_2;
   float tan_1, cos_2, sin_2, sin2a, sm, dsm;
   Double angle_d, pi_d;
   Double angle;
   int maxSteps;
   String id;

   // Constructor
   public jump_thread (TransformNode tn, float x, float y, float z, float v0,
				float g, float alpha, int maxSteps, String id) {

	this.tn = tn;
	this.x = x;
	this.y = y;
	this.z = z;
	this.v0 = v0;
	this.g  = g;
	this.alpha = alpha;
	this.maxSteps = maxSteps;
	this.id = id;
	this.start();
   }

   public void init() { }

   public void run() {
	int i;
	float s = 0;

	angle_d = new Double( alpha );
	pi_d    = new Double( Math.PI/180 );

	alpha = pi_d.floatValue() * angle_d.floatValue();

	float[] translation = new float[3];
	tn.translation.getValue( translation );

	dx = (translation[0] - x) / maxSteps;
	dy = (translation[1] - y) / maxSteps;
	dz = (translation[2] - z) / maxSteps;

	tan_1 = (new Float (Math.tan(alpha))).floatValue();
	cos_2 = (new Float (Math.pow(Math.cos(alpha),2.0f))).floatValue();
	sin_2 = (new Float (Math.pow(Math.sin(alpha),2.0f))).floatValue();
	sin2a = (new Float (Math.sin( 2 * alpha) )).floatValue();
	v0_2  = (new Float (Math.pow(v0,2.0f))).floatValue();

	c1  = tan_1;
	c2  = g/( 2 * v0_2 * cos_2 );
	sm  = (v0_2 * sin2a) / g;
	dsm = sm / maxSteps;
		
        for ( i=0; i<maxSteps; i++) {

	   jump_val = (s*c1) - (s*s*c2);
	   s += dsm;

	   translation[0] -= dx;
	   translation[1] -= dy;
	   translation[2] -= dz;

	   tn.translation.setValue(translation[0], translation[1]+jump_val,
                                                translation[2]);
	   try { Thread.sleep( 20 ); }
	   catch (Exception e) {}; 
	}
	tn.translation.setValue(x, y, z);

	// Finish
	jcom.send( "animationReady "+id );
   }
}

class rotate_thread extends Thread {

   TransformNode tn;
   int useWorld, useCenter, maxSteps;
   float x, y, z, da, angle, cx, cy, cz;
   Double angle_d;
   Quaternion q, q_akt;
   String id;

   // Constructor
   public rotate_thread (TransformNode tn, float x, float y, float z, float angle, 
			int useWorld, int useCenter, float cx, float cy, float cz, int maxSteps, String id) {

	this.tn        = tn;
	this.x         = x;
	this.y         = y;
	this.z         = z;
	this.angle     = angle;
	this.useCenter = useCenter;
	this.useWorld  = useWorld;
	this.cx        = cx;
	this.cy        = cy;
	this.cz        = cz;
	this.maxSteps  = maxSteps;
	this.id        = id;
	this.start();
   }

   public void init() { }

   public void run() {
	int i;

	// Wenn keine Achse eingegeben wurde...
	if ( x == 0 && y == 0 && z == 0) {
	   jcom.send( "animationReady "+id );
	   return;
	}

	// Winkel umrechnen
	angle_d = new Double ( angle );
	da = (float) ( (Math.PI/180) * angle_d.doubleValue() ) / maxSteps ;

	// Quaternion bzgl. Objektkoordinaten erzeugen
	float[] akt_rot = new float[4];
	tn.rotation.getValue( akt_rot );
	Vector3 vec_tmp = new Vector3 (akt_rot[0], akt_rot[1], akt_rot[2] );
	q_akt = new Quaternion( vec_tmp, akt_rot[3] );

	if ( useCenter == 1 ) {
	   VrmlWindow.changeCenter( tn, cx, cy, cz);
	}

	// Erzeugen des Rotationsvektors
	Vector3 rotationVector = new Vector3( x, y, z );
	rotationVector.normalize();

	// Rotations-Quaternion erzeugen
	q = new Quaternion ( );
	q.rotation(rotationVector, da);
	q.normalize( );

        for ( i=1; i<=maxSteps; i++) {    

	   if ( useWorld == 0 ) {
		// Objekt-Koordinaten
		q_akt.preMultiply( q );
	   } else {
		// Welt-Koordinaten
		q_akt.postMultiply( q );		
	   }

	   // Rotationswert setzen
           tn.rotation.setValue( q_akt );

	   try { Thread.sleep( 20 ); }
	   catch (Exception e) {}; 
	}

	// Finish
	jcom.send( "animationReady "+id );
   }
}

class scale_thread extends Thread {

   TransformNode tn;
   float dx, dy, dz, cx, cy, cz;
   int maxSteps, useCenter;
   String id;

   public scale_thread (TransformNode tn, float dx, float dy, float dz, int useCenter,
			float cx, float cy, float cz, int maxSteps, String id) {

	this.tn        = tn;
	this.dx        = dx;
	this.dy        = dy;
	this.dz        = dz;
	this.cx        = cx;
	this.cy        = cy;
	this.cz        = cz;
	this.useCenter = useCenter;
	this.maxSteps  = maxSteps;
	this.id        = id;
	this.start();
   }

   public void init() { }

   public void run() {
	int i;

	if ( useCenter == 1 ) {
	   VrmlWindow.changeCenter( tn, cx, cy, cz);
	}

	// get current values
        float[] scale = new float[3];
	tn.scale.getValue( scale );
		
        for ( i=1; i<=maxSteps; i++) {
	   scale[0] -= dx;
	   scale[1] -= dy;
	   scale[2] -= dz;
	   tn.scale.setValue(scale[0], scale[1], scale[2]);

	   try { Thread.sleep( 20 ); }
	   catch (Exception e) {}; 
	}

	// Finish
	jcom.send( "animationReady "+id );
   }
}
