/*
       Threads. java
 */

import dnx.lr.*;
import dnx.lr.node.*;
import dnx.lr.app.*;
import dnx.lr.field.*;
import dnx.geom.*;
import dnx.awtutil.*;
import java.awt.Toolkit;
import java.awt.Image;
import java.net.MalformedURLException;
import java.io.File;
import java.util.*;
import java.awt.*;
import java.net.URL;
import java.applet.*;
import java.io.*;
import java.lang.*;
import Browse;
import jcom;

class TouchThread extends Thread {

   // Class variables

   public static int numTouchThreads = 0;
   public static Vector namesTouchThreads;
   //public static TouchThread t;

   // Instance variables

   TouchSensorNode tsn;	// Zu aktivierender TouchSensorNode
   String trans;	// Name der entsprechenden Transition
   String id;		// (Unique) ID der Aktion

   // Static Initializer

   static {
	namesTouchThreads = new Vector();
   }

   // Constructor
   public TouchThread( TouchSensorNode tsn, String trans, String id ) {

	/* 
	Ueberpruefen, ob bereits ein Thread gestarted ist
	*/

	int namePos   = namesTouchThreads.indexOf( tsn.getName() );
	if ( namePos != -1) {
	   //System.out.println( tsn.getName()+" already started ! Ignore Action. ");
	   jcom.send( "animationReady "+id );
	   return;
	}

	/* 
	trans ist der Name der Transition, die Schalten soll.
	*/

	// Instance
	this.tsn   = tsn;
	this.trans = trans;
	this.id    = id;

	// Class
	numTouchThreads++;

	// namesTouchThreads.addElement( trans );
	namesTouchThreads.addElement( tsn.getName() );
	namesTouchThreads.addElement( this );
	//System.out.println( namesTouchThreads.toString() );

	// Start
	this.start();
   }

   static int getNumberOfTouchThreads() {

	// Gibt die Anzahl der existierenden Touch-Threads zurueck

	return numTouchThreads;
   }

   static void destroyTouchThread( String touchSensorName, String id ) {

	// Beendet einen Touch-Thread, der zu einem Transitionsnamen
	// gehoert.

	TouchThread t;

	int namePos   = namesTouchThreads.indexOf( touchSensorName );
	int threadPos = namePos + 1;

	if ( namePos == -1) {
	   System.out.println( "No such TouchThread ");
	   jcom.send( "animationReady "+id );
	   return;
	}

	t = (TouchThread) namesTouchThreads.elementAt( threadPos );

	// Thread aus Thread-Vektor loeschen (namePos, weil Position nachrueckt)
	try { namesTouchThreads.removeElementAt( namePos );
	      namesTouchThreads.removeElementAt( namePos );
        }
        catch (ArrayIndexOutOfBoundsException ident) {
	}

	// stop the Thread
	// System.out.println("Stopping...");
	numTouchThreads--;

	jcom.send( "touchThreadDisabled "+id+" "+t.trans );
	t.stop();

	//jcom.send( "animationReady "+id );
	
   }

   public void init() { }

   public void run() {
	// Simulator den Start miteilen
	jcom.send( "touchThreadActivated "+id );
	//jcom.send( "animationReady "+id );
	while ( true ) {
	   if ( tsn.isActive.getValue() ) {
		//System.out.println("Touch");
		//System.out.println(this.getName());
			
		// wait a moment...	
      		try { Thread.sleep( 50 ); }
      		catch (Exception e) {};
		
		// finish
	        jcom.send( "touchThreadTouched "+trans );
	   }
      	   try { Thread.sleep( 300 ); }
	   catch (Exception e) {};
	}
   }
}
