import java.awt.*;
import java.net.*;
import java.applet.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import java.applet.*;
import VrmlWindow;

public class jcom extends Thread {

  // RPC Constants
  public final static int RPC_CODE           = 2;
  public final static String RPC_OK          = "  0        0";
  public final static String RPC_PREFIX      = "          ";
  public final static int RPC_PREFIX_LENGTH  = 10;

  public static int serverPort, clientPort;
  public static Socket clientSocket, rec_socket;
  public static ServerSocket serverSocket;
  public static PrintStream pout, poutSend;		// JDK1.0.2
  public static DataInputStream din, dinSend;		// JDK1.0.2
  
  //public static BufferedReader dinBuff;		// JDK1.1.1
  //public static PrintWriter    poutWrite;		// JDK1.1.1

  public static Parameter paraString;
  public static int i, paraCounter;
  public static String command, message;
  public static int commandLength;

  public int j;

  // Constructor
  public jcom ( int serverPort, int clientPort ) {
		this.serverPort = serverPort;
		this.clientPort = clientPort;
		this.init();
		this.start();
  }

  // Init
  public void init ( ) {
    try {
	  // Create a serversocket 
          serverSocket = new ServerSocket( clientPort );
          this.send( "hello_server "+clientPort);
    }
	catch (IOException e) {
          System.err.println ("Exception creating Serversocket: "+e);
    }
  }

  public void run() {
	try {
	   while( true ) {
		// Waiting for connection
		rec_socket = serverSocket.accept();
      	      	//System.out.println(" Got a connection from tcl-server !" );

	      	// Read and convert the message
	      	// JDK 1.0.2
	      	// --------------------------------------------------------------
		try { din = new DataInputStream( rec_socket.getInputStream() ); }
		catch (IOException e) {
		   try {
			rec_socket.close(); 
		   } catch (IOException e2) {};

		   System.out.println("Exception getting socket streams: "+e);
		}
              	message = din.readLine();
	      	// --------------------------------------------------------------
	
	      	// JDK 1.1.1
	      	// --------------------------------------------------------------
	      	// dinBuff = new BufferedReader( new InputStreamReader( rec_socket.getInputStream() ) );
	      	// message = dinBuff.readLine();
	      	// --------------------------------------------------------------

		rec_socket.close();
		
      		//System.out.println("message: "+message );
		message = message.substring(13, (message.length() - 1) );

		// Get the command
		Parameter init_msg = new Parameter ( message );
		String init_command = init_msg.getFirstParameter();
      		int init_commandLength = init_command.length() + 1;

		if ( !init_command.equals("") ) {

		   // Get the message
		   String init_message = message.substring(init_commandLength, message.length() );
		   Parameter init_paraString = new Parameter( init_message );

		   // Parallel Event

		   if ( init_command.equals("para") ) {

		      for (j = 1; j <= init_paraString.countParallel() ; j++) {
		         createThread( init_paraString.getParallel(j) );
		      }

		   } else if ( init_command.equals("endSessionServer") ) {
		      Browse.endSessionServer();
		   } else if ( init_command.equals("testCom") ) {
      		      System.out.println( "Test command detected !" );
		   } else {

		   // Other Events
		      createThread( message );
		   }
		}
	  }
	}
	catch (IOException e) {
		System.err.println ("exception while listening for connections: "+e);
	}
  }


  // Create Thread from Command
  public static void createThread ( String message ) {

	// Get the command
	Parameter msg = new Parameter ( message );
	String command = msg.getFirstParameter();
      	int commandLength = command.length() + 1;

	// Get the message
	message = message.substring(commandLength, message.length() );
	paraString = new Parameter( message );

	// Set Nodename
      	String nodeName = paraString.getFirstParameter();

	// Count parameters
	paraCounter = paraString.countParameter() + 1;
	String paraStrings[] = new String[paraCounter + 1];
	float val[] = new float[paraCounter + 1];

	// put the values in val array and ignore strings
	for (i = 2; i < paraCounter ; i++) {
	   paraStrings[i] = paraString.getParameter( i );
    	   try { 
	         val[i] = (new Float( paraStrings[i]).floatValue() );
     	   }
     	   catch (NumberFormatException e) { }
	}
	int maxSteps = (new Integer(paraString.getParameter( paraCounter - 1 )).intValue() );
	String id = new String (paraString.getParameter( paraCounter) );

	//
	// Translate Event
	//
	if ( command.equals("translate") ) {

      	   //System.out.println( "Translate Event" );
      	   VrmlWindow.translate( nodeName, val[2], val[3], val[4], (int) val[5], maxSteps, id );
	// ######################################################################################

	//
	// Jump Event
	//
	} else if ( command.equals("jump") ) {

      	   //System.out.println( "Translate Event" );
      	   VrmlWindow.jump( nodeName, val[2], val[3], val[4], val[5], val[6],
			  	      val[7], maxSteps, id );
	// ######################################################################################

	//
	// Rotate Event
	//
	} else if ( command.equals("rotate") ) {

      	   //System.out.println( "Rotate Event" );
	   VrmlWindow.rotate( nodeName, val[2], val[3], val[4], val[5], (int) val[6], (int) val[7],
						val[8], val[9], val[10], maxSteps, id );
	// ######################################################################################

	//
	// Scale Event
	//
	} else if ( command.equals("scale") ) {

      	   //System.out.println( "Scale Event" );
      	   VrmlWindow.scale( nodeName, val[2], val[3], val[4], (int) val[5], val[6],
					val[7], val[8], maxSteps, id );
	// ######################################################################################

	//
	// Appearance Change Event
	//
	} else if ( command.equals("appearance") ) {

      	   //System.out.println( "Appearance change Event" );
      	   VrmlWindow.appearance( nodeName, val[2], val[3], val[4],  val[5], val[6], val[7],
					      val[8], val[9], val[10], val[11], maxSteps, id );
	// ######################################################################################

	//
	// ActivateTouchSensor Event
	//
	} else if ( command.equals("touch") ) {

           String TouchSensorName  = paraString.getFirstParameter();
      	   String TransName        = paraString.getParameter( 2 );

	   VrmlWindow.setTouch( TouchSensorName, TransName, id );
	// ######################################################################################

	//
	// DeactivateTouchSensor Event
	//
	} else if ( command.equals("untouch") ) {

           String TransName  = paraString.getFirstParameter();

	   TouchThread.destroyTouchThread( TransName, id );
	// ######################################################################################

	} else {
      		//System.out.println( "Unknown Event" );
    }

  }


  public static void send( String msg ) {

	try { 
	   // Create Message RPC-Message
	   int msg_length = msg.length() + 2;
	   Integer msg_string_length = new Integer(msg_length);
	   int msg_end = msg_string_length.toString().length();

	   String prefix = new String( RPC_PREFIX.substring( 0, (RPC_PREFIX_LENGTH - msg_end)) );
	   String message = prefix+msg_string_length.toString()+"{"+msg+"}";

	   // Begin Critical Section
	   synchronized ( serverSocket ) {
		clientSocket = new Socket( "localhost", serverPort );

		//System.out.println("VRML -> Animator: "+message );

		// JDK 1.0.2
		// #############################
                poutSend = new PrintStream( clientSocket.getOutputStream(), true );
                //dinSend = new DataInputStream( clientSocket.getInputStream() );
                // Write Message
		// ----------------------------
                poutSend.println( RPC_CODE );
                poutSend.println( message );
		// Get Response from Tcl-Server
		// ----------------------------
                //String response = din.readLine();

		// JDK 1.1.1
		// #############################
		// poutWrite = new PrintWriter( clientSocket.getOutputStream(), true );
		// dinBuff = new BufferedReader( new InputStreamReader( clientSocket.getInputStream() ) );
		// Write Message
		// ----------------------------
		// poutWrite.println( RPC_CODE );
		// poutWrite.println( message );
		// Get Response from Tcl-Server
		// ----------------------------
		// String response = dinBuff.readLine();

		//System.out.println("VRML (response): "+response );

		//if ( response.equals( RPC_OK ) ) {
		//   System.out.println("Transmission accepted by Tcl Server !" );
		//} else {
		//   System.err.println("Transmission not accepted by Tcl Server !!" );
		//}
		
		try {
		   clientSocket.close();
		}
		catch (IOException e) {}
	   }
	   // End Critical Section
	}
	catch (IOException e) {
	   System.err.println ("Exception while sending message: "+e);
	}
	catch (NullPointerException e) {
	   System.err.println ("NullPointerException");
	}

   }

} // End Class jcom

class Parameter {

	String paraString;

	// Constructor
	public Parameter ( String paraString ) {
		this.paraString = paraString;
    	}

	public String getFirstParameter () {
		int pos;

		pos = paraString.indexOf(" ");
		try {
		   return paraString.substring( 0, pos ); 
		}
		catch (StringIndexOutOfBoundsException e) {
		   System.err.println ("Exception in getFirstParameter");
		   return "";
		}
    	}

	public String getParameter( int nr ) {
		int    pos, i;
		String tmpString = paraString;
	
		for (i = 1; i < nr; i++) {
			pos = (tmpString.indexOf(" ") + 1);
			tmpString = tmpString.substring( pos, tmpString.length() );
		}
		pos = tmpString.indexOf(" ");
		if (pos == -1) {
			return tmpString;
		} else {	
			return tmpString.substring( 0, pos );
		}
	}

	public String getParallel( int nr ) {
		int    pos, i;
		String tmpString = paraString;

		// Delete first and last bracket
		tmpString = tmpString.substring( 1, tmpString.length() - 1 );
	
		for (i = 1; i < nr; i++) {
			pos = (tmpString.indexOf(")(") + 2);
			tmpString = tmpString.substring( pos, tmpString.length() );
		}
		pos = tmpString.indexOf(")(");
		if (pos == -1) {
			return tmpString;
		} else {	
			return tmpString.substring( 0, pos );
		}
	}

	public int countParameter ( ) {
		int count = -1;
		int pos = 1;
		String tmpString = paraString;
		
		pos = tmpString.indexOf(" ");

		while (pos > 0) {
			tmpString = tmpString.substring( pos, tmpString.length() );
			pos = (tmpString.indexOf(" ") + 1);
			count++;
		}
		return count;
	}

	public int countParallel ( ) {
		int count = -1;
		int pos = 1;
		String tmpString = paraString;
		
		pos = tmpString.indexOf(")(");

		while (pos > 0) {
			tmpString = tmpString.substring( pos, tmpString.length() );
			pos = (tmpString.indexOf(")(") + 1);
			count++;
		}
		count++;
		return count;
	}

	public String toString ( ) {
		return paraString;
	}

} // End Class Parameter
