#!wish
#############################################################################
# Visual Tcl v1.10 Project
#

#################################
# GLOBAL VARIABLES
#
global Com; 
global Compute; 
global DECIDE; 
global Files; 
global act_element; 
global act_hierachy; 
global act_trans; 
global activeDecide; 
global anim_ok; 
global animator; 
global continueSimulation; 
global debug; 
global disableDecide; 
global filename; 
global gvar; 
global hl_ref_ext; 
global pfa_ref_ext; 
global known_trans; 
global ll_ref_ext; 
global mode; 
global newActiveMarking; 
global newActiveTransitions; 
global prevActiveMarking; 
global prevActiveTransitions; 
global simulationDecide; 
global simulation_started; 
global started; 
global widget; 
global path_to_move_file path_to_wrl_file ;# PTAK
    set widget(DebugFrame) {.top17.fra24}
    set widget(InfoMenu) {.top17.fra18.cpd21.men23}
    set widget(MessageLabel) {.top17.fra20.lab22}
    set widget(OpenLLButton) {.top17.fra19.but24}
    set widget(OpenVRMLButton) {.top17.fra19.but21}
    set widget(Simulator) {.top17}
    set widget(StartButton) {.top17.fra19.but20}
    set widget(StepButton) {.top17.fra19.but25}
    set widget(StopButton) {.top17.fra19.but22}
    set widget(rev,.top17) {Simulator}
    set widget(rev,.top17.fra18.cpd21.men23) {InfoMenu}
    set widget(rev,.top17.fra19.but20) {StartButton}
    set widget(rev,.top17.fra19.but21) {OpenVRMLButton}
    set widget(rev,.top17.fra19.but22) {StopButton}
    set widget(rev,.top17.fra19.but24) {OpenLLButton}
    set widget(rev,.top17.fra19.but25) {StepButton}
    set widget(rev,.top17.fra20.lab22) {MessageLabel}
    set widget(rev,.top17.fra24) {DebugFrame}

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {
global auto_path gvar bitmap_path env
global started anim_ok known_trans 
global act_element act_hierachy act_trans mode
global disableDecide DECIDE numDisableTouchThreads numActiveTouchThreads 
global activeDecide 
global newActiveTransitions prevActiveTransitions
global newActiveMarking prevActiveMarking
global filename animator pfa_ref_ext hl_ref_ext ll_ref_ext
global simulation_started simulationDecide
global continueSimulation debug edited version

if [catch {set env(PEPHOME)}] {
   set my_auto_path_common   "/opt/pep/lib"
   set my_auto_path          "/opt/pep/lib/simPEP"
   set my_bitmaps_path       "/opt/pep/bitmaps/simPEP"
} else {
  set my_auto_path_common   "$env(PEPHOME)/lib"
  set my_auto_path          "$env(PEPHOME)/lib/simPEP"
  set my_bitmaps_path       "$env(PEPHOME)/bitmaps/simPEP"
}  ;# else, eine Path-Angabe war vorhanden
set auto_path [linsert $auto_path 0 $my_auto_path_common]
set auto_path [linsert $auto_path 0 $my_auto_path]
package require Tcl_RPC
package require pep_edit

#rpc_debug all

set filename "<Noname>.move"
set animator(connect_to) "<Noname>.wrl"
set path_to_move_file [pwd] ;# PTAK
set path_to_wrl_file [pwd] ;# PTAK
set hl_ref_ext ".bpn2_hl_ref"
set pfa_ref_ext ".pfa_bpn2_ref"
set ll_ref_ext ".bpn2_ll_ref"

init_client_com

set gvar(vrml.comstate) "disconnected"
set gvar(vrml.host) ""
set gvar(vrml.port) ""

set gvar(ll_net.state) "edit"

set started ""
set simulation_started 0
set simulationDecide 0
set anim_ok ""
set gvar(oneStepStarted) 0
set continueSimulation 1

set gvar(prg) "simulator"

set act_element ""
set act_hierachy 1
set act_trans ""
set known_trans ""
set disableDecide ""
set DECIDE ""

set activeDecide ""
set newActiveTransitions ""
set prevActiveTransitions ""
set newActiveMarking ""
set prevActiveMarking ""

set mode "simulate"
set edited "no"

set version "V 0.2.2"

set debug(com) 0
set debug(files) 0
set debug(compute) 0
set debug(force) 1
}

init $argc $argv


proc TransitionFired {LLString} {
# LL-Editor hat eine transition geschaltet

global fired known_trans DECIDE disableDecide activeDecide mode 
global numDisableTouchThreads numActiveTouchThreads Animation 
global animatingListElement anotherAnimation Cond T P 
global animateWhenActiveEver animateWhenActiveOnce
global animateWhenActiveEverE animateWhenActiveOnceE
global gvar randValue widget
global newActiveTransitions prevActiveTransitions
global newActiveMarking prevActiveMarking
global partialOnceList partialEverList
global simulation_started simulationDecide continueSimulation

if {$gvar(vrml.comstate) == "disconnected"} {
    sendAnimationOkToLL
    DEBUG com "VRML Browser is disconnected."
    return
}

set transitionName [lindex $LLString 0]
set delimiterPos [lsearch $LLString "-marking"]
set activeTransitions [lrange $LLString 2 [expr ($delimiterPos - 1)]]
set activeMarking     [lrange $LLString [expr ($delimiterPos + 1)] end]

if {$simulationDecide} {
    set simulationDecide 0
}

set fireAnimationList ""

# zunaechst werden die prevActiveTransitions auf die aktuellen
# aktiven Transistionen gesetzt, wenn noch keine existierten
# Das gleiche wird fuer die Stellen gesetzt.

if {$prevActiveTransitions == ""} {
    set prevActiveTransitions $activeTransitions
}
if {$prevActiveMarking == ""} {
    set prevActiveMarking $activeMarking
}

set newActiveTransitions [minus $prevActiveTransitions $activeTransitions]
set newActiveMarking     [minus $prevActiveMarking $activeMarking]

set animationList ""
set anotherAnimation 0

DEBUG compute "TransitionFired: (activeTransitions)     = $activeTransitions"
DEBUG compute "TransitionFired: (prevActiveTransitions) = $prevActiveTransitions"
DEBUG compute "TransitionFired: (newActiveTransitions)  = $newActiveTransitions"
DEBUG compute "TransitionFired: (transitionName)        = $transitionName"
DEBUG compute "----------------"

  # Animationsliste erstellen
  ############################

  # Animationen die an aktive Transitionen und Stellen gebunden sind
  #
  # partieller Vergleich

  set newPartialSet "$newActiveTransitions $newActiveMarking"
  set partialSet "$activeTransitions $activeMarking"

  foreach i $partialOnceList {
     regsub -all "," $i " " compareList
     if {[isIn $compareList $newPartialSet]} {
        set animationList "$animationList $animateWhenActiveOnce($i)"
     }
  }

  foreach i $partialEverList {
     regsub -all "," $i " " compareList
     if {[isIn $compareList $partialSet]} {
        set animationList "$animationList $animateWhenActiveEver($i)"
     }
  }

  # exakter Vergleich
  regsub -all { } [lsort $activeMarking]        "," exactMarking
  regsub -all { } [lsort $newActiveMarking]     "," newExactMarking
  regsub -all { } [lsort $activeTransitions]    "," exactActive
  regsub -all { } [lsort $newActiveTransitions] "," newExactActive

  if {![ catch {set exactList $animateWhenActiveEverE($exactMarking) } ] } {
       set animationList "$animationList $exactList"
  }
  if {![ catch {set exactList $animateWhenActiveEverE($exactActive) } ] } {
       set animationList "$animationList $exactList"
  }
  if {![ catch {set exactList $animateWhenActiveOnceE($newExactMarking) } ] } {
       set animationList "$animationList $exactList"
  }
  if {![ catch {set exactList $animateWhenActiveOnceE($newExactActive) } ] } {
       set animationList "$animationList $exactList"
  }

  # Sichern der aktiven Transitionen und der aktuellen Markierung
  set prevActiveTransitions $activeTransitions
  set prevActiveMarking $activeMarking

  # Animationen starten, die an gefeuerte Transitionen gebunden sind.
  catch {set fireAnimationList $Animation($transitionName)}

  foreach element $fireAnimationList {
       lappend animationList $element
  }

  DEBUG compute "animationList: $animationList"

  foreach animation $animationList {
     if {[string range $animation 0 5] == "__tmp_"} {
        set animationList [deleteElementFromList $animation $animationList]
     }
  }

  set animationListLength [llength $animationList]
  DEBUG compute "animationList: $animationList"

  if {$animationListLength == 1} {
     send [lindex $animationList 0]
     tkwait variable continueSimulation
  } elseif {$animationListLength > 1} {
     set anotherAnimation 1
     set animatingListElement 1
     incr animationListLength -1
     for {set i 0} {$i < $animationListLength} {incr i} {
         send [lindex $animationList $i]
         tkwait variable animatingListElement
     }
     set anotherAnimation 0
     send [lindex $animationList end]
     tkwait variable continueSimulation
  } else {
     sendAnimationOkToLL
     msg ""
     updateButtons
  }
  set gvar(oneStepStarted) 0

  if {$simulation_started} {
     simulationOneStep
  }
}

proc computeAnimations {} {
# Ordnet den Transitionen und Stellen Animationen zu

global T P Animation Cond
global animateWhenActiveEver animateWhenActiveEverE 
global animateWhenActiveOnce animateWhenActiveOnceE

set transNames [array names T]
set placeNames [array names P]

foreach transition $transNames {
    if {[lindex $Cond($transition#) 0] == "active"} {

        set transList [lsort $T($transition)]
        regsub -all { } $transList "," transList

        # Animation wird bei jeder aktiven Transitionsbelegung ausgefuehrt
	if {[lindex $Cond($transition#) 1] == "ever"} {
           if {[lindex $Cond($transition#) 2] == "partial"} {           
              # Wenn die Transtition aktiv ist, wird animiert
              lappend animateWhenActiveEver($transList) $transition
           } else {
              # Nur wenn genau diese Transitionen aktiv sind...
              lappend animateWhenActiveEverE($transList) $transition
           }
        # Nur einmal
	} else {
           if {[lindex $Cond($transition#) 2] == "partial"} {           
               lappend animateWhenActiveOnce($transList) $transition
           } else {
               lappend animateWhenActiveEverE($transList) $transition
           }
	}
    } else {
       set transList $T($transition)
       foreach element $transList {
           lappend Animation($element) $transition
       }
    }
}

foreach place $placeNames {

    if {[lindex $Cond($place#) 0] == "active"} {

        set placeList [lsort $P($place)]
        regsub -all { } $placeList "," placeList

        # Animation wird bei jeder aktuellen Markierung ausgefuehrt
	if {[lindex $Cond($place#) 1] == "ever"} {
           if {[lindex $Cond($place#) 2] == "partial"} {           
              # Wenn die Stelle unter den markierten ist, wird animiert
              lappend animateWhenActiveEver($placeList) $place
           } else {
              # Nur wenn genau diese Stellen markiert sind...
              set animateWhenActiveEverE($placeList) $place
           }
        # Nur einmal
	} else {
           if {[lindex $Cond($place#) 2] == "partial"} {  
              lappend animateWhenActiveOnce($placeList) $place
           } else {
              # Nur wenn genau diese Stellen markiert sind...
              set animateWhenActiveEverE($placeList) $place
           }
	}
    } else {
       set placeList $P($place)
       foreach element $placeList {
           lappend Animation($element) $place
       }
    }
}
}

proc end_session_local {} {
global gvar widget

# Dem LL-Editor das ableben miteilen
sendGoodbyeToLL

# Beenden der Simulation
simulationStop

# VRML Browser schliessen
closeVRML

# Dem Server das ableben mitteilen
goodbye_server

Window destroy $widget(Simulator)
Window destroy .

}

proc fireTransition {name} {
global gvar
 
 if {$gvar(ll_net.comstate) == "connected" && !$gvar(oneStepStarted)} {
    DEBUG com "Simulator -> LL Edit : FireTransName $name"
    set gvar(oneStepStarted) 1
    RDO "FireTransName $name" $gvar(ll_net.host) $gvar(ll_net.port)
 }
}

proc getActiveTransitions {} {
global gvar

 #set gvar(ll_net.host) [get_ref ll_net.host]
 #set gvar(ll_net.port) [get_ref ll_net.port]

 set str [RPC "S_getActiveTransitions" $gvar(ll_net.host) $gvar(ll_net.port)]

 return $str
}

proc getKnownTransitions {} {
global T

 set list ""
 set names [array names T]

 foreach i $names {
    if { ! [isIn $T($i) $list] } {
        lappend list "$T($i)"
    }
 }

 return $list
}

proc getLLComstate {} {
global gvar disableDecide DECIDE widget

 set gvar(ll_net.comstate) [getVarFromServer ll_net.comstate]

 if {$gvar(ll_net.comstate) == "connected"} {
   set gvar(ll_net.host) [getVarFromServer ll_net.host]
   set gvar(ll_net.port) [getVarFromServer ll_net.port]

   # Das erneute oeffnen eines Editor unterbinden
   $widget(OpenLLButton) configure -state disabled

   # Dem LL-Editor die eigene Existenz mitteilen
   sendHelloToLL
   # die aktiven Transitionen abfragen. Dies ist fuer die Simulation
   # wichtig.

   # Aktive Transitionen
   set activeTransitions [getActiveTransitions]
   # Deaktivierte Entscheidungstransitionen
   # set disableDecide [minus $activeTransitions $DECIDE]

 } else {
   set gvar(ll_net.host) ""
   set gvar(ll_net.port) ""
 }
}

# Gibt ein zufaelliges Element einer Liste zurueck.
proc getRandomElement {list} {
  set elementNumber [expr int(rand()*[llength $list])]
  return [lindex $list $elementNumber]
}

# Fragt einen Wert des gvar-Arrays vom peptool ab.
proc getVarFromServer {gvar_value} {
 global gvar

 return [RPC "get_gvar_from_client $gvar(prjnum) $gvar_value"  $gvar(server_host) $gvar(server_port)]

}

proc get_ref {ref} {
  global gvar

  return [RPC "get_ref_from_client $gvar(prjnum) {$ref}"  $gvar(server_host) $gvar(server_port)]
}

proc insertAllConditions {activeAnimation} {
# Diese Prozedur macht nichts, da im Simulator keine Bedingungen
# angezeigt werden muessen.
}

proc msg {message} {
global widget old_msg

 $widget(MessageLabel) configure -text $message
 set old_msg $message
}

proc new_ref {program ref} {
global gvar

  if {$gvar(server.connected)} {
    catch {RPC "new_ref_from_client $gvar(prjnum) $program {$ref}"  $gvar(server_host) $gvar(server_port)}
  }  ;# if PEP-Server vorhanden
}

proc readMoveFile {name} {
global H A DEP animator filename known_trans Cond gvar
global def ref_pl_hl ref_pl_ll ref_tr_hl ref_tr_ll
global abs abs_pos abstr LPT LTP TA TD PA PD T P Animation 
global partialOnceList partialEverList
global animateWhenActiveEver animateWhenActiveOnce
global animateWhenActiveEverE animateWhenActiveOnceE
global path_to_move_file path_to_wrl_file ;# PTAK

 set filename $name

 unsetAllArrays 

# PTAK NEW BEGIN
 # Den filename ein wenig aufbereiten...
  # absoluten Pfad der move Datei ermitteln
 if {[catch {cd [file dirname $filename]}]} {
   DEBUG files "Could not change to [file dirname $filename]!"
   set filename "<Noname>.move"
 } else {
   set filename [file tail $filename]
 }
 set path_to_move_file [pwd]
# PTAK NEW END

 # Einlesen der Animationsdatei
# if {[file exists $filename]} {   ;# PTAK
#      source $filename            ;# PTAK
# }                                ;# PTAK

 if {[file exists $filename]} {
   DEBUG files "MV File found."
   source $filename

    # absoluten Pfad der wrl Datei ermitteln
   set act_dir [pwd]
   if {[catch {cd [file dirname $animator(connect_to)]}]} {
     DEBUG files "Could not change to [file dirname $animator(connect_to)]!"
     set animator(connect_to) "<Noname>.wrl"
   } else {
     set path_to_wrl_file [pwd]
     set animator(connect_to) "[pwd]/[file tail $animator(connect_to)]"
   }
   cd $act_dir
 } else {
   DEBUG files "$filename not found."
 }

 set gvar(prjname) $animator(prjname)

 # Einlesen der Referenzen und abstrakten Namen
 read_references   

 # Einlesen des LL-Netzes
 if {[file exists $gvar(prjname).ll_net]} {
    read_ll_net $gvar(prjname).ll_net
 } else {
    puts "No LL-Net found."
 }

 # Aufloesen der Bedingungen (T und P)
 computeAllConditions

 # Zuordnung der Stellen und Transitionsnamen zu einer Animation
 computeAnimations

 # Titel
 update_title

 # setzen der bekannten Transitionsnamen
 set known_trans [getKnownTransitions]

 set partialOnceList [array names animateWhenActiveOnce]
 set partialEverList [array names animateWhenActiveEver]

 #arrayWrite T
 #arrayWrite P
 #arrayWrite Animation
 #arrayWrite animateWhenActiveOnce
 #arrayWrite animateWhenActiveEver
 #arrayWrite animateWhenActiveOnceE
 #arrayWrite animateWhenActiveEverE
 #arrayWrite H
 #arrayWrite DEP
}

proc send {trans} {
global gvar anim_ok H DEP A animate animatingListElement continueSimulation

   set anim_ok ""
   set names [array names DEP]

   set continueSimulation 0

   regsub -all {\#} $names { } trans_list

   foreach i $names {
        set trans_id $i
        if ([string match "$trans\#*" $trans_id]) {
              set animate($trans_id) $DEP($trans_id)
        }
   }

   set first [createCommand [no_deps]]

   DEBUG com "Simulator -> VRML: $first"

   msg "animating..."
   RDO "$first" $gvar(vrml.host) $gvar(vrml.port)
}

proc sendAnimationOkToLL {} {
setVarInLLEditor simulator.ok 1
   #puts "sendAnimationOkToLL: simulator.ok 1"
}

proc sendCommandToLLEditor {command} {
global gvar

 RPC "$command" $gvar(ll_net.host) $gvar(ll_net.port)
}

proc sendCommandToServer {command} {
global gvar

 RPC "$command"  $gvar(server_host) $gvar(server_port)
}

proc sendGoodbyeToLL {} {
# dem LL Editor das eigene Ableben mitteilen

 setVarInLLEditor simulator.comstate disconnected
}

proc sendHelloToLL {} {
# dem LL Editor die eigene Existenz mitteilen

 setVarInLLEditor simulator.comstate connected
 setVarInLLEditor simulator.ok 1
}

proc setEditorClose {editor_name} {
# das peptool hat einen Editor geoeffnet

 global gvar widget

 set gvar($editor_name.comstate) "disconnected"
 set gvar($editor_name.host) ""
 set gvar($editor_name.port) ""

 msg "$editor_name is now closed !"
 simulationStop

 updateButtons
}

proc setEditorOpen {editor_name} {
# das peptool hat einen Editor geoeffnet

 global gvar widget DECIDE activeTransitions disableDecide

 set gvar($editor_name.comstate) "connected"
 set gvar($editor_name.host) [getVarFromServer $editor_name.host]
 set gvar($editor_name.port) [getVarFromServer $editor_name.port]

 msg "Host: $gvar($editor_name.host) Port: $gvar($editor_name.port)"
 
 updateButtons

 sendHelloToLL

 # die aktiven Transitionen abfragen. Dies ist fuer die Simulation
 # wichtig.

 # Aktive Transitionen
 set activeTransitions [getActiveTransitions]
 # Deaktivierte Entscheidungstransitionen
 set disableDecide [minus $activeTransitions $DECIDE]
}

proc setTransitionFired {name} {
# LL-Editor hat eine transition geschaltet

global fired

set known_trans [getKnownTransitions]

if {[isIn $name $known_trans]} {
   send $name
}
}

proc setVarInLLEditor {gvar_name gvar_value} {
#
# Setzt einen Wert des gvar Arrays im LL-Editor
#

 global gvar

 if {$gvar(ll_net.comstate) == "connected"} {
    #set value [RPC "S_setValueFromSimulator $gvar_name $gvar_value"  $gvar(ll_net.host) $gvar(ll_net.port)]
    RDO "S_setValueFromSimulator $gvar_name $gvar_value"  $gvar(ll_net.host) $gvar(ll_net.port)
 }
}

proc simulationInit {} {
global activeTransitions DECIDE simulation_started

 sendCommandToLLEditor "S_oneStep"
 set activeTransitions [getActiveTransitions]
 #set disableDecide [minus $activeTransitions $DECIDE]

 #set simulation_started 1
}

proc simulationOneStep {} {
global DECIDE known_trans simulation_started activeTransitions
global simulationDecide gvar widget

 $widget(StepButton) configure -state disabled
 $widget(StartButton) configure -state disabled

 set activeTransitions [getActiveTransitions]
 set otherTransitions  [minus $DECIDE $activeTransitions]

 if {$activeTransitions != ""} {

    if { [lsort $activeTransitions] == [lsort $DECIDE] } {
        msg "Ok, then decide !"
        set simulationDecide 1
        tkwait variable simulationDecide
    } else {

     set fireTrans [getRandomElement $otherTransitions]
     DEBUG compute "DECIDE: $DECIDE"
     DEBUG compute "active: $activeTransitions"
     DEBUG compute "other : $otherTransitions"
     fireTransition $fireTrans

    }
 } else {
   #set simulation_started 0
 }
}

proc simulationStart {} {
global DECIDE known_trans simulation_started activeTransitions

 simulationInit

 set simulation_started 1
 updateButtons
 simulationOneStep
}

proc simulationStop {} {
global simulation_started anotherAnimation started continueSimulation

  set continueSimulation 1
  set started ""
  set anotherAnimation 0
  set simulation_started 0
  
  sendAnimationOkToLL
  updateButtons
}

proc stateLLEdit {} {
global gvar

set gvar(ll_net.state) "edit"
sendAnimationOkToLL
}

proc stateLLReference {} {
global gvar

set gvar(ll_net.state) "reference"
sendAnimationOkToLL
}

proc stateLLSimulation {} {
global gvar

simulationStop

set gvar(ll_net.state) "simulation"
sendAnimationOkToLL
}

proc stateSimWait {} {
global widget continueSimulation

#$widget(StepButton) configure -state normal

set continueSimulation 1
}

proc touchThreadActivated {id} {
#
# Mitteilung des VRML-Browsers, das ein TouchThread (id) gestartet ist.

global anim_ok started H A DECIDE T P

 set startedTransition [getResultList [lindex $H($id) 0] ]

 DEBUG compute "started Transitions: $startedTransition"

 foreach trans $startedTransition {
    if {![isIn $trans $DECIDE]} {
        lappend DECIDE $trans
    }
 }

 DEBUG compute "New Decide: $DECIDE"

 set anim_ok "$anim_ok $id"
 set started [minus $id $started]

 checkNextAction
}

proc touchThreadDisabled {id finishedTransition} {
#
# Mitteilung des VRML-Browsers, das ein TouchThread (id) beendet ist.

global anim_ok started DECIDE H A

  regsub -all "," $finishedTransition " " finishedTransition
  DEBUG compute "finished Transition: $finishedTransition"

  foreach trans $finishedTransition {
     if {[isIn $trans $DECIDE]} {
          set pos [lsearch $DECIDE $trans]
          set DECIDE [lreplace $DECIDE $pos $pos]
     }
  }

  DEBUG compute "New Decide: $DECIDE"

  set anim_ok "$anim_ok $id"
  set started [minus $id $started]

  checkNextAction
}

proc touchThreadTouched {trans_name} {
# Der VRML-Browser uebermittelt einen gedrueckten Transitionsnamen der
 # im LL-Editor geschaltet werden soll.

 global widget continueSimulation gvar

 if {$continueSimulation && !$gvar(oneStepStarted)} {
  DEBUG force "Ok, Touch-Event accepted with $trans_name"
  regsub -all "," $trans_name " " trans_name

  if {[llength $trans_name] == 1} {
      fireTransition $trans_name
  } else {
      set activeTransitions [getActiveTransitions]
      foreach transition $trans_name {
         if {[isIn $transition $activeTransitions]} {
            fireTransition $transition
            return
         }
      }
   }
 } else {
  DEBUG force "Animating, please try later"
 }
}

proc updateButtons {} {
# Akitviert/Deaktiviert die Buttons in der Buttonleiste

global gvar widget simulation_started continueSimulation

# Open VRML
if {$gvar(vrml.comstate) == "connected"} {
   $widget(OpenVRMLButton) configure -state disabled
} else {
   $widget(OpenVRMLButton) configure -state normal
}
# Open LL
if {$gvar(ll_net.comstate) == "connected"} {
   $widget(OpenLLButton) configure -state disabled
} else {   
   $widget(OpenLLButton) configure -state normal
}
# Step
if {$gvar(vrml.comstate) == "connected" && $gvar(ll_net.comstate) == "connected" && !$simulation_started && $continueSimulation} {
   $widget(StepButton) configure -state normal
} else {
   $widget(StepButton) configure -state disabled
}
# Start
if {$gvar(vrml.comstate) == "connected" && $gvar(ll_net.comstate) == "connected" && !$simulation_started && $continueSimulation} {
   $widget(StartButton) configure -state normal
} else {
   $widget(StartButton) configure -state disabled
}
# Stop
if {$gvar(vrml.comstate) == "connected" && $gvar(ll_net.comstate) == "connected" && $simulation_started} {
   $widget(StopButton) configure -state normal
} else {
   $widget(StopButton) configure -state disabled
}
}

proc update_title {} {
global filename animator

 regsub -all {/} $filename { } move
 regsub -all {/} $animator(connect_to) { } anim

 set move [lindex $move end]
 set anim [lindex $anim end]

 wm title .top17 "Simulator ($move)"
}

proc vrmlClosed {} {
global widget gvar

 simulationStop

 set gvar(vrml.comstate) "disconnected"
 set gvar(vrml.host) ""
 set gvar(vrml.port) ""

 msg "VRML Editor closed"

 updateButtons
}

proc main {argc argv} {
global widget

if {$argc >= 1} {
    set filename [lindex $argv 0]

    if {[file exists $filename] == 1} {
        readMoveFile $filename
    }
 }
 getLLComstate

 update_title

 wm protocol $widget(Simulator) WM_DELETE_WINDOW end_session_local
}

proc Window {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt.tcl #2"
    bind $base <Button-1> {
        unpost .absMenu
    }
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 388x87+12+151
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Simulator"
    frame $base.fra18 \
        -borderwidth 2 -height 36 -relief groove -width 125 
    frame $base.fra18.cpd21 \
        -borderwidth 1 -height 30 -relief sunken -width 30 
    menubutton $base.fra18.cpd21.01 \
        -anchor w -menu .top17.fra18.cpd21.01.02 -padx 4 -pady 3 -text File \
        -width 4 
    menu $base.fra18.cpd21.01.02 \
        -cursor {} -tearoff 0 
    $base.fra18.cpd21.01.02 add command \
        -command {FSBox readMoveFile "Open" {{Move files} .move}} -label Open 
    menubutton $base.fra18.cpd21.men24 \
        -menu .top17.fra18.cpd21.men24.m -padx 4 -pady 3 -text Info 
    menu $base.fra18.cpd21.men24.m \
        -cursor {} -tearoff 0 
    $base.fra18.cpd21.men24.m add command \
        -label About 
    $base.fra18.cpd21.men24.m add separator
    $base.fra18.cpd21.men24.m add cascade \
        -label Debug -menu .top17.fra18.cpd21.men24.m.men25 
    menu $base.fra18.cpd21.men24.m.men25 \
        -tearoff 0 
    $base.fra18.cpd21.men24.m.men25 add checkbutton \
        \
        -command {if {$debug(com)} {
    DEBUG force "set debug (Com) OFF"
    set debug(com) 0
} else {
    DEBUG force "set debug (Com) ON"
    set debug(com) 1
}} \
        -label Com -state active -variable Com 
    $base.fra18.cpd21.men24.m.men25 add checkbutton \
        \
        -command {if {$debug(files)} {
    DEBUG force "set debug (Files) OFF"
    set debug(files) 0
} else {
    DEBUG force "set debug (Files) ON"
    set debug(files) 1
}} \
        -label Files -variable Files 
    $base.fra18.cpd21.men24.m.men25 add checkbutton \
        \
        -command {if {$debug(compute)} {
    DEBUG force "set debug (Compute) OFF"
    set debug(compute) 0
} else {
    DEBUG force "set debug (Compute) ON"
    set debug(compute) 1
}} \
        -label Compute -variable Compute 
    frame $base.fra19 \
        -borderwidth 2 -height 41 -width 125 
    button $base.fra19.but21 \
        -command newClient -padx 9 -pady 3 -text VRML 
    button $base.fra19.but24 \
        -command {sendCommandToServer "open_an_editor $gvar(prjnum) ll_net"} \
        -padx 9 -pady 3 -text {Open LL} 
    button $base.fra19.but25 \
        -command simulationOneStep -padx 9 -pady 3 -state disabled -text Step 
    button $base.fra19.but20 \
        -command simulationStart -padx 9 -pady 3 -state disabled -text Start 
    button $base.fra19.but22 \
        -command simulationStop -padx 9 -pady 3 -state disabled -text Stop 
    button $base.fra19.but18 \
        -command end_session_local -padx 9 -pady 3 -text Quit 
    frame $base.fra20 \
        -borderwidth 2 -height 30 -relief groove -width 125 
    label $base.fra20.lab22 \
        -borderwidth 1 -text {Welcome to Simulator V0.2} 
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.fra18 \
        -in .top17 -anchor center -expand 0 -fill x -side top 
    pack $base.fra18.cpd21 \
        -in .top17.fra18 -anchor center -expand 0 -fill x -side top 
    pack $base.fra18.cpd21.01 \
        -in .top17.fra18.cpd21 -anchor center -expand 0 -fill none -side left 
    pack $base.fra18.cpd21.men24 \
        -in .top17.fra18.cpd21 -anchor center -expand 0 -fill none \
        -side right 
    pack $base.fra19 \
        -in .top17 -anchor center -expand 1 -fill both -side top 
    pack $base.fra19.but21 \
        -in .top17.fra19 -anchor center -expand 1 -fill none -side left 
    pack $base.fra19.but24 \
        -in .top17.fra19 -anchor center -expand 1 -fill none -side left 
    pack $base.fra19.but25 \
        -in .top17.fra19 -anchor center -expand 1 -fill none -side left 
    pack $base.fra19.but20 \
        -in .top17.fra19 -anchor center -expand 1 -fill none -side left 
    pack $base.fra19.but22 \
        -in .top17.fra19 -anchor center -expand 1 -fill none -side left 
    pack $base.fra19.but18 \
        -in .top17.fra19 -anchor center -expand 1 -fill none -side left 
    pack $base.fra20 \
        -in .top17 -anchor center -expand 1 -fill both -side top 
    pack $base.fra20.lab22 \
        -in .top17.fra20 -anchor center -expand 1 -fill both -side top 
}

Window show .
Window show .top17

main $argc $argv
