/*****************************************************************************/
/* readlib.c								     */
/*****************************************************************************/
/*				    Stefan Roemer,  06.02.1995 - 06.02.1995  */
/*				    Stefan Schwoon, April 1997		     */
/*****************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#include "readlib.h"
#include "readPEP.h"
#include "memlib.h"

/*****************************************************************************/
/* Globale Konstante: aktuelle Zeilennummer in der Eingabedatei.	     */
/*****************************************************************************/

char *cbuf = NULL;
char *cc = NULL;
int  cballoc = 0;
int  cbused = 0;
int  commenthack = 0;


/*****************************************************************************/
/* Ueberlesen von whitespace und Kommentarzeilen.			     */
/*****************************************************************************/

void cb_add(char c)
{
	if (cbused + 1 >= cballoc)
	{
		cbuf = MYrealloc(cbuf, cballoc += 512);
		cc = cbuf + cbused;
	}
	*cc++ = c;
	*cc = '\0';
	cbused++;
}

char ReadCharComment(FILE *file)
{
	register char ch = '\0';
	int hadcomments = 0;

	do {
		ch = '\n';
		if (feof(file)) ch = getc(file);
		while (!feof(file) && strchr(" \t\b", ch = getc(file)));
		if (ch == '%')
		{
			cb_add(ch);
			hadcomments = 1;
			while (!feof(file) && (ch = getc(file)) != '\n')
				cb_add(ch);
			cb_add(ch);
			if (ch == '\n')
			{
				NNinput_line++;
				ch = '\0';
			} /* if */
		} /* if */
	} while (!ch);

	if (hadcomments && commenthack)
	{
		if (!feof(file)) ungetc(ch,file);
		return '\n';
	}

	return ch;

} /* ReadCharComment() */

