proc FSBox { cmd {why "Open"} {filter {}} {dir .} {dlgtype open}} {
#
# Parameter:
#   cmd     procedure to be invoked with file as parameter
#   why     title of the dialog box
#   filter  list of tk file dialog filters
#   dir     initial directoy chosen by dialog
#   dlgtype choose between open and save dialog (cd also available but not
#           yet used
# Returns:  Return value of cmd, if file is chosen, else empty string

    global FSBox fs_file

    set def_ext [lindex [lindex filter 0] 1]
    if {$def_ext=="*"} {
      set def_ext ""
    }
    set filterlist [list {{All files} *}]
    if {$filter!=""} {
      set filterlist [linsert $filterlist 0 $filter]
    }
    switch $dlgtype {
	open {set dialog tk_getOpenFile}
	save {set dialog tk_getSaveFile}
	cd {set dialog tk_chooseDirectory}
    }

    set fs_file [$dialog -defaultextension $def_ext -filetypes $filterlist -initialdir $dir -title $why]
    if {$fs_file != ""} {
	return [eval $cmd $fs_file]
    }
}

