# argparse.tcl, little Lib for preparation of arguments
# started: 30.12.96, last-update: 11.03.97

###########
# argparse
###########
# Evaluate parameters given in 'arglist' and store the results
# in the variables given in 'argtable'.
#   arglist  - args to parse (I)
#   argtable - parse tabke as list of list {prefix #argopts resvar}
#   return   - not used args
proc argparse {arglist argtable} {
    # 1. retrieve all prefix in one list
  set argpre {}
  foreach el $argtable {
    lappend argpre [lindex $el 0]
  }  ;# foreach prefix
    # search for prefix in arglist
  set precount 0
  set argused {}
  foreach pre $argpre {
    upvar [lindex [lindex $argtable $precount] 2] res
    set argpos [lsearch -glob $arglist $pre*]
      # get optional args
    if {$argpos >= 0} {
      lappend argused $argpos
      set res $pre
      if {[lindex [lindex $argtable $precount] 1] > 0} {
        lappend res [split [lrange \
          [split [lindex $arglist $argpos] "="] 1 end] ","]
      }  ;# if options for this parameter
    } else {
      set res {}
    }  ;# no options
    incr precount
  }  ;# foreach prefix
    # compile the not used args in one list
  set returnarglist {}
  set i 0
  while {$i < [llength $arglist]} {
    if {[lsearch $argused $i] == -1} {
      lappend returnarglist [lindex $arglist $i]
    }  ;# if arg not used
    incr i
  }  ;# foreach arg
  return $returnarglist
}  ;# argparse

  #*** end of file argparse.tcl ***
