# ccom.tcl, Include f"ur Clients unter PEP
# per Auto-Loading in den Client einbinden
# Initialisierung mit: init_client_com
# RPC-Update von Michael Kater 
# begonnen: 16.02.95, last-update: 21.03.97
# BG Anfuehrungszeichen fehlten
# BG Abgleich Andre's PFA, Ptak FC2 und Peedy Animator 10.2.98

  #####################################
  # ComPars und Dateinamen vorbelegen #
  #####################################

  # die globale Variable gvar erzeugen/belegen
set gvar(client.com.version) "0.03a"

package require Tcl_RPC

###############################################################
proc init_client_com {} {
###############################################################
  # Die Kommunikation f"ur den Client initialisieren.
  global argc
  global argv
  global gvar

  set prjnum 0
  set prjname "Noname"
  set prgtype "unknown"
  set pepcom {}
  set at {{"-prjnum" 1 prjnum} {"-prjname" 1 prjname} {"-prgtype" 1 prgtype} \
    {"-color_palette" 1 color_palette} {"-pepcom" 3 pepcom}}

  set argv [argparse $argv $at]
  set argc [llength $argv]

  set pepcom [lindex $pepcom 1]
  if {[llength $pepcom] == 3} {
      # Variablen eintragen
    set gvar(prjnum) [lindex $prjnum 1]
    set gvar(prjname) [lindex $prjname 1]
    set gvar(prgtype) [lindex $prgtype 1]
    set gvar(color_palette) [lindex $color_palette 1]
    tk_setPalette $gvar(color_palette)
    set gvar(server_host) [lindex $pepcom 0]
    set gvar(server_port) [lindex $pepcom 1]
    set gvar(server_sock) [lindex $pepcom 2]
      # die Kommunikation aufbauen
    set gvar(my_host) "localhost"
    set gvar(my_sock) [RPC_server 0]
    set gvar(my_port) [lindex [fconfigure $gvar(my_sock) -sockname] 2]

    catch {RPC "init_client_peer $gvar(prjnum) $gvar(prgtype) \
      $gvar(my_host) $gvar(my_port) $gvar(my_sock)" \
      $gvar(server_host) $gvar(server_port)}

      # die Kopfzeile setzen
    switch $gvar(prgtype) {
      bpn2.normal  {
        set gvar(prgtitle) "B(PN) Editor, Project: $gvar(prjname)"}
      bpn2.expanded {
        set gvar(prgtitle) "Expanded B(PN) Editor, Project: $gvar(prjname)"}
      boxexpr      {
        set gvar(prgtitle) "PBC Editor, Project: $gvar(prjname)"}
      ll_net       {
        set gvar(prgtitle) "LL Net Editor, Project: $gvar(prjname)"
      }
      hl_net       {
        set gvar(prgtitle) "HL Net Editor, Project: $gvar(prjname)"}
      c_source     {
        set gvar(prgtitle) "C Source Editor, Project: $gvar(prjname)"}
      formula.normal {
        set gvar(prgtitle) "Formula Editor, Project: $gvar(prjname)"}
      doc          {
        set gvar(prgtitle) "Document Editor, Project: $gvar(prjname)"}
      help.view    {
        set gvar(prgtitle) "Help View, Project: $gvar(prjname)"}
      ina          {
        set gvar(prgtitle) "INA, Project: $gvar(prjname)"}
      pfa          {
        set gvar(prgtitle) "PFA, Project: $gvar(prjname)"}
      sdl_properties {
        set gvar(prgtitle) "SDL Properties, Project: $gvar(prjname)"}
      sdl          {
        set gvar(prgtitle) "SDL Editor, Project: $gvar(prjname)"}
      animator          {
        set gvar(prgtitle) "Animator, Project: $gvar(prjname)" }
      simulator          {
        set gvar(prgtitle) "Simulator, Project: $gvar(prjname)"}
      default      {
        set gvar(prgtitle) "UNKNOWN PEP Editor, Project: UNKNOWN"}
    }  ;# switch "uber den Programmtyp
    wm title . $gvar(prgtitle)
    wm protocol . WM_DELETE_WINDOW editor_wm_delete_window
    set gvar(server.connected) 1
  } else {
    set gvar(prgtitle) "PEP Program"
    wm title . $gvar(prgtitle)
    set gvar(server.connected) 0
    set gvar(prgtype) ""
  }  ;# else, keine ComPars vorhanden
}  ;# init_client_com

  ######################
  # Interne Prozeduren #
  ######################

proc editor_wm_delete_window {} {
  # Wird vom Window Manager im Falle des Schlie"sens aufgerufen.
    # dem PEPTool Bescheid sagen
  goodbye_server
    # sich selbst abschie"sen
  end_session "JA"
}  ;# editor_wm_delete_window

  ###########################
  # Mitteilungen vom Server #
  ###########################

proc raise_window_from_server {} {
  # Das Fenster des Programmes soll nach oben wandern im Stapel
  # der Fenster auf dem Bildschirm. Hilft bei der Suche des
  # dem Projekt und der Datei zugeh"origen Programmes.
  raise .
}  ;# raise_window_from_server

  #######################################
  # Mitteilungen an den Server absetzen #
  #######################################

proc new_filename_server new_filename {
###############################################################
  # Dem Server den neuen Dateinamen bekanntgeben.
  global gvar

  if {$gvar(server.connected)} {
    catch {RDO "new_filename_from_client \
      $gvar(prjnum) $gvar(prgtype) $new_filename" \
      $gvar(server_host) $gvar(server_port)}
  }  ;# if PEP-Server vorhanden
}  ;# new_filename_server

proc file_changed_server {} {
###############################################################
  # Dem Server mitteilen, da"s die Datei geschrieben wurde.
  global gvar

  if {$gvar(server.connected)} {
    catch {RDO "file_changed_from_client \
      $gvar(prjnum) $gvar(prgtype)" \
      $gvar(server_host) $gvar(server_port)}
  }  ;# if PEP-Server vorhanden
}  ;# file_changed_server

proc highlight_reference args {
###################################
  # Im B(PN)-Editor etwas markieren und im einem der Netzeditoren anzeigen.
  global gvar

# TODO
# Diese Zeilen sollten wieder raus ! (MK)
# Sie nehmen nur die Klammern aus dem String...
 regsub -all {\{} $args {} args
 regsub -all {\}} $args {} args

  if {$gvar(server.connected)} {
    switch $gvar(prgtype) {
      bpn2.normal {
        catch {RPC "highlight_reference_from_client \
          $gvar(prjnum) $gvar(prgtype) $args" \
          $gvar(server_host) $gvar(server_port)}
      } 
       ina { 
          # BW: hier die Ergaenzung fuer Highlighting von Ina aus
          # beachte: rufe PROC 'highlight_reference_from_ina' !
           # diese Procedur muss in scom.tcl noch ergaenzt werden
         catch {RPC "highlight_reference_from_ina \
           $gvar(prjnum) $gvar(prgtype) $args" \
                    $gvar(server_host) $gvar(server_port)}
	}
      bpn2.expanded {
        catch {RPC "highlight_reference_from_client \
          $gvar(prjnum) $gvar(prgtype) $args" \
          $gvar(server_host) $gvar(server_port)}
      }
      sdl {
        catch {RPC "highlight_reference_from_client \
          $gvar(prjnum) $gvar(prgtype) $args" \
          $gvar(server_host) $gvar(server_port)}
      }
      default {
        puts "highlight_reference: Highlight is only for B(PN)/Exp B(PN)\n\
          (not for $gvar(prgtype))"
      }
    }  ;# switch "uber den Programmtyp
  }  ;# if PEP-Server vorhanden
}  ;# highlight_reference

proc highlight_in_bpn2 ref_str {
###################################
  # Im einem der Netzeditoren etwas markieren und im B(PN)-Editor anzeigen.
  global gvar

  if {$gvar(server.connected)} {
    switch $gvar(prgtype) {
      ll_net {
#ref_str is either transition or place name
        catch {RPC "highlight_in_bpn2_from_client \
          $gvar(prjnum) $gvar(prgtype) $ref_str" \
          $gvar(server_host) $gvar(server_port)}
      }
      hl_net {
#ref_str is either transition or place name
        catch {RPC "highlight_in_bpn2_from_client \
          $gvar(prjnum) $gvar(prgtype) $ref_str" \
          $gvar(server_host) $gvar(server_port)} 
      }
      ina {
        catch {RPC "highlight_in_bpn2_from_client \
          $gvar(prjnum) $gvar(prgtype) $ref_str" \
          $gvar(server_host) $gvar(server_port)}
      }
      pfa {
        #ref_str is the number of the arc in the PFA file
        catch {RPC "highlight_in_bpn2_from_client \
          $gvar(prjnum) $gvar(prgtype) $ref_str" \
          $gvar(server_host) $gvar(server_port)}
      }
      default {
        puts "highlight_in_bpn2: Highlight is only for LL/HL Net, INA, PFA \
          (not for $gvar(prgtype))"
      }
    }  ;# switch "uber den Programmtyp
  }  ;# if PEP-Server vorhanden
}  ;# highlight_in_bpn2

proc show_place_reference_in_formula ref_str {
###############################################################
  # Die Referenz als Stelle in die Formel einfgen.
  global gvar

  if {$gvar(server.connected)} {
    switch $gvar(prgtype) {
      bpn2.normal {
        catch {RPC "show_place_ref_in_formula_from_client \
          $gvar(prjnum) $gvar(prgtype) {$ref_str}" $gvar(server_host) $gvar(server_port)}
      }
      bpn2.expanded {
        catch {RPC "show_place_ref_in_formula_from_client \
          $gvar(prjnum) $gvar(prgtype) {$ref_str}" $gvar(server_host) $gvar(server_port)}
      }
      default {
        puts "show_place_reference_in_formula: Show refence only for \
          B(PN) (not for $gvar(prgtype))"
      }
    }  ;# switch ber den Programmtyp
  }  ;# if PEP-Server vorhanden
}  ;# show_place_reference_in_formula

proc show_transitions_reference_in_formula {ref_str {opt "total"}} {
###############################################################
  # Die Referenz als Transitionen in die Formel einfgen.
  # ref_str - die Referenzangabe
  # opt - total oder partial
  global gvar

  if {$gvar(server.connected)} {
    switch $gvar(prgtype) {
      bpn2.normal {
        catch {RPC "show_transitions_ref_in_formula_from_client \
          $gvar(prjnum) $gvar(prgtype) {$ref_str} $opt" $gvar(server_host) $gvar(server_port)}
      }
      bpn2.expanded {
        catch {RPC "show_transitions_ref_in_formula_from_client \
          $gvar(prjnum) $gvar(prgtype) {$ref_str} $opt" $gvar(server_host) $gvar(server_port)}
      }
      default {
        puts "show_transitions_reference_in_formula: \
          Show refence only for B(PN) \
          (not for $gvar(prgtype))"
      }
    }  ;# switch ber den Programmtyp
  }  ;# if PEP-Server vorhanden
}  ;# show_transitions_reference_in_formula

proc goodbye_server {} {
###############################################################
  # Dem Server das eigene Ableben mitteilen.
  global gvar

  if {$gvar(server.connected)} {
    catch {RDO "goodbye_from_client $gvar(prjnum) $gvar(prgtype)" \
    	$gvar(server_host) $gvar(server_port)}
  }  ;# if PEP-Server vorhanden
}  ;# goodbye_server


# Simulator Teil
#######################################################################

#proc send_to_ll_edit {command {par1 ""} {par2 ""}} {
#
# global gvar
#
# RPC "send_to_ll_edit_from_client $gvar(prjnum) $command $par1 $par2" \
#		 $gvar(server_host) $gvar(server_port)
#
#}

proc send_to_simulator {command} {
# 
# Schickt ein Kommando an den Simulator und wartet auf das Ok.
 global gvar

  catch {
     if {$gvar(simulator.comstate) == "connected"} {
        set gvar(simulator.ok) 0
        RDO "send_to_simulator_from_client $gvar(prjnum) $command" \
	     $gvar(server_host) $gvar(server_port)
        if {$gvar(simulator.ok) == 0} {
           tkwait variable gvar(simulator.ok)
        }
     }
  }
}

#proc get_value_from_ll_edit {command} {
#
# global gvar
#
# set str [RPC "get_value_from_ll_edit_from_client $gvar(prjnum) $command" $gvar(server_host) $gvar(server_port)]
#
# return $str
#}

proc open_sdl_prop_editor {} {
  global gvar
  puts "proc open_sdl_prop_editor" ;# PTAK
  catch {RPC "open_or_raise_sdl_prop_editor $gvar(prjnum)" \
          $gvar(server_host) $gvar(server_port)}
}

  #*** Dateiende ccom.tcl ***
