#!/usr/bin/tclsh
# Recreate index for Auto-Loading
# arguments:
#   -pkg  - create pkgIndex.tcl, else create tclIndex
#   dir   - Lib-directory (if not set . is used)

if {[lsearch -exact $argv "-pkg"]!= -1} {
  set cmd pkg_mkIndex
  set filename pkgIndex.tcl
} else {
  set cmd auto_mkindex 
  set filename tclIndex
}

set libdir .
if {$argc >= 1} {
  set libdir [lindex $argv end]
}
if {$libdir=="-pkg"} {
  set libdir .
}

set files [glob -tails -nocomplain -directory $libdir *.tcl]

puts "  LibDir is '$libdir'"
if {[llength $files] > 0} {
  puts "  Files are $files"
  puts "  Please stand by..."

  puts "The file '$filename' is being recreated."
  $cmd $libdir *.tcl
} else {
  puts "  No files found"
}

puts "Done."

